var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-00294B7D-A624-43BA-8FF8-D684DAEBEF04\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"variables\">\n      <meta name=\"indexterm\" content=\"assignment: to variables\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Variable Assignment</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-00294B7D-A624-43BA-8FF8-D684DAEBEF04\"></a><div class=\"head\">\n            <h1>Variable Assignment </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8686D\"></a>  The syntax for general assignment, <span class=\"code\"> &lt;assignment&gt; </span>, is: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61BB\"></a><pre>&lt;destination&gt; = &lt;expr&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86871\"></a>where <span class=\"code\"> <em class=\"strong\">&lt;destination&gt;</em> </span> can be one of: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61BA\"></a><pre>&lt;var_name&gt;\n&lt;property&gt;\n&lt;array_index&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86875\"></a>Each of these destination type is described below. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86876\"></a>MAXScript provides a <span class=\"code\"> <em class=\"strong\">swap()</em> </span> method that takes two valid assignment destinations as arguments and swaps their\n            values. Its syntax is: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61B9\"></a><pre>swap &lt;destination&gt; &lt;destination&gt;</pre></div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86878\"></a> \n            <h2><a name=\"GUID-06B0E51C-0AA9-49FD-BAA5-68DABD06ECB0\"></a> <em class=\"strong\">Assignment to Variables</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86879\"></a>A variable is identified with a MAXScript <span class=\"code\"> &lt;var_name&gt; </span>, as described in <span class=\"char_link\"><a href=\"GUID-1C428A1F-3638-4DAC-812C-C6EBAE2100A8.htm\">Names</a></span>. If <span class=\"code\"> &lt;destination&gt; </span> is a <span class=\"code\"> <em class=\"strong\">var_name</em> </span>, it identifies the variable to be assigned a value, as shown in the following examples:\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61B8\"></a><pre>\nx = 2 + 2 * 3 -- assign to variable x\ny = [1, 2, 3] + pos -- assign to variable y\nz = #(1, 2,\"foo\",\"bar\") -- assign to variable z\nz = #oops -- oops, changed my mind\n</pre></div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E8687E\"></a> \n            <h2><a name=\"GUID-C4BA2964-DF21-4B2C-8E86-695A2236D7C8\"></a> <em class=\"strong\">Assignment to Accessors</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8687F\"></a>If <span class=\"code\"> &lt;destination&gt; </span> is a <span class=\"code\"> &lt;property&gt; </span> or an <span class=\"code\"> &lt;array_index&gt; </span>, the assignment is to an accessor. Accessors are constructs used to access the components\n               in compound values, such as arrays and 3D points. There are two kinds of accessors\n               corresponding to the two kinds of <em class=\"mild\">compound values</em> in MAXScript: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86880\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86882\"></a>The component values are arranged in an indexable sequence, as in arrays or strings.\n                     \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86884\"></a>The compound value contains a fixed set of named components, as with 3D points and\n                     time intervals. \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86885\"></a>All <em class=\"strong\">3ds Max</em> objects, such as boxes, spheres, bend modifiers, or bitmap textures are treated as\n               compound values in this sense. All their parameters, such as height and angle, or\n               map file name, are accessed as named components. In MAXScript, these named components\n               are referred to as <em class=\"mild\">properties</em>. For more information, see <span class=\"char_link\"><a href=\"GUID-0CA68F7B-8B14-4D5E-8D9C-BE97E2881B43.htm\">Properties, Methods, Operators, and Literals</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86886\"></a>Accessors have one of two forms, an <span class=\"code\"> &lt;array_index&gt; </span>: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61B7\"></a><pre>&lt;operand&gt; <em class=\"codeEmphasisStrong\">[</em> &lt;expr&gt; <em class=\"codeEmphasisStrong\">] </em>-- an indexed element</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86889\"></a>or a <span class=\"code\"> &lt;property&gt; </span>: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61B6\"></a><pre>&lt;operand&gt;<em class=\"codeEmphasisStrong\">.</em>&lt;var_name&gt; -- a named property - property var_name of value in operand</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8688C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8688D\"></a><p class=\"table-body\"> <em class=\"strong\">Examples of assignment to accessors are:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61B5\"></a><pre>\n$box01.pos = baseObj.pos + (baseObj.radius*[0,0,1])\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86891\"></a><p class=\"table-body\">Set the position property of object <span class=\"code\"> <em class=\"strong\">box01</em> </span> based on the position and radius properties of the object whose value is stored in\n                           variable <span class=\"code\"> <em class=\"strong\">baseObj</em> </span>. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61B4\"></a><pre>\nz[2] = d.rotation as eulerangles\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86895\"></a><p class=\"table-body\">Convert the rotation property value of the value stored in variable <span class=\"code\"> <em class=\"strong\">d</em> </span> to an <span class=\"code\"> <em class=\"strong\">eulerAngles</em> </span> class value, and store this value in element 2 of the array stored in variable <span class=\"code\"> <em class=\"strong\">z</em> </span>. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86896\"></a>&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86898\"></a>The syntax definitions allow you to use any <span class=\"code\"> <em class=\"strong\">&lt;operand&gt;</em> </span> before the <span class=\"code\"> <em class=\"strong\">.</em> </span> or <span class=\"code\"> <em class=\"strong\">[]</em> </span>. Because accessors are themselves operands, this definition is <em class=\"mild\">recursive</em>, which means you can string accessors together to query nested arrays or properties:\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61B3\"></a><pre>\nmy_things[i][j]\nmy_objects[i].target.position.x\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8689B\"></a>Accessors are evaluated left-to-right. The first example evaluates the i’th element\n               of <span class=\"code\"> <em class=\"strong\">my_things</em> </span>, which is presumably a nested array or an array of strings, before yielding the j\'th\n               element of that element. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8689C\"></a>The second example retrieves an object from an array of <span class=\"code\"> <em class=\"strong\">my_objects</em> </span>, then its <span class=\"code\"> <em class=\"strong\">target</em> </span>, then the <span class=\"code\"> <em class=\"strong\">position</em> </span> of the target (a 3D point), and finally the <span class=\"code\"> <em class=\"strong\">x</em> </span> coordinate of that point. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8689D\"></a>An <span class=\"code\"> &lt;operand&gt; </span> can also be a block-expression, allowing you to compute the target object to be accessed.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8689E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8689F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61B2\"></a><pre>\n(instance myNode).pos=myNode.parent.pos\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E868A3\"></a><p class=\"table-body\">Create an instance of the node whose value is stored in variable <span class=\"code\"> <em class=\"strong\">myNode</em> </span>, and set its position to the position of the <span class=\"code\"> <em class=\"strong\">myNode</em> </span>’s parent object. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61B1\"></a><pre>\n(find_table\"foo\")[n - 2] = \"fred\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E868A7\"></a><p class=\"table-body\">Call function <span class=\"code\"> <em class=\"strong\">find_table</em> </span> with a parameter value of <span class=\"code\"> <em class=\"strong\">\"foo\"</em> </span>. The return value from the function is presumably an array. Set element <span class=\"code\"> <em class=\"strong\">n-2</em> </span> of this array to the value <span class=\"code\"> <em class=\"strong\">\"fred\"</em> </span>. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E868A9\"></a>The named properties defined for the MAXScript values and classes are documented with\n               the value and class descriptions. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E868AA\"></a> \n            <h2><a name=\"GUID-86AA9265-90F5-437C-823C-001A15C97905\"></a> <em class=\"strong\">Order of Evaluation</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E868AB\"></a>In an assignment, <span class=\"code\"> <em class=\"strong\">&lt;expr&gt;</em> </span> is evaluated before <span class=\"code\"> <em class=\"strong\">&lt;destination&gt;, </em> </span>as can be seen in the following example: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E868AC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E868AD\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61B0\"></a><pre>\na=#() -- create an empty array to play with\na[(print \"in &lt;destination&gt;\";1)]=(print \"in &lt;expr&gt;\";10)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E868B2\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61AF\"></a><pre>\n#() -- result line 1\n\"in &lt;expr&gt;\" -- output from &lt;expr&gt; side of assignment\n\"in &lt;destination&gt;\" -- output from &lt;destination&gt; side of assignment\n10 -- result line 2\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E868BA\"></a>Assignment in MAXScript is itself an expression and yields the value just assigned.\n               Therefore, you can use assignments inside other expressions or cascade assignments,\n               as in: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E868BB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-61AE\"></a><pre>\nx = y = z = 0\n#(1, 2, a = [0,0,1], 4)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E868C2\"></a> <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E868C3\"></a> <span class=\"char_link\"><a href=\"GUID-3E792B8C-AF02-4178-9651-EDDB1341B68D.htm\">Specifying Global Variables As Global Using ::</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E868C4\"></a> <span class=\"char_link\"><a href=\"GUID-2739C3A0-16DB-4871-9F69-DCEC0862A186.htm\">Persistent Global Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E868C5\"></a> <span class=\"char_link\"><a href=\"GUID-5C8F4D60-69B0-4DC0-9641-E0F8C0CFCB84.htm\">Type-Free Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E868C6\"></a> <span class=\"char_link\"><a href=\"GUID-FAF8B2F4-3199-4757-A604-49E1F5BBEBE9.htm\">Reference Assignment</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E868C7\"></a> <span class=\"char_link\"><a href=\"GUID-DF09BF99-2106-408D-9965-60436B853D76.htm\">Memory Allocation and Garbage Collection</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E868C8\"></a> <span class=\"char_link\"><a href=\"GUID-CA7ABB4B-6CB6-47B7-903D-84D2F45D993D.htm\">Manual Garbage Collection</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";