var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-0203C56F-ABE5-4BBA-A5C2-9E7F6755FD0D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Debugger\">\n      <meta name=\"indexterm\" content=\"stack()\">\n      <meta name=\"indexterm\" content=\"Manual Stack Dump using the Stack Function\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Manual Stack Dump using the Stack() Function</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0203C56F-ABE5-4BBA-A5C2-9E7F6755FD0D\"></a><div class=\"head\">\n            <h1>Manual Stack Dump using the Stack() Function </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC536F\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5374\"></a>    <em class=\"strong\">Syntax:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6375\"></a><pre><em class=\"codeEmphasisStrong\">stack threadID</em>:&lt;int&gt; <em class=\"codeEmphasisStrong\">showLocals</em>:&lt;bool&gt; <em class=\"codeEmphasisStrong\">firstFrameOnly</em>:&lt;bool&gt; <em class=\"codeEmphasisStrong\">excludeOwner</em>:&lt;bool&gt; <em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt; <em class=\"codeEmphasisStrong\">asString</em>:&lt;bool&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5376\"></a>This function dumps the call stack showing the nesting of function calls at the current\n               execution point. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5377\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">threadID:</em> </span> is not specified, the current thread is dumped. If a thread ID is supplied, the specified\n               thread is dumped. See the \n               		  <span class=\"code\"> <em class=\"strong\">threads()</em> </span> method. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5378\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">showLocals:</em> </span> is not specified or supplied as true, the local variables in each stack frame are\n               dumped. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5379\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">firstFrameOnly:</em> </span> is not specified or supplied as false, all stack frames are displayed. If supplied\n               as true, only the current stack frame is displayed. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC537A\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">to:</em> </span> is not specified, output is sent to the MAXScript Listener, otherwise to the supplied\n               stream. \n               		\n            </p> \n            <p>Available \n               		  <em class=\"strong\">in 3ds Max 2017 and higher</em>: If \n               		  <span class=\"code\"><em class=\"strong\">excludeOwner:</em></span> is true, the dumping of the owner (if any) is not performed at each stack level.\n               If \n               		  <span class=\"code\"><em class=\"strong\">excludeOwner:</em></span> if false, a dump of the owner of the frame is included. \"Owners\" include rollouts,\n               scripted plugins, and structure instances. See the second example below. \n               		\n            </p> \n            <p>If \n               		  <span class=\"code\"><em class=\"strong\">asString:</em></span> is true, the method does not write to a stream (either the listener or the stream\n               specified by to), rather the stack capture is returned from the function as a string.\n               \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC537B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC537C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6374\"></a><pre>\nfn test somevalue = (ss=stringstream\"\";stack to:ss;ss)\nfn test2 = (xx = pi; test xx)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5381\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6373\"></a><pre>\ntest()\ntest2()\nStringStream:\"**&nbsp;thread data: threadID:1184\n**&nbsp;------------------------------------------------------\n**&nbsp;[stack level: 0]\n**&nbsp;In test(); filename: ; position: 52; line: 1\n--&nbsp;&nbsp;Parameters:\n--&nbsp;&nbsp;&nbsp;somevalue: 3.14159\n--&nbsp;&nbsp;Locals:\n--&nbsp;&nbsp;&nbsp;somevalue: 3.14159\n--&nbsp;&nbsp;&nbsp;ss: StringStream:\"\"\n--&nbsp;&nbsp;Externals:\n--&nbsp;&nbsp;&nbsp;owner: undefined\n**&nbsp;------------------------------------------------------\n**&nbsp;[stack level: 1]\n**&nbsp;called from test2(); filename: ; position: 88; line: 2\n--&nbsp;&nbsp;Locals:\n--&nbsp;&nbsp;&nbsp;xx: 3.14159\n--&nbsp;&nbsp;Externals:\n--&nbsp;&nbsp;&nbsp;owner: undefined\n--&nbsp;&nbsp;&nbsp;test: Global:test : test()\n**&nbsp;------------------------------------------------------\n**&nbsp;[stack level: 2]\n**&nbsp;called from top-level\n\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"TABLE_EC6DAD65F21B4733B4EC756CD9AE9D87\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">EXCLUDEOWNER EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\nrollout test \"test\"\n(\n	button b \"Press Me\"\n	on b pressed do\n	(\n		print \"stack with owner\"\n		stack  excludeOwner:false\n		print \"\\n\\nstack w/o owner\"\n		stack excludeOwner:true\n	)\n)\ncreateDialog test\n\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\n\"stack with owner\"\n**	thread data: threadID:7228\n**	------------------------------------------------------\n**	[stack level: 0]\n**	In b.pressed(); filename: ; position: 125; line: 7\n**	member of: Rollout:test\n--		Locals:\n--		Externals:\n--			test: Rollout:test\n--			owner: Rollout:test\n--		Owner:\n--			Locals:\n--				b: RolloutControl:b in rollout:test : ButtonControl:b\n--			Externals:\n**	------------------------------------------------------\n**	[stack level: 1]\n**	called from top-level\n\"\n\nstack w/o owner\"\n**	thread data: threadID:7228\n**	------------------------------------------------------\n**	[stack level: 0]\n**	In b.pressed(); filename: ; position: 183; line: 9\n**	member of: Rollout:test\n--		Locals:\n--		Externals:\n--			test: Rollout:test\n--			owner: Rollout:test\n**	------------------------------------------------------\n**	[stack level: 1]\n**	called from top-level\n\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";