var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-02F74674-AC9B-45AB-B2BF-02682C4A4E75\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"scripted plug-ins\">\n      <meta name=\"indexterm\" content=\"Helper: scripted plug-ins\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Helper Plug-ins</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-02F74674-AC9B-45AB-B2BF-02682C4A4E75\"></a><div class=\"head\">\n            <h1>Scripted Helper Plug-ins </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-50AF\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-50AE\"></a>  Scripted Helper plug-ins can only extend existing Helper plug-ins.A scripted Helper\n               plug-in is declared by specifying the <span class=\"code\"> &lt;superclass&gt; </span> as <span class=\"code\"> <em class=\"strong\">helper</em> </span>. If a <span class=\"code\"> <em class=\"strong\">create</em> </span> tool is specified, it will override the delegate\'s create tool. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-50AB\"></a>An example of a scripted Helper plug-in is shown in the Three Lights example in <span class=\"char_link\"><a href=\"GUID-DB36699E-7589-4C38-97C2-A04F093C6789.htm\">Scripted Plug-in Methods</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-50A9\"></a> <em class=\"strong\">Event Handlers</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7197\"></a><pre>on <em class=\"codeEmphasisStrong\">getDisplayMesh </em>do ....</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-50A7\"></a>This event handler is available to <span class=\"char_link\"><a href=\"GUID-2662358C-43AA-460D-9B0F-C53CC91F769C.htm\">scripted cameras</a></span> and helpers in <em class=\"strong\">3ds Max 7 and higher</em> and lets the developer replace the viewport display mesh of the delegate with a custom\n               display mesh. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-50A6\"></a>This handler is optional. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75C4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>For <em class=\"strong\">performance</em> reasons, it is <em class=\"strong\">critical</em> to regenerate the returned mesh as little as possible. The handler is called often\n                  - for display, bounds testing, and hit testing. \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-50A1\"></a>The example below shows how to update the mesh in the handler only when the mesh has\n               actually changed: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-50A0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-509F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7196\"></a><pre>\nplugin Helper HelperTest_DisplayMesh\nname:\"HelperTest\"\nclassID:#(0x47db14fe, 0x4e9b5f90)\ncategory:\"Standard\"\nextends:dummy\n(\n  local lastSize, meshObj\n  parameters pblock rollout:params\n  (\n    size type:#float animatable:true ui:amount default:40.0\n  )\n  rollout params \"HelperTest Parameters\"\n  (\n    Spinner amount \"Size:\" range:[0, 1e9, 40]\n  )\n  <em class=\"codeEmphasisStrong\">on getDisplayMesh do</em>\n  (\n    if (meshObj == undefined) do\n    (\n      meshObj = createInstance box length:size \\\n      width:size height:size mapCoords:false \\\n      lastSize = size\n    )\n    if size != lastSize do\n    (\n      meshObj.length = meshObj.width = meshObj.height = size \\\n      lastSize = size\n    )\n    meshObj.mesh\n  )\n  tool create\n  (\n    on mousePoint click do\n    (\n      nodeTM.translation = gridPoint;#stop\n    )\n  )\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7195\"></a><pre>on <em class=\"codeEmphasisStrong\">useWireColor</em> do ....</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-506F\"></a>This <em class=\"strong\">optional</em> event handler lets the developer specify whether to use the node\'s wire color when\n               drawing the object in the viewport, or use the UI color for the object type (Dummy\n               Object for Helpers). If this handler returns true, the node\'s wire color is used,\n               otherwise the UI color for the object type is used. If the event handler is not specified,\n               the wire color is used. This handler is only applicable when a <span class=\"code\"> <em class=\"strong\">getDisplayMesh</em> </span> handler is supplied. Available in <em class=\"strong\">3ds Max 8 and higher</em>. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-506D\"></a> <span class=\"char_link\"><a href=\"GUID-44D4AC45-65DD-401B-B4A1-07B71B35D544.htm\">Updating Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-506C\"></a> <span class=\"char_link\"><a href=\"GUID-DB36699E-7589-4C38-97C2-A04F093C6789.htm\">Scripted Plug-in Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-506B\"></a> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Scripted Plug-in Clauses</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-506A\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5069\"></a> <span class=\"char_link\"><a href=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29.htm\">Scripted Mouse Tools</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";