var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-04D996CE-B03E-41D6-ADD4-E9A043A483B6\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"random()\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>AngleAxis Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-04D996CE-B03E-41D6-ADD4-E9A043A483B6\"></a><div class=\"head\">\n            <h1>AngleAxis Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E40\"></a>The \n            		<em class=\"strong\">AngleAxis</em> class provides a representation for orientation in 3D space using an angle in degrees\n            and a rotation axis. T \n            	 \n         </p>\n         <p><a name=\"P_F6967DE0CD024666AB8172F4BE88AA23\"></a>his class is similar to a quaternion, except that a normalized quaternion only represents\n            -PI to +PI rotation. \n            	 \n         </p>\n         <p><a name=\"P_43C5253760994A1C88F4A4DC534B0CA3\"></a>AngleAxis angles can be greater than 360 and so specify multiple revolutions, unlike\n            quaternions. \n            	 \n         </p>\n         <p><a name=\"P_57ACB36E40FC49358B4A51B7CAD591AD\"></a>Rotations follow the right-hand-rule. \n            	 \n         </p>\n         <p><a name=\"P_7B40AB8F250F43B287384DAEF7DEEF97\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E41\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F53\"></a><pre><em class=\"codeEmphasisStrong\">angleaxis</em> &lt;degrees_float&gt; &lt;axis_point3&gt; \n&lt;quat&gt; <em class=\"codeEmphasisStrong\">as angleaxis</em>\n&lt;eulerangle&gt; <em class=\"codeEmphasisStrong\">as angleaxis</em>\n&lt;matrix3&gt; <em class=\"codeEmphasisStrong\">as angleaxis</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E46\"></a>extracts the rotation component as an angleaxis \n            	 \n         </p>\n         <p><a name=\"P_26C9B3F2D9814CDEBD541BA69969AEFE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E47\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F52\"></a><pre>&lt;angleaxis&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;angleaxis&gt;\n&lt;angleaxis&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;angleaxis&gt;\n&lt;angleaxis&gt; <em class=\"codeEmphasisStrong\">as</em> &lt;class&gt;</pre></div>\n         <p><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-558A\"></a>AngleAxis can convert to Matrix3\'s, Quat\'s, Eulerangle\'s \n            	 \n         </p>\n         <p><a name=\"P_AF31AD37DBB64CE586070A9805A24BC7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E4C\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F51\"></a><pre>&lt;angleaxis&gt;.<em class=\"codeEmphasisStrong\">angle</em>: Float\n&lt;angleaxis&gt;.<em class=\"codeEmphasisStrong\">axis</em>: Point3\n&lt;angleaxis&gt;.<em class=\"codeEmphasisStrong\">numrevs</em>: Integer</pre></div>\n         <p><a name=\"P_63E9E3E875AF4CEABC1BCEA3D19716A7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6A12\"></a>   <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F50\"></a><pre><em class=\"codeEmphasisStrong\">copy</em>&lt;angleaxis&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E53\"></a>Creates a new copy of the angleaxis value. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8798B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8798C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FFA\"></a><pre>newAngleAxis = copy oldAngleAxis</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E55\"></a>The new value contains a copy of the input angleaxis value, and is independent of\n            the input angleaxis value. \n            	 \n         </p>\n         <p><a name=\"P_507BD61E48014BA5AF9A71ED7CF8957C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F4D\"></a><pre><em class=\"codeEmphasisStrong\">random</em> &lt;angleaxis&gt; &lt;angleaxis&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E58\"></a>Random rotation in degrees, but uses quat Slerp, so loses multiple revolution angles.\n            \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E5B\"></a> <span class=\"char_link\"><a href=\"GUID-87BB6468-79E2-4FA2-9BAB-42E427219C4F.htm\">EulerAngles Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E5C\"></a> <span class=\"char_link\"><a href=\"GUID-C42F8CCE-CE31-49B4-9D5A-65C07D9F33FD.htm\">Quat Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";