var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-05587CE9-F6EF-47F3-9ECF-45F88A2222A7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Advanced_Lighting_Override Material\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Advanced_Lighting_Override : Material</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-05587CE9-F6EF-47F3-9ECF-45F88A2222A7\"></a><div class=\"head\">\n            <h1>Advanced_Lighting_Override : Material </h1>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4643\"></a><pre><em class=\"codeEmphasisStrong\">Advanced_Lighting_Override - superclass: material; super-superclass:MAXWrapper - classID: #(689195325, 1828668151)</em> </pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67D4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67D5\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-23A6A316-7C51-430C-8A44-9236C837DB10.htm\">Material</a></span> &gt; Advanced_Lighting_Override  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67D8\"></a>This material is used to override the physical properties of the Base material for\n            radisosity calculations. \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-258E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67DB\"></a>The <em class=\"strong\">Advanced_Lighting_Override</em> material found in <em class=\"strong\">3ds Max</em> was called <em class=\"strong\">Radiosity_Override</em> in <em class=\"strong\">Autodesk VIZ</em>, but has the same classID in both applications! \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67DC\"></a>Class instances of this material can also be constructed in both applications using\n                  the alias <em class=\"strong\">discreetRadiosityMaterial.</em> It is a good idea to use the alias in your scripts to ensure compatibility between\n                  <em class=\"strong\">3ds Max</em> and <em class=\"strong\">Autodesk VIZ</em>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67DD\"></a>Checking the class using \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4642\"></a><pre>classof my_mat == discreetRadiosityMaterial</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67E1\"></a>will return <span class=\"code\"> <em class=\"strong\">true</em> </span> in both applications. \n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67E3\"></a> <em class=\"strong\">3ds Max Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4641\"></a><pre><em class=\"codeEmphasisStrong\">advanced_lighting_override... 	 \ndiscreetRadiosityMaterial...</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67E6\"></a> <em class=\"strong\">Autodesk VIZ Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4640\"></a><pre><em class=\"codeEmphasisStrong\">radiosity_override ...   \ndiscreetRadiosityMaterial ... </em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67E9\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-463F\"></a><pre>&lt;Advanced_Lighting_Override&gt;.<em class=\"codeEmphasisStrong\">baseMaterial</em> Standardmaterial default: (null):Standard -- material; SubAnim </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67EB\"></a>Contains the base material whose radiosity properties have to be controlled. \n         </p>\n         <p><a name=\"GUID-41E23536-40B6-4993-9BEF-BA80D6523BEB\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-463E\"></a><pre>&lt;Advanced_Lighting_Override&gt;.<em class=\"codeEmphasisStrong\">bumpScale</em> Float default: 1.0 -- animatable; float </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67EE\"></a>Get/Set the Bump Scale value. \n         </p>\n         <p><a name=\"GUID-803B8589-1A5E-4C49-BB41-D931440797BB\"></a> Scales the effect of the base material\'s Bump Mapping in areas lit by indirect light.\n            \n         </p>\n         <p><a name=\"GUID-EEEC062C-678B-41B5-9317-A80D2E30A1D8\"></a> When this value is zero, no bump mapping is done for indirect light. \n         </p>\n         <p><a name=\"GUID-82747CDC-2A53-4272-A9D1-2B232CF3ECFF\"></a>Increasing Indirect Light Bump Scale increases the bump effect under indirect lighting.\n            \n         </p>\n         <p><a name=\"GUID-D55067F3-DDC7-4583-9018-0660B0D05903\"></a>This value does not affect the Bump amount in areas where the base material is lit\n            directly. \n         </p>\n         <p><a name=\"GUID-75CA4F83-53F8-49C1-B29B-1AD286F183AA\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-463D\"></a><pre>&lt;Advanced_Lighting_Override&gt;.<em class=\"codeEmphasisStrong\">colorBleed</em> Float default: 1.0 -- animatable; float </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67F1\"></a>Get/Set the Color Bleeding value. \n         </p>\n         <p><a name=\"GUID-F493F720-ADD2-4FA1-9161-4B012D18C66F\"></a>Controls the saturation of reflected color during radiosity processing. \n         </p>\n         <p><a name=\"GUID-266084FC-2134-4DBF-8B98-E06445ABBF04\"></a>Range from 0.0 to 1.0 in <em class=\"strong\">Autodesk VIZ</em>. \n         </p>\n         <p><a name=\"GUID-1EB6C095-F3B4-49D3-893C-29C93A9C5562\"></a>Range from 0.0 to 1000.0 in <em class=\"strong\">3ds Max</em>. \n         </p>\n         <p><a name=\"GUID-258F319F-CE84-4BBC-9484-BD5E807E1AD0\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-463C\"></a><pre>&lt;Advanced_Lighting_Override&gt;.<em class=\"codeEmphasisStrong\">luminanceScale</em> Float default: 0.0 -- animatable; float </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67F4\"></a>Get/Set the Luminance Scale value. \n         </p>\n         <p><a name=\"GUID-2FD66D37-CD0B-47C6-968B-7C022B07C45D\"></a>Scales the self-illumination component of the base material. \n         </p>\n         <p><a name=\"GUID-5978B479-7676-4083-8F59-70D3CFBA43AB\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-463B\"></a><pre>&lt;Advanced_Lighting_Override&gt;.<em class=\"codeEmphasisStrong\">reflectanceScale</em> Float default: 1.0 -- animatable; float </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67F7\"></a>Get/Set the Reflectance Scale value. \n         </p>\n         <p><a name=\"GUID-56DA423A-3697-4D39-A134-45237755623A\"></a> Used to Scale increases or decreases the energy of reflected rays. \n         </p>\n         <p><a name=\"GUID-0EC50A32-9041-4306-BA2F-97CF4AC2D240\"></a>Range from 0.1 to 5.0 in <em class=\"strong\">Autodesk VIZ</em>. \n         </p>\n         <p><a name=\"GUID-ECA52138-375E-4A72-B759-DE04BF2D2A0E\"></a> Range from 0.0 to 1000.0 in <em class=\"strong\">3ds Max</em>. \n         </p>\n         <p><a name=\"GUID-20F814D4-12A7-4CAB-A73D-04E6A8995C68\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-463A\"></a><pre>&lt;Advanced_Lighting_Override&gt;.<em class=\"codeEmphasisStrong\">transmittanceScale</em> Float default: 1.0 -- animatable; float </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67FA\"></a>Get/Set the Transmittance Scale value. \n         </p>\n         <p><a name=\"GUID-02311F70-875D-452D-9A99-C2314D53F95A\"></a>Used to control the amount of radiosity energy the material transmits. \n         </p>\n         <p><a name=\"GUID-FEF55118-EE76-4990-9732-D3A11BBD3099\"></a>Range from 0.0 to 1000.0 in <em class=\"strong\">3ds Max</em>. \n         </p>\n         <p><a name=\"GUID-0DF43E82-636E-460D-B451-26BE4169203E\"></a>(Range from 0.1 to 5.0 in the <em class=\"strong\">Radiosity_Override</em> material in <em class=\"strong\">Autodesk VIZ</em>.) \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67FD\"></a> <span class=\"char_link\"><a href=\"GUID-23A6A316-7C51-430C-8A44-9236C837DB10.htm\">Material Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67FE\"></a> <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C67FF\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";