var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-059672B5-A234-438C-8A80-F5CC6C3BE936\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Dereferencing Operator\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Dereferencing Operator</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-059672B5-A234-438C-8A80-F5CC6C3BE936\"></a><div class=\"head\">\n            <h1>Dereferencing Operator </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87428\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87429\"></a>  <span class=\"char_link\"><a href=\"GUID-15EBBE7C-3ADD-4A28-96E7-B9FE47072004.htm\">Visible Class For \'&amp;\' Reference Values</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8742B\"></a>A Function Published <em class=\"strong\">dereferencing prefix operator</em>, <em class=\"strong\">*</em>, is available in MAXScript since <em class=\"strong\">3ds Max 4</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8742C\"></a>It can be used in conjunction with the \'<em class=\"strong\">&amp;</em>\' reference operator that was added to support pass-by-reference arguments to functions\n               and interface methods. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8742D\"></a>The \'<em class=\"strong\">&amp;</em>\' operator is used to get a \'reference\' to a variable or property or array element\n               slot in MAXScript. You can pass this reference in to a function that accepts by-reference\n               arguments, allowing its code to directly assign values to the referenced variable\n               or property or array element, thus supporting a kind of multiple-value return. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8742E\"></a>The \'<em class=\"strong\">*</em>\' operator allows you to work with \'<em class=\"strong\">&amp;</em>\' reference values anywhere in MAXScript code. Therefore \'dereference\' the reference\n               and get the value in the slot or variable it is referring to and to assign it to the\n               referenced slot. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8742F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87430\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87431\"></a><p class=\"table-body\">The following puts a value into ref which is a reference to the .pos property in the\n                           scene object $foo. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-608C\"></a><pre>ref = <em class=\"codeEmphasisStrong\">&amp;</em>$foo.pos</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87435\"></a><p class=\"table-body\">Elsewhere in the code, you could use the * dereferencing operator to say: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-608B\"></a><pre>$baz.pos = <em class=\"codeEmphasisStrong\">*</em>ref</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87439\"></a><p class=\"table-body\">The * above dereferences the reference value in ref, essentially making the expression\n                           equivalent to: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-608A\"></a><pre>$baz.pos = $foo.pos</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8743D\"></a><p class=\"table-body\">You can also use this construct as a destination for an assignment: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6089\"></a><pre>*ref = [10,0,0]</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87441\"></a><p class=\"table-body\">The above first dereferences the reference in ref to $foo.pos and then assigns to\n                           that, effectively setting $foo\'s position. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87443\"></a>In order to <em class=\"strong\">avoid ambiguity</em> with the \'<em class=\"strong\">*</em>\' multiply operator, the precedence of the \'<em class=\"strong\">*</em>\' dereferencing operator is set at just lower than the function call and just higher\n               than the <em class=\"strong\">\'as\' coercion operator</em>. This means that if you want to send a dereferenced value into a function as an argument,\n               you must surround the dereferencing with parentheses, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87444\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87445\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6088\"></a><pre>foo (*ref) x y z</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8744A\"></a>Remember that reference values can be generated for variables, properties and array\n               elements, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8744B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8744C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6087\"></a><pre>\n&amp;foo\n&amp;$box.position.x\n&amp;valArray[23]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87453\"></a>The \'*\' dereferencing operator is a moderately advanced feature in MAXScript that\n               is often used to allow very general purpose code to be written that uses references\n               instead of actual objects so that it can be applied to different kinds of objects\n               and properties at different times. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87454\"></a>&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87455\"></a> <em class=\"strong\">Nested property access is allowed</em> in &amp; reference values in MAXScript. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87456\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87457\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87458\"></a><p class=\"table-body\">This allows a construct like </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6086\"></a><pre>\nref = &amp;$foo.pos\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8745C\"></a><p class=\"table-body\">and later in the code </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6085\"></a><pre>\n*r.controller\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87460\"></a><p class=\"table-body\">to mean the same as </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6084\"></a><pre>\n$foo.pos.controller\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87466\"></a> <span class=\"char_link\"><a href=\"GUID-6E1C44F4-81C0-400F-9558-E565E1F77D36.htm\">By Reference Parameter Passing</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";