var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-067C93F7-04E8-4C83-9896-437599B4E762\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface integrator\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: integrator</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-067C93F7-04E8-4C83-9896-437599B4E762\"></a><div class=\"head\">\n            <h1>Interface: integrator </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EEC\"></a> \n            <p><a name=\"GUID-5A7474D2-4DD5-4FBF-96FE-0E0E81517B32\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EEF\"></a> <em class=\"strong\">Description:</em>  \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EF0\"></a>The <em class=\"strong\">Integrator</em> moves particles in time according to inertia rules. It is a must for Collision operators\n               since they need to substitute the part of the data that the integrator calculates.\n               Particularly, the Collision tests change the position/speed data by their own as calculated\n               by deflectors. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EF1\"></a>All Test actions provide access to an Integrator interface via the <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span> and its <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm#WS73099CC142F487553098682E12AC2FC2BC7-423A\">getIntegrator_Method</a></span> that can be accessed using pCont.GetIntegrator() in a Proceed() handler. \n            </p> \n            <p><a name=\"GUID-E14BB322-AF8A-4984-BBE1-2D59B3A75AC3\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EF2\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4272\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">proceedSync</em> &lt;IObject&gt;container &lt;time&gt;timeTick &lt;float&gt;tickFraction &lt;bool&gt;selectedOnly &lt;bitArray&gt;selected 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EF4\"></a>Returns <em class=\"strong\">true</em> if the operation has been proceeded successfully. \n            </p> \n            <p><a name=\"GUID-0EBCCA37-C858-4E92-A2AD-E9E5DCFEAB4C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-4271\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">proceedASync</em> &lt;IObject&gt;container &lt;time array&gt;timeTick &lt;float array&gt;tickFraction &lt;bool&gt;selectedOnly &lt;bitArray&gt;selected   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EF6\"></a>Returns <em class=\"strong\">true</em> if the operation has been proceeded successfully. \n            </p> \n            <p><a name=\"GUID-B28F7F68-AF80-464B-8C27-599718E80FF5\"></a>&nbsp;<span class=\"code\">timeTick</span>, <span class=\"code\">timeFraction</span> - The exact time for particles to come to. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EFA\"></a>The <span class=\"code\"> <em class=\"strong\">timeFraction</em> </span> value stays in the range between -0.5f and 0.5f \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EFD\"></a><span class=\"code\">selectedOnly</span>, <span class=\"code\">selected</span> - If only part of the particles need to be time-advanced then set <span class=\"code\">selectedOnly </span>to <em class=\"strong\">true</em> and supply a BitArray for <span class=\"code\">selected</span> \n            </p> \n            <p><a name=\"GUID-FF60D587-E6B8-4C26-A9DA-B1DE98E92756\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EFE\"></a>See <span class=\"char_link\"><a href=\"GUID-340A20E5-B6B4-4C44-ABB8-D29D9EA10A77.htm\">Integrator ProceedSynch Example</a></span> for usage example. \n            </p> \n            <p><a name=\"GUID-116ACC2C-F5D0-41C8-8B58-8481E6C175D6\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82EFF\"></a> <em class=\"strong\">This Interface is available in:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82F00\"></a> <span class=\"char_link\"><a href=\"GUID-2B26090C-6DFC-4062-9AF9-27B62D0FBF90.htm\">Collision_Spawn : Helper</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82F01\"></a> <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm#WS73099CC142F487553098682E12AC2FC2BC7-423A\">MaxscriptParticleContainer getIntegrator Method</a></span> \n            </p> \n            <p><a name=\"GUID-827CEDEA-4FE7-4215-A90F-9845EE27AE85\"></a> <span class=\"char_link\"><a href=\"GUID-6D5AAD12-EAD9-4D30-8501-6D1622490C9F.htm\">mP_Collision : Helper</a></span> \n            </p> \n            <p><a name=\"GUID-6FCA1220-4A3A-4CC5-AACE-88CDA720EA4F\"></a> <span class=\"char_link\"><a href=\"GUID-809C2220-CDA3-4B88-AF15-A50C3603949F.htm\">mP_InterCollision : Helper</a></span> \n            </p> \n            <p><a name=\"GUID-4700EE9B-E981-4454-B526-EFDD602F9AB7\"></a> <span class=\"char_link\"><a href=\"GUID-C8A59616-D435-43A2-8859-065E3B41F45B.htm\">mP_World : Helper</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82F03\"></a> <span class=\"char_link\"><a href=\"GUID-B4D7BCE0-D4BC-48C8-8B0E-1513ED9BF43E.htm\">Particle Flow Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82F04\"></a> <span class=\"char_link\"><a href=\"GUID-340A20E5-B6B4-4C44-ABB8-D29D9EA10A77.htm\">Integrator ProceedSynch Example</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";