var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-08E9529C-5160-4E70-90F6-8E82C4C1908F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Spring Controller\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Spring Controller</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-08E9529C-5160-4E70-90F6-8E82C4C1908F\"></a><div class=\"head\">\n            <h1>Spring Controller </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CB7\"></a>The Spring controller adds secondary dynamics effects to any point or object position.\n            The end result is secondary mass/spring dynamics similar to Flex. This constraint\n            adds realism to generally static animations. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CB6\"></a>When you apply Spring to an animated object, its original motion is preserved and\n            secondary, velocity-based dynamics are applied. When you first apply the controller,\n            it constructs a virtual spring between the object\'s original position and where it\n            would end up after forces are applied to it. You can adjust spring tension and dampening.\n            Increasing the tension creates a tighter spring, while increasing the dampening smoothes\n            out jitters in the motion. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CB5\"></a>Users have control over the point\'s Mass and Drag, the spring\'s Tension and Dampening,\n            and other world space constraints. These include being able to add external forces\n            like Wind and Gravity (spacewarps), and being able to constrain the spring effects\n            along a given axis. This way you can add vertical dynamics while controlling the about\n            of effect it has in the horizontal directions. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CB4\"></a>The solution is calculated using a start time and a step size. Solutions are cached\n            once for the last tick calculated, and once per frame. Performance should be the same\n            one each frame as you step forward, and significantly faster after the first pass\n            if nothing changes. Cached values will be used if going backwards in time. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CB3\"></a>The biggest slowdown occurs when animating an object that the controller uses as a\n            force way down the time line since this is a history dependant solver. If a lot of\n            animation is going to occur along a long timeline you can shut off the spring solver\n            by setting steps to 0. Set this back to the desired value when you want the solution\n            recalculated. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CB2\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E54\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">getMass</em> () 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CB0\"></a>Returns the mass. \n         </p>\n         <p><a name=\"GUID-DEC05B3A-0975-4197-9941-27FD4756CFE2\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E53\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">setMass</em> &lt;float&gt;mass   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CAD\"></a>Sets the mass. The mass of the object to which the Spring controller is applied. Increasing\n            the mass causes the \"bouncing\" spring motion to become more exaggerated. \n         </p>\n         <p><a name=\"GUID-E13BD4D6-0BD9-4B09-B53D-BBD81408E02C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E52\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">getDrag</em> () </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CAA\"></a>Returns the drag. \n         </p>\n         <p><a name=\"GUID-C607132D-D24B-48DB-B1B6-749FEA6406BF\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E51\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">setDrag</em> &lt;float&gt;drag </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CA7\"></a>Sets the drag. Acts as air friction on the spring motion. A low Drag setting results\n            in a greater \"bouncing\" effect, while a high Drag results in subdued bouncing. Default=1.\n            Range=0 to 10. \n         </p>\n         <p><a name=\"GUID-6BD515EE-6341-49CF-9C45-E9D564908B46\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E50\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">getTension</em> &lt;index&gt;springIndex </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CA4\"></a>Gets the tension for the spring corresponding to the index. \n         </p>\n         <p><a name=\"GUID-3A341A13-C1EF-4161-9CAB-79BD8D463BC6\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E4F\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">setTension</em> &lt;index&gt;springIndex &lt;float&gt;tension </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7CA1\"></a>Sets the tension for the spring corresponding to the index. The \"stiffness\" of the\n            virtual spring between the controlled object and the highlighted spring object(s).\n            \n         </p>\n         <p><a name=\"GUID-492FD60B-9B07-4F08-A035-2B4355E4DDCD\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E4E\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">getDampening</em> &lt;index&gt;springIndex </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C9E\"></a>Gets the dampening for the spring corresponding to the index. \n         </p>\n         <p><a name=\"GUID-52766261-78E6-480B-9389-2C6312C82F8B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E4D\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">setDampening</em> &lt;index&gt;springIndex &lt;float&gt;dampening </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C9B\"></a>Sets the dampening for the spring corresponding to the index.<em class=\"strong\">:</em>Acts as a multiplier of an internal factor that determines how quickly the object\n            comes to rest. With the Self Influence spring, changing Dampening has the same effect\n            as changing Drag. With other springs, Dampening affects only the movement caused by\n            that spring. Internally, the dampening value is proportional to the tension, so as\n            you increase the tension and make the solution more stiff, the dampening is increased\n            to maintain system stability. \n         </p>\n         <p><a name=\"GUID-6D56E442-33BD-4C12-A879-D47CF8B8B5C7\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E4C\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">addSpring</em> &lt;node&gt;node </pre></div>\n         <p><a name=\"GUID-E27955F7-9679-4059-8646-27F9AC1F18FD\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E4B\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">node</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C97\"></a>Adds the node to the spring list. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C96\"></a>Returns true if successful, false otherwise \n         </p>\n         <p><a name=\"GUID-11167422-AD32-4E52-8EC1-CB776032C49E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E4A\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">getSpringCount</em> () </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C93\"></a>Returns the number of springs in the spring system. \n         </p>\n         <p><a name=\"GUID-E9AAC3B6-A9DA-4307-8057-0E2C618862B6\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E48\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">removeSpringByIndex</em> &lt;index&gt;springIndex </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C90\"></a>Removes the spring corresponding to the index. \n         </p>\n         <p><a name=\"GUID-D7F8C407-458F-4C7A-A543-EDE97327541C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E47\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">removeSpring</em> &lt;node&gt;node </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C8D\"></a>Removes the spring if the node is in the spring list. \n         </p>\n         <p><a name=\"GUID-F9E99092-7F63-4C4D-92B8-802371FF07EC\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C8B\"></a> <span class=\"char_link\"><a href=\"GUID-596E2144-26B1-4231-BFA9-D43AA361C03B.htm\">SpringPoint3Controller : Point3Controller</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C8A\"></a> <span class=\"char_link\"><a href=\"GUID-0882AF3A-E1B4-4261-84D1-E55CBCA62EC4.htm\">SpringPositionController : PositionController</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C89\"></a> <span class=\"char_link\"><a href=\"GUID-B1A27E36-3F95-4491-8A1C-67FA4262EE61.htm\">Flex : Modifier</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";