var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-0AEAB821-E2BD-48FE-B9C1-1BC23DDC7039\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"nodeSelectionSet Interface\">\n      <meta name=\"indexterm\" content=\"Interface NamedSelectionSetManager\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: nodeSelectionSet</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0AEAB821-E2BD-48FE-B9C1-1BC23DDC7039\"></a><div class=\"head\">\n            <h1>Interface: nodeSelectionSet</h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7CA0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7C9F\"></a><p class=\"table-body\">  <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; nodeSelectionSet \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-4D377532-3025-49AF-AF12-DB80CF86B189\"></a> The <em class=\"strong\">nodeSelectionSet Core Interface</em> provides methods for querying the current node selection to determine the state of\n            the display and render UI controls. Available in <em class=\"strong\">3ds Max 2015 and higher</em>. \n         </p>\n         <p><a name=\"GUID-E6B24F39-4DF0-4AA2-A331-265DFAD1BC76\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-4F07900F-3656-47BE-B1DD-287C0AFDE2D2\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">nodeSelectionSet.getDisplayPropState</em> &lt;enum&gt;propID &lt;enum&gt;condition \n\n    propID enums: {<em class=\"codeEmphasisStrong\">#DisplayProp_Transparent | #DisplayProp_Bone | #DisplayProp_FrozenWithMaterial | \n        #DisplayProp_Hidden | #DisplayProp_Frozen | #DisplayProp_Box | #DisplayProp_BackfaceCull | \n        #DisplayProp_AllEdges | #DisplayProp_BoneOnly | #DisplayProp_BoneAsLine | #DisplayProp_ShowTrajectory | \n        #DisplayProp_VertexTicks | #DisplayProp_IgnoreExtents | #DisplayProp_XRay</em>} \n\n    condition enums: {<em class=\"codeEmphasisStrong\">#Cond_AnyChecked | #Cond_AnyUnchecked | #Cond_Indeterminate | #Cond_Enabled</em>}\n\n\n</pre></div>\n         <p><a name=\"GUID-05BA4DE7-944A-4CDA-AB29-A960345D9433\"></a>Returns True if the Display Property specified by the propID enum argument has the\n            state specified by the condition emum argument, otherwise returns False. \n         </p>\n         <p><a name=\"GUID-19B96EAF-B4DF-48FE-BA27-E3C75A5CC8F7\"></a>A valid scene selection is required for this method to return a meaningful result,\n            if the selection is empty, a value of False will be returned. \n         </p>\n         <p><a name=\"GUID-8FD56787-71CD-44F4-9655-9208C4609B9E\"></a><span class=\"code\"> <em class=\"strong\">#Cond_AnyChecked</em> </span> will return True if the specified Display property is checked in at least one of\n            the selected objects, and False if all objects have the property unchecked. \n         </p>\n         <p><a name=\"GUID-7E2EE80B-53B9-48A6-876E-4349451EE8B9\"></a><span class=\"code\"> <em class=\"strong\">#Cond_AnyUnchecked</em> </span> will return True if the specified Display property is unchecked in at least one of\n            the selected objects, and False if all objects have the property checked. \n         </p>\n         <p><a name=\"GUID-6E5A3F92-8910-4D74-86AE-40EAAB3CB68F\"></a><span class=\"code\"> <em class=\"strong\">#Cond_Indeterminate</em> </span> will return True if at least one object has the specified Display property in a different\n            state than the other objects, and False if all objects have the same state, regardless\n            of whether it is checked or unchecked. \n         </p>\n         <p><a name=\"GUID-07790720-9BF0-4072-8D98-DDC8B3554E84\"></a><span class=\"code\"> <em class=\"strong\">#Cond_Enabled</em> </span> will return True if the checkbox is enabled and can be set using the mouse, or False\n            if the property cannot be set interactively because the current selection does not\n            support setting this property for all objects. \n         </p>\n         <p><a name=\"GUID-61BAFA60-9EF1-4A9E-96BA-4E31C987167F\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">nodeSelectionSet.setDisplayPropState</em> &lt;enum&gt;propID &lt;boolean&gt;val \n\n    propID enums: {<em class=\"codeEmphasisStrong\">#DisplayProp_Transparent | #DisplayProp_Bone | #DisplayProp_FrozenWithMaterial | \n        #DisplayProp_Hidden | #DisplayProp_Frozen | #DisplayProp_Box | #DisplayProp_BackfaceCull | \n        #DisplayProp_AllEdges | #DisplayProp_BoneOnly | #DisplayProp_BoneAsLine | #DisplayProp_ShowTrajectory | \n        #DisplayProp_VertexTicks | #DisplayProp_IgnoreExtents | #DisplayProp_XRay</em>}\n\n\n</pre></div>\n         <p><a name=\"GUID-2BB76C12-CB7A-481E-803D-B783259BE90C\"></a>Sets the state of the Display Property specified by the first argument to the Boolean\n            state given by the second argument. \n         </p>\n         <p><a name=\"GUID-8272707B-D905-41FF-AAD7-33B8080BA909\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">nodeSelectionSet.getRenderPropState</em> &lt;enum&gt;propID &lt;enum&gt;condition \n\n    propID enums: {<em class=\"codeEmphasisStrong\">#RenderProp_Renderable | #RenderProp_CastShadows | #RenderProp_ReceiveShadows | \n        #RenderProp_MotionBlur | #RenderProp_DisplayTexture | #RenderProp_InheritVisibility | #RenderProp_ColorVerts | \n        #RenderProp_ShadeColorVerts | #RenderProp_VelocityMotionBlur | #RenderProp_RenderOccluded | #RenderProp_CastCaustic | \n        #RenderProp_ReceiveCaustics | #RenderProp_ApplyAtmospherics | #RenderProp_CastGlobalIllumination | \n        #RenderProp_ReceiveGlobalIllumination | #RenderProp_InvisibleToCamera | #RenderProp_InvisibleToReflections</em>} \n\n    condition enums: {<em class=\"codeEmphasisStrong\">#Cond_AnyChecked | #Cond_AnyUnchecked | #Cond_Indeterminate | #Cond_Enabled</em>}\n\n\n</pre></div>\n         <p><a name=\"GUID-BBCFDFF1-E06E-4D5D-A161-75530263B3C7\"></a>Returns True if the Render Property specified by the propID enum argument has the\n            state specified by the condition emum argument, otherwise returns False. \n         </p>\n         <p><a name=\"GUID-BE6BF8BF-E414-4038-AAC8-BEA9DA9F6292\"></a>A valid scene selection is required for this method to return a meaningful result,\n            if the selection is empty, a value of False will be returned. \n         </p>\n         <p><a name=\"GUID-606CC18B-E569-4481-BF11-46741BB8AD85\"></a><span class=\"code\"> <em class=\"strong\">#Cond_AnyChecked</em> </span> will return True if the specified Render Property is checked in at least one of the\n            selected objects, and False if all objects have the property unchecked. \n         </p>\n         <p><a name=\"GUID-BFC3390E-9570-4259-AFF4-F8C70D3600AA\"></a><span class=\"code\"> <em class=\"strong\">#Cond_AnyUnchecked</em> </span> will return True if the specified Render Property is unchecked in at least one of\n            the selected objects, and False if all objects have the property checked. \n         </p>\n         <p><a name=\"GUID-0BFB0AB5-6553-473A-9E50-8C18B72EE977\"></a><span class=\"code\"> <em class=\"strong\">#Cond_Indeterminate</em> </span> will return True if at least one object has the specified Render Property in a different\n            state than the other objects, and False if all objects have the same state, regardless\n            of whether it is checked or unchecked. \n         </p>\n         <p><a name=\"GUID-699E1B67-E066-487B-B2BF-2A630AE06E86\"></a><span class=\"code\"> <em class=\"strong\">#Cond_Enabled</em> </span> will return True if the checkbox is enabled and can be set using the mouse, or False\n            if the property cannot be set interactively because the current selection does not\n            support setting this property for all objects. \n         </p>\n         <p><a name=\"GUID-6182A769-8BF7-4D76-A218-2376C422BB2E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">nodeSelectionSet.setRenderPropState </em>&lt;enum&gt;propID &lt;boolean&gt;val \n\n    propID enums: {<em class=\"codeEmphasisStrong\">#RenderProp_Renderable | #RenderProp_CastShadows | #RenderProp_ReceiveShadows | \n        #RenderProp_MotionBlur | #RenderProp_DisplayTexture | #RenderProp_InheritVisibility | #RenderProp_ColorVerts | \n        #RenderProp_ShadeColorVerts | #RenderProp_VelocityMotionBlur | #RenderProp_RenderOccluded | #RenderProp_CastCaustic | \n        #RenderProp_ReceiveCaustics | #RenderProp_ApplyAtmospherics | #RenderProp_CastGlobalIllumination | \n        #RenderProp_ReceiveGlobalIllumination | #RenderProp_InvisibleToCamera | #RenderProp_InvisibleToReflections</em>}\n\n\n</pre></div>\n         <p><a name=\"GUID-EAEA8F24-BC51-40F9-BFAC-04DB36731057\"></a>Sets the state of the Render Property specified by the first argument to the Boolean\n            state given by the second argument. \n         </p>\n         <p><a name=\"GUID-0BDBA350-BD06-493E-AA1D-2735936135EB\"></a>&nbsp;&nbsp;&nbsp; \n         </p><a name=\"TABLE_79B3E7AFB0454CCB8269FDA239D4C6AC\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-BA263D07-DCBF-486D-9A4F-FE2618A6A5E8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>b = box()\n--&gt; $Box:Box001 @ [0.000000,0.000000,0.000000]\nc = cylinder pos:[0,100,0]\n--&gt; $Cylinder:Cylinder001 @ [0.000000,100.000000,0.000000]\ns = sphere pos:[100,0,0]\n--&gt; $Sphere:Sphere001 @ [100.000000,0.000000,0.000000]\nb.vertexTicks = c.vertexTicks  = s.vertexTicks  = true\n--&gt;true\nc.boxMode = true\n--&gt;true\n\n--Check to see if the Display As Box property is checked in any of the objects:\nnodeSelectionSet.getDisplayPropState #DisplayProp_Box #Cond_AnyChecked\n--&gt;false --because nothing is selected in the scene!\nselect #(b,c,s) --select all three objects\n--&gt;OK\nnodeSelectionSet.getDisplayPropState #DisplayProp_Box #Cond_AnyChecked\n--&gt;true --because at least one of them has the Display As Box checked!\nnodeSelectionSet.getDisplayPropState #DisplayProp_Box #Cond_Indeterminate\n--&gt;true --because some are checked and some are not\nnodeSelectionSet.getDisplayPropState #DisplayProp_Box #Cond_AnyUnchecked\n--&gt;true --because two are unchecked\nnodeSelectionSet.getDisplayPropState #DisplayProp_Box #Cond_Enabled\n--&gt;true --because the checkbox is enabled and can be set to another state with the mouse\nc.boxMode = false --let\'s turn off the Box mode of the Cylinder \n--&gt;false\nnodeSelectionSet.getDisplayPropState #DisplayProp_Box #Cond_AnyChecked\n--&gt;false --now none of the three objects has the state checked. so we get false\nnodeSelectionSet.getDisplayPropState #DisplayProp_Box #Cond_AnyUnchecked\n--&gt;false --same reason, all are checked!\n\n--Now let\'s explore the Vertex Ticks display property:\nnodeSelectionSet.getDisplayPropState #DisplayProp_VertexTicks  #Cond_AnyChecked\n--&gt;true --because the Vertex Ticks option of all three objects is checked\nnodeSelectionSet.getDisplayPropState #DisplayProp_VertexTicks  #Cond_Indeterminate\n--&gt;false --the Vertex Ticks of all three objects are checked, so the checkbox is not indeterminate\nnodeSelectionSet.getDisplayPropState #DisplayProp_VertexTicks #Cond_AnyUnchecked\n--&gt;false --the Vertex Ticks of all three objects are checked, ergo none is unchecked!\n\n--Now let\'s explore the Renderable property:\nnodeSelectionSet.getRenderPropState #RenderProp_Renderable #Cond_AnyChecked \n--true --right now all three objects are renderable\nnodeSelectionSet.getRenderPropState #RenderProp_Renderable #Cond_AnyUnchecked \n--false --so of course none of them has the Renderable property unchecked...\nnodeSelectionSet.getRenderPropState #RenderProp_Renderable  #Cond_Indeterminate\n--false --that\'s why the checkbox is not intederminate, it is checked for all three\ns.renderable = false --so let\'s uncheck the renderable property of the Sphere\n--&gt;false\nnodeSelectionSet.getRenderPropState #RenderProp_Renderable #Cond_AnyUnchecked \n--true --now there is one property that is unchecked, so we get true as result!\nnodeSelectionSet.getRenderPropState #RenderProp_Renderable  #Cond_Indeterminate\n--true --and of course the checkbox would now be indeterminate\n\n--finally, let\'s turn off the renderable property of all three objects\nnodeSelectionSet.setRenderPropState #RenderProp_Renderable false \n--&gt;OK\nnodeSelectionSet.getRenderPropState #RenderProp_Renderable #Cond_AnyChecked \n--&gt;false --we successfully unchecked the Renderable property of the current selection!\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";