var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-0AEEF510-1859-48B7-9A19-A6158B0310A7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"working with\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Working with Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0AEEF510-1859-48B7-9A19-A6158B0310A7\"></a><div class=\"head\">\n            <h1>Working with Values </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E876FB\"></a> \n            <h2><a name=\"GUID-B4D59682-3678-4FEF-922D-C3C56FD3CA39\"></a> <em class=\"strong\">Print and Format</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876FC\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">print()</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">format()</em> </span> functions are straightforward. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876FD\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">format</em> </span> function is used when any formatting of the output is desired, or if you want to\n               print multiple values on a line. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876FE\"></a>When printing a value using either of these functions, a string representation of\n               the value is printed. This is not the object name for those objects with names (for\n               example a \n               		  <em class=\"strong\">3ds Max</em> object or material). \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E876FF\"></a>In the following example, variable \n               		  <span class=\"code\"> <em class=\"strong\">b</em> </span> contains a reference to a \n               		  <em class=\"strong\">3ds Max</em> Box object that has a material applied: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87700\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87701\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-603D\"></a><pre>print b\nprint b.name\nprint b.material\nprint b.material.name</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87708\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-603C\"></a><pre>$Box:Box01 @ [-74.353745,0.000001,-19.931978]\n\"Box01\"\nMaterial #1:Standard\n\"Material #1\"</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87710\"></a>The printed results above also reflect the result of a \n               		  <span class=\"code\"> <em class=\"strong\">&lt;value&gt; as string</em> </span> operation, that is the result is a string representation of the object rather than\n               the object name. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87711\"></a> \n            <h2><a name=\"GUID-916ECCE5-D523-4B3D-B47A-DBCB63C1CC1F\"></a> <em class=\"strong\">classOf, superClassOf, and isKindOf</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87712\"></a>The following table shows the hierarchy of classes and superclasses for a variable\n               that contains a reference to a \n               		  <em class=\"strong\">3ds Max</em> Box object (i.e., \n               		  <span class=\"code\"> <em class=\"strong\">b=box()</em> </span> ). \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87713\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"33.333333333333336%\">\n                     <col width=\"33.333333333333336%\">\n                     <col width=\"33.333333333333336%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87714\"></a><p class=\"table-body\">&nbsp; \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87715\"></a><p class=\"table-body\"> <em class=\"strong\">ClassOf</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87716\"></a><p class=\"table-body\"> <em class=\"strong\">SuperClassOf</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">b</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">Box</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">GeometryClass</span> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">box</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">GeometryClass</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">Node</span> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">GeometryClass</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">Node</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">MAXWrapper</span> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">Node</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">MAXWrapper</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">Value</span> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">MAXWrapper</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">Value</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">Value</span> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">Value</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">Value</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">Value</span> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87729\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">isKindOf()</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">classOf()</em> </span> functions are useful for filtering objects from a set. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8772A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8772B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8772C\"></a><p class=\"table-body\">either of the following will collect all objects of class \n                           						<span class=\"code\"> <em class=\"strong\">box</em> </span> into variable \n                           						<span class=\"code\"> <em class=\"strong\">allBoxes</em> </span>: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-603B\"></a><pre>allBoxes=for obj in $* where (isKindOf obj box) collect obj</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-603A\"></a><pre>allBoxes=#()\nfor obj in $* do (if classOf obj == box then append allBoxes obj)</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87735\"></a>One of the named parameters to the interactive node selection functions is \n               		  <span class=\"code\"> <em class=\"strong\">filter</em> </span>, which allows you to specify a function that returns a value of \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if an object can be selected. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87736\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">classOf</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">superClassOf</em> </span>, and \n               		  <span class=\"code\"> <em class=\"strong\">isKindOf</em> </span> functions are frequently used in these functions. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87737\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87738\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87739\"></a><p class=\"table-body\">the following function limits the choices to shape objects: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6039\"></a><pre>fn shape_filt obj = isKindOf obj Shape</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8773E\"></a>For an example of such a usage, see \n               		  <span class=\"char_link\"><a href=\"GUID-CE0FD5F8-61D6-4B61-AB86-D2176CEE990B.htm\">Pickbutton</a></span>. \n               		\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";