var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-0C0DBA6B-9D54-47E8-8FA8-F9D780B154E8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"rendererClass\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>rendererClass</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0C0DBA6B-9D54-47E8-8FA8-F9D780B154E8\"></a><div class=\"head\">\n            <h1>rendererClass </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5098\"></a>The RendererClass is a MAXClass wrapper of the plug-in renderer superclass which was\n            added in \n            		<em class=\"strong\">3ds Max 4</em> so that a renderer instance can be worked with in MAXScript. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5096\"></a>The property .classes provides an array of all installed RendererClass objects, which\n            allows for example the procedural creation of renderer class instances, the checking\n            for available renderers on the current system and so on. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5094\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5093\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2427\"></a><pre>\nRendererClass.classes\n--&gt; #(Default_Scanline_Renderer, VUE_File_Renderer, Quicksilver_Hardware_Renderer, mental_ray_renderer, Missing_Renderer)\n--<span class=\"codeComment\">You can assign a new renderer class to the current renderer</span>\nrenderers.current = RendererClass.classes[3]()\n--&gt; mental_ray_renderer:mental_ray_renderer\n&nbsp;\n--<span class=\"codeComment\">Conditional assignment: collect all renderer classes that match</span>\n--<span class=\"codeComment\">the name pattern \"Quicksilver*\" and if exactly one was collected,</span>\n--<span class=\"codeComment\">assign an instance of it to the current renderer:</span>\ntheRenderer = for i in RendererClass.classes where \\\nmatchPattern (i as string) pattern:\"Quicksilver*\" collect i\n--&gt; #(Quicksilver_Hardware_Renderer)\nif theRenderer.count == 1 do renderers.current = theRenderer[1]()\n--&gt; Quicksilver_Hardware_Renderer:Quicksilver_Hardware_Renderer--<span class=\"codeComment\">Using the class as string to pattern match the name is</span>\n--<span class=\"codeComment\">useful when the actual class name is changing (for example</span>\n--<span class=\"codeComment\">some 3rd party renderers include the version number in the</span>\n--<span class=\"codeComment\">class name, making it difficult to hard-code in scripts for</span>\n--<span class=\"codeComment\">more than one version).</span>\n--<span class=\"codeComment\">The above approach would work with these cases, too.</span> </pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-507B\"></a>The shipping \n            		<em class=\"strong\">RendererClass</em> classes are: \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-507A\"></a> <span class=\"char_link\"><a href=\"GUID-D4C5C5DF-7447-485F-9802-2E5328037EBE.htm\">Default_Scanline_Renderer : RendererClass</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5078\"></a> <span class=\"char_link\"><a href=\"GUID-00E1A3D2-590E-4B2A-8019-C9FFD7D983E6.htm\">Quicksilver_Hardware_Renderer : RendererClass</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5077\"></a> <span class=\"char_link\"><a href=\"GUID-0A4FE872-3677-4CBF-B44D-BAEBC7C0A3B2.htm\">VUE_File_Renderer : RendererClass</a></span> \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5075\"></a> <span class=\"char_link\"><a href=\"GUID-5984208E-B730-44F2-8D15-D4BB350F5877.htm\">Renderers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5074\"></a> <span class=\"char_link\"><a href=\"GUID-9175301C-13E6-488B-ABA6-D27CD804B205.htm\">Controlling the Renderer</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5072\"></a> <span class=\"char_link\"><a href=\"GUID-B13534DF-1D54-4921-B4E7-66E1A1A0FF35.htm\">Network Render Interface</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5071\"></a> <span class=\"char_link\"><a href=\"GUID-DEF2CDBF-C729-46B9-BC0D-F030E255E3A7.htm\">Interface: NetRender</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";