var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-0CA68F7B-8B14-4D5E-8D9C-BE97E2881B43\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"properties\">\n      <meta name=\"indexterm\" content=\"operators\">\n      <meta name=\"indexterm\" content=\"methods\">\n      <meta name=\"indexterm\" content=\"literals\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Properties, Methods, Operators, and Literals</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0CA68F7B-8B14-4D5E-8D9C-BE97E2881B43\"></a><div class=\"head\">\n            <h1>Properties, Methods, Operators, and Literals </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D13\"></a>    One principle of object-oriented programming is that how a class operates internally\n            is hidden. All interactions with a class are defined by the external interfaces for\n            the class. These external interfaces are broken up into several categories.\n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D18\"></a> <em class=\"strong\">Properties : </em>Accessible parameters for objects of the class. Examples of properties are height,\n            width, and length for boxes, and radius for spheres.\n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D19\"></a> <em class=\"strong\">Methods :</em>Defines all the functions you can call for objects of the class. Examples of methods\n            are moving or rotating a <em class=\"strong\">3ds Max</em> object, adding a modifier to a <em class=\"strong\">3ds Max</em> object, and accessing the position of vertices in a <em class=\"strong\">3ds Max</em> object. The terms <em class=\"mild\">method</em> and <em class=\"mild\">function</em> are synonymous in this document.\n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D1A\"></a> <em class=\"strong\">Operators :</em> Defines the math and other symbolic operators that are defined on values in the class.\n            An example of an operator is the \'-\' operator, which will perform a mathematical operation\n            on numbers, colors, vectors, and matrices, but will perform a Boolean subtraction\n            when used with <em class=\"strong\">3ds Max</em> objects.\n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D1B\"></a> <em class=\"strong\">Constructors :</em> The various ways you can create objects of the class. For example <span class=\"code\"> <em class=\"strong\">Point3 0 0 0</em> </span> and<span class=\"code\"> <em class=\"strong\"> &lt;color&gt; as Point3</em> </span> are constructors for the Point3 class. Executing either of these constructors will\n            create a new Point3 object.\n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D1C\"></a> <em class=\"strong\">Literals :</em> Any literal form for objects of the class. For example [0,0,0] is a literal form\n            for the Point3 class, and \"Hello world\" is a literal form for the String class.\n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";