var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-0D9C8669-81FB-489B-9457-DC689EDAC5FD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSSurface - NURBSObject\">\n      <meta name=\"indexterm\" content=\"NURBS2RailSweepSurface - NURBSSurface\">\n      <meta name=\"indexterm\" content=\"setFlip()\">\n      <meta name=\"indexterm\" content=\"setCurveStartPoint()\">\n      <meta name=\"indexterm\" content=\"setCurveByID()\">\n      <meta name=\"indexterm\" content=\"setCurve()\">\n      <meta name=\"indexterm\" content=\"getFlip()\">\n      <meta name=\"indexterm\" content=\"getCurveStartPoint()\">\n      <meta name=\"indexterm\" content=\"getCurveID()\">\n      <meta name=\"indexterm\" content=\"getCurve()\">\n      <meta name=\"indexterm\" content=\"appendCurveByID()\">\n      <meta name=\"indexterm\" content=\"appendCurve()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBS2RailSweepSurface : NURBSSurface</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0D9C8669-81FB-489B-9457-DC689EDAC5FD\"></a><div class=\"head\">\n            <h1>NURBS2RailSweepSurface : NURBSSurface </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4303\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4302\"></a>  This class defines a dependent 2-Rail Sweep surface. A 2-Rail Sweep surface uses at\n               least three curves. Two curves, the \"rails,\" define the two edges of the surface.\n               The other curves define the surface\'s cross sections. A 2-Rail Sweep surface is similar\n               to a 1-Rail sweep. The additional rail gives you more control over the shape of the\n               surface. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42FF\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-216A\"></a><pre><em class=\"codeEmphasisStrong\">NURBS2RailSweepSurface</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42FD\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2169\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42F9\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2168\"></a><pre>&lt;nurbs2railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">rail1</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42F7\"></a>The 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent rail curve by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2167\"></a><pre>&lt;nurbs2railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">rail1ID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42F4\"></a>The 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent rail curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2166\"></a><pre>&lt;nurbs2railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">rail2</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42F1\"></a>The 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent rail curve by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2165\"></a><pre>&lt;nurbs2railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">rail2ID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42EE\"></a>The 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent rail curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2164\"></a><pre>&lt;nurbs2railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">numCurves</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42EB\"></a>The number of cross-section curves. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2163\"></a><pre>&lt;nurbs2railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">parallel</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42E8\"></a>If <span class=\"code\"> <em class=\"strong\">false</em> </span>, the rail curves define a ruled surface, and the cross sections describe lofting\n               from this base ruled surface. If <span class=\"code\"> <em class=\"strong\">true</em> </span>, each cross section is associated with its best fitting plane. This plane moves along\n               the rails and parallel to them. If the rails are curved, the plane can rotate. If\n               the spacing between the rails changes, the section scales or stretches. In either\n               case, the surface is blended from section to section along its entire length. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42E7\"></a>&nbsp; \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-5210\"></a>           <em class=\"strong\">Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2162\"></a><pre><em class=\"codeEmphasisStrong\">appendCurve</em> &lt;nurbs2railsweepsurface&gt; &lt;curve&gt; [<em class=\"codeEmphasisStrong\">flip</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">startPoint</em>:&lt;float&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42DB\"></a>Adds a curve to the end of the list of cross-section curves by specifying the index\n               in the NURBSSet. If <span class=\"code\"> <em class=\"strong\">flip:true</em> </span> is specified, the cross-section curve is reversed. <span class=\"code\"> <em class=\"strong\">startPoint</em> </span> specifies the start point on the parent curve. <span class=\"code\"> <em class=\"strong\">startPoint</em> </span> is applicable only if the parent is a closed curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2161\"></a><pre><em class=\"codeEmphasisStrong\">appendCurveByID</em> &lt;nurbs2railsweepsurface&gt; &lt;curveID&gt; [<em class=\"codeEmphasisStrong\">flip</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">startPoint</em>:&lt;float&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42D8\"></a>Adds a curve to the end of the list of cross-section curves by specifying the NURBSId.\n               If <span class=\"code\"> <em class=\"strong\">flip:true</em> </span> is specified, the cross-section curve is reversed. <span class=\"code\"> <em class=\"strong\">startPoint</em> </span> specifies the start point on the parent curve. <span class=\"code\"> <em class=\"strong\">startPoint</em> </span> is applicable only if the parent is a closed curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2160\"></a><pre><em class=\"codeEmphasisStrong\">getCurve</em> &lt;nurbs2railsweepsurface&gt; &lt;index&gt; <em class=\"codeEmphasisStrong\">setCurve</em> &lt;nurbs2railsweepsurface&gt; &lt;index&gt; &lt;curve&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42D4\"></a>Get or set the indexed cross-section curve by NURBSSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-215F\"></a><pre><em class=\"codeEmphasisStrong\">getCurveID</em> &lt;nurbs2railsweepsurface&gt; &lt;index&gt; <em class=\"codeEmphasisStrong\">setCurveByID</em> &lt;nurbs2railsweepsurface&gt; &lt;index&gt; &lt;curveID&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42D0\"></a>Get or set the indexed cross-section curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-215E\"></a><pre><em class=\"codeEmphasisStrong\">getFlip</em> &lt;nurbs2railsweepsurface&gt; &lt;index&gt; <em class=\"codeEmphasisStrong\">setFlip</em> &lt;nurbs2railsweepsurface&gt; &lt;index&gt; &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42CC\"></a>Get or set whether the indexed cross-section curve is reversed. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-215D\"></a><pre><em class=\"codeEmphasisStrong\">getCurveStartPoint</em> &lt;nurbs2railsweepsurface&gt; &lt;index&gt; <em class=\"codeEmphasisStrong\">setCurveStartPoint</em> &lt;nurbs2railsweepsurface&gt; &lt;index&gt; &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42C8\"></a>Get or set the start point of the indexed cross-section curve on the parent curve.\n               The start point is applicable only if the parent is a closed curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42C5\"></a> <span class=\"char_link\"><a href=\"GUID-19C0A3FC-AECA-437A-A430-51EFC9D70545.htm\">NURBSSurface</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42C4\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-42C3\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";