var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-0EE531B2-6FF8-4D0B-ACA1-5400E0B9D604\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"getFilenameType()\">\n      <meta name=\"indexterm\" content=\"getFilenamePath()\">\n      <meta name=\"indexterm\" content=\"getFilenameFile()\">\n      <meta name=\"indexterm\" content=\"filenameFromPath()\">\n      <meta name=\"indexterm\" content=\"file name parsing\">\n      <meta name=\"indexterm\" content=\"files\">\n      <meta name=\"indexterm\" content=\"doesFileExist()\">\n      <meta name=\"indexterm\" content=\"files\">\n      <meta name=\"indexterm\" content=\"doesDirectoryExist()\">\n      <meta name=\"indexterm\" content=\"pathIsNetworkPath()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>File Name Parsing</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0EE531B2-6FF8-4D0B-ACA1-5400E0B9D604\"></a><div class=\"head\">\n            <h1>File Name Parsing </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F08\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F07\"></a>     The following function can be used to parse file name paths and extract different\n               parts like the path, the file name, the type (extension) etc. \n               		\n            </p> \n            <div><a name=\"GUID-E86BD07C-D0CB-42DA-BDE4-4DD235BA2009\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>These functions operate from the current working directory, when relative paths are\n                  used. The current directory can change depending on the last operation performed by\n                  3ds Max (for example, opening a scene file will set the current directory to the file\'s\n                  directory). Use \n                  		  <span class=\"code\">sysInfo.currentdir()</span> to get the current working directory. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-F72D2A66-2C5B-4DD5-9EAE-AF69E45895A1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69CA\"></a><pre><em class=\"codeEmphasisStrong\">filenameFromPath</em> &lt;filename_string&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F00\"></a>Returns the \n               		  <em class=\"strong\">file name and extension</em> of a full file name, useful for labeling file buttons in rollout panels. \n               		\n            </p> \n            <p><a name=\"GUID-97314A5C-4A39-494D-A66F-C7A89DF7174A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69C9\"></a><pre><em class=\"codeEmphasisStrong\">getFilenamePath</em> &lt;filename_string&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EFE\"></a>Returns the directory path part of a full file name. \n               		\n            </p> \n            <p><a name=\"GUID-0BEB26BD-28B2-48DD-A584-72324A347B4E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69C8\"></a><pre><em class=\"codeEmphasisStrong\">getFilenameFile</em> &lt;filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EFC\"></a>Returns the file name part of a full file name. \n               		\n            </p> \n            <p><a name=\"GUID-DEF9BE7A-A8D8-4BCA-A962-AAF24142A287\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69C7\"></a><pre><em class=\"codeEmphasisStrong\">getFilenameType</em> &lt;filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EFA\"></a>Returns the type extension part of a full file name. \n               		\n            </p> \n            <p><a name=\"GUID-48433A3E-A4B0-4F3E-8011-3BCD2D11216C\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69C6\"></a><pre><em class=\"codeEmphasisStrong\">doesFileExist</em> &lt;filename_string&gt; allowDirectory:&lt;bool&gt; ignoreCache:&lt;bool&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-7959\"></a>  Returns true if the file exists, false otherwise. \n               		\n            </p> \n            <p>When \n               		  <em class=\"strong\">allowDirectory</em> is true (the default), the \n               		  <span class=\"code\">&lt;filename_string&gt;</span> can be a directory name. \n               		\n            </p> \n            <p> if \n               		  <span class=\"code\">ignoreCache</span> is specified as true, testing does not consider whether the file\'s path may be in\n               the File Path Not Present Cache maintained by the MissingPathCache. See \n               		  <span class=\"char_link\"><a href=\"GUID-9EFFD0CD-7FFE-4F46-9022-E02186B34C5C.htm\">missingPathCache Interface</a></span> for more information. \n               		\n            </p> \n            <p><a name=\"GUID-538AA3F0-4C0D-4566-86A4-E6A0E3902FC1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">doesDirectoryExist</em> &lt;directoryname_string&gt;</pre></div> \n            <p>  Returns true if the directory exists, false otherwise. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69C5\"></a><pre><em class=\"codeEmphasisStrong\">pathIsNetworkPath</em> &lt;file_path&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EF3\"></a>  <em class=\"strong\">[</em> AVG \n               		  <em class=\"strong\">]</em> Returns true if the specified file path has a UNC network path signature (\\\\someslave\\)\n               and false if it has a local path signature (D:\\) where D: is a drive letter. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EF2\"></a>Available since \n               		  <em class=\"strong\">3ds Max 2008</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EF1\"></a>The method does not test for the path\'s existence, it only checks the signature of\n               the path to see if it is UNC or local. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EF0\"></a>See also \n               		  <span class=\"code\"> <em class=\"strong\">pathConfig.isUncPath()</em> </span> in the \n               		  <span class=\"char_link\"><a href=\"GUID-7F26EC19-6C56-4580-B6C3-C51ACC8E4356.htm\">PathConfig Struct</a></span> topic. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EEE\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EED\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69C4\"></a><pre>\nfile=\"g:\\\\subdir1\\\\subdir2\\\\myImage.jpg\"\nfilenameFromPath file -- returns: \"myImage.jpg\"\ngetFilenamePath file -- returns: \"g:\\subdir1\\subdir2\\\"\ngetFilenameFile file -- returns: \"myImage\"\ngetFilenameType file -- returns: \".jpg\"\npathIsNetworkPath \"c:\\\\temp\\\\test.txt\" --returns: false\npathIsNetworkPath \"\\\\\\\\someserver\\\\temp\\\\test.txt\" --returns: true\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EE1\"></a> <span class=\"char_link\"><a href=\"GUID-BB041082-3EEF-4576-9D69-5B258A59065E.htm\">Filestream Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EE0\"></a> <span class=\"char_link\"><a href=\"GUID-BA196B48-8ECA-4E0C-AE2E-F7EFAAF39844.htm\">External File Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EDF\"></a> <span class=\"char_link\"><a href=\"GUID-D4B43A33-8342-4BC9-80AB-91460861D37C.htm\">Standard Open and Save File Dialogs</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EDD\"></a> <span class=\"char_link\"><a href=\"GUID-7F26EC19-6C56-4580-B6C3-C51ACC8E4356.htm\">PathConfig Struct</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EDC\"></a> <span class=\"char_link\"><a href=\"GUID-0A32BE7C-2389-4C5B-8CD1-E3A1E04C3827.htm\">pluginPaths Struct</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";