var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-0F35AB71-82B2-499A-B933-CDF7AF681938\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"SceneMissingPlugIns Interface\">\n      <meta name=\"indexterm\" content=\"Interface SceneMissingPlugIns\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: SceneMissingPlugIns</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0F35AB71-82B2-499A-B933-CDF7AF681938\"></a><div class=\"head\">\n            <h1>Interface: SceneMissingPlugIns </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6EEF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6EEE\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; SceneMissingPlugIns \n                     </p>   \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-7116264F-94A1-4AD6-A6B1-37970357BC44\"></a> The <em class=\"strong\">SceneMissingPlugins Core Interface</em> provides methods to query to count, classes, file names and descriptions of missing\n            plugins in the current scene. \n         </p>\n         <p><a name=\"GUID-D719CC08-84E5-4430-8987-4E558D62CC34\"></a>Available in <em class=\"strong\">3ds Max 2014 and higher</em>. \n         </p>\n         <p><a name=\"GUID-679CA800-EEB5-485E-A499-6462C40BFECC\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-7E477F1D-1ED7-4A87-83F7-532FCA3B9534\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">SceneMissingPlugIns.GetMissingPlugInCount()</em></pre></div>\n         <p><a name=\"GUID-5DF486C7-9EE0-4A40-8458-4601B7E4ADD1\"></a>Returns the number of missing plugins in the current scene. \n         </p>\n         <p><a name=\"GUID-33883417-7B8C-4B09-9412-278DBA7EB603\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">SceneMissingPlugIns.GetMissingPlugInClassName</em> &lt;index&gt;Index</pre></div>\n         <p><a name=\"GUID-56FAB62A-6A6D-4E58-A4CB-030EB85210DD\"></a>Returns the class name of the indexed missing plugin. \n         </p>\n         <p><a name=\"GUID-9FD3CBFD-84FC-4815-8653-F4581F71F933\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">SceneMissingPlugIns.GetMissingPlugInFileName</em> &lt;index&gt;Index</pre></div>\n         <p><a name=\"GUID-2F8BC769-8FAC-4EE9-8BC1-5A49EE5CB4FB\"></a>Returns the file name of the indexed missing plugin. \n         </p>\n         <p><a name=\"GUID-1C5F4EE1-6B8D-49B0-A459-548EBBBD5374\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">SceneMissingPlugIns.GetMissingPlugInDescription</em> &lt;index&gt;Index</pre></div>\n         <p><a name=\"GUID-41325BAF-049B-4E15-964E-92E8F77FD0E6\"></a>Returns the description of the indexed missing plugin. \n         </p>\n         <p><a name=\"GUID-52A7C027-CA04-469C-93C1-AF5FC0A7B774\"></a>&nbsp;&nbsp;&nbsp; \n         </p><a name=\"TABLE_7604B4A4B5CB4F37A06A8BE6C1BF3116\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\n--The following script will print information about missing plugins, if any:\nfor i = 1 to SceneMissingPlugIns.GetMissingPlugInCount() do\n(\n    local theName = SceneMissingPlugIns.GetMissingPlugInClassName i\n    local theFileName = SceneMissingPlugIns.GetMissingPlugInFileName i\n    local theDesc = SceneMissingPlugIns.GetMissingPlugInDescription i\n    format \"%: % | % | %\\n\" i theName theFileName theDesc\n)\n--To test, evaluate a scripted plugin, create an instance of it in the scene and save the scene.\n--Restart 3ds Max and without reevaluating the scripted plugin, load the scene file.\n--Then execute the script above to see the information about your missing plugin.\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-74E3C764-9D0D-42B8-8258-78BDEEA3FD88\"></a></p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";