var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-1193B0E7-10DF-4D3F-A89F-29FF0A291646\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I align the UVW_Modifier\'s Gizmo to a selected face?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1193B0E7-10DF-4D3F-A89F-29FF0A291646\"></a><div class=\"head\">\n            <h1>How do I align the UVW_Modifier\'s Gizmo to a selected face? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1074\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1076\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1077\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8DC\"> Working With Editable Meshes</a></span> &gt; How do I align the UVW_Modifier\'s Gizmo to a selected face? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC107A\"></a>The following code implements the \"Normal Align\" feature of the UVW_Map modifier.\n            The \"Normal Align\" button is not directly accessible to MAXScript. This function can\n            be used as a replacement, and might help you understand the usefulness of the Vector\n            Cross Product. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC107B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC107C\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6644\"></a><pre>\nfn alignUVGizmo theObj theFace =\n(\n--&nbsp;First get the face normal vector.\n--&nbsp;It is shown in BLUE on the image\nfaceNormal = in coordsys theObj (getFaceNormal theObj theFace)\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1083\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-5E8F461C-9842-407F-8B58-21E71A518BE2-low.gif\"></div> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6643\"></a><pre>\n--&nbsp;This is the desired up vector in world space\n--&nbsp;It is shown in YELLOW on the image\nworldUpVector = [0,0,1]\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1087\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-3462E452-7D74-4AC5-AF65-3F12A83AE20B-low.gif\"></div> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6642\"></a><pre>\n--&nbsp;Now get the cross-product of the face normal and the up vector.\n--&nbsp;This will give you a vector that is perpendicular to the plane defined\n--&nbsp;by the normal and the up vector. Normalize it to get a normal vector\n--&nbsp;pointing to the right.\n--&nbsp;It is shown in RED on the image\nrightVector = normalize (cross worldUpVector faceNormal)\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC108F\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-06AEF84C-066C-4A21-A1D3-DA182B7A9288-low.gif\"></div> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6641\"></a><pre>\n--&nbsp;Now using the face normal and the new vector,\n--&nbsp;get a vector that is perpendicular to the plane defined by the two.\n--&nbsp;This is the \"local up vector\", the vector that is the projection of\n--&nbsp;the world up vector on the face you selected. This one is perpendicular\n--&nbsp;to both the face normal and the right vector, and you have 3 normals now\n--&nbsp;that define the X, Y and Z of your new orthogonal coordinate system\n--&nbsp;for the UVW gizmo!\n--&nbsp;Note that this new vector can be seen as the SHADOW of the World Up vector\n--&nbsp;on the face of the object in the above image.\n-- It is now displayed in green in the image below:\nupVector = normalize ( cross rightVector faceNormal )\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC109B\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-E1A5E554-50AD-4433-AC19-73A52F2E61E0-low.gif\"></div> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6640\"></a><pre>\n--&nbsp;Using the 3 vectors, define a matrix3 value which represents the\n--&nbsp;coordinate system of the gizmo. The face normal is the Z axis,\n--&nbsp;the right vector is the X axis, and the local up vector is the Y axis:\ntheMatrix = matrix3 rightVector upVector faceNormal [0,0,0]\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10A0\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-782FE8A0-AD9A-4B46-A4E0-DC47C352A2E2-low.gif\"></div> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-663F\"></a><pre>\ntheMap = Uvwmap()\nmodPanel.addModToSelection theMap ui: on\ntheMap.gizmo.transform = theMatrix\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10A9\"></a> <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values- Vector Cross Product</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10AB\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";