var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-11F1DD52-A99E-4537-90EC-8DFE9547F21E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Converting ActiveX TreeView Control to DotNet TreeView Control\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Converting ActiveX TreeView Control to DotNet TreeView Control</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-11F1DD52-A99E-4537-90EC-8DFE9547F21E\"></a><div class=\"head\">\n            <h1>Converting ActiveX TreeView Control to DotNet TreeView Control </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-AAB\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-AA7\"></a>TreeView Controls are among the most widely used ActiveX controls in scripted 3ds\n               Max tools. Converting such scripts to use DotNet TreeView controls is a relatively\n               straightforward process. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-AA5\"></a>Let\'s take as the base for our conversion example the simple script available in the\n               topic \n               		  <span class=\"char_link\"><a href=\"GUID-E6C53A89-CE94-4E2C-8143-7C8767BDC772.htm\">How To ... Develop a Scene Browser using TreeView ActiveX Control - Part One</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-AA3\"></a>In the following script, you can compare the original ActiveX code which is now remarked\n               and in green to the new commented DotNet code. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-AA2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-AA1\"></a><p class=\"table-body\"> <em class=\"strong\">CONVERSION OF THE SCRIPT - PART ONE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6775\"></a><pre>\nmacroScript SceneTreeView category:\"DotNet\"\n(\nrollout treeview_rollout \"TreeView Scene Browser\"\n(\n<em class=\"codeEmphasisMild\">/* ActiveXVersion:\nfn initTreeView tv =\n(\ntv.Indentation = 28*15\ntv.LineStyle = #tvwRootLines\n)\n*/</em>\n\nfn initTreeView tv =\n(\ntv.Indent= 28 --property name is different and value is in pixels\n--the default style already has root lines.\n) \n\n<em class=\"codeEmphasisMild\">/* ActiveXVersion:\nfn addChildren tv theNode theChildren =\n(\nfor c in theChildren do\n(\nnewNode = tv.Nodes.add theNode.index 4 \"\" c.name 0\naddChildren tv newNode c.children\n)\n)\n*/</em>\n\nfn addChildren theNode theChildren =\n(\nfor c in theChildren do\n(\nnewNode = theNode.Nodes.add c.name --add to the parent!\nnewNode.tag = dotNetMXSValue c --.tag can contain a MXS value\naddChildren newNode c.children --recursive call for new node\n)\n)\n\n<em class=\"codeEmphasisMild\">/* ActiveX Version:\nfn fillInTreeView tv =\n(\ntheRoot = tv.Nodes.add()\ntheRoot.text = \"WORLD ROOT\"\nrootNodes = for o in objects where o.parent == undefined collect o\naddChildren tv theRoot rootNodes\n)\n*/</em>\n\nfn fillInTreeView tv =\n(\ntheRoot = tv.Nodes.add \"WORLD ROOT\" --add parent node\nrootNodes = for o in objects where o.parent == undefined collect o\naddChildren theRoot rootNodes --no need to pass theTreeView\n)\n\n<em class=\"codeEmphasisMild\">/*ActiveX Version:\nactiveXControl tv \"MSComctlLib.TreeCtrl\" width:190 height:290 align:#center\n*/</em>\n\ndotNetControl tv \"TreeView\" width: 190 height:290 align:#center\nspinner spn_indent \"Indentation\" range:[0,100,28] type:#integer fieldwidth:40\n\n<em class=\"codeEmphasisMild\">/*ActiveX Version:\non tv nodeClick theNode do try(select (getNodeByName theNode.text))catch()\n*/</em>\n\non tv Click arg do\n(\n--First get theTreeView node below the mouse cursor\n--The arg argument has properties .x and .y with the current pos.\n--Use showProperties arg to see what is available...\n--We use the TreeView method GetNodeAt to see what was clicked:\nhitNode = tv.GetNodeAt (dotNetObject \"System.Drawing.Point\" arg.x arg.y)\nif hitNode != undefined do --if a TreeView node was clicked,\ntry(select hitNode.tag.value)catch(max select none)\n--...we try to select the object stored as value in the .tag\n)\n--We change the .indentation to .indent:\non spn_indent changed val do tv.indent = val\n--The rest of the script does not require changes:\non treeview_rollout open do\n(\ninitTreeView tv\nfillInTreeView tv\n)\n)\ntry(destroyDialog treeview_rollout)catch()\ncreateDialog treeview_rollout200 320\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-A43\"></a>Now let\'s take a look at the second part of the TreeView example found in the topic\n               \n               		  <span class=\"char_link\"><a href=\"GUID-399134B9-7BC1-4F2A-9525-BD7EED14221D.htm\">How To ... Develop a Scene Browser using TreeView ActiveX Control - PartTwo</a></span>. In this example, we will convert the ActiveX ImageList control to a DotNet ImageList\n               object, will add icons to the TreeView, set the node\'s color to the wireframe color\n               of the scene object and also add checkboxes to control the hidden state of the objects.\n               \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-A41\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-A40\"></a><p class=\"table-body\"> <em class=\"strong\">CONVERSION OF THE SCRIPT - PART TWO</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6774\"></a><pre>\nmacroScript SceneTreeView category:\"DotNet\"\n(\n--We create an ImageList object to hold all icons for the TreeView\n--in the local scope of the MacroScript. In he case of ActiveX,\n--the ImageList had to be a UI control inside the rollout.\n--It is possible to create a local DotNet object inside the rollout\n--and pass the ImageList as parameter to the functions, but it is\n--more convoluted. In this version, all functions \"see\" the\n--ImageList DotNet object in the higher scope:\nilTv = dotNetObject \"System.Windows.Forms.ImageList\"\nilTv.imageSize = dotNetObject \"System.Drawing.Size\" 16 15\nrollout treeview_rollout \"TreeView Scene Browser\"\n(\n<em class=\"codeEmphasisMild\">/* ActiveX Version:\nfn getIconFromBitmap thePath number =\n(\ntempBmp = openBitmap thePath\niconBmp = bitmap 16 15\nfor v = 0 to 14 do\nsetPixels iconBmp [0,v] (getPixels tempBmp [(number-1)*16, v] 16)\niconBmp.filename = getDir #image +\"/_temp.bmp\"\nsave iconBmp\nclose iconBmp\nclose tempBmp\ngetDir #image +\"/_temp.bmp\"\n)\n*/</em>\n--When creating icons for DotNet, it is necessary to create\n--one bitmap for each icon, because the DotNet image list will\n--lock the file for the duration of the script execution.\n--The original script used a single file to write temporarily\n--all icon bitmaps. This version writes a separate bitmap with the\n--name passed as third argument. The function only creates bitmaps\n--if they do not exist yet to avoid bitmap access errors.\nfn getIconFromBitmap thePath number iconFileName =\n(\ntheFileName = getDir #image +\"\\\\icon_\"+ iconFileName +\".bmp\"\nif not doesFileExist theFileName do\n(\ntempBmp = openBitmap thePath\niconBmp = bitmap 16 15\nfor v = 0 to 14 do\nsetPixels iconBmp [0,v] (getPixels tempBmp [(number-1)*16, v] 16)\niconBmp.filename = theFileName\nsave iconBmp\nclose iconBmp\nclose tempBmp\n)\nimg = dotNetClass \"System.Drawing.Image\" --create an image\nilTv.images.add (img.fromFile theFileName) --add to the list\n)\n<em class=\"codeEmphasisMild\">/* ActiveX Version:\nfn initTreeView tv ilTv =\n(\ntv.Indentation = 28*15\ntv.LineStyle = #tvwRootLines\ntv.checkboxes = true\ntv.sorted = true\nilTv.imagewidth = 16\nilTv.imageheight = 15\niconDir = (getDir #ui) + \"\\\\icons\"\nilTv.listImages.add 1 #root (loadPicture (getIconFromBitmap (iconDir + \"\\\\Standard_16i.bmp\") 2))\nilTv.listImages.add 2 #geomnode (loadPicture (getIconFromBitmap (iconDir + \"\\\\Standard_16i.bmp\") 1))\nilTv.listImages.add 3 #light (loadPicture (getIconFromBitmap (iconDir + \"\\\\Lights_16i.bmp\") 3))\nilTv.listImages.add 4 #camera (loadPicture (getIconFromBitmap (iconDir + \"\\\\Cameras_16i.bmp\") 2))\nilTv.listImages.add 5 #helper (loadPicture (getIconFromBitmap (iconDir + \"\\\\Helpers_16i.bmp\") 1))\ntv.imageList = ilTv\n)\n*/</em>\nfn initTreeView tv =\n(\ntv.Indent= 28\ntv.CheckBoxes = true --same as in ActiveX\n--This is the icons directory.\n--We could also use the new colorman.resolveIconFolder() method\n--to get the path to the actual system icons...\niconDir = (getDir #ui_ln) + \"icons\\\\\"\n--We call our function for each icon, this time also passing a\n--third argument with the icon name suffix.\ngetIconFromBitmap (iconDir + \"Standard_16i.bmp\") 2 \"Sphere\"\ngetIconFromBitmap (iconDir + \"Standard_16i.bmp\") 1 \"Box\"\ngetIconFromBitmap (iconDir + \"Lights_16i.bmp\") 3 \"Light\"\ngetIconFromBitmap (iconDir + \"Cameras_16i.bmp\") 2 \"Camera\"\ngetIconFromBitmap (iconDir + \"Helpers_16i.bmp\") 1 \"Helper\"\n--At the end, we assign the ImageList to the TreeView.\ntv.imageList = ilTv\n)\n<em class=\"codeEmphasisMild\">/* ActiveX Version:\nfn addChildren tv theNode theChildren =\n(\nfor c in theChildren do\n(\ntheIcon = case superclassof c of\n(\nGeometryClass: 2\nLight: 3\nCamera: 4\nHelper: 5\nDefault:2\n)\nnewNode = tv.Nodes.add theNode.index 4 \"\" c.name theIcon\ntheNode.sorted = true\nnewNode.checked = not c.isHidden\nnewNode.forecolor = color c.wirecolor.b c.wirecolor.g c.wirecolor.r\naddChildren tv newNode c.children\n)\n)\n*/</em>\nfn addChildren theNode theChildren =\n(\nfor c in theChildren do\n(\nnewNode = theNode.Nodes.add c.name\nnewNode.tag = dotNetMXSValue c\n--By default, all nodes will use icon 0 (the first one) unless\n--specified otherwise via the .iconIndex and .selectedIconIndex\n--properties.We set both of them to the icon corresponding to\n--the superclass of the scene object:\nnewNode.imageIndex = newNode.selectedImageIndex = case superclassof c of\n(\nDefault: 1\nLight: 2\nCamera: 3\nHelper: 4\n)\nnewNode.checked = not c.isHidden--same as in ActiveX\n--For the color, we create a DotNet color class from the\n--wirecolor of the object and assign to the .forecolor of\n--the TreeView node:\nnewNode.forecolor = (dotNetClass \"System.Drawing.Color\").fromARGB c.wirecolor.r c.wirecolor.g c.wirecolor.b\naddChildren newNode c.children\n)\n)\n--Since every node uses icon with index 0 unless specified otherwise\n--the Root Node will use the first icon by default.\nfn fillInTreeView tv =\n(\ntheRoot = tv.Nodes.add \"WORLD ROOT\"\nrootNodes =for o in objects where o.parent == undefined collect o\naddChildren theRoot rootNodes\n)\ndotNetControl tv \"TreeView\" width:290 height:490 align:#center\non tv Click arg do\n(\nhitNode = tv.GetNodeAt (dotNetObject \"System.Drawing.Point\" arg.x arg.y)\nif hitNode != undefined do\ntry(select hitNode.tag.value)catch(max select none)\n)\n<em class=\"codeEmphasisMild\">/*\non tv NodeCheck theNode do\n(\ntheSceneNode = (getNodeByName theNode.text)\nif theSceneNode != undefined do\ntheSceneNode.isHidden = not theNode.checked\n)\n*/</em>\n--NOTE that in the case of ActiveX controls, we were using the name\n--displayed by the TreeView node. In the case of DotNet, we are\n--using the actual MAXScript value pointing at the scene object.\n--The arg argument provides a .node property containing the node\n--that was checked. We use the .tag property to access the\n--DotNetMXSValue stored in the TreeView node and then the .value to\n--get the MAXScript value stored in it. Then we set the isHidden\n--property of the scene object to the inverse of the checked state\n--of the TreeView node:\non tv AfterCheck arg do\ntry (arg.node.tag.value.isHidden = not arg.node.checked)catch()\non treeview_rollout open do\n(\ninitTreeView tv\nfillInTreeView tv\n)\n)\ntry (destroyDialog treeview_rollout)catch()\ncreateDialog treeview_rollout 300 500\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-97C\"></a> <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet In MAXScript</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-97B\"></a> <span class=\"char_link\"><a href=\"GUID-E6C53A89-CE94-4E2C-8143-7C8767BDC772.htm\">How To ... Develop a Scene Browser using TreeView ActiveX Control - Part One</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-97A\"></a> <span class=\"char_link\"><a href=\"GUID-399134B9-7BC1-4F2A-9525-BD7EED14221D.htm\">How To ... Develop a Scene Browser using TreeView ActiveX Control - Part Two</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";