var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-1233998E-6755-451C-B9DF-95351475231F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSObject - Value\">\n      <meta name=\"indexterm\" content=\"NURBSControlVertex - NURBSObject\">\n      <meta name=\"indexterm\" content=\"getCV()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSControlVertex : NURBSObject</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1233998E-6755-451C-B9DF-95351475231F\"></a><div class=\"head\">\n            <h1>NURBSControlVertex : NURBSObject </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4629\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4628\"></a>   This class defines an independent Control Vertex of a NURBS Curve or NURBS Surface.\n               This class shares may of the same properties as a NURBSPoint and has the added property\n               of a rational weight. The weight value of a CV is rational. That is, it is relative\n               to other CVs in the curve or surface. Changing the weight of all CVs at once has no\n               effect, because this doesn’t change the ratio between weights. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4624\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2222\"></a><pre><em class=\"codeEmphasisStrong\">NURBSControlVertex</em> &lt;point3&gt; [&lt;weight_float&gt;] 	 </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2221\"></a><pre><em class=\"codeEmphasisStrong\">getCV</em> &lt;nurbscvcurve&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2220\"></a><pre><em class=\"codeEmphasisStrong\">getCV</em> &lt;nurbscvsurface&gt; &lt;u_index&gt; &lt;v_index&gt; </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-461D\"></a> <em class=\"strong\">Operators</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-221F\"></a><pre>&lt;nurbscontrolvertex&gt; == &lt;nurbscontrolvertex&gt;</pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-221E\"></a><pre>&lt;nurbscontrolvertex&gt; != &lt;nurbscontrolvertex&gt;</pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4618\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-221D\"></a><pre>&lt;nurbscontrolvertex&gt;.<em class=\"codeEmphasisStrong\">weight</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4616\"></a>The weight of the control vertex. This is a value greater than zero. Larger values\n               cause the CV to have a greater effect, thus the curve or surface will try to pass\n               closer to the CV. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4614\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4613\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";