var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-13500B2A-1364-424B-9C44-C6E973497635\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"World Space Modifiers - Validity Methods\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>World Space Modifiers - Validity Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-13500B2A-1364-424B-9C44-C6E973497635\"></a><div class=\"head\">\n            <h1>World Space Modifiers - Validity Methods </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6697\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C6698\"></a> The following method can be used to determine whether a Space Warp can be applied\n               to a given object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C669A\"></a>This method is available in <em class=\"strong\">3ds Max 2008</em> and higher. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-465C\"></a><pre>&lt; Boolean&gt;<em class=\"codeEmphasisStrong\">IsSpaceWarpValid</em> &lt;Scene Object&gt;object &lt;Space warp&gt;warp</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C669D\"></a>Returns true if it is possible to add the given space warp to the specified scene\n               object, false otherwise. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C669E\"></a> <span class=\"code\"> <em class=\"strong\">object</em> </span> &amp;endash; Any scene object that you want to apply theSpaceWarp too. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C669F\"></a> <span class=\"code\"> <em class=\"strong\">warp</em> </span> &amp;endash; AnySpaceWarpobject instance. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C66A0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C66A1\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE USAGE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-465B\"></a><pre>\n(\nlocal b = box()\nlocal p = parray()\nlocal o = omnilight()\nfor class in SpacewarpObject.classes do(\nif (class.creatable) then (\nlocal inst = class()\nfor obj in #(b,p,o) do (\nif (IsSpaceWarpValid obj inst) then\nformat \"+% can be applied to %\\n\" class obj\nelse\nformat \"-% CANNOT be applied to %\\n\" class obj\n)--end obj loop\n)--end if creatable\n)--end class loop\n)--end script\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C66B4\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-465A\"></a><pre>\n+SpaceBend can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SpaceBend can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SpaceBend CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+SpaceTaper can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SpaceTaper can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SpaceTaper CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Spaceripple can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+Spaceripple can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Spaceripple CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Spacewave can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+Spacewave can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Spacewave CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+SpaceTwist can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SpaceTwist can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SpaceTwist CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+SpaceStretch can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SpaceStretch can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SpaceStretch CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+gravity can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+gravity can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-gravity CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Wind can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Wind CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Spacedisplace can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+Spacedisplace can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Spacedisplace CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Deflector can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+Deflector can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Deflector CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Bomb can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n-Bomb CANNOT be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Bomb CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+PDynaFlect can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+PDynaFlect can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-PDynaFlect CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Vortex can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+Vortex can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Vortex CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+UOmniFlect can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+UOmniFlect can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-UOmniFlect CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+UDeflector can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+UDeflector can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-UDeflector CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+PushSpaceWarp can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+PushSpaceWarp can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-PushSpaceWarp CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+ConformSpaceWarp can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+ConformSpaceWarp can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-ConformSpaceWarp CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+SDynaFlect can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SDynaFlect can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SDynaFlect CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Drag can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+Drag can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Drag CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+WaterSpaceWarp can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+WaterSpaceWarp can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-WaterSpaceWarp CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+PBomb can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+PBomb can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-PBomb CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+POmniFlect can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+POmniFlect can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-POmniFlect CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Motor can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+Motor can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Motor CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+SOmniFlect can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SOmniFlect can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SOmniFlect CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+SpaceFFDBox can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SpaceFFDBox can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SpaceFFDBox CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+UDynaFlect can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+UDynaFlect can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-UDynaFlect CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+SDeflector can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SDeflector can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SDeflector CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+SpaceSkew can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SpaceSkew can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SpaceSkew CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Vector_Field can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+Vector_Field can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Vector_Field CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+Path_Follow can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+Path_Follow can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-Path_Follow CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+SpaceNoise can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SpaceNoise can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SpaceNoise CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\n+SpaceFFDCyl can be applied to $Box:Box04 @ [0.000000,0.000000,0.000000]\n+SpaceFFDCyl can be applied to $PArray:PArray03 @ [0.000000,0.000000,0.000000]\n-SpaceFFDCyl CANNOT be applied to $Omni_Light:Omni03 @ [0.000000,0.000000,0.000000]\nOK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";