var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-14B02950-26DF-498C-A88A-CD87DC84473C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Develop An SVG Polygon Renderer Part 3\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop An SVG Polygon Renderer - Part 3</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-14B02950-26DF-498C-A88A-CD87DC84473C\"></a><div class=\"head\">\n            <h1>How To ... Develop An SVG Polygon Renderer - Part 3 </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34A3\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34A4\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; Develop An SVG Polygon Renderer - Part 3 \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-313234CA-9188-4DA4-BA27-A9FC189538EC\"></a> The following is <em class=\"strong\">part three</em> of a three parts tutorials series demonstrating the use of MAXScript together with\n            the <span class=\"char_link\"><a href=\"GUID-CA5BD5C0-E2B3-4C8F-8115-0E670B71B5E7.htm\">Vector_Map TextureMap</a></span>. MAXScript will be used to write an SVG XML file to disk containing polygon entities\n            representing the faces of scene objects to be rendered. The SVG file can be loaded\n            in any Web Browser or rendered to a bitmap via the <span class=\"code\"> <em class=\"strong\">renderMap()</em> </span> function. For more information about the use of MAXScript to create SVG files, please\n            see the <span class=\"char_link\"><a href=\"GUID-3EF5C2D1-992C-4F29-8543-72D61F2870D1.htm\">Vector_Map TextureMap and MAXScript</a></span> topic. \n         </p>\n         <p><a name=\"GUID-FD947704-78BE-471F-BDBC-CCF234B11188\"></a>In <span class=\"char_link\"><a href=\"GUID-6B5EDC11-A154-4AA7-A972-A11AC36949E9.htm\">the first part of the tutorial</a></span>, we output all camera-facing triangle faces of all geometry object. \n         </p>\n         <p><a name=\"GUID-E58D83CD-8CAF-4F2F-8E4B-A207E44318DA\"></a>In <span class=\"char_link\"><a href=\"GUID-0453DFB1-1773-40DC-928E-C328D53EE293.htm\">the second part of the tutorial</a></span>, we sorted the polygons by depth to make sure the faces do not overlap incorrectly.\n            \n         </p>\n         <p><a name=\"GUID-49276167-56A9-4472-BDE3-1889FAB95671\"></a> In <em class=\"strong\">this third part of the tutorial</em>, we will add support for material colors and implement lighting using Facets Shading\n            and Blinn Specular Highlights. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34A8\"></a> <em class=\"strong\">Related topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34A9\"></a> <span class=\"char_link\"><a href=\"GUID-CA5BD5C0-E2B3-4C8F-8115-0E670B71B5E7.htm\">Vector_Map TextureMap</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34AA\"></a> <span class=\"char_link\"><a href=\"GUID-3EF5C2D1-992C-4F29-8543-72D61F2870D1.htm\">Vector_Map TextureMap and MAXScript</a></span> \n         </p>\n         <p><a name=\"GUID-052BEBCC-4DEE-450D-A260-61DDC9DD8754\"></a> <span class=\"char_link\"><a href=\"GUID-B57EA575-DCDE-42F5-9D30-88E3EB41F350.htm#GUID-DF4741A6-F352-4E30-9EEF-35E4CDD45042\">Number Values - bit methods</a></span> \n         </p>\n         <p><a name=\"GUID-A50ACC0B-77D1-4621-AD61-52D453DF509B\"></a> <span class=\"char_link\"><a href=\"GUID-43EC5EED-F275-4325-8D99-819C51C11380.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-43D6\">renderMap Method</a></span> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34AD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34AE\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34AF\"></a><p class=\"table-body\">Get the Viewer\'s Position value from the View Transformation Matrix. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34B0\"></a><p class=\"table-body\">Get the Diffuse Color, SpecularLevel and Glossiness of the material, if any. Otherwise\n                        use default values. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-BEE14D43-F0AF-4900-A8E8-DC44CF58644E\"></a><p class=\"table-body\">Calculate the Diffuse and Specular components of the Blinn Shading model. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-8F13FF90-195A-4EB7-A916-3A6FC149A0FE\"></a><p class=\"table-body\">Accumulate the influence of all scene lights in a variable </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-8B01812F-B5A8-41C3-A154-E879A8034305\"></a><p class=\"table-body\">Pass the new lighting variable to the array for sorting and drawing. </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34B4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC34B5\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>(\nfn ColorToHex col =\n(\n	local theComponents = #(bit.intAsHex col.r, bit.intAsHex col.g, bit.intAsHex col.b)\n	local theValue = \"#\"\n	for i in theComponents do \n		theValue += (if i.count == 1 then \"0\" else \"\") + i\n	theValue\n)\n\nfn compareFN v1 v2=\n(\n	if v1[6] &lt; v2[6] then -1 else 1\n)\n\nlocal st = timestamp()\nlocal theFileName = (getDir #userscripts + \"\\\\PolygonRendering8.svg\")\nlocal theSVGfile = createFile theFileName\nformat \"&lt;svg xmlns=\\\"http://www.w3.org/2000/svg\\\"\\n\" to:theSVGfile\nformat \"\\t\\txmlns:xlink=\\\"http://www.w3.org/1999/xlink\\\"&gt;\\n\" to:theSVGfile\n\nlocal theViewTM =  viewport.getTM()\ntheViewTM.row4 = [0,0,0]\nlocal theViewTM2 = viewport.getTM()\n<em class=\"codeEmphasisStrong\">local theViewPos = (inverse (viewport.getTM())).row4</em>\nlocal theViewSize = getViewSize()\nlocal theViewScale = getViewSize()\ntheViewScale.x /= 1024.0\ntheViewScale.y /= 1024.0\n\nlocal drawArray = #()	\n	\nlocal theStrokeThickness = 1\n	\ngw.setTransform (matrix3 1)	\nlocal theLights = for o in Lights where classof o != TargetObject collect o\nfor o in Geometry where not o.isHiddenInVpt and classof o != TargetObject do\n(\n	<em class=\"codeEmphasisStrong\">local theStrokeColor = o.wirecolor\n	if classof o.material == StandardMaterial then \n	(\n		local theFillColor = o.material.diffusecolor \n		local theSpecularPower = o.material.Glossiness\n		local theSpecularLevel = o.material.SpecularLevel/100.0\n	)\n	else\n	(\n		local theFillColor = o.wirecolor	\n		local theSpecularPower = 50.0\n		local theSpecularLevel = 0.25\n	)</em>\n	\n	local theMesh = snapshotAsMesh o\n	for f = 1 to theMesh.numfaces do\n	(\n		local theNormal = normalize (getfaceNormal theMesh f) \n		if (theNormal*theViewTM).z &gt; 0 do\n		(\n			local theFace = getFace theMesh f\n			local v1 = gw.transPoint (getVert theMesh theFace.x)\n			local v2 = gw.transPoint (getVert theMesh theFace.y)\n			local v3 = gw.transPoint (getVert theMesh theFace.z)\n			\n			v1.x /= theViewScale.x \n			v1.y /= theViewScale.y \n			v2.x /= theViewScale.x \n			v2.y /= theViewScale.y\n			v3.x /= theViewScale.x\n			v3.y /= theViewScale.y\n			\n			local theFaceCenter = meshop.getFaceCenter theMesh f\n			local theZDepth = (theFaceCenter*theViewTM2).z\n			local theViewVector = normalize (theViewPos - theFaceCenter)\n			\n			<em class=\"codeEmphasisStrong\">local theLitFillColor = black\n			for aLight in theLights where classof aLight != TargetObject do\n			(\n				local theLightVector = normalize (aLight.pos - theFaceCenter)\n				local theHalfVector = normalize (theLightVector + theViewVector)\n				\n				theDiffuse = (dot theLightVector theNormal)\n				if theDiffuse &lt; 0 do theDiffuse = 0\n					\n				theSpecular = (dot theNormal theHalfVector)\n				if theSpecular &lt; 0 do theSpecular = 0\n				theSpecular = (theSpecular^theSpecularPower)*theSpecularLevel\n			\n				theLitFillColor += theFillColor * aLight.color * theDiffuse + aLight.color * theSpecular\n			)\n			if theLitFillColor.r &gt; 255.0 do theLitFillColor.r = 255\n			if theLitFillColor.g &gt; 255.0 do theLitFillColor.g = 255\n			if theLitFillColor.b &gt; 255.0 do theLitFillColor.b = 255</em>\n			\n			append drawArray #(v1, v2, v3, (ColorToHex theStrokeColor), (ColorToHex <em class=\"codeEmphasisStrong\">theLitFillColor</em>), theZDepth)\n		)--end aLight loop\n	)--end f loop\n)--end o loop\nqsort drawArray compareFN\n\nfor d in drawArray do\n(\n	format \"\\t&lt;polygon points=\'%,%  %,%  %,%\' \\n\" d[1].x d[1].y d[2].x d[2].y d[3].x d[3].y to:theSVGfile\n	format \"\\tstyle=\'stroke:%; fill:%; stroke-width:%\'/&gt;\\n\" d[4] d[5] theStrokeThickness to:theSVGfile\n)\n\nformat \"&lt;/svg&gt;\\n\" to:theSVGfile\nclose theSVGfile\nlocal theSVGMap = VectorMap vectorFile:theFileName alphasource:0\nlocal theBitmap = bitmap theViewSize.x theViewSize.y\nrenderMap theSVGMap into:theBitmap filter:true\ndisplay theBitmap\nformat \"Render Time: % sec.\\n\" ((timestamp()-st)/1000.0)\n)</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_04EFDCE704F94B138B888F8419598EF7\"></a> \n            <h2><a name=\"GUID-3A709F2D-0C86-42DE-902A-841B2E8570DB\"></a>Step-By-Step\n            </h2> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisMild\">(\nfn ColorToHex col =\n(\n	local theComponents = #(bit.intAsHex col.r, bit.intAsHex col.g, bit.intAsHex col.b)\n	local theValue = \"#\"\n	for i in theComponents do \n		theValue += (if i.count == 1 then \"0\" else \"\") + i\n	theValue\n)\n\nfn compareFN v1 v2=\n(\n	if v1[6] &lt; v2[6] then -1 else 1\n)\n\nlocal st = timestamp()\nlocal theFileName = (getDir #userscripts + \"\\\\PolygonRendering8.svg\")\nlocal theSVGfile = createFile theFileName\nformat \"&lt;svg xmlns=\\\"http://www.w3.org/2000/svg\\\"\\n\" to:theSVGfile\nformat \"\\t\\txmlns:xlink=\\\"http://www.w3.org/1999/xlink\\\"&gt;\\n\" to:theSVGfile\n\nlocal theViewTM =  viewport.getTM()\ntheViewTM.row4 = [0,0,0]\nlocal theViewTM2 = viewport.getTM()</em></pre></div> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">local theViewPos = (inverse (viewport.getTM())).row4</em> </pre></div> \n            <p><a name=\"GUID-6250A8F6-BEF9-44D3-BCB6-5BD0F5EFDDA3\"></a>In order to calculate the shading, we will need to compute the view ray connecting\n               the eye (camera position) with the center of the face. \n            </p> \n            <p><a name=\"GUID-326F6ED0-EF7B-43E2-AF14-C7298A101BB1\"></a>Even when there is no explicit camera, the fourth row of the inverted view transformation\n               matrix gives us the viewer\'s location. \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisMild\">local theViewSize = getViewSize()\nlocal theViewScale = getViewSize()\ntheViewScale.x /= 1024.0\ntheViewScale.y /= 1024.0\n\nlocal drawArray = #()	\n	\nlocal theStrokeThickness = 1\n	\ngw.setTransform (matrix3 1)	\nlocal theLights = for o in Lights where classof o != TargetObject collect o\nfor o in Geometry where not o.isHiddenInVpt and classof o != TargetObject do\n(</em></pre></div> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">	local theStrokeColor = o.wirecolor\n	if classof o.material == StandardMaterial then \n	(\n		local theFillColor = o.material.diffusecolor \n		local theSpecularPower = o.material.Glossiness\n		local theSpecularLevel = o.material.SpecularLevel/100.0\n	)\n	else\n	(\n		local theFillColor = o.wirecolor	\n		local theSpecularPower = 50.0\n		local theSpecularLevel = 0.25\n	)</em></pre></div> \n            <p><a name=\"GUID-9778D70B-553B-4C7A-8A70-D149F4280839\"></a>We will now change the Stroke color to be taken from the object\'s wirecolor property.\n               \n            </p> \n            <p><a name=\"GUID-99BF6B01-BB99-4A67-9E1F-937A9BAEAEAE\"></a>The Fill color will be set to the diffuse color of the material if a Standard Material\n               is assigned to the object, otherwise the wirecolor will be used again. \n            </p> \n            <p><a name=\"GUID-B9700ADB-DD3E-4FEB-AA14-B8C86B105AB8\"></a>Additionally, we will try to get the SpecularPower (Glossiness) value and the SpecularLevel\n               of the Standard Material to reflect correctly the shading parameters. \n            </p> \n            <p><a name=\"GUID-AE8BE4FC-8889-42F5-AF8F-0FAEF66A9F18\"></a>Note that the 3ds Max UI exposes the Specular Level as 100 times stronger to make\n               it easier to control, so we have to divide it by 100.0 to bring it in the right range.\n               \n            </p> \n            <p><a name=\"GUID-2ECF50F3-43AC-472D-80AA-0131CD2045C4\"></a>If there is no Material, we will set the specular settings to be very close to what\n               the <em class=\"strong\">3ds Max</em> viewports use in that case... \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisMild\">local theMesh = snapshotAsMesh o\n	for f = 1 to theMesh.numfaces do\n	(\n		local theNormal = normalize (getfaceNormal theMesh f) \n		if (theNormal*theViewTM).z &gt; 0 do\n		(\n			local theFace = getFace theMesh f\n			local v1 = gw.transPoint (getVert theMesh theFace.x)\n			local v2 = gw.transPoint (getVert theMesh theFace.y)\n			local v3 = gw.transPoint (getVert theMesh theFace.z)\n			\n			v1.x /= theViewScale.x \n			v1.y /= theViewScale.y \n			v2.x /= theViewScale.x \n			v2.y /= theViewScale.y\n			v3.x /= theViewScale.x\n			v3.y /= theViewScale.y\n			\n			local theFaceCenter = meshop.getFaceCenter theMesh f\n			local theZDepth = (theFaceCenter*theViewTM2).z</em></pre></div> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">\n			local theViewVector = normalize (theViewPos - theFaceCenter)</em></pre></div> \n            <p><a name=\"GUID-1E7021A6-A0BB-4EDA-806E-AEF49CF40E41\"></a>For the shading calculations, we will need the normalized view vector pointing from\n               the center of the face at the viewer\'s position. \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">local theLitFillColor = black</em></pre></div> \n            <p><a name=\"GUID-2291657F-0ACA-4244-92DC-AF355AB6126B\"></a>We will initialize a new variable to black color. \n            </p> \n            <p><a name=\"GUID-0704BBFD-9DF0-4B17-B195-8A7A563F4FB3\"></a>This will be the variable where we will accumulate the lighting information as we\n               process the lights and shade the face. \n            </p> \n            <p><a name=\"GUID-7B672820-7C6F-4D1A-8C06-D051EAEFC03B\"></a>We could initialize this value to the Ambient color of the material if we want to\n               support Ambient lighting. \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">			for aLight in theLights where classof aLight != TargetObject do\n			(\n				local theLightVector = normalize (aLight.pos - theFaceCenter)\n				local theHalfVector = normalize (theLightVector + theViewVector)</em></pre></div> \n            <p><a name=\"GUID-9EF85162-B762-47A4-907D-E9A6C521F3BC\"></a>A for loop will visit all light sources in the scene. \n            </p> \n            <p><a name=\"GUID-00DF27D0-9E70-4A2C-B276-C01BF7850EC3\"></a>For each light, we will calculate the light vector (a normalized vector pointing from\n               the center of the face at the light). \n            </p> \n            <p><a name=\"GUID-838E7F68-2F96-4F45-81DE-A2D4EDAE31B9\"></a>We will also calculate the Half-Vector (according to the Blinn Shading approximation\n               of the Phong Shading model) by adding the Light Vector and the View Vector. \n            </p> \n            <div class=\"codeBlock\"><pre> <em class=\"codeEmphasisStrong\">				theDiffuse = (dot theLightVector theNormal)\n				if theDiffuse &lt; 0 do theDiffuse = 0</em></pre></div> \n            <p><a name=\"GUID-989CAD48-16E5-4623-A570-50C6A7CDB987\"></a>The Diffuse component is calculated as the dot product of the Light Vector and the\n               Normal. It is view-independent (because the diffusion is Isotropic, the same in all\n               directions). \n            </p> \n            <p><a name=\"GUID-5E3DA451-5015-460A-B59D-474260CEFD4A\"></a>The amount of light diffused depends only on the cosine of the angle between the Light\n               Vector and the Normal. \n            </p> \n            <p><a name=\"GUID-00B1E990-49D9-4216-BD49-395994315DD6\"></a>Faces pointing away from the light get no light at all, so when the dot product is\n               negative, we set the value to 0. \n            </p> \n            <div class=\"codeBlock\"><pre> <em class=\"codeEmphasisStrong\">				theSpecular = (dot theNormal theHalfVector)\n				if theSpecular &lt; 0 do theSpecular = 0\n				theSpecular = (theSpecular^theSpecularPower)*theSpecularLevel</em> </pre></div> \n            <p><a name=\"GUID-52299231-BC4E-4283-B7C3-028E96A3F806\"></a>The Specular component on the other hand is view-dependent. \n            </p> \n            <p><a name=\"GUID-6223A054-1F98-47EF-85AB-99F4D3241094\"></a>We calculate the dot product of the Normal and the Half Vector which depends on the\n               Light Vector and the View Vector. \n            </p> \n            <p><a name=\"GUID-A4552A43-7ACB-4524-9FCC-F4C6F17B6F86\"></a>Again, we don\'t want any influence on faces that are facing in the opposite direction,\n               so we zero out any values below 0. \n            </p> \n            <p><a name=\"GUID-BAE78840-E3ED-40EA-9494-356284A5264F\"></a>The actual specular value is then taken to the power of the Glossiness (a.k.a. SpecularPower),\n               and multiplied by the Specular Level. \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">				theLitFillColor += theFillColor * aLight.color * theDiffuse + aLight.color * theSpecular\n			)--end aLight loop</em></pre></div> \n            <p><a name=\"GUID-2D1A578C-449C-4C7B-80D2-2920F81F94B8\"></a>The influence of the light will be accumulated into the variable we originally initialized\n               to black. \n            </p> \n            <p><a name=\"GUID-A6DC0C6D-A33F-4705-8F99-297D13EFA5C0\"></a>The value that is added is comprised of the fill color multiplied by the light color,\n               multiplied by the Diffuse coefficient. \n            </p> \n            <p><a name=\"GUID-891AEA35-32BB-4DDE-A717-80297EF53568\"></a>To that we add the light color multiplied by the Specular coefficient. \n            </p> \n            <p><a name=\"GUID-CC196582-FB71-48D1-BACE-BE6B62B0D1FE\"></a>This is repeated for all lights, producing the combined illumination of the face.\n               \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">			if theLitFillColor.r &gt; 255.0 do theLitFillColor.r = 255\n			if theLitFillColor.g &gt; 255.0 do theLitFillColor.g = 255\n			if theLitFillColor.b &gt; 255.0 do theLitFillColor.b = 255</em></pre></div> \n            <p><a name=\"GUID-C206607E-B030-4286-AE94-B222A136EDB3\"></a>Finally we want to clamp the color to 255 to avoid strange results because the Hexadecimal\n               conversion does not support Hight Dynamic Range colors. \n            </p> \n            <div class=\"codeBlock\"><pre>			\n			append drawArray #(v1, v2, v3, (ColorToHex theStrokeColor), (ColorToHex <em class=\"codeEmphasisStrong\">theLitFillColor</em>), theZDepth)</pre></div> \n            <p><a name=\"GUID-06988983-7781-4D5C-A969-23AC799A8117\"></a>We just have to change the name of the Fill Color variable to include the lighting\n               in the array. \n            </p> \n            <div class=\"codeBlock\"><pre>\n							)\n	)--end f loop\n)--end o loop\nqsort drawArray compareFN\n\nfor d in drawArray do\n(\n	format \"\\t&lt;polygon points=\'%,%  %,%  %,%\' \\n\" d[1].x d[1].y d[2].x d[2].y d[3].x d[3].y to:theSVGfile\n	format \"\\tstyle=\'stroke:%; fill:%; stroke-width:%\'/&gt;\\n\" d[4] d[5] theStrokeThickness to:theSVGfile\n)\n\nformat \"&lt;/svg&gt;\\n\" to:theSVGfile\nclose theSVGfile\nlocal theSVGMap = VectorMap vectorFile:theFileName alphasource:0\nlocal theBitmap = bitmap theViewSize.x theViewSize.y\nrenderMap theSVGMap into:theBitmap filter:true\ndisplay theBitmap\nformat \"Render Time: % sec.\\n\" ((timestamp()-st)/1000.0)\n)</pre></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_CF3CCF5FCB7244ED853AF91A1334812B\"></a> \n            <h2><a name=\"GUID-9110546E-4936-479B-95DC-89C8FA0D88E4\"></a>Using The Script To Render Geometry And Lights\n            </h2> \n            <p><a name=\"GUID-433A96A6-4203-400D-9974-5D5664092E0A\"></a>Let\'s render once again the same Geosphere as before, but this time lit by two Omni\n               lights - one white on the left, and one blue and with a lower Multiplier on the right.\n               \n            </p> \n            <p><a name=\"GUID-E590DDB9-4F5A-40A9-B77E-E33B3E101700\"></a>The left image is the screenshot of the viewport set to Facets + Edged Faces mode.\n               The right image shows the render output of our SVG script: \n            </p> <img src=\"../images/GUID-C84DFD5F-E226-4A55-9298-3945D08D27FA-low.png\"> <img src=\"../images/GUID-6AA98CD9-6EAD-4E8A-AD57-B11BFC432B31-low.png\"> \n            <p><a name=\"GUID-3A58DDFD-B1C7-49AA-A52A-4BCB074F9FA3\"></a>Let\'s see how this changes when we assign a default Standard Material to this object.\n               \n            </p> \n            <p><a name=\"GUID-9B89B48B-E209-4523-8DF7-F20D28756238\"></a>The Fill color of the faces will now be taken from the Diffuse color of the material,\n               while the Stroke color will be taken from the .wirecolor property: \n            </p> <img src=\"../images/GUID-EAB89C30-A7F6-4658-BFD2-A1DB34B2DBF8-low.png\"> <img src=\"../images/GUID-727BE682-9D48-4DE2-8FA4-44D479712CB3-low.png\"> \n            <p><a name=\"GUID-59BAF4A8-5548-4482-A9DA-611AE750993C\"></a>The default Standard Material has a Specular Level of 0, so there is no Specular component\n               in the above rendering. \n            </p> \n            <p><a name=\"GUID-5647A90D-561E-4FC9-AA21-9F5FC70C1176\"></a>Let\'s increase the Specular Level to 100, and change the Glossiness to 20. \n            </p> <img src=\"../images/GUID-370D4B31-063D-4AB2-91DB-352AF78BC506-low.png\"> <img src=\"../images/GUID-496B9530-7ED2-4C3B-9E05-C60E5D6A5649-low.png\"> \n            <p><a name=\"GUID-1C57CEA9-57E0-4E3C-91F4-DFD2FD1DDAA2\"></a>It is very easy to modify the script to render without edged faces - simply set the\n               edge color to the lit fill color! \n            </p> \n            <div class=\"codeBlock\"><pre>append drawArray #(v1, v2, v3, (ColorToHex <em class=\"codeEmphasisStrong\">theLitFillColor</em>), (ColorToHex theLitFillColor), theZDepth)</pre></div> \n            <p><a name=\"GUID-02FCC479-E288-45AA-909C-D3CF738B22B6\"></a>As you can see, our script\'s output matches very closely the representation of the\n               same object in the viewport: \n            </p> <img src=\"../images/GUID-809E9482-71C0-4FE9-8AB2-E413AD1EE9DE-low.png\"> <img src=\"../images/GUID-F227DCF4-A40C-4E7A-B706-C6C146E8F8B1-low.png\"> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";