var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-162DC544-DC8D-41E9-8DAD-D0F7266BF173\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"SessionPaths Struct\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>SessionPaths Struct</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-162DC544-DC8D-41E9-8DAD-D0F7266BF173\"></a><div class=\"head\">\n            <h1>SessionPaths Struct </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FED\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FEC\"></a> Session paths are identical to bitmap/photometric paths and xref paths, except they\n               are never saved when <em class=\"strong\">3ds Max</em> exits. \n            </p> \n            <p><a name=\"GUID-5325F1D4-F254-4684-82CD-BB7A6992B379\"></a>The list of session paths is always empty when <em class=\"strong\">3ds Max</em> boots up. \n            </p> \n            <p><a name=\"GUID-E8C8215D-938F-4CAC-AF50-8665AE0F89D6\"></a>However, if session paths are configured before a file is loaded, then they will be\n               used to search for resources in the file. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-755F\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The session paths are <em class=\"strong\">NOT</em> displayed in the Configure Paths dialog! \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FE6\"></a>There are four functions available through the sessionPaths structure. In each function,\n               the keyword <span class=\"code\"> <em class=\"strong\">#map</em> </span> can be replaced with <span class=\"code\"> <em class=\"strong\">#xref</em> </span> to specify an xref path. \n            </p> \n            <p><a name=\"GUID-4C9090D8-4CB1-4466-B8DC-D759BF009795\"></a>The two lists of session paths (bitmaps and xrefs) are maintained separately from\n               each other. \n            </p> \n            <p><a name=\"GUID-C756DCB4-2FDB-4C46-8299-57AF167549C1\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69E5\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">sessionPaths.add</em> (<em class=\"codeEmphasisStrong\">#map</em> |	<em class=\"codeEmphasisStrong\">#xref</em> ) &lt;String path&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FE4\"></a>Adds a new bitmap or xref session path. Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> on success. Adding the same path more than once will result in a single path stored\n               in the session paths. \n            </p> \n            <p><a name=\"GUID-36913AC3-D5F2-4705-8C45-0D4DDE945BD4\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69E4\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">sessionPaths.count</em> ( <em class=\"codeEmphasisStrong\">#map</em> |	<em class=\"codeEmphasisStrong\">#xref</em> )   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FE1\"></a>Returns the number of bitmap or xref session paths. \n            </p> \n            <p><a name=\"GUID-B46C7480-B301-4D81-9287-5DEFB4BD670C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69E3\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">sessionPaths.get</em> ( <em class=\"codeEmphasisStrong\">#map</em> | <em class=\"codeEmphasisStrong\">#xref</em> ) &lt;Integer index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FDE\"></a>Returns the indexed bitmap or xref session path. \n            </p> \n            <p><a name=\"GUID-6B685454-4108-4D75-9E15-9AC32E146C5B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69E2\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">sessionPaths.delete</em> ( <em class=\"codeEmphasisStrong\">#map</em> | <em class=\"codeEmphasisStrong\">#xref</em> ) &lt;Integer index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FDB\"></a>Deletes the indexed bitmap or xref session path. Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> on success. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FDA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FD9\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69E1\"></a><pre>\nsessionPaths.count #map --the number of session bitmap paths\n0 --there are none at this point\nsessionPaths.add #map \"d:/maps\" --add a bitmap session path\ntrue --success!\nsessionPaths.count #map --has the number of paths changed?\n1 --of course it did!\nsessionPaths.get #map 1 --get the first bitmap session path\n\"d:/maps\" --what you put in, comes out...\nsessionPaths.delete #map 1 --delete the first bitmap session path\ntrue --dead you are!\nsessionPaths.count #map --and the number of session paths is...\n0 --none.\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FC9\"></a>One suggested use for session paths is to create a \"project\" system of asset management.\n               Each project has certain folders for bitmaps and xrefs. Before a user loads a file,\n               they would first load the project settings, which would set up the appropriate session\n               paths. Any files loaded as part of that project will automatically have access to\n               the correct library of maps and xrefs. If a project is closed, the session paths would\n               be deleted. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FC7\"></a> <span class=\"char_link\"><a href=\"GUID-F7577416-051E-478C-BB5D-81243BAAC8EC.htm\">3ds Max System Directories</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";