var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-17DBC9E3-5B61-4738-B78B-D3D57A515CE8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"RCMenu\">\n      <meta name=\"indexterm\" content=\"menus\">\n      <meta name=\"indexterm\" content=\"scripted right-click menus\">\n      <meta name=\"indexterm\" content=\"right-click menus\">\n      <meta name=\"indexterm\" content=\"mouse right-click menus\">\n      <meta name=\"indexterm\" content=\"popUpMenu()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Right-Click Menus</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-17DBC9E3-5B61-4738-B78B-D3D57A515CE8\"></a><div class=\"head\">\n            <h1>Scripted Right-Click Menus </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59B7\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59AE\"></a>MAXScript provides a set of classes and functions and some special syntax to allow\n               you to construct custom right-click menus. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59AD\"></a> \n               <h3><a name=\"GUID-3270999D-2BAD-4487-A8A9-048395B6FA5B\"></a> <em class=\"strong\">Feature History</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59AC\"></a>In versions prior to <em class=\"strong\">3ds Max 4</em> when the QuadMenu system was still not available, scripted right-click menus could\n                  be incorporated into the existing <em class=\"strong\">3ds Max</em> user interface. The typical use of right-click menus was to provide quick access\n                  to a selection of tools written in MAXScript. These tools would typically have no\n                  user interface, however one could create dialogs or rollout floater windows in a right-click\n                  menu to display a user interface \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59AB\"></a>For an example and list of deprecated methods, see the topic <span class=\"char_link\"><a href=\"GUID-26A87677-A237-401D-B280-9E3BE51D56FD.htm\">Deprecated RCmenu Methods</a></span> \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59AA\"></a> \n               <h3><a name=\"GUID-B270FB75-9577-46E3-8381-F47D030C921E\"></a> <em class=\"strong\">Current Usage</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59A9\"></a>With the introduction of the QuadMenu system in <em class=\"strong\">3ds Max 4</em>, registering custom scripted right-click menus became impossible, but the menus themselves\n                  can still be used in scripted tools: \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59A8\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59A6\"></a>The <span class=\"code\"> <em class=\"strong\">popUpMenu()</em> </span> method described below is still available and could be called from event handlers\n                        or macroScripts to display a right-click menu under the mouse cursor. \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59A4\"></a>The scripted dialogs created from rollouts using the <span class=\"code\"> <em class=\"strong\">createDialog()</em> </span> method provide an optional <span class=\"code\"> <em class=\"strong\">menu:</em> </span> parameter which accepts an RCmenu which is then displayed as a menu bar on top of\n                        the dialog. See the <span class=\"char_link\"><a href=\"GUID-816D257C-CD2D-4753-A792-6E7AEFAFA6A7.htm\">CreateDialog</a></span> topic for details. \n                     </p> \n                  </li>\n               </ul> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59A3\"></a> \n               <h3><a name=\"GUID-C8DCB10E-105A-47B1-AE69-55C2B376EA8C\"></a> <em class=\"strong\">Creation</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59A2\"></a>A scripted right-click menu is created using the <span class=\"code\"> <em class=\"strong\">RCMenu</em> </span> definition construct in MAXScript, and then you register the right-click menu with\n                  <em class=\"strong\">3ds Max</em>. The top-level definition syntax is as follows: \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72A9\"></a><pre><em class=\"codeEmphasisStrong\">rcmenu</em> &lt;var_name&gt; <em class=\"codeEmphasisStrong\">(</em> &lt;rcmenu_body&gt; <em class=\"codeEmphasisStrong\">)</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-59A0\"></a>where: \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-599F\"></a> <span class=\"code\"> <em class=\"strong\">&lt;var_name&gt;</em> </span> is the name of an automatically created global variable to hold the <span class=\"code\"> <em class=\"strong\">rcmenu</em> </span> value that represents the right-click menu. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-599E\"></a> <span class=\"code\"> <em class=\"strong\">&lt;rcmenu_body&gt;</em> </span> is enclosed in the required parentheses and is a sequence of clauses that define\n                  the menu items that will appear in the utility, along with functions and event handlers\n                  that process user interactions. These clauses are defined in detail in <span class=\"char_link\"><a href=\"GUID-584BA3B0-ADBC-45A7-9BF4-ACE81930B2A0.htm\">RCMenu Clauses</a></span>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-599D\"></a> <em class=\"strong\">Methods</em>  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72A8\"></a><pre><em class=\"codeEmphasisStrong\">popUpMenu</em> &lt;RCMenu&gt; [<em class=\"codeEmphasisStrong\">pos</em>:&lt;Point2&gt;] [<em class=\"codeEmphasisStrong\">rollout</em>:&lt;Rollout&gt;] [<em class=\"codeEmphasisStrong\">align</em>:&lt;key&gt;]</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-599B\"></a>This method will popup a menu anywhere on the screen. The controls are as follows:\n                  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-599A\"></a> <span class=\"code\"> <em class=\"strong\">&lt;RCMenu&gt;:</em> </span> Any RCMenu defined. It does not have to be registered. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5999\"></a> <span class=\"code\"> <em class=\"strong\">[pos:&lt;Point2&gt;]:</em> </span> The point where the menu pops up, either relative to the Rollout or the screen. (Default:\n                  popup from current mouse position.) \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5998\"></a> <span class=\"code\"> <em class=\"strong\">[rollout:&lt;Rollout&gt;]:</em> </span> This will make the menu popup from a rollouts local coordinate system. Specifying\n                  undefined will cause the menu to popup relative to the upper left corner of the screen.\n                  (Default: undefined) \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5997\"></a> <span class=\"code\"> <em class=\"strong\">[align:&lt;key&gt;]:</em> </span> Can be one of the following (Default: <span class=\"code\"> <em class=\"strong\">#align_topleft</em> </span>): \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72A7\"></a><pre> <em class=\"codeEmphasisStrong\">#align_topleft</em> <em class=\"codeEmphasisStrong\">#align_topcenter</em> <em class=\"codeEmphasisStrong\">#align_topright</em> <em class=\"codeEmphasisStrong\">#align_bottomleft</em> <em class=\"codeEmphasisStrong\">#align_bottomcenter</em> <em class=\"codeEmphasisStrong\">#align_bottomright</em> <em class=\"codeEmphasisStrong\">#align_vcenterleft</em> <em class=\"codeEmphasisStrong\">#align_vcentercenter</em> <em class=\"codeEmphasisStrong\">#align_vcenterright</em></pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-598D\"></a>If a runtime error occurs while executing a scripted right-click menu, an error message\n                  is displayed in Listener. The right-click menu will not be disabled. \n               </p> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-598B\"></a> <span class=\"char_link\"><a href=\"GUID-17DBC9E3-5B61-4738-B78B-D3D57A515CE8.htm\">Scripted Right-Click Menus</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-598A\"></a> <span class=\"char_link\"><a href=\"GUID-584BA3B0-ADBC-45A7-9BF4-ACE81930B2A0.htm\">RCMenu Clauses</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5989\"></a> <span class=\"char_link\"><a href=\"GUID-882F8399-5E54-4F53-8676-0F533E23A472.htm\">RCMenu User-Interface Items</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-584BA3B0-ADBC-45A7-9BF4-ACE81930B2A0.htm\">RCMenu Clauses </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-26A87677-A237-401D-B280-9E3BE51D56FD.htm\">Deprecated RCmenu Methods </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-882F8399-5E54-4F53-8676-0F533E23A472.htm\">RCMenu User-Interface Items </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";