var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-1961F536-7F01-4D72-930C-4B9432952B79\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Callbacks\">\n      <meta name=\"indexterm\" content=\"viewport redraw callback\">\n      <meta name=\"indexterm\" content=\"unRegisterRedrawViewsCallback()\">\n      <meta name=\"indexterm\" content=\"registerRedrawViewsCallback()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Viewport Redraw Callback Mechanism</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1961F536-7F01-4D72-930C-4B9432952B79\"></a><div class=\"head\">\n            <h1>Viewport Redraw Callback Mechanism </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19DC\"></a>You can register one or more functions to be called whenever the <em class=\"strong\">3ds Max</em> viewports are redrawn. \n         </p>\n         <p><a name=\"P_C5BC05C90D0743C2AFCD6431683DF175\"></a>In addition, with the introduction of the Nitrous Graphics Manager in <em class=\"strong\">3ds Max 2012</em>, any MAXScript Graphics Window (gw.) <span class=\"char_link\"><a href=\"GUID-1B088FF0-6A36-420E-9F37-F0DBE9FB2676.htm\">Viewport Drawing Methods</a></span> must be wrapped in a Viewport Redraw Callback function to produce any results due\n            to the progressive refinement nature of the drawing process. \n         </p>\n         <p><a name=\"P_66C51F1E3679431CAE95B36CE9CAB462\"></a>The following methods let you register and unregister these callbacks: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6939\"></a><pre><em class=\"codeEmphasisStrong\">registerRedrawViewsCallback</em> &lt;fn&gt;\n<em class=\"codeEmphasisStrong\">unRegisterRedrawViewsCallback</em> &lt;fn&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19D7\"></a>You can register as many functions as you like. Each one is individually called whenever\n            the viewports are redrawn. The functions you register must take no arguments. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19D6\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19D5\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6938\"></a><pre>\nfn redrawviews_p = print \"Viewports Redrawn\"\nregisterRedrawViewsCallback redrawviews_p\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19D0\"></a><p class=\"table-body\">In the above example, the registered function causes the string \"Viewports Redrawn\"\n                        to be printed in the Listener window whenever the <em class=\"strong\">3ds Max</em> viewports are redrawn. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19CF\"></a> <em class=\"strong\">Special Considerations</em> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19CE\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19CC\"></a>If a runtime error occurs in a callback function while it is being executed, an error\n                  message is displayed and that callback function is permanently disabled. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19CA\"></a>The registered function is executed in a special context and not in the context of\n                  the code that created it. This means that the function cannot contain references to\n                  local variables in outer code nestings surrounding the function definition since those\n                  variables are on an execution stack that does not exist at the time the function is\n                  called. An important exception to this is utility and rollout panel locals, such as\n                  local functions, rollout variables and nested rollouts. You can refer to them in change\n                  handler code inside rollout code as they are associated directly with their rollout\n                  or utility object. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19C8\"></a>Note that it is the <em class=\"strong\">function value</em> that is being registered, not the function name or global variable. This means that\n                  redefining the same-named function after registering it will not change the callback\n                  automatically, but register another function value to be called resulting in two separate\n                  callbacks. You either need to unregister the old callback function, then redefine\n                  the function and register it again (see further on this page), or make the registered\n                  function an intermediary which calls another function, \n               </p> \n            </li>\n         </ul><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19C7\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19C6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6937\"></a><pre>\nfn redrawviews_cb = print currentTime\nfn rvcb = redrawviews_cb()\nregisterRedrawViewsCallback rvcb\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19C0\"></a><p class=\"table-body\">In this case, the registered callback function, <span class=\"code\"> <em class=\"strong\">rvcb</em> </span>, calls the real call back, <span class=\"code\"> <em class=\"strong\">redrawviews_cb</em> </span>, (by referencing the global variable it is defined in), meaning you can redefine\n                        <span class=\"code\"> <em class=\"strong\">redrawviews_cb()</em> </span> as often as you need and the callback will always invoke the latest definition. This\n                        is a useful technique to employ while you are developing and debugging a callback.\n                        \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19BF\"></a><p class=\"table-body\">Note that you may only redefine the <span class=\"code\"> <em class=\"strong\">redrawviews_cb()</em> </span> function but NOT evaluate the other two lines again, otherwise you would end up with\n                        multiple callbacks calling the same function on each redraw. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19BE\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19BB\"></a>Due to the fact that the function value is being registered, it is absolutely important\n                  to unregister any previous value using the <span class=\"code\"> <em class=\"strong\">unregisterRedrawViewsCallback()</em> </span> method before redefining the function and registering a new callback.The method can\n                  be called with an undefined argument, so it can be safely placed just before the function\n                  definition without the need to ensure the function already exists. This will ensure\n                  that a previous definition of the function will not remain registered without any\n                  means to unregister it (short of restarting <em class=\"strong\">3ds Max</em>). \n               </p> \n            </li>\n         </ul><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19BA\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19B9\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6936\"></a><pre>\nunregisterRedrawViewsCallback redrawviews_callback_function\nfn redrawviews_callback_function = print \"Viewport Redraw 1\"\nregisterRedrawViewsCallbackredrawviews_callback_function\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19B3\"></a><p class=\"table-body\">Evaluating the above will first attempt to unregister the callback function. If it\n                        was not registered, nothing will happen. Then the function will be defined and its\n                        value will be registered as callback. Orbiting in the viewport for example will cause\n                        the string to be printed to the listener. \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19B2\"></a><p class=\"table-body\">If you would change the string to \"Viewport Redraw 2\" and evaluate the same code,\n                        the old function will be unregistered, the new function will be defined and the new\n                        callback will be registered. Orbiting the viewport will print the new string only.\n                        \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19B1\"></a><p class=\"table-body\"> <em class=\"strong\">BAD EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6935\"></a><pre>\nfn redrawviews_callback_function = print \"Viewport Redraw2\"\nunregisterRedrawViewsCallback redrawviews_callback_function\nregisterRedrawViewsCallback redrawviews_callback_function\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19AB\"></a><p class=\"table-body\">If the unregister function call were the second line and not the first, the new function\n                        would be defined first, then the unregister attempt would fail silently because the\n                        new function would be used and the old one\'s value would be inaccessible. This would\n                        result in both the old and the new functions being executed on viewport redraws, thus\n                        printing both \"Viewport Redraw 1\" and \"Viewport Redraw 2\" to the Listener. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19AA\"></a><p class=\"table-body\"> <em class=\"strong\">LOCAL SCOPE EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6934\"></a><pre>\n(--open a local scope\nglobal redrawviews_cb_function --ensure variable visibility\nunregisterRedrawViewsCallback redrawviews_cb_function\nfn redrawviews_cb_function= print \"Redraw Test1\"\nregisterRedrawViewsCallback redrawviews_cb_function\n)--end local scope\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19A1\"></a><p class=\"table-body\">If the function definition and the callback unregistering and registering are performed\n                        in local scope, it is paramount to ensure the callback function\'s visibility to the\n                        code in either global scope or a \"private local\" scope such as the top-level local\n                        scope of a MacroScript that would protect the function value during the current session.\n                        Evaluating the above code without a global declaration would create a function value\n                        inside the LOCAL scope defined by the outer-most brackets and the attempt to call\n                        <span class=\"code\"> <em class=\"strong\">unregisterRedrawViewsCallback()</em> </span> in a second evaluation of the script would NOT see the original function value in\n                        the variable since the variable would have ceased to exist after the first run. Thus,\n                        the variable storing the function value must be declared as global to allow a second\n                        run of the script to successfully unregister the previous function value. \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19A0\"></a><p class=\"table-body\">Changing the printed string to \"Redraw Test 2\" and evaluating the code again would\n                        correctly unregister the old value stored in the global variable, then overwrite it\n                        with the new value and register it as a redraw views callback. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-199F\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-199B\"></a>Callback functions remain registered after loading a new file or performing a <em class=\"strong\">3ds Max</em> reset. \n               </p> \n            </li>\n         </ul><a name=\"TABLE_293CDC7E87A941B6891388DD70046827\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"3.6900369003690034%\">\n                  <col width=\"41.25461254612546%\">\n                  <col width=\"55.055350553505534%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\" valign=\"middle\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\" colspan=\"2\" valign=\"middle\"> <a name=\"P_922165E9AA71407EA76A341B0019A422\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_6EE31EE12F0E444AA561B36176A346E0\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">Callback Notifications - Quick Navigation</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1997\"></a> <span class=\"char_link\"><a href=\"GUID-1BE2E978-72CF-495C-81D6-2B36E2C4FFC7.htm\">Change Handlers and Callbacks</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1996\"></a> <span class=\"char_link\"><a href=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875.htm\">Change Handlers and When Constructs</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1995\"></a> <span class=\"char_link\"><a href=\"GUID-962137D0-2937-4A31-A3E0-2BBF8C365577.htm\">Time Change Callback Mechanism</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1994\"></a> <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";