var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-1BB21805-1A09-442D-8ED4-386D1900C7FD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Documentation Changes in 3ds Max 2012</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1BB21805-1A09-442D-8ED4-386D1900C7FD\"></a><div class=\"head\">\n            <h1>Documentation Changes in 3ds Max 2012 </h1>\n         </div>\n         <p><a name=\"GUID-9536F333-5A6F-42A6-9ED6-897049DAE29B\"></a> This topic discusses the changes made to the MAXScript Reference for the 2012 release\n            of <em class=\"strong\">3ds Max</em>. See also <span class=\"char_link\"><a href=\"GUID-31E273C4-9248-49A0-B357-4B8F8023385D.htm\">What is New in MAXScript in 3ds Max 2012</a></span>. \n         </p>\n         <div class=\"section\"><a name=\"SECTION_633D544507B8497087970B240A5135ED\"></a> \n            <h2><a name=\"GUID-11ED89E4-603C-4288-BB8F-C91D77BC6FB0\"></a>New Authoring System - New Reference Format\n            </h2> \n            <p><a name=\"P_0D32EF81C1E243039A80569911F42BEE\"></a>If you are an existing customer, you have surely noticed that this version of the\n               MAXScript Reference is significantly different. The complete documentation of all\n               Autodesk products has been moved to a unified piblishing system based on XML source\n               which should provide significant improvements to both the end users and the documentation\n               developers in the long run. \n            </p> \n            <p><a name=\"P_90114490761045E98DC8CD24A411D3CA\"></a>Here are some of <em class=\"strong\">the benefits</em> it brings: \n            </p> <a name=\"UL_CE067F0522D948B79FB68F6072292381\"></a><ul>\n               <li>The new system supports multiple output targets including HTML, CHM and Wiki pages,\n                  allowing for faster and more often updates of the online version, as well as new approaches\n                  to documentation management via Wiki entries. \n               </li>\n               <li>The source is formatted using XML tags, allowing the easy redefinition of the complete\n                  publication via quick changes to the style sheets. \n               </li>\n               <li>The source is managed on centralized servers, allowing for better collaboration between\n                  authors including version control, offline output compiling etc. \n               </li>\n               <li>Thanks to the centralized version control and access, the localization of the documentation\n                  can be performed faster. \n               </li>\n               <li>Each page of the MAXScript Reference now features the same feeback links as the regular\n                  <em class=\"strong\">3ds Max</em> User Manual. \n               </li>\n               <li>Cross-reference links are now based on unique resource identifies (GUIDs) and are\n                  less likely to break. \n               </li>\n               <li>The Look-and-Feel of the MAXScript Reference is now the same as the <em class=\"strong\">3ds Max</em> User Manual and features the same navigation links in the header including breadcrubms\n                  and next/previous/parent page links. \n               </li>\n               <li>It would be technically possible to easily cross-reference pages between the various\n                  online help documents, for example between the <em class=\"strong\">3ds Max</em> User Manual and the MAXScript Reference. \n               </li>\n            </ul> \n            <p><a name=\"P_479F08AC0A834C5A867A1443B4A67F50\"></a>Currently, there are also <em class=\"strong\">a number of limitations </em>compared to the previous CHM format of the MAXScript Reference: \n            </p> <a name=\"UL_6272C7EC24A545CEA127E78D05026B2D\"></a><ul>\n               <li>The <em class=\"strong\">Index tab</em> provides approximately the same links as the old build of the MAXScript Reference,\n                  but the <em class=\"strong\">index links do not jump to the exact position</em> of the relevant term but to the top of the topic containing the term. \n               </li>\n               <li>The current format <em class=\"strong\">does not support clickable images or image maps</em>. This is not a limitation of the system itself but of the current implementation\n                  of the building scripts and will be hopefully addressed in the future. For that reason,\n                  the Quick Navigation and Back To Topic Navigation icons (blur and green \"wind roses\")\n                  are not clickable anymore and are accompanied by text links for the actual navigation.\n                  \n               </li>\n               <li>There is <em class=\"strong\">no support for popup pages</em> used in the old MAXScript Reference for Quick Navigation indices or terminology explanations.\n                  For that reason the Quick Navigation links navigate away from the current page to\n                  the relevant index topic. This is a minor difference and most of the Quick Navigation\n                  indices have been recreated from scratch since they were not translated automatically\n                  in the source conversion process. \n               </li>\n               <li>There is <em class=\"strong\">no example color coding</em> except for the \n                  <div class=\"codeBlock\"><a name=\"CODEBLOCK_ECA16CF778E444F9AC565D782B7E29C6\"></a><pre> --code comments</pre></div> \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_344ECAD26D9049EF82303D7FC8518214\"></a> \n            <h2><a name=\"GUID-329A1811-321C-4C11-B1FF-3D3584546258\"></a>What To Expect\n            </h2> \n            <p><a name=\"P_2E106FB5B2914093B5572C547F05BD14\"></a>The source conversion process preserved the majority of the content including text\n               paragraphs, examples and images, but nearly all formatting was lost or damaged and\n               required laborious re-editing by hand or using custom scripts (written in MAXScript,\n               of course!). \n            </p> \n            <p><a name=\"P_84AD85788F874D46AE3AE21A0C21AB1E\"></a>Despite the significant effort which went into restoring the look and usability of\n               the document, it is likely that not all of the over 4200 topics have been completely\n               fixed. In particular, there have been significant glitches in the location of space\n               characters within the text. In some cases, words in text paragraphs or keywords in\n               code examples could be written together as one word, or the space could be shifted,\n               eventually affecting the meaning of the text, or breaking the example code. \n            </p> \n            <p><a name=\"P_D645B13D519F46EF8179BC040ADFD90E\"></a>While the majority of these problems have been fixed, this could not be done automatically\n               so there still can be glitches hiding within the documentation. If you discover a\n               misformatted sentence or a code example, please submit a report to Autodesk using\n               the Feedback link at the bottom of the topic. Thank you in advance! \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_D104286245DA4F8FA1A459AFBFE9D27B\"></a> \n            <h2><a name=\"GUID-33E62F16-9984-4C4D-98CF-16E26EA6B3F8\"></a>Removed Sections and Topics\n            </h2> \n            <p><a name=\"P_DBCB508E6CE3478C8076EF299F8B6C16\"></a>The following parts of the MAXScript Reference have been removed from the 2012 build:\n               \n            </p> <a name=\"UL_8F0D2B1600004F9A81DFFDC79D4745BA\"></a><ul>\n               <li>The section on using the HTML Help system had to be removed since the MAXScript Reference\n                  can now exist in various forms and those topics only covered the CHM Help Viewer.\n                  \n               </li>\n            </ul> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";