var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-1E2277FE-7854-4404-89A9-9D72C07CDBDB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"transform properties - sub-object\">\n      <meta name=\"indexterm\" content=\"sub-object transform properties\">\n      <meta name=\"indexterm\" content=\"Modifier - MAXWrapper\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Modifier Sub-Object Transform Properties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1E2277FE-7854-4404-89A9-9D72C07CDBDB\"></a><div class=\"head\">\n            <h1>Modifier Sub-Object Transform Properties </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36D7\"></a>In MAXScript, the values of modifier sub-object transform properties, such as centers\n            and gizmo position, rotation and scale, are <em class=\"strong\">not</em> given in the current working coordinate system, but rather are typically in the coordinate\n            system of the object to which it is applied. This is in contrast to scene node transform\n            properties. The values given are exactly as would be seen in the sub-object’s corresponding\n            track view or as might be referenced in an Expression controller track variable for\n            that sub-object property. To convert from local to world coordinates, you multiply\n            the local coordinates by the node’s <span class=\"code\"> <em class=\"strong\">objecttransform</em> </span> matrix. To convert from world to local coordinates, you multiple the world coordinates\n            by the inverse of the node’s <span class=\"code\"> <em class=\"strong\">objecttransform</em> </span> matrix. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36D8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36D9\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50B3\"></a><pre>\nobj=box pos:[10,20,30]\naddModifier obj (affect_region())\nobjTM=obj.objecttransform\nmodTM=getModContextTM obj obj.affect_region\n--<span class=\"codeComment\">calculate world coordinates of end point</span>\nobj.affect_region.end_point * (inverse modTM) * objTM\n--<span class=\"codeComment\">set end point at world coordinates [20,20,0]</span>\nobj.affect_region.end_point = [20,20,0] * modTM * (inverse objTM)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36E5\"></a> \n            <h2><a name=\"GUID-B3F5ADFD-31E0-47B0-A000-AE7CCED68E1C\"></a> <em class=\"strong\">FFD Control Points</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36E6\"></a>FFD control point sub-object properties are also accessible but have several special\n               considerations. The control points properties are named as they appear in the track\n               view, subject to the MAXScript convention of using <span class=\"code\"> <em class=\"strong\">\'_\'</em> </span> underscores for spaces, so \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36E7\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36E8\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50B2\"></a><pre>\n$foo.ffd_2x2x2.control_point_1\n$baz.ffd_3x3x3.control_point_32 = [1,2,3]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36EE\"></a>There are two special considerations when accessing FFD control points. First, you\n               can only access control points that have ALREADY been animated by hand, or by using\n               the <span class=\"code\"> <em class=\"strong\">animateVertex()</em> </span> or the <span class=\"code\"> <em class=\"strong\">animateAll()</em> </span> MAXScript functions (see <span class=\"char_link\"><a href=\"GUID-E75D8D72-53D4-4306-BD8C-25D7363A7050.htm\">Scripting Vertex and Control Point Animation</a></span>). The FFD doesn’t actually create accessible control points until you do this, a\n               behavior that shows up in the track view in normal <em class=\"strong\">3ds Max</em> use - you cannot actually place control point keyframes in the track view until you’ve\n               animated the control point. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36EF\"></a>Second, control point coordinates are in FFD lattice space. This is a normalized space,\n               with [0,0,0] at the lower left-hand corner (at control_point_1) and [1,1,1] at the\n               opposite corner of the FFD lattice, so you have to be careful about computing and\n               scaling correct coordinates when you set them. This is also reflected in the track\n               view for FFD control points in normal <em class=\"strong\">3ds Max</em> use - if you look at their values in a keyframe property dialog or a function graph,\n               they are in this normalized lattice space, not world-space coordinates. You’d have\n               to work in this space also if you tried to use expression controllers to control FFDs.\n               The modifier utility functions <span class=\"code\"> <em class=\"strong\">getModContextBBoxMin()</em> </span> and <span class=\"code\"> <em class=\"strong\">getModContextBBoxMin()</em> </span> can be used to determine the world-space bounds of an FFD lattice allowing you to\n               compute scaled lattice space coordinates from world coordinates. See details on these\n               functions in <span class=\"char_link\"><a href=\"GUID-DB496ACA-1506-4FB1-B8F8-EECC7D9794DD.htm\">Modifier Common Properties, Operators, and Methods</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36F0\"></a>An example of accessing and converting coordinate systems for FFD control points is\n               shown in the following script: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36F1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36F2\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50B1\"></a><pre>\nb=box pos:[10,20,0]\nffd=ffdbox()\naddModifier b ffd\nanimateVertex ffd 64\ncp64posL=ffd.control_point_64\nobjTM=b.objecttransform\nmodTM=(getModContextTM b ffd)*ffd.lattice_transform.value\nmodBBMin=getModContextBBoxMin b ffd\nmodBBMax=getModContextBBoxMax b ffd\ncp64posW=(modBBMin+(cp64posL*(modBBMax-modBBMin)))* (inverse modTM) * objTM\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";