var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-20409BF0-2192-4551-AB01-EA46E1DE51EE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"is64bitApplication()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>64 Bit Values - Double, Integer64, IntegerPtr</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-20409BF0-2192-4551-AB01-EA46E1DE51EE\"></a><div class=\"head\">\n            <h1>64 Bit Values - Double, Integer64, IntegerPtr </h1>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87978\"></a><pre><em class=\"codeEmphasisStrong\">Double</em> : Number\n<em class=\"codeEmphasisStrong\">Integer64</em> : Number\n<em class=\"codeEmphasisStrong\">IntegerPtr</em> : Number</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8797A\"></a>Three Number value classes have been added to MAXScript in \n            		<em class=\"strong\">3ds Max 9</em>: Double, Integer64 and IntegerPtr. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8797B\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8797D\"></a>The widest float value in the .NET Common Type System (CTS) is the System::Double,\n                  which corresponds to the C++ double value (real*8). The Double value class in MAXScript\n                  wraps the double value class. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8797F\"></a>All \n                  			 <span class=\"char_link\"><a href=\"GUID-B57EA575-DCDE-42F5-9D30-88E3EB41F350.htm\">generic mathematical methods and operations</a></span> (sin, cos, random, +, -, etc.) that operate on the Float value class in MAXScript\n                  are also implemented on the Double class. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87981\"></a>The Double class supports the \n                  			 <span class=\"char_link\"><a href=\"GUID-B57EA575-DCDE-42F5-9D30-88E3EB41F350.htm#WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6D55\">\'bit\' structure methods</a></span> in a manner similar to the Float class. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87983\"></a>The Double class is a MAXScript \n                  			 <em class=\"strong\">saveable</em> class - in other words, it can be used in persistent globals. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87985\"></a>The data type convertors for ActiveX, OLE, and fileProperties.getPropertyValue / setPropertyValue\n                  will convert variant VT_R8 to Doubles, and vice versa. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87987\"></a>For methods that expect a Float as an argument, the Double value will be cast to a\n                  Float value and used. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87989\"></a>Double literals are indicated by \'d\' exponential qualifier. \n                  		  \n               </p> \n            </li>\n         </ul><a name=\"WS73099CC142F48755-2231E4B3128F27532E8798B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8798C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FFA\"></a><pre>\n1.0d0 --returns 1.0d0\n0.5 as Double --returns0.5d0\n2.0d5--returns 2000000.0d0\n1.2d-3 --returns 0.0012d0\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27532E87994\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87996\"></a>\'bit\' structure methods that operate on an Integer can also operate on Integer64 and\n                  IntegerPtr. For methods that take 2 integer arguments, the first argument determines\n                  the output value type. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87998\"></a> <span class=\"code\"> <em class=\"strong\">bit.intAsHex</em> </span> will append an \"L\" to the output string for Integer64 inputs, and a \"P\" for IntegerPtr\n                  inputs. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8799A\"></a> <span class=\"code\"> <em class=\"strong\">bit.hexAsInt</em> </span> will output an Integer64 if the input string contains an \"L\", an IntegerPtr if it\n                  contains a \"P\". \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8799C\"></a>String and Stringstream values can be coerced to Double, Integer64 and IntegerPtr.\n                  \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8799E\"></a>All number data types (Integer, Float, Integer64, IntegerPtr, Double) and Time can\n                  be coerced from one to the other. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879A0\"></a>For loop variables are either Integer, Float, Integer64, IntegerPtr, or Double based\n                  on the widest value type for the to, from, and step values \n                  		  \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879A2\"></a> The printing of very small Double values has been improved in \n            		<em class=\"strong\">3ds Max 2011 and higher</em>: \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879A3\"></a>When a Float value is printed, if its value is less than 1.192092896e-07 (the smallest\n            float f such that 1.0+f != 1.0), the Float is printed as 0.0.&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879A4\"></a>When a Double value is printed, if its value is less than 2.2204460492503131e-016\n            (the smallest double d such that 1.0+d != 1.0), the Double is printed as 0.0.&nbsp; In\n            versions prior to \n            		<em class=\"strong\">3ds Max 2011</em>, the float value of 1.192092896e-07 was being used for Doubles too. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879A6\"></a> <em class=\"strong\">Related Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FF9\"></a><pre><em class=\"codeEmphasisStrong\">is64bitApplication</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879A8\"></a>In \n            		<em class=\"strong\">3ds Max 9</em> and higher, returns true if running in a 64 bit build of \n            		<em class=\"strong\">3ds Max</em>, false otherwise. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E879AA\"></a> <span class=\"char_link\"><a href=\"GUID-B57EA575-DCDE-42F5-9D30-88E3EB41F350.htm\">Number Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";