var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-21F52D81-8D49-4CBC-A8C4-3E906E150439\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Control Constructs\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"indexterm\" content=\"case/of expression\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Case Expression</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-21F52D81-8D49-4CBC-A8C4-3E906E150439\"></a><div class=\"head\">\n            <h1>Case Expression </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E871E1\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871E2\"></a>   The <span class=\"code\"> <em class=\"strong\">case</em> </span> expression is used to select an expression to be evaluated from a set of labeled\n               expressions based on a test value compared against the labels. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871E6\"></a>Only the first expression whose label matches the test expression is evaluated. \n            </p> \n            <p><a name=\"P_6A0C68778F724B9783E7F0F35EF1AF41\"></a>All labels must be comparable to the test expression. \n            </p> \n            <p><a name=\"P_E167304B24654DDB8F4DD3E15EBE35D1\"></a>Labeled expressions can be block-expressions, so you can use the <span class=\"code\"> <em class=\"strong\">case</em> </span> expression as a case statement, choosing between blocks of code to execute. \n            </p> \n            <p><a name=\"P_492DF028D941476C960BBA6BF13D7AF2\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871E7\"></a>The <em class=\"strong\">syntax </em>for <span class=\"code\">&lt;case_expr&gt;</span> is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60C1\"></a><pre><em class=\"codeEmphasisStrong\">case</em> [ &lt;expr&gt; ] <em class=\"codeEmphasisStrong\"> of (</em> &lt;cases&gt; <em class=\"codeEmphasisStrong\">)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871E9\"></a>where <span class=\"code\"> &lt;expr&gt; </span> is the test expression and <span class=\"code\"> &lt;cases&gt; </span> is a sequence of labeled expressions: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60C0\"></a><pre>&lt;factor&gt;: &lt;expr&gt;\n<em class=\"codeEmphasisStrong\">default</em>: &lt;expr&gt;   </pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871ED\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871EE\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60BF\"></a><pre>\nb = Box()\ncopy_type = 2 --copy\nnew_obj = case copy_type of\n(\n2: copy b\n3: instance b\ndefault: reference b\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871F7\"></a>A special label, <span class=\"code\"> <em class=\"strong\">default</em> </span>, can be optionally used to tag the expression that will be evaluated if no other\n               labels match the test expression. \n            </p> \n            <p><a name=\"P_4AEFA747A328448AB83810D3D2D4FF34\"></a>If the <span class=\"code\"> <em class=\"strong\">default</em> </span> label is not used, and no label matches the test expression, the <span class=\"code\"> <em class=\"strong\">case</em> </span> expression returns a value of <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n            </p> \n            <p><a name=\"P_9BCAF4069B8E4C32A98CE974BDE7DA41\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871F8\"></a>The labels are <span class=\"code\">&lt;factors&gt;</span> - elements such as, number literals, name literals, string literals, variables, or\n               block-expressions. \n            </p> \n            <p><a name=\"P_5ECCD95F064C48DA97A99A4CD1A4B789\"></a>When a <span class=\"code\"> <em class=\"strong\">case</em> </span> expression is evaluated, the test expression is evaluated once, then each label expression\n               is evaluated in order until one is found that compares equally to the test expression\n               value. \n            </p> \n            <p><a name=\"P_8D271EFD1682471EBEF4EC53A12A24B9\"></a>The expression it labels is then evaluated and this becomes the result of the <span class=\"code\"> <em class=\"strong\">case</em> </span> expression. \n            </p> \n            <p><a name=\"P_330F88832D6743378ECB7B5C2AA02417\"></a>No further labels are evaluated or tested. \n            </p> \n            <p><a name=\"P_79CEC6296E1D4B1187812135E3C5A73A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E871F9\"></a>The test expression is optional. \n            </p> \n            <p><a name=\"P_B144E8063A0449E2B714543D991A1A9B\"></a>If it is not supplied, the labels are expected to be Boolean values or expressions\n               and the first label evaluated as <span class=\"code\"> <em class=\"strong\">true</em> </span> determines the chosen case. \n            </p> \n            <p><a name=\"P_CF401EC248A14F5686823BB40C4746AC\"></a>In this variant, it is common to use expressions as labels, so be sure to parenthesize\n               them. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871FB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E871FC\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60BE\"></a><pre>\na= random 1 20\nb = random 1 20\nc = random 1 20\nd = random 1 20 \ncase of\n(\n(a &gt; b): print \"a is big\"\n(b &lt; c): print \"b is little\"\n(c &lt;= d*3): print \"c is less than 3 times d\" \ndefault: print \"none of the above\"\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";