var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-23013A3F-2F69-4970-9ECE-D53A8A3DED28\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"macroScript Localization Support for CUI and menu files\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>macroScript Localization Support for CUI and menu files</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-23013A3F-2F69-4970-9ECE-D53A8A3DED28\"></a><div class=\"head\">\n            <h1>macroScript Localization Support for CUI and menu files </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5723\"></a> In order to make the menu and CUI files more easily localized, a keyword argument,\n            <span class=\"code\"> <em class=\"strong\">InternalCategory:</em> </span>, has been added to the macroScript facility. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5721\"></a>Previously, when a macroScript is assigned to a CUI button or menu item, it is identified\n            in the CUI or MNU file using the macroScript name and category, like this (from the\n            menu file): \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-726A\"></a><pre>Item6_Action=647394:Isolate`Tools</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-571F\"></a>\"Isolate\" is the name of the macro and \"Tools\" is the category. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-571E\"></a>The macroScript that defines this operation looks like: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7269\"></a><pre>MacroScript Isolate\nCategory:\"Tools\"\nToolTip:\"Isolate Tool\"\nIcon:#(\"ViewPortNavigationControls\",7)</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5719\"></a>The problem is when the macroScript is localized, the category is localized but the\n            macroScript name \"Isolate\" should not be localized. When it is localized, then the\n            MNU file entry of \"Isolate`Tools\" no longer works. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5718\"></a>A non-localized category name is needed that would be used to write the operation\n            to MNU and CUI files. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5717\"></a>In this case the macroScript now looks like: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7268\"></a><pre>MacroScript Isolate\nCategory:\"Tools\"\nInternalCategory:\"Tools\" -- This is the new keyword\nToolTip:\"Isolate Tool\"\nIcon:#(\"ViewPortNavigationControls\",7)</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5714\"></a>When this macroScript is localized the Category would be translated, but the <span class=\"code\"> <em class=\"strong\">InternalCategory</em> </span> would not. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";