var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-23401629-F449-496F-9DD0-87E0E886221B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NodeExposureInterface Struct Methods\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NodeExposureInterface Struct Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-23401629-F449-496F-9DD0-87E0E886221B\"></a><div class=\"head\">\n            <h1>NodeExposureInterface Struct Methods </h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A82\"></a> The<em class=\"strong\"> NodeExposureInterface </em>structure provides methods to create a<em class=\"strong\"> INodeExposureR Interface </em>for a given node and get an existing interface from a node. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A80\"></a>The Node Exposure Interface can be used to define the exposure of a scene node to\n            various areas of the<em class=\"strong\"> 3ds Max</em> User Interface. By default, all scene nodes are visible to all areas of the 3ds Max\n            UI, but by creating a Node Exposure Interface and changing the exposure settings in\n            it, a node could be excluded from sub-systems like the Select By Name dialog, the\n            Schematic View and the Track View. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A7F\"></a>Available in<em class=\"strong\"> 3ds Max 2008 </em>and higher. Previously available in the <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-9C6CE053-8792-4BBD-85ED-F65622035876\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A7E\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-530D\"></a><pre>&lt;INodeExposureR Interface&gt;<em class=\"codeEmphasisStrong\">NodeExposureInterface.Create </em>&lt;node&gt; 	 </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A7D\"></a>Creates the node exposure interface if not already present, and returns the INodeExposureR\n            Interface value. \n         </p>\n         <p><a name=\"GUID-A5325A8C-9DAA-4F41-94A4-9D424CD57BFA\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-530C\"></a><pre>&lt;INodeExposureR Interface&gt;<em class=\"codeEmphasisStrong\">NodeExposureInterface.Get</em> &lt;node&gt;   </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A7B\"></a>Returns the node exposure interface if already created, otherwise returns \'undefined\'\n            \n         </p>\n         <p><a name=\"GUID-7A3CD27E-DAF5-4DFB-918E-34AD576318AE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A79\"></a> <em class=\"strong\">Both methods return a Function Published Interface value:</em> \n         </p>\n         <p><a name=\"P_B179856E74BE43279D4697F00B3F545A\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-530B\"></a><pre>Interface:<em class=\"codeEmphasisStrong\"> INodeExposureR</em> </pre></div>\n         <p><a name=\"GUID-7940FCB4-C351-4BD4-BBB8-BDDEFA9C4C2E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A78\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-530A\"></a><pre>&lt;bool&gt;&lt;INodeExposureR&gt;.<em class=\"codeEmphasisStrong\">isExposed</em> &lt;integer&gt;ui </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A77\"></a>Returns true if the the node is exposed to the UI sub-system corresponding to the\n            0-based index. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A76\"></a>Possible values for \'ui\' are: \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A75\"></a>0 - SelectObjects (Select By Name dialog) \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A74\"></a>1 - SchematicView \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A73\"></a>2 - Maxscript&nbsp;&nbsp;-- currently unsupported \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A72\"></a>3 - Merge&nbsp;&nbsp;-- currently unsupported \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A71\"></a>4 - MergeAnimation&nbsp;-- currently unsupported \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A70\"></a>5 - Replace&nbsp;&nbsp;-- currently unsupported \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A6F\"></a>6 - KeyEditor \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A6E\"></a>7 - CurveEditor \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A6D\"></a>8 - RangeEditor \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A6C\"></a>As noted above, values 2 through 5 currently have no affect! \n         </p>\n         <p><a name=\"GUID-25F58304-3638-4DDE-A0BF-00196A246037\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5309\"></a><pre>&lt;void&gt;&lt;INodeExposureR&gt;.<em class=\"codeEmphasisStrong\">SetExposedInAll</em> &lt;bool&gt;state </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A6A\"></a>This method sets all node exposures to the given Boolean value. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A69\"></a>If the argument is <span class=\"code\"> <em class=\"strong\">false</em> </span>, the node will be excluded from all UI areas of exposure. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A68\"></a>If the argument is <span class=\"code\"> <em class=\"strong\">true</em> </span>, the node will be exposed to all UI sub-systems. \n         </p>\n         <p><a name=\"GUID-BAA7A888-015D-4EAD-BE0F-CA354B9DFBAD\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5308\"></a><pre>&lt;void&gt;&lt;INodeExposureR&gt;.<em class=\"codeEmphasisStrong\">SetExposed </em>&lt;bool&gt;state &lt;integer&gt;ui </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A66\"></a>This method sets the node exposure for thespecific UI area defined by the second argument\n            to the Boolean value defined by the first argument. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A65\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A64\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5307\"></a><pre>\ntheNode = Sphere()\ntheInterface = NodeExposureInterface.Create theNode\ntheInterface.SetExposed false 0\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A63\"></a><p class=\"table-body\">will make the newly created sphere invisible to the Select By Name dialog. </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-4D20C7E7-19AE-44E3-8A17-B0F2A60D4577\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5306\"></a><pre>&lt;void&gt;&lt;INodeExposureR&gt;.<em class=\"codeEmphasisStrong\">BakeExposure</em>() </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-A5F\"></a>&nbsp;See \'Class INodeExposure\' in the SDK help file for more information on this interface.\n            \n         </p>\n         <p><a name=\"GUID-8F764ABF-AB34-44E6-8869-944DBBDC9BF2\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";