var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-2497AE43-97CA-4D30-B40E-8D45AC6DAEC5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"union - mesh\">\n      <meta name=\"indexterm\" content=\"subtraction - mesh\">\n      <meta name=\"indexterm\" content=\"intersection - mesh\">\n      <meta name=\"indexterm\" content=\"geometry - Node\">\n      <meta name=\"indexterm\" content=\"Boolean - mesh\">\n      <meta name=\"indexterm\" content=\"getTriMeshFaceCount()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>GeometryClass Common Properties, Operators, and Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2497AE43-97CA-4D30-B40E-8D45AC6DAEC5\"></a><div class=\"head\">\n            <h1>GeometryClass Common Properties, Operators, and Methods </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F97\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F96\"></a>      \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F8F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F8E\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm\">Node</a></span> &gt; GeometryClass \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F8C\"></a>The mesh operations underlying the Boolean Compound Object in <em class=\"strong\">3ds Max</em> are accessible in MAXScript. They appear as operators (+, -, *) that you can apply\n               to any two scene objects that are convertible to meshes. These objects are all GeometryClass\n               objects with the exception of the particle systems. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F8B\"></a>The <em class=\"strong\">operators </em>are: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CBC\"></a><pre>&lt;node1&gt; <em class=\"codeEmphasisStrong\">+</em> &lt;node2&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F89\"></a>Returns the <em class=\"strong\">union</em> of node1 and node2 \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CBB\"></a><pre>&lt;node1&gt;<em class=\"codeEmphasisStrong\">-</em>&lt;node2&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F87\"></a>Returns the <em class=\"strong\">subtraction</em> of node2 from node1 \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CBA\"></a><pre>&lt;node1&gt;<em class=\"codeEmphasisStrong\">*</em>&lt;node2&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F85\"></a>Returnsthe <em class=\"strong\">intersection</em> of node1 and node2 \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F84\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F83\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CB9\"></a><pre>\n$foo - $baz\n$sphere01 + $sphere02 + $sphere03 + $sphere04\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F7D\"></a>The Boolean operators <em class=\"strong\">change the first operand</em> to be the result of the operation and leave the second operand untouched. So, in\n               the first example, the <span class=\"code\"> <em class=\"strong\">$foo</em> </span> node is changed to an Editable Mesh object containing the result of the difference\n               operation. In the second example,<span class=\"code\"> <em class=\"strong\">$sphere01</em> </span> is successively unioned with each of the other spheres -<span class=\"code\"> <em class=\"strong\">$sphere01</em> </span> contains the compound result and the other spheres are left standing. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AE9\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F7A\"></a>Unlike the Boolean compound object in <em class=\"strong\">3ds Max</em>, this operation destructively modifies the first operand - you cannot retrieve the\n                     original first operand after the Boolean operation is performed. You can effectively\n                     keep the first operand by using a copy function, \n                  </p> \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F78\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F77\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CB8\"></a><pre>\nresult = (copy $foo) - $baz\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F73\"></a>will put a modified copy of <span class=\"code\"> <em class=\"strong\">$foo</em> </span> into the variable result, leaving the original <span class=\"code\"> <em class=\"strong\">$foo</em> </span> unchanged. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CB7\"></a><pre><em class=\"codeEmphasisStrong\">GetTriMeshFaceCount</em> &lt;node&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2F70\"></a>Returns an array of two integers - the face count and the vertex count of the TriMesh\n               on top of the modifier stack. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";