var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-24FFB4C6-B37D-4F37-89FC-54AED58B44C2\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"dotNetClass\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>dotnetclass</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-24FFB4C6-B37D-4F37-89FC-54AED58B44C2\"></a><div class=\"head\">\n            <h1>dotnetclass </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11E7\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11E3\"></a>In \n               		  <em class=\"strong\">3ds Max 9</em> and higher, the \n               		  <span class=\"code\"> <em class=\"strong\">dotNetClass</em> </span> wraps a DotNet \n               		  <span class=\"code\"> <em class=\"strong\">System::Type</em> </span> and exposes the static properties, methods, and events associated with the class\n               via reflection. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11E2\"></a>Property access uses MAXScript number data types (widened as necessary), String, Boolean,\n               dotNetControl, dotNetObject, and dotNetClass values. Properties are accessed via the\n               normal property access specification [control.property] and \n               		  <span class=\"code\"> <em class=\"strong\">getProperty()</em> </span>/<span class=\"code\"> <em class=\"strong\">setProperty()</em> </span> methods. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11E1\"></a>Accessing a class method will create a \n               		  <span class=\"char_link\"><a href=\"GUID-216D4AE4-3BFF-46C5-BCBE-53E2FDFC7DB1.htm\">dotNetMethod</a></span> instance. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11E0\"></a>New methods are used to add and manage event handlers. These methods register and\n               unregister callback functions to be called when the event is fired. The arguments\n               passed back to the functions will include the class, the event name, and the arguments\n               passed by the event handler. See \n               		  <span class=\"char_link\"><a href=\"GUID-9BE82D70-1869-46D7-9501-E5453E25AC68.htm\">dotNet Struct Methods</a></span> for details. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-754C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11DC\"></a>There is a difference between a dotNetClass and a \n                     			 <span class=\"char_link\"><a href=\"GUID-56961A11-BD8A-40E5-BB68-74AA27F2E056.htm\">dotNetObject</a></span> that wraps the same type. \n                     		  \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11DB\"></a>Accessing the dotNetClass accesses the System::Type while accessing the dotNetObject\n                     access the object type described by the System::Type. \n                     		  \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11DA\"></a>So, for example, if you called showProperties() on a dotNetObject you will get the\n                     properties of the System::Type the dotNetObject wraps, but on a dotNetClass that wraps\n                     the same type you will get the properties of System::Type itself. \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11D8\"></a> <em class=\"strong\">Constructor:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67DD\"></a><pre><em class=\"codeEmphasisStrong\">dotNetClass</em> {&lt;dotNetObject&gt; | &lt;dotNetControl&gt; | &lt;class_type_string&gt; | &lt;c_sharp_type_string&gt; }</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11D6\"></a>Constructs a dotNetClassobject. If the argument is a dotNetObject or dotNetControl\n               object, the dotNetClass will wrap the System::Type of that object. If the argument\n               is a string, MXS will attempt to resolve the string as a System::Type name. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11D5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11D4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67DC\"></a><pre>\ntheClass = dotNetClass \"System.Drawing.Size\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11CF\"></a> <em class=\"strong\">This resolution is done using the following steps:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11CE\"></a>1. Attempt to resolve as a fully qualified name. A fully qualified name includes both\n               the class name and the assembly name. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11CC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11CB\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67DB\"></a><pre>\ndotNetClass \"System.Windows.Forms.MonthCalendar, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11C6\"></a>2. Attempt to resolve as a class name by looking for the name in each assembly loaded\n               into the current AppDomain. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11C5\"></a>3. If no match is found, the name is prepended with \"System.\" and another attempt\n               will be made. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11C4\"></a>4. If no match is found, the name is prepended with \"System.Windows.Forms.\" and another\n               attempt will be made. \n               		\n            </p> \n            <p>5. Finally, an attempt is made to match against built-in C# data type names to the\n               matching .NET system type. The mappings are: \n               		\n            </p> <a name=\"TABLE_369EBDB367B04A7B90BAE2DA8DBBCDD4\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-heading\">\n                     <th class=\"table-heading\">C# Built-in Type Name \n                        				  \n                     </th>\n                     <th class=\"table-heading\">.NET Framework Type \n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">bool</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.Boolean</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">byte</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.Byte</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">sbyte</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.SByte</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">char</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.Char</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">decimal</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.Decimal</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">float</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.Single</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">int</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.Int32</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">uint</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.UInt32</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">long</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.Int64</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">ulong</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.UInt64</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">object</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.Object</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">short</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.Int16</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">ushort</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.UInt16</span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">string</span> \n                     </td>\n                     <td class=\"table-body\"> <span class=\"code\">System.String</span> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"TABLE_9DA5A94DE09048F69EE43ECFA6405755\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-heading\">\n                     <th class=\"table-heading\">EXAMPLE \n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>type = dotnetclass \"bool[]\" --&gt; dotNetClass:System.Boolean[]\nv = dotnet.ValueToDotNetObject #(false,true) type --&gt; dotNetObject:System.Boolean[]\nv.get 0 --&gt; false\ntype = dotnetclass \"byte[]\" --&gt; dotNetClass:System.Byte[]\nv = dotnet.ValueToDotNetObject #(1,2) type --&gt; dotNetObject:System.Byte[]\nv.get 0 --&gt; 1\ntype = dotnetclass \"char[]\" --&gt; dotNetClass:System.Char[]\nv = dotnet.ValueToDotNetObject #(\"A\",\"B\") type --&gt; dotNetObject:System.Char[]\nv.get 0 --&gt; \"A\"</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"GUID-8EF470D3-9D7B-4851-B8FF-7FBD69C75749\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>C# built-in type string matching was introduced in \n                  		  <em class=\"strong\">3ds Max 2018.2 Update</em>. \n                  		\n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11C2\"></a>Assemblies can be loaded to the Current AppDomain. See the \n               		  <span class=\"code\"> <em class=\"strong\">dotNet.LoadAssembly()</em> </span> method in \n               		  <span class=\"char_link\"><a href=\"GUID-9BE82D70-1869-46D7-9501-E5453E25AC68.htm\">dotNet Struct Methods</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11C1\"></a>An example of adding an assembly to the current AppDomainvia methods exposed by the\n               dotNetClass itself: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11C0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11BF\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67DA\"></a><pre>\nassembly = dotNetClass \"System.Reflection.Assembly\"\nr = assembly.loadfrom \"F:\\\\FlashTrackBar\\\\bin\\\\Debug\\\\FlashTrackBar.dll\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-754B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-13D5656D-99CC-444F-9202-F6823A0FBFD6\"></a>Assemblies can not be unloaded once loaded. \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11B5\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67D9\"></a><pre><em class=\"codeEmphasisStrong\">getProperty</em> &lt;dotNetClass&gt; &lt;prop name&gt; [<em class=\"codeEmphasisStrong\">asDotNetObject</em>:&lt;bool&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11B3\"></a>Returns the value of the specified property. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11B2\"></a>If asDotNetObject is false (the default) the value will converted to a native MAXScript\n               value if possible; if true, the value will always be returned as a dotNetControl or\n               dotNetObject value. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11B0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11AF\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67D8\"></a><pre>\no = dotNetClass \"System.String\"\n-- o has only one property, .Empty:\nprop = getProperty o \"Empty\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67D6\"></a><pre><em class=\"codeEmphasisStrong\">setProperty</em> &lt;dotNetClass&gt; &lt;prop name&gt; &lt;value&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1198\"></a>Sets the value of the specified property. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1197\"></a>If the value specified is a native MAXScript value, it will be converted to the proper\n               DotNet value if possible. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67D5\"></a><pre><em class=\"codeEmphasisStrong\">getPropNames</em> &lt;dotNetClass&gt; [<em class=\"codeEmphasisStrong\">showStaticOnly</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">declaredOnTypeOnly</em>:&lt;bool&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1194\"></a>Returns an array of property names exposed by the class. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1193\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">showStaticOnly:</em> </span> is true (the default), only static properties are shown; if false both static and\n               instance properties are shown. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1192\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">declaredOnTypeOnly:</em> </span> is true, only properties declared on the specified class are shown; if false (the\n               default) properties on the class and the classes it derives from are shown. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1191\"></a>The results of this method are sorted by name. The properties returned actually contain\n               two different things in terms of DotNet - properties and fields. The properties are\n               shown first in sorted order, then the fields are shown in sorted order. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67D4\"></a><pre><em class=\"codeEmphasisStrong\">showProperties</em> &lt;dotNetClass&gt; [\"prop_pat\"] [<em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt;] [<em class=\"codeEmphasisStrong\">showStaticOnly</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">showMethods</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">showAttributes</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">declaredOnTypeOnly</em>:&lt;bool&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-118E\"></a>Displays the properties exposed by the class whose name matches the property pattern.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-118D\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">to</em> </span> is not specified, the output goes to Listener, otherwise the output goes to the specified\n               stream. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-118C\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">showStaticOnly:</em> </span> is true (the default), only static properties are shown; if false both static and\n               instance properties are shown. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-118B\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">showMethods:</em> </span> is true, the signature of the get and set methods (if any) are shown; defaults to\n               false. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-118A\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">showAttributes:</em> </span> is true, the attributes associated with the property are shown; defaults to false.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1189\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">declaredOnTypeOnly:</em> </span> is true, only properties declared on the specified class are shown; if false (the\n               default) properties on the class and the classes it derives from are shown. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1188\"></a>The results of this method are sorted by name. The properties returned actually contain\n               two different things in terms of DotNet - properties and fields. The properties are\n               shown first in sorted order, then the fields are shown in sorted order. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67D3\"></a><pre><em class=\"codeEmphasisStrong\">showMethods</em> &lt;dotNetClass&gt; [\"prop_pat\"] [<em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt;] [<em class=\"codeEmphasisStrong\">showStaticOnly</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">showSpecial</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">showAttributes</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">declaredOnTypeOnly</em>:&lt;bool&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1185\"></a>Displays the methods exposed by the class whose name matches the property pattern.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1184\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">to</em> </span> is not specified, the output goes to Listener, otherwise the output goes to the specified\n               stream. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1183\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">showStaticOnly:</em> </span> is true (the default), only static properties are shown; if false both static and\n               instance properties are shown. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1182\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">showSpecial:</em> </span> is true, methods that are not normally called by the user (such as a method to set\n               a property value or to invoke an event handler) are shown; defaults to false. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1181\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">showAttributes:</em> </span> is true, the attributes associated with the property are shown; defaults to false.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1180\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">declaredOnTypeOnly:</em> </span> is true, only properties declared on the specified class are shown; if false (the\n               default) properties on the class and the classes it derives from are shown. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-117F\"></a>The results are sorted by name. Secondary sort is performed based on the number of\n               parameters. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67D2\"></a><pre><em class=\"codeEmphasisStrong\">showEvents</em>&lt;dotNetClass&gt; [\"prop_pat\"] [<em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt;] [<em class=\"codeEmphasisStrong\">showStaticOnly</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">declaredOnTypeOnly</em>:&lt;bool&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-117C\"></a>Displays the events exposed by the class whose name matches the property pattern.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-117B\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">to</em> </span> is not specified, the output goes to Listener, otherwise the output goes to the specified\n               stream. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-117A\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">showStaticOnly:</em> </span> is true (the default), only static properties are shown; if false both static and\n               instance properties are shown. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1179\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">declaredOnTypeOnly:</em> </span> is true, only properties declared on the specified class are shown; if false (the\n               default) properties on the class and the classes it derives from are shown. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1178\"></a>The results are sorted by name. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67D1\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.showConstructors</em> &lt;dotNetClass&gt; [<em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1175\"></a>Displays the constructors exposed by the class. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1174\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">to</em> </span> is not specified, the output goes to Listener, otherwise the output goes to the specified\n               stream. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1173\"></a>The results are sorted by name. Secondary sort is performed based on the number of\n               parameters. \n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1171\"></a> <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet In MAXScript</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1170\"></a> <span class=\"char_link\"><a href=\"GUID-9BE82D70-1869-46D7-9501-E5453E25AC68.htm\">dotNet Struct Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";