var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-25DA5CC7-E8AB-4E6E-92DF-200E121D2CCB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"IKLimb Solver\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>IKLimb Solver</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-25DA5CC7-E8AB-4E6E-92DF-200E121D2CCB\"></a><div class=\"head\">\n            <h1>IKLimb Solver </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BD3\"></a>The IK Limb Solver is specifically meant for animating the limbs of human characters;\n            for example, the hip to the ankle, or the shoulder to the wrist. It affects only two\n            bones in a chain. It is an analytical solver that is very fast and accurate in viewports. \n         </p>\n         <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F85\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>To use with the IK Limb solver, a bones system must have <span class=\"code\"> <em class=\"strong\">three</em> </span> bones in the chain. The goal is placed at the pivot point of the third bone, and\n               the IK solution is calculated for the first and second bones. \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BCE\"></a>The IK Limb solver works not only with bone hierarchies, but with any linked hierarchy\n            that has three elements, and is set up to model a human limb. The additional requirements\n            are: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BCD\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BCB\"></a>The first joint is \"spherical.\" That is, it has 3 degrees of freedom. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BC9\"></a>The second joint is \"revolute.\" That is, it has 1 degree of freedom. \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BC8\"></a>If you attempt to put an IK Limb solver on an inappropriate chain, a warning message\n            informs you that your IK Limb solver assignment has no effect. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BC7\"></a>The IK Limb solver uses the same controls as the HI IK solver, so it follows the model\n            of setting preference angles for joints, and allows for mixing periods of forward\n            and inverse kinematics in the same animation period. It does not use the HD IK Solver\n            methods of damping, precedence, and setting joint limits. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BC6\"></a>The source code of the IK Limb solver is provided as is, so it can be exported directly\n            to a game engine. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BC5\"></a>The joint angles are obtained by computing the transformation (rotation) between the\n            initial chain plane and the target chain plane. The initial chain plane is defined\n            by three unit vectors: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BC4\"></a><ol type=\"1\" start=\"1\">\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BC2\"></a>shoulder-to-elbow unit vector (at the initial pose) \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BC0\"></a>projection of end-effector-axis on a plane perpendicular to the shoulder-to-elbow\n                  unit vector (at the initial pose) \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BBE\"></a>cross product of the above two. \n               </p> \n            </li>\n         </ol>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BBD\"></a>Similarly, the target plane is defined by three analogous vectors at the target pose.\n            \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BBB\"></a> <span class=\"char_link\"><a href=\"GUID-A22DCC5C-A298-4FBD-8BC4-2F086FD2CEEE.htm\">Interface: IKSys</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BBA\"></a> <span class=\"char_link\"><a href=\"GUID-8396FB0C-E332-41F1-92E2-540FEAF0AB4C.htm\">Interface: HDIKSys</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BB9\"></a> <span class=\"char_link\"><a href=\"GUID-8E902545-FEDA-45BF-B052-07732329FA65.htm\">HD IK Controller Chains Can Be Assigned to Existing Hierarchies</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6BB8\"></a> <span class=\"char_link\"><a href=\"GUID-67D4697E-D0F6-4B9C-93A0-8A1D5C57AA9B.htm\">IKChainControl : Matrix3Controller</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";