var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-25E15114-B1F5-4C62-8E84-C630C15E92BB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Converting ActiveX ListView Control to DotNet ListView Control\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Converting ActiveX ListView Control to DotNet ListView Control</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-25E15114-B1F5-4C62-8E84-C630C15E92BB\"></a><div class=\"head\">\n            <h1>Converting ActiveX ListView Control to DotNet ListView Control </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B11\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B0D\"></a>ListView Controls are probably the most widely used ActiveX controls in scripted 3ds\n               Max tools. Converting such scripts to use DotNet ListView controls is a relatively\n               straightforward process. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B0B\"></a>Let\'s take as the base for our conversion example the simple script available in the\n               topic <span class=\"char_link\"><a href=\"GUID-CE10C843-DBC1-4FFF-94CE-BCD79F8FF31C.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                     One</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-B09\"></a>In the following script, you can compare the original ActiveX code which is now remarked\n               and in green to the new commented DotNet code. \n            </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-7BB3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-7BB2\"></a><p class=\"table-body\"> <em class=\"strong\">CONVERSION OF THE SCRIPT</em> \n                        </p> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6776\"></a><pre>\nmacroScript SceneListView category:\"DotNet\"\n(\nrollout listview_rollout \"ListView Selected\"\n(\n/* ActiveX Version:\nfn initListView lv =\n(\nlv.gridLines = true \nlv.View = #lvwReport \nlv.fullRowSelect = true\nlayout_def = #(\"Object Name\", \"Object Class\", \"Verts\", \"Faces\", \"Material\")\nfor i in layout_def do\n(\ncolumn = lv.ColumnHeaders.add()\ncolumn.text = I\n)\n)\n*/\n\nfn initListView lv =\n(\nlv.gridLines = true --same as in ActiveX\n--The following controls the display of details. We use defaults:\nlv.View = (dotNetClass \"System.Windows.Forms.View\").Details\nlv.fullRowSelect = true --same as in ActiveX\nlayout_def = #(\"Object Name\", \"Object Class\", \"Verts\", \"Faces\", \"Material\")\nfor i in layout_def do\nlv.Columns.add i 96 --add column with name and optional width\n)\n/* ActiveX Version:\nfn fillInSpreadSheet lv =\n(\nfor o in selection do\n(\nli = lv.ListItems.add()\nli.text = o.name\nsub_li = li.ListSubItems.add()\nsub_li.text = (classof o) as string\nsub_li = li.ListSubItems.add()\nsub_li.text = try((o.mesh.numverts) as string)catch(\"--\")\nsub_li = li.ListSubItems.add()\nsub_li.text = try((o.mesh.numfaces) as string)catch(\"--\")\nsub_li = li.ListSubItems.add()\nsub_li.text = (o.material) as string\n)\n)\n*/\n\nfn fillInSpreadSheet lv =\n(\ntheRange = #() --array to collect the list items\nfor o in selection do\n(\n--First we create a ListViewItem objectwith the object\'s name:\nli = dotNetObject \"System.Windows.Forms.ListViewItem\" o.name\n--Then we add all the sub-itemswith the desired string values:\nsub_li = li.SubItems.add ((classof o) as string)\nsub_li = li.SubItems.add (try((o.mesh.numverts) as string)catch(\"--\"))\nsub_li = li.SubItems.add (try((o.mesh.numfaces) as string)catch(\"--\"))\nsub_li = li.SubItems.add ((o.material) as string)\nappend theRange li--we add the list item to the array\n)\nlv.Items.AddRange theRange--when done, we populate the ListView\n)\n/* ActiveX Version:\nactiveXControl lv_objects \"MSComctlLib.ListViewCtrl\" width:490 height:190 align:#center\n*/\n\ndotNetControl lv_objects \"System.Windows.Forms.ListView\" width:490 height:190 align:#center\non listview_rollout open do\n(\ninitListView lv_objects\nfillInSpreadSheet lv_objects\n)\n)\ntry(destroyDialog listview_rollout)catch()\ncreateDialog listview_rollout 500 200\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-AAD\"></a> <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet In MAXScript</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-AAC\"></a> <span class=\"char_link\"><a href=\"GUID-CE10C843-DBC1-4FFF-94CE-BCD79F8FF31C.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                              One</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";