var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-26009A1A-50AF-4ED7-AECA-8CB60D11A1A5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"function calls\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Function Calls</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-26009A1A-50AF-4ED7-AECA-8CB60D11A1A5\"></a><div class=\"head\">\n            <h1>Function Calls </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F0D\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F0E\"></a>  A function call expression passes an optional list of arguments to a MAXScript or\n               user-defined function, and the value returned by the function is the function call\n               expression’s result. A <span class=\"code\">&lt;function_call&gt;</span> has one of the following forms: \n            </p> \n            <p><a name=\"P_F2E06EE304C04CA8AA2BFC1696BFD225\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6115\"></a><pre>&lt;operand&gt; { &lt;argument&gt; }+ -- one or more arguments</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6114\"></a><pre>&lt;operand&gt; <em class=\"codeEmphasisStrong\">()</em> -- no arguments 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F13\"></a>in which, <span class=\"code\">&lt;argument&gt;</span> is one of the following: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6113\"></a><pre>&lt;operand&gt;&lt;name&gt;: &lt;operand&gt; -- keyword argument</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F16\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F17\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6112\"></a><pre>\nsin a\ntan2 x y\nprint (n + 1) to:debug\nfns[i] $box01 -- get function out of array fns\nmove object1 [10,20,x * 3]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F20\"></a>This syntax is unlike most programming languages that typically use parenthesized\n               lists of comma-separated arguments. This syntax was chosen for MAXScript for the following\n               reasons: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F21\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F23\"></a>It is simpler and easier to use, particularly if a function has many optional keyword\n                     arguments. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F25\"></a>The language is used in a command-line window within <em class=\"strong\">3ds Max</em>. Therefore, this form is similar to other command or shell languages that users might\n                     already know. \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F26\"></a>All <em class=\"strong\">3ds Max</em> objects including geometric objects, splines, materials, and so on are created using\n               function calls. The name of the object creation function is the object’s class name.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F27\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86F28\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6111\"></a><pre>\nstandard() -- create a standard material\nbend angle:45 -- create a bend modifier\nbox height:20 width:40 -- create a box\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F30\"></a> <span class=\"char_link\"><a href=\"GUID-822DE27D-004E-4B19-ADA6-B0E980626462.htm\">Positional and Keyword Arguments</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F31\"></a> <span class=\"char_link\"><a href=\"GUID-DF143835-008F-4753-9674-BB7B02DCDE51.htm\">Function Precedence </a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F32\"></a> <span class=\"char_link\"><a href=\"GUID-CFDAE10B-5BA5-4EB3-8909-28223E713B91.htm\">Code Layout </a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F33\"></a> <span class=\"char_link\"><a href=\"GUID-3F90A2E3-2AA1-4C3E-9474-15EE04750992.htm\">Special Notes about Function Calls</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86F34\"></a> <span class=\"char_link\"><a href=\"GUID-6CF536D8-B90A-4998-AA16-71F23E710B47.htm\">Creating Functions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-822DE27D-004E-4B19-ADA6-B0E980626462.htm\">Positional and Keyword Arguments </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-DF143835-008F-4753-9674-BB7B02DCDE51.htm\">Function Precedence </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-CFDAE10B-5BA5-4EB3-8909-28223E713B91.htm\">Code Layout </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-3F90A2E3-2AA1-4C3E-9474-15EE04750992.htm\">Special Notes About Function Calls </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";