var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-26735E7E-9F8E-4E70-A992-986C448459E9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Camera_Culling Helper\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>AirFlow_Node : Helper</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-26735E7E-9F8E-4E70-A992-986C448459E9\"></a><div class=\"head\">\n            <h1>AirFlow_Node : Helper</h1>\n         </div>\n         <div class=\"codeBlock\"><pre>AirFlow_Node - superclass: helper; super-superclass:node - 26:0 - classID: #(1509449990L, 515064320L)</pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E8351D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8351E\"></a><p class=\"table-body\">  <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm\">Node</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-4ECA4F12-1972-42E7-BDDD-9AE188AC4BEF.htm\">Helper</a></span> &gt; AirFlow_Node \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p>The AirFlow_Node helper converts CFD Data to particle flow nodes for airflow simulations.\n            Available in \n            		<em class=\"strong\"> in 3ds Max 2018 and higher.</em> \n         </p>\n         <div><a name=\"GUID-18CB993A-4F59-4D99-80B8-FEEC42BEC47D\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> this class is not creatable in the 3ds Max ParticleFlow UI. It can only be created\n               via MAXScript. \n               	 \n            </div>\n         </div>\n         <div><a name=\"GUID-35A016D5-6E7F-4093-80DF-AAC57F9FACDA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> The AirFlow* pflow classes in MAXScript are a prototype for CFD visualization. The\n               recommended method is to use MCG. See \"Visualizing CFD Data\" in the 3ds Max User’s\n               Guide. \n               	 \n            </div>\n         </div>\n         <p><em class=\"strong\">Properties:</em> \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Color</em>     Color    default: (color 255 255 255)   --  RGB color</pre></div>\n         <p>Gets or sets the node color. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Color_Levels</em>     Integer    default: 16   --  integer</pre></div>\n         <p>Gets or sets the number of color levels. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Color_RGB_To_Script_Vector</em>     BooleanClass    default: false   --  boolean</pre></div>\n         <p>Gets or sets the value of the \n            		<span class=\"MenuCascade\">Color RBG --&gt; Script Vector</span> check box. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Color_Type</em>     BooleanClass    default: true   --  boolean</pre></div>\n         <p>Gets or sets the value of the \n            		<span class=\"MenuCascade\">Color Coordinated</span> check box. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Data_Display</em>     Integer    default: 0   --  integer</pre></div>\n         <p>Gets or sets the \n            		<span class=\"MenuCascade\">Color Data</span> setting for the node, where: \n            	 \n         </p><a name=\"UL_8D855446F84340E08D6C43126FA9A282\"></a><ul>\n            <li> \n               <p>0 = None \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>1=Pressure \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>2=Temperature \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>3=Scal1 \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>4=Turbk \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>5=Heat Flux \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>6=Shear Mag \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>7=NVol \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>8=Density \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>9=Match \n                  		  \n               </p> \n            </li>\n         </ul>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Data_Source_File</em>     UndefinedClass    default: undefined   --  filename; !error setting value!</pre></div>\n         <p>Gets or sets the .csv data source file. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Display_Type</em>     Integer    default: 0   --  integer</pre></div>\n         <p>Gets or sets the display type where: \n            	 \n         </p><a name=\"UL_110BA1AC82F14AD5BF42AE8F9C6918FC\"></a><ul>\n            <li> \n               <p>0=None \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>1=Dots \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>2=Ticks \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>3=Circles \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>4=Boxes \n                  		  \n               </p> \n            </li>\n            <li> \n               <p>5=Lines \n                  		  \n               </p> \n            </li>\n         </ul>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Emit_Time</em>     Integer    default: 0   --  integer</pre></div>\n         <p>Gets or sets the \n            		<span class=\"MenuCascade\">Emit Time</span>. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Icon_Height</em>     Float    default: 10.0   --  worldUnits\n&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Icon_Length</em>     Float    default: 10.0   --  worldUnits\n&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Icon_Width</em>     Float    default: 10.0   --  worldUnits</pre></div>\n         <p>Gets or sets the \n            		<span class=\"MenuCascade\">Icon Size</span> values for height, length, and width. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Intensity_To_Script_Integer</em>     BooleanClass    default: false   --  boolean; Intensity_To_Script_Vector</pre></div>\n         <p>Gets or sets the value of the \n            		<span class=\"MenuCascade\">Intensity --&gt; Script Integer</span> check box. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Load_For_Inside_Icon_Only</em>     BooleanClass    default: false   --  boolean</pre></div>\n         <p>Gets or sets the value of the \n            		<span class=\"MenuCascade\">Load For Inside Icon Only</span> checkbox. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Load_For_Visible_Only</em>     BooleanClass    default: false   --  boolean</pre></div>\n         <p>Gets or sets the value of the \n            		<span class=\"MenuCascade\">Load For Visible % Only</span> checkbox. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Random_Seed</em>     Integer    default: 45921   --  integer</pre></div>\n         <p> Gets or sets the \n            		<span class=\"MenuCascade\">Visibility Randomness</span> random seed value. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Rotation_Offset_X</em>     Float    default: 0.0   --  angle\n&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Rotation_Offset_Y</em>     Float    default: 0.0   --  angle\n&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Rotation_Offset_Z</em>     Float    default: 0.0   --  angle</pre></div>\n         <p> Gets or sets the \n            		<span class=\"MenuCascade\">Data Rotation Offset</span> value for X, Y and Z axes. This is a Euler angle value. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Save_Data_With_Max_File</em>     BooleanClass    default: true   --  boolean</pre></div>\n         <p> Gets or sets the value of the \n            		<span class=\"MenuCascade\">Save Data With .max File</span> checkbox. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Speed_Factor</em>     Float    default: 1.0   --  float</pre></div>\n         <p> Gets or sets the speed factor. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Translation_Offset_X</em>     Float    default: 0.0   --  worldUnits \n&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Translation_Offset_Y</em>     Float    default: 0.0   --  worldUnits \n&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Translation_Offset_Z</em>     Float    default: 0.0   --  worldUnits</pre></div>\n         <p> Gets or sets the Data Translation Offset X, Y, and Z values. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Upper_Limit</em>     Integer    default: 1000000   --  integer</pre></div>\n         <p> Gets or sets the Upper Limit for data statistics. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Visible_Inside_Icon_Only</em>     BooleanClass    default: false   --  boolean</pre></div>\n         <p> Gets or sets the \n            		<span class=\"MenuCascade\">Visible Inside Icon Only</span> checkbox value. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;AirFlow_Node&gt;.<em class=\"codeEmphasisStrong\">Visible_Ratio</em>     Float    default: 100.0   --  percent</pre></div>\n         <p> Gets or sets the \n            		<span class=\"MenuCascade\">Visible %</span> value. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E83543\"></a> \n            <h2><a name=\"GUID-14B36B1A-9868-4A47-B9D6-5806E6F6AAF8\"></a> <em class=\"strong\">AirFLow_Node interfaces:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83544\"></a> <em class=\"strong\">The following common Particle Flow Interfaces are exposed by the AirFlow_Node Class:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83545\"></a> <span class=\"char_link\"><a href=\"GUID-E79B7C9A-90E9-4EBA-8528-D819882EADF2.htm\">Interface: action</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83546\"></a> <span class=\"char_link\"><a href=\"GUID-997AF141-E2BD-419E-A10A-71B2288F571C.htm\">Interface: operator</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E83547\"></a> <span class=\"char_link\"><a href=\"GUID-E431999C-D823-4650-8C5C-D02137348CF9.htm\">Interface: PViewItem</a></span> \n            </p> \n         </div>\n         <p> </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";