var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-2739C3A0-16DB-4871-9F69-DCEC0862A186\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"variables\">\n      <meta name=\"indexterm\" content=\"persistent global variables\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Persistent Global Variables</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2739C3A0-16DB-4871-9F69-DCEC0862A186\"></a><div class=\"head\">\n            <h1>Persistent Global Variables </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A34\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A35\"></a>  MAXScript supports a limited form of persistent global variables. You declare a particular\n               global to be persistent and the value it contains is always saved to and restored\n               from scene files as they are opened and closed. Therefore, you can keep direct references\n               to objects in the scene in variables and those references will persist across scene\n               save and reload. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A38\"></a>You declare a global variable as persistent by prefacing its declaration with the\n               reserved word \n               		  <span class=\"code\"> <em class=\"strong\">persistent</em> </span>. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A39\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A3A\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-619A\"></a><pre>persistent global foo, baz, bar</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A3F\"></a>declares the variables \n               		  <span class=\"code\"> <em class=\"strong\">foo</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">baz</em> </span>, and \n               		  <span class=\"code\"> <em class=\"strong\">bar</em> </span> to be persistent. From then on, the values in \n               		  <span class=\"code\"> <em class=\"strong\">foo</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">baz</em> </span>, and \n               		  <span class=\"code\"> <em class=\"strong\">bar</em> </span> at the time of a scene save are stored in the .max scene file. When that file is\n               reopened, the values in \n               		  <span class=\"code\"> <em class=\"strong\">foo</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">baz</em> </span>, and \n               		  <span class=\"code\"> <em class=\"strong\">bar</em> </span> are restored, with an implicit declaration as persistent globals if they are not\n               so already declared. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A40\"></a>The current limitation with persistent global variables is that only certain kinds\n               of values are storable in a scene file, and only those types of values are saved and\n               restored across scene saves and loads. \n               		\n            </p> \n            <p><a name=\"GUID-D75A6CDF-CEF8-4A6D-AD62-B1BDB013282C\"></a>The supported value classes are: AngleAxis, Array, Boolean, Color, DataPair, Double,\n               Empty, EulerAngles, Float, Integer, Integer64, IntegerPtr, Interval, Matrix3, Name,\n               OK, Point2, Point3, Point4, Quat, Ray, String, Struct, Time, Undefined, Unsupplied,\n               and all the MAXWrapper classes (nodes, modifiers, controllers, materials, and so on).\n               All other types of values restore as the value \n               		  <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A41\"></a>In the case of Array, only those values in the array that are in the previous list\n               are correctly saved and restored; others appear as \n               		  <span class=\"code\"> <em class=\"strong\">undefined</em> </span> in the restored array. \n               		\n            </p> \n            <p><a name=\"GUID-411453D5-8139-4F2A-940A-10A67E843B1B\"></a>IntegerPtr loading and saving support was added in \n               		  <em class=\"strong\">3ds Max 2015</em>. When saving to a previous 3ds Max version, IntegerPtr values will be stored as Integer64\n               values. \n               		\n            </p> \n            <p>DataPair loading and saving support was added in \n               		  <em class=\"strong\">3ds Max 2017 Extension 1</em>. When saving to a previous 3ds Max version, DataPair values will be stored as undefined.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A42\"></a>Persistent globals are removed from the persistent globals pool when a File &gt; Reset,\n               File &gt; New, or File &gt; Open is performed, but they will remain in memory as ordinary,\n               non-persistent global variables for that MAX session. Subsequently, persistent global\n               variables declared during a MAX session do not \"stick around\" and get stored with\n               every other file saved during that session. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-193B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A45\"></a>When merging or XRef-ing in a file (scene/object XRefs are a special case of merge),\n                     when reading in persistent global variables, \n                     		  \n                  </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A46\"></a><ul>\n                     <li> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A48\"></a>If the variable being read from the scene file already \n                           				  <em class=\"strong\">exists as a persistent global variable</em>, the value of the persistent global is \n                           				  <em class=\"strong\">not overwritten</em>. (It was overwritten in versions prior to \n                           				  <em class=\"strong\">3ds Max 8</em>). \n                           				\n                        </p> \n                     </li>\n                     <li> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A4A\"></a>If the variable exists as a non-persistent global variable, the global variable\'s\n                           value is overwritten. \n                           				\n                        </p> \n                     </li>\n                     <li> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A4C\"></a>If the variable does not exist as a global variable, a non-persistent global variable\n                           will be created. The last 2 behaviors are the same as in previous versions of \n                           				  <em class=\"strong\">3ds Max</em>. \n                           				\n                        </p> \n                     </li>\n                  </ul> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A4E\"></a>If needed, you can install persistent globals in each new file using a \n               		  <span class=\"code\"> <em class=\"strong\">#filePreSave</em> </span> callback. See \n               		  <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span> for more information. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A4F\"></a>However, this behavior also means that variables originally declared as persistent\n               global variables may remain defined as ordinary global variables over multiple scenes\n               while a script is being created or run, yet show up as undefined when these saved\n               scenes are reopened in another MAX session. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A51\"></a>Below are two examples illustrating the use of callbacks to handle such situations:\n               \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A52\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A53\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 1:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A54\"></a><p class=\"table-body\">If a script requires that a certain critical variable carries its value into new and\n                           opened scenes and always exists as a persistent global, the following callbacks would\n                           ensure this during File &gt; Reset, File &gt; New and File &gt; Open events: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6199\"></a><pre>callbacks.addscript #systemPostNew \"persistent global myVar\" id:#myTools\ncallbacks.addscript #systemPostReset \"persistent global myVar\" id:#myTools\ncallbacks.addscript #filePostOpen \"persistent global myVar\" id:#myTools</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A5B\"></a>The critical variable is simply re-declared, leaving its value unaffected but ensuring\n               that it is saved as a persistent global within the scene. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A5D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A5E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 2:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A5F\"></a><p class=\"table-body\">Another case would be a script requiring that a certain critical variable always exist\n                           as a persistent global but never carry its current value into other scenes, instead\n                           either reverting to a default value for new and opened scenes that don\'t have the\n                           persistent global defined, or restoring the value from opened scenes that do have\n                           the persistent global defined. The following callbacks would assign default values\n                           to the variable during File &gt; Reset and File &gt; New events, but would only assign a\n                           default value during a File &gt; Open event if the persistent global was not already\n                           present in the opened file: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6198\"></a><pre>callbacks.addscript #systemPostReset \"persistent global myVar=0.0\" id:#myTools\ncallbacks.addscript #systemPostNew \"persistent global myVar=0.0\" id:#myTools\ncallbacks.addscript #filePreOpen \"myVar=undefined\" id:#myTools\ncallbacks.addscript #filePostOpen \"if myVar==undefined do (persistent global myVar=0.0)\" id:#myTools</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86A67\"></a>During File &gt; Reset and File &gt; New events the critical variable is re-declared and\n               assigned a default value, but during a File &gt; Open event the variable first becomes\n               undefined and is then tested after the file is opened. If that persistent global variable\n               was already present and defined in the scene being opened, the variable would have\n               already been restored as a persistent global variable with its old value. In that\n               case, there\'s no need to re-declare it as a persistent global since it is already\n               in the persistent global pool and will remain there forever until explicitly removed.\n               \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-193A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-CAC20F88-0C0D-46BB-B989-FCDE5D0AF1A4\"></a>There is one potential problem with both of the above examples: the persistent globals\n                     will continue being created by the callbacks for the rest of the current MAX session.\n                     Unless this is the desired behavior, this should be avoided by having the created\n                     callbacks removed when the script is closed. \n                     		  \n                  </p> \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A68\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A6B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A6C\"></a><p class=\"table-body\">if the script exists in a utility or dialog rollout then the associated close event\n                           handler should include a \"callbacks.removeScripts\" command to remove the callbacks.\n                           \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6197\"></a><pre>on myToolsUtility close do (callbacks.removeScripts id:#myTools)</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A70\"></a><p class=\"table-body\">This example also illustrates the advantage of using id: parameter whenever possible.\n                           This not only makes removal easy but specific as well, since it avoids accidentally\n                           removing callbacks that belong to other scripts. \n                           					 \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A71\"></a><p class=\"table-body\">See \n                           						<span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span> and \n                           						<span class=\"char_link\"><a href=\"GUID-DC435555-362D-4A03-BCF2-21179C5442F2.htm\">Utility and Rollout Properties, Methods, and Event Handlers</a></span> for more information. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"P_BFBC5FFBAA094E678CF982BF11CE34F6\"></a>For \n               		  <em class=\"strong\">methods</em> to \n               		  <em class=\"strong\">create</em>, \n               		  <em class=\"strong\">collect</em>, \n               		  <em class=\"strong\">test</em>, \n               		  <em class=\"strong\">show</em> and \n               		  <em class=\"strong\">remove</em> persistent global variables, see the topic \n               		  <span class=\"char_link\"><a href=\"GUID-A2F1412A-0EF7-405B-A4A2-6F169A838C4C.htm\">Persistents Structure</a></span>. \n               		\n            </p> \n            <p><a name=\"P_835F46325F144FF98A1716E52FF5518B\"></a> \n               <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1939\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If a persistent global variable contains a \n                     			 <span class=\"code\"> <em class=\"strong\">MAXWrapper</em> </span> value, but the class instance is \n                     			 <em class=\"strong\">not</em> in the scene, that value is \n                     			 <em class=\"strong\">not</em> stored/restored on a file save/load. \n                     		  \n                  </div>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A97\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A9A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6191\"></a><pre>\n-- persistents - node only\npersistent global global_array = #() \nglobal_array[1] = b= box() \nglobal_array[2] = bm= bend() \nglobal_array[3] = sm= standard() \nglobal_array[4] = fog() \nglobal_array[5] = area() \nglobal_array[6] = bezier_float() \nglobal_array[7] = br= bricks() \nglobal_array[8] = lookat() \nglobal_array[9] = blur() \nglobal_array[10] = MapScaler() \n--b.material=sm \n--addmodifier b bm \n--sm.diffusemap=br \npersistents.show() \nmax hold \nmax fetch\npersistents.show()\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86A9F\"></a><p class=\"table-body\"> <em class=\"strong\">REMARKS:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86AA0\"></a><p class=\"table-body\">Only the box is in the array after running this script. If the commented lines are\n                              run, the material, modifier, and map are also in the array. MAXScript does not do\n                              a full reference-tree dump when it outputs its persistent variables, it just outputs\n                              RefIDs for MAX objects and so depends on them being dumped as references by the main\n                              file save code. \n                              					 \n                           </p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AA3\"></a> <span class=\"char_link\"><a href=\"GUID-F82B9FF1-2B52-4DA6-B9D3-627742690462.htm\">How To Make It Better?</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";