var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-2A6DF478-2707-4D8B-A9CE-8E4E90D6FD1C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Develop a Bitmap Painting Tool\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop a Bitmap Painting Tool - Erase Changes</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2A6DF478-2707-4D8B-A9CE-8E4E90D6FD1C\"></a><div class=\"head\">\n            <h1>How To ... Develop a Bitmap Painting Tool - Erase Changes </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29C9\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29CA\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-FA2D9E9C-90EA-4E95-926E-29BB2FA416FA.htm\">Develop a Bitmap Painting Tool</a></span>- Erase Changes \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29CC\"></a>In this step of the Bitmap Painting tool development, we will add an eraser option\n            to the existing brushes. When the user is drawing with the right mouse button pressed,\n            the background image will be revealed.This mode will support all available brushes\n            including the Airbrush mode, allowing the user to erase smoothly. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29CE\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29CF\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29D0\"></a><p class=\"table-body\">We will add a new flag variable to control the Erase mode. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29D1\"></a><p class=\"table-body\">We will change the paintbrush function to support reading of pixels from the background\n                        image. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29D2\"></a><p class=\"table-body\">We will implement right mouse button handlers to enable erasing of the existing pixels\n                        with the original pixels from the background. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29D3\"></a><p class=\"table-body\">We will add a commit change option to the Edit menu to copy the foreground painting\n                        canvas into the background and \"bake in\" all changes. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29D5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC29D6\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63D6\"></a><pre>\nmacroScript MicroPaint category: \"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry (destroyDialog MicroPaint_CanvasRollout) catch()\nlocal isErasing =isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white\nlocal theBackgroundBitmap = bitmap bitmapX bitmapY color:white\nlocal currentPos = lastPos = [0,0]\n&nbsp;\nrcMenu CanvasMenu\n(\n  subMenu \"File\"\n  (\n    menuItem new_menu \"New\"\n    menuItem open_menu \"Open...\"\n    menuItem save_as \"Save As...\"\n    separator file_menu_1\n    menuItem quit_tool \"Quit\"&nbsp;&nbsp;\n  )\n  subMenu \"Edit\"\n  (\n    &nbsp;menuItem commit_menu \"Commit Changes\"\n  )\n  on commit_menu picked do copy theCanvasBitmap theBackgroundBitmap\n&nbsp;\n  subMenu \"Help\"\n  (\n    menuItem about_tool \"About MicroPaint...\"&nbsp;\n  )\n&nbsp;\n  on new_menu picked do\n  (\n    theBackgroundBitmap = theCanvasBitmap = bitmap bitmapX bitmapY color:MicroPaint_CanvasRollout.paperColor.color\n    MicroPaint_CanvasRollout.theCanvas.bitmap = theCanvasBitmap\n  )\n&nbsp;\n&nbsp;\n  on open_menu picked do\n  (\n    theOpenBitmap= selectBitmap()\n    if theOpenBitmap != undefined do\n    (\n      copy theOpenBitmap theCanvasBitmap\n      copy theOpenBitmap theBackgroundBitmap\n      close theOpenBitmap\n      MicroPaint_CanvasRollout.theCanvas.bitmap = theCanvasBitmap\n    )\n  )\n&nbsp;\n  on save_as picked do\n  (\n    theSaveName = getSaveFileName types:\"BMP (*.bmp)|*.bmp|Targa (*.tga)|*.tga|JPEG (*.jpg)|*.jpg\"\n    if theSaveName != undefined do\n    (\n      theCanvasBitmap.filename = theSaveName\n      save theCanvasBitmap\n    )\n  )\n  on about_tool picked do messagebox \"MicroPaint\\nMAXScript Tutorial\" title:\"About...\"\n  on quit_tool picked do destroyDialog MicroPaint_CanvasRollout\n)\n&nbsp;\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\n  bitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap\n  colorpicker inkColor height:16 modal:false color:black across:5\n  colorpicker paperColor height:16 modal:false color:white\n  checkbutton airBrush \"AirBrush\" width:50\n  spinner AirBrushSpeed \"Speed\" range:[0.1,50,10] fieldwidth:30\n  spinner BrushSize \"Size\" range:[1,50,10] type:#integer fieldwidth:40\n  listbox BrushShape items:#(\"Circle\",\"Box\",\"Circle Smooth\") pos:[bitmapX+5,0] width:90\n&nbsp;\n  fn paintBrush pos =\n  (\n    if isErasing then\n      thePaintColor = (getPixels theBackgroundBitmap pos 1)[1]\n    else\n      thePaintColor = inkColor.color\n    if thePaintColor == undefined do thePaintColor = white\n&nbsp;\n    case BrushShape.selection of\n    (\n      1: (\n        if distance pos currentPos &lt;= BrushSize.value/2 do\n          setPixels theCanvasBitmap pos #(thePaintColor)\n      )\n      2: setPixels theCanvasBitmap pos #(thePaintColor)\n      3: (\n        theFactor = (distance pos currentPos) / (BrushSize.value/2.0)\n        if theFactor &lt;= 1.0 do\n        (\n          theFactor = sin ( 90.0 * theFactor)\n          thePixels = getPixels theCanvasBitmap pos 1\n          if thePixels[1] != undefined do\n          (\n            thePixels[1] = (thePixels[1] * theFactor) + (thePaintColor * (1.0 - theFactor))\n              setPixels theCanvasBitmap pos thePixels\n          )\n        )\n      )--end case 3\n    )--end case\n  )--end fn\n&nbsp;\n  fn drawStroke lastPos pos =\n  (\n    currentPos = lastPos\n    deltaX = pos.x - lastPos.x\n    deltaY = pos.y - lastPos.y\n    maxSteps = amax #(abs(deltaX),abs(deltaY))\n    deltaStepX = deltaX / maxSteps\n    deltaStepY = deltaY / maxSteps\n    for i = 0 to maxSteps do\n    (\n      if airBrush.checked then\n      (\n        for b = 1 to (BrushSize.value / AirBrushSpeed.value) do\n          paintBrush (currentPos + (random [-BrushSize.value/2,-BrushSize.value/2] [BrushSize.value/2,BrushSize.value/2] ))\n      )\n      else\n        for b = -BrushSize.value/2 to BrushSize.value/2 do\n          for c = -BrushSize.value/2 to BrushSize.value/2 do\n            paintBrush (currentPos + [c,b])\n      currentPos += [deltaStepX, deltaStepY]\n    )\n    theCanvas.bitmap = theCanvasBitmap\n  )\n&nbsp;\n  on MicroPaint_CanvasRollout lbuttondown pos do\n  (\n    lastPos = pos\n    isDrawing = true\n    isErasing = false\n    drawStroke lastPos pos\n  )\n  on MicroPaint_CanvasRollout rbuttondown pos do\n  (\n    lastPos = pos\n    isErasing = isDrawing = true\n    drawStroke lastPos pos\n  )\n  on MicroPaint_CanvasRollout lbuttonup pos do isErasing =isDrawing = false\n  on MicroPaint_CanvasRollout rbuttonup pos do isErasing =isDrawing = false\n&nbsp;\n  on MicroPaint_CanvasRollout mousemove pos do\n  (\n    if isDrawing do drawStroke lastPos pos\n    lastPos = pos\n  )\n)\ncreateDialog MicroPaint_CanvasRollout (bitmapx+100) (bitmapy+30) menu:CanvasMenu\nMicroPaint_CanvasRollout.theCanvas.bitmap = theBackgroundBitmap\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2A73\"></a> \n            <h2><a name=\"GUID-B43EEF46-5E57-433C-B178-2B555DC7B5FD\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63D5\"></a><pre><em class=\"codeEmphasisMild\"><em class=\"codeEmphasisStrong\">--Code in green has no changes since the previous version.</em></em> <em class=\"codeEmphasisMild\">macroScript MicroPaint category:\"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry(destroyDialog MicroPaint_CanvasRollout)catch()</em> <em class=\"codeEmphasisStrong\">local isErasing = isDrawing = false</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2A7B\"></a>We add a new variable isErasing that will be set to true when the right mouse button\n               is pressed. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63D4\"></a><pre><em class=\"codeEmphasisMild\">local bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white\nlocal theBackgroundBitmap = bitmap bitmapX bitmapY color:white\nlocal currentPos = lastPos = [0,0]\n\nrcMenu CanvasMenu\n(\nsubMenu \"File\"\n(\nmenuItem new_menu \"New\"\nmenuItem open_menu \"Open...\"\nmenuItem save_as \"Save As...\"\nseparator file_menu_1\nmenuItem quit_tool \"Quit\"\n)\nsubMenu \"Edit\"\n(</em> <em class=\"codeEmphasisStrong\">menuItem commit_menu \"Commit Changes\"</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2A8E\"></a>We add a new menu item to the Edit dialog. It will be used to commit the editing changes\n               and make them \"unerasable\". \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63D3\"></a><pre><em class=\"codeEmphasisMild\">)</em> <em class=\"codeEmphasisStrong\">on commit_menu picked do copy theCanvasBitmap theBackgroundBitmap</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2A91\"></a>This is the event handler for the commit changes option. When selected, the foreground\n               image we are painting on will be copied into the background image, thus \"baking\" all\n               the changed pixels into it. Using the eraser from this point on will reveal the new\n               pixels. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63D2\"></a><pre><em class=\"codeEmphasisMild\">subMenu \"Help\"\n(\nmenuItem about_tool \"About MicroPaint...\"&nbsp;\n)\n\non new_menu picked do\n(\ntheBackgroundBitmap = theCanvasBitmap = bitmap bitmapX bitmapY color:MicroPaint_CanvasRollout.paperColor.color\nMicroPaint_CanvasRollout.theCanvas.bitmap = theCanvasBitmap\n)\n\non open_menu picked do\n(\ntheOpenBitmap= selectBitmap()\nif theOpenBitmap != undefined do\n(\ncopy theOpenBitmap theCanvasBitmap\ncopy theOpenBitmap theBackgroundBitmap\nclose theOpenBitmap\nMicroPaint_CanvasRollout.theCanvas.bitmap = theCanvasBitmap\n)\n)\n\non save_as picked do\n(\ntheSaveName = getSaveFileName types:\"BMP (*.bmp)|*.bmp|Targa (*.tga)|*.tga|JPEG (*.jpg)|*.jpg\"\nif theSaveName != undefined do\n(\ntheCanvasBitmap.filename = theSaveName\nsave theCanvasBitmap\n)\n)\n\non about_tool picked do messagebox \"MicroPaint\\nMAXScript Tutorial\" title:\"About...\"\non quit_tool picked do destroyDialog MicroPaint_CanvasRollout\n)\n\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\nbitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap\ncolorpicker inkColor height:16modal:false color:black across:5\ncolorpicker paperColor height:16 modal:false color:white\ncheckbutton airBrush \"AirBrush\" width:50\nspinner AirBrushSpeed \"Speed\" range:[0.1,50,10] fieldwidth:30\nspinner BrushSize \"Size\" range:[1,50,10] type:#integer fieldwidth:40\nlistbox BrushShape items:#(\"Circle\", \"Box\", \"Circle Smooth\") pos:[bitmapX+5,0] width:90\n\nfn paintBrush pos =\n(</em> <em class=\"codeEmphasisStrong\">if isErasing then</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2AC4\"></a>If the eraser mode is active (that means, the user is holding down the right mouse\n               button), then \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63D1\"></a><pre><em class=\"codeEmphasisStrong\">thePaintColor = (getPixels theBackgroundBitmap pos 1)[1]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2AC6\"></a>we get the color of the pixel from the background as the ink color. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63D0\"></a><pre><em class=\"codeEmphasisStrong\">else\nthePaintColor = inkColor.color</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2AC9\"></a>Otherwise, we use the ink color defined by the User Interface. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63CF\"></a><pre><em class=\"codeEmphasisStrong\">if thePaintColor == undefined do thePaintColor = white</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2ACB\"></a>If the pixel was outside the bitmap, it might contain undefined. To avoid errors,\n               we reset it back to white. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63CE\"></a><pre><em class=\"codeEmphasisMild\">case BrushShape.selection of\n(\n1: (\nif distance pos currentPos &lt;= BrushSize.value/2 do</em> <em class=\"codeEmphasisStrong\">setPixels theCanvasBitmap pos #(thePaintColor)</em> <em class=\"codeEmphasisStrong\">)</em> <em class=\"codeEmphasisStrong\">2: setPixels theCanvasBitmap pos #(thePaintColor)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2AD3\"></a>In both cases, we replace the explicit use of the InkColor.color with thepaintColor\n               that contains the correct color to paint with. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63CD\"></a><pre><em class=\"codeEmphasisMild\">3: (\ntheFactor = (distance pos currentPos) / (BrushSize.value/2.0)\nif theFactor &lt;= 1.0 do\n(\ntheFactor = sin ( 90.0 * theFactor)\nthePixels = getPixels theCanvasBitmap pos 1\nif thePixels[1] != undefined do\n(</em> <em class=\"codeEmphasisStrong\">thePixels[1] = (thePixels[1] * theFactor) + (thePaintColor * (1.0 - theFactor))</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2ADE\"></a>Again, we replace the explicit use of the InkColor.color with thePaintColor that contains\n               the correct color to paint with. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63CC\"></a><pre><em class=\"codeEmphasisMild\">setPixels theCanvasBitmap pos thePixels\n)\n)\n)--end case 3\n)--end case\n)--end fn\n\nfn drawStroke lastPos pos =\n(\ncurrentPos = lastPos\ndeltaX = pos.x - lastPos.x\ndeltaY = pos.y - lastPos.y\nmaxSteps = amax #(abs(deltaX),abs(deltaY))\ndeltaStepX = deltaX / maxSteps\ndeltaStepY = deltaY / maxSteps\nfor i = 0 to maxSteps do\n(\nif airBrush.checked then\n(\nfor b = 1 to (BrushSize.value / AirBrushSpeed.value) do\npaintBrush (currentPos + (random [-BrushSize.value/2,-BrushSize.value/2] [BrushSize.value/2,BrushSize.value/2] ))\n)\nelse\nfor b = -BrushSize.value/2 to BrushSize.value/2 do\nfor c = -BrushSize.value/2 to BrushSize.value/2 do\npaintBrush (currentPos + [c,b])\ncurrentPos += [deltaStepX, deltaStepY]\n)\ntheCanvas.bitmap = theCanvasBitmap\n)\n\non MicroPaint_CanvasRollout lbuttondown pos do\n(\nlastPos = pos\nisDrawing = true</em> <em class=\"codeEmphasisStrong\">isErasing = false</em></pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-76DB\"></a>The isErasing flag is set to false whenever the user presses the left mouse button.\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63CB\"></a><pre><em class=\"codeEmphasisMild\">drawStroke lastPos pos\n)</em> <em class=\"codeEmphasisStrong\">on MicroPaint_CanvasRollout rbuttondown pos do\n(\nlastPos = pos\nisErasing = isDrawing = true\ndrawStroke lastPos pos\n)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2B0C\"></a>This new handler is called whenever the right mouse button is pressed. It is identical\n               to the left mouse button handler except for the isErasing flag that is set to true\n               this time. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63CA\"></a><pre><em class=\"codeEmphasisStrong\">on MicroPaint_CanvasRollout lbuttonup pos do isErasing = isDrawing = false\non MicroPaint_CanvasRollout rbuttonup pos do isErasing = isDrawing = false</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2B0F\"></a>The lbuttonup and the new rbuttonup handlers will stop drawing and erasing by setting\n               both the flags to false. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63C9\"></a><pre><em class=\"codeEmphasisMild\">on MicroPaint_CanvasRollout mousemove pos do\n(\nif isDrawing do drawStroke lastPos pos\nlastPos = pos\n)\n)\ncreateDialog MicroPaint_CanvasRollout (bitmapx+100) (bitmapy+30) menu:CanvasMenu\nMicroPaint_CanvasRollout.theCanvas.bitmap = theBackgroundBitmap\n)</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2B1B\"></a> <em class=\"strong\">Previous Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2B1C\"></a> <span class=\"char_link\"><a href=\"GUID-2A734060-09D6-44CE-A0B1-6E7094C03AC3.htm\">How To ... Develop a Bitmap Painting Tool - Load and Save</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2B1D\"></a> <em class=\"strong\">NextTutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2B1E\"></a> <span class=\"char_link\"><a href=\"GUID-8ECDE2E0-2C77-4191-9710-C527D95F763E.htm\">How To ... Develop a Bitmap Painting Tool - Unwrap UV Coordinates</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2B20\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";