var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-2AF2AFE0-1B22-4DA2-B0F9-CA3ADABCB6C6\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MAX File Asset Metadata Stream Access\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAX File Asset Metadata Stream Access</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2AF2AFE0-1B22-4DA2-B0F9-CA3ADABCB6C6\"></a><div class=\"head\">\n            <h1>MAX File Asset Metadata Stream Access </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2479\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2478\"></a> In \n               		  <em class=\"strong\">3ds Max 2010 and higher</em>, the \n               		  <em class=\"strong\">3ds Max scene file</em> provides \n               		  <em class=\"strong\">Asset Metadata</em> in a separate stream which can be accessed and modified by external applications.\n               The Asset data is generated and managed by the \n               		  <span class=\"char_link\"><a href=\"GUID-E3237B13-8069-4177-8544-9000A98B1C15.htm\">AssetManager</a></span> and \n               		  <span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-52AF\">AssetUser</a></span> objects. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2475\"></a>The \n               		  <em class=\"strong\">Asset Metadata</em> inside a saved \n               		  <em class=\"strong\">3ds Max scene file</em> can also be accessed by MAXScript using the following functions: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A73\"></a><pre><em class=\"codeEmphasisStrong\">getMAXFileAssetMetadata</em> &lt;filename&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2473\"></a>Returns an array of AssetMetadata_StructDef struct instances corresponding to assets\n               defined in the specified.MAXfile. \n               		\n            </p> \n            <p>For more information about how 3ds Max resolves the file specified by \n               		  <span class=\"code\">filename</span>, see \n               		  <span class=\"char_link\"><a href=\"GUID-624D3D05-B15D-4A97-9F15-DA35CDB0DDD2.htm#SECTION_78DCA28E50D6469096968F0AE49E1FAC\">Scene File Path Resolution</a></span> \n            </p> \n            <p><a name=\"GUID-7F51F39C-EBE5-48D8-8669-8CA1D7483093\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A72\"></a><pre><em class=\"codeEmphasisStrong\">setMAXFileAssetMetadata</em> &lt;filename&gt; &lt;array of AssetMetadata_StructDef instances&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2470\"></a>Updates the asset metadata defined in the specified.MAXfile. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-246F\"></a>If the asset ID for an existing asset is not found in the AssetMetadata_StructDef\n               struct instances, the asset is unchanged. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-246E\"></a>If an asset ID match is found, the asset types must be the same, otherwise a runtime\n               error will be generated. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-246C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-246B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A71\"></a><pre>\nscenefilename = @\"$scenes\\assetMetaDataRewriteTest.max\"\nfileassets = #()\n(\nresetmaxfile #noprompt\ngc()\nmyteapot = teapot material:(standard diffusemap:(bitmapTexture filename:@\"$maps[1]\\assetFile1.tga\") bumpmap:(bitmapTexture filename:@\"$maps[1]\\assetFile2.tga\"))\nprint \"material assets:\"\nformat \"%\\n\"myteapot.material.diffusemap.filename\nformat \"%\\n\"myteapot.material.bumpmap.filename\nformat \"\\n\"\nprint \"asset manager assets - presave:\"\nfor i = 1 to assetmanager.GetNumAssets() do\n(\nasset = assetmanager.GetAssetByIndex i\nformat \"% : % : % \\n\" (asset.GetAssetId()) (asset.GetFileName()) (asset.GetType()) \n)\nformat \"\\n\"\ngc light:true\nsavemaxfile scenefilename\nprint \"asset manager assets - postsave:\"\nfor i = 1 to assetmanager.GetNumAssets() do\n(\nasset = assetmanager.GetAssetByIndex i\nformat \"% : % : % \\n\" (asset.GetAssetId()) (asset.GetFileName()) (asset.GetType())\n)\nformat \"\\n\"\ngc light:true\nprint \"original scene file assets:\"\nfileassets = getMAXFileAssetMetadata scenefilename\nfor asset in fileassets do\nformat \"% : % : %\\n\" asset.assetId asset.FileName asset.Type\nformat \"\\n\"\ngc light:true\nfileassets[1].filename = \"assetFile3.tga\"\nsetMAXFileAssetMetadata scenefilename fileassets\nprint \"modified scene file assets:\"\nfileassets = getMAXFileAssetMetadata scenefilename\nfor asset in fileassets do\nformat \"% : % : %\\n\" asset.assetId asset.FileName asset.Type\nformat \"\\n\"\ngc light:true\nok\n)\n-- error tests\noldType = fileassets[1].type\nfileassets[1].type = #animation\nsetMAXFileAssetMetadata scenefilename fileassets\nfileassets[1].type = oldType\noldAssetId = fileassets[1].assetId\nfileassets[1].assetId = 123\nsetMAXFileAssetMetadata scenefilename fileassets\nfileassets[1].assetId = oldAssetId\noldAssetId = fileassets[1].assetId\nfileassets[1].assetId = \"123\"\nsetMAXFileAssetMetadata scenefilename fileassets\nfileassets[1].assetId = oldAssetId\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2424\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A70\"></a><pre>\n\"$scenes\\assetMetaDataRewriteTest.max\"\n#()\n\"material assets:\"\nC:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\assetFile1.tga\nC:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\assetFile2.tga\n\"asset manager assets - presave:\"\n{FFF11D6D-8F2A-417E-8D45-4FAC1B750C43} : C:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\assetFile2.tga : #bitmap\n{7647BFE7-3E18-480D-83BC-19F378C9E185} : C:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\assetFile1.tga : #bitmap\n{4316B891-0A3E-48A6-BACA-139E228E5899} : glare_streaks_star_camera_filter.tif : #other\n{38B4658B-2DB4-4145-9245-0FCDF7DCC711} : glare_streaks_star_camera_filter.tif : #bitmap\n{77E039AC-3830-4A55-BB7E-0B41BAFB488D} : Untitled Scene : #xref\n\"asset manager assets - postsave:\"\n{FFF11D6D-8F2A-417E-8D45-4FAC1B750C43} : C:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\assetFile2.tga : #bitmap\n{7647BFE7-3E18-480D-83BC-19F378C9E185} : C:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\assetFile1.tga : #bitmap\n{38B4658B-2DB4-4145-9245-0FCDF7DCC711} : glare_streaks_star_camera_filter.tif : #bitmap\n{14C3E0E5-219F-4E26-9831-0CF67D83B770} : C:\\Documents and Settings\\username\\My Documents\\3dsMax\\scenes\\assetMetaDataRewriteTest.max : #xref\n{0D502254-780D-405A-8B55-F52E720E43AD} : glare_streaks_star_camera_filter.tif : #other\n\"original scene file assets:\"\n{FFF11D6D-8F2A-417E-8D45-4FAC1B750C43} : C:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\assetFile2.tga : #bitmap\n{7647BFE7-3E18-480D-83BC-19F378C9E185} : C:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\assetFile1.tga : #bitmap\n{38B4658B-2DB4-4145-9245-0FCDF7DCC711} : glare_streaks_star_camera_filter.tif : #bitmap\n\"modified scene file assets:\"\n{FFF11D6D-8F2A-417E-8D45-4FAC1B750C43} : assetFile3.tga : #bitmap\n{7647BFE7-3E18-480D-83BC-19F378C9E185} : C:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\assetFile1.tga : #bitmap\n{38B4658B-2DB4-4145-9245-0FCDF7DCC711} : glare_streaks_star_camera_filter.tif : #bitmap\nOK\n#bitmap\n#animation\n-- Error occurred in anonymous codeblock; filename: C:\\Program Files\\Autodesk\\3ds Max 2010\\ui\\macroscripts\\; position: 1590; line: 56\n-- Runtime error: Incorrect asset type for assetId {38B4658B-2DB4-4145-9245-0FCDF7DCC711}; expecting: #Bitmap; got: #animation\n#bitmap\n\"{FFF11D6D-8F2A-417E-8D45-4FAC1B750C43}\"\n123\n-- Error occurred in anonymous codeblock; filename: C:\\Program Files\\Autodesk\\3ds Max 2010\\ui\\macroscripts\\; position: 1737; line: 61\n-- Unable to convert: 123 to type: String\n\"{FFF11D6D-8F2A-417E-8D45-4FAC1B750C43}\"\n\"{FFF11D6D-8F2A-417E-8D45-4FAC1B750C43}\"\n\"123\"\n-- Error occurred in anonymous codeblock; filename: C:\\Program Files\\Autodesk\\3ds Max 2010\\ui\\macroscripts\\; position: 1892; line: 66\n-- Runtime error: Cannot convert assetId string to assetId value: \"123\"\n\"{FFF11D6D-8F2A-417E-8D45-4FAC1B750C43}\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23F1\"></a> <span class=\"char_link\"><a href=\"GUID-E5D783F1-9108-4436-921C-D72BF7035866.htm\">Accessing AssetManager, AssetUser and Asset Metadata in MAX Files</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23EF\"></a> <span class=\"char_link\"><a href=\"GUID-E3237B13-8069-4177-8544-9000A98B1C15.htm\">Interface: AssetManager</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23EE\"></a> <span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm\">IObject:AssetUser</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23ED\"></a> <span class=\"char_link\"><a href=\"GUID-DFC564A3-A5E1-4398-AF50-3B4C91BB3358.htm\">Interface: FileResolutionManager</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"GUID-F3625196-9605-4F9D-B711-BEE1C465C1C7\"></a> <span class=\"char_link\"><a href=\"GUID-F693FDB5-1B1B-4A4D-9C48-ECF91272FD88.htm\">MAX File Version Access</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";