var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-2C5F5486-A171-43C1-9304-8A3D016BB0BD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Rollup Systems \'category\' Mechanism\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Rollout Systems \'category\' Mechanism</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2C5F5486-A171-43C1-9304-8A3D016BB0BD\"></a><div class=\"head\">\n            <h1>Rollout Systems \'category\' Mechanism </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66C3\"></a>You can control the grouping of rollout for a plug-in, utility or floater by supplying\n            a <span class=\"code\"> <em class=\"strong\">category:&lt;integer&gt;</em> </span> creation parameter before the opening parenthesis of the rollout body. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66C1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66C0\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-746E\"></a><pre>\nrollout rollout01 \"Rollout 01\" category:10\n(\n  button btn_pressme \"Press Me\"\n)\nrollout rollout02 \"Rollout 02\" category:1\n(\n  button btn_pressme \"Press Me\"\n)\nrollout rollout03 \"Rollout 03\" category:2\n(\n  button btn_pressme \"Press Me\"\n)\ntheFloater = newRolloutFloater \"Test\" 200 200\naddRollout rollout01 theFloater\naddRollout rollout02 theFloater\naddRollout rollout03 theFloater\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66AC\"></a><p class=\"table-body\">Note that although we added the rollouts in the order of their naming (rollout01,\n                        rollout02, rollout03), they appear in the floater in the order defined by the category\n                        - Category 1 first, then 2, then 10. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66AB\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-7890D9B4-EB55-49C4-8484-C53765FA04F7-low.gif\"></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66AA\"></a><p class=\"table-body\">The Floater does not allow dynamic reordering via the mouse, but scripted plugin rollouts\n                        shown in the modify tab of the command panel will participate in the rollout reordering\n                        system and can be reordered manually. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66A8\"></a>The category: keyword is a creation parameter and cannot be accessed as a property\n            of the rollout after the creation. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66A5\"></a> <span class=\"char_link\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">Rollout User-Interface Controls</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66A4\"></a> <span class=\"char_link\"><a href=\"GUID-E421933F-958E-42FD-80A1-D66F2A2C0A06.htm\">Rollout User-Interface Controls Types</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66A3\"></a> <span class=\"char_link\"><a href=\"GUID-3880D745-8496-4DFB-8B31-4DEAC152DBB3.htm\">Rollout User-Interface Controls Common Properties</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66A2\"></a> <span class=\"char_link\"><a href=\"GUID-FF0CBCCD-4968-41F0-8765-B41391BC2715.htm\">Customize The Order of Rollup Pages</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66A1\"></a> <span class=\"char_link\"><a href=\"GUID-CB8255AE-BA4C-42B2-A2E4-58BACCC98C1C.htm\">Interface: cmdPanel</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-66A0\"></a> <span class=\"char_link\"><a href=\"GUID-EA37E7DB-1E74-4377-B3D8-EDAE19CE27E7.htm\">Rollout User-Interface Controls Common Layout Parameters</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-669F\"></a> <span class=\"char_link\"><a href=\"GUID-C3EEFA6F-6132-445E-B256-083679CEC9CB.htm\">Visual MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";