var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-2C8D489B-28B7-4829-9C7D-448AE9ED61A6\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"parameter ranges for curves and surfaces\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Parameter Ranges for Curves and Surfaces</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2C8D489B-28B7-4829-9C7D-448AE9ED61A6\"></a><div class=\"head\">\n            <h1>Parameter Ranges for Curves and Surfaces </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48B6\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48B5\"></a> Methods that deal with points in the parameter space of a curve work with arguments\n               in U. Methods that deal with points in the parameter space of surfaces deal with arguments\n               in U and V. For example, setting the property <span class=\"code\"> <em class=\"strong\">&lt;NURBSSurfConstPoint&gt;.uParam</em> </span> sets the position of a dependent point in the parent surface\'s U parameter space.\n               The valid U and V values that may be passed to this method must be obtained by referencing\n               the <span class=\"code\"> <em class=\"strong\">&lt;NURBSSurface&gt;</em> </span> properties <span class=\"code\"> <em class=\"strong\">.uParameterRangeMin</em> </span>, <span class=\"code\"> <em class=\"strong\">.uParameterRangeMax</em> </span>, <span class=\"code\"> <em class=\"strong\">.vParameterRangeMin</em> </span>, and <span class=\"code\"> <em class=\"strong\">.vParameterRangeMax</em> </span> on the parent surface. This retrieves the minimum and maximum values for U and V\n               that may be used. For curves there are similar properties for getting the valid range\n               for U.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48B3\"></a>Developers should be aware that a curve or surface needs to be instantiated in the\n               <em class=\"strong\">3ds Max</em> data base before it is okay to call these methods (for example by calling <span class=\"code\"> <em class=\"strong\">NURBSNode()</em> </span>). Prior to the object existing in the data base these calls will fail.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48B2\"></a>Generally, when CV curves and surfaces are created, the valid parameter range is known\n               because they were specified in the beginning and ending knot values. In cases where\n               they are not known, one can instantiate a NURBSSet that has just the base curves or\n               surfaces. Once instantiated, the parameter range properties can be interrogated. Then\n               one can build the rest of the parametric model by making additions and/or modifications\n               to the already instantiated object. The node method <span class=\"code\"> <em class=\"strong\">addNURBSSet()</em> </span> makes this easy to do.\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";