var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-2CECA1ED-4A66-4D96-A8F8-3486378804D8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"SceneEffectLoader Interface\">\n      <meta name=\"indexterm\" content=\"Interface SceneEffectLoader\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: SceneEffectLoader</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2CECA1ED-4A66-4D96-A8F8-3486378804D8\"></a><div class=\"head\">\n            <h1>Interface: SceneEffectLoader </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7833\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7832\"></a><p class=\"table-body\">   <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; SceneEffectLoader \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7831\"></a>This Core Interface exposes<em class=\"strong\"> the Scene Effect Loader Utility </em>to MAXScript. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7830\"></a>Available in<em class=\"strong\"> 3ds Max 9 and higher.</em> \n         </p>\n         <p><a name=\"GUID-9FF41F1C-2563-45AA-A7EF-B1AE999F22E1\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-782F\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55BB\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">SceneEffectLoader.LoadSceneEffect </em>&lt;filename&gt;effectFile<em class=\"codeEmphasisStrong\"> effectType</em>:&lt;enum&gt; <em class=\"codeEmphasisStrong\">numberOfPasses</em>:&lt;integer&gt; 	 \n\neffectType enums: { <em class=\"codeEmphasisStrong\">#Post</em> | <em class=\"codeEmphasisStrong\">#Pre</em> | <em class=\"codeEmphasisStrong\">#Env</em>} 	 \neffectType default value: <em class=\"codeEmphasisStrong\">#Post</em> 	 \nnumberOfPasses default value: 0   </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-782E\"></a>Loads the specified effects file into the Scene Effect Loader. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-782D\"></a>Loads the specified file and registers it with the Scene Effect system. The system\n            maintains three lists: Post, Pre, and Env. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-782C\"></a><span class=\"code\"> <em class=\"strong\">#Post</em> </span> - The effect is applied at the end of the scene graph. For example, Sepia or edge\n            detect. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-782B\"></a><span class=\"code\"> <em class=\"strong\">#Pre</em> </span> - Runs before any geometry is rendered. Useful for background effects. Only the first\n            loaded pre-effect will be used. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-782A\"></a><span class=\"code\"> <em class=\"strong\">#Env</em> </span> - Environmental effects. These are run in a separate pass and generally create data\n            for object based shaders or shaders later on in the scene graph. For example, shadows\n            or depth info. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7829\"></a>To specify which list the effect belongs to, use the effectType: argument. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7828\"></a>The numberOfPasses: argumentis only used with Env type shaders. Environment shaders\n            must specify how many passes it requires to the system, for example, to create a cubemap,\n            the shader will need six passed. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7827\"></a>The lists are maintained in the order they are generated. This means that the effects\n            are run in the same order. So, if you want to reorganize the list, simply remove all\n            effects and apply them in the correct order. \n         </p>\n         <p><a name=\"GUID-3A1E59E4-22B9-4F49-8A20-F48BF95F4A09\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55B9\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">SceneEffectLoader.ResetEffects</em>() </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7826\"></a>Resets the Scene Effect Loader, removing all effects. \n         </p>\n         <p><a name=\"GUID-DBAD46A7-F338-4193-B288-D2E14ECA9A35\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55B8\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">SceneEffectLoader.EnableSceneEffects </em>&lt;bool&gt;enable </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7825\"></a>Enables or disables the Scene Effect Loader depending on the boolean argument. If\n            there are no \"post\" effects present, the system will not be enabled. There needs to\n            be at least one post effect for the system to be able to render. \n         </p>\n         <p><a name=\"GUID-2EA35E01-A6C8-4132-A092-1A898DD410BF\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55B7\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">SceneEffectLoader.IsSceneEffectsEnabled</em>() </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7824\"></a>Returns true if the Scene Effect Loader is enabled, false otherwise. \n         </p>\n         <p><a name=\"GUID-3ABC93C5-9FF7-4C62-B208-449363367B1C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55B6\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">SceneEffectLoader.GetNumberOfSceneEffects effectType</em>:&lt;enum&gt; \n\neffectType enums: { <em class=\"codeEmphasisStrong\">#Post</em> | <em class=\"codeEmphasisStrong\">#Pre</em> | <em class=\"codeEmphasisStrong\">#Env</em> } \neffectType default value: <em class=\"codeEmphasisStrong\">#Post</em> </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7823\"></a>Returns the number of scene effects currently loaded in the Scene Effect Loader. By\n            default, returns only Post Effects unless the effect type is specified explicitly.\n            \n         </p>\n         <p><a name=\"GUID-DF703F5D-406F-4BBF-83F4-C275AC7BE58C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55B4\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">SceneEffectLoader.RemoveSceneEffect</em> &lt;index&gt;index<em class=\"codeEmphasisStrong\"> effectType</em>:&lt;enum&gt; \n\neffectType enums: { <em class=\"codeEmphasisStrong\">#Post</em> | <em class=\"codeEmphasisStrong\">#Pre</em> | <em class=\"codeEmphasisStrong\">#Env</em> } \neffectType defaultvalue: <em class=\"codeEmphasisStrong\">#Post</em> </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7822\"></a>Removes the indexed scene effect from the Loader. By default, it affects the Post\n            Effects list. A different effect type can be specified to affect the corresponding\n            effects list. \n         </p>\n         <p><a name=\"GUID-2586F938-50D9-4749-9E2B-0EFE460F86EC\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55B2\"></a><pre>&lt;material&gt;<em class=\"codeEmphasisStrong\">SceneEffectLoader.GetSceneEffect</em> &lt;index&gt;index <em class=\"codeEmphasisStrong\">effectType</em>:&lt;enum&gt; \n\neffectType enums: { <em class=\"codeEmphasisStrong\">#Post</em> | <em class=\"codeEmphasisStrong\">#Pre</em> | <em class=\"codeEmphasisStrong\">#Env</em> } \neffectType default value:<em class=\"codeEmphasisStrong\"> #Post</em> </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7821\"></a>Returns a DirectX Shader material hosting the indexed effect from the specified effects\n            list. \n         </p>\n         <p><a name=\"GUID-C08FE295-4A9D-4C3D-9EB4-0F37747B135F\"></a>For example, if the Post list contains the effect post_corona.fx, calling this method\n            with index 1 will create a DirectX Shader with this fx file loaded, which can be assigned\n            to any slot of the Material Editor for tweaking or manipulated using MAXScript. \n         </p>\n         <div><a name=\"GUID-020DCBFE-0A20-4A95-A903-ACA60DA33C80\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>You can run the following example only if the Viewport driver is legacy Direct3D.\n               \n            </div>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7820\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-781F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-55B0\"></a><pre>\ntheFile = (GetDir #maxroot + \"maps\\\\fx\\\\scene\\\\post_corona.fx\") --the FX file\nSceneEffectLoader.LoadSceneEffect theFile --add the file to the Post list.\ntheShader = SceneEffectLoader.GetSceneEffect 1 --get the first Post effect\ntheShader.GlowCol = blue --set the glow color to blue\ntheShader.Bias = 8.0 --set the bias to 8\nmeditmaterials[1] = theShader --assign to MEdit slot 1 for manual tweaking\nSceneEffectLoader.EnableSceneEffects true --enable the scene effects\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";