var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-2E27412E-89E3-41F5-A4C2-B9E809255390\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I filter a string including empty entries?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2E27412E-89E3-41F5-A4C2-B9E809255390\"></a><div class=\"head\">\n            <h1>How do I filter a string including empty entries? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCB0\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCB2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCB3\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8BE\">MAXScript Values</a></span> &gt; How do I filter a string including empty entries? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div><a name=\"WS3ED54CBA79FF2E3D-3BC1F56812B783555D7-7D4E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCB7\"></a>In <em class=\"strong\">3ds Max 8 and higher</em>, a keyword parameter <em class=\"strong\">splitEmptyTokens:</em> can be passed to the <span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm#WS73099CC142F487553098682E12AC2FC2BC7-5FE5\">filterString</a></span> function to perform this kind of filtering. \n               </p> \n            </div>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCBA\"></a> \n            <h2><a name=\"GUID-BE1CCD23-F22E-45E8-AA31-4A5A7D199AF6\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCBB\"></a>The filterString function does not return empty entries. For example, if I am filtering\n               by tabs a string containing two tabs in a row, no empty entry will be returned. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCBC\"></a>For example, \n            </p> \n            <p><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5566\"></a> <span class=\"code\"> <em class=\"strong\">filterString \"One\\t\\tThree Four,,Five \"\"\\t, \"</em> </span> <span class=\"code\"> <em class=\"strong\">#(\"One\", \"Three\", \"Four\", \"Five\")</em> </span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCBF\"></a> \n            <h2><a name=\"GUID-F38FF11B-B90A-41C9-B937-71008967DC20\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCC0\"></a>The following scripted function behaves as requested. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCC1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCC2\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPTED FUNCTION:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6666\"></a><pre>\nfn filterString2 theString theDelimiters =\n(\n&nbsp;theTokens = #() --array of tokens to return\n&nbsp;ready = false\n&nbsp;while not ready do --repeat until no more delimiters can be found\n&nbsp;(\n&nbsp;&nbsp;ready = true --raise a flag that we are done\n&nbsp;&nbsp;thePosArray = #() --init. an array to hold possible split positions\n&nbsp;&nbsp;for i = 1 to theDelimiters.count do --go through all delimiters\n&nbsp;&nbsp;(\n&nbsp;&nbsp;&nbsp;checkPos = findString theString theDelimiters[i] --check if the delimiter is in the string\n&nbsp;&nbsp;&nbsp;if checkPos != undefined do append thePosArray checkPos --if it is, add to the split positions array\n&nbsp;&nbsp;) --end i loop&nbsp;\n&nbsp;&nbsp;if thePosArray.count &gt; 0 then --if the array has any splitpositions,\n&nbsp;&nbsp;(\n&nbsp;&nbsp;&nbsp;sort thePosArray --sort the array in ascending order\n&nbsp;&nbsp;&nbsp;checkPos = thePosArray[1] --grab the first position\n&nbsp;&nbsp;&nbsp;aToken = substring theString 1 (checkPos-1) --take the token from start to the split pos. - 1\n&nbsp;&nbsp;&nbsp;append theTokens aToken --add the token to the array of tokens\n&nbsp;&nbsp;&nbsp;theString = substring theString (checkPos+1) theString.count --remove the token and the delimiter from the string\n&nbsp;&nbsp;&nbsp;ready = false --lower the flag because we are not ready yet\n&nbsp;&nbsp;) --end if\n&nbsp;) --end while loop\n&nbsp;append theTokens theString --add what is left of the string to the array\n&nbsp;theTokens --return the array of tokens\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6665\"></a><pre>\nfilterString2 \"One\\t\\tThree,Four,,Five \" \"\\t,\"\n#(\"One\", \"\", \"Three\", \"Four\", \"\", \"Five \")\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6664\"></a><pre>\nfilterString2 \"One\\t\\tThree Four,,Five \" \"\\t, \"\n#(\"One\", \"\", \"Three\", \"Four\", \"\", \"Five\", \"\")\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCEB\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";