var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-2EBF67B3-7D0D-4649-80E4-A1D1D7E4C63E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface INodeGIProperties\">\n      <meta name=\"indexterm\" content=\"INodeGIProperties Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: INodeGIProperties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2EBF67B3-7D0D-4649-80E4-A1D1D7E4C63E\"></a><div class=\"head\">\n            <h1>Interface: INodeGIProperties </h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B5E\"></a>  This Node Interface exposes the node’s Global Illumination Properties. These properties\n            correspond to the UI controls found in the \"Adv. Lighting\" tab of the Object Properties\n            dialog in<em class=\"strong\"> 3ds Max 5 and higher.</em> \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A3673\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-13C0898B-41FA-4E60-A3F8-0375E250E159-low.gif\"></div>\n         <p><a name=\"GUID-5196749C-BA36-4A57-83C1-8196658081BE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B5B\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5343\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.isGIExcluded </em>: boolean : Read|Write 	 </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B5A\"></a>Corresponds to the<em class=\"strong\"> Exclude from Radiosity Processing</em> checkbox in the Object Properties &gt; Adv. Lighting tab \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B59\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Since hidden objects are NEVER considered by the radiosity processing, setting <span class=\"code\">.<em class=\"strong\">isGIExcluded </em></span>to <span class=\"code\"> <em class=\"strong\">false</em> </span> for hidden objects will have no practical effect on them - they will NOT be processed\n               unless unhidden! \n            </div>\n         </div>\n         <p><a name=\"GUID-585B98D9-A0CD-46ED-B24C-4188258BFF2B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5342\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.GIByLayer </em>: boolean : Read|Write   </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B57\"></a>Corresponds to the<em class=\"strong\"> By Layer / By Object </em>checkbutton in the Object Properties &gt; Adv. Lighting tab \n         </p>\n         <p><a name=\"GUID-6665FE01-E809-41CC-9A08-49F850030AA1\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B56\"></a> \n            <h2><a name=\"GUID-AD5B02B0-3F1A-406D-BCB2-BFED6A48399A\"></a>Adv.Lighting General Properties\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5341\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.isGIOccluder </em>: boolean : Read|Write   </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B55\"></a>Corresponds to the <em class=\"strong\">Cast Shadows</em> checkbox in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-50A4C3CC-DF5A-4C1C-888B-72E039B448CB\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5340\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.isGIReceiver </em>: boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B53\"></a>Corresponds to the <em class=\"strong\">Receive Illumination</em> checkbox in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-2B8862C5-8168-4A3A-83B1-163218E2CD8F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-533F\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">GIRayMult </em>: float : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B51\"></a>Corresponds to the<em class=\"strong\"> Num. Regathering Rays Multiplier </em>value in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-C3EFCFC1-B442-4CFD-B69A-4EA13918A465\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B4F\"></a> \n            <h2><a name=\"GUID-3B30708E-4837-4840-A5B5-266CD79AD813\"></a>Radiosity-only Properties\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-533E\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.isGIDiffuse </em>: boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B4E\"></a>Corresponds to the <em class=\"strong\">Diffuse (reflective &amp; translucent)</em> checkbox in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-E48660B5-D817-4086-B6AD-54326D330077\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-533D\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.isGISpecular </em>: boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B4C\"></a>Corresponds to the<em class=\"strong\"> Specular (reflective &amp; translucent)</em> checkbox in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-558E5A66-7B9E-4B00-90A1-69EB6F2CF6F2\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-533C\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.isGIExcludedFromRegather </em>: boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B4A\"></a>Corresponds to the<em class=\"strong\"> Exclude from Regathering</em> checkbox in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-EC7BD161-39AF-440C-8678-ACBBE48A22AB\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B48\"></a> \n            <h2><a name=\"GUID-A12A5065-B7D5-4458-9EA6-828AC9B0A0DF\"></a> <em class=\"strong\">Object Subdivision Settings</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-533B\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.GIUseGlobalMeshing</em> : boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B47\"></a>Corresponds to the<em class=\"strong\"> Use Global Subdivision Settings</em> checkbox in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-41BF2DE8-E3E5-489F-B582-5002D200F8EB\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-533A\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.GIMeshingEnabled</em> : boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B45\"></a>Corresponds to the<em class=\"strong\"> Subdivide checkbox</em> in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-80C0D479-C75E-41A3-BD6C-A293780316F4\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5339\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">GIUseAdaptiveSubdivision</em> : boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B43\"></a>Corresponds to the<em class=\"strong\"> Use Adaptive Subdivision</em> checkbox in the Object Properties &gt; Adv. Lighting tab. Available in<em class=\"strong\"> 3ds Max 8 and higher</em>. \n            </p> \n            <p><a name=\"GUID-9DBA174C-898D-4DCF-B93E-0BA659374BCA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B41\"></a> \n            <h2><a name=\"GUID-CA2C0CEF-E80A-4F1E-A705-23A3A7038451\"></a>Mesh Settings\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5338\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.GIMeshSize </em>: worldUnits : Read|Write|Validated by Range: 0.01 to 1e+009 </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B40\"></a>Corresponds to the<em class=\"strong\"> Max.Mesh Size </em>value in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-8826FE4F-D59C-4B56-A430-0FA31C1ED36D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5337\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">GIMinMeshSize </em>: float : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B3E\"></a>Corresponds to the<em class=\"strong\"> Min.Mesh Size</em> value in the Object Properties &gt; Adv. Lighting tab. Available in<em class=\"strong\"> 3ds Max 8 and higher</em>. \n            </p> \n            <p><a name=\"GUID-5ACBBE08-51D9-4C10-B76F-D2C29DC10779\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5336\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">GIContrastThreshold </em>: float : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B3C\"></a>Corresponds to the<em class=\"strong\"> Contrast Threshold</em> value in the Object Properties &gt; Adv. Lighting tab. Available in <em class=\"strong\">3ds Max 8 and higher</em>. \n            </p> \n            <p><a name=\"GUID-143A2B4A-D12D-4433-B905-D927046201AB\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5335\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">GIInitialMeshSize</em> : float : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B3A\"></a>Corresponds to the<em class=\"strong\"> Initial Mesh Size</em> value in the Object Properties &gt; Adv. Lighting tab. Available in<em class=\"strong\"> 3ds Max 8 and higher</em>. \n            </p> \n            <p><a name=\"GUID-686522F8-B515-4C88-A726-8D35F05C764C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5334\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.nbGIRefineSteps </em>: integer : Read|Write|Validated by Range: 0 to 65535 </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B38\"></a>Corresponds to the<em class=\"strong\"> Refine Iterations</em> value in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-B3EB1A1D-2D39-49E6-81DD-73F73D670E26\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5333\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.nbGIRefineStepsDone </em>: integer : Read|Write|Validated by Range: 0 to 65535 </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B36\"></a>Corresponds to the<em class=\"strong\"> Iterations Done </em>value in the Object Properties &gt; Adv. Lighting tab \n            </p> \n            <p><a name=\"GUID-6B96F511-7499-45D4-9BBD-3B4CAE4DDDAA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B35\"></a> \n            <h2><a name=\"GUID-AFEA6BF2-8697-4BAE-8C4B-FC0F71D9AAA9\"></a>Light Object Radiosity Properties\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5332\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.storeIllumToMesh </em>: boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B34\"></a>Corresponds to the<em class=\"strong\"> Store Direct Illumination in Mesh</em> checkbox in the Object Properties &gt; Adv. Lighting tab \n            </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B32\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B31\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5331\"></a><pre>\n--Create a box which is excluded from Radiosity Processing\nb = box isGIExcluded:true\n--&gt; $Box:Box01 @ [0.000000,0.000000,0.000000]\n--Include the box in Radiosity Processing again\nb.isGIExcluded = false\n--&gt; false\n--Uncheck the Receive Illumination property\nb.isGIReceiver = false\n--&gt; false\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-2C37EE96-C752-49E2-9224-66333BB66387\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B2E\"></a> <span class=\"char_link\"><a href=\"GUID-38A8EFE3-685B-41F8-9E36-5B6B5CEACC18.htm\">Node Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B2D\"></a> <span class=\"char_link\"><a href=\"GUID-8E5EC5CD-D6FF-4F20-BEDC-9B7B8BEA7EA4.htm\">Interface: SceneRadiosity</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B2C\"></a> <span class=\"char_link\"><a href=\"GUID-00AB0CFA-3190-4A28-A185-4774B684F6D8.htm\">General Node Properties</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";