var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-308EA213-59FA-4F1B-AF40-FC7E658F5DD2\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"transformation: scaling\">\n      <meta name=\"indexterm\" content=\"transformation: rotating\">\n      <meta name=\"indexterm\" content=\"transformation: moving\">\n      <meta name=\"indexterm\" content=\"scale()\">\n      <meta name=\"indexterm\" content=\"rotate()\">\n      <meta name=\"indexterm\" content=\"move()\">\n      <meta name=\"indexterm\" content=\"applying standard transformations\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Applying Standard Transformations</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-308EA213-59FA-4F1B-AF40-FC7E658F5DD2\"></a><div class=\"head\">\n            <h1>Applying Standard Transformations </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F6D\"></a>        \n         </p>\n         <div><a name=\"GUID-27F5C460-ABD3-4E45-BC20-ABD6D3A3F315\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This is a continuation of the <span class=\"char_link\"><a href=\"GUID-4C1D639F-0A2C-402D-A078-56D8A8DB4964.htm\">\"Manipulating The Box - First Steps in MAXScript\"</a></span> tutorial\'s previous lessons <span class=\"char_link\"><a href=\"GUID-208C9C90-45C4-4267-A161-0D9D59D44F4D.htm\">\"Drawing a Box with MAXScript\"</a></span> and <span class=\"char_link\"><a href=\"GUID-9C018FC7-3129-4352-AC95-F0BD5CFA867D.htm\">\"Modifying the Box\"</a></span>. It requires the variable <span class=\"code\">mybox</span> to be already defined and containing an instance of a Box primitive. If you are <em class=\"strong\">not </em>continuing directly from these previous lessons, you must at least evaluate the line\n               \n               <div class=\"codeBlock\"><pre>mybox = box()</pre></div>in order to apply the following examples to the <em class=\"strong\">3ds Max</em> scene. \n            </div>\n         </div>\n         <p><a name=\"GUID-4F982F80-1035-4B74-A931-3D7582E3A8D8\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-65D00646-E6FC-4CCE-8E4E-85B45FEC865C\"></a>Now that you know how to <span class=\"char_link\"><a href=\"GUID-208C9C90-45C4-4267-A161-0D9D59D44F4D.htm\">create</a></span> and <span class=\"char_link\"><a href=\"GUID-9C018FC7-3129-4352-AC95-F0BD5CFA867D.htm\">modify</a></span> the basic properties of a box, you need to learn how to apply the standard transformations\n            (move, scale, and rotate) to it. It is possible to designate position, size, and orientation\n            when the box is created; however, you can also carry out these operations after you\n            have created your object, just as you would in <em class=\"strong\">3ds Max</em>. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F75\"></a> \n            <h2><a name=\"GUID-7DD0D4B3-FFDD-4AB3-BA95-BC3974C4DB2A\"></a> <em class=\"strong\">Moving the Box</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F76\"></a>Moving an object in MAXScript is very simple: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5082\"></a><pre>\nmove name_obj [&lt;x,y,z&gt;]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F78\"></a>where name_objis the name of the object you want to move and <span class=\"code\">&lt;x,y,z&gt;</span> is the amount you want it to move. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F79\"></a>It is <em class=\"strong\">important to note </em>that you are not moving the object <em class=\"strong\">to</em><span class=\"code\"> &lt;x,y,z&gt;</span>, but <em class=\"strong\">by</em> the amounts <span class=\"code\">&lt;x,y,z&gt;</span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F7A\"></a>Therefore, if you apply the move function more than once, the object continues to\n               move. This is also true for the scale and rotate transforms. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F7B\"></a>This is in contrast to setting a property of an object. If you set the object position,\n               scale, and rotation properties several times, the object won’t change, assuming that\n               you assign the same value each time. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F7C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F7D\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5081\"></a><pre>\nmybox.pos = [10,0,0]\nmybox.pos = [10,0,0]\nmybox.pos = [10,0,0]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F84\"></a>will only change the position of your box after the first line is executed. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F85\"></a>The second and third lines do not affect the position of your box, as they do not\n               change the absolute position of the box: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F86\"></a>&nbsp;<img src=\"../images/GUID-09BD30C4-0FD2-46AE-80D9-F0105C1CBA3E-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F87\"></a>If you entered the above three commands, click <img src=\"../images/GUID-062EDDCE-D844-4382-A665-C8A36D8FFCDB-low.gif\">Undo three times to move the box back to its original position. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F89\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F8A\"></a><p class=\"table-body\"> <em class=\"strong\">ON THE OTHER HAND, ENTERING</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5080\"></a><pre>\nmove mybox [10,0,0]\nmove mybox [10,0,0]\nmove mybox [10,0,0]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F91\"></a>will move your box 30 units along the X-axis: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F92\"></a>&nbsp;<img src=\"../images/GUID-011EEED2-7DCA-4E8E-8497-6EC86DB62554-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F93\"></a>If you entered the above commands, click <img src=\"../images/GUID-062EDDCE-D844-4382-A665-C8A36D8FFCDB-low.gif\">Undo three times to move the box back to its original position. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F94\"></a> \n            <h2><a name=\"GUID-1ACCCC60-2A25-4850-A374-A5D1CC28F98C\"></a> <em class=\"strong\">Scaling the Box</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F95\"></a>Scaling is performed in a similar manner: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-507F\"></a><pre>\nscale name_obj [&lt;x,y,z&gt;]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F97\"></a>where <span class=\"code\">name_obj</span> is the name of the object and <span class=\"code\">&lt;x,y,z&gt;</span> is a 3D coordinate that corresponds to the amount you would like to scale the object\n               along the X, Y, and Z-axis, respectively. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F98\"></a>Again, the scale transformation is different from the scale object property. Setting\n               the object’s scale property (<span class=\"code\">name_obj.scale</span>= …) repeatedly with the same values will only scale the object the first time, but\n               applying the scale transformation repeatedly will continue to scale the object relatively\n               to the previous scale. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F99\"></a> \n            <h2><a name=\"GUID-8B64E6DC-1922-4A2F-82CA-9269C862EC03\"></a> <em class=\"strong\">Rotating the Box</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F9A\"></a>The rotate transformation is not as simple as the move and rotate transforms. In fact,\n               there are three ways to express rotation values in MAXScript: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F9B\"></a> <em class=\"strong\">[<span class=\"char_link\"><a href=\"GUID-87BB6468-79E2-4FA2-9BAB-42E427219C4F.htm\">Euler Angles</a></span>]</em>, <em class=\"strong\">[<span class=\"char_link\"><a href=\"GUID-C42F8CCE-CE31-49B4-9D5A-65C07D9F33FD.htm\">Quaternions</a></span> ]</em> and <em class=\"strong\">[<span class=\"char_link\"><a href=\"GUID-04D996CE-B03E-41D6-ADD4-E9A043A483B6.htm\">Angleaxis</a></span> ]</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F9C\"></a>This lesson will only consider Euler Angles. If you would like further information\n               on any of these transformations, see the MAXScript Reference. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F9D\"></a>To apply a rotation transform in MAXScript, you must first define the rotation as\n               a sort of <em class=\"mild\">rotation object</em>, and then apply the rotation object to the object you want to rotate. The rotation\n               object is defined in the following way: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-507E\"></a><pre>\nrot_obj = eulerangles x y z\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4F9F\"></a>whererot_objcan be any name and x,y, and z represent the amount you want to rotate\n               your object (in degrees) around the X, Y, and Z-axes, respectively. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FA0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FA1\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-507D\"></a><pre>\nrot_box = eulerangles 0 30 0\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FA5\"></a><p class=\"table-body\">creates an object called rot_box, which will rotate an object around the Y-axis by\n                           30 degrees. This rotation can be applied to your box in the following way: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-507C\"></a><pre>\nrotate mybox rot_box\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FAA\"></a>&nbsp;<img src=\"../images/GUID-9DD41A18-3F60-434E-A1EF-F1026777152F-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FAB\"></a>In fact, this rotation could be applied to any object by writing the same line as\n               above and replacing <span class=\"code\">mybox</span> with the name of the object you want to rotate. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FAC\"></a>If you entered the above commands, click <img src=\"../images/GUID-062EDDCE-D844-4382-A665-C8A36D8FFCDB-low.gif\">Undo to change the box back to its original orientation. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FAD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FAE\"></a><p class=\"table-body\"> <em class=\"strong\">IF YOU DESIGNATE ANGLES FOR MORE THAN ONE AXIS:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-507B\"></a><pre>\nrot_box2 = eulerangles 30 45 60\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FB3\"></a>The rotation is applied to an object, with the X-axis rotation occurring first, followed\n               by the Y-axis rotation, and then the Z-axis rotation. \n            </p> \n            <div><a name=\"WS3ED54CBA79FF2E3D-60A7FFE512B7835635C-7E57\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FB7\"></a>Moving, scaling, or rotating objects, or setting transform-related properties operates\n                     in the World Coordinate System, by default. If you want to perform these transformations\n                     in another coordinate system, see <span class=\"char_link\"><a href=\"GUID-6C7219CF-B9B7-4B18-A846-5522A9D970F3.htm\">Coordsys</a></span>. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FB9\"></a> <em class=\"strong\">Next Topic</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4FBA\"></a> <span class=\"char_link\"><a href=\"GUID-22A56B6C-CB64-49BA-8C15-0354378EB575.htm\">More Box Transformations</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";