var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-30E85745-916B-4D41-8618-B92465A414FC\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"HKey Values\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>HKey Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-30E85745-916B-4D41-8618-B92465A414FC\"></a><div class=\"head\">\n            <h1>HKey Values </h1>\n         </div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EE4\"></a>  <em class=\"strong\">HKey</em> class instances are used to access registry keys. \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EE2\"></a>Available in <em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span> . \n         </p>\n         <p><a name=\"GUID-42D51814-067D-4D51-847C-94669DF34A89\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EE1\"></a> \n            <h2><a name=\"GUID-C38A316C-433E-47C0-9523-BCB8F77F6DC8\"></a> <em class=\"strong\">Constructors</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50BC\"></a><pre><em class=\"codeEmphasisStrong\">HKey</em> &lt;HKey parentKey&gt; &lt;string keyName&gt; &lt;int writeAccess&gt; 	 </pre></div> \n            <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EDF\"></a>Opens existing subkey of parentKey. \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EDE\"></a>This constructor is not typically used, instead the method <span class=\"code\"> <em class=\"strong\">registry.openKey()</em> </span> is used. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EDD\"></a> \n            <h2><a name=\"GUID-6D1A286B-A343-46B7-89CA-71FE6B3800F5\"></a> <em class=\"strong\">Properties</em> \n            </h2> \n            <p><a name=\"GUID-2FEF8C44-EFD7-404B-9A34-6F75567682D1\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50BB\"></a><pre>&lt;HKey&gt;.<em class=\"codeEmphasisStrong\">parentKey</em>&nbsp;: HKey - read-only - parent HKey   </pre></div> \n            <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EDB\"></a>Contains the parent HKey of the sub key. \n            </p> \n            <p><a name=\"GUID-94874158-BC6C-4420-82E3-9FFC677CE963\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50BA\"></a><pre>&lt;HKey&gt;.<em class=\"codeEmphasisStrong\">name</em>&nbsp;&nbsp;: String - read-only - subKey name </pre></div> \n            <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ED9\"></a>Contains the name of the sub key. \n            </p> \n            <p><a name=\"GUID-61F54A42-6810-49EF-BF54-B15691AB9C76\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50B9\"></a><pre>&lt;HKey&gt;.<em class=\"codeEmphasisStrong\">accessRights</em>&nbsp;: Integer - read-only - access rights flags </pre></div> \n            <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ED7\"></a>Contains the access rights of the sub key (see tables below) \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ED6\"></a> <em class=\"strong\">writeAcces values are as follows (see platform SDK help file for more info):</em> \n            </p> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ED5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ED4\"></a><p class=\"table-body\"> <em class=\"strong\">STANDARD_RIGHTS_READ</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ED3\"></a><p class=\"table-body\">0x00020000 </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ED2\"></a><p class=\"table-body\"> <em class=\"strong\">STANDARD_RIGHTS_WRITE&nbsp;</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ED1\"></a><p class=\"table-body\">0x00020000 </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ED0\"></a><p class=\"table-body\"> <em class=\"strong\">STANDARD_RIGHTS_ALL</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ECF\"></a><p class=\"table-body\">0x001F0000 </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ECE\"></a><p class=\"table-body\"> <em class=\"strong\">KEY_QUERY_VALUE</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ECD\"></a><p class=\"table-body\">0x00000001 </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ECC\"></a><p class=\"table-body\"> <em class=\"strong\">KEY_SET_VALUE&nbsp;</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ECB\"></a><p class=\"table-body\">0x00000002 </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7ECA\"></a><p class=\"table-body\"> <em class=\"strong\">KEY_CREATE_SUB_KEY</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EC9\"></a><p class=\"table-body\">0x00000004 </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EC8\"></a><p class=\"table-body\"> <em class=\"strong\">KEY_ENUMERATE_SUB_KEYS</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EC7\"></a><p class=\"table-body\">0x00000008 </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EC6\"></a> <em class=\"strong\">writeAccess values for common access types are:</em> \n            </p> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EC5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EC4\"></a><p class=\"table-body\"> <em class=\"strong\">#readOnly</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EC3\"></a><p class=\"table-body\">0x00020019 </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EC2\"></a><p class=\"table-body\"> <em class=\"strong\">#writeOnly&nbsp;</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EC1\"></a><p class=\"table-body\">0x00020006 </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EC0\"></a><p class=\"table-body\"> <em class=\"strong\">#all&nbsp;</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EBF\"></a><p class=\"table-body\">0x000f003f </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EBE\"></a> <span class=\"char_link\"><a href=\"GUID-72CBE101-72C4-4416-AAC5-2EDD91A119AF.htm\">Registry Structure</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EBD\"></a> <span class=\"char_link\"><a href=\"GUID-D65AE3C0-0C12-4262-8807-B23CBED54508.htm\">Interaction With The Operating System</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";