var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-3191CEE3-9676-472E-BC00-ED8F3ACF746C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"View-Dependent Particle Resolution Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>View-Dependent Particle Resolution Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3191CEE3-9676-472E-BC00-ED8F3ACF746C\"></a><div class=\"head\">\n            <h1>View-Dependent Particle Resolution Example </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8490D\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8490E\"></a>The following example shows a possible way to control the resolution of particles\n            based on the distance to a camera. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8490F\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84910\"></a>Should be used in a <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator</a></span>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84911\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-0911BCD3-DBC1-4918-A907-7997206265F9-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84912\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84913\"></a>The script uses a Sphere primitive from the scene as the shape of every particle and\n            sets its segments based on the distance to a hard-coded camera $Camera001. As particles\n            get farther from the camera, they get less polygons. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84914\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-0AECEB5D-F4B0-4116-807E-09BA8F9A5BEE-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E84915\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84916\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E0F\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.useShape = true --Enable the Shape channel\npCont.usePosition = true --Enable the Position channel\npCont.useScale = true --Enable the Scale channel\n)\n--The Init handler is called on initialization.\n--In this case, it is used to define and, if necessary, create\n--the source of particle shapes\non Init pCont do\n(\n-- Get the shape source primitive by name.\n-- Use random name to avoid conflict with other objects in the scene\nglobal sph = $SphereDynamic2468975\n \n-- In case the object does not exist, create it\nif sph == undefined then\n(\nsph = Sphere()\n-- Give the object a unique name\nsph.name =\"SphereDynamic2468975\"\n-- Set the radius to one.\nsph.radius = 1.0\n-- Hide the Sphere\nhide sph\n)\n)\n \n--The Proceed handler contains the main script\n--applied to the Particles.\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to:\non Proceed pCont do\n(\n--If there is a camera named Camera001 in the scene...\nif $Camera001 != undefined then\n(\n--Get the current total particles count:\ncount = pCont.NumParticles()\n \n--Loop through all particles:\nfor i in 1 to count do \n(\n \n--Set the current particle index:\npCont.particleIndex = i \n \n--Modify the pre-created sphere with radius\n--based on the particle size:\nsph.radius = pCont.particleScale \n \n--Modify segments based on the distance to the camera\n--called $Camera01\n--At distance of 500.0 units the segments will be set to 2\n--At distance of 250.0 the segments will be 4, at 100 units 10 etc.\n--Change the function to get the desired falloff\nsph.segs = 1000.0/(length (pCont.particlePosition - $Camera01.pos))\n \n--Set the shape of the particle to the TriMesh of the Sphere\npCont.particleShape = sph.mesh\n)--end i loop\n)--end if\n)--end proceed\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84966\"></a> <span class=\"char_link\"><a href=\"GUID-BD5ADFE5-379A-40D5-8FA2-3EB9649F088B.htm\">Sphere : GeometryClass</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84967\"></a> <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84968\"></a> <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84969\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8496A\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";