var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-31C598AB-B3BE-4965-996E-0CD59C0EC018\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Point4 Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-31C598AB-B3BE-4965-996E-0CD59C0EC018\"></a><div class=\"head\">\n            <h1>Point4 Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D41\"></a>The \n            		<em class=\"strong\">Point4</em> class defines the characteristics of points in 4D space (for example RGBA color space).\n            \n            	 \n         </p>\n         <p><a name=\"P_C2B38CF5CC364C0AB269D0347108B240\"></a>These values contain 4 component floating point numbers and can be used to express\n            floating point color values where the components are the Red, Green, Blue and Alpha\n            values. \n            	 \n         </p>\n         <p><a name=\"P_BA3E7A09E3A74433AEB35066B9AD5246\"></a>Several Point4 controllers were also introduced to store animation of parameters containing\n            Point4 values. \n            	 \n         </p>\n         <p><a name=\"P_26C9B3F2D9814CDEBD541BA69969AEFE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D43\"></a> <em class=\"strong\">Literals</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F80\"></a><pre><em class=\"codeEmphasisStrong\">[</em>&lt;expr&gt;, &lt;expr&gt;, &lt;expr&gt;, &lt;expr&gt;<em class=\"codeEmphasisStrong\">]</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D45\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F7F\"></a><pre><em class=\"codeEmphasisStrong\">point4</em> &lt;x&gt; &lt;y&gt; &lt;z&gt; &lt;w&gt;\n&lt;color&gt; <em class=\"codeEmphasisStrong\">as point4</em></pre></div>\n         <p><a name=\"P_89D2806A305C4581ADD4B6C21EA53C95\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D48\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F7E\"></a><pre>&lt;point4&gt;.<em class=\"codeEmphasisStrong\">x</em>: Float --the x component\n&lt;point4&gt;.<em class=\"codeEmphasisStrong\">y</em>: Float --the y component\n&lt;point4&gt;.<em class=\"codeEmphasisStrong\">z</em>: Float --the z component\n&lt;point4&gt;.<em class=\"codeEmphasisStrong\">w</em>: Float --the w component</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D4D\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F7D\"></a><pre>&lt;point4&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;point4&gt;\n&lt;point4&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;point4&gt;\n&nbsp;\n&lt;point4&gt; <em class=\"codeEmphasisStrong\">+</em> &lt;point4_or_number&gt;\n&lt;point4&gt; <em class=\"codeEmphasisStrong\">-</em> &lt;point4_or_number&gt;\n&lt;point4&gt; <em class=\"codeEmphasisStrong\">*</em> &lt;point4_or_number&gt;\n&lt;point4&gt; <em class=\"codeEmphasisStrong\">/</em> &lt;point4_or_number&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D55\"></a>Standard vector arithmetic. \n            	 \n         </p>\n         <p><a name=\"P_BBB9A1C6AD4C49CFAE6D8CB7857490DD\"></a>If the second operand is a number, the operation is performed on each component of\n            the value. \n            	 \n         </p>\n         <p><a name=\"P_2C95A17682F24CCDA34F17D0FB553E83\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F7C\"></a><pre><em class=\"codeEmphasisStrong\">-</em> &lt;point4&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D58\"></a>Unary minus \n            	 \n         </p>\n         <p><a name=\"P_10A0DC930A0F490DA8EE04F8533510B5\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F7B\"></a><pre>&lt;point4&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;integer&gt;<em class=\"codeEmphasisStrong\">]</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D5B\"></a>Returns a component of the Point4 as a float. \n            	 \n         </p>\n         <p><a name=\"P_4862DDFAB48D42268E884A07303AD3DD\"></a>Valid range on the index is 1 to 4. \n            	 \n         </p>\n         <p><a name=\"P_75D6D3774FBF42AEB5DB4FA72E8A0330\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F7A\"></a><pre>&lt;point4&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;integer&gt;<em class=\"codeEmphasisStrong\">]</em> = &lt;float&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D5E\"></a>Sets a component of the Point4 to the float. \n            	 \n         </p>\n         <p><a name=\"P_AEC48A7EB95F402EB9C5D9CCBEEAA6EA\"></a>Valid range on the index is 1 to4. \n            	 \n         </p>\n         <p><a name=\"P_CF8DE30901E849A0B4345E9648030FEE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D5F\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F79\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;point4&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D61\"></a>Creates a new copy of the Point4 value. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D62\"></a>The new value contains a copy of the input Point4 value, and is independent of the\n            input Point4 value. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D63\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87D64\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F78\"></a><pre>\noldValue = Point4 1.0 2.0 3.0 4.0--define a Point4 value\n[1,2,3,4]\nnewValue1 = copy oldValue--create a copy of the value\n[1,2,3,4]\nnewValue2 = oldValue--variable newValue2 points at the same value!\n[1,2,3,4]\nnewValue2.x = 10.0--set the x component of the instance to 10\n10.0\nnewValue2--see the result\n[10,2,3,4]\noldValue--note that the original value was also changed!\n[10,2,3,4]\nnewValue1--but the copy was independent and did not change!\n[1,2,3,4]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F77\"></a><pre><em class=\"codeEmphasisStrong\">random</em> &lt;point4&gt; &lt;point4&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D77\"></a>Generates a pseudo-random point between the given points. \n            	 \n         </p>\n         <p><a name=\"P_A8981810006748C387D906D134A9FAD0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F76\"></a><pre><em class=\"codeEmphasisStrong\">length</em> &lt;point4&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D7A\"></a>Returns the length of the 4D vector. \n            	 \n         </p>\n         <p><a name=\"P_DB72CF13ACAC423E99A564009A14F0E3\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"CODEBLOCK_9A565D39CCE74B39BBEB463B3621E660\"></a><pre><em class=\"codeEmphasisStrong\">distance</em> &lt;point4&gt; &lt;point4&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D7D\"></a>Returns the distance between the points in 4D space. \n            	 \n         </p>\n         <p><a name=\"P_BC0EFC927BA54790BF49E29DC9FBD883\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F74\"></a><pre><em class=\"codeEmphasisStrong\">normalize</em> &lt;point4&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D80\"></a>Returns the \n            		<span class=\"code\"> point4 \n               		</span> value normalized such that the 4D vector length equals 1. \n            	 \n         </p>\n         <p><a name=\"P_898ADFBF1CEF47DB8E0ADA3C71F3FCA4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D83\"></a> <span class=\"char_link\"><a href=\"GUID-DC4992FA-05CC-4376-B1B5-666B9A00CBFF.htm\">Point2 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D84\"></a> <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D85\"></a> <span class=\"char_link\"><a href=\"GUID-6185357B-C725-4E04-9619-FA0A31F73525.htm\">Box2 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87D86\"></a> <span class=\"char_link\"><a href=\"GUID-5A117E26-3BA4-4C4C-A0C7-0F4190F9D50D.htm\">Ray Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";