var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-3226B145-9115-492A-960F-E74999B902E8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSCVCurve: NURBSCurveOnSurface\">\n      <meta name=\"indexterm\" content=\"NURBSCurveOnSurface - NURBSCVCurve\">\n      <meta name=\"indexterm\" content=\"NURBSCurve - NURBSObject\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSCurveOnSurface : NURBSCVCurve</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3226B145-9115-492A-960F-E74999B902E8\"></a><div class=\"head\">\n            <h1>NURBSCurveOnSurface : NURBSCVCurve </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4559\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4558\"></a>   This class defines a dependent Curve-on-Surface CV curve. These curves can be used\n               for trimming the surface they lie on. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4554\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21F0\"></a><pre><em class=\"codeEmphasisStrong\">NURBSCurveOnSurface</em> [&lt;property&gt;:&lt;val&gt;] [<em class=\"codeEmphasisStrong\">closed:</em>&lt;boolean&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4552\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               If <span class=\"code\"> <em class=\"strong\">closed:true</em> </span> is specified, the curve is created as a closed curve, otherwise it is an open curve.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21EF\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-454E\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21EE\"></a><pre>&lt;nurbscurveonsurface&gt;.<em class=\"codeEmphasisStrong\">parent</em>: integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-454C\"></a>The parent surface by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21ED\"></a><pre>&lt;nurbscurveonsurface&gt;.<em class=\"codeEmphasisStrong\">parentID</em>: integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4549\"></a>The parent surface by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21EC\"></a><pre>&lt;nurbscurveonsurface&gt;.<em class=\"codeEmphasisStrong\">trim</em>: boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4546\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, trims parent surface at the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21EB\"></a><pre>&lt;nurbscurveonsurface&gt;.<em class=\"codeEmphasisStrong\">flipTrim</em>: boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4543\"></a>The state of the trim flip toggle. This controls which portion of the surface is trimmed.\n               \n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F52\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4540\"></a>The values for CVs for a NURBSCurveOnSurface are values in the parameter space of\n                     the surface, not in 3D space. CV surfaces are normally parameterized from 0 to 1,\n                     so all the CV values should have values from 0 to 1. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-453F\"></a>Point surfaces are chord-length parameterized, which means that the CV parameter range\n                     is about the same as the size of the surface. In most cases, NURBSCurveOnSurfaces\n                     work better when point surfaces are used. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-453E\"></a>You may have problems generating NURBSCurveOnSurfaces on CV surfaces. NURBSPointCurveOnSurfaces\n                     on CV surfaces are typically easier to work with. \n                  </p> \n               </div>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-453B\"></a> <span class=\"char_link\"><a href=\"GUID-593123B8-0F17-4944-861E-57C9458BF61E.htm\">NURBSCVCurve</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-453A\"></a> <span class=\"char_link\"><a href=\"GUID-8CEABA20-9D21-4ED0-AA95-3749435D2104.htm\">NURBSCurve</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4539\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4538\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";