var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-340A20E5-B6B4-4C44-ABB8-D29D9EA10A77\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Integrator ProceedSynch Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Integrator ProceedSynch Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-340A20E5-B6B4-4C44-ABB8-D29D9EA10A77\"></a><div class=\"head\">\n            <h1>Integrator ProceedSynch Example </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C2C\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C2D\"></a>The following examples show the difference in particle position in two PF_Sources\n            using the Integrator Interface’s proceedSynch methods. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C2E\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C2F\"></a>These two sample scripts should be used inside of <span class=\"char_link\"><a href=\"GUID-096D9928-CFE6-4485-84D1-A38E0DC47660.htm\">Script_Test</a></span> actions. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C30\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C32\"></a>Create a PF_Source in the viewport. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C34\"></a>Open Particle View. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C36\"></a>Add a Script_Test action to the end of Event01. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C38\"></a>Clone the particle system but leave it at the exactly same position. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C3A\"></a>Change the color of the second particle system \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C3C\"></a>Load the first sample in the Script_Test of the first particle system. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C3E\"></a>Load the second sample in the Script_Test of the second particle system. \n               </p> \n            </li>\n         </ul><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C3F\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-47D77EC2-C7C7-4370-96DF-50F4F0D466F3-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C40\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C41\"></a>Allows the user to compare the effects of two ProceedSynch calls. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C42\"></a>The resulting positions of all particles will be printed to the Listener. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C44\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84C45\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 1</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E08\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.useTime = true --enable the Time channel\npCont.usePosition = true --enable the Position channel\n)\n \n--The Init handler is called on initialization.\n--It is not used in this case.\non Init pCont do\n(\n)\n \n--In the Proceed handler, we will call the ProceedSync method\n--of the integrator.\non Proceed pCont do\n(\nend = pCont.GetTimeEnd() as float\n_int = pCont.GetIntegrator()\ncount = pCont.NumParticles()\npCont_curr = pCont.GetParticleContainer()\n \nfor i in 1 to count do\n(\npCont.particleIndex = i\nif _int != undefined then\n_int.proceedSync pCont_curr (end/160) 0.0 false #{}\nformat \"p1.particle%=%\\n\" i (pCont.GetParticlePosition i)\n)\n)\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n)\n \n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C73\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84C74\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 2</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E07\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.useTime = true --enable the Time \nchannelpCont.usePosition = true --enable the Position channel\n)\n--The Init handler is called on initialization.\n--It is not used in this case.\non Init pCont do \n(\n)\n\non Proceed pCont do\n(\nend = pCont.GetTimeEnd()asfloat_int = pCont.GetIntegrator()\ncount = pCont.NumParticles()pCont_curr = pCont.GetParticleContainer()\n \nfor i in 1 to count do\n(\npCont.particleIndex = i\nif _int != undefined then\n_int.proceedSync pCont_curr (end/160) 0.5 false #{}\n-- Array version to try out:\n--_int.proceedASync pCont_curr #((end/160), (2*end/160), (3*end/160)) #(0.1, 0.2, 0.5) true #{1..3}\n \nformat \"p2.particle%=%\\n\" i (pCont.GetParticlePosition i)\n)\n)\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n)\n \n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C9A\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C9B\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";