var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-36BA05E8-2F9A-4761-8D9B-40E3BC6503BF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Control Constructs\">\n      <meta name=\"indexterm\" content=\"try expression\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"indexterm\" content=\"catch\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Try Expression</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-36BA05E8-2F9A-4761-8D9B-40E3BC6503BF\"></a><div class=\"head\">\n            <h1>Try Expression </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E872D2\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872D3\"></a>    MAXScript provides simple exception-handling with the \n               		  <span class=\"code\"> <em class=\"strong\">try</em> </span> expression, a simplified form of the C++ exception-handling scheme. \n               		\n            </p> \n            <p><a name=\"P_9614D87756EF4AF48CB6063F5C3DAE85\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">try</em> </span> expression lets you bracket a piece of code and catch any runtime errors. \n               		\n            </p> \n            <p><a name=\"P_093B0833D5BC470489C5471891FA6449\"></a>This allows you to respond appropriately or take corrective action, rather than let\n               MAXScript halt the execution of your script and print an error message. \n               		\n            </p> \n            <p><a name=\"P_89DF9F6726E244DA847F6AEB6C716E2A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872D8\"></a>The \n               		  <em class=\"strong\">syntax \n                  		  </em>for the \n               		  <span class=\"code\"> <em class=\"strong\">try</em> </span> expression is: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60A9\"></a><pre><em class=\"codeEmphasisStrong\">try</em> &lt;protected_expr&gt; <em class=\"codeEmphasisStrong\">catch</em> &lt;on_err_expr&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872DB\"></a>The \n               		  <span class=\"code\">&lt;protected_expr&gt;</span> is executed and any errors that occur are trapped and the \n               		  <span class=\"code\">&lt;on_err_expr&gt;</span> is executed. \n               		\n            </p> \n            <p><a name=\"P_4519859F06D44CEDBAE98FC0DF9DDA4D\"></a>If the \n               		  <span class=\"code\">&lt;protected_expr&gt;</span> is a block-expression, the block-expression stops executing at the point of the error.\n               \n               		\n            </p> \n            <p><a name=\"P_85987F4D8BE94A18B31B52AFA526C707\"></a>If there are no errors in the protected expression, the \n               		  <span class=\"code\">&lt;on_err_expr&gt;</span> is not executed. \n               		\n            </p> \n            <p><a name=\"P_91C01C27E2B945AB94C3451896639413\"></a>This is a very simple error-trapping scheme, but limited heavily by the fact that\n               you only get limited error codes or information about the error that occurred. See\n               \n               		  <span class=\"char_link\"><a href=\"GUID-36BA05E8-2F9A-4761-8D9B-40E3BC6503BF.htm#WS3ED54CBA79FF2E3D1E593B6612B78359E8F-706A\">getCurrentException()</a></span> below. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872DC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872DD\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60A8\"></a><pre>\nf = openFile \"foo.dat\"\ntry\nwhile not eof f do read_some_data f\ncatch\n(\nmessageBox \"bad data in foo.dat\"\nresults = undefined\n)\nclose f\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872EA\"></a>In this example, any errors in reading or processing the data in the \n               		  <span class=\"code\"> <em class=\"strong\">read_some_data()</em> </span> function are trapped, then a Message box is displayed and some clean-up is done.\n               \n               		\n            </p> \n            <p><a name=\"P_7824C7508AAE4478B6EE2C86726A6D02\"></a>This is a good example of a use for the simple error-trapping. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E872EB\"></a> \n            <h2><a name=\"GUID-ACC0170F-2182-48D0-AD97-64BCC8CE5B39\"></a> <em class=\"strong\">Throw</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872EC\"></a>There is also an associated function, \n               		  <span class=\"code\"> <em class=\"strong\">throw()</em> </span>, which can be used to generate your own runtime error and pass on an error you caught\n               when doing some interim clean-up, or do a non-local jump. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872ED\"></a>It has the form: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60A7\"></a><pre><em class=\"codeEmphasisStrong\">throw</em> &lt;error_message_string&gt; [ &lt;value&gt; ] [ debugBreak:&lt;bool&gt; ]\n<em class=\"codeEmphasisStrong\">throw</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872F1\"></a>If you have no intervening catches in your script, calling \n               		  <span class=\"code\"> <em class=\"strong\">throw()</em> </span> with error message arguments will cause a runtime error to be signaled and MAXScript\n               will report the error message using its standard error reporting. \n               		\n            </p> \n            <p><a name=\"P_82245A42E4264BACAA6DE56CD03173EE\"></a>The optional \n               		  <span class=\"code\">&lt;value&gt;</span> argument can be any value you want printed with the error message, perhaps the object\n               involved in the error. This argument can not be specified if the \n               		  <span class=\"code\"> <em class=\"strong\">throw</em> </span> is in the body of a \n               		  <span class=\"code\"> <em class=\"strong\">catch()</em> </span> and will generate a compile error if present. \n               		\n            </p> \n            <p>The optional \n               		  <span class=\"code\">debugBreak:&lt;bool&gt;</span> argument specifies whether to break and display the MAXScript Debugger window. The\n               default setting for this argument is set by the MAXScript Debugger configuration setting\n               \"Default Throw debugBreak:on\", which you can query with the \n               		  <span class=\"char_link\"><a href=\"GUID-B016FEF4-BE4C-40EB-887C-0752F97239F2.htm\">MXSDebugger.defaultBreakOnThrow</a></span> property. Note that even if specified as true, if the \"Allow Break On Throw\" option\n               is disabled for the debugger, the debugger will not display. You can query this setting\n               with the \n               		  <span class=\"char_link\"><a href=\"GUID-B016FEF4-BE4C-40EB-887C-0752F97239F2.htm\">MXSDebugger.allowBreakOnThrow</a></span> property. \n               		\n            </p> \n            <p><a name=\"P_467F6080FC554E52A8E8E1D5372CDA8D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872F2\"></a>If the \n               		  <span class=\"code\"> <em class=\"strong\">try</em> </span>/<span class=\"code\"> <em class=\"strong\">catch</em> </span> is within another \n               		  <span class=\"code\"> <em class=\"strong\">try</em> </span> expression, calling \n               		  <span class=\"code\"> <em class=\"strong\">throw()</em> </span> will cause the \n               		  <span class=\"code\"> <em class=\"strong\">catch</em> </span> expression associated with the outer \n               		  <span class=\"code\"> <em class=\"strong\">try</em> </span> expression to be executed. \n               		\n            </p> \n            <p><a name=\"P_12C81A3421CC4780B2202D54291B709A\"></a>If you have no intervening catches in your script, calling \n               		  <span class=\"code\"> <em class=\"strong\">throw()</em> </span> will cause MAXScript to continue running the script from just after the top-most\n               set of parenthesis surrounding the \n               		  <span class=\"code\"> <em class=\"strong\">try</em> </span>/<span class=\"code\"> <em class=\"strong\">catch</em> </span>, or will stop the currently running script if there are no parenthesis surrounding\n               the \n               		  <span class=\"code\"> <em class=\"strong\">try</em> </span>/<span class=\"code\"> <em class=\"strong\">catch</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E872F3\"></a>If you want to catch an error, perhaps to do some clean-up processing, and then pass\n               the error on to outer handlers or MAXScript for error reporting, you can call \n               		  <span class=\"code\"> <em class=\"strong\">throw()</em> </span> with \n               		  <em class=\"strong\">no</em> arguments. \n               		\n            </p> \n            <p><a name=\"P_0861C38B8A8449309584A2C40F601D2E\"></a>This throws the current error again and must \n               		  <em class=\"strong\">only</em> be done inside a \n               		  <span class=\"code\"> <em class=\"strong\">catch</em> </span> expression. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872F5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E872F6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60A6\"></a><pre>\ntry\n(\ni=10\ntry ( i.x=1 ) -- will generate a run-time error\ncatch\n(\nprint \"Bad Error\" -- error message printed\ntry (i.pos=[0,0,0]) -- will also generate a run-time error\ncatch (throw()) -- throw() will cause outer catch\n-- to execute\n)\n)\ncatch (print \"Really Bad Error Occurred\") -- error message printed\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-706A\"></a> \n            <h2><a name=\"GUID-DA966F08-0FFE-422A-BD64-5B7BC404EC95\"></a> Current Exception\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60A5\"></a><pre><em class=\"codeEmphasisStrong\">getCurrentException</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87309\"></a>This method returns the text of the current exception. \n               		\n            </p> \n            <p><a name=\"P_044A3203B5AC485FA2D172646BDF1940\"></a>It is only useful inside a catch statement - if used outside a catch, it will return\n               \'undefined\'. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8730A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8730B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60A4\"></a><pre>\ntry\n(\nthrow \"AAAAA\"\n)\ncatch\n(\nformat \"*** % ***\\n\" (getCurrentException())\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87316\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60A3\"></a><pre>\n*** -- Runtime error: AAAAA ***\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">hasCurrentExceptionStackTrace</em>()</pre></div> \n            <p> <em class=\"strong\">Available since 3ds Max 2017</em>: Returns true if a MAXScript stack trace is available. It is only useful inside a\n               catch statement - if used outside a catch, it will return false. It should always\n               return true within a catch. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">hasCurrentExceptionCallStack</em>()</pre></div> \n            <p> <em class=\"strong\">Available since 3ds Max 2017</em>: Returns true if a C++ stack trace is available. It is only useful inside a catch\n               statement - if used outside a catch, it will return false. Within a catch, it will\n               be true only if the exception that was caught was a system exception, such as an access\n               violation or an integer divide by 0. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">getCurrentExceptionStackTrace</em>()</pre></div> \n            <p> <em class=\"strong\">Available since 3ds Max 2017</em>: Returns the MAXScript stack trace as a string. It is only useful inside a catch\n               statement - if used outside a catch, it will return false. It should always return\n               true within a catch. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">getCurrentExceptionCallStack</em>()</pre></div> \n            <p> <em class=\"strong\">Available since 3ds Max 2017</em>: Returns the C++ stack trace captured at the time an exception was thrown, as a string.\n               It is only useful inside a catch statement - if used outside a catch, it will return\n               \'undefined\'. Within a catch, if the C++ stack trace was not captured, an empty string\n               is returned. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">CaptureCallStack</em> [<em class=\"codeEmphasisStrong\">skipFirstNStackLevels</em>:&lt;int&gt;]</pre></div> \n            <p> <em class=\"strong\">Available since 3ds Max 2017</em>: Captures the MAXScript call stack. The \n               		  <span class=\"code\">skipFirstNStackLevels</span> parameter defaults to 3 if not specified. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;string&gt; <em class=\"codeEmphasisStrong\">getErrorSourceFileName</em>()</pre></div> \n            <p> Available in \n               		  <em class=\"strong\">3ds Max 2018 and higher</em>: Returns offset where the error occurred, when called inside a catch statement. This\n               is the end of the expression being evaluated, including any comments. \n               		\n            </p> \n            <div><a name=\"GUID-4C03C3B1-9FD2-4123-8C55-FD2C64678DFA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This method is only useful inside a catch statement. If used outside a catch statement,\n                  it will return \n                  		  <span class=\"code\">undefined</span>. \n                  		\n               </div>\n            </div> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";