var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-36ED2106-3576-4AF8-B809-431AB3FD36DB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I change a property in multiple objects at once?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-36ED2106-3576-4AF8-B809-431AB3FD36DB\"></a><div class=\"head\">\n            <h1>How do I change a property in multiple objects at once? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCEE\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCF0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCF1\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8C7\">Accessing Object Properties</a></span> &gt; How do I change a property in multiple objects at once? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCF3\"></a>One of the most often used applications of MAXScript is the mass-changing of object\n            properties. This can save tremendous amounts of clicks and time. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-29E0\"></a><p class=\"list-intro\"><a name=\"WS3ED54CBA79FF2E3D-3BC1F56812B783555D7-7D37\"></a>To change a property in multiple objects, you need to:\n         </p>\n         <ol type=\"1\" start=\"1\">\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCF5\"></a>Get the correct objects to change \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCF6\"></a>Assign a value to the correct property \n               </p> \n            </li>\n         </ol>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCF7\"></a>The simplest situation imaginable is a selection of similar objects. For example,\n            a large number of sphere primitives. MAXScript lets you easily access the current\n            selection in the scene. In addition, an object property assignment is \"mappable\".\n            This means that MAXScript applies the value on the right side of the assignment operator\n            \'=\' to every single object in the selection automatically without the need of an explicit\n            MAXScript for loop. See <span class=\"char_link\"><a href=\"GUID-A5F09739-AA1A-4C15-9AA2-95565EF8EC65.htm\">What Are Mapped Operations in MAXScript?</a></span> for more details on mapped operations. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCF9\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCFA\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6663\"></a><pre>\n--&nbsp;select a large number of spheres in the scene with the mouse,\n--&nbsp;then change the radius of all selected objects to 10.0 units\n--&nbsp;by typing in the Listener:\nselection.radius = 10\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD02\"></a>In case you have selected some object that does not have a property called radius\n            such as, a Box primitive or some EditableMesh object, the above code causes an error:\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD03\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD04\"></a><p class=\"table-body\"> <em class=\"strong\">ERROR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6662\"></a><pre>\nselection.radius = 10\n--&nbsp;Unknown property: \"radius\" in $Box:Box01 @ [0. 000000, 0. 000000,0.000000]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD0A\"></a>In such a case, you need to make sure that the collection of objects is filtered by\n            your script before an assignment is made. See the <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">For Loop</a></span> topic for more information. A possible way is: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD0B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD0C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6661\"></a><pre>\n--&nbsp;select any number of objects in the scene with the mouse,\n--&nbsp;then change the radius of all objects that have a .radius property\n--&nbsp;by typing in the Listener:\nfor i inselection where hasProperty i \"radius\" do i.radius = 10\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD14\"></a>If you want to change the radius of any object in the scene that has such a property\n            instead of selecting objects manually, you can let MAXScript filter the scene for\n            you. This affects all Spheres, GeoSpheres, Cylinders, and so on, but ignores any Boxes\n            that do not have a \"radius\" property. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD15\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD16\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6660\"></a><pre>\n--&nbsp;Go through all geometry objects, filter those that have a .radius property\n--&nbsp;and change the radius to 10 units by typing in the Listener:\nfor i inGeometry where hasProperty i \"radius\" do i.radius = 10\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD1D\"></a>If you want to affect only the GeoSpheres in the scene and exclude all other classes,\n            you can check the class of the objects instead. In this case, you do not have to check\n            for a property named \"radius\" because any GeoSphere has this property. The <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm#WS73099CC142F487553098682E12AC2FC2BC7-3D36\">classOf</a></span> function returns the object\'s class, so you can compare it to the class you want\n            to affect. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD1E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD1F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-665F\"></a><pre>\n--&nbsp;Go through all geometry objects, filter the GeoSpheres\n--&nbsp;and change their radius to 10 units by typing in the Listener:\nfor i in Geometry where classOf i == GeoSphere do i.radius = 10\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD26\"></a>If you have no idea what the correct MAXScript name of a property is, you can either\n            consult this Help File or use the <span class=\"char_link\"><a href=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52.htm\">showProperties</a></span> inspector function in the Listener to print a list of all exposed object properties.\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD27\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD28\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-665E\"></a><pre>\n--&nbsp;Select a single sphere in the scene using the mouse and\n--&nbsp;type in the Listener:\nshowProperties $\n.smooth : boolean\n.radius : float\n.mapCoords : boolean\n.segs : integer\n.slice : boolean\n.hemisphere : float\n.sliceFrom : angle\n.sliceTo : angle\n.chop : integer\n.recenter : boolean\nfalse\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD3A\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";