var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Control Constructs\">\n      <meta name=\"indexterm\" content=\"for loop\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>For Loop</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F\"></a><div class=\"head\">\n            <h1>For Loop </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E8722F\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87230\"></a>   The <span class=\"code\"> <em class=\"strong\">for</em> </span> loop iterates through a range of numbers, time values, or a sequenced collection\n               of values such as, an array or object set. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87234\"></a>The syntax for the <span class=\"code\"> <em class=\"strong\">for</em> </span> loop is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60B8\"></a><pre><em class=\"codeEmphasisStrong\">for</em> &lt;var_name&gt; ( <em class=\"codeEmphasisStrong\">in</em> | <em class=\"codeEmphasisStrong\">=</em> )&lt;sequence&gt; ( <em class=\"codeEmphasisStrong\">do</em> | <em class=\"codeEmphasisStrong\">collect</em> ) &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87236\"></a>where <span class=\"code\">&lt;var_name&gt;</span> is the name of the loop index variable that holds the loop value, and <span class=\"code\">&lt;sequence&gt;</span> is the source of values for the loop. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87237\"></a>The <span class=\"code\"> &lt;sequence&gt; </span> can be one of the following: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60B7\"></a><pre>&lt;expr&gt; <em class=\"codeEmphasisStrong\">to</em> &lt;expr&gt; [ <em class=\"codeEmphasisStrong\">by</em> &lt;expr&gt; ] [<em class=\"codeEmphasisStrong\">while</em> &lt;expr&gt;] [<em class=\"codeEmphasisStrong\">where</em> &lt;expr&gt; ]\n&lt;expr&gt; [<em class=\"codeEmphasisStrong\">while</em> &lt;expr&gt;] [ <em class=\"codeEmphasisStrong\">where</em>&lt;expr&gt; ]</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60B6\"></a><pre>&lt;expr&gt; <em class=\"codeEmphasisStrong\">to</em> &lt;expr&gt; [ <em class=\"codeEmphasisStrong\">by</em> &lt;expr&gt; ] [<em class=\"codeEmphasisStrong\">where</em> &lt;expr&gt; ]\n&lt;expr&gt; [<em class=\"codeEmphasisStrong\">where</em> &lt;expr&gt;]</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8723E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8723F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60B5\"></a><pre>for i = 1 to 10 do print i -- sequence numbers</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60B4\"></a><pre>for item in table1 do x = x + item.height -- sequence an array</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60B3\"></a><pre>for t in 0f to 100f by 5f do sliderTime=t -- sequence time (given as frames, here)</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60B2\"></a><pre>bigones = for obj in $box* -- you can sequence pathnames!\nwhere obj.height &gt; 100 collect obj -- collect the big boxes into an array</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8724E\"></a>The first <span class=\"code\">&lt;sequence&gt;</span> form is the standard number loop, the first <span class=\"code\">&lt;expr&gt;</span> value is the start value, the <span class=\"code\"><em class=\"strong\">to</em> &lt;expr&gt;</span> value is the limit value and the optional <span class=\"code\"><em class=\"strong\">by</em> &lt;expr&gt;</span> value is the loop value increment. The allowable value types are <em class=\"strong\">integer</em>, <em class=\"strong\">float</em>, and <em class=\"strong\">time</em>. If the <span class=\"code\"> <em class=\"strong\">by</em> </span> value is not given, it defaults to 1. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87250\"></a>The second form of <span class=\"code\">&lt;sequence&gt;</span> takes a sequencable collection such as, an <span class=\"char_link\"><a href=\"GUID-F44E766A-34AA-4F90-9776-E8A1C4D7CF33.htm\">array</a></span> or <span class=\"char_link\"><a href=\"GUID-77CB1890-C949-43AC-B1E9-B37F97B6712D.htm\">ObjectSet</a></span>, and iterates through all its values assigning successive elements in the collection\n               to the loop value each time through the loop. MAXScript contains several sequence\n               collections including <span class=\"char_link\"><a href=\"GUID-47B0A7AE-5401-4E92-BB47-F12C5B4E93D7.htm\">PathName values</a></span>, the current selection set, the children of a node, and the stack of modifiers on\n               an object. See also <span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collections</a></span> for caveats when using a collection in a <span class=\"code\"> <em class=\"strong\">for</em> </span> loop. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87252\"></a>If an optional <span class=\"code\"><em class=\"strong\">while</em> &lt;expr&gt;</span> test is specified, the <span class=\"code\"> <em class=\"strong\">for</em> </span> loop terminates if the test evaluates to <span class=\"code\"> <em class=\"strong\">false</em> </span>. The <span class=\"code\"> <em class=\"strong\">while</em> </span> test expression must evaluate to a boolean (<span class=\"code\"> <em class=\"strong\">true</em> </span>/<span class=\"code\"> <em class=\"strong\">false</em> </span>). \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87253\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87254\"></a><p class=\"table-body\"> <em class=\"strong\">PERFORMANCE WARNING</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87255\"></a><p class=\"table-body\">Breaking out of a loop using an <span class=\"code\"> <em class=\"strong\">exit</em> </span> construct is implemented internally using try/catch, which is <em class=\"strong\">extremely slow</em>. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87256\"></a><p class=\"table-body\">This is why the use of the <span class=\"code\"> <em class=\"strong\">while</em> </span> test is recommended over the use of <span class=\"code\"> <em class=\"strong\">exit</em> </span> for performance reasons. The <span class=\"code\"> <em class=\"strong\">while</em> </span> expression is evaluated before the <span class=\"code\"> <em class=\"strong\">where</em> </span> expression. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87259\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8725A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60B1\"></a><pre>\nfunction findByClass _obj _className =\n(\nlocal notFound = true\nlocal res = 0\nlocal searchName = _className as name\nfor i = 1 to _obj.NumBakeElements() while notFound do\n(\nlocal myElement = _obj.GetBakeElement i\nif myElement.enabled do\n(\nlocal eleName = (classof myElement as string) as name\nif eleName == searchName do\n(\nres = i\nnotFound = false\n)\n)\n)\nreturn res\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87272\"></a>Each <span class=\"code\">&lt;sequence&gt;</span> source form takes an optional <span class=\"code\"><em class=\"strong\">where</em> &lt;expr&gt;</span> that must evaluate to <span class=\"code\"> <em class=\"strong\">true</em> </span> or <span class=\"code\"> <em class=\"strong\">false</em> </span>. The <span class=\"code\"> <em class=\"strong\">where</em> </span> expression is evaluated at the beginning of each loop and only executes the loop\n               body for that loop value if the <span class=\"code\"> <em class=\"strong\">where</em> </span> expression is <span class=\"code\"> <em class=\"strong\">true</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87273\"></a>The <span class=\"code\"><em class=\"strong\">do</em> &lt;expr&gt;</span> form simply evaluates the body expression once for each value in the sequence. The\n               loop variable is visible to the code in the body expression as though it was declared\n               locally and initialized to the successive loop values each time. When the <span class=\"code\"><em class=\"strong\">do</em> &lt;expr&gt;</span> form of a <span class=\"code\"> <em class=\"strong\">for</em> </span> loop is used as an expression, its return value is always <span class=\"code\"> <em class=\"strong\">OK</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87274\"></a>The <span class=\"code\"> <em class=\"strong\">collect &lt;expr&gt;</em> </span> form gathers the expression values from the loop iterations and stores them in an\n               array, which is then yielded as the value of the overall <span class=\"code\"> <em class=\"strong\">for</em> </span> loop. For example, this is a good way to gather procedural selections of objects\n               from a scene. If the <span class=\"code\"> <em class=\"strong\">where</em> </span> expression is used with the <span class=\"code\"> <em class=\"strong\">collect</em> </span> form of the <span class=\"code\"> <em class=\"strong\">for</em> </span> loop, only the values from those iterations for which the <span class=\"code\"> <em class=\"strong\">where</em> </span> expression is <span class=\"code\"> <em class=\"strong\">true</em> </span> are collected. This can be used to collect a filtered sub-set of the iterated values.\n               You can also achieve this collection filtering in a <span class=\"code\"> <em class=\"strong\">for</em> </span> loop that does not use a <span class=\"code\"> <em class=\"strong\">where</em> </span> expression by yielding the special value <span class=\"code\"> <em class=\"strong\">dontCollect</em> </span> for those iterations that must not be added to the collection. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87275\"></a>As described in <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span>, a <span class=\"code\"> <em class=\"strong\">for</em> </span> loop creates a new scope context. The <span class=\"code\"> <em class=\"strong\">for</em> </span> loop index variable\'s scope is always the extent of the <span class=\"code\"> <em class=\"strong\">for</em> </span> loop, even if another variable of the same name already exists. Once the <span class=\"code\"> <em class=\"strong\">for</em> </span> loop exits, the <span class=\"code\"> <em class=\"strong\">for</em> </span> loop index variable is no longer accessible. The scope of any variables created in\n               a <span class=\"code\"> <em class=\"strong\">for</em> </span> loop is always the extent of the <span class=\"code\"> <em class=\"strong\">for</em> </span> loop. This is shown in the following example: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87277\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87278\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60B0\"></a><pre>\nobj=box()\navg_pos=[0,0,0]\noffset_pos=[100,100,0]\n-- new for loop index variable obj created even though\n-- a variable named obj already exists, scope is for loop\nfor obj in $* do\n(\n-- new variable pos created, scope is for\n-- loop offset_pos already exists outside\n-- for loop, its value will be used\npos=obj.pos-offset_pos\n-- avg_pos already exists outside for loop,\n-- its value will be used for loop index since variable\n-- obj goes out of scope\navg_pos += pos\n)\navg_pos /= $*.count\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8728E\"></a> <span class=\"char_link\"><a href=\"GUID-C6E64837-C873-4895-A5CF-FA1A5055CEF8.htm\">Skipping Loop Iterations</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8728F\"></a> <span class=\"char_link\"><a href=\"GUID-A3807B0D-F4E0-49B1-807A-8B582A30DFA4.htm\">Loop Exit</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";