var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-3792EE10-B44E-4E2C-822F-94CC0B4BB0C1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Age Test in Script Test Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Age Test in Script Test Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3792EE10-B44E-4E2C-822F-94CC0B4BB0C1\"></a><div class=\"head\">\n            <h1>Age Test in Script Test Example </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BAD\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BAE\"></a>The following example shows the access to the Proceed methods of an Age Test from\n            the Proceed hander of a Script Test. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BAF\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BB0\"></a>Should be used inside a <span class=\"char_link\"><a href=\"GUID-096D9928-CFE6-4485-84D1-A38E0DC47660.htm\">Script_Test : Helper</a></span> to access an <span class=\"char_link\"><a href=\"GUID-9D2E3BF3-A1AF-4200-AF42-0C38FF3FD799.htm\">Age_Test : Helper</a></span> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BB1\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-5751034D-732F-4CDA-8F14-814F05B6BA84-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BB2\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BB3\"></a>In the Init hander, the Script_Test creates a unqiue Age Test action or accesses an\n            existing one if already created before. It then calls the Proceed methods of the Age\n            Test to acquire its test results. Then it takes only the particles that have not passed\n            the Age Test and checks them against a spherical volume. Those that fall inside the\n            volume pass the Script Test, too. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BB4\"></a>The particles that tested True are passed to a second Event which stops them. The\n            final result is that all particles either stop because they are too old, or stop because\n            they have entered the spherical volume. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BB5\"></a>In the sample scene, a Sphere with radius 20 represents the spherical volume tested\n            by the script. The particles either rest on the surface of the sphere, or have passed\n            it and have stopped because of their age outside the sphere. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BB6\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-0B1E53A6-F685-4C24-B5A0-F66E5A524D55-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E84BB7\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84BB8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E09\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.useTime = true --enable the Time channel\npCont.usePosition = true --enable the Position channel\npCont.useAge = true --enable the Age channel\n)\n \n--The Init handler is called on initialization.\n--In this case, it is used to create the Age Test if it does not\n--exist yet, or get the existing one.\non Init pCont do\n(\nglobal ageT\n \n--If the unique object does not exist yet\nif $ageTest77777 == undefined then\n(\n--Disable automatic event encapsulation\nparticleFlow.BeginEdit()\n--Create a new Age Test\nageT = Age_Test()\n--Give it a unique name! If you are reusing the code\n--multiple times, change the number to have a unique ID\nageT.name =\"ageTest77777\"\n--Disable editing mode, enable auto-encapsulation\nparticleFlow.EndEdit()\n--Set the Age Test value to 1600 ticks, no variation\nageT.Test_Value = 1600\nageT.Variation = 0\n)\nelse\nageT = $ageTest77777--if the object exists, get it\n)--end init handler\n--In the Proceed handler, the Script Test calls the Proceed methods\n--of the Age Test to acquire its results and then checks the\n--the particles that have not passed the Age Test against\n--a spherical volume\non Proceed pCont do\n(\n--Get the current number of particles\ncount = pCont.NumParticles()\n \n--Get the exact start and end time\nt_start = pCont.GetTimeStart() as time\nt_end = pCont.GetTimeEnd() as time\nt_start_frac = (pCont.GetTimeStart() as float) - (t_start as integer)\nt_end_frac = (pCont.GetTimeEnd() as float) - (t_end as integer)\n \n--Initialize a BitArray to store results\ntestResult = #{}\n \n--Initialize an Array to store test times\ntestTime = #()\n \n--Call the ProceedStep1 method of the Age Test\nageT.proceedStep1 (pCont.GetParticleContainer()) (pCont.GetParticleSystem()) (pCont.getParticleSystemNode()) (pCont.getActionNode()) (pCont.getIntegrator())\n \n--Call the ProceedStep2 method of the Age Test\n--The results will be returned in the by-reference variables\nageT.proceedStep2 t_start t_start_frac &amp;t_end &amp;t_end_frac &amp;testResult &amp;testTime\n \n--If the particle system is not undefined\nif pCont.GetParticleSystem() != undefined then\n(\n--Go through all particles\nfor i in 1 to count do\n(\n--If the i-th particle passed the Age Test\nif (testResult[i]) then\n(\n \n--Set the current particle index\npCont.particleIndex = i\n--Set the particle’s test status to true\npCont.particleTestStatus = true\n--Set the particle’s Test time to the one returned by the\n--Age Test\npCont.setParticleTestTimePrecise i t_start testTime[i]\n)\nelse\n(\n--Set the current particle index\npCont.particleIndex = i\n--Any particles inside a sphere with radius 20\n--satisfy the test\nif length(pCont.particlePosition) &lt; 20 then\n(\n--Tell the particle it passed the test\npCont.particleTestStatus = true\n--And set the test time to the current particle time\npCont.particleTestTime = pCont.particleTime\n)\n)\n)\n)\n)\n \non Release pCont do\n(\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C27\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84C28\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";