var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-37CB6A37-B1D9-41F5-AD94-C196E76A729C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ActiveX Control Properties\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ActiveX Control Properties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-37CB6A37-B1D9-41F5-AD94-C196E76A729C\"></a><div class=\"head\">\n            <h1>ActiveX Control Properties </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C8C\"></a> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75B9\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C86\"></a> <img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\"> ActiveX Controls have been deprecated by Microsoft in the latest versions of the\n                     Windows operating system in favor of the <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet</a></span> framework and its controls. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C85\"></a>While MAXScript still supports ActiveX controls, these have to be installed and registered\n                     on the system to be accessible to MAXScript. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C84\"></a>As a replacement of ActiveX controls, MAXScript supports <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet controls</a></span> in <em class=\"strong\">3ds Max 9 and higher</em>. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C81\"></a>There are two common properties for ActiveX controls, <span class=\"code\"> <em class=\"strong\">.pos</em> </span> and <span class=\"code\"> <em class=\"strong\">.size</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C80\"></a>Other ActiveX properties are control specific and vary from one control to another.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C7F\"></a>For a list of all available properties except the two common properties listed above,\n               you can use the ActiveX Control Inspector Function \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7136\"></a><pre><em class=\"codeEmphasisStrong\">showProperties </em>&lt;axControl&gt;\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C7C\"></a>Properties can be set as usual in MAXScript, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C7B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7135\"></a><pre>ax<em class=\"codeEmphasisStrong\">.checkboxes</em>= true</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C76\"></a>where <span class=\"code\"> <em class=\"strong\">ax</em> </span> is the control name and <span class=\"code\"> <em class=\"strong\">.checkboxes</em> </span> is a boolean property. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C75\"></a>Additionally, there is support for color properties. The internal representation of\n               colors for ActiveX controls is COLORREF(unsigned integer) so you will always get integers\n               when reading them, but you can set them as follows: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C74\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7134\"></a><pre>ax<em class=\"codeEmphasisStrong\">.forecolor =</em>red -- if a .forecolor property exists</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75B8\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Colors in Microsoft Windows are represented as BGR instead of RGB values. Thus the\n                  above example will result in the foreground color to be <em class=\"strong\">BLUE</em> and not <em class=\"strong\">RED</em>. To specify the correct color, you can use a MAXScript color value and turn the order\n                  of the blue and red channels manually, or define a function to do so automatically,\n                  \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C6B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C6A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7133\"></a><pre>\nfn activeXColortheColor = (color theColor.b theColor.g theColor.r)\nax.forecolor = activeXColor red\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C63\"></a> <span class=\"char_link\"><a href=\"GUID-A81EA1A3-BE58-4A69-BB30-474F805D5E81.htm\">Active X Inspector Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C62\"></a> <span class=\"char_link\"><a href=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA.htm\">ActiveX Controls in MAXScript Rollouts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";