var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-3880D745-8496-4DFB-8B31-4DEAC152DBB3\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Rollout user-interface controls\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Rollout User-Interface Controls Common Properties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3880D745-8496-4DFB-8B31-4DEAC152DBB3\"></a><div class=\"head\">\n            <h1>Rollout User-Interface Controls Common Properties </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6661\"></a>All defined user-interface controls have a local variable constructed for them in\n            the rollout and a value representing the control is placed in that variable. These\n            values typically contain state information relevant to the item, such as if a check\n            box is checked, the current spinner value, the items in a list box, and so on. This\n            information is made available to you as various named properties on the item values.\n            You use standard MAXScript property access to read and set these values, \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6660\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"50%\">\n                  <col width=\"50%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-665F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\">&nbsp;</td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7468\"></a><pre>\nfrab_x.enabled = true\n</pre></div> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-665C\"></a><p class=\"table-body\">enable the <span class=\"code\"> <em class=\"strong\">frab_x</em> </span> spinner \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7467\"></a><pre>\nfoo.text = \"Don\'t do it\"\n</pre></div> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6659\"></a><p class=\"table-body\">set <span class=\"code\"> <em class=\"strong\">foo</em> </span> button text \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7466\"></a><pre>\nfirst_item = baz.items[1]\n</pre></div> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F4875525E8C7E5129B19AABD9-78DE\"></a><p class=\"table-body\">get item list from listbox <span class=\"code\"> <em class=\"strong\">baz</em> </span> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7465\"></a><pre>\n$bar.pos.x = x_spinner.value\n</pre></div> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F4875525E8C7E5129B19AABD9-78DD\"></a><p class=\"table-body\">get current value from spinner <span class=\"code\"> <em class=\"strong\">x_spinner</em> </span> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6651\"></a>All of the user-interface common properties except for <span class=\"code\"> <em class=\"strong\">caption</em> </span> (the label string value is used as the caption) can be specified as parameters when\n            the user-interface item is constructed. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-664F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-664E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7464\"></a><pre>\nbutton foo \"You Cannot Press Me!\" enabled:false\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-664A\"></a> \n            <h2><a name=\"GUID-8E0C6BEE-CB17-430F-B1CE-C3A2C3299130\"></a> <em class=\"strong\">The following properties are common to all user-interface items:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7463\"></a><pre>&lt;ui_item&gt;.<em class=\"codeEmphasisStrong\">caption</em> String</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6648\"></a>The meaning of this property varies depending on the specific user-interface item\n               type. If the user-interface item has a caption, this property contains the caption\n               string. For the various types of buttons, it is the text inside the button. The default\n               value of the caption is the label string specified in the item definition. \n            </p> \n            <p><a name=\"GUID-CFA62C16-2F7F-47D4-8BE4-E2BF54976971\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7462\"></a><pre>&lt;ui_item&gt;.<em class=\"codeEmphasisStrong\">text</em> String</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6645\"></a>For all the user-interface items except <span class=\"code\"> <em class=\"strong\">edittext</em> </span> and <span class=\"code\"> <em class=\"strong\">combobox</em> </span>, the <span class=\"code\"> <em class=\"strong\">.text</em> </span> property is an alias of the <span class=\"code\"> <em class=\"strong\">.caption</em> </span> property. \n            </p> \n            <p><a name=\"GUID-89F78A67-3214-4630-89D2-11BF0B7EB549\"></a>For <span class=\"code\"> <em class=\"strong\">edittext</em> </span> and <span class=\"code\"> <em class=\"strong\">combobox</em> </span> user-interface items, it is the text in the edit box. \n            </p> \n            <p><a name=\"GUID-5E25D31D-300B-4A4F-A97D-76130CF30678\"></a>The default <span class=\"code\"> <em class=\"strong\">text</em> </span> property value for <span class=\"code\"> <em class=\"strong\">edittext</em> </span> user-interface items is a null string (\"\"). \n            </p> \n            <p><a name=\"GUID-EAB99506-0A23-4AE7-8B83-AB1F3AB7E51C\"></a>The default <span class=\"code\"> <em class=\"strong\">text</em> </span> property value for <span class=\"code\"> <em class=\"strong\">combobox</em> </span> user-interface items is the selected item’s text. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6644\"></a>The <span class=\"code\"> <em class=\"strong\">.text</em> </span> property in <em class=\"strong\">3ds Max 7 and higher</em> is <em class=\"strong\">really</em> equivalent to the <span class=\"code\"> <em class=\"strong\">.caption</em> </span> property for all rollout controls that do not define <span class=\"code\"> <em class=\"strong\">.text</em> </span> separately. \n            </p> \n            <p><a name=\"GUID-CF09F2D3-C779-4532-91B4-8537BA969DA4\"></a> Setting a label\'s text is the same as setting a label\'s caption. In previous releases,\n               setting the text would not update the UI, but would update the internal <span class=\"code\"> <em class=\"strong\">.caption</em> </span> value \n            </p> \n            <p><a name=\"GUID-5A83D11D-8A61-499E-8030-FD777F998B27\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7461\"></a><pre>&lt;ui_item&gt;.<em class=\"codeEmphasisStrong\">enabled</em> Boolean default: true</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6641\"></a>Sets whether the item is enabled for interaction when the rollout is initially opened.\n               Disabled items appear unavailable in the rollout. All items are enabled by default,\n               so you typically use this parameter to disable those items that should not initially\n               be available to the user. For example, you might have some spinners that change the\n               properties on a scene object that should not be changed until the user has picked\n               the object, typically with a <span class=\"code\"> <em class=\"strong\">pickbutton</em> </span> in the rollout. You would disable the spinner in its definition, as in the following\n               example, and enable it once the user picked an object. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6640\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-663F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7460\"></a><pre>\nspinner frab_x \"Frabulate x-axis:\" range:[0,100,0] enabled:false\n...\nfrab_x.enabled=true\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-18548E11-A165-45BD-810B-E2ED91CA7A8E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-745F\"></a><pre>&lt;ui_item&gt;.<em class=\"codeEmphasisStrong\">pos</em> Point2 default: varies</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6636\"></a>This forces the user-interface item to a fixed [x,y] pixel position in the rollout,\n               with [0,0] at the top-left corner. \n            </p> \n            <p><a name=\"GUID-30E3231F-C3AD-4314-A4AB-5DA32BEA9696\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-745E\"></a><pre>&lt;ui_item&gt;.<em class=\"codeEmphasisStrong\">visible</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6634\"></a>When set to <span class=\"code\"> <em class=\"strong\">false</em> </span>, the UI Item is hidden and disabled. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6633\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6632\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-745D\"></a><pre>\nrollout test \"test\"\n(\n  button b1 \"b1\"\n  on b1 pressed do print \"b1\"\n  button b2 \"b2\"\n  on b2 pressed do b1.visible = not b1.visible\n)\ncreatedialog test\n--Pressing the \'b2\' button hides and unhides the b1 button\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-FA37DFCE-3006-4A61-B5C8-ECEC3A8912DC\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;ui_item&gt;.<em class=\"codeEmphasisStrong\">hwnd</em> Integer, read-only</pre></div> \n            <p><a name=\"GUID-CCC99A2E-C3C1-4337-945D-90368271D867\"></a> Contains an array of the HWND Window handles of the control\'s rollout if the rollout\n               is open, or an empty array if the control\'s rollout is closed. \n            </p> \n            <p><a name=\"GUID-89AA9187-2747-45D3-BA85-1D7FE72FF1A5\"></a>Available in <em class=\"strong\">3ds Max 2011 and higher</em>. \n            </p> \n            <p><a name=\"GUID-52783A51-F76A-4B6D-998F-8DB9A85512FE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75DD\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Due to limitations in <em class=\"strong\">3ds Max</em>, you cannot specify a node using a Pickbutton in the Create panel, for example in\n                  a scripted Geometry plugin. The work-around is to only enable the Pickbutton when\n                  the object is open in the Modify Panel. \n               </div>\n            </div> \n            <p><a name=\"GUID-FE29A7A9-D779-4973-A0A1-A65779D56499\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6620\"></a> <span class=\"char_link\"><a href=\"GUID-6F37DC25-A3BF-4A3B-965B-7AD55D035BD1.htm\">Rollout User-Interface Controls</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-661F\"></a> <span class=\"char_link\"><a href=\"GUID-EA37E7DB-1E74-4377-B3D8-EDAE19CE27E7.htm\">Rollout User-Interface Controls Common Layout Parameters</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";