var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-3CF6FA6C-4CEA-4CC4-BACF-B2E40EF28C53\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"RayMeshGridIntersect ReferenceTarget\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>RayMeshGridIntersect : ReferenceTarget</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3CF6FA6C-4CEA-4CC4-BACF-B2E40EF28C53\"></a><div class=\"head\">\n            <h1>RayMeshGridIntersect : ReferenceTarget </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C70\"></a> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FE3\"></a><pre><em class=\"codeEmphasisStrong\">RayMeshGridIntersect - superclass: ReferenceTarget; super-superclass:MAXWrapper - 1:0 - classID: #(930131240, 656216840)</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C6D\"></a>Provides advanced ray-to-mesh intersection methods using a uniform voxel grid as acceleration\n               method. \n            </p> \n            <p><a name=\"GUID-7C0ACA05-1B82-4F3A-B926-F259B5F10343\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C6C\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FE2\"></a><pre>&lt;RayMeshGridIntersect&gt;.<em class=\"codeEmphasisStrong\">nodeList</em> ArrayParameter default: #() -- node array; Node_List   </pre></div> \n            <p><a name=\"GUID-914D04DB-4E24-48AF-B005-A9F2AC6BCD5C\"></a>Get/set the array of nodes. \n            </p> \n            <div><a name=\"GUID-F53A739A-E7B7-4EE1-9A2D-58F046F4F30E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Despite the implementation as an array parameter, the RayMeshGridIntersect does <em class=\"strong\">NOT</em> actually operate on all objects in the list, but only on the <em class=\"strong\">FIRST</em> object in the list. If the intersection against multiple objects is required, a separate\n                  RayMeshGridIntersect instance should be created for each one and the intersections\n                  have to be processed one after the other within a MAXScript loop. \n               </div>\n            </div> \n            <p><a name=\"GUID-704554CF-DBB5-4031-A6A1-970DE66201F3\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C6A\"></a> \n            <h2><a name=\"GUID-9522C218-48B6-4C44-9AA0-E3E5D5EAF62C\"></a> <em class=\"strong\">RayMeshGridIntersect interfaces:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FE1\"></a><pre>Interface: <em class=\"codeEmphasisStrong\">rayMeshGridIntersectOps</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C68\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FE0\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">initialize</em> &lt;integer&gt;gridSize </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C66\"></a>Initializes the voxel grid with the specified grid size. \n            </p> \n            <p><a name=\"GUID-A06ECFDD-DDC6-467E-8BE8-24696FEA02E1\"></a>The grid size value defines the number of voxels along all 3 axes. \n            </p> \n            <p><a name=\"GUID-777DD538-2ECC-4348-A4DD-B5632EC17060\"></a>The actual size of the voxels depends on the bounding box of the nodes to be processed.\n               \n            </p> \n            <p><a name=\"GUID-EEB14992-A524-433C-A88A-0D06A9727149\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FDF\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">addNode</em> &lt;node&gt;addNode </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C63\"></a>Adds a node to the node list. \n            </p> \n            <p><a name=\"GUID-1F1495A5-7284-494A-8C30-279AF37BCC3D\"></a>Please see the Note above - only the first object on the list will be used! \n            </p> \n            <p><a name=\"GUID-57B228E1-C192-4121-BF64-1F5D3766233F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FDE\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">buildGrid()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C60\"></a>Fills in the voxel grid with data. \n            </p> \n            <p><a name=\"GUID-180E386A-073E-4C1C-B3F6-D3C2500AB512\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FDD\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">free()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C5D\"></a>Removes all data from the voxel grid. \n            </p> \n            <p><a name=\"GUID-3227734D-808E-4C26-8519-456EAC5430C5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FDC\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">intersectBox</em> &lt;point3&gt;min &lt;point3&gt;max </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C5A\"></a>Performs a box intersection using the specified min. and max. points in world space.\n               \n            </p> \n            <p><a name=\"GUID-6B663300-AE8B-4B6D-9D12-E0642CEE04C4\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FDB\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">intersectSphere</em> &lt;point3&gt;center &lt;float&gt;radius </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C57\"></a>Performs a sphere intersection using the specified center and radius. \n            </p> \n            <p><a name=\"GUID-A7C74539-2E27-4BB9-AE5A-69FC15DA1DBD\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FDA\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">intersectRay</em> &lt;point3&gt;p &lt;point3&gt;dir &lt;boolean&gt;doubleSided </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C54\"></a>Performs a ray intersection using the specified position and direction. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C53\"></a>If the doubleSided argument is False, only intersection with faces whose normals point\n               towards the ray will be collected. \n            </p> \n            <p><a name=\"GUID-EA21D244-15CF-4CA5-8F77-9186259BC81A\"></a>When it is True, the faces will be considered double-sided and intersected even when\n               their normals are pointing in the direction of the ray. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C52\"></a>The result is 0 if not intersection was detected, or a positive number representing\n               the number of faces that have been intersected. \n            </p> \n            <p><a name=\"GUID-93E327A3-536D-42A8-8EC9-834EECDE463D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FD9\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">intersectSegment</em> &lt;point3&gt;p1&lt;point3&gt;p2 &lt;boolean&gt;doubleSided </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C4F\"></a>Performs a segment intersection using the specified two world positions. \n            </p> \n            <p><a name=\"GUID-D0DBBBC5-6330-4A0C-A622-FD76F48FA9AC\"></a>This is similar to intersectRay, but instead of a point and direction, the intersection\n               ray is defined using two absolute positions in space, where p1 is the origin and the\n               direction is from p1 to p2. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C4E\"></a>If the doubleSided argument is False, only intersection with faces whose normals point\n               towards the ray will be collected. \n            </p> \n            <p><a name=\"GUID-A05D2A63-7977-4EBF-87BD-6B624C519387\"></a>When it is True, the faces will be considered double-sided and intersected even when\n               their normals are pointing in the direction of the ray. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C4D\"></a>The result is 0 if no intersection was detected, or a positive number representing\n               the number of faces that have been hit. \n            </p> \n            <p><a name=\"GUID-86B33F8E-69D7-4EB1-85F6-25982D15002B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FD8\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">getHitFace</em> &lt;integer&gt;index </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C4A\"></a>Returns the index of the TriMesh face for the indexed hit. \n            </p> \n            <p><a name=\"GUID-DC4526C5-C9D4-4213-A853-023CCB2177DA\"></a>The index can be a positive number between 1 and the number of hits reported by the\n               last intersection method. \n            </p> \n            <p><a name=\"GUID-A7283D4D-3F37-440C-860F-A46B5F7B1D1C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FD7\"></a><pre>&lt;point3&gt;<em class=\"codeEmphasisStrong\">getHitBary</em> &lt;integer&gt;index </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C47\"></a>Returns the Barycentric Coordinates of the TriMesh face for the indexed hit. \n            </p> \n            <p><a name=\"GUID-6C6AE1BC-870A-4842-AB8A-B546564C35CB\"></a>The index can be a positive number between 1 and the number of hits reported by the\n               last intersection method. \n            </p> \n            <p><a name=\"GUID-F00236A2-0BA5-416A-B909-74CBE2A8D6AF\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FD6\"></a><pre>&lt;point3&gt;<em class=\"codeEmphasisStrong\">getHitNormal</em> &lt;integer&gt;index </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C44\"></a>Returns the face normal of the TriMesh face for the indexed hit in world space. \n            </p> \n            <p><a name=\"GUID-066DC353-C7B1-4C67-965B-2BE507C01652\"></a>The index can be a positive number between 1 and the number of hits reported by the\n               last intersection method. \n            </p> \n            <p><a name=\"GUID-BBCFF248-0C54-4E29-A28E-C9A1B3C4CF35\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FD5\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">getHitDist</em> &lt;integer&gt;index </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C41\"></a>Returns the distance to the indexed hit. \n            </p> \n            <p><a name=\"GUID-B03F3184-5214-4B46-A83D-351A7CF3E440\"></a>The index can be a positive number between 1 and the number of hits reported by the\n               last intersection method. \n            </p> \n            <p><a name=\"GUID-B9C1E5F0-BE6F-43C3-A94B-E1DDC033A1FF\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FD4\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">intersectSegmentDebug</em> &lt;point3&gt;p1 &lt;point3&gt;p2 &lt;boolean&gt;doubleSided &lt;integer&gt;gridID </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C3E\"></a>This method is for debugging purposes only. \n            </p> \n            <p><a name=\"GUID-2A08AF00-BC5D-4206-BD08-9BDC163ADD53\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FD3\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">getClosestHit()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C3B\"></a>Returns the index of the closest hit. \n            </p> \n            <p><a name=\"GUID-EA876F2C-857F-46FF-BF3A-DDA38DA895CF\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FD2\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">getFarthestHit()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C38\"></a>Returns the index of the farthest hit. \n            </p> \n            <p><a name=\"GUID-38F48FE7-F8E6-47FE-B5C3-D6F01ACDFB5E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FD1\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">closestFace</em> &lt;point3&gt;p </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C35\"></a>Performsintersections from the specified world point with all faces and returns the\n               number of hits as integer. \n            </p> \n            <p><a name=\"GUID-55F05A32-FC6E-41A2-92F1-ECC929B6EA20\"></a>You can use the getClosestHit() and getFarthestHit() to determine the closest and\n               farthest faces to the specified world point, getHitDist() to determine the distance\n               to every face, and getPerpDist() to determine the perpendicular distance to the point.\n               \n            </p> \n            <p><a name=\"GUID-6A104556-1F4F-409C-ABF7-F74BCB4BF0FD\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FD0\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">getPerpDist</em> &lt;integer&gt;index </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C32\"></a>Returns the perpendicular distance to the indexed hit. \n            </p> \n            <p><a name=\"GUID-F2CDC320-8CF0-49B9-8E52-8429EF5B6D0A\"></a>The index can be a positive number between 1 and the number of hits reported by the\n               last intersection method. \n            </p> \n            <p><a name=\"GUID-F9FA373C-0DF7-4089-8B31-4EC9252AB703\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FCF\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">ClearStats()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C2F\"></a>Clears all statistics. \n            </p> \n            <p><a name=\"GUID-E6782E86-52CF-4229-8152-9FBAECFBE73E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FCE\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">PrintStats()</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C2C\"></a>Prints current statistics, including number of faces and number of searches performed.\n               \n            </p> \n            <p><a name=\"GUID-009A3B75-E9EF-4E99-B230-A7C013226642\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C2B\"></a>The following example creates a sphere and a geosphere, registers the sphere with\n               the voxel grid and then shoots rays from each vertex of the geosphere and selects\n               the faces of the sphere that these rays have hit. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C2A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C29\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-1FCD\"></a><pre>\n(\nresetMaxFile #noprompt --reset the scene\ntheSphere = Sphere radius:40 segs:50 pos:[100,200,300] --create a sphere\ntheGeoSphere = Geosphere radius:100 segs:3 pos:[100,200,300] --create a geosphere\ntheFacesArray = #() --init. an array to collect face selection\n&nbsp;\nrm = RayMeshGridIntersect () --create an instance of the Reference Target\nrm.Initialize 10 --init. the voxel grid size to 10x10x10\nrm.addNode theSphere --add the sphere to the grid\nrm.buildGrid () --build the grid data (collecting faces into the grid voxels)\ntheGSMesh = snapshotasmesh theGeoSphere --grab the TriMesh of the Geosphere\nfor v = 1 to theGSMesh.numverts do --go through all verts of the Geosphere\n(\nthePos = getVert theGSMesh v --get the position of the vertex\ntheNormal = -(getNormal theGSMesh v) --get the normal of the vertex, reverse direction\ntheHitsCount = rm.intersectRay thePos theNormal false --intersect the ray with the sphere\nif theHitsCount &gt; 0 then --if have hit anything...\n(\n&nbsp;theIndex = rm.getClosestHit () --get the index of the closest hit by the ray\n&nbsp;theFace = rm.getHitFace theIndex --get the face index corresponding to that indexed hit\n&nbsp;append theFacesArray theFace --add to the face array to select the face...\n)\nelse\n&nbsp;format \"The Ray % Missed\\n\" v\n)\n&nbsp;\nms = mesh_select() --create a mesh select modifier\naddModifier theSphere ms --add on top of the sphere\nselect theSphere --select the sphere\nmax modify mode --go to modify panel\nsetFaceSelection theSphere 1 theFacesArray --set the selection in the MeshSelect\nsubObjectLevel = 3 --go to face selection level\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C03\"></a> <span class=\"char_link\"><a href=\"GUID-9AA3FE8F-1B39-42FE-BC4F-C915EDE1B343.htm\">MeshProjIntersect : ReferenceTarget</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C02\"></a> <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm#WS73099CC142F487553098682E12AC2FC2BC7-3D4B\">IntersectRay</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3C01\"></a> <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm#WS73099CC142F487553098682E12AC2FC2BC7-3D4B\">IntersectRayExt</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";