var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-3E389A4A-740A-4D64-888D-04A51EBA061A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ViewPanelManager Interface\">\n      <meta name=\"indexterm\" content=\"Interface ViewPanelManager\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: ViewPanelManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3E389A4A-740A-4D64-888D-04A51EBA061A\"></a><div class=\"head\">\n            <h1>Interface: ViewPanelManager </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1058\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1057\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; ViewPanelManager \n                        					  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-0F6E106E-11DD-4E43-8F2D-483A73D100EC\"></a>This Core Interface exposes the \n            		<em class=\"strong\">View Panel Manager</em> to MAXScript. \n            	 \n         </p>\n         <p><a name=\"GUID-4C4A1BAF-C6FC-4B37-8B32-ABB4BA602FF5\"></a>It provides methods for the creation and manipulation of View Panels containing custom\n            viewport configurations, as well as methods for View Panel Presets management. \n            	 \n         </p>\n         <p>This interface also provides methods for managing floating viewports. \n            	 \n         </p>\n         <p><a name=\"GUID-222A90B7-1B16-43A0-A899-7201EB17BC59\"></a>Available in \n            		<em class=\"strong\">3ds Max 2013 and higher</em>. \n            	 \n         </p><img src=\"../images/GUID-5279C695-ACA1-46BC-B1EE-26F6B1036B5E-low.png\"><p><a name=\"GUID-C00FAA01-9C29-4E68-9A52-5A7D1A8741F6\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"section\"><a name=\"SECTION_D585744D68CD4648A20E530F69568B91\"></a> \n            <h2><a name=\"GUID-C5F683EA-EF2A-4400-95E8-BC26FD0A29F2\"></a>View Panel Creation\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;index&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.CreateViewPanel</em> &lt;string&gt;tabName &lt;enum&gt;layout &lt;bool&gt;isActive\n\nlayout enums: {\n<em class=\"codeEmphasisStrong\">#layout_1</em> | <em class=\"codeEmphasisStrong\">#layout_2v</em> | <em class=\"codeEmphasisStrong\">#layout_2h</em> | <em class=\"codeEmphasisStrong\">#layout_2ht</em> | <em class=\"codeEmphasisStrong\">#layout_2hb</em> | <em class=\"codeEmphasisStrong\">\n#layout_3vl</em> | <em class=\"codeEmphasisStrong\">#layout_3vr</em> | <em class=\"codeEmphasisStrong\">#layout_3ht</em> | <em class=\"codeEmphasisStrong\">#layout_3hb</em> | \n<em class=\"codeEmphasisStrong\">#layout_4</em> | <em class=\"codeEmphasisStrong\">#layout_4vl</em> | <em class=\"codeEmphasisStrong\">#layout_4vr</em> | <em class=\"codeEmphasisStrong\">#layout_4ht</em> | <em class=\"codeEmphasisStrong\">#layout_4hb</em> }\n</pre></div> \n            <p><a name=\"GUID-9C7B758E-FBF3-441C-86F5-B741C48BD57C\"></a>Creates a new View Panel with the name specified by the first argument. \n               		\n            </p> \n            <p><a name=\"GUID-C5BD7DD0-8A71-4760-AB87-98F531CAEE3C\"></a>The second argument specifies the layout name - see table below. \n               		\n            </p> \n            <p><a name=\"GUID-8009FBA0-936E-4CBF-B51B-B58440A136FE\"></a>The third argument controls whether the new View Panel will set as the active one.\n               \n               		\n            </p> \n            <p><a name=\"GUID-9C5C54FF-7222-45A9-AF02-6B40D7E5B7A2\"></a>Returns the index of the new View Panel. \n               		\n            </p> <a name=\"TABLE_C1BE30AF10924770B93F42DC1BC206DC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"3.431708991077557%\">\n                     <col width=\"9.814687714481812%\">\n                     <col width=\"86.75360329444062%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Layout \n                        				  \n                     </th>\n                     <th class=\"table-heading\">Name \n                        				  \n                     </th>\n                     <th class=\"table-heading\">Description \n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-D3DDB1AD-7EBF-4834-90C4-E8554DB339FD-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-2C44F010-4FE0-43CB-A2EA-D51EFBFA0BC9\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_1 \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-475918ED-5092-4A46-AF1E-DAAB93CD778B\"></a><p class=\"table-body\">One viewport \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-389DADB3-37D1-4F9C-AC6D-05085082424E-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-97C4D3B5-5D8C-405B-B8E1-491E4E48AB4E\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_2v \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-99A2FA0F-7DC3-4031-ABA9-729C3FC3A534\"></a><p class=\"table-body\">Two Viewports, Vertical Split, Equally Sized \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-192FAFF6-C2B9-40F9-AD63-85D956FC17C7-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-8F510A8F-324C-460E-B1F0-9AD5137E7AA1\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_2h \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-9DE584AA-F06F-4CD9-9743-4CC74C712D86\"></a><p class=\"table-body\">Two Viewports, Horizontal Split, Equally Sized \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-7AD85944-5DAE-4459-995F-850B3A5033EB-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-B3963203-6033-4426-879C-87B4D5775363\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_2ht \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-AB0AD3B3-1346-4C37-9605-60CE4BC4F5F3\"></a><p class=\"table-body\">Two Viewports, Horizontal Split, Top Viewport Smaller \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-6F359915-7D6D-4ECC-AEBC-EEF378CD302E-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-02EA2683-18FE-40E5-A5BE-335817F57A72\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_2hb \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-A800423D-3C56-4989-837F-51438896A65C\"></a><p class=\"table-body\">Two Viewports, Horizontal Split, Bottom Viewport Smaller \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-7157846C-4B5F-412C-A901-FFAFE25C27E1-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-FDE16F2C-2A06-442D-8E5A-C734F14A285A\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_3vl \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-E131C50B-A43D-411C-A756-B70928903190\"></a><p class=\"table-body\">Three Viewports, Vertical Split, Horizontal Split On Left \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-C21F006E-B824-498D-9AAF-37FE4D1C0F3A-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-2F946AB0-C861-42C9-AA0C-67A6849960CD\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_3vr \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-76AF7CD0-A88F-4754-86EC-99D27862175C\"></a><p class=\"table-body\">Three Viewports, Vertical Split, Horizontal Split On Right \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-C4F0AAF8-8BBE-483C-AAE1-6D0DD19C1B55-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-E0D97BEF-CBAF-4314-ACFF-DBD4FDD2E8AB\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_3ht \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-2F30DAF7-6A5F-42DD-A7A1-BED8AA3F7081\"></a><p class=\"table-body\">Three Viewports, Horizontal Split, Vertical Split On Top \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-B0FC4F20-1720-4DF6-998F-B59D822A539A-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-11729981-E991-4825-AD23-32754D78AB7C\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_3hb \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-31DC980B-F393-49B8-AF92-38218F102280\"></a><p class=\"table-body\">Three Viewports, Horizontal Split, Vertical Split On Bottom \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-B32F1448-56A9-4F68-832B-AFF6B5BD925E-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-E87EF2EF-6755-4815-9AFB-358ED428722D\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_4vl \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-0CF99514-12C4-4A67-A07A-81F210323475\"></a><p class=\"table-body\">Four Viewports, Vertical Split, Two Horizontal Splits On Left \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-4C5AB5F5-3CAA-43DD-9FE0-C9DF5D50A5F6-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-89C628C7-42F7-49BB-991E-B1FBA92ACDA2\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_4vr \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-BBEF3D68-EBF2-4529-81B4-E8C565A9F82B\"></a><p class=\"table-body\">Four Viewports, Vertical Split, Two Horizontal Splits On Right \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-FFB07D24-135A-4693-B242-70B1B4C7C58D-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-D323C887-52EA-4824-BB56-94CD0E45E87F\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_4ht \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-36768C49-34D1-46C3-96CF-8A4D5E06DDD8\"></a><p class=\"table-body\">Four Viewports, Horizontal Split, Two Vertical Splits On Top \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-26249849-0397-4C78-B2F8-CE004F184854-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-07D0E527-4FF1-479E-95BF-792206BF1EE6\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_4hb \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-A15D6CAA-95C9-4D71-9A3F-C0A4969AD2BD\"></a><p class=\"table-body\">Four Viewports, Horizontal Split, Two Vertical Splits On Bottom \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-3872E535-AC23-4367-AD13-DADF8897B72C-low.png\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-2C8BC989-408E-4253-B25C-5AFC4BA91EFC\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_4</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-8A30FF21-2FAC-4788-80A0-7B6B6B246568\"></a><p class=\"table-body\">Four Viewports, Equally Sized \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"GUID-94091A70-6242-498C-B75A-9DC31B38A9B1\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>To get or set the layout of an existing View Panel, use \n                  		  <span class=\"char_link\"><a href=\"GUID-8AA71F9E-F4F0-4437-A44E-9683619E89DE.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-5AD8\">viewport.getLayout() and viewport.setLayout()</a></span>. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-2CAD3389-34D2-43B8-8A1C-D97A9B83D160\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.GetViewPanelCount()</em></pre></div> \n            <p><a name=\"GUID-CAA14B65-959C-49CC-B7E0-52E873814004\"></a>Returns the number of View Panels, including the three available Floating Viewports,\n               whether they are visible or not. This method will always return at least 4, since\n               there is always at least one static View Panel. \n               		\n            </p> \n            <p>See GetNumViewportsFromAllVisibleViewPanels() below to get a count of all visible\n               viewports. \n               		\n            </p> \n            <p><a name=\"GUID-FDAF5D02-63E4-4186-9309-2E6E8FB2CAE9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.SetActiveViewPanel</em> &lt;index&gt;Index</pre></div> \n            <p><a name=\"GUID-C2F723FA-5CC0-443D-9563-94065C9F2968\"></a>Sets the active View Panel to the indexed definition. \n               		\n            </p> \n            <p>If you specify a non-visible floating viewport View Panel index, that View Panel will\n               become visible. \n               		\n            </p> \n            <p><a name=\"GUID-D7415AE9-D5D7-4FF9-9B79-31E934EC5F17\"></a>Returns True on success, False on failure. \n               		\n            </p> \n            <p><a name=\"GUID-D842E7C8-51C5-4981-994D-FFD19DDCB509\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;index&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.GetActiveViewPanelIndex()</em></pre></div> \n            <p><a name=\"GUID-8474142B-EE5E-4477-A2AF-B956EF81FD78\"></a>Returns the index of the active View Panel. \n               		\n            </p> \n            <p><a name=\"GUID-412E801A-DD37-48CB-941C-41AA501596A0\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.CanCreateMoreViewPanels()</em></pre></div> \n            <p><a name=\"GUID-863A354B-1BC0-4E00-A570-3FDE561D4538\"></a>Returns True if new View Panels can be created, False if the limit has been reached.\n               \n               		\n            </p> \n            <p><a name=\"GUID-4C7903DD-A6C6-4E91-AC91-C5E86AF94305\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.GetViewPanelName</em> &lt;index&gt;Index</pre></div> \n            <p><a name=\"GUID-EDBB467C-3539-4FBC-9564-267FC3CFB4A0\"></a>Returns the name of the indexed View Panel. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.SetViewPanelName</em> &lt;index&gt;Index &lt;string&gt;newPanelName</pre></div> \n            <p><a name=\"GUID-282F1CF9-078D-4D54-A74B-711B8CE246CB\"></a>Sets the name of the indexed View Panel to the string provided by the second argument.\n               \n               		\n            </p> \n            <p><a name=\"GUID-72DC377D-0279-489C-8E18-1B51A005B0B4\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;value&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.GetActiveViewPanelDib()</em></pre></div> \n            <p><a name=\"GUID-9CF772C4-B17A-4C17-932E-48ECD299CE82\"></a>Returns the Device Independent Bitmap (Viewport Snapshot) of the active View Panel.\n               \n               		\n            </p> \n            <p><a name=\"GUID-DDC78236-8B93-410A-B758-FDCB33D4D637\"></a>The image will contain the content of all viewports in the View Panel. \n               		\n            </p> \n            <p><a name=\"GUID-B747D987-6959-45A5-A757-8D743FE00BA7\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.IsViewPanelLocked</em> &lt;index&gt;Index</pre></div> \n            <p><a name=\"GUID-2366F821-E56C-4E69-A555-AD2F77FE0533\"></a>Returns True if the indexed View Panel is locked, False if it is not locked. \n               		\n            </p> \n            <p><a name=\"GUID-CA4F6B4F-BAD7-48F2-B27D-8A75AAAA2D9B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.SetSplitterBarPos</em> &lt;integer&gt;splitterBarID &lt;float&gt;pos</pre></div> \n            <p><a name=\"GUID-77E8927E-B410-4854-BC53-AE6F32CFF329\"></a>Sets the position of the horizontal or vertical splitter bar to the specified position.\n               \n               		\n            </p> \n            <p><a name=\"GUID-97BD8F1B-64D7-409F-9B4E-9D939E064528\"></a>The first argument is in the range from 0 to 2 and depends on the current layout:\n               \n               		\n            </p> <a name=\"TABLE_ADA2BBA2ED014412B364656E3604A1B8\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"10.49317943336831%\">\n                     <col width=\"22.24554039874082%\">\n                     <col width=\"67.26128016789087%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Layout \n                        				  \n                     </th>\n                     <th class=\"table-heading\">Visible Bar Indices \n                        				  \n                     </th>\n                     <th class=\"table-heading\">Comments \n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-755459A5-EC84-4691-B7EB-875E5AEB0BDE\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_1 \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-D8FB2407-7AD6-427C-8672-F30277C9BFB5\"></a><p class=\"table-body\">None \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-95957BAF-91A7-40FA-B0E6-6161FE695E84\"></a><p class=\"table-body\">No splitter bars are used, but 0,1 and 2 are still valid first arguments. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-B884654C-E3F1-4D05-95EC-7AB023DC195A\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_2v \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-6A98EB7B-773B-4E92-AF78-39E3FAEF56D0\"></a><p class=\"table-body\">1 - vertical splitter bar \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-19FEC61C-F994-4A29-9B9D-2FA9BEC49AFC\"></a><p class=\"table-body\">0 and 2 are valid indices, but the corresponding splitter bars are not used. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-BE43F9EA-2E36-4FA7-A0A1-978958334A87\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_2h \n                                 						  </em> </span> \n                        </p> <a name=\"GUID-B5A6DBA3-476B-4AD9-905B-C0ED6F750DBD\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_2ht \n                                 						  </em> </span> \n                        </p> <a name=\"GUID-D741BA56-48F5-43AD-8E9F-C86518B2F588\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_2hb \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-BA881B77-FC30-4B51-B21B-A67685EC1381\"></a><p class=\"table-body\">0 - horizontal splitter bar \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-ADB859F7-F485-4379-83F0-6CEA25A776BF\"></a><p class=\"table-body\">1 and 2 are valid indices, but the corresponding splitter bars are not used. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-1E35DD60-8774-446D-BB44-D3BF2F36DE24\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_3vl \n                                 						  </em> </span> \n                        </p> <a name=\"GUID-C7D1E22E-4F0B-4904-9474-1D34840DE59D\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_3vr \n                                 						  </em> </span> \n                        </p> <a name=\"GUID-A9A012FD-A32D-4AAC-979C-1F65D2E8E437\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_3ht \n                                 						  </em> </span> \n                        </p> <a name=\"GUID-55E08894-6503-493F-A1DB-3BD8AC71ED56\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_3hb \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-6E518CA7-324F-4FF9-A468-1B6372ADE29D\"></a><p class=\"table-body\">0 - horizontal splitter bar \n                           					 \n                        </p> <a name=\"GUID-905D0055-C047-48ED-8164-5E236631E60C\"></a><p class=\"table-body\">1 - vertical splitter bar \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-F5BE2097-7182-4413-A59B-DF1231C1B229\"></a><p class=\"table-body\">2 is a valid index, but the corresponding splitter bar is not used. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-819BF3AD-D5B5-4E10-85FA-A08638051A6F\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_4</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-179BB52B-AA0F-41DC-9938-01C3DF418837\"></a><p class=\"table-body\">0 - horizontal splitter bar \n                           					 \n                        </p> <a name=\"GUID-2D92D644-3297-4356-8167-6B6F8C1EB4A9\"></a><p class=\"table-body\">1 - vertical splitter bar \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-B5D80701-67A5-43D4-8316-58BB280124CB\"></a><p class=\"table-body\">2 is a valid index, but the corresponding splitter bar is not used. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-BC0C7C76-28B3-499F-9508-9A058051A2FA\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_4vl \n                                 						  </em> </span> \n                        </p> <a name=\"GUID-B41EB519-1B30-4DE6-B762-4D167FBC0AAE\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_4vr \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-15D89387-0C03-4F79-81E6-704B22006C90\"></a><p class=\"table-body\">0 - vertical splitter bar \n                           					 \n                        </p> <a name=\"GUID-CB5FDB20-B75B-4A2E-A3DD-EBAE3FEA0C66\"></a><p class=\"table-body\">1 - top horizontal splitter bar \n                           					 \n                        </p> <a name=\"GUID-0932BEA3-16AA-45C8-A149-838A9455F471\"></a><p class=\"table-body\">2 - bottom horizontal splitter bar \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-A7001A58-0DC1-4801-A032-AEF9AEBFF468\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_4ht \n                                 						  </em> </span> \n                        </p> <a name=\"GUID-F9BBD466-CC18-4EBA-BC47-CA589AD0C499\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#layout_4hb \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-D8D38A7D-B91F-4BB6-99D4-48EDC9ED1F86\"></a><p class=\"table-body\">0 - horizontal splitter bar \n                           					 \n                        </p> <a name=\"GUID-0130AF6E-2B54-43A8-A0C4-C2196481E836\"></a><p class=\"table-body\">1 - left vertical splitter bar \n                           					 \n                        </p> <a name=\"GUID-7F99438E-50EF-4727-9DEF-64A8A8BD55AD\"></a><p class=\"table-body\">2 - right vertical splitter bar \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-A07D7D7C-80F7-4AB6-BC62-2EC93534B6FE\"></a>The second argument must be a float in the range from 0.0 to 1.0, with 0.5 being centered\n               in the middle of the panel. \n               		\n            </p> \n            <p><a name=\"GUID-55683F80-A894-414B-9ECF-A7F87C480C18\"></a>Returns True on success, False if the second argument is out of range. Note that attempting\n               to set a non-visible splitter bar index still returns True. \n               		\n            </p> \n            <p><a name=\"GUID-120AC365-D4F7-4449-87C8-FAE7197EDD20\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.SetExtendedView</em> &lt;integer&gt;viewIndex &lt;enum&gt;extendedViewType\n\nextendedViewType enums: {<em class=\"codeEmphasisStrong\">#ev_type_tree</em>|<em class=\"codeEmphasisStrong\">#ev_type_schematic</em>|<em class=\"codeEmphasisStrong\">#ev_type_sceneexplore</em>}\n</pre></div> \n            <p><a name=\"GUID-789EB764-501A-484A-9B34-B2E2A9669F81\"></a>Sets the indexed extended view to the extended view type specified by the second argument\'s\n               enum value. \n               		\n            </p> \n            <div><a name=\"GUID-DED12441-D0D8-440E-BDFD-E0D9D42B6141\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Not all extended view types exposed in the UI are currently supported in MAXScript.\n                  \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-ED31692E-C4AE-4946-BC6B-7E0981AD7D80\"></a>Possible values are: \n               		\n            </p> <a name=\"TABLE_CFCC987BF6C8466CA17B8ADE4F2751F9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"10.916030534351146%\">\n                     <col width=\"7.633587786259542%\">\n                     <col width=\"81.45038167938932%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Enum \n                        				  \n                     </th>\n                     <th class=\"table-heading\">As Integer \n                        				  \n                     </th>\n                     <th class=\"table-heading\">Result \n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-35897D26-107F-462A-A2BF-AE0DD082D828\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#ev_type_tree \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-B59B102C-602F-4F86-9A7F-550B523B8BB4\"></a><p class=\"table-body\">0 \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-444C0D64-7D68-484E-BA3E-F0C0E3CAAE94\"></a><p class=\"table-body\">Set Extended Viewport to TrackView \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-228663B3-DC2F-4392-BFE0-4D4FECFAF745\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#ev_type_schematic</em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-6EE13F55-3384-4D55-8F22-B63F90B0AB2A\"></a><p class=\"table-body\">1 \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-BA17415E-7126-4D6A-9227-10E340A05204\"></a><p class=\"table-body\">Set Extended Viewport to Schematic View \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-D5E0740A-1AC7-4E88-9428-5D033876F710\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#ev_type_sceneexplore \n                                 						  </em> </span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-7DDF34BA-73BA-46B8-94F2-B3B868E629DC\"></a><p class=\"table-body\">2 \n                           					 \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-2EAA1338-49C8-451F-B424-50185B624DA0\"></a><p class=\"table-body\">Set Extended Viewport to Scene Explorer \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-C33B192C-BA4E-4A7B-922F-C28DA252B1F1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.DestroyViewPanel</em> &lt;index&gt;Index</pre></div> \n            <p><a name=\"GUID-35D83067-8D97-4BE4-8F5B-52C5AB77D17B\"></a>Destroys the indexed View Panel. \n               		\n            </p> \n            <p><a name=\"GUID-1EFB6CA6-FA84-435A-AAC1-F35185CDCAD2\"></a>Returns True on success, False on failure. \n               		\n            </p> \n            <p><a name=\"GUID-BB4F2B70-41B5-486D-8DF7-F87CE4BD4036\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-114B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-114A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5883\"></a><pre>\ntheActive = ViewPanelManager.GetActiveViewPanelIndex()\n--&gt; 1\ncanCreate = ViewPanelManager.CanCreateMoreViewPanels()\n--&gt; true \nif canCreate do theNew = ViewPanelManager.CreateViewPanel \"Two Horizontal Large Top\" #layout_2h false\n--&gt; 2\nViewPanelManager.SetSplitterBarPos 0 0.65\n--&gt; true\ntheCount = ViewPanelManager.GetViewPanelCount()\n--&gt; 2\nfor i = 1 to 2 do\n(\n	theName = ViewPanelManager.GetViewPanelName i\n	isLocked = ViewPanelManager.IsViewPanelLocked i\n	format \"% Name:\'%\' Locked:% \" i theName isLocked\n	if i == theActive then format \"(active)\\n\" else format \"\\n\"\n)	\n--&gt; 1 Name:\'Quad 4\' Locked:true (active)\n--&gt; 2 Name:\'Two Horizontal Large Top\' Locked:false \n--&gt; OK\ntheBitmap = ViewPanelManager.GetActiveViewPanelDib()\n--&gt; BitMap:\ndisplay theBitmap\n--&gt; OK\nViewPanelManager.DestroyViewPanel theNew\n--&gt; true\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_EB9D28B0A896475DB8CE7DAF3F4CFBAD\"></a> \n            <h2><a name=\"GUID-75A35785-2858-4F23-9507-C1FC3B43649D\"></a>View Panel Preset Management\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.GetPresetCount()</em></pre></div> \n            <p><a name=\"GUID-8AC34667-780C-4550-B0F8-A43E4018F4F1\"></a>Returns the number of available named View Panel presets. \n               		\n            </p> \n            <p><a name=\"GUID-ED5CFB6C-87F1-493A-9695-F4C21A48CD98\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.GetPresetName</em> &lt;index&gt;presetIndex</pre></div> \n            <p><a name=\"GUID-E6A0FCD3-4199-471B-B0A3-069FEC7968D9\"></a>Returns the name of the indexed View Panel Preset. \n               		\n            </p> \n            <p><a name=\"GUID-57676018-3CD1-48D5-9B3A-0EBCD65C4D88\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;index&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.GetPresetID</em> &lt;string&gt;presetName</pre></div> \n            <p><a name=\"GUID-AF3A81D0-2B9F-4A33-9D36-0E466E9FB06B\"></a>Returns the ID of the named View Panel Preset. \n               		\n            </p> \n            <p><a name=\"GUID-97C8B92D-B34C-4C0A-8D8C-D08022D3485B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.DoesViewPanelPresetExist</em> &lt;string&gt;presetName</pre></div> \n            <p><a name=\"GUID-90CB10BB-45E7-4F6C-9ED3-4D4A3FC8994C\"></a>Returns True if a View Panel Preset with the name specified by the argument exists.\n               \n               		\n            </p> \n            <p><a name=\"GUID-271A6416-90BF-47B1-90EF-71AE44C812B2\"></a>Returns False if the View Panel Preset with the specified name does not exist. \n               		\n            </p> \n            <p><a name=\"GUID-CF2E5D0B-1A57-46E4-8FAE-4E09D67AFECB\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.GetViewPanelPresetLayout</em> &lt;integer&gt;presetIndex</pre></div> \n            <p><a name=\"GUID-D7C01CC5-DC54-40D4-95F6-B8FFECC86F89\"></a>Returns the layout of the indexed View Panel Preset as an integer, or -1 if the specified\n               \n               		  <span class=\"code\">presetIndex</span> does not exist.. \n               		\n            </p> \n            <p><a name=\"GUID-F509F688-88D7-4CE2-A90B-D880AD09153C\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;index&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.CreateViewPanelFromPreset</em> &lt;string&gt;presetName &lt;bool&gt;isActive</pre></div> \n            <p><a name=\"GUID-4B5DD108-3CEA-4295-9EE6-41098C30B712\"></a>Creates a new View Panel from the specified named preset. \n               		\n            </p> \n            <p><a name=\"GUID-2B3E6E3A-6146-4478-86D5-D99921CC620B\"></a>If the second argument is set to True, the View Panel will also be made active. \n               		\n            </p> \n            <p><a name=\"GUID-B26B47F4-606B-4D01-85D1-206D21D25A3C\"></a>Returns the index of the new View Panel. \n               		\n            </p> \n            <p><a name=\"GUID-2E76D1DF-86CD-45C3-B8ED-FB3CC2F89740\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.CreatePresetFromActiveViewPanel</em> &lt;string&gt;presetName</pre></div> \n            <p><a name=\"GUID-21F5E4F7-DB09-422A-9E93-AD3E8C48322C\"></a>Creates a new Preset with the specified name from the active View Panel. \n               		\n            </p> \n            <p><a name=\"GUID-FFC139DD-CD57-48CC-B344-2FE5C7B33CB7\"></a>If the name already exists, it will be appended a numeric suffix, e.g. \"Test\" will\n               become \"Test 01\". \n               		\n            </p> \n            <p><a name=\"GUID-92C6F3B3-879A-4DA1-BA9E-9E3EC50E6B46\"></a>Returns True on success, False on failure. \n               		\n            </p> \n            <p><a name=\"GUID-413A0B15-F9AB-41FF-B35B-F593B5B84A09\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.CreatePresetFromViewPanel</em> &lt;index&gt;panelIndex &lt;string&gt;presetName</pre></div> \n            <p><a name=\"GUID-DEB75DA8-BB3E-4D99-8DF7-8DD4001FCF92\"></a>Creates a new Preset from the indexed View Panel specified by the first argument.\n               \n               		\n            </p> \n            <p><a name=\"GUID-21104C7D-7A77-45AF-ACAE-37EF825486C8\"></a>The Preset will be named according to the second argument. \n               		\n            </p> \n            <p><a name=\"GUID-18389B43-2608-4171-9540-70552528C129\"></a>Returns True on success, False on failure. \n               		\n            </p> \n            <p><a name=\"GUID-1AA412F9-21C2-41A6-B174-C6E589D9CBB9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.RenameViewPanelPreset</em> &lt;string&gt;presetName &lt;string&gt;newName</pre></div> \n            <p><a name=\"GUID-52F57CE7-C85A-4036-9D39-4D41733DA8DD\"></a>Renames the View Panel Preset specified by the first argument to the name given by\n               the second argument. \n               		\n            </p> \n            <p><a name=\"GUID-AC24A6CC-4612-4A6A-8619-119D8AD344E5\"></a>Returns True if the renaming succeeded. \n               		\n            </p> \n            <p><a name=\"GUID-A108ED80-7683-4815-BF8F-CFE18ADDD9D5\"></a>Returns False if a Preset with the name specified by the first argument does not exist.\n               \n               		\n            </p> \n            <p><a name=\"GUID-83DDCDDE-FFCC-4AFD-8C1C-2166FC39A52D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.DeletePreset</em> &lt;string&gt;presetName</pre></div> \n            <p><a name=\"GUID-F3E13B59-B9D3-4521-A3D1-EA89F97B4458\"></a>Deletes the named View Panel Preset. \n               		\n            </p> \n            <p><a name=\"GUID-5F1F8C5D-5DB0-4EE5-92CC-35D80FE13ADC\"></a>Returns True on success. \n               		\n            </p> \n            <p><a name=\"GUID-12EE4393-489A-470D-A4C8-B34C5A3DB4A5\"></a>Returns False if the named Preset does not exist. \n               		\n            </p> \n            <p><a name=\"GUID-2AB72CAB-A955-40E6-A863-C733A6E5AA14\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">ViewPanelManager.DeleteAllViewPanelPresets()</em></pre></div> \n            <p><a name=\"GUID-4053556B-1696-42E8-8B23-6E4F597D2263\"></a>Deletes all View Panel Presets. \n               		\n            </p> \n            <p><a name=\"GUID-FD47DB7E-5458-44E9-A6BA-437866D86382\"></a>Returns True on success, False on failure. \n               		\n            </p> \n            <p><a name=\"GUID-F1121F65-1D5F-4E61-9A69-801A7CFD37D3\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> <a name=\"TABLE_06B19848776440DD900F43DB8AFBA02F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-3BB30E2F-FB29-4FD4-8634-DCE3CE1784ED\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\ntheNewPresetName = \"Just A Test\"\n--&gt; \"Just A Test\"\nif not ViewPanelManager.DoesViewPanelPresetExist theNewPresetName do \n  ViewPanelManager.CreatePresetFromActiveViewPanel theNewPresetName\n--&gt; true\nViewPanelManager.RenameViewPanelPreset theNewPresetName \"A Test Indeed\"\n--&gt; true\ntheCount = ViewPanelManager.GetPresetCount()\n--&gt; 1\nfor i = 1 to theCount do\n(\n  theName = ViewPanelManager.GetPresetName i\n  theLayout = ViewPanelManager.GetViewPanelPresetLayout i\n  format \"% Name:\'%\' Layout:\'%\' \\n\" i theName theLayout\n)\n--&gt; 1 Name:\'A Test Indeed\' Layout:\'-1\' \n--&gt; OK\nViewPanelManager.DeletePreset theNewPresetName\n--&gt; false\nViewPanelManager.DeletePreset \"A Test Indeed\"\n--&gt; true\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_BF2996CD338D4C6A860C8921D45F6E97\"></a> \n            <h2><a name=\"GUID-48D66ABE-60F4-430D-9063-BF048B4C50F3\"></a>Floating Viewport Management\n            </h2> \n            <p><img src=\"../images/GUID-21C87158-BBA7-4B63-B8F7-CB9BA17CA2CA-low.gif\"> <span class=\"char_link\"><a href=\"GUID-F90290FA-90A2-4720-B9FE-A4CCE0446252.htm\">NEW</a></span><em class=\"strong\"> in 3ds Max 2020.1 Update:</em> These functions expose floating viewport functionality. \n               		\n            </p> \n            <p>Note that floating viewports are actually independent View Panels, that by default\n               have a four viewport layout with the perspective view maximized (though this can be\n               changed in the \n               		  <em class=\"strong\">Viewport Configuration</em> dialog). They are always present, and so will show up in the value returned by \n               		  <span class=\"code\">getViewPanelCount()</span>, but not always visible. \n               		\n            </p> \n            <div><a name=\"GUID-25B8E0A9-6EFD-471F-A42D-2AB5CC8D4E30\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>All indices passed as parameters or returned by methods are 0-based. \n                  		\n               </div>\n            </div> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">IsViewPanelVisible</em> &lt;index&gt;Index	</pre></div> \n            <p>Returns whether the view panel specified by index is visible. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">IsViewPanelFloating</em> &lt;index&gt;Index</pre></div> \n            <p>Returns whether the view panel specified by index is a floating viewport. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;enum&gt;<em class=\"codeEmphasisStrong\">GetViewPanelFloatingID</em> &lt;index&gt;Index\nGetViewPanelFloatingID enums: {#Not_Floating|#Floating_ViewPanel_1|#Floating_ViewPanel_2|#Floating_ViewPanel_3}</pre></div> \n            <p>Returns the ID of the view panel specified by index, or \n               		  <span class=\"code\">#Not_Floating</span> if it is not a floating view panel. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;index&gt;<em class=\"codeEmphasisStrong\">GetViewPanelIndexFromFloatingID</em> &lt;enum&gt;ViewPanelfloatingID \nViewPanelfloatingID enums: {#Not_Floating|#Floating_ViewPanel_1|#Floating_ViewPanel_2|#Floating_ViewPanel_3}</pre></div> \n            <p>Returns the view panel index of the view panel specified by ID, or -1 for \n               		  <span class=\"code\">#Not_Floating</span>. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">GetNumFloatingViewPanels</em>()</pre></div> \n            <p>Returns the number of possible floating View Panels. Note that this is not the same\n               as the number of visible View Panels. Currently this method always returns 3. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">HideAllFloatingViewPanels</em>()</pre></div> \n            <p>Makes all visible floating view panels not visible. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">SetFloatingViewPanelVisibility</em> &lt;enum&gt;ViewPanelfloatingID &lt;bool&gt;bVisible\nViewPanelfloatingID enums: {#Not_Floating|#Floating_ViewPanel_1|#Floating_ViewPanel_2|#Floating_ViewPanel_3}</pre></div> \n            <p>Sets the visibility of the view panel specified by ID. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">GetNumViewportsFromAllVisibleViewPanels</em>()</pre></div> \n            <p>Returns the number of all visible viewports, including those on floating viewports.\n               To get a count of all view panels (including visible and non-visible floating view\n               panels), use \n               		  <span class=\"code\">GetViewPanelCount()</span>. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">GetNumVisibleViewPanels</em>()</pre></div> \n            <p>Returns the number of all visible View Panels. \n               		\n            </p> <a name=\"TABLE_DF6E549A39E2457C90D2058A9F62D542\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\n-- Floating View Panels example\n-- hide any visible floating viewports first\nViewPanelManager.HideAllFloatingViewPanels()\n\n-- This will be 3, whether they are visible or not:\nViewPanelManager.GetNumFloatingViewPanels()\n\n-- How many view panels and viewports are visible?\nvis_panels = ViewPanelManager.GetNumVisibleViewPanels()\nvis_ports = ViewPanelManager.GetNumViewportsFromAllVisibleViewPanels()\nformat \"% visible viewports on % visible view panels\\n\" vis_ports vis_panels\n\ncount = ViewPanelManager.GetViewPanelCount()\nformat \"% View Panels (visible and/or floating)\" count\n\nfor i = 1 to count do (\n	vp_name = ViewPanelManager.GetViewPanelName i\n	vp_visible = ViewPanelManager.IsViewPanelVisible i\n	vp_floating = ViewPanelManager.IsViewPanelFloating i\n	format \"View Panel % name:%\\n visible:%\\n floating:%\\n\" i vp_name vp_visible vp_floating\n	-- let\'s make all the floating ones visible\n	if vp_floating do ViewPanelManager.SetActiveViewPanel i		\n	)\n	\n-- The id of the first floating viewpanel\nvp_id = #Floating_ViewPanel_1\n	\n-- hide it\nformat \"Hiding %\\n\" vp_id\nViewPanelManager.SetFloatingViewPanelVisibility vp_id false\n	\n-- change the layout of Floating Viewport 3	\nindexOfFloatingVP3 = ViewPanelManager.GetViewPanelIndexFromFloatingID #Floating_ViewPanel_3\nViewPanelManager.SetActiveViewPanel indexOfFloatingVP3\nviewport.setLayout #layout_3vl\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";