var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-3F1E2379-5CE4-4E2A-AD24-ED5BBE9BFC24\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"PluginPackageManager\">\n      <meta name=\"indexterm\" content=\"ExchangeStorePackageManager\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: PluginPackageManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3F1E2379-5CE4-4E2A-AD24-ED5BBE9BFC24\"></a><div class=\"head\">\n            <h1>Interface: PluginPackageManager</h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3E3F\"></a> This Core Interface provides MAXScript access to the Plugin Package Manager that\n            handles plug-ins packaged in the Autodesk Bundle format. \n            	 \n         </p>\n         <p><a name=\"GUID-68F4D6AE-2F81-4FC0-8764-448E9BEA99F9\"></a>Available in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>. \n            	 \n         </p>\n         <div><a name=\"GUID-7892A73F-97A9-42F9-9FD7-E213E7C768FB\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This interface was introduced in \n               		<em class=\"strong\">3ds Max 2014</em> as \n               		<span class=\"code\">ExchangeStorePackageManager</span>. It was renamed in \n               		<em class=\"strong\">3ds Max 2020</em> to \n               		<span class=\"code\">PluginPackageManager</span>. However, a global variable named \n               		<span class=\"code\">ExchangeStorePackageManager</span> points to the re-named interface to prevent older scripts from breaking.\n               	 \n            </div>\n         </div>\n         <p><a name=\"GUID-73EF0F69-D517-45C0-BD60-5F73DEC8F86C\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetNativePlugInCount</em>()</pre></div>\n         <p><a name=\"GUID-0C990EEE-1C6D-4B81-B016-A5CA1019F582\"></a>Returns the number of native plugins. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetNativePlugInFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-4ECA1F00-CFBA-43AE-BB1B-91FB11CA3AFF\"></a>Returns the full file name of the indexed native plugin. \n            	 \n         </p>\n         <p><a name=\"GUID-9C9B8E94-2F83-4228-9D58-22ACA233AE20\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetManagedAssemblyCount</em>()</pre></div>\n         <p><a name=\"GUID-95C869FC-71A1-4760-823C-0486C7F6B93E\"></a>Returns the number of managed assemblies. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetManagedAssemblyFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-AF65A724-81B1-4D75-AB90-77799EF6206E\"></a>Returns the full file name of the indexed managed assembly. \n            	 \n         </p>\n         <p><a name=\"GUID-D16C23EE-56C1-4C66-B81E-8D436E5AFEC2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetUISchemeCount</em>()</pre></div>\n         <p><a name=\"GUID-6ACC5BFD-EDE7-46AC-AFEE-71EE5F99CC04\"></a>Returns the number of UI Schemes. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetUISchemeFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-3CED25A5-C12B-47D1-B5A2-49894DE0669C\"></a>Returns the full file name of the indexed UI Schemes. \n            	 \n         </p>\n         <p><a name=\"GUID-013E3127-FD21-41D8-A145-01DDED18AE8F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetDefaultSettingCount</em>()</pre></div>\n         <p><a name=\"GUID-DC245974-437C-42F9-93B6-26C68AD073DF\"></a>Returns the number of Default Settings. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetDefaultSettingFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-1A374BBD-7768-41FC-9855-5EA14B55F033\"></a>Returns the full file name of the indexed Default Setting. \n            	 \n         </p>\n         <p><a name=\"GUID-75285423-806B-4FBB-9859-24C40465832A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetMaxscriptsCount</em>()</pre></div>\n         <p><a name=\"GUID-68E6BF74-856B-4E77-9B4E-3495D8FA423D\"></a>Returns the number of MAXScripts. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetMaxscriptsFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-DE00596B-FDBD-4EB8-BD24-744FBBB0FE12\"></a>Returns the full file name of the indexed MAXScript. \n            	 \n         </p>\n         <p><a name=\"GUID-C8B6D07C-F7F6-48A5-8DD2-833088C7C05B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetMacroscriptsCount</em>()</pre></div>\n         <p><a name=\"GUID-CC149E41-199D-4257-B438-FBC2D7F59044\"></a>Returns the number of MacroScripts. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetMacroScriptsFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-4701F44F-A6A2-4381-99CC-9F5AF69DE48C\"></a>Returns the full file name of the indexed MacroScript. \n            	 \n         </p>\n         <p><a name=\"GUID-456D58BB-CCF7-40B5-93CF-1278A22C4992\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetPostStartUpScriptsCount</em>()</pre></div>\n         <p><a name=\"GUID-DBF108E4-A482-44D9-8150-DC16CEC28B84\"></a>Returns the number of Startup Scripts. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetPostStartUpScriptFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-11AE9AC1-8217-4964-85A1-3FF335AFA64A\"></a>Returns the full file name of the indexed Startup Script. \n            	 \n         </p>\n         <p><a name=\"GUID-7F72F3B8-5AD5-4585-BEFD-0F09974254B4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetMetaSLShaderPathCount</em>()</pre></div>\n         <p><a name=\"GUID-B95EEA38-280C-48E9-8BE1-FA080C7B842A\"></a>Returns the number of MetaSL Shaders. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetMetaSLShaderFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-C90C813E-F73C-4363-836D-C250D56F61C3\"></a>Returns the full file name of the indexed MetaSL Shader. \n            	 \n         </p>\n         <p><a name=\"GUID-373910C4-7B8A-4F8C-B0B6-E29A7A0B5A18\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetMiFileCount</em>()</pre></div>\n         <p><a name=\"GUID-C0ED01A5-FE81-4022-865B-82072DA329F5\"></a>Returns the number of .mi files. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetMiFileFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-97C9C2CE-852E-40D9-BDFE-CEA5BC06ABB7\"></a>Returns the full file name of the indexed .mi file. \n            	 \n         </p>\n         <p><a name=\"GUID-A2BEC040-203E-4337-B050-20B0301AAE40\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetLightIconPathsCount</em>()</pre></div>\n         <p><a name=\"GUID-D24C6C75-54BE-4908-A1D8-E9AF23F2EBC8\"></a>Returns the number of light icon paths. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetLightIconPathFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-2CE63B32-A8AC-4183-8151-654578F63187\"></a>Returns the full file name of the indexed light icon path. \n            	 \n         </p>\n         <p><a name=\"GUID-4159B962-4C3A-47EF-90D8-031822337F97\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetDarkIconPathsCount</em>()</pre></div>\n         <p><a name=\"GUID-5D8DC13F-3200-4782-9606-8D6C83F4CA5F\"></a>Returns the number of dark icon paths. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetDarkIconPathFullPath</em> &lt;index&gt;index</pre></div>\n         <p><a name=\"GUID-6E750A24-4855-4D05-8C5B-CB2D7039F972\"></a>Returns the full file name of the indexed dark icon path. \n            	 \n         </p>\n         <p><a name=\"GUID-6E9DAE16-93CD-4DA4-8D61-939B926B80DC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.ProcessCustomInstallDirectory</em> &lt;filename&gt;path</pre></div>\n         <p>Processes the given custom install directory filepath. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">PluginPackageManager.GetPackageInstallPathByUpgradeCode</em> &lt;string&gt;upgradeCode</pre></div>\n         <p><img src=\"../images/GUID-21C87158-BBA7-4B63-B8F7-CB9BA17CA2CA-low.gif\"> <span class=\"char_link\"><a href=\"GUID-F90290FA-90A2-4720-B9FE-A4CCE0446252.htm\">NEW</a></span><em class=\"strong\"> in 3ds Max 2020:</em> Returns the install path associated with the plugin package with the specified \n            		<span class=\"code\">upgradeCode</span>. \n            	 \n         </p>\n         <div><a name=\"GUID-DD07FFCF-4E45-4687-9A5D-43B7D08E13A6\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This function replaces the undocumented \n               		<span class=\"code\">pathConfig.GetExchangeStorePlugInInstallPath &lt;string&gt;productCode</span> which used the product code as the key. \n               	 \n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";