var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-3F328EC6-88EF-4EE9-AE79-ADC3F629716D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"using\">\n      <meta name=\"indexterm\" content=\"language\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Using the MAXScript Documentation</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3F328EC6-88EF-4EE9-AE79-ADC3F629716D\"></a><div class=\"head\">\n            <h1>Using the MAXScript Documentation </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC395F\"></a>  This reference is written primarily for artists learning MAXScript. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3963\"></a>The topics are organized with the introductory material presented first, then descriptions\n            of the MAXScript syntax and grammar, followed by a description of creating, accessing,\n            and modifying the various \n            		<em class=\"strong\">3ds Max</em> objects. These \n            		<em class=\"strong\">3ds Max</em> objects include geometry objects, modifiers, controllers, materials, textures, and\n            render effects. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3964\"></a>The MAXScript tools are then described, followed by descriptions of the methods for\n            interacting with the \n            		<em class=\"strong\">3ds Max</em> user interface, accessing external files, and establishing notifications to a script\n            when an object or \n            		<em class=\"strong\">3ds Max</em> state changes. Throughout these topics, the purpose and syntax of the commands in\n            the MAXScript language are described. \n            	 \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3965\"></a> \n            <h2><a name=\"GUID-50A0BEF4-D852-4019-946F-CD62E8A06596\"></a>For New Users\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3966\"></a>Although it’s helpful to have programming experience, the basic aspects of MAXScript\n               do not require this or an in-depth understanding of the structure underlying \n               		  <em class=\"strong\">3ds Max</em>. Concepts presented in one topic do assume a basic understanding of the concepts\n               presented in earlier topics. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3967\"></a>At the very least, the topics in the \"Learning MAXScript\" chapter and the topics up\n               to and including \n               		  <span class=\"char_link\"><a href=\"GUID-798DBAF9-7171-457A-95EE-FC8F2062CCBD.htm\">Controlling Program Flow</a></span> in the \"MAXScript Language Reference\" chapter should be read in order. By reading\n               the topics in order, you will learn the MAXScript language starting with the basics,\n               and work your way toward writing full-featured MAXScript utilities. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3968\"></a>In the later sections, features and techniques are presented for programmers with\n               more advanced programming experience. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3969\"></a>For those new to MAXScript, \n               		  <span class=\"char_link\"><a href=\"GUID-4C14F474-CD23-4001-93DF-0F0F9A6025C7.htm\">Learning MAXScript</a></span> provides an introduction to the features, syntax, and practical applications of MAXScript.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC396A\"></a>Users who only intend to use MAXScript tools written by 3rd parties without learning\n               the language itself will find the \n               		  <span class=\"char_link\"><a href=\"GUID-35CB7918-A86D-465E-AC63-3AAE310A113B.htm\">MAXScript for New and Casual Users</a></span> topics useful. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC396B\"></a> \n            <h2><a name=\"GUID-842A907F-46BD-4FD2-9150-EE74C521DA38\"></a>For Existing Users\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC396D\"></a>The index topic \n               		  <span class=\"char_link\"><a href=\"GUID-4C90C00E-BF1E-4E46-B30D-E1D513C600D5.htm\">New in MAXScript</a></span> provides links to topics documenting the changes to MAXScript in the current and\n               previous releases. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC396E\"></a> \n            <h2><a name=\"GUID-B1E3F9FA-35C0-4021-AD80-08442DBF1354\"></a>Tutorials, Examples, FAQs\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC396F\"></a>This document also features a set of \n               		  <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To - Practical Examples</a></span> which can be used as tutorials or as starting point for own script development, and\n               an index of \n               		  <span class=\"char_link\"><a href=\"GUID-6B55BDA6-7A44-4910-9650-C65CA1457343.htm\">Online Help Script Examples</a></span> listing useful scripts located inside of various topics. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3970\"></a>The \n               		  <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> chapter provides links to relevant topics and solutions to real-world problems based\n               on questions by users. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3971\"></a> \n            <h2><a name=\"GUID-547BCB80-E850-4639-AB5B-BC16A43B4E64\"></a>MAXScript Extensions\n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3972\"></a>Several chapters have been dedicated to MAXScript Extensions incl. \n               		  <span class=\"char_link\"><a href=\"GUID-591A4DF8-3CA5-4ECD-BEB9-9EC247F51C60.htm\">character studio</a></span>, \n               		  <span class=\"char_link\"><a href=\"GUID-B63E19A0-DD0A-4B95-BBBD-3D41894C49BE.htm\">Particle Flow</a></span>, \n               		  <span class=\"char_link\"><a href=\"GUID-9E9940D5-36A3-470B-BD76-71EF29F4AC15.htm\">Cloth</a></span>, \n               		  <span class=\"char_link\"><a href=\"GUID-CCE212C8-DCD9-41F2-87FF-2F1CA1A071BC.htm\">Hair&amp;Fur</a></span>, \n               		  <span class=\"char_link\"><a href=\"GUID-BD83BF8F-9E14-4CDD-AAAD-3554CA8085DA.htm\">ProBoolean</a></span>, \n               		  <span class=\"char_link\"><a href=\"GUID-7DDD5571-7928-4573-83F8-80639C2A3A23.htm\">ProSound</a></span> etc. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3973\"></a>Although these plugins are now part of the shipping version of \n               		  <em class=\"strong\">3ds Max</em>, they all started as add-ons and were often developed by external teams, leading\n               to some individual flavors of the MAXScript exposure and own internal logic and structure\n               of classes and interfaces. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3974\"></a>For that reason, their documentation is provided in separate chapters under \"MAXScript\n               Extensions\" that are mostly self-contained and can be seen as mini-help files within\n               the large one. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3975\"></a> \n            <h2><a name=\"GUID-B60948A9-A191-4B6F-AED7-0F7E48E16375\"></a> <em class=\"strong\">Quick Navigation Index Pages</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3976\"></a>For the most frequently used sections of the MAXScript Reference, a set of Quick Navigation\n               index pages has been developed. These pages can be accessed by clicking on the Quick\n               Navigation links placed on relevant topics and provide shortcuts to other topics related\n               to the current one. Each index page also provides an icon leading back to the \n               		  <span class=\"char_link\"><a href=\"\">Quick Navigation - Main Index</a></span> which is the \"hub\" for fast access to the information needed most often. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3977\"></a>In addition, the \n               		  <span class=\"char_link\"><a href=\"\">Locating Information in this Help File</a></span> chapter provides several Topic Index pages for easier access to information related\n               to common scripting tasks like creating MAXScript Tools, accessing geometry data,\n               rendering etc. \n               		\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";