var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-409D100A-02E1-4539-B847-C3F6DFE6A66B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Develop a Bitmap Painting Tool\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop a Bitmap Painting Tool - 3D Painting</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-409D100A-02E1-4539-B847-C3F6DFE6A66B\"></a><div class=\"head\">\n            <h1>How To ... Develop a Bitmap Painting Tool - 3D Painting </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2D52\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2D53\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-FA2D9E9C-90EA-4E95-926E-29BB2FA416FA.htm\">Develop a Bitmap Painting Tool</a></span>- 3D Painting \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2D55\"></a>In this even more exciting step of the Bitmap Painting tool development, we will add\n            the option to directly paint on a scene object in the<em class=\"strong\"> 3ds Max</em> viewports. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2D57\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2D58\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2D59\"></a><p class=\"table-body\">We will add a new checkbutton to the User Interface to enable and disable the 3D Painting.\n                        \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2D5A\"></a><p class=\"table-body\">We will define a couple of simple functions using <span class=\"char_link\"><a href=\"GUID-01A9145F-54A0-4283-93BD-6F942C118E6C.htm\">thePainterInterface</a></span> to control the brush in the viewport, read the UV coordinates of the faces it is\n                        painting, and draw in the corresponding area of the bitmap. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2D5C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2D5D\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63A1\"></a><pre>\nmacroScript MicroPaint category: \"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry(destroyDialog MicroPaint_CanvasRollout)catch()\nlocal isErasing = isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal bitmapx_1 = bitmapx-1\nlocal bitmapy_1 = bitmapy-1\n&nbsp;\nlocal temp_bitmap_filename = (getDir #preview +\"/microPaint_temp.tga\")\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white filename:temp_bitmap_filename\nlocal theBackgroundBitmap = bitmap bitmapX bitmapY color:white\nlocal currentPos = lastPos = [0,0]\nlocal theChannel = 1\nlocal theObj = undefined\n&nbsp;\nlocal bary = [0,0,0]\nlocal faceIndex = 1\n&nbsp;\nrcMenu CanvasMenu\n(\n  subMenu\"File\"\n  (\n    menuItem new_menu \"New\"\n    menuItem open_menu \"Open...\"\n    menuItem save_as \"Save As...\"\n    separator file_menu_1\n    menuItem quit_tool \"Quit\"&nbsp;&nbsp;\n  )\n  subMenu\"Edit\"\n  (\n    menuItem commit_menu \"Commit Changes\"\n    separator edit_menu_1\n    menuItem uv_menu \"Get UV Coordinates...\"\n    menuItem paint3d_menu \"Toggle 3D Painting...\"\n  )\n  on commit_menu picked do copy theCanvasBitmap theBackgroundBitmap\n&nbsp;\n  on uv_menu picked do MicroPaint_CanvasRollout.unwrapTexture()\n  on paint3d_menu picked do MicroPaint_CanvasRollout.startPainting3D()\n\n  subMenu\"Help\"\n  (\n    menuItem about_tool \"About MicroPaint...\"&nbsp;\n  )\n&nbsp;\n  on new_menu picked do\n  (\n    theBackgroundBitmap = theCanvasBitmap = bitmap bitmapX bitmapY color:MicroPaint_CanvasRollout.paperColor.color filename:temp_bitmap_filename\n    MicroPaint_CanvasRollout.theCanvas.bitmap = theCanvasBitmap\n  )\n&nbsp;\n  on open_menu picked do\n  (\n    theOpenBitmap= selectBitmap()\n    if theOpenBitmap != undefined do\n    (\n      copy theOpenBitmap theCanvasBitmap\n      copy theOpenBitmap theBackgroundBitmap\n      close theOpenBitmap\n      MicroPaint_CanvasRollout.theCanvas.bitmap = theCanvasBitmap\n    )\n  )\n&nbsp;\n  on save_as picked do\n  (\n    theSaveName = getSaveFileName types:\"BMP (*.bmp)|*.bmp|Targa (*.tga)|*.tga|JPEG (*.jpg)|*.jpg\"\n    if theSaveName != undefined do\n    (\n      theCanvasBitmap.filename = theSaveName\n      save theCanvasBitmap\n      theCanvasBitmap.filename = temp_bitmap_filename\n    )\n  )\n  on about_too lpicked do messagebox \"MicroPaint\\nMAXScript Tutorial\" title:\"About...\"\n  on quit_tool picked do destroyDialog MicroPaint_CanvasRollout\n)\n&nbsp;\n&nbsp;\nfn mesh_filter obj = superclassof obj == GeometryClass and classof obj != TargetObject\n&nbsp;\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\n  bitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap\n  colorpicker inkColor height:16 modal:false color:black across:6\n  colorpicker paperColor height:16 modal:false color:white\n  checkbutton autoSave \"AutoSave\" width:70 offset:[0,-3] highlightcolor:(color 255 200 200)\n  checkbutton airBrush \"AirBrush\" width:70 offset:[0,-3] highlightcolor:(color 200 255 200)\n  spinner AirBrushSpeed \"Speed\" range:[0.1,50,10] fieldwidth:30\n  spinner BrushSize \"Size\" range:[1,50,1] type:#integer fieldwidth:40\n  listbox BrushShape items:#(\"Circle\",\"Box\",\"Circle Smooth\") pos:[bitmapX+5,0] width:90\n&nbsp;\n  pickbutton pickMesh \"Pick Mesh\" width:90 height:30 highlightcolor:(color 200 200 255) pos:[bitmapX+5,140] filter:mesh_filter autodisplay:true\n&nbsp;\n  on pickMesh picked obj do\n  (\n    if obj != undefined do\n  &nbsp;&nbsp;(\n&nbsp;&nbsp;  &nbsp; theObj = Obj\n &nbsp;&nbsp;&nbsp;  try\n  &nbsp; &nbsp;&nbsp;(\n  &nbsp;&nbsp;  &nbsp;&nbsp;copy theObj.material.diffusemap.bitmap theCanvasBitmap\n    &nbsp;&nbsp;&nbsp;&nbsp;copy theObj.material.diffusemap.bitmap theBackgroundBitmap\n  &nbsp;&nbsp;  &nbsp;&nbsp;theCanvas.bitmap = theCanvasBitmap\n   &nbsp;&nbsp;&nbsp;)catch()&nbsp;\n  &nbsp;&nbsp;)&nbsp;\n  )&nbsp;\n&nbsp;\n  checkbutton paint3D \"3D PAINT\" width:90 height:50 highlightcolor:(color 200 200 255) pos:[bitmapX+5,180]\n&nbsp;\n  fn paintBrush pos =\n  (\n    if isErasing then\n      thePaintColor = (getPixels theBackgroundBitmap pos 1)[1]\n    else\n      thePaintColor = inkColor.color\n    if thePaintColor == undefined then thePaintColor = white\n&nbsp;\n    case BrushShape.selection of\n    (\n      1: (\n        if distance pos currentPos &lt;= BrushSize.value/2 do\n          setPixels theCanvasBitmap pos #(thePaintColor)\n      )\n      2: setPixels theCanvasBitmap pos #(thePaintColor)\n      3: (\n        theFactor = (distance pos currentPos) / (BrushSize.value/2.0)\n        if theFactor &lt;= 1.0 do\n        (\n          theFactor = sin ( 90.0 * theFactor)\n          thePixels = getPixels theCanvasBitmap pos 1\n          if thePixels[1] != undefined do\n          (\n            thePixels[1] = (thePixels[1] * theFactor) + (thePaintColor * (1.0 - theFactor))\n            setPixels theCanvasBitmap pos thePixels\n          )\n        )\n      )--end case 3\n    )--end case\n  )--end fn\n&nbsp;\n  fn drawStroke lastPos pos drawIt: =\n  (\n    currentPos = lastPos\n    deltaX = pos.x - lastPos.x\n    deltaY = pos.y - lastPos.y\n    maxSteps = amax #(abs(deltaX),abs(deltaY))\n    deltaStepX = deltaX / maxSteps\n    deltaStepY = deltaY / maxSteps\n    for i = 0 to maxSteps do\n    (\n      if airBrush.checked then\n        for b = 1 to (BrushSize.value / AirBrushSpeed.value) do\n          paintBrush (currentPos + (random [-BrushSize.value/2,-BrushSize.value/2] [BrushSize.value/2,BrushSize.value/2] ))\n      else\n        for b = -BrushSize.value/2 to BrushSize.value/2 do\n          for c = -BrushSize.value/2 to BrushSize.value/2 do\n            paintBrush (currentPos + [c,b])\n      currentPos += [deltaStepX, deltaStepY]\n    )\n    if drawIt== true or drawIt == unsupplied do theCanvas.bitmap = theCanvasBitmap\n  )\n&nbsp;\n  fn unwrapTexture =\n  (\n    if theObj != undefined then\n    (\n      theMesh = snapshotAsMesh theObj\n      if meshop.getMapSupport theMesh theChannel do\n      (\n        faceCount = meshop.getNumMapFaces theMesh theChannel\n        for f = 1 to faceCount do\n        (\n          theFace = meshop.getMapFace theMesh theChannel f\n          vert1= meshop.getMapVert theMesh theChannel theFace.x\n          vert2= meshop.getMapVert theMesh theChannel theFace.y\n          vert3= meshop.getMapVert theMesh theChannel theFace.z\n&nbsp;\n          drawStroke [vert1.x * bitmapx_1, bitmapy_1 - vert1.y * bitmapy_1] [vert2.x * bitmapx_1, bitmapy_1 - vert2.y * bitmapy_1] drawIt:false\n          drawStroke [vert1.x * bitmapx_1, bitmapy_1 - vert1.y * bitmapy_1] [vert3.x * bitmapx_1, bitmapy_1 - vert3.y * bitmapy_1] drawIt:false\n          drawStroke [vert3.x * bitmapx_1, bitmapy_1 - vert3.y * bitmapy_1] [vert2.x * bitmapx_1, bitmapy_1 - vert2.y * bitmapy_1] drawIt:false\n        )\n      )&nbsp;\n      theCanvas.bitmap = theCanvasBitmap\n      save theCanvasBitmap\n      if theObj.material == undefined do theObj.material = Standard()\n      if theObj.material.diffusemap == undefined do\n      theObj.material.diffusemap = bitmapTexture filename:temp_bitmap_filename\n      showTextureMap theObj.material true\n      autoSave.checked = true\n    )\n  )\n&nbsp;\n&nbsp;\n  fn StartStroke = ( thePainterInterface.undoStart() )\n  fn PaintStroke =\n  (\n    theMesh = theObj.mesh\n    thePainterInterface.getHitFaceData &amp;bary &amp;faceIndex theObj 0\n    theFace = meshop.getMapFace theMesh theChannel faceIndex\n    vert1= meshop.getMapVert theMesh theChannel theFace.x\n    vert2= meshop.getMapVert theMesh theChannel theFace.y\n    vert3= meshop.getMapVert theMesh theChannel theFace.z\n    thePoint = bary.x*vert1 + bary.y*vert2 + bary.z*vert3\n    drawStroke [thePoint.x * bitmapx_1, bitmapy_1 - thePoint.y * bitmapy_1] [thePoint.x * bitmapx_1, bitmapy_1 - thePoint.y * bitmapy_1]\n    thePainterInterface.clearStroke()\n  )\n  fn EndStroke =\n  (\n    thePainterInterface.undoAccept()\n    if autoSave.checked do\n    (\n      save theCanvasBitmap\n      try(theObj.material.diffsemap.bitmap = theCanvasBitmap)catch()\n    )&nbsp;\n  )\n&nbsp;\n  fn CancelStroke = (thePainterInterface.undoCancel())\n&nbsp;\n  fn SystemEndPaintSession = ( paint3D.checked = false )\n&nbsp;\n  fn startPainting3D =\n  (\n    if thePainterInterface.InPaintMode() or theObj == undefined then\n    (\n      thePainterInterface.EndPaintSession()\n      paint3D.checked = false\n    )\n    else\n    (\n      paint3D.checked = true\n      thePainterInterface.pointGatherEnable = TRUE\n      thePainterInterface.initializeNodes 0 #(theObj)\n      thePainterInterface.offMeshHitType = 2\n      thePainterInterface.ScriptFunctions startStroke paintStroke endStroke cancelStroke SystemEndPaintSession\n      thePainterInterface.startPaintSession()\n    )\n  )\n&nbsp;\n  on paint3D changed state do startPainting3D()\n&nbsp;\n  on MicroPaint_CanvasRollout lbuttondown pos do\n  (\n    lastPos = pos\n    isDrawing = true\n    isErasing = false\n    drawStroke lastPos pos\n  )\n  on MicroPaint_CanvasRollout rbuttondown pos do\n  (\n    lastPos = pos\n    isErasing = isDrawing = true\n    drawStroke lastPos pos\n  )\n  on MicroPaint_CanvasRollout lbuttonup pos do\n  (\n    isErasing = isDrawing = false\n    if autoSave.checked do save theCanvasBitmap\n  )&nbsp;\n  on MicroPaint_CanvasRollout rbuttonup pos do\n  (\n    isErasing = isDrawing = false\n    if autoSave.checked do save theCanvasBitmap\n  )&nbsp;\n  on autoSave changed state do if state do save theCanvasBitmap\n&nbsp;\n  on MicroPaint_CanvasRollout mousemove pos do\n  (\n    if isDrawing do drawStroke lastPos pos\n    lastPos = pos\n  )\n)\ncreateDialog MicroPaint_CanvasRollout (bitmapx+100) (bitmapy+30) menu:CanvasMenu\nMicroPaint_CanvasRollout.theCanvas.bitmap = theBackgroundBitmap\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2E76\"></a> \n            <h2><a name=\"GUID-F786352E-E3FE-4EDE-A3B6-B634709BD452\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-63A0\"></a><pre><em class=\"codeEmphasisMild\"><em class=\"codeEmphasisStrong\">--Code in italic has no changes since the previous version</em></em> <em class=\"codeEmphasisMild\">macroScript MicroPaint category:\"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry(destroyDialog MicroPaint_CanvasRollout)catch()\nlocal isErasing = isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal bitmapx_1 = bitmapx-1\nlocal bitmapy_1 = bitmapy-1\n\nlocal temp_bitmap_filename = (getDir #preview +\"/microPaint_temp.tga\")\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white filename:temp_bitmap_filename\nlocal theBackgroundBitmap = bitmap bitmapX bitmapY color:white\nlocal currentPos = lastPos = [0,0]\nlocal theChannel = 1\nlocal theObj = undefined</em> <em class=\"codeEmphasisStrong\">local bary = [0,0,0]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2E88\"></a>This variable will be used by the PainterInterface to return the Barycentric Coordinates\n               of the hit point inside the face. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-639F\"></a><pre><em class=\"codeEmphasisStrong\">local faceIndex = 1</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2E8A\"></a>This variable will be used by the PainterInterface to return the index of the face\n               that has been hit. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-639E\"></a><pre><em class=\"codeEmphasisMild\">rcMenu CanvasMenu\n(\nsubMenu \"File\"\n(\nmenuItem new_menu \"New\"\nmenuItem open_menu \"Open...\"\nmenuItem save_as \"Save As...\"\nseparator file_menu_1\nmenuItem quit_tool \"Quit\"&nbsp;&nbsp;\n)\nsubMenu \"Edit\"\n(\nmenuItem commit_menu \"Commit Changes\"\nseparator edit_menu_1\nmenuItem uv_menu \"Get UV Coordinates...\"</em> <em class=\"codeEmphasisStrong\">menuItem paint3d_menu \"Toggle 3D Painting...\"</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2E9C\"></a>This is the new \"Toggle 3D Painting\" menu item. We will also add a very prominent\n               button to the main User Interface... \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-639D\"></a><pre><em class=\"codeEmphasisMild\">)\non commit_menu picked do copy theCanvasBitmap theBackgroundBitmap\non uv_menu picked do MicroPaint_CanvasRollout.unwrapTexture()</em> <em class=\"codeEmphasisStrong\">on paint3d_menu picked do MicroPaint_CanvasRollout.startPainting3D()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2EA2\"></a>This is the handler of the new \"Toggle 3D Painting\" menu item. It calls a function\n               that will toggle the PainterInterface on and off. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-639C\"></a><pre><em class=\"codeEmphasisMild\">subMenu \"Help\"\n(\nmenuItem about_tool \"About MicroPaint...\"&nbsp;\n)\n\non new_menu picked do\n(\ntheBackgroundBitmap = theCanvasBitmap = bitmap bitmapX bitmapY color:MicroPaint_CanvasRollout.paperColor.color filename:temp_bitmap_filename\nMicroPaint_CanvasRollout.theCanvas.bitmap = theCanvasBitmap\n)\n&nbsp;\non open_menu picked do\n(\ntheOpenBitmap= selectBitmap()\nif theOpenBitmap != undefined do\n(\ncopy theOpenBitmap theCanvasBitmap\ncopy theOpenBitmap theBackgroundBitmap\nclose theOpenBitmap\nMicroPaint_CanvasRollout.theCanvas.bitmap = theCanvasBitmap\n)\n)\n&nbsp;\non save_as picked do\n(\ntheSaveName = getSaveFileName types:\"BMP (*.bmp)|*.bmp|Targa (*.tga)|*.tga|JPEG (*.jpg)|*.jpg\"\nif theSaveName != undefined do\n(\ntheCanvasBitmap.filename = theSaveName\nsave theCanvasBitmap\ntheCanvasBitmap.filename = temp_bitmap_filename\n)\n)\non about_tool picked do messagebox \"MicroPaint\\nMAXScript Tutorial\" title:\"About...\"\non quit_tool picked do destroyDialog MicroPaint_CanvasRollout\n)\n&nbsp;\nfn mesh_filter obj = superclassof obj == GeometryClass and classof obj != TargetObject\n\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\nbitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap\ncolorpicker inkColor height:16 modal:false color:black across:6\ncolorpicker paperColor height:16 modal:false color:white\ncheckbutton autoSave \"AutoSave\" width:70 offset:[0,-3] highlightcolor:(color 255 200 200)\ncheckbutton airBrush \"AirBrush\" width:70 offset:[0,-3] highlightcolor:(color 200 255 200)\nspinner AirBrushSpeed \"Speed\" range:[0.1,50,10] fieldwidth:30\nspinner BrushSize \"Size\" range:[1,50,1] type:#integer fieldwidth:40\nlistbox BrushShape items:#(\"Circle\", \"Box\", \"Circle Smooth\") pos:[bitmapX+5,0] width:90\n&nbsp;\npickbutton pickMesh \"Pick Mesh\" width:90 height:30 highlightcolor:(color 200 200 255) pos:[bitmapX+5,140] filter:mesh_filter autodisplay:true\n\non pickMesh picked obj do\n(\nif obj != undefined do\n(\ntheObj = Obj\ntry\n(\ncopy theObj.material.diffusemap.bitmap theCanvasBitmap\ncopy theObj.material.diffusemap.bitmap theBackgroundBitmap\ntheCanvas.bitmap = theCanvasBitmap\n)catch()\n)\n)</em> <em class=\"codeEmphasisStrong\">checkbutton paint3D \"3D PAINT\" width:90 height:50 highlightcolor:(color 200 200 255) pos:[bitmapX+5,180]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2EE9\"></a>This is the new checkbutton controlling the painting in 3D space. It will turn blue\n               when enabled. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-639A\"></a><pre><em class=\"codeEmphasisMild\">fn paintBrush pos =\n(\nif isErasing then\nthePaintColor = (getPixels theBackgroundBitmap pos 1)[1]\nelse\nthePaintColor = inkColor.color\nif thePaintColor == undefined then thePaintColor = white\n\ncase BrushShape.selection of\n(\n1: (\nif distance pos currentPos &lt;= BrushSize.value/2 do\nsetPixels theCanvasBitmap pos #(thePaintColor)\n)\n2: setPixels theCanvasBitmap pos #(thePaintColor)\n3: (\ntheFactor = (distance pos currentPos) / (BrushSize.value/2.0)\nif theFactor &lt;= 1.0 do\n(\ntheFactor = sin ( 90.0 * theFactor)\nthePixels = getPixels theCanvasBitmap pos 1\nif thePixels[1] != undefined do\n(\nthePixels[1] = (thePixels[1] * theFactor) + (thePaintColor * (1.0 - theFactor))\nsetPixels theCanvasBitmap pos thePixels\n)\n)\n)--end case 3\n)--end case\n)--end fn\n&nbsp;\nfn drawStroke lastPos pos drawIt: =\n(\ncurrentPos = lastPos\ndeltaX = pos.x - lastPos.x\ndeltaY = pos.y - lastPos.y\nmaxSteps = amax #(abs(deltaX),abs(deltaY))\ndeltaStepX = deltaX / maxSteps\ndeltaStepY = deltaY / maxSteps\nfor i = 0 to maxSteps do\n(\nif airBrush.checked then\nfor b = 1 to (BrushSize.value / AirBrushSpeed.value) do\npaintBrush (currentPos + (random [-BrushSize.value/2,-BrushSize.value/2] [BrushSize.value/2,BrushSize.value/2] ))\nelse\nfor b = -BrushSize.value/2 to BrushSize.value/2 do\nfor c = -BrushSize.value/2 to BrushSize.value/2 do\npaintBrush (currentPos + [c,b])\ncurrentPos += [deltaStepX, deltaStepY]\n)\nif drawIt== true or drawIt == unsupplied do theCanvas.bitmap = theCanvasBitmap\n)\n\non pickMesh picked obj do if obj != undefined do theObj = Obj\n\nfn unwrapTexture =\n(\nif theObj != undefined then\n(\ntheMesh = snapshotAsMesh theObj\nif meshop.getMapSupport theMesh theChannel do\n(\nfaceCount = meshop.getNumMapFaces theMesh theChannel\nfor f = 1 to faceCount do\n(\ntheFace = meshop.getMapFace theMesh theChannel f\nvert1= meshop.getMapVert theMesh theChannel theFace.x\nvert2= meshop.getMapVert theMesh theChannel theFace.y\nvert3= meshop.getMapVert theMesh theChannel theFace.z\n&nbsp;\ndrawStroke [vert1.x * bitmapx_1, bitmapy_1 - vert1.y * bitmapy_1] [vert2.x * bitmapx_1, bitmapy_1 - vert2.y * bitmapy_1] drawIt:false\ndrawStroke [vert1.x * bitmapx_1, bitmapy_1 - vert1.y * bitmapy_1] [vert3.x * bitmapx_1, bitmapy_1 - vert3.y * bitmapy_1] drawIt:false\ndrawStroke [vert3.x * bitmapx_1, bitmapy_1 - vert3.y * bitmapy_1] [vert2.x * bitmapx_1, bitmapy_1 - vert2.y * bitmapy_1] drawIt:false\n)\n)&nbsp;\ntheCanvas.bitmap = theCanvasBitmap\nsave theCanvasBitmap\nif theObj.material == undefined do theObj.material = Standard()\nif theObj.material.diffusemap == undefined do\ntheObj.material.diffusemap = bitmapTexture filename:temp_bitmap_filename\nshowTextureMap theObj.material true\nautoSave.checked = true\n)\n)</em>\n&nbsp;\n<em class=\"codeEmphasisStrong\">fn StartStroke = ( thePainterInterface.undoStart() )</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F41\"></a>This function is executed in the beginning of a stroke. See the <span class=\"char_link\"><a href=\"GUID-01A9145F-54A0-4283-93BD-6F942C118E6C.htm\">PainterInterface documentation</a></span> for details. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6399\"></a><pre><em class=\"codeEmphasisStrong\">fn PaintStroke =\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F45\"></a>This function performs the painting of a stroke in 3D. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6398\"></a><pre><em class=\"codeEmphasisStrong\">theMesh = theObj.mesh</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F47\"></a>We take a copy of the TriMesh of the object to paint on. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6397\"></a><pre><em class=\"codeEmphasisStrong\">thePainterInterface.getHitFaceData &amp;bary &amp;faceIndex theObj 0</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F49\"></a>Then we call this function to get the last face that was hit by the brush (last argument\n               is face index 0 which means \"get the last hit\"). The variables bary and faceIndex\n               we defined in the beginning of the script are passed \"by reference\" - the function\n               will write the results into them. After the call, bary will contain the Barycentric\n               coordinates of the hit point inside the face, and faceIndex will contain the index\n               of the face that was last hit. theObj is the variable containing the object we selected\n               in the scene to paint on. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6396\"></a><pre><em class=\"codeEmphasisStrong\">theFace = meshop.getMapFace theMesh theChannel faceIndex</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F4B\"></a>Using this data we get the map face in channel 1 with the same index as the mesh face\n               that was hit. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6395\"></a><pre><em class=\"codeEmphasisStrong\">vert1= meshop.getMapVert theMesh theChannel theFace.x\nvert2= meshop.getMapVert theMesh theChannel theFace.y\nvert3= meshop.getMapVert theMesh theChannel theFace.z</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F4F\"></a>Next, we read the texture vertices referenced by the map face. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6394\"></a><pre><em class=\"codeEmphasisStrong\">thePoint= bary.x*vert1 + bary.y*vert2 + bary.z*vert3\n&nbsp;drawStroke [thePoint.x * bitmapx_1, bitmapy_1 -thePoint.y * bitmapy_1] [thePoint.x * bitmapx_1, bitmapy_1 -thePoint.y * bitmapy_1]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F52\"></a>Now we can calculate the UV coordinates of the hit point using its <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm#WS73099CC142F48755-2231E4B3128F27E2F8C-336F\">barycentric coordinates</a></span> inside the face and the texture vertex coordinates corresponding to that face. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6393\"></a><pre><em class=\"codeEmphasisStrong\">thePainterInterface.clearStroke()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F54\"></a>Finally, we clear the stroke. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6392\"></a><pre><em class=\"codeEmphasisStrong\">)</em> <em class=\"codeEmphasisStrong\">fn EndStroke =</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F59\"></a>This function is called at the end of a stroke. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6391\"></a><pre><em class=\"codeEmphasisStrong\">thePainterInterface.undoAccept()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F5B\"></a>Accept the changes in the undo system. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6390\"></a><pre><em class=\"codeEmphasisStrong\">if autoSave.checked do</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F5E\"></a>If autosaving is enabled, \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-638F\"></a><pre><em class=\"codeEmphasisStrong\">save theCanvasBitmap</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F60\"></a>save the painting to disk \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-638E\"></a><pre><em class=\"codeEmphasisStrong\">try(theObj.material.diffsemap.bitmap = theCanvasBitmap)catch()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F62\"></a>and try to force the bitmap of the diffuse map channel in the object\'s material to\n               the painting bitmap value. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-638D\"></a><pre><em class=\"codeEmphasisStrong\">)&nbsp;\n)\n\nfn CancelStroke = (thePainterInterface.undoCancel())</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F67\"></a>This function is called when the stroke is canceled. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-638C\"></a><pre><em class=\"codeEmphasisStrong\">fn SystemEndPaintSession = ( paint3D.checked = false )</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F69\"></a>This function is called when the painting session ends. It will make sure the UI button\n               is unchecked if the painting is stopped for some other reason. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-638B\"></a><pre><em class=\"codeEmphasisStrong\">fn startPainting3D =\n(</em></pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-76D9\"></a>This function toggles the 3D Painting. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-638A\"></a><pre><em class=\"codeEmphasisStrong\">if thePainterInterface.InPaintMode() or theObj == undefined then\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F70\"></a>If we are already painting or the object is not selected yet, \n            </p> \n            <div class=\"codeBlock\"><a name=\"CODEBLOCK_1924A9853E2345448F8BFD7A4A2D7702\"></a><pre><em class=\"codeEmphasisStrong\">&nbsp;&nbsp;thePainterInterface.EndPaintSession()\n&nbsp;&nbsp;paint3D.checked = false</em></pre></div> \n            <p><a name=\"P_712467EC3D71425B8E37A7DE73003E62\"></a>we end the 3D painting session and uncheck the button in the UI. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6389\"></a><pre><em class=\"codeEmphasisStrong\">)&nbsp;\nelse\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F77\"></a>If the 3D paining is not active and the mesh scene object has been selected already,\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6388\"></a><pre><em class=\"codeEmphasisStrong\">paint3D.checked = true</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F79\"></a>we make sure that the checkbutton is pressed (as we can start this from the Main menu,\n               too). \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6387\"></a><pre><em class=\"codeEmphasisStrong\">thePainterInterface.pointGatherEnable = TRUE</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F7B\"></a>Enable point gathering. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6386\"></a><pre><em class=\"codeEmphasisStrong\">thePainterInterface.initializeNodes 0 #(theObj)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F7D\"></a>Initialize the PainterInterface with just the single object that was selected. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6385\"></a><pre><em class=\"codeEmphasisStrong\">thePainterInterface.offMeshHitType = 2</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F7F\"></a>Set the behavior for the cases the mesh was not hit to 2, which does not require a\n               mesh. There will be no face hit and no painting in this case. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6384\"></a><pre><em class=\"codeEmphasisStrong\">thePainterInterface.ScriptFunctions startStroke paintStroke endStroke cancelStroke SystemEndPaintSession</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F81\"></a>Register all previously defined scripted functions with the PainterInterface and \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6383\"></a><pre><em class=\"codeEmphasisStrong\">thePainterInterface.startPaintSession()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F83\"></a>start the painting. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6382\"></a><pre><em class=\"codeEmphasisStrong\">)&nbsp;\n)&nbsp;\n\non paint3D changed state do startPainting3D()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2F88\"></a>If the checkbutton was pressed by the user, call the above function. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6381\"></a><pre><em class=\"codeEmphasisMild\">on MicroPaint_CanvasRollout lbuttondown pos do\n(\nlastPos = pos\nisDrawing = true\nisErasing = false\ndrawStroke lastPos pos\n)\non MicroPaint_CanvasRollout rbuttondown pos do\n(\nlastPos = pos\nisErasing = isDrawing = true\ndrawStroke lastPos pos\n)\non MicroPaint_CanvasRollout lbuttonup pos do\n(\nisErasing = isDrawing = false\nif autoSave.checked do save theCanvasBitmap\n)&nbsp;\non MicroPaint_CanvasRollout rbuttonup pos do\n(\nisErasing = isDrawing = false\nif autoSave.checked do save theCanvasBitmap\n)&nbsp;\non autoSave changed state do if state do save theCanvasBitmap\n\non MicroPaint_CanvasRollout mousemove pos do\n(\nif isDrawing do drawStroke lastPos pos\nlastPos = pos\n)\n)\ncreateDialog MicroPaint_CanvasRollout (bitmapx+100) (bitmapy+30) menu:CanvasMenu\nMicroPaint_CanvasRollout.theCanvas.bitmap = theBackgroundBitmap\n)</em></pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FAE\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FAF\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FB1\"></a> <img src=\"../images/GUID-76F7EB0D-5D9A-494B-BD95-650873293731-low.gif\"> <img src=\"../images/GUID-1B50C09C-B5FD-4859-BB44-DC8F5AABBF7F-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FB2\"></a>You can paint on both the 3D object and the 2D image at the same time. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FB4\"></a> <em class=\"strong\">Previous Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FB5\"></a> <span class=\"char_link\"><a href=\"GUID-8ECDE2E0-2C77-4191-9710-C527D95F763E.htm\">How To ... Develop a Bitmap Painting Tool - Unwrap UV Coordinates</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FB7\"></a> <span class=\"char_link\"><a href=\"GUID-01A9145F-54A0-4283-93BD-6F942C118E6C.htm\">thePainterInterface</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2FB8\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";