var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-41314BEF-A7C5-4525-AF73-B826194A4965\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"getClassInstances\">\n      <meta name=\"indexterm\" content=\"getClassCounts()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>getClassInstances</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-41314BEF-A7C5-4525-AF73-B826194A4965\"></a><div class=\"head\">\n            <h1>getClassInstances </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72D9\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72D8\"></a> The \n               		  <em class=\"strong\">getClassInstances</em> function available in \n               		  <em class=\"strong\">3ds Max 7 and higher</em> returns an array of all instances of a specified class that exist in a scene. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72D6\"></a>It was previously available through the \n               		  <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard</a></span> DLX 3rd party MAXScript extension. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72D4\"></a> Until \n               		  <em class=\"strong\">3ds Max 2011</em>, the function was looking for the class instances by enumerating the animatable tree.\n               There are many cases where the subAnims of an object are a subset of the references\n               held by an object, so instances present in the scene were being missed. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72D3\"></a>Starting with \n               		  <em class=\"strong\">3ds Max 2011</em>, \n               		  <span class=\"code\"> <em class=\"strong\">getClassInstances()</em> </span> can search for class instances in a variety of ways depending on its arguments, including\n               the two new ones: \n               		  <span class=\"code\"> <em class=\"strong\">processAllAnimatables:</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">processChildren:</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72D1\"></a>The syntax is: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D4C\"></a><pre><em class=\"codeEmphasisStrong\">getClassInstances</em> &lt;MAXClass&gt; <em class=\"codeEmphasisStrong\">processAllAnimatables:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">target:</em>&lt;MAXObject&gt; <em class=\"codeEmphasisStrong\">asTrackViewPick:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">processChildren:</em>&lt;bool&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72CE\"></a><span class=\"code\">&lt;MAXClass&gt;</span> specifies the class whose instances are being searched for. \n               		\n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72CD\"></a> \n               <h3><a name=\"GUID-1BEAB698-3DB2-4764-B02D-D34BE814DD37\"></a> <em class=\"strong\">processAllAnimatables:</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72CC\"></a> If \n                  			 <span class=\"code\"> <em class=\"strong\">processAllAnimatables:true</em> </span> is specified in \n                  			 <em class=\"strong\">3ds Max 2011 or higher</em>, all existing objects, even those not present in the scene, are tested to see if\n                  they are instances of the specified class. These objects include, for example, objects\n                  held only by MAXscript values. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72CB\"></a>When \n                  			 <span class=\"code\"> <em class=\"strong\">processAllAnimatables:true</em> </span> is specified, no other keyword parameters are applicable and are ignored. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72CA\"></a>The default value for this parameter is \n                  			 <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72C9\"></a> \n               <h3><a name=\"GUID-F50FF62C-887A-4BDB-ADAA-3F8A7F8CEC57\"></a> <em class=\"strong\">target:</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72C8\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">target</em> </span>: is specified, only the hierarchy for that target is searched. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72C7\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">target</em> </span>: is not specified, the entire scene under the scene root is searched. The scene in\n                  this case refers not only to the node hierarchy, but also the Material Editor, Track\n                  View, and others. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72C6\"></a> \n               <h3><a name=\"GUID-6B67EB51-23BB-4280-8A3A-1D867299A1AF\"></a> <em class=\"strong\">asTrackViewPick:</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72C5\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">asTrackViewPick:true</em> </span> is specified, each use of a class instance is returned as a \n                  			 <span class=\"char_link\"><a href=\"GUID-B3D86BDD-E947-43F3-B57B-168A1420E3FA.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-5B2B\">TrackViewPick value</a></span>. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72C4\"></a>If asTrackViewPick:true is specified, the hierarchy that is searched is the Animatable\n                  tree under the target. There are lots of cases where the subAnims of an object are\n                  a subset of the references held by an object, so class instances present in the scene\n                  might be missed. The Animatable tree is the tree shown in TrackView. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72C3\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">asTrackViewPick:false</em> </span> is specified or not supplied, each class instance is returned, and the hierarchy\n                  that is searched is the Reference tree under the target. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72C2\"></a>The default value for this parameter is \n                  			 <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72C1\"></a> \n               <h3><a name=\"GUID-046FB575-356E-4EB5-ABFE-2B53C26F1171\"></a> <em class=\"strong\">processChildren:</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72C0\"></a> If \n                  			 <span class=\"code\"> <em class=\"strong\">processChildren:true</em> </span> is specified in \n                  			 <em class=\"strong\">3ds Max 2011 or higher</em>, children scene nodes are also searched as part of the Animatable or Reference hierarchy.\n                  \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72BF\"></a>The default value for this parameter is \n                  			 <span class=\"code\"> <em class=\"strong\">false</em> </span> unless no target is specified, the scene root node (rootNode) is specified, or the\n                  scene root (rootScene) is specified, in which case the default is \n                  			 <span class=\"code\"> <em class=\"strong\">true</em> </span>. \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72BC\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72BB\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D4B\"></a><pre>\n--Create two spheres, and an instance of one of the spheres:\nresetMaxFile #noPrompt\ns1 = sphere()\ns2 = sphere pos:[100,0,0]\ns3 = instance s1\ns3.pos = [-100,0,0]\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72B2\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"CODEBLOCK_3C7A1080451C4130A99CBEF2FDA253B6\"></a><pre>OK \n$Sphere:Sphere01 @ [0.000000,0.000000,0.000000] \n$Sphere:Sphere02 @ [100.000000,0.000000,0.000000] \n$Sphere:Sphere03 @ [0.000000,0.000000,0.000000] [-100,0,0] \n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-72A9\"></a><p class=\"table-body\"> <em class=\"strong\">EXECUTE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D49\"></a><pre>\ntvps=getClassInstances sphere asTrackViewPick:true\nfor tvp in tvps do\n(\nprint tvp.anim\nprint tvp.client\nprint tvp.subNum\nprint tvp.name\nprint tvp.client[tvp.subNum]\n)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-729D\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D48\"></a><pre>\n#(TrackViewPick:\"Object (Sphere)\", TrackViewPick:\"Object (Sphere)\", TrackViewPick:\"Object (Sphere)\")\nSphere\n$Sphere:Sphere001 @ [0.000000,0.000000,0.000000]\n4\n\"Object (Sphere)\"\nSubAnim:Object__Sphere\nSphere\n$Sphere:Sphere002 @ [100.000000,0.000000,0.000000]\n4\n\"Object (Sphere)\"\nSubAnim:Object__Sphere\nSphere\n$Sphere:Sphere003 @ [-100.000000,0.000000,0.000000]\n4\n\"Object (Sphere)\"\nSubAnim:Object__Sphere\nOK\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7289\"></a><p class=\"table-body\"> <em class=\"strong\">NOW EXECUTE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D47\"></a><pre>\nobjs=getClassInstances sphere\nfor obj in objs do print (refs.dependents obj) #nomap\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7284\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D46\"></a><pre>\n#(Sphere, Sphere)\n#($Sphere:Sphere003 @ [-100.000000,0.000000,0.000000], $Sphere:Sphere001 @ [0.000000,0.000000,0.000000], ReferenceTarget:NodeRefMgr)\n#($Sphere:Sphere002 @ [100.000000,0.000000,0.000000])\nOK\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-727C\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-727B\"></a><p class=\"table-body\"> <em class=\"strong\">CONCLUSION:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-727A\"></a><p class=\"table-body\">As one of the spheres is instanced, three TrackViewPick values are returned, but only\n                              two class instances are returned. \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7276\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7275\"></a><p class=\"table-body\"> <em class=\"strong\">EXPLORING ARGUMENT COMBINATIONS:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D45\"></a><pre>\nt1 = bitmaptex filename:\"t1.bmp\" name:#Sphere_DiffuseMap\nt2 = bitmaptex filename:\"t2.bmp\" name:#Teapot_DiffuseMap\nt3 = bitmaptex filename:\"t3.bmp\" name:#Displace\nt4 = bitmaptex filename:\"t4.bmp\" name:#VolSelect\nt5 = bitmaptex filename:\"t5.bmp\" name:#HairDens\nt6 = bitmaptex filename:\"t6.bmp\" name:#NoWhere\nt7 = bitmaptex filename:\"t7.bmp\" name:#MEdit\nt8 = bitmaptex filename:\"t8.bmp\" name:#NodeCustAttrib\nt9 = bitmaptex filename:\"t9.bmp\" name:#ObjCustAttrib\ns = sphere material:(standard showInViewport:true)\nt = teapot material:(standard showInViewport:true) pos:[0,50,0] parent:s\ns.material.diffusemap = t1\ns.material.specularmap = t1\nt.material.diffusemap = mix mask:t2\naddModifier s (displace map:t3 strength:10)\naddModifier t (volumeSelect texture:t4)\naddModifier s (HairMod())\ns.modifiers[1].maps[1] = t5\ns.modifiers[1].mapEnables[1] = true\nmeditmaterials[1] = t7\ng=geosphere()\ntestCADef = attributes testCA\n(\nparameters main\n(\nmap type:#texturemap\n)\n)\nCustAttributes.add g testCADef BaseObject:false\nCustAttributes.add g testCADef BaseObject:true\ng.testCA.map = t8\ng.baseobject.testCA.map = t9\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7252\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D44\"></a><pre>\nSphere_DiffuseMap:Bitmap\nTeapot_DiffuseMap:Bitmap\nDisplace:Bitmap\nVolSelect:Bitmap\nHairDens:Bitmap\nNoWhere:Bitmap\nmedit:Bitmap\nNodeCustAttrib:Bitmap\nObjCustAttrib:Bitmap\n$Sphere:Sphere001 @ [0.000000,0.000000,0.000000]\n$Teapot:Teapot001 @ [0.000000,50.000000,0.000000]\nSphere_DiffuseMap:Bitmap\nSphere_DiffuseMap:Bitmap\nMix:Mix\nOK\nOK\nOK\nHairDens:Bitmap\ntrue\nmedit:Bitmap\n$GeoSphere:GeoSphere001 @ [0.000000,0.000000,0.000000]\n&lt;AttributeDef:testCA&gt;\ntrue\ntrue\nNodeCustAttrib:Bitmap\nObjCustAttrib:Bitmap\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7234\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 1:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D43\"></a><pre>\nfor b in getClassInstances bitmaptex do\nformat \"Name : %, Texture name : %, Affected Nodes : %\\n\" b.name b.filename (refs.dependentNodes b)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-722F\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 1 OUTPUT</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D42\"></a><pre>\nName : medit, Texture --&gt; Name : t7.bmp , Affected Nodes : #()\nName : Sphere_DiffuseMap, Texture --&gt; Name : t1.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Teapot_DiffuseMap, Texture --&gt; Name : t2.bmp, Affected Nodes : #($Editable_Mesh:Teapot001 @ [0.000000,50.000000,0.000000])\nName : VolSelect, Texture --&gt; Name : t4.bmp, Affected Nodes : #($Editable_Mesh:Teapot001 @ [0.000000,50.000000,0.000000])\nName : Displace , Texture --&gt; Name : t3.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : HairDens, Texture --&gt; Name : t5.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : ObjCustAttrib, Texture name : t9.bmp, Affected Nodes : #()\nName : NodeCustAttrib, Texture name : t8.bmp, Affected Nodes : #($GeoSphere:GeoSphere001 @ [0.000000,0.000000,0.000000])\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7224\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 2</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D41\"></a><pre>\nfor b in getClassInstances bitmaptex target:rootnode do\nformat \"Name : %, Texture name : %, Affected Nodes : %\\n\" b.name b.filename (refs.dependentNodes b)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-721F\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 2 OUTPUT</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D40\"></a><pre>\nName : VolSelect, Texture --&gt; Name : t4.bmp, Affected Nodes : #($Editable_Mesh:Teapot001 @ [0.000000,50.000000,0.000000])\nName : Teapot_DiffuseMap, Texture --&gt; Name : t2.bmp, Affected Nodes : #($Editable_Mesh:Teapot001 @ [0.000000,50.000000,0.000000])\nName : Displace, Texture --&gt; Name : t3.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : HairDens, Texture --&gt; Name : t5.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Sphere_DiffuseMap, Texture --&gt; Name : t1.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : ObjCustAttrib, Texture name : t9.bmp, Affected Nodes : #()\nName : NodeCustAttrib, Texture name : t8.bmp, Affected Nodes : #($GeoSphere:GeoSphere001 @ [0.000000,0.000000,0.000000])\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7215\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 3</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D3F\"></a><pre>\nfor b in getClassInstances bitmaptex target:s do\nformat \"Name : %, Texture name : %, Affected Nodes : %\\n\" b.name b.filename (refs.dependentNodes b)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7210\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 3 OUTPUT</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D3E\"></a><pre>\nName : Displace, Texture --&gt; Name : t3.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : HairDens, Texture --&gt; Name : t5.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Sphere_DiffuseMap, Texture --&gt; Name : t1.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-720A\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 4</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D3D\"></a><pre>\nfor b in getClassInstances bitmaptex target:s processChildren:true do\nformat \"Name : %, Texture name : %, Affected Nodes : %\\n\" b.name b.filename (refs.dependentNodes b)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7205\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 4 OUTPUT</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D3C\"></a><pre>\nName : VolSelect, Texture --&gt; Name : t4.bmp, Affected Nodes : #($Editable_Mesh:Teapot001 @ [0.000000,50.000000,0.000000])\nName : Teapot_DiffuseMap, Texture --&gt; Name : t2.bmp, Affected Nodes : #($Editable_Mesh:Teapot001 @ [0.000000,50.000000,0.000000])\nName : Displace, Texture --&gt; Name : t3.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : HairDens, Texture --&gt; Name : t5.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Sphere_DiffuseMap, Texture --&gt; Name : t1.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71FC\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 5</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D3B\"></a><pre>\nfor b in getClassInstances bitmaptex target:g do\nformat \"Name : %, Texture name : %, Affected Nodes : %\\n\" b.name b.filename (refs.dependentNodes b)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71F7\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 5 OUTPUT</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D3A\"></a><pre>\nName : ObjCustAttrib, Texture name : t9.bmp, Affected Nodes : #()\nName : NodeCustAttrib, Texture name : t8.bmp, Affected Nodes : #($GeoSphere:GeoSphere001 @ [0.000000,0.000000,0.000000])\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71F2\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 6</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D39\"></a><pre>\nfor b in getClassInstances bitmaptex processAllAnimatables:true do\nformat \"Name : %, Texture name : %, Affected Nodes : %\\n\" b.name b.filename (refs.dependentNodes b)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71ED\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 6 OUTPUT</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D38\"></a><pre>\nName : Sphere_DiffuseMap, Texture --&gt; Name : t1.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Teapot_DiffuseMap, Texture --&gt; Name : t2.bmp, Affected Nodes : #($Editable_Mesh:Teapot001 @ [0.000000,50.000000,0.000000])\nName : Displace, Texture --&gt; Name : t3.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : VolSelect, Texture --&gt; Name : t4.bmp, Affected Nodes : #($Editable_Mesh:Teapot001 @ [0.000000,50.000000,0.000000])\nName : HairDens, Texture --&gt; Name : t5.bmp, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : NoWhere, Texture --&gt; Name : t6.bmp, Affected Nodes : #()\nName : medit, Texture --&gt; Name : t7.bmp, Affected Nodes : #()\nName : ObjCustAttrib, Texture name : t9.bmp, Affected Nodes : #()\nName : NodeCustAttrib, Texture name : t8.bmp, Affected Nodes : #($GeoSphere:GeoSphere001 @ [0.000000,0.000000,0.000000])\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71E1\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 7</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D37\"></a><pre>\nfor b in getClassInstances bitmaptex asTrackViewPick:true do\nformat \"Name : %, Texture name : %, Client: %, subAnim: %, Affected Nodes : %\" b.anim.name b.anim.filename b.client b.subnum (refs.dependentNodes b.anim)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71DC\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 7 OUTPUT</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D36\"></a><pre>\nName : Sphere_DiffuseMap, Texture name : t1.bmp, Client: ReferenceTarget:ReferenceTarget, subAnim: 4 , Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Sphere_DiffuseMap, Texture name : t1.bmp, Client: ReferenceTarget:ReferenceTarget, subAnim: 6 , Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Teapot_DiffuseMap, Texture name : t2.bmp, Client: Mix:Mix, subAnim: 4, Affected Nodes : #($Editable_Mesh:Teapot001 @ [0.000000,50.000000,0.000000])\nName : medit, Texture name : t7.bmp, Client: #meditMaterials(), subAnim: 1, Affected Nodes : #()\nName : Displace, Texture name : t3.bmp, Client: Displace:Displace, subAnim: 3, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71D4\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 8</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D35\"></a><pre>\nfor b in getClassInstances bitmaptex target:s asTrackViewPick:true do\nformat \"Name : %, Texture name : %, Client: %, subAnim: %, Affected Nodes : %\\n\" b.anim.name b.anim.filename b.client b.subnum (refs.dependentNodes b.anim)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71CF\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 8 OUTPUT</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D34\"></a><pre>\nName : Displace, Texture name : t3.bmp, Client: Displace:Displace, subAnim: 3 , Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Sphere_DiffuseMap, Texture name : t1.bmp, Client: ReferenceTarget:ReferenceTarget, subAnim: 4 , Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Sphere_DiffuseMap, Texture name : t1.bmp, Client: ReferenceTarget:ReferenceTarget, subAnim: 6 , Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71C9\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 9</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D33\"></a><pre>\nfor b in getClassInstances bitmaptex target:s processChildren:true asTrackViewPick:true do\nformat \"Name : %, Texture name : %, Client: %, subAnim: %, Affected Nodes : %\\n\" b.anim.name b.anim.filename b.client b.subnum (refs.dependentNodes b.anim)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71C4\"></a><p class=\"table-body\"> <em class=\"strong\">TEST 9 OUTPUT</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D32\"></a><pre>\nName : Displace, Texture name : t3.bmp, Client: Displace:Displace, subAnim: 3, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Sphere_DiffuseMap, Texture name : t1.bmp, Client: ReferenceTarget:ReferenceTarget, subAnim: 4, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Sphere_DiffuseMap, Texture name : t1.bmp, Client: ReferenceTarget:ReferenceTarget, subAnim: 6, Affected Nodes : #($Object:Sphere001 @ [0.000000,0.000000,0.000000])\nName : Teapot_DiffuseMap, Texture name : t2.bmp, Client: Mix:Mix, subAnim: 4, Affected Nodes : #($Editable_Mesh:Teapot001 @ [0.000000,50.000000,0.000000])\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_F7D630D959C54125BBA4FC6EF966BAE8\"></a> \n            <h2><a name=\"GUID-5525EE70-9456-4C00-AC44-6D90C1174E5F\"></a>getClassCounts()\n            </h2> \n            <p>The \n               		  <span class=\"code\">getClassCounts()</span> function, available in \n               		  <em class=\"strong\">3ds Max 2018 and higher</em>, returns array of DataPair instances, where v1 is a maxclass and v2 is the number\n               of instances of the corresponding class that exist in the scene. The syntax is:\n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;array of datapair(maxclass,count)&gt;<em class=\"codeEmphasisStrong\">getClassCounts</em>()</pre></div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71BA\"></a> <span class=\"char_link\"><a href=\"GUID-EB69A035-7FF4-4A0A-8A82-409C4145B9DF.htm\">Interface: InstanceMgr</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71B9\"></a> <span class=\"char_link\"><a href=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52.htm\">Class and Object Inspector Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71B8\"></a> <span class=\"char_link\"><a href=\"GUID-782447FD-103B-4686-8F65-97A2A02EB3FB.htm\">showInterfaces Inspector Function</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71B7\"></a> <span class=\"char_link\"><a href=\"GUID-AEF738FF-131B-4731-A00D-B943DD7E4B94.htm\">GetInterfaces Interface Inspector</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71B6\"></a> <span class=\"char_link\"><a href=\"GUID-C3849AEC-32FC-41B4-9934-1AFAA22CAB79.htm\">showInterface Inspector Function</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";