var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-42358EC9-39BA-4E4F-A83C-DD685C64DC78\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Navigating CATRig Hierarchies using MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Navigating CATRig Hierarchies using MAXScript</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-42358EC9-39BA-4E4F-A83C-DD685C64DC78\"></a><div class=\"head\">\n            <h1>Navigating CATRig Hierarchies using MAXScript </h1>\n         </div><a name=\"TABLE_868E2C022C5B4A439D86DAA73C1DDC11\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"3.1476235442241105%\">\n                  <col width=\"54.170601196096946%\">\n                  <col width=\"42.681775259678936%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\" colspan=\"2\"> <a name=\"P_93F7AE084C8E4A5888872B833C8BA0C4\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_AAF24F5C88334D3CAC4CD93D06E837E7\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">3ds Max CAT - Quick Navigation</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171CA1\"></a>  \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC685F\"></a> \n            <h2><a name=\"GUID-15915A63-96DD-46E4-A95A-F28520CC0617\"></a> <em class=\"strong\">Accessing Bones in the CATRig Skeleton</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6860\"></a>Accessing bones by name in a skeleton tends to cause errors. For example, if an artist\n               renames a bone, your scripts might stop working. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6861\"></a> <em class=\"strong\">3ds Max CAT</em> is designed to let you navigate hierarchies from a script without necessarily knowing\n               the names of the bones in the rig. This means that you can write scripts that will\n               work on any CATrig, regardless of the naming conventions used. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6863\"></a>The CATRig is <em class=\"strong\">structured like a tree</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6864\"></a>Each bone has child bones that you can navigate to and get their children. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6865\"></a>There are special controllers in CAT that hold parts of the tree together, but do\n               not show up in the hierarchy you see in <em class=\"strong\">3ds Max</em>. For example, there is a controller called \"Limb\" whose job is to maintain the limb\n               (arm or leg). Each bone in the limb is generic and contains only information related\n               to that specific bone. If you want information about the limb, you can access the\n               limb controller. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6867\"></a>The <em class=\"strong\">basic tree structure</em> looks like this: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6868\"></a>From a hub controller you can get to a limb controller and from a limb controller\n               you can get to the collarbone controller. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6869\"></a>From a hub controller you can get to a tail controller and from a tail controller\n               you can get to any of the tailbone controllers. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC686A\"></a>From a hub controller you can get to a spine controller and from a spine controller\n               you can get to any of the spine bone controllers, or to the hub controller at the\n               tip of the spine. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC686B\"></a>Hubs \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC686C\"></a>Hubs-&gt;Limbs \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC686D\"></a>Hubs-&gt;Limbs-&gt;Collarbone \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC686E\"></a>Hubs-&gt;Limbs-&gt;Limb Bones \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC686F\"></a>Hubs-&gt;Limbs-&gt;Limb Bones-&gt;Bone Segments \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6870\"></a>Hubs-&gt;Limbs-&gt;Palm/Ankle \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6871\"></a>Hubs-&gt;Limbs-&gt;Palm/Ankle-&gt;Digits \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6872\"></a>Hubs-&gt;Limbs-&gt;Palm/Ankle-&gt;Digits-&gt;Digit Bones \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6873\"></a>Hubs-&gt;Tails \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6874\"></a>Hubs-&gt;Tails-&gt;Tail Bones \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6875\"></a>Hubs-&gt;Spines \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6876\"></a>Hubs-&gt;Spines-&gt;Spine Bones \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6877\"></a>Hubs-&gt;Spines-&gt;Tip Hub \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC687A\"></a> \n            <h2><a name=\"GUID-971E5343-EFE7-45BD-AB24-EBD4796C8E51\"></a> <em class=\"strong\">Using Bone Addresses</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC687B\"></a>The 3ds Max CAT scripting interface includes methods that let you access bones using\n               bone \"addresses\". Each bone in a CATRig contains a unique address. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC687C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC687D\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5043\"></a><pre>\n--Select a bone, for example left elbow:\ntheAddress =$[3].address\n--the result will be something like:\n\"SceneRootNode.Hub.Spine[0].Hub.Limb[0].LimbBone[1].BoneSeg[0]\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6885\"></a>Once you have an address, it is easy to get the same bone on a different rig. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6886\"></a>There is a method on the CATParent for retrieving a bone from the skeleton using an\n               address. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6887\"></a>This method is called <span class=\"code\"> <em class=\"strong\">GetBoneUsingAddress:</em> </span> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6889\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC688A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5042\"></a><pre>\n--Selectthe CATParent of a rig and call:\n$.GetBoneByAddresstheAddress\n--the result will be something like:\n$Object:MaramaLForeArm1 @ [18.374180,2.811419,91.353607]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6892\"></a> \n            <h2><a name=\"GUID-7D19C42E-4C33-4B72-88BD-7FD094EA666D\"></a> <em class=\"strong\">Getting all the Bones that make up the CATRig</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6893\"></a>The CATParent provides a property called CATRigNodes that contains a list of all the\n               bones in a CATRig. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6894\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6895\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5041\"></a><pre>\n--Select the CATParent of a CATRig andexecute:\n$.CATRigNodes\n#($Object:MaramaPelvis @ [0.643538,12.460782,56.982174], $IKTarget:MaramaLPlatform @ [-9.479717,45.484272,2.016279], $Object:MaramaLThigh @ [-5.399519,13.610688,52.234413], $Object:MaramaLCalf @ [-5.073243,42.623035,42.755692], $Object:MaramaLAnkle @ [-9.923340,42.132290,12.445667], $Object:MaramaLToe @ [-8.354513,46.355228,5.667924], $IKTarget:MaramaRPlatform @ [22.299629,-26.312172,2.125263], $Object:MaramaRThigh @ [7.615567,12.286880,53.555431], $Object:MaramaRCalf @ [18.307613,1.576054,27.048307], $Object:MaramaRAnkle @ [15.838839,-24.331221,10.763937], $Object:MaramaRToe @ [21.849598,-24.039907,5.285047], $Object:MaramaSpine1 @ [0.084267,13.617851,61.769054], $Object:MaramaSpine2 @ [0.155154,17.742903,70.302628], $Object:MaramaSpine3 @ [0.838520,20.302643,79.403381], $Object:MaramaRibcage @ [1.721320,22.587023,88.560089], $IKTarget:MaramaLIKTarget @ [-14.076582,23.387424,73.722427], $Object:MaramaLCollarbone @ [-0.265896,27.761074,90.442078], $Object:MaramaLUpperArm @ [-7.214790,19.994431,91.494965], $Object:MaramaLForeArm1 @ [-22.375963,8.502111,91.433647], $Object:MaramaLForeArm2 @ [-18.546179,13.426756,83.416336], ...)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC689C\"></a>All the bones in the rig have been collected and put into an array for you. This makes\n               it unnecessary to learn how to navigate CATRig hierarchies. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC689D\"></a> \n            <h2><a name=\"GUID-A38C6BBC-302A-4CBC-B102-478E22BC815E\"></a> <em class=\"strong\">Getting All the Layer Controllers in a CATRig</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC689E\"></a>The <em class=\"strong\">CATParent</em> also provides a property called <span class=\"code\">CATRigLayerCtrls</span> that contains an array of all the layer controllers in a CATRig. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC689F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68A0\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5040\"></a><pre>\n-- Select the CATParent of a CATRig andexecute:\n$.CATRigLayerCtrls\n#(Controller:LayerWeights, Controller:LayerMatrix3, Controller:LayerFloat, Controller:LayerWeights, Controller:LayerFloat, Controller:LayerFloat, Controller:LayerFloat, Controller:LayerMatrix3, Controller:LayerMatrix3, Controller:LayerWeights, Controller:LayerMatrix3, Controller:LayerFloat, Controller:LayerMatrix3, Controller:LayerMatrix3, Controller:LayerWeights, Controller:LayerFloat, Controller:LayerFloat, Controller:LayerFloat, Controller:LayerMatrix3, Controller:LayerMatrix3, ...)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68A7\"></a>The Pose Mixer utility uses this function to find all the controllers that will be\n               keyframed. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68A8\"></a> \n            <h2><a name=\"GUID-1B84DE3A-8128-46AC-AC10-459A46DA3FF0\"></a> <em class=\"strong\">Navigating Bones</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68A9\"></a>Each bone in a CATRig is controlled by a controller. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68AA\"></a>This controller exposes the <span class=\"char_link\"><a href=\"GUID-6AD3551C-6AE4-4120-8CD1-CB3C78C09D50.htm\">CATNodeControl interface</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68AB\"></a>This means you can access information about that bone. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68AC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68AD\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68AE\"></a><p class=\"table-body\">If a hub bone is selected and you want to know how many limbs are attached to the\n                           hub, use the following line of script. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-503F\"></a><pre>\n$[3].address\n\"SceneRootNode.Hub.Spine[0].Hub.Limb[0].LimbBone[0].BoneSeg[2]\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68B5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68B6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68B7\"></a><p class=\"table-body\">To get the layer controller for a CATBone, use the following line: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-503E\"></a><pre>\n$[3].layertrans.controller\nController:LayerMatrix3\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68BC\"></a><p class=\"table-body\">Note that some bones do not have a layertrans controller such as, the bones in the\n                           procedural spine. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68BE\"></a> \n            <h2><a name=\"GUID-DB15EB9A-F1E2-4375-A8D0-2101B2D5E989\"></a> <em class=\"strong\">Navigating Hubs</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68BF\"></a>Hubs are the \"joiners\" of the <em class=\"strong\">3ds Max CAT</em> hierarchy. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68C0\"></a>Hubs can have limbs (legs and arms), tails, spines, and extra bones attached to them.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68C1\"></a>For any Hub, you can see how many limbs are attached and then you can access the limb\n               and get the bones from that limb. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68C2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68C3\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68C4\"></a><p class=\"table-body\">If a hub bone is selected and you want to know how many limbs are attached to the\n                           hub, use the following line of script. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-503D\"></a><pre>-- Select the CATParent of a CATRig andexecute:\n$[3].limbs.count\n<span class=\"charspan-emphasis\">2</span> </pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68CB\"></a> \n            <h2><a name=\"GUID-EE5714D4-DA15-43F5-AEEE-93FE9DD48AB7\"></a> <em class=\"strong\">Navigating Limbs</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68CC\"></a>Limbs are made up of the following types of controllers: <span class=\"char_link\"><a href=\"GUID-F625A12E-F7BB-49B7-99A8-8D1850A9FA66.htm\">Limb</a></span>, <span class=\"char_link\"><a href=\"GUID-6F260A22-DCCF-4869-BFB5-45BC5ECCB25D.htm\">Collarbone</a></span>, <span class=\"char_link\"><a href=\"GUID-8178D378-C160-4E9F-BC90-A84BD85A92B6.htm\">Bone</a></span>, <span class=\"char_link\"><a href=\"GUID-0BCF2300-D4C9-4691-A399-79BE1692DA65.htm\">BoneSeg</a></span>, <span class=\"char_link\"><a href=\"GUID-8C4AEC0E-B048-4B43-B70E-0282BECD5718.htm\">Palm</a></span>, <span class=\"char_link\"><a href=\"GUID-5DB436FC-7683-41E6-804B-D92C3D05E200.htm\">IKTarget</a></span>, and Upvector. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68CD\"></a>The Limb controller holds all the information about the whole limb, such as its name,\n               and also keep a pointer to each bone in the limb, collarbone, ankle, and the IKTarget.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68CE\"></a>From one limb bone you can access everything in a CATRig. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68CF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68D0\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-503C\"></a><pre>--To get the limb controller from a limb bone use the following:\n$[3].Limb\n<span class=\"charspan-emphasis\">Controller:CATLimbData2</span>\n \n--If you have a Limb bone selected and you want to know how many\n--bones in the Limb use the following:\n$[3].Limb.bones.count\n<span class=\"charspan-emphasis\">4</span>\n \n--To get the second bone in the Limb use the following:\n$[3].Limb.bones[2]\n<span class=\"charspan-emphasis\">Controller:CATBoneData</span>\n \n--If a limb bone is selected and you want to select all the bones\n--in the limb, you can use the following:\nselect (for o in $[3].Limb.bonescollect o.node)\n<span class=\"charspan-emphasis\">OK</span> </pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68E7\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68E8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68E9\"></a><p class=\"table-body\">If a limb bone is selected and you want to get the name of the first bone in the limb,\n                           you can use the following: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-503B\"></a><pre>\n$[3].limb.bones[1].node.name\n<span class=\"charspan-emphasis\">\"MarineLUpperarm1\"</span>\n \n--Here is a quick overview of bone hierarchy access:\n$--&gt; accesses the selected bone\n<span class=\"charspan-emphasis\">$Object:MarineLUpperarm3 @ [32.745049,27.963869,14.721746]</span>\n$[3]--&gt; accesses the selected bone\'s transform controller\n<span class=\"charspan-emphasis\">SubAnim:Transform</span>\n$[3].limb--&gt; accesses the selected bone\'s tail controller\n<span class=\"charspan-emphasis\">Controller:CATLimbData2</span>\n$[3].limb.bones[1]--&gt; accesses the 1st bone in the limb controller\n<span class=\"charspan-emphasis\">Controller:CATBoneData</span>\n$[3].limb.bones[1].node--&gt; accesses the node of the 1st bone.\n<span class=\"charspan-emphasis\">$Object:MarineLUpperarm1 @ [30.869087,27.893547,14.979661]</span>\n$[3].limb.bones[1].node.name--&gt; accesses the name of the node of the 1st bone in the Limb.\n<span class=\"charspan-emphasis\">\"MarineLUpperarm1\"</span> </pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68FD\"></a> \n            <h2><a name=\"GUID-22905A93-325A-40E3-9D6D-C6464BA44483\"></a> <em class=\"strong\">Navigating Tails</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68FE\"></a>Tails are made up of two types of controllers: <span class=\"char_link\"><a href=\"GUID-36777CE3-C39A-462B-9A0A-731FDEDA627C.htm\">TailData</a></span> and<span class=\"char_link\"><a href=\"GUID-12DA76AC-7DE2-48DE-8DE6-D2D7F11F6923.htm\"> TailTrans</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC68FF\"></a> <span class=\"char_link\"><a href=\"GUID-36777CE3-C39A-462B-9A0A-731FDEDA627C.htm\">TailData</a></span> holds all the information about the whole tail such as, its name and it also keep\n               a pointer to each bone in the tail. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6900\"></a>From one tail bone you can access everything in a CATRig. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6901\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6902\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-503A\"></a><pre>\n--To get the TailData controller from a tail bone use the following:\n$[3].tail\n \n--If you have a Tail bone selected and you want to know how many bones\n--arein the tail, use the following:\n$[3].tail.bones.count\n \n--To get the second bone in the tail, use the following:\n$[3].tail.bones[2]\n \n--If you have one tail bone selected and you want to select all\n--the bones in the tail, you can use the following:\nselect (for o in $[3].Limb.bones collect o.node)\nOK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6914\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6915\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6916\"></a><p class=\"table-body\">If you have a tail bone selected and you want to get the name of the first bone in\n                           the tail, you can use the following: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5039\"></a><pre>\n$[3].tail.bones[1].node.name\n \n--Here is a detailed overview of the hierarchy access:\n$--&gt; accesses the selected bone\n$[3]--&gt; accesses the selected bone\'s transform controller\n$[3].tail--&gt; accesses the selected bone\'s tail controller\n$[3].tail.bones[1]--&gt; accesses the 1st bone in the tail controller\n$[3].tail.bones[1].node--&gt; accesses the node of the 1st bone.\n$[3].tail.bones[1].node.name--&gt; accesses the name of the node of the 1st bone in the tail.\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"TABLE_DCE08B6281EE467F91C7FA22DC7DFD45\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1476235442241105%\">\n                     <col width=\"54.170601196096946%\">\n                     <col width=\"42.681775259678936%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\" colspan=\"2\"> <a name=\"P_C7E9D4D7B0114F3FB924D12144DCC846\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_54A8416A06BE425D9BF5831AF028A442\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">3ds Max CAT - Quick Navigation</a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171CA2\"></a></p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6926\"></a> <span class=\"char_link\"><a href=\"GUID-7664D95A-A27D-4356-8442-F53064920BF8.htm\">3ds Max CAT and MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";