var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-4389A5F4-9D6E-4DDE-B3A1-F19E89ED3FB5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"time literal\">\n      <meta name=\"indexterm\" content=\"literals\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Time Literals</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4389A5F4-9D6E-4DDE-B3A1-F19E89ED3FB5\"></a><div class=\"head\">\n            <h1>Time Literals </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86CCB\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86CCC\"></a>  Time is a basic data type in MAXScript. Its semantics are based on animation time\n               in <em class=\"strong\">3ds Max</em>, where you can express time in frames, <span class=\"char_link\"><a href=\"GUID-D62B5EF2-702E-4281-88EA-129223F6E0DA.htm\">ticks</a></span> or normalized time. In <em class=\"strong\">3ds Max</em>, time is stored with a resolution of 4800 ticks per second. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86CCF\"></a>The format for a time literal is one of: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-615A\"></a><pre>[-]{&lt;decimal_number&gt;[<em class=\"codeEmphasisStrong\">m</em> | <em class=\"codeEmphasisStrong\">s</em> | <em class=\"codeEmphasisStrong\">f</em> | <em class=\"codeEmphasisStrong\">t</em>]}+ -- minutes/sec/frames/ticks</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6159\"></a><pre>[-]{&lt;digit&gt;}<em class=\"codeEmphasisStrong\">:</em>{&lt;digit&gt;}[.{&lt;digit&gt;}] -- SMPTE mins:secs.frame</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6158\"></a><pre>[-]&lt;decimal_number&gt;<em class=\"codeEmphasisStrong\">n</em> -- active segment normalized time</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86CD3\"></a>In the first form, the <span class=\"code\"> <em class=\"strong\">{...}+</em> </span> indicates one or more repetitions, so you can string together minutes/seconds/frames/ticks.\n               If you do this, they must be in the specific minutes/seconds/frames/ticks order. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86CD4\"></a>The normalized time form is always relative to the current active animation time segment.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CD5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CD6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CD7\"></a><p class=\"table-body\"> <em class=\"strong\">MEANING</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CD8\"></a><p class=\"table-body\"> <span class=\"code\">2.5s</span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CD9\"></a><p class=\"table-body\">2.5 seconds </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CDA\"></a><p class=\"table-body\"> <span class=\"code\">1m15s</span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CDB\"></a><p class=\"table-body\">1 minute 15 seconds </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CDC\"></a><p class=\"table-body\"> <span class=\"code\">2m30s5f2t</span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CDD\"></a><p class=\"table-body\">2 minutes 30 seconds 5 frames 2 ticks </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CDE\"></a><p class=\"table-body\"> <span class=\"code\">125f</span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CDF\"></a><p class=\"table-body\">125 frames </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CE0\"></a><p class=\"table-body\"> <span class=\"code\">18.25f</span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CE1\"></a><p class=\"table-body\">18.25 frames </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CE2\"></a><p class=\"table-body\"> <span class=\"code\">1f20t</span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CE3\"></a><p class=\"table-body\">1 frame 20 ticks </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CE4\"></a><p class=\"table-body\"> <span class=\"code\">2:10.0</span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CE5\"></a><p class=\"table-body\">2 minutes 10 seconds 0 frames (SMPTE) </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CE6\"></a><p class=\"table-body\"> <span class=\"code\">0:0.29</span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CE7\"></a><p class=\"table-body\">29 frames (SMPTE) </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CE8\"></a><p class=\"table-body\"> <span class=\"code\">0.45n</span> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CE9\"></a><p class=\"table-body\">0.45 normalized time (fraction of active segment) </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86CEC\"></a> <span class=\"char_link\"><a href=\"GUID-51429B01-2FC6-4746-9E88-5EB5D93056CC.htm\">Time Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"P_CCCEE7B8AA0444CDA28F9791B5BC2D54\"></a> <span class=\"char_link\"><a href=\"GUID-D62B5EF2-702E-4281-88EA-129223F6E0DA.htm\">Ticks</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";