var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-45473275-772E-4EC1-A38A-114C8D7384F1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"RCMenu\">\n      <meta name=\"indexterm\" content=\"subMenu\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>submenu</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-45473275-772E-4EC1-A38A-114C8D7384F1\"></a><div class=\"head\">\n            <h1>submenu </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-58AC\"></a>A <em class=\"strong\">subMenu</em> is used to place an item in the right-click menu that, if the cursor is placed on,\n            opens a submenu containing additional user-interface items. The syntax for a subMenu\n            is: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7287\"></a><pre><em class=\"codeEmphasisStrong\">subMenu</em> &lt;label&gt; [ <em class=\"codeEmphasisStrong\">filter</em>:&lt;function&gt; ]<em class=\"codeEmphasisStrong\"> (</em> &lt;submenu_body&gt; <em class=\"codeEmphasisStrong\">)</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-58AA\"></a>The <span class=\"code\"> <em class=\"strong\">&lt;submenu_body&gt;</em> </span> of a subMenu definition is made up of a sequence of RCMenu clauses as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7286\"></a><pre>&lt;submenu_body&gt; ::= { &lt;rcmenu_clause&gt; }+</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-58A8\"></a> <em class=\"strong\">Parameters</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7285\"></a><pre><em class=\"codeEmphasisStrong\">label</em>:</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-58A6\"></a>The string that appears in the right-click menu. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7284\"></a><pre><em class=\"codeEmphasisStrong\">filter</em>:</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-58A3\"></a>A function that returns a Boolean value. The filter function is evaluated when the\n            right-click menu is first opened. If the filter function returns <span class=\"code\"> <em class=\"strong\">true</em> </span> the subMenu appears in the menu, otherwise it is not displayed. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-58A1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-58A0\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7283\"></a><pre>\nrcmenu MyRCmenu\n(\nfn flt_objects = ($ != undefined) -- objects filter\nfn flt_shapes = (isKindOf $ Shape) -- shapes filter\nmenuItem mi_cs \"Cast Shadows\" checked:false\nmenuItem mi_rs \"Receive Shadows\" checked:false\nseparator sep2 filter:flt_objects\nsubMenu \"Modifiers\" filter:flt_objects -- begin subMenu\n(\n-- Add common objects\nmenuItem mi_bend \"Bend\"\nmenuItem mi_twist \"Twist\"\n-- Add shape only modifiers\nseparator sep3 filter:flt_shapes\nsubMenu \"Shape\" filter:flt_shapes -- begin nested subMenu\n(\nmenuItem mi_extrude \"Extrude\"\nmenuItem mi_EditSpline \"Edit Spline\"\n)\n)\n-- event handlers would go here...\n)\nregisterRightClickMenu MyRcmenu -- register the rcmenu\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5884\"></a> <span class=\"char_link\"><a href=\"GUID-584BA3B0-ADBC-45A7-9BF4-ACE81930B2A0.htm\">RCMenu Clauses</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5883\"></a> <span class=\"char_link\"><a href=\"GUID-17DBC9E3-5B61-4738-B78B-D3D57A515CE8.htm\">Scripted Right-Click Menus</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";