var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-45E2F1A9-AFBB-413F-AEAD-7C9816BA94E5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Exploring the Trackbar Filter Callback Functions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Exploring the Trackbar Filter Callback Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-45E2F1A9-AFBB-413F-AEAD-7C9816BA94E5\"></a><div class=\"head\">\n            <h1>Exploring the Trackbar Filter Callback Functions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1617\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1616\"></a> To understand how the filter function callback works, you can register a test function\n               to explore the argument passed by the callback: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1614\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1613\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6873\"></a><pre>\nfn testCallbackFilterFunction theAnimatable theParent theSubAnimIndex theGrandParent theNode=(\nformat \"theAnimatable: %\\n\" theAnimatable\nformat \"theParent: %\\n\" theParent\nformat \"theSubAnimIndex: %\\n\" theSubAnimIndex\nformat \"theGrandParent: %\\n\" theGrandParent\nformat \"theNode: %\\n\\n\" theNode\ntrue ) --always returns true, means show all keys\nfn testCallbackAdditionFunction arg1 arg2 = (true)\ntheInterface = maxOps.trackbar\ntheIndex = theInterface.registerFilter testCallbackFilterFunction\\\ncallbackAdditionFunction \"Test Filter\" 8 active:true stopTraversal:false\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1604\"></a>For example, if you select a Sphere scene node called \"Sphere01\", the callback traverses\n               all its sub-anim tracks and calls the function multiple times. The function prints\n               all arguments to the Listener. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1603\"></a>You can take a look at some of them for better understanding: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6872\"></a><pre>\ntheAnimatable: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheParent: undefined\ntheSubAnimIndex: 1\ntheGrandParent: undefined\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-15FD\"></a>In this case, the scene node Sphere01 is being filtered. There is no grand parent,\n               there is no parent either, the animatable to be filtered is the node itself, the subAnim\n               Index is 1. This is the \"top level\" of the node. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6871\"></a><pre>\ntheAnimatable: Controller:Bezier_Float\ntheParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheSubAnimIndex: 1\ntheGrandParent: undefined\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-15F6\"></a>In this case, there is no grand parent, the parent is the sphere node itself, the\n               animatable to be filtered is the subAnim with Index 1, which is the Bezier Controller\n               of the Visibility track. This shows that the visibility of this sphere is animated.\n               Otherwise, theAnimatable would be undefined. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6870\"></a><pre>\ntheAnimatable: undefined\ntheParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheSubAnimIndex: 2\ntheGrandParent: undefined\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-15EF\"></a>In this case, there is no grand parent, the parent is the sphere node itself, the\n               animatable to be filtered is the subAnim with Index 2, which is undefined. Track 2\n               of every node is the Space_Warps subAnim track. You can verify by typing in the Listener:\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-686F\"></a><pre>\n$Sphere01[2]\n$Sphere01[2].controller\n--results:\nSubAnim:Space_Warps\nundefined\ntheAnimatable: Controller:Position_Rotation_Scale\ntheParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheSubAnimIndex: 3\ntheGrandParent: undefined\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-15E3\"></a>In this case, there is no grand parent, the parent is the sphere node itself, the\n               animatable to be filtered is the subAnim with Index 3, which is the Transformation\n               controller (in this case a Position_Rotation_Scale controller). \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-686E\"></a><pre>\ntheAnimatable: Controller:Position_XYZ\ntheParent: Controller:Position_Rotation_Scale\ntheSubAnimIndex: 1\ntheGrandParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-15DC\"></a>Now, go one level deeper. The grand parent is the Sphere, the parent is the Transformation\n               controller (Position_Rotation_Scale), the subAnim index inside the parent is 1, which\n               corresponds to the Position track (in this case a Position_XYZ controller). For comparison,\n               try typing in the Listener: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-686D\"></a><pre>\n$Sphere01[3][1].controller\nController:Position_XYZ\ntheAnimatable: Controller:Bezier_Float\ntheParent: Controller:Position_XYZ\ntheSubAnimIndex: 1\ntheGrandParent: Controller:Position_Rotation_Scale\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-15D3\"></a>Now, go even deeper. The grand parent is the node Transformation track (the PRS controller),\n               the parent is the Position track (the Position_XYZ), the animatable to be filtered\n               is the subAnim with Index 1, which is the Bezier controller assigned to the X axis\n               of the node position. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-686C\"></a><pre>\ntheAnimatable: Controller:Bezier_Float\ntheParent: Controller:Position_XYZ\ntheSubAnimIndex: 2\ntheGrandParent: Controller:Position_Rotation_Scale\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheAnimatable: Controller:Bezier_Float\ntheParent: Controller:Position_XYZ\ntheSubAnimIndex: 3\ntheGrandParent: Controller:Position_Rotation_Scale\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-766B\"></a>Same with these two tracks, which are the Y and Z sub-controllers of the Position\n               track with indices 2 and 3 respectively. This is the same as accessing \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-686B\"></a><pre>\n$Sphere01[3][1][3].controller\n--result\nController:Bezier_Float\ntheAnimatable: Controller:Euler_XYZ\ntheParent: Controller:Position_Rotation_Scale\ntheSubAnimIndex: 2\ntheGrandParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-15BC\"></a>Now, go back one level and get to the second subAnim index of the PRS controller,\n               which is the Rotation track. It has an Euler_XYZ controller assigned. The following\n               three calls traverses the X, Y, and Z sub-controllers of the rotation: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-686A\"></a><pre>\ntheAnimatable: Controller:Bezier_Float\ntheParent: Controller:Euler_XYZ\ntheSubAnimIndex: 1\ntheGrandParent: Controller:Position_Rotation_Scale\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheAnimatable: Controller:Bezier_Float\ntheParent: Controller:Euler_XYZ\ntheSubAnimIndex: 2\ntheGrandParent: Controller:Position_Rotation_Scale\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheAnimatable: Controller:Bezier_Float\ntheParent: Controller:Euler_XYZ\ntheSubAnimIndex: 3\ntheGrandParent: Controller:Position_Rotation_Scale\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-15AA\"></a>Go back one level again and get to the third subAnim index of the PRS controller,\n               which is the Scale track. It has a Bezier_Scale controller assigned that does not\n               have sub-controllers: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6869\"></a><pre>\ntheAnimatable: Controller:Bezier_Scale\ntheParent: Controller:Position_Rotation_Scale\ntheSubAnimIndex: 3\ntheGrandParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheAnimatable: Sphere\ntheParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheSubAnimIndex: 4\ntheGrandParent: undefined\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-159E\"></a>Go back to the Sphere object level and check the 4<sup> <span class=\"charspan-emphasis\">th</span> </sup>subAnim index, which is the Sphere object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-159D\"></a>Try this in the Listener: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6868\"></a><pre>\n$Sphere01[4]\n$Sphere01[4].controller\n--results:\nSubAnim:Object__Sphere\nundefined\ntheAnimatable: ReferenceTarget:ParamBlock\ntheParent: Sphere\ntheSubAnimIndex: 1\ntheGrandParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1591\"></a>Now, you are inside the ParamBlock of the sphere. The grand parent is the Sphere node\n               itself, the parent is the sphere, the subAnim index is 1 and the animatable track\n               is the Parameter Block. It does not have any keys, so you can go on and traverse its\n               subAnim tracks that contain the animatable parameters of the Sphere \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6867\"></a><pre>\ntheAnimatable: undefined\ntheParent: ReferenceTarget:ParamBlock\ntheSubAnimIndex: 1\ntheGrandParent: Sphere\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-158A\"></a>This is the first subAnim of the ParamBlock, which is the Radius of the sphere. The\n               radius of this sphere was not animated, so there is no controller assigned - theAnimatable\n               parameter is passed as undefined. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1589\"></a>Compare to the Listener: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6866\"></a><pre>\n$Sphere01[4][1]\n$Sphere01[4][1].controller\n--results:\nSubAnim:Radius\nundefined\ntheAnimatable: Controller:Bezier_Float\ntheParent: ReferenceTarget:ParamBlock\ntheSubAnimIndex: 2\ntheGrandParent: Sphere\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-157D\"></a>This is the second subAnim of the ParamBlock, which is the Segments count of the sphere.\n               The Segments of this sphere are animated, so there is a Bezier_Float controller assigned.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-157C\"></a>Compare to the Listener: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6865\"></a><pre>\n$Sphere01[4][2]\n$Sphere01[4][2].controller\n--results:\nSubAnim:Segments\nController:Bezier_Float\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1575\"></a>This following calls traverse the remaining tracks of the ParamBlock and of the Sphere\n               itself, but do not find any controllers assigned - they all return undefined as theAnimatable:\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6864\"></a><pre>\ntheAnimatable: undefined\ntheParent: ReferenceTarget:ParamBlock\ntheSubAnimIndex: 3\ntheGrandParent: Sphere\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheAnimatable: undefined\ntheParent: ReferenceTarget:ParamBlock\ntheSubAnimIndex: 4\ntheGrandParent: Sphere\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheAnimatable: undefined\ntheParent: ReferenceTarget:ParamBlock\ntheSubAnimIndex: 5\ntheGrandParent: Sphere\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheAnimatable: undefined\ntheParent: ReferenceTarget:ParamBlock\ntheSubAnimIndex: 6\ntheGrandParent: Sphere\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheAnimatable: undefined\ntheParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheSubAnimIndex: 5\ntheGrandParent: undefined\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheAnimatable: undefined\ntheParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheSubAnimIndex: 6\ntheGrandParent: undefined\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheAnimatable: undefined\ntheParent: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\ntheSubAnimIndex: 7\ntheGrandParent: undefined\ntheNode: $Sphere:Sphere01 @ [-40.683792,-17.994026,0.000000]\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-154A\"></a>The test function always returns true. Now, that you know how it is being called,\n               you can change it to perform actual filtering. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1549\"></a>See <span class=\"char_link\"><a href=\"GUID-8C8AA5D7-5C8D-44C5-BAED-BA8EC10C59FC.htm\">Trackbar Filter Callback Function Examples</a></span> for some ideas for filter functions including a way to limit the number of displayed\n               keys in the trackbar to increase interaction speed with the 3ds Max UI. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1547\"></a> <span class=\"char_link\"><a href=\"GUID-8C8AA5D7-5C8D-44C5-BAED-BA8EC10C59FC.htm\">Trackbar Filter Callback Function Examples</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1546\"></a> <span class=\"char_link\"><a href=\"GUID-48C5E2F2-DE34-4EA3-A84C-4DBD463DBF90.htm\">Trackbar Interface</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-8C8AA5D7-5C8D-44C5-BAED-BA8EC10C59FC.htm\">Trackbar Keys Filter Callback Function Examples </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";