var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Clauses\">\n      <meta name=\"indexterm\" content=\"scripted plug-ins\">\n      <meta name=\"indexterm\" content=\"parameter blocks\">\n      <meta name=\"indexterm\" content=\"version\">\n      <meta name=\"indexterm\" content=\"this\">\n      <meta name=\"indexterm\" content=\"delegate\">\n      <meta name=\"indexterm\" content=\"loading\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Plug-in Clauses</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3\"></a><div class=\"head\">\n            <h1>Scripted Plug-in Clauses </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5505\"></a>   The various optional clauses inside the plug-in body are similar to those for scripted\n            utilities and tools. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5501\"></a>There is an additional scripted plug-in specific clause \n            		<span class=\"code\"> <em class=\"strong\">&lt;parameters&gt;</em> </span> for defining scene-savable and Track View visible parameters for the plug-in. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5500\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">&lt;plugin_body&gt;</em> </span> of a scripted plug-in definition is made up of a sequence of plug-in clauses as follows:\n            \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7224\"></a><pre>&lt;plugin_body&gt; ::= { &lt;plugin_clause&gt; }+</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54FD\"></a>Plug-in clauses define the components of a scripted plug-in and can be one of these\n            five basic things: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54FC\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54FA\"></a> <em class=\"strong\">Local variables, functions, or structure definitions</em> - They are variables, functions, and structures whose scope is the plug-in. These\n                  locals will exist as long as the instance of the plug-in exists. The visibility of\n                  locals and accessing scripted plug-in locals from external code are described in \n                  			 <span class=\"char_link\"><a href=\"GUID-608825CD-D025-4054-91E2-2562A6AB31CF.htm\">Visibility of Locals, Functions, Structures, and User-Interface Items in Rollout Code</a></span> and \n                  			 <span class=\"char_link\"><a href=\"GUID-D7B7488F-BE23-4A1E-BA83-A48C21F6C73B.htm\">Accessing Locals and Other Items in a Rollout from External Code</a></span>. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54F8\"></a> <em class=\"strong\">Parameter blocks</em> - They define a set of parameters for the plug-in, which are like plug-in local variables,\n                  but are directly animatable and are saved to and restored from scene files. You can\n                  also associate each parameter with appropriate user-interface elements in one of the\n                  plug-ins rollouts. When associated in this way, the parameters are \"wired\" to their\n                  spinners, checkboxes, and others. Both update automatically as the other changes,\n                  so you do not have to write any user-interface event handlers for them. These parameters\n                  correspond to the visible parameters you see in other \n                  			 <em class=\"strong\">3ds Max</em> plug-ins. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54F6\"></a> <em class=\"strong\">Mouse tools</em> - They are used to perform a set of actions based on mouse clicks in the \n                  			 <em class=\"strong\">3ds Max</em> viewports and are described in \n                  			 <span class=\"char_link\"><a href=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29.htm\">Scripted Mouse Tools</a></span>. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54F4\"></a> <em class=\"strong\">Rollouts</em> - They can be displayed for the scripted plug-in. For scripted plug-ins that extend\n                  an existing plug-in, these rollouts can be displayed in addition to or replace the\n                  existing plug-in’s rollouts. Rollout definitions are described in \n                  			 <span class=\"char_link\"><a href=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F.htm\">Utility Clauses</a></span>. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54F2\"></a> <em class=\"strong\">Event handlers</em> - They are special kinds of functions associated with particular events. Event handlers\n                  specify the processing that must occur when a user creates an instance of the scripted\n                  plug-in or when \n                  			 <em class=\"strong\">3ds Max</em> calls the scripted plug-in. These actions generate named events and the optional\n                  event handler you supply for that event is called when the action occurs. \n                  		  \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54F1\"></a>Formally, the syntax of a \n            		<span class=\"code\">&lt;plugin_clause&gt;</span> is defined as follows: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7223\"></a><pre>\n&lt;plugin_clause&gt; ::= &lt;local_variable_decl&gt; | \n&lt;local_function_decl&gt; | \n&lt;local_struct_decl&gt; | \n&lt;parameters&gt; | \n&lt;tools&gt; | \n&lt;rollouts&gt; | \n&lt;event_handler&gt;\n</pre></div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54EE\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"50%\">\n                  <col width=\"50%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54EF\"></a><p class=\"table-heading\"> <em class=\"strong\">Topic Navigation:</em> \n                     </p> \n                  </th>\n                  <th class=\"table-heading\">&nbsp;</th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54ED\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC-54E5\">Locals</a></span> \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54EC\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-73C1\">Plugin Local Variables</a></span> \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54EB\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-73AA\">Parameters</a></span> \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54E9\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC-53F9\"> Parameter Event Handlers</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54E8\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC-5381\">Tools</a></span> \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54E7\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-72F7\">Rollouts and related Event Handlers</a></span> \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54E6\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-72EB\">Scripted_Plugin_Event_Handlers</a></span> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54E5\"></a> \n            <h2><a name=\"GUID-6740BB91-FBF2-4F97-B29B-49DBD9D7529B\"></a>Locals\n            </h2> <a name=\"TABLE_952B7A110F564359A4E855DA30304383\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1456432840515887%\">\n                     <col width=\"96.85435671594841%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-3B47EB57-7FF0-4F12-9D88-B0689E7EBFCB-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"P_0156FF2748014486A13AAF7E4F617270\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; \n                           					 \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4219\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Back To Topic Navigation \n                                    						  </a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54E3\"></a>The \n               		  <span class=\"code\">&lt;local_variable_decl&gt;</span>, \n               		  <span class=\"code\">&lt;local_function_decl&gt;</span>, and \n               		  <span class=\"code\">&lt;local_struct_decl&gt;</span> are exactly the same as local variable, function, and structure definitions in MAXScript:\n               \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7222\"></a><pre>&lt;local_variable_decl&gt; ::= <em class=\"codeEmphasisStrong\">local</em> &lt;decl&gt; {<em class=\"codeEmphasisStrong\"> , </em>&lt;decl&gt; }\n&lt;decl&gt; ::= &lt;name&gt; [ = &lt;expr&gt; ] -- optional initial value\n&lt;local_function_decl&gt; ::= [ <em class=\"codeEmphasisStrong\">mapped</em> ](<em class=\"codeEmphasisStrong\">function</em> | <em class=\"codeEmphasisStrong\">fn</em>) &lt;name&gt; { &lt;argument&gt; } <em class=\"codeEmphasisStrong\">= </em>&lt;expr&gt;\n&lt;local_struct_decl&gt; ::= <em class=\"codeEmphasisStrong\">struct</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">(</em> &lt;member&gt; {<em class=\"codeEmphasisStrong\"> , </em>&lt;member&gt; } <em class=\"codeEmphasisStrong\">)</em>\n&lt;member&gt; ::= ( &lt;name&gt; [ <em class=\"codeEmphasisStrong\">= </em>&lt;expr&gt; ] | &lt;local_function_decl&gt; )</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54DD\"></a>Global variables cannot be declared as a plug-in clause. However, they can be declared\n               within event handler scripts. If you need to ensure a variable name references a global\n               variable, declare the variable name as global immediately before defining the plug-in\n               in your script. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54DC\"></a>When writing scripts, it is good programming practice to explicitly declare your local\n               and global variables. Implicit declaration is provided as a short-hand, typically\n               used when working in the Listener interactively or developing short scripts. When\n               developing extended scripts, explicitly declaring variables can reduce errors and\n               improve readability of the code. It is also recommended that you declare as local\n               all variables unless you really want them to be global variables. The reasons for\n               this are described in \n               		  <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54DB\"></a>Plug-in locals are attached to plug-in objects and each new instance of the scripted\n               plug-in has its own local storage area. When you reference a plug-in local in a plug-in\n               function or handler, it accesses the local storage of the currently active object.\n               For example, the object currently open in the command panel. Plug-in local storage\n               is not permanent across scene saves and loads (unlike \n               		  <span class=\"code\"> <em class=\"strong\">&lt;parameters&gt;</em> </span>). You can provide initial values for locals, as elsewhere in MAXScript, and the locals\n               are re-initialized when a saved scripted plug-in object is loaded again as part of\n               a scene file open. You can also do this by hand in a \n               		  <span class=\"code\"> <em class=\"strong\">create</em> </span> event handler if you supply one in the plug-in. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54DA\"></a>Plug-in locals are accessible to script code outside a plug-in as a normal property\n               on the object, but note that they might be hidden by parameters or other common object\n               properties if they have the same name. When accessing a property on a scripted plug-in\n               object, MAXScript first looks in the common properties (such as, \n               		  <span class=\"code\"> <em class=\"strong\">.pos</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">.scale</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">.parent</em> </span>, and others on a node), then in the parameters, and then in the locals for a property\n               name match. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-73C1\"></a> \n            <h2><a name=\"GUID-1D6E3998-DB63-4F86-A376-46993A279B8B\"></a>   There are four local variables accessible in all scripted plug-ins:\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-6380\"></a> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC-54EF\">Scripted Plug-in Clauses </a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7221\"></a><pre><em class=\"codeEmphasisStrong\">version</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54D4\"></a>Yields the current version of the object as an Integer value. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7220\"></a><pre><em class=\"codeEmphasisStrong\">this</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54D2\"></a>Yields the instance of the scripted plug-in. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-721F\"></a><pre><em class=\"codeEmphasisStrong\">delegate</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54D0\"></a>Yields the instance of the plug-in you are extending in an \n               		  <span class=\"code\"> <em class=\"strong\">extends:</em> </span> plug-in. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-721E\"></a><pre><em class=\"codeEmphasisStrong\">loading</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54CE\"></a>In \n               		  <em class=\"strong\">3ds Max</em><em class=\"strong\">6 and higher,</em> yields True while the plug-in instance is in the process of being loaded. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54CD\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">version</em> </span> local variable contains the version number specified in the scripted plug-in definition.\n               See \n               		  <span class=\"char_link\"><a href=\"GUID-44D4AC45-65DD-401B-B4A1-07B71B35D544.htm\">Updating Scripted Plug-ins</a></span> for more information on this variable. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54CC\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">this</em> </span> local variable always contains the MAXScript value corresponding to the current instance\n               of the scripted plug-in. This variable provides a guaranteed way of accessing parameters\n               on the new object within plug-in code (in case there are locals or globals with the\n               same name), and it is a way of referencing the plug-in in case you want to store it\n               to a variable. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54CB\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">delegate</em> </span> local variable contains the MAXScript value corresponding to the instance of the\n               plug-in being extended. To access common properties or subAnim properties in the instance\n               of the plug-in being extended, you need to do so using the \n               		  <span class=\"code\"> <em class=\"strong\">delegate</em> </span> local variable. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54CA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54C9\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-721D\"></a><pre>\ndelegate.width = thisWidth\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-49D92FDB129CC323221-6413\"></a><p class=\"table-body\">inside a plug-in function or handler will set the \n                           						<span class=\"code\"> <em class=\"strong\">.width</em> </span> property in the instance of the plug-in being extended. The delegate local variable\n                           in a scripted plug-in that creates a scene object does not contain the node itself,\n                           but the BaseObject of that node. As such, you can not access the node level properties\n                           of the object being created. An exception to this is the node’s transform, which is\n                           exposed to the scripted plug-in through a local variable called \n                           						<span class=\"code\"> <em class=\"strong\">nodeTM</em> </span>. This variable is described in the applicable scripted plug-in type topics. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54C4\"></a>If the \n               		  <span class=\"code\"> <em class=\"strong\">extends:</em> </span> parameter is not supplied for a plug-in, \n               		  <span class=\"code\"> <em class=\"strong\">delegate</em> </span> returns \n               		  <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54C3\"></a>As well as local variables, you can define local functions and local structures, just\n               as you can with scripted utilities and rollouts. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-73AA\"></a> \n            <h2><a name=\"GUID-9A6C57EE-5815-46EC-ABA1-5D0C28BE17EC\"></a> <em class=\"strong\">Parameters</em> \n            </h2> <a name=\"TABLE_689B83E795BE43C8B7BBD36B2846AD37\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1456432840515887%\">\n                     <col width=\"96.85435671594841%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-3B47EB57-7FF0-4F12-9D88-B0689E7EBFCB-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"P_BD986A0AD42344C882EC5114A76F83CB\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; \n                           					 \n                        </p> <a name=\"P_EBA5B54C715549859DBA3005C9C6478D\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Back To Topic Navigation \n                                    						  </a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54C1\"></a>You can define one or more parameter blocks in a scripted plug-in. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54C0\"></a>A parameter block has the form: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-721C\"></a><pre><em class=\"codeEmphasisStrong\">parameters</em> &lt;name&gt; [<em class=\"codeEmphasisStrong\">type</em>:#class] [<em class=\"codeEmphasisStrong\">rollout</em>:&lt;name&gt;] <em class=\"codeEmphasisStrong\">(</em> \n{ &lt;param_defs&gt; }+ \n{ &lt;event_handler&gt; } \n<em class=\"codeEmphasisStrong\">)</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54BD\"></a>A parameter block defines a set of parameters for the plug-in, which are like plug-in\n               local variables, but are directly animatable and are saved to and restored from scene\n               files. You can also associate each parameter with appropriate user-interface elements\n               in one of the plug-ins rollouts. When associated in this way, the parameters are \"wired\"\n               to their spinners, checkboxes, and others. Both update automatically as the other\n               changes, so you do not have to write any user-interface event handlers for them. These\n               parameters correspond to the visible parameters you see in other \n               		  <em class=\"strong\">3ds Max</em> plug-ins. Parameters in the parameter block do not participate in \n               		  <em class=\"strong\">3ds Max</em>’s undo system, therefore changes to the parameter values are not undoable. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54BC\"></a>The \n               		  <span class=\"code\">&lt;name&gt;</span> you give to a parameter block becomes permanently associated with the parameter block\n               and is used by MAXScript to connect to the right parameter block in a plug-in object\n               that is being loaded from a scene file. This becomes important as you modify a plug-in\n               script and yet there are still objects corresponding to the old definition in other\n               files. When the old-version object is loaded, MAXScript attempts to convert it to\n               the new definition using the current parameter block definition as a guide. To properly\n               do this, each parameter in a parameter block is also given a permanent name. So, if\n               you have existing objects of your plug-in in other files, do not change the parameter\n               block names randomly or they will not be loadable. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54BB\"></a>The optional \n               		  <span class=\"code\"> <em class=\"strong\">type:</em>&lt;#class&gt; \n                  		  </span> specifies that the parameters in the parameter block are \"class\" parameters. This\n               means that there is one copy of each parameter for *all* the objects of this plug-in\n               class; they all share the parameter. Examples of existing class parameters are the\n               creation type and type-in parameters in a typical geometry primitive. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54BA\"></a>The optional \n               		  <span class=\"code\"> <em class=\"strong\">rollout:</em>&lt;name&gt; \n                  		  </span> specifies a rollout definition elsewhere in the plug-in body to use as the user-interface\n               rollout for the parameter block\'s parameters. A limitation of the internal parameter\n               block mechanism requires that each parameter block be associated with a separate rollout\n               and each rollout be associated with only one parameter block. This means that each\n               rollout you want to have in the plug-ins user interface must have its own separate\n               parameter block. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54B9\"></a>The \n               		  <span class=\"code\">&lt;param_defs&gt;</span> are definitions for each parameter in the parameter block. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54B8\"></a>They have the form: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-721B\"></a><pre>&lt;name&gt; <em class=\"codeEmphasisStrong\">type</em>:&lt;#name&gt; [<em class=\"codeEmphasisStrong\">tabSize</em>:&lt;integer&gt;] [<em class=\"codeEmphasisStrong\">tabSizeVariable</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">default</em>:&lt;operand&gt;] [<em class=\"codeEmphasisStrong\">animatable</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">subAnim</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">ui</em>:&lt;ui_def&gt;] [<em class=\"codeEmphasisStrong\">assettype</em>:&lt;asset_type&gt;] [<em class=\"codeEmphasisStrong\">invisibleInTV</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">showAllInTV</em>:&lt;boolean&gt;]\n[<em class=\"codeEmphasisStrong\">readOnly</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">readOnlyAsset</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">enumAsAsset</em>:&lt;boolean&gt;]\n[<em class=\"codeEmphasisStrong\">useNodeOsValidity</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">useNodeTmValidity</em>:&lt;boolean&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54B5\"></a>The \n               		  <span class=\"code\">&lt;name&gt;</span> is permanently associated with the parameter in the same sense as parameter block\n               names. They are used to connect to the right parameter when loading objects of the\n               scripted plug-in and allow you to make certain changes to a script and still be able\n               to load old version objects. So, as with parameter block names, do not change or re-use\n               parameter names if you have scene files with old version objects you want to get at.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-54B4\"></a>The \n               		  <span class=\"code\"><em class=\"strong\">type:</em>&lt;#name&gt;</span> parameter is required and defines the parameter type. It can be one of the following:\n               \n               		\n            </p> <a name=\"TABLE_CA2902473D3F409F940590B19ABDD885\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#float</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#integer</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#index</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#color</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#rgb</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable, alias of \n                        					 <em class=\"strong\"> <span class=\"code\">#color</span> </em> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#frgba</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable, available since \n                        					 <em class=\"strong\">3ds Max 6</em> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#point3</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#point4</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable, available since \n                        					 <em class=\"strong\">3ds Max 6</em> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#boolean</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#angle</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#percent</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#worldUnits</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#matrix3</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#string</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#filename</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#colorChannel</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#time</em> </span> \n                     </td>\n                     <td class=\"table-body\">animatable \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#radiobtnIndex</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#material</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#texturemap</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#bitmap</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#node</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#maxObject</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"><span class=\"code\"><em class=\"strong\">#paramBlock2</em></span> \n                     </td>\n                     <td class=\"table-body\">available since \n                        					 <em class=\"strong\">3ds Max 2018</em> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"><span class=\"code\"><em class=\"strong\">#point2</em></span> \n                     </td>\n                     <td class=\"table-body\">available since \n                        					 <em class=\"strong\">3ds Max 2018</em> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-549C\"></a>or one of the following types which are arrays of the above base types: \n               		\n            </p> <a name=\"TABLE_06746CF6DA8F44A3A0A7928A3467E11C\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#floatTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#intTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#indexTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#colorTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#rgbTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">Alias of \n                        					 <span class=\"code\"> <em class=\"strong\">#colorTab</em> </span> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#frgbaTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">Available since \n                        					 <em class=\"strong\">3ds Max 6</em> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#point3Tab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#point4Tab</em> </span> \n                     </td>\n                     <td class=\"table-body\">Available since \n                        					 <em class=\"strong\">3ds Max 6</em> \n                     </td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#boolTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#angleTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#percentTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#worldUnitsTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#matrix3Tab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#stringTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#filenameTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#colorChannelTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#timeTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#radiobtnIndexTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#materialTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#texturemapTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#bitmapTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#nodeTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#maxObjectTab</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-736B\"></a>In \n               		  <em class=\"strong\">3ds Max 2010 and higher</em>, when the parameter is of type \n               		  <em class=\"strong\"> <span class=\"code\">#filename</span> </em>, to handle the parameter as an asset you also need to specify \n               		  <span class=\"code\"><em class=\"strong\">assettype:</em>&lt;asset_type&gt;</span> where argument is one of the following enums: \n               		\n            </p> <a name=\"TABLE_1932E82560A64CA1AF42636861796AF2\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#Other</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#Bitmap</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#XRef</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#Photometric</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#Animation</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#VideoPost</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#BatchRender</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#ExternalLink</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#RenderOutput</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#PreRenderScript</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#PostRenderScript</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#Sound</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#Container</em> </span> \n                     </td>\n                     <td class=\"table-body\">&nbsp;</td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5471\"></a>TYPE_INDEX, TYPE_INDEX_TAB, TYPE_MATRIX3, and TYPE_MATRIX3_TAB have been added as\n               supported PB2 data types in MAXScript. TYPE_INDEX is used for parameters that are\n               0-based, but are exposed in MAXScript as 1-based, for example, a vertex index. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5470\"></a>The above data types are also available in scripted parameter blocks with types of\n               \n               		  <span class=\"code\"> <em class=\"strong\"> #index</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\"> #indexTab</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\"> #matrix3</em> </span>, and \n               		  <span class=\"code\"> <em class=\"strong\"> #matrix3Tab</em> </span> respectively. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-546F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-546E\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71DF\"></a><pre>\nheight1 type:#index animatable:true default:1 ui:height1\nheight3 type:#indexTab tabSizeVariable:true\nm3a type:#matrix3 default:(matrix3 [1,0,0] [0,0,1] [0,-1,0] [53.1187,-6.50834e-007,14.8893])\nm3b type:#matrix3tab tabSizeVariable:true\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5466\"></a><span class=\"code\"> <em class=\"strong\">type:#index</em> </span> is animatable, and \n               		  <span class=\"code\"> <em class=\"strong\">#matrix3</em> </span> is not. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5465\"></a><span class=\"code\"> <em class=\"strong\">type:#index</em> </span> must behave in the same manner as \n               		  <span class=\"code\"> <em class=\"strong\">type:#int</em> </span>, except the data value stored is 0-based, but is seen by MAXScript as 1-based. So,\n               if you had an object using an animated height1 property (as defined above), \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5464\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5463\"></a><p class=\"table-body\"> <em class=\"strong\">YOU WILL SEE SOMETHING LIKE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71DE\"></a><pre>\n$.height1\n15\n$.height1.controller.value\n14.0\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-545B\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">type:#integer</em> </span> parameters can be associated with dropDownList, ComboBox, and ListBox user interface\n               controls using the UI: option in the parameter definition. The value in the parameter\n               corresponds to the 1-based index of the currently selected item in the user interface\n               control. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-545A\"></a>ListBox user interface controls were not supported for integer parameter association\n               in releases prior to \n               		  <em class=\"strong\">3ds Max 7</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5459\"></a>Typically, you would populate this list with names or strings, and the value in the\n               associate parameter effectively becomes a code number for these names or strings.\n               Setting the value of the parameter using a script will automatically cause the corresponding\n               item in the dropDownList to be selected if the UI for that object is currently open.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5458\"></a> <span class=\"code\"> <em class=\"strong\">#worldUnits</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">#worldUnitsTab</em> </span> specify that a parameter holds a world distance value that is kept internally as\n               a system units float. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5457\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5456\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71DD\"></a><pre>\nparameters main rollout:params\n(\nheight type:#worldUnits ui:heightSpin\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-544F\"></a>Note that this does not cause any spinner display to be automatically shown in current\n               display units. You also need to specify \n               		  <span class=\"code\"> <em class=\"strong\">type:#worldUnits</em> </span> on the associated rollout spinner definition. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-544E\"></a> <span class=\"code\"> <em class=\"strong\">#node</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">#nodeTab</em> </span> are used to store references to nodes. The nodes stored in these parameters cannot\n               create a circular dependency. For example, if you were creating a scripted helper,\n               and set the helper as a target or parent of a camera, you cannot store the camera\n               node in a \n               		  <span class=\"code\"> <em class=\"strong\">#node</em> </span> or \n               		  <span class=\"code\"> <em class=\"strong\">#nodeTab</em> </span> parameter. Likewise, if you created a scripted modifier or material, and store a\n               node in a \n               		  <span class=\"code\"> <em class=\"strong\">#node</em> </span> or \n               		  <span class=\"code\"> <em class=\"strong\">#nodeTab</em> </span> parameter, you cannot apply the modifier or material to that node. \n               		\n            </p> \n            <p><span class=\"code\">#node</span> and \n               		  <span class=\"code\">#nodeTab</span> can take these flags, which affect whether the plugin is re-evaluated if the node\n               is animated: \n               		\n            </p> <a name=\"UL_CC0AE26739F84B6AA290C1451F6543C8\"></a><ul>\n               <li><span class=\"code\">useNodeTmValidity</span> - set to true to cause the scripted plugin to take into account the node\'s transform\n                  validity. \n                  		  \n               </li>\n               <li><span class=\"code\">useNodeOsValidity</span> - set to true to cause the scripted plugin to take into account the node\'s object\n                  space / geometry pipeline validity. \n                  		  \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-544D\"></a>The various \n               		  <span class=\"code\"> <em class=\"strong\">xxTab</em> </span> parameter types allow you to store an array of values having the corresponding type.\n               The initial size of the array is specified using the \n               		  <span class=\"code\"> <em class=\"strong\">tabSize:</em> </span> specifier. If \n               		  <span class=\"code\"> <em class=\"strong\">tabSizeVariable:true</em> </span> is specified, the size of the array will be automatically expanded when you assign\n               to an higher array index. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-544C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-544B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71DC\"></a><pre>\nparameters main rollout:params\n(\nmapAmounts type:#floatTab tabSize:4 tabSizeVariable:true ui:(map1Amount, map2Amount, map3Amount, map4Amount)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5444\"></a>defines an array parameter containing four float elements (defined by the \n               		  <span class=\"code\"> <em class=\"strong\">tabSize:</em> </span> parameter). \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5443\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\"> <em class=\"strong\">WARNING!</em> \n                     </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5441\"></a><p class=\"table-body\">The number of UI items must match the tabSize. If the user increases the tab size\n                           using a script, new UI elements are not created for the new items. If the user decreases\n                           the number to less than the UI element count, this will lead to a crash. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-543F\"></a>You can associate a separate rollout element with each array parameter element. These\n               parameters appear as arrays when accessed in the plug-in handler code. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-543E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-543D\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71DB\"></a><pre>\na = mapAmounts[i]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5439\"></a>Because \n               		  <span class=\"code\"> <em class=\"strong\">tabSizeVariable:true</em> </span> was specified, the following will automatically increase the array size to 10: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71DA\"></a><pre>\nmapAmounts[10] = a\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5437\"></a>You can also increase or decrease the array size by assigning a value to the \n               		  <span class=\"code\"> <em class=\"strong\">.count</em> </span> property. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5436\"></a>Each element in an array parameter whose base type is a number of some kind (<span class=\"code\"> <em class=\"strong\">floatTab</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">intTab</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">percentTab</em> </span>, and so on) is independently and automatically animatable unless you specify \n               		  <span class=\"code\"> <em class=\"strong\">animatable:false</em> </span>. You can get at and assign individual controllers using the \n               		  <span class=\"code\"> <em class=\"strong\">.controller</em> </span> property. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5435\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5434\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71D9\"></a><pre>\nc = mapAmounts[i].controller\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5430\"></a>The optional parameter \n               		  <span class=\"code\"> <em class=\"strong\">default:&lt;operand&gt;</em> </span> specifies an initial default value for the parameter. The \n               		  <span class=\"code\"> <em class=\"strong\">&lt;operand&gt;</em> </span> expression has to be convertible by MAXScript to the base type of the parameter.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-542F\"></a>The optional parameter \n               		  <span class=\"code\"> <em class=\"strong\">animatable:&lt;boolean&gt;</em> </span> specifies whether the parameter is animatable and hence visible in the track view.\n               Only those base types marked as animatable in the above type list can be specified\n               as animatable. Defaults to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-542E\"></a>The optional parameter \n               		  <span class=\"code\"> <em class=\"strong\">subAnim:&lt;boolean&gt;</em> </span> can be specified for the \n               		  <em class=\"strong\">3ds Max</em> object types: \n               		  <span class=\"code\"> <em class=\"strong\">#node</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">#material</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">#textureMap</em> </span>, and \n               		  <span class=\"code\"> <em class=\"strong\">#maxObject</em> </span>. If specified as \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span>, the \n               		  <em class=\"strong\">3ds Max</em> object is made visible as a sub-object track in track view. Defaults to \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-542D\"></a>The optional parameter \n               		  <span class=\"code\"> <em class=\"strong\">ui:&lt;ui_def&gt;</em> </span> is used to specify which user-interface element in the parameter block\'s associated\n               rollout is to be linked to this parameter. When linked, the handling of user actions\n               for these elements are automatic and they also update automatically to follow any\n               changes to the parameter caused by animation, scripts, and others. For example, in\n               the following, the parameter block named \n               		  <span class=\"code\"> <em class=\"strong\">main</em> </span> is associated with the rollout named \n               		  <span class=\"code\"> <em class=\"strong\">params</em> </span>. The parameters \n               		  <span class=\"code\"> <em class=\"strong\">height</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">spread</em> </span> are then linked with the spinners named \n               		  <span class=\"code\"> <em class=\"strong\">height</em> </span> and \n               		  <span class=\"code\"> <em class=\"strong\">spread</em> </span> in that rollout: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-542C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-542B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71D8\"></a><pre>\nparameters main rollout:params\n(\nkey type:#node subAnim:true\nfill type:#node subAnim:true\nback type:#node subAnim:true\nheight type:#float animatable:true default:10 ui:height\nspread type:#float animatable:true default:10 ui:spread\non height set val do\n(\nkey.pos.z = val\nback.pos.z = val * 1.5\nfill.pos.z = val * 0.5\n)\n)\nrollout params \"Light Parameters\"\n(\nspinner height \"Height\"\nspinner spread \"Spread\"\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5415\"></a>After this is done, the parameter and spinner are linked and changes in one are reflected\n               immediately and automatically in the other. Further, if the parameter is animated,\n               the spinner will show red keyframe highlights when the time slider is positioned at\n               a keyframe for that parameter as with other \n               		  <em class=\"strong\">3ds Max</em> plug-ins. The kinds of user-interface items that can be linked to particular parameter\n               types is limited to the following sensible combinations: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5414\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"33.23216995447648%\">\n                     <col width=\"66.76783004552352%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5413\"></a><p class=\"table-body\"> <em class=\"strong\">Parameter type</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5412\"></a><p class=\"table-body\"> <em class=\"strong\">Rollout user-interface item</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#integer</em> </span> \n                     </td>\n                     <td class=\"table-body\"> spinner, slider, radioButtons, checkbox, checkbutton \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#float</em> </span> \n                     </td>\n                     <td class=\"table-body\"> spinner, slider \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#time</em> </span> \n                     </td>\n                     <td class=\"table-body\"> spinner, slider \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#color</em> </span> \n                     </td>\n                     <td class=\"table-body\"> colorpicker \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#angle</em> </span> \n                     </td>\n                     <td class=\"table-body\"> spinner, slider \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#percent</em> </span> \n                     </td>\n                     <td class=\"table-body\"> spinner, slider \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#colorChannel</em> </span> \n                     </td>\n                     <td class=\"table-body\"> spinner, slider \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#boolean</em> </span> \n                     </td>\n                     <td class=\"table-body\"> checkbox, checkbutton \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#node</em> </span> \n                     </td>\n                     <td class=\"table-body\"> pickButton \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#textureMap</em> </span> \n                     </td>\n                     <td class=\"table-body\"> mapButton \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#material</em> </span> \n                     </td>\n                     <td class=\"table-body\"> materialButton \n                        				  \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">#worldUnits</em> </span> \n                     </td>\n                     <td class=\"table-body\"> spinner, slider \n                        				  \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-76C23A9E-10EE-48F8-955B-449A8BCB6B59\"></a>The optional parameter \n               		  <span class=\"code\"> <em class=\"strong\">invisibleInTV:&lt;boolean&gt;</em> </span> if set to \n               		  <em class=\"strong\">true</em> hides the parameter in TrackView. This only applies to parameters that are subAnim\n               or animatable normally shown in TrackView. The default is \n               		  <em class=\"strong\">false</em>. \n               		\n            </p> \n            <p><a name=\"GUID-DAD9C9F6-0103-4E14-AFC5-6B76A41A4A69\"></a>The optional parameter \n               		  <span class=\"code\"> <em class=\"strong\">showAllInTV:&lt;boolean&gt;</em> </span> if set to \n               		  <em class=\"strong\">true</em>, and the parameter is subAnim or animatable normally shown in TrackView, and the\n               parameter is also a Tab type parameter, then all of the tab elements are shown in\n               TrackView. The default is \n               		  <em class=\"strong\">false</em>. \n               		\n            </p> \n            <p>The optional parameter \n               		  <span class=\"code\"><em class=\"strong\">readOnly:&lt;boolean&gt;</em></span> if set to true, means the parameter\'s value cannot be set using MAXScript, it can\n               only be changed in the user interface. Similarly, the optional \n               		  <span class=\"code\"><em class=\"strong\">readOnlyAsset:&lt;boolean&gt;</em></span> parameter applies to asset type parameters, and when true, the parameter\'s value\n               cannot be set using the Asset Tracker or MAXScript. It can only be changed using the\n               user interface. \n               		\n            </p> \n            <p>The optional parameter \n               		  <span class=\"code\"><em class=\"strong\">enumAsAsset:&lt;boolean&gt;</em></span> if set to true for asset type parameters, specifies that the asset held by the parameter\n               is reported when performing scene asset enumeration. \n               		\n            </p> <a name=\"TABLE_E4B328B0D31247E39B7B780A5EE2C2D9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\nt=teapot()\nbitmap_holder = attributes \"bitmap_holder\"\n(\nparameters main\n(\nthebitmap type:#filename assetType:#bitmap enumAsAsset:true\n)\n)\ncustattributes.add t.baseobject bitmap_holder\nt.baseobject.thebitmap = \"fir1.tga\"\n\nfunction get_names name a = append a name\nfiles = #()\nenumerateFiles t.baseobject get_names files\nenumerateFiles t.baseobject get_names files #missing\nfiles\n\n--&gt; #(\"fir1.tga\")\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p> </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-53F9\"></a> \n            <h2><a name=\"GUID-719C1C76-B543-47B9-92B3-873D74AFC4DA\"></a>Parameter Event Handlers\n            </h2> <a name=\"TABLE_0A24D65BCF5B41B698BBC365B581EE31\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1456432840515887%\">\n                     <col width=\"96.85435671594841%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-3B47EB57-7FF0-4F12-9D88-B0689E7EBFCB-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"P_F25BF3F277E34784899160083B20EE1F\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; \n                           					 \n                        </p> <a name=\"P_4CF9403C5536468BB95561D1200789F1\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Back To Topic Navigation \n                                    						  </a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-53F7\"></a>The following event handlers are associated with parameters. These handlers are called\n               when a parameter is assigned a value, or when the parameter value is retrieved. \n               		\n            </p> \n            <div><a name=\"GUID-B666ADFF-F480-4D26-9FA6-F10941484B53\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span><em class=\"strong\">preSet</em> replaces \n                  		  <em class=\"strong\">set</em> in most situations; see below. \n                  		\n               </div>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71BF\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">set</em> &lt;arg&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;\n<em class=\"codeEmphasisStrong\">on</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">preSet</em> &lt;arg1&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;\n<em class=\"codeEmphasisStrong\">on</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">postSet</em> &lt;arg1&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-53F5\"></a>A \n               		  <span class=\"code\"> <em class=\"strong\">set</em> </span> handler can be supplied for any of the parameters in the block and it will be called\n               whenever the parameter is updated, either through an associated rollout user-interface\n               item or directly, especially using the MAXScript property assignment. In general,\n               the way you code change handlers is to supply \n               		  <span class=\"code\"> <em class=\"strong\">set</em> </span> handlers for parameters, rather than \n               		  <span class=\"code\"> <em class=\"strong\">on &lt;item&gt;</em> </span> change handlers for spinners, checkboxes, and others in the rollout definition. A\n               \n               		  <span class=\"code\"> <em class=\"strong\">set</em> </span> handler in used in the previous example to update the light positions when the height\n               parameter value changes. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-53F4\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">set</em> </span> handlers are also called when an instance is created or loaded so that common dependent\n               actions can be taken such as, setting up other dependent system object or delegate\n               properties. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75C8\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If the param is of a \n                  		  <em class=\"strong\">tab</em> type, the \n                  		  <span class=\"code\"> <em class=\"strong\">set</em> </span> handler is \n                  		  <em class=\"strong\">not</em> called on create or load. \n                  		\n               </div>\n            </div> \n            <p>Available since \n               		  <em class=\"strong\">3ds Max 2018</em>: The \n               		  <em class=\"strong\">preSet</em> and \n               		  <em class=\"strong\">postSet</em> handlers guarantee the state of the parameter value. In most situations you should\n               use \n               		  <em class=\"strong\">preSet</em> instead of \n               		  <em class=\"strong\">set</em>, as the parameter value is guaranteed to be the original value, while the \n               		  <span class=\"code\">&lt;arg&gt;</span> passed through is the new value. To alter the \n               		  <span class=\"code\">&lt;arg&gt;</span> value passing through, do not change \n               		  <span class=\"code\">&lt;arg&gt;</span>, but rather return a new value from the handler. MAXScript will set the parameter\n               to this returned value. \n               		\n            </p> \n            <p>In situations where you do not need to alter the value passing through, or do not\n               care about the original parameter value (for example, when you are updating a UI element),\n               use \n               		  <em class=\"strong\">postSet</em>. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71BE\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">get</em> &lt;arg&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-53EE\"></a>A \n               		  <span class=\"code\"> <em class=\"strong\">get</em> </span> handler can be supplied for any of the parameters in the block and it will be called\n               whenever the parameter value is retrieved. This will occur when the user interface\n               updates itself or a script accesses the parameter. It will also occur when a viewport\n               is redrawn or a render occurs if a script (including the scripted plugin itself) accesses\n               the parameter as part of the redraw or render. In all these cases, the animated value\n               is retrieved one or more times. The \n               		  <span class=\"code\"> <em class=\"strong\">get</em> </span> handler is called with a single argument which is the current value stored in the\n               paramblock (or underlying controller if the parameter is animated). The \n               		  <span class=\"code\"> <em class=\"strong\">currentTime</em> </span> variable is set to the time at which the value is being retrieved and not necessarily\n               the current slider time, since you can ask a parameter for its value for any specified\n               time. If you implement the \n               		  <span class=\"code\"> <em class=\"strong\">get</em> </span> handler, you must return a value, and that value is returned as the value of the\n               parameter to the value requester. If you do not want to modify the value, but just\n               monitor accesses, return the argument. You can also compute and return any value of\n               the appropriate type. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71BD\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">set</em> &lt;arg1&gt; [&lt;arg2&gt;] <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;\n\n<em class=\"codeEmphasisStrong\">on</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">get</em> &lt;arg1&gt; [&lt;arg2&gt;] <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-53EA\"></a>For both get and set handlers, if the parameter is of \n               		  <em class=\"strong\">tab</em> type, a second argument can be specified for the handlers. The tab index will be\n               placed in the second argument. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-53E9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-53E8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71BC\"></a><pre>\nplugin helper getsetHandlerTest\nname:\"DummyEx\"\nclassID:#(1453456,5432110)\ncategory:\"Scripted Primitives\"\nextends:dummy\n(\nparameters main rollout:params\n(\nnodeTab type:#nodetab tabSizeVariable:true\non nodeTab set val index do format \"set nodeTab: % : %\\n\" val index\non nodeTab get val index do (format \"get nodeTab: % : %\\n\" val index;val)\nintTab type:#inttab tabSizeVariable:true\non intTab set val index do format \"set intTab: % : %\\n\" val index\non intTab get val index do (format \"get intTab: % : %\\n\" val index;val)\npoint3Tab type:#point3tab tabSizeVariable:true\non point3Tab set val index do format \"set point3Tab: % : %\\n\" val index\non point3Tab get val index do (format \"get point3Tab: % : %\\n\" val index;val)\nintVal type:#integer\non intVal set val do format \"set intVal: %\\n\" val\non intVal get val do (format \"get intVal: %\\n\" val;val)\n)\nrollout params \"Parameters\"\n(\n)\n)\n----------------------------------\n--Test the Get and Set Handlers:--\n----------------------------------\nx=getsetHandlerTest() --create an instance of the above Helper\nb=box()\ns=sphere()\nx.nodeTab[1] = b\nx.nodeTab[2] = s\nx.nodeTab[1]\nx.nodeTab[2]\nx.intTab[1] = 9\nx.intTab[2] = 20\nx.intTab[1]\nx.intTab[2]\nx.point3Tab[1] = [pi,pi,pi]\nx.point3Tab[2] = [e,e,e]\nx.point3Tab[1]\nx.point3Tab[2]\nx.intVal = 20\nx.intVal\nwith animate on at time 100 x.intVal = 120\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-53AF\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71BB\"></a><pre>\ngetsetHandlerTest\nset intVal: 0\n$DummyEx:DummyEx01 @ [0.000000,0.000000,0.000000]\n$Box:Box01 @ [0.000000,0.000000,0.000000]\n$Sphere:Sphere01 @ [0.000000,0.000000,0.000000]\nset nodeTab: $Box:Box01 @ [0.000000,0.000000,0.000000] : 1\n$Box:Box01 @ [0.000000,0.000000,0.000000]\nset nodeTab: $Sphere:Sphere01 @ [0.000000,0.000000,0.000000] : 2\n$Sphere:Sphere01 @ [0.000000,0.000000,0.000000]\nget nodeTab: $Box:Box01 @ [0.000000,0.000000,0.000000] : 1\n$Box:Box01 @ [0.000000,0.000000,0.000000]\nget nodeTab: $Sphere:Sphere01 @ [0.000000,0.000000,0.000000] : 2\n$Sphere:Sphere01 @ [0.000000,0.000000,0.000000]\nset intTab: 9 : 1\n9\nset intTab: 20 : 2\n20\nget intTab: 9 : 1\n9\nget intTab: 20 : 2\n20\nset point3Tab: [3.14159,3.14159,3.14159] : 1\n[3.14159,3.14159,3.14159]\nset point3Tab: [2.71828,2.71828,2.71828] : 2\n[2.71828,2.71828,2.71828]\nget point3Tab: [3.14159,3.14159,3.14159] : 1\n[3.14159,3.14159,3.14159]\nget point3Tab: [2.71828,2.71828,2.71828] : 2\n[2.71828,2.71828,2.71828]\nset intVal: 20\n20\nget intVal: 20\n20\nset intVal: 120\n120\nOK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71BA\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">tabChanged</em> &lt;arg1&gt; &lt;arg2&gt; &lt;arg3&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5387\"></a>A \n               		  <span class=\"code\"> <em class=\"strong\">tabChanged</em> </span> handler can be supplied for any Tab parameters in the block and will be called when\n               an operation is performed on the tab itself. The arguments are: \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5386\"></a> <span class=\"code\"> <em class=\"strong\">arg1</em> </span> - The type of change. Will be one of: #<span class=\"code\"> <em class=\"strong\">insert</em> </span>, #<span class=\"code\"> <em class=\"strong\">append</em> </span>, #<span class=\"code\"> <em class=\"strong\">delete</em> </span>, #<span class=\"code\"> <em class=\"strong\">refDeleted</em> </span>, #<span class=\"code\"> <em class=\"strong\">setCount</em> </span>, or #<span class=\"code\"> <em class=\"strong\">sort</em> </span>. All are pretty evident except for #<span class=\"code\"> <em class=\"strong\">refDeleted</em> </span>. This type will occur when a MAXWrapper stored in the tab is deleted. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5385\"></a> <span class=\"code\"> <em class=\"strong\">arg2</em> </span> - The tabIndex associated with the operation. If not applicable, it will have a value\n               of 0. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5384\"></a> <span class=\"code\"> <em class=\"strong\">arg3</em> </span> - The count associated with the operation. If not applicable, it will have a value\n               of -1. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5383\"></a>For example, if you append an item to a tab that already contains one member, you\n               will get a call to this handler with arguments of: #append 2 1. The set handler is\n               not called, so you must handle this message in the same way as the set handler. \n               		\n            </p> \n            <p> </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5381\"></a> \n            <h2><a name=\"GUID-E1B52BDB-C018-4365-B8AE-19982E002DCF\"></a>Tools\n            </h2> <a name=\"TABLE_66A06D6004F34C8D9D5871FED981EBF6\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1456432840515887%\">\n                     <col width=\"96.85435671594841%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-3B47EB57-7FF0-4F12-9D88-B0689E7EBFCB-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"P_EBD331BD677E4B94B32C0B95FCA7165D\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; \n                           					 \n                        </p> <a name=\"P_A65CC66E55DB40E3AAF3907963281E55\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Back To Topic Navigation \n                                    						  </a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-537F\"></a>Plug-ins can define local mouse tools. Although, you can have any number of local\n               tools and start them as needed, you typically supply a single tool with the reserved\n               name \n               		  <span class=\"code\"> <em class=\"strong\">create</em> </span>. This is taken to be the create tool for objects created in the Create panel and\n               is invoked automatically when you create scripted plug-in objects. Tool definitions\n               are described in \n               		  <span class=\"char_link\"><a href=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29.htm\">Scripted Mouse Tools</a></span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-537E\"></a>Creatable scene scripted plug-ins (scripted plug-ins that are not invisible, temporary,\n               or extend another plug-in) require a \n               		  <span class=\"code\"> <em class=\"strong\">create</em> </span> tool. A \n               		  <span class=\"code\"> <em class=\"strong\">create</em> </span> tool, if present on a non-temporary extending plug-in will override the delegate\'s\n               create tool. The animate state is implicitly turned off while the \n               		  <span class=\"code\"> <em class=\"strong\">create</em> </span> tool is executed. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-537D\"></a>A local variable \n               		  <span class=\"code\"> <em class=\"strong\">WS73099cc142f487553098682e12ac2fc2bc7-722e</em> </span> is accessible within the \n               		  <span class=\"code\"> <em class=\"strong\">create</em> </span> tool. This variable contains a Matrix3 value. This value is in the active grid coordinate\n               system. This variable allows the \n               		  <span class=\"code\"> <em class=\"strong\">create</em> </span> tool to set the transform of the node currently being created. Also, within the \n               		  <span class=\"code\"> <em class=\"strong\">create</em> </span> tool you must use the \n               		  <span class=\"code\"> <em class=\"strong\">gridX</em> </span> values rather than \n               		  <span class=\"code\"> <em class=\"strong\">worldX</em> </span> values in all cases because object-creation is managed in the active grid coordinate\n               system. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-72F7\"></a> \n            <h2><a name=\"GUID-3CD316C7-A65B-4736-8BD3-F8566B5244C8\"></a> <em class=\"strong\">Rollouts and related Event Handlers</em> \n            </h2> <a name=\"TABLE_D6117BB88B21400AB7546AF1B63A821B\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1456432840515887%\">\n                     <col width=\"96.85435671594841%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-3B47EB57-7FF0-4F12-9D88-B0689E7EBFCB-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"P_89760D66470443739F850F4C92121B7A\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; \n                           					 \n                        </p> <a name=\"P_43CBDB2342C944B8B323793C591A2FCE\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Back To Topic Navigation \n                                    						  </a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-537B\"></a>Plug-ins can define local rollouts. These have the same syntax as local rollouts in\n               scripted utilities. Unlike utility local rollouts, these rollouts are automatically\n               opened as appropriate for the plug-in type (in the command panel, Material Editor,\n               and others). \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75C7\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Rollout local variables only live as long as the rollout is open in the user interface.\n                  It gets opened and closed each time it is displayed, so the rollout open and close\n                  events are signalled at this time. If you want to load any spinners or other user-interface\n                  elements from the currently editing plug-in object, supply an \n                  		  <span class=\"code\"> <em class=\"strong\">on &lt;rollout&gt; open</em> </span> event handler to pick up these values. Rollout definitions are described in \n                  		  <span class=\"char_link\"><a href=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F.htm\">Utility Clauses</a></span>. \n                  		\n               </div>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71B8\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;rollout&gt; <em class=\"codeEmphasisStrong\">reload do ...</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5371\"></a>This event handler is defined for rollouts in scripted plug-ins. This handler is called\n               in a scripted material, environment, or render effect whenever an instance of the\n               plug-in is open in the Material Editor or render effects dialog, and another instance\n               of the same plug-in class is selected. In this situation, the existing rollout is\n               not closed and re-opened, but rather left open and \'loaded\' with the new instance.\n               The \'reload\' handler is called after the new instance is installed in the rollout\n               and can be used in place of \'on &lt;rollout&gt; open do ...\' handler to update the rollout.\n               The open handler is not called in this case. The reload event handler is not called\n               if the scripted object has custom attributes associated with it, rather the existing\n               rollout is closed and a new rollout opened. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71B7\"></a><pre><em class=\"codeEmphasisStrong\">on </em>&lt;rollout&gt; <em class=\"codeEmphasisStrong\">setTime </em>&lt;val&gt; <em class=\"codeEmphasisStrong\">do</em> ...</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-536E\"></a>This event handler is defined for rollups in scripted materials and texturemaps. This\n               handler is called whenever the time slider is changed while the rollout is displayed.\n               &lt;val&gt; is the slider time. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-72EB\"></a> \n            <h2><a name=\"GUID-E5420127-0733-491A-A6E7-EECBA9A4861E\"></a> <em class=\"strong\">Event Handlers</em> \n            </h2> <a name=\"TABLE_D66EA6BA0E3D4C8DA8D71EB866674839\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1456432840515887%\">\n                     <col width=\"96.85435671594841%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-3B47EB57-7FF0-4F12-9D88-B0689E7EBFCB-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"P_969FCC00FDB6423294708674AE595333\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; \n                           					 \n                        </p> <a name=\"P_C0D594F6D200416786769478FE3ABB30\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Back To Topic Navigation \n                                    						  </a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-536C\"></a>As with mouse tools, scripted plug-ins respond to certain actions in \n               		  <em class=\"strong\">3ds Max</em> by implementing handler functions. All types of scripted plug-ins support the following\n               event handlers. You can use these event handlers to perform any extra initialization\n               needed such as, loading up plug-in local variables or initializing properties of the\n               plug-in’s delegate. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71B6\"></a><pre><em class=\"codeEmphasisStrong\">on create do</em> &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-536A\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">create</em> </span> event handler is called whenever an instance of a scripted plug-in is created in\n               a scene file. The animate state is implicitly turned off while the \n               		  <span class=\"code\"> <em class=\"strong\">create</em> </span> event handler expression is executed. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71B5\"></a><pre><em class=\"codeEmphasisStrong\">on postCreate do</em> &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5367\"></a>When a scripted plugin is created, its create handler is called, the set handler for\n               all paramBlock items are called, and then the postCreate handler is called. Available\n               in \n               		  <em class=\"strong\">3ds Max 6 and higher</em>. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71B4\"></a><pre><em class=\"codeEmphasisStrong\">on load do</em> &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5364\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">load</em> </span> event handler that is called whenever an instance of a scripted plug-in is loaded\n               from a scene file. The animate state is implicitly turned off while the \n               		  <span class=\"code\"> <em class=\"strong\">load</em> </span> event handler expression is executed. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71B3\"></a><pre><em class=\"codeEmphasisStrong\">on postLoad do</em> &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5361\"></a>When a scripted plugin is loaded, its update handler is called if necessary, the load\n               handler is called, the set handler for all param block items are called, and then\n               the postLoad handler is called. In most cases, you do not want to perform any action\n               in the param block item set handlers when they are called during a load. You can make\n               processing with the set handlers conditional using the \'loading\' automatic variable.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5360\"></a>Available in \n               		  <em class=\"strong\">3ds Max 6 and higher</em>. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-535F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\"> <em class=\"strong\">WARNING!</em> \n                     </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-535D\"></a><p class=\"table-body\">It is recommended that MAX objects not be deleted in the load or postload handlers,\n                           or in the param block item set handlers when they are called during a load. These\n                           calls occur much later in the scene load than the update handler, and deleting objects\n                           will most likely not cause a failure. However, this can not be guaranteed. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71B2\"></a><pre><em class=\"codeEmphasisStrong\">on update do</em> &lt;nodeVar&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-535A\"></a>The \n               		  <span class=\"code\"> <em class=\"strong\">update</em> </span> event handler that is called whenever an instance of a scripted plug-in is present\n               in the scene file, and the definition of the scripted plug-in is changed (if you define\n               a scripted plug-in, create an instance of the plug-in object in the scene, and then\n               change and execute the script defining the scripted plug-in, the update event handler\n               defined in the new definition of the scripted plug-in script is called for each instance\n               of the plug-in object in the scene). See the Updating Scripted Plug-ins topic for\n               more information. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5359\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\"> <em class=\"strong\">WARNING!</em> \n                     </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5357\"></a><p class=\"table-body\">You must not cause a MAX object to be deleted in an update handler. The file is not\n                           done loading when the update handler is called and deleting an object might cause\n                           a crash when \n                           						<em class=\"strong\">3ds Max</em> tries to finish loading the now deleted object. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71B1\"></a><pre><em class=\"codeEmphasisStrong\">on attachedToNode</em> &lt;nodeVar&gt; <em class=\"codeEmphasisStrong\">do </em>...</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5354\"></a>Called whenever a scripted plug-in scene object (geometry, camera, light, helper,\n               shape) is bound to a node in the scene such as, during create mode. The node that\n               the current plug-in instance is being attached to is given as the first argument.\n               In the event of scene node instancing, this handler might be called several times,\n               whenever the base object is instanced to a node. Note that, in most cases, this will\n               be called in the middle of a create mode and consequently actions such as, creating\n               other nodes in the handler body are forbidden as they are generally in \'on create\'\n               handlers. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71B0\"></a><pre><em class=\"codeEmphasisStrong\">on detachedFromNode</em> &lt;node&gt; <em class=\"codeEmphasisStrong\">do ...</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5351\"></a>This is a handler to scene object scripted plug-ins. It is called whenever a node\n               that references a plug-in instance is deleted in the scene. Note that in the presence\n               of instancing, there might still be other nodes referencing the base object instance.\n               \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71AF\"></a><pre><em class=\"codeEmphasisStrong\">on deleted do</em>...</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-534E\"></a>Called whenever the scripted plug-in object is finally deleted. This might not occur\n               immediately such as, when a scene node containing a scripted base object is deleted\n               because the object is held onto by the undo stack in case the node delete is undone\n               by the user. The delete might occur when the undo stack is cleared such as, a file\n               new or reset. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71AE\"></a><pre><em class=\"codeEmphasisStrong\">on clone</em> &lt;original&gt; <em class=\"codeEmphasisStrong\">do ...</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-534B\"></a>Called whenever an instance of a scripted plug-in is cloned. This event handler is\n               called on the newly created scripted plugin instance and the argument passed in is\n               the plugin instance that was cloned. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-534A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5349\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71AD\"></a><pre>\nplugin material MyMaterial\nname:\"MyMaterial\"\nclassID:#(0x69fedc0d, 0x7c79a4d2)\nextends:Standard replaceUI:true\n(\nparameters hardwareShaders rollout:shaderRoll\n(\n)\nrollout shaderRoll \"Hardware Shaders\" width:328 height:189\n(\nlabel l1 \"AA\"\n)\non create do format \"created: %\\n\"this\non clone orig do format \"cloned: % : % : % : %\\n\" this orig(this == orig) (delegate == orig.delegate)\n)\na=mymaterial()\nb=copy a\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5333\"></a><p class=\"table-body\"> <em class=\"strong\">RESULTS:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71AC\"></a><pre>\nMyMaterial\ncreated: (null):MyMaterial\nMyMaterial:MyMaterial\ncloned: MyMaterial:MyMaterial : MyMaterial:MyMaterial : false : false\nMyMaterial:MyMaterial\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-532B\"></a>Specific classes of scripted plug-ins implement additional event handlers and are\n               described with description of the scripted plug-in type. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-532A\"></a>Runtime errors in certain event handlers cause the plug-in to be disabled until it\n               is re-defined. When disabled, none of the plug-in event handlers are called. For example,\n               errors in the \n               		  <span class=\"code\"> <em class=\"strong\">map</em> </span> event handler expression in \n               		  <span class=\"code\"> <em class=\"strong\">SimpleMods</em> </span> and the \n               		  <span class=\"code\"> <em class=\"strong\">buildMesh</em> </span> event handler expression in \n               		  <span class=\"code\"> <em class=\"strong\">SimpleObject</em> </span> disable the plug-in because they are called so frequently. You will need to correct\n               any problems and re-evaluate the plug-in definition again to re-enable the plug-in\n               event handlers. \n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5328\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";