var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-4733B2AC-1F0E-4A78-A79C-93ED8A28DAC9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"working with\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Working with Note Tracks</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4733B2AC-1F0E-4A78-A79C-93ED8A28DAC9\"></a><div class=\"head\">\n            <h1>Working with Note Tracks </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-366F\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-366E\"></a> Changing the <span class=\"code\"> <em class=\"strong\">time</em> </span> property of a note key may cause it to go out of time order relative to the other\n               keys in the controller. You <em class=\"strong\"> must </em> call the <span class=\"code\"> <em class=\"strong\">sortKeys() </em> </span>function on the controller or associated <span class=\"code\"> <em class=\"strong\">MAXNoteKeyArray</em> </span> once all key time manipulations of this kind is complete so that animation will perform\n               correctly. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-366C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-366B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DB5\"></a><pre>\ns = sphere()-- create a sphere\n--&gt;$Sphere:Sphere02 @ [0.0,0.0,0.0]\nntp1 = NoteTrack\"PosNT1\"-- create a note track\n--&gt;Notetrack:PosNT1\nntp2 = NoteTrack\"PosNT2\"-- create another note track\n--&gt;Notetrack:PosNT2\n-- apply first note track to sphere\'s pos controller:\naddNoteTrack s.pos.controller ntp1\n--&gt;OK\n-- apply second note track to sphere\'s pos controller:\naddNoteTrack s.pos.controller ntp2\n--&gt;OK\n-- check number of note tracks on pos controller:\nnumNoteTracks s.pos.controller\n--&gt;2\n-- test to see if pos controller has note tracks:\nhasNoteTracks s.pos.controller\n--&gt;true\n-- add key to first note track, and select the key:\naddNewNoteKey ntp1.keys 20 #select\n--&gt;#Note key(1 @ 20f)\n-- add another key to first note track:\naddNewNoteKey ntp1.keys 40\n--&gt;#Note key(2 @ 40f)\n-- retrieve first note track on the pos controller:\nn = getNoteTrack s.pos.controller 1\n-- retrieve an instance of the note track key array Notetrack:\nnk=n.keys\n--&gt;#keys(20f, 40f)\n-- set value for second note key:\nnk[2].value =\"Yo What\'s Up\"\n--&gt;\"Yo What\'s Up\"\n-- change the time for second note key. Now first key\nnk[2].time = 10\n--&gt;10\nnk[1].selected = true-- select the first note key\n--&gt;true\n-- changed the time of the note keys, so re-sort:\nsortNoteKeys nk\n--&gt;OK\nnk.count-- check number of keys\n--&gt;2\nnk-- display the note keys\n--&gt;#keys(10f, 20f)\n-- &nbsp;To delete the note tracks and note keys:\ndeleteNoteKey nk 1-- delete first note key\n--&gt;OK\ndeleteNoteKeys n.keys #allKeys-- delete all the note keys\n--&gt;OK\n-- remove note track from pos controller:\ndeleteNoteTrack s.pos.controller ntp1\n--&gt;OK\n-- remove note track from pos controller:\ndeleteNoteTrack s.pos.controller ntp2\n--&gt;OK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";