var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"objXRefMgr Interface\">\n      <meta name=\"indexterm\" content=\"Interface objXRefMgr\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: objXRefMgr</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2\"></a><div class=\"head\">\n            <h1>Interface: objXRefMgr </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B2B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B2A\"></a><p class=\"table-body\">   <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; objXRefMgr \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B29\"></a>The \n            		<em class=\"strong\">objXRefMgr Core Interface</em> provides access to the \n            		<em class=\"strong\">XRef Manager</em>, and is the preferred way for working with XRefs in MAXScript. Scripts should not\n            use both the methods in this interface and those exposed by \n            		<span class=\"code\">XRefObject</span>. The \n            		<em class=\"strong\">objXrefMgr</em> coordinates all object xref additions and changes in a scene. \n            	 \n         </p>\n         <p><a name=\"GUID-B15EE31B-D3F8-4338-B517-8051F42FC2A8\"></a>Available in<em class=\"strong\"> 3ds Max 8 and higher</em>. \n            	 \n         </p>\n         <p>You may find the following concepts useful when working with XRefs in MAXScript: \n            	 \n         </p><a name=\"UL_857E32D3F7D74DAFB0549635647219C7\"></a><ul>\n            <li>Xrefs are organized by the file they come from, which is represented by an \n               		  <span class=\"code\">IXRefRecord</span> object. For example, the \n               		  <span class=\"code\">objXRefMgr.AddXrefItemsFromFile()</span> method returns this object. See the \n               		  <span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecordMixinInterface</a></span> for methods available from this interface. \n               		\n            </li>\n            <li>Individual Xrefs in an \n               		  <span class=\"code\">XrefRecord</span> are held in \n               		  <span class=\"code\">IXrefItem</span> objects. See \n               		  <span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm\">IXRefItem MixinInterface</a></span> for methods exposed by that interface. \n               		\n            </li>\n         </ul>\n         <p><a name=\"GUID-2FBD8FFC-1903-4D1C-A7E9-894B008F2748\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5725\"></a><pre>Interface:<em class=\"codeEmphasisStrong\"> objXRefMgr</em> </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B28\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">objXRefMgr.includeAll</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-D975EB27-B978-4D1D-AFCA-16A9C7377758\"></a> Get/set the state of the \n            		<em class=\"strong\">\"Include All\"</em> checkbox. \n            	 \n         </p>\n         <p><a name=\"GUID-92C0D901-76E0-41A8-AEC0-5393BE1D9005\"></a> Default is True. \n            	 \n         </p>\n         <p><a name=\"GUID-3F0E5633-D2A6-4133-90DA-D50A2FD36CC8\"></a> Available in \n            		<em class=\"strong\">3ds Max 2016 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-ABDBA87D-5518-4A01-9B4C-A268EC85448A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">objXRefMgr.enableUseLocalProxySettings</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-E5663D37-F0BD-4ABB-9765-1F184F89B687\"></a>When set to True, local proxy settings will be used. \n            	 \n         </p>\n         <p><a name=\"GUID-AB804092-0BD8-465D-8E4B-965AD860783B\"></a> Default is False. \n            	 \n         </p>\n         <p> Available in \n            		<em class=\"strong\">3ds Max 2016 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-C1655E4A-8892-46D3-9309-3B84E3D45018\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5724\"></a><pre><em class=\"codeEmphasisStrong\">objXRefMgr</em>.<em class=\"codeEmphasisStrong\">recordCount</em>: DWORD : Read   </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B27\"></a>Returns the number of Object XRef records. \n            	 \n         </p>\n         <p><a name=\"GUID-43716A28-F87B-414B-BAA0-D8CA4A3A3EE9\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5723\"></a><pre><em class=\"codeEmphasisStrong\">objXRefMgr</em>.<em class=\"codeEmphasisStrong\">dupObjNameAction </em>: enum : Read|Write \n\ndupObjNameAction enums: {<em class=\"codeEmphasisStrong\">#prompt|#xref|#skip|#deleteOld|#autoRename</em>} </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B26\"></a>Get/set the action to perform when duplicate names have been detected. \n            	 \n         </p>\n         <p><a name=\"GUID-49113239-67FA-43EF-9B61-A4375A16F1F4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5720\"></a><pre><em class=\"codeEmphasisStrong\">objXRefMgr</em>.<em class=\"codeEmphasisStrong\">dupMtlNameAction </em>: enum : Read|Write \n\ndupMtlNameAction enums: {<em class=\"codeEmphasisStrong\">#prompt|#useXRefed|#useScene|#autoRename</em>} </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B24\"></a>Get/set the action to perform when duplicate material names have been detected. \n            	 \n         </p>\n         <p><a name=\"GUID-DFFCBFD3-B859-448E-8337-A793F27B71D9\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_79ECA387EF9147B89E51AC02C29BE010\"></a><pre><em class=\"codeEmphasisStrong\">objXRefMgr</em>.<em class=\"codeEmphasisStrong\">mergeTransforms </em>: bool : Read|Write </pre></div>\n         <p><a name=\"P_C557F3D119F049E9BFF723E8D28566D7\"></a>Get/set whether to merge the transformation controllers of the Object XRefs. When\n            set to true, the transform controllers will be merged into the master scene and will\n            lose the live connection to the referenced file. Default is false. \n            	 \n         </p>\n         <p><a name=\"P_ACA32E7F917A454BA04FB6FE7CBE488C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_B90B2E25750D46BC8B3BAF64B3AE7047\"></a><pre><em class=\"codeEmphasisStrong\">objXRefMgr</em>.<em class=\"codeEmphasisStrong\">mergeMaterials </em>: bool : Read|Write </pre></div>\n         <p><a name=\"P_130937C7DD69425592CBC8A9F09D5B53\"></a>Get/set whether to merge the materials of the Object XRefs. When set to true, the\n            materials of the referenced objects will be merged into the master scene and will\n            lose the live connection to the referenced file. This option must be set before creating\n            the Object XRef. Default is false. \n            	 \n         </p>\n         <p><a name=\"P_E7E77678BFBF492DAF4DB8A04E522111\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_4E41B87B6A9641A880D1E836F78A2456\"></a><pre><em class=\"codeEmphasisStrong\">objXRefMgr</em>.<em class=\"codeEmphasisStrong\">mergeManipulators </em>: bool : Read|Write </pre></div>\n         <p><a name=\"P_94B1C83DB6EE4B3FA69380135B2D276C\"></a>Get/set whether to merge the manipulators of the Object XRefs. When set to true, the\n            manipulators of the referenced objects will be merged into the master scene and will\n            lose the live connection to the referenced file. This option must be set before creating\n            the Object XRef. Default is false. \n            	 \n         </p>\n         <p><a name=\"P_88E3345AE80A467FA0AB49AD1EE00636\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_5B73EF67DC6E47AC94C1D58383DD553D\"></a><pre><em class=\"codeEmphasisStrong\">objXRefMgr</em>.<em class=\"codeEmphasisStrong\">mergeModifiers </em>: enum : Read|Write \n\nmergeModifiers enums: {<em class=\"codeEmphasisStrong\">#xrefModifiers</em>|<em class=\"codeEmphasisStrong\">#ignoreModifiers</em>|<em class=\"codeEmphasisStrong\">#mergeModifiers</em>} </pre></div>\n         <p><a name=\"P_CC38099C8EF345378D869B302BFD2F16\"></a>Get/set the handling of the modifiers of the Object XRef. \n            	 \n         </p>\n         <p><a name=\"P_2AA4B9115F474C82B45119E2B786FD39\"></a>When the \n            		<span class=\"code\"> <em class=\"strong\">#xrefModifiers</em> </span> option is specified, the modifiers will be applied to the XRef Object before it is\n            merged into the master scene and cannot be changed. \n            	 \n         </p>\n         <p><a name=\"P_11F2B170B58040A2B367D13E154A1CEE\"></a>When the \n            		<span class=\"code\"> <em class=\"strong\">#ignoreModifiers</em> </span> option is specified, the modifiers from the referenced file will not be applied to\n            the XRef Object. \n            	 \n         </p>\n         <p><a name=\"P_276AC2F76D30480C9D5FFBB24DDB1271\"></a>When the \n            		<span class=\"code\"> <em class=\"strong\">#mergeModifiers</em> </span> option is specified, the modifiers from the referenced file will be merged into the\n            master scene and can be manipulated, but will lose their live connection to the referended\n            file. \n            	 \n         </p>\n         <p><a name=\"P_8A3517E6CE9944C58ED529AF9D6C1841\"></a>This option must be set before creating the Object XRef. \n            	 \n         </p>\n         <p><a name=\"P_BCD838CC2663427680FE93FC6515F65A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_EFEA1EA2490A4DE9B32388B322745DDF\"></a><pre><em class=\"codeEmphasisStrong\">objXRefMgr</em>.<em class=\"codeEmphasisStrong\">getAutoUpdate </em>: bool : Read|Write</pre></div>\n         <p><a name=\"P_1323D72BBDFE47F5ADB8EAE14B1E96D0\"></a>Get/set whether to update the Object XRefs automatically when the referenced source\n            file has been saved. \n            	 \n         </p>\n         <p><a name=\"P_7F9D3680014543E58BA3916558E9C2C6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B23\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-571D\"></a><pre>&lt;Interface&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.GetRecord </em>&lt;index&gt;index </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B22\"></a>Returns the indexed record, where index is between 1 and the \n            		<span class=\"code\"> <em class=\"strong\">.recordCount</em> </span> \n         </p>\n         <p><a name=\"GUID-D52E6D7B-1476-4DD4-9F06-EA84B45973E2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-571C\"></a><pre>&lt;Interface&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.FindRecord</em> &lt;DWORD&gt;handle </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B21\"></a>Returns the record by handle. \n            	 \n         </p>\n         <p><a name=\"P_7907D4E2076C4965801FFDE35176F8CD\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecordMixinInterface</a></span> for details on the return value. \n            	 \n         </p>\n         <p><a name=\"GUID-22B9E2E9-D925-4A0D-92F5-E8FB7737BBD2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5719\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.RemoveRecordFromScene</em> &lt;Interface&gt;record \n\nrecord Validated by Validator function</pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B20\"></a>Removes the specified record from the scene. \n            	 \n         </p>\n         <p><a name=\"P_6E9A06FBD50B4C10AA4FDB77F2918C7A\"></a>Returns true on success, false on failure. \n            	 \n         </p>\n         <p><a name=\"P_D23F76B152C944068AFADA6BAD8FF834\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecord MixinInterface</a></span> for details on the record argument. \n            	 \n         </p>\n         <p><a name=\"GUID-D77570DB-CF3A-4325-A114-D6610AE06C92\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5718\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.MergeRecordIntoScene</em> &lt;Interface&gt;record \n\nrecord Validated by Validator function </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B1F\"></a>Merges the specified record into the scene. \n            	 \n         </p>\n         <p><a name=\"P_433C2DF404A74B7DB488E078B46DE156\"></a>Returns true on success, false on failure. \n            	 \n         </p>\n         <p><a name=\"P_9BAEFA1AC5E04734A5AFEA4D1B1CAB77\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\"> IXrefRecord MixinInterface</a></span> for details on the record argument. \n            	 \n         </p>\n         <p><a name=\"GUID-74D275C4-159F-4912-95CE-B4F9136990F1\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5715\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.SetRecordSrcFile</em> &lt;Interface&gt;xrefRecord &lt;filename&gt;fileName </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B1E\"></a>Sets the source file of the specified record to the given file name. \n            	 \n         </p>\n         <p><a name=\"P_28A359226042441FB944570F99F6B95F\"></a>Returns true on success, false on failure. \n            	 \n         </p>\n         <p><a name=\"P_F6F9A1DBB12644BD8FEF3C4CFD184A59\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecord MixinInterface</a></span> for details on the record argument. \n            	 \n         </p>\n         <p><a name=\"GUID-F0A14F06-DFDA-4DA9-A8B7-198A48983BC2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5714\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.UpdateAllRecords</em>() </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B1D\"></a>Updates all records in the scene. Returns true on success, false on failure. \n            	 \n         </p>\n         <p><a name=\"GUID-14CDAEBE-A465-4DAB-822A-A9E2A44094B4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5713\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.SetXRefItemSrcName</em> &lt;&amp;maxObject&gt;xrefItem &lt;string&gt;itemName \n\nxrefItem is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B1C\"></a>Sets the source item name of the object passed by-reference to the given string. \n            	 \n         </p>\n         <p><a name=\"P_BAECDE1286D84740973EF92327173861\"></a>Returns true on success, false on failure. \n            	 \n         </p>\n         <p><a name=\"GUID-C5159851-1CC7-4ACB-817F-53468CD9B386\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5710\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.SetProxyItemSrcName</em> &lt;&amp;maxObject&gt;xrefItem &lt;string&gt;itemName \n\nproxyItem is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B1B\"></a>Sets name of the proxy of the object passed by-reference to the given string. \n            	 \n         </p>\n         <p><a name=\"P_8A4C705EBE704D9D9CC8522ECAE8FBB8\"></a>Returns true on success, false on failure. \n            	 \n         </p><a name=\"TABLE_9D5BF99FF19241E3B57BC9B4A6DD1B99\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-heading\">\n                  <th class=\"table-heading\">For Example \n                     				\n                  </th>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>-- Illustrate the use of SetProxyItemSrcName, SetProxyItemSrcFile, and AddXrefItemsFromFile\n\nsphereFile = @\"mySphereScene.max\"\nteapotFile = @\"myTeapotScene.max\"\n\n-- Create a scene file containing a sphere, this will be the proxy object\nresetMaxFile #noPrompt\ns = sphere name:\"mySphere\"\nsaveMaxFile sphereFile useNewFile:false\n\n-- create a scene file containing a teapot, this will be the xref object\nresetMaxFile #noPrompt\n-- add a teapot, we\'ll use the sphere as a proxy\nt = teapot name:\"myTeapot\"\nsaveMaxFile teapotFile useNewFile:false\n\n-- create our xref and our proxy\nresetMaxFile #noPrompt\nxrefRecord = objXrefMgr.AddXrefItemsFromFile teapotFile promptObjNames:false \\\nxrefOptions:#(#mergeModifiers, #mergeControllers, #mergeManipulators, #mergeMaterials)\n  \nxrefItem = xrefRecord.getItem 1 #XrefObjectType\nobjXrefMgr.SetProxyItemSrcFile xrefItem @\"mySphereScene.max\"\nobjXrefMgr.SetProxyItemSrcName xrefItem \"mySphere\"</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-1D8F8741-3FC1-452E-B6B7-4FE3444C8C61\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-570D\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.SetXRefItemSrcFile </em>&lt;&amp;maxObject&gt;xrefItem &lt;filename&gt;fileName \n\nxrefItem is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B1A\"></a>Sets the source item file name of the object passed by-reference to the given filename\n            string. \n            	 \n         </p>\n         <p><a name=\"P_400FDBA85143463E82106F709A416F81\"></a>Returns true on success, false on failure. \n            	 \n         </p>\n         <p><a name=\"GUID-92AAD6FF-1939-4329-A0D5-78E85A495237\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-570A\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.SetProxyItemSrcFile</em> &lt;&amp;maxObject&gt;xrefItem &lt;filename&gt;fileName \n\nproxyItem is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B19\"></a>Sets the proxy item file name of the object passed by-reference to the given filename\n            string. \n            	 \n         </p>\n         <p><a name=\"P_F55CAAA6E62E42B28E0DBF88C3F2B705\"></a>Returns true on success, false on failure. \n            	 \n         </p>\n         <p><a name=\"GUID-F9E2A2B6-165E-4440-947C-8F739CF4E229\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5707\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.AddXRefItemsToRecord</em> &lt;Interface&gt;record<em class=\"codeEmphasisStrong\"> promptObjNames</em>:&lt;bool&gt;<em class=\"codeEmphasisStrong\">objNames</em>:&lt;string array&gt; \n\nrecord Validated by Validator function \npromptObjNames default value: false \nobjNames default value: #() </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B18\"></a>Adds XRefs for the array of object names in the scene to the given record. \n            	 \n         </p>\n         <p><a name=\"P_DE37BC5BAE6543F4943CF71AD0FBD5DB\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecord MixinInterface</a></span> for details on the record argument. \n            	 \n         </p>\n         <p><a name=\"GUID-53A15857-A8CD-49DF-A726-31094C828D55\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5704\"></a><pre>&lt;Interface&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.AddXRefItemsFromFile </em>&lt;filename&gt;fileName<em class=\"codeEmphasisStrong\"> promptObjNames</em>:&lt;bool&gt;<em class=\"codeEmphasisStrong\"> objNames</em>:&lt;string array&gt;<em class=\"codeEmphasisStrong\"> xrefOptions</em>:&lt;&amp;enum array&gt; \n\npromptObjNames default value: false \nobjNames default value: #() \nxrefOptions enums: {<em class=\"codeEmphasisStrong\">#asProxy|#xrefModifiers|#dropModifiers|#mergeModifiers|#mergeManipulators\n|#selectNodes|#mergeControllers|#mergeMaterials|#xrefControllers|#localControllers</em>} \nxrefOptions default value: #() \nxrefOptions is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B17\"></a>Returns an XRef record object (IXRefRecord) that contains the XRefs (as IXRefItem\n            objects) added to the scene from the specified file, of the specified objects. \n            	 \n         </p>\n         <div><a name=\"GUID-E9A8D727-B55A-4A83-9D0A-2A0A7B7F79F5\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Some of the \n               		<span class=\"code\">xrefOptions</span> parameter options are exclusive. You can only specify one of the Modifier options\n               ( \n               		<span class=\"code\">#xrefModifiers</span>, \n               		<span class=\"code\">#dropModifiers</span>, \n               		<span class=\"code\">#mergeModifiers</span>) and one of the controller options ( \n               		<span class=\"code\">#mergeControllers</span>, \n               		<span class=\"code\">#xrefControllers</span>, \n               		<span class=\"code\">#localControllers</span>). \n               	 \n            </div>\n         </div>\n         <p>See \n            		<span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecord MixinInterface</a></span> for details on the record argument. \n            	 \n         </p>\n         <p><a name=\"GUID-3AAF4A71-4E77-4083-9585-2CEA8CF5480E\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5703\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.CanCombineRecords</em> &lt;Interface&gt;firstRecord &lt;Interface&gt;secondRecord \n\nfirstRecord Validated by Validator function \nsecondRecord Validated by Validator function </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B16\"></a>Returns true if the two records can be combined, false otherwise. \n            	 \n         </p>\n         <p><a name=\"P_B28895A816644715A1E551D1372CBAF5\"></a> See \n            		<span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecord MixinInterface</a></span> for details on the record arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-F2CA05DB-CD6C-4335-ABE2-7D58974A5043\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5700\"></a><pre>&lt;Interface&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.CombineRecords</em> &lt;&amp;Interface array&gt;records\n\nrecords Validated by Validator function \nrecords is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B15\"></a>Combines the records given as by-reference array of interfaces to a single interface.\n            \n            	 \n         </p>\n         <p><a name=\"P_9E26564774A24CB4B9D484B2D5A82D38\"></a>See \n            		<span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecord MixinInterface</a></span> for details on the record argument and return value. \n            	 \n         </p>\n         <p><a name=\"GUID-12D38564-B43D-4818-B114-DFD88C65C2CF\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56FD\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.RemoveXRefItemsFromScene</em> &lt;&amp;maxObject array&gt;xrefItems \n\nxrefItems is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B14\"></a>Removes the given XRef Items from the scene. \n            	 \n         </p>\n         <p><a name=\"P_206D9D1B1D2F4FFBB22B7E389D563495\"></a>Returns true on success, false on failure. \n            	 \n         </p>\n         <p><a name=\"GUID-9DFCEE04-84C3-44B6-8E57-9DADDDF369F6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56FA\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.MergeXRefItemsIntoScene</em> &lt;&amp;maxObject array&gt;xrefItems \n\nxrefItems is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B13\"></a>Merges the XRef Items specified as an array into the scene. \n            	 \n         </p>\n         <p><a name=\"P_D8934BC05BB84764A48395473A020373\"></a>Returns true on success, false on failure. \n            	 \n         </p>\n         <p><a name=\"GUID-2C30958F-BB93-433D-8C69-4145CB891AD6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56F7\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.ApplyXRefMaterialsToXRefObjects </em>&lt;&amp;maxObject array&gt;objectXRefItems \n\nobjectXRefItems is In parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B12\"></a>Applies XRef Materials to the specified XRef objects. \n            	 \n         </p>\n         <p><a name=\"GUID-CCC44F13-2488-483C-925D-FF2D1C97F90C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56F4\"></a><pre>&lt;Interface&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.IsNodeXRefed </em>&lt;node&gt;node </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B11\"></a>If the node is XRef-ed, returns an \n            		<span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm\">IXRefItem MixinInterface</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_D66391FDA0DE45C3AD5A67D756C3B51F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_362021C03C054D868D08B2AD1BAC2C20\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.ApplyXRefControllersToXRefObjects </em>&lt;&amp;maxObject array&gt;objectXRefItems \n\nobjectXRefItems is In parameter </pre></div>\n         <p><a name=\"P_601DF22E8E3E4C288237D418BBF05B61\"></a>Applies XRef controllers to the Object XRef items specified by the by-reference array\n            argument. \n            	 \n         </p>\n         <p><a name=\"P_34308AEF096A40DE97E1FC3AB67766DE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_C052DB3A50684756A05BC7CCC8F2C385\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.ResetXRefControllersPRSOffset </em>&lt;&amp;maxObject array&gt;xrefItems \n\nxrefItems is In parameter </pre></div>\n         <p><a name=\"P_A3D53B0D6B894C69B7F57C39FAF4EB1C\"></a>Applies Position/Rotation/Scale offset to the XRef controllers of the Object XRef\n            items specified by the by-reference array argument. \n            	 \n         </p>\n         <p><a name=\"P_E0B196B1DF8747CDB6C95F849E08D0F4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_D19482B7C6E74EA285865A218A5D09BD\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">objXRefMgr.CanResetXRefControllersPRSOffset </em>&lt;&amp;maxObject&gt;xrefItem \n\nxrefItem is In parameter</pre></div>\n         <p><a name=\"P_5E84E4C32ADC4FB4AD2A9AC58C569CFE\"></a>Returns true if Position/Rotation/Scale offset can be applied to the XRef controllers\n            of the Object XRef item specified by the by-reference argument. \n            	 \n         </p>\n         <p><a name=\"GUID-BBC65CF4-8798-463F-9BB1-6F176E47FA0F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\"></a> \n            <h2><a name=\"GUID-44385917-7960-4DD3-8512-A9DB34EB862A\"></a>The following MixinInterface represents an Object XRef Record:\n            </h2> \n            <p><a name=\"GUID-842D4D74-AAFC-4B63-8FAA-AA14A17D4C08\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56F3\"></a><pre>Interface:<em class=\"codeEmphasisStrong\"> IXRefRecord</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B0F\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56F2\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">includeAll </em>: bool : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B0E\"></a>Get/Set the state of the Include All checkbox. When set to true, all objects in the\n               record will be included. \n               		\n            </p> \n            <p><a name=\"GUID-91239998-F7A8-443F-9112-45F1FBCA5E9E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56F1\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">autoUpdate </em>: bool : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B0D\"></a>Get/Set the state of the Auto Update checkbox. When set to true, changes to the XRef\n               source will be automatically updated in the scene. \n               		\n            </p> \n            <p><a name=\"GUID-9C033854-8B31-42B8-97ED-733468888E13\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56F0\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">enabled</em> : bool : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B0C\"></a>Get/Set the state of the Enable checkbox. \n               		\n            </p> \n            <p><a name=\"GUID-27FCA17D-E953-4449-9152-92F200824DDF\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56EF\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">uptodate </em>: bool : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B0B\"></a>Get/Set the whether the record is up to date or outdated. \n               		\n            </p> \n            <p><a name=\"GUID-B7513E08-4802-4B10-B5BA-979917C30209\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56EE\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">empty </em>: bool : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B0A\"></a>Contains true if the record is empty, false otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-B4F8E8DA-11E1-48CA-897D-12DCB2F304F8\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56ED\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">nested </em>: bool : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B09\"></a>Contains true if the record is nested, false otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-90FCE993-8BBC-4C32-87BC-F18C64DE4EE2\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56EC\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">unresolved </em>: bool : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B08\"></a>Contains true if the record is unresolved, false otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-79A08549-EEE5-4704-800D-9CD53A6247D7\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56EB\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">srcFileName </em>: filename : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B07\"></a>Contains the file name of the source file. This property can be set in<em class=\"strong\"> 3ds Max 9 \n                  		  </em>and higher, prior to<em class=\"strong\"> 3ds Max 9 \n                  		  </em>it was read-only. \n               		\n            </p> \n            <p><a name=\"GUID-2E465553-7A1C-42AF-A19D-1588D8BF1C38\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56EA\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">recordID </em>: DWORD : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B06\"></a>Contains the record\'s ID. \n               		\n            </p> \n            <p><a name=\"GUID-521B1F0A-529A-4138-AE3F-D327DDEFC221\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56E9\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">handle </em>: DWORD : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B05\"></a>Contains the record\'s Handle. \n               		\n            </p> \n            <p><a name=\"GUID-41602687-DE19-445F-B969-F7AF464FC31D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56E8\"></a><pre>&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">xrefOptions </em>: enum by value array : Read \n\nxrefOptions enums: {<em class=\"codeEmphasisStrong\">#asProxy|#xrefModifiers|#dropModifiers|#mergeModifiers|#mergeManipulators|#selectNodes|#mergeMaterials</em>} </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B04\"></a>Contains an array of the XRef Options. \n               		\n            </p> \n            <p><a name=\"GUID-931CCF2D-9A50-4D49-A09B-4018F211CB8D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B03\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56E5\"></a><pre>&lt;DWORD&gt;&lt;IXRefRecord MixinInterface&gt;<em class=\"codeEmphasisStrong\">.ItemCount</em> &lt;&amp;enum array&gt;types \n\ntypes enums: {<em class=\"codeEmphasisStrong\">#XRefObjectType|#XRefMaterialType|#XRefAtmospheric Type|#XRefAllType</em>} \ntypes is In parameter </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B02\"></a>Returns the number of items in the record that correspond to the types passed by the\n               by-reference array argument. \n               		\n            </p> \n            <p><a name=\"GUID-5F5FEB57-8710-46E0-8897-D292879B7F09\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56E2\"></a><pre>&lt;maxObject&gt;&lt;IXRefRecord MixinInterface&gt;<em class=\"codeEmphasisStrong\">.GetItem</em> &lt;index&gt;index &lt;enum&gt;type \n\ntype enums: {<em class=\"codeEmphasisStrong\">#XRefObjectType|#XRefMaterialType|#XRefAtmosphericType</em>} </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B01\"></a>Returns the indexed item of the specified XRef type. \n               		\n            </p> \n            <p><a name=\"GUID-07D17BA1-E6E3-4924-AAD6-1B6C85CBC79B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56DE\"></a><pre>&lt;DWORD&gt;&lt;IXRefRecord MixinInterface&gt;<em class=\"codeEmphasisStrong\">.GetItems</em> &lt;&amp;enum array&gt;types &lt;&amp;maxObject array&gt;xrefItems \n\ntypes enums: {<em class=\"codeEmphasisStrong\">#XRefObjectType|#XRefMaterialType|#XRefAtmosphericType|#XRefAllType</em>} \ntypes is In and Out parameter \nxrefItems is In and Out parameter </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B00\"></a>Returns all items of the types specified by the by-reference array of the first argument\n               into the by-reference array of the second argument. \n               		\n            </p> \n            <p><a name=\"GUID-0438E733-0A1B-4B2A-A926-AAD51EC94918\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56DB\"></a><pre>&lt;DWORD&gt;&lt;IXRefRecord MixinInterface&gt;<em class=\"codeEmphasisStrong\">.GetChildRecords </em>&lt;&amp;Interface array&gt;children \n\nchildren is Out parameter </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AFF\"></a>Returns the child records into the by-reference array. See \n               		  <span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecord MixinInterface</a></span> for details on the array\'s values type. \n               		\n            </p> \n            <p><a name=\"GUID-F3C897B9-D505-46FC-8217-747E6DD9AC0B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56D8\"></a><pre>&lt;DWORD&gt;&lt;IXRefRecord MixinInterface&gt;<em class=\"codeEmphasisStrong\">.GetParentRecords </em>&lt;&amp;Interface array&gt;parents \n\nparents is Out parameter </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AFE\"></a>Returns the parent records into the by-reference array. See \n               		  <span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecord MixinInterface</a></span> for details on the array\'s values type. \n               		\n            </p> \n            <p><a name=\"GUID-04FC64F4-DA56-4E60-8F03-04E8FFCEEDB1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56D5\"></a><pre>&lt;DWORD&gt;&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">GetRootRecords </em>&lt;&amp;Interface array&gt;roots \n\nroots is Out parameter </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AFD\"></a>Returns the root records into the by-reference array. See \n               		  <span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXrefRecord MixinInterface</a></span> for details on the array\'s values type. \n               		\n            </p> \n            <p><a name=\"GUID-5C7CDD80-8EAA-46B8-BF7E-B54ACD863D67\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56D2\"></a><pre>&lt;bool&gt;&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">CheckSrcFileChanged</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AFC\"></a>Returns true if the source file has changed, false if it has not. \n               		\n            </p> \n            <p><a name=\"GUID-AB5EBBA0-6942-45BD-8454-212C4D39059E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56D1\"></a><pre>&lt;bool&gt;&lt;IXRefRecord MixinInterface&gt;.<em class=\"codeEmphasisStrong\">Update</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AFB\"></a>Forces an update of the XRef Record and returns true on success, false on failure.\n               \n               		\n            </p> \n            <p><a name=\"GUID-8C1243BE-296D-4213-8C99-E49BDB852235\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AFA\"></a> \n            <h2><a name=\"GUID-0DF21676-2F4C-49C5-A693-B4CD6D8036FF\"></a> <em class=\"strong\">The following MixinInterface represents an Object XRef Item:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56D0\"></a><pre>Interface:<em class=\"codeEmphasisStrong\"> IXRefItem</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AF9\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56CF\"></a><pre>&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">srcFileName </em>: filename : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AF8\"></a>Contains the file name of the source file. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AF7\"></a>This property was read-only in versions prior to<em class=\"strong\"> 3ds Max 9</em>. \n               		\n            </p> \n            <p><a name=\"GUID-44A1CD35-FF28-4284-995C-D6732B35AE7B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56CE\"></a><pre>&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">srcItemName </em>: string : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AF6\"></a>Contains the name of the source item. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AF5\"></a>This property was read-only in versions prior to<em class=\"strong\"> 3ds Max 9</em>. \n               		\n            </p> \n            <p><a name=\"GUID-BC481BC8-E057-4612-BD47-F4A0A05CCE9F\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56CD\"></a><pre>&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">xrefRecord</em> : Interface : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AF4\"></a>Contains the Xref Record\'s \n               		  <span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXRefRecord MixinInterface</a></span>. \n               		\n            </p> \n            <p><a name=\"GUID-C1225925-2521-4777-BE4F-384B829364B7\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56CC\"></a><pre>&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">unresolved </em>: bool : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AF3\"></a>Contains true if the XRef is unresolved, false otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-FA03327C-E6F6-4C66-9BC6-BF5728CE1576\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56CB\"></a><pre>&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">nested </em>: bool : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AF2\"></a>Contains true if the XRef is nested, false otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-7DC202B2-CE57-4F53-8715-5779D166A81C\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56CA\"></a><pre>&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">retargetable </em>: bool : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AF1\"></a>Contains true if the XRef can be retargeted, false otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-F7B9E938-F968-4030-A795-BB37F4362E14\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AF0\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56C9\"></a><pre>&lt;maxObject&gt;&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">GetSrcItemresolveNested</em>:&lt;bool&gt; \n\nresolveNested default value: false </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AEF\"></a>Returns the source item. If the \n               		  <span class=\"code\"> <em class=\"strong\">resolveNested \n                     			 </em> </span>optional keyword is specified and is true, nested XRefs will be resolved to get the\n               source item. If not specified or false, nested XRefs will not be resolved. \n               		\n            </p> \n            <p><a name=\"GUID-F4BC53B5-7E26-46C6-B80C-1BB367325CBB\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56C7\"></a><pre>&lt;DWORD&gt;&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">GetParentItems</em> &lt;&amp;maxObject array&gt;parentItems \n\nparentItems is Out parameter </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AEE\"></a>Returns the parent items into the by-reference array argument. \n               		\n            </p> \n            <p><a name=\"GUID-79790184-DA5A-406B-8DE0-80816CB1C3BB\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56C5\"></a><pre>&lt;DWORD&gt;&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">GetRootItems</em> &lt;&amp;maxObject array&gt;rootItems \n\nrootItems is Out parameter </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AED\"></a>Returns the root items into the by-reference array argument. \n               		\n            </p> \n            <p><a name=\"GUID-47CFA6EE-9AC7-42D2-8374-21C429B4CF04\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56C3\"></a><pre>&lt;DWORD&gt;&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">GetChildItems </em>&lt;&amp;maxObject array&gt;childItems \n\nchildItems is Out parameter </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AEC\"></a>Returns the child items into the by-reference array argument. \n               		\n            </p> \n            <p><a name=\"GUID-A739EB98-EEB3-46B1-9A28-FA546D4CA3A9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56C1\"></a><pre>&lt;void&gt;&lt;IXRefItem MixinInterface&gt;.<em class=\"codeEmphasisStrong\">GetNodes</em>&lt;&amp;node array&gt;xrefNodes \n\nxrefNodes is Out parameter </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AEB\"></a>Returns the XRef nodes into the by-reference array argument. \n               		\n            </p> \n            <p><a name=\"GUID-B8EBD2D3-8B9D-420D-8DF2-3E2F1D37427C\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AEA\"></a> \n            <h2><a name=\"GUID-A11C1D47-9F84-4A1F-AF87-E269BC0804A3\"></a> <em class=\"strong\">The following MixinInterface represents an Object XRef Proxy:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56BF\"></a><pre>Interface:<em class=\"codeEmphasisStrong\"> IXRefProxy</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AE9\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56BE\"></a><pre>&lt;IXRefProxy MixinInterface&gt;.<em class=\"codeEmphasisStrong\">proxyFileName</em> : filename : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AE8\"></a>Contains the proxy filename. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AE7\"></a>This property was read-only in versions prior to \n               		  <em class=\"strong\">3ds Max 9</em>. \n               		\n            </p> \n            <p><a name=\"GUID-51358ED8-7EA7-4117-81C8-A857D83E43BF\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56BD\"></a><pre>&lt;IXRefProxy MixinInterface&gt;.<em class=\"codeEmphasisStrong\">proxyItemName </em>: string : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AE6\"></a>Contains the proxy item name. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AE5\"></a>This property was read-only in versions prior to<em class=\"strong\"> 3ds Max 9</em>. \n               		\n            </p> \n            <p><a name=\"GUID-0AE6D2AF-4F79-4432-BF1C-555513236DA0\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56BC\"></a><pre>&lt;IXRefProxy MixinInterface&gt;.<em class=\"codeEmphasisStrong\">proxyRecord </em>: Interface : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AE4\"></a>Contains the \n               		  <span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXRefRecord Interface</a></span> of the Proxy. \n               		\n            </p> \n            <p><a name=\"GUID-B356FB8B-0DBB-496A-B792-2B2E1306B5B5\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56BB\"></a><pre>&lt;IXRefProxy MixinInterface&gt;.<em class=\"codeEmphasisStrong\">displayProxy</em>: bool : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AE3\"></a>Get/set whether to display the proxy in the viewports or not. \n               		\n            </p> \n            <p><a name=\"GUID-9CA9EBEF-79FF-45E1-A2BE-736DBF2AE3F7\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56BA\"></a><pre>&lt;IXRefProxy MixinInterface&gt;.<em class=\"codeEmphasisStrong\">renderProxy </em>: bool : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AE2\"></a>Get/set whether to render the proxy or not. \n               		\n            </p> \n            <p><a name=\"GUID-EAE7A18C-A1C8-4360-A9D1-63B28C9C6398\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AE1\"></a> \n            <h2><a name=\"GUID-FB10C800-9F9D-46CF-9753-106CDE97C2EA\"></a> <em class=\"strong\">The following MixinInterface represents an Object XRef Proxy:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56B9\"></a><pre>Interface: <em class=\"codeEmphasisStrong\">IXRefObject</em> </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AE0\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56B8\"></a><pre>&lt;IXRefObject MixinInterface&gt;.<em class=\"codeEmphasisStrong\">activeFileName </em>: filename : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7ADF\"></a>Contains the active filename. \n               		\n            </p> \n            <p><a name=\"GUID-7188DE8C-1982-466D-80B4-2691B44223BB\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56B7\"></a><pre>&lt;IXRefObject MixinInterface&gt;.<em class=\"codeEmphasisStrong\">activeObjName</em>: string : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7ADE\"></a>Contains the active object name. \n               		\n            </p> \n            <p><a name=\"GUID-192B4D12-2401-4CE0-8522-239B0D8E0129\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56B6\"></a><pre>&lt;IXRefObjectMixinInterface&gt;.<em class=\"codeEmphasisStrong\">activeRecord </em>: Interface : Read </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7ADD\"></a>Contains the \n               		  <span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm#WS1A9193826455F5FF-56C0CD8012AE38BF917-7B10\">IXRefRecord Interface</a></span> of the Xref Object. \n               		\n            </p> \n            <p><a name=\"GUID-8A8A14E2-5187-4C9B-B0D8-6BAD416AF983\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7ADC\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-56B5\"></a><pre>&lt;maxObject&gt;&lt;IXRefObject MixinInterface&gt;.<em class=\"codeEmphasisStrong\">GetSourceObject </em>&lt;bool&gt;resolveNestedXRef <em class=\"codeEmphasisStrong\">modifiers</em>:&lt;&amp;maxObject array&gt; \n\nmodifiers default value: #() \nmodifiers is Out parameter </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7ADB\"></a>Returns the Source Object. When the first argument is set to true, nested XRefs will\n               be resolved. The optional modifiers: array parameter will be populated with the modifiers\n               of the object. \n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7ADA\"></a> <span class=\"char_link\"><a href=\"GUID-843369B8-EA84-4C5F-8316-247A8465B4DE.htm\">Interface: objXRefs</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AD9\"></a> <span class=\"char_link\"><a href=\"GUID-8B7E81F0-AC81-4518-8D8E-B0C9C6717645.htm\">XRefObject : Node</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AD8\"></a> <span class=\"char_link\"><a href=\"GUID-090B28AB-5710-45BB-B324-8B6FD131A3C8.htm\">XRefScene Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7AD7\"></a> <span class=\"char_link\"><a href=\"GUID-1DC52054-C370-444F-8F9E-E55477A86BD0.htm\">XRef Files</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";