var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-496852FB-9EEB-4D04-A6D4-1BB0E68DE4D5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I remove duplicate arrays from an array?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-496852FB-9EEB-4D04-A6D4-1BB0E68DE4D5\"></a><div class=\"head\">\n            <h1>How do I remove duplicate arrays from an array? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC38\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC3A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC3B\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8BE\">MAXScript Values</a></span> &gt; How do I remove duplicate arrays from an array? \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC3D\"></a> \n            <h2><a name=\"GUID-874E7D6E-68A4-4EB5-B1CA-0CE3603CCC89\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC3E\"></a> I have an array of arrays like this: \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-5567\"></a> <span class=\"code\">#(#(1, 5), #(6, 10), #(6, 10), #(14, 18), #(14, 18))</span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC40\"></a>How can I search for, and get rid of, the duplicates, which in this case would be\n               items at indices 2 &amp; 3 (#(6,10)), and 4 &amp; 5 (#(14,18)). \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC41\"></a>If I use find Item, it just returns the first instance and does not continue searching.\n               I have also tried comparing the first and second numbers using nested \'for\' loops,\n               but I cannot set it up to work like I want. Mainly, there seems to be problems when\n               deleting items from an array while it is going through a loop. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC42\"></a> \n            <h2><a name=\"GUID-7F89C2B3-D8AB-426F-94E4-212BE20CE346\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC43\"></a>Here is a long version with some debug prints so you can see what is happening. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC44\"></a>The key is to always count backwards when deleting elements from an array you are\n               looping through. Otherwise, the loop gets confused as deleting elements renumbers\n               the array items. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC46\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC47\"></a><p class=\"table-body\"> <em class=\"strong\">LONG VERSION</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-666F\"></a><pre>\n(\ntheArray = #(#(1, 5), #(6, 10), #(6, 10), #(14, 18), #(14, 18))\nprint \"Before:\"\nprint theArray\nfn compareSubArrays first second =\n(\n  result = true\n  if first.count != second.count then\n    result = false\n  else\n    for i = 1 to first.count do\n  if first[i] != second[i] do result = false\n  result\n)\nfor i = 1 to theArray.count do\n(\n  for j = theArray.count to i+1 by -1 do\n  (\n    format \"Comparing %:% to %:% \\n\" i theArray[i] j theArray[j]\n    test = (compareSubArrays theArray[i] theArray[j])\n    print test\n    if test do\n    (\n      deleteItem theArray j\n      format\"Deleting %\\n\"j\n    )\n  )--end j loop\n)--end i loop\nprint\"After:\"\nprint theArray\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC6A\"></a><p class=\"table-body\"> <em class=\"strong\">RESULTS:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-666A\"></a><pre>\n\"Before:\"\n#(1, 5)\n#(6, 10)\n#(6, 10)\n#(14, 18)\n#(14, 18)\nComparing 1:#(1, 5) to 5:#(14, 18)\nfalse\nComparing 1:#(1, 5) to 4:#(14, 18)\nfalse\nComparing 1:#(1, 5) to 3:#(6, 10)\nfalse\nComparing 1:#(1, 5) to 2:#(6, 10)\nfalse\nComparing 2:#(6, 10) to 5:#(14, 18)\nfalse\nComparing 2:#(6, 10) to 4:#(14, 18)\nfalse\nComparing 2:#(6, 10) to 3:#(6, 10)\ntrue\nDeleting 3\nComparing 3:#(14, 18) to 4:#(14, 18)\ntrue\nDeleting 4\n\"After:\"\n#(1, 5)\n#(6, 10)\n#(14, 18)\nOK\nOK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC8C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC8D\"></a><p class=\"table-body\"> <em class=\"strong\">COMPACT VERSION WITH COMMENTS:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6669\"></a><pre>\n(\ntheArray = #(#(1, 5), #(6, 10), #(6, 10), #(14, 18), #(14, 18))\n--Function to compare the content of two arrays\nfn compareSubArrays first second =\n(\n  result = true --init. return value to true\n  if first.count != second.count then --if the count of the two subarrays is different,\n    result = false--return false\n  else --otherwise\n    for i = 1 to first.count do --go through all elements in the arrays\n  if first[i] != second[i] do result = false --and see if two elements are different\n  result --return the result - true if identical, false if not\n)\nfor i= 1 to theArray.count do --go through all elements of the main array\nfor j = theArray.count to i+1 by -1 do --go backwards from the last to the current+1\n  if compareSubArrays theArray[i] theArray[j] do\n    deleteItem theArray j --if identical, delete the one with the higher index\nformat \"%\\n\" theArray --print the result to the Listener\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCA5\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6668\"></a><pre>\n#(#(1, 5), #(6, 10), #(14, 18))\nOK\nOK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCAD\"></a> <span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm\">Array Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCCAE\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";