var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-4A7F7C48-6724-4063-9562-7E2D63EA4D1D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"objects\">\n      <meta name=\"indexterm\" content=\"classes and objects in object-oriented programming\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Objects and Classes in Object-Oriented Programming</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4A7F7C48-6724-4063-9562-7E2D63EA4D1D\"></a><div class=\"head\">\n            <h1>Objects and Classes in Object-Oriented Programming </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CE7\"></a>  To understand the terminology associated with MAXScript, a basic understanding of\n            object-oriented programming is required. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CEA\"></a>All of the values you work with in MAXScript have a well-defined type, such as <em class=\"mild\">integer</em>, <em class=\"mild\">matrix3</em>, or<em class=\"mild\">twist</em>. The type of a value is also known as its <em class=\"mild\">class</em>, following the convention of modern object-oriented languages. We\'ve been using a\n            somewhat neutral convention so far of calling the things you compute with<em class=\"mild\"> values</em>. The term for these things in object-oriented languages is, not surprisingly,<em class=\"mild\"> object</em>. The terms <em class=\"mild\">object </em>and<em class=\"mild\"> value</em> are synonymous in this document. An <em class=\"mild\">object </em>is a particular instance of a <em class=\"mild\">class</em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CEB\"></a>For example, in MAXScript <em class=\"mild\">Box </em>is a class. It is not a box as shown in <em class=\"strong\">3ds Max</em>, but rather defines the characteristics such a box has. These characteristics include\n            the ways to create an instance of the Box class (a box object); the properties of\n            a box object (such as Height, Width, and Length); and operations you can perform on\n            a box object (such as move, copy, and delete). \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CEC\"></a>To create a box object, you would say: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CED\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6388\"></a><pre>b=box()</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CF1\"></a>In this line <span class=\"code\"> <em class=\"strong\">box() </em> </span>is a constructor - it causes a box object to be created, and returns a reference to\n            the box object. This reference is then stored in variable <span class=\"code\"> <em class=\"strong\">b</em> </span>. No parameters (such as Height, Width, and Length) were supplied for the constructor,\n            so the default values specified by the Box class are used. In the <em class=\"strong\">3ds Max </em>viewports, the box object is displayed, and can be manipulated like any other object\n            you create in <em class=\"strong\">3ds Max</em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CF2\"></a>If parameters are supplied for the constructor, these parameters replace the \"<span class=\"code\"> <em class=\"strong\">()</em> </span>\". \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CF3\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CF4\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6387\"></a><pre>b=box width:10 length:100</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CF8\"></a>creates a box object with the supplied parameters. All unsupplied parameters will\n            use their default values. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4CF9\"></a>MAXScript is internally object-oriented. All the built-in classes are arranged in\n            an <em class=\"mild\">inheritance hierarchy</em> and most of the built-in functions are <em class=\"mild\">polymorphic</em>, terms we\'ll explore below. You cannot, however, create new classes in MAXScript\n            and the functions you can script are not polymorphic. This may change in later versions\n            of MAXScript, but it is an advanced refinement that is not really necessary in an\n            application scripting language, where the most important abstractions are the features\n            of the host application and are already built-in. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"GUID-CA82121D-8CA7-4739-A5E4-545534EF6C75.htm\">Inheritance and Polymorphism </a></span></li>\n                  <li><span class=\"char_link\"><a href=\"GUID-0CA68F7B-8B14-4D5E-8D9C-BE97E2881B43.htm\">Properties, Methods, Operators, and Literals </a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";