var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-4BAF2F8E-4EAC-4276-A9A7-FF80EE597A45\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ObjExp ExporterPlugin\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ObjExp : ExporterPlugin</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4BAF2F8E-4EAC-4276-A9A7-FF80EE597A45\"></a><div class=\"head\">\n            <h1>ObjExp : ExporterPlugin </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-63A9\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-63A8\"></a>The <em class=\"strong\">ObjExp ExporterPlugin</em> introduced in <em class=\"strong\">3ds Max 2010</em> exposes an interface to access the ASCII-based INI files location and name of the\n               exporter dialog. The settings can then be queried and modified using the regular MAXScript\n               INI settings functions <span class=\"code\"> <em class=\"strong\">getIniSetting()</em> </span> and <span class=\"code\"> <em class=\"strong\">setIniSetting().</em> </span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-63A6\"></a>  <em class=\"strong\">ObjExp Interfaces:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2989\"></a><pre>Interface: <em class=\"codeEmphasisStrong\">iobjexp</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-63A4\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2988\"></a><pre>&lt;TSTR by value&gt;<em class=\"codeEmphasisStrong\">objExp.getIniName</em> ()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-63A2\"></a>Returns the name of the Obj Exporter Settings file. \n            </p> \n            <p><a name=\"GUID-10AD8386-3E39-460F-A59E-44A52C0D82AB\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2987\"></a><pre>&lt;TSTR by value&gt;<em class=\"codeEmphasisStrong\">objExp.getPresetIniName</em> ()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-639F\"></a>Returns the name of the Obj Exporter Preset file. \n            </p> \n            <p><a name=\"GUID-AFCFBF63-A4DC-4919-99BD-9E6C4585F348\"></a>&nbsp;&nbsp;&nbsp; \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-639D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-639C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2986\"></a><pre>\n--Open the INI file for editing in the MAXScript Editor\nedit (objexp.getIniName())\n&nbsp;\n--Alternatively, use INI file access to read and write:\ntheINI =objimp.getIniName()\ngetIniSettingtheINI--get INI file categories\n--&gt;#(\"General\", \"Geometry\", \"Material\", \"Output\", \"Optimize\")\n&nbsp;\n--get the keys of the General category:\ngetIniSetting theINI\"General\"\n--&gt;#(\"UseLogging\", \"Preset\", \"MapSearchPath\")\n&nbsp;\n--get the value of the General &gt;Use Logging key:\ngetIniSetting theINI\"General\" \"UseLogging\"\n--&gt;\"1\"\n&nbsp;\n--Turn Loggingoff:\nsetIniSetting theINI\"General\" \"UseLogging\" \"0\"\n--&gt;true\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6384\"></a> <span class=\"char_link\"><a href=\"GUID-639CF6E0-1B9F-4B05-9CE8-D6418162E0CE.htm\">ObjImp : ImporterPlugin</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6383\"></a> <span class=\"char_link\"><a href=\"GUID-5F4CDEC6-288D-4C33-91FA-0CB1AF4121C7.htm\">Import and Export Filters</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";