var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-4CAB016E-90BC-4E46-B195-108F3F956B65\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Definition Constructs Can Include Global Variable Declarations At Top Level\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Definition Constructs Can Include Global Variable Declarations At Top Level</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4CAB016E-90BC-4E46-B195-108F3F956B65\"></a><div class=\"head\">\n            <h1>Definition Constructs Can Include Global Variable Declarations At Top Level </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BB6\"></a> \n            <h2><a name=\"GUID-568A9692-7303-4499-AC4A-1E19F1925A83\"></a> <em class=\"strong\">Definition Constructs Can Include Global Variable Declarations At Top Level</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BB7\"></a> All the major definition constructs in MAXScript (such as, utility, rollout, macroScript,\n               rcmenu, tool, plug-in, and others) can now include <em class=\"strong\">global</em> variable declarations at the top-level within them. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BB9\"></a>&nbsp; \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86BBA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86BBB\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-617B\"></a><pre>\nrollout foo \"foo\"\n(\nlocal a, b = undefined, c\nglobal d, f = 3 -- now possible\nspinner bar \"Bar\"\ncheckBox baz \"Baz: \"\non bar changed do print a --etc\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BC7\"></a>In releases prior to <em class=\"strong\">3ds Max 4</em>,<em class=\"strong\"> globals</em> had to be declared inside on-handler bodies. Any initializers present in a global\n               declaration like this are <em class=\"strong\">at compile time</em>, so the initial value expressions must be executable at the time the script is compiled.\n               \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BC9\"></a> <span class=\"char_link\"><a href=\"GUID-00294B7D-A624-43BA-8FF8-D684DAEBEF04.htm\">Variable Assignment</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BCA\"></a> <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BCB\"></a> <span class=\"char_link\"><a href=\"GUID-3E792B8C-AF02-4178-9651-EDDB1341B68D.htm\">Specifying Global Variables As Global Using ::</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BCC\"></a> <span class=\"char_link\"><a href=\"GUID-2739C3A0-16DB-4871-9F69-DCEC0862A186.htm\">Persistent Global Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BCD\"></a> <span class=\"char_link\"><a href=\"GUID-5C8F4D60-69B0-4DC0-9641-E0F8C0CFCB84.htm\">Type-Free Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86BCE\"></a> <span class=\"char_link\"><a href=\"GUID-FAF8B2F4-3199-4757-A604-49E1F5BBEBE9.htm\">Reference Assignment</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";