var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5015B963-A1C7-457F-A76B-F63D3676CC6F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Script Controller - Avoiding Circular Dependency\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Script Controller - Avoiding Circular Dependency</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5015B963-A1C7-457F-A76B-F63D3676CC6F\"></a><div class=\"head\">\n            <h1>Script Controller - Avoiding Circular Dependency </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D1D\"></a>  <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm#WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-71E0\">Target</a></span> and <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm#WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-71C2\">Object variables</a></span> in Script Controllers will cause the whole object subAnim tree to be evaluated when\n            the controller value is updated. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D1B\"></a>In cases where the final result of the script controller has to depend on other properties\n            of the same object it is assigned to, creating a Target or Object Variable is prevented\n            by MAXScript with a Runtime error to avoid \"vicious circle\" conditions. Otherwise,\n            the update of the controller will cause other properties to update and in turn cause\n            the controller to be updated again, without an end. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D1A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D19\"></a><p class=\"table-body\"> <em class=\"strong\">DOES NOT WORK:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B42\"></a><pre>\nobj = Teapot ()\n--&gt;$Teapot:Teapot001 @ [0.000000,0.000000,0.000000]\nobj.scale.controller = scale_script()\n--&gt;Controller:Scale_Script\nobj.scale.controller.addTarget \"pos\" obj.position.controller\n-- Runtime error: Cannot add/set object, would create circular dependency: Controller:Position_XYZ\nobj.scale.controller.setExpression \"[0.01*pos.x,1,1]\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D0E\"></a>In these circumstances, a Node Variable can be used instead. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D0D\"></a>The variable will contain a reference to the scene node and the script controller\'s\n            expression will access the necessary property from the node instead of pointing directly\n            at a subAnim or MAXWrapper object: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D0C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6D0B\"></a><p class=\"table-body\"> <em class=\"strong\">WORKS:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B41\"></a><pre>\nobj = Teapot ()\n--&gt;$Teapot:Teapot001 @ [0.000000,0.000000,0.000000]\nobj.scale.controller = scale_script()\n--&gt;Controller:Scale_Script\nobj.scale.controller.addNode \"obj\" obj\n--&gt;true\nobj.scale.controller.setExpression \"[0.01*obj.pos.x,1,1]\"\n--&gt;true\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CFF\"></a>Moving the teapot along the X axis will automatically scale its X axis according to\n            the distance to the world origin. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CFC\"></a> <span class=\"char_link\"><a href=\"GUID-5015B963-A1C7-457F-A76B-F63D3676CC6F.htm\">Script Controller - Avoiding Circular Dependency</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CFB\"></a> <span class=\"char_link\"><a href=\"GUID-0DCBE29A-130E-4C3D-82A7-5EEF8CAA8AAE.htm\">Referencing Nodes and Controllers in Script Controllers FAQ</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CF9\"></a> <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6CF8\"></a> <span class=\"char_link\"><a href=\"GUID-63624405-E55C-4E7C-825D-747D710DB262.htm\">Using Script Controllers</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";