var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"when construct\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"indexterm\" content=\"deleteChangeHandler()\">\n      <meta name=\"indexterm\" content=\"deleteAllChangeHandlers()\">\n      <meta name=\"indexterm\" content=\"change handlers: ChangeHandler - value\">\n      <meta name=\"indexterm\" content=\"change handlers\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Change Handlers and When Constructs</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875\"></a><div class=\"head\">\n            <h1>Change Handlers and When Constructs </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AB8\"></a>Change Handlers are used to detect when certain types of user events are performed\n            on objects in a scene, allowing you to write scripts that respond to user operations\n            like object moves, vertex edits, object deletions, name changes, and so on. Change\n            Handlers are applied to individual MAXWrapper objects and specify an attribute to\n            monitor for that object and an expression to evaluate when that attribute changes.\n            Example attributes that can be monitored are geometry, name, transform, and parameters.\n            Change Handlers are not stored in a <em class=\"strong\">3ds Max</em> scene. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AB7\"></a>The <span class=\"code\"> <em class=\"strong\">ChangeHandler : Value</em> </span> class instances represent change handler setups. ChangeHandler values are created\n            using the <span class=\"code\"> <em class=\"strong\">when</em> </span> construct. Each time a <span class=\"code\"> <em class=\"strong\">when</em> </span> construct is executed, it creates and returns a new ChangeHandler instance. You must\n            store this ChangeHandler value in a variable or array so that you can dismiss the\n            handler when it is appropriate to do so. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AB6\"></a>The <span class=\"code\"> <em class=\"strong\">when</em> </span> construct defines a change handler function for a certain type of event on one or\n            more objects. The system then automatically calls this function whenever the event\n            occurs. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AB5\"></a>The syntax of the <span class=\"code\"> <em class=\"strong\">when</em> </span> construct has two forms as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-694F\"></a><pre><em class=\"codeEmphasisStrong\">when</em> &lt;attribute&gt; &lt;objects&gt; <em class=\"codeEmphasisStrong\">change</em>[s] [ <em class=\"codeEmphasisStrong\">id</em>:&lt;name&gt; ] \\ \n[<em class=\"codeEmphasisStrong\">handleAt</em>: <em class=\"codeEmphasisStrong\">#redrawViews</em>|<em class=\"codeEmphasisStrong\">#timeChange</em>] \\ \n[ &lt;object_parameter&gt; ] <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt;</pre></div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-694E\"></a><pre><em class=\"codeEmphasisStrong\">when</em> &lt;objects&gt; <em class=\"codeEmphasisStrong\">deleted</em> [ <em class=\"codeEmphasisStrong\">id</em>:&lt;name&gt; ] \\ \n[<em class=\"codeEmphasisStrong\">handleAt</em>:<em class=\"codeEmphasisStrong\">#redrawViews</em>|<em class=\"codeEmphasisStrong\">#timeChange</em>] \\\n[ &lt;object_parameter&gt; ] <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AB0\"></a>In the first form, the <span class=\"code\"> <em class=\"strong\">&lt;attribute&gt;</em> </span> can be one of: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-694D\"></a><pre> <em class=\"codeEmphasisStrong\">topology</em> <em class=\"codeEmphasisStrong\">geometry</em> <em class=\"codeEmphasisStrong\">name[s]</em> <em class=\"codeEmphasisStrong\">transform</em> <em class=\"codeEmphasisStrong\">select</em> <em class=\"codeEmphasisStrong\">parameters</em> <em class=\"codeEmphasisStrong\">subAnimStructure</em> <em class=\"codeEmphasisStrong\">controller</em> <em class=\"codeEmphasisStrong\">children</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AA6\"></a>These specify the attribute of the given object(s) to be tracked for change (see below\n            for more details). \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AA5\"></a>The second form tracks object deletion by the user or other scripts. This is typically\n            used if you have tables or other structures containing MAXScript object values and\n            you want to remove deleted objects from them as the user modifies the scene. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AA4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AA3\"></a><p class=\"table-body\"> <em class=\"strong\">NOTES:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AA1\"></a><p class=\"table-body\">The <span class=\"code\"> <em class=\"strong\">#selectedNodesPreDelete </em> </span><span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm#WS73099CC142F487553098682E12AC2FC2BC7-68B3\">general callback</a></span> is the far superior method to use to catch node deletion by the user. It is called\n                        before <em class=\"strong\">anything</em> happens to the nodes and will report the deletion of any node. In contrast, the <span class=\"code\"> <em class=\"strong\">when</em> </span> construct operates only on nodes explicitly registered with the callback. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-694C\"></a><pre>\nmypot1 = teapot() --create a teapot\nfn whendeleted = --define a callback function\n(\nlocal deletedobjects = callbacks.notificationParam()\nformat \"Callback: %\\n\" deletedobjects\n-- This will printevery object that was deleted.\n-- By this point, the object isstillattached to it\'s parents\n-- and is still in groups etc...\n-- Nothing has been done to the nodeyet.\n)\nwhen mypot1 deleted id:#foo obj do --define a when construct\n(\nformat \"When Construct:%\\n\" obj\n)\n--unregisterany preDeletecallbacks\ncallbacks.removeScripts #selectedNodesPreDelete\n--register the function as general callback\ncallbacks.addscript #selectedNodesPreDelete \"whendeleted()\"\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A89\"></a><p class=\"table-body\">A regression in <em class=\"strong\">3ds Max 9</em> caused a change in the way the <span class=\"code\"> <em class=\"strong\">when</em> </span> construct was called. In releases prior to <em class=\"strong\">3ds Max 9</em>, the <span class=\"code\"> <em class=\"strong\">when</em> </span> construct was called before the actual deletion of the object. In <em class=\"strong\">3ds Max 9</em>, the <em class=\"strong\">when</em> callback in the above code would return &lt;deleted scene node&gt; instead. \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A88\"></a><p class=\"table-body\">This behavior has been fixed in <em class=\"strong\">3ds Max 2008</em>. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A84\"></a>In both forms, the <span class=\"code\"> <em class=\"strong\">&lt;objects&gt;</em> </span> argument can be one of the following: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A83\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A81\"></a>a single <em class=\"strong\">3ds Max</em> object such as, a scene node, controller, modifier, material, and so on. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A7F\"></a>one of the object sets such as, \'selection\' or \'cameras\'. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A7D\"></a>a wild-card pathname like $foo*. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A7B\"></a>an array of <em class=\"strong\">3ds Max</em> objects. \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A7A\"></a>If more than one object is specified, the handler is called each time the given attribute\n            of any of the objects is signaled as changed by the <em class=\"strong\">3ds Max</em> core. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A79\"></a>The optional <span class=\"code\"> <em class=\"strong\">id:</em> </span> parameter specifies an ID for one or more handlers as a name literal. The ID name\n            can later be used to delete the handler and if the same name is given to several handlers,\n            they can be deleted as a group. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A78\"></a>The optional <span class=\"code\"> <em class=\"strong\">handleAt:</em> </span> parameter signals that the change handler expression must <em class=\"strong\">not</em> be executed immediately upon notification, but delayed until either the <em class=\"strong\">3ds Max</em> viewports are redrawn (<span class=\"code\"> <em class=\"strong\">#redrawViews</em> </span>) or current <em class=\"strong\">3ds Max</em> animation time is changed (<span class=\"code\"> <em class=\"strong\">#timeChange</em> </span>). Delaying the processing of the change handler expression is highly recommended,\n            as described in the Caution section below. An example usage of the <span class=\"code\"> <em class=\"strong\">handleAt:</em> </span> parameter is:when select $ changes id:#foo handleAt:#redrawViews do ... \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A77\"></a>The optional <span class=\"code\"> <em class=\"strong\">&lt;object_parameter&gt;</em> </span> lets you specify the name of a parameter variable that will be accessible in the\n            do <span class=\"code\"> <em class=\"strong\">&lt;expr&gt;</em> </span> and will hold the actual object that has changed. You typically specify this parameter\n            name if the handler will respond to changes in many objects, so you can determine\n            which one has changed. The <span class=\"code\"> <em class=\"strong\">&lt;expr&gt;</em> </span> can be a single expression or block expression. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A76\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A75\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-694B\"></a><pre>\nb1 = box()\nb2 = box()\nb3 = box()\nwhen transform $box001 changes do\n$box002.pos = $box001.pos + delta\nmax select all\nwhen names selection change obj do update_name_table obj\nwhen #($box001, $box002, $box003) deleted obj do\n(\nmessageBox \"Warning!\"\ndeleteItem obj_table (findItem obj_table obj)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A69\"></a>The change attributes are interpreted as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-694A\"></a><pre><em class=\"codeEmphasisStrong\">topology</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A67\"></a>Signaled when the topology of an object changes in the Modify panel such as, using\n            a mesh smooth, optimize, or vertex delete. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6949\"></a><pre><em class=\"codeEmphasisStrong\">geometry</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A64\"></a>Signaled when the geometry of an object changes such as, by moving a vertex or using\n            an animated modifier. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6948\"></a><pre><em class=\"codeEmphasisStrong\">name </em>or<em class=\"codeEmphasisStrong\"> names</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A61\"></a>Signaled when the name of an object is changed if this occurs because a user edits\n            the name in one of the <em class=\"strong\">3ds Max</em> command panels. The handler is called repeatedly with each character that is changed.\n            \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6947\"></a><pre><em class=\"codeEmphasisStrong\">transform</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A5E\"></a>Signaled when the transform of an object is changed such as, by a move, rotate, or\n            scale. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6946\"></a><pre><em class=\"codeEmphasisStrong\">select</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A5B\"></a>Signaled when a scene node moves into or out of the current selection set. You should\n            interrogate the <span class=\"code\"> <em class=\"strong\">&lt;node&gt;.isSelected</em> </span> property to determine the new state. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6945\"></a><pre><em class=\"codeEmphasisStrong\">parameters</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A58\"></a>Signaled when any parameters are changed in the object. This is something of a catch\n            all because the core signals this event in many situations. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6944\"></a><pre><em class=\"codeEmphasisStrong\">subAnimStructure</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A55\"></a>Signaled when the dynamic subAnim structure changes such as, when a new vertex becomes\n            animated in an editable mesh, or when a new controller is added to a list controller.\n            Also called when subAnims are reassigned, for example, when a material is changed\n            in an object. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6943\"></a><pre><em class=\"codeEmphasisStrong\">controller</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A52\"></a>Signaled when a new controller is assigned to one of the object\'s tracks. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6942\"></a><pre><em class=\"codeEmphasisStrong\">children</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A4F\"></a>Signaled when an object has immediate children added or removed. \n         </p>\n         <p><a name=\"P_62D45F0CA7554F9A9C21E2E6D728046E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A4D\"></a> \n            <h2><a name=\"GUID-AA6F62F8-5CE5-4042-B6DC-E537521654DA\"></a> <em class=\"strong\">Deleting Change Handlers</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A4C\"></a>You can use the following two methods for deleting change handlers: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6941\"></a><pre><em class=\"codeEmphasisStrong\">deleteChangeHandler</em> &lt;change_handler&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A4A\"></a>deletes specified change handler .<span class=\"code\"> <em class=\"strong\">change_handler</em> </span> is the value returned by a <span class=\"code\"> <em class=\"strong\">when</em> </span> construct. \n            </p> \n            <p><a name=\"P_49FA86FD380A4DFB870122CFE59E5C93\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6940\"></a><pre><em class=\"codeEmphasisStrong\">deleteAllChangeHandlers</em> [ <em class=\"codeEmphasisStrong\">id</em>:&lt;name&gt; ]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A47\"></a>If optional <span class=\"code\"> <em class=\"strong\">id:</em> </span> parameter is not specified, deletes all change handlers. If optional <span class=\"code\"> <em class=\"strong\">id:</em> </span> parameter is specified, deletes all change handlers with the specified id. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A46\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A45\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-693F\"></a><pre>\ndeleteAllChangeHandlers id:#foo\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A40\"></a>For efficiency reasons, you do not want irrelevant change handlers running in the\n               background, so it is essential that you delete those that you no longer need. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A3F\"></a> <em class=\"strong\">Special Considerations</em> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A3E\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A3C\"></a>If a runtime error occurs in the body of a change handler while it is being executed,\n                     an error message is displayed and that handler is permanently disabled. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A3A\"></a>If all of the objects being tracked by a change handler are deleted, the change handler\n                     is also deleted. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A38\"></a>The <span class=\"code\"> <em class=\"strong\">do &lt;expr&gt;</em> </span> change handler code is executed in a special context and not in the context of the\n                     code that created it. This means that the <span class=\"code\"> <em class=\"strong\">&lt;expr&gt;</em> </span> code cannot contain references to local variables in outer code nestings surrounding\n                     the <span class=\"code\"> <em class=\"strong\">when</em> </span> because those variables are on an execution stack that does not exist at the time\n                     the <span class=\"code\"> <em class=\"strong\">when</em> </span> handler is called. The compiler detects any illegal references to outer locals and\n                     generates a compiler message. An important exception to this is utility and rollout\n                     panel locals such as, local functions, rollout variables, and nested rollouts. You\n                     can refer to them in change handler code inside rollout code as they are associated\n                     directly with their rollout or utility object. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A36\"></a>Change handlers are called only for user initiated events, and not for changes resulting\n                     from a change in controller values. For example, a change handler on the transform\n                     attribute of a node would be called when the user moves the node. If the position\n                     of the node is animated, and you play back the animation, the transform attribute\n                     change handler is not called. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A34\"></a>If you assign a change handler to an attribute on multiple objects, the change handler\n                     is called once per object if that object’s attribute changes. \n                  </p> \n               </li>\n            </ul> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A33\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A32\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE, IF YOU SAY:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-693E\"></a><pre>\nwhen select $ changes obj do update_modifier_list obj\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A2E\"></a><p class=\"table-body\">The function <span class=\"code\"> <em class=\"strong\">update_modifier_list</em> </span> is called whenever any object is selected or deselected. This is true even if you\n                           do an Edit / Select All. In this case, <span class=\"code\"> <em class=\"strong\">update_modifier_list</em> </span> will be called once for each object currently selected (as the objects are deselected),\n                           and then once for all objects in the scene (as the objects are selected). If <span class=\"code\"> <em class=\"strong\">update_modifier_list</em> </span> is at all processor-intensive, a significant system slowdown can occur. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A2D\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A29\"></a>Change handlers are only applied to object already present in the scene. Change handlers\n                     are not automatically applied to newly created objects. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A27\"></a>If you have multiple change handlers defined, the order in which the change handlers\n                     are called is somewhat arbitrary. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A25\"></a>Due to the way that <em class=\"strong\">3ds Max</em> internally processes notification signals, the <em class=\"strong\">$</em> form of accessing selected objects is not recommended in a select change handler.\n                     To access the selected objects, you must use the <em class=\"strong\">selection</em> objectset. This is because <em class=\"strong\">$</em> relies on information that has not yet been set in the selection processing whereas\n                     <em class=\"strong\">selection</em> uses a different method of accessing selections and the information it uses has been\n                     set up. \n                  </p> \n               </li>\n            </ul> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A22\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A21\"></a><p class=\"table-body\"> <em class=\"strong\">CAUTION</em> <em class=\"strong\">!</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A20\"></a><p class=\"table-body\">The change handler system is based on <em class=\"strong\">3ds Max</em>\'s internal notification system which essentially drives all animation and interactivity\n                           within <em class=\"strong\">3ds Max</em>. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A1F\"></a><p class=\"table-body\">There are cases when the core sends many signals for the same change, so setting up\n                           change handlers on many objects that do vast amounts of computing can significantly\n                           slow down the system. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A1E\"></a><p class=\"table-body\">Strictly speaking, change handlers are supposed to be used to just set \"dirty flags\"\n                           in a lightweight, order-independent way, and then use Redraw Views or Time Change\n                           callbacks to actually cause the triggered processing. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A1D\"></a><p class=\"table-body\">You must attempt to use change handlers judiciously, and not, for example, as a simple\n                           way to get scripted controllers. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A1C\"></a><p class=\"table-body\">If you do find that a desired setup is being flooded with unnecessary signals, you\n                           must use the <span class=\"code\"> <em class=\"strong\">handleAt:</em> </span> to delay the actual processing of the event handler script until a redrawViews or\n                           timeChange event occurs. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div><a name=\"TABLE_1A6FEF015C044CAD9B666FB7ED263E6B\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"3.6900369003690034%\">\n                  <col width=\"41.25461254612546%\">\n                  <col width=\"55.055350553505534%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\" valign=\"middle\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\" colspan=\"2\" valign=\"middle\"> <a name=\"P_23726818F1DC4EE9AAC2BF00F6CE7F96\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_D81F4BEE8E324CBA8E4BB59667750D80\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">Callback Notifications - Quick Navigation</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A18\"></a> <span class=\"char_link\"><a href=\"GUID-1BE2E978-72CF-495C-81D6-2B36E2C4FFC7.htm\">Change Handlers and Callbacks</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A17\"></a> <span class=\"char_link\"><a href=\"GUID-962137D0-2937-4A31-A3E0-2BBF8C365577.htm\">Time Change Callback Mechanism</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A16\"></a> <span class=\"char_link\"><a href=\"GUID-1961F536-7F01-4D72-930C-4B9432952B79.htm\">Viewport Redraw Callback Mechanism</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A15\"></a> <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";