var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-52E2EA19-D42C-4240-A061-CB0DC364267E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"setNeedsRedraw()\">\n      <meta name=\"indexterm\" content=\"Refreshing the Viewports\">\n      <meta name=\"indexterm\" content=\"redrawViews()\">\n      <meta name=\"indexterm\" content=\"nodeInvalRect()\">\n      <meta name=\"indexterm\" content=\"isSceneRedrawDisabled()\">\n      <meta name=\"indexterm\" content=\"forceCompleteRedraw()\">\n      <meta name=\"indexterm\" content=\"enableSceneRedraw()\">\n      <meta name=\"indexterm\" content=\"disableSceneRedraw()\">\n      <meta name=\"indexterm\" content=\"completeRedraw()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Refreshing the Viewports</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-52E2EA19-D42C-4240-A061-CB0DC364267E\"></a><div class=\"head\">\n            <h1>Refreshing the Viewports </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B52\"></a>         The following methods force the viewports to redraw, or control when the viewports\n            are redrawn. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B79\"></a><pre><em class=\"codeEmphasisStrong\">redrawViews</em>() 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B47\"></a>Causes the <em class=\"strong\">3ds Max</em> viewports to be immediately redrawn in an optimal way, such that only those parts\n            of the view that have changed are redrawn. This is different from forcing a redraw\n            with the <span class=\"code\"> <em class=\"strong\">max view redraw</em> </span> command or one of the following methods which redraw the entire scene in all views.\n            \n         </p>\n         <p><a name=\"GUID-16117F93-3037-4375-A8EC-9C535B832241\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B78\"></a><pre><em class=\"codeEmphasisStrong\">completeRedraw</em>() 	 \n<em class=\"codeEmphasisStrong\">forceCompleteRedraw</em> [ <em class=\"codeEmphasisStrong\">doDisabled</em>:&lt;boolean&gt; ]   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B43\"></a>Calling this method will cause all the viewports to be completely redrawn. This method\n            literally forces everything (every object, every screen rectangle, every view) to\n            be marked invalid and then the whole scene is regenerated. The individual object pipeline\n            caches are not flushed, however. This routine is guaranteed to be slow. If the optional\n            <span class=\"code\"> <em class=\"strong\">doDisabled:</em> </span> boolean argument for <span class=\"code\"> <em class=\"strong\">ForceCompleteRedraw</em> </span> is <span class=\"code\"> <em class=\"strong\">true</em> </span>, disabled viewports will also be redrawn. \n         </p>\n         <p><a name=\"GUID-6351BDB8-3EC2-4122-9249-53527DA4FD78\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B77\"></a><pre><em class=\"codeEmphasisStrong\">setNeedsRedraw complete</em>:&lt;bool&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B40\"></a>Sets an internal MAXScript flag that viewports need to be redrawn before MAXScript\n            returns. This is equivalent to a delayed <span class=\"code\"> <em class=\"strong\">redrawViews()</em> </span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B3F\"></a>If <span class=\"code\"> <em class=\"strong\">complete:</em> </span> is true, a flag is set that a complete viewport redraw is needed. This is equivalent\n            to a delayed <span class=\"code\"> <em class=\"strong\">completeRedraw()</em> </span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B3E\"></a>Available in <em class=\"strong\">3ds Max 2008</em> and higher. Previously available in <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-4828476F-E425-428F-A9F6-CCD04EC5E7E3\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B76\"></a><pre><em class=\"codeEmphasisStrong\">disableSceneRedraw</em>() </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B3B\"></a>Turns viewport scene redraw off (disables it). \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B3A\"></a>All calls to <span class=\"code\"> <em class=\"strong\">DisableSceneRedraw()</em> </span>/<span class=\"code\"> <em class=\"strong\">EnableSceneRedraw()</em> </span> must be in pairs, since an internal counter is used in <em class=\"strong\">3ds Max</em> to actually do the redraw enable/disable action. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B39\"></a>It is a better practice to use the<span class=\"char_link\"><a href=\"GUID-9A522918-0517-4B04-80AF-F3FEFEE23448.htm\">with redraw off Context</a></span> which turns off redraws only for the expression inside the Context\'s body. \n         </p>\n         <p><a name=\"GUID-ADAC68AC-BD9F-43BD-B2CC-DD67D9FEDDBB\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B75\"></a><pre><em class=\"codeEmphasisStrong\">enableSceneRedraw</em>() </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B36\"></a>Turns viewport scene redraw on (enables it). \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B35\"></a>All calls to <span class=\"code\"> <em class=\"strong\">DisableSceneRedraw()</em> </span>/<span class=\"code\"> <em class=\"strong\">EnableSceneRedraw()</em> </span> must be in pairs, since an internal counter is used in <em class=\"strong\">3ds Max</em> to actually do the redraw enable/disable action. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B34\"></a>It is a better practice to use the <span class=\"char_link\"><a href=\"GUID-9A522918-0517-4B04-80AF-F3FEFEE23448.htm\">with redraw off Context</a></span> which turns off redraws only for the expression inside the Context\'s body. \n         </p>\n         <p><a name=\"GUID-679F8DFE-247F-4C71-A49E-8351B5990C6B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B74\"></a><pre><em class=\"codeEmphasisStrong\">isSceneRedrawDisabled</em>() </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B31\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if scene redraw is disabled, <span class=\"code\"> <em class=\"strong\">false</em> </span> if it is enabled. \n         </p>\n         <p><a name=\"GUID-FC9C651C-9BDB-4D7B-BF26-9ED74EBA43B1\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B73\"></a><pre><em class=\"codeEmphasisStrong\">nodeInvalRect</em> &lt;node&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B2E\"></a>Invalidates the rectangle in the viewports that the node is occupying. Rectangles\n            flagged as invalid will be updated on the next screen redraw. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2B2A\"></a> <span class=\"char_link\"><a href=\"GUID-9A522918-0517-4B04-80AF-F3FEFEE23448.htm\">Redraw Context</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";