var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-54E22731-0A26-4156-8515-369866D380EB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: CustomFileStream</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-54E22731-0A26-4156-8515-369866D380EB\"></a><div class=\"head\">\n            <h1>Interface: CustomFileStream</h1>\n         </div>\n         <p>The \n            		<span class=\"code\">CustomFileStream</span> interface is used to query, add, modify and remove \n            		<span class=\"code\">CustomFileStream</span>s from an external scene file. Available in <em class=\"strong\">3ds Max 2019 and higher</em>. \n            		<span class=\"code\">CustomFileStream</span>s in the current scene file are managed with the \n            		<span class=\"char_link\"><a href=\"GUID-ED92EB20-5E7E-4FC3-81CA-9454D38F97B1.htm\">CustomSceneStreamManager</a></span> interface. See the overview topic \n            		<span class=\"char_link\"><a href=\"GUID-81C6EC68-B766-4C6C-A6A4-D0272A0DE953.htm\">Custom File Streams</a></span>.\n            	 \n         </p>\n         <p>For a description of the possible pre-defined flag values and the \"public\" customizable\n            flag value, see \n            		<span class=\"char_link\"><a href=\"GUID-ED92EB20-5E7E-4FC3-81CA-9454D38F97B1.htm\">CustomSceneStreamManager</a></span>. \n            	 \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6492\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6493\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; CustomFileStream \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><em class=\"strong\">Methods</em>: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;TSTR by value array&gt;<em class=\"codeEmphasisStrong\">getStreamNames</em>\n	&lt;filename&gt;fileName</pre></div>\n         <p>Returns an array of the \n            		<span class=\"code\">CustomFileStream</span> names in the specified file. If the specified file does not exist, or if it does\n            not support custom file stream storage (for example, has a file version older than\n            3ds Max 2019), an exception is thrown. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">doesStreamExist</em> &lt;filename&gt;fileName\n	&lt;string&gt;streamName</pre></div>\n         <p>Returns true if the specified \n            		<span class=\"code\">CustomFileStream</span> is present in the specified file. If the specified file does not exist, or if it\n            does not support custom file stream storage, an exception is thrown. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; <em class=\"codeEmphasisStrong\">isCustomFileStreamOperable</em>\n	&lt;filename&gt;fileName &lt;string&gt;streamName</pre></div>\n         <p>Returns true if the specified stream in the specified file is a valid \n            		<span class=\"code\">CustomFileStream</span>. If the specified file does not exist, if it does not support custom file stream\n            storage, or if the named stream does not exist, an exception is thrown. This method\n            is intended primarily to test whether \n            		<span class=\"code\">CustomFileStream</span>s written by external applications are valid. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">deleteStream</em> &lt;filename&gt;fileName\n	&lt;string&gt;streamName</pre></div>\n         <p>Deletes the specified \n            		<span class=\"code\">CustomFileStream</span> in the specified file. Returns false if the file exists but cannot be opened with\n            write access. If the specified file does not exist, if it does not support custom\n            file stream storage, or if the named \n            		<span class=\"code\">CustomFileStream</span> does not exist, an exception is thrown. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;TSTR by value&gt;<em class=\"codeEmphasisStrong\">readStream</em> &lt;filename&gt;fileName\n	&lt;string&gt;streamName</pre></div>\n         <p>Returns the content of the specified \n            		<span class=\"code\">CustomFileStream</span> in the specified file as a string. If the content is an array of strings, the first\n            string is returned. If the specified file does not exist, if it does not support custom\n            file stream storage, or if the named \n            		<span class=\"code\">CustomFileStream</span> does not exist, an exception is thrown. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">writeStream</em> &lt;filename&gt;fileName\n	&lt;string&gt;streamName &lt;string&gt;content\n	persistent:&lt;bool&gt; noLoadOnSceneLoad:&lt;bool&gt;\n	append:&lt;bool&gt;\n	persistent default value: true\n	noLoadOnSceneLoad default value: false\n	append default value: false</pre></div>\n         <p>Creates and sets the content of the specified \n            		<span class=\"code\">CustomFileStream</span> in the specified file to the specified string, setting the corresponding flag values\n            if it is a new stream. If the stream already exists, its contents are replaced unless\n            \n            		<span class=\"code\">append:true</span> is specified, in which case the specified string is appended to the current contents.\n            Returns false if the file exists but cannot be opened with write access. If the specified\n            file does not exist, or if it does not support custom file stream storage, an exception\n            is thrown. If appending and the stream has existing array content, an exception is\n            thrown. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;TSTR by value array&gt;<em class=\"codeEmphasisStrong\">readStreamArray</em>\n	&lt;filename&gt;fileName &lt;string&gt;streamName</pre></div>\n         <p>Returns the content of the specified \n            		<span class=\"code\">CustomFileStream</span> in the specified file as an array of strings. If the content is a single string,\n            it is returned in a one element array. If the specified file does not exist, if it\n            does not support custom file stream storage, or if the named \n            		<span class=\"code\">CustomFileStream</span> does not exist, an exception is thrown. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">writeStreamArray</em> &lt;filename&gt;fileName\n	&lt;string&gt;streamName &lt;string by value array&gt;contentArray\n	persistent:&lt;bool&gt; noLoadOnSceneLoad:&lt;bool&gt;\n	append:&lt;bool&gt;\n	persistent default value: true\n	noLoadOnSceneLoad default value: false\n	append default value: false</pre></div>\n         <p>Creates and sets the content of the specified \n            		<span class=\"code\">CustomFileStream</span> in the specified file to the specified array of strings, setting the corresponding\n            private flag values if it is a new stream. If the stream already exists, its contents\n            are replaced unless \n            		<span class=\"code\">append:true</span> is specified, in which case the specified array of strings is appended to the current\n            contents. Returns false if the file exists but cannot be opened with write access.\n            If the specified file does not exist or if it does not support custom file stream\n            storage, an exception is thrown. If appending and the stream has existing string content\n            (not an array), an exception is thrown. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;DWORD&gt;<em class=\"codeEmphasisStrong\">getStreamFlags</em> &lt;filename&gt;fileName\n	&lt;string&gt;streamName getPrivate:&lt;bool&gt;\n	getPrivate default value: false</pre></div>\n         <p>Returns the flag value of the specified \n            		<span class=\"code\">CustomFileStream</span> in the specified file. If the specified file does not exist, if it does not support\n            custom file stream storage, or if the named \n            		<span class=\"code\">CustomFileStream</span> does not exist, an exception is thrown. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">setStreamFlags</em> &lt;filename&gt;fileName\n	&lt;string&gt;streamName &lt;DWORD&gt;flags\n	setPrivate:&lt;bool&gt;\n	setPrivate default value: false</pre></div>\n         <p>Sets the flag value of the specified \n            		<span class=\"code\">CustomFileStream</span> in the specified file. Returns false if the file exists but cannot be opened with\n            write access. If the specified file does not exist, if it does not support custom\n            file stream storage, or if the named \n            		<span class=\"code\">CustomFileStream</span> does not exist, an exception is thrown. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">isStreamDataAnArray</em> &lt;filename&gt;fileName\n	&lt;string&gt;streamName</pre></div>\n         <p>Returns true if the content of the specified \n            		<span class=\"code\">CustomFileStream</span> in the specified file is an array of strings. If the specified file does not exist,\n            if it does not support custom file stream storage, or if the named \n            		<span class=\"code\">CustomFileStream</span> does not exist, an exception is thrown. \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";