var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-54F44A51-D225-4B91-B87B-E60216B26F16\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Photometric Light Classes\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Photometric Light Classes</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-54F44A51-D225-4B91-B87B-E60216B26F16\"></a><div class=\"head\">\n            <h1>Photometric Light Classes </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D80\"></a> The Photometric Lights have been redesigned in <em class=\"strong\">3ds Max 2009</em> to simplify the creation and conversion between types, as well as extended to support\n            more options, preview Web Distribution and more. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D7E\"></a>Internally,<em class=\"strong\">3ds Max 2009 and higher</em> expose a multitude of Photometric Light Classes with unique ClassIDs. Some of these\n            classes includingthePoint,Line and Area Lights (both Free and Targeted) provide backwards\n            compatibility withPhotometric Lights from previous versions. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D7D\"></a>In the <em class=\"strong\">3ds Max Command Panel</em>, the creation has been reduced to only <em class=\"strong\">two basic types</em> -<em class=\"strong\">Target Light</em> and <em class=\"strong\">Free Light</em> which can be converted into all other types via the \"Shape/Area Shadows\" rollout.\n            The old \"Area\" type is now called \"Rectangle\" to distinguish between the various area\n            light shapes that are now available. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D7C\"></a>Several <em class=\"strong\">new Area Light types</em> -<em class=\"strong\">Disc</em>,<em class=\"strong\">Sphere</em> and <em class=\"strong\">Cylinder</em> have been added. Class instances of these light classes can be created directly by\n            MAXScript or indirectly by settinga light\'s <span class=\"code\"> <em class=\"strong\">.type</em> </span> property to <span class=\"code\"> <em class=\"strong\">#Free_Disc, #Target_Disc, #Free_Sphere, #Target_Sphere, #Free_Cylinder</em> </span> or <span class=\"code\"> <em class=\"strong\">#Target_Cylinder</em> </span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D7B\"></a>Also note that the User Interface of all Photometric Lights exposes a checkbox called\n            \"Targeted\". Changing the state of this checkbox using the mouse will implicitly convert\n            the classof the object between #Target_* and #Free_* types. This property cannot be\n            set directly with MAXScript, instead, the .type property has to be set to the desired\n            #Free_* or #Target_* type. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D7A\"></a>The table below lists all available Photometric Light types. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D78\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"25%\">\n                  <col width=\"25%\">\n                  <col width=\"25%\">\n                  <col width=\"25%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D77\"></a><p class=\"table-body\"> <em class=\"strong\">Type</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D76\"></a><p class=\"table-body\"> <em class=\"strong\">Class</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D75\"></a><p class=\"table-body\"> <em class=\"strong\">ClassID</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D74\"></a><p class=\"table-body\"> <em class=\"strong\">New in 3ds Max 2009</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D73\"></a><p class=\"table-body\"> <em class=\"strong\">FREE TYPES</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D72\"></a><p class=\"table-body\"></p> \n                  </td>\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D71\"></a><p class=\"table-body\"></p> \n                  </td>\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D70\"></a><p class=\"table-body\"></p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D6F\"></a><p class=\"table-body\">#Free_Point </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D6E\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-64C0706D-35D1-42D2-882D-846DE5B1DC4F.htm\">Free_Light</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D6D\"></a><p class=\"table-body\">#(842489804, 184704240) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D6C\"></a><p class=\"table-body\">No </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D6B\"></a><p class=\"table-body\">#Free_Line </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D6A\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BAAB1BA1-9B64-436E-83E9-4B92E6E5FCBA.htm\">Free_Linear</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D69\"></a><p class=\"table-body\">#(2015392769, 897523032) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D68\"></a><p class=\"table-body\">No </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D67\"></a><p class=\"table-body\">#Free_Rectangle </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D66\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-8DFE6989-B425-4CEE-9D00-098DDCD45A49.htm\">Free_Area</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D65\"></a><p class=\"table-body\">#(911244690, 274340423) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D64\"></a><p class=\"table-body\">No </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D63\"></a><p class=\"table-body\">#Free_Disc </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D62\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-A7D8BB77-BD10-4BCA-AFB7-7924D8FD9AEC.htm\">Free_Disc</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D61\"></a><p class=\"table-body\">#(1540123970, 206521102) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D60\"></a><p class=\"table-body\">Yes </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D5F\"></a><p class=\"table-body\">#Free_Sphere </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D5E\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-70EE7542-0052-4B0D-B3E6-DE9AC4130507.htm\">Free_Sphere</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D5D\"></a><p class=\"table-body\">#(2091464066, 448490290) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D5C\"></a><p class=\"table-body\">Yes </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D5B\"></a><p class=\"table-body\">#Free_Cylinder </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D5A\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-4E2C9189-84D0-4758-BEEC-10EACD05C737.htm\">Free_Cylinder</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D59\"></a><p class=\"table-body\">#(1190540515, 171080367) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D58\"></a><p class=\"table-body\">Yes </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D57\"></a><p class=\"table-body\"> <em class=\"strong\">TARGETED TYPES</em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D56\"></a><p class=\"table-body\"></p> \n                  </td>\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D55\"></a><p class=\"table-body\"></p> \n                  </td>\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D54\"></a><p class=\"table-body\"></p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D53\"></a><p class=\"table-body\">#Target_Point </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D52\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-092590A0-89E9-4919-891D-330FA43E6512.htm\">Target_Light</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D51\"></a><p class=\"table-body\">#(1703759767, 1926054489) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D50\"></a><p class=\"table-body\">No </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D4F\"></a><p class=\"table-body\">#Target_Line </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D4E\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-690D28EB-BA85-4317-9E36-0F9312AF0D08.htm\">Target_Linear</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D4D\"></a><p class=\"table-body\">#(1158113413, 1081676873) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D4C\"></a><p class=\"table-body\">No </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D4B\"></a><p class=\"table-body\">#Target_Rectangle </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D4A\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-03DC3502-AEAC-4606-873B-B8D4990907A9.htm\">Target_Area</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D49\"></a><p class=\"table-body\">#(1903775645, 1890472690) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D48\"></a><p class=\"table-body\">No </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D47\"></a><p class=\"table-body\">#Target_Disc </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D46\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-04D60796-9C35-492F-9F97-79FD786E5088.htm\">Target_Disc</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D45\"></a><p class=\"table-body\">#(947069768, 538400947) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D44\"></a><p class=\"table-body\">Yes </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D43\"></a><p class=\"table-body\">#Target_Sphere </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D42\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-3FB8DC0E-7BC1-434A-A10D-2986FAA24767.htm\">Target_Sphere</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D41\"></a><p class=\"table-body\">#(872184553, 1413692869) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D40\"></a><p class=\"table-body\">Yes </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D3F\"></a><p class=\"table-body\">#Target_Cylinder </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D3E\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-7F4E882C-D454-4121-8E13-FD1566DA4314.htm\">Target_Cylinder</a></span> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D3D\"></a><p class=\"table-body\">#(2089507600, 1272135302) </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D3C\"></a><p class=\"table-body\">Yes </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-D3A\"></a>All these light classes share the same <span class=\"char_link\"><a href=\"GUID-F0C33251-1FCD-4B83-8697-F755F7D7AECD.htm\">Photometric Lights Common Properties, Operators, and Methods</a></span> , thus their respective documentation pages contain no properties. There are some\n            slight differences in the allowed ranges of a few common parameters, for example the\n            Sphere and Cylinder lights support only a <span class=\"code\"> <em class=\"strong\">.distribution</em> </span> value of 0, while all other types support a range from 0 to 3. These specifics have\n            been noted explicitly where applicable. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";