var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5517C84B-95A3-430D-BBF2-D62E638FD77E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"setAppData() - AppData\">\n      <meta name=\"indexterm\" content=\"MAXWrapper - Value\">\n      <meta name=\"indexterm\" content=\"getAppData() - AppData\">\n      <meta name=\"indexterm\" content=\"deleteAppData() - AppData\">\n      <meta name=\"indexterm\" content=\"clearAllAppData() - AppData\">\n      <meta name=\"indexterm\" content=\"AppData\">\n      <meta name=\"indexterm\" content=\"Accessing AppData\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Access to MAXWrapper AppData</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5517C84B-95A3-430D-BBF2-D62E638FD77E\"></a><div class=\"head\">\n            <h1>Access to MAXWrapper AppData </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3773\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3772\"></a>       The AppData access methods give a simple form of access to the AppData capability\n               in the <em class=\"strong\">3ds Max</em> SDK. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-376A\"></a>The AppData mechanism provides a way for plug-ins to attach arbitrary data to any\n               <em class=\"strong\">3ds Max</em> object in a scene, such as nodes, materials, modifiers, controllers, etc., that is\n               permanently stored with that object in the <em class=\"strong\">3ds Max</em> scene file. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3768\"></a>The following <em class=\"strong\">methods </em>are used to read and store AppData for a MAXWrapper object: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DD9\"></a><pre><em class=\"codeEmphasisStrong\">setAppData</em> &lt;MAXWrapper_object&gt; &lt;integer_ID&gt; &lt;string&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3766\"></a>Sets the AppData item of the given ID number on the given <em class=\"strong\">3ds Max</em> object to the <span class=\"code\"> <em class=\"strong\">&lt;string&gt;</em> </span>value. This creates a new item if needed or replaces the string contents if an item\n               of that ID already exists. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DD8\"></a><pre><em class=\"codeEmphasisStrong\">getAppData</em> &lt;MAXWrapper_object&gt; &lt;integer_ID&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3763\"></a>Returns the AppData item string of the given ID number from the given <em class=\"strong\">3ds Max</em> object. Returns the value <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the ID\'d item is not present. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DD7\"></a><pre><em class=\"codeEmphasisStrong\">deleteAppData</em> &lt;MAXWrapper_object&gt; &lt;integer_ID&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3760\"></a>Deletes the AppData item if the given ID number from the given <em class=\"strong\">3ds Max</em> object. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DD6\"></a><pre><em class=\"codeEmphasisStrong\">clearAllAppData</em> &lt;MAXWrapper_object&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-375D\"></a>Clears out all MAXScript-related AppData items from the given MAXWrapper object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-375B\"></a>You can add as many AppData strings as you like to an object—you assign them each\n               an integer identification number when they are first added and access them later using\n               those IDs. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-375A\"></a>AppData strings can be attached to any MAXWrapper subclass instance, including scene\n               nodes, modifiers, controllers, materials, atmospherics, etc. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AF5\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The AppData is stored in the scene—file <em class=\"strong\">only</em> if its object is in the scene—if, for example, you create a material in MAXScript\n                  and do not assign it to any object or the material editor, it will not be saved in\n                  the scene file nor will its AppData. \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3755\"></a>If you want to associate certain AppData strings with the scene as a whole, it is\n               recommended that you create a hidden dummy node with a unique name and attach the\n               scene AppData to that node. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3754\"></a>AppData in its full generality allows the C++ plug-in developer to store arbitrary\n               binary data with an object. This is not directly possible with MAXScript, so the approach\n               taken is to store and retrieve AppData text strings that can be built-up or parsed\n               into complex MAXScript objects using a <span class=\"char_link\"><a href=\"GUID-DB8A8E34-179F-4264-86E3-D0CD9AB836A6.htm\">StringStream Value</a></span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3752\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3751\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3750\"></a><p class=\"table-body\">To store some numbers in an array on a scene node, you might do the following: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DD5\"></a><pre>\nss = StringStream\"\"\nfor v in data_values do print v to:ss\nsetAppData $foo 1 ss\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-374A\"></a><p class=\"table-body\">and read them back after the scene has been saved and reloaded as follows: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DD4\"></a><pre>\nss = StringStream (getAppData $foo 1)\ndata_values = #()\nwhile not eof ss do\nappend data_values (readValue ss)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";