var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-55FF64C3-624B-4910-A552-9ED4DA266461\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Reactor controller\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Reactor controller</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-55FF64C3-624B-4910-A552-9ED4DA266461\"></a><div class=\"head\">\n            <h1>Reactor controller </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7225\"></a> The Reactor controller is a procedural controller that reacts to changes in any other\n            controller within the software. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7223\"></a>Reactor comes in five different forms: Position Reactor, Rotation Reactor, Point3\n            Reactor, Scale Reactor, and Float Reactor. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7222\"></a>Any animatable parameter in the software can react to changes in any other animatable\n            parameter. Reactor is not based on time, but is based on other variables in your scene.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7221\"></a></p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7220\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-721F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2C1A\"></a><pre>\n-- Setup a scene\nball = sphere name:\"ball\"pos:[-40,0,50] radius:10\nball.pos.controller = position_XYZ()\n-- create some keys\nkey = addNewKey ball.pos.Zposition.controller 0\nkey.outTangentType = #slow\nkey.value = 50\nkey = addNewKey ball.pos.Xposition.controller 0\nkey.value = -40\nkey = addNewKey ball.pos.Zposition.controller 25\nkey.InTangentType = #fast\nkey.outTangentType = #fast\nkey.value = 4\nkey = addNewKey ball.pos.Xposition.controller 25\nkey.value = -10\nkey = addNewKey ball.pos.Zposition.controller 50\nkey.InTangentType = #slow\nkey.value = 50\nkey = addNewKey ball.pos.Xposition.controller 50\nkey.value = 20\nball.showtrajectory = true\n-- assign a reactor controller to the scale of the ball\nreactorCtrl= Scale_Reactor()\nball.scale.controller = reactorCtrl\n-- Pick the react to object, and create reactions\nreactorCtrl.reactions.reactTo ball.pos.ZPosition.controller\nreactorCtrl.reactions.setName 1 \"UnSquashed\"\nreactorCtrl.reactions.setVectorState 1 [1,1,1]\nreactorCtrl.reactions.create name: \"Squashed\"\nreactorCtrl.reactions.setVectorState 2 [1.5,1.5,.4]\nreactorCtrl.reactions.setValueAsFloat 2 10\nreactorCtrl.reactions.setInfluence 1 6\nreactorCtrl.reactions.setInfluence 2 5.5\nreactorCtrl.reactions.setStrength 2 1.5\nreactorCtrl.reactions.setFalloff 1 1.75\nss = StringStream\"\"\nreactorCtrl.reactions.getType()\nct = reactorCtrl.reactions.getCount ()\nformat \"Reactor Statistics: \\n------------------------------\\n \\n\" to:ss\nformat \"Count : %\\n\" ct to:ss\nformat \"\\n\" to:ss\nfor i =1 to ct do\n(\nformat \"Reaction #: % \\n------------------------------------------------\nName : %\nState: %\nValue: %\nStrength: %\nInfluence : %\nFalloff: % \\n\\n\"(i)\\\n(reactorCtrl.reactions.getName i)\\\n(getReactionState reactorCtrl i)\\\n(getReactionValue reactorCtrl i)\\\n(reactorCtrl.reactions.getStrength i)\\\n(reactorCtrl.reactions.getInfluence i )\\\n(reactorCtrl.reactions.getFalloff i )to:ss\n)\nprint ss\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71D8\"></a><p class=\"table-body\"> <img src=\"../images/GUID-DB031BA7-2F52-44C2-8174-FEEC34517624-low.gif\"> <img src=\"../images/GUID-B0CC4779-3D34-4FE0-BDA9-1F4F35934DE1-low.gif\"> \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71D7\"></a><p class=\"table-body\"> <img src=\"../images/GUID-F811AF9A-50EB-448D-A8A6-2E49BB0EB9AF-low.gif\"> <img src=\"../images/GUID-BB8A30CF-E68C-44F7-A8B5-C77D26A493C0-low.gif\"> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71D5\"></a> <span class=\"char_link\"><a href=\"GUID-D259F92F-5E96-4167-A0D8-3569BBAAC0DC.htm\">Reactor Controllers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71D3\"></a> <span class=\"char_link\"><a href=\"GUID-9FC642E8-30D1-40DB-8AA5-D1B997AE653D.htm\">FloatReactor : FloatController</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71D2\"></a> <span class=\"char_link\"><a href=\"GUID-A8C9BD34-35D5-4F1F-8B90-CC677F25DA7F.htm\">Point3Reactor : Point3Controller</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71D1\"></a> <span class=\"char_link\"><a href=\"GUID-0CAA1D19-7984-4952-B6E8-755DE4788022.htm\">PositionReactor : PositionController</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71D0\"></a> <span class=\"char_link\"><a href=\"GUID-31641715-C556-40C6-9819-FF732C75525C.htm\">Rotation_Reactor : RotationController</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71CF\"></a> <span class=\"char_link\"><a href=\"GUID-2578F441-06B3-400E-90BC-14F54D8E25BC.htm\">Scale_Reactor : ScaleController</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71CD\"></a> <span class=\"char_link\"><a href=\"GUID-5A880FC4-1C01-4563-9368-D47DFCE9F777.htm\">Interface: reactionMgr</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71CB\"></a> <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controller Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71CA\"></a> <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-71C9\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";