var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-56961A11-BD8A-40E5-BB68-74AA27F2E056\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"dotNetObject\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>dotnetobject</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-56961A11-BD8A-40E5-BB68-74AA27F2E056\"></a><div class=\"head\">\n            <h1>dotnetobject </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-116F\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-116B\"></a>In <em class=\"strong\">3ds Max 9</em> and higher, the <span class=\"code\"> <em class=\"strong\">dotNetObject</em> </span> value class wraps instances of DotNet objects. It is the MAXScript wrapper class\n               around a DotNet <span class=\"code\"> <em class=\"strong\">System::Object</em> </span> object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-116A\"></a>The dotNetObject class exposes the properties, methods, and events associated with\n               the object via reflection. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1169\"></a>Property access uses MAXScript number data types (widened as necessary), String, Boolean,\n               dotNetControl, dotNetObject, and dotNetClass values. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1168\"></a>Properties of dotNetObject can be accessed via the normal property access specification\n               [object.property] and the <span class=\"code\"> <em class=\"strong\">getProperty()</em> </span>/<span class=\"code\"> <em class=\"strong\">setProperty()</em> </span> methods. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1167\"></a>Accessing an object method will create a <span class=\"char_link\"><a href=\"GUID-216D4AE4-3BFF-46C5-BCBE-53E2FDFC7DB1.htm\">dotNetMethod</a></span> instance. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1166\"></a>New methods are used to add and manage event handlers. These methods register and\n               unregister callback functions to be called when the event is fired. The arguments\n               passed back to the functions include the object, the event name, and the arguments\n               passed by the event handler. See <span class=\"char_link\"><a href=\"GUID-9BE82D70-1869-46D7-9501-E5453E25AC68.htm\">dotNet Struct Methods</a></span> for details. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7549\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1162\"></a>There is a difference between a <span class=\"char_link\"><a href=\"GUID-24FFB4C6-B37D-4F37-89FC-54AED58B44C2.htm\">dotNetClass</a></span> and a dotNetObject that wraps the same type. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11DB\"></a>Accessing the dotNetClass accesses the System::Type while accessing the dotNetObject\n                     accesses the object type described by the System::Type. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-11DA\"></a>So, for example, if you called showProperties() on a dotNetObject you will get the\n                     properties of the System::Type the dotNetObject wraps, but on a dotNetClass that wraps\n                     the same type you will get the properties of System::Type itself. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"GUID-90327923-2616-42E2-BED8-0A63A40AEDE8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-115E\"></a> <em class=\"strong\">Constructor:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67D0\"></a><pre><em class=\"codeEmphasisStrong\">dotNetObject</em> { &lt;dotNetClass&gt; | &lt;class_type_string&gt; } ... additional args as needed ... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-115C\"></a>Constructs a dotNetObject object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-115B\"></a>A dotNetObject can be created either using the class type string or from a dotNetClass:\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-115A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1159\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67CF\"></a><pre>\no1 = dotNetObject \"System.Drawing.Size\" 10 20 -- existing object\no2 = dotNetClass \"System.Drawing.Size\"\no3 = dotNetObject o2 10 20 -- newobject from class\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-BCC4FF19-9D3C-4A70-AF19-B21D851E05A1\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1152\"></a> <em class=\"strong\">Operators:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67CE\"></a><pre><em class=\"codeEmphasisStrong\">==</em> <em class=\"codeEmphasisStrong\">!=</em> </pre></div> \n            <p><a name=\"GUID-C836BBD7-C187-4F34-A55B-DECE4E69079A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-114F\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67CD\"></a><pre><em class=\"codeEmphasisStrong\">getProperty</em> &lt;dotNetObject&gt; &lt;prop name&gt; [  <em class=\"codeEmphasisStrong\">asDotNetObject</em>:&lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-114D\"></a>Returns the value of the specified property. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-114C\"></a>If <span class=\"code\"> <em class=\"strong\">asDotNetObject</em> </span> is false (the default) the value will converted to a native MAXScript value if possible;\n               if true, the value will always be returned as a dotNetControl or dotNetObject value.\n               \n            </p> \n            <p><a name=\"GUID-5ABB4432-E1A9-49CC-B952-BDF8159FE59E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67CC\"></a><pre><em class=\"codeEmphasisStrong\">setProperty</em> &lt;dotNetObject&gt; &lt;prop name&gt; &lt;value&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1149\"></a>Sets the value of the specified property. If the value specified is a native MAXScript\n               value, it will be converted to the proper DotNet value if possible. \n            </p> \n            <p><a name=\"GUID-6B977098-A542-46AA-BC00-ED38D1B68B27\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67CB\"></a><pre><em class=\"codeEmphasisStrong\">getPropNames</em> &lt;dotNetObject&gt; [<em class=\"codeEmphasisStrong\">showStaticOnly</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">declaredOnTypeOnly</em>:&lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1146\"></a>Returns an array of property names exposed by the object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1145\"></a>If <span class=\"code\"> <em class=\"strong\">showStaticOnly</em> </span> is true (the default), only static properties are shown; if false both static and\n               instance properties are shown. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1144\"></a>If <span class=\"code\"> <em class=\"strong\">declaredOnTypeOnly</em> </span> is true, only properties declared on the specified object are shown; if false (the\n               default) properties on the object and the classes it derives from are shown. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1143\"></a>The results of this method are sorted by name. The properties returned actually contain\n               two different things in terms of DotNet - properties and fields. The properties are\n               shown first in sorted order, then the fields are shown in sorted order. \n            </p> \n            <p><a name=\"GUID-6DC2B2D6-8188-4F80-9BB3-EB062F9D6836\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67CA\"></a><pre><em class=\"codeEmphasisStrong\">showProperties</em> &lt;dotNetObject&gt; [\"prop_pat\"] [<em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt;] [<em class=\"codeEmphasisStrong\">showStaticOnly</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">showMethods</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">showAttributes</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">declaredOnTypeOnly</em>:&lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1140\"></a>Displays the properties exposed by the object whose name matches the property pattern.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-113F\"></a>If <span class=\"code\"> <em class=\"strong\">to</em> </span> is not specified, the output goes to Listerner, otherwise the output goes to the\n               specified stream. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-113E\"></a>If <span class=\"code\"> <em class=\"strong\">showStaticOnly</em> </span> is true (the default), only static properties are shown; if false both static and\n               instance properties are shown. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-113D\"></a>If <span class=\"code\"> <em class=\"strong\">showMethods</em> </span> is true, the signature of the get and set methods (if any) are shown; defaults to\n               false. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-113C\"></a>If <span class=\"code\"> <em class=\"strong\">showAttributes</em> </span> is true, the attributes associated with the property are shown; defaults to false.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-113B\"></a>If <span class=\"code\"> <em class=\"strong\">declaredOnTypeOnly</em> </span> is true, only properties declared on the specified object are shown; if false (the\n               default) properties on the object and the classes it derives from are shown. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-113A\"></a>The results of this method are sorted by name. The properties returned actually contain\n               two different things in terms of DotNet- properties and fields. The properties are\n               shown first in sorted order, then the fields are shown in sorted order. \n            </p> \n            <p><a name=\"GUID-C2C7F114-6766-4CF5-BD91-C03FE3AAF575\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67C9\"></a><pre><em class=\"codeEmphasisStrong\">showMethods</em> &lt;dotNetObject&gt; [\"prop_pat\"] [<em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt;] [<em class=\"codeEmphasisStrong\">showStaticOnly</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">showSpecial</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">showAttributes</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">declaredOnTypeOnly</em>:&lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1137\"></a>Displays the methods exposed by the object whose name matches the property pattern.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1136\"></a>If <span class=\"code\"> <em class=\"strong\">to</em> </span> is not specified, the output goes to Listerner, otherwise the output goes to the\n               specified stream. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1135\"></a>If <span class=\"code\"> <em class=\"strong\">showStaticOnly</em> </span> is true (the default), only static properties are shown; if false both static and\n               instance properties are shown. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1134\"></a>If <span class=\"code\"> <em class=\"strong\">showSpecial</em> </span> is true, methods that are not normally called by the user (such as a method to set\n               a property value or to invoke an event handler) are shown; defaults to false. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1133\"></a>If <span class=\"code\"> <em class=\"strong\">showAttributes</em> </span> is true, the attributes associated with the property are shown; defaults to false.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1132\"></a>If <span class=\"code\"> <em class=\"strong\">declaredOnTypeOnly</em> </span> is true, only properties declared on the specified object are shown; if false (the\n               default) properties on the object and the classes it derives from are shown. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1131\"></a>The results are sorted by name. Secondary sort is performed based on the number of\n               parameters. \n            </p> \n            <p><a name=\"GUID-089A7BCB-279B-4E00-B370-DD147FAFDD58\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67C8\"></a><pre><em class=\"codeEmphasisStrong\">showEvents</em> &lt;dotNetObject&gt; [\"prop_pat\"] [<em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt;] [<em class=\"codeEmphasisStrong\">showStaticOnly</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">declaredOnTypeOnly</em>:&lt;bool&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-112E\"></a>Displays the events exposed by the object whose name matches the property pattern.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-112D\"></a>If <span class=\"code\"> <em class=\"strong\">to</em> </span> is not specified, the output goes to Listerner, otherwise the output goes to the\n               specified stream. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-112C\"></a>If <span class=\"code\"> <em class=\"strong\">showStaticOnly</em> </span> is true (the default), only static properties are shown; if false both static and\n               instance properties are shown. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-112B\"></a>If <span class=\"code\"> <em class=\"strong\">declaredOnTypeOnly</em> </span> is true, only properties declared on the specified object are shown; if false (the\n               default) properties on the object and the classes it derives from are shown. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-112A\"></a>The results are sorted by name. \n            </p> \n            <p><a name=\"GUID-33B6ACB1-1100-41D1-AF92-A919A0CCCD2F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67C7\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.showConstructors</em> &lt;dotNetClass&gt; [<em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1127\"></a>Displays the constructors exposed by the object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1126\"></a>If <span class=\"code\"> <em class=\"strong\">to</em> </span> is not specified, the output goes to Listerner, otherwise the output goes to the\n               specified stream. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1125\"></a>The results are sorted by name. Secondary sort is performed based on the number of\n               parameters. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1123\"></a> <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet In MAXScript</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1122\"></a> <span class=\"char_link\"><a href=\"GUID-9BE82D70-1869-46D7-9501-E5453E25AC68.htm\">dotNet Struct Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";