var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-57562F6A-A8A1-4A28-BAE1-0D4729411214\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Physical_Material : Material</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-57562F6A-A8A1-4A28-BAE1-0D4729411214\"></a><div class=\"head\">\n            <h1>Physical_Material : Material </h1>\n         </div>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">Physical_Material - superclass: material; super-superclass:MAXWrapper - 115:1 - classID: #(1030429932L, 3735928833L)</em></pre></div>\n         <p><a name=\"GUID-1B24CB4C-C0AC-4F49-9C5B-ADC090364FC4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p>Implements a General physical material that can be used both with the ART_Renderer\n            and all other rendering engines shipping with 3ds Max. Available in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-48ED2940-DE36-485E-8C21-CC529F3CC387\"></a> <em class=\"strong\"> Constructors:</em> \n         </p>\n         <div class=\"codeBlock\"><pre> <em class=\"codeEmphasisStrong\">Physical_Material...\nPhysicalMaterial...</em> </pre></div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"section\"><a name=\"SECTION_B3B2A9910C8F416F9648B2D5B6CF7C97\"></a> \n            <h2><a name=\"GUID-5DC8162E-9ADA-4935-A68B-0C7021EDC768\"></a>Properties:\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.material_mode</em>     Integer    default: 0   --  integer</pre></div> \n            <p> Possible values are: \n               		\n            </p> \n            <p> 0 - \n               		  <em class=\"strong\">Standard</em> (default) \n               		\n            </p> \n            <p> 1 - \n               		  <em class=\"strong\">Advanced</em> \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><em class=\"strong\"> Coating Parameters Rollout</em> \n            </p> \n            <p> Clear Coat Group Of Controls \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coating</em>     Float    default: 0.0   --  animatable; float; Coating_Weight</pre></div> \n            <p> Get/set the Weight of the Coating. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_color</em>     Color    default: (color 255 255 255)   --  animatable; fRGBA color; Coating_Color; Controller Scaling: ([1,1,1,1] : (color 255 255 255))</pre></div> \n            <p> Get/set the Color of the Coating. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_roughness</em>     Float    default: 0.0   --  animatable; float; Coating_Rougness</pre></div> \n            <p> Get/set the Roughness of the Coating. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_roughness_inv</em>     BooleanClass    default: false   --  boolean; Invert_Coating_Roughness</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">Invert Coating Roughness</em> checkbutton. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_ior</em>     Float    default: 1.52   --  animatable; float; Coating_IOR</pre></div> \n            <p> Get/set the Index Of Refraction of the Coating. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p>Affect Underlying Group Of Controls \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_affect_color</em>     Float    default: 0.5   --  animatable; float; Coating_Affect_Color</pre></div> \n            <p> Get/set the value controlling how much the Coating affects the Color of the underlying\n               materials by making the color darker and more saturated. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_affect_roughness</em>    Float    default: 0.5   --  animatable; float; Coating_Affect_Rougness</pre></div> \n            <p> Get/set the value controlling how much the Coating affects the Roughness of the underlying\n               materials. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><em class=\"strong\"> Basic Parameters Rollout</em> \n            </p> \n            <p> Basic Color Group Of Controls (Advanced Mode) \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.base_weight</em>     Float    default: 1.0   --  animatable; float</pre></div> \n            <p> Get/set the Weight of the Base Color. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.Base_Color</em>     Color    default: (color 127.5 127.5 127.5)   --  animatable; fRGBA color; Controller Scaling: ([1,1,1,1] : (color 255 255 255))</pre></div> \n            <p> Get/set the Base Color value. \n               		\n            </p> \n            <p> For non-metals, it can be considered the Diffuse color. \n               		\n            </p> \n            <p> For metals, it is the color of the metal itself. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.diff_roughness</em>     Float    default: 0.0   --  animatable; float; Diffuse_Roughness</pre></div> \n            <p> Get/set the Diffuse Roughness value (using the Oren/Nayar diffuse model). \n               		\n            </p> \n            <p> Not used for metals. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p> Reflections Group Of Controls (Advanced Mode) \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.Reflectivity</em>     Float    default: 1.0   --  animatable; float</pre></div> \n            <p> Get/set the Reflectivity value. \n               		\n            </p> \n            <p> Should be left at 1.0 for realistic results. \n               		\n            </p> \n            <p> It has no effect on metals which always reflect. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.refl_color</em>     Color    default: (color 255 255 255)   --  animatable; fRGBA color; Reflection_Color; Controller Scaling: ([1,1,1,1] : (color 255 255 255))</pre></div> \n            <p> Get/set the Reflection Color value. \n               		\n            </p> \n            <p> Should be left at white for realistic results. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.roughness</em>     Float    default: 0.0   --  animatable; float</pre></div> \n            <p> Get/set the Roughness value. \n               		\n            </p> \n            <p> The higher the roughness, the blurrier the material. \n               		\n            </p> \n            <p> Lower roughness produces a more mirror-like material. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.roughness_inv</em>    BooleanClass    default: false   --  boolean; Invert_Rougness</pre></div> \n            <p> Get/set the Invert Roughness checkbox. \n               		\n            </p> \n            <p> When checked, the \n               		  <span class=\"code\"><em class=\"strong\">.roughness</em></span> value will be inverted so that higher values produce less roughness, and vice-versa.\n               \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.metalness</em>     Float    default: 0.0   --  animatable; float</pre></div> \n            <p> Get/set the Metalness value. \n               		\n            </p> \n            <p> It mixes two shading modes. \n               		\n            </p> \n            <p> At 0, a non-metal diffuse model is used where the Base Color is taken as the diffuse\n               color, with reflections added on top, with sub-surface scattering and transparency.\n               \n               		\n            </p> \n            <p> At 1, a solely reflective metallic surface is rendered, reflecting the Base Color\n               for facing angles, and the Reflection color (typically white) at the edges. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_ior</em>    Float    default: 1.52   --  animatable; float; Index_of_Refraction</pre></div> \n            <p> Get/set the Index Of Refraction (IOR) value. \n               		\n            </p> \n            <p> It defines both how much rays bend when entering the medium, and also the angular\n               dependency of the reflectivity when set to Fresnel mode (the default). \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p> Transparency Group Of Controls \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.Transparency</em>     Float    default: 0.0   --  animatable; float</pre></div> \n            <p> Get/set the Transparency value. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_color</em>     Color    default: (color 255 255 255)   --  animatable; fRGBA color; Transparency_Color; Controller Scaling: ([1,1,1,1] : (color 255 255 255))</pre></div> \n            <p> Get/set the Transparency color. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_roughness_lock</em>     BooleanClass    default: true   --  boolean; Lock_Transparency_Roughness</pre></div> \n            <p> Get/set the state of the Transparency Roughness lock checkbutton. \n               		\n            </p> \n            <p> When checked (default), the Transparency Roughness will be locked to the Roughness\n               of Reflections. \n               		\n            </p> \n            <p> When unchecked, the Transparency Roughness can be set independently. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_roughness</em>    Float    default: 0.0   --  animatable; float; Transparency_Roughness</pre></div> \n            <p> Get/set the Transparency Roughness. \n               		\n            </p> \n            <p> Used only when the \n               		  <span class=\"code\"><em class=\"strong\">.trans_roughness_lock</em></span> property is set to False. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_roughness_inv</em>     BooleanClass    default: false   --  boolean; Invert_Transparency_Roughness</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">Invert Transparency Roughness</em> checkbox. \n               		\n            </p> \n            <p> Used only when the \n               		  <span class=\"code\"><em class=\"strong\">.trans_roughness_lock</em></span> property is set to False. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_depth</em>    Float    default: 0.0   --  animatable; float; Transparency_Depth</pre></div> \n            <p> Get/set the Transparency Depth value. \n               		\n            </p> \n            <p> When set to 0.0 (default), the Transparency is computed at the surface. \n               		\n            </p> \n            <p> When not 0.0, the Transparency Color is applied as an Absorption, and the Depth value\n               defines the depth at which the Absorption reaches the specified Transparency Color.\n               \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.thin_walled</em>     BooleanClass    default: false   --  Boolean</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">Thin-Walled</em> checkbox. \n               		\n            </p> \n            <p> When set to False (default), the object is considered solid, and contains volume\n               of material that supports transparency depth and sub-surface scattering. \n               		\n            </p> \n            <p> When set to True, the object is considered to be made of an infinitely thin transparent\n               shell (like a soap bubble), and there is no refraction, Transparency Depth is disabled,\n               and sub-surface scattering is replaced by Translucency. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p> Sub-Surface Scattering Group Of Controls \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.scattering</em>    Float    default: 0.0   --  animatable; float</pre></div> \n            <p> Get/set the weight of the Sub-Surface Scattering / Translucency. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.sss_color</em>    Color    default: (color 255 255 255)   --  animatable; fRGBA color; Controller Scaling: ([1,1,1,1] : (color 255 255 255))</pre></div> \n            <p> Get/set the color of the Sub-Surface Scattering / Translucency. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PhysicalMaterial&gt;<em class=\"codeEmphasisStrong\">.sss_scatter_color</em>     Color    default: (color 255 127.5 63.75)   --  animatable; fRGBA color; Controller Scaling: ([1,1,1,1] : (color 255 255 255))</pre></div> \n            <p> Defines the color of the interior of the medium where the light is scattered in.\n               \n               		\n            </p> \n            <p> Technically, it is the red, green and blue ratios of the \"mean free path\" of scattering.\n               \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.sss_depth</em>     Float    default: 10.0   --  animatable; float</pre></div> \n            <p> Get/set the amount of spread of light in the material (\"mean free path\" of the scattering).\n               \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.sss_scale</em>     Float    default: 1.0   --  animatable; float</pre></div> \n            <p> Get/set the scale of the depth. \n               		\n            </p> \n            <p> Used mainly for adjust the Depth via a bitmap with values in the range from 0.0 and\n               1.0. \n               		\n            </p> \n            <p> See also the \n               		  <em class=\"strong\">.sss_scale_map</em> property. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p> Emission Group Of Controls \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.emission</em>     Float    default: 0.0   --  animatable; float</pre></div> \n            <p> Get/set the amount of the Emission (Self-Illumination). \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.emit_color</em>   Color    default: (color 255 255 255)   --  animatable; fRGBA color; Emission_Color; Controller Scaling: ([1,1,1,1] : (color 255 255 255))</pre></div> \n            <p> Get/set the Emission Color (Self-Illumination Color). \n               		\n            </p> \n            <p> Also affected by the color temperature. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.emit_luminance</em>    Float    default: 1500.0   --  animatable; float; Luminance</pre></div> \n            <p> Get/set the luminance of the surface in cd/m2 (\"nits\"). \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.emit_kelvin</em>     Float    default: 6500.0   --  animatable; float; Kelvin_Degrees</pre></div> \n            <p> Get/set the Kelvin temperature of the Emission. \n               		\n            </p> \n            <p> Also affected by the Emission Color. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.EffectiveLuminance</em>     Color    default: (color 801.106 801.106 801.106)   --  color by value;</pre></div> \n            <p> Not exposed to the UI. \n               		\n            </p> \n            <p> Read-Only. \n               		\n            </p> \n            <p> Returns the effective illuminance, taking into account all Emission properties. \n               		\n            </p> \n            <p> Exposed by the Helpers MininInterface. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><em class=\"strong\"> Advanced Reflectance Parameters Rollout (Advanced Mode)</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.brdf_mode</em>     BooleanClass    default: true   --  boolean</pre></div> \n            <p> Get/set the state of the radio buttons controlling the BRDF Reflectance mode. \n               		\n            </p> \n            <p> Possible values are: \n               		\n            </p> \n            <p> True - \n               		  <em class=\"strong\">By IOR</em> (default) - uses the Fresnel effect based on the IOR value (most physically plausible\n               mode) \n               		\n            </p> \n            <p> False - \n               		  <em class=\"strong\">Custom Curve</em> \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.brdf_low</em>   Float    default: 0.05   --  animatable; float</pre></div> \n            <p> Get/set the value of the \n               		  <em class=\"strong\">\"Facing\"</em> spinner. \n               		\n            </p> \n            <p> Controls the low value of the curve. \n               		\n            </p> \n            <p> Used only when in Custom Curve mode. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.brdf_high</em>     Float    default: 1.0   --  animatable; float</pre></div> \n            <p> Get/set the value of the \n               		  <em class=\"strong\">\"Edge\"</em> spinner. \n               		\n            </p> \n            <p> Controls the high value of the curve. \n               		\n            </p> \n            <p> Used only when in Custom Curve mode. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.brdf_curve</em>    Float    default: 5.0   --  animatable; float; Brdf_Exponent</pre></div> \n            <p> Get/set the value of the \n               		  <em class=\"strong\">\"Slope\"</em> spinner. \n               		\n            </p> \n            <p> Controls the Exponent of the curve. \n               		\n            </p> \n            <p> Used only when in Custom Curve mode. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p> <em class=\"strong\">Anisotropy Rollout</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.anisotropy</em>   Float    default: 1.0   --  animatable; float</pre></div> \n            <p> Get/set the value of the \n               		  <em class=\"strong\">\"Anisotropy\"</em> spinner. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.anisoangle</em>     Float    default: 0.0   --  animatable; float; Anisotropy_Angle</pre></div> \n            <p> Get/set the value of the \n               		  <em class=\"strong\">\"Rotation\"</em> spinner. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.aniso_mode</em>     Integer    default: 0   --  integer; Anisotropy_Mode</pre></div> \n            <p> Get/set the state of the Anisotropy Mode radio buttons. \n               		\n            </p> \n            <p> Possible vaues are: \n               		\n            </p> \n            <p> 0 - \n               		  <em class=\"strong\">Auto</em> (default) \n               		\n            </p> \n            <p> 1 - \n               		  <em class=\"strong\">Map Channel</em> \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.aniso_channel</em>     Integer    default: 0   --  integer; Anisotropy_Channel</pre></div> \n            <p> Get/set the value of the \n               		  <em class=\"strong\">\"Map Channel\"</em> spinner. \n               		\n            </p> \n            <p>Used only when the \n               		  <em class=\"strong\">.aniso_mode</em> is set to 1. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><em class=\"strong\"> Special Maps Rollout</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.bump_map_on</em>     BooleanClass    default: true   --  boolean</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Bump Map\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.bump_map_amt</em>     Float    default: 0.3   --  animatable; float; Bump_Map_Amount</pre></div> \n            <p> Get/set the value of the \n               		  <em class=\"strong\">\"Bump Map\"</em> spinner. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.bump_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Bump Map\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_bump_map_on</em>     BooleanClass    default: true   --  boolean; Coating_Bump_Map_On</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Coating Bump Map\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.clearcoat_bump_map_amt</em>     Float    default: 0.3   --  animatable; float; Coating_Bump_Map_Amount</pre></div> \n            <p> Get/set the value of the \n               		  <em class=\"strong\">\"Coating Bump Map\"</em> spinner. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_bump_map</em>     UndefinedClass    default: undefined   --  texturemap; Coating_Bump_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Coating Bump Map\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.displacement_map_on</em>     BooleanClass    default: true   --  boolean; Displacement_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Displacement\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.displacement_map_amt</em>     Float    default: 1.0   --  animatable; float; Displacement_Map_Amount</pre></div> \n            <p> Get/set the value of the \n               		  <em class=\"strong\">\"Displacement\"</em> spinner. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.displacement_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Displacement\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.cutout_map_on</em>     BooleanClass    default: true   --  boolean; Cutout_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Cutout\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.cutout_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Cutout\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><em class=\"strong\"> Generic Maps Rollout</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.base_weight_map_on</em>     BooleanClass    default: true   --  boolean; Base_Weight_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Base Weight\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.base_weight_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM0</em>     UndefinedClass    default: undefined   --  texturemap; Base_Weight_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Base Weight\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.base_color_map_on</em>     BooleanClass    default: true   --  boolean; Base_Color_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Base Color\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.base_color_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM1</em>     UndefinedClass    default: undefined   --  texturemap; Base_Color_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Base Color\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.reflectivity_map_on</em>     BooleanClass    default: true   --  boolean; Reflectivity_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Reflection Weight\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.reflectivity_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM2</em>     UndefinedClass    default: undefined   --  texturemap; Reflectivity_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Reflection Weight\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.refl_color_map_on</em>     BooleanClass    default: true   --  boolean; Refl_Color_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Reflection Color\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.refl_color_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM3</em>     UndefinedClass    default: undefined   --  texturemap; Refl_Color_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Reflection Color\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.roughness_map_on</em>     BooleanClass    default: true   --  boolean; Roughness_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Roughness\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.roughness_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM4</em>     UndefinedClass    default: undefined   --  texturemap; Roughness_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Roughness\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.metalness_map_on</em>     BooleanClass    default: true   --  boolean; Metalness_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Metalness\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.metalness_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM5 </em>    UndefinedClass    default: undefined   --  texturemap; Metalness_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Metalness\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.diff_rough_map_on</em>     BooleanClass    default: true   --  boolean; Diffuse_Roughness_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Diffuse Roughness\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.diff_rough_map</em>     UndefinedClass    default: undefined   --  texturemap; Diffuse_Roughness_Map</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM6</em>     UndefinedClass    default: undefined   --  texturemap; Diffuse_Roughness_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Diffuse Roughness\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.anisotropy_map_on</em>     BooleanClass    default: true   --  boolean; Anisotropy_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Anisotropy\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.anisotropy_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM7</em>     UndefinedClass    default: undefined   --  texturemap; Anisotropy_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Anisotropy\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.aniso_angle_map_on</em>     BooleanClass    default: true   --  boolean; Anisotropy_Angle_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Anisotropy Angle\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.aniso_angle_map </em>    UndefinedClass    default: undefined   --  texturemap; Anisotropy_Angle_Map</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM8</em>     UndefinedClass    default: undefined   --  texturemap; Anisotropy_Angle_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Anisotropy Angle\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.transparency_map_on</em>     BooleanClass    default: true   --  boolean; Transparency_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Transparency Weight\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.transparency_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM9</em>     UndefinedClass    default: undefined   --  texturemap; Transparency_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Transparency Weight\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_color_map_on</em>     BooleanClass    default: true   --  boolean; Transparency_Color_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Transparency Color\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_color_map</em>     UndefinedClass    default: undefined   --  texturemap; Transparency_Color_Map</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM10</em>     UndefinedClass    default: undefined   --  texturemap; Transparency_Color_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Transparency Color\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_rough_map_on</em>     BooleanClass    default: true   --  boolean; Transparency_Rougness_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Transparency Roughness\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_rough_map</em>    UndefinedClass    default: undefined   --  texturemap; Transparency_Rougness_Map</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM11</em>     UndefinedClass    default: undefined   --  texturemap; Transparency_Rougness_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Transparency Roughness\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_ior_map_on</em>     BooleanClass    default: true   --  boolean; IOR_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"IOR\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.trans_ior_map</em>     UndefinedClass    default: undefined   --  texturemap; IOR_Map</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM12</em>     UndefinedClass    default: undefined   --  texturemap; IOR_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"IOR\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.scattering_map_on</em>     BooleanClass    default: true   --  boolean; Scattering_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Scattering Weight\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.scattering_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM13</em>    UndefinedClass    default: undefined   --  texturemap; Scattering_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Scattering Weight\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.sss_color_map_on</em>    BooleanClass    default: true   --  boolean; SSS_Color_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Scattering Color\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.sss_color_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM14</em>     UndefinedClass    default: undefined   --  texturemap; SSS_Color_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Scattering Color\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.sss_scale_map_on</em>     BooleanClass    default: true   --  boolean; SSS_Scale_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Scattering Scale\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.sss_scale_map</em>    UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM15</em>     UndefinedClass    default: undefined   --  texturemap; SSS_Scale_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Scattering Scale\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.emission_map_on</em>     BooleanClass    default: true   --  boolean; Emission_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Emission Weight\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.emission_map</em>     UndefinedClass    default: undefined   --  texturemap</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM16</em>     UndefinedClass    default: undefined   --  texturemap; Emission_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Emission Weight\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.emit_color_map_on</em>     BooleanClass    default: true   --  boolean; Emission_Color_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Emission Color\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.emit_color_map</em>     UndefinedClass    default: undefined   --  texturemap; Emission_Color_Map</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM17</em>     UndefinedClass    default: undefined   --  texturemap; Emission_Color_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Emission Color\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_map_on</em>     BooleanClass    default: true   --  boolean; Coating_Weight_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Coating Weight\"</em> checkbox. \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_map</em>     UndefinedClass    default: undefined   --  texturemap; Coating_Weight_Map</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM18</em>     UndefinedClass    default: undefined   --  texturemap; Coating_Weight_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Coating Weight\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_color_map_on</em>     BooleanClass    default: true   --  boolean; Coating_Color_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Coating Color\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_color_map</em>     UndefinedClass    default: undefined   --  texturemap; Coating_Color_Map</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM19</em>     UndefinedClass    default: undefined   --  texturemap; Coating_Color_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Coating Color\"</em> map button. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_rough_map_on</em>     BooleanClass    default: true   --  boolean; Coating_Roughness_Map_Enabled</pre></div> \n            <p> Get/set the state of the \n               		  <em class=\"strong\">\"Coating Roughness\"</em> checkbox. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.coat_rough_map</em>     UndefinedClass    default: undefined   --  texturemap; Coating_Roughness_Map</pre></div> \n            <div class=\"codeBlock\"><pre>&lt;Physical_Material&gt;<em class=\"codeEmphasisStrong\">.mapM20</em>    UndefinedClass    default: undefined   --  texturemap; Coating_Roughness_Map</pre></div> \n            <p> Get/set the texture map of the \n               		  <em class=\"strong\">\"Coating Roughness\"</em> map button. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_573C09D8BBCF4CA082543D12BEA793B5\"></a> \n            <h2><a name=\"GUID-11FBABA0-68BC-4E4F-A60B-60A65624B779\"></a>Physical_Material interfaces:\n            </h2> \n            <div class=\"codeBlock\"><pre>Interface: IMtlRender_Compability_MtlBase</pre></div> \n            <p> <em class=\"strong\">Properties:</em> \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p> <em class=\"strong\">Methods:</em> \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p> <em class=\"strong\"> Actions:</em> \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>Interface: Helpers</pre></div> \n         </div>\n         <p> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">.EffectiveLuminance</em> : color by value : Read</pre></div>\n         <p> See description earlier on this page in the \"Emission Group Of Controls\" section.\n            \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p> <em class=\"strong\">Methods:</em> \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p> <em class=\"strong\"> Actions:</em> \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";