var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-584BA3B0-ADBC-45A7-9BF4-ACE81930B2A0\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"RCMenu\">\n      <meta name=\"indexterm\" content=\"Clauses\">\n      <meta name=\"indexterm\" content=\"right-click menu: scripted\">\n      <meta name=\"indexterm\" content=\"on\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>RCMenu Clauses</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-584BA3B0-ADBC-45A7-9BF4-ACE81930B2A0\"></a><div class=\"head\">\n            <h1>RCMenu Clauses </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5982\"></a>The <span class=\"code\"> &lt;rcmenu_body&gt; </span> of a right-click menu definition is made up of a sequence of scripted right-click\n            menu clauses as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72A6\"></a><pre>&lt;rcmenu_body&gt; ::= { &lt;rcmenu_clause&gt; }+</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5980\"></a>Scripted right-click menu clauses define the components of a scripted right-click\n            menu and can be one of three basic things: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-597F\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-597D\"></a> <em class=\"strong\">Local variables, functions or structure definitions</em> are variables, functions, and structures whose scope is the scripted right-click\n                  menu. These locals will exist as long as the scripted right-click menu value exists.\n                  The scripted right-click menu value will exist until the scripted right-click menu\n                  value is redefined or deleted. Local variables are particularly useful for storing\n                  working data associated with the right-click menu such as picked objects. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-597B\"></a> <em class=\"strong\">User-interface items </em>are displayed in the right-click menu, such as menu items, separators, and submenus.\n                  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5979\"></a> <em class=\"strong\">Event handlers </em>are special kinds of functions that are associated with particular user-interface\n                  items. Event handlers specify the processing you want to occur when a user interacts\n                  with an user-interface item, for example pressing a menu item or opening a submenu.\n                  These user actions generate named <em class=\"strong\">events</em> and the optional event handler you supply for that event is called when the user\n                  action occurs. \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5978\"></a>The visibility of locals, and accessing scripted right-click menu locals from external\n            code, are the same as described for utility rollouts, and described in <span class=\"char_link\"><a href=\"GUID-608825CD-D025-4054-91E2-2562A6AB31CF.htm\">Visibility of Locals, Functions, Structures, and User-Interface Items in Rollout Code</a></span> and <span class=\"char_link\"><a href=\"GUID-D7B7488F-BE23-4A1E-BA83-A48C21F6C73B.htm\">Accessing Locals and Other Items in a Rollout from External Code</a></span>. In both utility rollouts and scripted right-click menus, the name given to a user-interface\n            item is used to name an automatically constructed local variable that will hold the\n            value representing the item. It is also used to associate event handler functions\n            with the item. One difference between the scooping of these variables is that they\n            are local to the rollout in utility rollouts, and local to the scripted right-click\n            menu in scripted right-click menus. This means that all user-interface items in a\n            scripted right-click menu must have a unique name within the scripted right-click\n            menu, even for those items present in a <span class=\"code\"> <em class=\"strong\">subMenu</em> </span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5977\"></a>Formally, the syntax of a <span class=\"code\"> <em class=\"strong\">&lt;rcmenu_clause&gt;</em> </span> is defined as follows: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72A5\"></a><pre>&lt;rcmenu_clause&gt; ::= &lt;local_variable_decl&gt; | &lt;local_function_decl&gt; | &lt;local_struct_decl&gt; | &lt;user_interface_item&gt; | &lt;event_handler&gt;</pre></div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5975\"></a> \n            <h2><a name=\"GUID-32FAAD53-4C75-4363-9451-73504C9168F9\"></a> <em class=\"strong\">Locals</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5974\"></a>A <span class=\"code\"> <em class=\"strong\">&lt;local_variable_decl&gt;</em> </span>, <span class=\"code\"> <em class=\"strong\">&lt;local_function_decl&gt;</em> </span>, and <span class=\"code\"> <em class=\"strong\">&lt;local_struct_decl&gt;</em> </span> are exactly the same as local variable, function, and structure definitions in MAXScript:\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72A4\"></a><pre>&lt;local_variable_decl&gt; ::= <em class=\"codeEmphasisStrong\">local</em> &lt;decl&gt; { , &lt;decl&gt; } \n&lt;decl&gt; ::= &lt;name&gt; [ = &lt;expr&gt; ] -- optional initial value</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72A3\"></a><pre>&lt;local_function_decl&gt; ::= [ <em class=\"codeEmphasisStrong\">mapped</em> ](<em class=\"codeEmphasisStrong\">function</em> | <em class=\"codeEmphasisStrong\">fn</em>) &lt;name&gt; { &lt;argument&gt; }<em class=\"codeEmphasisStrong\"> =</em> &lt;expr&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72A2\"></a><pre>&lt;local_struct_decl&gt; ::= <em class=\"codeEmphasisStrong\">struct</em> &lt;name&gt; <em class=\"codeEmphasisStrong\">(</em> &lt;member&gt; { , &lt;member&gt; }<em class=\"codeEmphasisStrong\">)</em>&lt;member&gt; ::= ( &lt;name&gt; [<em class=\"codeEmphasisStrong\"> = </em>&lt;expr&gt; ] | &lt;local_function_decl&gt; )</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-596D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-596C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES OF THE ABOVE (IN ORDER) ARE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72A1\"></a><pre>\nlocal numSelected\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-72A0\"></a><pre>\nlocal numSelected = 0\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-729F\"></a><pre>\nfn onlyOneSelected = selection.count == 1\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-729E\"></a><pre>\nstruct parents (mother=\"\",father=\"\")\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-595E\"></a>Global variables cannot be declared as a scripted right-click menu clause, however\n               they can be declared within event-handler scripts. If you need to ensure that a variable\n               name references a global variable, declare the variable name as global immediately\n               before defining the right-click menu in your script. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-595D\"></a>When writing scripts, it is good programming practice to explicitly declare your local\n               and global variables. Implicit declaration is provided as a short-hand, typically\n               used when working in the Listener interactively or developing short scripts. When\n               developing extended scripts, explicitly declaring variables can reduce errors and\n               improve readability of the code. It is also recommend that you declare as local all\n               variables unless you really want them to be global variables. The reasons for this\n               are described in <span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope of Variables</a></span>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-595C\"></a> \n            <h2><a name=\"GUID-BEA8E496-FD91-4C86-9F0A-22DAF5F6D761\"></a> <em class=\"strong\">User-Interface Items</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-595B\"></a>A <span class=\"code\"> <em class=\"strong\">&lt;user_interface_item&gt;</em> </span> defines an individual menu item, separator, or submenu user-interface item that will\n               appear in the right-click menu. These user-interface items are described in <span class=\"char_link\"><a href=\"GUID-882F8399-5E54-4F53-8676-0F533E23A472.htm\">RCMenu User-Interface Items</a></span>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-595A\"></a> \n            <h2><a name=\"GUID-5BD2F300-FD3E-495E-8EA6-6B6F38758653\"></a> <em class=\"strong\">Event Handlers</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5959\"></a>An <span class=\"code\"> <em class=\"strong\">&lt;event_handler&gt;</em> </span> is a special function definition local to a scripted right-click menu that you provide\n               to handle the processing you want to occur when a user clicks on a menu item. This\n               user action generates a named event and any event handler you supply for that event\n               is called when the action occurs. The syntax for defining a handler is as follows: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-729D\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;item_name&gt; &lt;event_name&gt; <em class=\"codeEmphasisStrong\">do </em>&lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5957\"></a>The <span class=\"code\"> <em class=\"strong\">&lt;item_name&gt;</em> </span> specifies the name of the item for which this handler is connected. The <span class=\"code\"> <em class=\"strong\">&lt;event_name&gt;</em> </span> specifies the type of event to be handled. \n            </p> \n            <p><a name=\"GUID-E059366D-D2FE-43AD-9F7E-FABFBDF23599\"></a>There is only one type of user-interface item event: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-729C\"></a><pre><em class=\"codeEmphasisStrong\">picked</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5955\"></a>The <span class=\"code\"> <em class=\"strong\">picked</em> </span> handler expression is executed when a menu item is picked from the right-click menu.\n               Any MAXScript action like creating a object, adding a modifier, and so on can be performed\n               in this expression. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5954\"></a>In addition to the event handlers you specify for particular menu items in a right-click\n               menu, you can define a handler function that is called when the entire right-click\n               menu is first opened by the user. This event handler is useful for initialization\n               code. The syntax for this event handler is as follows: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-729B\"></a><pre><em class=\"codeEmphasisStrong\">on</em> &lt;rcmenu&gt; <em class=\"codeEmphasisStrong\">open do</em> &lt;expr&gt;</pre></div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5951\"></a> <span class=\"char_link\"><a href=\"GUID-17DBC9E3-5B61-4738-B78B-D3D57A515CE8.htm\">Scripted Right-Click Menus</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5950\"></a> <span class=\"char_link\"><a href=\"GUID-882F8399-5E54-4F53-8676-0F533E23A472.htm\">RCMenu User-Interface Items</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";