var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-593123B8-0F17-4944-861E-57C9458BF61E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSCVCurve - NURBSCurve\">\n      <meta name=\"indexterm\" content=\"NURBSCurve - NURBSObject\">\n      <meta name=\"indexterm\" content=\"setKnot()\">\n      <meta name=\"indexterm\" content=\"setCV()\">\n      <meta name=\"indexterm\" content=\"reparameterize()\">\n      <meta name=\"indexterm\" content=\"refine()\">\n      <meta name=\"indexterm\" content=\"getKnot()\">\n      <meta name=\"indexterm\" content=\"getCV()\">\n      <meta name=\"indexterm\" content=\"close()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSCVCurve : NURBSCurve</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-593123B8-0F17-4944-861E-57C9458BF61E\"></a><div class=\"head\">\n            <h1>NURBSCVCurve : NURBSCurve </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4597\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4596\"></a>  This class defines an independent NURBS CV Curve. The position and weight of the control\n               vertices (CVs) controls the shape of the curve. Unlike spline vertices, CVs don’a\n               t necessarily lie on the curve they define. The CVs define a control lattice which\n               surrounds the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4593\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21FE\"></a><pre><em class=\"codeEmphasisStrong\">NURBSCVCurve</em> [&lt;property&gt;:&lt;val&gt;] [closed:&lt;boolean&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4591\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               If <span class=\"code\"> <em class=\"strong\">closed:true</em> </span> is specified, the curve is created as a closed curve, otherwise it is an open curve.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21FD\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-458D\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21FC\"></a><pre>&lt;nurbscvcurve&gt;.<em class=\"codeEmphasisStrong\">order</em>: integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-458B\"></a>The order of the curve. This is one more than the degree of polynomial of any segment\n               of the curve. All curves have a degree. The degree of a curve is the highest exponent\n               in the equation used to represent it. A linear equation is degree 1, a quadratic equation\n               degree 2. NURBS curves typically are represented by cubic equations and have a degree\n               of 3. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21FB\"></a><pre>&lt;nurbscvcurve&gt;.<em class=\"codeEmphasisStrong\">numKnots</em>: integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4588\"></a>The number of knots in the curve. If this value is changed, the previous knot data\n               is NOT maintained. Because they are generated mathematically, NURBS curves have a\n               parameter space in addition to the 3D geometric space in which they are displayed.\n               Specifically, an array of values called knots specifies the extent of influence of\n               each control vertex (CV) on the curve or surface. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21FA\"></a><pre>&lt;nurbscvcurve&gt;.<em class=\"codeEmphasisStrong\">numCVs</em>: integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4585\"></a>The number of control vertices in the curve. If this value is changed, the previous\n               control vertex data is NOT maintained. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21F9\"></a><pre>&lt;nurbscvcurve&gt;.<em class=\"codeEmphasisStrong\">transform</em>: matrix3 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4582\"></a>The transformation matrix for the NURBSCVCurve. This controls the relative position\n               of the item within a NURBSSet. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21F8\"></a><pre>&lt;nurbscvcurve&gt;.<em class=\"codeEmphasisStrong\">endsOverlap</em>: boolean, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-457F\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if the ends of the curve overlap even though the curve may not be closed (that is,\n               the tangents match at the ends), <span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21F7\"></a><pre>&lt;nurbscvcurve&gt;.<em class=\"codeEmphasisStrong\">autoParam</em>:#notAutomatic, #autoCentripetal, #autoUniform </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-457C\"></a> <span class=\"code\"> <em class=\"strong\">#notAutomatic</em> </span>, <span class=\"code\"> <em class=\"strong\">#autoCentripetal</em> </span>, and <span class=\"code\"> <em class=\"strong\">#autoUniform</em> </span> correspond to the Automatic Reparam options in the CV Curve rollouts: none, chord\n               length and uniform, respectively. Defaults to <span class=\"code\"> <em class=\"strong\">#notAutomatic</em> </span>. \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-543B\"></a>        <em class=\"strong\">Methods</em> \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21F6\"></a><pre><em class=\"codeEmphasisStrong\">close</em> &lt;nurbscvcurve&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4572\"></a>Forces the curve to be closed. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21F5\"></a><pre><em class=\"codeEmphasisStrong\">getKnot</em> &lt;nurbscvcurve&gt; &lt;index&gt; <em class=\"codeEmphasisStrong\">setKnot</em> &lt;nurbscvcurve&gt; &lt;index&gt; &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-456E\"></a>Get and set the indexed knot’s value, indexes are 1-based. Knots are a mathematical\n               construct that helps define the span of control of CVs and blending functions that\n               define NURBS Curves and Surfaces. The knots are an array of values that determines\n               the parameterization of a curve. Values in the knot vector are nondecreasing. The\n               knots specify the region of influence of the CVs on the curve. It is a way of partitioning\n               the parameter space up into different segments. A B-spline curve or a NURBS curve\n               is a curve that is defined by a series of segments. On each one of the segments the\n               curve is like a polynomial, or in the case of a rational one, it\'s like the ratio\n               of polynomials. The knot vector describes how to partition the parameter space of\n               the curve up for each of the different pieces of the polynomial. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21F4\"></a><pre><em class=\"codeEmphasisStrong\">getCV</em> &lt;nurbscvcurve&gt; &lt;cv_index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-456B\"></a>Get the indexed CV as a NURBSControlVertex, indexes are 1-based. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21F3\"></a><pre><em class=\"codeEmphasisStrong\">setCV</em> &lt;nurbscvcurve&gt; &lt;cv_index&gt; &lt;NURBSControlVertex&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4568\"></a>Sets the indexed CV to the given NURBSControlVertex, indexes are 1-based. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21F2\"></a><pre><em class=\"codeEmphasisStrong\">refine</em> &lt;nurbscvcurve&gt; &lt;u_param&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4565\"></a>Add a new, interpolated CV at the given parametric point along the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21F1\"></a><pre><em class=\"codeEmphasisStrong\">reparameterize</em> &lt;nurbscvcurve&gt; (<em class=\"codeEmphasisStrong\">#centripetal | #uniform</em>) </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4562\"></a>Reparameterizes the curve by chord length (<span class=\"code\"> <em class=\"strong\">#centripetal</em> </span>) or uniform (<span class=\"code\"> <em class=\"strong\">#uniform</em> </span>) uniform parameterization. \n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F53\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p>CV curves and surfaces must obey the relationship that \"order + number of CVs = number\n                     of knots\". If this is not the case in most cases no object will be created and in\n                     some cases an assertion fault might be generated. \n                  </p> \n               </div>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-455C\"></a> <span class=\"char_link\"><a href=\"GUID-8CEABA20-9D21-4ED0-AA95-3749435D2104.htm\">NURBSCurve</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-455B\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-455A\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";