var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"IObject AssetUser\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>IObject:AssetUser</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A\"></a><div class=\"head\">\n            <h1>IObject:AssetUser </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FC5\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FC4\"></a> An instance of this class contains information on the asset filename, its type, and\n               the \n               		  <em class=\"strong\">3ds Max</em> scene file that depends on it (this is used for resolving external references). Access\n               to, and life time management of assets is handled by the \n               		  <span class=\"char_link\"><a href=\"GUID-E3237B13-8069-4177-8544-9000A98B1C15.htm\">Asset Manager</a></span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FC1\"></a>In releases prior to \n               		  <em class=\"strong\">3ds Max 2010</em>, a plug-in that referenced an external file (an asset) would hold the asset’s filename\n               as a string or as a Path object, and would store the filename to the \n               		  <em class=\"strong\">3ds Max</em> scene file as a string or an IParameterBlock2 TYPE_FILENAME parameter. To allow \n               		  <em class=\"strong\">3ds Max</em> to identify the assets used by a plug-in, the plug-in would implement an IAssetAccessor-derived\n               class. The information provided from this class was primarily used by the Asset Tracker.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FC0\"></a>Loading and saving the Asset to the \n               		  <em class=\"strong\">3ds Max</em> scene file is now done through the AssetUser and the AssetManager. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FBF\"></a> <em class=\"strong\">Constructors:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FBE\"></a>Instances of the AssetUser class are returned by methods exposed by the \n               		  <span class=\"char_link\"><a href=\"GUID-E3237B13-8069-4177-8544-9000A98B1C15.htm\">AssetManager</a></span> interface: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FBD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69E0\"></a><pre>\nAUIO = AssetManager.GetAssetByIndex1\n--&gt; &lt;IObject:AssetUser&gt;\nAUIO2= AssetManager.GetAsset \"Simple_Stone_Mtl_Marble_bump.jpg\" #bitmap\n--&gt; &lt;IObject:AssetUser&gt;\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FB4\"></a>MAXScript Filename strings can be automatically coerced to AssetUser instances: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1FB3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69DF\"></a><pre>\n--Create a new bitmap texture map with a valid file name:\nbmt = bitmaptexture filename:\"Simple_Stone_Mtl_Marble_bump.jpg\"\n--&gt; Bitmaptexture:Bitmap\nbmt.filename --get the bitmap\'s file name\n--&gt; \"Simple_Stone_Mtl_Marble_bump.jpg\"\nAUIO3 = bmt.filename as AssetUser --get the file name as AssetUser IObject\n--&gt; &lt;IObject:AssetUser&gt;\nAUIO3.getFileName()\n--&gt;\"Simple_Stone_Mtl_Marble_bump.jpg\"\nAUIO3.getType()\n--&gt; #Bitmap\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-53B1C7FC-03BA-49A2-9BEA-DEA50141E93B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-52AF\"></a> <em class=\"strong\">&lt;IObject:AssetUser&gt; Interfaces</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69DE\"></a><pre>Interface: <em class=\"codeEmphasisStrong\">AssetUser</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F9E\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69DD\"></a><pre>&lt;TSTR by value&gt;&lt;AssetUser&gt;.<em class=\"codeEmphasisStrong\">GetAssetId</em>()   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F9C\"></a>Returns the AssetID of the Asset. \n               		\n            </p> \n            <p><a name=\"GUID-AA2DA1C5-B8C6-45F5-90BF-DC6CDBC4E094\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69DC\"></a><pre>&lt;enum&gt;&lt;AssetUser&gt;.<em class=\"codeEmphasisStrong\">GetType</em>() \n\nGetType enums: {<em class=\"codeEmphasisStrong\">#Other|#Bitmap|#XRef|#Photometric|#Animation|#VideoPost|#BatchRender|#ExternalLink|#RenderOutput|#PreRenderScript|#PostRenderScript|#Sound|#Container</em>} </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F98\"></a>Returns the Type of the Asset. \n               		\n            </p> \n            <p><a name=\"GUID-E46F8B02-EE49-42FB-930A-FE268216EB64\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69DA\"></a><pre>&lt;TSTR by value&gt;&lt;AssetUser&gt;.<em class=\"codeEmphasisStrong\">GetFileName</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F95\"></a>Returns the File Name of the Asset. \n               		\n            </p> \n            <p><a name=\"GUID-E4163007-286D-4A0A-B17F-D900E807C672\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69D9\"></a><pre>&lt;bool&gt;&lt;AssetUser&gt;.<em class=\"codeEmphasisStrong\">CanGetFullFilePath</em> &lt;&amp;TSTR&gt;fileName \n\nfileName is Out parameter 		</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F91\"></a>Returns true if the full file path can be acquired using the .GetFullFilePath() method.\n               \n               		\n            </p> \n            <p><a name=\"GUID-5729DC91-EA42-4EC0-ACED-8C3C01570A45\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69D8\"></a><pre>&lt;TSTR by value&gt;&lt;AssetUser&gt;.<em class=\"codeEmphasisStrong\">GetFullFilePath</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F8E\"></a>Returns the full file path of the Asset. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;&lt;AssetUser&gt;.<em class=\"codeEmphasisStrong\">Reset</em>() </pre></div> \n            <p> Removes the underlying reference to the asset, allowing it to be garbage-collected\n               if it is no longer referenced by anything else. It is recommended to call this method\n               on an AssetUser when you are done with it. Available in \n               		  <em class=\"strong\">3ds Max 2018 and higher</em>. \n               		\n            </p> \n            <p> </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F8C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F8B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69D7\"></a><pre>\nAUIO = AssetManager.GetAssetByIndex 2 --get the AsserUser with index 2\n--&gt; &lt;IObject:AssetUser&gt;\nAUIO.GetFileName() --get the file name - it is not full file name\n--&gt; \"Simple_Stone_Mtl_Marble_bump.jpg\"\nAUIO.CanGetFullFilePath (AUIO.GetFileName()) --can we get the full name?\n--&gt; true\nAUIO.GetFullFilePath() --then let\'s get it!\n--&gt; \"C:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\adskMtl\\Simple_Stone_Mtl_Marble_bump.jpg\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F7B\"></a> <span class=\"char_link\"><a href=\"GUID-E5D783F1-9108-4436-921C-D72BF7035866.htm\">Accessing AssetManager, AssetUser and Asset Metadata in MAX Files</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F79\"></a> <span class=\"char_link\"><a href=\"GUID-E3237B13-8069-4177-8544-9000A98B1C15.htm\">Interface: AssetManager</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F78\"></a> <span class=\"char_link\"><a href=\"GUID-2AF2AFE0-1B22-4DA2-B0F9-CA3ADABCB6C6.htm\">MAX File Asset Metadata Stream Access</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F77\"></a> <span class=\"char_link\"><a href=\"GUID-DFC564A3-A5E1-4398-AF50-3B4C91BB3358.htm\">Interface: FileResolutionManager</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";