var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5A4580C6-B5CF-4104-898B-9313D1AAECD4\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Context Filters\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Context Filters</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5A4580C6-B5CF-4104-898B-9313D1AAECD4\"></a><div class=\"head\">\n            <h1>Context Filters </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56CA\"></a> Filter functions for context-sensitive menus. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56C8\"></a>Use this for .<em class=\"strong\">IsEnabled</em> or .<em class=\"strong\">IsVisible</em> handlers in macroScripts. isEnabled and isChecked handlers have been added to many\n            of the existing macroScripts. All of the modifier, creation, and polygon toolbox macroScripts\n            have these two handlers. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56C7\"></a>These handlers allow object creation CUI buttons to turn green while creating objects,\n            and modifier buttons are only enabled if they apply to the current selection. Moreover,\n            the polygon toolbox buttons only enable when applicable, and the selection level buttons\n            stay pressed while in the sub-object level. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56C6\"></a>This structure is defined in .\\stdplugs\\stdscripts\\<span class=\"code\"> <em class=\"strong\">FilterFunctions.ms.</em> </span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56C5\"></a>An example of filter functions is available in the Selection and Display Callbacks\n            Script File, .\\stdplugs\\stdscripts\\<span class=\"code\"> <em class=\"strong\">Selection_Display_Filters.ms</em> </span> \n         </p>\n         <p><a name=\"GUID-6DF94C12-9305-4273-A45F-D9A5CD3E85BB\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7264\"></a><pre>#Struct:<em class=\"codeEmphasisStrong\">Filters</em>( 		\n<em class=\"codeEmphasisStrong\">Is_EditMesh</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_NURBS</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_EditPoly</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_EditPatch</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_EditSpline</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_MeshSelect</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_PolySelect</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_SplineSelect</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_PatchSelect</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_PosXYZ</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_RotationXYZ</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">Is_ScaleXYZ</em>:&lt;fn&gt;, 		\n<em class=\"codeEmphasisStrong\">is_Child</em>:&lt;fn&gt;, 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56B6\"></a>This is used for the new IK assignments. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7263\"></a><pre><em class=\"codeEmphasisStrong\">is_Parent</em>:&lt;fn&gt;,   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56B4\"></a>This is used for the new IK assignments. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56B3\"></a>CanSwitchTo_XXXX for SubObject levels: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7262\"></a><pre><em class=\"codeEmphasisStrong\">CanSwitchTo_Vertex</em>:&lt;fn&gt;,   \n<em class=\"codeEmphasisStrong\">CanSwitchTo_Edge</em>:&lt;fn&gt;,   \n<em class=\"codeEmphasisStrong\">CanSwitchTo_Face</em>:&lt;fn&gt;,   \n<em class=\"codeEmphasisStrong\">CanSwitchTo_Polygon</em>:&lt;fn&gt;,   \n<em class=\"codeEmphasisStrong\">CanSwitchTo_Element</em>:&lt;fn&gt;,   \n<em class=\"codeEmphasisStrong\">CanSwitchTo_Border</em>:&lt;fn&gt;,   \n<em class=\"codeEmphasisStrong\">CanSwitchTo_Patch</em>:&lt;fn&gt;,   \n<em class=\"codeEmphasisStrong\">CanSwitchTo_Segment</em>:&lt;fn&gt;,   \n<em class=\"codeEmphasisStrong\">CanSwitchTo_Spline</em>:&lt;fn&gt;, </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56A9\"></a>These can be used to check if MeshSelect, PatchSelect, SplineSelect, Edit(able) Patch,\n            Edit(able)Mesh, and Edit(able) Spline can go into these subobject levels. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7261\"></a><pre><em class=\"codeEmphasisStrong\">Are_Modifiers_Applied</em>:&lt;fn&gt;, </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56A7\"></a>The following requires a node to be passed into the function: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7260\"></a><pre><em class=\"codeEmphasisStrong\">Is_Bone</em>:&lt;fn&gt;, \n<em class=\"codeEmphasisStrong\">Is_IKChain</em>:&lt;fn&gt;, \n<em class=\"codeEmphasisStrong\">Is_Point</em>:&lt;fn&gt;, \n<em class=\"codeEmphasisStrong\">Is_Light</em>:&lt;fn&gt;, \n<em class=\"codeEmphasisStrong\">Is_Camera</em>:&lt;fn&gt;, </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56A1\"></a>These return true if the selected object’s function name condition is met. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-725F\"></a><pre><em class=\"codeEmphasisStrong\">Is_Target</em>:&lt;fn&gt;, </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-569F\"></a>Returns true if the node is a target of a LookAt controller, false otherwise. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-725E\"></a><pre><em class=\"codeEmphasisStrong\">HasBaseObjectProperty</em>:&lt;fn&gt;, </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-569D\"></a>Returns true if the node\'s base object has the specified property, or if the base\n            object is a scripted plugin, and the delegate has the specified property. Is either\n            a string or name value. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-725D\"></a><pre><em class=\"codeEmphasisStrong\">GetBaseObjectProperty</em>:&lt;fn&gt;, </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-569B\"></a>Returns the value for the node\'s base object property, or the delegate\'s property\n            if the base object is a scripted plugin. If the specified property is not found, a\n            name value of \'#error\' will be returned. Is either a string or name value. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-725C\"></a><pre><em class=\"codeEmphasisStrong\">SetBaseObjectProperty</em>:&lt;fn&gt;, </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5699\"></a>Sets the value for the node\'s base object property, or the delegate\'s property if\n            the base object is a scripted plugin. If the specified property is not found, or does\n            not accept the type of value specified, a name value of \'#error\' will be returned.\n            Is either a string or name value. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-725B\"></a><pre>-- returns new value/#error<em class=\"codeEmphasisStrong\">ToggleBaseObjectProperty</em>:&lt;fn&gt;) </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5696\"></a>Toggles the value for the node\'s base object property, or the delegate\'s property\n            if the base object is a scripted plugin. If the specified property is not found, or\n            is not a boolean, a name value of \'#error\' will be returned. Otherwise the property\'s\n            new value will be returned. Is either a string or name value. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5694\"></a> <span class=\"char_link\"><a href=\"GUID-3DC75DDE-E4BC-4033-ABA9-A42063036CB9.htm\">Macro Scripts</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5693\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining Macro Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";