var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5A84508D-6F9E-4E18-8C0A-81F91794DA47\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"SafeArrayWrapper Class\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>SafeArrayWrapper Class</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5A84508D-6F9E-4E18-8C0A-81F91794DA47\"></a><div class=\"head\">\n            <h1>SafeArrayWrapper Class </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12C6\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12C5\"></a> Instances of <em class=\"strong\">SafeArrayWrapper</em> are creatable by the user and are returned by OLE methods that return SAFEARRAY values.\n               Available in <em class=\"strong\">3ds Max 8 and higher</em>. \n            </p> \n            <p><a name=\"GUID-C871DC53-49B1-4C41-AD0B-E49292F30F97\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12C2\"></a> <em class=\"strong\">Constructor:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6808\"></a><pre><em class=\"codeEmphasisStrong\">SafeArrayWrapper</em> ()\n<em class=\"codeEmphasisStrong\">SafeArrayWrapper</em> &lt;data array&gt;\n<em class=\"codeEmphasisStrong\">SafeArrayWrapper</em> &lt;data array&gt; &lt;lBounds array&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12BD\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6807\"></a><pre>&lt;SafeArrayWrapper&gt;.<em class=\"codeEmphasisStrong\">dataArray</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12BB\"></a>Data array. Might be \'undefined\'. The dataArray is a set of nested arrays. The dataArray\n               must be \"square\" (the number of elements in the dataArray at any given dimension is\n               constant). For example, \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12BA\"></a>dataArray[i].count is constant for i = 1 to dataArray.count, dataArray[i][j].count\n               is constant for j = 1 to dataArray[2].count. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12B9\"></a>A runtime error will be thrown if dataArray is set to a non-square array. The depth\n               of the array is its dimension. A dimension 2 array is where dataArray[i][j] is a non-array\n               data value. Setting dataArray will change the number of elements in lBoundsArray to\n               match with added elements having the value 0. \n            </p> \n            <p><a name=\"GUID-DDC611DB-1424-4A0C-8DA0-5DF5A3822108\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6806\"></a><pre>&lt;SafeArrayWrapper&gt;.<em class=\"codeEmphasisStrong\">lBoundsArray</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12B7\"></a>Lower bounds array. Might be \'undefined\'. Array of size dimensions, where each element\n               contains the lower bound of one dimension of the array. This array is used for creating\n               the OLE SAFEARRAY value from the SafeArrayWrapper. When setting lBoundsArray, its\n               size must be \'dimensions\' or a runtime error will be thrown. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6805\"></a><pre>&lt;SafeArrayWrapper&gt;.<em class=\"codeEmphasisStrong\">dimensions</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12B5\"></a>Number of dimensions in the data and bounds array. Read only. \n            </p> \n            <p><a name=\"GUID-8EB43490-D836-4158-A181-FB5245FC1B67\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12B3\"></a> <em class=\"strong\">Methods</em>: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6804\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;SafeArrayWrapper&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12B1\"></a>Returns a new SafeArrayWrapper, a deep copy is performed on the data and bounds array.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12AF\"></a> <em class=\"strong\">Notes:</em> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12AE\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12AC\"></a>SafeArrayWrapper values can be passed to OLE methods as arguments and can passed to/from\n                     ActiveX control methods. Arrays passed to OLE or ActiveX methods are automatically\n                     converted to intermediate SafeArrayWrapper values. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12AA\"></a>The following additional variant types for values returned by OLE objects can be converted\n                     to MAXScriptvalues: VT_UI2, VT_UI4, VT_INT, VT_NULL, and VT_VOID. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12A8\"></a>Color values are converted to VT_I4 variant values when passed to OLE objects. \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12A6\"></a> <em class=\"strong\">Examples:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-12A5\"></a>Example tests which show in part retrieving data from an SQL database using the GetRows\n               method: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6803\"></a><pre>\n-- open sql database and get rows\nDogConn = createOLEObject \"ADODB.Connection\"\nDogConn.Open \"driver={SQL Server}; server=dsqedb01.autodesk.com; database=MXSTest\"\nrecordSet = createOLEObject \"ADODB.Recordset\"\nrecordSet.Open \"SELECT * from TestTable\" DogConn\na = recordSet.GetRows()\n-- display data properties\na.dataArray\na.lBoundsArray\na.dimensions\n</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6802\"></a><pre>\n-- create a new SafeArrayWrapper using data array and lbounds array\nb = SafeArrayWrapper #(#(1, 1.2345, \"One point two three four five\", undefined, undefined, undefined), #(2, undefined, \"Float is null\", undefined, undefined, undefined), #(3, 0.0, \" \", undefined, undefined, undefined), #(4, 123.4, undefined, undefined, undefined, undefined)) #(0, 0)\nb.dataArray\nb.lBoundsArray\nb.dimensions\n</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6801\"></a><pre>\n-- create a new SafeArrayWrapper using data array\nd = SafeArrayWrapper a.dataArray\nd.dataArray\nd.lBoundsArray\nd.dimensions\n</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6800\"></a><pre>\n-- create a new SafeArrayWrapper via copy, show it is a deep copy\nf = copy a\nf.dataArray\nf.lBoundsArray\nf.dimensions\nf.dataArray[1][1] = 999999\nf.dataArray\na.dataArray\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1281\"></a>Example of updating an SQL database, where the update method is passed an array or\n               SafeArrayWrapper values: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67FF\"></a><pre>\nDogConn=createOLEObject \"ADODB.Connection\"\nDogConn.Open \"driver={SQL Server}; server=dsqedb01.autodesk.com; database=MXSTest\"\nrecordSet = createOLEObject \"ADODB.Recordset\"\nrecordSet.Open \"SELECT * from TestTable\" DogConn 1 3 -- adOpenKeyset adLockOptimistic\nfields=recordSet.Fields -- print out column names\ncount = fields.count\nfor i = 1 to count do (local item = fields.item (i-1); print item.name)\nrecordSet.GetRows() -- display current contents\nrecordSet.AddNew #(\"arbitraryFloat\", \"arbitraryChar\", \"boolean\", \"arbitraryInt\") #(pi,\"Hello World\",true,42) -- add via array\nrecordSet.AddNew (SafeArrayWrapper #(\"arbitraryFloat\", \"arbitraryChar\", \"arbitraryInt\")) (SafeArrayWrapper #(e/pi,\"Merry xmas!\", 54321)) -- add via SafeArrayWrapper\nrecordSet.close()\nrecordSet.Open \"SELECT * from TestTable\" DogConn\nrecordSet.GetRows() -- display current contents\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1271\"></a>Example of getting/setting an ActiveX control property with SafeArrayWrapper: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67FE\"></a><pre>\nrollout controlR86 \"Microsoft Chart Control 6.0 (SP4) (OLEDB)\"\n(\nactiveXControl ax \"{3A2B370C-BA0A-11D1-B137-0000F8753F5D}\" height:200 width:300 align:#left setupEvents:false\n)\ncreatedialog ControlR86 height:250 width:350\ndata = ControlR86.ax.chartdata -- returns SafeArrayWrapper\nControlR86.ax.chartdata = SafeArrayWrapper #(#(undefined, \"R1\", \"R2\", \"R3\", \"R4\", \"R5\"), #(\"C1\", 1, 2, 3, 4, 5), #(\"C2\", 1, 2, 3, 4, 5), #(\"C3\", 5, 4, 3, 2, 1), #(\"C4\", -1, 2, 3, 2, 1))\n</pre></div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1267\"></a> \n               <h3><a name=\"GUID-926083FD-842D-49A0-A803-DC7C6F535083\"></a> <em class=\"strong\">Conversion between MAXScript values and OLE variant values:</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1265\"></a> <em class=\"strong\">OLE -&gt; MAXScript:</em> \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1264\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"50%\">\n                        <col width=\"50%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67FD\"></a><pre>\nVT_EMPTY\nVT_NULL\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67FC\"></a><pre>\nundefined\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67FB\"></a><pre>\nVT_VOID\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67FA\"></a><pre>\nOK\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67F9\"></a><pre>\nVT_UI1\nVT_UI2\nVT_UI4\nVT_I2\nVT_I4\nVT_INT\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67F8\"></a><pre>\nInteger\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67F7\"></a><pre>\nVT_R4\nVT_R8\nVT_CY\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67F6\"></a><pre>\nFloat\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67F5\"></a><pre>\nVT_BSTR\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67F4\"></a><pre>\nString\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67F3\"></a><pre>\nVT_BOOL\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67F2\"></a><pre>\nBoolean\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67F1\"></a><pre>\nVT_DISPATCH\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67F0\"></a><pre>\nOLEObject\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67EF\"></a><pre>\nVT_ARRAY | VT_VARIANT\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67EE\"></a><pre>\nSafeArrayWrapper\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-124A\"></a> <em class=\"strong\">MAXScript -&gt; OLE:</em> \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1249\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"50%\">\n                        <col width=\"50%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67ED\"></a><pre>\nSafeArrayWrapper\nArray\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67EC\"></a><pre>\nVT_ARRAY | VT_VARIANT\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67EB\"></a><pre>\nInteger\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67EA\"></a><pre>\nVT_I4\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67E9\"></a><pre>\nFloat\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67E8\"></a><pre>\nVT_R4\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67E7\"></a><pre>\nBoolean\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67E6\"></a><pre>\nVT_BOOL\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67E5\"></a><pre>\nColor\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67E4\"></a><pre>\nVT_I4\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67E3\"></a><pre>\nString\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67E2\"></a><pre>\nVT_BSTR\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67E1\"></a><pre>\nUndefined\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67E0\"></a><pre>\nVT_EMPTY\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67DF\"></a><pre>\nOLEObject\n</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67DE\"></a><pre>\nVT_DISPATCH\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1236\"></a>The following information is taken from the document \"Accessing Data with ADO\" from\n                  MSDN (<em class=\"strong\">ms-help://MS.MSDNQTR.2003OCT.1033/iisref/htm/AccessingDatawithADO.htm</em>). \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1235\"></a> <em class=\"strong\">The following table lists OLE DB connection strings for several common data sources:</em> \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1234\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"33.33333333333333%\">\n                        <col width=\"66.66666666666666%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1233\"></a><p class=\"table-body\"> <em class=\"strong\">Data Source</em> \n                           </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1232\"></a><p class=\"table-body\"> <em class=\"strong\">OLE DB Connection String</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F487554A38425612A6182AEB9-6A47\"></a><p class=\"table-body\">Microsoft Access </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1230\"></a><p class=\"table-body\">Provider=Microsoft.Jet.OLEDB.4.0;Data Source=<em class=\"strong\">physical path to .mdb file</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-122F\"></a><p class=\"table-body\">Microsoft SQL Server </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-122E\"></a><p class=\"table-body\">Provider=SQLOLEDB.1;Data Source=<em class=\"strong\">path to database on server</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-122D\"></a><p class=\"table-body\">Oracle </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-122C\"></a><p class=\"table-body\">Provider=MSDAORA.1;Data Source=<em class=\"strong\">path to database on server</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-122B\"></a><p class=\"table-body\">Microsoft Indexing Service </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-122A\"></a><p class=\"table-body\">Provider=MSIDXS.1;Data Source=<em class=\"strong\">path to file</em> \n                           </p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1229\"></a>To provide for backward compatibility, the OLE DB Provider for ODBC supports ODBC\n                  connection string syntax. The following table lists commonly used ODBC connection\n                  strings: \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1228\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"33.33333333333333%\">\n                        <col width=\"66.66666666666666%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1227\"></a><p class=\"table-body\"> <em class=\"strong\">Data Source Driver</em> \n                           </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1226\"></a><p class=\"table-body\"> <em class=\"strong\">ODBC Connection String</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1225\"></a><p class=\"table-body\">Microsoft Access </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1224\"></a><p class=\"table-body\">Driver={Microsoft Access Driver (*.mdb)};DBQ=<em class=\"strong\">physical path to .mdb file</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1223\"></a><p class=\"table-body\">SQL Server </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1222\"></a><p class=\"table-body\">DRIVER={SQL Server};SERVER=<em class=\"strong\">path to server</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1221\"></a><p class=\"table-body\">Oracle </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1220\"></a><p class=\"table-body\">DRIVER={Microsoft ODBC for Oracle};SERVER=<em class=\"strong\">path to server</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-121F\"></a><p class=\"table-body\">Microsoft Excel </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-121E\"></a><p class=\"table-body\">Driver={Microsoft Excel Driver (*.xls)};DBQ=<em class=\"strong\">physical path to .xls file</em>; DriverID=278 \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-121D\"></a><p class=\"table-body\">Microsoft Excel 97 </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-121C\"></a><p class=\"table-body\">Driver={Microsoft Excel Driver (*.xls)};DBQ=<em class=\"strong\">physical path to .xls file</em>;DriverID=790 \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-121B\"></a><p class=\"table-body\">Paradox </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-121A\"></a><p class=\"table-body\">Driver={Microsoft Paradox Driver (*.db)};DBQ=<em class=\"strong\">physical path to .db file</em>;DriverID=26 \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1219\"></a><p class=\"table-body\">Text </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1218\"></a><p class=\"table-body\">Driver={Microsoft Text Driver (*.txt;*.csv)};DBQ=<em class=\"strong\">physical path to .txt file</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1217\"></a><p class=\"table-body\">Microsoft Visual FoxPro (with a database container) </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1216\"></a><p class=\"table-body\">Driver= {MicrosoftVisualFoxProDriver};SourceType=DBC;SourceDb=<em class=\"strong\">physical path to .dbc file</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1215\"></a><p class=\"table-body\">Microsoft Visual FoxPro (without a database container) </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1214\"></a><p class=\"table-body\">Driver= {MicrosoftVisualFoxProDriver};SourceType=DBF;SourceDb=<em class=\"strong\">physical path to .dbf file</em> \n                           </p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";