var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5B8A48AB-AED6-4EDE-9802-F9F5E9102E46\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSSurface - NURBSObject\">\n      <meta name=\"indexterm\" content=\"NURBSRuledSurface - NURBSSurface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSRuledSurface : NURBSSurface</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5B8A48AB-AED6-4EDE-9802-F9F5E9102E46\"></a><div class=\"head\">\n            <h1>NURBSRuledSurface : NURBSSurface </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40CB\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40CA\"></a>  This class defines a dependent Ruled surface. A Ruled surface is generated from two\n               curve sub-objects. It lets you use curves to design the two opposite borders of a\n               surface. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40C7\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20EF\"></a><pre><em class=\"codeEmphasisStrong\">NURBSRuledSurface</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40C5\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20EE\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40C1\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20ED\"></a><pre>&lt;nurbsruledsurface&gt;.<em class=\"codeEmphasisStrong\">parent1</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40BF\"></a>The 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent curve by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20EC\"></a><pre>&lt;nurbsruledsurface&gt;.<em class=\"codeEmphasisStrong\">parent1ID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40BC\"></a>The 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20EB\"></a><pre>&lt;nurbsruledsurface&gt;.<em class=\"codeEmphasisStrong\">parent2</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40B9\"></a>The 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent curve by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20EA\"></a><pre>&lt;nurbsruledsurface&gt;.<em class=\"codeEmphasisStrong\">parent2ID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40B6\"></a>The 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20E9\"></a><pre>&lt;nurbsruledsurface&gt;.<em class=\"codeEmphasisStrong\">flip1</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40B3\"></a>Controls the matching of parent curve direction when creating the Ruled surface. For\n               example, normally when you create a Ruled surface between two parent curves you don\'t\n               want a \'bow tie\' surface (one with the ends rotated 180 degrees so it crosses on itself\n               in the middle). If you simply match the parent direction you\'ll get a \'bow tie\' surface.\n               To prevent this you use this property to set a state indicating that one or the other\n               should be flipped before it\'s used. In this way, when the ruled surface is created,\n               a \'bow tie\' won\'t occur. If <span class=\"code\"> <em class=\"strong\">true</em> </span>, the 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent’s curve direction will be flipped; if <span class=\"code\"> <em class=\"strong\">false</em> </span> the 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent’s curve direction will not be flipped. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20E8\"></a><pre>&lt;nurbsruledsurface&gt;.<em class=\"codeEmphasisStrong\">flip2</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40B0\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, the 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent’s curve direction will be flipped; if <span class=\"code\"> <em class=\"strong\">false</em> </span> the 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent’s curve direction will not be flipped. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20E7\"></a><pre>&lt;nurbsruledsurface&gt;.<em class=\"codeEmphasisStrong\">curveStartPoint1</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40AD\"></a>The start point on the 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent curve. This value is only applicable if the curve is closed. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-20E6\"></a><pre>&lt;nurbsruledsurface&gt;.<em class=\"codeEmphasisStrong\">curveStartPoint2</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40AA\"></a>The start point on the 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent curve. This value is only applicable if the curve is closed. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40A7\"></a> <span class=\"char_link\"><a href=\"GUID-19C0A3FC-AECA-437A-A430-51EFC9D70545.htm\">NURBSSurface</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40A6\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-40A5\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";