var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5C8F4D60-69B0-4DC0-9641-E0F8C0CFCB84\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"variables\">\n      <meta name=\"indexterm\" content=\"type-free variables\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Type-Free Variables</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5C8F4D60-69B0-4DC0-9641-E0F8C0CFCB84\"></a><div class=\"head\">\n            <h1>Type-Free Variables </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AA4\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AA5\"></a>  Variables can hold any type of value, and the value type they hold can change from\n               assignment to assignment. For example, you can store a point3 value, then a float\n               value, and then an array to the same variable. The variables in MAXScript are known\n               as <em class=\"mild\">type-free variables</em>, unlike variables in C or Java, which can only hold values of a particular declared\n               type. This freedom makes scripting simpler and more exploratory.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86AA8\"></a>As well as being type-free, variables in MAXScript are also <em class=\"mild\">type-safe</em>. This means you cannot perform the wrong operation on a value in a variable, as shown\n               in the following example, where MAXScript prints an error message following the invalid\n               operation:\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86AA9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6190\"></a><pre>\nx = $Box01.position -- a point3 value\nx = \"foo\" -- a string value\nx = x + 2 -- try to add a number to a string\nError: Unable to convert 2 to type String\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";