var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5D007B11-0770-47BC-B4ED-5D3DF8C78BE9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"getLastRenderedImage()\">\n      <meta name=\"indexterm\" content=\"Accessing the Last Rendered Image\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Accessing the Last Rendered Image</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5D007B11-0770-47BC-B4ED-5D3DF8C78BE9\"></a><div class=\"head\">\n            <h1>Accessing the Last Rendered Image </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-14B6\"></a> \n            <p><a name=\"GUID-7DDF5BB8-9D55-41E5-B5E8-39E34BFE93E2\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6851\"></a><pre><em class=\"codeEmphasisStrong\">getLastRenderedImage</em> [ <em class=\"codeEmphasisStrong\">copy:</em>&lt;bool&gt; ] 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-14B0\"></a>The <span class=\"code\"> <em class=\"strong\">getLastRenderedImage()</em> </span> method returns the last image rendered via Render Scene, Render Last, or Quick Render\n               as a bitmap value. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-14AF\"></a>If the optional keyword argument <span class=\"code\"> <em class=\"strong\">copy:</em> </span> is not specified or is set to <span class=\"code\"> <em class=\"strong\">true</em> </span> in <em class=\"strong\">3ds Max 2009 and higher</em>, the bitmap will be copied into a new bitmap value. If the keyword argument <span class=\"code\"> <em class=\"strong\">copy:</em> </span> is specified as <span class=\"code\"> <em class=\"strong\">true</em> </span>, the MAXScript bitmap value will share the renderer\'s bitmap. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7550\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-567ACD73-0610-4904-BC4F-9D1C0C4BE0A8\"></a>The renderer reuses the last rendered bitmap value when re-rendering with the same\n                     dimensions. If the dimensions have been changed, a new bitmap value will be created.\n                     \n                  </p> \n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-14AA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-14A9\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-14A8\"></a><ul>\n                           <li> \n                              <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-14A6\"></a>Render the scene \n                              </p> \n                           </li>\n                           <li> \n                              <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-14A4\"></a>Run the following code: \n                              </p> \n                           </li>\n                        </ul> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6850\"></a><pre>\nbm = GetLastRenderedImage copy:false --share the bitmap\ndisplay bm\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-149F\"></a><ul>\n                           <li> \n                              <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-149D\"></a>Change the view and render the scene again. \n                              </p> \n                           </li>\n                           <li> \n                              <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-149B\"></a>Run the following code: \n                              </p> \n                           </li>\n                        </ul> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-684F\"></a><pre>\ndisplay bm\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1497\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT</em>: The bitmap display will update to reflect the second render. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1496\"></a><ul>\n                           <li> \n                              <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1494\"></a>Change the render size and render the scene again. \n                              </p> \n                           </li>\n                           <li> \n                              <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1492\"></a>Run the following code: \n                              </p> \n                           </li>\n                        </ul> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-684E\"></a><pre>\ndisplay bm\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-148E\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT</em>: The bitmap display will still reflect the second render because the third render\n                           created a new bitmap value which is not referenced by the variable bm. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-148D\"></a><p class=\"table-body\">You still need to call <span class=\"code\"> <em class=\"strong\">free bm</em> </span> to release the underlying bitmap from the MAXScript bitmap value if you want the\n                           release to occur before the MAXScript bitmap value is garbage collected. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-148A\"></a> <span class=\"char_link\"><a href=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304.htm\">Bitmap Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";