var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5F41F145-0939-4DC0-B0F4-CC086B4CF866\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Controller\">\n      <meta name=\"indexterm\" content=\"MasterBlockController: MasterBlock\">\n      <meta name=\"indexterm\" content=\"MasterBlock - MasterBlockController\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MasterBlock : MasterBlockController</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5F41F145-0939-4DC0-B0F4-CC086B4CF866\"></a><div class=\"head\">\n            <h1>MasterBlock : MasterBlockController </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-79BB\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-79BA\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controllers</a></span> &gt; MasterBlockController &gt; MasterBlock \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-79B8\"></a> <em class=\"strong\">Constructor</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-79B7\"></a>The MasterBlock controller cannot be created by MAXScript. It can only be created\n            in the Block Control node in the Global Tracks node of Track View. If multiple MasterBlocks\n            are present, you will need to access the MasterBlocks as a subAnim of <span class=\"code\"> <em class=\"strong\">trackviewnodes.global_tracks.block_control</em> </span>. This is because all MasterBlocks have the same name (MasterBlock). \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-79B6\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-79B5\"></a>Once a MasterBlock has been created in Track View, the following MasterBlock property\n            is available: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DD6\"></a><pre>&lt;MasterBlock&gt;.<em class=\"codeEmphasisStrong\">blend</em> Float</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-79B2\"></a>Once a track has been added to the MasterBlock, a Block controller is added to the\n            MasterBlock and the track’s controller is added as an input controller to the Block\n            controller. The name assigned to the Block controller is the name specified for the\n            block. The Block controller is then available as a property of the MasterBlock and\n            the track’s controller is available as a property of the Block controller. In addition,\n            the track’s controller is replaced with a list controller and the track’s original\n            controller is placed in the list controller along with a Slave controller. This Slave\n            controller is controlled by the Block controller. For example, if a block with the\n            name \"BoxHeight\" is present and contains the height controller for a box object, the\n            block and its track can be accessed as follows: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-79B1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DD5\"></a><pre>\nmb=trackviewnodes.global_tracks.block_control[1]\n--&gt; SubAnim:MasterBlock\ngetpropnames mb\n--&gt; #(#Blend, #height)\nh=mb.height\n--&gt; SubAnim:height\nh.object\n--&gt; Controller:Block\ngetpropnames h\n--&gt; #(#Box01_Height)\nh.box01_height\n--&gt; 157.083-- the box’s height\nh.box01_height.controller\n--&gt; Controller:Bezier_Float-- the box’s height controller\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-799E\"></a> <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controller Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-799D\"></a> <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-799C\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";