var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5FBA4F99-5A57-4B36-9008-F8EC68340AA6\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"structure definition\">\n      <meta name=\"indexterm\" content=\"struct\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Structure Definition</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5FBA4F99-5A57-4B36-9008-F8EC68340AA6\"></a><div class=\"head\">\n            <h1>Structure Definition </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E874AB\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874AC\"></a>   You can create your own compound values in MAXScript using <em class=\"strong\">Structure definitions</em>. \n            </p> \n            <p><a name=\"P_6DAD25B6D2724CE1AB83C964C00D7200\"></a>Structure definitions let you define the layout of new \'classes\' of values that you\n               can then create and work with in your code. \n            </p> \n            <p><a name=\"P_26C9B3F2D9814CDEBD541BA69969AEFE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874B0\"></a>The <em class=\"strong\">syntax </em>for a structure definition is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-607F\"></a><pre><em class=\"codeEmphasisStrong\">struct</em> &lt;struct_name&gt; ( &lt;member&gt; { , &lt;member&gt; } )</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874B2\"></a>where each <span class=\"code\"> <em class=\"strong\">&lt;member&gt;</em> </span> can be one of: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-607E\"></a><pre>&lt;name&gt; [ <em class=\"codeEmphasisStrong\">=</em> &lt;expr&gt; ] --name and optional initial value\n&lt;function_def&gt;\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874B5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874B6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-607D\"></a><pre>\nstruct person (name, height, age, sex)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874BB\"></a>The above example defines a new \'person\' class. You can create values of this class\n               using the \'person\' constructor: \n            </p> <a name=\"TABLE_A752ADC126D84AA1AD9130964E8FF11E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"P_8EBB1A21297549E2AD4AA1EC736D2F36\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"CODEBLOCK_B73070AE48AF4622B61793E9DB180509\"></a><pre>\nbill = person name: \"Bill\" height:72 age:34 sex:#male\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874BD\"></a>This creates an instance of the <span class=\"code\"> <em class=\"strong\">person</em> </span> class, storing the instance in variable <span class=\"code\"> <em class=\"strong\">bill</em> </span>. Member <span class=\"code\"> <em class=\"strong\">name</em> </span> is initialized to the string value \"Bill\", <span class=\"code\"> <em class=\"strong\">height</em> </span> to the integer value 72, <span class=\"code\"> <em class=\"strong\">age</em> </span> to the integer value 34, and <span class=\"code\"> <em class=\"strong\">sex </em> </span> to the name value #male. \n            </p> <a name=\"TABLE_7A6AA3EB61554A6EB0F313E8D1FB672D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"P_CE7CB6E44C5445C4AED27445A9F48FEF\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"CODEBLOCK_188A29B939DC488B829150722733B797\"></a><pre>\njoe = person name: \"Joseph\" sex:#male\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874BF\"></a>This creates an instance of the <span class=\"code\"> <em class=\"strong\">person</em> </span> class, storing the instance in variable <span class=\"code\"> <em class=\"strong\">joe</em> </span>. Member <span class=\"code\"> <em class=\"strong\">name</em> </span> is initialized to the string value \"Joseph\" and <span class=\"code\"> <em class=\"strong\">sex</em> </span> to the name value #male. As the <span class=\"code\"> <em class=\"strong\">height</em> </span> and <span class=\"code\"> <em class=\"strong\">age</em> </span> members are not assigned values and do not have optional initial values supplied\n               in the structure definition, they default to a value of <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874C0\"></a>You can access structured values using the standard property accessing syntax in MAXScript.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874C1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874C2\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-607A\"></a><pre>\nbill.age  --returns 34\njoe.age  --returns undefined\njoe.age = bill.age-4 --assigns Bill\'s age less 4 to Joe\'s age.\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874C9\"></a>Structure definitions are useful as an alternative to arrays when you have a fixed,\n               usually small number of independent components and the code to work with them is much\n               clearer when they can be referenced by property name, rather than by index number.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874CA\"></a>As with function definitions, a structure definition actually creates a value to represent\n               the definition and stores it in a variable of the same name as the structure. You\n               can store the structure definitions in other compound objects or pass them as function\n               arguments. The <span class=\"code\"> <em class=\"strong\">classOf()</em> </span> function returns this structure definition value when applied to these values, so\n               you can use it to test the definition of structure instances at runtime. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874CB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874CC\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6079\"></a><pre>\nclassOf bill --returns person\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874D1\"></a>The <span class=\"code\"> <em class=\"strong\">struct</em> </span> value constructors are just like function calls and take positional argument initializers\n               as well as keyword initializers. The elements of the new <span class=\"code\"> <em class=\"strong\">struct</em> </span> are filled in order from any positional arguments and then by name from any keyword\n               arguments. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874D2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874D3\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874D4\"></a><p class=\"table-body\">given the following <span class=\"code\"> <em class=\"strong\">struct</em> </span> definition: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6078\"></a><pre>\nstruct foo (name, age, height, hair=\"brown\")\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874D8\"></a><p class=\"table-body\">you can create instances in several ways: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6077\"></a><pre>\nf1 = foo \"bill\" 23 72 --fills in name, age, height in order\nf2 = foo age:45 name: \"sam\" --random named initializers\nf3 = foo \"mary\" hair: \"red\" --first name, then keywords\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874DF\"></a>There are several methods associated with <span class=\"code\"> <em class=\"strong\">struct</em> </span> values: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6076\"></a><pre><em class=\"codeEmphasisStrong\">getProperty</em> &lt;struct&gt; &lt;propname&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874E1\"></a>Allows you to access properties of the structure. \n            </p> \n            <p><a name=\"P_5CE1AE39B3DE457D9F205EE0B1E58D3E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6075\"></a><pre><em class=\"codeEmphasisStrong\">getPropNames</em> &lt;struct&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874E3\"></a>Returns the properties of the structure as an array. \n            </p> \n            <p><a name=\"P_ADAB3463356643D5A7CAE5D75A2C6FBB\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6074\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;struct&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874E5\"></a>Creates a copy of the structure. The copy made is called a <em class=\"mild\">shallow copy</em>. Only a copy of the upper-level value itself (that is, the <span class=\"code\"> <em class=\"strong\">struct</em> </span> value) is created. Copies are not made of compound values stored in the structure,\n               rather the same compound value is stored in both the <span class=\"code\"> <em class=\"strong\">struct</em> </span> values. This can be seen in the following example, where changing a component value\n               of a compound value in a copy of a <span class=\"code\"> <em class=\"strong\">struct</em> </span> value also changes the value in the original <span class=\"code\"> <em class=\"strong\">struct</em> </span> value: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874E6\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874E7\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6073\"></a><pre>\nStruct test (pos1, pos2) --define a structure\ntestval = test [1,2,3] [4,5,6] --create struct value\ntestval_copy=copy testval --copy the struct value\ntestval_copy.pos1.x=10 --change component value of a compound\n--value in the copy\ntestval --look at original struct value\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E874F0\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6072\"></a><pre>\n#Struct:test( --result line 1\n  pos1:&lt;data&gt;; Public,\n  pos2:&lt;data&gt;; Public)\ntest(pos1:[1,2,3] pos2:[4,5,6]) --result line 2\ntest(pos1:[1,2,3] pos2:[4,5,6]) --result line 3\n10 --result line 4\n(test pos1:[10,2,3] pos2:[4,5,6]) --result line 6\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874FC\"></a> <span class=\"char_link\"><a href=\"GUID-35E5A5EF-BF14-4D11-8ABA-CFD9A0E7249E.htm\">Defining Local Functions in Structures</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874FD\"></a> <span class=\"char_link\"><a href=\"GUID-D5426B3F-7060-4C02-BA75-CB24A66B2ABD.htm\">Structure Inherited Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874FE\"></a> <span class=\"char_link\"><a href=\"GUID-4B31E2CC-8862-4C19-AA07-2DDED173757C.htm\">Structure Scope While Initializing</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874FF\"></a> <span class=\"char_link\"><a href=\"GUID-A3A4E597-B4D7-4C38-90A6-E8F78203114E.htm\">Structure Creation and Cloning Event Handlers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87500\"></a> <span class=\"char_link\"><a href=\"GUID-0D3592DD-2F20-4A41-B19F-544426B8186E.htm\">Private and Public Members in Structure Definitions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";