var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5FC5036F-E2D7-46C9-9AFA-7B3550B9F254\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"RolloutCreator Functions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>RolloutCreator Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5FC5036F-E2D7-46C9-9AFA-7B3550B9F254\"></a><div class=\"head\">\n            <h1>RolloutCreator Functions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-431A\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4316\"></a> <em class=\"strong\">RolloutCreator</em> is a structure of functions for dynamically creating rollouts. The functions are\n               implemented by a script located under \n               		  <em class=\"strong\">stdplugs\\stdscripts\\baseLib\\rolloutCreator.ms</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4315\"></a> <em class=\"strong\">Here are the implemented functions and their usage:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F8B\"></a><pre><em class=\"codeEmphasisStrong\">rolloutCreator</em> &lt;rollout_name&gt; &lt;rollout_caption&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4313\"></a>Creates an instance of rolloutCreator, assign it to a variable, \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4312\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4311\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F8A\"></a><pre>\nrci = rolloutCreator \"myRollout\" \"My Rollout\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-2F4E335A-DD04-48FB-BCBB-A9569965A41C\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F89\"></a><pre>&lt;rollout_creator&gt;.<em class=\"codeEmphasisStrong\">begin</em>()   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-430B\"></a>This function needs to be called immediately after the instance is created, this does\n               the initialization \n               		\n            </p> \n            <p><a name=\"GUID-7F55E50F-D47B-4562-801D-120BA1D2A6EC\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F88\"></a><pre>&lt;rollout_creator&gt;<em class=\"codeEmphasisStrong\">.addControl</em> &lt;control_type&gt; &lt;control_name&gt; &lt;control_caption&gt; [  <em class=\"codeEmphasisStrong\">paramStr</em>:&lt;string&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4308\"></a>Adds a control to the rollout: \n               		\n            </p> \n            <p><a name=\"GUID-1A0F5717-5610-4F52-B7DC-3EBBA599B5B5\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F87\"></a><pre>&lt;control_type&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4306\"></a>can be any of named rolloutControls eg: #button, #spinner, #activeXControl etc. \n               		\n            </p> \n            <p><a name=\"GUID-D83165F1-7637-42C8-B3AA-302A43E09B49\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F86\"></a><pre>&lt;control_name&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4304\"></a>variable name of the control by which it is referred eg: #btnButton \n               		\n            </p> \n            <p><a name=\"GUID-654A8445-5303-4C76-B08D-F2245A887D6D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F85\"></a><pre>&lt;control_caption&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4302\"></a>caption of the control \"My Button\" \n               		\n            </p> \n            <p><a name=\"GUID-FBE43301-8248-4CC0-B5AE-88D84DDA883D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F84\"></a><pre><em class=\"codeEmphasisStrong\">[paramStr:]</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4300\"></a>an optional string representation of all the keyword parameters that needs to be passed\n               to the control, for example: \"width:100 height:20 align:#right\" \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42FF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42FE\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F83\"></a><pre>\nrci.addControl #button #myButton \"My Button\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-07FF9585-F6FD-40ED-A022-4BF3F28C1972\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F82\"></a><pre>&lt;rollout_creator&gt;<em class=\"codeEmphasisStrong\">.addHandler</em> &lt;control_name&gt; &lt;event_type&gt; [<em class=\"codeEmphasisStrong\">paramStr</em>:&lt;string&gt;] [<em class=\"codeEmphasisStrong\">codeStr</em>:&lt;string&gt;] [<em class=\"codeEmphasisStrong\">filter</em>:&lt;boolean&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42F8\"></a>Adds an event handler for the controls previously added: \n               		\n            </p> \n            <p><a name=\"GUID-7821FBF0-1AA2-4A52-8FFB-F6C820760294\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F81\"></a><pre>&lt;control_name&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42F6\"></a>the variable passed during the control creation \n               		\n            </p> \n            <p><a name=\"GUID-A4AAD7FE-8BBF-4F25-A3B5-B0613856FE79\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F80\"></a><pre>&lt;event_type&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42F4\"></a>any of the events supported by the control, eg: #changed, #pressed, #selected \n               		\n            </p> \n            <p><a name=\"GUID-E75C05B8-9A53-409C-BCAF-DEEFE855D89F\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F7F\"></a><pre><em class=\"codeEmphasisStrong\">[paramStr:&lt;string&gt;]</em> </pre></div> \n            <p><a name=\"GUID-3E5E2F6F-AB5E-4ABF-87C2-31CA66E3AF86\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F7E\"></a><pre><em class=\"codeEmphasisStrong\">[codeStr:&lt;string&gt;]</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42F0\"></a>a string representation of the event handler code, if the string contains sub-strings,\n               enclose them in two \'@\' characters and pass on\\true to the filter: parameter \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42EF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42EE\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F7D\"></a><pre>\nrci.addHandler #myButton #pressed codeStr: \"MessageBox @Hey@\" filter:on\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF7E7AB08D12A3860DF8E-590B\"></a><p class=\"table-body\">This will add an event handler for button named \"myButton\". When the button is clicked,\n                           a messagebox pops up with the text \"hey\" in it. The final result inside the rollout\n                           definition will look like this: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F7C\"></a><pre>\non myButton presseddoMessageBox \"Hey\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42E3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42E2\"></a><p class=\"table-body\"> <em class=\"strong\">ANOTHER EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F7B\"></a><pre>\nrci.addHandler #myCheckbox #changed paramStr:\"val\" codeStr:\"myOtherCheckbox.state = not val\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-49D92FDB129CC323221-7E08\"></a><p class=\"table-body\">This will add an event handler for checkbox named \"myCheckbox\". When the state of\n                           the checkbox is changed, the state of another previously defined checkbox called \"myOtherCheckbox\"\n                           will also be changed to the inverted boolean value of the argument variable \"val\"\n                           which is passed the actual state of \"myCheckbox\". The final result inside the rollout\n                           definition will look like this: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F7A\"></a><pre>\non myCheckbox changed val do myOtherCheckbox.state = not val\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-299CA32A-EEB8-42AF-B8AA-1203493AF36B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F79\"></a><pre>&lt;rollout_creator&gt;<em class=\"codeEmphasisStrong\">.end</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42D6\"></a>This function has to be called whenever all the required controls and their event\n               handlers are called. This function forms the rollout string, evaluates it and returns\n               the definition which can be passed to createDialog and addRollout functions. \n               		\n            </p> \n            <p><a name=\"GUID-69E6C641-3DF8-4C2B-B15F-CD7C9C4D2BB1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F78\"></a><pre>&lt;rollout_creator&gt;<em class=\"codeEmphasisStrong\">.addLocal</em> &lt;string&gt; [<em class=\"codeEmphasisStrong\">init</em>:&lt;value&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42D3\"></a>This function can be used to add local variables to the rollout definitions. The variable’s\n               value can be initialized by passing the \n               		  <span class=\"code\"> <em class=\"strong\">init:</em> </span> value \n               		\n            </p> \n            <p><a name=\"GUID-C4028F77-F421-416F-9742-3F621F914EE1\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F77\"></a><pre>&lt;string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42D1\"></a>Name of local variable \n               		\n            </p> \n            <p><a name=\"GUID-CC56A812-939B-4E66-8004-8603B22E355C\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F76\"></a><pre><em class=\"codeEmphasisStrong\">init</em>: </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42CF\"></a>Specifies initialization value of local \n               		\n            </p> \n            <p><a name=\"GUID-984C53B4-11A3-4664-A775-DBAAFDA27C20\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F75\"></a><pre>&lt;rollout_creator&gt;<em class=\"codeEmphasisStrong\">.addText</em> &lt;string&gt; [<em class=\"codeEmphasisStrong\">filter</em>:&lt;boolean&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42CC\"></a>This function is useful for adding functions to the rollout definitions. If the string\n               contains sub-strings, enclose them in two \'@\' characters and pass true to the \n               		  <span class=\"code\"> <em class=\"strong\">filter</em> </span>: parameter \n               		\n            </p> \n            <p><a name=\"GUID-F5AC5B9D-C9A2-4A34-A8BF-3592AB83D328\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F74\"></a><pre>&lt;string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42CA\"></a>String added to rollout definition. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42C8\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42C7\"></a><p class=\"table-body\"> <em class=\"strong\">COMPLETE EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F73\"></a><pre>\nrci = rolloutCreator \"myRollout\" \"My Rollout\"\nrci.begin()\nrci.addControl #button #myButton \"My Button\"\nrci.addHandler #myButton #pressed filter:on codeStr:\"MessageBox @Isn\'t this cool@ title:@Wow@\"\ncreateDialog (rci.end())\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42BE\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-42BD\"></a><p class=\"table-body\"> <em class=\"strong\">ANOTHER EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6F72\"></a><pre>\nrfTest = rolloutCreator \"rfTestN\" \"rfTestC\"\n-- Start creating the rollout\nrfTest.begin()\nrfTest.addControl #button #myButton \"My Button\" -- add a button\nrfTest.addHandler #myButton #pressed filter:on codeStr:\"MessageBox @Look to the \\@Light\\@ thing@\"\nrfTest.end()\ncreateDialog rfTest.def\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";