var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-5FD967A2-25A0-40DB-A4CB-5B327A0AD689\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MultiTile : textureMap</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5FD967A2-25A0-40DB-A4CB-5B327A0AD689\"></a><div class=\"head\">\n            <h1> MultiTile : textureMap </h1>\n         </div>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MultiTile - superclass: textureMap; super-superclass:material - 2:2 - classID: #(736L, 0L)</em></pre></div>\n         <p>This textureMap implements support for UDIM, custom, Z-Brush and Mudbox-compatible\n            multi-tile textures. Available in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2804\"></a> <em class=\"strong\">Constructors:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MultiTile...</em> <em class=\"codeEmphasisStrong\">MultiTileMap...</em></pre></div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;MultiTile&gt;<em class=\"codeEmphasisStrong\">.PatternFormat</em>     Name    default: #ZBrush   --  enum</pre></div>\n         <p> Get/set the selection of the \n            		<em class=\"strong\">\"File Pattern Format\"</em> drop-down list. \n            	 \n         </p>\n         <p> Exposed by the MultiTile MixinInterface (see below). \n            	 \n         </p>\n         <p> Possible values are: \n            	 \n         </p>\n         <p> 0 - \n            		<em class=\"strong\">#ZBrush</em> (default) \n            	 \n         </p>\n         <p> 1 - \n            		<em class=\"strong\">#Mudbox</em> \n         </p>\n         <p> 2 - \n            		<em class=\"strong\">#UDIM</em> \n         </p>\n         <p> 3 - \n            		<em class=\"strong\">#Custom</em> \n         </p>\n         <p> Setting the property to the corresponding integer value from 0 to 3 is also supported.\n            \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;MultiTile&gt;<em class=\"codeEmphasisStrong\">.ViewportQuality</em>     Name    default: #low   --  enum</pre></div>\n         <p> Get/set the selection of the \n            		<em class=\"strong\">\"Viewport Quality\"</em> drop-down list. \n            	 \n         </p>\n         <p> Exposed by the MultiTile MixinInterface (see below). \n            	 \n         </p>\n         <p> Possible values are: \n            	 \n         </p>\n         <p> 0 - #<em class=\"strong\">Low</em> (default) \n            	 \n         </p>\n         <p> 1 - #<em class=\"strong\">Medium</em> \n         </p>\n         <p> 2 - #<em class=\"strong\">High</em> \n         </p>\n         <p> Setting the property to the corresponding integer value from 0 to 3 is also supported.\n            \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"section\"><a name=\"SECTION_5DDBCF5DB19A4C0AA2AFDE33B09FF753\"></a> \n            <h2><a name=\"GUID-AF136545-2BAF-4ECB-BE8E-6F3FCE73ADF4\"></a>MultiTile interfaces:\n            </h2> \n            <div class=\"codeBlock\"><pre>Interface: MultiTiles</pre></div> \n            <p><em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">.PatternFormat</em> : enum : Read|Write\nPatternFormat enums: {<em class=\"codeEmphasisStrong\">#ZBrush|#Mudbox|#UDIM|#Custom</em>}</pre></div> \n            <p> See the Properties: list above for details. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">.ViewportQuality</em> : enum : Read|Write\nViewportQuality enums: {<em class=\"codeEmphasisStrong\">#Low|#Middle|#High</em>}</pre></div> \n            <p> See the Properties: list above for details. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">setPatternedImageFile</em> &lt;filename&gt;filePath</pre></div> \n            <p> Sets the filename and path to the Patterned Image File. \n               		\n            </p> \n            <p> Returns True on success, False on failure (for example, if file was not found or\n               was not a valid patterned file). \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">setImageFile</em> &lt;index&gt;tile index &lt;filename&gt;filePath</pre></div> \n            <p> Sets the bitmap image to the indexed tile from the Patterned Image File specified\n               by the second argument. \n               		\n            </p> \n            <p> Returns True on success, False on failure. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">getTileUOffset</em> &lt;index&gt;tileIndex</pre></div> \n            <p> Returns the U offset of the indexed tile. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">setTileUOffset</em> &lt;index&gt;tileIndex &lt;integer&gt;uIndex</pre></div> \n            <p> Sets the U offset of the indexed tile to the offset specified by the second argument.\n               \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">getTileVOffset</em> &lt;index&gt;tileIndex</pre></div> \n            <p> Returns the V offset of the indexed tile. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">setTileVOffset</em> &lt;index&gt;tileIndex &lt;integer&gt;vIndex</pre></div> \n            <p> Sets the V offset of the indexed tile to the offset specified by the second argument.\n               \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;texturemap&gt;<em class=\"codeEmphasisStrong\">getTileTexmap</em> &lt;index&gt;tileIndex</pre></div> \n            <p> Returns a bitmapTexture map with the indexed tile. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">setTileTexmap</em> &lt;index&gt;tileIndex &lt;texturemap&gt;texmap</pre></div> \n            <p> Sets the indexed tile to the bitmapTexture map supplied as second argument. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">tileCount()</em></pre></div> \n            <p> Returns the number of tiles. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">addTile()</em></pre></div> \n            <p> Adds a tile. \n               		\n            </p> \n            <p> Equivalent to pressing the \"Add Tile\" icon next to the \"Number Of Textures\" field\n               in the UI. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">deleteTile</em> &lt;index&gt;tile index</pre></div> \n            <p> Deletes the indexed tile. \n               		\n            </p> \n            <p> Equivalent to pressing the \"Delete Tile\" icon next to the Tile name button in the\n               UI. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p> <em class=\"strong\">Actions:</em> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";