var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-60A6F37F-D8CB-4A73-BE89-1F6A8F542CE0\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface DialogMonitorOPS\">\n      <meta name=\"indexterm\" content=\"DialogMonitorOPS Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: DialogMonitorOPS</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-60A6F37F-D8CB-4A73-BE89-1F6A8F542CE0\"></a><div class=\"head\">\n            <h1>Interface: DialogMonitorOPS </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A652B\"></a> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A652F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6530\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; DialogMonitorOPS \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6531\"></a>The <em class=\"strong\">DialogMonitorOPS Core Interface</em> provides a callback system to monitor the <em class=\"strong\">3ds Max</em> User Interface. In conjunction with the <span class=\"char_link\"><a href=\"GUID-CA86733B-05E1-4F7E-A589-FF20E75CE094.htm\">Interface: UIAccessor</a></span> it can be used to collect data and interact with dialogs and popups, for example\n               to press the default or specific button in a pop-up dialog when running automated\n               tasks or log data about the <em class=\"strong\">3ds Max</em> UI activities to a log file. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6532\"></a>Available in <em class=\"strong\">3ds Max 9</em> and higher. \n            </p> \n            <p><a name=\"GUID-70EB4BB9-82EC-4705-A254-097E5CE7467C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6533\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5AB5\"></a><pre><em class=\"codeEmphasisStrong\">DialogMonitorOPS</em>.<em class=\"codeEmphasisStrong\">Enabled</em> : bool : Read|Write 	 </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6534\"></a>Get/Set the enabled state of the Dialog Monitor. \n            </p> \n            <p><a name=\"GUID-30571598-CC3B-41DC-A6F0-3BF3FCF67FB4\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5AB4\"></a><pre><em class=\"codeEmphasisStrong\">DialogMonitorOPS</em>.<em class=\"codeEmphasisStrong\">Interactive</em> : bool : Read|Write   </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6535\"></a>Get/Set the interactive state of the Dialog Monitor. \n            </p> \n            <p><a name=\"GUID-B9E0A12D-A3B1-416C-8477-9AF88E923109\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6536\"></a> <em class=\"strong\">Methods</em>: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5AB3\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">DialogMonitorOPS.RegisterNotification</em> &lt;value&gt;Callback  <em class=\"codeEmphasisStrong\">ID:</em>&lt;name&gt; \n\nID defaultvalue: undefined </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6537\"></a>Registers a notification callback function with an optional user-defined ID. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6538\"></a>The callback function can be any MAXScript function and will be called each time a\n               dialog or menu is opened, but the best way to use this feature is to access the dialog\'s\n               or menu\'s data using the <span class=\"char_link\"><a href=\"GUID-CA86733B-05E1-4F7E-A589-FF20E75CE094.htm\">Interface: UIAccessor</a></span> methods. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A6539\"></a>The callback function MUST return a Boolean value - true on success, false on failure.\n               \n            </p> \n            <p><a name=\"GUID-FB289FC0-3B03-412B-A7AF-EC7FBF6975A0\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5AB1\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">DialogMonitorOPS.UnRegisterNotification ID:</em>&lt;name&gt; \n\nID defaultvalue: undefined </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A653A\"></a>Unregisters the notification callbacks with the user-defined ID. If no ID is specified,\n               all callbacks will be unregistered. \n            </p> \n            <p><a name=\"GUID-75FB7787-F118-44F2-8D96-B8144B75D717\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5AAF\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">DialogMonitorOPS.ShowNotification</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A653B\"></a>Lists all registered notification callbacks with their ID and callback function. \n            </p> \n            <p><a name=\"GUID-E9E9D626-55FC-45FD-972A-D5B1BC391861\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5AAE\"></a><pre>&lt;HWND&gt;<em class=\"codeEmphasisStrong\">DialogMonitorOPS.GetWindowHandle</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A653C\"></a>Returns the Window Handle of the current dialog. The handle can be used as an argument\n               in most <span class=\"char_link\"><a href=\"GUID-CA86733B-05E1-4F7E-A589-FF20E75CE094.htm\">Interface: UIAccessor</a></span> methods to collect details about the current dialog and manipulate it. \n            </p> \n            <p><a name=\"GUID-FBB488C9-8DC0-49EE-A449-1F1CDAB321C8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A653D\"></a> <span class=\"char_link\"><a href=\"GUID-CA86733B-05E1-4F7E-A589-FF20E75CE094.htm\">Interface: UIAccessor</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";