var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-61344DFE-8DA6-4E19-A184-BFD9ED093EFF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Render To Texture Using MAXScript</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-61344DFE-8DA6-4E19-A184-BFD9ED093EFF\"></a><div class=\"head\">\n            <h1>Render To Texture Using MAXScript </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-317F\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-317B\"></a> <em class=\"strong\">Render To Texture</em> (also known as \n               		  <em class=\"strong\">Texture Baking</em>) is a procedure for capturing various aspects of \n               		  <em class=\"strong\">3ds Max</em> geometry scene objects\' surfaces to bitmaps using the production renderer. The \n               		  <span class=\"char_link\"><a href=\"GUID-D4C5C5DF-7447-485F-9802-2E5328037EBE.htm\">Default Scanline renderer</a></span> supports this functionality. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-317A\"></a>The actual \n               		  <em class=\"strong\">3ds Max Render To Texture tool</em> available through the \n               		  <em class=\"strong\">Main Menu&gt;Rendering&gt;Render To Texture</em> menu item is implemented as a scripted tool.Its source code can be found in the following\n               subfolder of the \n               		  <em class=\"strong\">3ds Max</em> installation: \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3179\"></a> <em class=\"strong\">..\\ui\\macroscripts\\Macro_BakeTextures.mcr</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3178\"></a>In addition, some Render To Texture methods used by the network version of the tool\n               can be found in the file \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3177\"></a> <em class=\"strong\">..\\stdplugs\\stdscripts\\RTT_methods.ms</em> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3176\"></a> \n            <h2><a name=\"GUID-A774A922-2D1E-47B0-8B2E-286252186F73\"></a> <em class=\"strong\">Render To Texture Components</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3175\"></a>Here is a short overview of the MAXScript classes, interfaces, properties and methods\n               used in the process and how to use them to create your own texture baking tools: \n               		\n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3173\"></a> \n               <h3><a name=\"GUID-0970C32D-2C49-4D9C-970C-0965F2B067D7\"></a> <em class=\"strong\">Bake Elements</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3172\"></a>The main object class involved in the texture baking process is the \n                  			 <span class=\"char_link\"><a href=\"GUID-60C2F166-93C0-4061-B12D-3616AE38B922.htm\">Bake Element</a></span>. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3171\"></a>It implements an object capable of capturing a specific channel out of the production\n                  renderer, for example Diffuse, Lighting, Ambient Occlusion, Normals, Shadows and so\n                  on. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-316F\"></a> \n               <h3><a name=\"GUID-EA17DE26-3694-4129-AC74-4EACE608BAB4\"></a> <em class=\"strong\">INodeBakeProperties Interface</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-316E\"></a>The geometry objects whose surfaces will be baked have to be set up for the process\n                  using the \n                  			 <span class=\"char_link\"><a href=\"GUID-0BFEF796-5952-48B0-8929-88475F927649.htm\">INodeBakeProperties Interface</a></span> exposed by all scene nodes. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-316D\"></a>This interface is used to add one or more Bake Elements to specific nodes, enable\n                  the baking and control some other related parameters. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-316B\"></a> \n               <h3><a name=\"GUID-4E0418CC-5450-4E7F-98E2-CA2767FCBA3C\"></a> <em class=\"strong\">Production Renderer</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-316A\"></a>The \n                  			 <span class=\"char_link\"><a href=\"GUID-9175301C-13E6-488B-ABA6-D27CD804B205.htm\">production renderer</a></span>, including the \n                  			 <span class=\"char_link\"><a href=\"GUID-D4C5C5DF-7447-485F-9802-2E5328037EBE.htm\">Default Scanline renderer</a></span>, has to be called via MAXScript in a special mode invoked via \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C61\"></a><pre><em class=\"codeEmphasisStrong\">render rendertype:#bakeSelected</em></pre></div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3167\"></a> \n               <h3><a name=\"GUID-927A9F8A-583E-4AA6-80BD-D0BC36FE44CA\"></a> <em class=\"strong\">Unwrap UVW</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3166\"></a>For the baked texture to be usable, the object being rendered has to provide good\n                  texture coordinates without any overlapping. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3165\"></a>The Render To Texture script shipping with \n                  			 <em class=\"strong\">3ds Max</em> provides controls over the automatic application and setup of \n                  			 <span class=\"char_link\"><a href=\"GUID-17D700DC-1FDC-4713-8041-D9E3C3EB4789.htm\">Unwrap_UVW Modifiers</a></span> to ensure the texture coordinates are usable for baking. You might have to ensure\n                  the same in your own script, unless your object has good UV coordinates to work with.\n                  \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3163\"></a> \n               <h3><a name=\"GUID-EF0459D5-57B6-4F35-A2AC-02F69EFC38AA\"></a> <em class=\"strong\">Projection Mapping</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3162\"></a>In some cases, especially when generating Normal Maps, the surface being rendered\n                  is a high-resolution version of an object, while the target object being mapped is\n                  a lower-resolution version. In this case, the texture coordinates of the low-resolution\n                  object have to be generated by projecting from the high-resolution one. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3161\"></a>The \n                  			 <span class=\"char_link\"><a href=\"GUID-E8E1CE84-5209-451C-AB5B-2222DE54F925.htm\">Interface: INodeBakeProjProperties</a></span>, the \n                  			 <span class=\"char_link\"><a href=\"GUID-73AC907D-1FE9-4B9B-8091-8B1AB98F1E85.htm\">Projection Modifier</a></span> and the \n                  			 <span class=\"char_link\"><a href=\"GUID-F33E997F-2194-49BC-80D8-83C068B639C9.htm\">Project_Mapping ReferenceTarget</a></span> are the main elements of the Projection Mapping system of \n                  			 <em class=\"strong\">3ds Max</em>. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-315F\"></a> \n               <h3><a name=\"GUID-41E45009-1F93-436A-8192-6A33FFB00881\"></a> <em class=\"strong\">Shell Material</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-315E\"></a>The \n                  			 <span class=\"char_link\"><a href=\"GUID-02E37D03-C1D5-4345-984F-70F44F614DEE.htm\">Shell Material</a></span> has been specifically designed to be used together with the Render To Texture tools.\n                  It can hold two different materials, typically the original material and the baked\n                  material. Either one can be used in the Viewport or in the Renderer. \n                  		  \n               </p> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-315C\"></a> \n            <h2><a name=\"GUID-C778C34C-F33D-42E6-8DFB-794C412243DD\"></a> <em class=\"strong\">Developing a Simple Render To Texture Script</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-315B\"></a>The following example shows the basic steps to create a custom Render To Texture script.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-315A\"></a>The script creates a simple scene containing a textured sphere on a textured plane\n               lit by a shadow-casting omni light. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3159\"></a>Then it bakes the Diffuse and Lighting Elements of both objects to TGA files on disk\n               and creates a Shell Material containing the old material in the one slot and the baked\n               material in the other. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3158\"></a>The Baked material uses a Composite map to combine the diffuse and the lighting information\n               into a single diffuse map. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3157\"></a>In this simple case, the texture coordinates of both objects are procedurally generated\n               by the geometry primitives and are usable for baking. Also, no projection mapping\n               is required in this simple case. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3155\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3154\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C60\"></a><pre>\nfn BakeDiffuseAndLighting obj size =\n(\n--Clear all render elements \nobj.iNodeBakeProperties.removeAllBakeElements() \n--Preparing the Bake Elements:\nbe1 = diffusemap() --instance of the bake element class\nbe1.outputSzX = be1.outputSzY = size --set the size of the baked map\n--specifythe full file path, name and type:\nbe1.fileType = (getDir #image+\"\\\\\"+obj.name+\"_diffuse.tga\")\nbe1.fileName = filenameFromPath be1.fileType\nbe1.filterOn = true --enable filtering\nbe1.shadowsOn = false --disable shadows\nbe1.lightingOn = false --disable lighting\nbe1.enabled = true --enable baking\nbe2 = LightingMap() -- instance of the bake element class\nbe2.outputSzX =be2.outputSzY = size --set the size of the baked map\n--specifythe full file path, name and type:\nbe2.fileType = (getDir #image+\"\\\\\"+obj.name+\"_lighting.tga\")\nbe2.fileName = filenameFromPath be2.fileType\nbe2.filterOn = true --enable filtering\nbe2.shadowsOn =true --enable shadows\nbe2.enabled = true --enable baking\n--Preparing theobjectfor baking:\nobj.INodeBakeProperties.addBakeElement be1 --add first element\nobj.INodeBakeProperties.addBakeElement be2 --add second element\nobj.INodeBakeProperties.bakeEnabled = true --enabling baking\nobj.INodeBakeProperties.bakeChannel = 1 --channel to bake\nobj.INodeBakeProperties.nDilations = 1 --expand the texturea bit\nselect obj --we are baking the selection, so we select the object\n--Call the renderer to bake both elements:\nrender rendertype:#bakeSelected vfb:off progressBar:true outputSize:[size,size]\ntheComp = CompositeTextureMap() --create a composite map\ntheComp.add() --add a second layer\ntheComp.blendMode = #(0,5) --set second layer to Multiply \n--Create two maps, one with the diffuse, one with the lighting map\ntheMap1 =bitmaptexture filename:be1.fileType\ntheMap2=bitmaptexture filename:be2.fileType\ntheComp.mapList = #(theMap1,theMap2) --composite the two maps\ntheComp.opacity = #(100,70) --set the lighting map to 70% opacity\n--Create a standard self-illum material using the Composite map\nbakedMat = standard diffusemap:theComp selfIllumAmount:100\n--Assign a Shell Material to the object,\n--keep the old material as original material,\n--set the new bakedMat as the baked material:\nobj.material = Shell_Material originalMaterial:obj.material\\\nbakedMaterial:bakedMat viewportMtlIndex:1 renderMtlIndex:1\n--Show the textures of the baked material in the viewport\nshowTextureMap obj.material obj.material.bakedMaterial true\n)--end fn\nresetMaxFile #noprompt--reset the scene to start from scratch\n--Create a shadow casting white Omni light\ntheLight = omniLight pos:[0,-60,100] rgb:white\ntheLight.baseobject.castshadows = true\n--Create a mapped sphere object above the ground plane\ntheObject = Sphere segs:32 mapcoords:true pos:[0,0,25]\n--Create a Cellular map and assign via Standard material to object\ntheMap = cellular cellColor:blue divColor1:red divColor2:yellow size:15\ntheObject.material = standard diffusemap:theMap\n--Call the Bake function with the object and the desired size\nBakeDiffuseAndLighting theObject 256\n--Create a mappedplaneobjecton theground plane\ntheObject = Plane width:200 length:200 mapcoords:true\n--Create a checker map and set the tiling to 4x4, then assign to object\ntheMap = checker Color1:green Color2:orange\ntheMap.coordinates.uTiling = theMap.coordinates.vTiling = 4\ntheObject.material = standard diffusemap:theMap\n--Call the Bake function with the object and the desired size\nBakeDiffuseAndLighting theObject 256\n--Delete the light from the scene and deselect everything\ndelete theLight\nmax select none\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-30FA\"></a><p class=\"table-body\"> <em class=\"strong\">RESULTS</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-30F9\"></a><p class=\"table-body\">After running the script, the following four baked textures will be written to the\n                           Images folder and will appear on the scene objects in the viewports: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-30F7\"></a><p class=\"table-body\"> <img src=\"../images/GUID-FF0F53D5-EE97-47A9-AF27-694AC2FF4560-low.gif\"> <img src=\"../images/GUID-45F90F71-AE5C-45FC-832A-E2580C954135-low.gif\"> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-30F6\"></a><p class=\"table-body\"> <img src=\"../images/GUID-9E043D54-9F4C-467C-8FE5-B1957AC096D9-low.gif\"> <img src=\"../images/GUID-95AFC7E6-E364-46E0-9FD1-C2FEF4922189-low.gif\"> \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-30F5\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-22F2E537-1BD7-40A2-B9C6-8DF33DA01B87-low.gif\"></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-30F1\"></a> <span class=\"char_link\"><a href=\"GUID-60C2F166-93C0-4061-B12D-3616AE38B922.htm\">Bake Elements</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-30F0\"></a> <span class=\"char_link\"><a href=\"GUID-0BFEF796-5952-48B0-8929-88475F927649.htm\">Interface: INodeBakeProperties</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-30EF\"></a> <span class=\"char_link\"><a href=\"GUID-CA3EA4FD-2A33-4BC5-AAC8-2B75C0E45147.htm\">RTT_Methods : Render To Texture Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";