var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-615D14FB-0F2D-4801-B381-1128C4128C70\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"scripts\">\n      <meta name=\"indexterm\" content=\"script files\">\n      <meta name=\"indexterm\" content=\"rollouts\">\n      <meta name=\"indexterm\" content=\"files\">\n      <meta name=\"indexterm\" content=\"UI setting - customizing\">\n      <meta name=\"indexterm\" content=\"startup: script files\">\n      <meta name=\"indexterm\" content=\"startup: organizing scripts\">\n      <meta name=\"indexterm\" content=\"plug-ins: defining\">\n      <meta name=\"indexterm\" content=\"loading - automatic\">\n      <meta name=\"indexterm\" content=\"function libraries\">\n      <meta name=\"indexterm\" content=\"automatic loading\">\n      <meta name=\"indexterm\" content=\"auto-load\">\n      <meta name=\"indexterm\" content=\"auto start MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Startup Scripts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-615D14FB-0F2D-4801-B381-1128C4128C70\"></a><div class=\"head\">\n            <h1>Startup Scripts </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B52\"></a>             When \n            		<em class=\"strong\">3ds Max</em> is first started, MAXScript searches for any startup script files that it then automatically\n            loads and runs. This feature is useful if you have function libraries you always use\n            and want preloaded, or if you want to establish custom UI settings, define scripted\n            plug-ins, or load scripted utility rollouts. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B60\"></a>When \n            		<em class=\"strong\">3ds Max</em> starts up, it will always follow the script loading order described below. Certain\n            parts of the software will still not be up and running at different stages of the\n            startup process. Understanding the order and the reasons for it will help you organize\n            your code and have all functions and UI auto-loading and working correctly together.\n            \n            	 \n         </p>\n         <div><a name=\"GUID-E8DE1ECB-D704-4857-BE08-03692C81A308\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>3ds Max looks for scripts of type \n               		<span class=\"filePath\">.ms</span> and \n               		<span class=\"filePath\">.mcr</span>. If you have scripts that you don\'t want to load automatically, for example library\n               scripts you explicitly load in other scripts, you can give them the \n               		<span class=\"filePath\">.mxs</span> extension. This extension is still recognized as executable by the MAXScript Editor.\n               \n               	 \n            </div>\n         </div>\n         <div><a name=\"GUID-E2077008-ADE1-485A-A1CF-C43DD8401711\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>You can use the \n               		<span class=\"char_link\"><a href=\"GUID-53F8D6CE-A5A6-4353-BE48-4298BBE107DE.htm\">getMaxscriptStartupState()</a></span> function to determine if standard or startup scripts are currently loading, or are\n               loaded.\n               	 \n            </div>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B61\"></a> \n            <h2><a name=\"GUID-CCFFB287-112B-4A77-AD4C-6BE778B62EBA\"></a> <em class=\"strong\">Launching 3ds Max Without a File</em> \n            </h2> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B62\"></a> \n               <h3><a name=\"GUID-7236B3D6-D269-4D4B-B985-E166CA7DF28F\"></a> <em class=\"strong\">STEP 1 - Standard Scripts</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B63\"></a><em class=\"strong\">3ds Max</em> will evaluate the shipping scripts found under \n                  			 <em class=\"mild\">stdplugs\\stdscripts</em>. These define functions needed by several scripted elements of the base \n                  			 <em class=\"strong\">3ds Max</em> software. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B64\"></a>If you need to have some functions/global variables defined for use by your own MacroScript,\n                  those should go into an .ms file in \n                  			 <em class=\"mild\">stdplugs\\stdscripts</em>. This will ensure that they will be defined first. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B65\"></a> \n               <h3><a name=\"GUID-286B0718-A8DF-41CE-9D96-7DAC2DB8C02E\"></a> <em class=\"strong\">STEP 2 - User-Defined Plug-in Paths</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B66\"></a>Next, \n                  			 <em class=\"strong\">3ds Max</em> will load script files in directories defined in Customize... &gt; Configure Paths...\n                  &gt; Plug-Ins \n                  			 <em class=\"strong\">and their subdirectories. \n                     			 </em>Note that this is different from the way regular plug-ins are loaded. Plug-ins will\n                  only load from the specified path and not search sub-directories. Here you can define\n                  functions, methods, and structures used by other scripts, particularly MacroScripts.\n                  \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B67\"></a>The \n                  			 <em class=\"strong\">3ds Max \n                     			 </em>scene has not been created and the viewports have not been created at this point.\n                  You cannot create scene objects or do anything UI related in these scripts. Of course\n                  you can define functions that do these operations, you just can\'t call these functions\n                  at this point. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B68\"></a>In this pass, any script files with the name \n                  			 <em class=\"mild\">startup.ms</em> are ignored. This allows you to place your scripted plug-in scripts in the plug-in\n                  folders for automatic loading. They can be managed like DLL plug-ins, and used to\n                  organize your startup scripts into groups in their own directories for easier management.\n                  You can prevent a nested directory from being scanned by placing its name in parentheses,\n                  for example \"(old-versions)\", allowing you to enable and disable scripts in handy\n                  directory-based groupings. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B69\"></a> \n               <h3><a name=\"GUID-B03B401A-20BB-428B-A729-A5DCDF90FD0C\"></a> <em class=\"strong\">STEP 3 - MacroScripts</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B6A\"></a>Next, MacroScript .mcr files in \n                  			 <em class=\"mild\">ui\\macroscripts</em> will be evaluated - they define Action Items that can be displayed in the UI. At\n                  this point, UI has not been built yet, the MacroScripts will be needed to fill in\n                  their related buttons. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B6B\"></a> \n               <h3><a name=\"GUID-30E09541-2F00-4EF7-9DE7-397432376785\"></a> <em class=\"strong\">STEP 4 - Startup Scripts</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B6C\"></a>Finally, the \n                  			 <em class=\"mild\">startup.ms</em> and then any scripts found in the startup folders will be evaluated. At this point,\n                  scene, viewports, and UI are up. You can do anything here you want. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B6D\"></a>In \n                  			 <em class=\"strong\">3ds Max 9 and higher</em>, startup scripts in the \n                  			 <em class=\"strong\">3ds Max system startup scripts</em> directory are run first, then the startup scripts in the \n                  			 <em class=\"strong\">user startup scripts</em> directory are run, providing that the user startup scripts directory is different\n                  than the max system startup scripts directory. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B6E\"></a>MAXScript first searches for a file named \n                  			 <em class=\"mild\">startup.ms</em> in the following directories, in the order listed: \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B6F\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B71\"></a>The user scripts directory \n                        				\n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B73\"></a>The user startup scripts directory \n                        				\n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B75\"></a>The3ds Max system scripts directory \n                        				\n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B77\"></a>The3ds Max system startup scripts directory \n                        				\n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B79\"></a>The 3ds Max executable main directory \n                        				\n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B7B\"></a>The Windows NT 32-bit system directory (system32) \n                        				\n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B7D\"></a>The Windows 16-bit system directory (system) \n                        				\n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B7F\"></a>The Windows directory \n                        				\n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B81\"></a>The directories that are listed in the PATH environment variable \n                        				\n                     </p> \n                  </li>\n               </ul> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B82\"></a>MAXScript stops searching when it finds the first occurrence of \n                  			 <em class=\"mild\">startup.ms</em>. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B83\"></a>The automatic loading of startup script files can be deactivated by turning off the\n                  Auto Start MAXScript option in the MAXScript page of the Preferences dialog, as described\n                  in the MAXScript Preferences Settings topic in the main product online help. \n                  		  \n               </p> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B85\"></a> \n            <h2><a name=\"GUID-7BDDBA46-CC8C-44C2-9539-1B200986B3E3\"></a> <em class=\"strong\">Launching 3ds Max With a File</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-340E\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-340D\"></a>Consider the following two use cases:\n            </p>\n            <ol type=\"1\" start=\"1\">\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B87\"></a>Starting \n                     				<em class=\"strong\">3ds Max</em> from the command line, eventually with a \n                     				<span class=\"char_link\"><a href=\"GUID-A04C0E75-F82A-41AC-92E8-D7CB1D797430.htm\">command line script</a></span>: \n                     			 \n                  </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B88\"></a><div class=\"table-ruled\">\n                     <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                        <colgroup>\n                           <col width=\"100%\">\n                        </colgroup>\n                        <tr class=\"ruled-odd-row\">\n                           <td class=\"table-body\"> \n                              <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63AF\"></a><pre>3dsmax.exe somefile.max\n3dsmax.exe somefile.max -U MAXScript somescript.ms</pre></div> \n                           </td>\n                        </tr>\n                     </table>\n                  </div> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B8D\"></a>Dragging a.MAXfile onto a \n                     				<em class=\"strong\">3ds Max \n                        				</em>shortcut on your desktop \n                     			 \n                  </p> \n               </li>\n            </ol> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B8F\"></a>In both cases, \n               		  <em class=\"strong\">3ds Max \n                  		  </em>boots up as described above and then loads the file. \n               		\n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-340A\"></a> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B90\"></a>In<em class=\"strong\"> 3ds Max 2009 and earlier</em>, the order of script folders and callbacks getting executed was as follows: \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B91\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"50%\">\n                        <col width=\"50%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B92\"></a><p class=\"table-body\"> <em class=\"strong\">Folder / Callback Processed</em> \n                           </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B93\"></a><p class=\"table-body\"> <em class=\"strong\">Comments</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <span class=\"code\">stdplugs\\stdscripts\\</span> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B95\"></a><p class=\"table-body\">3ds Max scene and UI not created yet. \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <span class=\"code\">plugin paths</span> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B97\"></a><p class=\"table-body\">3ds Max scene and UI not created yet. \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <span class=\"code\">MacroScripts</span> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B99\"></a><p class=\"table-body\">UI not created yet. \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <span class=\"code\">#filePreOpenProcess</span> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B9B\"></a><p class=\"table-body\">Scene created. \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <span class=\"code\">#filePreOpen</span> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B9D\"></a><p class=\"table-body\">Startup scripts not loaded yet! \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <span class=\"code\">\\Startup</span> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4B9F\"></a><p class=\"table-body\">File objects not accessible yet! \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <span class=\"code\">.MAX File</span> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BA1\"></a><p class=\"table-body\">Loading the command line / dropped file \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <span class=\"code\">#filePostOpen</span> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BA3\"></a><p class=\"table-body\">Scene objects are accessible from here on. \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <span class=\"code\">#filePostOpenProcess</span> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BA5\"></a><p class=\"table-body\">File has finished loading. \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <span class=\"code\">-U MAXScript script</span> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BA7\"></a><p class=\"table-body\">Executing the command line script (if any) \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BA9\"></a>As result, scripts loaded from the \\Startup folder could NOT be used by \n                  			 <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-4D9E\">#filePreOpen event callbacks</a></span>! \n                  		  \n               </p> \n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BAB\"></a>In \n               		  <em class=\"strong\">3ds Max 2010 \n                  		  </em>the load order has been changed to: \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BAC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"52.37556561085973%\">\n                     <col width=\"47.624434389140276%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BAD\"></a><p class=\"table-body\"> <em class=\"strong\">Folder / Callback Processed</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BAE\"></a><p class=\"table-body\"> <em class=\"strong\">Comments</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">stdplugs\\stdscripts\\ \n                           					 </span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BB0\"></a><p class=\"table-body\">3ds Max scene and UI not created yet. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">plugin paths \n                           					 </span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BB2\"></a><p class=\"table-body\">3ds Max scene and UI not created yet. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">MacroScripts \n                           					 </span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BB4\"></a><p class=\"table-body\">UI not created yet. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">\\Startup \n                           					 </span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BB6\"></a><p class=\"table-body\">UI Created. Startup scripts loaded \n                           						<em class=\"strong\">before callbacks</em>! \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">#filePreOpenProcess \n                           					 </span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BB8\"></a><p class=\"table-body\">Scene created. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">#filePreOpen \n                           					 </span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BBA\"></a><p class=\"table-body\">File objects not accessible yet. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">.MAX File \n                           					 </span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BBC\"></a><p class=\"table-body\">Loading the command line / dropped file \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">#filePostOpen \n                           					 </span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BBE\"></a><p class=\"table-body\">Scene objects are accessible from here on. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"code\">#filePostOpenProcess</span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BC0\"></a><p class=\"table-body\">File has finished loading. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"code\">Command Line -U MAXScript script \n                           					 </span> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BC2\"></a><p class=\"table-body\">Executing the command line script (if any) \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"GUID-53F8D6CE-A5A6-4353-BE48-4298BBE107DE.htm\">getMaxscriptStartupState() in Miscellaneous Functions\n                           		</a></span></li>\n                  <li><span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">#preStartupScriptLoad in General Event Callback Mechanism\n                           		</a></span></li>\n                  <li><span class=\"char_link\"><a href=\"GUID-A04C0E75-F82A-41AC-92E8-D7CB1D797430.htm\">Running Scripts from the Command Line \n                           		</a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";