var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-6171A574-2BEE-4259-8D34-2B31E324020B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Rendered Frame Window and MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Rendered Frame Window and MAXScript</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6171A574-2BEE-4259-8D34-2B31E324020B\"></a><div class=\"head\">\n            <h1>Rendered Frame Window and MAXScript </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31CF\"></a> The <em class=\"strong\">Rendered Frame Window</em> (a.k.a. Virtual Frame Buffer or VFB) provides <em class=\"strong\">Iterative</em> and <em class=\"strong\">Production</em> rendering workflows in <em class=\"strong\">3ds Max 2009 and higher</em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31CD\"></a>The renderer-specific extensions have been implemented using MAXScript.This means\n            that the controls exposed to the top and bottom panel of the Rendered Frame Window\n            can be enhanced or replaced by technical artists and technical directors to facilitate\n            various workflows and 3<sup> <span class=\"charspan-emphasis\">rd</span> </sup>party renderers using only MAXScript. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31CC\"></a>The following MAXScript additions provide ways to access the Rendered Frame Window\n            and its properties and register new rollouts in its panels: \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31CB\"></a> <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-4E0B\">Image Viewer DisplayNotifications</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31CA\"></a>Two new notifications have been added to the General Event Callbacks mechanism: <span class=\"code\"> <em class=\"strong\">#preImageViewerDisplay</em> </span> and <span class=\"code\"> <em class=\"strong\">#postImageViewerDisplay</em> </span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31C9\"></a>They are broadcast before and after the Rendered Frame Windows has been opened. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31C8\"></a> <span class=\"char_link\"><a href=\"GUID-2C2819EA-8997-45DF-8ED6-A81FE3E154A4.htm\">Interface:IVFB</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31C7\"></a>The <span class=\"code\"> <em class=\"strong\">callbacks.notificationParam()</em> </span> method, if executed within the callback script, will return an <em class=\"strong\">IVFB Interface</em> which provides the properties and methods exposed by the Rendered Frame Window. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31C4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31C3\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31C2\"></a><p class=\"table-body\">The following example REMOVES the original callbacks defined in the file ..\\<em class=\"strong\">StdPlugs\\StdScripts\\VFB_Methods.ms</em> and defines new rollouts for the rollout panels. \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31C1\"></a><p class=\"table-body\">In order to restore the original functionality, evaluate the </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31C0\"></a><p class=\"table-body\"> <span class=\"code\"> <em class=\"strong\">callbacks.removeScripts #preImageViewerDisplay</em> </span> \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31BF\"></a><p class=\"table-body\">then run the above-mentioned script to register the original callbacks. </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-31BE\"></a><p class=\"table-body\">Alternatively, simply restart <em class=\"strong\">3ds Max</em>. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C62\"></a><pre>\n(\nglobal MyFirstVFBLayout --the function needs to be global\nfn MyFirstVFBLayout VFB_Interface = ( --will be called by the callback\n--if the window is a Rendered Frame Window,\nif VFB_Interface.IsFramebuffer do (\n--set all borders to 0 to save screen estate\nVFB_Interface.SetMetric #horzMarginLeft 0\nVFB_Interface.SetMetric #horzMarginCenter 0\nVFB_Interface.SetMetric #horzMarginRight 0\nVFB_Interface.SetMetric #vertMarginTop 0\nVFB_Interface.SetMetric #vertMarginCenter 0\nVFB_Interface.SetMetric #vertMarginBottom 0\nVFB_Interface.SetMetric #minClientWidth 320\nVFB_Interface.SetMetric #minClientHeight 240\n--Definesome stand-in rollouts to display in the three panels:\nrollout theTopLeftRollout \"Top Left Rollout\" width:200 height:45 (\ndropdownlist ddl_topLeft items:#(\"View\",\"Region\",\"Crop\") width:160\nbutton btn_topLeft \"Top Left Button\" width:160 )\nrollout theTopRightRollout \"Top Right Rollout\" width:200 height:50(\nbutton btn_topLeft\"Top Right Button...\")\nrollout theBottomRollout \"Bottom Rollout\" width:200 height:22(\nbutton btn_bottomButton \"Bottom Button (Try to say 3 times fast!)\"\n)\n--Initialize the top left panel to a size and\n--get its RolloutFloater value back:\ntheTopLeftFloater = VFB_Interface.InitRolloutWindow #TopLeft 200 60\n--Add the rollout to the RolloutFloater without borders and tile bar:\naddRollout theTopLeftRollout theTopLeftFloater border:false\n--and enable the visibility of the top left panel:\nVFB_Interface.SetRolloutWindowVisible #TopLeft true\n--Initialize the top right panel to a size and\n--get its RolloutFloater value back:\ntheTopRightFloater = VFB_Interface.InitRolloutWindow #TopRight 200 60\n--add the rollout to the RolloutFloater WITH borders and tile bar:\naddRollout theTopRightRollout theTopRightFloater border:true\n--and enable the visibility of the top left panel:\nVFB_Interface.SetRolloutWindowVisible #TopRight true\n--Initialize the bottom panel to a size and\n--get its RolloutFloater value back:\ntheBottomFloater = VFB_Interface.InitRolloutWindow #Bottom 400 35\n--add the rollout to the RolloutFloater without borders and tile bar:\naddRollout theBottomRollout theBottomFloater border:false\n--and enable the visibility of the top left panel:\nVFB_Interface.SetRolloutWindowVisible #Bottom true\nVFB_Interface.InitLayout() --finally, initialize the new layout\n)--end if\n)--end fn\n--unregister any related callbacks:\ncallbacks.removeScripts #preImageViewerDisplay\n--register a pre-image viewer display callback\ncallbacks.addScript #preImageViewerDisplay \"MyFirstVFBLayout (callbacks.notificationParam())\" id:#ResizeVFBPanels\n)--end script\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3181\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-FEDD3A65-6C6F-4096-9351-9ABC8F03D2F2-low.gif\"></div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";