var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-6185357B-C725-4E04-9619-FA0A31F73525\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"translate()\">\n      <meta name=\"indexterm\" content=\"scale()\">\n      <meta name=\"indexterm\" content=\"rectify()\">\n      <meta name=\"indexterm\" content=\"isEmpty()\">\n      <meta name=\"indexterm\" content=\"empty()\">\n      <meta name=\"indexterm\" content=\"contains()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Box2 Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6185357B-C725-4E04-9619-FA0A31F73525\"></a><div class=\"head\">\n            <h1>Box2 Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FEE\"></a>The \n            		<em class=\"strong\">Box2</em> class describes a 2D rectangular region using integer coordinates. The Box2 class\n            provides methods that return individual coordinates of the box, scale and translate\n            it, retrieve its center, modify its size, and determine if points are inside the box.\n            Box2 values are primarily used in the viewport graphics methods described in \n            		<span class=\"char_link\"><a href=\"GUID-1B088FF0-6A36-420E-9F37-F0DBE9FB2676.htm\">Viewport Drawing Methods</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_AA9C198F12824EE693E36EF6CDE38EA2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FEF\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F09\"></a><pre><em class=\"codeEmphasisStrong\">Box2</em> &lt;x_integer&gt; &lt;y_integer&gt; &lt;w_integer&gt; &lt;h_integer&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FF1\"></a>Constructs a Box2 with the upper left corner at \n            		<span class=\"code\"> <em class=\"strong\">[x,y]</em> </span> with width \n            		<span class=\"code\"> <em class=\"strong\">w</em> </span> and height \n            		<span class=\"code\"> <em class=\"strong\">h</em> </span>. \n            	 \n         </p>\n         <p><a name=\"P_A22D2E36E3A04A6AB113FF736E31DD9C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F08\"></a><pre><em class=\"codeEmphasisStrong\">Box2</em> &lt;upperleft_point2&gt; &lt;lowerRight_point2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FF3\"></a>Constructs a Box2 object from the specified corners. \n            	 \n         </p>\n         <p><a name=\"P_45ADE2EF71474DAC9BBE2DD2A0893947\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FF4\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F07\"></a><pre>&lt;Box2&gt;.<em class=\"codeEmphasisStrong\">x</em>: Integer\n&lt;Box2&gt;.<em class=\"codeEmphasisStrong\">y</em>: Integer\n&lt;Box2&gt;.<em class=\"codeEmphasisStrong\">w</em>: Integer\n&lt;Box2&gt;.<em class=\"codeEmphasisStrong\">h</em>: Integer\n&lt;Box2&gt;.<em class=\"codeEmphasisStrong\">left</em>: Integer, alias of x property\n&lt;Box2&gt;.<em class=\"codeEmphasisStrong\">right</em>: Integer\n&lt;Box2&gt;.<em class=\"codeEmphasisStrong\">top</em>: Integer, alias of y property\n&lt;Box2&gt;.<em class=\"codeEmphasisStrong\">bottom</em>: Integer\n&lt;Box2&gt;.<em class=\"codeEmphasisStrong\">center</em>: Point2, read-only</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FFE\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">right</em> </span> property is calculated as \n            		<span class=\"code\"> <em class=\"strong\">right = x + w - 1</em> </span>. The \n            		<span class=\"code\"> <em class=\"strong\">bottom</em> </span> property is calculated as \n            		<span class=\"code\"> <em class=\"strong\">bottom = y + h - 1</em> </span>. Setting the \n            		<span class=\"code\"> <em class=\"strong\">right</em> </span> or \n            		<span class=\"code\"> <em class=\"strong\">bottom</em> </span> property will normally change the \n            		<span class=\"code\"> <em class=\"strong\">w</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">h</em> </span> properties, respectively. However, if \n            		<span class=\"code\"> <em class=\"strong\">right</em> </span> is set less than \n            		<span class=\"code\"> <em class=\"strong\">left</em> </span>, the \n            		<span class=\"code\"> <em class=\"strong\">right</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">left</em> </span> values will be swapped, and then the new value will be used as the \n            		<span class=\"code\"> <em class=\"strong\">left</em> </span> value. Likewise, if \n            		<span class=\"code\"> <em class=\"strong\">bottom</em> </span> is set less than \n            		<span class=\"code\"> <em class=\"strong\">top</em> </span>, the \n            		<span class=\"code\"> <em class=\"strong\">bottom</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">top</em> </span> values will be swapped, and then the new value will be used as the \n            		<span class=\"code\"> <em class=\"strong\">top</em> </span> value. \n            	 \n         </p>\n         <p><a name=\"P_9307D15FBC8546029A126432B29A897E\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-8000\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F06\"></a><pre>&lt;Box2&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;Box2&gt;\n&lt;Box2&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;Box2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FFD\"></a>Standard comparison operators. Two Box2 values are equal if all of their component\n            values are equal. \n            	 \n         </p>\n         <p><a name=\"P_D7F57D2D93C64B3C9F7FD59C890F95B9\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6907\"></a>       <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F05\"></a><pre><em class=\"codeEmphasisStrong\">scale</em> &lt;Box2&gt; &lt;float&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FF5\"></a>Scales the coordinates of the box about the center of the box. \n            	 \n         </p>\n         <p><a name=\"P_DE588A1AA4744D3BAF0C1040D944A245\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F04\"></a><pre><em class=\"codeEmphasisStrong\">translate</em> &lt;Box2&gt; &lt;point2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FF2\"></a>Translates the coordinates of the box by the distance specified. \n            	 \n         </p>\n         <p><a name=\"P_AF751E16A2C5428DBA757AAA66735812\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F03\"></a><pre><em class=\"codeEmphasisStrong\">contains</em> &lt;Box2&gt; &lt;point2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FEF\"></a>Determines if the point2 value is contained within the Box2. Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if the point is inside the Box2 or on the Box2 edge; otherwise \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            	 \n         </p>\n         <p><a name=\"P_56BA6A7DC43C46598F7B05B575DEC670\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F02\"></a><pre><em class=\"codeEmphasisStrong\">rectify</em> &lt;Box2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FEC\"></a>Adjusts the coordinates of the box such that \n            		<span class=\"code\"> <em class=\"strong\">top</em> </span>&lt;<span class=\"code\"> <em class=\"strong\">bottom</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">left</em> </span>&lt;<span class=\"code\"> <em class=\"strong\">right</em> </span>. \n            	 \n         </p>\n         <p><a name=\"P_59ACD8A094834A8EACD634A6F88AA43A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F01\"></a><pre><em class=\"codeEmphasisStrong\">empty</em> &lt;Box2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FE9\"></a>Sets the Box2 to a special \"empty\" value. \n            	 \n         </p>\n         <p><a name=\"P_10B60DC4DB4F48809720717951AD9DB8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F00\"></a><pre><em class=\"codeEmphasisStrong\">isEmpty</em> &lt;Box2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FE6\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if the Box2 contains the special \"empty\" value, \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. \n            	 \n         </p>\n         <p><a name=\"P_9ADD9388277F4DA28826FF67FC642E4D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p> <span class=\"char_link\"><a href=\"GUID-2921953D-F655-4663-B243-2E8DAFEED15F.htm\">Box3 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FE3\"></a> <span class=\"char_link\"><a href=\"GUID-DC4992FA-05CC-4376-B1B5-666B9A00CBFF.htm\">Point2 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FE2\"></a> <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FE1\"></a> <span class=\"char_link\"><a href=\"GUID-31C598AB-B3BE-4965-996E-0CD59C0EC018.htm\">Point4 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7FE0\"></a> <span class=\"char_link\"><a href=\"GUID-5A117E26-3BA4-4C4C-A0C7-0F4190F9D50D.htm\">Ray Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";