var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-62979DC6-3C9B-4A8C-B695-CA83E8AA1437\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"creating new NURBS objects\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Creating New NURBS Objects</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-62979DC6-3C9B-4A8C-B695-CA83E8AA1437\"></a><div class=\"head\">\n            <h1>Creating New NURBS Objects </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48E8\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48E7\"></a> The NURBS classes can be used to create new NURBS scene objects. This is done by adding\n               the objects (points, curves and surfaces) to an item called a NURBSSet and passing\n               it to the function <span class=\"code\"> <em class=\"strong\">NURBSNode()</em> </span>. The NURBSSet is a container for the objects that define each element in the scene\n               NURBS object. The function <span class=\"code\"> <em class=\"strong\">NURBSNode()</em> </span> makes an internal <em class=\"strong\">3ds Max</em> NURBS object from the specifications in the set. The function <span class=\"code\"> <em class=\"strong\">NURBSNode()</em> </span> is documented in <span class=\"char_link\"><a href=\"GUID-B2EED1F7-073C-4799-BC4B-0F0A419FCC61.htm\">Creating NURBS Scene Objects</a></span>.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48E5\"></a>As an example, consider the following code fragment that creates a NURBSCVCurve object\n               (with NURBSControlVertex sub-objects) and puts it in the scene:\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48E4\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48E3\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22CF\"></a><pre>\n-- create an empty NURBSSet object\nnset = NURBSSet ()\n-- create a new NURBSCVCurve and set the knots and CVs\nc = NURBSCVCurve name:\"CV Curve\" order:4 numCVs:4 numKnots:8\nfor k in 1 to 4 do ( setKnot c k 0; setKnot c (k+4) 1 )\ncv = NURBSControlVertex [0, 0, 50]\nsetCV c 1 cv\ncv.pos = [-100, 0, 50]\nsetCV c 2 cv\ncv.pos = [-100, 100, 50]\nsetCV c 3 cv\ncv.pos = [0, 100, 50]\nsetCV c 4 cv\n-- add the NURBSCVCurve object to the set\nappendObject nset c\n-- create the NURBS object from the NURBSSet\nn = NURBSNode nset name:\"nurbs01\"pos:[10,0,0]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48CE\"></a>Note that the NURBSSet supplied to the <span class=\"code\"> <em class=\"strong\">NURBSNode()</em> </span> function will be modified by that function to be a relational representative for\n               the newly created scene node which you can then use to modify the scene object --\n               you don\'t have to re-extract a fresh relational NURBSSet.\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";