var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-6736979B-D33A-4968-8BD2-FE2365A3A539\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"encryptScript()\">\n      <meta name=\"indexterm\" content=\"encrypting scripts\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Encrypting Script Files</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6736979B-D33A-4968-8BD2-FE2365A3A539\"></a><div class=\"head\">\n            <h1>Encrypting Script Files </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C70\"></a>  MAXScript lets you create an encrypted copy of a specified script file with the same\n            name prefix, but with the suffix .mse, in the same directory as the source script\n            file. The encryption uses a fixed hidden key that lets it run on any <em class=\"strong\">3ds Max </em>system, but effectively hides the source of the script. Encrypted script files have\n            the suffix .mse. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C73\"></a>To encrypt a script, use the following MAXScript method: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6393\"></a><pre><em class=\"codeEmphasisStrong\">encryptScript</em> &lt;filename_string&gt; [<em class=\"codeEmphasisStrong\">version</em>:&lt;int&gt;]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C75\"></a>where <span class=\"code\">&lt;filename_string&gt;</span> is a string literal or an expression that evaluates to a string specifying the name\n            of the script file whose contents are encrypted. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C76\"></a>The optional <span class=\"code\"> <em class=\"strong\">version:</em> </span>keyword can be either 0 or 1. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C77\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C79\"></a>When set to 0, the method uses the old encryption scheme of <em class=\"strong\">3ds Max 2 to 9</em>. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C7B\"></a>When set to 1 or not specified, the method uses the new encryption scheme introduced\n                  in <em class=\"strong\">3ds Max 9 SP 1</em>. Note that files encrypted with the new scheme cannot be run in previous versions\n                  of <em class=\"strong\">3ds Max</em>. If an encrypted script has to be used in an older version of<em class=\"strong\"> 3ds Max</em>, use the <em class=\"strong\">version:0 </em>option. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C7D\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C7E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE USES ARE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6392\"></a><pre>\nencryptScript \"my_script.ms\"\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6391\"></a><pre>\n--create file compatible with old versions:\nencryptScript \"my_script.ms\" version:0\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C86\"></a><p class=\"table-body\">or </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6390\"></a><pre>\nscriptfile= \"my_script.ms\"\nencryptScript scriptfile\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C8C\"></a>The encrypted script file from the previous examples would be named <em class=\"mild\">my_script.mse</em>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C8D\"></a>The Run Script button in the MAXScript rollout and the <span class=\"code\"> <em class=\"strong\">fileIn() </em> </span>method described in <span class=\"char_link\"><a href=\"GUID-86D82FCE-B88F-4487-9B34-B6222EDA1C71.htm\">Running Scripts</a></span> automatically support .mse encrypted scripts. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C8E\"></a>You can couple this script source code encryption with the <span class=\"code\"> <em class=\"strong\">hardwareLockID </em> </span>variable and the encrypted file I/O functions to provide authorization-based protection\n                  for your scripts. \n               </p> \n            </li>\n         </ul>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";