var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To - Introduction to the Tutorials</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD\"></a><div class=\"head\">\n            <h1>How To - Introduction to the Tutorials </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1847\"></a>The \"How To\" topics present some simple programming tasks as extended MAXScript examples.\n            All of them are based on actual real-world cases, include detailed explanations and\n            tips and tricks from the scripting practice. In addition, most of the scripts are\n            not longer than 30 lines so they are perfectly suited for beginners. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1848\"></a> \n            <h2><a name=\"GUID-4A89D7BE-71A0-4370-BA4C-81905C41C25B\"></a> <em class=\"strong\">Objectives:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1849\"></a>The main objective of these tutorials is to teach the MAXScript user some possible\n               approaches for developing scripted solutions to practical problems - from the original\n               idea through a concept expressed in a natural language (English) down to the actual\n               MAXScript code and ideas for potential future enhancements. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC184A\"></a> \n            <h2><a name=\"GUID-45997208-EE87-4B0A-A91B-A5CFFC830506\"></a> <em class=\"strong\">Structure:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC184B\"></a>The \"How To\" tutorials provide \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC184C\"></a>A <em class=\"strong\">list of related topics</em> the user might want to read before trying the actual tutorial; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC184D\"></a>The <em class=\"strong\">complete uncommented code</em> – the user can cut &amp; paste it and use immediately; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC184E\"></a>The same <em class=\"strong\">code with detailed explanations;</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC184F\"></a> <em class=\"strong\">Links to definitions</em> of the used functions and methods; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1850\"></a>Some info about the <em class=\"strong\">usage of the script</em> in the practice; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1851\"></a>Things to try – <em class=\"strong\">ideas for improvements</em> that the user could try alone. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1852\"></a> \n            <h2><a name=\"GUID-03DBC876-B28A-444E-8322-7F3AF14D87CA\"></a> <em class=\"strong\">Topics:</em> \n            </h2> <a name=\"GUID-F5A94BD8-5A65-48F0-9A1D-F362474EEDD9\"></a><dl>\n               <dt><a name=\"GUID-5A52D06A-5844-4438-AE23-1795C181A638\"></a><span class=\"term\"><a name=\"GUID-ADD755BF-4C4B-4159-85E5-DDB9F563DE4A\"></a> <span class=\"char_link\"><a href=\"GUID-8EB13535-72B4-439C-94D3-E93434BA163B.htm\">How To ... Develop A Transform Lock Script</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-7C0C0CA3-C90B-40A3-8CB6-00A4F0D1AC47\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1854\"></a>Developing a simple script for checking all Transformation locks. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-DD419AD0-6365-4C09-88EB-353CA390758B\"></a><dl>\n               <dt><a name=\"GUID-952C8EB5-1148-4C7B-9A53-A431AABAA18C\"></a><span class=\"term\"><a name=\"GUID-499A8705-5610-4548-BF9D-375098D12444\"></a> <span class=\"char_link\"><a href=\"GUID-BB996DFB-0367-4DFF-A1CC-50BEB3A97757.htm\">How To ... Remove All Materials</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-88DCE28B-466B-4182-8EED-2B6551A39CC7\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1856\"></a>Creating a very simple script removing all materials from the scene. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-491769ED-1348-4044-98B4-C77E7BD7256B\"></a><dl>\n               <dt><a name=\"GUID-5536C1F0-467B-462F-96AD-DACE19580DB3\"></a><span class=\"term\"><a name=\"GUID-C90C8EFD-202D-44B2-968C-407A69C9BB99\"></a> <span class=\"char_link\"><a href=\"GUID-5986CAD3-BB68-47BC-B4B2-EF84C4659271.htm\">How To ... Quickly Rename Selected Objects</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-88D25366-B9C5-476E-943C-2FA79F78C798\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1858\"></a>Developing a simple renaming utility to change the names of selected objects \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-6B45CFF8-3D31-4F15-9E7E-5A23807F6D7C\"></a><dl>\n               <dt><a name=\"GUID-C4C3EC84-14D6-4C71-BA99-566AD7FB913E\"></a><span class=\"term\"><a name=\"GUID-0C8A036A-7247-4FEB-B2E4-68B7378FA6DD\"></a> <span class=\"char_link\"><a href=\"GUID-6021C91D-405D-4DA9-81D9-02547B9D4370.htm\">How To ... Select Non-Quad Polygons</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-2BFCDD4D-E9AC-4391-AB52-69967203AD6B\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC185A\"></a>Example of accessing and selecting Polygons in an EditablePoly object. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-11661A00-AB44-456E-B914-3917E18DB1AE\"></a><dl>\n               <dt><a name=\"GUID-BAEF5F7A-59AD-4363-BD3F-259BEBE64F0A\"></a><span class=\"term\"><a name=\"GUID-F83CAD8A-2886-42F9-AC84-CB57665CC6F7\"></a> <span class=\"char_link\"><a href=\"GUID-7F799BCA-B11D-4307-AA34-8FB0E2F757A4.htm\">How To ... Assign Materials Automatically</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-B9B7074B-32EB-482B-B23C-057FFB11D2F3\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC185C\"></a>Shows how to use MAXScript callbacks to automate material assignment. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-F3D26DB7-C5C1-42F5-BC1A-DCD43D72C138\"></a><dl>\n               <dt><a name=\"GUID-111CBF14-85C3-46D8-A586-07C8E4CDFEE1\"></a><span class=\"term\"><a name=\"GUID-AB3755ED-30E5-4664-B5EE-CE5171E34C1A\"></a> <span class=\"char_link\"><a href=\"GUID-84E24969-C175-4389-B9A6-3B2699B66785.htm\">How To ... Move Objects to a Surface</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-D3CBF88B-C2D0-425A-965F-41E51B9D72EC\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC185E\"></a>Shows how to use the intersectRay function to find surface points on objects. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-F8BE6DAB-0C39-4179-B74A-AC3366594E9A\"></a><dl>\n               <dt><a name=\"GUID-AA86F8E8-9E3B-4092-93BF-64001794293E\"></a><span class=\"term\"><a name=\"GUID-38185FC2-493F-4218-AE2A-1D5C61BD7B46\"></a> <span class=\"char_link\"><a href=\"GUID-2DB3A775-776F-4D63-BDFB-D99523ECB69D.htm\">How To ... Output Object Data To File</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-CE6CC7E9-AFDE-4D08-B659-467B1B3F1CAC\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1860\"></a>Shows the basic of writing object data to an external text file. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-D4CBD7B2-5BAD-4970-9A69-A3212BDD4E76\"></a><dl>\n               <dt><a name=\"GUID-0996F6C4-969D-4D0A-887F-017E25672111\"></a><span class=\"term\"><a name=\"GUID-A5E96BD3-95CE-40A6-9F9B-BDEA9120CD24\"></a> <span class=\"char_link\"><a href=\"GUID-38562330-1435-4112-9265-DE965319A2F2.htm\">How To ... Output Geometry Data To Text File - Part One</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-71A1C31E-4A07-47CC-8FEA-853425F375A3\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1862\"></a>Shows the basic of writing mesh geometry data to an external text file. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-600E6077-4CCC-46B7-8AB0-0E739A293956\"></a><dl>\n               <dt><a name=\"GUID-AC2E0B34-C964-403D-96D3-C408587E8D76\"></a><span class=\"term\"><a name=\"GUID-0B98F33E-3A60-4C98-9AE2-DD0CF20BD279\"></a> <span class=\"char_link\"><a href=\"GUID-BC1C2CB2-F6C5-48D7-8686-DD3988D4AEBA.htm\">How To ... Read Geometry Data From Text File - Part One</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-27F9C3CD-1F8B-4E1F-9343-E4CF8632876D\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1864\"></a>Shows the basic of reading object data from an external text file. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-2EDF5BA1-B17C-4C01-B02D-280CCE3850B3\"></a><dl>\n               <dt><a name=\"GUID-ADEA4637-D837-43DF-BBCC-3162896C3E92\"></a><span class=\"term\"><a name=\"GUID-55A7997C-ECA6-48FE-8B00-9C7990FF9E42\"></a> <span class=\"char_link\"><a href=\"GUID-537409FE-EF5B-4E02-8261-456F74134CA5.htm\">How To ... Output Geometry Data To Text File - Part Two</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-5CDB1574-56DB-460D-8C2C-F3A930F89CDA\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1866\"></a>Enhances the mesh geometry output script with support of smoothing groups, material\n                        ids and edge visibility. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-0868A96A-10B3-4567-91D6-EAA879E23403\"></a><dl>\n               <dt><a name=\"GUID-267658CB-1D57-49BA-B598-88D06FD563F0\"></a><span class=\"term\"><a name=\"GUID-68BF9031-D98E-4470-80C9-E307687C4F40\"></a> <span class=\"char_link\"><a href=\"GUID-4ED6C9C6-53B3-437C-969E-B8C924DF34AA.htm\">How To ... Read Geometry Data From Text File - Part Two</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-31F47C38-2532-43BB-8891-F3A05B17F695\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1868\"></a>Enhances the input script developed in Part One to support the new data added by the\n                        preceding tutorial. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-051842EC-3E6D-4678-8F01-D9DFC8C101F3\"></a><dl>\n               <dt><a name=\"GUID-51DFF07A-5B32-41DB-BF12-17CDC445CF6D\"></a><span class=\"term\"><a name=\"GUID-967D4BF8-1BA5-40C3-B774-70A8D154EF3A\"></a> <span class=\"char_link\"><a href=\"GUID-333382D0-57AF-4797-98F2-C2BE09442607.htm\">How To ... Create a Quick Preview</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-7C695419-1F68-4626-A423-13A1E0DF6DA5\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC186A\"></a>Implements a simple viewport preview and automatic RAMplayer loading \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-4116496A-81A7-452F-9AC2-EBCB68CA00D9\"></a><dl>\n               <dt><a name=\"GUID-564E7A68-D046-4C9E-AAEC-FB8155183898\"></a><span class=\"term\"><a name=\"GUID-67F8C2E4-3990-4D7F-A80C-BEC01EC96B7D\"></a> <span class=\"char_link\"><a href=\"GUID-3667A33C-E3E4-4F39-A480-3713240838F1.htm\">How To ... Access the Z-Depth channel</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-0BED0713-54F5-47E0-A4BD-7B5835947BE9\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC186C\"></a>A small experiment creating objects based on the Z-Depth of the camera. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-9D0F0EC6-F8B7-4A88-8B95-BF9733450111\"></a><dl>\n               <dt><a name=\"GUID-D4BAE102-F366-4B71-8D21-10A6F1271B5F\"></a><span class=\"term\"><a name=\"GUID-11B88D86-777D-43D0-8041-ED4F47E48CB8\"></a> <span class=\"char_link\"><a href=\"GUID-5E5E1A71-24E2-4605-9720-2178B941DECC.htm\">How To ... Create a MonoChrome RenderEffect</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-4B178E5B-B149-415E-8316-E428D79D4582\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC186E\"></a>A simple example of a scripted RenderEffect plug-in. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-344EDCE1-6EB6-4ED4-845C-2D2E06462243\"></a><dl>\n               <dt><a name=\"GUID-0972A991-8B0E-4079-B5FA-29C970401590\"></a><span class=\"term\"><a name=\"GUID-0B13AC9E-D017-46A0-8651-D9CEC3F3A545\"></a> <span class=\"char_link\"><a href=\"GUID-BFE0D012-E8F6-4903-B3C5-ABDA06F4F18C.htm\">How To ... Create Custom Mesh Object</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-6161B93A-864E-4AED-9E4B-CD015796DB5F\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1870\"></a>Shows how to create a custom mesh object. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-592048A6-3B07-4910-B401-6745082D1FD6\"></a><dl>\n               <dt><a name=\"GUID-43E29B43-6F45-4956-8573-58C9D2C01923\"></a><span class=\"term\"><a name=\"GUID-ED19A4D3-D3B7-4285-9E4E-C116C2760682\"></a> <span class=\"char_link\"><a href=\"GUID-EC33589D-822A-4E79-9682-185EC5DBAB9F.htm\">How To ... Create Scripted Geometry Plug-in</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-5C1CCA9E-696B-47CF-A6FA-15DFE6C4CAB0\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1872\"></a>An example of a scripted geometry plug-in. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-9BF62119-34B2-48C0-97BE-F13B8DF1D652\"></a><dl>\n               <dt><a name=\"GUID-FAB7A7F2-1A8A-4E1D-AD9C-C74FE424C569\"></a><span class=\"term\"><a name=\"GUID-C40D528C-DD70-4D55-8134-6C29459C848F\"></a> <span class=\"char_link\"><a href=\"GUID-26D082D6-B086-48A2-A642-1137AEA145BD.htm\">How To ... Create a Dalmatian TextureMap Plug-in</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-15EEAFEC-57EE-4C37-9C26-BE50F18E309A\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1874\"></a>An example of a scripted texture map plug-in in the famous polka-dot dog look. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-4F0854CD-D421-4F9E-ABB5-60CBD7C67702\"></a><dl>\n               <dt><a name=\"GUID-E992897E-3E18-4C57-89B0-0E4932C316C9\"></a><span class=\"term\"><a name=\"GUID-394E005F-6387-4A12-A2EE-8CAFB903DB72\"></a> <span class=\"char_link\"><a href=\"GUID-F4A71DC8-DC5A-4ACA-8475-C8869BAC7EFF.htm\">How To ... Access Windows System Data</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-F6FD944D-C9FD-4F58-93EB-1F1B8899EAA1\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1876\"></a>Shows an approach to access system data that is not directly exposed to MAXScript.\n                        \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-B92C4922-7494-4453-A42F-CF134456FD2A\"></a><dl>\n               <dt><a name=\"GUID-165D1377-E44D-4EDD-904A-871118A63B08\"></a><span class=\"term\"><a name=\"GUID-3F53A0EA-34A0-4BCD-8D80-C01D7042FA89\"></a> <span class=\"char_link\"><a href=\"GUID-71415C32-4325-4474-8DFB-67BE74587970.htm\">How To ... Sort TrackView Alphabetically</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-1B768276-93B5-418A-8618-3F1D7AE134C4\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1878\"></a>Shows an approach to sort the objects in the TrackView. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-9FE72144-FCCE-4BDB-989A-357DFBCECCD3\"></a><dl>\n               <dt><a name=\"GUID-AA871CEF-C530-43BB-9C39-BED5D11FDEE0\"></a><span class=\"term\"><a name=\"GUID-F611E5BC-9698-4290-9BFC-A24410C9D284\"></a> <span class=\"char_link\"><a href=\"GUID-68E7C8BE-E2A1-4C0A-A5A9-A9A122DE7A66.htm\">How To ... Flatten a SplineShape</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-292F008D-6C75-4108-A7CD-5AC267263431\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC187A\"></a>Example of modifying a slineShape by moving knots and bezier vectors. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-10B46FF7-A069-434C-B672-D221C8425654\"></a><dl>\n               <dt><a name=\"GUID-87EBECD4-1E9A-45E3-9D6E-70066372C6C9\"></a><span class=\"term\"><a name=\"GUID-4AA51C32-C000-4CFB-970C-AA183A3FC302\"></a> <span class=\"char_link\"><a href=\"GUID-0876DF46-FAA3-4131-838D-5739A67FF2C1.htm\">How To ... Draw a Freehand Spline</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-53176A32-16A2-4D7A-8361-2AE80F558A95\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC187C\"></a>Example of drawing a spline with the mouse in the ground plane. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-4C5CD57B-EB22-4BE4-BF04-E6E3CFBD2147\"></a><dl>\n               <dt><a name=\"GUID-EDF0C9D3-F3BC-49FF-969E-398ECC78D308\"></a><span class=\"term\"><a name=\"GUID-FEAE1FF0-536F-4B18-8AA1-4A33AEAFE97C\"></a> <span class=\"char_link\"><a href=\"GUID-496428B3-D9F8-4CF1-91ED-5D1708DF100E.htm\">How To ... Enhance the Morpher Modifier With Floating Controls</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-6A196DC5-4DE2-400A-A690-CA1A12ABDEE9\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC187E\"></a>Example of dynamic UI creation, time and change callbacks usage to create a floater\n                        with controls linked interactively to a Morpher modifier. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-7769C952-3147-4167-B806-43075E2DDB62\"></a><dl>\n               <dt><a name=\"GUID-A308F012-8442-4000-BDBE-44AA80557062\"></a><span class=\"term\"><a name=\"GUID-C5430288-7835-45FA-8D2A-B61E9472D68E\"></a> <span class=\"char_link\"><a href=\"GUID-F7FA2755-0408-4610-ABDB-B403D85AA597.htm\">How To ... Change Objects At Render Time</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-05A1FFEB-305F-47D7-B28B-0C6179CF1F86\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1880\"></a>An example of changing object properties at render time using callback scripts. \n                     </p> \n                  </div>\n               </dd>\n            </dl> <a name=\"GUID-27C90494-8AED-4526-AE61-0A2D37A73AAF\"></a><dl>\n               <dt><a name=\"GUID-EF19C017-9B2E-42C7-9876-829DDFFA604A\"></a><span class=\"term\"><a name=\"GUID-E8877DE2-230B-4D54-9613-1E08EC59D039\"></a> <span class=\"char_link\"><a href=\"GUID-853014AC-9DC8-4F5C-B14B-3643E5925AD8.htm\">How To ... Develop a Vertex Renderer</a></span> </span></dt>\n               <dd>\n                  <div class=\"definition\"><a name=\"GUID-C9D1D196-57E6-4191-85A5-D546A82BC51F\"></a> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1882\"></a>An example of a scripted vertex realtime renderer. \n                     </p> \n                  </div>\n               </dd>\n            </dl> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1883\"></a> \n               <h3><a name=\"GUID-89F6BB43-B653-4315-B5BD-90CF3B7A33DF\"></a> <em class=\"strong\">How To ... Script Particle Flow</em> \n               </h3> <a name=\"GUID-3382F133-AE50-4FE1-8B8F-ACC005B3339C\"></a><dl>\n                  <dt><a name=\"GUID-288DC55A-361E-4763-93D7-16D687C5F653\"></a><span class=\"term\"><a name=\"GUID-3A5523BE-60A0-4B27-A87B-0B128491D521\"></a> <span class=\"char_link\"><a href=\"GUID-8F114E91-183D-47A9-A302-6B8A1BD15C6E.htm\">How To ... Transfer ParticleFlow Particle Motion To Scene Objects</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-A9D116D6-D447-4C1D-B651-74FB48B59F7A\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1885\"></a>An example of moving scene objects using Particle Flow particles. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-195E869D-E535-4F5A-A9A3-7163F5F314CE\"></a><dl>\n                  <dt><a name=\"GUID-01DA4418-874E-4EF1-9CA6-70D957C744FA\"></a><span class=\"term\"><a name=\"GUID-E1CF6176-B97C-40D7-9EFB-F8A300BF9FAC\"></a> <span class=\"char_link\"><a href=\"GUID-8C394F51-48FF-4605-B7C5-F3E62AABB5F9.htm\">How To ... Affect Particle Flow Particles by Mass</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-D03113C0-FA4F-4829-AC5F-F457429A5234\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1887\"></a>An example of applying a Force to particles based on their mass. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1888\"></a> \n               <h3><a name=\"GUID-807AC1BF-C9F0-459A-91EF-80EF6BD86838\"></a> <em class=\"strong\">How To ... Develop a Bitmap Painting Tool In Nine Easy Steps</em> \n               </h3> <a name=\"GUID-31861BF1-3F9F-4CA9-983B-5226CC4EAEFA\"></a><dl>\n                  <dt><a name=\"GUID-0532AA39-437B-4438-A8D6-27ACA3B87DAA\"></a><span class=\"term\"><a name=\"GUID-09724B3D-DC76-4F1B-9CB2-B6D9C0DA583B\"></a> <span class=\"char_link\"><a href=\"GUID-9355B32D-DDC4-4C26-BEFD-66BE3D291B63.htm\">How To ... Develop a Bitmap Painting Tool - Basic Utility</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-88654F01-B985-46D1-9D65-CC1BAAEF276C\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC188A\"></a>The first step of the tool creation - The basic tool with a single point brush without\n                           strokes support. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-DDBE0E37-BF32-4049-8872-D9FC7215E727\"></a><dl>\n                  <dt><a name=\"GUID-73C55554-1DFC-41DC-9DA5-C0476BC8BCFF\"></a><span class=\"term\"><a name=\"GUID-2DE17DDF-A284-4894-BCA4-4AAC5AF617EC\"></a> <span class=\"char_link\"><a href=\"GUID-89495341-DEA2-41D9-BFBB-543006E64CA2.htm\">How To ... Develop a Bitmap Painting Tool - Strokes Support</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-2802548B-EDE3-4E13-A169-097BEACB0DC1\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC188C\"></a>The second iteration of the tool adds continuous stroke drawing. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-77563AFF-6F7B-4F82-94DC-B8F24A7F6562\"></a><dl>\n                  <dt><a name=\"GUID-932C4615-ABEE-4FE2-9CA1-1F1ABF27DCD3\"></a><span class=\"term\"><a name=\"GUID-FFA185A9-585A-414E-A4ED-E1481ACAEAFD\"></a> <span class=\"char_link\"><a href=\"GUID-E9C5AFAA-52A0-4274-A92C-8075C3BD0F25.htm\">How To ... Develop a Bitmap Painting Tool - Brush Size and Color</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-B24E30F5-054B-4CD7-B868-1D98D9FBAA0C\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC188E\"></a>The third iteration of the tool adds control over the size and color of the brush.\n                           \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-7C97FCB4-E389-4B33-BD66-C8A7101FDF1A\"></a><dl>\n                  <dt><a name=\"GUID-84D5300B-E0A0-4376-9E6B-571FDF5AE267\"></a><span class=\"term\"><a name=\"GUID-697EDE25-20F7-4F4B-8FA3-97CABE31CA19\"></a> <span class=\"char_link\"><a href=\"GUID-78460DD3-5FA4-4F68-990A-54D8D6092802.htm\">How To ... Develop a Bitmap Painting Tool - Airbrush and Shapes</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-92512616-1D7B-4B5D-A544-70FEA0A8A86A\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1890\"></a>The fourth iteration of the tool adds circular brush shape support and an Airbrush\n                           option with variable strength. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-3B6787F5-0E55-4AFD-8F08-127C4710E9DC\"></a><dl>\n                  <dt><a name=\"GUID-9CAA93AC-1339-4D90-BAE1-786FB22C28C2\"></a><span class=\"term\"><a name=\"GUID-EE2BB036-5A59-4020-92F1-76788F2CACD2\"></a> <span class=\"char_link\"><a href=\"GUID-6AC542FD-A91B-4F32-89DD-56A9E1B118E3.htm\">How To ... Develop a Bitmap Painting Tool - Smooth Brushes</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-745D187E-9283-407D-B041-46A062FA38BA\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1892\"></a>The fifth iteration of the tool adds a brush with smooth falloff \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-3E869A62-E535-4030-B7D3-D00F2D94170A\"></a><dl>\n                  <dt><a name=\"GUID-D343D897-F1A6-4675-BC11-EF631ED14BD5\"></a><span class=\"term\"><a name=\"GUID-D9251E53-E47D-42DB-9C3A-A943EBE4DF77\"></a> <span class=\"char_link\"><a href=\"GUID-2A734060-09D6-44CE-A0B1-6E7094C03AC3.htm\">How To ... Develop a Bitmap Painting Tool - Load and Save</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-84B6E223-3035-4E5C-8725-FB386BBA5DD0\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1894\"></a>The sixth iteration of the tool adds bitmap file loading and saving. Finally, you\n                           can store your work of art to disk and continue on painting later in a new session...\n                           \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-66F59842-8045-4731-8824-15548445DA39\"></a><dl>\n                  <dt><a name=\"GUID-98682642-78DA-4AC5-98BA-2E00FE7BE2BD\"></a><span class=\"term\"><a name=\"GUID-2DD253E8-524B-494A-ACDC-113438D44703\"></a> <span class=\"char_link\"><a href=\"GUID-2A6DF478-2707-4D8B-A9CE-8E4E90D6FD1C.htm\">How To ... Develop a Bitmap Painting Tool - Erase Changes</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-45CB1469-4387-4312-9093-F8B15321BBA5\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1896\"></a>The seventh iteration of the tool adds an eraser option to the right mouse button\n                           and a Commit Changes menu option to permanently bake the changes to the image. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-78434AD9-04B7-4A7C-988E-6B37268AC834\"></a><dl>\n                  <dt><a name=\"GUID-67C8E855-DED3-4BB1-A2CA-A9013B1C6FE0\"></a><span class=\"term\"><a name=\"GUID-3F693972-D42E-43C6-8ECA-E4F9D1482899\"></a> <span class=\"char_link\"><a href=\"GUID-8ECDE2E0-2C77-4191-9710-C527D95F763E.htm\">How To ... Develop a Bitmap Painting Tool - Unwrap UV Coordinates</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-3977051A-8720-4252-A023-936A29BFED76\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1898\"></a>The eight iteration of the tool adds UV texture coordinates unwrapping and realtime\n                           updates of the bitmap as diffusemap on a selected object. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-914FC335-7563-435C-B268-EB1FB73FE3C5\"></a><dl>\n                  <dt><a name=\"GUID-A64355B8-04C0-4297-BF96-609D7C13C2E4\"></a><span class=\"term\"><a name=\"GUID-4492CFBF-3386-4957-A422-E32B9A31E9F7\"></a> <span class=\"char_link\"><a href=\"GUID-409D100A-02E1-4539-B847-C3F6DFE6A66B.htm\">How To ... Develop a Bitmap Painting Tool - 3D Painting</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-B11BC04F-8F99-4314-AF86-02A086148157\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC189A\"></a>The ninth iteration of the tool adds 3D Painting on a selected object in the viewport.\n                           \n                        </p> \n                     </div>\n                  </dd>\n               </dl> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC189B\"></a> \n               <h3><a name=\"GUID-AB8661C2-9028-448B-A8F1-6D17C3677262\"></a> <em class=\"strong\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control</em> \n               </h3> <a name=\"GUID-50E265DA-CCCB-4914-8294-CE9A86CD45D3\"></a><dl>\n                  <dt><a name=\"GUID-F710E874-A1FF-44BD-889C-CA18C80C40A1\"></a><span class=\"term\"><a name=\"GUID-ECB68E6A-4FEE-4A6A-BEAB-A78830AB0939\"></a> <span class=\"char_link\"><a href=\"GUID-CE10C843-DBC1-4FFF-94CE-BCD79F8FF31C.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                              One</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-9956EE59-7391-4C2F-AE30-7BED79B0DF34\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC189D\"></a>This tutorial will demonstrate how to set up an ActiveX Control in a MAXScript rollout\n                           to display details about selected scene objects \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-2149209C-F2AF-45EC-9E8F-43A1EE2281A1\"></a><dl>\n                  <dt><a name=\"GUID-7580F6E0-0571-421F-8998-D913A028A385\"></a><span class=\"term\"><a name=\"GUID-9EF3AC5B-216D-4B7F-A724-ABD8D06695AF\"></a> <span class=\"char_link\"><a href=\"GUID-C9BD442F-7B4E-42F6-92CC-31B2DEE9E4FB.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                              Two</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-7317C72E-1573-4CEE-B8C8-BB5C34CA6936\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC189F\"></a>This second tutorial will demonstrate how to customize the ListView ActiveX Control\n                           defined in Part One and update the display automatically when the selection set changes\n                           \n                        </p> \n                     </div>\n                  </dd>\n               </dl> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18A0\"></a> \n               <h3><a name=\"GUID-DB68EB67-38FD-4424-B6B6-54653ADDC340\"></a> <em class=\"strong\">How To ... Develop a Scene Browser using TreeView ActiveX Control</em> \n               </h3> <a name=\"GUID-4CE58D64-9795-4078-9775-695A936BF9B8\"></a><dl>\n                  <dt><a name=\"GUID-1498948A-BEB7-4614-8435-E6F8D877ACC6\"></a><span class=\"term\"><a name=\"GUID-5F5A7B2F-03DC-43EB-97D3-E62303B9529D\"></a> <span class=\"char_link\"><a href=\"GUID-E6C53A89-CE94-4E2C-8143-7C8767BDC772.htm\">How To ... Develop a Scene Browser using TreeView ActiveX Control - Part One</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-9989C033-4B61-4AEC-A135-1EF08A4FF1E3\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18A2\"></a>This tutorial will demonstrate how to set up an ActiveX Control in a MAXScript rollout\n                           to display the hierarchy of the <em class=\"strong\">3ds Max</em> scene nodes. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-7D3CAB9A-1906-498C-ACA3-93203D00DCF8\"></a><dl>\n                  <dt><a name=\"GUID-9501F894-7CE5-4CFC-BE75-8A6FA57036E0\"></a><span class=\"term\"><a name=\"GUID-489A940D-8C0E-4E98-9C9C-B4EE1AECC0DD\"></a> <span class=\"char_link\"><a href=\"GUID-399134B9-7BC1-4F2A-9525-BD7EED14221D.htm\">How To ... Develop a Scene Browser using TreeView ActiveX Control - Part Two</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-F33A0E86-8B3B-45AF-BCBA-584177BE8B41\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18A4\"></a>The second tutorial will demonstrate how to customize the TreeView ActiveX Control\n                           defined in Part One by adding icons, colors and checkboxes to display and control\n                           the hidden state of scene nodes. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18A5\"></a> \n               <h3><a name=\"GUID-46306B92-A803-419C-912B-95D267FE866E\"></a>How To ... Develop Tools Using DotNet\n               </h3> <a name=\"GUID-6422047A-3DAD-43F1-A947-7212F4E1FE65\"></a><dl>\n                  <dt><a name=\"GUID-C901C6AD-F1F5-4130-B5EA-A0DC5BB88FCA\"></a><span class=\"term\"><a name=\"GUID-1C013D9A-A938-4032-B650-F0D13AED6CCB\"></a> <span class=\"char_link\"><a href=\"GUID-DEA74F18-7B83-4459-ABFB-F36A3BD49BD7.htm\">How To ... Copy The Last Rendered Image To The Windows Clipboard</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-A85F69E5-4216-49AF-A1A9-1E813D1760EB\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18A7\"></a>This tutorial demonstrates how to use a DotNet class to put the last rendered image\n                           into the Windows Clipboard. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-0F7B5D25-0F69-4A1C-891D-81318E526B91\"></a><dl>\n                  <dt><a name=\"GUID-B374AADE-650B-4349-8942-71BDC4CF3F41\"></a><span class=\"term\"><a name=\"GUID-AA37E56A-C990-41E8-8776-A2B317EA78DE\"></a> <span class=\"char_link\"><a href=\"GUID-DB82F222-B77F-4F85-865F-A4D54B53107D.htm\">How To ... Call a MAXScript Function Periodically using DotNet</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-EBEDFCFF-6B88-4CBE-9208-92381B002D69\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18A9\"></a>This tutorial demonstrates how to use a DotNet Timer object to call a MAXScript function\n                           at given intervals without the need for a rollout. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-64135B80-9651-4D7D-910C-72C35140EB1E\"></a><dl>\n                  <dt><a name=\"GUID-5CAD3AE0-F72F-4E32-B37B-4E6DB31CEC79\"></a><span class=\"term\"><a name=\"GUID-964A3054-1C4E-425F-9D46-92CCA8828798\"></a> <span class=\"char_link\"><a href=\"GUID-8EC1EEA5-41CD-4E1F-B9FA-562B515EADE7.htm\">How To ... Generate Hash Checksums using DotNet</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-E188AC16-2986-4000-8272-4BD43FC18EBA\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18AB\"></a>This tutorial demonstrates how to use a DotNet Timer object to call a MAXScript function\n                           at given intervals without the need for a rollout. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-C4EEFF75-F959-4CD6-9DF1-3D1A79A6CC48\"></a><dl>\n                  <dt><a name=\"GUID-593CEBD3-6042-40E5-9B61-F701534B4218\"></a><span class=\"term\"><a name=\"GUID-DBF1728B-3D7A-480B-AA1C-279902C86F02\"></a> <span class=\"char_link\"><a href=\"GUID-5A63220F-1C0E-4916-B9F5-905BE92C4673.htm\">How To ... Print Using DotNet</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-113EDE24-7F0F-4A2E-8A3A-4E67C93AD264\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18AD\"></a>This tutorial demonstrates how to use a DotNet form to display a file from disk and\n                           then print it as multiple pages to the printer. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18AE\"></a> \n               <h3><a name=\"GUID-018CDE5D-EB6D-458F-BD2A-87B913761A35\"></a> <em class=\"strong\">How To ... Develop An XView Geometry Checker</em> \n               </h3> <a name=\"GUID-76E168A5-F872-482D-8988-4E775817010B\"></a><dl>\n                  <dt><a name=\"GUID-35150AA7-4D1F-440D-87CF-61B6DB78010C\"></a><span class=\"term\"><a name=\"GUID-1F19EC76-6F42-47BB-9306-A12A9B8D733C\"></a> <span class=\"char_link\"><a href=\"GUID-C94469C6-19A5-427E-A16B-D46054B3AA1A.htm\">How To ... Develop A Face AreaXViewChecker - Part 1</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-88B28356-D322-4F3E-85EA-BE4AB6A3F87A\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18B0\"></a>This tutorial demonstrates how to define and register MAXScript functions with the\n                           XView Checker interface introduced in <em class=\"strong\">3ds Max 2010</em> to perform a Face Area test on geometry objects. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-969015E3-7FA4-475C-B9C2-9D5A0A63B362\"></a><dl>\n                  <dt><a name=\"GUID-1B46AA11-5E57-4732-B024-F1D18335571E\"></a><span class=\"term\"><a name=\"GUID-317E8C92-E49C-4FDC-8336-5737FB30BC60\"></a> <span class=\"char_link\"><a href=\"GUID-09495930-94A5-4CE7-BADB-D630B8306883.htm\">How To ... Develop A Face AreaXViewChecker - Part2</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-61BB4BA1-8CA4-4784-A076-58B3BC68365A\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18B2\"></a>This tutorial expands on the previous example by adding multiple checker modes and\n                           custom text and display override functions. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-946FAF2F-4550-4312-B14A-C8CD578AA56A\"></a><dl>\n                  <dt><a name=\"GUID-824A60D7-A7AA-4B4F-89FF-A0457AE84548\"></a><span class=\"term\"><a name=\"GUID-6D4CDC7E-E483-43F9-A6AE-18F2CEBF7787\"></a> <span class=\"char_link\"><a href=\"GUID-33391123-6956-49B8-9535-37A87754BA32.htm\">How To ... Develop A Face AreaXViewChecker - Part3</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-63406152-C7B2-44B9-8535-9CE6012BA392\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18B4\"></a>This tutorial continues the development of the Face Area Geometry Checker by implementing\n                           sticky settings via an INI file. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-75AA5693-9B9F-45EE-9C7A-1140181888A8\"></a><dl>\n                  <dt><a name=\"GUID-AD5FFD3D-0678-4C58-8B53-E08FAB7C110D\"></a><span class=\"term\"><a name=\"GUID-0161B172-B536-4B4C-9529-FCF6DB4C1982\"></a> <span class=\"char_link\"><a href=\"GUID-8385056C-4105-485F-B9AE-4280F87E366A.htm\">How To ... Develop A Face AreaXViewChecker - Part4</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-A4015089-D7E2-4E67-819D-598DBB986F4B\"></a> \n                        <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC18B6\"></a>This tutorial finishes the development of the Face Area Geometry Checker by implementing\n                           a MacroScript to place in the Viewport Menus. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_D15E62ED585A4CEF9869D2981380E02D\"></a> \n               <h3><a name=\"GUID-9850C497-F07C-4ACA-AF8F-D7F45C0601A6\"></a> <em class=\"strong\">How To ... Develop An SVG Polygon Renderer</em> \n               </h3> <a name=\"GUID-03A4CB79-4B62-4739-9520-8ED48ED9B06C\"></a><dl>\n                  <dt><a name=\"GUID-98422570-0001-4CBC-94E7-CD1213A9E152\"></a><span class=\"term\"><a name=\"GUID-55119D01-7E54-47D9-B7EF-EE1596CBCA4E\"></a> <span class=\"char_link\"><a href=\"GUID-6B5EDC11-A154-4AA7-A972-A11AC36949E9.htm\">How To ... Develop An SVG Polygon Renderer - Part 1</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-2B75661A-92C4-4F78-80EF-6944653DC535\"></a> \n                        <p><a name=\"GUID-92E8EE2C-3F5E-49FA-BCF2-C04D474C6922\"></a>This tutorial demonstrates how to use the Vector_Map TextureMap introduced in <em class=\"strong\">3ds Max 2014</em> to render polygons of scene geometry objects. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-AB106280-0C89-4394-BFFD-13842A3328AA\"></a><dl>\n                  <dt><a name=\"GUID-B0EF1B5F-3A89-49F3-8F2A-4BA97A03DED1\"></a><span class=\"term\"><a name=\"GUID-802F47FD-BF6A-47E4-A30D-4F1F0AECE0E2\"></a> <span class=\"char_link\"><a href=\"GUID-0453DFB1-1773-40DC-928E-C328D53EE293.htm\">How To ... Develop An SVG Polygon Renderer - Part2</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-FC3C933D-B164-4532-B5B5-5E3C6E5FADBD\"></a> \n                        <p><a name=\"GUID-29745549-FF7C-4DB0-A2BF-9B25D8B1831D\"></a>The second part of this tutorial expands on the previous example by adding depth sorting\n                           to avoid incorrectly overlapping polygons. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> <a name=\"GUID-27562DDD-C6AB-4039-8FEB-C939452646A1\"></a><dl>\n                  <dt><a name=\"GUID-A01A15D2-1585-4B32-8CE8-87F23C93C800\"></a><span class=\"term\"><a name=\"GUID-418CB7C7-C4AC-4562-9823-66326505A04F\"></a> <span class=\"char_link\"><a href=\"GUID-14B02950-26DF-498C-A88A-CD87DC84473C.htm\">How To ... Develop An SVG Polygon Renderer - Part3</a></span> </span></dt>\n                  <dd>\n                     <div class=\"definition\"><a name=\"GUID-92841717-C1A5-44B7-B6C6-5071913987AD\"></a> \n                        <p><a name=\"GUID-E3BD0E29-FE1C-4069-8C86-0ED0035AC17C\"></a>The third part of the tutorial implements material color and lighting support using\n                           Facets Shading with Blinn Specular Highlights. \n                        </p> \n                     </div>\n                  </dd>\n               </dl> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";