var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-68E7C8BE-E2A1-4C0A-A5A9-A9A122DE7A66\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Flatten a SplineShape</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-68E7C8BE-E2A1-4C0A-A5A9-A9A122DE7A66\"></a><div class=\"head\">\n            <h1>How To ... Flatten a SplineShape </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F1A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F1B\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; Flatten a SplineShape \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F1D\"></a>The following tutorial shows how to access and modify the splines and their knots\n            (vertices) and tangents in a SplineShape. The resulting macroScript will move all\n            knots to the Z height defined by the shape’s Z position, thus aligning them to a plane\n            parallel to the ground XY world construction plane. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F1E\"></a> <em class=\"strong\">Related Topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F1F\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining MacroScripts</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F20\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F21\"></a> <span class=\"char_link\"><a href=\"GUID-1C3873E2-A01A-4EF5-8B29-44617DFCDE81.htm\">Spline Shape Common Properties, Operators, and Methods</a></span> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F23\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F24\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F25\"></a><p class=\"table-body\">Package the code as macroScript to be able to use as a button, menu item or shortcut.\n                        \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F26\"></a><p class=\"table-body\">Enable the script only when a single Editable Spline without modifiers has been selected.\n                        \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F27\"></a><p class=\"table-body\">When executed, go through all splines in the shape </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F28\"></a><p class=\"table-body\">For each spline, go through all knots (vertices) </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F29\"></a><p class=\"table-body\">For each knot, set the Z coordinate of the In and Out tangent to the shape’s Z position\n                        \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F2A\"></a><p class=\"table-body\">For each knot, set knot’s Z coordinate to the shape’s Z position </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F2B\"></a><p class=\"table-body\">When ready with all splines and knots, update the shape. </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F2E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F2F\"></a><p class=\"table-body\"> <em class=\"strong\">MAXSCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6519\"></a><pre>\nmacroscript FlattenSpline category:\"HowTo\" tooltip:\"Flatten Spline\"\n(\non isEnabled return\n(\n&nbsp; selection.count == 1 and \\\n &nbsp;(classof selection[1] == SplineShape or\\\n &nbsp;classof selection[1] == Line) \\\n &nbsp;and selection[1].modifiers.count == 0\n)\non execute do\n(\n&nbsp; new_z = $.pos.z\n &nbsp;for s = 1 to (numSplines $) do\n&nbsp; (\n&nbsp;&nbsp;  for k = 1 to (numKnots $ s) do\n  &nbsp;&nbsp;(\n&nbsp;&nbsp;   &nbsp;knt = getKnotPoint $ s k\n   &nbsp;&nbsp;&nbsp;in_vec = getInVec $ s k\n   &nbsp;&nbsp;&nbsp;out_vec = getOutVec $ s k\n   &nbsp;&nbsp;&nbsp;knt.z = in_vec.z = out_vec.z = new_z\n   &nbsp;&nbsp;&nbsp;setInVec $ s k in_vec\n   &nbsp;&nbsp;&nbsp;setOutVec $ s k out_vec\n   &nbsp;&nbsp;&nbsp;setKnotPoint $ s k knt\n  &nbsp;&nbsp;)--end k loop\n &nbsp;)--end s loop\n  updateshape $\n)--end execute\n)--end script\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F4F\"></a> \n            <h2><a name=\"GUID-F8742F74-4328-42AF-AA96-8DD07419E421\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6518\"></a><pre><em class=\"codeEmphasisStrong\">macroscript FlattenSpline category:\"HowTo\" tooltip:\"Flatten Spline\"</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F52\"></a>The macroScript will be called <span class=\"code\"> <em class=\"strong\">FlattenSpline</em> </span>. To use the script, you can go to Customize... and drag the script from the category\n               \"HowTo\" to a toolbar, a menu, a quad menu or assign to a keyboard shortcut. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F53\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining Macro Scripts</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6517\"></a><pre><em class=\"codeEmphasisStrong\">on isEnabled return\n(\nselection.count == 1 and \\\n(classof selection[1] == SplineShape or \\\nclassof selection[1] == Line) \\\nand selection[1].modifiers.count == 0\n)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F5B\"></a>The macroScript ActionItem (button, menu item, shortcut) will only be enabled when\n               the scene selection contains a single object AND this one object is either a SplineShape\n               class (in other words an EditableSpline) without any modifiers as MAXScript cannot\n               modify a spline with modifiers on top. The result of the expression after the return\n               statement evaluates to true or false. When true, the script becomes enabled. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F5C\"></a>In these lines we compare the count of the current scene selection with 1, then the\n               class of the first selected object to the class SplineShape. Then once again we compare\n               the class of the first selected object with the class Line as a newly drawn line would\n               be an exception – we can modify it, but the class is not SplineShape until collapsed\n               to EditableSpline. Lastly, we check the number of modifiers and compare to 0. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F5D\"></a>If the first AND either the second OR the third, AND the fourth condition are true,\n               the selected object is valid and can be modified by the script! \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F5E\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-75AB\">Macroscript_Body_Event_Handlers</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F5F\"></a> <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm#WS73099CC142F487553098682E12AC2FC2BC7-3D36\">ClassOf</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F60\"></a> <span class=\"char_link\"><a href=\"GUID-C20D1836-542E-4458-B8A5-4D8C806FA120.htm\">ModifierArray Values</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6516\"></a><pre><em class=\"codeEmphasisStrong\">on execute do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F63\"></a>The <span class=\"code\"> <em class=\"strong\">on execute</em> </span> handler contains the actual code. It will be executed whenever the script is started\n               by clicking the button, selecting the item from a menu, using the keyboard shortcut\n               etc. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F64\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-75AB\">Macroscript_Body_Event_Handlers</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6515\"></a><pre><em class=\"codeEmphasisStrong\">new_z = $.pos.z</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F66\"></a>We will need the Z coordinate of the splineShape in order to move all Knots and Tangents\n               to that position. We store the Z component of the position of the scene selection\n               in the user variable new_z. Because we already checked in the isEnabled handler that\n               there is only one object selected, we don’t need to use selected[1] to access the\n               first selected object – we are completely sure the $ representing the current selection\n               is actually a single object! \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F67\"></a> <span class=\"char_link\"><a href=\"GUID-C17D0E4B-C408-426B-B300-7E23A0D98515.htm\">Node Transform Properties</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6514\"></a><pre><em class=\"codeEmphasisStrong\">for s = 1 to (numSplines $) do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F6A\"></a>A splineShape can contain any number of splines (a Donut shape for example contains\n               two circles!). To change every single spline, we will create a for loop which counts\n               from 1 to the number of splines in the selected object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F6B\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">For Loop</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F6C\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6513\"></a><pre><em class=\"codeEmphasisStrong\">for k = 1 to (numKnots $ s) do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F6F\"></a>Each spline in the shape can contain any number of knots. To change every single knot,\n               we will create another for loop which counts from 1 to the number of knots in the\n               s-th spline – the index of the spline is controlled by the outer for loop. Note that\n               the for k... loop will be executed again and again for each repetition of the for\n               s loop. So these are nested loops! \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F70\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">For Loop</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F71\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6512\"></a><pre><em class=\"codeEmphasisStrong\">knt = getKnotPoint $ s k</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F73\"></a>Using getKnotPoint, we read the K-th knot in the S-th spline in the selected splineShape.\n               We store its Point3 world coordinates in the user variable knt. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F74\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6511\"></a><pre><em class=\"codeEmphasisStrong\">in_vec = getInVec $ s k</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F76\"></a>Then we read the in vector of the K-th knot in the S-th spline in the selected splineShape.\n               We store its Point3 world coordinates in the user variable in_vec. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F77\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6510\"></a><pre><em class=\"codeEmphasisStrong\">out_vec = getOutVec $ s k</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F79\"></a>We read the out vector of the K-th knot in the S-th spline in the selected splineShape.\n               We store its Point3 world coordinates in the user variable out_vec. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F7A\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-650F\"></a><pre><em class=\"codeEmphasisStrong\">knt.z = in_vec.z = out_vec.z = new_z</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F7C\"></a>Now we can set the Z coordinate of both vectors and the knot to the new value stored\n               in the new_z variable. Note we can assign the same value to multiple variables as\n               MAXScript processes the expression by evaluating the right-hand side of the assignment\n               first then assigning the result to the left-hand side and so on. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F7D\"></a> <span class=\"char_link\"><a href=\"GUID-00294B7D-A624-43BA-8FF8-D684DAEBEF04.htm\">Variable Assignment</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-650E\"></a><pre><em class=\"codeEmphasisStrong\">setInVec $ s k in_vec\nsetOutVec $ s k out_vec</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F80\"></a>Now we can assign the new in and out vectors back to the respective knot and spline.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F81\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-650D\"></a><pre><em class=\"codeEmphasisStrong\">setKnotPoint $ s k knt</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F83\"></a>Then we assign the new knot position back to the respective knot and spline. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F84\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-650C\"></a><pre><em class=\"codeEmphasisStrong\">)--end k loop\n)--end s loop\nupdateshape $\n)--end execute</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F88\"></a>Finally, it is very important to update the splineShape. This makes all changes visible\n               by updating the internal data structures. Failing to do so could cause instabilities\n               in <em class=\"strong\">3ds Max</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F89\"></a> <span class=\"char_link\"><a href=\"GUID-6C6A35EB-DD5F-40C1-9869-0938849F6842.htm\">SplineShape : Shape</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-650B\"></a><pre><em class=\"codeEmphasisStrong\">)--end script</em></pre></div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F8D\"></a> \n            <h2><a name=\"GUID-B7FF41A8-BE73-4529-88F9-9FBDD771892A\"></a> <em class=\"strong\">Using the Script</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F8E\"></a>Evaluate the script. To use it, you can use Customize... to drag the script from the\n               category \"HowTo\" to a toolbar, a menu, a quad menu or to assign to a keyboard shortcut.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F8F\"></a>Select a single spline in the scene and execute the script. All knots should move\n               to become aligned to the XY plane in the height of the spline’s pivot. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F90\"></a> \n            <h2><a name=\"GUID-1DB662BF-CC8C-4837-8E86-BD6502DEC898\"></a> <em class=\"strong\">Where to go from here</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F91\"></a>You could add an UI with options to align to other construction planes or to move\n               the knots to the ground plane (by just using 0.0 instead of new_Z) \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F92\"></a> <em class=\"strong\">Back to</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1F93\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";