var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-69632609-C1FC-43F3-BA75-17033A41DA9C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Defining Custom Paint Tools Using the Painter Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Defining Custom Paint Tools Using the Painter Interface</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-69632609-C1FC-43F3-BA75-17033A41DA9C\"></a><div class=\"head\">\n            <h1>Defining Custom Paint Tools Using the Painter Interface </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-558F\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-558C\"></a> <span class=\"char_link\"><a href=\"GUID-01A9145F-54A0-4283-93BD-6F942C118E6C.htm\">PainterInterface</a></span>  \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-558B\"></a>The Painter Interface provides all necessary functions for developing custom Paint\n               Tools. The Interface .thePainterInterface drives all its callbacks through user-defined\n               functions. You need to implement the following functions:\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-558A\"></a> <em class=\"strong\">StartStroke</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5589\"></a> <em class=\"strong\">PaintStroke</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5588\"></a> <em class=\"strong\">EndStroke</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5587\"></a> <em class=\"strong\">CancelStroke</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5586\"></a> <em class=\"strong\">SystemEnd</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5585\"></a>These functions are callbacks in response to the paint system. They will be called\n               as the users paints across a mesh.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5584\"></a>To initialize these functions, you need to call <span class=\"code\"> <em class=\"strong\">thePainterInterface.ScriptFunctions</em> </span> method:\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5583\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5582\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7237\"></a><pre>\nfn startStroke = print \"Handle start stroke here\"\nfn paintStroke = print \"Handle paint stroke here\"\nfn endStroke = print \"Handle end stroke here\"\nfn cancelStroke = print \"Handle cancel stroke here\"\nfn systemEnd = print \"Handle system end here\"\nthePainterInterface.ScriptFunctions startStroke paintStroke endStroke cancelStroke systemEnd\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5578\"></a>Once you have established the connection the thePainterInterface, you will need to\n               tell it what to paint on. This is done by calling the initializeNodes method.\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5577\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5576\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7236\"></a><pre>\nnodeList = $\nthePainterInterface.initializeNodes 0 nodeList\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-49D92FDB129CC323221-6415\"></a><p class=\"table-body\">Once you have set up the nodes, you need to tell the system when you want to start\n                           a paint session:\n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7235\"></a><pre>\nthePainterInterface.startPaintSession()\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-49D92FDB129CC323221-6414\"></a><p class=\"table-body\">The Painter Interface will call your functions until you end the session. In order\n                           to finish painting, you should call\n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7234\"></a><pre>\nthePainterInterface.endPaintSession()\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5567\"></a> <span class=\"char_link\"><a href=\"GUID-01A9145F-54A0-4283-93BD-6F942C118E6C.htm\">PainterInterface</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5565\"></a> <span class=\"char_link\"><a href=\"GUID-409D100A-02E1-4539-B847-C3F6DFE6A66B.htm\">How To ... Develop a Bitmap Painting Tool - 3D Painting</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";