var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-6A7FF822-09E6-414A-9FEA-767FA12BEEB0\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>A360_Cloud_Rendering : RendererClass</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6A7FF822-09E6-414A-9FEA-767FA12BEEB0\"></a><div class=\"head\">\n            <h1> A360_Cloud_Rendering : RendererClass </h1>\n         </div>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">A360_Cloud_Rendering - superclass: RendererClass; super-superclass:MAXWrapper - 14:7 - classID: #(862667290, 1464541674)</em></pre></div>\n         <p><a name=\"GUID-3F0E5633-D2A6-4133-90DA-D50A2FD36CC8\"></a> Exposes the A360 Cloud Renderer to MAXScript. It allows you to upload render tasks\n            to the Autodesk Cloud for rendering. Available in \n            		<em class=\"strong\">3ds Max 2016 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-506A\"></a> <em class=\"strong\">Constructor</em> \n         </p>\n         <div class=\"codeBlock\"><pre> <em class=\"codeEmphasisStrong\">A360_Cloud_Rendering...\nA360Renderer...</em> </pre></div>\n         <p><a name=\"GUID-83B54C8A-0880-4DF4-826F-AE9FD779E8DE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-5059\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">UserLoggedIn</em>     BooleanClass    default: false   --  boolean</pre></div>\n         <p><a name=\"GUID-A7636CDC-5C67-4CC2-9A75-55D823B4A0CF\"></a>Returns True if the user is logged in, False if not logged in. Setting this value\n            to True using MAXScript has no effect. Exposed by the Jobs Mixin Interface. \n            	 \n         </p>\n         <p><a name=\"GUID-E71FE8B5-3BC4-4DB1-BF43-B0779D38847F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">RenderType</em>     String    default: \"image\"   --  string</pre></div>\n         <p><a name=\"GUID-95A25DC4-01A3-4330-B020-16F4DCD2BF39\"></a>Gets/sets the state of the \"Output Type\" drop-down list as a string value. Possible\n            values are: \n            	 <a name=\"UL_FCFB2A17D41C48A3B0C1529A015B9CEE\"></a><ul>\n               <li><em class=\"strong\">\"image\"</em> (default) - Still Image output \n                  		\n               </li>\n               <li><em class=\"strong\">\"panorama\"</em> - Interactive Panorama output \n                  		\n               </li>\n               <li><em class=\"strong\">\"ss_preview\"</em> - Preview Solar Study output \n                  		\n               </li>\n               <li><em class=\"strong\">\"solarstudy\"</em>- Solar Study output \n                  		\n               </li>\n               <li><em class=\"strong\">\"illuminance\"</em> - Illuminance output \n                  		\n               </li>\n            </ul> \n         </p>\n         <p><a name=\"GUID-37DF34F3-D4EA-4142-B65D-DE1E0887AB66\"></a> Attempting to assign any other string value will cause a runtime error and will also\n            print an error message to the MAXScript Listener listing the possible values. \n            	 \n         </p>\n         <p><a name=\"GUID-9B04A840-B1C9-48F4-9A99-CAF4B5F9F396\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">Quality</em>     String    default: \"draft\"   --  string</pre></div>\n         <p><a name=\"GUID-17A5797C-8C4B-42E1-988C-3445CE401D8B\"></a> Gets/sets the state of the \"Render Quality\" drop-down list as a string value. Possible\n            values are: \n            	 <a name=\"UL_726627DD9C094713BB4B7B89D4B8D0C4\"></a><ul>\n               <li><em class=\"strong\">\"draft\"</em>(default) - low render quality \n                  		\n               </li>\n               <li><em class=\"strong\">\"standard\"</em> - standard render quality \n                  		\n               </li>\n               <li><em class=\"strong\">\"high\"</em> - high render quality \n                  		\n               </li>\n               <li><em class=\"strong\">\"best\"</em> - highest render quality \n                  		\n               </li>\n            </ul> \n         </p>\n         <p><a name=\"GUID-C29465CA-E912-4CC9-93C4-F41135F30E1C\"></a> Attempting to assign any other string value will cause a runtime error and will also\n            print an error message to the MAXScript Listener listing the possible values. \n            	 \n         </p>\n         <p><a name=\"GUID-978E9C1B-9551-425B-940B-9F335DEEAD2D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">Width</em>     Integer    default: 640   --  integer</pre></div>\n         <p><a name=\"GUID-48F49898-EF22-4808-8A2A-AD5399B80DB8\"></a> Gets/sets the width of the render output in pixels. \n            	 \n         </p>\n         <p><a name=\"GUID-9234FD9A-0BA7-427D-A29C-1DA1720B331B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">Height</em>     Integer    default: 480   --  integer</pre></div>\n         <p><a name=\"GUID-36E00E53-4F41-4960-9410-121AA1AECB88\"></a> Gets/sets the height of the render output in pixels. \n            	 \n         </p>\n         <p><a name=\"GUID-EFD279B6-FCA0-468F-A71A-6946F7835CEC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">Exposure</em>     String    default: \"Advanced\"   --  string</pre></div>\n         <p><a name=\"GUID-2D0C87E3-7A12-4F9A-977C-FF8321F70835\"></a> Gets/sets the state of the \"Exposure\" drop-down list as a string value. Possible\n            values are: \n            	 <a name=\"UL_696E5B7E247B4414B6AC9BEA57D3F7C6\"></a><ul>\n               <li> <em class=\"strong\">\"Native\"</em> \n               </li>\n               <li> \n                  <p><a name=\"GUID-69AF9272-BEE7-4482-B5C5-4D2815BA85CB\"></a> <em class=\"strong\">\"Advanced\"</em> (default) \n                     		  \n                  </p> \n               </li>\n            </ul> \n         </p>\n         <p><a name=\"GUID-C28F4E1E-5018-4EE6-97E8-30D2B2E48E5D\"></a> Attempting to assign any other string value will cause a runtime error and will also\n            print an error message to the MAXScript Listener listing the possible values. \n            	 \n         </p>\n         <p><a name=\"GUID-2D93CA42-B7A8-4320-A91C-D5C8B8EECF43\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">Format</em>     String    default: \"JPEG\"   --  string</pre></div>\n         <p><a name=\"GUID-91A9D407-DCBC-4194-A060-6FFA4ECD5210\"></a> Gets/sets the File Format to render to as a string value. Possible values are: \n            	 <a name=\"UL_B201C4A850FD42FFBEAB59DD44313B7B\"></a><ul>\n               <li><em class=\"strong\">\"PNG\"</em> - save in Portable Network Graphics format (lossless compression) \n                  		\n               </li>\n               <li><em class=\"strong\">\"JPEG\"</em> - lossy compression (default) \n                  		\n               </li>\n               <li><em class=\"strong\">\"TIFF\"</em> - lossless compression \n                  		\n               </li>\n            </ul> \n         </p>\n         <p><a name=\"GUID-7413C213-72FD-4F00-BB90-B97CA9C83290\"></a> Attempting to assign any other string value will cause a runtime error and will also\n            print an error message to the MAXScript Listener listing the possible values. \n            	 \n         </p>\n         <p><a name=\"GUID-FA2FFF37-49C9-4F3D-859B-102E13C0E93E\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">NotifyByEmail</em>     BooleanClass    default: false   --  boolean; Notify_me_by_e_mail_when_complete</pre></div>\n         <p><a name=\"GUID-9944D6F6-D009-4C19-A8DB-BA45D9AA2A19\"></a> Gets/sets the state of the \"Notify me by e-mail when complete\" checkbox. When set\n            to True, the logged in user will be notified by email when the job is completed using\n            the email address from the user\'s registration. When set to False (default), no email\n            notification will be sent. \n            	 \n         </p>\n         <p><a name=\"GUID-4D9E285F-B96D-4DFF-B4A1-4FFA28BA36E8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">lastJobs</em>     String    default: \"[]\"   --  string</pre></div>\n         <p><a name=\"GUID-2F886448-7732-4849-99F1-8B601DA3AE2F\"></a> Contains a string describing the last jobs of the logged in user. \n            	 \n         </p>\n         <p><a name=\"GUID-1EFF235C-A5E2-4AEE-A9BA-8EBF32931300\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">WaitingTime</em>     Integer    default: -1   --  integer</pre></div>\n         <p><a name=\"GUID-F57E2E3C-9832-42A9-B715-FAD3C9CE4A84\"></a> Contains the waiting time in seconds. \n            	 \n         </p>\n         <p><a name=\"GUID-39BCC733-C890-4A24-BF60-D77CF8CBC19D\"></a> Contains -1 when not logged in. \n            	 \n         </p>\n         <p><a name=\"GUID-4527715C-BC5C-4084-85AC-5E7E2D7F8354\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">CheckPricePending</em>     BooleanClass    default: false   --  boolean</pre></div>\n         <p><a name=\"GUID-DC934011-8EB3-4671-8E0A-D2E05CF78AF1\"></a> Contains True when the price check is pending. \n            	 \n         </p>\n         <p><a name=\"GUID-3CB9E44E-A9FA-4AAD-92D2-F6C529894D70\"></a> Contains False when not logged in, when the price check has not been initiated, or\n            when the price check has finished. \n            	 \n         </p>\n         <p><a name=\"GUID-BDB7F19A-02C0-4B8E-9992-306F54475003\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">CheckPriceReceived</em>     BooleanClass    default: false   --  boolean</pre></div>\n         <p><a name=\"GUID-002FA3C1-27F2-4E82-BC9C-9B9985F5C74B\"></a> Contains True when the price has been received. \n            	 \n         </p>\n         <p><a name=\"GUID-8827E573-6B5B-4D4B-8DEC-B3A6A84EAAE9\"></a> Contains False when not logged in or the price has not been received yet. \n            	 \n         </p>\n         <p><a name=\"GUID-8A1E426A-EBD6-47EE-8FD3-256FC902A250\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">CreditsAvailable</em>     Integer    default: -1   --  integer</pre></div>\n         <p><a name=\"GUID-C195926B-264C-43C3-8099-8FF9155567DB\"></a> Contains the number of available credits on the logged in user\'s account. \n            	 \n         </p>\n         <p><a name=\"GUID-0868E854-90B9-4C5E-90E9-8D878D583549\"></a> Contains -1 when not logged in. \n            	 \n         </p>\n         <p><a name=\"GUID-84316614-6023-4EF1-820A-DCA1A7770ADB\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">CreditsNeeded </em>    Integer    default: -1   --  integer</pre></div>\n         <p><a name=\"GUID-BF9DAAB2-DF4A-4BEA-B180-B1634E31F8FD\"></a> Contains the number of credits needed to render the job. \n            	 \n         </p>\n         <p><a name=\"GUID-F1AA9E5E-EE60-4003-BF4D-AA56B112E795\"></a> Contains -1 when not logged in. \n            	 \n         </p>\n         <p><a name=\"GUID-5452B15D-CA4A-4183-8EF7-C637EFCC127A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"section\"><a name=\"SECTION_C7D47F3EA5384B0B84299362FCE03203\"></a> \n            <h2><a name=\"GUID-BBC5691D-401E-46DE-885F-AA2FAD922F2A\"></a>A360_Cloud_Rendering interfaces:\n            </h2> \n            <div class=\"codeBlock\"><pre>Interface: <em class=\"codeEmphasisStrong\">IMtlRender_Compability_Renderer</em></pre></div> \n            <p><a name=\"GUID-6D936D3A-A705-4548-BA29-20BCE0727AC2\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <p><a name=\"GUID-0C0BE398-FE87-49A5-BE25-F1DE19412B42\"></a>No properties exposed. \n               		\n            </p> \n            <p><a name=\"GUID-4151B796-7F14-42C5-9C90-DD9146EA34F6\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"GUID-9FC4F7E2-B432-4A67-A5CE-4C6A3D0EE09E\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <p><a name=\"GUID-CD410D9C-B4FD-49CE-A46F-246633A6574E\"></a> No methods exposed. \n               		\n            </p> \n            <p><a name=\"GUID-0BC4D6B0-0AB9-4354-AA01-FF0C65BB943E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"GUID-B509A02B-6FE7-4206-B217-0C44323B86AD\"></a> <em class=\"strong\">Actions:</em> \n            </p> \n            <p><a name=\"GUID-1030816B-4589-449B-ADC1-015A2CEE8417\"></a> No actions exposed. \n               		\n            </p> \n            <p><a name=\"GUID-7F765085-F646-480D-A13D-958E03C40101\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>Interface: <em class=\"codeEmphasisStrong\">jobs</em></pre></div> \n            <p><a name=\"GUID-ECE7E597-4BD6-4A8C-8FDE-47E338C4C47D\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><pre>\n&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">lastJobs</em> : string : Read\n&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">UserLoggedIn</em> : boolean : Read\n&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">CheckPricePending</em> : boolean : Read\n&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">CheckPriceReceived</em> : boolean : Read\n&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">CreditsNeeded</em> : integer : Read\n&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">CreditsAvailable</em> : integer : Read\n&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">WaitingTime</em> : integer : Read\n</pre></div> \n            <p><a name=\"GUID-812EEF56-51D4-41A2-AACB-53FD6CBB1E42\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"GUID-E5BEF149-7457-412E-8572-C33EC4444F25\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;string&gt;&lt;A360_Cloud_Rendering&gt;.<em class=\"codeEmphasisStrong\">QueryJobInfo</em> &lt;string&gt;jobID</pre></div> \n            <p><a name=\"GUID-4FCC2F3B-B162-476E-900D-68176E5E4966\"></a> Returns information about the job with the specified ID. \n               		\n            </p> \n            <p><a name=\"GUID-48BF3241-D943-421D-95A8-F06EA28815DF\"></a> The ID can be extracted from the \n               		  <span class=\"code\"> <em class=\"strong\">.lastJobs</em> </span> string. \n               		\n            </p> \n            <p><a name=\"GUID-C22705C3-BC6D-4A4A-8C3E-9F8042CE7499\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"GUID-4D698602-837E-4F09-A505-F767A996115D\"></a> <em class=\"strong\">Actions:</em> \n            </p> \n            <p><a name=\"GUID-4CC4CDAD-0FB5-433B-A037-6599EC706FC6\"></a> No actions exposed. \n               		\n            </p> \n            <p><a name=\"GUID-88A89431-8F57-4B27-9B00-BA935940FAFC\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2632\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2633\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-52A3\"></a><pre>\nAutodesk360.InitializeWebServices()\n--&gt;true\na360=A360_Cloud_Rendering()\n--&gt;A360_Cloud_Rendering:A360_Cloud_Rendering\nrenderSceneDialog.close()--close the render dialog\n--&gt;OK\nrenderers.current = a360 --assign the A360 renderer \na360.UserLoggedIn --check if the user is logged in \n--&gt;false\n--Log in if not logged in yet:\nif not a360.UserLoggedIn do Autodesk360.Login()\n--&gt;true\na360.UserLoggedIn    --check if the user is logged in now \n--&gt;true\nAutodesk360.getLoginUserName()--get the login name\n--&gt;\"yourname\"\n\nrenderers.target --check the target mode\n--&gt;\"local\"\nrenderers.target = \"cloud\" --set it to cloud rendering\n--&gt;\"cloud\"\nrenderSceneDialog.open() --re-open the render dialog\n--&gt;OK\n\na360.RenderType = \"image\" --render image\n--&gt;\"image\"\na360.Quality  = \"standard\" --increase quality from draft to standard\n--&gt;\"standard\"\na360.Exposure = \"Native\" --change the exposure from advanced do native\n--&gt;\"Native\"\na360.Width = 1000\n--&gt;1000\na360.Height = 750\n--&gt;750\na360.Format = \"PNG\" --set the format to Portable Network Graphics\n--&gt;PNG\na360.NotifyByEmail = true --send the user an email when done\n--&gt;true\na360.CreditsNeeded --see how many credits are needed\n--&gt;0\na360.CreditsAvailable --see how many credits are left\n--&gt;25\n--If there are enough credits, submit the job to the A360 Cloud\nif a360.CreditsNeeded &lt;= a360.CreditsAvailable do max quick render\n--&gt;OK	\na360.lastJobs \n--&gt;\"[  ]\"\na360.WaitingTime\n--&gt;0\n--Filter the last jobs string to create an array of strings\ntheFilteredJobs = filterString  a360.lastJobs  \":[]{} \\\",\"\n--&gt;#()\n--Print information about the last jobs:\nfor i = 4 to theFilteredJobs.count by 4 do\n  format \"%\\n\" (a360.QueryJobInfo theFilteredJobs[i])\n--&gt;OK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";