var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-6B150E47-DCB0-43D3-8C58-F506B5CC7B7A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I get the object by object name?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6B150E47-DCB0-43D3-8C58-F506B5CC7B7A\"></a><div class=\"head\">\n            <h1>How do I get the object by object name? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD54\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD56\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD57\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8C7\">Accessing Object Properties</a></span> &gt; How do I get the object by object name? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD59\"></a> \n            <h2><a name=\"GUID-83F298AA-FE33-4984-8447-4BF57AAB6C57\"></a> <em class=\"strong\">Many Users Asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD5A\"></a>When typing in known object paths in the Listener, in scripts or scripted controllers,\n               I can use the $ prefix to denote an object path (for example. $Box001 returns the\n               object called \"Box001\"). But sometimes all I have is the name of the object as string\n               (\"Box001\"), but I want to access the scene object that the name corresponds to. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD5B\"></a> \n            <h2><a name=\"GUID-AAF334CE-2E2A-4CB8-AD90-781B752D3D07\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD5C\"></a>There are multiple ways to convert an object name (a string) to the object path (a\n               MAXScript expression) corresponding to the scene object: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD5D\"></a> <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm#WS73099CC142F487553098682E12AC2FC2BC7-3D97\">getNodeByName</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD5E\"></a>This function provides an easy way to convert a name string to object path with case-sensitive\n               and case-insensitive options.See the link for details. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD5F\"></a> <span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm#WS73099CC142F487553098682E12AC2FC2BC7-5FEB\">Execute</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD60\"></a>Using the <em class=\"strong\">execute</em> method, it is possible to convert any string into a MAXScript expression. This includes\n               evaluating a string containing an object path into the object path itself. If an object\n               name is stored in a string variable, you have to add the \"$\" character as string to\n               the name to convert it into object path. Since certain special characters like \".\"\n               (period) or \" \" (space) cannot be evaluated when being part of the name string, it\n               is advisable to add \"\'\" (single quote) characters around the object\'s name to prevent\n               an evaluation error. Any characters enclosed between the single quote characters will\n               be recognized as part of the string. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD61\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD62\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-665C\"></a><pre>\n--if an object is called Box001, you could use\nobjName = \"Box001\"\nobjPath = execute (\"$\'\"+objName + \"\'\")\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD6A\"></a> <span class=\"char_link\"><a href=\"GUID-24161478-A63E-4D18-8AF0-2AACD35D9232.htm\">Why does Execute return \'undefined\' when accessing a loop variable?</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCD6B\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";