var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-6CF536D8-B90A-4998-AA16-71F23E710B47\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"mapped function definition\">\n      <meta name=\"indexterm\" content=\"function\">\n      <meta name=\"indexterm\" content=\"fn function definition\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"indexterm\" content=\"creating functions\">\n      <meta name=\"indexterm\" content=\"showSource()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Creating Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6CF536D8-B90A-4998-AA16-71F23E710B47\"></a><div class=\"head\">\n            <h1>Creating Functions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E8731B\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8731C\"></a>     Functions are defined in MAXScript using the function definition expression. \n            </p> \n            <p><a name=\"P_67BD0337CDE24D8E9F4F97BC51D781F7\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87322\"></a>The <em class=\"strong\">syntax</em> for <span class=\"code\">&lt;function_def&gt;</span> is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60A2\"></a><pre>[<em class=\"codeEmphasisStrong\">mapped</em>] ( <em class=\"codeEmphasisStrong\">function</em> | <em class=\"codeEmphasisStrong\">fn</em>) &lt;name&gt; { &lt;parameter&gt; } <em class=\"codeEmphasisStrong\">=</em> &lt;expr&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87324\"></a>Here, <span class=\"code\">&lt;name&gt;</span> is the name of the function. \n            </p> \n            <p><a name=\"P_68C3B5B91E2B45548570C194001C0EBF\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87325\"></a>The optional sequence of <span class=\"code\">&lt;parameter&gt;</span> can be one of: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60A1\"></a><pre>&lt;name&gt;\n&lt;name&gt;<em class=\"codeEmphasisStrong\">:</em> [&lt;operand&gt;] --keyword parameter with optional default value   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87329\"></a>The <span class=\"code\"> &lt;expr&gt; </span> after the <span class=\"code\"> <em class=\"strong\">\'=\'</em> </span> (equal sign) is the body of the function. \n            </p> \n            <p><a name=\"P_AF69057DF895469787BEA4669D003AA3\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8732A\"></a>The function <span class=\"code\"> &lt;name&gt; </span> is actually used to name a variable into which a value representing the function\n               is placed. \n            </p> \n            <p><a name=\"P_CF15B31AAE294CE1B9D93ACD6BD40A64\"></a>When you call a function by using its name, you are accessing its definition in a\n               variable of that name. \n            </p> \n            <p><a name=\"P_771BDF24A4CD43029223A0C5796C3439\"></a>The scope of the function name variable is the current MAXScript scope. \n            </p> \n            <p><a name=\"P_D4C34C8B37C34FA2826610B4C4EAE92E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8732B\"></a>The parameters for a function are either <em class=\"strong\">positional</em> or <em class=\"strong\">keyword</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8732C\"></a> <em class=\"mild\">Positional parameters</em> are defined with a simple <span class=\"code\"> &lt;name&gt; </span> and must be placed before any keyword parameters. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8732D\"></a> <em class=\"mild\">Keyword parameters</em> have a \':\' (colon) after the name and an optional default value. The caller of the\n               function can optionally supply keyword arguments in any order. Those not supplied\n               is set to the given default value, or the special value <span class=\"code\"> <em class=\"strong\">unsupplied</em> </span> if a default value is not given. \n            </p> \n            <p><a name=\"P_9DC12C9F63B04A43A4E9A39D86D5221E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8732E\"></a>Using the <span class=\"code\"> <em class=\"strong\">mapped</em> </span> prefix on a function definition marks this function to be automatically mapped over\n               collections. \n            </p> \n            <p><a name=\"P_A21E9EB4191C45419D3DB8173358AB7B\"></a>This means the function is automatically called repeatedly on the elements of a collection\n               if the collection is given as the first argument to the function. \n            </p> \n            <p><a name=\"P_F7B7ADBED18E4E0BBE62E22C4BCA3047\"></a>This allows you to define scripted functions that behave in a similar manner to the\n               <em class=\"strong\">mapped</em> built-in functions such as, copy, delete, move, and so on, which can be applied to\n               an object set, path name pattern, or array. \n            </p> \n            <p><a name=\"P_12F7D00BFD12499FB5CFD674218658DA\"></a>See <span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collections</a></span> for more information. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8732F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87330\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60A0\"></a><pre>\nfunction my_add a b = a + b\nfn factorial n = if n &lt;= 0 then 1 else n * factorial (n - 1)\nmapped function rand_color x =\nx.wireColor = random (color 0 0 0) (color 255 255 255)\nfn starfield count extent:[200,200,200] pos:[0,0,0] =\n(\nlocal f = pos - extent / 2,\nt = pos + extent / 2\nfor i = 1 to count do\nsphere name: \"star\"\\\nradius:(random 0.1 2.0) \\\nposition:(random f t) \\\nsegs:4 smooth:false\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87342\"></a>A scripted function returns as its value the value of the body <span class=\"code\"> &lt;expr&gt; </span>. If the body is a block-expression, the function evaluates to the value of the last\n               expression in the block. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87343\"></a>A function can be called recursively (that is, the function can call itself), as is\n               the <span class=\"code\"> <em class=\"strong\">factorial</em> </span> function in the previous examples. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87344\"></a>If you need to locate the source of a scripted function, you can use the <span class=\"code\"> <em class=\"strong\">showSource()</em> </span> function. It displays a script Editor containing the source file in which the function\n               was defined and positioned at the function\'s definition. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87345\"></a>The form is: \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-7045\"></a>  \n            </p> \n            <p><a name=\"P_BE40E7D81EF44435A3AE35D369EB9165\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-609F\"></a><pre><em class=\"codeEmphasisStrong\">showSource</em> &lt;fn&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87347\"></a>This is useful for browsing definitions if you are working on many scripted functions\n               that were defined in several script files. \n            </p> \n            <p><a name=\"P_4B3DCE669B8B497C9C1F79CB961A5DC7\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87349\"></a> <span class=\"char_link\"><a href=\"GUID-7B851ED2-B59C-45E7-97BF-16B0A5C02971.htm\">Function Variables</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8734A\"></a> <span class=\"char_link\"><a href=\"GUID-B48DA525-F64B-480C-A6E1-3A05D09007F7.htm\">Function Parameters</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8734B\"></a> <span class=\"char_link\"><a href=\"GUID-07D714FC-B207-4BBF-9590-16C93C631F50.htm\">The Return Expression</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8734C\"></a> <span class=\"char_link\"><a href=\"GUID-3F90A2E3-2AA1-4C3E-9474-15EE04750992.htm\">Special Notes about Function Calls</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";