var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-6DE57ABF-F7CA-4256-8B2D-F2271401FCBB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSMirrorCurve - NURBSCurve\">\n      <meta name=\"indexterm\" content=\"NURBSCurve - NURBSObject\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSMirrorCurve : NURBSCurve</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6DE57ABF-F7CA-4256-8B2D-F2271401FCBB\"></a><div class=\"head\">\n            <h1>NURBSMirrorCurve : NURBSCurve </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44E5\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44E4\"></a>  This class defines a dependent Mirror curve. A Mirror curve is similar to a mirror\n               object that you create using the Mirror tool (on the <em class=\"strong\">3ds Max</em> toolbar) or the Mirror modifier. It is the original curve reflected about one or\n               two axes. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44E1\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21D4\"></a><pre><em class=\"codeEmphasisStrong\">NURBSMirrorCurve</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44DF\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21D3\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44DB\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21D2\"></a><pre>&lt;nurbsmirrorcurve&gt;.<em class=\"codeEmphasisStrong\">parent</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44D9\"></a>The parent curve by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21D1\"></a><pre>&lt;nurbsmirrorcurve&gt;.<em class=\"codeEmphasisStrong\">parentID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44D6\"></a>The parent curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21D0\"></a><pre>&lt;nurbsmirrorcurve&gt;.<em class=\"codeEmphasisStrong\">axis</em> :<em class=\"codeEmphasisStrong\">#X, #Y, #Z, #XY, #XZ, #YZ</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44D3\"></a>The axis or axes of reflection for the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21CF\"></a><pre>&lt;nurbsmirrorcurve&gt;.<em class=\"codeEmphasisStrong\">distance</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44D0\"></a>The mirror offset distance. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21CE\"></a><pre>&lt;nurbsmirrorcurve&gt;.<em class=\"codeEmphasisStrong\">transform</em> : matrix3 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44CD\"></a>This is an additional transformation applied to the axis specification. This corresponds\n               to the gizmo the user may use interactively to alter the location of the mirror axis.\n               This is exactly equivalent to setting the transform on the gizmo of a mirror modifier.\n               \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44CA\"></a> <span class=\"char_link\"><a href=\"GUID-8CEABA20-9D21-4ED0-AA95-3749435D2104.htm\">NURBSCurve</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44C9\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44C8\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";