var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-6E2727F1-BF6E-4C3D-AF3B-121B1B59DACF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"utility\">\n      <meta name=\"indexterm\" content=\"managing multiple rollouts in a scripted utility\">\n      <meta name=\"indexterm\" content=\"addRollout()\">\n      <meta name=\"indexterm\" content=\"removeRollout()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Managing Multiple Rollouts in a Scripted Utility</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6E2727F1-BF6E-4C3D-AF3B-121B1B59DACF\"></a><div class=\"head\">\n            <h1>Managing Multiple Rollouts in a Scripted Utility </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A34\"></a>MAXScript includes support for managing multiple rollouts in one utility, which is\n            useful in large scripted utilities that are unwieldy in one rollout. There is one\n            main rollout defined by the user-interface items in the utility definition. The other\n            rollouts are defined as nested rollouts within the body of the utility definition.\n            These other rollouts can be added to and removed from the Utilities panel under script\n            control. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A33\"></a>You can define extra rollouts with the <span class=\"code\"> <em class=\"strong\">rollout</em> </span> clause inside a utility definition: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74D0\"></a><pre>\nutility foo \"name\"\n(\nlocal ...\nspinner ...\n...\nrollout baz \"name\"\n(\nlocal ...\ncheckbox ..\non ...\n)\n...\n)\n</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A25\"></a>Such nested rollouts can contain anything that a utility definition can contain with\n            the exception of further nested rollouts. Nested rollouts are not automatically opened\n            or closed when the parent utility rollout opens and closes. You need to explicitly\n            do this in the open and close handlers, or other handlers or functions in the utility.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A24\"></a>There are two functions for this: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74CF\"></a><pre><em class=\"codeEmphasisStrong\">addRollout</em> &lt;rollout&gt; [ <em class=\"codeEmphasisStrong\">rolledUp</em>:&lt;boolean&gt; ] <em class=\"codeEmphasisStrong\">removeRollout</em> &lt;rollout&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A20\"></a>The <span class=\"code\"> <em class=\"strong\">rolledUp:</em> </span> parameter on the <span class=\"code\"> <em class=\"strong\">addRollout()</em> </span> function specifies whether the rollout is added in a rolled-up state. This defaults\n            to <span class=\"code\"> <em class=\"strong\">false</em> </span>, so the rollout is added fully opened. The nested rollouts are arranged in the order\n            of <span class=\"code\"> <em class=\"strong\">addRollout()</em> </span> calls, so take care in sequencing these to ensure the order you want. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A1F\"></a>The nested rollouts do not automatically get removed when the main utility rollout\n            is closed. You must make sure they are explicitly removed, typically in the close\n            handler for the main utility. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A1E\"></a>To always open and close extra rollouts when the main utility is opened and closed,\n            place <span class=\"code\"> <em class=\"strong\">addRollout()</em> </span> and <span class=\"code\"> <em class=\"strong\">removeRollout()</em> </span> calls in the main utility open and close handlers. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A1D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A1C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74CE\"></a><pre>\non foo open do\n(\n...\naddRollout panel_1\naddRollout panel_2 rolledUp:true\n...\n)\non foo close do\n(\n...\nremoveRollout panel_1\nremoveRollout panel_2\n...\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A0A\"></a>Calling <span class=\"code\"> <em class=\"strong\">removeRollout()</em> </span> on an already closed rollout is OK and does nothing. If during utility development,\n            you forget to close a nested rollout, closing the entire MAXScript utility will remove\n            any remaining open scripted rollouts. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A09\"></a>Because these rollout definitions are nested within a utility, all the locals, functions,\n            and other items in the utility are visible to nested rollouts, following the standard\n            nested scoping in MAXScript. This means you can \"reach out\" and access the utility’s\n            locals, user-interface control items, and functions. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A08\"></a>Conversely, user-interface control items and locals in nested rollouts are exposed\n            as properties of that rollout, so code in the main utility or other rollouts can \"reach\n            in\" and access them. In the following example, the spinner<span class=\"code\"> <em class=\"strong\">bar</em> </span> change handler looks at the state of a check box in the nested rollout <span class=\"code\"> <em class=\"strong\">baz</em> </span>: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A07\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6A06\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74CD\"></a><pre>\nutility foo \"name\"\n(\nlocal ...\nlocal ...\nspinner bar ...\n...\nrollout baz \"name\"\n(\nlocal ...\ncheckbox baz_enable ...\non ...\n)\n...\non bar changed val do\nif baz.baz_enable.checked == true then...\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69F4\"></a>You can control the grouping of rollouts by supplying a <span class=\"code\"> <em class=\"strong\">category:&lt;integer&gt;</em> </span> header parameter before the opening parenthesis of the rollout body. The category\n            numbers order the rollouts. In the following example, the rollouts are defined and\n            added in a certain order, but displayed in another based on their category number:\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69F3\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69F2\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74CC\"></a><pre>\n(\nrollout first_rollout \"1st Rollout\" category:2\n(\nlabel rights \"First\"\n)\nrollout second_rollout \"2nd Rollout\" category:1\n(\nlabel second \"Second\"\n)\nrf = newRolloutFloater \"Rollout Order Test\" 200 140\naddRollout first_rollout rf\naddRollout second_rollout rf\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69E0\"></a> <span class=\"char_link\"><a href=\"GUID-B478B60B-B27D-4916-A07E-264818666080.htm\">Scripted Utilities</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69DF\"></a> <span class=\"char_link\"><a href=\"GUID-9BA10055-A4EA-4F2B-B356-8C41FCFC86A2.htm\">Scripted Utility Panels</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-69DE\"></a> <span class=\"char_link\"><a href=\"GUID-934D13D7-94E9-4481-8832-25A5B83C949F.htm\">Utility Clauses</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";