var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ActiveX Controls in MAXScript Rollouts\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ActiveX Controls in MAXScript Rollouts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA\"></a><div class=\"head\">\n            <h1>ActiveX Controls in MAXScript Rollouts </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CF7\"></a> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75BB\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CF1\"></a> <img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\"> ActiveX Controls have been deprecated by Microsoft in the latest versions of the\n                     Windows operating system in favor of the <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet</a></span> framework and its controls. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CF0\"></a>While MAXScript still supports ActiveX controls, these have to be installed and registered\n                     on the system to be accessible to MAXScript. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CEF\"></a>As a replacement of ActiveX controls, MAXScript supports <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet controls</a></span> in <em class=\"strong\">3ds Max 9 and higher</em>. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CEC\"></a>Starting with <em class=\"strong\">3ds Max 4</em>, MAXScript lets the user embed ActiveX Controls in rollouts, thus expanding the number\n               of available User Interface control types. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CEB\"></a>Examples include: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CEA\"></a> <em class=\"strong\">Simple controls</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-713F\"></a><pre>ActiveMovieControl Object,Calendar Control,Microsoft TreeView</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CE6\"></a> <em class=\"strong\">Compound controls</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-713E\"></a><pre>Microsoft Excel,Microsoft Internet ExplorerAdobe Acrobat</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CE1\"></a>This provides numerous possibilities in MAXScript which include: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CE0\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CDE\"></a>Embed a web browser into a rollout and then navigate the user to a web site. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CDC\"></a>Embed an Excel spreadsheet into a rollout, extract the user entered values from cells\n                     and then create animation in Max. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CDA\"></a>Create an ActiveMovie player through MAXScript, load an Avi file and then synchronize\n                     the animation between the rendered Avi in ActiveMovie player to animation in Max.\n                     \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CD9\"></a>The technology behind this feature is a MAXScript extension plug-in (MxsActiveX.dlx)\n               making it MAXScript capable. It does not use ParamBlock2. The plug-in adds a new type\n               of rollout control. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CD8\"></a> <em class=\"strong\">The syntax is: </em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-713D\"></a><pre><em class=\"codeEmphasisStrong\">activeXControl</em> &lt;name&gt; [ &lt;control_type&gt; ] [	<em class=\"codeEmphasisStrong\">setupEvents:</em>&lt;boolean&gt; ] [	<em class=\"codeEmphasisStrong\">releaseOnClose:</em>&lt;boolean&gt;	] [	<em class=\"codeEmphasisStrong\">prop1</em>:&lt;value&gt; ] [	<em class=\"codeEmphasisStrong\">prop2</em>:&lt;value&gt; ] &amp;ldots; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CD6\"></a> <em class=\"strong\">Parameters:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-713C\"></a><pre>&lt;<em class=\"codeEmphasisStrong\">control_type</em>&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CD4\"></a>A string to create the control. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CD3\"></a>The string <em class=\"strong\">must</em> be formatted in one of the following ways: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CD2\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CD0\"></a>A Program ID such as \"MSCAL.Calendar.7\" \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CCE\"></a>A Class ID such as \"{8E27C92B-1264-101C-8A2F-040224009C02}\" \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CCC\"></a>A URL such as \"http://www.microsoft.com\" \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CCA\"></a>A reference to an Active document such as \"file://\\\\Documents\\MyDoc.doc\" \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CC8\"></a>A fragment of HTML such as \"MSHTML:&lt;HTML&gt;&lt;BODY&gt;This is a line of text&lt;/BODY&gt;&lt;/HTML&gt;\"\n                     \n                  </p> \n               </li>\n            </ul> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75BA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-B47FD61D-4396-4F70-B24C-D3E09404F912\"></a>\"MSHTML:\" must precede the HTML fragment so that it is designated as being a MSHTML\n                     stream. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"GUID-A0CF4D6A-C1EF-4D90-9922-2E1DE2E4ED84\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-713B\"></a><pre><em class=\"codeEmphasisStrong\">prop1:&lt;value&gt;</em> </pre></div> \n            <p><a name=\"GUID-5EA0F91A-79E6-4E58-B395-E168DA2CFE26\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-713A\"></a><pre><em class=\"codeEmphasisStrong\">prop2:&lt;value&gt;</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CC1\"></a>These are control specific keyword arguments. You can get a list of properties and\n               their types by calling <span class=\"code\"> <em class=\"strong\">showProperties</em> </span> on the control. \n            </p> \n            <p><a name=\"GUID-BADFD0FD-1638-4016-93B0-84D1B0BD3C83\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7139\"></a><pre><em class=\"codeEmphasisStrong\">setupEvents:&lt;boolean&gt;</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CBF\"></a>When set to <span class=\"code\"> <em class=\"strong\">true</em> </span> (default), event support for activeX controls will be enabled. When set to <span class=\"code\"> <em class=\"strong\">false</em> </span>, none of the event handlers will be called. This is useful when a control fires too\n               many events but you are not interested in any. \n            </p> \n            <p><a name=\"GUID-EB78C5BB-B379-4130-AF09-790D826AD95C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7138\"></a><pre><em class=\"codeEmphasisStrong\">releaseOnClose:&lt;boolean&gt;</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CBD\"></a>Every activeX control creates two hidden controls. Passing <span class=\"code\"> <em class=\"strong\">true</em> </span> here (default) will free them up and also any resources taken up by the control,\n               and the activex properties cannot be accessed after the rollout has been closed. This\n               is the case for window\'ed controls like listview, treeview etc. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CBC\"></a>If you need to access the properties of the control after you close the rollout, then\n               you need to pass <span class=\"code\"> <em class=\"strong\">false</em> </span>. This is helpful for windowless control like XML parser, FTP controls etc. See <em class=\"strong\">xmlio.ms</em> for an example. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CBA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CB9\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7137\"></a><pre>\nactiveXControl ax \"{05589FA1-C356-11CE-BF01-00AA0055595A}\" \\ height:200 width:300 align:#left\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CB5\"></a> \n            <h2><a name=\"GUID-8713B836-01D1-43E8-8E59-D31F4DE88DD4\"></a> <em class=\"strong\">ActiveX Controls Topics:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CB4\"></a> <span class=\"char_link\"><a href=\"GUID-37CB6A37-B1D9-41F5-AD94-C196E76A729C.htm\">ActiveX Control Properties</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CB3\"></a> <span class=\"char_link\"><a href=\"GUID-821C8560-8D09-4B15-B621-D22DA34343D5.htm\">Active X Controls Methods</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CB2\"></a> <span class=\"char_link\"><a href=\"GUID-A81EA1A3-BE58-4A69-BB30-474F805D5E81.htm\">Active X Inspector Functions</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CB1\"></a> <span class=\"char_link\"><a href=\"GUID-ABE0F393-E18C-464B-95AB-7AD6A6879B09.htm\">Accessing ActiveX Controls Indexed Properties</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CB0\"></a> <span class=\"char_link\"><a href=\"GUID-F4EB0656-9607-42E8-8FAE-6E04CE44E903.htm\">ActiveX Controls Cursor Access</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CAF\"></a> <span class=\"char_link\"><a href=\"GUID-7B4262BD-FE95-4DAF-894B-284A92100171.htm\">ActiveX Array Properties</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CAE\"></a> <span class=\"char_link\"><a href=\"GUID-F9BDCDFD-5C2D-42ED-A840-184795A2E057.htm\">ActiveX - Disable3ds Maxkeyboard accelerators</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CAD\"></a> <span class=\"char_link\"><a href=\"GUID-65B8D93C-FC48-49CB-BF36-6B2C40503F4D.htm\">ActiveX COM Enums Represented as MAXScript Names</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CAC\"></a> <span class=\"char_link\"><a href=\"GUID-C62167A8-8ED9-422E-BCE1-F01ADDA41D33.htm\">ActiveX by-reference arguments for methods and events</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CAA\"></a> <span class=\"char_link\"><a href=\"GUID-8A271B35-D0A9-4155-B92E-21B356F6ACFF.htm\">loadPicture for ActiveX Controls</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CA9\"></a> <span class=\"char_link\"><a href=\"GUID-3C76F71F-7341-4258-AB9B-BF38AE498376.htm\">updateWindow for ActiveX Controls</a></span> \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CA7\"></a> \n               <h3><a name=\"GUID-1096627D-36F6-4DD2-8A04-85B54E00A7B3\"></a> <em class=\"strong\">Typical ActiveX Controls And Examples</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CA6\"></a> <span class=\"char_link\"><a href=\"GUID-0C6E7C77-A065-4602-9930-4FE275AE3B9A.htm\">ListView ActiveX Control</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CA5\"></a> <span class=\"char_link\"><a href=\"GUID-D62ADC40-0FEB-42FC-AD97-0C6BC5BD383E.htm\">ListView ActiveX Helper Functions</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CA4\"></a> <span class=\"char_link\"><a href=\"GUID-87081207-7388-4F7E-AA7B-60D00ABECF03.htm\">ListView ActiveX Control Example</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CA3\"></a> <span class=\"char_link\"><a href=\"GUID-CE10C843-DBC1-4FFF-94CE-BCD79F8FF31C.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                        One</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CA2\"></a> <span class=\"char_link\"><a href=\"GUID-C9BD442F-7B4E-42F6-92CC-31B2DEE9E4FB.htm\">How To ... Develop a Selected Objects Inspector using ListView ActiveX Control - Part\n                        Two</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4CA0\"></a> <span class=\"char_link\"><a href=\"GUID-C2B51AEE-9C08-4679-B625-A36C72025C91.htm\">TreeView ActiveX Control</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C9F\"></a> <span class=\"char_link\"><a href=\"GUID-E6C53A89-CE94-4E2C-8143-7C8767BDC772.htm\">How To ... Develop a Scene Browser using TreeView ActiveX Control - Part One</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C9E\"></a> <span class=\"char_link\"><a href=\"GUID-399134B9-7BC1-4F2A-9525-BD7EED14221D.htm\">How To ... Develop a Scene Browser using TreeView ActiveX Control - Part Two</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C9C\"></a> <span class=\"char_link\"><a href=\"GUID-B2761D73-7B3D-4A71-99E1-637C34059BBB.htm\">ImageList ActiveX Control</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C9A\"></a> <span class=\"char_link\"><a href=\"GUID-5460ECA8-63BE-45B7-A3FB-79EFEB8232B5.htm\">TabStrip ActiveX Control</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C98\"></a> <span class=\"char_link\"><a href=\"GUID-B87B076E-0057-41A7-97A3-C0A8315FB699.htm\">Windows Media Player ActiveX Control</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C97\"></a> <span class=\"char_link\"><a href=\"GUID-03958ED1-69C2-425D-8DEF-A386DEA6765D.htm\">Windows Media Player ActiveX Control Example</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C95\"></a> <span class=\"char_link\"><a href=\"GUID-7DA4342B-6D1A-438B-9F1F-BCD48D742F19.htm\">Adobe Acrobat ActiveX Control</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C94\"></a> <span class=\"char_link\"><a href=\"GUID-5B78FC97-8913-4CAF-9BEE-71436D045AE7.htm\">Internet Explorer ActiveX Control</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C93\"></a> <span class=\"char_link\"><a href=\"GUID-EE307693-ACA8-4C1F-AE03-BDAE3C585C57.htm\">Excel Spreadsheet in Internet Browser Control as Extended Viewport</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C92\"></a> <span class=\"char_link\"><a href=\"GUID-D84D283E-F722-48EB-A712-C893ACB53C30.htm\">Shockwave Flash ActiveX Object Events</a></span> \n               </p> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C8F\"></a> <span class=\"char_link\"><a href=\"\">i-drop - drag and drop</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C8E\"></a> <span class=\"char_link\"><a href=\"GUID-C3EEFA6F-6132-445E-B256-083679CEC9CB.htm\">Visual MAXScript</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4C8D\"></a> <span class=\"char_link\"><a href=\"GUID-E66C9960-E058-4EF8-92EA-EB65365B79CF.htm\">MAXScript Dialogs and Rollout Floaters as Extended viewports</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";