var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-6EF57030-B59F-4341-B6AA-BFB4269AE913\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Selection Filter\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Selection Filter</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6EF57030-B59F-4341-B6AA-BFB4269AE913\"></a><div class=\"head\">\n            <h1>Selection Filter </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BAE\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BAD\"></a> The Selection Filter list lets you restrict the selection done by the selection tools\n               to specific types and combinations of objects. For example, if Cameras is selected,\n               you can select only cameras with the selection tools. Other objects cannot be selected\n               interactively with the mouse in the viewport. Although, they can be selected using\n               the Select By Name, Selection Sets, or MAXScript select methods. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BAB\"></a> \n               <h3><a name=\"GUID-76C9ED60-1CAC-45BC-9D91-E6248E249C4C\"></a> <em class=\"strong\">Selection Filter Methods:</em> \n               </h3> \n               <p><a name=\"GUID-250C5ED3-D108-4230-A6D0-04D2E5AED9B7\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E03\"></a><pre>&lt;int&gt;<em class=\"codeEmphasisStrong\">GetSelectFilter</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BA9\"></a>Returns the index of the current selection select filter in the selection filter list.\n                  For example, by default 1 means All, 4 means Lights, 8 means Bones, and so on. \n               </p> \n               <p><a name=\"GUID-9701E211-03F8-4F09-ADDC-966340776B6C\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E02\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">SetSelectFilter</em> &lt;int_index&gt; 	 </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BA6\"></a>Set the current select filter by index. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BA5\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BA4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E01\"></a><pre>\nsetSelectFiler 5 --set selection filter to Cameras\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-37BFB26A-B1CC-4A10-BDAD-692CE2EDC748\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E00\"></a><pre>&lt;int&gt;<em class=\"codeEmphasisStrong\">GetNumberSelectFilters</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B9D\"></a>Returns the number of selection filters in the drop down. \n               </p> \n               <p><a name=\"GUID-0A234A68-796B-46C6-9EE8-A0C5289AD30B\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DFF\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">GetSelectFilterName</em> &lt;int_index&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B9A\"></a>Returns the name of the indexed selection filter. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B98\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B97\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DFE\"></a><pre>\nfor i = 1 to GetNumberSelectFilters() do --go through all\nformat \"%: %\\n\"i (GetSelectFilterName i) --print index and name\n--result:\n--&gt;1: All\n--&gt;2: Geometry\n--&gt;3: Shapes\n--&gt;4: Lights\n--&gt;5: Cameras\n--&gt;6: Helpers\n--&gt;7: Warps\n--&gt;8: Bone\n--&gt;9: IK Chain Object\n--&gt;10: Point\n--&gt;11: CAT Bone\n--&gt;OK\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B85\"></a> \n               <h3><a name=\"GUID-E3312DA7-F450-4D18-B035-695D6D81A5A3\"></a> <em class=\"strong\">Display Filter Methods:</em> \n               </h3> \n               <p><a name=\"GUID-66B3E008-9A6C-4A93-91E7-F3AB8788E53C\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DFD\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">GetDisplayFilter</em> &lt;int_index&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B83\"></a>Returns true if the indexed display filter is enabled, false otherwise. \n               </p> \n               <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7583\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Unlike, the Selection filers that can be enabled only one at a time, any number of\n                     Display filters can be activated at the same time. \n                  </div>\n               </div> \n               <p><a name=\"GUID-657C083E-F071-4C3E-9F13-33A223EB0975\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DFC\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">SetDisplayFilter</em> &lt;int_index&gt; &lt;bool_on&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B7D\"></a>Sets the enabled state of the indexed display filter to the supplied Boolean value.\n                  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B7C\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B7B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DFB\"></a><pre>\nsetDisplayFiler 3 --set display filter to Point\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-FDB61FCC-E436-4616-80F5-F2D6FB3AE513\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DFA\"></a><pre>&lt;int&gt;<em class=\"codeEmphasisStrong\">GetNumberDisplayFilters</em> </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B75\"></a>Returns the number of display filters in the display panel\'s list box. \n               </p> \n               <p><a name=\"GUID-DA58E99C-EA6E-4CD0-AE18-838770F2AE63\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DF9\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">GetDisplayFilterName</em> &lt;int_index&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B72\"></a>Returns the name of the indexed display filter. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B70\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B6F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DF8\"></a><pre>\nfor i = 1 to GetNumberDisplayFilters() do --go through all\nformat \"%: %\\n\"i (GetDisplayFilterName i) --print index and name\n--result:\n--&gt;1: Bone\n--&gt;2: IK Chain Object\n--&gt;3: Point\n--&gt;4: CAT Bone\n--&gt;OK\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B63\"></a> <span class=\"char_link\"><a href=\"GUID-97C887B6-CE4D-46EB-AB10-BE3A9DC2F69A.htm\">Class Id Filters</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3B62\"></a> <span class=\"char_link\"><a href=\"GUID-408F43DA-6C99-4CF5-96D5-78836A5DCB02.htm\">Main Toolbar</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";