var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-71299FC9-9EE4-45EB-AF7D-146F31EB6AC6\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Controller\">\n      <meta name=\"indexterm\" content=\"getTimeRange()\">\n      <meta name=\"indexterm\" content=\"setTimeRange()\">\n      <meta name=\"indexterm\" content=\"supportsTimeOperations()\">\n      <meta name=\"indexterm\" content=\"scaleTime()\">\n      <meta name=\"indexterm\" content=\"reverseTime()\">\n      <meta name=\"indexterm\" content=\"insertTime()\">\n      <meta name=\"indexterm\" content=\"deleteTime()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Controller Time Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-71299FC9-9EE4-45EB-AF7D-146F31EB6AC6\"></a><div class=\"head\">\n            <h1>Controller Time Functions </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E14\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E15\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controllers</a></span> &gt; Time Functions \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E17\"></a> \n            <h2><a name=\"GUID-A4262132-8C78-45A3-B366-C94494C0E34A\"></a> <em class=\"strong\">Time Range Operations:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F09\"></a><pre><em class=\"codeEmphasisStrong\">getTimeRange</em> &lt;controller&gt; [<em class=\"codeEmphasisStrong\">#selOnly</em>] [<em class=\"codeEmphasisStrong\">#allKeys</em>] [<em class=\"codeEmphasisStrong\">#children</em>] 		</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E19\"></a>Returns a time Interval value specifying the range of time covered by keys in the\n               controller. The optional symbolic arguments specify options: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E1A\"></a>#<span class=\"code\"> <em class=\"strong\">selOnly</em> </span>: return the time range covered by the currently selected keys (in the track view)\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E1B\"></a>#<span class=\"code\"> <em class=\"strong\">allKeys</em> </span> (default): the time range for all keys in the controller \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E1C\"></a>#<span class=\"code\"> <em class=\"strong\">children</em> </span>: descends into sub-controllers and returns the total time interval covering all keys\n               in all sub-controllers \n            </p> \n            <p><a name=\"GUID-27AADDC7-B196-4465-AF59-1B96C4B569C2\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F08\"></a><pre><em class=\"codeEmphasisStrong\">setTimeRange</em> &lt;controller&gt; [&lt;interval&gt;] [<em class=\"codeEmphasisStrong\">#linkToKeys</em>] 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E1F\"></a>Sets the time range to be an interval other than that covered by existing keys, typically\n               to influence when the out-of-range methods take over. If the optional <span class=\"code\"> <em class=\"strong\">#linkToKeys</em> </span> argument is given any keys exactly at the start or end of the given interval become\n               anchors for the time range and moving them move the time range for the controller. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E20\"></a>If you call <span class=\"code\"> <em class=\"strong\">setTimeRange()</em> </span> with just the single argument, <span class=\"code\"> <em class=\"strong\">#linkToKeys</em> </span>, it will set the time range to the current start and end keysin all the controllers\n               affected, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E21\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E22\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F07\"></a><pre>\nsetTimeRange $box* #linkToKeys\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E26\"></a>This is equivalent to the Recouple Ranges function in the Position Ranges mode in\n               Track View. \n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7FB8\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>When the <span class=\"code\"> <em class=\"strong\">#linkToKeys</em> </span> argument is not supplied, only the supplied controller will be affected. When the\n                  <span class=\"code\"> <em class=\"strong\">#linkToKeys</em> </span> argument is supplied, the function will also affect recursively all sub-controllers.\n                  \n               </div>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-7F74\"></a> \n            <h2><a name=\"GUID-1911F54C-675B-4A11-ACE0-B769DF76A415\"></a>     Time Operations:\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F06\"></a><pre><em class=\"codeEmphasisStrong\">supportsTimeOperations</em> &lt;ctrl&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E31\"></a>returns <span class=\"code\"> <em class=\"strong\">true</em> </span> or <span class=\"code\"> <em class=\"strong\">false</em> </span> depending on whether the controller supports the following time operations \n            </p> \n            <p><a name=\"GUID-C83E0414-BCD0-4DA6-8539-69E015EE3143\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F05\"></a><pre><em class=\"codeEmphasisStrong\">deleteTime</em> &lt;controller&gt; &lt;interval&gt; [<em class=\"codeEmphasisStrong\">#incLeft</em>] [<em class=\"codeEmphasisStrong\">#incRight</em>] [<em class=\"codeEmphasisStrong\">#noSlide</em>] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E34\"></a>Deletes an interval of time from the controller, removing all the keys with that interval\n               and, by default, sliding the keys to the right of the interval to the left by the\n               width of the interval. The optional symbolic arguments choose one of several options:\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E35\"></a>#<span class=\"code\"> <em class=\"strong\">incLeft</em> </span>: includes any key exactly at the start time of the interval \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E36\"></a>#<span class=\"code\"> <em class=\"strong\">incRight</em> </span>: includes any key exactly at the end time of the interval \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E37\"></a>#<span class=\"code\"> <em class=\"strong\">noSlide</em> </span>: doesn’t slide the later keys to fill in the gap removed- this effectively just deletes\n               any keys in the interval. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E38\"></a>The <span class=\"code\"> <em class=\"strong\">&lt;interval&gt;</em> </span> argument can be specified as an Interval value or as two numbers or time values defining\n               the start and end times. Number values are taken as <em class=\"strong\">frame</em> numbers. \n            </p> \n            <p><a name=\"GUID-386D8089-501A-4160-8932-63F0B45FD485\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F04\"></a><pre><em class=\"codeEmphasisStrong\">reverseTime</em> &lt;controller&gt; &lt;interval&gt; [<em class=\"codeEmphasisStrong\">#incLeft</em>] [<em class=\"codeEmphasisStrong\">#incRight</em>] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E3B\"></a>Reverses time in the given interval, essentially swapping keys around so that their\n               time placements are reversed within the interval. The notes on inclusion and interval\n               arguments from <span class=\"code\"> <em class=\"strong\">deleteTime()</em> </span> apply. \n            </p> \n            <p><a name=\"GUID-BA574692-9768-471B-94C0-2E51413AAAC6\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F03\"></a><pre><em class=\"codeEmphasisStrong\">scaleTime</em> &lt;controller&gt; &lt;interval&gt; &lt;float_scale&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E3E\"></a>Scales the times of the keys within the given interval. Again, the <span class=\"code\"> <em class=\"strong\">&lt;interval&gt;</em> </span> argument can be specified as an Interval value or as two numbers or time values defining\n               the start and end times. Number values are taken as <em class=\"strong\">frame</em> counts. \n            </p> \n            <p><a name=\"GUID-05690122-A515-4427-B45A-2226F836F564\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F02\"></a><pre><em class=\"codeEmphasisStrong\">insertTime</em> &lt;controller&gt; &lt;at_time&gt; &lt;amount_time&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E41\"></a>Inserts a block of time at the specified time, effectively moving all later keys out\n               in time by the amount inserted. The times can be numbers or Time values. Numbers are\n               taken as frame counts. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E43\"></a>The following script shows example usages of some of the above methods. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E44\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E45\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F01\"></a><pre>\n-- controller test bed 1\nb=box height:10\nat time 5 animate on b.height=50\nat time 10 animate on b.height=100\nbhc=b.height.controller\nbhk=bhc.keys\nsupportstimeoperations bhc\ndeletetime bhc 4 5\nbhk\ndeletetime bhc 4 5 #incLeft\nbhk\ndeletetime bhc 1 4 #noslide\nbhk\nat time 5 animate on b.height=50\ndeletetime bhc (interval 5 8) #incLeft\nbhk\nat time 10 animate on b.height=150\nfor k in bhk do format \"%:%\\n\"k.time k.value\nreversetime bhc 5 15 #incLeft #incRight\nfor k in bhk do format \"%:%\\n\"k.time k.value\ninsertTime bhc 12 5\nbhk\ngetTimeRange bhc\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E61\"></a> <span class=\"char_link\"><a href=\"GUID-B1700B1D-B1EA-4A6C-B4A3-A29DB26C8C02.htm\">Controller Key Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7E62\"></a> <span class=\"char_link\"><a href=\"GUID-46A7941F-9A1E-49AF-B607-5516DC6ACCEF.htm\">Time and Key Functions on Object Hierarchies</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";