var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-715B1CA8-B27D-495B-964D-1826EAE7030C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Context\">\n      <meta name=\"indexterm\" content=\"in context\">\n      <meta name=\"indexterm\" content=\"at level context\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>at level; in</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-715B1CA8-B27D-495B-964D-1826EAE7030C\"></a><div class=\"head\">\n            <h1>at level; in </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87061\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87062\"></a>   The <span class=\"code\"> <em class=\"strong\">at level &lt;node&gt;</em> </span> and <span class=\"code\"> <em class=\"strong\">in &lt;node&gt;</em> </span> contexts set the specified node to be the effective root for any specified pathnames\n               or scene objects created in the context. These contexts automatically prefix the specified\n               node to any pathnames in the context. They also set the specified node to be the parent\n               for any scene objects created in the context. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87066\"></a>To be able to use pathnames within level contexts to name objects anywhere in the\n               scene, you can override the current working level by using a <em class=\"mild\">rooted pathname</em>. A rooted pathname has an extra \"/\" before the first-level name and indicates \"start\n               at the actual root of the object tree\". \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87067\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87068\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60F2\"></a><pre>\nscale $/baz/* [1,1,2]\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8706B\"></a><p class=\"table-body\">operates on the object <span class=\"code\"> <em class=\"strong\">baz</em> </span> in the actual top level, not just as a child of the current working level. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8706D\"></a>You can also use this rooted pathname form to force a pathname to only consider top-level\n               objects when you name a single object. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8706E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8706F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60F1\"></a><pre>\n$foo\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87072\"></a><p class=\"table-body\">looks throughout the whole scene at all levels for an object named <span class=\"code\"> <em class=\"strong\">foo</em> </span>, \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87073\"></a><p class=\"table-body\"> <em class=\"strong\">BUT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60F0\"></a><pre>\n$/foo\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87076\"></a><p class=\"table-body\">will only look for a top-level object named <span class=\"code\"> <em class=\"strong\">foo</em> </span>. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87079\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8707A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60EF\"></a><pre>\nin $mannequin01...LClav...hand --set context to hand\n$mannequin01.spine.LClav.arm.hand\n(\nrotate $thumb1 15 y_axis --rotate hand\'s child thumb\nrotate $finger11 10 y_axis --rotate hand\'s child first finger\nPalmCenter=$finger21.parent.pos --get hand\'s position\nPalmCenter+=(LHandPos-$finger21.pos)/2.--calculate center of palm\n--create a dummy there, dummy is a child of the hand:\ndummy name:\"palmLink\" pos:PalmCenter\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60EE\"></a><pre>\nin $dummy\n(\n-- create automatically as children of $dummy:\nsphere name:\"ear1\" pos:[10,10,10]\nsphere name:\"ear2\" pos:[-10,10,10]\nscale $foo/* [1,1,2] --look for \'foo\' as a child of $dummy\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";