var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-7184EA04-F106-4BA1-9497-0002D87EB1B8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"files\">\n      <meta name=\"indexterm\" content=\"openEncryptedFile()\">\n      <meta name=\"indexterm\" content=\"encryptFile()\">\n      <meta name=\"indexterm\" content=\"encrypted files\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Encrypted Files</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7184EA04-F106-4BA1-9497-0002D87EB1B8\"></a><div class=\"head\">\n            <h1>Encrypted Files </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D5F\"></a> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-698C\"></a><pre><em class=\"codeEmphasisStrong\">encryptFile</em> &lt;in_filename_string&gt; &lt;out_filename_string&gt; &lt;key_integer&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D5E\"></a>    Creates an encrypted copy of the file named by <span class=\"code\"> <em class=\"strong\">&lt;in_filename_string&gt;</em> </span> using the integer supplied as a key, naming the encrypted file <span class=\"code\"> <em class=\"strong\">&lt;out_filename_string&gt;.</em> </span> \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-698B\"></a><pre><em class=\"codeEmphasisStrong\">openEncryptedFile</em> &lt;filename_string&gt; &lt;key_integer&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D55\"></a>Opens the encrypted file using the given integer key and returns a FileStream value\n               that you can then do read calls on, exactly as you can on FileStreams returned from\n               the <span class=\"code\"> <em class=\"strong\">openFile()</em> </span> function. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D54\"></a> <span class=\"code\"> <em class=\"strong\">encryptFile()</em> </span> and <span class=\"code\"> <em class=\"strong\">openEncryptedFile()</em> </span> let you encrypt a text file with your own key and open an encrypted file via a key\n               for reading. Among other things, you can use this to write and read an encrypted file\n               containing a hardware lock ID for doing authorization-based piracy protection. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D53\"></a>Here is some code that creates an encrypted lock ID file in some authorization process.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D52\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D51\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-698A\"></a><pre>\nf = createFile \"lock.tmp\"\nformat \"%\" hardwareLockID to:f\nclose f\nencryptFile \"lock.tmp\" \"lock.dat\" 5476557\ndeleteFile \"lock.tmp\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D48\"></a>The following code can be used to read and check the lock ID (obviously, all this\n               is only safe if the creation and checking scripts are themselves encrypted): \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D47\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D46\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6989\"></a><pre>\nf = openEncryptedFile \"lock.dat\" 5476557\nid = readValue f\nclose f\nif id != hardwareLockID then\n(\nmessage \"Lock ID\'s don\'t match\"\nreturn 0\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";