var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-71F3BEDB-008E-439F-B575-77B0407EB3FE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSSurface - NURBSObject\">\n      <meta name=\"indexterm\" content=\"NURBSCVSurface - NURBSSurface\">\n      <meta name=\"indexterm\" content=\"setVKnot()\">\n      <meta name=\"indexterm\" content=\"setUKnot()\">\n      <meta name=\"indexterm\" content=\"setCV()\">\n      <meta name=\"indexterm\" content=\"reparameterize()\">\n      <meta name=\"indexterm\" content=\"refineV()\">\n      <meta name=\"indexterm\" content=\"refineU()\">\n      <meta name=\"indexterm\" content=\"refine()\">\n      <meta name=\"indexterm\" content=\"getVKnot()\">\n      <meta name=\"indexterm\" content=\"getUKnot()\">\n      <meta name=\"indexterm\" content=\"getCV()\">\n      <meta name=\"indexterm\" content=\"closeV()\">\n      <meta name=\"indexterm\" content=\"closeU()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSCVSurface : NURBSSurface</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-71F3BEDB-008E-439F-B575-77B0407EB3FE\"></a><div class=\"head\">\n            <h1>NURBSCVSurface : NURBSSurface </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-425D\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-425C\"></a>  This class defines an independent surface that uses control vertices (CVs) to describe\n               its shape. The CVs define a control lattice which surrounds the surface. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4259\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2146\"></a><pre><em class=\"codeEmphasisStrong\">NURBSCVSurface</em>[&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4257\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2145\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4253\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2144\"></a><pre>&lt;nurbscvsurface&gt;.<em class=\"codeEmphasisStrong\">uOrder</em>: integer &lt;nurbscvsurface&gt;.  <em class=\"codeEmphasisStrong\">vOrder</em>: integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4250\"></a>The order of the surface in the U and V directions. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2143\"></a><pre>&lt;nurbscvsurface&gt;.<em class=\"codeEmphasisStrong\">numUKnots</em>: integer &lt;nurbscvsurface&gt;.<em class=\"codeEmphasisStrong\">numVKnots</em>: integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-424C\"></a>The number of knots in the surface in the U and V directions. If this value is changed,\n               the previous knot data is NOT maintained. Because they are generated mathematically,\n               NURBS surfaces have a parameter space in addition to the 3D geometric space in which\n               they are displayed. Specifically, an array of values called knots specifies the extent\n               of influence of each control vertex (CV) on the surface. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2142\"></a><pre>&lt;nurbscvsurface&gt;.<em class=\"codeEmphasisStrong\">numCVs</em>: point2 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4249\"></a>The number of control vertices for the surface in the U and V directions. If this\n               value is changed, the previous control vertex data is NOT maintained. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2141\"></a><pre>&lt;nurbscvsurface&gt;.<em class=\"codeEmphasisStrong\">transform</em>: matrix3 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4246\"></a>The transformation matrix for the NURBSCVSurface. This controls the relative position\n               of the item within a NURBSSet. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2140\"></a><pre>&lt;nurbscvsurface&gt;.<em class=\"codeEmphasisStrong\">uEdgesOverlap</em>: boolean, read-only &lt;nurbscvsurface&gt;.<em class=\"codeEmphasisStrong\">vEdgesOverlap</em>: boolean, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4242\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if the edges of the surface overlap in U and/or V even though the surface may not\n               be closed (that is, the tangents match at the edges), <span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-213F\"></a><pre>&lt;nurbscvsurface&gt;.<em class=\"codeEmphasisStrong\">autoParam</em>:<em class=\"codeEmphasisStrong\">#notAutomatic, #autoCentripetal, #autoUniform</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-423F\"></a> <span class=\"code\"> <em class=\"strong\">#notAutomatic</em> </span>, <span class=\"code\"> <em class=\"strong\">#autoCentripetal</em> </span>, and <span class=\"code\"> <em class=\"strong\">#autoUniform</em> </span> correspond to the Automatic Reparam options in the CV Surface rollouts: none, chord\n               length and uniform, respectively. Defaults to <span class=\"code\"> <em class=\"strong\">#notAutomatic</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-213E\"></a><pre>&lt;nurbscvsurface&gt;.<em class=\"codeEmphasisStrong\">rigid</em>: boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-423C\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if the surface is \'rigid\'; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. The only editing allowed on a rigid surface is to transform it at the Surface sub-object\n               level. You can\'t move a rigid surface\'s points or CVs, or change the number of points\n               or CVs. Rigid surfaces reduce the amount of memory used by the NURBS model. Making\n               surfaces rigid improves performance, especially for large and complex models. When\n               a surface is rigid, you can\'t see its points or CVs when you are at the Point or Surface\n               CV sub-object levels. If the model has no nonrigid surfaces and no point curves, the\n               Point and Surface CV sub-object levels aren\'t available at all. \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-516B\"></a>             <em class=\"strong\">Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-213D\"></a><pre><em class=\"codeEmphasisStrong\">closeU</em> &lt;nurbscvsurface&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-422E\"></a>Closes the surface in the U direction. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-213C\"></a><pre><em class=\"codeEmphasisStrong\">closeV</em>&lt;nurbscvsurface&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-422B\"></a>Closes the surface in the V direction. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-213B\"></a><pre><em class=\"codeEmphasisStrong\">getUKnot</em> &lt;nurbscvsurface&gt; &lt;u_index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4228\"></a>Get the indexed U-direction knot; knot indexes are 1-based. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-213A\"></a><pre><em class=\"codeEmphasisStrong\">setUKnot</em> &lt;nurbscvsurface&gt; &lt;u_index&gt; &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4225\"></a>Sets the indexed U-direction knot to the given value; knot indexes are 1-based. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2139\"></a><pre><em class=\"codeEmphasisStrong\">getVKnot</em> &lt;nurbscvsurface&gt; &lt;v_index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4222\"></a>Get the indexed V-direction knot; knot indexes are 1-based. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2138\"></a><pre><em class=\"codeEmphasisStrong\">setVKnot</em> &lt;nurbscvsurface&gt; &lt;v_index&gt; &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-421F\"></a>Get the indexed V-direction knot to the given value; knot indexes are 1-based. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2137\"></a><pre><em class=\"codeEmphasisStrong\">getCV</em> &lt;nurbscvsurface&gt; &lt;u_index&gt; &lt;v_index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-421C\"></a>Get the CV at the given U and V index as a NURBSControlVertex; CV indexes are 1-based.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2136\"></a><pre><em class=\"codeEmphasisStrong\">setCV</em> &lt;nurbscvsurface&gt; &lt;u_index&gt; &lt;v_index&gt; &lt;NURBSControlVertex&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4219\"></a>Sets the CV at the given U and V index to the supplied NURBSControlVertex; CV indexes\n               are 1-based. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2135\"></a><pre><em class=\"codeEmphasisStrong\">refineU</em> &lt;nurbscvsurface&gt; &lt;v_param&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4216\"></a>Adds new row of interpolated CVs in the U direction on the surface at the given parametric\n               V point. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2134\"></a><pre><em class=\"codeEmphasisStrong\">refineV</em> &lt;nurbscvsurface&gt; &lt;u_param&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4213\"></a>Adds new column of interpolated CVs in the V direction on the surface at the given\n               parametric U point. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2133\"></a><pre><em class=\"codeEmphasisStrong\">refine</em> &lt;nurbscvsurface&gt; &lt;u_param&gt; &lt;v_param&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4210\"></a>Adds a new row and column of interpolated CVs on the surface at the given parametric\n               UV position. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2132\"></a><pre><em class=\"codeEmphasisStrong\">reparameterize</em> &lt;nurbscvsurface&gt; (<em class=\"codeEmphasisStrong\">#centripetal</em> | <em class=\"codeEmphasisStrong\">#uniform</em>) </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-420D\"></a>Reparameterizes the surface by chord length (#centripetal) or uniform (#uniform) uniform\n               parameterization. \n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F4F\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p>CV curves and surfaces must obey the relationship that \"order + number of CVs = number\n                     of knots\". If this is not the case in most cases no object will be created and in\n                     some cases an assertion fault might be generated. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4208\"></a>&nbsp; \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4206\"></a> <span class=\"char_link\"><a href=\"GUID-19C0A3FC-AECA-437A-A430-51EFC9D70545.htm\">NURBSSurface</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4205\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4204\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";