var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-724B14D0-06DC-424A-A6FE-8C494579ECA3\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MouseConfigManager Interface\">\n      <meta name=\"indexterm\" content=\"Interface MouseConfigManager\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: MouseConfigManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-724B14D0-06DC-424A-A6FE-8C494579ECA3\"></a><div class=\"head\">\n            <h1>Interface: MouseConfigManager </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1058\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1057\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; MouseConfigManager \n                        					  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-0F6E106E-11DD-4E43-8F2D-483A73D100EC\"></a> This Core Interface exposes the \n            		<em class=\"strong\">Mouse Configuration Manager</em> to MAXScript. \n            	 \n         </p>\n         <p><a name=\"GUID-DCA2DDFB-BCF0-4408-B20B-6665D8280A26\"></a>It allows the behavior of the mouse within the viewports to be customized and adapted\n            to various user workflows, including the emulation of \n            		<em class=\"strong\">Autodesk Maya</em> mouse controls. \n            	 \n         </p>\n         <p><a name=\"GUID-9CF326B9-8F23-4748-9CA0-04E4954B7D31\"></a>Available in \n            		<em class=\"strong\">3ds Max 2013 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-4D92EB27-CF7F-49E4-BC5C-F1E5ABD81B02\"></a> <img src=\"../images/GUID-261CF8C6-5859-4593-9B56-64C2E1359340-low.png\"> \n         </p>\n         <p><a name=\"GUID-F7364EB5-B38C-4B20-A981-6DD8CB068E78\"></a>See also the related \n            		<span class=\"char_link\"><a href=\"GUID-99E9991F-E246-41C8-A76F-AF5F341A1A52.htm\">Interface \n                  		  IInteractionMode</a></span> which exposes the \n            		<em class=\"strong\">Interaction Mode</em> tab of the \n            		<em class=\"strong\">Preference Settings</em> dialog. \n            	 \n         </p>\n         <p><a name=\"P_FB78CB2CCB184876A725B7A9CADB619A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-1A0C0564-DE64-4206-AC93-879286D69881\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MouseConfigManager.AutoFocusViewportOnKeyPress</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-BCC27FBE-4B0A-4886-ACE6-9E5244D4C95E\"></a>Get/set the auto-focus viewport on key press behavior. \n            	 \n         </p>\n         <p><a name=\"GUID-FB80BEB3-D00F-46DB-9A66-6E1CDD0E01B5\"></a>When set to false (<em class=\"strong\">3ds Max</em> default), pressing a key while the mouse is over a non-active viewport will not change\n            focus to that viewport. \n            	 \n         </p>\n         <p><a name=\"GUID-5A4C0386-F120-498B-B7DA-AAEE1A9F2C2A\"></a>When set to true (<em class=\"strong\">Maya</em> default), pressing a keyboard shortcut will automatically switch focus to the viewport\n            the mouse is over. \n            	 \n         </p>\n         <p><a name=\"GUID-9EDA80C4-A7A5-42C8-AE15-409CB8DA8368\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MouseConfigManager.MayaSelectionMode</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-97C15502-F5B0-4675-9742-D2858C5FD86E\"></a>Get/set the state of the Maya Selection Mode option. \n            	 \n         </p>\n         <p><a name=\"GUID-204144EF-3A53-4B22-A131-414E0E979C6F\"></a>When set to False (default), selection will be performed using the 3ds Max default\n            behavior. \n            	 \n         </p>\n         <p><a name=\"GUID-DB0D0D15-1139-4ACF-8AEC-C085A3096936\"></a>When set to True, the Maya selection behavior will be used. \n            	 \n         </p>\n         <p><a name=\"GUID-A34A605C-5261-4DD2-B10A-BEF2BFE68385\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5841\"></a><pre><em class=\"codeEmphasisStrong\">MouseConfigManager.ArcRotateLocked</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-EA59AB24-EB45-429F-ADCD-237FFFA65182\"></a>Get/set the locking of the Orbit (formerly known as Arc Rotate) feature in Orthographic\n            viewports (e.g. Top, Bottom, Front, Back, Left, Right). \n            	 \n         </p>\n         <p><a name=\"GUID-D8937DD1-06B0-401B-A1E2-A3F1F845CB33\"></a>When set to False (<em class=\"strong\">3ds Max</em> default), performing Orbit in an Orthographic viewport will turn it into an Orthographic\n            (a.k.a. User) view. \n            	 \n         </p>\n         <p><a name=\"GUID-9508BFF0-58BF-405C-96F0-6756FB4C4F27\"></a>When set to True (<em class=\"strong\">Maya</em> default), Orbit cannot be performed in Orthographic viewports, only in viewport already\n            set to Perspective or Orthographic. \n            	 \n         </p>\n         <p><a name=\"GUID-92EFAF5A-4427-4D64-A82F-6D0F18BFD0CC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MouseConfigManager.ZoomAboutMousePointOrthographic</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-CB6DDED2-1028-4149-8B96-6CBB614CCB79\"></a>Get/set whether to zoom about the mouse point in Orthographic viewports. \n            	 \n         </p>\n         <p><a name=\"GUID-DF4DA11D-1123-4A4D-9EA9-652A9A5575DC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MouseConfigManager.ZoomAboutMousePointPerspective</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-00565151-DFE1-4CE5-8A46-9121E1A4BF7D\"></a>Get/set whether to zoom about the mouse point in Perspective viewports. \n            	 \n         </p>\n         <p><a name=\"GUID-28006FA7-C0BD-4CAD-B94F-DE86DE05FBB4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MouseConfigManager.RightClickMenuOverSelectedOnly</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-05AA19FA-293F-49AC-88E6-18B570882E2E\"></a>Get/set whether to allow the opening of QuadMenus when right-clicking anywhere in\n            the viewport (false, default \n            		<em class=\"strong\">3ds Max</em> behavior), \n            	 \n         </p>\n         <p><a name=\"GUID-C5AD02EB-4FF2-4120-ACD6-49D9B1DD74B4\"></a>or only over selected objects (true, default Maya behavior) \n            	 \n         </p>\n         <p><a name=\"GUID-06B46AB2-0B3D-4F26-86AA-54CC179273B8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MouseConfigManager.MiddleMouseStrokeMode</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-1455F4AF-440E-427F-BBAE-118548DA2D22\"></a>Get/set whether to use the mouse wheel for Strokes or Viewport Pan. \n            	 \n         </p>\n         <p><a name=\"GUID-5C079867-D3FD-4AB1-8EE1-58DCDFEB215C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MouseConfigManager.ZoomWheelIncrement</em> : float : Read|Write</pre></div>\n         <p><a name=\"GUID-6F165B6F-7173-4378-9962-CEF1A2B7846D\"></a>Get/set the zoom increment when using the mouse wheel. \n            	 \n         </p>\n         <p><a name=\"GUID-406FC3C3-4683-4DD1-96DA-E3849F0612A7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MouseConfigManager.ZoomInDirection</em> : enum : Read|Write\n\nZoomInDirection enums: {<em class=\"codeEmphasisStrong\">#North</em>|<em class=\"codeEmphasisStrong\">#NorthEast</em>|<em class=\"codeEmphasisStrong\">#East</em>|<em class=\"codeEmphasisStrong\">#SouthEast</em>|<em class=\"codeEmphasisStrong\">#South</em>|<em class=\"codeEmphasisStrong\">#SouthWest</em>|<em class=\"codeEmphasisStrong\">#West</em>|<em class=\"codeEmphasisStrong\">#NorthWest</em></pre></div>\n         <p><a name=\"GUID-93FB4130-79AF-48B9-B166-34DD96C0D04B\"></a>Get/set the Zoom In mouse direction. \n            	 \n         </p>\n         <p><a name=\"GUID-A3F0F78D-EBA9-48C8-A043-DF3911895B36\"></a>The \n            		<em class=\"strong\">3ds Max</em> default is \n            		<span class=\"code\"> <em class=\"strong\">#North</em> </span>. \n            	 \n         </p>\n         <p><a name=\"GUID-C71FECD0-61CC-477D-82C6-28E71D1C9FED\"></a>The \n            		<em class=\"strong\">Maya</em> default is \n            		<span class=\"code\"> <em class=\"strong\">#SouthEast</em> </span> \n         </p>\n         <p><a name=\"GUID-6111513B-B6AE-4482-B8BF-0B89A70AF885\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MouseConfigManager.UserMode</em> : enum : Read|Write \n\nUserMode enums: {<em class=\"codeEmphasisStrong\">#Max</em>|<em class=\"codeEmphasisStrong\">#Maya</em>|<em class=\"codeEmphasisStrong\">#Customized</em>}</pre></div>\n         <p><a name=\"GUID-8B2B6565-2449-4966-9235-FAC09C3AE53C\"></a>Get/set the current Use Mode. \n            	 \n         </p>\n         <p><a name=\"GUID-45FB311E-1D59-4D85-87E7-2D5A3E7F966F\"></a>Possible mode values are: \n            	 \n         </p>\n         <p><a name=\"GUID-478FDFE4-9A9E-422A-B435-11309B1BCE1F\"></a><span class=\"code\"> <em class=\"strong\">#Max</em> </span> - all mouse settings match the standard \n            		<em class=\"strong\">3ds Max</em> behavior \n            	 \n         </p>\n         <p><a name=\"GUID-02506280-D6C7-443F-ABB7-94C6F0BED608\"></a><span class=\"code\"> <em class=\"strong\">#Maya</em> </span> - all mouse settings match the standard \n            		<em class=\"strong\">Maya</em> behavior \n            	 \n         </p>\n         <p><a name=\"GUID-32E0C4D5-1384-4A2B-87A6-11F78D584ED6\"></a><span class=\"code\"> <em class=\"strong\">#Customized</em> </span> - the mouse settings have been customized and are a mixture of \n            		<em class=\"strong\">3ds Max</em> and \n            		<em class=\"strong\">Maya</em> behaviors \n            	 \n         </p>\n         <p><a name=\"GUID-778A7BA9-0E74-4F8D-9C91-ADEAFE8594D6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-23A74412-6C24-4116-82F2-665944FB64A2\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">MouseConfigManager.GetZoomShortcut</em> &lt;&amp;enum&gt;key &lt;&amp;enum&gt;button\n\nkey enums: {<em class=\"codeEmphasisStrong\">#Null</em>|<em class=\"codeEmphasisStrong\">#Shift</em>|<em class=\"codeEmphasisStrong\">#Ctrl</em>|<em class=\"codeEmphasisStrong\">#Alt</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrl</em>|<em class=\"codeEmphasisStrong\">#CtrlAlt</em>|<em class=\"codeEmphasisStrong\">#AltShift</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrlAlt</em>}\nkey is Out parameter\nbutton enums: {<em class=\"codeEmphasisStrong\">#NullButton</em>|<em class=\"codeEmphasisStrong\">#LeftButton</em>|<em class=\"codeEmphasisStrong\">#MiddleButton</em>|<em class=\"codeEmphasisStrong\">#RightButton</em>}\nbutton is Out parameter</pre></div>\n         <p><a name=\"GUID-D1B2CCFC-AD7B-49E4-8462-28A6229506C0\"></a>Returns the current Viewport Zoom shortcut into the two by-reference arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-20900D1A-BE12-44CB-B435-DEFACE93F495\"></a>The first argument provides the keyboard key, the second provides the mouse button.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-5E6F393E-D229-4EAC-A18E-7232390810B4\"></a><em class=\"strong\">3ds Max</em> defaults are \n            		<span class=\"code\"> <em class=\"strong\">#CtrlAlt</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">#MiddleButton</em> </span>. \n            	 \n         </p>\n         <p><a name=\"GUID-022CFBD9-E5BF-4A38-8249-029EB37B567A\"></a><em class=\"strong\">Maya</em> defaults are \n            		<span class=\"code\"> <em class=\"strong\">#Alt</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">#RightButton</em> </span>. \n            	 \n         </p>\n         <p><a name=\"GUID-E9C78E3E-3903-4AB1-8558-E82467FB865B\"></a> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FF0\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FEF\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2ECD\"></a><pre>\nMouseConfigManager.GetZoomShortcut &amp;theKey &amp;theButton\n--&gt; OK\ntheKey\n--&gt; #CtrlAlt\ntheButton\n--&gt; #MiddleButton\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </p>\n         <p><a name=\"GUID-780FC92A-0B4F-4C15-B48B-2A56797D7F73\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">MouseConfigManager.SetZoomShortcut</em> &lt;enum&gt;key &lt;enum&gt;button\n\nkey enums: {<em class=\"codeEmphasisStrong\">#Null</em>|<em class=\"codeEmphasisStrong\">#Shift</em>|<em class=\"codeEmphasisStrong\">#Ctrl</em>|<em class=\"codeEmphasisStrong\">#Alt</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrl</em>|<em class=\"codeEmphasisStrong\">#CtrlAlt</em>|<em class=\"codeEmphasisStrong\">#AltShift</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrlAlt</em>}\nbutton enums: {<em class=\"codeEmphasisStrong\">#NullButton</em>|<em class=\"codeEmphasisStrong\">#LeftButton</em>|<em class=\"codeEmphasisStrong\">#MiddleButton</em>|<em class=\"codeEmphasisStrong\">#RightButton</em>}	</pre></div>\n         <p><a name=\"GUID-1366B516-940C-4302-937E-2E4C331234B0\"></a>Sets the current Viewport Zoom Shortcut to the keyboard key and mouse button specified\n            by the two arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-1E6052A1-FD06-4255-8092-234B96CFB931\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">MouseConfigManager.GetPanShortcut</em> &lt;&amp;enum&gt;key &lt;&amp;enum&gt;button\n\nkey enums: {<em class=\"codeEmphasisStrong\">#Null</em>|<em class=\"codeEmphasisStrong\">#Shift</em>|<em class=\"codeEmphasisStrong\">#Ctrl</em>|<em class=\"codeEmphasisStrong\">#Alt</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrl</em>|<em class=\"codeEmphasisStrong\">#CtrlAlt</em>|<em class=\"codeEmphasisStrong\">#AltShift</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrlAlt</em>}\nkey is Out parameter\nbutton enums: {<em class=\"codeEmphasisStrong\">#NullButton</em>|<em class=\"codeEmphasisStrong\">#LeftButton</em>|<em class=\"codeEmphasisStrong\">#MiddleButton</em>|<em class=\"codeEmphasisStrong\">#RightButton</em>}\nbutton is Out parameter</pre></div>\n         <p><a name=\"GUID-18D2A55F-A375-430F-94C7-C8D27F8A1DAF\"></a>Returns the Viewport Pan shortcut into the two by-reference arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-7C39FE18-3EA6-48F9-852A-4E253674D2E1\"></a>The first argument provides the keyboard key, the second provides the mouse button.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-1F4FB06B-67AA-436A-8D3E-A99ECB211441\"></a><em class=\"strong\">3ds Max</em> defaults are \n            		<span class=\"code\"> <em class=\"strong\">#Null</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">#MiddleButton</em> </span>. \n            	 \n         </p>\n         <p><a name=\"GUID-9D44B02F-190F-4DFE-B0FC-7E02343792B3\"></a><em class=\"strong\">Maya</em> defaults are \n            		<span class=\"code\"> <em class=\"strong\">#Alt</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">#MiddleButton</em> </span>. \n            	 \n         </p>\n         <p><a name=\"GUID-7891543C-86B2-45FE-9D30-79AEDC7443C7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">MouseConfigManager.SetPanShortcut</em> &lt;enum&gt;key &lt;enum&gt;button\n\nkey enums: {<em class=\"codeEmphasisStrong\">#Null</em>|<em class=\"codeEmphasisStrong\">#Shift</em>|<em class=\"codeEmphasisStrong\">#Ctrl</em>|<em class=\"codeEmphasisStrong\">#Alt</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrl</em>|<em class=\"codeEmphasisStrong\">#CtrlAlt</em>|<em class=\"codeEmphasisStrong\">#AltShift</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrlAlt</em>}\nbutton enums: {<em class=\"codeEmphasisStrong\">#NullButton</em>|<em class=\"codeEmphasisStrong\">#LeftButton</em>|<em class=\"codeEmphasisStrong\">#MiddleButton</em>|<em class=\"codeEmphasisStrong\">#RightButton</em>}	</pre></div>\n         <p><a name=\"GUID-3FE57E7B-B617-49BE-99D1-479D4A9179DD\"></a>Sets the current Viewport Pan shortcut to the keyboard key and mouse button specified\n            by the two arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-F13513F3-5FB7-4D30-A588-0E1FE481A8E4\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">MouseConfigManager.GetRotateShortcut</em> &lt;&amp;enum&gt;key &lt;&amp;enum&gt;button\n\nkey enums: {<em class=\"codeEmphasisStrong\">#Null</em>|<em class=\"codeEmphasisStrong\">#Shift</em>|<em class=\"codeEmphasisStrong\">#Ctrl</em>|<em class=\"codeEmphasisStrong\">#Alt</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrl</em>|<em class=\"codeEmphasisStrong\">#CtrlAlt</em>|<em class=\"codeEmphasisStrong\">#AltShift</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrlAlt</em>}\nkey is Out parameter\nbutton enums: {<em class=\"codeEmphasisStrong\">#NullButton</em>|<em class=\"codeEmphasisStrong\">#LeftButton</em>|<em class=\"codeEmphasisStrong\">#MiddleButton</em>|<em class=\"codeEmphasisStrong\">#RightButton</em>}\nbutton is Out parameter</pre></div>\n         <p><a name=\"GUID-C2AD1B71-656C-49EB-9E28-FD9820426129\"></a>Returns the Viewport Rotate shortcut into the two by-reference arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-82D3C9EB-900F-4BCC-89FD-BB57F00F3851\"></a>The first argument provides the keyboard key, the second provides the mouse button.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-9D2B7124-ABFE-48C7-916F-DEA6B62BF8A8\"></a><em class=\"strong\">3ds Max</em> defaults are \n            		<span class=\"code\"> <em class=\"strong\">#Alt</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">#MiddleButton</em> </span>. \n            	 \n         </p>\n         <p><a name=\"GUID-006E0B0D-D6C1-4148-86CB-FF0A899B0B8A\"></a><em class=\"strong\">Maya</em> defaults are \n            		<span class=\"code\"> <em class=\"strong\">#Alt</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">#LeftButton</em> </span>. \n            	 \n         </p>\n         <p><a name=\"GUID-FFB51CCA-C857-4C3A-A377-77A8378DE7ED\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">MouseConfigManager.SetRotateShortcut</em> &lt;enum&gt;key &lt;enum&gt;button\n\nkey enums: {<em class=\"codeEmphasisStrong\">#Null</em>|<em class=\"codeEmphasisStrong\">#Shift</em>|<em class=\"codeEmphasisStrong\">#Ctrl</em>|<em class=\"codeEmphasisStrong\">#Alt</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrl</em>|<em class=\"codeEmphasisStrong\">#CtrlAlt</em>|<em class=\"codeEmphasisStrong\">#AltShift</em>|<em class=\"codeEmphasisStrong\">#ShiftCtrlAlt</em>}\nbutton enums: {<em class=\"codeEmphasisStrong\">#NullButton</em>|<em class=\"codeEmphasisStrong\">#LeftButton</em>|<em class=\"codeEmphasisStrong\">#MiddleButton</em>|<em class=\"codeEmphasisStrong\">#RightButton</em>}	</pre></div>\n         <p><a name=\"GUID-7AB945B5-22E8-4A16-89C5-AA163CCAB731\"></a>Sets the current Viewport Rotate shortcut to the keyboard key and mouse button specified\n            by the two arguments. \n            	 \n         </p>\n         <p><a name=\"GUID-08CE9BDE-9FD7-4DE1-A480-03DF6C1AEA27\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-ABEBA5DA-DCFC-4AC8-A8BF-700307E164F2\"></a></p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7EE9\"></a> <span class=\"char_link\"><a href=\"GUID-99E9991F-E246-41C8-A76F-AF5F341A1A52.htm\">Interface IInteractionMode</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";