var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-74B0A138-0437-43E1-8658-C5E9D4CB448E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ProCutter - Interface\">\n      <meta name=\"indexterm\" content=\"Interface ProCutter\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: ProCutter</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-74B0A138-0437-43E1-8658-C5E9D4CB448E\"></a><div class=\"head\">\n            <h1>Interface: ProCutter </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E84ED8\"></a> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84EDC\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-F41446C7-22E4-4CD6-BEB3-A5CCBAF02748-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EDE\"></a>  The <em class=\"strong\">ProCutter Compound Object</em> is part of the <em class=\"strong\">ProBoolean</em> Extension which is integral part of <em class=\"strong\">3ds Max 9</em> and higher. \n            </p> \n            <p><a name=\"GUID-38CEB57E-3391-4A93-853D-9DA3BA850A6B\"></a>It can be used to cut one or more stock objects using a cutter object: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EDF\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59C1\"></a><pre> <em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">CreateCutter</em> #(&lt;object_1&gt;{,&lt;objectr_2&gt;}) &lt;addMethod&gt; &lt;stockOutsideCutter&gt; &lt;stockInsideCutter&gt; &lt;cutterOutsideStock&gt; &lt;autoExtractMesh&gt; &lt;explodeByElements&gt; 	 \n  \n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EE1\"></a>Creates a ProCutter object using node <span class=\"code\">&lt;operand_1&gt;</span> and multiple nodes <span class=\"code\">&lt;operand_2&gt;</span>, all stored in an array. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EE2\"></a> <span class=\"code\"> <em class=\"strong\">#( &lt;object_1&gt; { , &lt;object_2&gt; } )</em> -</span>Specifies the objects used to build the Cutter. Note that the cutter will take over\n               the node and name from <span class=\"code\">&lt;object_1&gt;</span>. The object of the first node will become the first cutter sub-object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EE3\"></a> <span class=\"code\"> <em class=\"strong\">&lt;addMethod&gt;</em> </span> specifies how the <span class=\"code\">&lt;operand_2&gt;</span> node(s) will be used. \n            </p> \n            <p><a name=\"GUID-0FCD9672-F5CC-4A75-9C6B-929A70310579\"></a>Possible values are: \n            </p> \n            <p><a name=\"GUID-6D276C44-7243-4F98-8150-6B99E9EC023E\"></a>1 - instance, operand is an instance of the original node \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EE4\"></a>2 - reference, operand is a reference to original node \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EE5\"></a>3 - copy, operand is a copy of original node \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EE6\"></a>4 - move, original node should be deleted \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EE7\"></a> <em class=\"strong\">One of the following three options must be set to true:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EE8\"></a> <span class=\"code\"> <em class=\"strong\">&lt;stockOutsideCutter&gt;</em> </span> specifies what to do with the portions of the Stock or Stocks outside the Cutter.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EE9\"></a>True - keep Stock outside the Cutter \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EEA\"></a>False -remove Stock outside the Cutter \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EEB\"></a> <span class=\"code\"> <em class=\"strong\">&lt;stockInsideCutter&gt;</em> </span> specifies what to do with the portions of the Stock or Stocks inside the Cutter.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EEC\"></a>True - keep Stock inside the Cutter \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EED\"></a>False -remove Stock inside the Cutter \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EEE\"></a> <span class=\"code\"> <em class=\"strong\">&lt;cutterOutsideStock&gt;</em> </span> specifies what to do with the portions of the Cutter outside of the Stock or Stocks.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EEF\"></a>True - keep Cutter outside of the Stock(s) \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EF0\"></a>False -remove Cutter outside of the Stock(s) \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EF1\"></a> <span class=\"code\"> <em class=\"strong\">&lt;autoExtractMesh&gt;</em> </span> specifies whether the result of the operation should be maintained in the Cutter\n               compound object or extracted into separate mesh. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EF2\"></a>True - don\'t modify the cutter object, just cut the stock mesh and extract it into\n               a new object. Note that once the operation is done, the result is an editable mesh\n               with no sub-objects. This flag is useful if you want to use the cutter like a cookie\n               cutter where you reuse the cutter over and over to make holes in an object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EF3\"></a>False - maintain all objects in the Cutter compound object.&nbsp; Once the operation is\n               performed the result is a procedural Cutter object with both cutters and stocks as\n               sub-objects that can be edited. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EF4\"></a> <span class=\"code\"> <em class=\"strong\">&lt;explodeByElements&gt;</em> </span> specifies whether mesh elements should be separated into individual meshes. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EF5\"></a>True - creates a separate mesh for each element. It is a good way to break apart an\n               object into smaller volumes by setting this flag to true while <span class=\"code\">&lt;autoExtractMesh&gt;</span> along with <span class=\"code\">&lt;stockOutsideCutter&gt;</span> and <span class=\"code\">&lt;stockInsideCutter&gt;</span> are also set to true. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EF6\"></a>False -create a single mesh with a mesh element for each separate volume. \n            </p> \n            <p><a name=\"GUID-49C3BEC9-8C9F-4088-8A23-93B9B4E8589C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59C0\"></a><pre><em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">AddStocks</em> &lt;cutter_object&gt; #(&lt;stock_1&gt;{,&lt;stock_2&gt;}) &lt;addMethod&gt; &lt;matMethod&gt;\n  \n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EF9\"></a>Adds one or more stock objects to an existing ProCutter compound object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EFA\"></a> <span class=\"code\"> <em class=\"strong\">&lt;cutter_object&gt; </em> </span>is the original ProCutter node created using <span class=\"code\"> <em class=\"strong\">ProCutter.CreateCutter()</em> </span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EFB\"></a> <span class=\"code\"> <em class=\"strong\">#(&lt;stock_2&gt;{,&lt;stock_2&gt;})</em> </span>- specifies one or more stock nodes in an array of nodes.&nbsp; Note that even if you have\n               only one stock object, you need to use an array, for example #(stockb). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EFC\"></a> <span class=\"code\"> <em class=\"strong\">&lt;mat_method&gt; </em> </span>specifies how the materials of the two operands should be handled. Possible values\n               are: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EFD\"></a>1 - applies operand material \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84EFE\"></a>2 - retains original material \n            </p> \n            <p><a name=\"GUID-1D83AFDE-31A2-49CA-B770-9EFD7852B3D7\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59BF\"></a><pre><em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">getOperandSel</em> &lt;bool_obj&gt; &lt;integer&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F01\"></a>Gets the index of the operand currently selected in the operands list. \n            </p> \n            <p><a name=\"GUID-84B92DAB-C92D-41B0-9899-8906DE941158\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59BE\"></a><pre><em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">setOperandSel</em> &lt;bool_obj&gt; &lt;integer&gt; &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F04\"></a>Sets the index of the operand to be selected in the operands list. \n            </p> \n            <p><a name=\"GUID-D7CD9A37-F216-41EF-AFA6-E3DC41B4FB33\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59BD\"></a><pre><em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">getDisplayResult</em> &lt;bool_obj&gt; \n<em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">setDisplayResult</em> &lt;bool_obj&gt; &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F08\"></a>These methods get and set whether Results or Operands are displayed. If true, Result\n               is displayed. If false, Operands are displayed. \n            </p> \n            <p><a name=\"GUID-DC6E1A83-77BF-4857-B1F0-B72F095A7B82\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59BC\"></a><pre><em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">getShowHiddenOps</em> &lt;bool_obj&gt; \n<em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">setShowHiddenOps</em> &lt;bool_obj&gt; &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F0C\"></a>these methods get and set whether Results + Hidden Operands are displayed. If true,\n               Results + Hidden Operands are displayed. If false, the Results or Operands as specified\n               using <span class=\"code\"> <em class=\"strong\">ProCutter.SetDisplayResult()</em> </span> are displayed. \n            </p> \n            <p><a name=\"GUID-F48C05AE-B839-4D3E-B69B-06FCE9828197\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59BB\"></a><pre><em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">getUpdateMode</em> &lt;bool_obj&gt; \n<em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">setUpdateMode</em> &lt;bool_obj&gt; &lt;integer&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F10\"></a>These methods get and set the Update mode as follows: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F11\"></a>0 - Always \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F12\"></a>1 - When Selected \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F13\"></a>2 - When Rendering \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F15\"></a>3 - Manually \n            </p> \n            <p><a name=\"GUID-F28162FB-C248-40EC-8BCE-D8F4E1E670E9\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59BA\"></a><pre><em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">getDecimationPercent</em> &lt;bool_obj&gt; \n<em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">setDecimationPercent</em> &lt;bool_obj&gt; &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F18\"></a>These methods get and set the decimation percentage that determines the percentage\n               of edges that will be removed from the total set of polygons on this Boolean. \n            </p> \n            <p><a name=\"GUID-CCAA5ABE-CF01-4FB3-934C-9CC3A72B6643\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59B9\"></a><pre><em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">getMakeQuad</em> &lt;bool_obj&gt; \n<em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">setMakeQuad</em> &lt;bool_obj&gt; &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F1C\"></a>These methods get and set whether the operation will change the tessellation of the\n               Boolean from triangles to quadrilaterals \n            </p> \n            <p><a name=\"GUID-E94F191E-2FE5-4C24-9169-CC1A9C2B6D73\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59B8\"></a><pre><em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">getQuadSizePercent</em> &lt;bool_obj&gt; \n<em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">setQuadSizePercent</em> &lt;bool_obj&gt; &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F20\"></a>These methods get and set the percentage of the overall length of the quadrilaterals.\n               \n            </p> \n            <p><a name=\"GUID-6B1B1EC4-4B64-4448-ABC2-FFF7CA53A186\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59B7\"></a><pre><em class=\"codeEmphasisStrong\">ProCutter</em>.<em class=\"codeEmphasisStrong\">getPlanarEdgeRemoval</em> &lt;bool_obj&gt; \n<em class=\"codeEmphasisStrong\">ProCutter.setPlanarEdgeRemoval</em> &lt;bool_obj&gt; &lt;integer&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F24\"></a> These methods determine how the polygons on planar faces will be handled: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F25\"></a>1 - Removes all extra co-planar edges on a face \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F26\"></a>2 - Removes only invisible edges on each face \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F27\"></a>3 - No edge removal \n            </p> \n            <p><a name=\"GUID-E6D14226-94D2-4D3C-B361-99598B2B1D83\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F28\"></a> \n               <h3><a name=\"GUID-C37F397C-60AB-4F43-956C-83AECAA2992E\"></a> <em class=\"strong\">Scripting ProCutter Operations</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F29\"></a>The ProCutter is a two stage operation for scripting. First you create the cutter\n                  then you add stocks to the existing cutter. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84F2A\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84F2B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 1</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84F2C\"></a><p class=\"table-body\">Create two boxes to be used in cutter and one box for stock. The resulting cutter\n                              object will contain 3 operands. \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59B6\"></a><pre>\na = box length:10 height:10 width:10\nb = box length:4 height:4 width:15\nc = box length:13 height:15 width:10\nProCutter.CreateCutter #(a,b) 1 True False False False False\nProCutter.AddStocks a #(c) 1 1\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84F35\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84F36\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE 2</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84F37\"></a><p class=\"table-body\">This is the sort of set up to use when you want to break an object apart into separate\n                              little volumes. \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-59B5\"></a><pre>\n--- Use cutter to break apart volumes of stock\n--- into separate little volumes that are extracted\n--- into separate meshes.&nbsp; This is what you might do\n--- if you want an object to \"explode\" into smaller\n--- pieces.&nbsp; Note that after the operation the original\n--- cutter object stays around and can be used again.\na = box length:10 height:10 width:10\nb = box length:4 height:4 width:15\nc = box length:13 height:15 width:10\nProCutter.CreateCutter #(a,b) 1 True True False True True\nProCutter.AddStocks a #(c) 1 1\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F47\"></a> <span class=\"char_link\"><a href=\"GUID-BD83BF8F-9E14-4CDD-AAAD-3554CA8085DA.htm\">ProBoolean Extension</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84F48\"></a> <span class=\"char_link\"><a href=\"GUID-4A79CA15-1146-4CB2-A520-FD55B4D7647D.htm\">Interface: PolyBoolean</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";