var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-7664D95A-A27D-4356-8442-F53064920BF8\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"3ds Max CAT and MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>3ds Max CAT and MAXScript</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7664D95A-A27D-4356-8442-F53064920BF8\"></a><div class=\"head\">\n            <h1>3ds Max CAT and MAXScript </h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171C97\"></a>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC675B\"></a> <em class=\"strong\">3ds Max CAT</em> (CAT stands for Character Animation Tools) feature introduced in <em class=\"strong\">3ds Max 2011</em> and refactored in <em class=\"strong\">3ds Max 2013</em> provides a powerful platform for character animation that is also highly customizable.\n            An important aspect of this is its accessibility to scripting. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC675D\"></a> \n            <h2><a name=\"GUID-6F606F10-DB30-4984-B4D7-294AC2234996\"></a> <em class=\"strong\">MAXScript Access to 3ds Max CAT</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC675E\"></a> <em class=\"strong\">3ds Max CAT</em> implements a character rig as a tree hierarchy of controllers and objects. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC675F\"></a>All the standard MAXScript calling conventions for navigating hierarchies, accessing\n               subanims, as well as getting, setting and inspecting controller properties work with\n               <em class=\"strong\">3ds Max CAT</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6760\"></a>The <em class=\"strong\">3ds Max CAT </em>Function Publishing Interfaces expose Properties, Methods and Actions which allow\n               you to use MAXScript to access objects written in C++. Many different types of objects\n               can expose the same interface, thus allowing them to share the same MAXScript exposure.\n               An example of this is that every controller in the CATRig provides the <span class=\"char_link\"><a href=\"GUID-367D9339-35CF-4950-9132-65A8C9AC42B9.htm\">interface ICATControlFPInterface</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6761\"></a>More specialized controllers such as <span class=\"char_link\"><a href=\"GUID-92BD8648-FC7D-49AD-BFC8-CA009CAB9CB5.htm\">HubTrans</a></span> can additionally provide Interfaces that expose features relevant only to these types\n               of controllers. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6763\"></a>To find out what functions are available on controllers and objects, you can use two\n               different MAXScript calls: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6764\"></a>Syntax \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5052\"></a><pre><em class=\"codeEmphasisStrong\">ShowProperties </em>&lt;MaxObject&gt;\n<em class=\"codeEmphasisStrong\">Show </em>&lt;MaxObject&gt;--alternative</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6767\"></a>Use <span class=\"code\">Show()</span> or <span class=\"code\">ShowProperties()</span> to find out what properties are available on an object or controller. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5051\"></a><pre><em class=\"codeEmphasisStrong\">ShowInterfaces </em>&lt;MaxObject&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC676A\"></a>Use <span class=\"code\">ShowInterfaces()</span> to find out what functions/methods and properties are available on an object or controller.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC676C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC676D\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5050\"></a><pre>\nShowProperties $Character001\n.CATMode : integer\n.CATName : TSTR by value\n.CATUnits : float\n.ColourMode : integer\n.LengthAxis : TSTR\n.Node : node\n.RootHub : control\n.CATVersion : integer\n.CATRigSpace : matrix3\n.CATRigNodes : node by value array\n.CATRigLayerCtrls : control by value array\n.RootTransformNode : node\n.NumLayers : integer\n.SelectedLayer : integer\n.SoloLayer : integer\n.TrackDisplayMethod : integer\n.Layers : float\nfalse\n \nShowInterfaces $Character001\nInterface: CATParentFPInterface\nProperties:\n.CATMode : integer : Read|Write|Validated by Validator function\n.CATName : TSTR by value : Read|Write\n.CATUnits : float : Read|Write|Validated by Validator function\n.ColourMode : integer : Read|Write\n.LengthAxis : TSTR : Read|Write|Validated by Validator function\n.Node : node : Read\n.RootHub : control : Read\n.CATVersion : integer : Read\n.CATRigSpace : matrix3 : Read\n.CATRigNodes : node by value array : Read\n.CATRigLayerCtrls : control by value array : Read\n.RootTransformNode : node : Read\nMethods:\n &lt;void&gt;AddHub()\n &lt;boolean&gt;LoadRig &lt;TSTR&gt;filename\n &lt;boolean&gt;SaveRig &lt;TSTR&gt;filename\n &lt;node&gt;GetBoneByAddress &lt;TSTR by value&gt;Address\n &lt;void&gt;UpdateUserProps()\n &lt;void&gt;AddRootNode()\nActions:\nInterface: LayerRootFPInterface\nProperties:\n.NumLayers : integer : Read\n.SelectedLayer : integer : Read|Write\n.SoloLayer : integer : Read|Write\n.TrackDisplayMethod : integer : Read|Write\nMethods:\n &lt;integer&gt;AppendLayer &lt;TSTR&gt;name &lt;name&gt;method\nmethod Validated by Validator function\n &lt;boolean&gt;InsertLayer &lt;TSTR&gt;name &lt;integer&gt;layerID &lt;name&gt;method\nmethod Validated by Validator function\n &lt;void&gt;RemoveLayer &lt;integer&gt;layerID\n &lt;void&gt;MoveLayerUp &lt;integer&gt;layerID\n &lt;void&gt;MoveLayerDown &lt;integer&gt;layerID\n &lt;boolean&gt;SaveClip &lt;TSTR&gt;filename &lt;time&gt;starttime &lt;time&gt;endtime &lt;integer&gt;startlayer &lt;integer&gt;endlayer\n &lt;boolean&gt;SavePose &lt;TSTR&gt;filename\n &lt;node&gt;LoadClip &lt;TSTR&gt;filename &lt;time&gt;starttime scaledata: &lt;boolean&gt; transformdata: &lt;boolean&gt; mirrordata: &lt;boolean&gt; mirrorworldX: &lt;boolean&gt; mirrorworldY: &lt;boolean&gt;\nscaledata default value: true\ntransformdata default value: true\nmirrordata default value: false\nmirrorworldX default value: false\nmirrorworldY default value: false\n &lt;node&gt;LoadPose &lt;TSTR&gt;filename &lt;time&gt;starttime scaledata: &lt;boolean&gt; transformdata: &lt;boolean&gt; mirrordata: &lt;boolean&gt; mirrorworldX: &lt;boolean&gt; mirrorworldY: &lt;boolean&gt;\nscaledata default value: true\ntransformdata default value: true\nmirrordata default value: false\nmirrorworldX default value: false\nmirrorworldY default value: false\n &lt;TSTR&gt;CreatePasteLayerTransformNode()\n &lt;TSTR&gt;GetFileTagValue &lt;TSTR&gt;filename &lt;TSTR&gt;tag\n &lt;boolean&gt;LoadHTR &lt;TSTR&gt;filename &lt;TSTR&gt;camfile\n &lt;boolean&gt;LoadBVH &lt;TSTR&gt;filename &lt;TSTR&gt;camfile\n &lt;boolean&gt;LoadFBX &lt;TSTR&gt;filename &lt;TSTR&gt;camfile\n &lt;boolean&gt;LoadBIP &lt;TSTR&gt;filename &lt;TSTR&gt;camfile\n &lt;void&gt;CollapsePoseToCurLayer()\n &lt;boolean&gt;CollapseTimeRangeToLayer &lt;time&gt;StartTime &lt;time&gt;Endtime &lt;time&gt;Frequency regularplot: &lt;boolean&gt; NumPasses: &lt;integer&gt; PosDeltaThreshold: &lt;float&gt; RotDeltaThreshold: &lt;float&gt;\nregularplot default value: false\nNumPasses default value: 2\nPosDeltaThreshold default value: 1.0\nRotDeltaThreshold default value: 5.0\n &lt;void&gt;CopyLayer &lt;index&gt;LayerID\n &lt;void&gt;PasteLayer Instance: &lt;boolean&gt; CopyLayerInfo: &lt;boolean&gt;\nInstance default value: false\nCopyLayerInfo default value: true\nActions:\nOK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67CA\"></a>Note that the properties exposed by an Interface will also appear as results of the\n               <span class=\"code\">ShowProperties()</span> call. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67CC\"></a>You can also call \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-504F\"></a><pre><em class=\"codeEmphasisStrong\">ClassOf</em> &lt;MaxObject&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67CE\"></a>This returns the class name of the specified object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67D0\"></a>To access the transform controller of a <em class=\"strong\">3ds Max CAT</em> bone object which represents the bone inside the controller tree hierarchy of a CATRig,\n               use the following syntax: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-504E\"></a><pre><em class=\"codeEmphasisStrong\">$</em>&lt;NodeName&gt;.<em class=\"codeEmphasisStrong\">transform.controller</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67D3\"></a>A shorthand way of doing the same thing is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-504D\"></a><pre><em class=\"codeEmphasisStrong\">$</em>&lt;NodeName&gt;<em class=\"codeEmphasisStrong\">[3].controller</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67D5\"></a>or, since the CAT Bone objects also provide a dedicated variable to access the transform\n               controller, \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-504C\"></a><pre><em class=\"codeEmphasisStrong\">$</em>&lt;NodeName&gt;<em class=\"codeEmphasisStrong\">.TMcontroller</em></pre></div> <a name=\"TABLE_00474F7A2DA041BABA04AC9179DC0254\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1476235442241105%\">\n                     <col width=\"54.170601196096946%\">\n                     <col width=\"42.681775259678936%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\" colspan=\"2\"> <a name=\"P_4069B9F2589F4B6AB60D34390906C54B\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_3BB5FFD01D874B1EA49A6224262CDCFF\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">3ds Max CAT - Quick Navigation</a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67DB\"></a> <span class=\"char_link\"><a href=\"GUID-A7CB37DD-5852-4C55-8C38-3335C56F9D01.htm\">MAXScript Access To CATRigs</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67DC\"></a> <span class=\"char_link\"><a href=\"GUID-A2663EFC-8DBE-4F18-9327-C1AFF6019BA1.htm\">MAXScript Access To CAT Layers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC67DD\"></a> <span class=\"char_link\"><a href=\"GUID-42358EC9-39BA-4E4F-A83C-DD685C64DC78.htm\">Navigating CATRig Hierarchies using MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";