var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-76F76CB2-1026-447E-8DEE-23A57FB29C25\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"keys\">\n      <meta name=\"indexterm\" content=\"Bezier controller keys\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Bezier Controller Keys</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-76F76CB2-1026-447E-8DEE-23A57FB29C25\"></a><div class=\"head\">\n            <h1>Bezier Controller Keys </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C0A\"></a>For Bezier controller keys, the following properties are accessible: \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C09\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E39\"></a><pre>&lt;key&gt;.<em class=\"codeEmphasisStrong\">time</em> Time</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C07\"></a>Time value or number (interpreted as frames) \n         </p>\n         <p><a name=\"GUID-E21A2FE2-1FEE-45F3-A512-E4DAD18A95CE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E38\"></a><pre>&lt;key&gt;.<em class=\"codeEmphasisStrong\">selected</em> Boolean</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C04\"></a>Specifies whether the key is selected \n         </p>\n         <p><a name=\"GUID-EC29BBFF-7DE8-458B-8372-C108D273AD66\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E37\"></a><pre>&lt;key&gt;.<em class=\"codeEmphasisStrong\">value</em> varies</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7C01\"></a>Class determined by its containing controller \n         </p>\n         <p><a name=\"GUID-98954A18-889A-4594-9336-63E17E2BCB10\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E36\"></a><pre>&lt;key&gt;.<em class=\"codeEmphasisStrong\">inTangent</em> varies-- float or point3 (see below)\n&lt;key&gt;.<em class=\"codeEmphasisStrong\">outTangent</em> varies-- float or point3 (see below)\n&lt;key&gt;.<em class=\"codeEmphasisStrong\">inTangentType</em> Name-- see list of permitted names below\n&lt;key&gt;.<em class=\"codeEmphasisStrong\">outTangentType</em> Name-- see list of permitted names below\n&lt;key&gt;.<em class=\"codeEmphasisStrong\">inTangentLength</em> Float\n&lt;key&gt;.<em class=\"codeEmphasisStrong\">outTangentLength</em> Float\n&lt;key&gt;.<em class=\"codeEmphasisStrong\">freeHandle</em> Boolean\n&lt;key&gt;.<em class=\"codeEmphasisStrong\">x_locked</em> Boolean default: true\n&lt;key&gt;.<em class=\"codeEmphasisStrong\">y_locked</em> Boolean default: true\n&lt;key&gt;.<em class=\"codeEmphasisStrong\">z_locked</em> Boolean default: true\n&lt;key&gt;.<em class=\"codeEmphasisStrong\">constantVelocity</em> Boolean default: false</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BF4\"></a>The .<span class=\"code\"> <em class=\"strong\">inTangent</em> </span> and .<span class=\"code\"> <em class=\"strong\">outTangent</em> </span> values are Floats in keys of float controllers and Point3s for the other appropriate\n            controllers. Default value is 0 for float controllers, [0,0,0] otherwise. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BF2\"></a>The .<span class=\"code\"> <em class=\"strong\">inTangentType</em> </span> and .<span class=\"code\"> <em class=\"strong\">outTangentType</em> </span> properties have symbolic name values representing the possible tangent types available\n            in the drop-down menu in the Bezier key property dialog: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E35\"></a><pre><em class=\"codeEmphasisStrong\">#smooth</em> <em class=\"codeEmphasisStrong\">#linear</em> <em class=\"codeEmphasisStrong\">#step</em> <em class=\"codeEmphasisStrong\">#fast</em> <em class=\"codeEmphasisStrong\">#slow</em> <em class=\"codeEmphasisStrong\">#custom</em> <em class=\"codeEmphasisStrong\">#auto</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BEA\"></a> <span class=\"code\"> <em class=\"strong\">.inTangentLength</em> </span> and .<span class=\"code\"> <em class=\"strong\">outTangentLength</em> </span>, (typically a fraction from 0 to 1) represent how long the handle is towards the\n            adjacent key. For example, a value of 0.5 means the handle reaches halfway from the\n            current key to the adjacent key, and a value of 1 reaches all the way. If the handle\n            reaches beyond the adjacent key, it will be greater than one. If there is no previous\n            key, the value of <span class=\"code\"> <em class=\"strong\">.inTangentLength</em> </span> will be -1. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BE9\"></a>There is a check box to the key property/Master Point control dialog found in the\n            Motion Panel. It is called Free Handle. When Free Handle is checked, the user can\n            move the horizontal handle. Otherwise, the user is constrained to prevent discontinuities.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BE8\"></a>Correspondingly, there is a bezier key property called <span class=\"code\"> <em class=\"strong\">.freeHandle</em> </span> that implements the functionality described above. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BE6\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BE5\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2E34\"></a><pre>\ns = sphere()\nc = bezier_position ()-- create and assign new controller\ns.pos.controller = c\nk = addNewKey c 0f-- add a key at frame 0\nk.value = [10,0,0]-- set value there\nk.outTangentType = #slow-- and outgoing tangent type\nk = addNewKey c 100f-- add another key at 100\nk.value = [200,10,0]-- set value\nk.inTangentType = #custom-- make inTangent custom\nk.inTangent = [0.2, 0.02, 0.112]-- set its tangents\nk.x_locked = false-- and unlock handles\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F9E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>There are a fair number of classes that do not implement the <span class=\"code\"> <em class=\"strong\">showproperties</em> </span> method. MAXKey is one of them. <span class=\"code\"> <em class=\"strong\">getPropNames</em> </span> is not implemented for it either. \n            </div>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BD1\"></a> <span class=\"char_link\"><a href=\"GUID-DB1E088D-DA4E-44BF-AE9A-B207653E96B8.htm\">Key Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BD0\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BCF\"></a> <span class=\"char_link\"><a href=\"GUID-65B2DF3B-07A9-441B-8BA8-663BE1527AB8.htm\">Bezier Controllers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7BCE\"></a> <span class=\"char_link\"><a href=\"GUID-C800917A-45CC-4FE7-914D-87D0BEFF506A.htm\">BezierDefaultParams Structure</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";