var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-779C94C1-87B6-46D4-80E5-9737689FD182\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"language\">\n      <meta name=\"indexterm\" content=\"tokens\">\n      <meta name=\"indexterm\" content=\"Code\">\n      <meta name=\"indexterm\" content=\"\\ character\">\n      <meta name=\"indexterm\" content=\"sub-expressions: line breaks\">\n      <meta name=\"indexterm\" content=\"source code layout and continuation lines\">\n      <meta name=\"indexterm\" content=\"punctuation: in MAXScript code\">\n      <meta name=\"indexterm\" content=\"line breaks: invalid\">\n      <meta name=\"indexterm\" content=\"line breaks: in MAXScript code\">\n      <meta name=\"indexterm\" content=\"freeform language - defined\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"indexterm\" content=\"double-hyphen - for code comments\">\n      <meta name=\"indexterm\" content=\"continuation lines\">\n      <meta name=\"indexterm\" content=\"comments\">\n      <meta name=\"indexterm\" content=\"backslash - for line continuation\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Source Code Layout and Continuation Lines</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-779C94C1-87B6-46D4-80E5-9737689FD182\"></a><div class=\"head\">\n            <h1>Source Code Layout and Continuation Lines </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BE7\"></a>               The layout rules for MAXScript code are unlike those of most programming languages\n            and give you the advantages of freeform languages, such as C and C++, but without\n            the need for extensive punctuation, like semicolons and parenthesized parameter lists.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BF7\"></a>MAXScript lets you break statements and expressions across lines wherever you want,\n            providing the line break is in the middle of an expression. MAXScript reads your code\n            until the end of each line and determines whether it has a complete expression. If\n            it does not, it continues to read subsequent lines until it finds the rest of the\n            expression. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BF8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BF9\"></a><p class=\"table-body\"> <em class=\"strong\">TAKE AS AN EXAMPLE THE FOLLOWING LINE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63A2\"></a><pre>a + b * c / d - e + f * g / h</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BFE\"></a>This line can be broken after any of the operators. MAXScript continues to read the\n            next line, because an operator needs another argument. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BFF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C00\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63A1\"></a><pre>a + b * c / d - e +\nf * g / h</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C06\"></a>You cannot break the example line as shown next and get the same result, because the\n            expression on the first line is a complete expression. MAXScript considers the two\n            lines as separate expressions, and the <em class=\"strong\">second line </em>is now<em class=\"strong\"> syntactically wrong</em>, because it <em class=\"strong\">starts with an operator</em>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C07\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C08\"></a><p class=\"table-body\"> <em class=\"strong\">NOT POSSIBLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63A0\"></a><pre>a + b * c / d - e\n+ f * g / h</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C0E\"></a>If you do want to break a line at the end of a sub-expression, you can use the backslash\n            line continuation character: \'<em class=\"strong\">\\</em>\'. The previous example above of an invalid break can be made valid using the line\n            continuation character after the \'e\': \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C0F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C10\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-639F\"></a><pre>a + b * c / d - e \\\n+ f * g / h</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C16\"></a>Whenever MAXScript encounters a \'<em class=\"strong\">\\</em>\' as the last character on a line, except for spaces, tabs, or comments, it continues\n            to read the next line as though the line break were not present. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C17\"></a>Line continuations are often used to break up function calls with many arguments,\n            as shown in many of the <span class=\"char_link\"><a href=\"GUID-B93647B2-8BC7-4D83-BA90-0105DAB3591C.htm\">Expressions</a></span> topics. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C19\"></a>This scheme allows you to write the following forms of the same statement without\n            using periods or semicolons, as you might in other freeform languages. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C1A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C1B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C1C\"></a><p class=\"table-body\">An <em class=\"strong\">if/then/else </em>construct could be written as: \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-639E\"></a><pre>if a &lt; b then print c else print d</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C20\"></a><p class=\"table-body\">or </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-639D\"></a><pre>if a &lt; b then print c\nelse print d</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C25\"></a><p class=\"table-body\">or </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-639C\"></a><pre>if\na &lt; b\nthen\nprint c\nelse\nprint d</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C2F\"></a>MAXScript also lets you combine multiple statements and expressions in a single line.\n            The statements or expressions are separated with a \'<em class=\"strong\">;</em>\'. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C30\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C31\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-639B\"></a><pre>print \"End of input data reached\" to:f ; close f ; f = undefined\nif a &lt; 0 do (print \"value out of range\";a=0)</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C37\"></a>Comments in MAXScript begin with a double-hyphen (\'<em class=\"strong\">--</em>\') and extend to the end of the current line. Many code examples in this help file\n            use comments in this style. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C38\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4C39\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-639A\"></a><pre>-- special cases...\nif first do\nsubanims[6]=undefined-- subanims[6] is #Image_Motion_Blur_Multiplier</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";