var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-78460DD3-5FA4-4F68-990A-54D8D6092802\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Develop a Bitmap Painting Tool\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop a Bitmap Painting Tool - Airbrush and Shapes</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-78460DD3-5FA4-4F68-990A-54D8D6092802\"></a><div class=\"head\">\n            <h1>How To ... Develop a Bitmap Painting Tool - Airbrush and Shapes </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26ED\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26EE\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-FA2D9E9C-90EA-4E95-926E-29BB2FA416FA.htm\">Develop a Bitmap Painting Tool</a></span>- Airbrush and Shapes \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26F0\"></a>In this step of the Bitmap Painting tool development, we will add an airbrush option\n            to the tool and a brush shape option to draw both rectangular and circular brushes.\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26F2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26F3\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26F4\"></a><p class=\"table-body\">The existing rollout will be enhanced by adding a dropdown list to define the Brush\n                        shape, a checkbutton to enable the AirBrush, and a spinner to control its strength.\n                        \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26F5\"></a><p class=\"table-body\">We will extend the existing code by drawing random points for the AirBrush option.\n                        \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26F6\"></a><p class=\"table-body\">The drawStroke function will be enhanced to draw a circle with the Size as the radius.\n                        \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26F8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC26F9\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-640E\"></a><pre>\nmacroScript MicroPaint category: \"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry (destroyDialog MicroPaint_CanvasRollout) catch()\nlocal isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white\nlocal currentPos = lastPos = [0,0]\n&nbsp;\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\n  bitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap\n  colorpicker inkColor height:16 modal:false color:black across:4\n  checkbutton airBrush \"AirBrush\" width:50\n  spinner AirBrushSpeed \"Speed\" range:[0.1,50,10] fieldwidth:40\n  spinner BrushSize \"Size\" range:[1,50,10] type:#integer fieldwidth:40\n  listbox BrushShape items:#(\"Circle\",\"Box\") pos:[bitmapX+5,0]width:90\n&nbsp;\n  fn paintBrush pos =\n  (\n    case BrushShape.selection of\n    (\n      1: (\n        if distance pos currentPos &lt;= BrushSize.value/2 do\n          setPixels theCanvasBitmap pos #(inkColor.color)\n      )\n      2: &nbsp;setPixels theCanvasBitmap pos #(inkColor.color)\n     )\n  )\n&nbsp;\n  fn drawStroke lastPos pos =\n  (\n    currentPos = lastPos\n    deltaX = pos.x - lastPos.x\n    deltaY = pos.y - lastPos.y\n    maxSteps = amax #(abs(deltaX),abs(deltaY))\n    deltaStepX = deltaX / maxSteps\n    deltaStepY = deltaY / maxSteps\n    for i = 0 to maxSteps do\n    (\n      if airBrush.checked then\n      (\n        for b = 1 to (BrushSize.value / AirBrushSpeed.value) do\n        paintBrush (currentPos + (random [-BrushSize.value/2,-BrushSize.value/2] [BrushSize.value/2,BrushSize.value/2] ))\n      )\n      else\n        for b = -BrushSize.value/2 to BrushSize.value/2 do\n          for c = -BrushSize.value/2 to BrushSize.value/2 do\n            paintBrush (currentPos + [c,b])\n      currentPos += [deltaStepX, deltaStepY]\n    )&nbsp;\n    theCanvas.bitmap = theCanvasBitmap\n  )\n&nbsp;\n  on MicroPaint_CanvasRollout lbuttondown pos do\n  (\n    lastPos = pos\n    isDrawing = true\n    drawStroke lastPos pos\n  )\n  on MicroPaint_CanvasRollout lbuttonup pos do isDrawing = false\n  on MicroPaint_CanvasRollout mousemove pos do\n  (\n    if isDrawing do drawStroke lastPos pos\n    lastPos = pos\n  )\n)\ncreateDialog MicroPaint_CanvasRollout (bitmapx+100) (bitmapy+30)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2742\"></a> \n            <h2><a name=\"GUID-880B079E-23D1-4F25-9A8E-AAEF9D924CFA\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-640D\"></a><pre><em class=\"codeEmphasisMild\"><em class=\"codeEmphasisStrong\">--Code in italic has no changes since the previous version.</em></em> <em class=\"codeEmphasisMild\">\nmacroScript MicroPaint category:\"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry(destroyDialog CanvasRollout)catch()\nlocal isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\nbitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap</em> <em class=\"codeEmphasisStrong\">colorpicker inkColor height:16 modal:false color:black across:4</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2752\"></a>To accommodate automatically all new controls in the bottom row, we will have to increase\n               the across: parameter to 4. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-640C\"></a><pre><em class=\"codeEmphasisStrong\">checkbutton airBrush \"AirBrush\" width:50</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2754\"></a>When checked, this checkbutton will enable the Airbrush feature. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-640B\"></a><pre><em class=\"codeEmphasisStrong\">spinner AirBrushSpeed \"Speed\" range:[0.1,50,10] fieldwidth:40</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2756\"></a>This value will control the strength of the Airbrush feature. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-640A\"></a><pre><em class=\"codeEmphasisMild\">spinner BrushSize \"Size\" range:[1,50,10] type:#integer fieldwidth:40</em> <em class=\"codeEmphasisStrong\">listbox BrushShape items:#(\"Circle\", \"Box\") width:90 pos:[bitmapx+5,0]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC275B\"></a>This listbox controls the shape of the brush. In the future versions, we will add\n               additional tools to it. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC275C\"></a> <span class=\"char_link\"><a href=\"GUID-7C37748B-C682-4834-B5A6-74185C8C661A.htm\">Listbox</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6409\"></a><pre><em class=\"codeEmphasisMild\">fn paintBrush pos =</em> <em class=\"codeEmphasisMild\">(</em> <em class=\"codeEmphasisStrong\">case BrushShape.selection of</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2762\"></a>Depending on the setting of the Brush Shape dropdown list, the pixels will be limited\n               inside a circle, or will be drawn as before. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2763\"></a> <span class=\"char_link\"><a href=\"GUID-21F52D81-8D49-4CBC-A8C4-3E906E150439.htm\">Case Expression</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6408\"></a><pre><em class=\"codeEmphasisStrong\">1: (\nif distance pos currentPos &lt;= BrushSize.value/2 do\nsetPixels theCanvasBitmap pos #(inkColor.color)\n)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2769\"></a>If the Circle shape is selected, the distance from the position to be drawn to the\n               center of the brush will be compared to the radius value (the size divided by 2).\n               Only if the point is at a distance less than the radius, it will be drawn. This defines\n               a circular brush. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6407\"></a><pre><em class=\"codeEmphasisStrong\">2: setPixels theCanvasBitmap pos #(inkColor.color)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC276B\"></a>This is the original function used in the previous step. It will be used when the\n               dropdown list selection is 2 - \"Box\". \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6406\"></a><pre><em class=\"codeEmphasisStrong\">)</em> <em class=\"codeEmphasisStrong\">)</em> <em class=\"codeEmphasisMild\">\nfn drawStroke lastPos pos =\n(\ncurrentPos = lastPos\ndeltaX = pos.x - lastPos.x\ndeltaY = pos.y - lastPos.y\nmaxSteps = amax #(abs(deltaX),abs(deltaY))\ndeltaStepX = deltaX / maxSteps\ndeltaStepY = deltaY / maxSteps\nfor i = 0 to maxSteps do\n(</em> <em class=\"codeEmphasisStrong\">if airBrush.checked then</em> <em class=\"codeEmphasisStrong\">(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC277B\"></a>When the Airbrush option is checked, the following code will be executed: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6405\"></a><pre><em class=\"codeEmphasisStrong\">for b = 1 to (BrushSize.value / AirBrushSpeed.value) do</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC277D\"></a>We will repeat a number of times. The actual number will be dependent on the size\n               of the brush and the Airbrush speed value. The higher the Speed value, the lower the\n               number of samples in the brush. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6404\"></a><pre><em class=\"codeEmphasisStrong\">paintBrush (currentPos + (random [-BrushSize.value/2,-BrushSize.value/2] [BrushSize.value/2,BrushSize.value/2] ))</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC277F\"></a>For every iteration, we will draw a random point between the lower left and upper\n               right corners of the box brush. If circular brush is selected, some of the points\n               will be filtered out by the new code in the paintbrush function above. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6403\"></a><pre><em class=\"codeEmphasisStrong\">)\nelse</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2782\"></a>Otherwise, the original brush code below will be executed. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6402\"></a><pre><em class=\"codeEmphasisMild\">for b = -BrushSize.value/2 to BrushSize.value/2 do\nfor c = -BrushSize.value/2 to BrushSize.value/2 do\npaintBrush (currentPos + [c,b])\ncurrentPos += [deltaStepX, deltaStepY]\n)&nbsp;\ntheCanvas.bitmap = theCanvasBitmap\n)\non MicroPaint_CanvasRollout lbuttondown pos do\n(\nlastPos = pos\nisDrawing = true\ndrawAPoint lastPos pos\n)\non MicroPaint_CanvasRollout lbuttonup pos do isDrawing = false\non MicroPaint_CanvasRollout mousemove pos do\n(\nif isDrawing do drawAPoint lastPos pos\nlastPos = pos\n)</em> <em class=\"codeEmphasisStrong\">createDialog MicroPaint_CanvasRollout (bitmapX+100)(bitmapY+30)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2798\"></a>In order to accommodate the new User Interface controls for the color and brush size,\n               we have to increase the horizontal size of the dialog by 100 pixels. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6401\"></a><pre><em class=\"codeEmphasisMild\">)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC279B\"></a> <em class=\"strong\">Result</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC279C\"></a> <img src=\"../images/GUID-8CF6215A-55E6-43C1-BDF7-E0DB958BCE8A-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC279E\"></a> <em class=\"strong\">Previous Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC279F\"></a> <span class=\"char_link\"><a href=\"GUID-E9C5AFAA-52A0-4274-A92C-8075C3BD0F25.htm\">How To ... Develop a Bitmap Painting Tool - Brush Size and Color</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27A0\"></a> <em class=\"strong\">Next Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27A1\"></a> <span class=\"char_link\"><a href=\"GUID-6AC542FD-A91B-4F32-89DD-56A9E1B118E3.htm\">How To ... Develop a Bitmap Painting Tool - Smooth Brushes</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC27A4\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";