var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-78A07874-70D3-4FFF-BE06-C9BB3721F252\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"trigonometric functions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Trigonometric Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-78A07874-70D3-4FFF-BE06-C9BB3721F252\"></a><div class=\"head\">\n            <h1>Trigonometric Functions </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC523C\"></a> This topic is a quick review for readers who need a reminder about this area of mathematics.\n            If you’re familiar with trigonometry, you can skip this topic. If you find this topic\n            difficult to follow, you might consult a more basic reference on mathematics. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC523E\"></a>Trigonometric functions are principally used to model or describe: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC523F\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5241\"></a>The relation between angles in a triangle (hence the name). \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5243\"></a>Rotations about a circle, including locations given in polar coordinates. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5245\"></a>Cyclical or periodic values, such as sound waves. \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5246\"></a>The three basic trigonometric functions are derived from an angle rotating about a\n            unit circle. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5247\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-AC6792B8-7D79-4850-BD89-E64280A0B1A2-low.gif\"><p class=\"figure-title\">Trigonometric functions based on the unit circle</p>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5249\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-3727A2D1-816F-47CD-96FC-77C598B42B78-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC524A\"></a>The tangent function is undefined for x = 0. Another way to define the target is:\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC524B\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-43C75AC0-CDCF-46DD-A222-07E30483A566-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC524C\"></a>Because <em class=\"mild\">XY R</em> defines a right-angled triangle, the relation between the sine and cosine is: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC524D\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-0959AA12-8A11-4F5B-A57F-CD2F32A3B7BC-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC524E\"></a>The graphs of the basic trigonometric functions illustrate their cyclical nature.\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC524F\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-1B9B81A2-255D-4BA5-B04D-B042BF9EA022-low.gif\"><p class=\"figure-title\">Graphs of basic trigonometric functions</p>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5251\"></a>The sine and cosine functions yield the same values, but the phase differs along the\n            X-axis by /2: in other words, 90 degrees. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5252\"></a>The inverse functions for the trigonometric functions are the arc functions—the inverse\n            only applies to values of x restricted by -/2 ≤ X ≤ /2. The graphs for these functions\n            appear like the basic trigonometric function graphs, but turned on their sides. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5253\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-ABF4269D-D5C1-4F0C-8041-7772AC921BD6-low.gif\"><p class=\"figure-title\"> <em class=\"strong\">Graphs of basic arc functions</em> \n            </p>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5255\"></a>The hyperbolic functions are based on the exponential constant <em class=\"mild\">e</em> instead of on circular measurement. However, they behave similarly to the trigonometric\n            functions and are named for them. The basic hyperbolic functions are: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5256\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-86F381E1-4DC6-426B-97D0-D91896320E04-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC5257\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-A9C7C2AC-0E02-49E7-9527-453807AE8D53-low.gif\"><p class=\"figure-title\">Graphs of basic hyperbolic functions</p>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";