var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-78A3F5B1-9C42-4725-B7BB-E67708D39644\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"variables\">\n      <meta name=\"indexterm\" content=\"string variables\">\n      <meta name=\"indexterm\" content=\"assigning variables\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Assigning Variables</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-78A3F5B1-9C42-4725-B7BB-E67708D39644\"></a><div class=\"head\">\n            <h1>Assigning Variables </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E82\"></a>   In the <span class=\"char_link\"><a href=\"GUID-34C253DE-0F9F-4FB5-BBB1-4233F2C32477.htm\">previous lesson</a></span>, you entered the string \"Hello\" in MAXScript, and MAXScript displayed the same string\n            as its command output. When you enter other strings, MAXScript displays them and forgets\n            about the previous ones. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E86\"></a>To make MAXScript <em class=\"strong\">remember the value</em> of a string, you can <em class=\"strong\">assign it to a variable</em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E88\"></a>The general syntax for assigning a variable in MAXScript is: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5094\"></a><pre>variable_name<em class=\"codeEmphasisStrong\">=</em>variable_value</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E8A\"></a>A <span class=\"code\">variable_name</span> starts with an alphabetic character or \"_\" (underscore), followed by any number of\n            alphanumeric characters. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E8B\"></a>The <span class=\"code\">variable_value</span> can be a string, a number, or any other expression. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E8C\"></a> \n            <h2><a name=\"GUID-A4F41465-6DD0-402A-90D6-575B89E397F3\"></a> <em class=\"strong\">To assign a string to a variable:</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E8D\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E8F\"></a>At the Listener prompt, enter the following command: \n                  </p> \n                  <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5093\"></a><pre>mystring = \"This is my string.\"</pre></div> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E91\"></a>MAXScript returns the value of the string variable: \n                  </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E92\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-714E597F-E871-42E7-AFB9-2782376BE72C-low.gif\"></div> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E95\"></a>You can now refer to this string variable by entering the variable’s name. Enter <span class=\"code\">mystring</span>. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E96\"></a>MAXScript again returns the value of the string variable: \n                  </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E97\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-32F21C3E-4142-460A-A93B-A5A57E098140-low.gif\"></div> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E98\"></a>This is faster than entering the string again. MAXScript remembers this string for\n                     as long as your <em class=\"strong\">3ds Max</em> session is open, or until you change the variable’s value. \n                  </p> \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E99\"></a> \n            <h2><a name=\"GUID-DCB6C4A4-1FB2-4778-8D9C-0B1AEDA24A7E\"></a> <em class=\"strong\">To assign a new value to an existing variable:</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E9A\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E9C\"></a>Enter <span class=\"code\">mystring = \"This is not your string.\"</span> \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E9D\"></a>MAXScript now displays the new value of <span class=\"code\">mystring</span>: \n                  </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4E9E\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-8061AB68-B776-4ED8-8E78-B71C1EDE1A8C-low.gif\"></div> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EA1\"></a>When you refer to <span class=\"code\">mystring</span> now, MAXScript uses the new value. Enter <span class=\"code\">mystring</span>. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EA2\"></a>MAXScript now displays the new variable value: \n                  </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EA3\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-7B56BA92-FC24-4B11-B084-D1397FC99D57-low.gif\"></div> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EA4\"></a>Notice that MAXScript doesn’t distinguish between lowercase and uppercase variable\n                     names because MAXScript names are not case-sensitive. Thus, entering myString is the\n                     same as entering mystring or MYSTRING or MyStRiNg. \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EA5\"></a> <em class=\"strong\">Next Topic</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4EA6\"></a> <span class=\"char_link\"><a href=\"GUID-BEFD6E9D-65BF-4C0B-B217-8604DC48200B.htm\">Mathematical Operations in MAXScript</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";