var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-78B579F1-1265-4D83-A0E5-B0E444F6AC3A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSSurface - NURBSObject\">\n      <meta name=\"indexterm\" content=\"NURBSCapSurface - NURBSSurface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSCapSurface : NURBSSurface</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-78B579F1-1265-4D83-A0E5-B0E444F6AC3A\"></a><div class=\"head\">\n            <h1>NURBSCapSurface : NURBSSurface </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-427C\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-427B\"></a>  This class defines a dependent Cap surface. A Cap surface is a surface that caps a\n               closed curve or the edge of a closed surface. Caps are especially useful with extruded\n               surfaces. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4278\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-214C\"></a><pre><em class=\"codeEmphasisStrong\">NURBSCapSurface</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4276\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-214B\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4272\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-214A\"></a><pre>&lt;nurbscapsurface&gt;.<em class=\"codeEmphasisStrong\">parent</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4270\"></a>The parent curve or surface by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2149\"></a><pre>&lt;nurbscapsurface&gt;.<em class=\"codeEmphasisStrong\">parentID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-426D\"></a>The parent curve or surface by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2148\"></a><pre>&lt;nurbscapsurface&gt;.<em class=\"codeEmphasisStrong\">edge</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-426A\"></a>Which edge of the parent surface is capped. This value is not applicable if the parent\n               is a curve. The property’s value is one of the following: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4269\"></a>1: The low U edge \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4268\"></a>2: The high U edge \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4267\"></a>3: The low V edge \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4266\"></a>4: The high V edge \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2147\"></a><pre>&lt;nurbscapsurface&gt;.<em class=\"codeEmphasisStrong\">curveStartPoint</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4263\"></a>The start point on the parent curve. This value is only applicable if the parent is\n               a curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4260\"></a> <span class=\"char_link\"><a href=\"GUID-19C0A3FC-AECA-437A-A430-51EFC9D70545.htm\">NURBSSurface</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-425F\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-425E\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";