var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-78D21100-E161-4015-9C8A-15629B153F8D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Scripted Plug-ins for New Users\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Plug-ins for New Users</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-78D21100-E161-4015-9C8A-15629B153F8D\"></a><div class=\"head\">\n            <h1>Scripted Plug-ins for New Users </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D7F\"></a> Scripted plug-ins appear and behave inside of <em class=\"strong\">3ds Max</em> like regular plug-ins written using the SDK. Often the user will have a hard time\n            telling whether a plug-in is actually a script or not (with the exception of scripted\n            RenderEffects that are usually slower than their C++ counterparts). \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D81\"></a>Before installing a scripted plug-in, you can open the source file and note the plug-in’s\n            name. This will make it easier for you to locate the actual UI entry as described\n            below. Typically, a scripted plug-in has the following form: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D82\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-637E\"></a><pre>\nplugin superClass ClassName\nname: \"PluginName\"\nclassID:#(....)...\n(\n...\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D8C\"></a>Remember the <span class=\"code\"> <em class=\"strong\">name:</em> </span>string and look for it in the respective area of the UI. \n         </p><a name=\"WS3ED54CBA79FF2E3D-7658A5A12B78356069-6DDC\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D8D\"></a> <em class=\"strong\">To install a scripted plug-in (multiple 3ds Max sessions)</em> \n         </p>\n         <ol type=\"1\" start=\"1\">\n            <li>Copy the script file to any folder listed in your Plug-ins Paths configuration ( Main\n               Menu &gt; Customize &gt; Configure System Paths &gt; 3rd Party Plug-Ins tab). \n            </li>\n            <li>Start <em class=\"strong\">3ds Max</em>. The script will be evaluated on startup and the new plug-in will appear in the respective\n               area of the UI. See below for details regarding different plug-in classes. This will\n               happen each time you start <em class=\"strong\">3ds Max</em>. \n            </li>\n         </ol><a name=\"WS3ED54CBA79FF2E3D-7658A5A12B78356069-6DD8\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D90\"></a> <em class=\"strong\">To test a scripted plug-in (single 3ds Max session):</em> \n         </p>\n         <ol type=\"1\" start=\"1\">\n            <li>From the Main Menu, select MAXScript and <em class=\"strong\">Run Script</em>. \n               <p><a name=\"WS3ED54CBA79FF2E3D-7658A5A12B78356069-6DD5\"></a>Alternatively, go to the Utilities panel, open MAXScript Utility, and press <em class=\"strong\">Run Script</em>. \n               </p> \n            </li>\n            <li>Locate and select the script source file and press <em class=\"strong\">Open</em>. The script will be evaluated and will create a new plug-in class. It will appear\n               in the respective area of the UI. See below for details regarding the different plug-in\n               classes. \n               <div><a name=\"WS3ED54CBA79FF2E3D-7658A5A12B78356069-6DD3\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Next time you start <em class=\"strong\">3ds Max</em>, the scripted plug-in will <em class=\"strong\">not</em> be available. The plug-in will be available only until the end of the current session\n                     and will be reported later as missing when loading files saved in the test session.\n                     To load .MAX files containing scripted plug-ins, you have to make sure the plug-in\n                     is loaded prior to opening the scene. \n                  </div>\n               </div> \n            </li>\n         </ol>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D95\"></a>Scripted plug-ins can be used to extend <em class=\"strong\">3ds Max</em> with: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12293\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3409\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3408\"></a> <em class=\"strong\">Scripted Geometry</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3407\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D97\"></a>Will appear in the Create panel &gt; Geometry in a category defined by the developer.\n                     These plug-ins can create and manipulate only instances of existing classes and are\n                     similar to System plug-ins, but living in the Create panel. They do not have their\n                     own object and sub-object levels. \n                  </p> \n               </div>\n            </dd>\n         </dl><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12299\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3406\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3405\"></a> <em class=\"strong\">Scripted MeshObjects (SimpleObject Class)</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3404\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D99\"></a>Will appear in the Create panel &gt; Geometry in a category defined by the developer.\n                     They can generate an Editable Mesh object on the fly just like the basic and extended\n                     primitives. \n                  </p> \n               </div>\n            </dd>\n         </dl><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12305\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3403\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3402\"></a> <em class=\"strong\">Scripted Modifiers</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3401\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D9B\"></a>Will appear in the Modify panel on the Modifiers list. There are two classes of modifiers.\n                     The one will extend existing modifiers (for example, by replacing the UI). The other\n                     will modify the object in local space based on a Gizmo (like Bend and Twist). \n                  </p> \n               </div>\n            </dd>\n         </dl><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12311\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3400\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33FF\"></a> <em class=\"strong\">Scripted Lights</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33FE\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D9D\"></a>Will appear in the Create panel &gt; Lights in a category defined by the developer. They\n                     can only extend existing lights. \n                  </p> \n               </div>\n            </dd>\n         </dl><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12317\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33FD\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33FC\"></a> <em class=\"strong\">Scripted Cameras</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33FB\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D9F\"></a>Will appear in the Create panel &gt; Cameras in a category defined by the developer.\n                     They can only extend existing cameras. \n                  </p> \n               </div>\n            </dd>\n         </dl><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12323\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33FA\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33F9\"></a> <em class=\"strong\">Scripted Helpers</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33F8\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DA1\"></a>Will appear in the Create panel &gt; Helpers in a category defined by the developer.\n                     They can only extend existing helpers. \n                  </p> \n               </div>\n            </dd>\n         </dl><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12329\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33F7\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33F6\"></a> <em class=\"strong\">Scripted Materials</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33F5\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DA3\"></a>Will appear in the Material/Map in a category defined by the developer. They can only\n                     extend existing materials. \n                  </p> \n               </div>\n            </dd>\n         </dl><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12335\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33F4\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33F3\"></a> <em class=\"strong\">Scripted TextureMaps</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33F2\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DA5\"></a>Will appear in the Material/Map in a category defined by the developer. They can only\n                     extend existing maps. \n                  </p> \n               </div>\n            </dd>\n         </dl><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12341\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33F1\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33F0\"></a> <em class=\"strong\">Scripted RenderEffects</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33EF\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DA7\"></a>Will appear in the Rendering &gt; Effects &gt; Add Effect list. \n                  </p> \n               </div>\n            </dd>\n         </dl><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12347\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33EE\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33ED\"></a> <em class=\"strong\">Scripted Atmospheric Plug-ins</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33EC\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DA9\"></a>Will appear in the Rendering &gt; Environment &gt; Atmosphere &gt; Add list. \n                  </p> \n               </div>\n            </dd>\n         </dl><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC38E0-12353\"></a><dl>\n            <dt><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33EB\"></a><span class=\"term\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33EA\"></a> <em class=\"strong\">Scripted Manipulators</em> </span></dt>\n            <dd>\n               <div class=\"definition\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33E9\"></a> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-33E8\"></a>Scripted Manipulators can appear under Create &gt; Helpers &gt; Manipulators or can be hidden\n                     to the user and only appear in the viewport when Manipulate mode is on and an object\n                     with a supported property is selected. They behave exactly as Manipulator plug-ins.\n                     In fact, several shipping manipulators like the Slider Manipulator, the Radius manipulator,\n                     and the UV Manipulator are implemented as Scripted Manipulator plug-ins. You can find\n                     their sources under <em class=\"mild\">Stdplugs\\StdScripts</em>. \n                  </p> \n               </div>\n            </dd>\n         </dl>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DAE\"></a> <em class=\"strong\">Topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DAF\"></a> <span class=\"char_link\"><a href=\"GUID-35CB7918-A86D-465E-AC63-3AAE310A113B.htm\">MAXScript for New and Casual Users</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DB0\"></a> <span class=\"char_link\"><a href=\"GUID-06825F89-B5DD-42D8-AB32-B928C897CA60.htm\">Scripted Utilities for New Users</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DB1\"></a> <span class=\"char_link\"><a href=\"GUID-C3F61DC1-D07C-4DCD-939C-CF30E4DCA29F.htm\">MacroScripts for New Users</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DB2\"></a> <span class=\"char_link\"><a href=\"GUID-F2A15BBB-2542-4983-89C0-BAEDC0E6051E.htm\">Scripted Functions for New Users</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4DB3\"></a> <span class=\"char_link\"><a href=\"GUID-7A554E0F-6509-4E50-9B52-7FF75774D064.htm\">MAXScript DLX Extensions for New Users</a></span> \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"GUID-615D14FB-0F2D-4801-B381-1128C4128C70.htm\">Startup Scripts </a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";