var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-78D32F5B-1805-4134-A923-60E541C984AD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"getInterface Function\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>getInterface Function</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-78D32F5B-1805-4134-A923-60E541C984AD\"></a><div class=\"head\">\n            <h1>getInterface Function </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FF2\"></a> \n            <p><a name=\"P_E807A9C624A64F96AE03554FDD700462\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5CFD\"></a><pre><em class=\"codeEmphasisStrong\">getInterface</em> {&lt;MAXWrapper&gt; | &lt;MAXClass&gt;} &lt;InterfaceNameString&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FED\"></a> <span class=\"code\"> <em class=\"strong\">getInterface</em> </span> returns the interface specified by the <span class=\"code\">&lt;InterfaceNameString&gt;</span>, or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the interface does not exist. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FEC\"></a>If the first argument is a node, the node-level interfaces for that node are returned.\n               \n            </p> \n            <p><a name=\"P_1DB184261A94415ABF0E16655E49826C\"></a>If you want the interfaces for the node\'s base object, you need to specify <span class=\"code\"> &lt;node&gt;<em class=\"strong\">.baseobject</em> </span> as the argument. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FEB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FEA\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5CFC\"></a><pre>\ns=sphere()\n--&gt; $Sphere:Sphere01 @ [0.000000,0.000000,0.000000]\ntheAInterface = getInterface s \"IAssembly\"\n--&gt; &lt;MixinInterface:IAssembly&gt;\nconverttopoly s\n--&gt; $Editable_Poly:Sphere01 @ [0.000000,0.000000,0.000000]\ntheEPInterface = getInterface s \"EditablePoly\"\n--&gt; undefined\ntheEPInterface = getInterface s.baseobject \"EditablePoly\"\n--&gt; &lt;MixinInterface:EditablePoly&gt;\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FDC\"></a>If the argument is a MAXClass, only static interfaces for that class are returned.\n               \n            </p> \n            <p><a name=\"P_A5D346FCCCC0443DA1B3D543102F6AD8\"></a>Typically, only utility plugin classes define static interfaces. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FDB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FDA\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5CFB\"></a><pre>\ngetInterface Plug_in_Manager \"PluginMgrAction\"\n&lt;Interface:PluginMgrAction&gt;\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FD3\"></a> <span class=\"char_link\"><a href=\"GUID-AEF738FF-131B-4731-A00D-B943DD7E4B94.htm\">GetInterfaces Interface Inspector</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FD2\"></a> <span class=\"char_link\"><a href=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52.htm\">Class and Object Inspector Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FD1\"></a> <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6FD0\"></a> <span class=\"char_link\"><a href=\"GUID-64FF9971-944C-42CF-995A-B549F9F7C11C.htm\">Other Interfaces</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";