var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-7AAEEA29-A627-43CF-B2F8-8B8BBB20F5E4\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Scripted SimpleMeshMod Plug-ins\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted SimpleMeshMod Plug-ins</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7AAEEA29-A627-43CF-B2F8-8B8BBB20F5E4\"></a><div class=\"head\">\n            <h1>Scripted SimpleMeshMod Plug-ins</h1>\n         </div>\n         <p><a name=\"GUID-2DEFE56B-6979-4386-939B-5A6D98945843\"></a> A SimpleMeshMod plug-in is a geometry modifier that can change the topology of the\n            incoming mesh and output the modified result. Available in \n            		<em class=\"strong\">3ds Max 2016 and higher</em>.\n            	 \n         </p>\n         <p><a name=\"GUID-7C64F32B-D344-475C-973B-90716D3F4993\"></a> Examples of similar modifiers are Mirror and Symmetry. \n            	 \n         </p>\n         <p><a name=\"GUID-43CC8ABE-6198-499D-82ED-535FA1882A78\"></a>These kinds of modifiers require a \n            		<span class=\"code\">modifyMesh</span> handler. The internal \n            		<span class=\"code\">mesh</span> value contains the modifier\'s TriMesh. It is set to the incoming TriMesh value and\n            can be set to a new TriMesh value to produce the modified output. \n            	 \n         </p>\n         <p><a name=\"GUID-27B6688F-E9B1-4B2F-9CBD-DEED1500620D\"></a> The internal \n            		<span class=\"code\">owningNode</span> value contains the node the modifier is applied to. If the modifier is instanced\n            across multiple nodes, only one of them will be accessible. \n            	 \n         </p>\n         <p><a name=\"GUID-CA9766EE-B33E-4EFF-A46B-81758BDC5DD7\"></a> The SimpleMeshMod plug-in operates similarly to a scripted Geometry plug-in, but\n            instead of creating a new Geometry object, it operates on the incoming TriMesh on\n            the Modifier Stack. \n            	 \n         </p>\n         <p><a name=\"GUID-FBD488F3-6244-460E-A2E3-C0A892D59B6B\"></a> A scripted Simple Mesh Modifier plug-in is declared by specifying the &lt;superclass&gt;\n            as \n            		<span class=\"code\">simpleMeshMod</span>. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2632\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C2633\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-52A3\"></a><pre>\nplugin simpleMeshMod TestCloneModifier\n	name:\"TestCloneMod\"\n	classID:#(0x3a4087e9, 0x2c2fdff7)\n	category:\"MXS Help\"\n(\n	parameters main rollout:params\n	(\n		nCopies ui:spn_nCopies default:2 type:#integer animatable:true\n		X_Offset ui:spn_X_Offset default:10 type:#float animatable:true\n		Y_Offset ui:spn_Y_Offset default:10 type:#float animatable:true\n		Z_Offset ui:spn_Z_Offset default:10 type:#float animatable:true\n	) \n\n	rollout params \"Parameters\"\n	(\n		spinner spn_nCopies \"# Copies:\" range:[1, 1000, 1] type:#integer\n		spinner spn_X_Offset \"X Offset:\" range:[-1000, 1000, 1] type:#float\n		spinner spn_Y_Offset \"Y Offset:\" range:[-1000, 1000, 1] type:#float\n		spinner spn_Z_Offset \"Z Offset:\" range:[-1000, 1000, 1] type:#float\n	) \n\n	on modifyMesh do\n	(\n		local inMesh = copy mesh --make a copy of the incoming mesh\n		for n = 2 to nCopies do --repeat N-1 times \n		(\n			local currentMesh = copy inMesh --copy the incoming mesh value\n			meshop.moveVert currentMesh #{1..currentMesh.numverts} ([X_Offset,Y_Offset,Z_Offset]*(n-1))\n			mesh = mesh + currentMesh --accummulate the moved value into the output mesh\n		)\n	)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-0436AE6F-30C8-4481-A70D-F14B511C6BFC\"></a> The above example implements a simple linear clone modifier. It contains four parameters\n            - the number of copies to create and the offset along each of the three axes. \n            	 \n         </p>\n         <p><a name=\"GUID-0EAC2465-5A9B-4662-8905-D50CB87BBE18\"></a> The on \n            		<span class=\"code\">modifyMesh</span> do handler is called whenever the modifier\'s output requires an update. The internal\n            \n            		<span class=\"code\">mesh</span> value is set to the incoming TriMesh from the stack. The script creates a local copy\n            of this TriMesh. Then it loops N-1 times, copies the TriMesh copy again and moves\n            all its vertices according to the offset values multiplied by the number of copies\n            minus 1. Finally, the resulting offset copy of the incoming mesh is added to the internal\n            mesh value. At the end of the handler, the mesh value contains the original TriMesh\n            plus all the copies accummulated into one. \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5236\"></a> <span class=\"char_link\"><a href=\"GUID-44D4AC45-65DD-401B-B4A1-07B71B35D544.htm\">Updating Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5235\"></a> <span class=\"char_link\"><a href=\"GUID-DB36699E-7589-4C38-97C2-A04F093C6789.htm\">Scripted Plug-in Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5234\"></a> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Scripted Plug-in Clauses</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5233\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5232\"></a> <span class=\"char_link\"><a href=\"GUID-9383EF8E-819E-4C4A-B60B-D69C1FEAC54F.htm\">Scripted Geometry Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"GUID-E1246319-E9DF-4D61-B5BC-7059909863F1\"></a> <span class=\"char_link\"><a href=\"GUID-3FB57157-0112-4617-9532-014B9CECC98E.htm\">Scripted SimpleMod Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"GUID-CCB8182A-2984-4F66-8BEA-996177CA88AC\"></a> <span class=\"char_link\"><a href=\"GUID-E91909AD-28D5-4AEF-8C6C-2EF2AC0C78AF.htm\">Scripted Modifier Plug-ins</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";