var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-7B4262BD-FE95-4DAF-894B-284A92100171\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ActiveX Array Properties\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ActiveX Array Properties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7B4262BD-FE95-4DAF-894B-284A92100171\"></a><div class=\"head\">\n            <h1>ActiveX Array Properties </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B40\"></a> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75AF\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B3A\"></a> <img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\"> ActiveX Controls have been deprecated by Microsoft in the latest versions of the\n                     Windows operating system in favor of the <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet</a></span> framework and its controls. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B39\"></a>While MAXScript still supports ActiveX controls, these have to be installed and registered\n                     on the system to be accessible to MAXScript. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B38\"></a>As a replacement of ActiveX controls, MAXScript supports <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet controls</a></span> in <em class=\"strong\">3ds Max 9 and higher</em>. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B35\"></a>To see whether an ActiveX property is an array, you can check for a hidden \"_newEnum\"\n               property. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B34\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B33\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-711E\"></a><pre>\nlocal an_array\ntry\n(\nget Property rListView.ax.listItems #_newEnum; an_array = true\n)\ncatch\n(\nan_array = false\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B26\"></a> \n            <h2><a name=\"GUID-1E296084-2087-443E-B650-CC4246A9366D\"></a> <em class=\"strong\">Properties which return arrays can be iterated</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B25\"></a>For example, .<span class=\"code\"> <em class=\"strong\">listItems</em> </span> in the ListView control, returns IListItems. This can be looped through and also\n               indexed. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-711D\"></a><pre>for li in ax<em class=\"codeEmphasisStrong\">.listItems</em> do li.bold = true</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B23\"></a>or \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-711C\"></a><pre>ax.<em class=\"codeEmphasisStrong\">listItems[1].</em>text = \"foo\"</pre></div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B20\"></a> <span class=\"char_link\"><a href=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA.htm\">ActiveX Controls in MAXScript Rollouts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";