var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-7B6E4693-2CE3-4A42-829C-9E668C671676\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"timeStamp()\">\n      <meta name=\"indexterm\" content=\"time stamping\">\n      <meta name=\"indexterm\" content=\"timeGetTime()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Time Stamping</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7B6E4693-2CE3-4A42-829C-9E668C671676\"></a><div class=\"head\">\n            <h1>Time Stamping </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13C5\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13C4\"></a>  The <span class=\"code\"> <em class=\"strong\">timeStamp()</em> </span> and timeGetTime() functions give the time-of-day resp. the time since Windows started\n               in milliseconds. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6830\"></a><pre><em class=\"codeEmphasisStrong\">timeStamp</em>()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13BF\"></a>The function returns the number of milliseconds since 00:00 hours that day. This is\n               useful for timing operations (presuming you are not timing across midnight.) \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13BE\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-13BD\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-682F\"></a><pre>\nstart = timeStamp()\nprocess_mesh() -- do some big job\nend = timeStamp()\nformat \"Processing took % seconds\\n\" ((end - start) / 1000.0)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-3530E5D7-4471-4107-B85F-0AE4A0E61471\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_4A22AA183E644104A3D192F81E078A05\"></a>  \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">timeGetTime</em>()</pre></div> \n            <p><a name=\"GUID-C11454C6-6661-4810-838D-8F009E832327\"></a>The function retrieves the system time in milliseconds. The system time is the time\n               elapsed since Windows was started. \n            </p> \n            <p><a name=\"GUID-8638935F-A1CD-4174-9981-6D14BE291918\"></a>The return value wraps around to 0 every 2^32 milliseconds, which is about 49.71 days.\n               \n            </p> \n            <p><a name=\"GUID-335BE64B-8008-48A4-9444-058DF0BFAB5D\"></a>This can cause problems in code that directly uses the <span class=\"code\"> <em class=\"strong\">timeGetTime()</em> </span> return value in computations, particularly where the value is used to control code\n               execution. \n            </p> \n            <p><a name=\"GUID-978B5D5A-D6E3-4FC8-BAB0-542F5266808E\"></a>You should always use the difference between two timeGetTime return values in computations.\n               \n            </p> \n            <p><a name=\"GUID-04337ED4-B727-430A-B3A2-D5C6EA988B8D\"></a>Available in <em class=\"strong\">3ds Max 2014 and higher</em>. \n            </p> \n            <p><a name=\"GUID-FA4467BD-7F09-43D4-AD4B-3F0DED8392AC\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";