var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-7C1FC5F5-58C3-48FA-84F8-B6F4B4A70239\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Make It Faster?\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Only calculate once if possible</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7C1FC5F5-58C3-48FA-84F8-B6F4B4A70239\"></a><div class=\"head\">\n            <h1>Only calculate once if possible </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1365\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1367\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1368\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-0030AA3F-47D9-4FDD-8517-5F7902884B37.htm\">How To Make It Faster</a></span> &gt; Only calculate once if possible \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC136B\"></a>MAXScript does no code optimization. You must do your own optimizations. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC136C\"></a>Try to avoid running the same calculation more than once, or interrogating the same\n            value in the same node more than once. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC136E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC136F\"></a><p class=\"table-body\"> <em class=\"strong\">TEST CASE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6629\"></a><pre>\nfn test4a inVal =\n(\nlocal res = 0\nfor i = 1 to 100 do res += ((inVal * 10) + i)\nres\n)\n--show the same nice black-red gradient\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6628\"></a><pre>\nfn test4b inVal =\n(\nlocal res = 0\nlocal temp = inVal * 10\nfor i = 1 to 100 do res += (temp + i)\nres\n)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1382\"></a><p class=\"table-body\"> <em class=\"strong\">FOR 100,000 ITERATIONS:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6627\"></a><pre>\ntest4a 0&nbsp;&nbsp;&nbsp;-- 20562 msec.\ntest4b 0&nbsp;&nbsp;&nbsp;-- 17797 msec.\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1388\"></a>In another example, a typical example of a script that you want to be as fast as possible\n            is a Particle Flow Script Operator. In a typical Script Operator, you usually go through\n            all particles in the Particle Container of the current Event and perform some operations\n            on each one of them. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1389\"></a>The Proceed handler typically looks like the following: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC138A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC138B\"></a><p class=\"table-body\"> <em class=\"strong\">GOOD CODE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6626\"></a><pre>\non Proceed pCont do\n(\ncount = pCont.NumParticles()\nfor i in 1 to count do\n(\npCont.particleIndex = i\npCont.particleVector = pCont.ParticlePosition\n)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1397\"></a>Note that the \'count\' variable containing the number of particles to be processed\n            is evaluated only once and then used as the top limit of the i loop. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1398\"></a>Writing the same as the following: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1399\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC139A\"></a><p class=\"table-body\"> <em class=\"strong\">BAD CODE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6625\"></a><pre>\non Proceed pCont do\n(\nfor i in 1 to pCont.NumParticles() do\n(\npCont.particleIndex = i\npCont.particleVector = pCont.ParticlePosition\n)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC13A5\"></a>This will be <em class=\"strong\">a bad idea</em> because in the case of 1 million particles, the expression <span class=\"code\">pCont.NumParticles()</span> will be evaluated 1 million times instead of just once. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC13A7\"></a> <em class=\"strong\">Previous Tip</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC13A8\"></a> <span class=\"char_link\"><a href=\"GUID-5ECE930B-32E0-42A7-9344-B9E0A2F73171.htm\">Never get a single pixel when you can get a whole line</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC13A9\"></a> <em class=\"strong\">Next Tip</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC13AA\"></a> <span class=\"char_link\"><a href=\"GUID-74BA7105-9907-4BB2-8C39-D9FD147C4898.htm\">Cache freqeuntly used functions and objects</a></span> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";