var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-7C65C77D-3C74-482B-ACC2-3D5D879DD99C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"or - Boolean\">\n      <meta name=\"indexterm\" content=\"not - Boolean\">\n      <meta name=\"indexterm\" content=\"logical expressions\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"indexterm\" content=\"and - Boolean\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Logical Expressions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7C65C77D-3C74-482B-ACC2-3D5D879DD99C\"></a><div class=\"head\">\n            <h1>Logical Expressions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86ECB\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86ECC\"></a>      <em class=\"strong\">Logical expressions</em> combine the results of Boolean expressions, such as comparisons, to construct complex\n               conditional expressions. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86ED2\"></a>The forms of a <span class=\"code\">&lt;logical_expr&gt;</span> are as follows: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-611E\"></a><pre>&lt;logical_operand&gt; <em class=\"codeEmphasisStrong\">or</em> &lt;logical_operand&gt; -- true if either operandis true\n&lt;logical_operand&gt; <em class=\"codeEmphasisStrong\">and</em> &lt;logical_operand&gt; -- true if both operands are true\n[ <em class=\"codeEmphasisStrong\">not</em> ] &lt;logical_operand&gt;-- true if operand is false</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86ED6\"></a>where <span class=\"code\"> <em class=\"strong\">&lt;logical_operand&gt;</em> </span> is one of the following: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-611D\"></a><pre>&lt;operand&gt;\n&lt;compare_expr&gt;\n&lt;function_call&gt;\n&lt;logical_expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EDB\"></a>Logical operators only operate on Boolean values, so each <span class=\"code\">&lt;logical_operand&gt;</span> must evaluate to <span class=\"code\"> <em class=\"strong\">true</em> </span> or <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86EDC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86EDD\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-611C\"></a><pre>\na &gt; 0 and a &lt; n + 1\nnot x and y\na and b or c and d and not e\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EE4\"></a>As with math expressions, <span class=\"code\">&lt;logical_expr&gt;</span> is a recursive definition, meaning a logical operand can be another logical expression.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EE5\"></a>You can have arbitrary sequences containing <span class=\"code\"> <em class=\"strong\">and</em> </span>, <span class=\"code\"> <em class=\"strong\">or</em> </span>, and <span class=\"code\"> <em class=\"strong\">not</em> </span>, and the order of evaluation is defined by the following precedence ordering (in\n               decreasing order of precedence): \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86EE6\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-611B\"></a><pre>not -- right associative</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-611A\"></a><pre>and -- left associative</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6119\"></a><pre>or -- left associative</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EEB\"></a>This means that in an unparenthesised logical expression, <span class=\"code\"> <em class=\"strong\">not</em> </span> is evaluated before <span class=\"code\"> <em class=\"strong\">and</em> </span> which is evaluated before <span class=\"code\"> <em class=\"strong\">or</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EEC\"></a>Logical operators have a lower precedence than comparison operators, math, and function\n               calls. Therefore, these operations are always evaluated before logical operators,\n               which follows convention. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EED\"></a>The previous examples would be evaluated in the following order: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86EEE\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6118\"></a><pre>(a &gt; 0) and (a &lt; (n + 1))\n(not x) and y\n(a and b) or ((c and d) and (not e))</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86EF6\"></a> <span class=\"char_link\"><a href=\"GUID-34349384-3978-4F17-8D45-326326909A35.htm\">Short-Circuiting Logical Expressions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-34349384-3978-4F17-8D45-326326909A35.htm\">Short-Circuiting Logical Expressions </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";