var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-7EAD66B1-29BE-4EC7-AC82-7D2831062856\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"scripted plug-ins\">\n      <meta name=\"indexterm\" content=\"Material: scripted plug-ins\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Material Plug-ins</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7EAD66B1-29BE-4EC7-AC82-7D2831062856\"></a><div class=\"head\">\n            <h1>Scripted Material Plug-ins </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-71D0\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FFB\"></a>  Scripted Material plug-ins can only extend existing Material plug-ins. \n            </p> \n            <p><a name=\"GUID-02037D81-421E-41AE-9A2A-AD80869CE16C\"></a>A scripted Material plug-in is declared by specifying the <span class=\"code\"> &lt;superclass&gt; </span> as <span class=\"code\"> <em class=\"strong\">material</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FF8\"></a>A scripted Material plug-in <em class=\"strong\">must have at least one rollout </em>defined. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FF7\"></a>In a scripted Material plug-in, Material and Map buttons that are associated with\n               a parameter in a parameter block do not call the button’s <span class=\"code\"> <em class=\"strong\">picked</em> </span> event handler. Instead, you should link the button to a parameter in a parameter\n               block, and use the <span class=\"code\"> <em class=\"strong\">set</em> </span> handler for the parameter. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FF5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FF4\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-718E\"></a><pre>\n-- this is a level 3 plug-in, the beginnings of a custom glass material.\n-- It extends Standard material and replaces its UI with a single\n-- rollout with 2 spinners and a color picker\nplugin material myGlass\nname:\"Supa Glass\"\nclassID:#(695425,446581)\nextends:Standard replaceUI:true version:1\n(\n  parameters main rollout:params\n  (\n    trans type:#float default:27 ui:trans\n    refrac type:#float default:1.5 ui:refrac\n    col type:#color default:blue ui:col\n    on trans set val do delegate.opacity = val\n    on refrac set val do delegate.ior = val\n    on col set val do delegate.diffuse_color = val\n  )\n  rollout params \"Glass Parameters\"\n  (\n    spinner trans \"Transparency: \" fieldwidth:45 offset:[-90,0]\n    spinner refrac \"Index of Refraction: \" fieldwidth:45 offset:[-90,0]\n    colorpicker col \"Base color: \" align:#center\n  )\n  on create do\n  (\n    -- setup initial material\n    delegate.opacityFalloff = 75\n  )\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FCD\"></a> <span class=\"char_link\"><a href=\"GUID-44D4AC45-65DD-401B-B4A1-07B71B35D544.htm\">Updating Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FCC\"></a> <span class=\"char_link\"><a href=\"GUID-DB36699E-7589-4C38-97C2-A04F093C6789.htm\">Scripted Plug-in Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FCB\"></a> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Scripted Plug-in Clauses</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FCA\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";