var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-8038109D-B71B-4685-8E78-E57333F3CA2C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"numNoteTracks() - Notetrack\">\n      <meta name=\"indexterm\" content=\"Notetrack Values\">\n      <meta name=\"indexterm\" content=\"hasNoteTracks() - Notetrack\">\n      <meta name=\"indexterm\" content=\"getNoteTrack() - Notetrack\">\n      <meta name=\"indexterm\" content=\"getNoteKeyTime() - Notetrack\">\n      <meta name=\"indexterm\" content=\"getNoteKeyIndex() - Notetrack\">\n      <meta name=\"indexterm\" content=\"deleteNoteTrack() - Notetrack\">\n      <meta name=\"indexterm\" content=\"addNoteTrack() - Notetrack\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Notetrack Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8038109D-B71B-4685-8E78-E57333F3CA2C\"></a><div class=\"head\">\n            <h1>Notetrack Values </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36E2\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36E1\"></a>         The following methods are related to creating, adding, deleting Note tracks. See <span class=\"char_link\"><a href=\"GUID-4A84696B-7541-4E8B-AA7A-7632849B824E.htm\">MAXNoteKeyArray Values</a></span> and <span class=\"char_link\"><a href=\"GUID-0901179E-E93C-4E0E-94B5-5BC479B3B056.htm\">MAXNoteKey Values</a></span> for information on accessing the contents of Note tracks. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36D7\"></a> <em class=\"strong\">Constructor</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DCE\"></a><pre><em class=\"codeEmphasisStrong\">notetrack</em> &lt;name_string&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36D5\"></a>Creates a new, empty note track with the specified name. The name is only used to\n               differentiate different note tracks in MAXScript but is not visible in <em class=\"strong\">3ds Max</em>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36D4\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DCD\"></a><pre>&lt;noteTrack&gt;.<em class=\"codeEmphasisStrong\">keys</em> MAXNoteKeyArray   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36D2\"></a>Contains an array of note keys. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DCC\"></a><pre>&lt;noteTrack&gt;.<em class=\"codeEmphasisStrong\">name</em> String </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36D0\"></a>Get/set the name of the note track. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36CF\"></a> <em class=\"strong\">Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DCB\"></a><pre><em class=\"codeEmphasisStrong\">getNoteKeyTime</em> &lt;notetrack&gt; &lt;index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36CD\"></a>Returns the time of indexed note key. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DCA\"></a><pre><em class=\"codeEmphasisStrong\">getNoteKeyIndex</em> &lt; notetrack &gt; &lt;time&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36CA\"></a>Returns the index of the note key at the specified time. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36C8\"></a> <em class=\"strong\">Associated Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DC9\"></a><pre><em class=\"codeEmphasisStrong\">addNoteTrack</em> &lt;MAXWrapper_object&gt; &lt;NoteTrack&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36C6\"></a>Adds a new note track to the MAXWrapper object. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DC8\"></a><pre><em class=\"codeEmphasisStrong\">deleteNoteTrack</em> &lt;MAXWrapper_object&gt; &lt;NoteTrack&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36C3\"></a>Deletes specified note track from the MAXWrapper object. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DC7\"></a><pre><em class=\"codeEmphasisStrong\">hasNoteTracks</em> &lt;MAXWrapper_object&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36C0\"></a>Returns true if the MAXWrapper object has note tracks, false otherwise. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DC6\"></a><pre><em class=\"codeEmphasisStrong\">numNoteTracks</em> &lt;MAXWrapper_object&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36BD\"></a>Returns the number of note tracks applied to the MAXWrapper object as an integer.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DC5\"></a><pre><em class=\"codeEmphasisStrong\">getNoteTrack</em> &lt;MAXWrapper_object&gt; &lt;index_integer&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36BA\"></a>Returns the indexed note track applied to the MAXWrapper object. Index is 1-based.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";