var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"tools\">\n      <meta name=\"indexterm\" content=\"on\">\n      <meta name=\"indexterm\" content=\"scripted mouse tools\">\n      <meta name=\"indexterm\" content=\"scripted mouse tool event handlers\">\n      <meta name=\"indexterm\" content=\"mouse tools - scripted\">\n      <meta name=\"indexterm\" content=\"tool\">\n      <meta name=\"indexterm\" content=\"startTool()\">\n      <meta name=\"indexterm\" content=\"stopTool()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Mouse Tools</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-80E8ADDC-F8A0-46F4-B909-4F39D5F37A29\"></a><div class=\"head\">\n            <h1>Scripted Mouse Tools </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5691\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5690\"></a>     Scripted Mouse Tools are used to perform a set of actions based on mouse clicks in\n               the <em class=\"strong\">3ds Max</em> viewports. Tools are useful for scripted object creation plug-ins, as described in\n               <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5689\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5688\"></a><p class=\"table-body\"> <em class=\"strong\">HERE IS A SIMPLE EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-725A\"></a><pre>\ntool foo\n(\nlocal b\non mousePoint clickno do\nif clickno == 1 then b = box pos:worldPoint else #stop\non mouseMove clickno do b.pos = worldPoint\n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-49D92FDB129CC323221-6416\"></a><p class=\"table-body\">This tool allows the user to click in a viewport at which point a box is created.\n                           Dragging the mouse positions the box and releasing the mouse button stops the tool.\n                           \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-567D\"></a><p class=\"table-body\"> <em class=\"strong\">YOU WOULD START THIS TOOL BY EXECUTING:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7259\"></a><pre>\nstartTool foo\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5679\"></a>The syntax for tools is similar to that for utility definition constructs. They have\n               local variables, functions, and event handlers, but tools have no user-interface items.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5678\"></a>A tool is created using the <span class=\"code\"> <em class=\"strong\">tool</em> </span> definition construct in MAXScript. The top-level syntax is as follows: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7258\"></a><pre><em class=\"codeEmphasisStrong\">tool</em> &lt;tool_name&gt; [ <em class=\"codeEmphasisStrong\">prompt</em>:&lt;string&gt; ] [ <em class=\"codeEmphasisStrong\">numPoints</em>:&lt;number&gt; ]<em class=\"codeEmphasisStrong\">(</em> &lt;tool_body&gt; <em class=\"codeEmphasisStrong\">)</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5676\"></a>where <span class=\"code\"> &lt;tool_name&gt; </span> is the name of an automatically created variable to hold the value that represents\n               the tool. The scope of this variable is the current MAXScript scope. This value is\n               also returned as a result of the <span class=\"code\"> <em class=\"strong\">tool</em> </span> declaration. The class of this value is <span class=\"code\"> <em class=\"strong\">MouseTool</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5675\"></a>The optional <span class=\"code\"> <em class=\"strong\">prompt:</em> </span> keyword argument specifies the prompt string displayed in the <em class=\"strong\">3ds Max</em> Prompt Line while the tool is executing. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5674\"></a>The optional <span class=\"code\"> <em class=\"strong\">numPoints:</em> </span> keyword argument specifies the maximum number of points (mouse clicks) the tool will\n               use. If the tool is still executing when you reach the <span class=\"code\"> <em class=\"strong\">numPoints</em> </span> number of mouse clicks, the tool will stop and return a value of <span class=\"code\"> <em class=\"strong\">#stop</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5673\"></a> <span class=\"code\"> &lt;tool_body&gt; </span> is enclosed in the required parentheses and is a sequence of clauses that define\n               the functions and event handlers that process mouse clicks. These clauses are defined\n               in detail in <span class=\"char_link\"><a href=\"GUID-619AF4D3-A347-4155-943B-707D421BC460.htm\">Mouse Tool Clauses</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5672\"></a>The following method invokes a tool: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7257\"></a><pre><em class=\"codeEmphasisStrong\">startTool</em> &lt;tool_name&gt; [<em class=\"codeEmphasisStrong\">prompt</em>:&lt;string&gt;] [<em class=\"codeEmphasisStrong\">snap</em>:<em class=\"codeEmphasisStrong\">#3D</em>|<em class=\"codeEmphasisStrong\">#2D</em>] [<em class=\"codeEmphasisStrong\">numPoints</em>:&lt;number&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5670\"></a>where <span class=\"code\"> &lt;tool_name&gt; </span> is the tool name used in a tool definition. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-566F\"></a>The optional <span class=\"code\"> <em class=\"strong\">prompt:</em> </span> keyword argument specifies the prompt string displayed in the <em class=\"strong\">3ds Max</em> Prompt Line while the tool is executing. If specified, this string overrides the\n               prompt string specified in the tool definition. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-566E\"></a>The optional <span class=\"code\"> <em class=\"strong\">snap:</em> </span> keyword argument specifies the upper limit on snapping. Specifying a <span class=\"code\"> <em class=\"strong\">snap</em> </span> parameter does not turn on snap, only the user can turn it on in the interface. When\n               2.5D or 3D snapping is turned on by the user, the <span class=\"code\"> <em class=\"strong\">snap</em> </span> parameter restricts snapping to the specified level. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-566D\"></a>The optional <span class=\"code\"> <em class=\"strong\">numPoints:</em> </span> keyword argument specifies the maximum number of points (mouse clicks) the tool will\n               use. If specified, this value overrides the number of points specified in the tool\n               definition. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-566C\"></a>The return value from <span class=\"code\"> <em class=\"strong\">startTool()</em> </span> will be either <span class=\"code\"> <em class=\"strong\">#stop</em> </span> if a called change handler returns the value <span class=\"code\"> <em class=\"strong\">#stop</em> </span> or the <span class=\"code\"> <em class=\"strong\">numPoints</em> </span> value is reached, or <span class=\"code\"> <em class=\"strong\">#abort</em> </span> if the user aborts the tool using a right-click or presses the ESC key. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-566B\"></a>A currently executing tool can also be aborted using the following method: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7256\"></a><pre><em class=\"codeEmphasisStrong\">stopTool</em> &lt;tool_name&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5669\"></a>where: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5668\"></a> <span class=\"code\"> &lt;tool_name&gt; </span> is the tool name used in a tool definition. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5667\"></a>This method would typically be called in a callback function or change handler (see\n               <span class=\"char_link\"><a href=\"GUID-1BE2E978-72CF-495C-81D6-2B36E2C4FFC7.htm\">Change Handlers and Callbacks</a></span>), or in a timer event handler in a rollout (see <span class=\"char_link\"><a href=\"GUID-9A4F0A09-BB42-4EED-95CC-6B3D06939640.htm\">Timer</a></span>). \n            </p> \n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-619AF4D3-A347-4155-943B-707D421BC460.htm\">Mouse Tool Clauses </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";