var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-8395020C-E3B6-4282-AF1C-5B58BDB97A24\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"PathName: literals\">\n      <meta name=\"indexterm\" content=\"object path names\">\n      <meta name=\"indexterm\" content=\"literals\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Pathname Literals</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8395020C-E3B6-4282-AF1C-5B58BDB97A24\"></a><div class=\"head\">\n            <h1>Pathname Literals </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86CED\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86CEE\"></a>    <span class=\"char_link\"><a href=\"GUID-1C428A1F-3638-4DAC-812C-C6EBAE2100A8.htm\">Names</a></span> identify entities such as variables and parameters inside the running MAXScript program.\n               If you want to identify objects by name in the <em class=\"strong\">3ds Max</em> scene, you use a pathname. Pathnames can name a single object in the scene, specify\n               a particular object using a path through the object hierarchy, or name sets of objects\n               using pattern matching. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86CF2\"></a>The full syntax for a pathname literal is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6157\"></a><pre>&lt;path_name&gt; ::= <em class=\"codeEmphasisStrong\">$</em>&lt;path&gt; | <em class=\"codeEmphasisStrong\">$</em> \n&lt;path&gt; ::= [ &lt;objectset&gt; ] [ <em class=\"codeEmphasisStrong\">/</em> ] [ &lt;levels&gt; ] &lt;level_name&gt; \n&lt;levels&gt; ::= &lt;level&gt; { <em class=\"codeEmphasisStrong\">/</em> &lt;level&gt; } \n&lt;level&gt; ::= &lt;level_name&gt;\n</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6156\"></a><pre>&lt;level_name&gt; ::= { &lt;alphanumeric &gt; | <em class=\"codeEmphasisStrong\">_</em> | <em class=\"codeEmphasisStrong\">*</em> | <em class=\"codeEmphasisStrong\">?</em> | <em class=\"codeEmphasisStrong\">\\</em> }\n<em class=\"codeEmphasisStrong\">\'</em>{ &lt;alphanumeric &gt; | <em class=\"codeEmphasisStrong\">_</em> | <em class=\"codeEmphasisStrong\">*</em> | <em class=\"codeEmphasisStrong\">?</em> | <em class=\"codeEmphasisStrong\">\\</em> }<em class=\"codeEmphasisStrong\">\'</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86CF5\"></a>The root of a <span class=\"code\"> &lt;path&gt; </span> can be an <span class=\"code\"> &lt;objectset&gt; </span>, which limits the pathname searching to the object set you specify. ObjectSets are\n               described in <span class=\"char_link\"><a href=\"GUID-77CB1890-C949-43AC-B1E9-B37F97B6712D.htm\">ObjectSet Values</a></span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CF7\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86CF8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6155\"></a><pre>\n$box01 -- object named \'box01\'\n$torso/left_up_arm/left_low_arm -- hierarchy path name\n$*box* -- all objects with \'box\' in\n-- the name\n$torso/* -- all the direct children of\n-- $torso\n$helpers/d* -- all helper objects whose name starts with \'d\'\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D02\"></a>All objects in a <em class=\"strong\">3ds Max</em> scene are arranged in a hierarchy as presented in Track View. This is both an important\n               organizing scheme in <em class=\"strong\">3ds Max</em>, and it suggests a MAXScript naming scheme for objects based on the path to an object\n               through the hierarchy. It is also very similar to path names in an operating system\'s\n               directory structure. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D03\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D04\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6154\"></a><pre>$dummy/head/neck</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D08\"></a><p class=\"table-body\">names the scene object <span class=\"code\"> <em class=\"strong\">neck</em> </span> whose parent is object <span class=\"code\"> <em class=\"strong\">head</em> </span>, which has the top-level parent object <span class=\"code\"> <em class=\"strong\">dummy</em> </span>. This pathname helps you identify a specific object in a <em class=\"strong\">3ds Max</em> scene, even if several objects have the same name. If <span class=\"code\"> <em class=\"strong\">head</em> </span> is unique in the scene, MAXScript lets you use the shorthand <span class=\"code\"> <em class=\"strong\">$head</em> </span> to refer to it regardless of its hierarchy position. Even if the object is not uniquely\n                           named you can use the shorthand form, but it is undetermined which of the same-named\n                           objects you will get. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D0A\"></a>Pathnames also provide a powerful way to refer to several objects at once, such as\n               all the children of a certain parent, or all the objects with names containing the\n               string <span class=\"code\"> <em class=\"strong\">foot</em> </span>. For this, you can use <em class=\"strong\">wild-card patterns</em>, as you can with operating system shell file naming schemes. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D0B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D0C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6153\"></a><pre>$dummy/*</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D10\"></a><p class=\"table-body\">names all the immediate children of <span class=\"code\"> <em class=\"strong\">dummy</em> </span>. The <span class=\"code\"> <em class=\"strong\">\"*\"</em> </span> character is used as a wild card. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6152\"></a><pre>$neck*</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D14\"></a><p class=\"table-body\">finds all the objects, whose names start with the string <span class=\"code\"> <em class=\"strong\">neck</em> </span>, anywhere in the hierarchy. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D16\"></a>You can use <em class=\"strong\">wild cards</em> anywhere in a pathname. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D17\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D18\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6151\"></a><pre>$*foot*</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D1B\"></a><p class=\"table-body\">finds all the objects with <span class=\"code\"> <em class=\"strong\">foot</em> </span> anywhere in their names. The <span class=\"code\"> <em class=\"strong\">\"*\"</em> </span> wild-card character effectively matches any number other characters. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D1D\"></a>You can also use the <em class=\"strong\">\"?\"</em> wild-card character to match exactly one \"don\'t care\" character. This is, the <em class=\"strong\">\"?\"</em> wild-card character will match any single character. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D1E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D1F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6150\"></a><pre>$box0?</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D22\"></a><p class=\"table-body\">finds all the objects that begin with <span class=\"code\"> <em class=\"strong\">box0</em> </span> and have exactly one character after the <span class=\"code\"> <em class=\"strong\">0</em> </span> in their names. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D24\"></a>Wild-card characters can also be used for specifying parent levels in a hierarchy.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D25\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D26\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-614F\"></a><pre>$dummy/*/*</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D29\"></a><p class=\"table-body\">names all the children of all the children of<span class=\"code\"> <em class=\"strong\"> $dummy</em> </span>. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D2B\"></a>If you want to find an object and all the children of the object at any nested level,\n               you use the special ellipsis level name \"...\", \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D2C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D2D\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-614E\"></a><pre>$dummy/.../box*</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D30\"></a><p class=\"table-body\">names all the children of all the children of <span class=\"code\"> <em class=\"strong\">$dummy</em> </span>. \n                        </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D31\"></a><p class=\"table-body\">This refers to <span class=\"code\"> <em class=\"strong\">$dummy</em> </span> and all the <span class=\"code\"> <em class=\"strong\">box*</em> </span> children at any level below <span class=\"code\"> <em class=\"strong\">$dummy</em> </span>. The <span class=\"code\"> <em class=\"strong\">\"...\" </em> </span>indicates to search the entire hierarchy below the level of the ellipsis. MAXScript\n                           lets you omit the \"/\" when using \"...\" because it is unambiguous: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-614D\"></a><pre>$dummy...box*</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D34\"></a><p class=\"table-body\">Or, in another common example, </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-614C\"></a><pre>$dummy...*</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D37\"></a><p class=\"table-body\">names <span class=\"code\"> <em class=\"strong\">$dummy</em> </span> and all the children of <span class=\"code\"> <em class=\"strong\">$dummy</em> </span> at any level. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D39\"></a>If you use a wild card in an object pathname MAXScript will manipulate all matching\n               objects at one time. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D3A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D3B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-614B\"></a><pre>hide $*foot*</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D3E\"></a><p class=\"table-body\">hides all objects whose names contain <span class=\"code\"> <em class=\"strong\">foot</em> </span>. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D40\"></a>You can also perform automatic collection mapping, where a property for each matching\n               object is set. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D42\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D43\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-614A\"></a><pre>$*box*.position += [10, 10, 0]</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D46\"></a><p class=\"table-body\">adds <span class=\"code\"> <em class=\"strong\">[10,10,0]</em> </span> to the positions of all scene objects whose names contain <span class=\"code\"> <em class=\"strong\">box</em> </span>. For more information, see <span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collections</a></span>. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D48\"></a>You can use a shorthand form for specifying the currently selected object or objects\n               with the pathname syntax. A lone \"$\" character refers to either the currently selected\n               object if a single object is selected, the current selection set as an ObjectSet if\n               more than one object is selected, or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if no objects are selected. This is a useful shorthand for use in the Listener when\n               working on selections. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D49\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86D4A\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6149\"></a><pre>$.pos = [0,0,0]\nhide $\nrotate $ 35 z_axis</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1937\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D53\"></a>Inside a script, it is better to use the <span class=\"code\"> <em class=\"strong\">selection</em> </span> ObjectSet rather than <span class=\"code\"> <em class=\"strong\">$</em> </span>. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D54\"></a> <span class=\"code\"> <em class=\"strong\">selection</em> </span> always contains an ObjectSet regardless of the number of selected objects. Where\n                     <span class=\"code\"> <em class=\"strong\">hide $</em> </span> will generate an error if no objects are selected (because <span class=\"code\"> <em class=\"strong\">$</em> </span> contains the value <span class=\"code\"> <em class=\"strong\">undefined</em> </span>), <span class=\"code\"> <em class=\"strong\">hide selection</em> </span> will not generate an error. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D55\"></a>Due to the way that <em class=\"strong\">3ds Max</em> internally processes notification signals, the <span class=\"code\"> <em class=\"strong\">$</em> </span> form of accessing selected objects is <em class=\"strong\">not recommended</em> in a <span class=\"code\"> <em class=\"strong\">select</em> </span> change handler. To access the selected objects, you should use the <span class=\"code\"> <em class=\"strong\">selection</em> </span> ObjectSet. This is because <span class=\"code\"> <em class=\"strong\">$</em> </span> relies on information that has not yet been set in the selection processing whereas\n                     <span class=\"code\"> <em class=\"strong\">selection</em> </span> uses a different method of accessing selections and the information it uses has been\n                     set up. \n                  </p> \n               </div>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D58\"></a> <span class=\"char_link\"><a href=\"GUID-0EB95212-EEC7-424F-A538-09C57E63AF41.htm\">Spaces and Other Special Characters in Pathnames</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D59\"></a> <span class=\"char_link\"><a href=\"GUID-77CB1890-C949-43AC-B1E9-B37F97B6712D.htm\">ObjectSet Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86D5A\"></a> <span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collections</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";