var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-843369B8-EA84-4C5F-8316-247A8465B4DE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NetworkManager Interface\">\n      <meta name=\"indexterm\" content=\"Interface NetworkManager\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: NetworkManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-843369B8-EA84-4C5F-8316-247A8465B4DE\"></a><div class=\"head\">\n            <h1>Interface: NetworkManager </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B57\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B56\"></a><p class=\"table-body\">   <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; NetworkManager \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B55\"></a>The <em class=\"strong\">NetworkManager Interface</em> exposes a method to send email messages via MAXScript. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B54\"></a>Available in <em class=\"strong\">3ds Max 2009 and higher</em>. \n         </p>\n         <p><a name=\"GUID-278A5992-A59C-4396-A176-7581D6CBC243\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B53\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5731\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">NetworkManager.Send</em> &lt;string&gt;to &lt;string&gt;from &lt;string&gt;subject &lt;string&gt;body &lt;string&gt;server 	 </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B52\"></a>Sends an email message. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B51\"></a>The first argument is the address to send to. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B50\"></a>The second argument is the address the message is sent from. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B4F\"></a>The third argument is the subject of the message. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B4E\"></a>The fourth argument is the body of the message. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B4D\"></a>The fifth argument is the email server to use to send the message. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B4C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7B4B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5730\"></a><pre>\n(\ntheAddress = \"youremail@yourcompany.com\"\ntheSender = \"myemail@mycompany.com\"\ntheSubject = \"Greetings from 3ds Max!\"\ntheBody = \"This email was sent by MAXScript\\n\"\ntheBody += \"from inside of 3ds Max!\\n\\n\"\ntheBody += \"Cool, eh?\"\ntheServer = \"smtp.myprovider.net\"\nres = NetworkManager.Send theAddress theSender theSubject theBody theServer\nif res then\nmessagebox (\"Email sent successfully to \" + theAddress)\nelse\nmessagebox (\"Failed to send email to \" + theAddress)\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";