var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-846B6AB0-EFF6-43E5-8A67-8D348FF78A57\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"executing external commands\">\n      <meta name=\"indexterm\" content=\"DOSCommand()\">\n      <meta name=\"indexterm\" content=\"shellLaunch()\">\n      <meta name=\"indexterm\" content=\"HiddenDOSCommand()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Executing External Commands</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-846B6AB0-EFF6-43E5-8A67-8D348FF78A57\"></a><div class=\"head\">\n            <h1>Executing External Commands </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1469\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1468\"></a>  MAXScript provides several methods for executing external programs \n            </p> \n            <p><a name=\"GUID-3671EE5E-BB28-4992-AC32-5312E16E37C9\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6848\"></a><pre><em class=\"codeEmphasisStrong\">DOSCommand</em> &lt;command_string&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1463\"></a>Takes a DOS command as a string and send it to the system for execution. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1462\"></a>You can use this function to launch other programs, or perform such tasks as gathering\n               all the material texture and displacement image files in your scene into one folder.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1461\"></a>Returns an integer which is the status result returned by the executed system command.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-145F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-145E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6847\"></a><pre>\nDOSCommand \"delete c:\\\\temp\\\\foo.dat\"\nDOSCommand (\"copy \" + source_file + \" \" + dest_folder)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-30C4D3C1-E3F9-47DB-B145-5A2345FA957B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6846\"></a><pre><em class=\"codeEmphasisStrong\">ShellLaunch</em> &lt;filename_string&gt; &lt;parameters_string&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1456\"></a>  <span class=\"code\"> <em class=\"strong\">ShellLaunch()</em> </span> emulates the double-clicking on a specified file in Windows. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1455\"></a>Whatever you send to ShellLaunch will be run by the Windows shell automatically. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1454\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1453\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6845\"></a><pre>\nShellLaunch \"E:\\\\tests\\\\lookup.html\" \"\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-144F\"></a><p class=\"table-body\">would launch the default Web Browser with lookup.html. </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-144D\"></a>If a filenameextensionis not specified in <span class=\"code\"> <em class=\"strong\">&lt;filename_string&gt;</em> </span>, Windows will search the specified directory for executable files. If no directory\n               is specified, Windows will search the paths in the Path environment variable for the\n               executable file. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-144C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-144B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6844\"></a><pre>\nshellLaunch \"e:/program files/ucalc/ucalc\" \"\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1447\"></a><p class=\"table-body\">will execute the ucalc.exe file in the specified directory. </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1445\"></a>The <span class=\"code\"> <em class=\"strong\">&lt;parameters_string&gt;</em> </span> is passed to the launched application as command line parameters. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1444\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1443\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6843\"></a><pre>\nshellLaunch \"e:/t.avi\" \"/play /loop\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-143F\"></a><p class=\"table-body\">will launch the application associated with .avi files, and pass <span class=\"code\"> <em class=\"strong\">/play</em> </span> and <span class=\"code\"> <em class=\"strong\">/loop</em> </span>as command line parameters. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-143D\"></a>Instead of launching a file with the default application registered for the given\n               file type, the application to be launched can be passed as the first argument and\n               the file to be opened as the second.This will pass the second argument as parameter\n               to the application specified by the first argument. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-143C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-143B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6842\"></a><pre>\nShellLaunch \"iexplorer.exe\" @\"c:\\temp\\report.html\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1437\"></a><p class=\"table-body\">will launch the page report.html with the Internet Explorer, </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6841\"></a><pre>\nShellLaunch \"firefox.exe\" @\"c:\\temp\\report.html\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1433\"></a><p class=\"table-body\">while the above will launch the same page in Mozilla Firefox. </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1431\"></a>The same approach can be used tonavigate to a specific path usingWindows Explorer.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1430\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-142F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6840\"></a><pre>\nShellLaunch @\"c:\\windows\\\" \"\"\nShellLaunch \"explorer.exe\" @\"c:\\windows\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-142A\"></a><p class=\"table-body\">Both expressions will open Windows Explorer at the Windows root folder. </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-683F\"></a><pre>\nShellLaunch \"explorer.exe\" \"/e,/select,\\\"c:\\\\windows\\\\notepad.exe\\\"\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1426\"></a><p class=\"table-body\">The above expression will open Windows Explorer at the file notepad.exe inside the\n                           Windows root directory. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-828FF62B-6FFC-4C32-8B60-543228FE84CF\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-683E\"></a><pre><em class=\"codeEmphasisStrong\">HiddenDOSCommand</em> &lt;command string to execute&gt; [  <em class=\"codeEmphasisStrong\">startpath</em>:unsupplied] [  <em class=\"codeEmphasisStrong\">prompt</em>:unsupplied] [  <em class=\"codeEmphasisStrong\">donotwait</em>:false] [  <em class=\"codeEmphasisStrong\">ExitCode</em>:&amp;variable] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1422\"></a>  <em class=\"strong\">[</em>AVG<em class=\"strong\">]</em> <span class=\"code\"> <em class=\"strong\"> HiddenDOSCommand()</em> </span> looks like <span class=\"code\"> <em class=\"strong\">DOSCommand()</em> </span>, but runs more like <span class=\"code\"> <em class=\"strong\">ShellLaunch()</em> </span>. It launches a DOS command in a hidden window. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1421\"></a> \n               <h3><a name=\"GUID-8067EB33-092D-4146-93CB-FC3C3166A76C\"></a> <em class=\"strong\">startpath:</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1420\"></a>Allows you to set the starting folder for the command. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-141F\"></a>In versions prior to <em class=\"strong\">3ds Max 2010</em>, omitting this optional argument resulted in function failure. This has been corrected\n                  in <em class=\"strong\">3ds Max 2010</em>. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-141E\"></a> \n               <h3><a name=\"GUID-C36DAA98-1E48-4179-9AE3-9EE07A65ABD6\"></a> <em class=\"strong\">prompt:</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-141D\"></a>Allows you to set the prompt that appears on the Max prompt line (just below the viewports).\n                  If you don\'t change it, the command string is displayed. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-141C\"></a> \n               <h3><a name=\"GUID-076393F9-BCFE-4492-B1B1-F0E9FA835FAA\"></a> <em class=\"strong\">donotwait:</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-141B\"></a>Allows you to decide whether or not you want to return control to back to MAXScript\n                  while the command runs, or wait for completion.Default is false, which results in\n                  blocking MAXScript execution until the command has finished. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-141A\"></a> \n               <h3><a name=\"GUID-D8DCB4D6-16BD-47BD-9CD1-DCC475799836\"></a> <em class=\"strong\">ExitCode:</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1419\"></a>If <span class=\"code\"> <em class=\"strong\">donotwait:</em> </span> is unsupplied or false and the command is executed successfully, the exit code of\n                  the command is written to the specified variable as an integer value.An exit code\n                  of 0 means the command was executed without errors, non-zero code usually means an\n                  error. Available in <em class=\"strong\">3ds Max 2010 and higher</em>. \n               </p> \n               <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-754F\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                     <p><a name=\"GUID-0CA60705-CB99-4D3F-9BFE-A8C5A1D2C1EC\"></a>You must redirect any output generated to a file if you are interested in text that\n                        would normally be printed to the console. \n                     </p> \n                  </div>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1413\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1412\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE USAGE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-683D\"></a><pre>\nHiddenDOSCommand \"dir &gt; %temp%\\\\hiddencmdout.tmp\" startpath:\"c:\\\\\"\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-683C\"></a><pre>\ncmd = \"echo The time is \" + localTime + \" &gt;&gt; %temp%\\\\hiddencmdout.tmp\"\nHiddenDOSCommand cmd startpath:\"c:\\\\\"\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-683B\"></a><pre>\nHiddenDOSCommand \"notepad %temp%\\\\hiddencmdout.tmp \"prompt:\"Waiting for Notepad to exit\" startpath:\"c:\\\\\"\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-683A\"></a><pre>\nHiddenDOSCommand \"del hiddencmdout.tmp\" donotwait:true startpath:\"c:\\\\\"\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6839\"></a><pre>\nmakeDir \"C:\\\\doscmdtest\\\\\"\nstr = \"rmDir C:\\\\doscmdtest\\\\\"\nhiddendoscommand str startpath:\"$max\" exitCode:&amp;exitcode\nexitcode --&gt; 0\nhiddendoscommand str startpath:\"$max\" exitCode:&amp;exitcode\nexitcode --&gt; 2 (error since directory does not exist anymore)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6838\"></a><pre>\n--(Source for HiddenDOSCommand provided by Mike BiddleCombe)\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";