var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-84F3CD2D-9BAB-4FAB-8E00-567428C04619\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Flying Letters from a Custom String\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Flying Letters from a Custom String</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-84F3CD2D-9BAB-4FAB-8E00-567428C04619\"></a><div class=\"head\">\n            <h1>Flying Letters from a Custom String </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849EB\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849EC\"></a>The following example uses a Script Operator to assign a single letter to each particle\n            based on a scene text objects. You can type in any text you want, define the font\n            and change the appearance of the text using modifiers like Extrude and Bevel and let\n            Particle Flow generate a stream of letters showing the text. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849ED\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849EE\"></a>The scripts should be used inside a <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator</a></span>. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849EF\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-ACE8921B-62AD-4C6D-9040-D6F2BE2897D4-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849F0\"></a> <em class=\"strong\">Effect:</em> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849F1\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849F3\"></a>The example uses a unique scene text object (with any modifiers on top) as instanced\n                  source. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849F5\"></a>The script makes copies of the source text and replaces the original text with a single\n                  letter from the text.This means that you can create any appearance (like for example\n                  adding custom Bevel to the source) and the particle system will inherit these settings.\n                  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849F7\"></a>Changing the Text of the Font of the Source and scrubbing the time back will automatically\n                  update the particle system. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849F9\"></a>Deleted letters from the scene will be detected and the particle system will regenerate\n                  to bring them back. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E849FB\"></a>If the source object was removed, a new default text with extrude modifier will be\n                  created in the scene with the string \"Enter Text Here\" and renderable flag set to\n                  false. This means that you can start from scratch using this text object and edit\n                  its font,text and stack to get the look you want. \n               </p> \n            </li>\n         </ul>\n         <div><a name=\"WS1A9193826455F5FF745FE04F12A3260983E-7F6B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"GUID-DCB38AA3-DF9B-4330-A179-96C891F320C0\"></a>The source object must be a text object with some meshing modifier on top. Do not\n                  collapse the stack to EMesh as the script needs access to the text baseobject\'s font\n                  and text properties! \n               </p> \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A02\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A04\"></a>You have to disable any Caches when changing the appearance in order to see the new\n                  look. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A06\"></a>You can change the timing of the Birth operator to get more particles if your text\n                  is longer than the default \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A08\"></a>You can use any other PFlow operators to affect the particles. The Script is only\n                  responsible for the shape of the particles. \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A0A\"></a>If you need multiple particle systems using the script, you should change the unique\n                  naming throughout the whole script to keep them apart. \n               </p> \n            </li>\n         </ul><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A0C\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-E49BB8FD-47E1-4C91-8A94-8F92774C404E-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A0F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84A10\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E0D\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do(\npCont.useShape = true --enable changes to the shape\n)\n \n--The Init handler is called on initialization.\n--In this case, it is used to define the string, font name\n--and create the text objects for every letter\n \non Init pCont do\n(\n--Define a global variable to store the array of letter objects\n--Use different unique ID if reusing the code\n--multiple times in the same scene\n \nglobal pflow_letter_array17b02b680\n \nlocal text_source = $PFlowText17b02b680\n \n--If the unique source is missing...\nif not isValidNode text_source do\n(\n--Create new text source object\ntext_source = text text:\"Enter Text Here\"\n--Give it the unique name - use a different ID\n--throughout the script if you need to use multiple\n--scripts in the same scene\ntext_source.name =\"PFlowText17b02b680\"\n--Add an extrude modifier to the text object\naddmodifier text_source (extrude amount:10)\n--make the source invisible to the renderer\ntext_source.renderable = false\n)\n--If the array has been initialized before...\nif pflow_letter_array17b02b680 != undefined do\n(\ntxtpos = 0\n--Go through all elements of the array\nfor i in pflow_letter_array17b02b680 do\n(\ntxtpos += 1\n--If any of the array nodes is invalid (deleted),\n--or the font does not match the source\'s font name,\n--or a letter does not match the letter in the source text,\n--reset the whole array so it can be reinitialized\nif not (isValidNode i) or i.font != text_source.font or i.text != (substring text_source.text txtpos 1) do\npflow_letter_array = undefined\n)\n)\n \n--If the array is newly created or reset (see above)\nif pflow_letter_array17b02b680 == undefined do\n(\n--Initialize to empty array\npflow_letter_array17b02b680 = #()\n--Get the string to display by the particle system from the\n--source text object in the scene. You can edit the\n--text\'s source to display any text you want!\n--Moving the time slider will update all letters!\nlocal str = text_source.text\n--Delete all possibly existing letter objects by name\ndelete $PFlow_Letter_17b02b680_*\n--Loop from 1 to the number of letters in the string\nfor i = 1 to str.count do\n(\n--Create a copy of the source object with\n--the i-th letter from the string\nletter = copy text_source\nletter.text = (substring str i 1)\n--Give the object a unique name\nletter.name = (uniquename\"PFlow_Letter_17b02b680_\")\n--Set the font to the font of the source\nletter.font = text_source.font\n--Append the new text object to the array\nappend pflow_letter_array17b02b680 letter\n--Hide the text object\nhide letter\n) \n) \n)\n \n--In the Proceed handler, we will assign the letters to the\n--available particles\n \non Proceed pCont do\n(\n--Get the current particle count\ncount = pCont.numParticles()\n--Get the number of text objects in the global array\nmaxcount = pflow_letter_array17b02b680.count\n--Create an empty mesh\nempty_mesh = triMesh()\n--Repeat for all particles\nfor i = 1 to count do\n(\n--Set the current particle index\npCont.particleIndex = i\n--If the particle index is less than the number of letters\nif i &lt;= maxcount then\n(\n--If the node is not deleted, set the particle shape\n--to the mesh of the i-th text object\nif isValidNode pflow_letter_array17b02b680[i] do\npCont.particleShape = pflow_letter_array17b02b680[i].mesh\n)\nelse\n(\n--If there is no letter for this particle,\n--set the shape to an empty mesh\npCont.particleShape = empty_mesh\n)\n)\n)\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n \n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A94\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A95\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";