var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-85AD190F-1A65-4BF2-8AE8-9688960B1ACC\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXScript Editor - Defining Custom Keywords</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-85AD190F-1A65-4BF2-8AE8-9688960B1ACC\"></a><div class=\"head\">\n            <h1>MAXScript Editor - Defining Custom Keywords </h1>\n         </div>\n         <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E17\"></a>The MAXScript-specific language settings of the <span class=\"char_link\"><a href=\"GUID-F561FC1E-CFF8-4FF6-874C-95EC4B9CD2CD.htm\">Tabbed MAXScript Editor</a></span> introduced in <em class=\"strong\">3ds Max 2008</em> can be customized by editing the file <em class=\"mild\">MAXScript.properties</em> located in the <em class=\"strong\">3ds Max</em> root folder to include user-defined keywords that are not part of the MAXScript language.\n            \n         </p>\n         <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E16\"></a>This could be used for example to highlight project-specific variable names etc. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E15\"></a> \n            <h2><a name=\"GUID-4B43902F-AF97-4618-A467-5798425BD1CF\"></a>Global Settings\n            </h2> \n            <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E14\"></a>To define custom keywords to be colorized in the source code of MAXScript files, follow\n               these steps: \n            </p> <a name=\"WS73099CC142F487558DF993412AF781CCF4-3E13\"></a><ul>\n               <li>Open the MAXScript Editor. </li>\n               <li>Create a new Script and enter in it: \"So long and thanks for all the fish.[New Line]\n                  Earth is mostly harmless\" \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E0F\"></a>The result should looks like this: \n                  </p> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E0E\"></a> <img src=\"../images/GUID-67E606C8-9FC7-4559-8751-CB0A786B9AE6-low.gif\"> \n                  </p> \n               </li>\n               <li>In the Tools menu of the Editor, select the item \"Open MAXScript.properties\" </li>\n               <li> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E0B\"></a>In the MAXScript.properties file, locate the section remarked with \n                  </p> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E0A\"></a>#keywords12 is for user defined words to be colorized. Keywords are checked for in\n                     this list first. \n                  </p> \n               </li>\n               <li>You can add keywords to the keywords12.$(file.pattern.MAXScript)= definition. Make\n                  sure to use \\ at the end of each new line. \n               </li>\n               <li>For example, enter the following words: <em class=\"strong\">so long thanks all the fish mostly harmless</em> \n               </li>\n               <li>Press <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">S</span></em> to save the file MAXScript.properties. \n               </li>\n            </ul> \n            <div><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E06\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If you don\'t have enough access rights to save the file to the root folder of <em class=\"strong\">3ds Max</em> due to the User Account Control (UAC) settings of your Windows OS, please see the\n                  <span class=\"char_link\"><a href=\"GUID-C8B2716A-A8C0-446F-BE44-A8CB948B5CA8.htm\">Local User Settings</a></span> section further on this page. \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E05\"></a>The resulting formatting should look something like this: \n            </p> \n            <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E04\"></a> <img src=\"../images/GUID-B72345D1-E1E3-4581-849E-7557BB49F7AE-low.gif\"> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E03\"></a> \n            <h2><a name=\"GUID-4217E35E-3FC1-4ACE-9F0C-2AE645F15D21\"></a> <em class=\"strong\">Modifying The Color And Style Of Custom Keywords</em> \n            </h2> \n            <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3E02\"></a>As you can see, the default color for user-defined keywords is red and the style is\n               bold italic. \n            </p> <a name=\"WS73099CC142F487558DF993412AF781CCF4-3E01\"></a><ul>\n               <li>This can be changed in the color definition of Keywords12 which can be found in the\n                  same MAXScript.properties file. \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DFE\"></a>Scroll down in the MAXScript.properties file and locate the lines \n                  </p> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DFD\"></a># Keywords12 - User defined \n                  </p> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DFC\"></a>style.MAXScript.23=fore:#FF0000,bold,italics \n                  </p> \n               </li>\n               <li>You can change this definition to give your own keywords the desired color and style.\n                  \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DF9\"></a>For example, remark the existing line using # and enter the following instead: \n                  </p> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DF8\"></a>style.MAXScript.23=fore:#0040F0,bold \n                  </p> \n               </li>\n               <li>Then press <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">S</span></em> to save. The result will be something like: \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DF6\"></a> <img src=\"../images/GUID-7B10324F-3063-4E19-9D72-37567D513164-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DF5\"></a>As mentioned in the remark to the keywords12 definition in the MAXScript.properties\n               file, keywords are ALWAYS checked for in the user-defined list before checking the\n               language-specific definitions (which in the case of MAXScript are exported automatically).\n               \n            </p> \n            <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DF4\"></a>In the above example, the keywords \"and\" and \"for\" are colorized as part of the language\n               (logical AND operation and FOR loop). If we would include them in our custom keywords\n               list, they would be colorized in brighter blue instead of dark blue and would override\n               the language-specific settings: \n            </p> \n            <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DF3\"></a> <img src=\"../images/GUID-8CDC46CC-7EB0-4DE1-BEB7-67E4C7D277DF-low.gif\"> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DF2\"></a> \n            <h2><a name=\"GUID-350EEB85-00B7-433B-83BE-84F70954A483\"></a> <em class=\"strong\">Local User Settings</em> \n            </h2> \n            <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DF1\"></a>On modern Operating Systems like Vista and Windows 7 with User Account Control (UAC)\n               enabled it might be impossible to modify the factory settings provided by the MAXScript.properties\n               file becase the file is located in the root of <em class=\"strong\">3ds Max</em>. For that reason, it is advisable to provide the custom settings using the \"User\n               Options File\" also available through the Tools menu of the Editor. \n            </p> <a name=\"WS73099CC142F487558DF993412AF781CCF4-3DF0\"></a><ul>\n               <li>If the file does not exist, it will be created automatically in the Local settings\n                  folders of the current user\'s account. The name of the file will be \"MXS_EditorUser.properties\"\n                  and it can override any settings normally found in the global \"MAXScript.properties\"\n                  file. \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DED\"></a>Copy the custom keywords definition and the color definition for keywords12 into this\n                     file and save it by pressing <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">S</span></em>: \n                  </p> \n                  <p><a name=\"WS73099CC142F487558DF993412AF781CCF4-3DEC\"></a> <img src=\"../images/GUID-311CEDE0-7C6F-4D04-8CBC-8B4376E7A402-low.gif\"> \n                  </p> \n               </li>\n               <li>The resulting colorization of user-defined keywords will be the same as in the examples\n                  above, but independent of the <em class=\"strong\">3ds Max</em> installation. For example, reinstalling <em class=\"strong\">3ds Max</em> but preserving the Local User settings will also preserve all overrides entered in\n                  the MXS_EditorUser.properties file. \n               </li>\n            </ul> \n         </div><a name=\"TABLE_0D3D0C16E8124DEFB87095EF8F50A681\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"5.656108597285068%\">\n                  <col width=\"39.366515837104075%\">\n                  <col width=\"54.97737556561086%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"P_88A108C74EFA4453BD6F828EECE284B5\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\"> MAXScript Editor </a></span> </em> \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"P_581EB4D13AB3421F81C41031EDB9365C\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\"> MAXScript Editor Property File Settings</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";