var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-860B6BEB-AE3E-4F99-96E9-CCD70DF4B772\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"python Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: python</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-860B6BEB-AE3E-4F99-96E9-CCD70DF4B772\"></a><div class=\"head\">\n            <h1>Interface: python</h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7CA0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7C9F\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; python \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-39348D57-0056-4145-BEE8-B0B7540DD105\"></a> The \n            		<em class=\"strong\">Python Core Interface</em> exposes the Python engine\'s controls to MAXScript. Available in \n            		<em class=\"strong\">3ds Max 2015 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-28781CFB-1712-466B-9968-5AE21369FE13\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-087D3C93-D64A-45BD-BF44-66E7BD5B7610\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;enum&gt;<em class=\"codeEmphasisStrong\">python.Init</em> <em class=\"codeEmphasisStrong\">throwOnError:</em>&lt;bool&gt; \n\n    Init enums: {<em class=\"codeEmphasisStrong\">#success</em> | <em class=\"codeEmphasisStrong\">#pathError</em> | <em class=\"codeEmphasisStrong\">#initError</em> | <em class=\"codeEmphasisStrong\">#scriptFileError</em> | <em class=\"codeEmphasisStrong\">#executeError</em>}\n    throwOnError default value: true</pre></div>\n         <p><a name=\"GUID-59334296-1800-4F29-967B-B5B6C7DAE475\"></a>Initializes the Python engine and returns \n            		<span class=\"code\"> <em class=\"strong\">#success</em> </span>. \n            	 \n         </p>\n         <p><a name=\"GUID-F34EAE64-860E-47FE-9C93-356B234F95D1\"></a>If the initialization failed, returns an enum describing the cause of the failure\n            - path error, initialization error, script file error or execution error. \n            	 \n         </p>\n         <p><a name=\"GUID-C6688665-8B75-4BC5-945D-139B1E31A6BA\"></a>If the optional argument \n            		<span class=\"code\"> <em class=\"strong\">throwOnError:</em> </span> is set to False, no error will be thrown if one is encountered. \n            	 \n         </p>\n         <p><a name=\"GUID-C4234DED-CC00-4867-A38B-7C10DA665061\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;enum&gt;<em class=\"codeEmphasisStrong\">python.Execute</em> &lt;string&gt;script <em class=\"codeEmphasisStrong\">fileName:</em>&lt;filename&gt; <em class=\"codeEmphasisStrong\">throwOnError:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">clearUndoBuffer:</em>&lt;bool&gt; \n\n    Execute enums: {<em class=\"codeEmphasisStrong\">#success</em> | <em class=\"codeEmphasisStrong\">#pathError</em> | <em class=\"codeEmphasisStrong\">#initError</em> | <em class=\"codeEmphasisStrong\">#scriptFileError</em> | <em class=\"codeEmphasisStrong\">#executeError</em>} \n    fileName default value: undefined \n    throwOnError default value: true \n    clearUndoBuffer default value: true</pre></div>\n         <p><a name=\"GUID-56AEAF7E-E75B-4959-8CE7-F448EBD64B6D\"></a>Executes the Python script specified by the string in the first argument, or, if the\n            optional \n            		<span class=\"code\"> <em class=\"strong\">fileName:</em> </span> argument is provided, executes the specified Python script file. \n            	 \n         </p>\n         <p><a name=\"GUID-11E4AA08-9A23-4818-A211-0D841870B732\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">#success</em> </span> if the execution was successful, or one of the other enums describing the cause of\n            the failure - path error, initialization error, script file error or execution error.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-DCB6FD3F-95DE-4257-B176-B7AB55303F93\"></a>If the optional argument \n            		<span class=\"code\"> <em class=\"strong\">throwOnError:</em> </span> is set to False, no error will be thrown if one is encountered. \n            	 \n         </p>\n         <p><a name=\"GUID-2CB57485-84D2-4A0A-8470-9376F0D6B2D4\"></a>If the optional argument \n            		<span class=\"code\"> <em class=\"strong\">clearUndoBuffer:</em> </span> is set to False, the Undo Buffer will not be cleared before execution. \n            	 \n         </p>\n         <p><a name=\"GUID-52BC904D-FF90-4258-891F-C7F091CC73C5\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;enum&gt;<em class=\"codeEmphasisStrong\">python.ExecuteFile</em> &lt;filename&gt;fileName <em class=\"codeEmphasisStrong\">throwOnError:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">clearUndoBuffer:</em>&lt;bool&gt; \n\n    ExecuteFile enums: {<em class=\"codeEmphasisStrong\">#success</em> | <em class=\"codeEmphasisStrong\">#pathError</em> | <em class=\"codeEmphasisStrong\">#initError</em> | <em class=\"codeEmphasisStrong\">#scriptFileError</em> | <em class=\"codeEmphasisStrong\">#executeError</em>} \n    throwOnError default value: true \n    clearUndoBuffer default value: true</pre></div>\n         <p><a name=\"GUID-EA8119D2-4BD4-4B55-998C-937CE5D234CE\"></a>Executes the Python script file specified by the first argument. \n            	 \n         </p>\n         <p><a name=\"GUID-B716AEFA-B141-450E-827C-1C26912B2FAE\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">#success</em> </span> if the execution was successful, or one of the other enums describing the cause of\n            the failure - path error, initialization error, script file error or execution error.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-9C724E30-287A-402B-998B-78B0353464C9\"></a>If the optional argument \n            		<span class=\"code\"> <em class=\"strong\">throwOnError:</em> </span> is set to False, no error will be thrown if one is encountered. \n            	 \n         </p>\n         <p><a name=\"GUID-B1224FEC-C93D-4614-8173-47B32C36A648\"></a>If the optional argument \n            		<span class=\"code\"> <em class=\"strong\">clearUndoBuffer:</em> </span> is set to False, the Undo Buffer will not be cleared before execution. \n            	 \n         </p>\n         <p><a name=\"GUID-03BE5C49-A179-42B0-B57B-4B8087643D57\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;value&gt;<em class=\"codeEmphasisStrong\">python.Import</em> &lt;string&gt;moduleName <em class=\"codeEmphasisStrong\">throwOnError</em>:&lt;bool&gt;\n    throwOnError default value: true</pre></div>\n         <p>Imports the specified Python module for use in MAXScript. \n            	 \n         </p>\n         <p>If the optional argument \n            		<span class=\"code\"> <em class=\"strong\">throwOnError:</em> </span> is set to False, no error will be thrown if one is encountered. \n            	 \n         </p>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2017 and higher</em> \n         </p><a name=\"TABLE_5400E362D4294511A94FBFBBBD717D2A\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-heading\">\n                  <th class=\"table-heading\">EXAMPLE\n                     				\n                  </th>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>-- import the Python built-in methods and constants\nbi = Python.Import \"__builtin__\"\n-- &lt;module \'__builtin__\' (built-in)&gt;\nbi.pow 2 3\n-- 8 \n-- use Python dictionary type\nd = bi.dict one:1 two:2 three:3 -- {u\'one\': 1, u\'three\': 3, u\'two\': 2}\n-- {u\'one\': 1, u\'three\': 3, u\'two\': 2} \nd[\"one\"]\n-- 1</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;value&gt;<em class=\"codeEmphasisStrong\">python.Reload</em> &lt;value&gt;module throwOnError:&lt;bool&gt;\n    throwOnError default value: true</pre></div>\n         <p>Reloads the specified Python module. This can be useful if a module keyword gets re-defined.\n            \n            	 \n         </p>\n         <p>If the optional argument \n            		<span class=\"code\"> <em class=\"strong\">throwOnError:</em> </span> is set to False, no error will be thrown if one is encountered. \n            	 \n         </p>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2017 and higher</em> \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;String by value&gt;<em class=\"codeEmphasisStrong\">python.GetLastError()</em> </pre></div>\n         <p><a name=\"GUID-ED7E27CE-F559-47FA-9A24-DA2643660591\"></a>Returns the last error message as string. \n            	 \n         </p>\n         <p><a name=\"GUID-FA360D64-E632-4BFE-A829-ABE2A274C32C\"></a>This is especially useful when executing with \n            		<span class=\"code\"> <em class=\"strong\">throwOnError:</em> </span> set to False - if the return value is not \n            		<span class=\"code\"> <em class=\"strong\">#success</em> </span>, you can use this method to display your own error message without throwing an error.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-183238F9-586E-41F7-B774-20089D1EEA7E\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p><a name=\"TABLE_7604B4A4B5CB4F37A06A8BE6C1BF3116\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\n(\nresult = python.Init throwOnError:false\nif result == #success do\n(\n	result = python.Execute \"print \\\"Hello World!\\\"\" throwOnError:false\n)\nif result != #success then\n(\n	format \"Python Initialization Failed due to %\\n\" (result as string)\n	format \"ERROR: %\\n\" (python.GetLastError())\n)\nelse\n	format \"The Python Execution Was A World-Wide Success!\\n\"\nOK\n)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>Hello World!\nThe Python Execution Was A World-Wide Success!\nOK\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">CHANGE LINE 5 - MISTYPE PRINT AS PRUNT:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nresult = python.Execute \"prunt \\\"Hello World!\\\"\" throwOnError:false\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>Python Initialization Failed due to executeError\nERROR: &lt;type \'exceptions.SyntaxError\'&gt; invalid syntax (, line 1)\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";