var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-86D82FCE-B88F-4487-9B34-B6222EDA1C71\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"scripts\">\n      <meta name=\"indexterm\" content=\"script files\">\n      <meta name=\"indexterm\" content=\"rollouts\">\n      <meta name=\"indexterm\" content=\"output pane\">\n      <meta name=\"indexterm\" content=\"listener window\">\n      <meta name=\"indexterm\" content=\"fileIn()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Running Scripts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-86D82FCE-B88F-4487-9B34-B6222EDA1C71\"></a><div class=\"head\">\n            <h1>Running Scripts </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3B4E\"></a>      To run an existing script file, press the \"Run Script\" button on the MAXScript utility\n            rollout, \n            		<em class=\"strong\">File &gt; Run Script</em> in the Listener menu bar, or \n            		<em class=\"strong\">MAXScript &gt; Run Script</em> in the \n            		<em class=\"strong\">3ds Max</em> menu bar. This opens a common File Open dialog for choosing the script. MAXScript\n            then reads and executes the selected script. Any output is printed to the Listener\n            output pane. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3B56\"></a>You can also run a script from Listener or from within other scripts using the \n            		<span class=\"code\"> <em class=\"strong\">fileIn()</em> </span> method: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-647F\"></a><pre><em class=\"codeEmphasisStrong\">fileIn </em>&lt;filename_string&gt; [ <em class=\"codeEmphasisStrong\">quiet:</em>&lt;boolean&gt; ]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3B58\"></a>where \n            		<span class=\"code\"> &lt;filename_string&gt;</span> is a string literal or an expression that evaluates to a string, and specifies the\n            name of the script file whose content is executed. The script file content is executed\n            one expression at a time, and halts processing if an error is encountered at any point.\n            By default, the file is not listed as it is loaded; use \n            		<span class=\"code\"> <em class=\"strong\">quiet:false \n                  		  </em></span> to have the file contents printed to the Listener. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3B59\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3B5A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE USAGES ARE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-647E\"></a><pre>\nfileIn \"my_script.ms\"\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3B5E\"></a><p class=\"table-body\">or \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-647D\"></a><pre>\nscriptfile=\"my_script.ms\"\nfileIn scriptfile\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3B64\"></a>The script file content is compiled in a global scope context, as opposed to the scope\n            in effect when the \n            		<span class=\"code\"> <em class=\"strong\">filein()</em> </span> method is executed. For more information, see \n            		<span class=\"char_link\"><a href=\"GUID-382E7583-DD2A-4DF5-B568-71502DF95ED9.htm\">Scope_of_Variables</a></span>. \n            	 \n         </p>\n         <p>The \n            		<span class=\"code\">fileIn()</span> method looks for scripts in the specified directory if \n            		<span class=\"code\">&lt;filename_string&gt;</span> contains a path as part of the file name, or in the current working directory if\n            only the file name is supplied. If no matching file is found, it then looks in the\n            following locations, in order: \n            	 \n         </p><a name=\"UL_65F18E85CDEA47D79244539368138F0F\"></a><ul>\n            <li>The user scripts directory \n               		\n            </li>\n            <li>The 3ds Max system scripts directory \n               		\n            </li>\n            <li>The 3ds Max main directory \n               		\n            </li>\n            <li>The Windows system32 directory \n               		\n            </li>\n            <li>The Windows system directory \n               		\n            </li>\n            <li>The Windows directory \n               		\n            </li>\n            <li>Directories in the PATH environment variable. \n               		\n            </li>\n         </ul>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";