var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-87BB6468-79E2-4FA2-9BAB-42E427219C4F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"random()\">\n      <meta name=\"indexterm\" content=\"quatToEuler2()\">\n      <meta name=\"indexterm\" content=\"quatToEuler()\">\n      <meta name=\"indexterm\" content=\"getEulerQuatAngleRatio()\">\n      <meta name=\"indexterm\" content=\"getEulerMatAngleRatio()\">\n      <meta name=\"indexterm\" content=\"eulerToQuat()\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>EulerAngles Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-87BB6468-79E2-4FA2-9BAB-42E427219C4F\"></a><div class=\"head\">\n            <h1>EulerAngles Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E65\"></a>The \n            		<em class=\"strong\">EulerAngles</em> class provides a representation for orientation in 3D space using rotation angles\n            in degrees about each axis. \n            	 \n         </p>\n         <p><a name=\"P_2F8BFBFE01394CB68BD4229523838943\"></a>Angles can be greater than 360 and so specify multiple revolutions. \n            	 \n         </p>\n         <p><a name=\"P_16373F7A0AB34153ACDEE02A48AAD4E1\"></a>Rotations follow the right-hand-rule. \n            	 \n         </p>\n         <p><a name=\"P_05AB2CF08C78430F94205CA5F1578336\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E66\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F4C\"></a><pre><em class=\"codeEmphasisStrong\">eulerAngles</em> &lt;x_degrees&gt; &lt;y_degrees&gt; &lt;z_degrees&gt;\n&lt;quat&gt; <em class=\"codeEmphasisStrong\">as eulerAngles</em>\n&lt;angleAxis&gt; <em class=\"codeEmphasisStrong\">as eulerAngles</em>\n&lt;matrix3&gt; <em class=\"codeEmphasisStrong\">as eulerAngles</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E6B\"></a>Extracts the rotation component as eulerAngles. \n            	 \n         </p>\n         <p><a name=\"P_0B60E2AC900D431BBF37F5F336C825F8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E6C\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F4B\"></a><pre>&lt;eulerAngles&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;eulerAngles&gt;\n&lt;eulerAngles&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;eulerAngles&gt;\n&lt;eulerAngles&gt; <em class=\"codeEmphasisStrong\">as</em> &lt;class&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E70\"></a>eulerAngles can convert to Matrix3, Quat, angleAxis values. \n            	 \n         </p>\n         <p><a name=\"P_AA9C198F12824EE693E36EF6CDE38EA2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E71\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F4A\"></a><pre>&lt;eulerAngles&gt;.<em class=\"codeEmphasisStrong\">x</em>: Float\n&lt;eulerAngles&gt;.<em class=\"codeEmphasisStrong\">y</em>: Float\n&lt;eulerAngles&gt;.<em class=\"codeEmphasisStrong\">z</em>: Float</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E75\"></a>Rotation about each primary axis in float degrees. \n            	 \n         </p>\n         <p><a name=\"P_2BD3A9E31B4B4347AEB2ED675D5886E7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-69F4\"></a>        <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F49\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;eulerAngles&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E7E\"></a>Creates a new copy of the eulerAngles value. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E80\"></a>The new value contains a copy of the input eulerAngles value and is independent of\n            the input eulerAngles value. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8798B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8798C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FFA\"></a><pre>newEulerAngles = copy oldEulerAngles</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"P_7FDCAC54709A46F2ACF1F007580974B6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F46\"></a><pre><em class=\"codeEmphasisStrong\">random</em> &lt;eulerAngles&gt; &lt;eulerAngles&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E83\"></a>Random rotation between the eulerAngles, but uses quat Slerp, so loses multiple revolution\n            angles. \n            	 \n         </p>\n         <p><a name=\"P_24CCAB9DFABB40CE9F8102B1B5B89DFB\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F45\"></a><pre><em class=\"codeEmphasisStrong\">quatToEuler</em> &lt;quat&gt; <em class=\"codeEmphasisStrong\">order</em>:&lt;eulertype_integer&gt;\n<em class=\"codeEmphasisStrong\">eulerToQuat</em> &lt;eulerAngle&gt; <em class=\"codeEmphasisStrong\">order</em>:&lt;eulertype_integer&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E87\"></a>Convert between quat and euler angle values. The optional order parameter specifies\n            the order of application of the angles. If not specified, XYZ ordering is used. Its\n            value can be any of the following: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F44\"></a><pre>\n1 - XYZ\n2 - XZY\n3 - YZX\n4 - YXZ\n5 - ZXY\n6 - ZYX\n7 - XYX\n8 - YZY\n9 - ZXZ\n</pre></div>\n         <p><a name=\"P_307B026D1DAD460DB3CE137162C1B706\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F42\"></a><pre><em class=\"codeEmphasisStrong\">quatToEuler2</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E92\"></a>Returns the same Euler value for the given Quaternion as shown in the Transform Type-In\n            dialog. \n            	 \n         </p>\n         <p><a name=\"P_32F91BD28D004C5184967CC2E3DAD047\"></a>Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"P_01EDA56669BC41B8B9E8190907B715CC\"></a>Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_1DF4269D9D8B4113A332E96CC3D4B6AF\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F41\"></a><pre><em class=\"codeEmphasisStrong\">quatArrayToEulerArray</em> &lt;quat array&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E95\"></a>Returns an array of smooth Euler values from the Quat array. \n            	 \n         </p>\n         <p><a name=\"P_ED5E22F8A2D24D9290F62A18DDC0100E\"></a>Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"P_CD91612905D04AF3972F90FACF7167BA\"></a>Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_4E0975AC68E8432D91696EE20070AC99\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E98\"></a>When converting a series of quat values to eulerAngle values, it is possible for sign\n            flips to occur in the eulerAngle values. This is due to the fact that one single quat\n            value can be expressed through many different eulerAngle values. This flip can be\n            detected based on the eulerAngles/quat ratio. The eulerAngles/quat ratio is the angle\n            difference in eulerAngles space to the angle difference in quat space. If this ratio\n            is bigger than PI the rotation between the two quat to eulerAngles conversions. This\n            method returns the eulerAngles/quat angle ratio between the two quat to eulerAngles\n            conversions as a float value. The actual detection of the flip is dependent on the\n            amount of rotation in between conversions. The smaller the amount of rotation, the\n            more accurate the detection. \n            	 \n         </p>\n         <p><a name=\"P_12EF1BAFD364468BAE844062937D36C3\"></a> Note that the following methods were broken in versions prior to \n            		<em class=\"strong\">3ds Max 2012</em>. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_A5C59B43BBCC4D7DBC8943DD57122FF5\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">GetEulerQuatAngleRatio</em> &lt;quat1&gt; &lt;quat2&gt; &lt;array1&gt; &lt;array2&gt; </pre></div>\n         <div class=\"codeBlock\"><a name=\"P_E9E29E1492CF4A919949A453659BEBDD\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">GetEulerQuatAngleRatio</em> &lt;quat1&gt; &lt;quat2&gt; &lt;eulerAngle1&gt; &lt;eulerAngle2&gt; </pre></div>\n         <div class=\"codeBlock\"><a name=\"P_5A19B7C74744459382396C8E10E7A222\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">GetEulerQuatAngleRatio</em> &lt;quat1&gt; &lt;quat2&gt; &amp;&lt;var1&gt; &amp;&lt;var2&gt;  </pre></div>\n         <p><a name=\"P_2CF3030EC03941C9893C4AE20267C4F4\"></a>The function returns the eulerAngles/Quat ratio as a Float. \n            	 \n         </p>\n         <p><a name=\"P_07D04D3495224AB49C89F3C98892656A\"></a>First two arguments are quats used as inputs. The first quat is the previous rotation,\n            the second quat is the current rotation. \n            	 \n         </p>\n         <p><a name=\"P_C5BA4829C9DA4BC9BF1A525AF9E7E993\"></a>The third and fourth arguments are the previous and current converted rotation angles.\n            They will be used as outputs. \n            	 \n         </p>\n         <p><a name=\"P_F41F8A7A163C4DA6AA2AD85A1568BFA3\"></a>In the first signature, the resulting Euler Angle .x, .y, and .z components are stored\n            in the array elements 1, 2, and 3. \n            	 \n         </p>\n         <p><a name=\"P_6A1CBB53392C4CA2926BA64182DD6CA7\"></a> In the second signature, the passed arguments \n            		<span class=\"code\">&lt;eulerAngle1&gt;</span> and \n            		<span class=\"code\">&lt;eulerAngle2&gt;</span> are modified to the converted values. \n            	 \n         </p>\n         <p><a name=\"P_56B3E6AE5097476C842CD64860574BDD\"></a>In the third signature, the EulerAngles passed as argument 3 and 4 are written back\n            by-reference. \n            	 \n         </p>\n         <p><a name=\"P_28EFC9D3C8254D98984F57966FB7BE91\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_5161851A5AA246BAAF1C2A108976422B\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">GetEulerMatAngleRatio</em> &lt;mat1&gt; &lt;mat2&gt; &lt;array1&gt; &lt;array2&gt;</pre></div>\n         <div class=\"codeBlock\"><a name=\"P_5450C7396DAC455B858F3C1F67551E16\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">GetEulerMatAngleRatio</em> &lt;mat1&gt; &lt;mat1&gt; &lt;eulerAngle1&gt; &lt;eulerAngle2&gt;  </pre></div>\n         <div class=\"codeBlock\"><a name=\"P_8614207154EB49C6BC2D05BABD57608A\"></a><pre>&lt;float&gt;<em class=\"codeEmphasisStrong\">GetEulerMatAngleRatio</em> &lt;mat1&gt; &lt;mat1&gt; &amp;&lt;var1&gt; &amp;&lt;var2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87EA6\"></a>This method parallels the \n            		<span class=\"code\"> <em class=\"strong\">getEulerQuatAngleRatio()</em> </span> method, but uses matrix3 values rather than Quat values as inputs. \n            	 \n         </p>\n         <p><a name=\"P_82D57C07F4F24371B4BEA5442E9E9A51\"></a>The first two arguments are matrix3 inputs describing the previous and current orientations.\n            \n            	 \n         </p>\n         <p><a name=\"P_BFB0B4645D6A48DB893EB989CF214708\"></a>The third and fourth arguments are the converted previous and current Euler Angles.\n            \n            	 \n         </p>\n         <p><a name=\"P_E863B73E54EE470399A4AF6348865C5D\"></a>In the first signature, the .x, .y, and .z components are stored in the first, second,\n            and third elements of the arrays. \n            	 \n         </p>\n         <p><a name=\"P_D4B3251003D54628B8F3A4A9C7AFF364\"></a>In the second signature, the output Euler Angles are stored in the passed \n            		<span class=\"code\">&lt;eulerAngle1&gt;</span> and \n            		<span class=\"code\">&lt;eulerAngle2&gt;</span> by modifying them. \n            	 \n         </p>\n         <p><a name=\"P_2FCD385DE2BA40C9A2B81918ACB5FAE7\"></a>In the third signature, the eulerAngles are written back to the third and fourth by-reference\n            arguments. \n            	 \n         </p><a name=\"TABLE_B902F8C49B6943D08DD1603E675D354A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"P_AC18768088A54CF8A63801BB38D9958B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"CODEBLOCK_F754E223959541FF9F6DDD34D22B5560\"></a><pre>\nq1 = (quat 0.412759 0.00141638 -0.113167 0.903782)\nq2 = (quat -0.150577 -0.378993 0.176638 0.895818)\na1 = #(0,0,0)\na2 = #(0,0,0)\ngetEulerQuatAngleRatio q1 q2 a1 a2 \n--&gt;0.583444\na1;a2\n--&gt;#(-48.5478, 5.21315, 11.922)\n--&gt;#(11.509, 47.0722, -17.2825)\n\na1 = #()\na2 = #()\ngetEulerQuatAngleRatio q1 q2 a1 a2 \n--&gt;0.583444\na1;a2\n--&gt;#(-48.5478, 5.21315, 11.922)\n--&gt;#(11.509, 47.0722, -17.2825)\n\na1 = eulerAngles 0 0 0 \na2 = eulerAngles 0 0 0 \ngetEulerQuatAngleRatio q1 q2 a1 a2 \n--&gt;0.583444\na1;a2\n--&gt;(eulerAngles -48.5478 5.21315 11.922)\n--&gt;(eulerAngles 11.509 47.0722 -17.2825)\n\ngetEulerQuatAngleRatio q1 q2 &amp;r1 &amp;r2 \n--&gt;0.583444\nr1;r2\n--&gt;(eulerAngles -48.5478 5.21315 11.922)\n--&gt;(eulerAngles 11.509 47.0722 -17.2825)\n\nm1 = (quat 0.412759 0.00141638 -0.113167 0.903782) as matrix3\nm2 = (quat -0.150577 -0.378993 0.176638 0.895818) as matrix3\na1 = #(0,0,0)\na2 = #(0,0,0)\nGetEulerMatAngleRatio m1 m2 a1 a2 \n--&gt;0.583444\na1;a2\n--&gt;#(-48.5478, 5.21315, 11.922)\n--&gt;#(11.509, 47.0722, -17.2825)\n\na1 = #()\na2 = #()\nGetEulerMatAngleRatio m1 m2 a1 a2 \n--&gt;0.583444\na1;a2\n--&gt;#(-48.5478, 5.21315, 11.922)\n--&gt;#(11.509, 47.0722, -17.2825)\n\na1 = eulerAngles 0 0 0 \na2 = eulerAngles 0 0 0 \nGetEulerMatAngleRatio m1 m2 a1 a2 \n--&gt;0.583444\na1;a2\n--&gt;(eulerAngles -48.5478 5.21315 11.922)\n--&gt;(eulerAngles 11.509 47.0722 -17.2825)\n\nGetEulerMatAngleRatio m1 m2 &amp;r3 &amp;r4\n--&gt;0.583444\nr3;r4\n--&gt;(eulerAngles -48.5478 5.21315 11.922)\n--&gt;(eulerAngles 11.509 47.0722 -17.2825)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87EA9\"></a> <span class=\"char_link\"><a href=\"GUID-04D996CE-B03E-41D6-ADD4-E9A043A483B6.htm\">AngleAxis Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87EAA\"></a> <span class=\"char_link\"><a href=\"GUID-C42F8CCE-CE31-49B4-9D5A-65C07D9F33FD.htm\">Quat Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87EAB\"></a> <span class=\"char_link\"><a href=\"GUID-D77C780A-4E8A-4528-949F-CC09AAE048DA.htm\">Matrix3 Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";