var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-8882888F-3AEF-477E-8CF1-6BD7338B9DB5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"localTime\">\n      <meta name=\"indexterm\" content=\"Local and Universal Time\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Local and Universal Time</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8882888F-3AEF-477E-8CF1-6BD7338B9DB5\"></a><div class=\"head\">\n            <h1>Local and Universal Time </h1>\n         </div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FDD\"></a>  The following methods and system global variables provide access to the system\'s time.\n            \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FDA\"></a>These methods are available in <em class=\"strong\">3ds Max 2008 and higher</em>. \n         </p>\n         <p><a name=\"GUID-6688AA69-133A-44C5-B1B2-536D08608584\"></a>They were previously available in the <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50E9\"></a><pre><em class=\"codeEmphasisStrong\">getLocalTime</em>()\n<em class=\"codeEmphasisStrong\">getUniversalTime</em>()</pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FD8\"></a>Return the Local respectively the Coordinated Universal Time (UTC) as an 8 element\n            array. \n         </p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FD7\"></a><p class=\"list-intro\"><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FD6\"></a>Array elements are:\n         </p>\n         <ol type=\"1\" start=\"1\">\n            <li> <em class=\"strong\">Year</em>- Specifies the current year. \n            </li>\n            <li> <em class=\"strong\">Month</em>- Specifies the current month; January = 1, February = 2, and so on. \n            </li>\n            <li> <em class=\"strong\">DayOfWeek</em>- Specifies the current day of the week; Sunday = 0, Monday = 1, and so on. \n            </li>\n            <li> <em class=\"strong\">Day</em>- Specifies the current day of the month. \n            </li>\n            <li> <em class=\"strong\">Hour</em>- Specifies the current hour. \n            </li>\n            <li> <em class=\"strong\">Minute</em>- Specifies the current minute. \n            </li>\n            <li> <em class=\"strong\">Second</em>- Specifies the current second. \n            </li>\n            <li> <em class=\"strong\">Milliseconds</em>- Specifies the current millisecond. \n            </li>\n         </ol>\n         <p><a name=\"GUID-4451EFC9-82FB-4287-BA3F-E41A8E5001ED\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50E8\"></a><pre><em class=\"codeEmphasisStrong\">localTime</em></pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FCC\"></a>This system global variable contains a String value that defines the current local\n            date and time. This variable is read-only. An example of the value stored in localtime\n            is: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50E7\"></a><pre>\ns = localTime\n--&gt; \"4/14/97 10:24:57 AM\"\n</pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FCA\"></a>The format of this string is controlled by the date format selected in the main Windows\n            Regional Settings control panel. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";