var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-89032CCA-155D-4C23-A574-67B718859E11\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"PointCloud GeometryClass\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>PointCloud : GeometryClass</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-89032CCA-155D-4C23-A574-67B718859E11\"></a><div class=\"head\">\n            <h1>PointCloud : GeometryClass</h1>\n         </div>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">PointCloud - superclass: GeometryClass; super-superclass:node - 26:0 - classID: #(1603164340, 469842767)</em></pre></div>\n         <p><a name=\"GUID-5BF1B5D7-1579-4716-A4A7-B76B5ED4CFA5\"></a> The \n            		<em class=\"strong\">PointCloud GeometryClass</em> object allows the loading of point cloud (e.g. LIDAR) data in Autodesk ReCap format\n            in \n            		<em class=\"strong\">3ds Max</em>. Available in \n            		<em class=\"strong\">3ds Max 2015 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-6229025B-ADAD-4D31-BA61-BEF3B14F31B3\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-19CF0281-F6DE-4A6D-84E7-3B7AAD4B2E98\"></a> <em class=\"strong\">Constructor:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">PointCloud...</em></pre></div>\n         <p><a name=\"GUID-A426C0F8-B909-4BFF-BE71-74B03AA6CC9F\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"section\"><a name=\"SECTION_58F2482D6C734CBD9C6333A0EF59CEDF\"></a> \n            <h2><a name=\"GUID-D8576A99-0A32-4B1A-9143-21AF95ACA1A4\"></a>Point Cloud Source rollout &gt; Scan File group of controls\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">filename</em>     String    default: \"\"   --  filename; Load_Point_Cloud</pre></div> \n            <p><a name=\"GUID-74656045-41D0-4EC9-B7E1-388CC7DC1258\"></a>Get/set the point cloud source filename. \n               		\n            </p> \n            <p><a name=\"GUID-3E2F736C-2A1C-4F72-BD63-F72214ACB1BE\"></a>Valid file formats are Autodesk Reality Capture Project .RCP and Autodesk Reality\n               Capture Scan .RCS files. \n               		\n            </p> \n            <p><a name=\"GUID-DC32D5CA-3302-4C0A-A7D5-D2B84C6AE30D\"></a>.RCS scan files contain actual point data. \n               		\n            </p> \n            <p><a name=\"GUID-7D912322-1A8F-4DCB-8EF1-98C360B27D3A\"></a>.RCP project files contain references to one or more .RCS files registered together\n               in Autodesk ReCap. \n               		\n            </p> \n            <p><a name=\"GUID-5C1DF256-774E-49CE-9208-6859906F3982\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">scanFiles</em>     ArrayParameter    default: #()   --  filename array; SubAnim</pre></div> \n            <p><a name=\"GUID-87F6E7D7-FDD9-420B-A53A-900816D20E56\"></a>A filename array of the .RCS scan files referenced and loaded by the .RCP project\n               file assigned to the \n               		  <span class=\"code\"> <em class=\"strong\">.filename</em> </span> property. \n               		\n            </p> \n            <p><a name=\"GUID-5106DBBF-3075-48BC-9568-9248B09A042E\"></a>If an .RCS scan file is assigned to the \n               		  <span class=\"code\"> <em class=\"strong\">.filename</em> </span> property, its name will be the only element of the array. \n               		\n            </p> \n            <p><a name=\"GUID-C82FCAD1-F4CC-46DE-B526-076733E74A9E\"></a>Not exposed to the UI. \n               		\n            </p> \n            <p><a name=\"GUID-338C3A53-3080-4548-B414-D95AFC44907B\"></a>Read-only. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_DE90F21928CB4183ADFA1A9E71A1E69C\"></a> \n            <h2><a name=\"GUID-DDDC3334-66B5-48BB-B78E-314D9860A19E\"></a>Display rollout &gt; Color Channel group of controls\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">displayTechnique</em>     Integer    default: 0   --  integer</pre></div> \n            <p><a name=\"GUID-C58D2842-AC3D-4760-A47E-CE2BCB172A00\"></a>Get/set the selection of the Color Channel drop-down list. \n               		\n            </p> \n            <p><a name=\"GUID-D5E4B57E-7742-41D5-B1ED-8962E7D86D68\"></a>Possible values are: \n               		\n            </p> \n            <p><a name=\"GUID-B191B986-BFB6-4112-9528-C52E23E3CE73\"></a>0 - \n               		  <em class=\"strong\">True Color \n                  		  </em>(default) \n               		\n            </p> \n            <p><a name=\"GUID-41FCEA92-6270-4845-88BC-9B2729B6CE9A\"></a>1 - \n               		  <em class=\"strong\">Single Color</em> \n            </p> \n            <p><a name=\"GUID-9E542396-D5E2-4E9F-B65D-8332543A05E2\"></a>2 - \n               		  <em class=\"strong\">Normal Ramp</em> \n            </p> \n            <p><a name=\"GUID-8C84DF81-47C9-4510-8FF1-4A805D5BE407\"></a>3 - \n               		  <em class=\"strong\">Elevation Ramp</em> \n            </p> \n            <p><a name=\"GUID-D523E359-79D1-4B25-AD85-02D2D53F22C1\"></a>4 - \n               		  <em class=\"strong\">Intensity Ramp</em> \n            </p> \n            <p><a name=\"GUID-B19D9CD5-EF81-460C-97FB-7FFDEC656F31\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">singleColor</em>     Color    default: (color 0 0 255)   --  animatable; RGB color; Controller Scaling: ([1,1,1] : (color 255 255 255))</pre></div> \n            <p><a name=\"GUID-07B34A72-823C-4246-97B8-11F815E7000C\"></a>Get/set the single color used for all points when the property \n               		  <span class=\"code\"> <em class=\"strong\">.displayTechnique</em> </span> is set to \n               		  <em class=\"strong\">1 - SingleColor</em>. \n               		\n            </p> \n            <p><a name=\"GUID-96D8D2BF-6563-4E9F-BFF8-E55FE54FB483\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">gradientTexmap</em>     Gradient_Ramp    default: (null):Gradient Ramp   --  texturemap; SubAnim</pre></div> \n            <p><a name=\"GUID-63EAC18C-2459-479D-A9CC-5BB9E041744A\"></a>Get/set the Gradient Ramp texture map used when the property \n               		  <span class=\"code\"> <em class=\"strong\">.displayTechnique</em> </span> is set to \n               		  <em class=\"strong\">2 - Normal Ramp</em>, \n               		  <em class=\"strong\">3 - Elevation Ramp</em> or \n               		  <em class=\"strong\">4 - Intensity Ramp</em> \n            </p> \n            <p><a name=\"GUID-E3660EBB-6EEB-4E80-931F-ED0E36D95FEB\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_5ED40419852648DB924AC554329B7E29\"></a> \n            <h2><a name=\"GUID-8D23C0AF-932D-44DD-A3DE-C8A2BA289703\"></a>Display rollout &gt; Level Of Detail Settings group of controls\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">performanceQuality</em>     Integer    default: 4   --  integer</pre></div> \n            <p><a name=\"GUID-CD7A6E7D-21B1-4950-B051-7E3E2B7A2C5A\"></a>Get/set the Performance vs. Quality slider\'s value. \n               		\n            </p> \n            <p><a name=\"GUID-0AAB9EB6-3BBE-4235-BC52-75A79C573741\"></a>Valid range is between 0 (high performance, low quality) and 8 (high quality, low\n               performance). \n               		\n            </p> \n            <p><a name=\"GUID-AD398F41-F822-4161-A0B1-2C69D292EE73\"></a>Default is 4, balanced performance and quality. \n               		\n            </p> \n            <p><a name=\"GUID-95C13CCC-852E-4F3C-8947-E65AF0AE6D97\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">fixedLODEnable</em>     BooleanClass    default: false   --  boolean; Fixed_LOD_Enable</pre></div> \n            <p><a name=\"GUID-188AFC23-B386-4F2E-8589-4D79FAA8D4A4\"></a>Get/set the state of the \n               		  <em class=\"strong\">\"Fixed in Rendering\"</em> checkbox. \n               		\n            </p> \n            <p><a name=\"GUID-8E45AC72-FCDD-4F15-8AE4-AACA0969863B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">fixedLODLevel</em>     Integer    default: 1   --  animatable; integer; Fixed_Level_of_Detail</pre></div> \n            <p><a name=\"GUID-FC6F4641-BBD7-428E-87EF-C2C55833AD87\"></a>Get/set the value of the \n               		  <em class=\"strong\">\"Level Of Detail\"</em> spinner. \n               		\n            </p> \n            <p><a name=\"GUID-58BEEA9E-56E6-41E3-9114-A01F3C766530\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_73B2C0EE2B8C495B8DD25596B7AF0BEA\"></a> \n            <h2><a name=\"GUID-C400FC5B-31B1-4939-898A-278862692350\"></a>Display rollout &gt; Point Display group of controls\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">pointSizeType</em>     Integer    default: 0   --  integer</pre></div> \n            <p><a name=\"GUID-4A1D0FE2-5F01-4418-8D1A-B7B14FC3DDCB\"></a>Get/set the state of the \n               		  <em class=\"strong\">\"Point Display\"</em> radio buttons. \n               		\n            </p> \n            <p><a name=\"GUID-814F10CF-426E-4D9C-82FA-7283E475A1DB\"></a>Possible values are: \n               		\n            </p> \n            <p><a name=\"GUID-40A57CC1-5956-4933-849B-46210694CDAD\"></a>0 - \n               		  <em class=\"strong\">As Pixel \n                  		  </em>(default) \n               		\n            </p> \n            <p><a name=\"GUID-3424453A-321D-4831-A9F4-0A6C5385FB39\"></a>1 - \n               		  <em class=\"strong\">Real-World Scale</em> \n            </p> \n            <p><a name=\"GUID-344AEFFB-2F61-4D06-A129-6F1A811B3A5A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">asPixelPointSize</em>     Float    default: 1.0   --  animatable; float; As_Pixel_Point_Size</pre></div> \n            <p><a name=\"GUID-40C776A2-435E-4C95-AE6D-E387702F4BB2\"></a>Get/set the value of the \n               		  <em class=\"strong\">\"As Pixel\"</em> spinner. \n               		\n            </p> \n            <p><a name=\"GUID-D1A7024C-E4E2-40CA-87FA-1E38764E8219\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">realWorldScalePointSize</em>     Float    default: 0.05   --  animatable; float; Real_World_Scale_Point_Size</pre></div> \n            <p><a name=\"GUID-CB1996FA-3E18-4CF9-8E93-8D28B62C83C0\"></a>Get/set the value of the \n               		  <em class=\"strong\">\"Real-World Scale\"</em> spinner. \n               		\n            </p> \n            <p><a name=\"GUID-3322C5FD-8E67-4DC9-95F0-83841CFC229F\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_797E36201D1B41D99FB17E7CA87C3EEB\"></a> \n            <h2><a name=\"GUID-8E5D9DF5-898A-45A9-8AF4-61D6627B697E\"></a>Limit Box &amp; Volumes rollout &gt; Limit Box group of controls\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">enableLimitPlanes</em>     BooleanClass    default: true   --  boolean</pre></div> \n            <p><a name=\"GUID-35196732-129F-471A-9B9D-D25560EA9264\"></a>Get/set the state of the \n               		  <em class=\"strong\">\"Enable Limit Box\"</em> checkbox. \n               		\n            </p> \n            <p><a name=\"GUID-0276F662-56DB-43E1-B70E-7C69A0C06843\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_F8F1BEF2950343D882EF2A74C3674EB1\"></a> \n            <h2><a name=\"GUID-91259906-B536-448F-9F3F-E52FF1BAB776\"></a>Limit Box &amp; Volumes rollout &gt; Display Volumes group of controls\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">GlobalEnableVolumes</em>     BooleanClass    default: false   --  boolean; volumeGlobalEnable</pre></div> \n            <p><a name=\"GUID-EAC56637-DFAA-43DF-AF70-59F974013FFB\"></a>Get/set the state of the \n               		  <em class=\"strong\">\"Use Display Volumes\"</em> checkbox. \n               		\n            </p> \n            <p><a name=\"GUID-DC97C988-B631-4407-9832-812B3E29FA01\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">VolumeObjects</em>     ArrayParameter    default: #()   --  node array; Volume_Object; SubAnim</pre></div> \n            <p><a name=\"GUID-A792A053-F82C-44B2-8359-CF1C1D5DCAE0\"></a>Get/set the node array of volumes to use when the \n               		  <span class=\"code\"> <em class=\"strong\">.GlobalEnableVolumes</em> </span> property is set to True. \n               		\n            </p> \n            <p><a name=\"GUID-FDFF049B-DBC8-4F37-9736-0A6C636435D4\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">GlobalInvertVolumes</em>     BooleanClass    default: false   --  boolean; volumeGlobalInvert</pre></div> \n            <p><a name=\"GUID-8775A5B8-4581-4D6C-A8C5-0DEB5C1D1CB3\"></a>Get/set the state of the \n               		  <em class=\"strong\">\"Invert\"</em> checkbox. \n               		\n            </p> \n            <p><a name=\"GUID-BC4CC7E2-B3C9-4D71-9588-7BE4B445E54B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div><a name=\"TABLE_C74DC4F59E204FE09C20715AF46A24BF\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-79214716-86FC-4E26-BC42-84EDB99E5DE9\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\n--Create a Point Cloud object at the world origin:\npc = PointCloud()\n--&gt; $PointCloud:PointCloud001 @ [0.000000,0.000000,0.000000]\n\n--Load the sample project installed by Autodesk ReCap:\npc.filename = @\"C:\\ProgramData\\Autodesk\\Autodesk ReCap\\Sample\\AutodeskReCapSampleProject.rcp\"\n--&gt; \"C:\\ProgramData\\Autodesk\\Autodesk ReCap\\Sample\\AutodeskReCapSampleProject.rcp\"\n\n--Query the scan files loaded by the project:\npc.scanFiles\n--&gt; #(\"C:\\ProgramData\\Autodesk\\Autodesk Recap\\Sample\\AutodeskReCapSampleProject Support\\techshop_012.rcs\", \"C:\\ProgramData\\Autodesk\\Autodesk Recap\\Sample\\AutodeskReCapSampleProject Support\\techshop_013.rcs\")\n\n--Create some geometry to use as Display Volumes:\ns1 = Sphere radius:50 pos:[-50,0,0]\n--&gt; $Sphere:Sphere001 @ [-50.000000,0.000000,0.000000]\nb1 = Box pos:[-50,-80,0] width:60 length:40 height:50\n--&gt; $Box:Box001 @ [-50.000000,-80.000000,0.000000]\npc.VolumeObjects = #(s1,b1)\n--&gt; #($Sphere:Sphere001 @ [-50.000000,0.000000,0.000000], $Box:Box001 @ [-50.000000,-80.000000,0.000000])\n\n--Enable the display volumes, invert to cull inside the volumes:\npc.GlobalEnableVolumes = true\n--&gt; true\npc.GlobalInvertVolumes = true\n--&gt; true\n\n--Increase the quality at cost of performance and increase the pixel point size\npc.performanceQuality = 6\n--&gt; 6\npc.asPixelPointSize = 4.0\n--&gt; 4.0\n\n--Display using an Elevation ramp map\npc.displayTechnique = 3\n--&gt; 3\n\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-38D3B69D-325C-4E64-8719-7722E43EE5F8-low.png\"> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-D363B5E1-907C-4082-A008-EFEBF5ADF398\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"section\"><a name=\"SECTION_E5CC11AF7B704C4C866F5DB25B3CB5FC\"></a> \n            <h2><a name=\"GUID-CDBA6C2B-7AF7-433C-B18B-15D44D58AC38\"></a>For Internal Use Only\n            </h2> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">voxelSize</em>     Float    default: 1.0   --  animatable; float</pre></div> \n            <p><a name=\"GUID-EC212BA9-A1C7-489A-ADFF-864F9DAB1E5F\"></a>Get/set the Voxel Size value. \n               		\n            </p> \n            <p><a name=\"GUID-0B6A198D-1AD8-41E4-B5D9-2B07DA62C7E5\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;PointCloud&gt;.<em class=\"codeEmphasisStrong\">Shader</em>     UndefinedClass    default: undefined   --  texturemap; GeomShader</pre></div> \n            <p><a name=\"GUID-A4D6E7CC-F38D-45F2-BB8C-179A281601B1\"></a>Get/set the Point Cloud Shader assigned to the object. \n               		\n            </p> \n            <p><a name=\"GUID-D54F4CAD-534E-4D7E-9EBF-09A318BFB1B9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";