var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-89495341-DEA2-41D9-BFBB-543006E64CA2\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Develop a Bitmap Painting Tool\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Develop a Bitmap Painting Tool - Strokes Support</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-89495341-DEA2-41D9-BFBB-543006E64CA2\"></a><div class=\"head\">\n            <h1>How To ... Develop a Bitmap Painting Tool - Strokes Support </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25DD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25DE\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-FA2D9E9C-90EA-4E95-926E-29BB2FA416FA.htm\">Develop a Bitmap Painting Tool</a></span>- Strokes Support \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25E0\"></a>In this step of the Bitmap Painting tool development, we will add some better stroke\n            drawing code to avoid the dotted appearance. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25E2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25E3\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25E4\"></a><p class=\"table-body\">We will extend the existing MacroScript by adding a new function. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25E5\"></a><p class=\"table-body\">The new function will be passed the old and the new position of the mouse and a line\n                        will be drawn between the two points to define a continuous stroke. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25E7\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC25E8\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6427\"></a><pre>\nmacroScript MicroPaint category: \"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry (destroyDialog MicroPaint_CanvasRollout) catch()\nlocal isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white\nlocal currentPos = lastPos = [0,0]\n&nbsp;\nrollout MicroPaint_CanvasRollout \"MicroPaint\"\n(\n&nbsp; bitmap theCanvas pos:[0,0] width:bitmapX height:bitmapY bitmap:theCanvasBitmap\n &nbsp;fn paintBrush pos = ( setPixels theCanvasBitmap pos #(color 0 0 0) )\n &nbsp;fn drawStroke lastPos pos =\n &nbsp;(\n&nbsp;  &nbsp;currentPos = lastPos\n  &nbsp;&nbsp;deltaX = pos.x - lastPos.x\n  &nbsp;&nbsp;deltaY = pos.y - lastPos.y\n  &nbsp;&nbsp;maxSteps = amax #(abs(deltaX),abs(deltaY))\n  &nbsp;&nbsp;deltaStepX = deltaX / maxSteps\n  &nbsp;&nbsp;deltaStepY = deltaY / maxSteps\n  &nbsp;&nbsp;for i = 0 to maxSteps do\n  &nbsp;&nbsp;(\n   &nbsp;&nbsp;&nbsp;paintBrush currentPos\n   &nbsp;&nbsp;&nbsp;currentPos += [deltaStepX, deltaStepY]\n  &nbsp;&nbsp;)&nbsp;\n  &nbsp;&nbsp;theCanvas.bitmap = theCanvasBitmap\n &nbsp;)\n &nbsp;on MicroPaint_CanvasRollout lbuttondown pos do\n &nbsp;(\n&nbsp;  &nbsp;lastPos = pos\n  &nbsp;&nbsp;isDrawing = true\n  &nbsp;&nbsp;drawStroke lastPos pos\n &nbsp;)\n &nbsp;on MicroPaint_CanvasRollout lbuttonup pos do isDrawing = false\n &nbsp;on MicroPaint_CanvasRollout mousemove pos do\n &nbsp;(\n  &nbsp;&nbsp;if isDrawing do drawStroke lastPos pos\n  &nbsp;&nbsp;lastPos = pos\n &nbsp;)\n)\ncreateDialog MicroPaint_CanvasRollout bitmapX bitmapY\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2617\"></a> \n            <h2><a name=\"GUID-5BD15D8B-93FC-453B-992C-24F6C06566CD\"></a> <em class=\"strong\">Step-By-Step</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6426\"></a><pre><em class=\"codeEmphasisStrong\"><em class=\"codeEmphasisMild\">--Code in italic has no changes since the previous version.</em></em> <em class=\"codeEmphasisMild\">macroScript MicroPaint category:\"HowTo\"\n(\nglobal MicroPaint_CanvasRollout\ntry(destroyDialog CanvasRollout)catch()\nlocal isDrawing = false\nlocal bitmapX = bitmapY = 512\nlocal theCanvasBitmap = bitmap bitmapX bitmapY color:white</em> <em class=\"codeEmphasisStrong\">local currentPos = lastPos = [0,0]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2623\"></a>The first change we will have to do is to define the current and the last known position\n               variables that will be used to keep track of the current stroke. We initialize both\n               to [0,0]. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6425\"></a><pre><em class=\"codeEmphasisMild\">rolloutMicroPaint_CanvasRollout \"MicroPaint\"</em> <em class=\"codeEmphasisMild\">(</em> <em class=\"codeEmphasisMild\">bitmap theCanvas pos:[0,0] width:400 height:400 bitmap:theCanvasBitmap</em> <em class=\"codeEmphasisMild\">fn paintBrush pos = ( setPixels theCanvasBitmap pos #(black) )</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC262A\"></a>We will simplify the paintbrush function. It will only draw the point, but will not\n               update the canvas. This is necessary because the stroke will contain a large number\n               of brush points, but will have to be updated just once after the stroke to maintain\n               interactivity. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6424\"></a><pre><em class=\"codeEmphasisStrong\">fn drawStroke lastPos pos =\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC262E\"></a>This will be the stroke drawing function called by the mouse handlers. Two arguments\n               are passed to it - the last mouse position (beginning of the stroke) and the current\n               mouse position (the end of the stroke). \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6423\"></a><pre><em class=\"codeEmphasisStrong\">currentPos = lastPos</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2630\"></a>The current position variable is initialized to the beginning of the stroke. It will\n               be used to draw the line from the start to the end point of the stroke. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6422\"></a><pre><em class=\"codeEmphasisStrong\">deltaX = pos.x - lastPos.x\ndeltaY = pos.y - lastPos.y</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2633\"></a>To draw a straight line from the last to the new position, we must know how far these\n               two points are from each other along both X and Y. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6421\"></a><pre><em class=\"codeEmphasisStrong\">maxSteps = amax #(abs(deltaX),abs(deltaY))</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2635\"></a>Then, we compare the absolute values along X and Y to see which one is larger. MaxSteps\n               will be equal to either the number of pixels between the two along X or along Y. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6420\"></a><pre><em class=\"codeEmphasisStrong\">deltaStepX = deltaX / maxSteps\ndeltaStepY = deltaY / maxSteps</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2638\"></a>Now, we calculate the increment per step we will need for the X and Y axis. If maxSteps\n               is equal to the distance along X, then deltaStepX will be +1 or -1, while deltaStepY\n               will be a number less than 1.0. If maxSteps is equal to the distance along Y, then\n               deltaStepY will be +1 or -1, and deltaStepX will be &lt; 1.0. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-641F\"></a><pre><em class=\"codeEmphasisStrong\">for i = 0 to maxSteps do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC263B\"></a>Now, we loop from 0 to the number of steps, \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-641E\"></a><pre><em class=\"codeEmphasisStrong\">paintBrush currentPos</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC263D\"></a>paint a black dot at the current position by calling our custom paintbrush function,\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-641D\"></a><pre><em class=\"codeEmphasisStrong\">currentPos += [deltaStepX, deltaStepY]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC263F\"></a>and then increment the current position with the deltaStep values until the current\n               mouse position is reached. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-641C\"></a><pre><em class=\"codeEmphasisStrong\">)&nbsp;\ntheCanvas.bitmap = theCanvasBitmap</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2642\"></a>Finally, when the stroke is done, we update the bitmap in the rollout. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-641B\"></a><pre><em class=\"codeEmphasisStrong\">)</em> <em class=\"codeEmphasisMild\">on MicroPaint_CanvasRollout lbuttondown pos do\n(&nbsp;&nbsp;\n</em><em class=\"codeEmphasisStrong\">lastPos = pos</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2649\"></a>If the user pressed the mouse button, we will have to reset the stroke to the currently\n               clicked point. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-641A\"></a><pre><em class=\"codeEmphasisMild\">isDrawing = true</em> <em class=\"codeEmphasisStrong\">drawStroke lastPos pos</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC264C\"></a>Instead of calling the PaintBrush function, we call the drawStroke function and pass\n               the last and the current position (which are equal at this point) to it. This will\n               create a single dot at the clicked point (the stroke has length 0, both deltaX and\n               deltaY are 0, thus maxSteps is 0, but since the for i loop starts counting at 0, we\n               get at least one iteration to draw the point). \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6419\"></a><pre><em class=\"codeEmphasisStrong\">)</em><div class=\"codeBlock\"><a name=\"CODEBLOCK_9C603F210C004F309D1A20F1668B5E1F\"></a><pre><em class=\"codeEmphasisMild\">on MicroPaint_CanvasRollout lbuttonup pos do isDrawing = false</em></pre></div> <em class=\"codeEmphasisMild\">on MicroPaint_CanvasRollout mousemove pos do (</em> <em class=\"codeEmphasisStrong\">if isDrawing do drawStroke lastPos pos</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2652\"></a>Instead of calling the PaintBrush function, we call the drawStroke function again.\n               At this point, the lastPos and the pos values are different and require a longer stroke\n               to be drawn. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6418\"></a><pre><em class=\"codeEmphasisStrong\">lastPos = pos</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2654\"></a>After the stroke is drawn, we record the current mouse position into the lastPos variable\n               to be used as the starting point of the next stroke. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6417\"></a><pre><em class=\"codeEmphasisMild\">)\n)\ncreateDialog MicroPaint_CanvasRollout bitmapX bitmapY\n)</em></pre></div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC265A\"></a> \n            <h2><a name=\"GUID-41E9F83B-18DA-4548-AEDB-C943C2DC875F\"></a> <em class=\"strong\">Result</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC265B\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-7E7978E1-C49D-4644-85E8-0B26A37CE643-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC265C\"></a> <em class=\"strong\">Previous Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC265D\"></a> <span class=\"char_link\"><a href=\"GUID-9355B32D-DDC4-4C26-BEFD-66BE3D291B63.htm\">How To ... Develop a Bitmap Painting Tool - Basic Utility</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC265E\"></a> <em class=\"strong\">Next Tutorial:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC265F\"></a> <span class=\"char_link\"><a href=\"GUID-E9C5AFAA-52A0-4274-A92C-8075C3BD0F25.htm\">How To ... Develop a Bitmap Painting Tool - Brush Size and Color</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC2661\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";