var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-89772473-4CCA-4E65-A83C-8F053CA86478\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"createPreview Method\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>createPreview Method</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-89772473-4CCA-4E65-A83C-8F053CA86478\"></a><div class=\"head\">\n            <h1>createPreview Method </h1>\n         </div>\n         <p><a name=\"GUID-B2B8863C-9DBA-4BEC-9A22-B6DCFEA7A0D7\"></a>Prior to \n            		<em class=\"strong\">3ds Max 2013</em>, the createPreview() method provided no parameters at all and only triggered the\n            Preview creation using the last settings found in the Make Preview dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-ABB84316-97D3-4D4D-B28F-760C0E9E4FE5\"></a>In \n            		<em class=\"strong\">3ds Max 2013</em>, several keyword arguments were added to provide better control over the Preview\n            making process. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">createPreview</em> <em class=\"codeEmphasisStrong\">filename:</em>&lt;string&gt; <em class=\"codeEmphasisStrong\">outputAVI:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">percentSize:</em>&lt;int&gt; \\\n<em class=\"codeEmphasisStrong\">start:</em>&lt;int&gt; <em class=\"codeEmphasisStrong\">end:</em>&lt;int&gt; <em class=\"codeEmphasisStrong\">skip:</em>&lt;int&gt; <em class=\"codeEmphasisStrong\">fps:</em>&lt;int&gt; \\\n<em class=\"codeEmphasisStrong\">dspGeometry:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">dspShapes:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">dspLights:</em>&lt;bool&gt; \\\n<em class=\"codeEmphasisStrong\">dspCameras:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">dspHelpers:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">dspParticles:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">dspBones:</em>&lt;bool&gt; \\\n<em class=\"codeEmphasisStrong\">dspGrid:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">dspSafeFrame:</em>&lt;bool&gt; <em class=\"codeEmphasisStrong\">dspFrameNums:</em>&lt;true&gt; <em class=\"codeEmphasisStrong\">dspBkg:</em>&lt;bool&gt; \\\n<em class=\"codeEmphasisStrong\">rndLevel:</em>&lt;<em class=\"codeEmphasisStrong\">#smoothhighlights</em> | <em class=\"codeEmphasisStrong\">#smooth</em> | <em class=\"codeEmphasisStrong\">#facethighlights</em> | <em class=\"codeEmphasisStrong\">#facet</em> | <em class=\"codeEmphasisStrong\">#flat</em> | <em class=\"codeEmphasisStrong\">#hiddenline</em> | <em class=\"codeEmphasisStrong\">#litwireframe</em> | <em class=\"codeEmphasisStrong\">#wireframe</em> | <em class=\"codeEmphasisStrong\">#box</em>&gt; \n  </pre></div>\n         <p><a name=\"GUID-540791B4-BFD1-4B73-904C-AC7E4B77C51E\"></a>Creates a preview animation sequence using either the last settings in the Make Preview\n            dialog or the optional arguments, if provided. \n            	 \n         </p>\n         <p><em class=\"strong\">filename:</em> When specified, saves the output to a file with this path and name. When not specified,\n            uses the default \"_preview\" name and the path in the \n            		<span class=\"code\">#preview</span> system directory.\n            	 \n         </p>\n         <p><a name=\"GUID-1764FC86-C6A1-42C4-9862-61E01EBCA489\"></a><span class=\"code\"> <em class=\"strong\">outputAvi:</em> </span> When true, outputs to AVI file with the last selected CODEC. When false, outputs\n            to custom file sequence. \n            	 \n         </p>\n         <p><a name=\"GUID-5B7FABF9-BAC2-4D43-B90C-403F8474618C\"></a><span class=\"code\"> <em class=\"strong\">percentSize:</em> </span> Defines the Preview output size as percentage of the current \n            		<span class=\"code\"> <em class=\"strong\">renderWidth</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">renderHeight</em> </span> values. \n            	 \n         </p>\n         <p><a name=\"GUID-0D388817-1B33-45A5-B023-AA69338DA80A\"></a><span class=\"code\"> <em class=\"strong\">start:</em> </span> Defines the first frame of the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-D527AD22-AB0C-4D72-850E-D2A205AA94B8\"></a><span class=\"code\"> <em class=\"strong\">end:</em> </span> Defines the last frame of the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-CEFD22CD-F51C-4CD9-B15F-C99C8A368BBE\"></a><span class=\"code\"> <em class=\"strong\">skip:</em> </span> Defines the Every Nth frame step of the Preview animation. Corresponds to the \"Every\n            Nth Frame\" value in the Make Preview Dialog. \n            	 \n         </p>\n         <p><a name=\"GUID-2809B173-CFD4-4D96-8189-3E71BD54F398\"></a><span class=\"code\"> <em class=\"strong\">fps:</em> </span> Defines the Frame Rate of the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-3BC99ADA-295F-4B8B-B103-7D42CC88950A\"></a><span class=\"code\"> <em class=\"strong\">dspGeometry:</em> </span> Controls the display of Geometry objects in the Preview animation (except those handled\n            by other flags like Particles and Bones). \n            	 \n         </p>\n         <p><a name=\"GUID-62EF6585-D8A8-4582-A3DF-1244AF781E06\"></a><span class=\"code\"> <em class=\"strong\">dspShapes:</em> </span> Controls the display of Shape objects in the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-42E623FC-3F05-4E50-8208-843A271ACBD0\"></a><span class=\"code\"> <em class=\"strong\">dspLights:</em> </span> Controls the display of Light objects in the Preview animation. This applies to the\n            viewport visibility of the light objects, not to their illumination - they will illuminate\n            the scene even if hidden. \n            	 \n         </p>\n         <p><a name=\"GUID-224E3F2E-058B-4DA2-BBCB-EBDFA6D7F169\"></a><span class=\"code\"> <em class=\"strong\">dspCameras:</em> </span> Controls the display of Camera objects in the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-FBEF31F2-2B23-4C6C-AE79-6614B7DCDC6D\"></a><span class=\"code\"> <em class=\"strong\">dspHelpers:</em> </span> Controls the display of Helper objects in the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-9F207674-4DA4-4ABF-B249-778975F1AAE4\"></a><span class=\"code\"> <em class=\"strong\">dspParticles:</em> </span> Controls the display of Particle objects in the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-CFD63DEB-9725-4B32-9FA2-6A0427EE38E4\"></a><span class=\"code\"> <em class=\"strong\">dspBones:</em> </span> Controls the display of Bone objects in the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-BE87E8ED-4F4B-4A6F-A40D-5980D017D01E\"></a><span class=\"code\"> <em class=\"strong\">dspGrid:</em> </span> Controls the display of Home of Custom Grid in the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-50C638F7-5B94-4C48-A338-823B98581C51\"></a><span class=\"code\"> <em class=\"strong\">dspSafeFrame:</em> </span> Controls the display of Safe Frames in the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-7E15E891-BEF6-441E-8DD2-0E9518F5F3BD\"></a><span class=\"code\"> <em class=\"strong\">dspFrameNums:</em> </span> Controls the display of Frame Number counter in the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-4158E55D-56A6-44A6-AD44-4C84B3B5D64B\"></a><span class=\"code\"> <em class=\"strong\">dspBkg:</em> </span> Controls the display of the Viewport Background in the Preview animation. \n            	 \n         </p>\n         <p><a name=\"GUID-9B6CE5FB-0719-4FD1-B51D-46DBAD5D86FD\"></a><span class=\"code\"> <em class=\"strong\">rndLevel:</em> </span> Controls the render level \n            		<em class=\"strong\">when using the Direct3D Driver</em>. When using Nitrous, the current Nitrous settings accessible through \n            		<span class=\"code\"> <em class=\"strong\">NitrousGraphicsManager.GetActiveViewportSetting()</em> </span> are used. \n            	 \n         </p>\n         <p><a name=\"GUID-D87CE221-EF4C-464D-93CA-D4AC64359B98\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-D9B4B1A8-FF21-4E01-A34B-A043828EC6E6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";