var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-8A616D27-6311-4A66-9C2D-43534D24511B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Make It Faster?\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Using Bsearch For Fast Table Lookup</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8A616D27-6311-4A66-9C2D-43534D24511B\"></a><div class=\"head\">\n            <h1>Using Bsearch For Fast Table Lookup </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC167B\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC167D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC167E\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-0030AA3F-47D9-4FDD-8517-5F7902884B37.htm\">How To Make It Faster</a></span> &gt; Using Bsearch For Fast Table Lookup \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1680\"></a>The <span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm#WS73099CC142F487553098682E12AC2FC2BC7-5E36\">bsearch()</a></span> method available in <em class=\"strong\">3ds Max 2009 and higher</em> allows for very fast table lookup operations in sorted arrays. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1681\"></a> \n            <h2><a name=\"GUID-0F3835F7-792B-4B7C-9603-6445BB2EAC3E\"></a> <em class=\"strong\">The problem</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1682\"></a>Assume that you have an array of arrays where each sub-array contains the same number\n               of elements with the same layout. In many cases, you will collect this information\n               just once and then retrieve the data stored in a specific sub-array (\"record\") by\n               providing a single search value (\"key\") that represents the whole record without having\n               to go through all objects in the scene again. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1683\"></a> \n            <h2><a name=\"GUID-F39C1BE1-1ED3-4D5C-8B55-8A7B6C82084D\"></a> <em class=\"strong\">Real-World Examples</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1684\"></a>An example is a list of all Editable Poly objects in the scene including their name,\n               vertex, and poly count as well as the number of triangles, quad polygons, and n-gons\n               in their geometry. As the collection of the polygon sides data is relatively slow\n               (it requires looping through all polygons and determining their degree), you can collect\n               this data just once and then be able to quickly ask \"How many tris and quads does\n               the object with the name \"Box25\" contain?\" \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1685\"></a> \n            <h2><a name=\"GUID-39FBB6E3-1025-4062-9F6F-1506E7CACCEF\"></a> <em class=\"strong\">Using MAXScript Functions for Linear Search</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1686\"></a>Using a user-made MAXScript function to solve this problem will be relatively slow.\n               It will require a linear search through the array (a loop) where the search key (in\n               the above example, it is the object\'s name) is compared with the name stored in each\n               sub-array of the table. If we assume that each entry is unique, then we can stop searching\n               when we find a matching key. With this assumption the linear search will be very fast\n               if the object in question happens to be the first record in the array, but much slower\n               if it happens to be the last record. The average search time will be somewhere in\n               between. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1688\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1689\"></a><p class=\"table-body\"> <em class=\"strong\">LINEAR SEARCH EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC168A\"></a><p class=\"table-body\">Below is one of the possible linear search functions used later on this page to compete\n                           against bsearch(). In short, the search key and the table to search is passed and\n                           it loops through them until it finds a match. At that point, it exits the loop and\n                           returns the current value. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65F3\"></a><pre>\nfn LookupMAXScriptLoop3 itemKey itemTable = (\n&nbsp;for i in itemTable do if i[1] == itemKey do exit with i\n)&nbsp;\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1690\"></a> \n            <h2><a name=\"GUID-929731EB-C867-4128-9414-58AEB5FC252E\"></a> <em class=\"strong\">Using Find Item To Speed Up MAXScript Search</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1691\"></a>A possible acceleration of the MAXScript function search involves the creation of\n               a second array containing only the keys from the original table and applying the findItem()\n               method to it to get the index of the record. While this is technically also a form\n               of linear search, findItem() is implemented in C++ and is much faster than a MAXScript\n               For loop. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1693\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1694\"></a><p class=\"table-body\"> <em class=\"strong\">FINDITEM SEARCH EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1695\"></a><p class=\"table-body\">Here, we pass the key, the table to search, and a table of all keys in the same order\n                           as the search table. FindItem() returns 0 if the key does not exist in the list or\n                           a positive index if it does. Using that index, we can return the record with the given\n                           key: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65F2\"></a><pre>\nfn LookupMAXScriptFindItem itemKey itemTable keyTable =(\nlocal theIndex = findItem keyTable itemKey\nif theIndex &gt; 0 then itemTable[theIndex] else undefined\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC169D\"></a> \n            <h2><a name=\"GUID-ACE5C9E5-32BD-4845-81A8-517DD0DC463B\"></a> <em class=\"strong\">Using bsearch() To Get There FAST</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC169E\"></a>The bsearch() function solves the problem by working on a table that is already pre-sorted\n               by the search key using qsort. It applies the same comparison function used for sorting\n               to searching. As you see below, bsearch() scales great as the size of the table increases\n               and is independent of the position of the record inside the table. It needs the same\n               time to find the first, middle, or last record. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC16A0\"></a>The following test script can be used to test the bsearch() method against various\n               variations of MAXScript functions. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC16A2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC16A3\"></a><p class=\"table-body\"> <em class=\"strong\">TEST SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65F1\"></a><pre>\n(\n<span class=\"codeComment\">-- Same compare function used by bsearch and qsort:</span>\nfn LookupTableComparator a b = (\nif a[1] &gt; b[1] then 1\nelse if a[1] &lt; b[1] then -1\nelse 0\n)\n \n<span class=\"codeComment\">-- Finds an item in a lookup table; -- A lookup table is a sorted array of items, -- where each item is an array with its key as the same entry as the sort key. -- In our case the LookupTableComparator uses the first element as the key --So we have to make the search key an array too --in order to make it compatible with the qsort function!</span>\nfn LookupTableLookup itemKey itemTable = (\nlocal lookupKey = #(itemKey)\nbsearch lookupKey itemTable LookupTableComparator\n)\n \n<span class=\"codeComment\">--MAXScript Function1 -collects all matches and returns the first, if any</span>\nfn LookupMAXScriptLoop1 itemKey itemTable = (\n result = for i in itemTable where i[1] == itemKey collect i\nif result.count &gt; 0 then result[1] else undefined\n)\n \n<span class=\"codeComment\">--MAXScript Function2 -loops until a match is found and returns the result, if any</span>\nfn LookupMAXScriptLoop2 itemKey itemTable = (\nfor i in itemTable do if i[1] == itemKey do return i\nundefined\n)\n \n<span class=\"codeComment\">--MAXScript Function3- loops until a match is found and exists with the result, if any</span>\nfn LookupMAXScriptLoop3 itemKey itemTable = (\nfor i in itemTable do if i[1] == itemKey do exit with i\n)\n \n<span class=\"codeComment\">--MAXScript Function loops using a while - managing the i var. is slower!</span>\nfn LookupMAXScriptLoop4 itemKey itemTable = (\nlocal i = 0\nresult = undefined\nwhile i &lt; itemTable.count do (\ni+=1\nif itemTable[i][1] == itemKey do (\nresult = itemTable[i]\ni = itemTable.count + 1\n)\n)\nresult\n)\nfn LookupMAXScriptFindItem itemKey itemTable keyTable = (\n  local theIndex = findItem keyTable itemKey\n  if theIndex &gt; 0 then itemTable[theIndex] else undefined\n)\n \n<span class=\"codeComment\">--TEST VALUES:</span>\nlocal searchKey =\"5498\"--the key to search for\nlocal iterations = 10--number of search calls\nlocal tableElements = 10000--number of elements in the table\n \n<span class=\"codeComment\">--Create an array to search in. --Its elements will have the form #(\"NNN\", \"TestNNN\", NNN). \n--But the table could contain ANYTHING, this is just an example</span>\nsearchTable =for i = 1 to tableElements collect\n#( (i as string), \"Test\"+(i as string), i)\n \n<span class=\"codeComment\">--For BSearch to work, the search table has to be sorted array!</span>\nst = timestamp()\nqsort searchTable LookupTableComparator\nformat \"QSort Time: %ms\\n\" (timestamp()-st)\n \n<span class=\"codeComment\">--Print the current first, middle and last element for best, mean and worst case searches</span>\nformat \"First Element : %\\n\" searchTable[1]\nformat \"Mid. Element : %\\n\" searchTable[tableElements/2] \nformat \"Last Element : %\\n\" searchTable[tableElements]\n \nlocal returnValue<span class=\"codeComment\">--variable to show the result</span>\n \nlocal st =timestamp()\nfor i = 1 to iterations do returnValue = LookupMAXScriptLoop1 searchKey searchTable\nlocal totalTime =(timestamp()-st)\nformat \"MXS Loop 1 - Total: %ms Per Search: %ms\\n\" totalTime (1.0*totalTime/iterations)\nformat \"%\\n\" returnValue\n \nst =timestamp()\nfor i = 1 to iterations do returnValue = LookupMAXScriptLoop2 searchKey searchTable\nlocal totalTime =(timestamp()-st)\nformat \"MXS Loop 2 - Total: %ms Per Search: %ms\\n\" totalTime (1.0*totalTime/iterations)\nformat \"%\\n\" returnValue\n \nst =timestamp()\nfor i = 1 to iterations do returnValue = LookupMAXScriptLoop3 searchKey searchTable\nlocal totalTime =(timestamp()-st)\nformat \"MXS Loop 3 - Total: %ms Per Search: %ms\\n\" totalTime (1.0*totalTime/iterations)\nformat \"%\\n\" returnValue\n \nst =timestamp()\nfor i = 1 to iterations do returnValue = LookupMAXScriptLoop4 searchKey searchTable\nlocal totalTime =(timestamp()-st)\nformat \"MXS Loop 4 - Total: %ms Per Search: %ms\\n\" totalTime (1.0*totalTime/iterations)\nformat \"%\\n\"returnValue \n \nlocal keyTable = (for i in searchTable collect i[1]) --collect all keys\nlocal st =timestamp()\nfor i = 1 to iterations do\nreturnValue = LookupMAXScriptFindItem searchKey searchTable keyTable\nlocal totalTime =(timestamp()-st)\nformat \"FindItem - Total: %ms Per Search: %ms\\n\" totalTime (1.0*totalTime/iterations)\nformat \"%\\n\"returnValue \n \nst =timestamp()\nfor i = 1 to iterations do returnValue = LookupTableLookup searchKey searchTable\nlocal totalTime =(timestamp()-st)\nformat \"BSEARCH - Total: %ms Per Search: %ms\\n\" totalTime (1.0*totalTime/iterations)\nformat \"%\\n\"returnValue \n)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC171A\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-65F0\"></a><pre>\nQSort Time: 375ms\nFirst Element : #(\"1\", \"Test1\", 1)\nMid. Element : #(\"5498\", \"Test5498\", 5498)\nLast Element : #(\"9999\", \"Test9999\", 9999)\nMXS Loop 1 - Total: 18812ms Per Search: 18.812ms\n#(\"5498\", \"Test5498\", 5498)\nMXS Loop 2 - Total: 9750ms Per Search: 9.75ms\n#(\"5498\", \"Test5498\", 5498)\nMXS Loop 3 - Total: 9594ms Per Search: 9.594ms\n#(\"5498\", \"Test5498\", 5498)\nMXS Loop 4 - Total: 18609ms Per Search: 18.609ms\n#(\"5498\", \"Test5498\", 5498)\nFindItem - Total: 1812ms Per Search: 1.812ms\n#(\"5498\", \"Test5498\", 5498)\nBSEARCH - Total: 0ms Per Search: 0.0ms\n#(\"5498\", \"Test5498\", 5498)\nOK\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC172F\"></a>In a table of 10,000 records sorted using qsort, key \"5498\" is exactly in the middle\n               of the sorted table. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1730\"></a>The MXS Loop 1 performs as bad as in the worst case scenario of \"9999\" because it\n               has to always loop through all elements. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1731\"></a>The MXS Loop 2 and 3 functions finish in half the time because they break in the middle\n               of the loop. If we were searching for \"9999\", their results will be close to those\n               of MXS Loop 1. But, if we were searching for key \"1\", they will be very fast because\n               it is the first thing they hit when testing. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1732\"></a>The FindItem approach proves to be an order of magnitude faster. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1733\"></a>Finally, the BSEARCH method is so fast that we cannot even stop its time (less than\n               1 millisecond for 1000 calls). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1735\"></a>The following table shows the per search times with different table sizes and the\n               best, mean, and worst cases for all methods. A large number of iterations (between\n               1000 and 100000 depending on the number of records) were used to ensure high precision.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1736\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"7.142857142857142%\">\n                     <col width=\"7.142857142857142%\">\n                     <col width=\"14.285714285714285%\">\n                     <col width=\"14.285714285714285%\">\n                     <col width=\"14.285714285714285%\">\n                     <col width=\"14.285714285714285%\">\n                     <col width=\"14.285714285714285%\">\n                     <col width=\"14.285714285714285%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1737\"></a><p class=\"table-body\"> <em class=\"strong\">Elements</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1738\"></a><p class=\"table-body\"> <em class=\"strong\">Key</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1739\"></a><p class=\"table-body\"> <em class=\"strong\">Loop 1</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC173A\"></a><p class=\"table-body\"> <em class=\"strong\">Loop 2</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC173B\"></a><p class=\"table-body\"> <em class=\"strong\">Loop 3</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC173C\"></a><p class=\"table-body\"> <em class=\"strong\">Loop 4</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC173D\"></a><p class=\"table-body\"> <em class=\"strong\">FindItem</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC173E\"></a><p class=\"table-body\"> <em class=\"strong\">Bsearch</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC173F\"></a><p class=\"table-body\"> <em class=\"strong\">10</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1740\"></a><p class=\"table-body\">\"1\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1741\"></a><p class=\"table-body\">0.01734ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1742\"></a><p class=\"table-body\"> <em class=\"strong\">0.06266ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1743\"></a><p class=\"table-body\">0.04093ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1744\"></a><p class=\"table-body\">0.00813ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1745\"></a><p class=\"table-body\"> <em class=\"strong\">0.00375ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1746\"></a><p class=\"table-body\">0.01266ms </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1747\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1748\"></a><p class=\"table-body\">\"4\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1749\"></a><p class=\"table-body\">0.01719ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC174A\"></a><p class=\"table-body\"> <em class=\"strong\">0.06781ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC174B\"></a><p class=\"table-body\">0.04562ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC174C\"></a><p class=\"table-body\">0.01844ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC174D\"></a><p class=\"table-body\"> <em class=\"strong\">0.00421ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC174E\"></a><p class=\"table-body\">0.00813ms </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC174F\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1750\"></a><p class=\"table-body\">\"9\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1751\"></a><p class=\"table-body\">0.01657ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1752\"></a><p class=\"table-body\"> <em class=\"strong\">0.07438ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1753\"></a><p class=\"table-body\">0.05156ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1754\"></a><p class=\"table-body\">0.03015ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1755\"></a><p class=\"table-body\"> <em class=\"strong\">0.00469ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1756\"></a><p class=\"table-body\">0.01062ms </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1757\"></a><p class=\"table-body\"> <em class=\"strong\">100</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1758\"></a><p class=\"table-body\">\"1\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1759\"></a><p class=\"table-body\"> <em class=\"strong\">0.13031ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC175A\"></a><p class=\"table-body\">0.06437ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC175B\"></a><p class=\"table-body\">0.04078ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC175C\"></a><p class=\"table-body\">0.00797ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC175D\"></a><p class=\"table-body\"> <em class=\"strong\">0.00406ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC175E\"></a><p class=\"table-body\">0.02032ms </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC175F\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1760\"></a><p class=\"table-body\">\"53\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1761\"></a><p class=\"table-body\">0.12922ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1762\"></a><p class=\"table-body\">0.12297ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1763\"></a><p class=\"table-body\">0.10454ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1764\"></a><p class=\"table-body\"> <em class=\"strong\">0.13016ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1765\"></a><p class=\"table-body\">0.00829ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1766\"></a><p class=\"table-body\"> <em class=\"strong\">0.00812ms</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1767\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1768\"></a><p class=\"table-body\">\"99\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1769\"></a><p class=\"table-body\">0.12984ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC176A\"></a><p class=\"table-body\">0.18688ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC176B\"></a><p class=\"table-body\">0.16859ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC176C\"></a><p class=\"table-body\"> <em class=\"strong\">0.25812ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC176D\"></a><p class=\"table-body\"> <em class=\"strong\">0.01329ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC176E\"></a><p class=\"table-body\">0.01546ms </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC176F\"></a><p class=\"table-body\"> <em class=\"strong\">1000</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1770\"></a><p class=\"table-body\">\"1\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1771\"></a><p class=\"table-body\"> <em class=\"strong\">1.3516ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1772\"></a><p class=\"table-body\">0.0609ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1773\"></a><p class=\"table-body\">0.0391ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1774\"></a><p class=\"table-body\">0.0078ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1775\"></a><p class=\"table-body\"> <em class=\"strong\">0.0031ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1776\"></a><p class=\"table-body\">0.0328ms </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1777\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1778\"></a><p class=\"table-body\">\"548\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1779\"></a><p class=\"table-body\"> <em class=\"strong\">1.4187ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC177A\"></a><p class=\"table-body\">0.7156ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC177B\"></a><p class=\"table-body\">0.7000ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC177C\"></a><p class=\"table-body\">1.3000ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC177D\"></a><p class=\"table-body\">0.0547ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC177E\"></a><p class=\"table-body\"> <em class=\"strong\">0.0078ms</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC177F\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1780\"></a><p class=\"table-body\">\"999\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1781\"></a><p class=\"table-body\">1.3875ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1782\"></a><p class=\"table-body\">1.4250ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1783\"></a><p class=\"table-body\">1.4156ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1784\"></a><p class=\"table-body\"> <em class=\"strong\">2.7469ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1785\"></a><p class=\"table-body\">0.1063ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1786\"></a><p class=\"table-body\"> <em class=\"strong\">0.0187ms</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1787\"></a><p class=\"table-body\"> <em class=\"strong\">10000</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1788\"></a><p class=\"table-body\">\"1\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1789\"></a><p class=\"table-body\"> <em class=\"strong\">17.344ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC178A\"></a><p class=\"table-body\">0.0620ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC178B\"></a><p class=\"table-body\">0.0470ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC178C\"></a><p class=\"table-body\">0.0160ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC178D\"></a><p class=\"table-body\"> <em class=\"strong\">0.0160ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC178E\"></a><p class=\"table-body\">0.0470ms </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC178F\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1790\"></a><p class=\"table-body\">\"5480\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1791\"></a><p class=\"table-body\">17.250ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1792\"></a><p class=\"table-body\">8.8590ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1793\"></a><p class=\"table-body\">8.7970ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1794\"></a><p class=\"table-body\"> <em class=\"strong\">20.187ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1795\"></a><p class=\"table-body\">1.6090ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1796\"></a><p class=\"table-body\"> <em class=\"strong\">0.0310ms</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1797\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1798\"></a><p class=\"table-body\">\"9999\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1799\"></a><p class=\"table-body\">18.641ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC179A\"></a><p class=\"table-body\">18.531ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC179B\"></a><p class=\"table-body\">18.625ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC179C\"></a><p class=\"table-body\"> <em class=\"strong\">40.375ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC179D\"></a><p class=\"table-body\">3.6870ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC179E\"></a><p class=\"table-body\"> <em class=\"strong\">0.0310ms</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC179F\"></a><p class=\"table-body\"> <em class=\"strong\">100000</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17A0\"></a><p class=\"table-body\">\"1\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17A1\"></a><p class=\"table-body\"> <em class=\"strong\">191.56ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17A2\"></a><p class=\"table-body\">0.0630ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17A3\"></a><p class=\"table-body\">0.0470ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17A4\"></a><p class=\"table-body\">0.2650ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17A5\"></a><p class=\"table-body\"> <em class=\"strong\">0.0150ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17A6\"></a><p class=\"table-body\">0.5940ms </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17A7\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17A8\"></a><p class=\"table-body\">\"54998\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17A9\"></a><p class=\"table-body\">194.38ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17AA\"></a><p class=\"table-body\">97.180ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17AB\"></a><p class=\"table-body\">96.570ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17AC\"></a><p class=\"table-body\"> <em class=\"strong\">3172.0ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17AD\"></a><p class=\"table-body\">19.530ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17AE\"></a><p class=\"table-body\"> <em class=\"strong\">0.0150ms</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17AF\"></a><p class=\"table-body\">&nbsp; </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17B0\"></a><p class=\"table-body\">\"99999\" </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17B1\"></a><p class=\"table-body\">187.34ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17B2\"></a><p class=\"table-body\">187.03ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17B3\"></a><p class=\"table-body\">188.59ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17B4\"></a><p class=\"table-body\"> <em class=\"strong\">5659.22ms</em> \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17B5\"></a><p class=\"table-body\">38.750ms </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17B6\"></a><p class=\"table-body\"> <em class=\"strong\">0.2660ms</em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17B8\"></a>As you can see from the table, the two best performers are the findItem and bsearch\n               methods. With very few records in the array, findItem performs a bit faster. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17B9\"></a>As the number of records in the array increases, the bsearch approach wins in both\n               the average (searching for the middle record) and worst case scenarios (searching\n               for the last record), while the linear search of findItem only wins in the best case\n               scenario. Thus, if you have a very large list of records, for example 100,000, finding\n               a random record by its key is 1300 times faster using bsearch() than by using findItem()\n               and over 6400 times faster than the fastest of the MAXScript Linear Search (Loop)\n               functions. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17BA\"></a>The above times do not take into account the time necessary to sort the table using\n               qsort() for bsearch() to be able to use, nor the time necessary to collect a keys\n               array for the findItem() method. We assume that these are performed in a separate\n               step once and then a very large number of random searches have to be performed very\n               fast. The time needed to sort 100,000 records using qsort is around 30 seconds, which\n               equals to about 800 calls to the findItem function. Thus, if you know that you will\n               be calling the search function thousands of times, spending 30 seconds to pre-sort\n               the list for bsearch() use is worth it and will pay off due to the much shorter search\n               times later on. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17BB\"></a> <em class=\"strong\">Previous Tip</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17BC\"></a> <span class=\"char_link\"><a href=\"GUID-2420F55C-E839-4F6A-9E89-6866D118A4A9.htm\">Optimizing Particle Flow Script Operator For Loops For Speed</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC17BF\"></a> <span class=\"char_link\"><a href=\"GUID-279879A8-9844-4C29-9EA8-43E5FF922692.htm\">For Loop By Index Vs For Loop Through Collection Performance</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";