var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-8B7E81F0-AC81-4518-8D8E-B0C9C6717645\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"XRefScene Values\">\n      <meta name=\"indexterm\" content=\"Node Subclasses\">\n      <meta name=\"indexterm\" content=\"XRefObject - Node\">\n      <meta name=\"indexterm\" content=\"addNewXRefObject() - xrefs\">\n      <meta name=\"indexterm\" content=\"updateXRef()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>XRefObject : Node</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8B7E81F0-AC81-4518-8D8E-B0C9C6717645\"></a><div class=\"head\">\n            <h1>XRefObject : Node </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB70\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB71\"></a>    An<em class=\"strong\"> XRefObject</em> value represents an XRef object in \n               		  <em class=\"strong\">3ds Max</em>. An XRefObject value is returned when the \n               		  <span class=\"code\"> <em class=\"mild\">xrefs.addNewXRefObject()</em> </span> function is called. There are two objects associated with an XRef object in<em class=\"strong\"> 3ds Max</em> - the non-proxy object and the proxy object. The proxy object is typically a lower\n               resolution object that is used as a standin for the non-proxy object in the viewports.\n               \n               		\n            </p> \n            <div><a name=\"GUID-52839CDF-7123-4714-B6B3-BAEA52A10B3B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>In \n                  		  <em class=\"strong\">3ds Max 8</em> and newer, the \n                  		  <span class=\"char_link\"><a href=\"GUID-4822E768-D5EF-44EF-89E7-5BF5404861A2.htm\">objXrefMgr</a></span> is the preferred way of working with XRefs in MAXScript. Scripts that use both \n                  		  <span class=\"code\">XRefObject</span> and \n                  		  <span class=\"code\">objXrefMgr</span> methods on the same XRefObject may not work correctly. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-C7429DEB-F49F-42E2-A38C-6DDA18930C05\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB76\"></a> <em class=\"strong\">Constructor:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F96\"></a><pre><em class=\"codeEmphasisStrong\">xrefs</em>.<em class=\"codeEmphasisStrong\">addNewXRefObject</em> &lt;filename&gt; {&lt;objectname&gt; | &lt;objectname_array&gt;} [<em class=\"codeEmphasisStrong\">#proxy</em>] \\\n <em class=\"codeEmphasisStrong\">modifiers</em>:{<em class=\"codeEmphasisStrong\">#xref | #merge | #drop</em>}	<em class=\"codeEmphasisStrong\">manipulators</em>: {		<em class=\"codeEmphasisStrong\">#xref | #merge</em> }		\\\n<em class=\"codeEmphasisStrong\">dupMtlNameAction</em>: {<em class=\"codeEmphasisStrong\">#prompt</em> |	<em class=\"codeEmphasisStrong\">#useXRefed</em> |	<em class=\"codeEmphasisStrong\">#useScene</em> |	<em class=\"codeEmphasisStrong\">#autoRename</em>} \\\n<em class=\"codeEmphasisStrong\">reparentAction</em>: {<em class=\"codeEmphasisStrong\">#promptReparent</em>|<em class=\"codeEmphasisStrong\">#alwaysReparent</em>|<em class=\"codeEmphasisStrong\">#neverReparent</em>}</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB78\"></a>Loads the specified node object from the specified scene file as an XRef object. The\n               case of \n               		  <span class=\"code\"> <em class=\"mild\">objectname_string</em> </span> must match the object\'s name in the scene file. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB79\"></a>If an array of object names is specified, the return value will be an array of the\n               XRef\'ed objects. Note that if a manipulator\'s name is specified in the array, and\n               manipulator:<span class=\"code\"> <em class=\"mild\">#merge</em> </span> is specified, the merged manipulator is not included in the result array since it\n               isn\'t an XRef Object. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB7A\"></a>If \n               		  <span class=\"code\"> <em class=\"mild\">#proxy</em> </span> is specified, the node object is loaded as the proxy object, otherwise it is loaded\n               as the non-proxy object. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB7B\"></a>The XRefObject is always loaded at world center. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB7C\"></a>References between XRef objects brought in as a single operation are maintained, so\n               that if you have a object parameter controlled by a manipulator, and you XRef in both\n               the object and the manipulator, the manipulator will still control the object\'s parameter.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB7D\"></a> <em class=\"strong\">Modifiers:</em> \n            </p> <a name=\"UL_0FCFACC2B94F409F9488ECD976E0FDD1\"></a><ul>\n               <li><em class=\"strong\"> #xref</em> - XRef Object contains any modifiers on object (default) \n                  		  \n               </li>\n               <li><em class=\"strong\"> #merge</em> - XRef Object contains base object, any modifiers on object are applied to the XRef\n                  Object \n                  		  \n               </li>\n               <li><em class=\"strong\"> #drop</em> - XRef Object contains base object, any modifiers on object are dropped \n                  		  \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB82\"></a> <em class=\"strong\">Manipulators:</em> \n            </p> <a name=\"UL_5A0673E8393A48568DD443811B702354\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB83\"></a> <em class=\"strong\"> #xref</em> - bring manipulator in as an xref \n                     			 \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB84\"></a> <em class=\"strong\"> #merge</em> - bring in manipulator as a manipulator \n                     			 \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB85\"></a> <em class=\"strong\">dupMtlNameAction:</em> (available in<em class=\"strong\"> 3ds Max 2010 and higher</em>) \n               		\n            </p> <a name=\"UL_872F8537F24D4DC1B0EBEE6EE09565C5\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB86\"></a> <em class=\"strong\"> #prompt</em>- Prompts the user to define the duplicated material names action (default) \n                     			 \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB87\"></a> <em class=\"strong\"> #useXRefed</em>- Uses the material from the XRef. \n                     			 \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB88\"></a> <em class=\"strong\"> #useScene</em>- Uses the scene material. \n                     			 \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB89\"></a> <em class=\"strong\"> #autoRename</em>- Rename the material to avoid dupilication. \n                     			 \n                  </p> \n               </li>\n            </ul> \n            <p><em class=\"strong\">reparentAction:</em> (available in \n               		  <em class=\"strong\">3ds Max 2019.1 Update and higher</em>)\n               		\n            </p> <a name=\"UL_479F6A36DD72433E83E3704C09700DA8\"></a><ul>\n               <li><em class=\"strong\">#promptReparent</em> - Prompt the user to re-parent the xref (the default).\n                  		  \n               </li>\n               <li><em class=\"strong\">#alwaysReparent</em> - Always re-parent the xref, and do not prompt the user. This is the default if 3ds\n                  Max is running in quiet mode (for example, running as Max Batch). \n                  		  \n               </li>\n               <li><em class=\"strong\">#neverReparent</em> - Never reparent the xref, and do not prompt the user. \n                  		  \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB8B\"></a>In<em class=\"strong\"> 3ds Max 6 and higher, \n                  		  </em><span class=\"code\"> <em class=\"mild\">xrefs.addNewXRefObject</em> </span> returns undefined when the argument is a file with DRF extension. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB8D\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <p><a name=\"GUID-AA87D30E-615E-4490-A965-65204ED870FF\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F95\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">proxyFileName</em> String default: varies   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB8F\"></a>The file name of the proxy object. \n               		\n            </p> \n            <p><a name=\"GUID-9927BD7C-FEED-4187-8DD0-A5BF5D90FD6F\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F94\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">fileName</em> String default: varies </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB92\"></a>The file name of the non-proxy object. \n               		\n            </p> \n            <p><a name=\"GUID-BAFFD05E-B39F-47B2-8F25-A6FAAC634932\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F93\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">currentFileName</em> String default: varies </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB95\"></a>The file name of the non-proxy object if the \n               		  <span class=\"code\"> <em class=\"mild\">useProxy</em> </span> property is \n               		  <span class=\"code\"> <em class=\"mild\">false</em> </span>, the file name of the proxy object if the \n               		  <span class=\"code\"> <em class=\"mild\">useProxy</em> </span> property is \n               		  <span class=\"code\"> <em class=\"mild\">true</em> </span>. \n               		\n            </p> \n            <p><a name=\"GUID-1EEE0623-E7C8-40C9-AC8C-63CC4FF25130\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F92\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">objectName</em> String default: varies </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB98\"></a>The name of the non-proxy object. \n               		\n            </p> \n            <p><a name=\"GUID-51FA9743-E6FF-4C00-9943-9C6B64582544\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F91\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">proxyObjectName</em> String default: varies </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB9B\"></a>The name of the proxy object. \n               		\n            </p> \n            <p><a name=\"GUID-B5EBEFCC-9CD4-431A-A31F-8EDCF4653BA8\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F90\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">currentObjectName</em> String default: varies </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CB9E\"></a>The name of the non-proxy object if the \n               		  <span class=\"code\"> <em class=\"mild\">useProxy</em> </span> property is \n               		  <span class=\"code\"> <em class=\"mild\">false</em> </span>, the name of the proxy object if the \n               		  <span class=\"code\"> <em class=\"mild\">useProxy</em> </span> property is \n               		  <span class=\"code\"> <em class=\"mild\">true</em> </span>. \n               		\n            </p> \n            <p><a name=\"GUID-5A278043-33F0-4CAD-86AD-43DF95B11516\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F8F\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">useProxy</em> Boolean default: varies </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBA1\"></a>If \n               		  <span class=\"code\"> <em class=\"mild\">true</em> </span>, the proxy object will be displayed in the viewports, otherwise the non-proxy object\n               will be displayed. \n               		\n            </p> \n            <p><a name=\"GUID-A79FB642-67BF-41EC-A202-A7D4A7305F93\"></a>If the XRef object is added to the scene using the \n               		  <span class=\"code\"> <em class=\"mild\">xrefs.addNewXRefObject()</em> </span> method, this parameters default value will be \n               		  <span class=\"code\"> <em class=\"mild\">true</em> </span> if \n               		  <span class=\"code\"> <em class=\"mild\">#proxy</em> </span> is specified,<span class=\"code\"> <em class=\"mild\">false</em> </span> otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-384E2AEA-97D7-48EE-9939-6EC3830534C3\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F8E\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">renderProxy</em> Boolean default: false </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBA4\"></a>If \n               		  <span class=\"code\"> <em class=\"mild\">true</em> </span>, the proxy object will be rendered, otherwise the non-proxy object will be rendered.\n               \n               		\n            </p> \n            <p><a name=\"GUID-B96BF872-9744-4562-8C11-B26CF8B18A01\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F8D\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">updateMaterial</em> Boolean default: false </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBA7\"></a>If \n               		  <span class=\"code\"> <em class=\"mild\">true</em> </span>, sets the Update Material option on. \n               		\n            </p> \n            <p><a name=\"GUID-7F6C0D81-3FB7-4EEC-BB20-06AF3026402F\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F8C\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">ignoreAnimation</em> Boolean default: false </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBAA\"></a>If \n               		  <span class=\"code\"> <em class=\"mild\">true</em> </span>, sets the Ignore Animation option on. \n               		\n            </p> \n            <p><a name=\"GUID-8EE16E20-96F8-48D7-B47F-FB8958C46835\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F8B\"></a><pre>&lt;XRefObject&gt;.<em class=\"codeEmphasisStrong\">actualBaseObject</em> -- read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBAD\"></a>Returns the actual base object of the referenced object as opposed to the base object\n               of the XRefObject. \n               		\n            </p> \n            <p><a name=\"GUID-83D9B125-11A9-4397-AC67-F33B8AB265F5\"></a>If \'Use Proxy\' is turned on for the XRefObject, the proxy base object is returned\n               if a proxy object is defined, otherwise a value of \'undefined\' is returned. \n               		\n            </p> \n            <p><a name=\"GUID-33058344-064D-4CAE-B258-DB70F883B1C8\"></a>Available in<em class=\"strong\"> 3ds Max 8 and higher</em>. \n               		\n            </p> \n            <p><a name=\"GUID-F2295FE3-32CB-464F-A30A-37BF14EF4CFD\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBAE\"></a> <em class=\"strong\">Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F8A\"></a><pre><em class=\"codeEmphasisStrong\">updateXRef</em> &lt;XRefObject&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBB0\"></a>Reloads the XRef object. \n            </p> \n            <p><a name=\"GUID-35525A26-0A9C-4DFD-95F6-5137F2D8301F\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBB2\"></a>The following XRefObject interfaces are available in<em class=\"strong\"> 3ds Max 8 and higher</em>: \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AAA\"></a> \n            <h2><a name=\"GUID-7B972DAA-2409-405B-8A91-3B40469D40A6\"></a> <em class=\"strong\">XRefObject interfaces:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F89\"></a><pre>Interface:<em class=\"codeEmphasisStrong\">IXRefItem</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBB6\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F88\"></a><pre>.<em class=\"codeEmphasisStrong\">srcFileName</em> : filename : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBB8\"></a>Contains the source file name. \n               		\n            </p> \n            <p><a name=\"GUID-3E26422B-B505-4794-A3E4-389E0DD9189F\"></a>Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-9C0B8639-D5E4-4BCF-87CE-D4FF3A8E33AF\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F87\"></a><pre>.<em class=\"codeEmphasisStrong\">srcItemName</em> : string : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBBB\"></a>Contains the name of the source item. \n               		\n            </p> \n            <p><a name=\"GUID-A6EB1AF7-34F4-4B73-B95B-160BE0A352BF\"></a>Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-2233C216-69A0-4F0B-8804-B935C3C270A0\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F86\"></a><pre>.<em class=\"codeEmphasisStrong\">xrefRecord</em> : Interface : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBBE\"></a>Contains the XRef record Interface. \n               		\n            </p> \n            <p><a name=\"GUID-6FB4EC38-18F5-4443-BC27-289F51F14265\"></a>Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-D69D27DE-067B-4C3A-87BA-3A8F4E0AE3B9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F85\"></a><pre>.<em class=\"codeEmphasisStrong\">unresolved</em> : bool : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBC1\"></a>Contains true if the XRef is unresolved, false otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-AA3ADF4C-E507-4FE6-BA4F-E85A4380A26D\"></a>Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-CFFBFDD7-33EE-4CB1-B8A4-873501FBD920\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F84\"></a><pre>.<em class=\"codeEmphasisStrong\">nested</em> : bool : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBC4\"></a>Contains true if the XRef is nested, false otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-D63E6DBB-44C6-4E51-BF00-3C345B571546\"></a>Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-DD070F12-E713-415F-A398-8DE2BC553865\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBC6\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F83\"></a><pre>&lt;maxObject&gt;<em class=\"codeEmphasisStrong\">GetSrcItem</em> <em class=\"codeEmphasisStrong\">resolveNested</em>:&lt;bool&gt; \n\nresolveNested default value: false </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBC9\"></a>Returns the source item object of the XRef Object. \n               		\n            </p> \n            <p><a name=\"GUID-19DAD11D-98B6-4F19-A622-BC7A217B2FA2\"></a>If the object is being referenced from nested files (in other words, the object is\n               referenced from a Max file containing an XRef of the object from another file instead\n               of the actual object) and \n               		  <span class=\"code\"> <em class=\"strong\">resolveNested</em> </span> is set to true, nested XRef files will be resolved. \n               		\n            </p> \n            <p><a name=\"GUID-8F5BC1BE-B908-43E7-90D8-5F4D6851C717\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F81\"></a><pre>&lt;DWORD&gt;<em class=\"codeEmphasisStrong\">GetParentItems</em> &lt;&amp;maxObject array&gt;parentItems \n\nparentItems is Out parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBCD\"></a>Returns an array of parent items in the by-reference Out parameter. \n               		\n            </p> \n            <p><a name=\"GUID-54C6522A-4F92-4F7C-A4B6-401AAB67AF9B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F7F\"></a><pre>&lt;DWORD&gt;<em class=\"codeEmphasisStrong\">GetRootItems</em> &lt;&amp;maxObject array&gt;rootItems \n\nrootItems is Out parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBD1\"></a>Returns an array of root items in the by-reference Out parameter. \n               		\n            </p> \n            <p><a name=\"GUID-8EB05D33-CC17-48B6-A918-8FE3268851E6\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F7D\"></a><pre>&lt;DWORD&gt;<em class=\"codeEmphasisStrong\">GetChildItems</em> &lt;&amp;maxObject array&gt;childItems \n\nchildItems is Out parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBD5\"></a>Returns an array of child items in the by-reference Out parameter. \n               		\n            </p> \n            <p><a name=\"GUID-4C866C90-8E29-460D-94AE-B828F189A512\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F7B\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">GetNodes</em> &lt;&amp;node array&gt;xrefNodes \n\nxrefNodes is Out parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBD9\"></a>Returns an array of XRef nodes in the by-reference Out parameter. \n               		\n            </p> \n            <p><a name=\"GUID-1C3F20C6-4231-4AB8-B2F4-9CD05B013495\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F79\"></a><pre>Interface:<em class=\"codeEmphasisStrong\">IXRefProxy</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBDD\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F78\"></a><pre>.<em class=\"codeEmphasisStrong\">proxyFileName</em> : filename : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBDF\"></a>Contains the proxy file name.Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-F3B3087E-F347-42BB-8C06-FAD6ADB6C902\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F77\"></a><pre>.<em class=\"codeEmphasisStrong\">proxyItemName</em> : string : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBE2\"></a>Contains the proxy item name.Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-1E82B39C-5EAE-423A-9B7D-D28FD69E6A81\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F76\"></a><pre>.<em class=\"codeEmphasisStrong\">proxyRecord</em> : Interface : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBE5\"></a>Contains the proxy record Interface.Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-98E4A13D-984B-4945-B94D-6428547B5F4E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F75\"></a><pre>.<em class=\"codeEmphasisStrong\">displayProxy</em> : bool : Read|Write </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBE8\"></a>When set to True, the proxy will be used in the viewport. \n               		\n            </p> \n            <p><a name=\"GUID-17A9C54A-DB64-492F-9C1F-C20024211E5E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F74\"></a><pre>.<em class=\"codeEmphasisStrong\">renderProxy</em> : bool : Read|Write </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBEB\"></a>When set to True, the proxy will be used by the production renderer. \n               		\n            </p> \n            <p><a name=\"GUID-A18313A9-0C74-475B-B6BF-51FC6B394CE9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>.<em class=\"codeEmphasisStrong\">useLocal</em> : bool : Read|Write</pre></div> \n            <p><a name=\"GUID-3F0E5633-D2A6-4133-90DA-D50A2FD36CC8\"></a> Get/set the state of the \n               		  <em class=\"strong\">\"Enable/Use Local\"</em> property in the \n               		  <em class=\"strong\">\"Proxy Object\"</em> rollout. \n               		\n            </p> \n            <p><a name=\"GUID-09550138-B0EA-4155-AD53-23CB55B960B5\"></a> When set to False (default), the Proxy Object will not be used and the XRef content\n               will be loaded instead. \n               		\n            </p> \n            <p><a name=\"GUID-489A2456-EC8A-4CCE-9907-5CC55E20D98F\"></a> When set to True, the local Proxy Object will be loaded. \n               		\n            </p> \n            <p>Available in \n               		  <em class=\"strong\">3ds Max 2016 and higher</em>. \n               		\n            </p> \n            <p><a name=\"GUID-DFDACD17-BCBA-4656-BF6B-8FE4B2DE92BA\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F73\"></a><pre>Interface:<em class=\"codeEmphasisStrong\">IXRefObject</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBEF\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F72\"></a><pre>.<em class=\"codeEmphasisStrong\">activeFileName</em> : filename : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBF1\"></a>Contains the active file name.Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-10EAC655-7013-4B94-BC65-03A56AE7A52D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F71\"></a><pre>.<em class=\"codeEmphasisStrong\">activeObjName</em> : string : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBF4\"></a>Contains the active object name.Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-876F06FD-02B7-436D-A3EE-38C69C574148\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F70\"></a><pre>.<em class=\"codeEmphasisStrong\">activeRecord</em> : Interface : Read </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBF7\"></a>Contains the active record Interface.Read-only. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBF9\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F6F\"></a><pre>&lt;maxObject&gt;<em class=\"codeEmphasisStrong\">GetSourceObject</em> &lt;bool&gt;resolveNestedXRef <em class=\"codeEmphasisStrong\">modifiers</em>:&lt;&amp;maxObject array&gt; \n\nmodifiers default value: #() \nmodifiers is Out parameter </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CBFD\"></a>Returns the source object. The optional modifiers: by-reference parameter will return\n               the array of modifiers applied to the source object. \n               		\n            </p> \n            <p><a name=\"GUID-43CB4444-8864-4153-8024-E76F766C31D5\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-5628\"></a> <span class=\"char_link\"><a href=\"GUID-AB920CA1-5DC2-44F5-9B3C-2B6D5047AC8A.htm\">Node Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CC01\"></a> <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8CC02\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";