var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-8CEABA20-9D21-4ED0-AA95-3749435D2104\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSObject - Value\">\n      <meta name=\"indexterm\" content=\"NURBSCurve - NURBSObject\">\n      <meta name=\"indexterm\" content=\"evalTangent()\">\n      <meta name=\"indexterm\" content=\"evalPos()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSCurve : NURBSObject</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8CEABA20-9D21-4ED0-AA95-3749435D2104\"></a><div class=\"head\">\n            <h1>NURBSCurve : NURBSObject </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4611\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4610\"></a>    This is the parent class for all the NURBS curve classes and so is not directly constructable.\n               The class describes the common properties of all NURBS curves. This includes its open/closed\n               state, and number of trim points. The <span class=\"code\"> <em class=\"strong\">evalPos()</em> </span> and <span class=\"code\"> <em class=\"strong\">evalTangent()</em> </span> methods are used to compute points and tangents on the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-460B\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-460A\"></a>All NURBS curve classes have the following properties: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-221C\"></a><pre>&lt;nurbscurve&gt;.<em class=\"codeEmphasisStrong\">isClosed</em> : boolean, read-only 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4608\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if the curve is closed, <span class=\"code\"> <em class=\"strong\">false</em> </span> if open. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-221B\"></a><pre>&lt;nurbscurve&gt;.<em class=\"codeEmphasisStrong\">numTrimPoints</em> : integer, read-only   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4605\"></a>The number of trim points in the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-221A\"></a><pre>&lt;nurbscurve&gt;.<em class=\"codeEmphasisStrong\">parameterRangeMin</em> : float, read-only &lt;nurbscurve&gt;.  <em class=\"codeEmphasisStrong\">parameterRangeMax</em> : float, read-only </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4601\"></a>Contains the minimum and maximum valid values for <span class=\"code\"> <em class=\"strong\">&lt;u_parm&gt;</em> </span> in the methods associated with NURBS Curves. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2219\"></a><pre>&lt;nurbscurve&gt;.<em class=\"codeEmphasisStrong\">matID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45FE\"></a>The material ID assigned to the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45FC\"></a> <em class=\"strong\">Methods</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45FB\"></a>All NURBS curve classes have the following methods: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2218\"></a><pre><em class=\"codeEmphasisStrong\">evalPos</em> &lt;nurbscurve&gt; &lt;u_param&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45F9\"></a>Returns the position in space of the given parametric point along the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2217\"></a><pre><em class=\"codeEmphasisStrong\">evalTangent</em> &lt;nurbscurve&gt; &lt;u_param&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45F6\"></a>Returns the tangent vector at the given parametric point along the curve. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45F3\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45F2\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";