var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-930627BF-AC41-4033-9768-64CC5A1CE684\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"logsystem struct\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Log System</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-930627BF-AC41-4033-9768-64CC5A1CE684\"></a><div class=\"head\">\n            <h1>Log System </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AF8\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AF7\"></a>  <em class=\"strong\">System Globals:</em> \n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">logsystem.getNetLogFileName()</em> </pre></div> \n            <p>Returns the current log filename. \n               		\n            </p> <a name=\"TABLE_822BC8869C2547979F9F65E42FCEF4ED\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\nlogsystem.getNetLogFileName()\n\"C:\\Users\\Garfield\\AppData\\Local\\Autodesk\\3dsMax\\2017 - 64bit\\ENU\\Network\\Max.log\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">logsystem.longevity</em> SystemGlobal:longevity default:#size</pre></div> \n            <p>Gets/sets the log file longevity mode. Available in \n               		  <em class=\"strong\">3ds Max 2017 and higher</em>. \n               		\n            </p> \n            <p>This setting corresponds to the Customize &gt; Preferences &gt; Files &gt; “Log File Maintenance”\n               radio buttons state. \n               		\n            </p> \n            <p>Possible values are: \n               		\n            </p> <a name=\"UL_EE9BB25457C040EF9F40FBAFB55CDE5A\"></a><ul>\n               <li><em class=\"strong\">#forever</em> : Keep the log entries forever, ignore both \n                  			 <span class=\"code\">logsystem.logSize</span> and \n                  			 <span class=\"code\">logsystem.logDays</span> \n               </li>\n               <li><em class=\"strong\">#days</em> : Use the \n                  			 <span class=\"code\">logsystem.logDays</span> value \n                  		  \n               </li>\n               <li><em class=\"strong\">#size</em> (default): Use the \n                  			 <span class=\"code\">logsystem.logSize</span> value \n                  		  \n               </li>\n            </ul> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">logsystem.logDays</em> SystemGlobal:logDays default:30</pre></div> \n            <p> Gets/sets the number of days to keep the log file entries. Corresponds to the \n               		  <span class=\"MenuCascade\">Customize &gt; Preferences &gt; Files &gt; Log File Maintenance &gt; “Maintain only XX Days”</span> option. Available in \n               		  <em class=\"strong\">3ds Max 2017 and higher</em>. \n               		\n            </p> \n            <p>Used when \n               		  <span class=\"code\">logsystem.longevity</span> is set to #days. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">logsystem.logSize</em> SystemGlobal:logSize default:256</pre></div> \n            <p> Gets/sets the maximum log file size in Kilobytes to keep. Corresponds to the \n               		  <span class=\"MenuCascade\">Customize &gt; Preferences &gt; Files &gt; Log File Maintenance &gt; “Maintain only XX Kbytes”</span> option. Available in \n               		  <em class=\"strong\">3ds Max 2017 and higher</em>. \n               		\n            </p> \n            <p>Used when \n               		  <span class=\"code\">logsystem.longevity</span> is set to #size, which is the default mode. \n               		\n            </p> \n            <p> &nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AEE\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6952\"></a><pre><em class=\"codeEmphasisStrong\">logsystem</em>.<em class=\"codeEmphasisStrong\">logEntry</em> &lt;string&gt; [<em class=\"codeEmphasisStrong\">debug</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">info</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">warning</em>:&lt;bool&gt;] [<em class=\"codeEmphasisStrong\">error</em>:&lt;bool&gt;]\n<em class=\"codeEmphasisStrong\">logsystem</em>.<em class=\"codeEmphasisStrong\">logEntry</em> &lt;string&gt; &lt;enum&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AEC\"></a>Outputs the string to the log file, based on the various type keyword parameters,\n               or enum value. \n               		\n            </p> \n            <p> The possible enum values are: \n               		  <em class=\"strong\">#error</em>, \n               		  <em class=\"strong\">#warning</em>, \n               		  <em class=\"strong\">#info</em>, \n               		  <em class=\"strong\">#debug</em>. Available in \n               		  <em class=\"strong\">3ds Max 2017.1 Update and higher</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AEB\"></a>Default values are: \n               		  <em class=\"strong\">debug:true, info:false, warning:false, error:false</em>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AEA\"></a>Output to the log file is filtered by the settings in the Preference Settings dialog,\n               Files tab. \n               		\n            </p> <a name=\"TABLE_F225AA4310764668B9C1025DC2B74109\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\nlogsystem.logEntry \"My Warning Message\" warning:true\nlogsystem.logEntry \"My Warning Message\" #warning\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-19F76A35-BDF8-43C7-8026-A4671A7EBB22\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">logsystem.logName</em> &lt;filename&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AE7\"></a>Sets an extra log file to the given filename. This log file is not persistent. This\n               log file is in addition to the normal log file, which can be accessed via \n               		  <span class=\"code\">logsystem.getNetLogFileName()</span> (below). \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AE6\"></a>If the log file was created successfully, returns the new log name. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AE5\"></a>If the new file creation failed, returns the current log file name. \n               		\n            </p> \n            <p>If the given filename already exists, its contents are over-written. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AE4\"></a>Available in \n               		  <em class=\"strong\">3ds Max 9</em> and higher. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AE2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AE1\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6950\"></a><pre>\nlogsystem.logName \"c:\\\\extra.log\"\n\"c:\\extra.log\"\nlogsystem.logName \"z:\\\\extra.log\" --Z: does not exist, keeps old log\n\"c:\\extra.log\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p> &nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">logsystem.setLogLevel</em> <em class=\"codeEmphasisStrong\">debug</em>:&lt;bool&gt; <em class=\"codeEmphasisStrong\">info</em>:&lt;bool&gt; <em class=\"codeEmphasisStrong\">warning</em>:&lt;bool&gt; <em class=\"codeEmphasisStrong\">error</em>:&lt;bool&gt;\n<em class=\"codeEmphasisStrong\">logsystem.setLogLevel</em> &lt;<em class=\"codeEmphasisStrong\">#error</em> | <em class=\"codeEmphasisStrong\">#warning</em> | <em class=\"codeEmphasisStrong\">#info</em> | <em class=\"codeEmphasisStrong\">#debug</em>&gt; &lt;bool&gt;</pre></div> \n            <p> Sets the specified logging levels on or off. For any logging levels not specified,\n               the existing setting is retained. Available in \n               		  <em class=\"strong\">3ds Max 2017.1 Update and higher</em>. \n               		\n            </p> \n            <p> <a name=\"TABLE_EC8FD558F5D1416689448A4B9A0F15CC\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>\nlogsystem.setLogLevel error:true warning:true info:false debug:false\nlogsystem.setLogLevel #debug false\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6951\"></a><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">logsystem.getLogLevel</em> &lt;<em class=\"codeEmphasisStrong\">#error</em> | <em class=\"codeEmphasisStrong\">#warning</em> | <em class=\"codeEmphasisStrong\">#info</em> | <em class=\"codeEmphasisStrong\">#debug</em>&gt;</pre></div> \n            <p>Gets the status (on or off) for the specified logging level. Available in \n               		  <em class=\"strong\">3ds Max 2017.1 Update and higher</em>. \n               		\n            </p> <a name=\"TABLE_94BDDE244D6A453A90CC8BE60CE1F2FD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\nerrorLoggingEnabled = logsystem.getLogLevel #error\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">logsystem.saveState()</em> </pre></div> \n            <p>Saves the state of the log system preferences. Normally, changing the log system settings\n               like \n               		  <span class=\"code\">logsystem.longevity</span> will only affect the current 3ds Max session. Available in \n               		  <em class=\"strong\">3ds Max 2017 and higher</em> \n            </p> \n            <p>Calling this function will commit the changes to stick between 3ds Max sessions. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">logsystem.loadState()</em></pre></div> \n            <p> <img src=\"../images/GUID-21C87158-BBA7-4B63-B8F7-CB9BA17CA2CA-low.gif\"> <span class=\"char_link\"><a href=\"GUID-F90290FA-90A2-4720-B9FE-A4CCE0446252.htm\">NEW</a></span><em class=\"strong\"> in 3ds Max 2020:</em> Loads previously saved log system preferences. \n               		\n            </p> \n            <p><a name=\"GUID-88803524-9C7C-4C5D-8D2F-F2CB84EB4C89\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">logsystem.enabled</em> default:true</pre></div> \n            <p> <img src=\"../images/GUID-21C87158-BBA7-4B63-B8F7-CB9BA17CA2CA-low.gif\"> <span class=\"char_link\"><a href=\"GUID-F90290FA-90A2-4720-B9FE-A4CCE0446252.htm\">NEW</a></span><em class=\"strong\"> in 3ds Max 2020:</em> This property gets or sets whether the log system is enabled. If false, there is\n               no output saved to the log file from the log system. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6953\"></a><pre><em class=\"codeEmphasisStrong\">logsystem.quietMode</em> default:false</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AF4\"></a>Lets you get and set whether error logging quiet mode is enabled. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AF3\"></a>A Boolean value set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> when you do not want error messages from the renderer to bring up dialog boxes. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AF2\"></a>If set to \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>, error messages from the renderer will bring up dialog boxes. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AF1\"></a>3ds Max sets the corresponding internal variable to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> during network rendering to suppress error messages such as the \"Missing Maps\" and\n               \"Missing Map Coordinates\" dialogs. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AF0\"></a>If this variable is set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> and the renderer generates an error message, the renderer will exit. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AEF\"></a>After setting quiet mode, do not forget to clear it when you are done, since the user\n               will not see any error messages from the renderer while quiet mode is enabled. \n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1AD9\"></a> <span class=\"char_link\"><a href=\"GUID-141213A1-B5A8-457B-8838-E602022C8798.htm#WS73099CC142F487553098682E12AC2FC2BC7-6242\">logsystem.quietmode System Global Variable</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";