var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-9394C031-25FB-434B-A744-A587C5D99C6A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"working with\">\n      <meta name=\"indexterm\" content=\"useEnvironmentMap\">\n      <meta name=\"indexterm\" content=\"environmentMap\">\n      <meta name=\"indexterm\" content=\"backgroundColor\">\n      <meta name=\"indexterm\" content=\"atmospheric effects: working with\">\n      <meta name=\"indexterm\" content=\"ambientColorController\">\n      <meta name=\"indexterm\" content=\"ambientColor\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Working with Atmospherics</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9394C031-25FB-434B-A744-A587C5D99C6A\"></a><div class=\"head\">\n            <h1>Working with Atmospherics </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-66F1\"></a>The following script shows an example of creating Volume Fog and Volume Light atmospherics.\n            \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-66F0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-66EF\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em>        \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2A29\"></a><pre>\n-- Atmospheric Effects Test Bed\n-- create a geosphere, sphere gizmo, onnilight, and targetted camera\ngeos=geosphere radius:24\nsgizmo=spheregizmo radius:40\nomni=omnilight farAttenStart:20 farAttenEnd:100 useFarAtten:true v=255\ncam=targetcamera pos:[150,-50,100] target:(targetobject())\n--\n-- put a material on the geosphere\ngeos.material=standard ()\ngeos.material.selfIllumColor = color 238 241 2\n--\n-- create a Volume Fog atmospheric. Set name so it has one in Environment dialog.\nvf=volume_fog name:\"VolFog\" soften_gizmo_edges:0.7 exponential:1 density:75\nvf.fog_color=color 255 157 0\nvf.noise_type=2\nvf.size=4\nappendGizmo vf sgizmo\naddAtmospheric vf\n--\n-- create a Volume Light atmospheric. Set name so it has one in Environment dialog.\nvl=volume_light name: \"VolLight\" exponential:1 density:20\nvl.fog_color=color 255 30 0\nvl.attenuation_color= color 255 162 0\nvl.Use_Attenuation_Color=1\nvl.noise_on=1\nvl.Noise_Amount=1\nvl.size=5\nvl.noise_type=2\nappendGizmo vl omni\naddAtmospheric vl\n--\n-- and render away...\nrenderWidth=320\nrenderHeight=200\nrender camera:cam\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-66C6\"></a> <span class=\"char_link\"><a href=\"GUID-E381CF5E-1D82-4C04-B870-5ECB9E2052BD.htm\">Atmospheric : MAXWrapper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-66C5\"></a> <span class=\"char_link\"><a href=\"GUID-ADB08F34-E0EE-4FDE-BEDC-B3A6CB6393C7.htm\"> Atmospheric Effects Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-66C4\"></a> <span class=\"char_link\"><a href=\"GUID-B301B3D1-B5C6-4EB5-9E36-B7134007BBD6.htm\"> Atmospheric Effect Types</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-66C3\"></a> <span class=\"char_link\"><a href=\"GUID-A0CD6389-178C-4417-8D9F-43C4FC6CE8E3.htm\">Environment And Effects Dialog</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-66C2\"></a> <span class=\"char_link\"><a href=\"GUID-27B7B613-AE4B-48C5-B26B-FB7D8369299C.htm\"> envEffectsDialog - Open and Close the Environment and Effects dialog</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";