var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-9588A886-A811-4C05-9A07-B6A68C969050\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MAXScript Source Filename Access\">\n      <meta name=\"indexterm\" content=\"getThisScriptFilename()\">\n      <meta name=\"indexterm\" content=\"getSourceFileOffset()\">\n      <meta name=\"indexterm\" content=\"getSourceFileName()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXScript Source Filename Access</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9588A886-A811-4C05-9A07-B6A68C969050\"></a><div class=\"head\">\n            <h1>MAXScript Source Filename Access </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F68\"></a>    These methods allow a script to query the source file it has been run from and the\n            position inside the source file: \n         </p>\n         <p><a name=\"GUID-6D549824-E7FF-4BB9-A72A-E305675BDE26\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69D6\"></a><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">getSourceFileName</em>() 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F62\"></a>Returns the <em class=\"strong\">filename path</em> of the source file the function has been called from. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F61\"></a>Returns undefined if the call does not occur from a valid MAXScript file, for example\n            if executed in the Listener. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F60\"></a>Returns empty string or file path without a file name if called from an Untitled (not\n            yet saved) file. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F5F\"></a>If the method has been called from inside a string evaluated using the <span class=\"code\"> <em class=\"strong\">execute()</em> </span> method, the result will still be the file the <span class=\"code\"> <em class=\"strong\">execute()</em> </span> has been called from. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F5E\"></a>Available in <em class=\"strong\">3ds Max 9</em> and higher. \n         </p>\n         <p><a name=\"GUID-34931FC0-8876-4030-8C42-AAC0AFABB542\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69D5\"></a><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">getThisScriptFilename</em>()   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F5B\"></a>Returns the filename associated with the calling script. Same as <span class=\"code\"> <em class=\"strong\">getSourceFileName()</em> </span>, added mainly for backwards compatibility with pre-Max 9 scripts using the <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F5A\"></a>Available in <em class=\"strong\">3ds Max 2008</em> and higher. Previously available in <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-FCA82D92-219D-4732-B6B8-11F86FC1DD6C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69D4\"></a><pre>&lt;integerPtr&gt;<em class=\"codeEmphasisStrong\">getSourceFileOffSet</em>() </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F57\"></a>Returns the <em class=\"strong\">character position</em> in the source script file, \'undefined\' if not called from a source script file. The\n            return value is <span class=\"char_link\"><a href=\"GUID-20409BF0-2192-4551-AB01-EA46E1DE51EE.htm\">IntegerPtr</a></span> to ensure that the position would be valid even with files over 4GB. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F56\"></a>Available in <em class=\"strong\">3ds Max 9</em> and higher. \n         </p>\n         <p><a name=\"GUID-F3E10051-5291-4CE4-BA8F-F22ACF04CAC4\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69D3\"></a><pre>&lt;integerPtr&gt;<em class=\"codeEmphasisStrong\">getSourceFileLine</em>() </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F53\"></a>Returns the <em class=\"strong\">code line</em> in the source script file, \'undefined\' if not called from a source script file, for\n            example if executed from the Listener.The return value is <span class=\"char_link\"><a href=\"GUID-20409BF0-2192-4551-AB01-EA46E1DE51EE.htm\">IntegerPtr</a></span> to ensure that the line number would be valid even with files over 4GB. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F52\"></a>Available in <em class=\"strong\">3ds Max 2010</em> and higher. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F50\"></a> <span class=\"char_link\"><a href=\"GUID-1B1833F0-8712-4EA5-AFFA-3E42DBF7960C.htm\">The MAXScript Debugger</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";