var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-95AD6CEA-8A88-4D54-834B-3FB89945DFAC\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>System Tools</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-95AD6CEA-8A88-4D54-834B-3FB89945DFAC\"></a><div class=\"head\">\n            <h1>System Tools </h1>\n         </div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F35\"></a>This group of functions lets you gather various pieces of information about the system\n            \n            		<em class=\"strong\">3ds Max</em> is running on. \n            	 \n         </p>\n         <p><a name=\"GUID-6446941A-3268-4994-8EA9-0078EDBD1256\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50CD\"></a><pre><em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">NumberOfProcessors</em>()   </pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F33\"></a>Returns the number of processors (cores) available according to the operating system.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-5E48C0C4-721D-41B9-9639-EC0AF052FF0B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50CC\"></a><pre><em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">GetScreenWidth</em> [ <em class=\"codeEmphasisStrong\">removeUIScaling</em>:&lt;true&gt; ]</pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F31\"></a>Returns the screen width including multiple monitors the desktop might be extended\n            to. \n            	 \n         </p>\n         <p>The optional \n            		<span class=\"code\"><em class=\"strong\">removeUIScaling</em></span> parameter indicates whether to remove scaling on high-DPI displays. \n            	 \n         </p>\n         <p><a name=\"GUID-38C458AB-55E8-404F-86D1-CE0C4F9B6B4A\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50CB\"></a><pre><em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">GetScreenHeight</em> [ <em class=\"codeEmphasisStrong\">removeUIScaling</em>:&lt;true&gt; ]</pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F2F\"></a>Returns the screen height including multiple monitors the desktop might be extended\n            to. \n            	 \n         </p>\n         <p>The optional \n            		<span class=\"code\"><em class=\"strong\">removeUIScaling</em></span> parameter indicates whether to remove scaling on high-DPI displays. \n            	 \n         </p>\n         <p><a name=\"GUID-02B85D2A-2ADC-44F8-AABD-E91B069F025F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50CA\"></a><pre><em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">IsWindows98or2000</em>() </pre></div>\n         <p>In versions \n            		<em class=\"strong\">prior to 3ds Max 2017</em>, returned True if the Operating System is Windows98, Windows2000, Windows XP, Windows\n            Vista or Windows 7. \n            	 \n         </p>\n         <p><a name=\"GUID-D4336717-CDE1-46B2-9F3A-555E9E80AA77\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50C9\"></a><pre><em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">IsWindows9x</em>() </pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F2B\"></a>In versions \n            		<em class=\"strong\">prior to 3ds Max 2017</em>, returned True if the OS is a Win9x flavor. \n            	 \n         </p>\n         <p><a name=\"GUID-87D6141E-5BB0-465C-B6B0-2387219DAF15\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">GetOSVersion</em>() </pre></div>\n         <p> Returns the OS version as a three part array representing the major version, the\n            minor version, and the build number. This function works for all versions of Windows\n            that 3ds Max supports. \n            	 \n         </p>\n         <p>Available \n            		<em class=\"strong\"> in 3ds Max 2019.1 Update and higher</em>.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50C8\"></a><pre>&lt;boolean&gt; <em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">IsDebugging</em>() </pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F29\"></a>Returns True if running in a Debugger. \n            	 \n         </p>\n         <p><a name=\"GUID-D4279AE0-6159-4DF6-8648-7232106D2799\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;string&gt; <em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">GetBuildNumber</em>() </pre></div>\n         <p> Returns string in the form \"#.#.#.#\" where the numbers are the major version, the\n            update version, the hot fix number, and the build number. This is the same string\n            displayed as Product Version for \n            		<span class=\"filePath\">3dsmax.exe</span> in \n            		<em class=\"strong\">File Properties</em> and at the top of the \n            		<em class=\"strong\">About 3ds Max</em> dialog. \n            	 \n         </p>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2018 and higher</em>. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">DebugPrint</em> &lt;string&gt; </pre></div>\n         <p>Prints the specified string to the debug output window of Visual Studio. \n            	 \n         </p>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2011 and higher</em>. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">sceneIODebugEnabled</em> &lt;boolean&gt; </pre></div>\n         <p> Specifies whether scene IO debugging is enabled. If true, information on scene load\n            is sent to the log system. \n            	 \n         </p>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2018 and higher</em>. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;boolean&gt; <em class=\"codeEmphasisStrong\">systemTools</em>.<em class=\"codeEmphasisStrong\">isDebugBuild</em> </pre></div>\n         <p> Returns true if this is a debug build of 3ds Max, false otherwise. \n            	 \n         </p>\n         <p>Available in \n            		<em class=\"strong\"> in 3ds Max 2019.2 Update and higher.</em> \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50C7\"></a><pre><em class=\"codeEmphasisStrong\">systemTools.getEnvVariable</em> &lt;string&gt; </pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F27\"></a>Returns the contents of specified environment variable. If the specified environment\n            variable does not exist, returns a value of undefined. \n            	 \n         </p>\n         <p><a name=\"GUID-0DC2B856-099C-405E-9A88-3390FCF71E61\"></a>Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F26\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F25\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50C6\"></a><pre>\nsystemTools.getEnvVariable \"PATH\"\n\"C:\\WINDOWS\\system32;C:\\WINDOWS;C:\\WINDOWS\\System32\\Wbem;C:\\Program Files\\Common Files\\Autodesk Shared\\;C:\\Program Files\\backburner 2\\;\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-776B6860-901C-436F-BE95-CD30A78B21BE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50C5\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">systemTools.setEnvVariable</em> &lt;string&gt; { &lt;string&gt; | undefined } </pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F22\"></a>Sets the contents of specified environment variable. \n            	 \n         </p>\n         <p><a name=\"GUID-E85EE9EC-6C47-4E3A-AEB3-56F0085AB0FE\"></a>Returns True if the set occurred, False if not. \n            	 \n         </p>\n         <p><a name=\"GUID-CC437173-057C-40A4-9547-F9BDDBA24322\"></a>If the second argument is the value undefined, the environment variable is deleted.\n            \n            	 \n         </p>\n         <p><a name=\"GUID-BDA49452-6AAD-41E8-8AE0-530962019236\"></a>Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <p><a name=\"GUID-5921E2FF-D200-4DA5-8B59-1FFB7358E003\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">systemTools.GetRegistryKeyBase()</em></pre></div>\n         <p> Returns the base product registry key in the form: \"SOFTWARE\\&lt;Company Name&gt;\\&lt;Product\n            Name&gt;\\&lt;version&gt;\". The application uses this key as the base for storing registry settings.\n            \n            	 \n         </p>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2018 and higher</em>. \n            	 \n         </p>\n         <p>For example: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>systemTools.GetRegistryKeyBase()\n--&gt; \"SOFTWARE\\Autodesk\\3dsMax\\21.0\"</pre></div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;int&gt;<em class=\"codeEmphasisStrong\">systemTools.getmaxstdio()</em></pre></div>\n         <p><a name=\"GUID-2256DA80-2DD2-492E-AB3F-D69E25CFC5C6\"></a> Returns the number of simultaneously open files permitted at the stdio level (i.e.\n            via fopen). \n            	 \n         </p>\n         <p><a name=\"GUID-52EB3ECB-4852-44EE-B25B-FDB45E5E0A45\"></a>Available in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-E41644B4-38A5-407F-9EA3-CD6C51BC44D2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;int&gt;<em class=\"codeEmphasisStrong\">systemTools.setmaxstdio</em> &lt;int newmax&gt;</pre></div>\n         <p><a name=\"GUID-1A9AED08-B6F6-4BEE-858B-8FD707021880\"></a> Sets the maximum number of simultaneously open files at the stdio level (i.e. via\n            fopen). \n            	 \n         </p>\n         <p><a name=\"GUID-94AF9E81-2579-44D0-A64E-00BF739E212A\"></a>The valid range for the \n            		<span class=\"code\">newmax</span> argument is between 512 and 2048. \n            	 \n         </p>\n         <p><a name=\"GUID-FE1315AA-4A4D-45F9-983C-B99D217AA6EC\"></a>Returns the new maximum value if successful. \n            	 \n         </p>\n         <p><a name=\"GUID-DECF48B8-EBDC-43FB-8BE2-41FF357A26BD\"></a>Currently, only increasing the value is allowed. \n            	 \n         </p>\n         <p><a name=\"GUID-1D007796-2BFA-49F2-B49A-70EDBEE420F0\"></a>Returns -1 if attempting to reduce the maximum count. \n            	 \n         </p>\n         <p><a name=\"GUID-45182EC2-53F7-4248-957B-90CC4EC67D5A\"></a>This could be used for example to allow more Point Cache files to be read in parallel\n            at the same time. \n            	 \n         </p>\n         <p><a name=\"GUID-8D0AB970-3626-4662-99D7-D3C984FAB992\"></a>Available in \n            		<em class=\"strong\">3ds Max 2014 and higher</em>. \n            	 \n         </p>\n         <p><a name=\"GUID-E5D01590-2C2C-42DB-89CA-36A0594C2155\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;int&gt;<em class=\"codeEmphasisStrong\">systemTools.getSystemMetrics</em> &lt;int&gt;</pre></div>\n         <p> Calls the win32 \n            		<span class=\"code\">GetSystemMetrics()</span> function, passing in the specified value. The return value is the return value from\n            \n            		<span class=\"code\">GetSystemMetrics()</span>. See the Win32 documentation for \n            		<span class=\"code\">getSystemMetrics</span> for parameter values. Available in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>. \n            	 \n         </p><a name=\"TABLE_498C6970DDAD41F28C8FBD888CB8AD2D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\n-- get client window width\nsystemTools.getSystemMetrics 16\n--&gt;1920\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">systemTools.isAeroEnabled</em>()</pre></div>\n         <p>Returns True if the Windows Aero theme is enabled, False if using the Windows Classic\n            theme on Windows 7. Available in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">systemTools.IsGpuPresent</em>()</pre></div>\n         <p> Returns true if at least one GPU is present on the current system, false otherwise.\n            \n            	 \n         </p>\n         <p>Available in \n            		<em class=\"strong\">in 3ds Max 2018 and higher</em>. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;array&gt;<em class=\"codeEmphasisStrong\">systemTools.EnumDisplayDevices</em> [ <em class=\"codeEmphasisStrong\">removeUIScaling</em>:&lt;true&gt; ]</pre></div>\n         <p> Returns an array of arrays, where each element in the outer array corresponds to\n            a display device. For each display device, the array contains the device ID, the device\n            name, the device string, the device state flags, and the device key. If the device\n            is attached to the desktop, the array also contains the device\'s top left x and y\n            pixel coordinates and its width and height. The pixel coordinates are 0-based. Available\n            in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>. \n            	 \n         </p>\n         <p> See MSDN documentation of \n            		<span class=\"code\">EnumDisplayDevices</span> for more information on display devices. \n            	 \n         </p><a name=\"TABLE_084809303F8A4A21AA27486AAD530E06\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\ndevices= systemTools.EnumDisplayDevices removeUIScaling:true\n	 for d in devices do print d #nomap\n	 #(\"\\\\.\\DISPLAY1\", \"NVIDIA Quadro FX 4800\", 5, \"PCI\\VEN_10DE&amp;DEV_05FE&amp;SUBSYS_059410DE&amp;REV_A1\", \"\\Registry\\Machine\\System\\CurrentControlSet\\Control\\Video{8A328D59-1288-485D-821D-7DA906E41335}\\0000\", 0, 0, 1920, 1080)\n	 #(\"\\\\.\\DISPLAY2\", \"NVIDIA Quadro FX 4800\", 1, \"PCI\\VEN_10DE&amp;DEV_05FE&amp;SUBSYS_059410DE&amp;REV_A1\", \"\\Registry\\Machine\\System\\CurrentControlSet\\Control\\Video{8A328D59-1288-485D-821D-7DA906E41335}\\0001\", 1920, 0, 1920, 1080)\n	 #(\"\\\\.\\DISPLAYV1\", \"RDPDD Chained DD\", 2097160, \"\", \"\\Registry\\Machine\\System\\CurrentControlSet\\Control\\Video{DEB039CC-B704-4F53-B43E-9DD4432FA2E9}\\0000\")\n	 #(\"\\\\.\\DISPLAYV2\", \"RDP Encoder Mirror Driver\", 2097160, \"\", \"\\Registry\\Machine\\System\\CurrentControlSet\\Control\\Video{42cf9257-1d96-4c9d-87f3-0d8e74595f78}\\0000\")\n	 #(\"\\\\.\\DISPLAYV3\", \"RDP Reflector Display Driver\", 2097160, \"\", \"\\Registry\\Machine\\System\\CurrentControlSet\\Control\\Video{b043b95c-5670-4f10-b934-8ed0c8eb59a8}\\0000\")\n	 OK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; <em class=\"codeEmphasisStrong\">GenerateMiniDumpAndContinue</em> <em class=\"codeEmphasisStrong\">sendDump</em>:&lt;false&gt; </pre></div>\n         <p> Available \n            		<em class=\"strong\">in 3ds Max 2018.2 Update and higher</em>: Generate a MiniDump file and continue executing. If \n            		<em class=\"strong\">sendDump</em> is true, the minidump file is sent to Autodesk. \n            	 \n         </p>\n         <div><a name=\"GUID-E9108DFC-83A5-42A0-B4A2-B5FCFB053A43\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This method, and in particular the \n               		<em class=\"strong\">sendDump</em> argument is primarily for testing of minidump generation, and should not generally\n               be used. \n               	 \n            </div>\n         </div>\n         <p> The MiniDump file generated is located at \n            		<span class=\"filePath\">C:\\Users\\&lt;UserName&gt;\\AppData\\Local\\temp\\3dsmax_minidump.dmp</span>. \n            	 \n         </p>\n         <p> If a big MiniDump file is generated, it is located at \n            		<span class=\"filePath\">C:\\Users\\&lt;UserName&gt;\\AppData\\Local\\temp\\3dsmax_minidump_big.dmp</span>. \n            	 \n         </p>\n         <p>See also: \"Using 3ds Max Generated Minidump Files\" in the \n            		3ds Max Developer Guide. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt; <em class=\"codeEmphasisStrong\">SetMiniDumpContents</em> {#default | #basic | #medium | #full | &lt;int&gt;}</pre></div>\n         <p> Available \n            		<em class=\"strong\">in 3ds Max 2018.2 Update and higher</em>: Sets the contents of generated minidumps. The \n            		<span class=\"code\">#default</span> and \n            		<span class=\"code\">#medium</span> flags are equivalent. \n            	 \n         </p>\n         <p> The MiniDump flags set for each level are as follows (see link below for description\n            of the MiniDump flag values) : \n            	 \n         </p><a name=\"UL_C8B5B0A1BAA24CD18C9E23B103E5CB65\"></a><ul>\n            <li> #basic - MiniDumpNormal \n               		\n            </li>\n            <li>#medium - MiniDumpNormal | MiniDumpWithIndirectlyReferencedMemory \n               		\n            </li>\n            <li>#full - MiniDumpNormal | MiniDumpWithDataSegs | MiniDumpWithFullMemory | MiniDumpWithHandleData\n               | MiniDumpWithUnloadedModules | MiniDumpWithIndirectlyReferencedMemory | MiniDumpWithProcessThreadData\n               | MiniDumpWithPrivateReadWriteMemory | MiniDumpIgnoreInaccessibleMemory \n               		\n            </li>\n         </ul>\n         <p> If \n            		<span class=\"code\">&lt;int&gt;</span> is specified, the bits set correspond to the MiniDump flag values. \n            	 \n         </p>\n         <p>See also: \"Using 3ds Max Generated Minidump Files\" in the \n            		3ds Max Developer Guide. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>systemTools.<em class=\"codeEmphasisStrong\">SetBigMiniDumpContents</em> {#default | #basic | #medium | #full | #off | &lt;int&gt;</pre></div>\n         <p>Available \n            		<em class=\"strong\">in 3ds Max 2018.2 Update and higher</em>: Sets the contents of generated big minidumps. Normally this is set to \n            		<span class=\"code\">#off</span>. \n            	 \n         </p>\n         <div><a name=\"GUID-2A644E27-B002-47D0-B729-F435704688BC\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Big minidump files at \n               		<span class=\"code\">#full</span> setting can be quite large, sometimes more than 2GB. Use with caution. \n               	 \n            </div>\n         </div>\n         <p>See also: \"Using 3ds Max Generated Minidump Files\" in the \n            		3ds Max Developer Guide. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">For internal use only:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">systemTools.PB2_AllNoRefSafePointersTestingDisable</em> &lt;bool&gt;disable</pre></div>\n         <p>For internal use only. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">systemTools.PB2_AllNoRefSafePointersTestingDisables</em>()</pre></div>\n         <p> For internal use only. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">systemTools.allocateMemory</em>()</pre></div>\n         <p> For internal use only. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">systemTools.releaseMemory</em>()</pre></div>\n         <p>For internal use only. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F21\"></a> <span class=\"char_link\"><a href=\"GUID-D65AE3C0-0C12-4262-8807-B23CBED54508.htm\">Interaction With The Operating System</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7F20\"></a> <span class=\"char_link\"><a href=\"GUID-CAC36F27-CB51-4C9F-B265-167F636C9A4D.htm\">System Information</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";