var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-962137D0-2937-4A31-A3E0-2BBF8C365577\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Callbacks\">\n      <meta name=\"indexterm\" content=\"unRegisterTimeCallback()\">\n      <meta name=\"indexterm\" content=\"time change callback\">\n      <meta name=\"indexterm\" content=\"registerTimeCallback()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Time Change Callback Mechanism</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-962137D0-2937-4A31-A3E0-2BBF8C365577\"></a><div class=\"head\">\n            <h1>Time Change Callback Mechanism </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A14\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A0E\"></a>You can register one or more functions to be called whenever the current <em class=\"strong\">3ds Max</em> animation time is changed, such as when the user drags the time slider or plays the\n               animation. The following methods let you register and unregister these callbacks: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-693D\"></a><pre><em class=\"codeEmphasisStrong\">registerTimeCallback</em> &lt;fn&gt;</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-693C\"></a><pre><em class=\"codeEmphasisStrong\">unRegisterTimeCallback</em> &lt;fn&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A09\"></a>You can register as many functions as you like. Each one is individually called whenever\n               the time changes. The functions you register must take no arguments. They can access\n               the updated current time through the MAXScript system variable <span class=\"code\"> <em class=\"strong\">currentTime</em> </span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A08\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A07\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-693B\"></a><pre>\nfn time_p = print currentTime\nregisterTimeCallback time_p\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A02\"></a><p class=\"table-body\">In the above example, the registered function causes the current time to be printed\n                           in the Listener window whenever the user moves the time slider or plays the animation.\n                           \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1A00\"></a> <em class=\"strong\">Special Considerations</em> \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19FF\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19FD\"></a>If a runtime error occurs in a callback function while it is being executed, an error\n                     message is displayed and that callback function is permanently disabled. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19FB\"></a>The time callback is <em class=\"strong\">not</em> called during rendering, even if multiple frames are rendered. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19F9\"></a>The registered function is executed in a special context and not in the context of\n                     the code that created it. This means that the function cannot contain references to\n                     local variables in outer code nestings surrounding the function definition since those\n                     variables are on an execution stack that does not exist at the time the function is\n                     called. An important exception to this is utility and rollout panel locals, such as\n                     local functions, rollout variables and nested rollouts. You can refer to them in change\n                     handler code inside rollout code as they are associated directly with their rollout\n                     or utility object. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19F7\"></a>Note that it is the <em class=\"strong\">function value</em> that is being registered, not the function name or global variable. This means that\n                     redefining the same-named function after registering it does <em class=\"strong\">not</em> change the callback. You either need to unregister, re-define the function and then\n                     register it again, or make the registered function an intermediary which calls another\n                     function, \n                  </p> \n               </li>\n            </ul> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19F6\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19F5\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-693A\"></a><pre>\nfn time_cb = print currentTime\nfn tcb = time_cb()\nregisterTimeCallback tcb\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19EF\"></a><p class=\"table-body\">In this case, the registered callback function, <span class=\"code\"> <em class=\"strong\">tcb</em> </span>, calls the real call back, <span class=\"code\"> <em class=\"strong\">time_cb</em> </span>, (by referencing the global variable it is defined in), meaning you can redefine\n                           <span class=\"code\"> <em class=\"strong\">time_cb()</em> </span> as often as you need and the callback will always invoke the latest definition. This\n                           is a useful technique to employ while you are developing and debugging a callback.\n                           \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19EE\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19EA\"></a>Callback functions remain registered after loading a new file or performing a <em class=\"strong\">3ds Max</em> Reset. \n                  </p> \n               </li>\n            </ul> <a name=\"TABLE_920E2AF5A5CC49A5A9A6D19D29A98FBD\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.6900369003690034%\">\n                     <col width=\"41.25461254612546%\">\n                     <col width=\"55.055350553505534%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\" valign=\"middle\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\" colspan=\"2\" valign=\"middle\"> <a name=\"P_ED07EA625DB84FF1B6531A42779A8106\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_7D078F613BB7447F97C1D40213013E8D\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">Callback Notifications - Quick Navigation</a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19E6\"></a> <span class=\"char_link\"><a href=\"GUID-1BE2E978-72CF-495C-81D6-2B36E2C4FFC7.htm\">Change Handlers and Callbacks</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19E5\"></a> <span class=\"char_link\"><a href=\"GUID-513285B3-DBF6-471E-B587-B5BE14D4D875.htm\">Change Handlers and When Constructs</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19E4\"></a> <span class=\"char_link\"><a href=\"GUID-1961F536-7F01-4D72-930C-4B9432952B79.htm\">Viewport Redraw Callback Mechanism</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-19E3\"></a> <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";