var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-97C887B6-CE4D-46EB-AB10-BE3A9DC2F69A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"class id filter\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>class id filter</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-97C887B6-CE4D-46EB-AB10-BE3A9DC2F69A\"></a><div class=\"head\">\n            <h1>class id filter </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BD9\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BD8\"></a> In the Selection filters/Combos filter, you can add <span class=\"code\"> <em class=\"strong\">class id</em> </span> filters in addition to registering superclassid filters. The bottom left list box\n               displays a list of all helper and geometry class ids. To add a filter, select an entry\n               from the list and hit the add button below the list box. The filter will appear in\n               the lower right list box. This list displays all of the current class id filters.\n               Once OK is pressed, the select filter drop down contains those class ids that were\n               added. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BD6\"></a>You can also register custom scripted functions as filters through a callback in MAXScript:\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BD5\"></a> <em class=\"strong\">Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E07\"></a><pre><em class=\"codeEmphasisStrong\">registerSelectFilterCallback</em> &lt;filterFunction&gt; &lt;name&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BD3\"></a>Registers a custom selection filter. The 2 parameters are the filter function to be\n               registered and the name of the filter to appear in the selection filter drop down\n               list. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BD2\"></a>The filter function itself expects one parameter which is the node to be checked.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BD1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BD0\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BCF\"></a><p class=\"table-body\">If you want to filter only objects that are renderable (in other words have their\n                           node-level Renderable property set to true / Renderable box checked in Properties\n                           dialog), you can register the following function: \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E06\"></a><pre>\nfn filterRenderableCallback node = --the node to be filtered is passed as argument\n(\nnode.renderable --return true if the node is renderable\n)\n--Register the function as Select filter Callback function\n--The filter will appear under the name \"Renderable\":\nregisterSelectFilterCallback filterRenderableCallback \"Renderable\"\n--To see how it works, execute the code below to generate 10 boxes\n--with random .renderable state\nfor i = 1 to 10 do\nb = box pos:[i*30,0,0] renderable:((random 0.0 1.0) &lt;0.5 )\n--Now select the filter \"Renderable\" from the drop-down list and try\n--to select all 10 boxes - only those that are renderable will\n--be selected!\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BBB\"></a> <em class=\"strong\">Prototype:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E05\"></a><pre><em class=\"codeEmphasisStrong\">unregisterSelectFilterCallback</em> &lt;filterFunction&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BB9\"></a>Removes the specified callback function from the list of selection filters. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BB7\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BB6\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6E04\"></a><pre>\nunregisterSelectFilterCallback filterRenderableCallback\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BB0\"></a> <span class=\"char_link\"><a href=\"GUID-6EF57030-B59F-4341-B6AA-BFB4269AE913.htm\">Selection Filters and Display Filters</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3BAF\"></a> <span class=\"char_link\"><a href=\"GUID-408F43DA-6C99-4CF5-96D5-78836A5DCB02.htm\">Main Toolbar</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";