var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-9A522918-0517-4B04-80AF-F3FEFEE23448\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"redraw Context\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>redraw Context</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9A522918-0517-4B04-80AF-F3FEFEE23448\"></a><div class=\"head\">\n            <h1>redraw Context </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E870F1\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E870F4\"></a>While the expression within the <span class=\"code\"> <em class=\"strong\">redraw</em> &lt;boolean&gt;</span> context is being evaluated, screen redraws are completely disabled, and the modify\n               and motion panels are suspended. \n            </p> \n            <p><a name=\"P_DCC7A28E390142068293B816E84926E1\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E870F5\"></a>This is basically an exception safe form of \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60DB\"></a><pre><em class=\"codeEmphasisStrong\">disableSceneRedraw</em>(); &lt;expr&gt;; <em class=\"codeEmphasisStrong\">enableSceneRedraw</em>() 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E870F7\"></a>That is, if an exception is thrown in &lt; expr &gt;, the scene redraws will be automatically\n               re-enabled as part of the exception handling. \n            </p> \n            <p><a name=\"P_CB9A60EBE3D2421F81796F8602C7C46F\"></a>The modify and motion panels are suspended if they are the currently active command\n               panel. \n            </p> \n            <p><a name=\"P_FB6E211846E543DC826CC4236A4C4576\"></a>If the expression sets the current command panel to either modify or motion, the command\n               panel will not be suspended at that point. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E870F8\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E870F9\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE USAGE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60DA\"></a><pre>\nwith redraw off\nfor t=0 to 10 do\n(\nsliderTime=t\nexportFile (\"outfile_\"+(t as string)+\".dxf\") #noPrompt selectedOnly:true\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87104\"></a> <span class=\"char_link\"><a href=\"GUID-52E2EA19-D42C-4240-A061-CB0DC364267E.htm\">Refreshing the Viewports</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";