var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-9BE82D70-1869-46D7-9501-E5453E25AC68\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"dotNet Struct Methods\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>dotNet Struct Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9BE82D70-1869-46D7-9501-E5453E25AC68\"></a><div class=\"head\">\n            <h1>dotNet Struct Methods </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-100E\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-100A\"></a>The dotNet \n               		  <em class=\"strong\">Struct</em> provides additional MAXScript methods for managing dotNet objects, classes, assemblies,\n               event handlers, and others. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1009\"></a>Available in \n               		  <em class=\"strong\">3ds Max 9</em> and higher. \n               		\n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1008\"></a> \n               <h3><a name=\"GUID-A9EB81ED-C2FB-425E-A51E-0FB3A07548FB\"></a> <em class=\"strong\">Assembly Loading:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-679D\"></a><pre>&lt;dotNetObject&gt;<em class=\"codeEmphasisStrong\">dotNet.loadAssembly</em> &lt;assembly&gt; [returnPassFail:bool]</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1006\"></a>This method loads the specified assembly. The assembly can be specified as an assembly\n                  name or the filename of the dll containing the assembly. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1005\"></a>The method first attempts to load an assembly from the application directory or from\n                  the global assembly cache using the assembly name. If that fails, a dll with the assembly\n                  name is searched in the directory containing the primary .net assemblies. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1004\"></a>If \n                  			 <em class=\"strong\">returnPassFail</em> is false (the default), the assembly is found and successfully loaded, a dotNetObject\n                  value wrapping the .net assembly value is returned, otherwise a value of undefined\n                  is returned. If \n                  			 <em class=\"strong\">returnPassFail</em> is true, this method returns true if the assembly is loaded, false if not. \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1003\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1002\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-679C\"></a><pre>\ndotnet.loadAssembly \"system.xml\"\ndotnet.loadAssembly \"system.xml.dll\"\ndotnet.loadAssembly \"C:\\\\WINDOWS\\\\Microsoft.NET\\\\Framework\\\\v2.0.50727\\\\system.xml.dll\"\ndotnet.loadAssembly \"C:\\\\WINDOWS\\\\Microsoft.NET\\\\Framework\\\\v2.0.50727\\\\system.xml\"\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7548\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                     <p><a name=\"GUID-C2168ED6-1335-4C9C-85BE-86C657C8478E\"></a>You can do the same by using the existing dotNet classes: \n                        			 \n                     </p> \n                  </div>\n               </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FF5\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FF4\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-679B\"></a><pre>\nassembly = dotNetClass \"System.Reflection.Assembly\" r = assembly.loadfrom \"F:\\\\FlashTrackBar\\\\bin\\\\Debug\\\\FlashTrackBar.dll\"\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <p> </p> \n            <div class=\"section\"><a name=\"SECTION_9BC16A131E474F3DB56C3BA6836B6D0D\"></a> \n               <h3><a name=\"GUID-504FBD82-7C9D-4ECB-AF9C-6DD50301FF63\"></a><em class=\"strong\">Icon Loading:</em></h3> \n               <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">dotNet.LoadIcon</em> &lt;iconName&gt; <em class=\"codeEmphasisStrong\">iconSize</em>:&lt;point2&gt; <em class=\"codeEmphasisStrong\">enabled</em>:&lt;bool&gt; <em class=\"codeEmphasisStrong\">on</em>:&lt;bool&gt; <em class=\"codeEmphasisStrong\">applyUIScaling</em>:&lt;bool&gt;</pre></div> \n               <p>Returns a \n                  			 <span class=\"code\">System::Drawing::Icon</span> if the icon is found, undefined if not. Available in \n                  			 <em class=\"strong\">in 3ds Max 2017 and higher</em>.\n                  		  \n               </p> \n               <p> The \n                  			 <span class=\"code\">iconName</span> is the path to an icon file, or previously loaded icon resource. \n                  		  \n               </p> \n               <p> The \n                  			 <span class=\"code\">iconSize</span> is the size of the icon at 100% DPI scaling. The default is [24,24] if not specified.\n                  \n                  		  \n               </p> \n               <p> The \n                  			 <span class=\"code\">enabled</span> parameter specifies which version (enabled or disabled) of the icon to load. \n                  		  \n               </p> \n               <p> The \n                  			 <span class=\"code\">on</span> parameter specifies which version (on or off) of the icon to load. \n                  		  \n               </p> \n               <p> The \n                  			 <span class=\"code\">applyUIScaling</span> specifies whether to apply scaling to the icon on High DPI displays. The default\n                  is true. \n                  		  \n               </p> \n               <p> <a name=\"TABLE_2138BB3602C1400DA5D58CA4B53D9152\"></a><div class=\"table-ruled\">\n                     <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                        <colgroup>\n                           <col width=\"100%\">\n                        </colgroup>\n                        <tr class=\"ruled-odd-row\">\n                           <td class=\"table-body\"> \n                              <p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                              </p> \n                           </td>\n                        </tr>\n                        <tr class=\"ruled-even-row\">\n                           <td class=\"table-body\"> \n                              <div class=\"codeBlock\"><pre>\nhForm = dotNetObject \"System.Windows.Forms.Form\"\ndotNetIcon = dotnet.loadIcon(\"PolyTools\\TransformTools\\PB_CW\")\nhForm.Icon = dotNetIcon --set the title bar icon of the form\nhForm.show()\n--Result: an empty form with a clockwise rotation arrow as icon\n\n</pre></div> \n                           </td>\n                        </tr>\n                     </table>\n                  </div> \n               </p> \n               <p> </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FEE\"></a> \n               <h3><a name=\"GUID-C71ED166-3BE1-434F-83F9-EDBEA218858B\"></a> <em class=\"strong\">Event Handlers:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-679A\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.addEventHandler</em> &lt;dotNetControl&gt; &lt;EventNameString&gt; &lt;function&gt;</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FEC\"></a>This method adds an event handler to the dotNetControl passed as the first argument.\n                  \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FEB\"></a>The second argument specifies the event name as string. The list of all available\n                  events for a given dotNetControl can be acquired by calling showEvents() on the dotNetControl\n                  value. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FEA\"></a>The third argument is the custom MAXScript function to be called when the event is\n                  triggered. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FE9\"></a>If the custom MAXScript function called by the handler expects two arguments, the\n                  first argument must contain the sender and the second the eventArg. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FE8\"></a>If the event handler function specifies only one argument, then only the eventArg\n                  is passed. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FE7\"></a>If the event handler function does not specify any arguments, none are passed. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FE6\"></a>See the example further on this page for details. \n                  		  \n               </p> \n               <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7547\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>You can register multiple functions with differing number of arguments for the same\n                     event using \n                     			 <span class=\"code\"> <em class=\"strong\">dotNet.addEventHandler()</em> </span>. \n                     		  \n                  </div>\n               </div> \n               <div><a name=\"GUID-495E6C9F-88B9-4B06-BCB9-DD73E91698C1\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>You can only add functions that are registered in the global scope as event handlers.\n                     If you need to register a function that is hidden from the global scop (for example,\n                     contained in a struct), you need to define a global function to point to the hidden\n                     function. \n                     		  \n                  </div>\n               </div> <a name=\"TABLE_F45F0883BDEA418F9C8A303A3ADE82B2\"></a><div class=\"table-not-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                     <colgroup>\n                        <col>\n                     </colgroup>\n                     <tr class=\"not-ruled-odd-row\">\n                        <td class=\"table-body\"><em class=\"strong\">Example</em> \n                        </td>\n                     </tr>\n                     <tr class=\"not-ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>struct dotNetStruct\n(\n	myForm = dotNetObject \"system.windows.forms.form\",\n	myButton = dotNetObject \"system.windows.forms.button\"\n)\n\nui = dotNetStruct()\n\nui.myForm.width = 100\nui.myForm.height = 100\nui.myButton.text = \"Say Something\"\nui.myForm.controls.add ui.myButton\n\n-- A function \"hidden\" in a global struct\nstruct functionStruct\n(\n	fn printSomething a b =\n	(\n		print \"something\"\n	)\n)\n\nmyFunctionStruct = functionStruct()\n\n--- Create a new function in global scope to point to our \"hidden\" function\nfn theFunctionPrint a b = myFunctionStruct.printSomething a b \n\nDotNet.AddEventHandler ui.mybutton \"click\" theFunctionPrint\n\n\nui.myForm.show()</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p> </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6799\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.removeAllEventHandlers</em> &lt;dotNetControl&gt;</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FE0\"></a>Removes all event handlers from the specified dotNetControl. \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6798\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.removeEventHandler</em> &lt;dotNetControl&gt; &lt;EventNameString&gt; &lt;function&gt;</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FDD\"></a>Removes the specified event handler function from the given dotNetControl and event.\n                  \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FDC\"></a>The arguments list is the same as the \n                  			 <span class=\"code\"> <em class=\"strong\">dotNet.addEventHandler()</em> </span>. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FDB\"></a>The callback function is specified as the third argument because there can be multiple\n                  functions registered with the same event (see note above). \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FDA\"></a>To remove all functions registered with a given event, see the following method: \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6797\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.removeEventHandlers</em> &lt;dotNetControl&gt; &lt;EventNameString&gt;</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FD7\"></a>Removes all functions registered with the specified event of the dotNetControl. \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FD5\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FD4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6796\"></a><pre>\n(\nfn buttonPressed1 a1 a2 =\n(\nprint \"1. Button Pressed - Two Arguments\"\nprint a1\nprint a2\n)\nfn buttonPressed2 a1 =\n(\nprint \"2. Button Pressed - One Argument\"\nprint a1\n)\nfn buttonPressed3 =\n(\nprint \"3. Button Pressed - No Arguments\"\n)\nfn mouseEnter4 =\n(\nprint \"4. Mouse Entered The Button!\"\n)\nfn mouseLeave5 =\n(\nprint \"5. Mouse Left The Button!\"\n)\nlocal mButton = dotNetObject \"System.windows.forms.button\"\nmButton.text = \"Press Me\"\nmButton.size = dotNetObject \"System.Drawing.Size\" 100 100\nmButton.location = dotNetObject \"System.Drawing.Point\" 10 10\nlocal hForm = dotNetObject \"System.Windows.Forms.Form\"\nhForm.size = dotNetObject \"System.Drawing.Size\" 120 140\nhForm.controls.add mButton\ndotNet.addEventHandler mButton \"click\" buttonPressed1\ndotNet.addEventHandler mButton \"click\" buttonPressed2\ndotNet.addEventHandler mButton \"click\" buttonPressed3\ndotNet.addEventHandler mButton \"MouseEnter\" mouseEnter4\ndotNet.addEventHandler mButton \"MouseLeave\" mouseLeave5\nhForm.show()\nok\n)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-FA1\"></a><p class=\"table-body\">If you evaluate the above script, move the mouse over the button, click it, move the\n                              mouse away from the button, and then back in and out, the Listener output appears\n                              as follows: \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6795\"></a><pre>\nOK\n\"4. Mouse Entered The Button!\"\n\"1. Button Pressed - Two Arguments\"\ndotNetObject:System.Windows.Forms.Button\ndotNetObject:System.Windows.Forms.MouseEventArgs\n\"2. Button Pressed - One Argument\"\ndotNetObject:System.Windows.Forms.MouseEventArgs\n\"3. Button Pressed - No Arguments\"\n\"5. Mouse Left The Button!\"\n\"4. Mouse Entered The Button!\"\n\"5. Mouse Left The Button!\"\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F93\"></a><p class=\"table-body\">Adding the following line to the first (buttonPressed1) function causes the first\n                              on Click event handler to be removed after the first click on the button. Clicking\n                              a second time prints only the second and third functions to the Listener. \n                              						\n                           </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F92\"></a><p class=\"table-body\">Within the function, the a1 argument contains the \"sender\", or the dotNetControl whose\n                              event was triggered. \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6794\"></a><pre>\ndotNet.removeEventHandlers a1 \"click\" buttonPressed1\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6793\"></a><pre>\nOK\n\"4. Mouse Entered The Button!\"\n\"1. Button Pressed - Two Arguments\"\ndotNetObject:System.Windows.Forms.Button\ndotNetObject:System.Windows.Forms.MouseEventArgs\n\"3. Button Pressed - No Arguments\"\n\"2. Button Pressed - One Argument\"\ndotNetObject:System.Windows.Forms.MouseEventArgs\n\"3. Button Pressed - No Arguments\"\n\"2. Button Pressed - One Argument\"\ndotNetObject:System.Windows.Forms.MouseEventArgs\n\"3. Button Pressed - No Arguments\"\n\"5. Mouse Left The Button!\"\n--additional clicks result in no output from function 1\n--but all others work\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F7D\"></a><p class=\"table-body\">Adding the following line to the first (buttonPressed1) function causes all on Click\n                              event handlers to be removed after the first click on the button. \n                              						\n                           </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F7C\"></a><p class=\"table-body\">Clicking a second time does not print anything to the Listener, but when the mouse\n                              moves in and out, the other two functions are printed. \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6792\"></a><pre>\ndotNet.removeEventHandlers a1 \"click\"\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6791\"></a><pre>\nOK\n\"4. Mouse Entered The Button!\"\n\"1. Button Pressed - Two Arguments\"\ndotNetObject:System.Windows.Forms.Button\ndotNetObject:System.Windows.Forms.MouseEventArgs\n\"2. Button Pressed - One Argument\"\ndotNetObject:System.Windows.Forms.MouseEventArgs\n\"3. Button Pressed - No Arguments\"\n\"5. Mouse Left The Button!\"\n\"4. Mouse Entered The Button!\"\n\"5. Mouse Left The Button!\"\n--additional clicks result in no output\n--but moving the mouse prints to the Listener\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F69\"></a><p class=\"table-body\">Adding the following line to the first (buttonPressed1) function causes all event\n                              handlers to be removed after the first click on the button including the on Click,\n                              on MouseEnter, and on MouseLeave events. \n                              						\n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6790\"></a><pre>\ndotNet.removeAllEventHandlers a1\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-678F\"></a><pre>\nOK\n\"4. Mouse Entered The Button!\"\n\"1. Button Pressed - Two Arguments\"\ndotNetObject:System.Windows.Forms.Button\ndotNetObject:System.Windows.Forms.MouseEventArgs\n\"2. Button Pressed - One Argument\"\ndotNetObject:System.Windows.Forms.MouseEventArgs\n\"3. Button Pressed - No Arguments\"\n--additional clicks result in no output\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F58\"></a> \n               <h3><a name=\"GUID-AB4635E4-6AF6-4B83-8003-28E0626435CD\"></a> <em class=\"strong\">Additional Inspector Functions:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-678E\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.showConstructors</em> [&lt;dotNetClass&gt; | &lt;dotNetObject&gt; | &lt;dotNetControl&gt;] [<em class=\"codeEmphasisStrong\">to</em>:&lt;stream&gt;]</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F56\"></a>Displays the constructors exposed by the specified DotNetClass, DotNetObject, or DotNetControl.\n                  \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F55\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">to</em> </span> is not specified, the output goes to Listerner, otherwise the output goes to the\n                  specified stream. \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-678D\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.getType</em>&lt;type_string&gt;</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F52\"></a>Returns a dotNetObject value that wraps the System:Type specified by the type string.\n                  \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F50\"></a> \n               <h3><a name=\"GUID-C4ABF7B8-E77A-4027-8379-4897323651CC\"></a> <em class=\"strong\">Enums:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-678C\"></a><pre><em class=\"codeEmphasisStrong\">dotnet.combineEnums</em> {&lt;dotNetObject&gt; | &lt;number&gt;}+</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F4E\"></a>Combines System::Enum-derived objects that are to be treated as bit fields (these\n                  have a FlagsAttribute). The System::Enum-derived objects must all be of the same type.\n                  The return value is of that type. If a number is specified, at least one System::Enum-derived\n                  object must also be specified (to provide the type). \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-678B\"></a><pre><em class=\"codeEmphasisStrong\">dotnet.CompareEnums</em>{&lt;dotNetObject&gt; | &lt;number&gt;} {&lt;dotNetObject&gt; | &lt;number&gt;}</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F4B\"></a>Performs bit-wise comparison of the two value. Returns true if at least one corresponding\n                  bit is set in each value. \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F4A\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F49\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-678A\"></a><pre>\nBindingFlags= dotNetClass \"System.Reflection.BindingFlags\"\n--&gt; dotNetClass:System.Reflection.BindingFlags\nBindingFlags.Static.value__\n--&gt; 8\nBindingFlags.Public.value__\n--&gt; 16\nBindingFlags.FlattenHierarchy.value__\n--&gt; 64\nres = dotNet.combineEnums BindingFlags.Static BindingFlags.Public 2\n--&gt; dotNetObject:System.Reflection.BindingFlags\nres.value__\n--&gt; 26\ndotNet.compareEnums res 1\n--&gt; false\ndotNet.compareEnums res BindingFlags.Static\n--&gt; true\ndotNet.compareEnums res BindingFlags.Public\n--&gt; true\ndotNet.compareEnums res BindingFlags.FlattenHierarchy\n--&gt; false\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F2C\"></a> \n               <h3><a name=\"GUID-3978CF88-000D-4617-BEC5-0D5261414216\"></a> <em class=\"strong\">Value Conversion:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6789\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.ValueToDotNetObject</em> &lt;value&gt; { &lt;dotNetClass&gt; | &lt;dotNetObject&gt; }</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F2A\"></a>See \n                  			 <span class=\"char_link\"><a href=\"GUID-FB52FDC5-CC83-46FB-A430-B90E7107805A.htm\">MAXScript / DotNet Value Conversions</a></span> for details. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F29\"></a>Available in \n                  			 <em class=\"strong\">3ds Max 2010</em> and higher. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F28\"></a> \n               <h3><a name=\"GUID-4CD1FF1C-2681-42EB-8531-D54F61E33AE7\"></a> <em class=\"strong\">Life Time Control:</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6788\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.setLifetimeControl</em> {&lt;dotNetObject&gt; | &lt;dotNetClass&gt;} {<em class=\"codeEmphasisStrong\">#mxs</em> | <em class=\"codeEmphasisStrong\">#dotnet</em>}</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F26\"></a>See \n                  			 <span class=\"char_link\"><a href=\"GUID-99E3B658-D86C-4FD6-9B37-753AEF05FB74.htm\">DotNet Objects and Classes Life Time Control</a></span> details. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F25\"></a>Available in \n                  			 <em class=\"strong\">3ds Max 2010</em> and higher. \n                  		  \n               </p> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-F22\"></a> <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet In MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";