var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-9D9CB9CD-5F2C-4AF6-8A55-54D933A8457A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I build Unconnected Edges Selections from EPoly Edge Selection?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9D9CB9CD-5F2C-4AF6-8A55-54D933A8457A\"></a><div class=\"head\">\n            <h1>How do I build Unconnected Edges Selections from EPoly Edge Selection? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC10FF\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1101\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1102\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8E2\"> Working With Editable Polys</a></span> &gt; How do I build Unconnected Edges Selections from EPoly Edge Selection? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1104\"></a> \n            <h2><a name=\"GUID-5AEC83F2-10E0-4BCC-8961-CFDD8708CCEF\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1105\"></a>I want to filter the edge selection and create arrays containing connected edges,\n               something like \"edge selection elements\". Edges from two arrays will never be connected,\n               in other words will not share vertices. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1106\"></a> \n            <h2><a name=\"GUID-8ADF45B0-A1B5-4D2D-B354-3A716CB7F4C3\"></a> <em class=\"strong\">Answer:</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1109\"></a><p class=\"list-intro\"><a name=\"WS3ED54CBA79FF2E3D-3BC1F56812B783555D7-7B7B\"></a>The following pseudo-code describes a possible approach:\n            </p>\n            <ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC110B\"></a>Get the current edge selection into a main selection array. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC110D\"></a>Create an empty array to hold the unconnected selections. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC110F\"></a>(A) Append a new empty array to it as a sub-array. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1111\"></a>Note the index of the current sub-array. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1113\"></a>Get the first edge from the main selection array. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1115\"></a>Delete it from the main selection array, append to the current sub-array of the unconnected\n                     selections array. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1117\"></a>For every edge in the new sub-array, get its corresponding vertices that define the\n                     edge. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC111B\"></a>For each of the two vertices, get their edges - this gives you all neighbor edges\n                     sharing a vertex with the current edge. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC111D\"></a>Loop through the neighbors and see if they appear in the main selection array. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC111F\"></a>If an edge is in the main selection array, delete it from there and append it to the\n                     current sub-array. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1121\"></a>Finish the loop when you have checked all edges from the sub-array. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1123\"></a>At this point, if all edges are connected, the main array will be empty. If it is\n                     not empty, there are edges unconnected to the selections you already collected. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1125\"></a>Add a new empty sub-array to the collection array. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1127\"></a>Repeat starting with (A). \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1128\"></a>The function is ready when there are no edges left in the main array. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1129\"></a>This will give you as many sub-arrays as there are unconnected edge selections. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC112B\"></a>The following function implements the pseudo-code in MAXScript code: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC112C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC112D\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6639\"></a><pre>\nfn getEPolyUnconnectedEdgesSelections thePoly =\n(\n--get the edge selection\nmainSelection = (polyOp.getEdgeSelection thePoly) as array\n--init. an array to collect sub-arrays with selections \"elements\"\nunconnectedSelections = #()\n--repeat until the main selection array is empty\nwhile mainSelection.count &gt; 0 do\n(\n--append a new empty sub-array:\nappend unconnectedSelections #()\n--remember the current sub-array\'s index:\ncurrentSelCount = unconnectedSelections.count\n--append the first edge from the main selectionarray to the sub-array:\nappend unconnectedSelections[currentSelCount] mainSelection[1]\n--and remove the first edge from the main selectionarray:\ndeleteItem mainSelection 1\n--initialize a counter:\ncnt = 0\n--while the counter is less than the edges in the sub-array\nwhile cnt &lt; unconnectedSelections[currentSelCount].count do\n(\n cnt += 1--increase the counter by 1\n --get the vertices of the current edge in the current sub-array:\n currentEdgeVerts = (polyOp.GetVertsUsingEdge thePoly  unconnectedSelections[currentSelCount][cnt]) as array\n neigborEdges = #()--init. an array to collect neighbor\n --for every vertex in the current edge,\n for v in currentEdgeVerts do\n --add the edges used by the vertex to the neighbors array\n  join neigborEdges ((polyOp.GetEdgesUsingVert thePoly v) as array)\n --for each neighbor edge,\n for edge in neigborEdges do\n (\n  --see if the edge is in the main selection array\n  checkInSelection = findItem mainSelection edge\n  --if it is,\n  if checkInSelection &gt; 0 do\n  (\n   --delete the edge from the main array\n   deleteItem mainSelection checkInSelection\n   --and add it to the current sub-array\n   append unconnectedSelections[currentSelCount] edge\n  )--end if\n )--end for edge loop\n)--end while cnt\n)--end while mainSelection.count\n--finally, return the array containing the sub-arrays of connected edges:\nunconnectedSelections\n)--end fn\n\n-- create box and mesh:\nb = box()\nconvertTo b editable_poly\nselect b\ngetEPolyUnconnectedEdgesSelections $Box001--call the function\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1166\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";