var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-9F96FB7D-EB51-41FA-976D-C39DEED69CE4\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Global and Private Custom Attributes Definitions\">\n      <meta name=\"indexterm\" content=\"Custom Attributes:  updating\">\n      <meta name=\"indexterm\" content=\"custAttributes:  redefine\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Global and Private Custom Attributes Definitions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9F96FB7D-EB51-41FA-976D-C39DEED69CE4\"></a><div class=\"head\">\n            <h1>Global and Private Custom Attributes Definitions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A58\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A57\"></a> Scripted custom attributes are properly saved to and loaded from scene files. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A55\"></a>You can assign a fixed, global definition ID to an attributes definition. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A54\"></a>This acts in a similar way to class IDs in scripted plug-ins. Such definitions are\n               \n               		  <em class=\"strong\">global</em> across any number of scenes that custom attributes may be present in and all instances\n               of custom attributes of a global definition will have the same shape. The ID is specified\n               with a new header parameter, \'<span class=\"code\"> <em class=\"strong\">attribID:</em> </span>’ \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A53\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2305\"></a><pre>\nattributes &lt;name&gt; <em class=\"codeEmphasisStrong\">attribID:</em> #(&lt;number&gt;, &lt;number&gt;) ( ... ) 				  </pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A4B\"></a>The ID number pair is chosen to be unique, perhaps generated with the \n               		  <span class=\"char_link\"><a href=\"GUID-E59FCB9A-04C0-4228-9779-4FD74F2D35AD.htm\">genClassID</a></span>() function in MAXScript. Attribute definitions without attribID\'s are private to\n               the current MAX session. \n               		\n            </p> \n            <p><a name=\"GUID-03131786-DF7E-42AA-B4C2-937AA4C12AF9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2304\"></a><pre><em class=\"codeEmphasisStrong\">genClassID</em> [	 <em class=\"codeEmphasisStrong\">returnValue:</em>&lt;boolean&gt;]   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A49\"></a>This method generates a random class ID similar to #(0x9b7ea231, 0xb6db86ef), and\n               prints it to Listener. You can just cut and paste this class ID into your script to\n               use the generated ID. If the optional returnValue keyword is supplied and set to true,\n               the value will be returned as the result of the method call. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A47\"></a>Definitions are identified depending on whether they are global or private definitions.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A46\"></a> <em class=\"strong\">Global definitions</em> have explicit attribID: parameters, which define a globally unique ID for that definition\n               and ensure that any object with custom attributes based on a definition with that\n               ID will be follow the same definition. Whenever you evaluate an attributes definition\n               with a particular attribID: you will update all objects that have custom attributes\n               based on that definition, and loading objects with attributes of that attribID will\n               update themselves to the current definition. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A45\"></a> <em class=\"strong\">Private definitions</em> have no explicit attribID: parameter (they effectively have an internally-generated\n               random one). Each time you evaluate one, except as described in the redefinition section\n               below, a completely distinct definition is created with its own internal ID. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A44\"></a>In the case of both global and private definitions, the \'attributes\' definition construct\n               returns the definition as its value, so you would typically assign that value to a\n               local and then use it to add custom attributes to objects via the \n               		  <span class=\"code\"> <em class=\"strong\">custAttributes.add ()</em> </span> function. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A43\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A42\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2303\"></a><pre>\nlocal def\ndef = attributes \"Game Data\"\n(\nparameters ...\nrollout ...\n)\ncustAttributes.add $box01 def\ncustAttributes.add $box02 def\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A37\"></a>This example adds a separate set of the defined custom attributes to box01 and box02.\n               The definition is shared between the two boxes. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A36\"></a>This is a private definition, it has no attribID:, so if you evaluated the \'def =\n               attributes (...)\' again, it would \n               		  <span class=\"code\"> <em class=\"strong\">*not*</em> </span> automatically update box01\'s and box02\'s attributes, as used to happen in prior builds,\n               but create a new definition. \n               		\n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A35\"></a> \n               <h3><a name=\"GUID-B19EF2F9-17D4-4C23-B4C7-2F37811ABF15\"></a> <em class=\"strong\">Redefining Custom Attributes</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A34\"></a>In order to redefine a specific attribute definition so that all objects that had\n                  attributes added using it will be updated, you can use one of two schemes that operate\n                  on the actual definition value (as it sits in the \'def\' variable in the above, for\n                  example). \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A33\"></a>First, you can use the \'redefine:\' attributes definition parameter: \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A32\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A31\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2302\"></a><pre>\nattributes \"Game Data\"\nredefine:def\n(\nparameters ...\nrollout ...\n)\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A28\"></a>This expects an existing attributes definition as the value given in the redefine:\n                  parameter and will update it to the definition that follows, and update any custom\n                  attributes made from that particular definition value. In the example, this would\n                  update $box01 and $box02. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A26\"></a>Alternatively, you can use the \n                  			 <span class=\"code\"> <em class=\"strong\">custAttributes.redefine</em> </span> method: \n                  		  \n               </p> \n               <p><a name=\"GUID-77DD3ADE-10BF-455A-99B8-F8BE42B1FC44\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2301\"></a><pre><em class=\"codeEmphasisStrong\">custAttributes</em>.<em class=\"codeEmphasisStrong\">redefine</em> &lt;def&gt; &lt;definition_string&gt;   </pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A23\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A22\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2300\"></a><pre>\nlocal new_def = \"attributes \\\"Game Data\\\" ( ... )\"\ncustAttributes.redefine def new_def\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A1C\"></a>This is particularly useful in situations where you are generating the attributes\n                  definition automatically as a string. You can use this function to compile and apply\n                  the redefinition to a particular definition object in one go, without having to construct\n                  a name for the object, as you would if you used the redefine: parameter scheme. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A1B\"></a>To redefine the attributes on some object, say based on the defData in that object\'s\n                  custom attributes, you might use this sequence: \n                  		  \n               </p> \n               <p><a name=\"GUID-F5A11629-B654-422D-9FAC-483A505A086D\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22FF\"></a><pre>old_def = custAttributes.getDef $box03 1 -- get existing def\nold_def_data = custAttributes.getDefData old_def -- get my defData from it\nnew_def_string = generate_new_def old_def_data ... -- make new def string\ncustAttributes.redefine old_def new_def_string -- redefine it</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A16\"></a>These redefinition techniques can be used with global definitions (with explicit attribID:),\n                  but are strictly unnecessary since the particular definition value is specified uniquely\n                  by the attribID: parameter. In any situation that you evaluate a global definition,\n                  all custom attributes in the current scene made from that definition will be updated.\n                  \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A15\"></a> <em class=\"strong\">Next Topic:</em> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A14\"></a> <span class=\"char_link\"><a href=\"GUID-0A1E08F8-A8C5-4737-AA6F-39194AD16559.htm\">Custom Attribute Management Functions</a></span> \n               </p> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A12\"></a> <span class=\"char_link\"><a href=\"GUID-ADFD29E4-9751-4F55-98CC-F7C721C9AEE2.htm\">Scripted Custom Attributes</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A11\"></a> <span class=\"char_link\"><a href=\"GUID-DAB53D18-EE71-4624-8796-87C74C9261E7.htm\">Adding Custom Attributes</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A10\"></a> <span class=\"char_link\"><a href=\"GUID-A2579383-CAA2-446B-8034-0502DDBBAAD4.htm\">Custom Attributes Definition Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A0F\"></a> <span class=\"char_link\"><a href=\"GUID-695C13A5-B461-4520-8540-47D18CA23AB0.htm\">Access to Custom Attributes Virtual Array</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4A0E\"></a> <span class=\"char_link\"><a href=\"GUID-E7BE579A-DB95-4225-A72C-5F27FA637E52.htm\">Custom Attributes in Materials and Texture Maps</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";