var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A04C0E75-F82A-41AC-92E8-D7CB1D797430\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"script files\">\n      <meta name=\"indexterm\" content=\"-U switch (command line)\">\n      <meta name=\"indexterm\" content=\"startup: scripts directory\">\n      <meta name=\"indexterm\" content=\"running scripts\">\n      <meta name=\"indexterm\" content=\"quitMAX()\">\n      <meta name=\"indexterm\" content=\"launch scripts vs. batch scripts\">\n      <meta name=\"indexterm\" content=\"command lines - running scripts\">\n      <meta name=\"indexterm\" content=\"batch scripts vs. launch scripts\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Running Scripts from the Command Line</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A04C0E75-F82A-41AC-92E8-D7CB1D797430\"></a><div class=\"head\">\n            <h1>Running Scripts from the Command Line </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BC7\"></a>        You can launch <em class=\"strong\">3ds Max</em> from a DOS command line and have it run a specified launch script, which is useful\n            for tasks such as unattended batch-rendering. This capability uses the existing<em class=\"strong\">- U</em> command line switch that names a utility to be run when <em class=\"strong\">3ds Max </em>is started. The<em class=\"strong\">- U </em>switch allows an optional extra argument which, for MAXScript, is taken to be the\n            name of the launch script to run. The case of MAXScript must be as shown in the following\n            example: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BD0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63A4\"></a><pre>\nc:\\3dsmax\\3dsmax -U MAXScript rendercams.ms\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BD5\"></a>This example command line would launch the <em class=\"strong\">3ds Max</em> executable in <em class=\"mild\">c:\\3dsmax</em>, start MAXScript, and then have it run the launch script <em class=\"mild\">rendercams.ms</em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BD6\"></a>The following example launch script loads two scenes, renders frames from each of\n            the cameras in them, and then quits <em class=\"strong\">3ds Max</em>: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BD7\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63A3\"></a><pre>loadMaxFile \"foo.max\"\nfor c in cameras do render camera:c outputfile:(\"foo_\"+c.name+\".bmp\")\nloadMaxFile \"baz.max\"\nfor c in cameras do render camera:c outputfile:(\"baz_\"+c.name+\".bmp\")\nquitMax #noPrompt</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BE0\"></a>This example makes use of the <span class=\"code\">quitMax() </span>method to exit <em class=\"strong\">3ds Max</em> (see <span class=\"char_link\"><a href=\"GUID-92E4150E-0AD4-430C-A852-783A45276D23.htm\">Exiting and Resetting3ds Max</a></span>) when the script is finished. Launch scripts need not be batch scripts as in this\n            example, but may be used to condition <em class=\"strong\">3ds Max </em>for interactive use, for example by loading a scene file and setting some user-interface\n            options. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BE1\"></a>The normal startup scripts, <em class=\"mild\">startup.ms</em> and those in the Startup Scripts directory, are run before the launch script. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4BE2\"></a>It is also possible to install scripts into individual scene files that run automatically\n            when that scene is open or closed or at certain other events (see <span class=\"char_link\"><a href=\"GUID-C1F6495F-5831-4FC8-A00C-667C5F2EAE36.htm\">General Event Callback Mechanism</a></span>). \n         </p>\n         <div><a name=\"WS3ED54CBA79FF2E3D-7658A5A12B78356069-6F12\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Command line -U MAXScript startup scripts are run *after* <em class=\"strong\">3ds Max </em>has completely booted and the standard MAXScript stdscripts and scripts\\startup scripts\n               have been run. \n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";