var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A06BF73D-7B3D-4898-8CE8-7DDB9F3C12F9\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ParticleCache\">\n      <meta name=\"indexterm\" content=\"GetParticleCache\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: ParticleCache</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A06BF73D-7B3D-4898-8CE8-7DDB9F3C12F9\"></a><div class=\"head\">\n            <h1> Interface: ParticleCache</h1>\n         </div>\n         <p> This interface provides access to the liquid or foam particle cache for \n            		<span class=\"char_link\"><a href=\"GUID-D0504863-171B-43E3-8229-31A8D13E7A9A.htm\">MaxLiquidSolver</a></span> objects. Available in \n            		<em class=\"strong\">3ds Max 2018.3</em> and later. \n            	 \n         </p>\n         <p> </p>\n         <p> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">ParticleCache.baseFilename</em> : string : Read</pre></div>\n         <p>Gets the base path and filename for the cache files. For example, \"C:\\Program Files\\3ds\n            Max 2019\\SimCache\\Untitled\\Liquid001\\Solver01\\voxel_liquid\\voxel_liquid_particle\".\n            This path is constructed from the \n            		<span class=\"code\">MaxLiquid.cacheOutputFilePattern</span> property. Cache files are stored in this location with a suffix of \n            		<span class=\"filePath\">&lt;frame number&gt;.bif</span>. For example \"voxel_liquid_particle.0001.bif\". \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">ParticleCache.numDigits</em> : integer : Read</pre></div>\n         <p> Gets the number of digits used for the frame portion of the cache file name. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">ParticleCache.cacheType</em> : enum : Read\n cacheType enums: {#unknown|#liquid|#smoke|#foam|#mesh}</pre></div>\n         <p>Returns the cache object type. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">ParticleCache.startFrame</em> : integer : Read</pre></div>\n         <p>Returns the frame number the cache starts at. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">ParticleCache.endFrame</em> : integer : Read</pre></div>\n         <p>Returns the frame number the cache ends at. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">ParticleCache.colorChannelname</em> : string : Read|Write\n<em class=\"codeEmphasisStrong\">ParticleCache.sizeChannelName</em> : string : Read|Write\n<em class=\"codeEmphasisStrong\">ParticleCache.opacityChannelname</em> : string : Read|Write</pre></div>\n         <p> Gets or sets the color, size, or opacity channel names. The string is empty when\n            the channel mode is \"Static\". This corresponds to the &lt;MaxLiquidSolver&gt; \n            		<span class=\"code\">.colorChannelMode</span>, \n            		<span class=\"code\">.sizeChannelMode</span>, and \n            		<span class=\"code\">.opacityChannelMode</span> properties. \n            	 \n         </p>\n         <p> </p>\n         <p> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre> &lt;string&gt;<em class=\"codeEmphasisStrong\">ParticleCache.GetMainName</em>()</pre></div>\n         <p> Returns the name of the solver the particle cache is associated with. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre> &lt;integer&gt;<em class=\"codeEmphasisStrong\">ParticleCache.GetNumFrames</em>()</pre></div>\n         <p> Returns the number of frames in the cache. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre> &lt;integer&gt;<em class=\"codeEmphasisStrong\">ParticleCache.GetNumParticles</em> &lt;integer&gt;frame</pre></div>\n         <p>Returns the number of particles in the cache file for the specified frame number,\n            or -1 if the specified frame does not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre> &lt;point3 by value&gt;<em class=\"codeEmphasisStrong\">ParticleCache.GetParticlePos</em> &lt;integer&gt;frame &lt;index&gt;particleIndex</pre></div>\n         <p>Returns the position of the particle at the specified index at the specified frame,\n            or [0,0,0] if the frame or index does not exist. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre> &lt;box3&gt;<em class=\"codeEmphasisStrong\">ParticleCache.GetBoundingBox</em> &lt;integer&gt;frame</pre></div>\n         <p>Returns the bounding box of all the particles at the specified frame. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre> &lt;void&gt;<em class=\"codeEmphasisStrong\">ParticleCache.Clear</em>()</pre></div>\n         <p>Clears the particle cache from memory. Note that this does not delete the cache files\n            on disk. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre> &lt;integer&gt;<em class=\"codeEmphasisStrong\">ParticleCache.IsCached</em> &lt;integer&gt;frame</pre></div>\n         <p>Returns true if a cache exists for the specified fame. \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";