var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A1FFEDE0-9B92-4CD5-8127-76AA393D5143\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Quiet Mode\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Quiet Mode</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A1FFEDE0-9B92-4CD5-8127-76AA393D5143\"></a><div class=\"head\">\n            <h1>Quiet Mode </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36A8\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36A7\"></a> In Quiet Mode, dialogs participating in the new Default Action system will be suppressed,\n               and user-defined actions will be performed instead. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36A5\"></a>The actions that can be specified are: <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, and <span class=\"code\"> <em class=\"strong\">#abort</em> </span>. In addition, you can specify an integer value, where the bits specify event ID specific\n               actions. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36A4\"></a>A <span class=\"code\"> <em class=\"strong\">#default</em> </span> action option is available in <em class=\"strong\">3ds Max 8 and higher</em>. When <span class=\"code\"> <em class=\"strong\">#default</em> </span> is specified, the current <span class=\"char_link\"><a href=\"GUID-A6FE1355-631F-47BD-BBAE-4368CF9D31FD.htm\">defaultAction context</a></span> state is used.By default, the quiet mode is off unless specified otherwise using\n               the context. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36A3\"></a>If you set Quiet mode but do not specify an action for an event, the default action\n               is typically to log to the log file and continue. \n            </p> \n            <p><a name=\"GUID-E67A6907-5854-4422-9042-66EDB22EDFCD\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36A2\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D51\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">GetQuietMode</em>() 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-36A0\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if quiet mode is set, or <em class=\"strong\">3ds Max</em> is in net render mode \n            </p> \n            <p><a name=\"GUID-4AFB0B07-684E-4914-A89F-7766053D92DB\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D50\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">SetQuietMode</em> &lt;bool&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-369D\"></a>Sets quiet mode on or off. Returns previous mode value. \n            </p> \n            <p><a name=\"GUID-83DAB77B-FB25-470F-BC0D-513B185AA772\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-369C\"></a> <em class=\"strong\">The syntax for MAXScript methods that use the Default Action system are:</em> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-369B\"></a> \n            <h2><a name=\"GUID-1E59444D-1DC7-42BA-8F58-2708935581EA\"></a> <em class=\"strong\">render:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D4F\"></a><pre><em class=\"codeEmphasisStrong\">quiet</em>: &lt;bool&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3699\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, suppress participating dialogs. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3698\"></a>In previous versions, the default was <span class=\"code\"> <em class=\"strong\">false</em> </span>. In <em class=\"strong\">3ds Max 8 and higher</em>, the default is the current quiet mode. \n            </p> \n            <p><a name=\"GUID-160FCEA8-AE86-4F46-90D6-06C9EBF81FE8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D4E\"></a><pre><em class=\"codeEmphasisStrong\">missingExtFilesAction</em>: &lt;actions&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3695\"></a>Actions to take on Missing External Files, where &lt;actions&gt; is :<span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, <span class=\"code\"> <em class=\"strong\">#abort</em> </span>, <span class=\"code\"> <em class=\"strong\">#default</em> </span> and/or an integer, or an array of one or more of those items. \n            </p> \n            <p><a name=\"GUID-0CABD2B0-D024-4139-A255-CA5098206A54\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D4D\"></a><pre><em class=\"codeEmphasisStrong\">missingExtFilesList</em>: &amp;variable </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3692\"></a>If <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span> is specified as action, the by-reference variable will be filled in with array of\n               the missing external file names. \n            </p> \n            <p><a name=\"GUID-2B992993-8B34-4956-8C67-C2897F5D26A5\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D4C\"></a><pre><em class=\"codeEmphasisStrong\">missingUVWAction</em>: &lt;actions&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-368F\"></a>Actions to take on Missing UVWs, where &lt;actions&gt; is: <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, <span class=\"code\"> <em class=\"strong\">#abort</em> </span>, <span class=\"code\"> <em class=\"strong\">#default</em> </span> and/or an integer, or an array of one or more of those items. \n            </p> \n            <p><a name=\"GUID-F39F424D-D403-41A1-8662-EC0C5B7EDB24\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D4B\"></a><pre><em class=\"codeEmphasisStrong\">missingUVWList</em>: &amp;variable </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-368C\"></a>If <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span> is specified as action, the by-reference variable will be filled in with array of\n               strings containing the missing map channel and node name. \n            </p> \n            <p><a name=\"GUID-97C3340E-F3D8-4446-A84D-58A0B5CB34A3\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D4A\"></a><pre><em class=\"codeEmphasisStrong\">unsupportedRenderEffectAction</em>: &lt;actions&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3689\"></a>Actions to take on Unsupported Render Effects, where &lt;actions&gt; is: <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, <span class=\"code\"> <em class=\"strong\">#abort</em> </span>, <span class=\"code\"> <em class=\"strong\">#default</em> </span> and/or an integer, or an array of one or more of those items. Available in <em class=\"strong\">3ds Max 8 and higher</em>. \n            </p> \n            <p><a name=\"GUID-5313D10C-F0C8-474D-8B0D-4DEED9E80166\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D49\"></a><pre><em class=\"codeEmphasisStrong\">unsupportedRenderEffectList</em>: &amp;variable </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3686\"></a>If <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span> is specified as action, the by-reference variable will be filled in with array of\n               the unsupported render effect names. Available in <em class=\"strong\">3ds Max 8 and higher</em>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3685\"></a> \n            <h2><a name=\"GUID-B856AC9C-F0A5-43DB-940C-8C14FC276B93\"></a> <em class=\"strong\">loadMaxFile: , fetchMaxFile:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D48\"></a><pre><em class=\"codeEmphasisStrong\">quiet</em>: &lt;bool&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3683\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, suppress participating dialogs. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3682\"></a>In previous versions, the default was <span class=\"code\"> <em class=\"strong\">false</em> </span>. In <em class=\"strong\">3ds Max 8 and higher</em>, the default is the current quiet mode. \n            </p> \n            <p><a name=\"GUID-2D090E0D-6B82-4C1F-A710-F98533DC50A7\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D47\"></a><pre><em class=\"codeEmphasisStrong\">missingExtFilesAction</em>: &lt;actions&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-367F\"></a>Actions to take on Missing External Files, where &lt;actions&gt; is: <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, <span class=\"code\"> <em class=\"strong\">#abort</em> </span>, <span class=\"code\"> <em class=\"strong\">#default</em> </span> and/or an integer, or an array of one or more of those items. \n            </p> \n            <p><a name=\"GUID-759D60EC-8209-4584-A1D7-B1FE3F66B880\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D46\"></a><pre><em class=\"codeEmphasisStrong\">missingExtFilesList</em>: &amp;variable </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-367C\"></a>If <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span> is specified as action, the by-reference variable will be filled in with array of\n               the missing external file names. \n            </p> \n            <p><a name=\"GUID-6B3F9050-565D-48B8-A53F-2577C6745D1B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D45\"></a><pre><em class=\"codeEmphasisStrong\">missingDLLsAction</em>: &lt;actions&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3679\"></a>Actions to take on Missing DLLs, where &lt;actions&gt; is: <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, <span class=\"code\"> <em class=\"strong\">#abort</em> </span>, <span class=\"code\"> <em class=\"strong\">#default</em> </span> and/or an integer, or an array of one or more of those items \n            </p> \n            <p><a name=\"GUID-8A19B9C7-3DDC-4287-BC6B-947D3894C8CD\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D44\"></a><pre><em class=\"codeEmphasisStrong\">missingDLLsList</em>: &amp;variable </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3676\"></a>If <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span> is specified as action, the by-reference variable will be filled in with array of\n               strings containing the missing dll file and class name. \n            </p> \n            <p><a name=\"GUID-2F0BD604-E493-4D3B-BF1A-0EF20A927AD0\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D43\"></a><pre><em class=\"codeEmphasisStrong\">missingXRefsAction</em>: &lt;actions&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3673\"></a>Actions to take on Missing Xrefs, where &lt;actions&gt; is: <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, <span class=\"code\"> <em class=\"strong\">#abort</em> </span>, <span class=\"code\"> <em class=\"strong\">#default</em> </span> and/or an integer, or an array of one or more of those items \n            </p> \n            <p><a name=\"GUID-6D204A47-05A0-4759-B25E-E1A22DDB2533\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D42\"></a><pre><em class=\"codeEmphasisStrong\">missingXRefsList</em>: &amp;variable </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3670\"></a>If <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span> is specified as action, the by-reference variable will be filled in with array of\n               strings containing the missing XRef files and/or XRef object names. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-366F\"></a> \n            <h2><a name=\"GUID-1E067DA9-4EA2-4D39-89AE-E5B1B2194CAB\"></a> <em class=\"strong\">mergeMaxFile:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D41\"></a><pre><em class=\"codeEmphasisStrong\">quiet</em>: &lt;bool&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-366D\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, suppress participating dialogs. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-366C\"></a>In previous versions, the default was <span class=\"code\"> <em class=\"strong\">false</em> </span>. In <em class=\"strong\">3ds Max 8 and higher</em>, the default is the current quiet mode. \n            </p> \n            <p><a name=\"GUID-2A889499-087E-4332-ABE8-A9AD8D6F6C27\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D40\"></a><pre><em class=\"codeEmphasisStrong\">missingDLLsAction</em>: &lt;actions&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3669\"></a>Actions to take on Missing DLLs, where &lt;actions&gt; is: <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, <span class=\"code\"> <em class=\"strong\">#abort</em> </span>, <span class=\"code\"> <em class=\"strong\">#default</em> </span> and/or an integer, or an array of one or more of those items. \n            </p> \n            <p><a name=\"GUID-956C3C3F-DEEF-4529-AD0A-21E309829EE9\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D3F\"></a><pre><em class=\"codeEmphasisStrong\">missingDLLsList</em>: &amp;variable </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3666\"></a>If <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span> is specified as action, the by-reference variable will be filled in with array of\n               strings containing the missing dll file and class name. \n            </p> \n            <p><a name=\"GUID-8EC64858-83FB-4D25-89FF-F6D50BC7318D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D3E\"></a><pre><em class=\"codeEmphasisStrong\">missingExtFilesAction</em>: &lt;actions&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3663\"></a>Actions to take on Missing External Files, where &lt;actions&gt; is: <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, <span class=\"code\"> <em class=\"strong\">#abort</em> </span> and/or an integer, or an array of one or more of those items. Available in <em class=\"strong\">3ds Max 8 and higher</em>. \n            </p> \n            <p><a name=\"GUID-0636C3B8-4E33-41D8-AE63-1DAD2FC9DBFD\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D3D\"></a><pre><em class=\"codeEmphasisStrong\">missingExtFilesList</em>: &amp;variable </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3660\"></a>If <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span> is specified as action, the by-reference variable will be filled in with array of\n               the missing external file names. Available in <em class=\"strong\">3ds Max 8 and higher</em>. \n            </p> \n            <p><a name=\"GUID-D3255D00-A523-45CF-9394-654952A2A575\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D3C\"></a><pre><em class=\"codeEmphasisStrong\">missingXRefsAction</em>: &lt;actions&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-365D\"></a>Actions to take on Missing Xrefs, where &lt;actions&gt; is: <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, <span class=\"code\"> <em class=\"strong\">#abort</em> </span> and/or an integer, or an array of one or more of those items. Available in <em class=\"strong\">3ds Max 8 and higher</em>. \n            </p> \n            <p><a name=\"GUID-A5D9515C-1592-4D58-9167-25DDE73D08D6\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D3B\"></a><pre><em class=\"codeEmphasisStrong\">missingXRefsList</em>: &amp;variable </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-365A\"></a>If <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span> is specified as action, the by-reference variable will be filled in with array of\n               strings containing the missing XRef files and/or XRef object names. Available in <em class=\"strong\">3ds Max 8 and higher</em>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3659\"></a> \n            <h2><a name=\"GUID-815FFC37-8FD8-4E1F-89A6-EF3E0E92F0F8\"></a> <em class=\"strong\">getMAXFileObjectNames:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D3A\"></a><pre><em class=\"codeEmphasisStrong\">quiet</em>: &lt;bool&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3657\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, suppress participating dialogs. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3656\"></a>In previous versions, the default was <span class=\"code\"> <em class=\"strong\">false</em> </span>. In <em class=\"strong\">3ds Max 8 and higher</em>, the default is the current quiet mode. \n            </p> \n            <p><a name=\"GUID-EC4E2CA9-1999-4EAF-9396-A2B0E8B765B1\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D39\"></a><pre><em class=\"codeEmphasisStrong\">missingDLLsAction</em>: &lt;actions&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3653\"></a>Actions to take on Missing DLLs, where &lt;actions&gt; is: <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span>, <span class=\"code\"> <em class=\"strong\">#logToFile</em> </span>, <span class=\"code\"> <em class=\"strong\">#abort</em> </span>, <span class=\"code\"> <em class=\"strong\">#default</em> </span> and/or an integer, or an array of one or more of those items \n            </p> \n            <p><a name=\"GUID-4D306961-ADC2-479D-8056-9B1922888942\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D38\"></a><pre><em class=\"codeEmphasisStrong\">missingDLLsList</em>: &amp;variable </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3650\"></a>If <span class=\"code\"> <em class=\"strong\">#logmsg</em> </span> is specified as action, the by-reference variable will be filled in with array of\n               strings containing the missing dll file and class name. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-364E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-364D\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D37\"></a><pre>\nval = undefined\nloadmaxfile \"apollo.max\" missingExtFilesList:&amp;val missingExtFilesAction:#logmsg quiet:true\nval\nval = undefined\nrender missingExtFilesList:&amp;val missingExtFilesAction:#(#logmsg,#abort) quiet:true\nval\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3643\"></a><p class=\"table-body\">If there are missing external files, the scene will load without a Missing External\n                           Files dialog, and val will contain an array of the missing file names. The scene will\n                           not render (due to the <span class=\"code\"> <em class=\"strong\">#abort</em> </span> option being specified), and val will contain an array of the missing file names.\n                           \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3640\"></a> <span class=\"char_link\"><a href=\"GUID-0625831A-42BF-4EB9-93E3-9606FD1BEC02.htm\">Command Line Option: -silent</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-363F\"></a> <span class=\"char_link\"><a href=\"GUID-9175301C-13E6-488B-ABA6-D27CD804B205.htm\">Controlling the Renderer</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-363E\"></a> <span class=\"char_link\"><a href=\"GUID-624D3D05-B15D-4A97-9F15-DA35CDB0DDD2.htm\">3ds Max File Loading and Saving</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";