var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A22DCC5C-A298-4FBD-8BC4-2F086FD2CEEE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface IKSys\">\n      <meta name=\"indexterm\" content=\"IKSys Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: IKSys</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A22DCC5C-A298-4FBD-8BC4-2F086FD2CEEE\"></a><div class=\"head\">\n            <h1>Interface: IKSys </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-15A2\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-15A1\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; IKSys \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-159F\"></a>This<em class=\"strong\"> Core Interface </em>provides methods for creating<em class=\"strong\"> IK Chains</em>. \n         </p>\n         <p><a name=\"GUID-99BBADF8-BE32-4CE7-9ADC-5BE84C829B3A\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-159E\"></a> <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59E0\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">IKSys</em>.<em class=\"codeEmphasisStrong\">ikChain</em> &lt;node&gt;startJoint &lt;node&gt;endJoint &lt;string&gt;solver 	 </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-159D\"></a>Creates an IK chain where startJoint is the first node in the new chain (ancestor),\n            endJoint is the last node in the chain (descendant) and solver is the name of the\n            IK solver to use (as returned by the<span class=\"code\"> <em class=\"strong\"> iksys.solverName()</em> </span> method described below. \n         </p>\n         <p><a name=\"GUID-663361D4-EA62-4D5C-AFDE-830C5E9D1AFB\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59DF\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">IKSys</em>.<em class=\"codeEmphasisStrong\">solverCount()</em> </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-159B\"></a>Returns the number of available solvers installed on the system. \n         </p>\n         <p><a name=\"GUID-CCEA2AE1-FAE1-445C-934C-C2F13CF0022C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59DE\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">IKSys</em>.<em class=\"codeEmphasisStrong\">solverName</em> &lt;integer&gt;solverIndex </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1599\"></a>Returns the name of the indexed solveras string. \n         </p>\n         <p><a name=\"GUID-83DAB93B-5CBA-459D-932A-1525C61F4D88\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59DD\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">IKSys</em>.<em class=\"codeEmphasisStrong\">solverUIName</em> &lt;integer&gt;solverIndex </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1597\"></a>Returns the UI Name of the indexed solver. \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1596\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1595\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59DC\"></a><pre>\nfor i = 1 to iksys.solverCount() do\nformat \"% : %\\n\" (iksys.solverName i) (iksys.solverUIName i)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1594\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59DB\"></a><pre>\nIKHISolver : IKHISolver\nIKLimb : IKLimb\nSplineIKSolver : SplineIKSolver\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-166DCBAD-8502-40B6-B1B9-B6AE06EF5F20\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59DA\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">IKSys</em>.<em class=\"codeEmphasisStrong\">suspendLinkNotify</em>() </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1592\"></a>Disables the link notification in IK systems. \n         </p>\n         <p><a name=\"GUID-210F62FC-A336-43D2-87BF-EB146BC19DCD\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59D9\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">IKSys</em>.<em class=\"codeEmphasisStrong\">resumeLinkNotify</em>() </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1590\"></a>Enables the link notification in IK systems. \n         </p>\n         <p><a name=\"GUID-A85A7BD2-53EF-4DD5-B4E6-4A1E6116759F\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-59D8\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">IKSys</em>.<em class=\"codeEmphasisStrong\">isLinkNotifySuspended</em>() </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-158E\"></a>Returns <span class=\"code\"> <em class=\"strong\">true </em> </span>if IK link notification is disabled,<span class=\"code\"> <em class=\"strong\"> false </em> </span>if enabled. \n         </p>\n         <p><a name=\"GUID-7FA45DFF-E260-47B6-84EE-0E847BAACD56\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";