var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A2663EFC-8DBE-4F18-9327-C1AFF6019BA1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MAXScript Access To CAT Layers\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXScript Access To CAT Layers</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A2663EFC-8DBE-4F18-9327-C1AFF6019BA1\"></a><div class=\"head\">\n            <h1>MAXScript Access To CAT Layers </h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171C9F\"></a>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6838\"></a> The following page provides an overview of the CAT layer controllers and interfaces\n            exposure to MAXScript. \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC683A\"></a> \n            <h2><a name=\"GUID-F98B9426-B2BF-4968-8885-BB1A0C953A0E\"></a> <em class=\"strong\">LayerRoot Controller</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC683B\"></a>The <span class=\"char_link\"><a href=\"GUID-BD1BAFF0-EB31-4EA0-BB2A-CED76CE170B1.htm\">CATParent Helper Object</a></span> holds a controller called the <span class=\"char_link\"><a href=\"GUID-3DA6C9E1-554C-4F6D-BB90-092A4F7CEFAC.htm\">LayerRoot</a></span> in its .layers property which manages all the layers in the character. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC683C\"></a>The <span class=\"char_link\"><a href=\"GUID-3DA6C9E1-554C-4F6D-BB90-092A4F7CEFAC.htm\">LayerRoot</a></span> holds an array of <span class=\"char_link\"><a href=\"GUID-F2499C73-51DF-4142-B77A-54E482E2005D.htm\">LayerInfo</a></span> controllers which contain information relevant to each layer, such as the layer name,\n               global weight and timewarp curve. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC683E\"></a> <em class=\"strong\">LayerRootFPInterface</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC683F\"></a>The <span class=\"char_link\"><a href=\"GUID-D3F998FD-2F74-4393-B705-B3B12F6EE9CD.htm\">LayerRootFPInterface</a></span> exposes all the layer manipulations to MAXScript and is available on every layer\n               controller, the CATParent and the <span class=\"char_link\"><a href=\"GUID-3DA6C9E1-554C-4F6D-BB90-092A4F7CEFAC.htm\">LayerRoot controller</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6840\"></a>Many controllers expose the <span class=\"char_link\"><a href=\"GUID-D3F998FD-2F74-4393-B705-B3B12F6EE9CD.htm\">LayerRootFPInterface</a></span>, and function calls made to a <span class=\"char_link\"><a href=\"GUID-D3F998FD-2F74-4393-B705-B3B12F6EE9CD.htm\">LayerRootFPInterface</a></span> are passed directly on to the <span class=\"char_link\"><a href=\"GUID-3DA6C9E1-554C-4F6D-BB90-092A4F7CEFAC.htm\">LayerRoot controller</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6841\"></a>In other words, the <span class=\"char_link\"><a href=\"GUID-D3F998FD-2F74-4393-B705-B3B12F6EE9CD.htm\">LayerRootFPInterface</a></span> is exposed on multiple controllers in the character hierarchy simply for the convenience\n               of the user. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6843\"></a> \n            <h2><a name=\"GUID-12E342A4-6336-495B-BC0F-04F6BAC4C1B6\"></a> <em class=\"strong\">LayerInfo</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6844\"></a>As mentioned above, the <span class=\"char_link\"><a href=\"GUID-3DA6C9E1-554C-4F6D-BB90-092A4F7CEFAC.htm\">LayerRoot Controller</a></span> holds an array of <span class=\"char_link\"><a href=\"GUID-F2499C73-51DF-4142-B77A-54E482E2005D.htm\"> LayerInfo Controllers</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6845\"></a>Each <span class=\"char_link\"><a href=\"GUID-F2499C73-51DF-4142-B77A-54E482E2005D.htm\">LayerInfo Controller</a></span> holds the properties for a layer in the layer stack. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6847\"></a> <em class=\"strong\">SubAnims </em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5048\"></a><pre>.<em class=\"codeEmphasisStrong\">weights</em>: float</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6849\"></a>The weights subanim found on the LayerInfo controller is the global weights controller\n               for this layer. \n            </p> \n            <p><a name=\"GUID-EF03056A-45F9-4165-B22E-13D8AAF7C033\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5047\"></a><pre>.<em class=\"codeEmphasisStrong\">timewarp</em>: float</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC684C\"></a>Provides access to the layer time warp controller. \n            </p> \n            <p><a name=\"GUID-0395F31B-57B5-4790-93C2-C1348392ADD8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5046\"></a><pre>.<em class=\"codeEmphasisStrong\">transform</em>: transform</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC684F\"></a>Contains the transform controller for the Transform node. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6851\"></a>The <span class=\"char_link\"><a href=\"GUID-F2499C73-51DF-4142-B77A-54E482E2005D.htm\">LayerInfo</a></span> controller exposes the <span class=\"char_link\"><a href=\"GUID-D3BB444C-2424-4D5B-9825-61729C16CC15.htm\">LayerInfoFPInterface </a></span>Function Publishing Interface. \n            </p> \n            <p><a name=\"GUID-697D2160-457C-4305-9092-974B95917FB8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5045\"></a><pre>.<em class=\"codeEmphasisStrong\">SelectedLayer</em>: integer : Read|Write</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6854\"></a>Returns the currently selected layer. \n            </p> \n            <p><a name=\"GUID-F930AC73-4271-4B82-8D80-B4EF0292799F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5044\"></a><pre>.<em class=\"codeEmphasisStrong\">SoloLayer</em>: integer : Read|Write</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC6857\"></a>Returns the index of the solo layer, or -1 if no layer is soloed. \n            </p> \n            <p><a name=\"P_CF76CE266E07406C8F55B85FBCCA9D90\"></a>&nbsp;&nbsp;&nbsp; \n            </p> <a name=\"TABLE_868E2C022C5B4A439D86DAA73C1DDC11\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.1476235442241105%\">\n                     <col width=\"54.170601196096946%\">\n                     <col width=\"42.681775259678936%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\" colspan=\"2\"> <a name=\"P_93F7AE084C8E4A5888872B833C8BA0C4\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_AAF24F5C88334D3CAC4CD93D06E837E7\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">3ds Max CAT - Quick Navigation</a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF9171CA0\"></a></p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC685B\"></a> <span class=\"char_link\"><a href=\"GUID-7664D95A-A27D-4356-8442-F53064920BF8.htm\">3ds Max CAT and MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";