var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A2F530D0-628D-48DA-A126-6752A525E1FF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>State Sets MAXScript Access</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A2F530D0-628D-48DA-A126-6752A525E1FF\"></a><div class=\"head\">\n            <h1>State Sets MAXScript Access </h1>\n         </div>\n         <p><a name=\"GUID-417E731F-B6AF-47CA-A26D-AECEAA404CE6\"></a> The State Sets render pass management system was first introduced in the \n            		<em class=\"strong\">Subscription Advantage Pack</em> extension to \n            		<em class=\"strong\">3ds Max 2012</em> and is now integral part of \n            		<em class=\"strong\">3ds Max 2013 and higher</em>. In \n            		<em class=\"strong\">3ds Max 2018 and higher</em>, the compositing editor is a node-based system. \n            	 \n         </p>\n         <p><a name=\"GUID-1C3C1A0A-3535-4083-B8A7-CCB2E132AA7B\"></a>This feature is exposed to MAXScript via a DotNet object and its properties and methods.\n            \n            	 \n         </p>\n         <p><a name=\"P_AC188672084641C2B7938C60AE97B11F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-01E7E5FC-B418-41F5-9052-10DCAD3CFEAD\"></a>The following example shows the basic steps involved in accessing and manipulating\n            State Sets. \n            	 \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-114B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-114A\"></a><p class=\"table-body\"> <em class=\"strong\">Getting Access To State Sets</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5883\"></a><pre>\nstateSetsDotNetObject = dotNetObject \"Autodesk.Max.StateSets.Plugin\" --Get StateSets dotNet object. \nstateSets = stateSetsDotNetObject.Instance --Get the state sets instance from the dotNet object. \n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-6CF74719-A5E7-4860-A5BA-27507D529D9D\"></a><p class=\"table-body\"> <em class=\"strong\">Opening and closing State Sets window</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nstateSets.ShowMainFrame() --Open the State Sets window. \nstateSets.HideMainFrame() --Close the State Sets window. \n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-1A17C42E-40D1-428C-BCF8-6731ADE715DD\"></a><p class=\"table-body\"> <em class=\"strong\">Getting access to the Master state</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>masterState = stateSets.EntityManager.RootEntity.MasterStateSet</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-F88C15EC-65C3-4614-9779-27125DC071A7\"></a><p class=\"table-body\"> <em class=\"strong\">Adding and renaming a new state set</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nstateSet = masterState.AddState()\nstateSet.Name = \"MyStateSet\"\nmasterState.AssignUniqueName stateSet \"MyMasterStateset\" --Assigns a unique name to the state set \n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-854F16BF-57CF-49B2-90C1-F073A5BA15F3\"></a><p class=\"table-body\"> <em class=\"strong\">Changing current state set, starting, and ending recording</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\npreviousCurrentStateSet = masterState.CurrentState.Items[0] --Record current state set.\nmasterState.CurrentState = #(stateSet) --Assign current state set. \nstateSet.BeginRecording() --Begin recording state set.  \nstateSet.EndRecording() --End recording state set. \nmasterState.CurrentState = #(previousCurrentStateSet) --Assign previous state set. \n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-AB958D2F-D843-4288-AB88-6E8471A63B76\"></a><p class=\"table-body\"> <em class=\"strong\">Adding and rendering a child sub-state set, and doing other operations</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nsubStateSet = stateSet.AddState()\nsubStateSet = stateSet.Render #(stateSet) --Render state set, note that we specify a path because this state set could be located under multiple parents.\n\nscriptedState = stateSet.AddScriptedState(false) --Add a scripted state. \nscriptedState.ApplyScript = \"-- MaxScript executed when applying state set\" --Assign the apply script.\nscriptedState.RevertScript = \"-- MaxScript executed when reverting state set\" --Assign the revert script. \nstateSet.CreateTemplate() --Create a template for this state set  \n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-104063E1-9239-4B21-94B3-B658A0CBE06A\"></a><p class=\"table-body\"> <em class=\"strong\">Deleting state set and first child</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nmasterState.RemoveChild stateSet --Removes the state set \nmasterState.RemoveChild masterState.Children.Item[0] --Removes the first child\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-A443E4BB-62D6-4EEE-A7DD-31067E10A7E4\"></a><p class=\"table-body\"> <em class=\"strong\">Adding a compositor view</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nmasterState.CreateCompositingView true --Add compositor view with render elements\nmasterState.CreateCompositingView false --Add compositor view without render elements\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <p class=\"table-body\"><em class=\"strong\">Getting the nodes in the active compositor view</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>cViewNodes = stateSets.CompositingViewNodes\n\nfor i in 0 to (cViewNodes.Count - 1 ) do (\n	node = cViewNodes.Item(i)\n	node.Collapsed = true\n	print node.Tag.Name	\n)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-102F26C6-AF2B-4E8F-AAB1-7BDD0EF360FE\"></a><p class=\"table-body\"> <em class=\"strong\">Rendering all state sets in the scene</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>masterState.RenderAllStates()</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-6C94CF50-6985-427E-AECC-E8708DFEC3FB\"></a><p class=\"table-body\"> <em class=\"strong\">Getting access to objects state set</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>objectStateSet = masterState.ObjectStateSet</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-D14E0D6B-6E0C-483A-AA41-710478D904A0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"GUID-140C3AE4-C222-44F0-B83C-976135DF3E19\"></a>All properties and methods of all DotNet objects and classes implemented by the State\n            Sets system are accessible to MAXScript using the DotNet inspector functions. \n            	 \n         </p><a name=\"TABLE_B8DA8F9402B24F63B2F6EBFD20B66833\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-47F5361A-2872-4326-8B53-0E11BDFD5E4D\"></a><p class=\"table-body\"> <em class=\"strong\">Exploring State Set Plugin Instance</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">stateSetsDotNetObject = dotNetObject \"Autodesk.Max.StateSets.Plugin\"</em>\ndotNetObject:Autodesk.Max.StateSets.Plugin\n\n<em class=\"codeEmphasisStrong\">stateSets = stateSetsDotNetObject.Instance</em>\ndotNetObject:Autodesk.Max.StateSets.Plugin\n\n<em class=\"codeEmphasisStrong\">showProperties stateSets</em>\n  .AbsentLayerStatesWereRemovedOnLoad : &lt;System.Boolean&gt;\n  .ActiveViewId : &lt;System.UInt16&gt;\n  .BitmapInfos : &lt;System.Collections.Generic.Dictionary`2[System.Int32,Autodesk.Max.IBitmapInfo]&gt;, read-only\n  .ClassDescManager : &lt;Autodesk.Max.StateSets.ClassDescManager&gt;, read-only\n  .CompositingView : &lt;Ephere.Gui.NodeViews.NodeView&gt;, read-only\n  .CompositingViewNodes : &lt;System.Collections.Generic.IList`1[Ephere.Gui.NodeViews.NodeView+Node]&gt;, read-only\n  .CompositorLink : &lt;Autodesk.Max.StateSets.CompositorLink.CompositorLinkSettingsController&gt;, read-only\n  .CompositorLinkTargetViewId : &lt;System.UInt16&gt;\n  .Configuration : &lt;Autodesk.Max.StateSets.Configuration&gt;\n  .EntityManager : &lt;Autodesk.Max.StateSets.Entities.EntityManager&gt;, read-only\n  .Global : &lt;Autodesk.Max.IGlobal&gt;\n  .GlobalStringFormat : &lt;System.Drawing.StringFormat&gt;, read-only\n  .HasRenderPreviewNode : &lt;System.Boolean&gt;, read-only\n  .Instance : &lt;Autodesk.Max.StateSets.Plugin&gt;, static\n  .InvokeRequired : &lt;System.Boolean&gt;, read-only\n  .IsInSequencerMode : &lt;System.Boolean&gt;\n  .IsMainFrameInitialized : &lt;System.Boolean&gt;, read-only\n  .IsMainFrameVisible : &lt;System.Boolean&gt;\n  .LoadedVersion : &lt;System.Version&gt;\n  .MainFrameBounds : &lt;System.Drawing.Rectangle&gt;\n  .NodeEvents : &lt;Autodesk.Max.StateSets.Plugin+NodeEventCallback&gt;, read-only\n  .OpenViewCount : &lt;System.Int32&gt;, read-only\n  .PluginWasRegistered : &lt;System.Boolean&gt;\n  .PreviewRenderNode : &lt;Autodesk.Max.IINode&gt;, read-only\n  .SequencerTreeView : &lt;Ephere.Gui.NodeViews.NodeView&gt;, read-only\n  .Skin : &lt;Ephere.Gui.NodeViews.Skin&gt;, read-only\n  .Sync : &lt;System.ComponentModel.ISynchronizeInvoke&gt;\n  .ToolbarTreeView : &lt;Ephere.Gui.NodeViews.NodeView&gt;, read-only\n  .TreeView : &lt;Ephere.Gui.NodeViews.NodeView&gt;, read-only\n  .TreeViews : &lt;Ephere.Gui.NodeViews.NodeView[]&gt;, read-only\n  .accumCallbacks : &lt;System.Int32[]&gt;\ntrue\n\n<em class=\"codeEmphasisStrong\">showMethods stateSets</em>\n  .&lt;System.Int32&gt;AccumCallbackCount &lt;Autodesk.Max.StateSets.Plugin+AccumCallbackType&gt;type\n  .AccumCallbackIncrement &lt;Autodesk.Max.StateSets.Plugin+AccumCallbackType&gt;type\n  .AccumCallbackIncrement &lt;Autodesk.Max.StateSets.Plugin+AccumCallbackType&gt;type &lt;System.Int32&gt;n\n  .AccumCallbackReset &lt;Autodesk.Max.StateSets.Plugin+AccumCallbackType&gt;type\n-- Added in 3ds Max 2018:\n  .&lt;Ephere.Gui.NodeViews.NodeView&gt;AddTreeView()\n  .&lt;System.IAsyncResult&gt;BeginInvoke &lt;System.Delegate&gt;method &lt;System.Object[]&gt;args\n  .Cleanup()\n  .&lt;T&gt;CreateInstance()\n  .&lt;System.Runtime.Remoting.ObjRef&gt;CreateObjRef &lt;System.Type&gt;requestedType\n  .&lt;System.Object&gt;EndInvoke &lt;System.IAsyncResult&gt;result\n  .&lt;System.Boolean&gt;Equals &lt;System.Object&gt;obj\n  .[static]&lt;System.Boolean&gt;Equals &lt;System.Object&gt;objA &lt;System.Object&gt;objB\n  .&lt;System.Int32&gt;GetHashCode()\n  .&lt;System.Object&gt;GetLifetimeService()\n  .&lt;System.Type&gt;GetType()\n  .&lt;System.Int32&gt;GetUniqueBitmapInfoId()\n  .HideMainFrame()\n  .Initialize &lt;Autodesk.Max.IGlobal&gt;global &lt;System.ComponentModel.ISynchronizeInvoke&gt;sync\n  .&lt;System.Object&gt;InitializeLifetimeService()\n  .&lt;System.Object&gt;Invoke &lt;System.Delegate&gt;method &lt;System.Object[]&gt;args\n  .&lt;Autodesk.Max.IValue&gt;LaunchBlank &lt;Autodesk.Max.IValue[]&gt;args\n  .[static]Log &lt;Autodesk.Max.StateSets.Plugin+LogType&gt;logType &lt;System.String&gt;message\n  .[static]Log &lt;System.String&gt;message &lt;System.Boolean&gt;newLine\n  .LogLocal &lt;Autodesk.Max.StateSets.Plugin+LogType&gt;logType &lt;System.String&gt;message\n  .PreviewRenderNodeReset()\n  .[static]&lt;System.Boolean&gt;ReferenceEquals &lt;System.Object&gt;objA &lt;System.Object&gt;objB\n  .RegisterAnchorCallbacks()\n  .ReloadConfiguration()\n  .ResetAndDelete()\n  .ResetConfiguration()\n  .ResetNodeEventCallbackMessages()\n  .ShowMainFrame()\n  .&lt;Autodesk.Max.StateSets.Entities.StateSets.SetupRenderOutputs&gt;ShowSetupRenderOutputsPanel()\n  .ToggleMainFrame()\n  .&lt;System.String&gt;ToString()\n  .TriggerNodeEventCallbackMessages()\n  .UnRegisterAnchorCallbacks()true\ntrue\n\n<em class=\"codeEmphasisStrong\">showEvents stateSets</em>\n   CameraSequencerModeChanged &lt;System.Boolean&gt;obj = ( ... )\n   CurrentLayerChanged &lt;Autodesk.Max.IILayer&gt;obj = ( ... )\n   CurrentStateSetChanged &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;obj = ( ... )\n   ScenePostSave = ( ... )\n   StateApplied &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;arg1 &lt;System.Boolean&gt;arg2 = ( ... )\n   StateRecording &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;arg1 &lt;System.Boolean&gt;arg2 = ( ... )\n   StateSetAdded &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;obj = ( ... )\n   StateSetChanged &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;obj = ( ... )\n   StateSetRemoved &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;obj = ( ... )\n   StateSetRenamed &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;obj = ( ... )\n   TimeChange &lt;System.Int32&gt;obj = ( ... )\n   TimeRangeChanged = ( ... )\ntrue\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-D7E8233A-7870-4E2F-AEAF-8A32E826B611\"></a><p class=\"table-body\"> <em class=\"strong\">Exploring MasterStateSet</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre> <em class=\"codeEmphasisStrong\">showProperties stateSets.EntityManager</em> <em class=\"codeEmphasisStrong\">.RootEntity</em> : &lt;Autodesk.Max.StateSets.Entities.Root&gt;\ntrue\n\n<em class=\"codeEmphasisStrong\">showProperties stateSets.EntityManager.RootEntity</em>\n  .AutomaticName : &lt;System.String&gt;\n  .AutomaticTypeName : &lt;System.String&gt;\n  .Children : &lt;System.Collections.Generic.List`1[Autodesk.Max.StateSets.Entities.Entity]&gt;\n  .CustomAttributes : &lt;System.Collections.Hashtable&gt;, read-only\n  .CustomChildren : &lt;System.Collections.Generic.List`1[Autodesk.Max.StateSets.Entities.Entity]&gt;\n  .Description : &lt;System.String&gt;\n  .DynamicInsertTarget : &lt;System.Boolean&gt;\n  .HierarchyIndex : &lt;System.Int32&gt;, read-only\n  .InternalName : &lt;System.String&gt;, read-only\n  .MasterStateSet : &lt;Autodesk.Max.StateSets.Entities.StateSets.Master&gt;, read-only\n  .Name : &lt;System.String&gt;\n  .Parents : &lt;Autodesk.Max.StateSets.Entities.Entity[]&gt;, read-only\n  .TypeName : &lt;System.String&gt;\n  .UseNameForTypeName : &lt;System.Boolean&gt;, read-only\n  .CustomChildrenToken : &lt;System.String&gt;, read-only, static \ntrue\n\n<em class=\"codeEmphasisStrong\">showProperties stateSets.EntityManager.RootEntity.MasterStateSet</em>\n  .AutomaticName : &lt;System.String&gt;, read-only\n  .AutomaticTypeName : &lt;System.String&gt;\n  .Children : &lt;System.Collections.Generic.List`1[Autodesk.Max.StateSets.Entities.Entity]&gt;\n  .CompositorLinkFilePath : &lt;System.String&gt;\n  .CurrentState : &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet[]&gt;\n  .CustomAttributes : &lt;System.Collections.Hashtable&gt;, read-only\n  .CustomChildren : &lt;System.Collections.Generic.List`1[Autodesk.Max.StateSets.Entities.Entity]&gt;\n  .DefaultRenderOutputFilePattern : &lt;System.String&gt;, read-only, static\n  .DescendantStateCount : &lt;System.Int32&gt;, read-only\n  .Description : &lt;System.String&gt;, read-only\n  .DynamicInsertTarget : &lt;System.Boolean&gt;\n  .HierarchyIndex : &lt;System.Int32&gt;, read-only\n  .InternalName : &lt;System.String&gt;, read-only\n  .Name : &lt;System.String&gt;\n  .ObjectStateSet : &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;, read-only\n  .Parents : &lt;Autodesk.Max.StateSets.Entities.Entity[]&gt;, read-only\n  .RenderOutputFilePattern : &lt;System.String&gt;\n  .StatesWithErrors : &lt;System.Collections.Generic.ICollection`1[Autodesk.Max.StateSets.Entities.StateSets.IState]&gt;, read-only\n  .TypeName : &lt;System.String&gt;\n  .UseNameForTypeName : &lt;System.Boolean&gt;, read-only\n  .CustomChildrenToken : &lt;System.String&gt;, read-only, static\n  .StateNameToken : &lt;System.String&gt;, read-only, static\ntrue\n\n<em class=\"codeEmphasisStrong\">showMethods stateSets.EntityManager.RootEntity.MasterStateSet</em>\n  .&lt;Autodesk.Max.StateSets.Entities.Entity&gt;AddChild &lt;Autodesk.Max.StateSets.Entities.Entity&gt;entity &lt;System.Boolean&gt;wasAutoGenerated\n  .&lt;Autodesk.Max.StateSets.Entities.Entity&gt;AddChild &lt;Autodesk.Max.StateSets.Entities.Entity&gt;entity &lt;System.Boolean&gt;wasAutoGenerated &lt;System.Boolean&gt;broadcastEvent\n  .AddObjectState()\n  .AddObjectState &lt;System.Nullable`1[[System.UInt16, mscorlib, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089]]&gt;targetViewId\n  .&lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;AddState()\n  .&lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;AddState &lt;System.Nullable`1[[System.UInt16, mscorlib, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089]]&gt;targetViewId &lt;System.Boolean&gt;addToCompositorView\n  .AssignUniqueName &lt;Autodesk.Max.StateSets.Entities.Entity&gt;state &lt;System.String&gt;baseName\n  .BeginRecordingStateSet &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;stateSet &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet[]&gt;path\n  .CheckForStateErrors()\n  .CollectDescendantStateSets &lt;System.Collections.Generic.List`1[[Autodesk.Max.StateSets.Entities.StateSets.StateSet, Autodesk.Max.StateSets, Version=20.0.966.0, Culture=neutral, PublicKeyToken=null]]&gt;destination\n  .CollectDescendantsWithCustomAttribute &lt;System.Object&gt;customAttribute &lt;System.Collections.Generic.List`1[[Autodesk.Max.StateSets.Entities.Entity, Autodesk.Max.StateSets, Version=20.0.966.0, Culture=neutral, PublicKeyToken=null]]&gt;destination\n  .CreateCompositingView &lt;System.Boolean&gt;includeRenderElements\n  .&lt;System.Runtime.Remoting.ObjRef&gt;CreateObjRef &lt;System.Type&gt;requestedType\n  .&lt;Autodesk.Max.StateSets.Entities.StateSets.IParameter&gt;CreateUserCreatableParameter &lt;System.String&gt;name\n  .DefaultSetup()\n  .Dispose()\n  .&lt;System.Boolean&gt;Equals &lt;System.Object&gt;obj\n  .[static]&lt;System.Boolean&gt;Equals &lt;System.Object&gt;objA &lt;System.Object&gt;objB\n  .GenerateChildrenForTarget &lt;Autodesk.Max.StateSets.Entities.Entity&gt;target\n  .&lt;Autodesk.Max.StateSets.Entities.Entity&gt;GetChild &lt;System.String&gt;name\n  .&lt;T&gt;GetCustomAttribute &lt;System.Object&gt;key &lt;T&gt;defaultValue\n  .&lt;System.Boolean&gt;GetCustomAttributeBoolean &lt;System.Object&gt;key\n  .&lt;Autodesk.Max.StateSets.Entities.Entity&gt;GetDescendant &lt;System.String&gt;name\n  .&lt;Autodesk.Max.StateSets.Entities.Entity&gt;GetDescendant &lt;System.Collections.Generic.List`1[[System.String, mscorlib, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089]]&gt;hierarchyIndex\n  .&lt;System.Collections.Generic.IEnumerable`1[Autodesk.Max.StateSets.Entities.Entity]&gt;GetDescendants()\n  .&lt;System.Int32&gt;GetDescendantStateSetIndex &lt;System.Collections.Generic.IEnumerable`1[[Autodesk.Max.StateSets.Entities.StateSets.StateSet, Autodesk.Max.StateSets, Version=20.0.966.0, Culture=neutral, PublicKeyToken=null]]&gt;stateSetPath\n  .&lt;System.Collections.Generic.List`1[Autodesk.Max.StateSets.Entities.StateSets.StateSet[]]&gt;GetDescendantStateSetPaths &lt;System.Boolean&gt;includeObjectStateSet\n  .&lt;System.Int32&gt;GetHashCode()\n  .&lt;System.Collections.Generic.List`1[System.String]&gt;GetHierarchyIndex &lt;Autodesk.Max.StateSets.Entities.Entity&gt;descendant\n  .&lt;System.Object&gt;GetLifetimeService()\n  .GetObjectData &lt;System.Runtime.Serialization.SerializationInfo&gt;info &lt;System.Runtime.Serialization.StreamingContext&gt;context\n  .&lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet&gt;GetStateById &lt;System.Int32&gt;id\n  .&lt;System.Type&gt;GetType()\n  .&lt;System.String[]&gt;GetUserCreatableParameterNames()\n  .&lt;System.Boolean&gt;HasCustomAttribute &lt;System.Object&gt;key\n  .&lt;System.Boolean&gt;HasDescendant &lt;Autodesk.Max.StateSets.Entities.Entity&gt;descendant &lt;System.Collections.Generic.HashSet`1[[Autodesk.Max.StateSets.Entities.Entity, Autodesk.Max.StateSets, Version=20.0.966.0, Culture=neutral, PublicKeyToken=null]]&gt;ignoreParents\n  .&lt;System.Boolean&gt;HasDescendant &lt;Autodesk.Max.StateSets.Entities.Entity&gt;descendant &lt;Autodesk.Max.StateSets.Entities.Entity[]&gt;ignoreParents\n  .&lt;System.Object&gt;InitializeLifetimeService()\n  .&lt;Autodesk.Max.StateSets.Entities.Entity&gt;InsertChild &lt;System.Int32&gt;index &lt;Autodesk.Max.StateSets.Entities.Entity&gt;entity\n  .&lt;Autodesk.Max.StateSets.Entities.Entity&gt;InsertChild &lt;System.Int32&gt;index &lt;Autodesk.Max.StateSets.Entities.Entity&gt;entity &lt;System.Boolean&gt;wasAutoGenerated &lt;System.Boolean&gt;broadcastEvent\n  .InvalidateChildren()\n  .&lt;System.Boolean&gt;IsDescendantOf &lt;Autodesk.Max.StateSets.Entities.Entity&gt;ancestor\n  .[static]maxnrAssignStateSetJob &lt;System.Int32[]&gt;stateSetsHandles &lt;System.Int32&gt;numHandles\n  .&lt;System.Boolean&gt;OnCreateChildForIndex &lt;System.String&gt;index &lt;Autodesk.Max.IRepresentation&gt;target\n  .[static]&lt;System.Boolean&gt;ReferenceEquals &lt;System.Object&gt;objA &lt;System.Object&gt;objB\n  .Refresh()\n  .RemoveChild &lt;Autodesk.Max.StateSets.Entities.Entity&gt;entity\n  .RemoveChild &lt;Autodesk.Max.StateSets.Entities.Entity&gt;entity &lt;System.Boolean&gt;entityChange\n  .RemoveChild &lt;Autodesk.Max.StateSets.Entities.Entity&gt;entity &lt;System.Boolean&gt;entityChange &lt;System.Boolean&gt;broadcastEvent\n  .RemoveCustomAttribute &lt;System.Object&gt;key\n  .&lt;System.Boolean&gt;Rename &lt;System.String&gt;newName\n  .RenderAllStates &lt;System.Boolean&gt;forceNetworkRender\n  .RenderStates &lt;System.Collections.Generic.IEnumerable`1[[System.Collections.Generic.IEnumerable`1[[Autodesk.Max.StateSets.Entities.StateSets.StateSet, Autodesk.Max.StateSets, Version=20.0.966.0, Culture=neutral, PublicKeyToken=null]], mscorlib, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089]]&gt;stateSetPaths &lt;System.Boolean&gt;useNetworkRender\n  .Reset()\n  .ResetCompositingView &lt;System.Boolean&gt;includeRenderElements\n  .SetCurrentStateSet &lt;Autodesk.Max.StateSets.Entities.StateSets.StateSet[]&gt;path\n  .SetCustomAttribute &lt;System.Object&gt;key &lt;T&gt;value\n  .SetCustomAttributeBoolean &lt;System.Object&gt;key &lt;System.Boolean&gt;value\n  .SetupRenderOutputsPath &lt;System.String&gt;value\n  .&lt;System.String&gt;ToString()\n  .UpdateHierarchyParents()\ntrue\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";