var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A3A4E597-B4D7-4C38-90A6-E8F78203114E\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Structure Creation and Cloning Event Handlers\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Structure Creation and Cloning Event Handlers</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A3A4E597-B4D7-4C38-90A6-E8F78203114E\"></a><div class=\"head\">\n            <h1>Structure Creation and Cloning Event Handlers </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87589\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8758A\"></a> In <em class=\"strong\">3ds Max 2010 and higher</em>, two <em class=\"strong\">event handlers</em> can be implemented in struct definitions to be called on <em class=\"strong\">struct creation</em> and <em class=\"strong\">struct cloning</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8758C\"></a>The struct event handlers are always <span class=\"char_link\"><a href=\"GUID-0D3592DD-2F20-4A41-B19F-544426B8186E.htm\">private</a></span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8758D\"></a>These event handlers can be used to perform additional initialization tasks, print\n               out the initial values of variables for debugging purposes, and so on. \n            </p> \n            <p><a name=\"P_26C9B3F2D9814CDEBD541BA69969AEFE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8758E\"></a> <em class=\"strong\">Syntax:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-606B\"></a><pre><em class=\"codeEmphasisStrong\">on create do</em> &lt;expression&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87590\"></a>This handler is called when an instance of the struct is created. \n            </p> \n            <p><a name=\"P_B1199BA43D324553B590475C76DD0D3D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-606A\"></a><pre><em class=\"codeEmphasisStrong\">on clone do</em> &lt;expression&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87593\"></a>This handler is called when a copy of a struct instance is created. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87595\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87596\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE- DEFINITION AND CREATION:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6069\"></a><pre>\nstruct foo2\n(\nA = 1,\nB = 3,\nfn error = throw \"ZZZ\",\non create do format \"Struct Created: %\\n\" this,\non clone do format \"Struct Cloned: %\\n\" this\n)\n&nbsp;\nf = foo2 ()\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E875A3\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6068\"></a><pre>\n#Struct:foo2(\na:&lt;data&gt;; Public,\nb:&lt;data&gt;; Public,\nerror:&lt;fn&gt;; Public)\nStruct Created: (foo2 a:1 b:3)\n(foo2 a:1 b:3)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E875AC\"></a><p class=\"table-body\"> <em class=\"strong\">CONTINUED EXAMPLE - CLONING:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6067\"></a><pre>\nf2 = copy f\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E875B0\"></a><p class=\"table-body\"> <em class=\"strong\">RESULT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6066\"></a><pre>\nStruct Cloned: (foo2 a:1 b:3)\n(foo2 a:1 b:3)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E875B7\"></a> <span class=\"char_link\"><a href=\"GUID-5FBA4F99-5A57-4B36-9008-F8EC68340AA6.htm\">Structure Definition</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E875B8\"></a> <span class=\"char_link\"><a href=\"GUID-35E5A5EF-BF14-4D11-8ABA-CFD9A0E7249E.htm\">Defining Local Functions in Structures</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E875B9\"></a> <span class=\"char_link\"><a href=\"GUID-D5426B3F-7060-4C02-BA75-CB24A66B2ABD.htm\">Structure Inherited Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E875BA\"></a> <span class=\"char_link\"><a href=\"GUID-4B31E2CC-8862-4C19-AA07-2DDED173757C.htm\">Structure Scope While Initializing</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E875BB\"></a> <span class=\"char_link\"><a href=\"GUID-0D3592DD-2F20-4A41-B19F-544426B8186E.htm\">Private and Public Members in Structure Definitions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";