var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A4807BDC-380B-49DE-B3E2-DCB35E43A10C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Controller\">\n      <meta name=\"indexterm\" content=\"sortKeys()\">\n      <meta name=\"indexterm\" content=\"setTimeRange()\">\n      <meta name=\"indexterm\" content=\"setBeforeORT()\">\n      <meta name=\"indexterm\" content=\"setAfterORT()\">\n      <meta name=\"indexterm\" content=\"selectKeys()\">\n      <meta name=\"indexterm\" content=\"scaleTime()\">\n      <meta name=\"indexterm\" content=\"reverseTime()\">\n      <meta name=\"indexterm\" content=\"reduceKeys()\">\n      <meta name=\"indexterm\" content=\"nested object controller functions\">\n      <meta name=\"indexterm\" content=\"moveKeys()\">\n      <meta name=\"indexterm\" content=\"MAXWrapper - Value\">\n      <meta name=\"indexterm\" content=\"insertTime()\">\n      <meta name=\"indexterm\" content=\"enableORTs()\">\n      <meta name=\"indexterm\" content=\"deselectKeys()\">\n      <meta name=\"indexterm\" content=\"deleteTime()\">\n      <meta name=\"indexterm\" content=\"deleteKeys()\">\n      <meta name=\"indexterm\" content=\"deleteEaseCurve()\">\n      <meta name=\"indexterm\" content=\"addNewKey()\">\n      <meta name=\"indexterm\" content=\"addEaseCurve()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Nested Object Controller Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A4807BDC-380B-49DE-B3E2-DCB35E43A10C\"></a><div class=\"head\">\n            <h1>Nested Object Controller Functions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3743\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3742\"></a>                    Certain time and keyframe functions on controllers can be called on any <em class=\"strong\">3ds Max</em> object or collection of <em class=\"strong\">3ds Max</em> objects. \n            </p> \n            <p><a name=\"P_02CF8138704343E980B9C2EF998A63D0\"></a>If called in this way, they apply recursively to all the nested controllers within\n               that object and on any sub-objects and sub-controllers within those objects. \n            </p> \n            <p><a name=\"P_BD5E5BABA58341CB96BFB28374164E73\"></a>In this way, they work in a manner similar to the object-level tracks in the <em class=\"strong\">3ds Max</em> Track View that allow you to manipulate keys and time for all the sub-objects and\n               sub-controllers within them. \n            </p> \n            <p><a name=\"P_63A477DFF6714F2E9F1A4F8AD4CDC682\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-372D\"></a>The time and controller functions that work in this way are: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DD3\"></a><pre><em class=\"codeEmphasisStrong\">deleteTime</em> <em class=\"codeEmphasisStrong\">reverseTime</em> <em class=\"codeEmphasisStrong\">scaleTime</em> <em class=\"codeEmphasisStrong\">insertTime</em> <em class=\"codeEmphasisStrong\">setTimeRange</em> <em class=\"codeEmphasisStrong\">addNewKey</em> <em class=\"codeEmphasisStrong\">deleteKeys</em> <em class=\"codeEmphasisStrong\">selectKeys</em> <em class=\"codeEmphasisStrong\">deselectKeys</em> <em class=\"codeEmphasisStrong\">moveKeys</em> <em class=\"codeEmphasisStrong\">mapKeys</em> <em class=\"codeEmphasisStrong\">sortKeys</em> <em class=\"codeEmphasisStrong\">reduceKeys</em> <em class=\"codeEmphasisStrong\">addEaseCurve</em> <em class=\"codeEmphasisStrong\">deleteEaseCurve</em> <em class=\"codeEmphasisStrong\">setBeforeORT</em> <em class=\"codeEmphasisStrong\">setAfterORT</em> <em class=\"codeEmphasisStrong\">enableORTs</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-371A\"></a>The above functions can be called on any <em class=\"strong\">3ds Max</em> object collection (such as, a wild-card pathname, object set, or array of objects\n               ) and will recursively apply to all animation within those objects. \n            </p> \n            <p><a name=\"P_ED5BD0E0971341E0A7AA83F87C191302\"></a>For more information, see <span class=\"char_link\"><a href=\"GUID-46A7941F-9A1E-49AF-B607-5516DC6ACCEF.htm\">Time and Key Functions on Object Hierarchies</a></span> and <span class=\"char_link\"><a href=\"GUID-71299FC9-9EE4-45EB-AF7D-146F31EB6AC6.htm\">Controller Time Functions</a></span>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3718\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3717\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3DD2\"></a><pre>\nfor i = 1 to 3 do (\n	b = box()\n	addmodifier b (XForm())\n)\n\ninsertTime $box001.xform 0f 10f\n-- all keys after0fin all controllers in theXFormmodifier are moved by10f\ninsertTime $box001 0f 10f\n-- all keys after0finbox01are moved (transform, creation, modifiers)\nselectKeys $box002.xform.gizmo.rotation.controller 0f 100f\n-- selects keys in0-100f. If controller is Euler, will select x, y and z keys\ndeleteTime $box* 10f 20f\n-- deletetime fromframe10to frame20in all keys in all objects named$box*(works with—any pathname or array of objects)\ninsertTime $box003.children 0f 10f\n-- inserts time in all controllers of all children of$box03\nreduceKeys $box001.modifiers 0.5 1f\n-- applies key reductions to all controllers in all modifiers in$box01(leaves—transform and creation parameters alone)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";