var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A72112A6-BDFB-47A6-88FB-8D49C4CBD049\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"rollout\">\n      <meta name=\"indexterm\" content=\"RolloutFloater - Value\">\n      <meta name=\"indexterm\" content=\"newRolloutFloater()\">\n      <meta name=\"indexterm\" content=\"closeRolloutFloater()\">\n      <meta name=\"indexterm\" content=\"removeRollout()\">\n      <meta name=\"indexterm\" content=\"addRollout()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Rollout Floater Windows</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A72112A6-BDFB-47A6-88FB-8D49C4CBD049\"></a><div class=\"head\">\n            <h1>Rollout Floater Windows </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-685F\"></a>MAXScript lets you create modeless floating dialog windows known as \n            		<em class=\"strong\">Rollout Floaters</em> and populate them with rollouts defined using rollout definitions. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-685E\"></a>The user can resize a rollout floater window vertically by dragging on the lower window\n            edge. \n            	 \n         </p>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-7EB9\"></a> \n            <h2><a name=\"GUID-48BD6D8D-15CB-4512-AB24-893BCD645FAA\"></a>   <em class=\"strong\">There are two functions and a special class in support of this, as follows:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7497\"></a><pre><em class=\"codeEmphasisStrong\">newRolloutFloater </em>&lt;title_string&gt; &lt;width_integer&gt; &lt;height_integer&gt; [&lt;top_integer&gt; &lt;left_integer&gt;] \\\n	 [lockHeight:&lt;boolean&gt;] [lockWidth:&lt;boolean&gt;] [autoLayoutOnResize:&lt;boolean&gt;] scrollBar:&lt;on|off|#on|#off|#asNeeded&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-685A\"></a>Creates and opens a new rollout floater window with the title and width and height\n               given. If you don\'t supply top and left coordinates, the window will open centered\n               in the screen. The width of the \n               		  <em class=\"strong\">3ds Max</em> command panel is 218, in case you want to duplicate its width for precisely accommodating\n               Utilities panel rollouts. This method returns a \n               		  <span class=\"code\"> <em class=\"strong\">RolloutFloater</em> </span> value to which you add rollouts. \n               		\n            </p> \n            <p> The \n               		  <span class=\"code\">lockHeight</span> and \n               		  <span class=\"code\">lockWidth</span> arguments specify whether to lock the height and width of the rollout floater (that\n               is, whether to disable resizing). Available in \n               		  <em class=\"strong\">3ds Max 2019 and higher</em>. The defaults are \n               		  <span class=\"code\">lockHeight:false</span> and \n               		  <span class=\"code\">lockWidth:true</span>. \n               		\n            </p> \n            <p> The \n               		  <span class=\"code\">autoLayoutOnResize</span> argument specifies whether to automatically re-layout the contained rollout when\n               the rollout floater is resized. Available in \n               		  <em class=\"strong\">3ds Max 2019 and higher</em>. The default is true. \n               		\n            </p> \n            <p> The \n               		  <span class=\"code\">scrollBar</span> argument specifies whether to add a scrollbar to the floater to scroll the contained\n               rollout. Available in \n               		  <em class=\"strong\">3ds Max 2019 and higher</em>. The default is \n               		  <span class=\"code\">#asNeeded</span>, where a scrollbar will only be displayed when the rollout floater is smaller than\n               the contained rollout. \n               		\n            </p> \n            <p><a name=\"GUID-941B9CD5-4816-47DC-8D1A-B1806B195525\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7496\"></a><pre><em class=\"codeEmphasisStrong\">closeRolloutFloater</em> &lt;rolloutFloater&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6856\"></a>Closes the rollout floater window. The user can also do this by clicking the close\n               box on the window. Once closed, the window is no longer usable. All the close handlers\n               in the rollout floater window\'s rollouts are called and they are released for use\n               in other rollout floater windows or scripted utilities. \n               		\n            </p> \n            <p><a name=\"GUID-86BE67C2-0492-4156-8876-D93F682C6D52\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-7EB1\"></a> \n            <h2><a name=\"GUID-27D39DCA-1B4F-43D3-BAC8-41F87C723E50\"></a>  The existing functions for adding and removing rollouts to the Utilities panel are\n               extended to work with rollout floater windows:\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7495\"></a><pre><em class=\"codeEmphasisStrong\">addRollout </em>&lt;rollout&gt; [ &lt;rolloutFloater&gt; ] [<em class=\"codeEmphasisStrong\">rolledUp</em>:&lt;boolean&gt; ] [<em class=\"codeEmphasisStrong\">border</em>:&lt;boolean&gt;]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6852\"></a>If the optional second argument is specified, it must be a RolloutFloater value as\n               returned from the \n               		  <span class=\"code\"> <em class=\"strong\">newRolloutFloater()</em> </span> function. The rollout specified by the first argument is appended after any rollouts\n               previously in the window. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6851\"></a>If the optional \n               		  <span class=\"code\"> <em class=\"strong\">rolledUp:</em> </span> keyword argument is specified, the rollout will be initially rolled up (closed) when\n               the argument is True or rolled down (open) when False. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6850\"></a>If the optional \n               		  <span class=\"code\"> <em class=\"strong\">border:</em> </span> keyword argument is specified and set to False in \n               		  <em class=\"strong\">3ds Max 2009 and higher</em>, the rollout will have no border. If the keyword argument is not supplied or set\n               to True, a border will be drawn around the rollout. \n               		\n            </p> \n            <p><a name=\"GUID-4A74BA6B-4A6D-4753-AD03-F8C4282A141C\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7494\"></a><pre><em class=\"codeEmphasisStrong\">removeRollout </em>&lt;rollout&gt; [ &lt;rolloutFloater&gt; ]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-684D\"></a>Removes the rollout from the given rollout floater window. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-684C\"></a>In both functions above, if the optional \n               		  <span class=\"code\">&lt;rolloutFloater&gt;</span> is not supplied the rollout is added to, or removed from, the Utilities panel, as\n               described in \n               		  <span class=\"char_link\"><a href=\"GUID-6E2727F1-BF6E-4C3D-AF3B-121B1B59DACF.htm\">Managing Multiple Rollouts in a Scripted Utility</a></span>. \n               		\n            </p> \n            <p><a name=\"GUID-431894BB-AAAD-4A20-ADFF-44F953B24D35\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-684A\"></a> \n            <h2><a name=\"GUID-9756ADDE-51D6-46C1-9539-A02594369022\"></a> <em class=\"strong\">Rollout floater properties:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7493\"></a><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">title</em> String</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6848\"></a>The Title of the floater. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75E1\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6845\"></a>You cannot change the title of a rollout floater registered as a dialog bar \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"GUID-E475638A-F738-4B7C-905A-289B7513EBB4\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7492\"></a><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">size</em> Point2</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6842\"></a>The current size of the rollout floater window in pixels. The first component of the\n               Point2 is the width, the second the height. This property is read/write. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75E4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If a rollout floater is in an extended viewport, the \n                  		  <span class=\"code\"><em class=\"strong\">.size</em> </span> and \n                  		  <span class=\"code\"><em class=\"strong\">.position</em> </span> properties report the size and position of the viewport. The properties cannot be\n                  set for this case. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-0DE5472C-148E-461D-85BE-FEE2D227FD10\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7491\"></a><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">pos</em> Point2</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-683F\"></a>The current screen position of the rollout floater window in pixels. This property\n               is read/write. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75E0\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-B30DF745-1425-4A78-A0ED-70E1916573C7\"></a>If a rollout floater is in an extended viewport, the size and position properties\n                     report the size and position of the viewport. The properties cannot be set for this\n                     case. \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-683A\"></a>When a rollout floater window is resized, either by the user or by a script changing\n               the \n               		  <span class=\"code\"><em class=\"strong\">size</em></span> property, a \n               		  <span class=\"code\"><em class=\"strong\">resized</em></span> event is generated for the first rollout in the rollout floater window. Likewise,\n               when a rollout floater window is moved, either by the user or by a script changing\n               the \n               		  <span class=\"code\"> <em class=\"strong\">pos</em> </span> property, a \n               		  <span class=\"code\"> <em class=\"strong\">moved</em> </span> event is generated for the first rollout in the rollout floater window. The event\n               handler for the \n               		  <span class=\"code\"><em class=\"strong\">resized</em></span> and \n               		  <span class=\"code\"><em class=\"strong\">moved</em></span> events are described in \n               		  <span class=\"char_link\"><a href=\"GUID-DC435555-362D-4A03-BCF2-21179C5442F2.htm\">Utility and Rollout properties, Methods, and Event Handlers</a></span>. \n               		\n            </p> \n            <p><a name=\"GUID-9A3432FA-E14D-421B-83C3-B6BA47D968E4\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7490\"></a><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">inViewport</em> Boolean, read-only.</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6838\"></a>Returns True if the floater is in extended viewport. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-748F\"></a><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">open</em> Boolean, read-only.</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6835\"></a>Returns True if the floater is open. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">visible</em> Boolean</pre></div> \n            <p><a name=\"GUID-DA44E7F5-5331-4E4A-87B8-BCB61BE5ED09\"></a>Get/Set the visibility of the Rollout Floater. Available in \n               		  <em class=\"strong\">3ds Max 2014 and higher</em>. \n               		\n            </p> \n            <p><a name=\"GUID-46D9FDFC-4E2B-4599-AB3C-23CEA410EA25\"></a>When set to True (default), the Rollout Floater will be displayed. \n               		\n            </p> \n            <p><a name=\"GUID-07FE97DA-1274-4FB3-92EC-CF50ED311818\"></a>When set to False, the Rollout Floater will not be drawn, but it and its rollouts\n               will still be accessible through MAXScript. \n               		\n            </p> \n            <div><a name=\"GUID-97D17896-8E77-4883-959C-54E535D5D94A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This can be used as an alternative to placing the Rollout Floater off-screen, a hack\n                  sometimes used in older versions of \n                  		  <em class=\"strong\">3ds Max</em>. Since \n                  		  <em class=\"strong\">3ds Max 2014</em>, any off-screen dialogs will be automatically moved back into view. \n                  		\n               </div>\n            </div> \n            <p><a name=\"GUID-FA8B0CC2-79A9-4F19-82EB-605BC1DCBBDF\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-748E\"></a><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">dialogBar </em>Boolean, read-only.</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6832\"></a>Returns True if the rollout floater is used as a dialog bar. \n               		\n            </p> \n            <p><a name=\"GUID-CA81961E-5981-4B37-A1FD-B82F2F96B014\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-748D\"></a><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">rollouts </em>Array of rollouts in floater, read-only</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-682F\"></a>Returns an array of all rollouts in the floater. \n               		\n            </p> \n            <p><a name=\"GUID-263A252F-2D67-412B-8B1A-ABEF7BB0AC38\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-74A8\"></a><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">placement</em>Name, enums:{#<em class=\"codeEmphasisStrong\">minimized</em>|#<em class=\"codeEmphasisStrong\">maximized</em>|#<em class=\"codeEmphasisStrong\">normal</em>}</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-68E8\"></a>This property gets/sets whether the dialog is minimized, maximized, or normal. This\n               property will return \'undefined\' if the rollout is not in a dialog, the dialog is\n               a dialogBar, or is in a viewport. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-68E7\"></a>This property is valid for Rolloutfloaters that are not a dialogBar nor in a viewport.\n               \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75E2\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This property is available in \n                  		  <em class=\"strong\">3ds Max 6 and higher</em>. \n                  		\n               </div>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-68E1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-68E0\"></a><p class=\"table-body\"> <em class=\"strong\">NOTES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-68DF\"></a><p class=\"table-body\">A rollout in a subrollout cannot be registered as a dialogbar or a view window. A\n                           rollout or rollout floater cannot be registered as both a dialogbar and a view window.\n                           \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-68DE\"></a><p class=\"table-body\">You can implement a form of rollout state save and restore for your scripted rollouts\n                           by recording the /<span class=\"code\"> <em class=\"strong\">open</em> </span> state of all rollouts and the .<span class=\"code\"> <em class=\"strong\">scrollPos</em> </span> of the entire panel during \n                           						<span class=\"code\"> <em class=\"strong\">close</em> </span> handler processing, and then reset the values in the \n                           						<span class=\"code\"> <em class=\"strong\">open</em> </span> handler. \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">lockHeight</em> Boolean</pre></div> \n            <p> <span class=\"code\"> <em class=\"strong\">True</em> </span> if floater height cannot be changed by dragging its borders. Available in \n               		  <em class=\"strong\">3ds Max 2019 and higher</em>. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">lockWidth</em> Boolean</pre></div> \n            <p> <span class=\"code\"> <em class=\"strong\">True</em> </span> if floater width cannot be changed by dragging its borders. Available in \n               		  <em class=\"strong\">3ds Max 2019 and higher</em>. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">autoLayoutOnResize</em> Boolean</pre></div> \n            <p> <span class=\"code\"> <em class=\"strong\">True</em> </span> if auto layout on resize is enabled for the floater. Available in \n               		  <em class=\"strong\">3ds Max 2019 and higher</em>. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;rolloutFloater&gt;.<em class=\"codeEmphasisStrong\">hwnd</em> IntegerPtr, read-only</pre></div> \n            <p> <img src=\"../images/GUID-21C87158-BBA7-4B63-B8F7-CB9BA17CA2CA-low.gif\"> <span class=\"char_link\"><a href=\"GUID-F90290FA-90A2-4720-B9FE-A4CCE0446252.htm\">NEW</a></span><em class=\"strong\"> in 3ds Max 2020:</em> Contains the window pointer for the floater as an integer pointer, if the floater\n               is open, or \n               		  <span class=\"code\">undefined</span> if the floater is closed. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-682D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-682C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-748C\"></a><pre>\nrollout grin \"Grin Control\"\n(\nslider happy \"Happy\" orient:#vertical across:5\nslider sad \"Sad\" orient:#vertical\nslider oo \"OO\" orient:#vertical\nslider ee \"EE\" orient:#vertical\nslider oh \"OH\" orient:#vertical\n/*\non happy changed val do object.xform1.center = ...\non sad changed val do object.xform2.gizmo.rotation = ...\n...\n*/\n)\ntheNewFloater = newRolloutFloater \"Grinning\" 300 220\naddRollout grin theNewFloater\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";