var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A8663B8E-7E30-474E-B3DB-E21585F125B1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Scene File Properties\">\n      <meta name=\"indexterm\" content=\"MAX Scene File Properties\">\n      <meta name=\"indexterm\" content=\"getPropertyValue() - fileProperties\">\n      <meta name=\"indexterm\" content=\"getPropertyName() - fileProperties\">\n      <meta name=\"indexterm\" content=\"getNumProperties() - fileProperties\">\n      <meta name=\"indexterm\" content=\"getItems() - fileProperties\">\n      <meta name=\"indexterm\" content=\"findProperty() - fileProperties\">\n      <meta name=\"indexterm\" content=\"fileProperties: getPropertyValue()\">\n      <meta name=\"indexterm\" content=\"fileProperties: getPropertyName()\">\n      <meta name=\"indexterm\" content=\"fileProperties: getNumProperties()\">\n      <meta name=\"indexterm\" content=\"fileProperties: getItems()\">\n      <meta name=\"indexterm\" content=\"fileProperties: findProperty()\">\n      <meta name=\"indexterm\" content=\"fileProperties: deleteProperty()\">\n      <meta name=\"indexterm\" content=\"fileProperties: addProperty()\">\n      <meta name=\"indexterm\" content=\"deleteProperty() - fileProperties\">\n      <meta name=\"indexterm\" content=\"addProperty() - fileProperties\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAX Scene File Properties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A8663B8E-7E30-474E-B3DB-E21585F125B1\"></a><div class=\"head\">\n            <h1>MAX Scene File Properties </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23E2\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23E1\"></a>                The <em class=\"strong\">File Properties</em> can be accessed in MAXScript using the methods described in this topic. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23D0\"></a>The File Properties are organized into three sets. These sets correspond to the three\n               pages in the Main Menu &gt; File &gt; File Properties dialog: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A6F\"></a><pre><em class=\"codeEmphasisStrong\">#summary</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23CE\"></a>This set contains the Title, Subject, Author, Keywords, Comments fields from the Summary\n               page. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A6E\"></a><pre><em class=\"codeEmphasisStrong\">#contents</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23CC\"></a>This set contains the Manager, Company, Category and an array of all headers from\n               the Contents page like General, Mesh Totals etc. Note that the Contents page contents\n               are only update when the file is saved. You can perform a <span class=\"code\"> <em class=\"strong\">max hold</em> </span> to perform a scene hold, which causes the file to be saved and the Contents page\n               contents to be updated. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A6D\"></a><pre><em class=\"codeEmphasisStrong\">#custom</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23CA\"></a>This set contains all the fields from the Custom page. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23C8\"></a>The following methods are used to access the above sets. <span class=\"code\"> <em class=\"strong\">&lt;set_name&gt;</em> </span> can be any of the values from above. \n            </p> \n            <p><a name=\"GUID-120EBD99-D78D-4EBB-AED9-7E753370F63A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A6C\"></a><pre><em class=\"codeEmphasisStrong\">fileProperties.getNumProperties</em> &lt;set_name&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23C6\"></a>Returns the number of properties in the given set. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23C5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23C4\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A6B\"></a><pre>\nnumProps=fileProperties.getNumProperties #summary\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-DE2CFDF3-0FF5-4822-A599-38001688A4A6\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A6A\"></a><pre><em class=\"codeEmphasisStrong\">fileProperties.getPropertyName</em> &lt;set_name&gt; &lt;index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23BD\"></a>Returns as a string the property name of the given index. The index is 1-based. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23BC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23BB\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A69\"></a><pre>\nnameProp=fileProperties.getPropertyName #summary 1\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-F6C181E8-E46F-457C-8F9C-164B5CD06F6D\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A68\"></a><pre><em class=\"codeEmphasisStrong\">fileProperties.getPropertyValue</em> &lt;set_name&gt; &lt;index&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23B4\"></a>Returns the property value of given index. The value type can be one of the following\n               types of values currently supported by <em class=\"strong\">3ds Max</em> in the File Properties dialog. The values in bracket are the MAXScript equivalent\n               value type. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23B3\"></a>Property Value Types: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A67\"></a><pre>Text [String]\nDate [String] - contains the date eg:\"03/23/99\"\nNumber [Integer or Float based on actual value]\nYes or No [Boolean]\nHeaders [Array of strings]</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23AD\"></a>Headers are items like General, Mesh Totals, etc. that appear in contents page. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23AC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23AB\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23AA\"></a><p class=\"table-body\">an array of headers from contents page obtained using: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A66\"></a><pre>\nfileproperties.getPropertyValue #contents 1\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-23A6\"></a><p class=\"table-body\">will return </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A65\"></a><pre>\n#(\"General\", \"Mesh Totals\",...)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-F605D446-5E85-43F1-A442-C6B3B7551A56\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A64\"></a><pre><em class=\"codeEmphasisStrong\">fileProperties.getItems</em> &lt;header_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-239F\"></a>Returns an array of strings containing all the items under the given header. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-239E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-239D\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-239C\"></a><p class=\"table-body\">an array of headers from contents page obtained using: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A63\"></a><pre>\nfileProperties.getItems \"Mesh Totals\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2398\"></a><p class=\"table-body\">might return </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A62\"></a><pre>\n#(\"Vertices: 488\", \"Faces: 968\")\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-138D1BB7-9DB8-4E3F-AFDD-F63FFDEE5750\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A61\"></a><pre><em class=\"codeEmphasisStrong\">fileProperties.findProperty</em> &lt;set_name&gt; &lt;prop_name_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2391\"></a>Given the set name and property name string, will return the index of the property\n               if found, 0 if not found. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2390\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-238F\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A60\"></a><pre>\nfileProperties.findProperty #custom \"BoolVal\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-C2EB98D0-A946-40D9-8AD0-0E26C1563193\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A5F\"></a><pre><em class=\"codeEmphasisStrong\">fileProperties.addProperty</em> &lt;set_name&gt; &lt;prop_name_string&gt; &lt;prop_value&gt; [#date] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2388\"></a>Adds a new property with the property name and property value to the specified set.\n               \n            </p> \n            <p><a name=\"GUID-ACD8D182-5751-4B55-9ABB-1EB5AA39F187\"></a>The property values can be any of the types previously described except an Array as\n               you cannot add anything to contents page. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2387\"></a>If string containing a date is passed then the optional <span class=\"code\"> <em class=\"strong\">#date</em> </span> argument has to be passed for it to be added as a date value. \n            </p> \n            <p><a name=\"GUID-781EA3E2-1D51-4BF6-9F34-F99700288725\"></a>Adding to an existing property name will replace the existing value and act as a setter\n               function - this is why <em class=\"strong\">there is no</em> <span class=\"code\"> <em class=\"strong\">fileProperties.setProperty()</em> </span> method. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2386\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2385\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A5E\"></a><pre>\nfileProperties.addProperty #custom \"DateVal\" \"03/23/99\" #date\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2381\"></a><p class=\"table-body\">will add a date property named <span class=\"code\"> <em class=\"strong\">DateVal</em> </span> to the custom page. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-3ACA1260-9B73-4688-B189-A1DB5858CD36\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A5D\"></a><pre><em class=\"codeEmphasisStrong\">fileProperties.deleteProperty</em> &lt;set_name&gt; &lt;prop_name_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-237D\"></a>Delete the property indicated by <span class=\"code\">&lt;prop_name_string&gt;</span> in the specified set. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-237C\"></a>Following is an example of printing all the File Properties in an hierarchical fashion\n               for the current scene. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-237B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-237A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6A5C\"></a><pre>\n-- Add some properties\nfileProperties.addProperty #summary \"Title\" \"H2G2\"\nfileProperties.addProperty #summary \"Subject\" \"Earth\" \nfileProperties.addProperty #summary \"Author\" \"Ford Prefect\"\n\nfileProperties.addProperty #contents \"Manager\" \"Zarniwoop\" \nfileProperties.addProperty #contents \"Company\" \"Megadodo Publishing\" \nfileProperties.addProperty #contents \"Category\" \"Mostly Harmless\" \n\nfileProperties.addProperty #custom \"IntVal\" 42\nfileProperties.addProperty #custom \"FloatVal\" 1.234\nfileProperties.addProperty #custom \"BoolVal\" true\nfileProperties.addProperty #custom \"DateVal\" \"05/11/2001\" #date\n--\n-- Perform a scene hold to update the Contents set.\nmax hold\n--\n-- Get all properties\npages = #( #summary, #contents, #custom)\nfor pg in pages do\n(\nformat \"--- % ---\\n\" (pg as string)\nfor i=1 to (fileProperties.getNumProperties pg) do\n(\nlocal pname = (fileProperties.getPropertyName pg i)\nlocal pval = (fileProperties.getPropertyValue pg i)\nformat \"\\t% : \" pname\nif (pname ==\"Headers\") then\n(\nformat \"\\n\"\nfor hdr in pval do\n(\nformat \"\\t\\t%\\n\" hdr\nlocal docs = fileProperties.getItems hdr\nif docs != undefined then\nfor d in docs do format \"\\t\\t\\t%\\n\"d\n)\n)\nelse format \" %\\n\" pval\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2353\"></a> <span class=\"char_link\"><a href=\"GUID-624D3D05-B15D-4A97-9F15-DA35CDB0DDD2.htm\">3ds Max File Loading and Saving</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2352\"></a> <span class=\"char_link\"><a href=\"GUID-BA196B48-8ECA-4E0C-AE2E-F7EFAAF39844.htm\"> External File Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2351\"></a> <span class=\"char_link\"><a href=\"GUID-0EE531B2-6FF8-4D0B-ACA1-5400E0B9D604.htm\">File Name Parsing</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2350\"></a> <span class=\"char_link\"><a href=\"GUID-D4B43A33-8342-4BC9-80AB-91460861D37C.htm\">Standard Open and Save File Dialogs</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-234F\"></a> <span class=\"char_link\"><a href=\"GUID-92E4150E-0AD4-430C-A852-783A45276D23.htm\"> Exiting and Resetting 3ds Max</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-234E\"></a> <span class=\"char_link\"><a href=\"GUID-CF408D64-D4E2-4C39-90DB-62E525D7B45A.htm\">Accessing INI File Keys</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";