var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-A968E741-4D24-4286-B3D0-1FDDE49B6ABE\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Fragmentation Sample Script\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Fragmentation Sample Script</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A968E741-4D24-4286-B3D0-1FDDE49B6ABE\"></a><div class=\"head\">\n            <h1>Fragmentation Sample Script </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847A5\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847A6\"></a>The following example shows a sample Fragmentation script using the Parray particle\n            system and the Mesher Compound object to generate object fragments on the fly. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847A7\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847A8\"></a>Should be used in a <span class=\"char_link\"><a href=\"GUID-BF55A04D-AED5-4948-A837-8D3E2C7E82DE.htm\">Birth_Script</a></span> Action to generate fragment particles. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847A9\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-5C788AFF-5AC1-4976-9073-711870FD3938-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847AA\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847AB\"></a>In the Init handler, the script prepares the fragment source object, a PArray, a Mesher\n            Compound and two Editable meshes to hold the fragments. It then assigns the PArray\n            to the Mesher. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847AC\"></a>In the Proceed handler, the script checks whether the particle system time is at frame\n            0 and no particles exist. In this case it gets the mesh of the PArray from the Mesher,\n            splits the mesh into elements, gives birth to new particles and assigns them the mesh\n            and position of the fragment. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847AD\"></a>After the script has created the particles with the fragments, they can be controlled\n            by any <em class=\"strong\">Particle Flow</em> operators as usual. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E847AF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E847B0\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E12\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\npCont.useTime = true--enable the Time channel\npCont.useAge = true--enable the Age channel\npCont.usePosition = true--enable the Position channel\npCont.useSpeed = true--enable the Speed channel\npCont.useShape = true--enable the Shape channel\n)\n \n--The Init handler is called on initialization.\n--This is where preparation works can be performed.\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non Init pCont do\n(\n-- Create a geometry primitive to break into fragments.\nglobal bb = $Teapot_69e13b6c--a unique name\n-- Create a PArray particle system to create the fragments.\nglobal a = $PArray_36ce15a4--a unique name\n-- Create a Mesher Compound object to turn PArray into mesh.\nglobal mshr = $Mesher_23951616--a unique name\n-- Create a mesh to hold the total mesh.\nglobal totalMesh = $EMesh_5990501d--a unique name\n-- Create a mesh to hold separate fragments.\nglobal fragmentMesh = $EMesh_1589735c-- a unique name\n--Disable screen redraw to speed up execution \nwithredrawoff(\n-- If the source object does not exist in the scene...\nif (bb == undefined) then (\n-- create a Teapot for fragmentation, give it a unique name\nbb = Teapot radius:20 smooth:on segs:6 body:on handle:on spout:on lid:on mapCoords:off\nbb.name =\"Teapot_69e13b6c\"\nhide bb-- hide the teapot\n)\n-- If the PArray object does not exist in the scene...\nif (a == undefined) then\n(\n-- Create and setup a PArray\na = PArray()\na.name =\"PArray_36ce15a4\"\na.speed = 0\na.emitter = b\nba.particleType = 2\na.viewtype = 2\nhide a\n)\n-- If the Mesher object does not exist in the scene...\nif (mshr == undefined) then (\n-- Create a Mesher Compound Object\n-- The Mesher gets mesh data out of the PArray\nmshr = mesher()\nmshr.name =\"Mesher_23951616\"\nmshr.pick = a-- Assign the Parray to the Mesher\nselect mshr\nmodPanel.addModToSelection (Edit_Mesh ()) ui:on\nclearSelection()\nhide mshr\n)\n \n-- If the total Emesh object does not exist in the scene...\nif(totalMesh == undefined)then(\n-- Create a new editable meshes with unique name\ntotalMesh = editable_mesh()\ntotalMesh.name =\"EMesh_5990501d\"\nhide totalMesh\n)\n-- If the fragments Emesh object does not exist in the scene...\nif(fragmentMesh == undefined)then(\n-- to create editable meshes our of Mesher\nfragmentMesh = editable_mesh()\nfragmentMesh.name =\"EMesh_1589735c\"\nhide fragmentMesh\n)\n)\n)\n--The Proceed handler contains the particle creating script\n \n--The parameter pCont passed to the handler\n \n--contains the Particle Container the script is applied to:\n \non Proceed pCont do(\n-- Get the time range\nt1 = pCont.getTimeStart() as float\nt2 = pCont.getTimeEnd() as float\n-- Only if the current time is at moment 0...\nif((t1 &lt;= 0) and (t2 &gt;= 0))then(\n-- Initialize a counter\ni = 0\n-- If there are still no particles in the system\nif(pCont.NumParticles() &lt;= 0)then\n(\nprint(\"should be making fragments\")\n-- You can modify the fragmentation parameters here:\na.Fragment_Thickness = 1\na.fragmentmethod = 1\na.fragChunkMinimum = 202\n-- Get the complete mesh from the mesher\ntotalMesh.mesh = mshr.mesh\n-- Create a bitarray with all faces set\nprint(\"assigning particles\")\n-- Repeat while there are still faces in the mesh\nwhile totalMesh.numfaces != 0 do\n(\n-- Get the mesh element the first face belongs to\nel = meshop.getelementsusingface totalMesh #{1}\n-- Detach the faces of the element\ntMesh = meshop.detachFaces totalMesh el delete:true asMesh:true\n-- Set the mesh of the fragment Emesh to the element\nfragmentMesh.mesh = tMesh\n-- Update the fragment Emesh\nupdate fragmentMesh\n-- Get the center of the fragment mesh\nmeshCenter = fragmentMesh.center\n-- The original particle position is the center of the fragment\nparticlePos = fragmentMesh.center\n-- Adjust vertex location to center around the chunk pivot\nfor j in 1 to fragmentMesh.verts.count do\n(\ncurVert = getVert fragmentMesh.mesh j\ncurVert = curVert - meshCenter\nsetVert fragmentMesh.mesh j curVert\n)\n-- Move the pivot of the fragment to the original center\n-- of the fragment\nfragmentMesh.pivot = meshCenter\n-- Give birth to a new particle\npCont.AddParticle()\n-- Increase the counter\ni += 1\n-- Set the current particle index to the counter\npCont.particleIndex = i\n-- Set particle time and age to 0 (newborn particle!)\npCont.particleTime = 0\npCont.particleAge = 0\n-- Set the particle’s position to the original fragment position\npCont.particlePosition = particlePos\n-- Reset the speed to 0\npCont.particleSpeed = [0,0,0]\n-- Set the shape of the particle to the mesh of the fragment\npCont.particleShape = fragmentMesh.mesh\n)\nprint(\"assigned particles \"+ (pCont.NumParticles() as string))\n)\n)\n)\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n \n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8484F\"></a> <span class=\"char_link\"><a href=\"GUID-10E56109-B676-409D-ADB8-E2EF90DEEDF6.htm\">PArray : GeometryClass</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84850\"></a> <span class=\"char_link\"><a href=\"GUID-10977590-413F-4902-828D-10868459DA47.htm\">Mesher : GeometryClass</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84851\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84852\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";