var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-AEE0D822-85A0-4F90-8B3C-C6336D8694B4\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MAXtoA\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <meta name=\"keywords\" content=\" Arnold &#xA;&#x9;&#x9;  \">\n      <meta name=\"keyword\" content=\" Arnold &#xA;&#x9;&#x9;  \">\n      <title>MAXtoA Scripted Plug-ins</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-AEE0D822-85A0-4F90-8B3C-C6336D8694B4\"></a><div class=\"head\">\n            <h1>MAXtoA Scripted Plug-ins</h1>\n         </div>\n         <p> \n            		Available in <em class=\"strong\">3ds Max 2018 and higher</em>: MAXScript provides a simple way to create a \"wrapper\" plug-in with a custom UI for\n            Arnold nodes. This approach is for plug-ins that are not shaders - shader plug-ins\n            use a different approach. \n            	 \n         </p>\n         <p>A MAXtoA plug-in uses specially-named parameters that the MAXtoA translator understands.\n            MAXtoA ignores other parameters and the internals of the plug-in, whether it contains\n            logic or wraps another existing 3ds Max class. 3ds Max sees the wrapped class and\n            plug-in logic, which will show up in the UI (viewport, modifier stack, etc depending\n            on plug-in type), and Arnold (via MAXtoA) reacts only to the special parameters, using\n            them to instantiate some particular Arnold node and set parameters on it accordingly.\n            \n            	 \n         </p>\n         <p>The following plug-in types can be extended: \n            	 \n         </p>\n         <p> <a name=\"UL_BD0769C147D7408F974C79B1F63F9F73\"></a><ul>\n               <li>Geometry - Any scripted geometry plugin can be turned into any Arnold shape node.\n                  \n                  		\n               </li>\n               <li>Cameras - A scripted camera can be turned into any Arnold camera node. \n                  		\n               </li>\n               <li>Modifiers on Lights - A scripted modifier applied to an Arnold Light can be turned\n                  into any Arnold light filter node. \n                  		\n               </li>\n            </ul> \n         </p>\n         <p> </p>\n         <div class=\"section\"><a name=\"SECTION_E9D2309AD2BD404F9582E115DF802EBD\"></a> \n            <h2><a name=\"GUID-2E4D3DDC-4BEA-43B7-AC13-AF7A0F607019\"></a>Parameter Layout and Naming\n            </h2> \n            <p>MAXtoA looks for exposed parameters that following a specific naming convention, and\n               acts on those parameters accordingly. The parameter names that MAXtoA recognizes are:\n               \n               		\n            </p> \n            <p> <a name=\"UL_83407BCAA4E44E5F90C63ECB3455B9E9\"></a><ul>\n                  <li><em class=\"strong\">arnold_node</em>: This parameter must be of type \n                     			 <em class=\"strong\">#string</em> and contains the name of the Arnold node to be instantiated for this particular script.\n                     \n                     		  \n                  </li>\n                  <li><em class=\"strong\">arnold_node_<em class=\"mild\">xxx</em></em>: This is the way to set parameter named \n                     			 <em class=\"mild\">xxx</em> on the Arnold node. That is, anything following the prefix \"arnold_node_\" is taken\n                     to be the parameter name. The parameter type in the scripted plug-in must match what\n                     the Arnold node expects. \n                     		  \n                  </li>\n                  <li> <em class=\"strong\">arnold_link_<em class=\"mild\">xxx</em></em>: This is the way to set parameter \n                     			 <em class=\"mild\">xxx</em> as a link to a shader on the Arnold node. Anything following the prefix \"arnold_link_\"\n                     is taken to be the parameter name on the Arnold node. If the value of the parameter\n                     (which must be of type \n                     			 <em class=\"strong\">#texmap</em>) is non-empty, the output of that texmap (or rather the Arnold shader implementing\n                     that texmap) will be connected to the Arnold node\'s input, and the value will come\n                     from it, replacing the value given by any \n                     			 <em class=\"strong\">arnold_node_<em class=\"mild\">xxx</em></em> parameter, if present. \n                     		  \n                  </li>\n                  <li><em class=\"strong\">arnold_decl_<em class=\"mild\">xxx</em></em>: This declares user-defined parameters before they are used. Anything following the\n                     \"arnold_decl_\" prefix is taken to be the parameter name. The parameter itself must\n                     be of type \n                     			 <em class=\"strong\">#string</em> and contain an Arnold parameter declaration string, for example “constant FLOAT”\n                     for a float value. \n                     		  \n                  </li>\n               </ul> \n            </p> \n            <p>Parameters are processed in the order they appear in the script, from top to bottom.\n               Declarations must precede usage. \n               		\n            </p> \n            <p><em class=\"strong\">Enum Parameters</em> \n            </p> \n            <p>Arnold parameters of type enum are normally represented by and integer value starting\n               at zero. However, MAXScript dropdown controls are one-based. Therefore, MAXtoA translates\n               enum type parameters to one-based arrays to support dropdowns in plug-in UIs. This\n               snippet illustrates how enums are defined and wired to a UI control. \n               		\n            </p> <a name=\"TABLE_70D154A41ED94309B52BF8C1ABE235C7\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-heading\">\n                     <th class=\"table-heading\">Enum Snippet \n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>parameters main rollout:params\n(\n   . . .\n   arnold_node_mode type:#integer default:2 ui:mode\n   . . .\n)\n  \nrollout params \" Parameters\"\n(\n   . . .\n   dropdownlist mode \"Mode\" items:#(\"Blend\", \"Mix\", \"Replace\", \"Add\", \"Sub\")\n   . . .\n)</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p> The parameter on the scripted node (the parameter named \n               		  <em class=\"strong\">arnold_node_mode</em>) will have values 1, 2, 3, 4 or 5 based on what is selected by the dropdown, however,\n               the value actually sent to Arnold will be 0, 1, 2, 3, or 4. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_EA65133FD6C64705879E66E9CF914B56\"></a> \n            <h2><a name=\"GUID-996EA34C-CF2B-4141-910A-76D35287ACD4\"></a>Example: A Spherical Camera Plug-in\n            </h2> \n            <p>This example creates a new camera type, derived from FreeCamera, named \"Spherical\n               Cam\" in the Arnold category, which simply turns on the Arnold spherical_camera node.\n               This script sets no other parameters. \n               		\n            </p> <a name=\"TABLE_C51A3ABA228042CD9B185FC3819BB823\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-heading\">\n                     <th class=\"table-heading\">Example \n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>plugin Camera arnold_spherical_camera\nextends:FreeCamera\nname:\"Spherical Cam\"\nclassID:#(135251,542126)\ncategory:\"Arnold\"\nreplaceUI:true\n(\n	parameters main rollout:params\n	(\n		arnold_node type:#string default:\"spherical_camera\"\n	)\n  \n	rollout params \"Example Parameters\"\n	(\n		\n	)\n)</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p> </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_2093ADE607EF472C856889BE006CB133\"></a> \n            <h2><a name=\"GUID-1ADC3BF6-26A4-40C5-9278-86B385F58353\"></a>Example: Sphere Geometry Plug-in\n            </h2> \n            <p>This example creates a new geometry type in the Arnold category called \"Sphere\". It\n               extends the built-in 3ds Max sphere, so it shows up in the viewport as such. But Arnold\n               will actually be given the mathematically exact “sphere” shape node when rendering.\n               \n               		\n            </p> \n            <p>Most of the code in this example enables geometry creation with the mouse and to keeping\n               that in sync with the parameter defining the Arnold object. A much simpler piece of\n               code could have been written had we completely ignored the wrapped object; we could\n               have set the UI in the rollout to apply directly to the Arnold style parameters, which\n               means no \n               		  <span class=\"code\">updateArnold()</span> function would have been needed, and it could have been only a few lines. \n               		\n            </p> <a name=\"TABLE_14AE42E8E3FF4619BAE434A45C054235\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-heading\">\n                     <th class=\"table-heading\">Example \n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>plugin Geometry Arnold_Sphere\nname:\"Sphere\"\nclassID:#(0xf00df103, 0xc55744a1)\ncategory:\"Arnold\"\nextends:Sphere\nreplaceUI:true\n(\n    local lastSize, meshObj\n    parameters pblock rollout:params\n    (\n        arnold_node type:#string default:\"sphere\"\n        arnold_node_radius type:#float default:1.0\n        arnold_node_center type:#point3 default:[0.0,0.0,0.0]\n      \n        radius type:#float animatable:true ui:radius default:1.0\n    )\n\n    fn fmax val1 val2 = if val1 &gt; val2 then val1 else val2\n\n    fn updateArnold =\n    (\n          -- Modify the Arnold Sphere\n          arnold_node_radius = delegate.radius\n    )\n        \n    tool create\n    (\n        on mousePoint click do\n        case click of\n        (\n            1: nodeTM.translation = gridPoint\n            2: #stop\n        )\n        on mouseMove click do\n        (\n            if click == 2 then (				\n                radius = delegate.radius = fmax (abs gridDist.x) (abs gridDist.y)\n                updateArnold()\n            )\n        )\n    )  \n  \n    rollout params \"Sphere Parameters\"\n    (\n        Spinner radius \"Radius:\" range:[0, 1e9, 1]\n\n        on radius changed val do (\n            delegate.radius = val\n            updateArnold()\n        )\n    )\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p>The key part of this code is the Arnold-specific parameter declarations: \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>arnold_node type:#string default:\"sphere\"\narnold_node_radius type:#float default:1.0\narnold_node_center type:#point3 default:[0.0,0.0,0.0]</pre></div> \n            <p> </p> \n            <p>These parameters tell Arnold to build a node named ‘sphere’ and assign its ‘radius’\n               parameter of type float and the ‘center’ parameter of type point with the value from\n               these variables. \n               		\n            </p> \n            <p>Had we needed custom declared user variables (which are needed, for example, in the\n               volume node), it would have looked like this: \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>arnold_node type:#string default:\"volume\"\narnold_node_min type:#point3 default:[-0.5,-0.5,0] \narnold_node_max type:#point3 default:[0.5,0.5,1] \narnold_node_dso type:#string default:\"volume_openvdb\"\n		\narnold_decl_filename type:#string default:\"constant STRING\"\narnold_node_filename type:#filename default:\"smoke.vdb\"\n		\narnold_decl_bounds_slack type:#string default:\"constant FLOAT\"\narnold_node_bounds_slack type:#float default:0.0</pre></div> \n            <p>This would instantiate a node called volume as before, and set its min, max and dso\n               parameters. But the rest of the parameters (due to the plug-in nature of volumes)\n               are user defined, so we need to define a string parameter called \"filename\", a float\n               parameter called \"bounds_slack\" and so on and so on. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_69CBF4AA55534DD8949F94907D8EFDD8\"></a> \n            <h2><a name=\"GUID-765337D4-27A9-4E36-A460-CAE8EC78424F\"></a>Example: Gobo Filter Plug-in\n            </h2> \n            <p>This example is a stripped down version of the Arnold Gobo filter modifier plugin\n               (located in \n               		  <span class=\"filePath\">&lt;3dsmax&gt;\\Plugins\\maxscript\\arnoldlight_gobofilter.ms</span>). It show case how you can add UI controls to support both a color picker and a Texmap\n               lookup. The Arnold target parameter here is gobo.slidemap. \n               		\n            </p> <a name=\"TABLE_3A86536826E44465A103543CCE7CD76D\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col>\n                  </colgroup>\n                  <tr class=\"not-ruled-heading\">\n                     <th class=\"table-heading\">Example \n                        				  \n                     </th>\n                  </tr>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>plugin modifier Arnold_Light_Gobo\nname:~ARNOLD_LIGHT_FILTER_GOBO_NAME~\ncategory:\"Arnold\"\n\nclassID:#(0xf00df10d,0x4001a10d)\n\nextends:ArnoldLightFilterModifier replaceUI:true version:1\n(\n  parameters main rollout:params\n  (\n    arnold_node type:#string default:\"gobo\"  \n	arnold_node_slidemap type:#color ui:slidemapcolor default:[255,255,255]\n	arnold_link_slidemap type:#texturemap ui:slidemap\n  )\n  rollout params ~ARNOLD_LIGHT_FILTER_GOBO_ROLLOUT_NAME~\n  (\n	  colorpicker slidemapcolor \"Color\" color:[255,255,255] modal:false\n	  mapButton slidemap \"Map\"\n  )\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";