var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-B28D7100-1F5F-4A0F-BFA3-17ABADD13580\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Definitions for MAXScript internal organization\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Definitions for MAXScript internal organization</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B28D7100-1F5F-4A0F-BFA3-17ABADD13580\"></a><div class=\"head\">\n            <h1>Definitions for MAXScript internal organization </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E8749E\"></a> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6080\"></a><pre><em class=\"codeEmphasisStrong\">MAXScriptFunction</em> <em class=\"codeEmphasisStrong\">Const Generic</em> <em class=\"codeEmphasisStrong\">Const MappedGeneric</em> <em class=\"codeEmphasisStrong\">Const NodeGeneric</em> <em class=\"codeEmphasisStrong\">Const Primitives</em> <em class=\"codeEmphasisStrong\">Const StructDef</em> <em class=\"codeEmphasisStrong\">Const Class</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874A8\"></a> When you use something like \'fn test val = ...\", a <span class=\"code\"> <em class=\"strong\">MAXScriptFunction</em> </span> value is created and stored in variable <em class=\"strong\">test</em>. If variable <em class=\"strong\">test</em> was passed into another method, for example as a filter function, that method would\n               test the class of the value to make sure it\'s a MAXScriptFunction and then call it\n               using apply(). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E874A9\"></a>The <span class=\"code\"> <em class=\"strong\">\'Const\'</em> </span> preceding the following simply says that it is a value that is created during MAXScript\n               initialization. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1932\"></a>A <span class=\"code\"> <em class=\"strong\">Generic</em> </span> is one or more methods with the same name, but defined for different classes. Which\n               method is called depends on the class of the first argument to the method. For example,\n               \'random\' is declared as a Generic, and there are methods implementing \'random\' in\n               several classes - Integer, Float, Point3, Color, Quat, etc. When MAXScript sees \'random\n               v1 v2\' in a script, it looks at the class of v1, and then calls the \'random\' method\n               for that class. So if v1 were a float, MAXScript would call the Float::random() method.\n               \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1931\"></a>A <span class=\"code\"> <em class=\"strong\">MappedGeneric</em> </span> is the same as a Generic, but the first argument can be a collection. If it is a\n               collection, the the method is called individually on each member of the collection.\n               For example, \'deleteTime $box* 10f 10f\' deletes 10f at frame 10 in all keys in all\n               objects named $box*. deleteTime can also be used on controllers, that\'s why it is\n               a Generic \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1930\"></a>A <span class=\"code\"> <em class=\"strong\">NodeGeneric</em> </span> is the same as a MappedGeneric, but its first argument has to be a node or a collection\n               of nodes. But given the definition of Generic, that doesn\'t make much sense. If the\n               first argument is a collection, and the method is applied to each member of the collection.\n               \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-192F\"></a> <span class=\"code\"> <em class=\"strong\">Primitives</em> </span> are methods that aren\'t class specific. The method is responsible for checking the\n               types of its arguments (if any) and throwing an error if one isn\'t correct. There\n               is only one definition of the Primitive. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-192E\"></a>A <span class=\"code\"> <em class=\"strong\">StructDef</em> </span> is a structure value. If the structure value is created by a script, its class is\n               StructDef. If MAXScript creates the structure during initialization, its class is\n               Const StructDef. So, for example, my meshop methods are defined to exist in a structure\n               called meshop. Since this structure is created during initialization, the class of\n               meshop is Const StructDef. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-192D\"></a> <span class=\"code\"> <em class=\"strong\">Const Class</em> </span> is just a class that is defined in MAXScript itself. So, for example, BitArray is\n               a Const Class. MAXScript also scans the classes registered with <em class=\"strong\">3ds Max</em> - these classes will be created in MAXScript as Const MAXClass. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";