var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-B4552BA1-8A8E-4223-A479-7DA55A8ABE37\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MakeNURBSTorusSurface()\">\n      <meta name=\"indexterm\" content=\"MakeNURBSSphereSurface()\">\n      <meta name=\"indexterm\" content=\"MakeNURBSLatheSurface()\">\n      <meta name=\"indexterm\" content=\"MakeNURBSCylinderSurface()\">\n      <meta name=\"indexterm\" content=\"MakeNURBSConeSurface()\">\n      <meta name=\"indexterm\" content=\"creating NURBSCVSurface values\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Creating NURBSCVSurface Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B4552BA1-8A8E-4223-A479-7DA55A8ABE37\"></a><div class=\"head\">\n            <h1>Creating NURBSCVSurface Values </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-486E\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-486D\"></a>      The following functions provide shorthand ways to construct NURBSCVSurface values\n               that you can then add to a NURBSSet for creation in the scene. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22B7\"></a><pre><em class=\"codeEmphasisStrong\">MakeNURBSLatheSurface</em> &lt;curve&gt; &lt;origin&gt; &lt;north&gt; &lt;start&gt; &lt;end&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4865\"></a>This function generates a NURBS surface of revolution given an input curve, origin,\n               up axis, and start and end angles. The output of this function is a NURBS Surface.\n               Note that this is a CV surface that matches the definition, not a relational surface.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22B6\"></a><pre><em class=\"codeEmphasisStrong\">curve</em> &lt;NURBSCurve&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4863\"></a>This is the NURBS curve that is revolved. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22B5\"></a><pre><em class=\"codeEmphasisStrong\">origin</em> &lt;point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4861\"></a>Specifies the origin of the revolution. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22B4\"></a><pre><em class=\"codeEmphasisStrong\">north</em> &lt;point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-485F\"></a>This is the axis that specified the up direction. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22B3\"></a><pre><em class=\"codeEmphasisStrong\">start</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-485D\"></a>This is the start angle of the revolution in radians. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22B2\"></a><pre><em class=\"codeEmphasisStrong\">end</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-485B\"></a>This is the end angle of the revolution in radians. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22B1\"></a><pre><em class=\"codeEmphasisStrong\">MakeNURBSSphereSurface</em> &lt;radius&gt; &lt;center&gt; &lt;north_axis&gt; &lt;ref_axis&gt; &lt;startU&gt; &lt;endU&gt; &lt;startV&gt; &lt;endV&gt; [<em class=\"codeEmphasisStrong\">open</em>:&lt;boolean&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4858\"></a>This function generates a NURBS sphere. \n            </p> \n            <p>The output of this function is a NURBS Surface. </p> \n            <p><em class=\"strong\">Note</em> that this is a CV surface that matches the definition, not a relational surface.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22B0\"></a><pre><em class=\"codeEmphasisStrong\">radius</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4856\"></a>The radius of the sphere. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22AF\"></a><pre><em class=\"codeEmphasisStrong\">center</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4854\"></a>The center point of origin of the sphere. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22AE\"></a><pre><em class=\"codeEmphasisStrong\">north_axis</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4852\"></a>This specifies the up axis. Use (Point3 0 0 1) for the Z axis for example. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22AD\"></a><pre><em class=\"codeEmphasisStrong\">ref_Axis</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4850\"></a>This is the direction of the seam. The sphere primitive uses (Point3 0 -1 0) as this\n               value. \n            </p> \n            <p>The <span class=\"code\"> <em class=\"strong\">northAxis</em> </span> and <span class=\"code\"> <em class=\"strong\">refAxis</em> </span> must be perpendicular to one another. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22AC\"></a><pre><em class=\"codeEmphasisStrong\">startU</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-484E\"></a>The start angle for the sphere in the U direction, specified in radians. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22AB\"></a><pre><em class=\"codeEmphasisStrong\">endU</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-484C\"></a>The end angle for the sphere in the U direction, specified in radians. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22AA\"></a><pre><em class=\"codeEmphasisStrong\">startV</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-484A\"></a>The start angle for the sphere in the V direction, specified in radians. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22A9\"></a><pre><em class=\"codeEmphasisStrong\">endV</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4848\"></a>The end angle for the sphere in the V direction, specified in radians. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22A8\"></a><pre><em class=\"codeEmphasisStrong\">open</em>: &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4846\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, the surface is closed; otherwise the surface is not closed. Defaults to <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22A7\"></a><pre><em class=\"codeEmphasisStrong\">MakeNURBSCylinderSurface</em> &lt;radius&gt; &lt;height&gt; &lt;origin&gt; &lt;sym_axis&gt; &lt;ref_axis&gt; &lt;start&gt; &lt;end&gt; [<em class=\"codeEmphasisStrong\">open</em>:&lt;boolean&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4843\"></a>This function generates a NURBS cylinder. The output of this function is a NURBS Surface.\n               \n            </p> \n            <p><em class=\"strong\">Note</em> that this is a CV surface that matches the definition, not a relational surface.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22A6\"></a><pre><em class=\"codeEmphasisStrong\">radius</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4841\"></a>The radius of the cylinder. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22A5\"></a><pre><em class=\"codeEmphasisStrong\">height</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-483F\"></a>The height of the cylinder. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22A4\"></a><pre><em class=\"codeEmphasisStrong\">origin</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-483D\"></a>The origin of the cylinder. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22A3\"></a><pre><em class=\"codeEmphasisStrong\">sym_Axis</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-483B\"></a>The axis of symmetry. The standard cylinder primitive specifies (Point3 0 0 1). \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22A2\"></a><pre><em class=\"codeEmphasisStrong\">ref_Axis</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4839\"></a>This is the direction of the seam. The standard cylinder primitive specifies (Point3\n               0 1 0). \n            </p> \n            <p>The <span class=\"code\"> <em class=\"strong\">symAxis</em> </span> and <span class=\"code\"> <em class=\"strong\">refAxis</em> </span> must be perpendicular to one another. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22A1\"></a><pre><em class=\"codeEmphasisStrong\">start</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4837\"></a>The start angle in radians. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-22A0\"></a><pre><em class=\"codeEmphasisStrong\">end</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4835\"></a>The end angle in radians. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-229F\"></a><pre><em class=\"codeEmphasisStrong\">open</em>: &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4833\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, the surface is closed; otherwise the surface is not closed. Defaults to <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-229E\"></a><pre><em class=\"codeEmphasisStrong\">MakeNURBSConeSurface</em> &lt;radius1&gt; &lt;radius2&gt; &lt;height&gt; &lt;origin&gt; &lt;sym_axis&gt; &lt;ref_axis&gt; &lt;start&gt; &lt;end&gt; [<em class=\"codeEmphasisStrong\">open</em>:&lt;boolean&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4830\"></a>This function generates a NURBS cone surface. The output of this function is a NURBS\n               Surface. <em class=\"strong\">Note</em> that this is a CV surface that matches the definition, not a relational surface.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-229D\"></a><pre><em class=\"codeEmphasisStrong\">radius1</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-482E\"></a>One of the radii of the cone. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-229C\"></a><pre><em class=\"codeEmphasisStrong\">radius2</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-482C\"></a>The other radius of the cone. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-229B\"></a><pre><em class=\"codeEmphasisStrong\">height</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-482A\"></a>The height of the cone. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-229A\"></a><pre><em class=\"codeEmphasisStrong\">origin</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4828\"></a>The origin of the cone. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2299\"></a><pre><em class=\"codeEmphasisStrong\">sym_Axis</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4826\"></a>The axis of symmetry. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2298\"></a><pre><em class=\"codeEmphasisStrong\">ref_Axis</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4824\"></a>This is the direction of the seam. \n            </p> \n            <p>The <span class=\"code\"> <em class=\"strong\">symAxis</em> </span> and <span class=\"code\"> <em class=\"strong\">refAxis</em> </span> must be perpendicular to one another. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2297\"></a><pre><em class=\"codeEmphasisStrong\">start</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4822\"></a>The start angle in radians. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2296\"></a><pre><em class=\"codeEmphasisStrong\">end</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4820\"></a>The end angle in radians. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2295\"></a><pre><em class=\"codeEmphasisStrong\">open</em>: &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-481E\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, the surface is closed; otherwise the surface is not closed. Defaults to <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2294\"></a><pre><em class=\"codeEmphasisStrong\">MakeNURBSTorusSurface</em> &lt;majorRad&gt; &lt;minorRad&gt; &lt;origin&gt; &lt;sym_axis&gt; &lt;ref_axis&gt; &lt;startU&gt; &lt;endU&gt; &lt;startV&gt; &lt;endV&gt; [<em class=\"codeEmphasisStrong\">open</em>:&lt;boolean&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-481B\"></a>This function generates a NURBS torus surface. The output of this function is a NURBS\n               Surface. Note that this is a CV surface that matches the definition, not a relational\n               surface. \n            </p> \n            <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F54\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p>This surface is not closed surface. </p> \n               </div>\n            </div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2293\"></a><pre><em class=\"codeEmphasisStrong\">majorRad</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4815\"></a>This is the radius of the entire \'donut\' shape. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2292\"></a><pre><em class=\"codeEmphasisStrong\">minorRad</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4813\"></a>The is the radius of the \'tube\'. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2291\"></a><pre><em class=\"codeEmphasisStrong\">origin</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4811\"></a>The origin of the cone. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2290\"></a><pre><em class=\"codeEmphasisStrong\">sym_Axis</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-480F\"></a>The axis of symmetry. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-228F\"></a><pre><em class=\"codeEmphasisStrong\">ref_Axis</em> &lt;Point3&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-480D\"></a>This is the direction of the seam. The <span class=\"code\"> <em class=\"strong\">symAxis</em> </span> and <span class=\"code\"> <em class=\"strong\">refAxis</em> </span> must be perpendicular to one another. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-228E\"></a><pre><em class=\"codeEmphasisStrong\">startU</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-480B\"></a>The start angle of the torus in the U direction. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-228D\"></a><pre><em class=\"codeEmphasisStrong\">endU</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4809\"></a>The end angle of the torus in the U direction. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-228C\"></a><pre><em class=\"codeEmphasisStrong\">startV</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4807\"></a>The start angle of the torus in the V direction. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-228B\"></a><pre><em class=\"codeEmphasisStrong\">endV</em> &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4805\"></a>The end angle of the torus in the V direction. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-228A\"></a><pre><em class=\"codeEmphasisStrong\">open</em>: &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4803\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, the surface is closed; otherwise the surface is not closed. Defaults to <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";