var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-B5CF6967-0CC7-48A5-9CC8-DF1AA6D84676\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Script Test Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Script Test Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B5CF6967-0CC7-48A5-9CC8-DF1AA6D84676\"></a><div class=\"head\">\n            <h1>Script Test Example </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A9A\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A9B\"></a>The following sample script is the default script of the Script Test. It shows how\n            to test particles against a spherical volume. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A9C\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A9D\"></a>This script must be used in a <span class=\"char_link\"><a href=\"GUID-096D9928-CFE6-4485-84D1-A38E0DC47660.htm\">Script_Test</a></span> action. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A9E\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-6FAFC7BB-8ED1-4E70-8ECD-201BC60C251E-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84A9F\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AA0\"></a>The script goes through all particles, compares the particle position with a radius\n            of 20 and sets the particle’s test status to <span class=\"code\"> <em class=\"strong\">true</em> </span> when the particle is inside the radius. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AA1\"></a>In the above setup, the particles that pass through the sphere are sent to the next\n            event where they change their color: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AA2\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-9D03B3FC-5CF4-4800-8CA5-A3FFFCCB0871-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E84AA3\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E84AA4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E0C\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\n--Enable the Time channel:\npCont.useTime = true\n--Enable the Position channel:\npCont.usePosition = true\n)\n \n--The Init handler is called on initialization.\n--It is not used in this case.\non Init pCont do\n(\n)\n \n--The Proceed handler contains the main script\n--applied to the Particles.\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to:\non Proceed pCont do\n(\n--get the total number of particles\ncount = pCont.NumParticles()\n--loop through all particles\nfor i in 1 to count do\n(\n--Set the particle index in the container to the current i value.\n--This makes the i-th particle in the container the current one\npCont.particleIndex = i\n-- all particles inside a sphere with radius 20 satisfy the test\nif length (pCont.particlePosition) &lt; 20 then\n(\n--set the Test Status of the particle to True\npCont.particleTestStatus = true\n--set the Test Time of the particle to the current Particle Time\npCont.particleTestTime = pCont.particleTime\n)\n)--end i loop\n)\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84ADB\"></a> <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84ADC\"></a> <span class=\"char_link\"><a href=\"GUID-096D9928-CFE6-4485-84D1-A38E0DC47660.htm\">Script_Test : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84ADD\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84ADE\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";