var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-B7285C43-6DDC-4928-A9BD-E79451A809E1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface PRTExport</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B7285C43-6DDC-4928-A9BD-E79451A809E1\"></a><div class=\"head\">\n            <h1>Interface PRTExport</h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7CA0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7C9F\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; PlacementTool \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> The \n            		<span class=\"code\">PRTExport</span> interface exposes PRT export functionality for fluids. Note that defaults for the\n            PRT export feature are stored in the \n            		<span class=\"filePath\">3dsmax.ini</span> file, in the [Fluids] section, and may be directly edited there. \n            	 \n         </p>\n         <p>Available in \n            		<em class=\"strong\">3ds Max 2018.4 Update and higher</em>. \n            	 \n         </p>\n         <div class=\"section\"><a name=\"SECTION_F599E96B48234728906D2F7BA841311C\"></a> \n            <h2><a name=\"GUID-589BD624-5262-4479-A7BF-606DB7F18951\"></a>Properties:\n            </h2> \n            <p>None \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_244EC0D4CF3047BFB04EE41031942597\"></a> \n            <h2><a name=\"GUID-F0811A97-B9DB-4870-87AC-F7447A26E53C\"></a>Methods:\n            </h2> \n            <div class=\"codeBlock\"><pre>    &lt;bool&gt;SetPRTFileVersion &lt;integer&gt;version</pre></div> \n            <p> PRT files have two versions, 1 or 2. 3ds Max supports both, but version 2 is recommended\n               as it provides additional axis orientation information. Returns true on success. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre>    &lt;integer&gt;GetPRTFileVersion()</pre></div> \n            <p> Returns the .prt file version in effect: 1 or 2. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre>    &lt;bool&gt;SetExportOption &lt;enum&gt;channel &lt;bool&gt;export\n       channel enums: {#position|#density|#velocity|#vorticity|#id|#age|#airDistance|#churn|#curvature|#droplet|#expansionRate|#stictionStrength|#stictionBandwidth|#uv}</pre></div> \n            <p> If \n               		  <span class=\"code\">export</span> is true, the specified \n               		  <span class=\"code\">channel</span> is exported into the .prt file if it exists in the .bif simulation data. Returns\n               true if successfully set. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre>    &lt;bool&gt;GetExportOption &lt;enum&gt;channel\n       channel enums: {#position|#density|#velocity|#vorticity|#id|#age|#airDistance|#churn|#curvature|#droplet|#expansionRate|#stictionStrength|#stictionBandwidth|#uv}</pre></div> \n            <p> Returns true if the specified \n               		  <span class=\"code\">channel</span> is set to export, false otherwise. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre>    &lt;bool&gt;SetExportName &lt;enum&gt;channel &lt;&amp;TSTR&gt;name       channel \n       channel enums: {#position|#density|#velocity|#vorticity|#id|#age|#airDistance|#churn|#curvature|#droplet|#expansionRate|#stictionStrength|#stictionBandwidth|#uv}\n       name is In parameter</pre></div> \n            <p>Sets the name to use for the given channel in the .prt file. For example, if you want\n               the Bifrost \"density\" channel to be called \"FluidDensity\" in the .prt, call: \n               		\n            </p> <span class=\"code\">SetExportName #density \"FluidDensity\"</span> \n            <p> </p> \n            <div class=\"codeBlock\"><pre>    &lt;bool&gt;GetExportName &lt;enum&gt;channel &lt;&amp;TSTR&gt;name\n       channel enums: {#position|#density|#velocity|#vorticity|#id|#age|#airDistance|#churn|#curvature|#droplet|#expansionRate|#stictionStrength|#stictionBandwidth|#uv}\n       name is Out parameter</pre></div> \n            <p>Gets the name used for the specified \n               		  <span class=\"code\">channel</span>, returned in the \n               		  <span class=\"code\">name</span> parameter. Returns true on success. \n               		\n            </p> \n            <p> </p> \n            <div class=\"codeBlock\"><pre>    &lt;void&gt;ResetSettings()</pre></div> \n            <p> Resets the .prt export settings to startup condition; this resets to factory settings\n               then loads the .ini file \"Fluids\" section settings. \n               		\n            </p> \n            <p> </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_5522EB67427644E28DBE292ECA38680F\"></a> \n            <h2><a name=\"GUID-03F35C25-B059-4840-8386-45892B1DEE85\"></a>Actions:\n            </h2> \n            <p>None \n               		\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";