var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-B8D76A96-97BF-414C-AF4F-F00AFD39B19D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBS\">\n      <meta name=\"indexterm\" content=\"overview of the principal NURBS classes\">\n      <meta name=\"indexterm\" content=\"independent NURBS object\">\n      <meta name=\"indexterm\" content=\"dependent NURBS objects\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Overview of the Principal NURBS Classes</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B8D76A96-97BF-414C-AF4F-F00AFD39B19D\"></a><div class=\"head\">\n            <h1>Overview of the Principal NURBS Classes </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4902\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4901\"></a>    The diagram below shows the inheritance tree of the principal classes in the NURBS\n               family. The base classes are shown at the top, and the inheritance hierarchy proceeds\n               toward the bottom and to the right. <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> is the main base class, with <span class=\"char_link\"><a href=\"GUID-7066A0C4-409A-4469-84C8-52C1977FE546.htm\">NURBSPoint</a></span>, <span class=\"char_link\"><a href=\"GUID-1233998E-6755-451C-B9DF-95351475231F.htm\">NURBSControlVertex</a></span>, <span class=\"char_link\"><a href=\"GUID-8CEABA20-9D21-4ED0-AA95-3749435D2104.htm\">NURBSCurve</a></span> , <span class=\"char_link\"><a href=\"GUID-19C0A3FC-AECA-437A-A430-51EFC9D70545.htm\">NURBSSurface</a></span>, <span class=\"char_link\"><a href=\"GUID-593123B8-0F17-4944-861E-57C9458BF61E.htm\">NURBSCVCurve</a></span>, and <span class=\"char_link\"><a href=\"GUID-4845926E-C867-4338-A52E-067B7C5A6C0E.htm\">NURBSPointCurve</a></span> also functioning as base classes. Several additional classes are used with NURBS\n               objects, but are not part of the NURBS hierarchy. These classes are the <span class=\"char_link\"><a href=\"GUID-521FBB6C-CB73-473E-A565-D1A369E7CDAE.htm\">NURBSDisplay</a></span>, <span class=\"char_link\"><a href=\"GUID-21C94F78-E3A1-4B24-AA5A-DDF4C9F0A9C8.htm\">NURBSSelection</a></span>, <span class=\"char_link\"><a href=\"GUID-B5D639EF-BC99-448C-B737-A8347EBD6250.htm\">NURBSSet</a></span>, <span class=\"char_link\"><a href=\"GUID-52D65D9D-C3D7-4438-868A-A1C5E10DFCF2.htm\">NURBSSurfaceApproximation</a></span>, and <span class=\"char_link\"><a href=\"GUID-189F1545-ABFC-4F2C-A7F0-17E069DD69F3.htm\">NURBSTextureSurface</a></span> classes.\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48FC\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-C769FE3F-7DBB-4E7C-9406-833374C1B183-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48FB\"></a> <em class=\"strong\">NURBS Class Hierarchy</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48FA\"></a>The <em class=\"strong\">NURBSObject</em> class is the base NURBS class. It provides a set of properties that are common to\n               the other classes such as getting and setting the name of the item. It also has a\n               <span class=\"code\"> <em class=\"strong\">NURBSId</em> </span> property which is an ID used to specify a particular object in communication between\n               the NURBS classes.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48F9\"></a>The <em class=\"strong\">NURBSSet</em> class is the class used when developers want to create <em class=\"strong\">3ds Max</em> NURBS objects, or retrieve data from existing <em class=\"strong\">3ds Max</em> NURBS objects. The NURBSSet acts as a container for the other objects. This class\n               contains a table of the various NURBSObject derived entities (points, curves, surfaces)\n               used to make up the set. Additionally it has two \'fuse\' tables: one for fuse curves\n               and one for fuse surfaces. These are used to allow the CVs in the curves or surfaces\n               to be \'stitched\' or \'fused\' together so that if one curve or surface moves the other\n               moves with it. This class also has the surface-approximation properties that control\n               the object\'s tessellation into triangle meshes for use in the viewports and the production\n               renderer.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48F8\"></a>The <em class=\"strong\">NURBSPoint</em> classes describe a point in 3D space. Depending on the specific class, points can\n               be either <span class=\"code\"> <em class=\"strong\">independent</em> </span> or <span class=\"code\"> <em class=\"strong\">dependent</em> </span>. Independent points are those that don\'t rely on other objects to define their location.\n               Dependent points are related to the objects they depend on such that the relationship\n               established initially remains if the point, curve or surface moves. For example, a\n               point can be created such that it always remains a certain distance from another point.\n               The options are XYZ-relative, along a normal, or along a tangent (or set of tangents\n               for a surface-dependent constrained point).\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48F7\"></a>The <em class=\"strong\">NURBSControlVertex</em> class defines a Control Vertex of a NURBS Curve or NURBS Surface. This class shares\n               may of the same properties as a NURBSPoint and has the added property of a rational\n               weight. The weight value of a CV is rational. That is, it is relative to other CVs\n               in the curve or surface. Changing the weight of all CVs at once has no effect, because\n               this doesn’t change the ratio between weights.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48F6\"></a>The <em class=\"strong\">NURBSCurve</em> classes describe the properties of NURBS curves. As with the NURBSPoint classes,\n               depending on the specific class, curves can be either independent or dependent. Independent\n               curves are those that don\'t rely on other objects to define their location. A dependent\n               curve is an object that depends on one or more other objects to define what it is.\n               For example, a Blend Curve depends on the two parent curves that it blends between\n               when it was created (as well as on its two tension parameters).\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-48F5\"></a>The <em class=\"strong\">NURBSSurface</em> classes describe the properties of NURBS surfaces. As with the NURBSPoint and NURBSCurve\n               classes, depending on the specific class, surfaces can be either independent or dependent.\n               Independent surfaces are those that don\'t rely on other objects to define their location.\n               Dependent surfaces are surface sub-objects whose geometry depends on other surfaces\n               or curves in the NURBS model. When you change the geometry of the original parent\n               surface or curve, the dependent surface changes as well.\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";