var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-B9058582-6DA8-41AF-B44E-930C787807F1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"properties: dynamic\">\n      <meta name=\"indexterm\" content=\"MAX-specific classes - dynamic properties\">\n      <meta name=\"indexterm\" content=\"dynamic properties\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Dynamic Properties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B9058582-6DA8-41AF-B44E-930C787807F1\"></a><div class=\"head\">\n            <h1>Dynamic Properties </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71B5\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71B4\"></a>   In addition to the properties listed in the reference, MAXScript provides access to\n               the <em class=\"strong\">dynamic properties</em> in <em class=\"strong\">3ds Max</em> entities, those properties that are specific to an individual object and depend on\n               the operations you\'ve performed on that object in the <em class=\"strong\">3ds Max</em> scene. These includes such things as animatable modifier sub-objects like gizmos\n               and FFD control points and sub-controllers like those in a List controller or P/R/S\n               Transform or Path controller.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71B0\"></a>These correspond to the many animatable parameters and sub-objects that you see in\n               the Track View for an object; if you can see them in the Track View they will be visible\n               as either static or dynamic properties in the MAXScript value that corresponds to\n               that object.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71AF\"></a>The property name you specify is matched against the sub-animatable name (as it would\n               be seen in the Track View or sub-object drop-down) using the standard MAXScript conventions\n               of mapping spaces to <span class=\"code\"> <em class=\"strong\">\'_\'</em> </span> underscores and ignoring case when dealing with <em class=\"strong\">3ds Max</em> class and property names. You can also simply leave out the spaces in any dynamic\n               property names.\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71AD\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71AC\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D31\"></a><pre>\np = $foo.bend.center\n$baz.taper.gizmo.rotation = quat 30 z_axis\n$foo.pos.controller.bezier_position = [10,0,0]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-71A5\"></a>Because these properties are dynamic and may change as controllers are replaced and\n               sub-objects become animated, they may vary from object to object and so are not reported\n               in the properties section of the <span class=\"code\"> <em class=\"strong\">showClass()</em> </span> function output. Instead, you can use the built-in function <span class=\"code\"> <em class=\"strong\">showProperties()</em> </span> which will display the accessible properties on a <em class=\"strong\">3ds Max</em> entity including the currently visible dynamic properties. Both functions are described\n               in <span class=\"char_link\"><a href=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52.htm\">Class and Object Inspector Functions</a></span>.\n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";