var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-B94A1094-002C-4A7D-B5DD-AF5AB3435041\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I calculate the Volume of an Object?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B94A1094-002C-4A7D-B5DD-AF5AB3435041\"></a><div class=\"head\">\n            <h1>How do I calculate the Volume of an Object? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBB6\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBB8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBB9\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8BE\">MAXScript Values</a></span> &gt; How do I calculate the Volume of an Object? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBBB\"></a>There is currently no access to the Measure Utility from MAXScript, but you can use\n            the following MAXScript function to get the same results: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBBD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBBE\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-667A\"></a><pre>\nfn CalculateVolumeAndCenterOfMass obj =\n(\nlocal Volume= 0.0\nlocal Center= [0.0, 0.0, 0.0]\nlocal theMesh = snapshotasmesh obj\nlocal numFaces = theMesh.numfaces\nfor i = 1 to numFaces do\n(\n  local Face= getFace theMesh i\n  local vert2 = getVert theMesh Face.z\n  local vert1 = getVert theMesh Face.y\n  local vert0 = getVert theMesh Face.x\n  local dV = Dot (Cross (vert1 - vert0) (vert2 - vert0)) vert0\n  Volume+= dV\n  Center+= (vert0 + vert1 + vert2) * dV\n)\ndelete theMesh\nVolume /= 6\nCenter /= 24\nCenter /= Volume\n#(Volume,Center)\n)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6678\"></a><pre>\n--Call the function on a geometry object - the result will be a list\n--containing the Volume and the Center of mass in local space.\ns = sphere()\ntheVolAndCom = CalculateVolumeAndCenterOfMass $Sphere001\n--To get the world space of the Center of Mass just like in the Utility,\n--you have to do some extra work:\ntheComInWorld = theVolAndCom[2] * $Sphere001.objectTransform\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBE4\"></a> <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBE5\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";