var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-B9AB78DC-D837-47F6-9B70-F4DEE00B716F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"mapKeys() method\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ControllermapKeys() Method</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B9AB78DC-D837-47F6-9B70-F4DEE00B716F\"></a><div class=\"head\">\n            <h1>ControllermapKeys() Method </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FAF\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FAE\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controllers</a></span> &gt; mapKeys() Method \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FAC\"></a>The <em class=\"strong\">mapKeys</em>() method gives access to the SDK function Control::MapKeys(). \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FAB\"></a>The form is: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EC9\"></a><pre><em class=\"codeEmphasisStrong\">mapKeys</em> &lt;max_object&gt; (&lt;map_struct&gt; | &lt;fn&gt; &lt;arg&gt;) [<em class=\"codeEmphasisStrong\">#allKeys</em>] [<em class=\"codeEmphasisStrong\">#selection</em>] [<em class=\"codeEmphasisStrong\">#slide</em>] [<em class=\"codeEmphasisStrong\">#rightToLeft</em>]\n</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FA8\"></a>This is like other recursive <span class=\"char_link\"><a href=\"GUID-B1700B1D-B1EA-4A6C-B4A3-A29DB26C8C02.htm\">controller key functions</a></span> in MAXScript such as, <span class=\"code\"> <em class=\"strong\">moveKeys</em> </span>, <span class=\"code\"> <em class=\"strong\">deleteKeys</em> </span>, and others, which operate on all the keys in nested controllers in the object you\n            supply. The thing to be mapped is either a scripted function and argument pair or\n            a struct instance. If a function is supplied, it must take two arguments, the time\n            value to be mapped and the &lt;arg&gt; from the mapKeys() call, and pass back the mapped\n            time. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FA7\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FA6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EC8\"></a><pre>\nfn bumpTime t delta = t + delta\nmapKeys $Box01 bumpTime 23 #selection\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FA1\"></a><p class=\"table-body\">will add 23 to all the selected keys in controllers within $Box01. </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7F9F\"></a>If a struct is supplied, it should have at least a \'map\' member function that takes\n            time to be mapped and returns the mapped time. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7F9E\"></a>The advantage of a struct is that it is a way to set up complex parameterized mapping\n            by having as many data members as needed to hold the parameters. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7F9D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7F9C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2EC7\"></a><pre>\nb=box()\nstruct mapper\n(\nscale,\noffset,\nfn map t = return t * scale * offset\n)\nmapKeys b (mapper scale:0.5 offset:10)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7F91\"></a>will execute a combination time scale and offset in one pass. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7F8F\"></a> <span class=\"char_link\"><a href=\"GUID-46A7941F-9A1E-49AF-B607-5516DC6ACCEF.htm\">Time and Key Functions on Object Hierarchies</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7F8E\"></a> <span class=\"char_link\"><a href=\"GUID-A4807BDC-380B-49DE-B3E2-DCB35E43A10C.htm\">Nested Object Controller Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7F8D\"></a> <span class=\"char_link\"><a href=\"GUID-71299FC9-9EE4-45EB-AF7D-146F31EB6AC6.htm\">Controller Time Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7F8C\"></a> <span class=\"char_link\"><a href=\"GUID-B1700B1D-B1EA-4A6C-B4A3-A29DB26C8C02.htm\">Controller Key Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7F8B\"></a> <span class=\"char_link\"><a href=\"GUID-3A44E400-8175-4A99-A53B-68192403819C.htm\">MAXKeyArray Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";