var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-BA196B48-8ECA-4E0C-AE2E-F7EFAAF39844\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"files\">\n      <meta name=\"indexterm\" content=\"external file methods\">\n      <meta name=\"indexterm\" content=\"getFiles()\">\n      <meta name=\"indexterm\" content=\"getDirectories()\">\n      <meta name=\"indexterm\" content=\"makeDir()\">\n      <meta name=\"indexterm\" content=\"removeDir()\">\n      <meta name=\"indexterm\" content=\"deleteFile()\">\n      <meta name=\"indexterm\" content=\"renameFile()\">\n      <meta name=\"indexterm\" content=\"copyFile()\">\n      <meta name=\"indexterm\" content=\"getFileSize()\">\n      <meta name=\"indexterm\" content=\"setFileAttribute()\">\n      <meta name=\"indexterm\" content=\"getFileAttribute()\">\n      <meta name=\"indexterm\" content=\"getFileModDate()\">\n      <meta name=\"indexterm\" content=\"getFileCreateDate()\">\n      <meta name=\"indexterm\" content=\"getFileVersion()\">\n      <meta name=\"indexterm\" content=\"getFileSecurityInfo()\">\n      <meta name=\"indexterm\" content=\"isDirectoryWritable()\">\n      <meta name=\"indexterm\" content=\"getMaxIniFile()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>External File Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BA196B48-8ECA-4E0C-AE2E-F7EFAAF39844\"></a><div class=\"head\">\n            <h1>External File Methods </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-5224\"></a> \n            <p><a name=\"GUID-48982988-F399-4FCE-B564-D322E6507191\"></a>The following methods provide access to external files and directories. \n               		\n            </p> \n            <p><a name=\"GUID-369E63AF-D393-4C1E-BBAB-6210D37A8EC6\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69C3\"></a><pre><em class=\"codeEmphasisStrong\">getFiles</em> &lt;wild_card_filename_string&gt; <em class=\"codeEmphasisStrong\">recurse:</em>&lt;bool&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EDB\"></a>   Returns an array of file names that match the given wild-card path name. If \n               		  <span class=\"code\">recurse</span> is specified as true, recursively searches directories starting at the specified\n               directory. The default is false.\n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ED5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ED4\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ED3\"></a><p class=\"table-body\">The following code gets an array of all the .max scene files in c:\\foo and then loops\n                           over the array, opening each file and printing the objects in each: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69C2\"></a><pre>\nfiles = getFiles \"c:\\\\foo\\\\*.max\"\nfor f in files do (loadMAXFile f; print objects)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ECD\"></a> <span class=\"code\"> <em class=\"strong\">getFiles()</em> </span> can also be used to determine if a \n               		  <em class=\"strong\">file or file pattern</em> exists. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ECB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1ECA\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EC9\"></a><p class=\"table-body\">the following function will return \n                           						<span class=\"code\"> <em class=\"strong\">true</em> </span> if the specified file name or pattern exists: \n                           					 \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69C1\"></a><pre>\nfn existFile fname = (getfiles fname).count != 0\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EC4\"></a>See also \n               		  <span class=\"char_link\"><a href=\"GUID-0EE531B2-6FF8-4D0B-ACA1-5400E0B9D604.htm#WS73099CC142F487553098682E12AC2FC2BC7-69C6\">doesFileExist()</a></span> which checks for a single file only and does not supportwildcardpatterns. \n               		\n            </p> \n            <p><a name=\"GUID-1C4D78B3-CC27-4436-A021-063821845ED3\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69C0\"></a><pre><em class=\"codeEmphasisStrong\">getDirectories</em> &lt;wild_card_directory_name_string&gt; <em class=\"codeEmphasisStrong\">recurse:</em>&lt;bool&gt;  </pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-7957\"></a> Returns an array of directory paths that match the given wild-card directory path\n               name. If \n               		  <span class=\"code\">recurse</span> is specified as true, recursively searches directories starting at the specified\n               directory. The default is false.\n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EBE\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EBD\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69BF\"></a><pre>\nfn getFilesRecursive root pattern =\n(\ndir_array = GetDirectories (root+\"/*\")\nfor d in dir_array do\n  join dir_array (GetDirectories (d+\"/*\"))\nmy_files = #()\nfor f in dir_array do\n  join my_files (getFiles (f + pattern))\nmy_files\n)\n--get all .ms files from the folder c:/temp\n--and all its subfolders:\ngetFilesRecursive \"c:/temp\" \"*.ms\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-5DA8CD69-6910-4990-BEC2-52BA79D647D6\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69BE\"></a><pre><em class=\"codeEmphasisStrong\">makeDir</em> &lt;directory_path_string&gt; <em class=\"codeEmphasisStrong\">all:</em>&lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-7956\"></a> Creates a new directory with the given name. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EA8\"></a>Returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the path was created successfully or if it existed already. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EA7\"></a>Returns \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> if the path could not be created either because the argument was not a valid path\n               or due to insufficient writing rights. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EA6\"></a>If the optional \n               		  <span class=\"code\"> <em class=\"strong\">all:</em> </span> keyword argument is set to \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> (default since \n               		  <em class=\"strong\">3ds Max 9</em>, in \n               		  <em class=\"strong\">3ds Max 8</em> the default was \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>), all sub-directory levels specified in the path will be created if they do not exist.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EA5\"></a>MAXScript does not provide a method for deleting directories. See the last example\n               for \n               		  <span class=\"char_link\"><a href=\"GUID-846B6AB0-EFF6-43E5-8A67-8D348FF78A57.htm#WS73099CC142F487553098682E12AC2FC2BC7-683E\">HiddenDOSCommand()</a></span> for a possible workaround. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EA3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1EA2\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69BD\"></a><pre>\nmakeDir @\"c:\\temp\\test\\deleteme\\if\\you\\can\" all:false\nfalse --unless the path already exists up to the \\you folder\nmakeDir @\"c:\\temp\\test\\deleteme\\if\\you\\can\" all:true\ntrue --creates all the folders listed in the path\nmakeDir @\"c:\\temp\\test\\deleteme\\if\\you\" all:true\ntrue --even if the previous call had created the path, still ok\nmakeDir @\"a:\\temp\"\nfalse --unless you still have a Floppy drive and a disk for it!\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-72AFFA3E-7EE0-4514-B06D-27D8FF311151\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">removeDir</em> &lt;directory_path_string&gt; </pre></div> \n            <p>  Removes the specified directory. Returns true if the directory was removed. \n               		\n            </p> \n            <p>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69BC\"></a><pre><em class=\"codeEmphasisStrong\">deleteFile</em> &lt;filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-7955\"></a> Deletes the named file. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E90\"></a>Fails if the file is open in MAXScript.An open file can be closed using the respective\n               close() method for ASCII or Binary streams, or if the handle is not accessible due\n               to local scope, by calling manual Garbage Collection using \n               		  <span class=\"code\"> <em class=\"strong\">gc().</em> </span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E8F\"></a>Does \n               		  <em class=\"strong\">not</em> work on directories created using \n               		  <span class=\"code\"> <em class=\"strong\">makeDir()</em> </span>, only on actual files. For a way to delete a directory, see the last example for\n               \n               		  <span class=\"char_link\"><a href=\"GUID-846B6AB0-EFF6-43E5-8A67-8D348FF78A57.htm#WS73099CC142F487553098682E12AC2FC2BC7-683E\">HiddenDOSCommand()</a></span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E8E\"></a>Returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> on success, \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> on failure. \n               		\n            </p> \n            <p><a name=\"GUID-EABB8915-6ADB-43C7-B215-C624E4ABA1FC\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69BB\"></a><pre><em class=\"codeEmphasisStrong\">renameFile</em> &lt;old_filename_string&gt; &lt;new_filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-7954\"></a> Renames the old file to the new file. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E8A\"></a>This can also be used to \n               		  <em class=\"strong\">move</em> a file between directories. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E89\"></a>Fails if the new file already exists or if the old file is open in MAXScript. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E88\"></a>Returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> on success, \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> on failure. \n               		\n            </p> \n            <p><a name=\"GUID-671758ED-68B3-4E6B-A383-6165EE09B325\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69BA\"></a><pre><em class=\"codeEmphasisStrong\">copyFile</em> &lt;existing_filename_string&gt; &lt;target_filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-7953\"></a> Copies the existing file to the new file. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E84\"></a>Fails if the existing file is open in MAXScript, the target file cannot be created,\n               or the target file already exists. In the latter case, you can use \n               		  <span class=\"code\"> <em class=\"strong\">deleteFile()</em> </span> to remove the existing target file first. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E83\"></a>Returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> on success, \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> on failure. \n               		\n            </p> \n            <p><a name=\"GUID-7AFD02B4-F053-4CE8-ADEA-2E81A06B1B38\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69B9\"></a><pre><em class=\"codeEmphasisStrong\">getFileSize</em> &lt;filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-7952\"></a> Returns the size of the specified file in bytes. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E7F\"></a>Returns 0 if the file could not be found. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E7D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E7C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69B8\"></a><pre>\nGetFileSize (getDir #maxRoot + \"\\\\3dsmax.exe\")\n--&gt; 9881600\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-8EC190CD-6016-47EA-BAB7-149B133935AD\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69B7\"></a><pre><em class=\"codeEmphasisStrong\">getFileAttribute</em> &lt;filename_string&gt; &lt;attribute&gt; \n<em class=\"codeEmphasisStrong\">setFileAttribute</em> &lt;filename_string&gt; &lt;attribute&gt; &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-7951\"></a>  Get and set the attributes associated with a file. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E71\"></a>The get function returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> or \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> depending on the state of the specified attribute. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E70\"></a>The set function sets the state of the individual attribute specified (leaving other\n               attributes as they were). \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E6F\"></a>The valid \n               		  <span class=\"code\"> <em class=\"strong\">&lt;attribute&gt;</em> </span> values are: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69B6\"></a><pre><em class=\"codeEmphasisStrong\">#readOnly</em> <em class=\"codeEmphasisStrong\">#hidden</em> <em class=\"codeEmphasisStrong\">#system</em> <em class=\"codeEmphasisStrong\">#directory</em> <em class=\"codeEmphasisStrong\">#archive</em> <em class=\"codeEmphasisStrong\">#temporary</em> <em class=\"codeEmphasisStrong\">#normal</em> </pre></div> \n            <p><a name=\"GUID-0766D716-68B4-4CCA-A249-7872A092E6E2\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69B5\"></a><pre><em class=\"codeEmphasisStrong\">getFileModDate</em> &lt;filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E66\"></a>Returns a String value containing the modification date for the specified file, for\n               example \n               		  <span class=\"code\"> <em class=\"strong\">\"1/29/99 1:52:05 PM\"</em> </span>. \n               		\n            </p> \n            <p><a name=\"GUID-C90E5253-1F91-4638-B832-0134C6B9BAE4\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69B4\"></a><pre><em class=\"codeEmphasisStrong\">getFileCreateDate</em> &lt;filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-794F\"></a> Returns a String value containing the creation date for the specified file. \n               		\n            </p> \n            <p><a name=\"GUID-79A93AD1-3EF7-49C3-B480-506D1AB977FE\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69B3\"></a><pre><em class=\"codeEmphasisStrong\">getFileVersion</em> &lt;filename_string&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-794E\"></a> Returns the file and product version for the specified file, or unknown if this data\n               is not specified in the file. This data is typically specified only for executable\n               and application extension (i.e., .dll) files. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E5F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E5E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69B2\"></a><pre>\nGetFileVersion (getDir #maxRoot + \"\\\\3dsmax.exe\")\n--&gt; \"12,0,0,91 12,0,0,91\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-99335793-E56C-40D0-8BC8-CEEDB43D2298\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69B1\"></a><pre><em class=\"codeEmphasisStrong\">getFileSecurityInfo</em> &lt;file_name&gt; &lt;attribute&gt; <em class=\"codeEmphasisStrong\">testFileAttribute</em>: &lt;bool&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E56\"></a> Returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the specified file exists and the specified security attribute is set, where &lt;attribute&gt;\n               is one of \n               		  <span class=\"code\"> <em class=\"strong\">#read</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">#write</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">#execute</em> </span>, \n               		  <span class=\"code\"> <em class=\"strong\">#all</em> </span>. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E55\"></a>If &lt;file_name&gt; is a directory and &lt;attribute&gt; is \n               		  <span class=\"code\"> <em class=\"strong\">#write</em> </span> or \n               		  <span class=\"code\"> <em class=\"strong\">#all</em> </span> and the directory\'s security attributes show the directory is writable, the method\n               will also attempt to create a temporary file in the directory to confirm it is writable.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E54\"></a>if \n               		  <span class=\"code\"> <em class=\"strong\">testFileAttribute:</em> </span> is \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span> or not specified, or &lt;file_name&gt; specifies a directory, the file attributes on the\n               file are \n               		  <em class=\"strong\">not</em> included in the test. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E53\"></a>If \n               		  <span class=\"code\"> <em class=\"strong\">testFileAttribute:</em> </span> is \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> and &lt;file_name&gt; specifies a file, the file attributes (read, write, execute) are\n               AND-ed with the security attributes. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E52\"></a>Available in \n               		  <em class=\"strong\">3ds Max 2010</em> and higher. \n               		\n            </p> \n            <p><a name=\"GUID-C70E15E2-3649-411C-9C23-F74E37952A9D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69B0\"></a><pre><em class=\"codeEmphasisStrong\">isDirectoryWriteable</em> &lt;dir_name&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E4F\"></a> Returns \n               		  <span class=\"code\"> <em class=\"strong\">true</em> </span> if the specified directory exists and the directory can be written into. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E4E\"></a>Available in \n               		  <em class=\"strong\">3ds Max 2010</em> and higher. \n               		\n            </p> \n            <p><a name=\"GUID-543A77AA-55EB-42C5-ADE5-93F4D4C4099A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69AF\"></a><pre><em class=\"codeEmphasisStrong\">getMAXIniFile</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E4B\"></a> In \n               		  <em class=\"strong\">3ds Max 6 and higher</em>, returns the current 3dsmax.ini file as a string. For some products that store the\n               ini settings in the registry, this method returns undefined. See also \n               		  <span class=\"char_link\"><a href=\"GUID-CF408D64-D4E2-4C39-90DB-62E525D7B45A.htm\">Accessing INI File Keys</a></span>. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E48\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E47\"></a><p class=\"table-body\"> <em class=\"strong\">MORE EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69AE\"></a><pre>\nfor f in getFiles \"3dsmax\\\\maps\\\\*.jpg\" do deleteFile f\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69AD\"></a><pre>\nfor d in getDirectories \"D:\\\\foo\\\\*\" do\nfor f in getFiles (d + \"*.*\") do\ncopyFile f (\"C:\\\\temp\\\\\" + getFilenameFile f + getFilenameType f)\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69AC\"></a><pre>\nif (getFiles \"foo*.max\").count == 0 do\nprint \"No Files Match Pattern \'foo*.max\'!\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E38\"></a> <span class=\"char_link\"><a href=\"GUID-BB041082-3EEF-4576-9D69-5B258A59065E.htm\">Filestream Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E37\"></a> <span class=\"char_link\"><a href=\"GUID-0EE531B2-6FF8-4D0B-ACA1-5400E0B9D604.htm\">File Name Parsing</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E36\"></a> <span class=\"char_link\"><a href=\"GUID-D4B43A33-8342-4BC9-80AB-91460861D37C.htm\">Standard Open and Save File Dialogs</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";