var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-BADB0C21-6628-4205-B326-71F38DABE06F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"OLE automation\">\n      <meta name=\"indexterm\" content=\"createOLEObject()\">\n      <meta name=\"indexterm\" content=\"releaseAllOLEObjects()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>OLE Automation</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BADB0C21-6628-4205-B326-71F38DABE06F\"></a><div class=\"head\">\n            <h1>OLE Automation </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1353\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1352\"></a> The OLE Automation capability in MAXScript allows <em class=\"strong\">3ds Max</em> to act as an OLE Automation server for applications such as, Visual Basic, Excel,\n               Paradox, and others. With it, you can publish MAXScript functions that can be called\n               from OLE Automation clients like VB and Excel to generate models or animations, return\n               data from the current scene, and so on. There is an example provided in the script\n               samples that defines a set of simple business graphing MAXScript functions and an\n               Excel spreadsheet with some Excel VB-scripted menus, which pass a selection of cells\n               across to these MAXScript functions to generate an animated bar chart. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1350\"></a>This facility has the following features and limitations: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-134F\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-134D\"></a>It exposes a <em class=\"strong\">single</em> server object to which you can attach a list of MAXScript functions that appear as\n                     the methods of that object to an OLE Automation client. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-134B\"></a>It is registered as a separate process, local server supporting multiple use of its\n                     exposed object. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1349\"></a>It does not support in-place activation or object linking and embedding, and provides\n                     no containers for other OLE objects. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1347\"></a>It supports only the IDispatch form of interface with no accessible type information.\n                     Clients need to declare their reference to the <em class=\"strong\">3ds Max</em> server object as an untyped generic object. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1345\"></a>It supports the following method argument and result data types: <a name=\"UL_10B6831B17614B7C8547CAF4E7D6DC1F\"></a><ul>\n                        <li>integers </li>\n                        <li>reals (floats) </li>\n                        <li>currency (floats) </li>\n                        <li>string </li>\n                        <li>boolean </li>\n                        <li>empty (for example, an empty spreadsheet cell) </li>\n                     </ul> \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-133E\"></a>The equivalent MAXScript value for empty is <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6815\"></a><pre>\nOLE Objects (interfaces)\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-133C\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-133A\"></a>You need to have <em class=\"strong\">3ds Max</em> running and MAXScript activated before OLE Clients can access <em class=\"strong\">3ds Max</em>. MAXScript is activated (and the <span class=\"code\"> <em class=\"strong\">startup.ms</em> </span> script run) when you first access its Utility panel rollout. Alternatively, you can\n                     use launch script facilities described in <span class=\"char_link\"><a href=\"GUID-A04C0E75-F82A-41AC-92E8-D7CB1D797430.htm\">Running Scripts from the Command Line</a></span> to establish an OLE server interface as soon as <em class=\"strong\">3ds Max</em> runs. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1338\"></a>You must register <em class=\"strong\">3ds Max</em> with Windows as an OLE server using the registration script supplied with this release.\n                     See the instructions in <span class=\"char_link\"><a href=\"GUID-7B244BAA-4200-44D6-BEBF-EE22B01C5F21.htm\">Setting Up MAXScript OLE Automation</a></span> for details. \n                  </p> \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1337\"></a> \n            <h2><a name=\"GUID-C9B47BD4-6CDB-4A23-B06F-D5F48CBCEBCF\"></a> <em class=\"strong\">OLE Client</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1336\"></a>With the MAXScript OLE Automation Client system, you can use MAXScript to create OLE\n               Automation (now called Active-X) objects within <em class=\"strong\">3ds Max</em> and control the associated OLE Automation Servers with MAXScript such as, making\n               an Excel spreadsheet and inserting <em class=\"strong\">3ds Max</em> object information directly into cells there. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1335\"></a>The function, \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6814\"></a><pre> <div class=\"codeBlock\"><pre> <em class=\"codeEmphasisStrong\">createOLEObject()</em></pre></div> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1333\"></a> is used for establishing a connection to OLE Auto Servers. The return value of <span class=\"code\"> <em class=\"strong\">createOLEObject()</em> </span> is an instance of the <span class=\"code\"> <em class=\"strong\">OLEObject</em> </span> class. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1332\"></a> <em class=\"strong\">For example,</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6813\"></a><pre>\nxl = createOLEObject \"Excel.Sheet\"\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1330\"></a>opens a connection to Excel and creates a sheet object and puts it in the variable\n               xl. The single argument to this function is an OLE progID string. You can then access\n               properties and call methods on the new OLE object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-132F\"></a> <em class=\"strong\">For example,</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6812\"></a><pre>\nxl.application.name\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-132D\"></a>will return \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6811\"></a><pre>\n\"Microsoft Excel\"\n</pre></div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6810\"></a><pre>\nxl.application.visible = true\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-132A\"></a>will make Excel visible on the desktop. You get properties on OLE objects with the\n               dot \'.\' notation, just as you do in MAXScript. You also refer to OLE object methods\n               as properties of the OLE object. For example, the Sheet has a method \'cells\' that\n               takes a cell coordinate and returns a Cell OLE object. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-680F\"></a><pre>\nxlc = xl.application.cells 1 1\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1328\"></a>puts the top-left-hand cell into xlc. Set its value like this: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-680E\"></a><pre>\nxlc.value = 123.45\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1326\"></a>The server application that was attached with <span class=\"code\"> <em class=\"strong\">createOLEObject()</em> </span> is released and terminated when the created MAXScript OLE object is eventually garbage-collected.\n               You can explicitly disconnect from an OLE server application with the <span class=\"code\"> <em class=\"strong\">releaseOLEObject()</em> </span> function. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1325\"></a>The form is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-680D\"></a><pre>\nreleaseOLEObject &lt;ole_object&gt;\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1323\"></a>The OLE object becomes disabled once <span class=\"code\"> <em class=\"strong\">releaseOLEObject()</em> </span> has been called on it and further attempts to use it results in a descriptive error\n               message. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1322\"></a>You can explicitly disconnect from all active OLE server applications with the <span class=\"code\"> <em class=\"strong\">releaseAllOLEObjects()</em> </span> function. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1321\"></a>Its form is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-680C\"></a><pre> <div class=\"codeBlock\"><pre> <em class=\"codeEmphasisStrong\">releaseAllOLEObjects</em></pre></div>() \n                  </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-131E\"></a>After calling this function, all existing OLE objects become disabled and any attempt\n               to use them further will generate a runtime error. \n            </p> \n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-7B244BAA-4200-44D6-BEBF-EE22B01C5F21.htm\">Setting Up MAXScript OLE Automation </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-0BAD1DAE-D29E-4A08-B516-442DE74B9231.htm\">Exposing MAXScript Functions </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-DC2B61FD-8FB6-4ABF-AD76-87E5531BDB93.htm\">3ds Max Specific Errors </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-AE4CAED2-1EF9-40EF-9761-83F535FE953A.htm\">Running the OLE Demo </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-5A84508D-6F9E-4E18-8C0A-81F91794DA47.htm\">SafeArrayWrapper Class </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";