var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interfaces\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interfaces</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39\"></a><div class=\"head\">\n            <h1>Interfaces </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7104\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7103\"></a> The Function Publishing System, introduced with <em class=\"strong\">3ds Max version 4</em>, is a system that allows plug-ins to publish their major functions and operations\n               in such a way that code outside the plug-in can discover and make inquiries about\n               these functions and is thus able to call them though a common calling mechanism. The\n               whole system is very similar to Window’s COM and OLE Automation systems and share\n               many similar concepts in the architecture. However, the Function Publishing System\n               is not based on COM and OLE but instead is a custom architecture more suited and optimized\n               for <em class=\"strong\">3ds Max</em>. The Function Publishing API serves a number of purposes, which allow third-party\n               developers to open up important portions of their plug-ins for use by external sources,\n               allowing for users to extend and control these directly. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7101\"></a>Some of the purposes of the Function Publishing System are: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-7100\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70FE\"></a>Modularizing plugin code into various \"engines\" that are able to supply services to\n                     other parts of 3ds Max and other third party plug-ins and can be delivered to the\n                     user through various different user-interfaces. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70FC\"></a>Providing automatic scriptability by exposing the published functions directly to\n                     MAXScript. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70FA\"></a>Providing alternate means of invoking plugin functions in the UI, such as via the\n                     manipulator system, scripted menus, quad menus, keyboard shortcuts, macroScripts,\n                     toolbar buttons, etc. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70F8\"></a>Allowing the MAXScript Macro Recorder to automatically generate calls to the published\n                     functions, in the event that these are invoked by the expanded ParamMap2 system or\n                     other UI mechanisms such as keyboard shortcuts or menu items. \n                  </p> \n               </li>\n            </ul> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1902\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>For complete details on the Function Publishing System, please see the <em class=\"strong\">3ds Max</em> SDK help file topic \"Function Publishing\". \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70F2\"></a> <em class=\"strong\">Interfaces</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70F1\"></a> <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70F0\"></a> <span class=\"char_link\"><a href=\"GUID-38A8EFE3-685B-41F8-9E36-5B6B5CEACC18.htm\">Node Interfaces</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70EF\"></a> <span class=\"char_link\"><a href=\"GUID-64FF9971-944C-42CF-995A-B549F9F7C11C.htm\">Other Interfaces</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70ED\"></a>Functions are published in one or more Interfaces by a plug-in. Action functions must\n               be published in their own set of interfaces. Each interface is represented by an instance\n               of a class derived from the base class FPInterface. An external system can find out\n               about the interfaces published by calling various query methods on ClassDesc that\n               access these interface definition objects. As well as these inquiry or \'reflection\'\n               methods, an FPInterface also has the calling methods for actually invoking a particular\n               function in the interface, so that if something has hold of one of your interfaces,\n               it can call <em class=\"strong\">any</em> of its published functions. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70EC\"></a> <em class=\"strong\">Action Interfaces</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70EB\"></a> <span class=\"char_link\"><a href=\"GUID-38CB8317-6EB2-49D1-A086-B06BA2A141AE.htm\">Action Manager</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70EA\"></a>A special kind of interface is the Action Interface. These interfaces only contain\n               UI Action Functions that provide a programmatic way of \"pressing\" buttons and keys\n               in the UI for a plug-in. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70E9\"></a> <em class=\"strong\">Direct dot-notation properties</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70E8\"></a>MAXScript exposes properties defined in this way as direct dot-notation properties\n               on the interface. So, were before the Get/SetRadius in the example cylinder mixin\n               would have been accessed as functions \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70E7\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70E6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D15\"></a><pre>\nr = $cyl01.cylMixin.getRadius()\n$cyl01.cylMixin.setRadius 23\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70E1\"></a><p class=\"table-body\">you now can use: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D14\"></a><pre>\nr = $cyl01.cylMixin.radius\n$cyl01.cylMixin.radius = 23\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70DB\"></a>This is true for all the types of Function Published Interfaces that exist in MAXScript-static,\n               <span class=\"char_link\"><a href=\"GUID-7BC5A515-913D-45D2-A45F-43792D828055.htm\">Mixin</a></span> and Core. As a further optimization, MAXScript effectively promotes all interface\n               methods and properties to the level of the interface, so if individual methods and\n               properties have unique names within all the interfaces of an object or class, you\n               can omit the interface name. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70DA\"></a>The above examples could be written as \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70D9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70D8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D13\"></a><pre>\nr = $cyl01.getRadius()\n$cyl01.setRadius 23\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70D3\"></a><p class=\"table-body\">and </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D12\"></a><pre>\nr = $cyl01.radius\n$cyl01.radius = 23\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70CD\"></a>If there is a naming conflict, you can always include the interface name level to\n               resolve this. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70CC\"></a> \n            <h2><a name=\"GUID-518D95B7-DD64-4499-A538-8BB6D3260ADA\"></a> <em class=\"strong\">Published Functions and MAXScript</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70CB\"></a>MAXScript automatically provides access to all functions published by a plug-in via\n               the Function Publishing system. Each plug-in class appears in MAXScript as a MAX class\n               object, which can be used to construct instances of the plug-in, do class tests, etc.\n               If a plug-in publishes interfaces, they are visible in MAXScript as properties on\n               this class object. The internal name for the interface is used as the property name.\n               All the functions in the interface are accessible as named properties on the interface.\n               So, if the above example interfaces were published by EditMesh, the following script\n               fragments would work \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70CA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70C9\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D11\"></a><pre>\nEditMesh.faceOps.extrude $foo.mesh #{1,2,3} 10\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70C5\"></a>The above script calls the Extrude function in the FaceOps interface on <span class=\"code\"> <em class=\"strong\">$foo</em> </span>\'s mesh, faces 1, 2 and 3, amount 10 units. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D10\"></a><pre>EditMesh.<em class=\"codeEmphasisStrong\">actions</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70C3\"></a>Retrieves and displays the action functions. Each interface is stored as a struct\n               definition in the class object. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D0F\"></a><pre>EditMesh.<em class=\"codeEmphasisStrong\">actions</em>.<em class=\"codeEmphasisStrong\">create</em>()</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70C1\"></a>Starts (or stops) the create mode. This would have the side-effect of highlighting/unhighlighting\n               the Create button in the EditMesh rollups. Calls to Action functions in MAXScript\n               return true if the function returns FPS_OK and false otherwise. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D0E\"></a><pre>if EditMesh.<em class=\"codeEmphasisStrong\">actions</em>.<em class=\"codeEmphasisStrong\">create</em>.<em class=\"codeEmphasisStrong\">isChecked</em>() then ...\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70BF\"></a>The predicate functions for an Action Function are available as properties on the\n               action function object itself, as shown. You can determine if a predicate is supplied\n               by asking: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D0D\"></a><pre>if EditMesh.actions.create.isChecked != undefined</pre></div> \n            <p><a name=\"GUID-328B3151-A310-4ABF-849B-8EAE98E149E9\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70BD\"></a> <em class=\"strong\">Two Ways of Accessing the Interface</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70BC\"></a>There are two ways to access the interface - as a standalone interface and as an interface\n               on a particular object. If you access the interface directly, you need to pass to\n               it the object to work on. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70BB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70BA\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D0C\"></a><pre>\nm = Bitmaptexture fileName:\"L:\\\\mypath\\\\scenes\\\\2500hicon.JPG\" \nbitmapTex.viewImage m -- direct interface access, need to pass object\nm.viewImage() -- accessing interface on object, object internally passed as arg 1.\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70B5\"></a> <em class=\"strong\">Associated Method:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D0B\"></a><pre><em class=\"codeEmphasisStrong\">getCoreInterfaces()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70B3\"></a>Returns an array of core interface values. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70B2\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70B1\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70B0\"></a><p class=\"table-body\">The following will list all of the core interfaces: </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5D0A\"></a><pre>\ncore_interfaces = getcoreinterfaces()\nfor i in core_interfaces do (showinterface i; format\"\\n\")\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70A9\"></a> <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70A8\"></a> <span class=\"char_link\"><a href=\"GUID-64FF9971-944C-42CF-995A-B549F9F7C11C.htm\">Other Interfaces</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70A7\"></a> <span class=\"char_link\"><a href=\"GUID-6E1C44F4-81C0-400F-9558-E565E1F77D36.htm\">By Reference Parameter Passing</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70A6\"></a> <span class=\"char_link\"><a href=\"GUID-059672B5-A234-438C-8A80-F5CC6C3BE936.htm\">Dereferencing Operator</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70A5\"></a> <span class=\"char_link\"><a href=\"GUID-15EBBE7C-3ADD-4A28-96E7-B9FE47072004.htm\">Visible Class For \'&amp;\' Reference Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70A4\"></a> <span class=\"char_link\"><a href=\"GUID-38CB8317-6EB2-49D1-A086-B06BA2A141AE.htm\">Action Manager</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70A3\"></a> <span class=\"char_link\"><a href=\"GUID-879ECFAD-7928-44B3-BCD7-276D53C89B52.htm\">Class and Object Inspector Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70A2\"></a> <span class=\"char_link\"><a href=\"GUID-782447FD-103B-4686-8F65-97A2A02EB3FB.htm\">showInterfaces Inspector Function</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70A1\"></a> <span class=\"char_link\"><a href=\"GUID-AEF738FF-131B-4731-A00D-B943DD7E4B94.htm\">GetInterfaces Interface Inspector</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-70A0\"></a> <span class=\"char_link\"><a href=\"GUID-C3849AEC-32FC-41B4-9934-1AFAA22CAB79.htm\">showInterface Inspector Function</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-709F\"></a> <span class=\"char_link\"><a href=\"GUID-FEA0A322-ECD4-465C-8C11-DDC4E36DC7BE.htm\">Increasing Performance when Searching for Interfaces and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-709E\"></a> <span class=\"char_link\"><a href=\"\">Auto-Wrapping Single Values in FPS Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";