var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-BC77ED4A-66B5-4958-876D-DBBBBD486A52\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MAXScript Editor - Defining Custom Keyboard Shortcuts\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXScript Editor - Defining Custom Keyboard Shortcuts</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BC77ED4A-66B5-4958-876D-DBBBBD486A52\"></a><div class=\"head\">\n            <h1>MAXScript Editor - Defining Custom Keyboard Shortcuts </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4715\"></a>The <span class=\"char_link\"><a href=\"GUID-F561FC1E-CFF8-4FF6-874C-95EC4B9CD2CD.htm\">Tabbed MAXScript Editor</a></span> introduced in <em class=\"strong\">3ds Max 2008 </em>lets you define your own custom keyboard shortcuts in addition to the hard-coded shortcuts\n            listed in the topic <span class=\"char_link\"><a href=\"GUID-B79B2059-FEAA-4939-8C83-7A04A53FBCE7.htm\">MAXScript Editor - Keyboard Shortcuts</a></span> \n         </p>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4717\"></a> \n            <h2><a name=\"GUID-5DC897A4-D35D-413E-8887-11C6376623EA\"></a> <em class=\"strong\">Definition:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4718\"></a>Custom keyboard shortcuts can be defined in the file <em class=\"strong\">MXS_Editor.properties </em>which is easily accessible via the<em class=\"strong\"> Tools &gt; Open Global Options File </em>menu item. See <span class=\"char_link\"><a href=\"GUID-9014954D-C25C-45B5-BD9C-19260B852185.htm\">MAXScript Editor - Properties File Settings</a></span> for all options. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3513\"></a> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC471A\"></a>Scroll down and locate the section remarked as \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63C6\"></a><pre># User defined key commands</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC471C\"></a>This section contains some existing keyboard shortcut definitions. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC471D\"></a> <em class=\"strong\">The definition starts with</em> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63C5\"></a><pre>user.shortcuts=\\</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC471F\"></a>and is a \'|\' delimited list of keys and the commands they produce. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4720\"></a>To place each command on a new line, add a backslash \\ at the end of each line. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4722\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4723\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63C4\"></a><pre>user.shortcuts=\\\nCtrl+Shift+V|IDM_PASTEANDDOWN|\\\nCtrl+PageUp|IDM_PREVFILE|\\\nCtrl+PageDown|IDM_NEXTFILE|</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC472B\"></a>The commands are either strings or numeric IDs - see <span class=\"char_link\"><a href=\"GUID-2F696A25-6854-4A9F-8E71-5EB81816D51E.htm\">List of Editor Key Commands</a></span> and <span class=\"char_link\"><a href=\"GUID-CA89F654-31EC-4F3C-8269-F11FCA167038.htm\">List of Editor Menu Commands</a></span>. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC472C\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC472E\"></a>Numeric IDs above 2000 are Scintilla commands and are sent to the focussed pane. \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4730\"></a>Named IDs and numeric IDs below 2000 are SciTE menu commands. \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4732\"></a>The modifier keys are <span class=\"keyboardEntry\">Ctrl</span>, <span class=\"keyboardEntry\">Shift</span>, and <span class=\"keyboardEntry\">Alt</span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4734\"></a>The named keys are <em class=\"strong\">Left</em>, <em class=\"strong\">Right</em>, <em class=\"strong\">Up</em>, <em class=\"strong\">Down</em>, <em class=\"strong\">Insert</em>, <em class=\"strong\">End</em>, <em class=\"strong\">Home</em>, <em class=\"strong\">Enter</em>, <em class=\"strong\">Space</em>, <em class=\"strong\">Tab</em>, <em class=\"strong\">KeypadPlus</em>, <em class=\"strong\">KeypadMinus</em>, <em class=\"strong\">KeypadMultiply</em>, <em class=\"strong\">KeypadDivide</em>, <em class=\"strong\">Escape</em>, <em class=\"strong\">Delete</em>, <em class=\"strong\">PageUp</em>, <em class=\"strong\">PageDown</em>, <em class=\"strong\">Slash</em>, <em class=\"strong\">Question</em>, <em class=\"strong\">Equal</em>, <em class=\"strong\">Win</em>. \n                     </p> \n                  </li>\n               </ul> \n               <div><a name=\"WS3ED54CBA79FF2E3D-7658A5A12B78356069-72BF\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Changes to user-defined keyboard shortcut definitions will become active <em class=\"strong\">only </em>after a restart of <em class=\"strong\">3ds Max</em>! \n                  </div>\n               </div> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4739\"></a> \n            <h2><a name=\"GUID-6FA30CB9-EA1B-4CFF-8EF4-3370545CF609\"></a> <em class=\"strong\">Adding a new user-defined keyboard shortcut</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC473A\"></a>Let’s assume you want to add a keyboard shortcut for the editor feature \"Clear All\n               Bookmarks\". This feature is listed in the Search menu but does not have a keyboard\n               shortcut assigned. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC473B\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC473D\"></a>Locate in the <span class=\"char_link\"><a href=\"GUID-CA89F654-31EC-4F3C-8269-F11FCA167038.htm\">List of Named IDs</a></span> the one called \"<em class=\"strong\">IDM_BOOKMARK_CLEARALL</em>\". Since all existing Bookmark-related shortcuts use the Function Key <em class=\"strong\"> <span class=\"keyboardEntry\">F2</span> </em>, let\'s assign the keyboard shortcut <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">SHIFT</span>+<span class=\"keyboardEntry\">F2 </span></em>to the Clear All Bookmarks feature by adding to the user.shortcuts definition in the\n                     <em class=\"strong\">MXS_Editor.properties </em>file: \n                  </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC473F\"></a><div class=\"table-ruled\">\n                     <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                        <colgroup>\n                           <col width=\"100%\">\n                        </colgroup>\n                        <tr class=\"ruled-odd-row\">\n                           <td class=\"table-body\"> \n                              <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63C3\"></a><pre>user.shortcuts=\\\nCtrl+Shift+V|IDM_PASTEANDDOWN|\\\nCtrl+PageUp|IDM_PREVFILE|\\\nCtrl+PageDown|IDM_NEXTFILE|<em class=\"codeEmphasisStrong\">\\</em> <em class=\"codeEmphasisStrong\">Ctrl+Shift+F2|IDM_BOOKMARK_CLEARALL|</em></pre></div> \n                           </td>\n                        </tr>\n                     </table>\n                  </div> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC474A\"></a>Press <em class=\"strong\"><span class=\"keyboardEntry\">CTRL</span>+<span class=\"keyboardEntry\">S</span></em> to save the <em class=\"strong\">MXS_Editor.properties </em>file. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC474C\"></a>Restart <em class=\"strong\">3ds Max</em>. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC474E\"></a>Open the Editor, load a script file and set several bookmarks using <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">F2</span></em>. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4750\"></a>Hold down <em class=\"strong\"> <span class=\"keyboardEntry\">Ctrl</span> </em> and<em class=\"strong\"> <span class=\"keyboardEntry\">SHIFT</span> </em>and press <em class=\"strong\"> <span class=\"keyboardEntry\">F2</span> </em>- all bookmarks will be cleared! \n                  </p> \n               </li>\n            </ul> \n         </div><a name=\"TABLE_F2C067EDE2D14294926EE6CD6D33C647\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"2.9638411381149967%\">\n                  <col width=\"54.386484884410194%\">\n                  <col width=\"42.649673977474805%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\" colspan=\"2\"> <a name=\"P_F0FC9D20517F446FBC6D74CAC1B5F7AA\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_B48C982DB5964741B110FBF9538076C4\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">MAXScript Editor - Quick Navigation</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";