var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-BCAFBD54-CE0D-40D0-8424-99E1FE1518CC\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>BooleanClass Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BCAFBD54-CE0D-40D0-8424-99E1FE1518CC\"></a><div class=\"head\">\n            <h1>BooleanClass Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B2A\"></a>The \n            		<em class=\"strong\">BooleanClass</em> class defines the characteristics of values that can only have one of two states.\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B2B\"></a> <em class=\"strong\">Literals</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FC4\"></a><pre><em class=\"codeEmphasisStrong\">true</em> <em class=\"codeEmphasisStrong\">false</em> <em class=\"codeEmphasisStrong\">on</em> --equivalent to true\n<em class=\"codeEmphasisStrong\">off</em> --equivalent to false\n\"true\" <em class=\"codeEmphasisStrong\">as booleanClass</em>\n\"false\" <em class=\"codeEmphasisStrong\">as booleanClass</em>\n\"on\" <em class=\"codeEmphasisStrong\">as booleanClass</em>\n\"off\" <em class=\"codeEmphasisStrong\">as booleanClass</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B34\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FC3\"></a><pre><em class=\"codeEmphasisStrong\">not</em> &lt;boolean&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B36\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if boolean=<span class=\"code\"> <em class=\"strong\">false</em> </span>, \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> if boolean=<span class=\"code\"> <em class=\"strong\">true</em> </span> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FC2\"></a><pre>&lt;boolean&gt; <em class=\"codeEmphasisStrong\">and</em> &lt;boolean&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B39\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if both boolean values are \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FC1\"></a><pre>&lt;boolean&gt; <em class=\"codeEmphasisStrong\">or</em> &lt;boolean&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B3C\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> if either boolean value is \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61B1\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B40\"></a>The boolean \n                  		  <span class=\"code\"> <em class=\"strong\">and</em> </span> and \n                  		  <span class=\"code\"> <em class=\"strong\">or</em> </span> evaluations are non-strict. This means that only the first boolean might be evaluated\n                  to determine the overall result: \n                  		\n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87B41\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B43\"></a>If the first operand is \n                        				<span class=\"code\"> <em class=\"strong\">false</em> </span> in an \n                        				<span class=\"code\"> <em class=\"strong\">and</em> </span> expression, the result \n                        				<span class=\"code\"> <em class=\"strong\">must</em> </span> be false, so the second operand is not evaluated. \n                        			 \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B45\"></a>If the first operand is \n                        				<span class=\"code\"> <em class=\"strong\">true</em> </span> in an \n                        				<span class=\"code\"> <em class=\"strong\">or</em> </span> expression, the result \n                        				<em class=\"strong\">must</em> be \n                        				<span class=\"code\"> <em class=\"strong\">true</em> </span>, so the second operand is not evaluated. \n                        			 \n                     </p> \n                  </li>\n               </ul> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B46\"></a>This saves execution time and enables useful shorthand notation. For example, if you\n                  want to calculate \n                  		  <span class=\"code\"> <em class=\"strong\">\'sin a\'</em> </span> and if the value of variable \n                  		  <span class=\"code\"> <em class=\"strong\">\'a\'</em> </span> is not \n                  		  <span class=\"code\"> <em class=\"strong\">undefined</em> </span>, you can use the example below: \n                  		\n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FC0\"></a><pre>\nif a != undefined and sin a &gt; 0 then...\n</pre></div> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B4B\"></a>The following script shows the use of various literals and operators of the BooleanClass\n            class. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B4C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87B4D\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FBF\"></a><pre>\n-- boolean test bed\nbool1=true-- set variables to boolean literals\nbool2=on\nif bool1 and bool2 do print \"booleans are equal\"-- compare the booleans\n-- define an \"exclusive or\" function\n-- returns true if only one of the\n-- inputs is true\nfn xor b1 b2 = (not (b1 and b2)) and (b1 or b2)\nxor false false-- evaluate 4 combinations of inputs to xor\nxor false true\nxor true false\nxor true true\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87B5C\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FBE\"></a><pre>\ntrue-- result of line 2\ntrue-- result of line 3\n\"booleans are equal\"-- output from line 4\n\"booleans are equal\"-- result of line 4\nxor()-- function definition\nfalse-- result of line 8\ntrue-- result of line 9\ntrue-- result of line 10\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><em class=\"strong\">Comparing / Coercing to Integers</em> \n         </p>\n         <p> Available in \n            		<em class=\"strong\">3ds Max 2018 and higher:</em><span class=\"code\">BooleanClass</span> values can be compared to \n            		<span class=\"code\">Integer</span> values, where 0 is equivalent to false, and all other values are true. \n            	 \n         </p><a name=\"TABLE_AAFE98A8D0BB4596A0017194F6898E60\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <p class=\"table-body\"> <em class=\"strong\">Example:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\n0 as BooleanClass --&gt; false\n1 as BooleanClass --&gt; true\ntrue as Integer --&gt; 1\nfalse as Integer --&gt; 0\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";