var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-BDAD17C6-AC43-4297-8AD3-69F0920ABC59\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"showTextureMap() function\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>showTextureMap() function</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BDAD17C6-AC43-4297-8AD3-69F0920ABC59\"></a><div class=\"head\">\n            <h1>showTextureMap() function </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-392C\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-392B\"></a> The \n               		  <span class=\"code\"> <em class=\"strong\">showTextureMap()</em> </span> function provides control over both material and map level texture showing in the\n               viewport. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3929\"></a> <em class=\"strong\">The form is: \n                  		  </em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DB7\"></a><pre><em class=\"codeEmphasisStrong\">showTextureMap</em> &lt;material&gt; [&lt;texmap&gt;|&lt;material&gt;] &lt;boolean&gt; 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3927\"></a>If the optional &lt;texmap&gt; or &lt;material&gt; is not specified, Show Map in Viewports is\n               set for the argument 1 material to the &lt;boolean&gt; argument. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3926\"></a>If the optional &lt;texmap&gt; is specified, it will be searched for in the argument 1 material.\n               It must be a direct subtexture of the supplied argument 1 material. Its show-in-viewport\n               state will be set on or off according to the &lt;boolean&gt; argument. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3925\"></a>If the optional material is specified, it will be searched for in the argument 1 material.\n               Its show-in-viewport state will be set on or off according to the &lt;boolean&gt; argument.\n               \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3924\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3923\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DB6\"></a><pre>\nshowTextureMap $foo.material on\nshowTextureMap $foo.material $foo.material.diffusemap off\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-7581\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-A0EB95C7-BFA5-45A3-8627-1F08895E9CB6\"></a>Mapping coordinates aren\'t explicitly enabled for all objects at creation time. When\n                     a script is run in the Listener, using \'showTextureMap\' is indirectly turning mapping\n                     coordinates on. This happens during the scene redraw which happens after each line\n                     is executed, if needed. If a script is run from a script editor, or if you put parenthesis\n                     around a script, no scene redraw is performed until the entire script is run. Since\n                     no redraw is performed, no mapping coordinates exist on the object when the script\n                     tries to access them. Solutions: explicitly perform a scene redraw [redrawViews()]\n                     after \'showTextureMap\', or explicitly turn on mapping coordinates for the object.\n                     \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3918\"></a>The following methods introduced in \n               		  <em class=\"strong\">3ds Max 2008</em> provide control over the state of the Hardware Mode Show Map In Viewports available\n               as a flyout option to the regular Show Map In Viewports icon: \n               		\n            </p> \n            <p><a name=\"GUID-505AFE1C-7178-490E-96B4-A75D97004C58\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DB5\"></a><pre><em class=\"codeEmphasisStrong\">enableHardwareMaterial</em> &lt;material&gt; [&lt;texmap&gt;|&lt;material&gt;] &lt;boolean&gt;   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3915\"></a>This method allows control over the state of the flyout at both material and map level.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3914\"></a>When set to true, the flyout will be switched to Hardware mode (magenta icon). \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3913\"></a>When set to false, the flyout will be switched to Software mode (blue icon) \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3912\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-205E793C-3A85-4890-B1AE-496D5AD1A806-low.gif\"></div> \n            <p><a name=\"GUID-CCB4BF40-EEC4-4A1F-BEEE-DFE963F90D18\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DB4\"></a><pre><em class=\"codeEmphasisStrong\">showHWTextureMap &lt;material&gt; [&lt;texmap&gt;|&lt;material&gt;] &lt;boolean&gt;</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-390F\"></a>This method provides control over the state of the Show Map In Viewport icon at both\n               material and map level. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-390E\"></a>When set to true, the icon will be pressed. When set to false, it will be depressed.\n               \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-390D\"></a>The flyout must be in hardware mode when using this method - see the enable Hardware\n               Material method described above. If it is not, the icon will be pressed but no maps\n               will be displayed in the viewport. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-390C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-390B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6DB3\"></a><pre>\n-- Apply a checkered map to a sphere.\ns = Sphere()\ns.mapcoords = on\ns.material = Standard()\ns.material.diffuseMap = Checker()\n\n-- Show the texture map.\nenableHardwareMaterial s.material true\nshowHWTextureMap s.material true\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3902\"></a> <span class=\"char_link\"><a href=\"GUID-E1FA38D3-D03C-4A33-9C5A-C2DA3B21EFAF.htm\">Material Editor</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3901\"></a> <span class=\"char_link\"><a href=\"GUID-43EC5EED-F275-4325-8D99-819C51C11380.htm\">TextureMap Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3900\"></a> <span class=\"char_link\"><a href=\"GUID-E1FA38D3-D03C-4A33-9C5A-C2DA3B21EFAF.htm#WS73099CC142F487553098682E12AC2FC2BC7-6DB9\">Accessing The Material Editor Active Slot</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-38FF\"></a> <span class=\"char_link\"><a href=\"GUID-0763253E-5392-4078-9B0B-E6CA3ACD32A2.htm\">Interface: medit</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";