var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-BFE0D012-E8F6-4903-B3C5-ABDA06F4F18C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Create Custom Mesh Object</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BFE0D012-E8F6-4903-B3C5-ABDA06F4F18C\"></a><div class=\"head\">\n            <h1>How To ... Create Custom Mesh Object </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CA1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CA2\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; Create Custom Mesh Object \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CA4\"></a>MAXScript lets you create editable mesh objects by supplying lists of vertices and\n            faces to the mesh constructor. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CA5\"></a>This topic shows how to write a simple mesh-generation script to create a circular\n            2D mesh object, similar to a sun symbol. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CA6\"></a> <em class=\"strong\">Related Topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CA7\"></a> <span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm\">Working with Arrays</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CA8\"></a> <span class=\"char_link\"><a href=\"GUID-0532C071-4401-4846-8450-3DA5510A3883.htm\">Creating Editable Mesh objects</a></span> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CAA\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CAB\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CAC\"></a><p class=\"table-body\">Define the basic parameters of the mesh object </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CAD\"></a><p class=\"table-body\">Generate all vertices of the mesh and store in an array </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CAE\"></a><p class=\"table-body\">Generate all faces by indexing the vertices and store in another array </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CAF\"></a><p class=\"table-body\">Call the mesh constructor with the two arrays as parameters. </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CB1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CB2\"></a><p class=\"table-body\"> <em class=\"strong\">MAXSCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6569\"></a><pre>\nradius1 = 100\nradius2 = 10\nwidth = 10\n&nbsp;\nvert_array = #()\nface_array = #()\n&nbsp;\nvert_count = 0\nnum_faces = 10\n&nbsp;\nfor a = 0 to (360-(360/num_faces)) by 360/num_faces do\n(\nv1 = [radius1*cos(a+width),radius1*sin(a+width),0]\nv2 = [radius1*cos(a-width),radius1*sin(a-width),0]\nv3 = [radius2*cos(a),radius2*sin(a),0]\nappend vert_array v1\nappend vert_array v2\nappend vert_array v3\n&nbsp;\nappend face_array [vert_count+1,vert_count+3,vert_count+2]\nvert_count += 3\n)\n&nbsp;\nm = mesh vertices:vert_array faces:face_array\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CCE\"></a> \n            <h2><a name=\"GUID-A08CA3AA-35E9-4EB8-A6A3-A8D94AE100D2\"></a> <em class=\"strong\">Step-By-Step:</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6568\"></a><pre><em class=\"codeEmphasisStrong\">radius1 = 100\nradius2 = 10\nwidth = 10</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CD2\"></a>First, we need some variables to define the geometry. The circular object has an inner\n               and outer radius and a width value defining the outer size of the ray. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6567\"></a><pre><em class=\"codeEmphasisStrong\">vert_array = #()\nface_array = #()</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CD5\"></a>The two arrays store the vertex coordinates and the face definitions. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CD6\"></a> <span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm\">Array Values</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6566\"></a><pre><em class=\"codeEmphasisStrong\">vert_count = 0</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CD8\"></a>The user variable <span class=\"code\"> <em class=\"strong\">vert_count</em> </span> is set to 0 and will be incremented while creating the faces of the mesh. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6565\"></a><pre><em class=\"codeEmphasisStrong\">num_faces = 10</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CDA\"></a>The number of steps is related to the number of faces to create. It is used as step\n               in the following loop. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6564\"></a><pre><em class=\"codeEmphasisStrong\"> for a = 0 to (360-(360/num_faces)) by 360/num_faces do\n(</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CDD\"></a>The <span class=\"code\"> <em class=\"strong\">for a</em> </span> loop counts from 0 to 360 (degrees), minus one step to prevent overlap, with a user-defined\n               step provided by the <span class=\"code\"> <em class=\"strong\">num_faces</em> </span> variable. This variable defines the number of \"rays\" in the mesh. For example, to\n               get 10 rays we need 360/10 = 36 degrees per ray. The <span class=\"code\"> <em class=\"strong\">a</em> </span> value will be incremented nine times by the value of 36 to make a full turn in degrees.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CDE\"></a> <span class=\"char_link\"><a href=\"GUID-378F3155-6001-43A7-9E0D-6D98E0823F6F.htm\">For Loop</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6563\"></a><pre><em class=\"codeEmphasisStrong\">v1 = [radius1*cos(a+width),radius1*sin(a+width),0]\nv2 = [radius1*cos(a-width),radius1*sin(a-width),0]\nv3 = [radius2*cos(a),radius2*sin(a),0]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CE2\"></a>Now we will define the 3 vertices for a single face. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CE3\"></a>The Vertices v1 and v2 are at the outer side of the object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CE4\"></a>The Vertex v3 is closer to the center (at distance equal to radius2). \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CE5\"></a>When radius3 is 0, all v3 vertices of all faces are coincident at the center. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CE6\"></a>We use the equation of the circle which is: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CE7\"></a>X = CenterX + Radius * Cos(A); Y = CenterY + Radius * Sin(A); Z = 0.0 \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CE8\"></a>where A is an angle changing from 0 to 2*Pi. In our case, CenterX and CenterY are\n               0.0. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CE9\"></a>By adding and subtracting the width value to/from the angle <span class=\"code\"> <em class=\"strong\">a</em> </span>, we get the outer two vertices offset from the actual angle used by the third vertex.\n               The third coordinate Z is always 0 in our case – the mesh will reside on the ground\n               XY plane. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6562\"></a><pre><em class=\"codeEmphasisStrong\">append vert_array v1\nappend vert_array v2\nappend vert_array v3</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CED\"></a>We add all 3 new vertices to the vertex array. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CEE\"></a> <span class=\"char_link\"><a href=\"GUID-A5B54C67-BFDD-45C0-9D6B-E6869817282A.htm\">Array Values</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6561\"></a><pre><em class=\"codeEmphasisStrong\">append face_array [vert_count+1,vert_count+3,vert_count+2]</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CF0\"></a>Now we can store a face in the face array, listing the 3 vertex indices as a Point3\n               value in Counter-Clockwise order. This will create the face with a normal pointing\n               up. Since <span class=\"code\"> <em class=\"strong\">vert_count</em> </span> is still 3 less than the number of vertices in the <span class=\"code\"> <em class=\"strong\">vert_array</em> </span>, we can add 1, 2 and 3 to its current value to get the correct indices needed for\n               the face definition. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6560\"></a><pre><em class=\"codeEmphasisStrong\">vert_count += 3</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CF2\"></a>Now we increase the vertex counter by 3. Next face definition will use the correct\n               indices again. The same could be expressed as <span class=\"code\"> <em class=\"strong\">vert_count = vert_count + 3</em> </span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-655F\"></a><pre><em class=\"codeEmphasisStrong\">)\nm = mesh vertices:vert_array faces:face_array</em></pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CF5\"></a>Now we can create a new Editable mesh by calling the <span class=\"code\"> <em class=\"strong\">mesh</em> </span> constructor and supplying the vertex and face arrays. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CF6\"></a> <span class=\"char_link\"><a href=\"GUID-0532C071-4401-4846-8450-3DA5510A3883.htm\">Editable_Mesh : GeometryClass and TriMesh : Value</a></span> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CF8\"></a> \n            <h2><a name=\"GUID-BA291F4C-74F4-44FC-83A9-BD0BEA021609\"></a> <em class=\"strong\">Using the Script</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CF9\"></a>If you evaluate the script now, a new mesh object will appear in the scene. Changing\n               the initial radius and width values lets you create multiple variations of the mesh.\n               \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CFA\"></a> \n            <h2><a name=\"GUID-9B2B1C65-2CF4-4525-8091-A9FCF048BB37\"></a> <em class=\"strong\">Where to go from here</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CFB\"></a>This was just a sketch of a mesh-creating script. In a second step, we will enhance\n               this code to generate a real geometry plug-in script operating interactively from\n               within the Create tab. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CFC\"></a> <span class=\"char_link\"><a href=\"GUID-EC33589D-822A-4E79-9682-185EC5DBAB9F.htm\">How To ... Create Scripted Geometry Plug-in</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CFD\"></a>Possible things to try yourself would be assigning different material IDs to the separate\n               faces, assigning UVW coordinates to the mesh etc. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CFE\"></a> <em class=\"strong\">Back to</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1CFF\"></a> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">\"How To\" Tutorials Index Page</a></span> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";