var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-C0641D37-1F76-453C-B1F1-C11D6861B74C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Patches\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>patches</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C0641D37-1F76-453C-B1F1-C11D6861B74C\"></a><div class=\"head\">\n            <h1>patches </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CCB\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CCC\"></a> A patch function package containing a large number of functions for creating, modifying,\n               and accessing patch objects has been introduced in <em class=\"strong\">3ds Max 4</em>. The sub-object selection system in MAXScript has also been extended to cover patch\n               objects. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CCE\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CD0\"></a>The Editable Patch object in MAX was called \'Patch\' in MAXScript. It has been renamed\n                     to \'Editable_Patch\' to be consistent with Editable_Mesh and Editable_Poly, and to\n                     allow the new patch function package to be named \'patch\'. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CD2\"></a>The MAXScript sub-object selection system has been extended to work with Editable\n                     Patch objects. This means that all the MAXScript VertexSelection, FaceSelection, and\n                     EdgeSelection properties and operations now work with patch objects. The \'face\' sub-object\n                     selections in this system correspond to the \'patch\' sub-object level when applied\n                     to patches. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CD4\"></a>The Patch functions. All the functions in this package take either a scene node containing\n                     an Editable Patch object or an Editable Patch base object as the first argument. QuadPatch\n                     and TriPatch objects need to be converted to Editable Patches for the Patch functions\n                     to be applicable. For example, when using the <span class=\"code\"> <em class=\"strong\">convertTo</em> </span> $foo Editable_Patch. \n                  </p> \n               </li>\n            </ul> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CD5\"></a>To create a patch object from scratch, create an Editable_Patch scene object to create\n               an empty patch object and use the geometry &amp; topology creation functions below to\n               fill the patch out, then use the <span class=\"code\"> <em class=\"strong\">patch.update</em> </span>() function to complete the construction. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1AA6\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Any set of changes to a patch object using the following functions do not take effect\n                  fully until the <span class=\"code\"> <em class=\"strong\">patch.update</em> </span>() function is called on it. This makes construction substantially more efficient,\n                  but can leave a patch in an unstable state if the script that contains the changing\n                  code finishes before calling patch<span class=\"code\"> <em class=\"strong\">.update</em> </span> on it, which might result in a MAX crash. \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CDA\"></a> <em class=\"strong\">Functions:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CDB\"></a>The following functions are used to get and set the overall geometry of the patch.\n               Supply <span class=\"code\"> <em class=\"strong\">keep:true</em> </span> to the setNumXXX functions for them to retain existing vertex/vector/patch/edge data,\n               defaults to false, which cleans out the geometry. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CDC\"></a> <em class=\"strong\">The functions are largely direct calls to the methods of the same name on the MAX\n                  SDK class PatchMesh. See the SDK Help file Advanced Topic \"Working with Patches\",\n                  and the documentation for the main Patch system classes for more detailed information.</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5414\"></a><pre>&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getNumVerts</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.setNumVerts </em>&lt;obj&gt; &lt;num&gt; [<em class=\"codeEmphasisStrong\">keep</em>:&lt;boolean&gt;] \n\n&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getNumVecs</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.setNumVecs</em> &lt;obj&gt; &lt;num&gt; [<em class=\"codeEmphasisStrong\">keep</em>:&lt;boolean&gt;] \n\n&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getNumPatches</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.setNumPatches </em>&lt;obj&gt; &lt;num&gt; [<em class=\"codeEmphasisStrong\">keep</em>:&lt;boolean&gt;] \n\n&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getNumEdges</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.setNumEdges </em>&lt;obj&gt; &lt;num&gt; [<em class=\"codeEmphasisStrong\">keep</em>:&lt;boolean&gt;] </pre></div> \n            <p><a name=\"GUID-DB43721A-2BA7-464D-947C-D5D767E4820F\"></a></p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CE8\"></a>The following functions get and set individual vertex and vector handle locations.\n               The vertex and vector coordinates are interpreted in MAXScript\'s current working coordinate\n               context. \n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1AA5\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"GUID-A87E8A19-D867-4596-9F1A-CF7E1A791581\"></a>Consistent with the rest of MAXScript, all vertex/patch/vector/edge indexes start\n                     numbering at 1. \n                  </p> \n               </div>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5413\"></a><pre>&lt;point3&gt; <em class=\"codeEmphasisStrong\">patch.getVert</em> &lt;obj&gt; &lt;index&gt;\n<em class=\"codeEmphasisStrong\">patch.setVert</em> &lt;obj&gt; &lt;index&gt; &lt;point3&gt;\n\n&lt;point3&gt; <em class=\"codeEmphasisStrong\">patch.getVec </em>&lt;obj&gt; &lt;index&gt;\n<em class=\"codeEmphasisStrong\">patch.setVec</em> &lt;obj&gt; &lt;index&gt; &lt;point3&gt;</pre></div> \n            <p><a name=\"GUID-FF77583C-37D3-4F70-9B48-A7922D5ECAE8\"></a></p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CF3\"></a>The following two functions are the main mechanism for creating individual patches\n               in the patch mesh: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5412\"></a><pre><em class=\"codeEmphasisStrong\">patch</em>.<em class=\"codeEmphasisStrong\">makeQuadPatch </em>&lt;obj&gt; &lt;index&gt; &lt;va&gt; &lt;vab&gt; &lt;vba&gt; &lt;vb&gt; &lt;vbc&gt; &lt;vcb&gt; &lt;vc&gt; &lt;vcd&gt; &lt;vdc&gt; &lt;vd&gt; &lt;vda&gt; &lt;vad&gt; &lt;i1&gt; &lt;i2&gt; &lt;i3&gt; &lt;i4&gt; &lt;sm&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1CF5\"></a>Where: <a name=\"UL_5B808D12C12843778999A60BC3C7984F\"></a><ul>\n                  <li><span class=\"code\"> <em class=\"strong\">index</em> </span>= The index of the patch to create (0&gt; = index &lt; numPatches). \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">va</em> </span>= The first vertex. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vab</em> </span>= Vector ab. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vba</em> </span>= Vector ba. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vb</em> </span>= The second vertex. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vbc</em> </span>= Vector bc. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vcb</em> </span>= Vector cb. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vc</em> </span>= The third vertex. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vcd</em> </span>= Vector cd. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vdc</em> </span>= Vector dc. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vd</em> </span>= The fourth vertex. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vda</em> </span>= Vector da. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vad</em> </span>= Vector ad. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">i1</em> </span>= Interior 1. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">i2</em> </span>= Interior 2. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">i3</em> </span>= Interior 3. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">i4</em> </span>= Interior 4. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">sm</em> </span>= The smoothing group mask \n                  </li>\n               </ul> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5410\"></a><pre><em class=\"codeEmphasisStrong\">patch.makeTriPatch</em> &lt;obj&gt; &lt;index&gt; &lt;va&gt; &lt;vab&gt; &lt;vba&gt; &lt;vb&gt; &lt;vbc&gt; &lt;vcb&gt; &lt;vc&gt; &lt;vca&gt; &lt;vac&gt; &lt;i1&gt; &lt;i2&gt; &lt;i3&gt; &lt;sm&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D09\"></a>Where: <a name=\"UL_43FCC16E71AA4142A1B6446CD3127C79\"></a><ul>\n                  <li><span class=\"code\"> <em class=\"strong\">va</em> </span>= The first vertex. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vab</em> </span>= Vector ab. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vba</em> </span>= Vector ba. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vb</em> </span>= The second vertex. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vbc</em> </span>= Vector bc. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vcb</em> </span>= Vector cb. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vc</em> </span>= The third vertex. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vca</em> </span>= Vector ca. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">vac</em> </span>= Vector ac. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">i1</em> </span>= Interior 1. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">i2</em> </span>= Interior 2. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">i3</em> </span>= Interior 3. \n                  </li>\n                  <li><span class=\"code\"> <em class=\"strong\">sm</em> </span>= The smoothing group mask \n                  </li>\n               </ul> \n            </p> \n            <p><a name=\"GUID-71992642-9075-4F00-A5F6-D03FCAD687E9\"></a></p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D18\"></a>The following function forces all the geometry and topology caches to be rebuilt,\n               change notifications to be sent, and a screen redraw request to be flagged. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D19\"></a>You must call this function after making any changes to a path object before exiting\n               the script. Otherwise, an invalid patch might be passed to MAX, which can cause a\n               crash. The <span class=\"code\"> <em class=\"strong\">patch.update</em> </span>() function is similar to the update() function in mesh object scripting. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-540E\"></a><pre><em class=\"codeEmphasisStrong\">patch.update</em> &lt;obj&gt;</pre></div> \n            <p><a name=\"GUID-795529A3-9ABA-4404-A12F-3CE6C620C307\"></a></p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D1B\"></a>The following functions give access to the topology of an existing patch object. They\n               return either indexes or arrays of indexes of the sub-objects requested. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D1C\"></a> <span class=\"code\"> <em class=\"strong\">getVertVecs()</em> </span> returns an array of the vectors coming out of the specified vertex. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-540D\"></a><pre>&lt;integer_array&gt; <em class=\"codeEmphasisStrong\">patch.getVertVecs</em> &lt;obj&gt; &lt;index&gt;\n&lt;integer_array&gt; <em class=\"codeEmphasisStrong\">patch.getVertPatches</em> &lt;obj&gt; &lt;index&gt;\n&lt;integer_array&gt; <em class=\"codeEmphasisStrong\">patch.getVertEdges</em> &lt;obj&gt; &lt;index&gt;\n&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getVecVert</em> &lt;obj&gt; &lt;index&gt;\n&lt;integer_array&gt; <em class=\"codeEmphasisStrong\">patch.getVecPatches</em> &lt;obj&gt; &lt;index&gt;\n&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getEdgeVert1</em> &lt;obj&gt; &lt;index&gt;\n&lt;integer&gt; <em class=\"codeEmphasisStrong\"> patch.getEdgeVert2</em> &lt;obj&gt; &lt;index&gt;\n&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getEdgeVec12</em> &lt;obj&gt; &lt;index&gt;\n&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getEdgeVec21</em> &lt;obj&gt; &lt;index&gt;</pre></div> \n            <p><a name=\"GUID-421EFC14-D984-4B35-8909-89568BB3AEA8\"></a></p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D2F\"></a>The following functions access and manipulate the texture mapping information in the\n               patch object: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-540C\"></a><pre>&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getNumMaps</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.setNumMaps </em>&lt;obj&gt; &lt;num&gt; [<em class=\"codeEmphasisStrong\">keep</em>:&lt;bool&gt;]\n\n&lt;boolean&gt; <em class=\"codeEmphasisStrong\">patch.getMapSupport</em> &lt;obj&gt; &lt;map_chan&gt;\n<em class=\"codeEmphasisStrong\">patch.setMapSupport</em> &lt;obj&gt; &lt;map_chan&gt; [<em class=\"codeEmphasisStrong\">init</em>:&lt;boolean&gt;]\n\n&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getNumMapVerts</em> &lt;obj&gt; &lt;map_index&gt;\n<em class=\"codeEmphasisStrong\">patch.setNumMapVerts</em> &lt;obj&gt; &lt;map_chan&gt; &lt;num&gt; [<em class=\"codeEmphasisStrong\">keep</em>:&lt;boolean&gt;]\n\n&lt;point3&gt; <em class=\"codeEmphasisStrong\">patch.getMapVert</em> &lt;obj&gt; &lt;map_chan&gt; &lt;index&gt;\n<em class=\"codeEmphasisStrong\">patch.setMapVert</em> &lt;obj&gt; &lt;map_chan&gt; &lt;index&gt; &lt;point3&gt;\n\n&lt;index_array&gt; <em class=\"codeEmphasisStrong\">patch.getMapPatch</em> &lt;obj&gt; &lt;map_chan&gt; &lt;index&gt;\n<em class=\"codeEmphasisStrong\">patch.setMapPatch</em> &lt;obj&gt; &lt;map_chan&gt; &lt;index&gt; &lt;index_array&gt;\n\n<em class=\"codeEmphasisStrong\">patch.maxMapChannels</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.setNumMapPatches</em> &lt;obj&gt; &lt;map_chan&gt; &lt;num&gt; [<em class=\"codeEmphasisStrong\">keep</em>:&lt;boolean&gt;]</pre></div> \n            <p><a name=\"GUID-678B021E-7C22-458B-8CBD-4C69DDB14F03\"></a></p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D43\"></a>The following functions get and set the material ID for the patch object as a whole\n               or for individual patches: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-540B\"></a><pre>&lt;integer&gt; <em class=\"codeEmphasisStrong\">patch.getMtlID</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.setMtlID</em> &lt;obj&gt; &lt;mtl_id&gt;\n\n&lt;integer&gt;<em class=\"codeEmphasisStrong\">patch.getPatchMtlID</em> &lt;obj&gt; &lt;index&gt;\n<em class=\"codeEmphasisStrong\">patch.setPatchMtlID</em> &lt;obj&gt; &lt;patch_index&gt; &lt;mtl_id&gt;</pre></div> \n            <p><a name=\"GUID-8CB4A8D8-838B-4E34-A597-41DBFAE68156\"></a></p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D4A\"></a>The following functions access and control the viewport and renderer tessellation\n               and visibility: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-540A\"></a><pre><em class=\"codeEmphasisStrong\">patch.setMeshSteps</em> &lt;obj&gt; &lt;steps&gt;\n<em class=\"codeEmphasisStrong\">patch.getMeshSteps</em> &lt;obj&gt;\n\n<em class=\"codeEmphasisStrong\">patch.setMeshStepsRender</em> &lt;obj&gt; &lt;steps&gt;\n<em class=\"codeEmphasisStrong\">patch.getMeshStepsRender</em> &lt;obj&gt;\n\n<em class=\"codeEmphasisStrong\">patch.setShowInterior</em> &lt;obj&gt; &lt;bool&gt;\n<em class=\"codeEmphasisStrong\">patch.getShowInterior</em> &lt;obj&gt;\n\n<em class=\"codeEmphasisStrong\">patch.setAdaptive</em> &lt;obj&gt; &lt;bool&gt;\n<em class=\"codeEmphasisStrong\">patch.getAdaptive</em> &lt;obj&gt;</pre></div> \n            <p><a name=\"GUID-B032F9DD-AFF3-4471-B0A0-82D4415E958E\"></a></p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D57\"></a>The following functions access the topology information for the specified sub-object:\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5409\"></a><pre>&lt;integer_array&gt; <em class=\"codeEmphasisStrong\"> patch.getEdges</em> &lt;obj&gt; &lt;v1&gt; [&lt;v2&gt;]\n&lt;integer_array&gt; <em class=\"codeEmphasisStrong\">patch.getPatches</em> &lt;obj&gt; &lt;v1&gt; [&lt;v2&gt;]\n&lt;integer_array&gt; <em class=\"codeEmphasisStrong\">patch.getVectors </em>&lt;obj&gt; &lt;vert&gt;</pre></div> \n            <p><a name=\"GUID-124AD14D-77FB-4601-8415-1AA8E5B0EE8A\"></a></p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D5C\"></a>The following function transforms all the vertices and vectors in the patch object\n               by the given matrix. This transform happens in the object local space. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5408\"></a><pre><em class=\"codeEmphasisStrong\">patch.transform</em> &lt;obj&gt; &lt;matrix3&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D5F\"></a>The following functions perform various high-level operations on a patch object: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5407\"></a><pre><em class=\"codeEmphasisStrong\">patch.weldVerts</em> &lt;obj&gt; &lt;threshold&gt; &lt;weldIdentical_bool&gt; &lt;startVert&gt;\n<em class=\"codeEmphasisStrong\">patch.weld2Verts</em> &lt;obj&gt; &lt;v1&gt; &lt;v2&gt;\n<em class=\"codeEmphasisStrong\">patch.weldEdges</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.deletePatchParts</em> &lt;obj&gt; &lt;del_vert_bitarray&gt; &lt;del_patches_bitarray&gt;\n<em class=\"codeEmphasisStrong\">patch.clonePatchParts</em> &lt;obj&gt; &lt;patch_bit_array&gt;\n<em class=\"codeEmphasisStrong\">patch.subdivideEdges</em> &lt;obj&gt; &lt;propagate&gt;\n<em class=\"codeEmphasisStrong\">patch.subdividePatches</em> &lt;obj&gt; &lt;propagate&gt;\n<em class=\"codeEmphasisStrong\">patch.addTriPatch</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.addQuadPatch</em> &lt;obj&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D6A\"></a>The following functions get and manipulate surface normal information. Again, normal\n               vectors are given in MAXScript\'s current working coordinate context. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5406\"></a><pre><em class=\"codeEmphasisStrong\">patch.patchNormal</em> &lt;obj&gt; &lt;patch&gt;\n<em class=\"codeEmphasisStrong\">patch.edgeNormal</em> &lt;obj&gt; &lt;edge&gt;\n<em class=\"codeEmphasisStrong\">patch.updatePatchNormals</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.flipPatchNormal</em> &lt;obj&gt; &lt;patch&gt;\n<em class=\"codeEmphasisStrong\">patch.unifyNormals</em> &lt;obj&gt;\n<em class=\"codeEmphasisStrong\">patch.autoSmooth</em> &lt;obj&gt; &lt;angle&gt; &lt;useSel_bool&gt; &lt;preventIndirectSmoothing_bool&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D72\"></a>The following functions access and change the vertex and interior vertex types: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5405\"></a><pre><em class=\"codeEmphasisStrong\">patch.changeVertType</em> &lt;obj&gt; &lt;vert&gt; <em class=\"codeEmphasisStrong\">#corner|#coplanar</em> <em class=\"codeEmphasisStrong\">patch.getVertType</em> &lt;obj&gt; &lt;vert&gt; -&gt;#corneror#coplanar\n\n<em class=\"codeEmphasisStrong\">patch.changePatchInteriorType</em> &lt;obj&gt; &lt;patch&gt; <em class=\"codeEmphasisStrong\">#automatic|#manual</em> <em class=\"codeEmphasisStrong\">patch.getPatchInteriorType</em> &lt;obj&gt; &lt;patch&gt; -&gt;#automaticor#manual</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D78\"></a>The following function returns the current mesh tessellation for the patch object:\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5404\"></a><pre>&lt;mesh value&gt;<em class=\"codeEmphasisStrong\">patch.getMesh</em> &lt;obj&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D7B\"></a>The following functions are used to interpolate individual patch surfaces. A tri-patch\n               interpolation takes u,v,w barycentric coordinates. A quad-patch takes u and c parameters.\n               In both cases, the point returns is given in the current MAXScript working coordinate\n               context. \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5403\"></a><pre>&lt;point3&gt;<em class=\"codeEmphasisStrong\">patch.interpTriPatch</em> &lt;obj&gt; &lt;patch&gt; &lt;u&gt; &lt;v&gt; &lt;w&gt;\n&lt;point3&gt;<em class=\"codeEmphasisStrong\">patch.interpQuadPatch</em> &lt;obj&gt; &lt;patch&gt; &lt;u&gt; &lt;v&gt;</pre></div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D7F\"></a> \n               <h3><a name=\"GUID-18D982D0-93FA-43CD-A9A0-73C00A203A9A\"></a> <em class=\"strong\">SubObject Selection</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D80\"></a>The following methods require a selection to operate on. Using them with out selection\n                  will not give results. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D81\"></a> <em class=\"strong\">subDivideEdges:</em> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5402\"></a><pre>\nQuadpatch lengthsegs:1 widthsegs:1 length:100 width:100 isSelected:on\nconvertTo $ Editable_Patch\n$.selectededges = #{1}\npatch.subdivideEdges $ false\npatch.update $\n</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D87\"></a> <em class=\"strong\">subdividePatches:</em> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5401\"></a><pre>\nQuadpatch lengthsegs:1 widthsegs:1 length:100 width:100 isSelected:on\nconvertTo $ Editable_Patch\n$.selectedfaces = #{1}\npatch.subdividePatches $ false\npatch.update $\n</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D8D\"></a> <em class=\"strong\">addTriPatch/addQuadPatch:</em> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-5400\"></a><pre>\nQuadpatch lengthsegs:1 widthsegs:1 length:100 width:100 isSelected:on\nconvertTo $ Editable_Patch\n$.selectededges = #{1}\npatch.addTriPatch $\npatch.update $\n$.selectededges = #{3}\npatch.addQuadPatch $\npatch.update $\n</pre></div> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D98\"></a> <span class=\"char_link\"><a href=\"GUID-D7D05B08-4D56-41E0-86FA-4CC0CE30201D.htm\">Patch_Select - superclass: modifier</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1D99\"></a> <span class=\"char_link\"><a href=\"GUID-7F382121-B42F-4486-A65B-16CA59434843.htm\">Patch : GeometryClass</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";