var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-C17D0E4B-C408-426B-B300-7E23A0D98515\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Node Transform Properties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C17D0E4B-C408-426B-B300-7E23A0D98515\"></a><div class=\"head\">\n            <h1>Node Transform Properties </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3DDCBAB2212B7835B3AF-7AEF\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3179\"></a>Unless otherwise noted, the following transform properties are always interpreted\n               with respect to the current working coordinate system as defined by the currently\n               active <span class=\"char_link\"><a href=\"GUID-E672728A-EE15-4197-9EDD-487781167B01.htm\">coordsys context</a></span>. The default <span class=\"code\"> <em class=\"strong\">coordsys</em> </span> is <span class=\"code\"> <em class=\"strong\">world</em> </span>. The <span class=\"code\"> <em class=\"strong\">pos</em> </span>, <span class=\"code\"> <em class=\"strong\">rotation</em> </span>, and <span class=\"code\"> <em class=\"strong\">scale</em> </span> properties of a node are aliases to the corresponding subcontroller for the node\'s\n               transform controller. If the transform controller does not have one of these subcontrollers,\n               accessing the corresponding node property will result in an \"Unknown property\" error\n               message. For example, the LookAt controller does not have a Rotation subcontroller,\n               and the IK controller does not have any subcontrollers. You can still access the transform\n               values using the Matrix3 properties of the node\'s <span class=\"code\"> <em class=\"strong\">transform</em> </span> property, for example, <span class=\"code\"> <em class=\"strong\">objpos=obj.transform.translationpart</em> </span>. \n            </p> \n            <p><a name=\"GUID-68289815-E0A2-46B9-A8AE-98F177D0CE65\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CE2\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">transform</em>: Matrix3</pre></div> \n            <p><a name=\"GUID-5B9C9C7E-2A43-4B33-AE0F-B3619193D201\"></a>Can read/write to. \n            </p> \n            <p><a name=\"GUID-D5910D55-D846-4971-B54F-5D28A68BBFAB\"></a>If written to, the Matrix3 value is decomposed into its position, rotation, and scale\n               values. These values are stored in the respective position, rotation, and scale controllers,\n               if those controllers exist and can be written to. \n            </p> \n            <p><a name=\"GUID-5306FDBA-F6EE-416C-96D6-A7F7DD386D39\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CE1\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">pos</em>: Point3 --can use .position synonym throughout\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">pos.controller</em>: Controller --can use .track synonym throughout\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">pos.isAnimated</em>: Boolean, read-only --true if position is animated\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">pos.keys</em>: MAXKeyArray\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">pos.track</em>: Controller --synonym of .pos.controller\n</pre></div> \n            <p><a name=\"GUID-4BB96F1B-D70A-4264-B745-9F5D191ADA5C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CE0\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">rotation</em>: Quat\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">rotation.x_rotation</em>: Float --X rotation of node\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">rotation.y_rotation</em>: Float --Y rotation of node\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">rotation.z_rotation</em>: Float --Z rotation of node\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">rotation.controller</em>: Controller --can use .track synonym throughout\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">rotation.isAnimated</em>: Boolean, read-only --true if rotation is animated\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">rotation.keys</em>: MAXKeyArray\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">rotation.track</em>: Controller --synonym of .rotation.controller</pre></div> \n            <p><a name=\"GUID-20CDEC46-F704-443F-AE4B-AF3660055250\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CDF\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">scale</em>: Point3 -- fraction\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">scale.controller</em>: Controller --can use .track synonym throughout\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">scale.isAnimated</em>: Boolean, read-only --true if scale is animated\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">scale.keys</em>: MAXKeyArray\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">scale.track</em>: Controller --synonym of .scale.controller</pre></div> \n            <p><a name=\"GUID-593ECD16-16E9-4DA7-AB91-C90CFFC8E23C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CDE\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">dir</em>: Point3 --local z-axis direction vector</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-315F\"></a>Rotates node so that the node\'s Z axis points in the specified direction. The node\n               is rotated around its Z axis such that the Y axis points as much as possible in the\n               world -Z direction. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-315E\"></a>Getting and setting <span class=\"code\"> <em class=\"strong\">&lt;node&gt;.dir</em> </span> now respects the current coordinate system. Previously, this property was always\n               in world coordinates. \n            </p> \n            <p><a name=\"GUID-70E76DCA-8858-47D6-99C8-AD5300FF279E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CDD\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">max</em>: Point3, read-only --max coordinates of node\'s bounding box\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">min</em>: Point3, read-only --min coordinates of node\'s bounding box\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">center</em>: Point3 --coordinates of center of node\'s bounding box</pre></div> \n            <p><a name=\"GUID-32B2DB72-1FD3-48FF-85C8-E873C44D1ABA\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CDC\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">transform</em>: Matrix3 --node\'s main transformation matrix</pre></div> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-2AEC\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3156\"></a>Rotation in the internal transformation matrices is <em class=\"strong\">left-handed</em> in contradiction to the <em class=\"strong\">3ds Max</em> user interface and MAXScript. Take care when mixing rotation derived from these matrices\n                     and rotation used in rotation-related functions or from rotation properties. \n                  </p> \n               </div>\n            </div> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CDB\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">pivot</em>: Point3 -- node\'s pivot point position</pre></div> \n            <p><a name=\"GUID-CB80D053-5041-43CD-BB67-AB917E17E4B1\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CDA\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">objectOffsetPos</em>: Point3\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">objectOffsetRot</em>: Quat\n&lt;node&gt;.<em class=\"codeEmphasisStrong\">objectOffsetScale</em>: Point3</pre></div> \n            <p><a name=\"GUID-4C7412A5-30B8-46C7-9FA4-E082BA2E8C6A\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-3150\"></a>Node geometry\'s position, rotation, and scale offset from the pivot in world coordinates.\n               \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CD9\"></a><pre>&lt;node&gt;.<em class=\"codeEmphasisStrong\">objectTransform</em>: Matrix3, read-only</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-314E\"></a>Node geometry\'s offset in world coordinates. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-314D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-314C\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3CD8\"></a><pre>\n--Setting a node\'s rotation relative to world space without\n--messing with its position:\nfn setNodeWorldRotation theNode theRot =\n(\nin coordsys (transmatrix theNode.transform.pos)\ntheNode.rotation = theRot\n)\nb = box isSelected:true \nsetNodeWorldRotation $ (eulerangles 45 45 0)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-313E\"></a> <span class=\"char_link\"><a href=\"GUID-3B001F21-8FE9-4663-A972-E648682A0ACD.htm\">Using Node Transform Properties</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";