var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-C27C77BB-2D47-4535-A5AC-A5949B7D2115\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSCurve - NURBSObject\">\n      <meta name=\"indexterm\" content=\"NURBSChamferCurve - NURBSCurve\">\n      <meta name=\"indexterm\" content=\"getObject()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSChamferCurve : NURBSCurve</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C27C77BB-2D47-4535-A5AC-A5949B7D2115\"></a><div class=\"head\">\n            <h1>NURBSChamferCurve : NURBSCurve </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45CB\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45CA\"></a>   This class defines a dependent Chamfer curve. A Chamfer is a curve that creates a\n               straight line corner between two parent curves. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45C6\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-220C\"></a><pre><em class=\"codeEmphasisStrong\">NURBSChamferCurve</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45C4\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-220B\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45C0\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-220A\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">parent1</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45BE\"></a>The 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent curve by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2209\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">parent1ID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45BB\"></a>The 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2208\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">parent2</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45B8\"></a>The 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent curve by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2207\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">parent2ID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45B5\"></a>The 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2206\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">length1</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45B2\"></a>The length for 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent curve back from the end that defines the beginning of the chamfer. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2205\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">length2</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45AF\"></a>The length for 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent curve back from the end that defines the beginning of the chamfer. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2204\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">flip1</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45AC\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> to use the end of 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent curve; <span class=\"code\"> <em class=\"strong\">false</em> </span> to use the beginning, defaults to <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2203\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">flip2</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45A9\"></a> <span class=\"code\"> <em class=\"strong\">true</em> </span> to use the end of 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent curve; <span class=\"code\"> <em class=\"strong\">false</em> </span> to use the beginning, defaults to <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2202\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">trim1</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45A6\"></a>Sets whether 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent curve is trimmed. <span class=\"code\"> <em class=\"strong\">true</em> </span> if the curve is trimmed; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2201\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">trim2</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45A3\"></a>Sets whether 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent curve is trimmed. <span class=\"code\"> <em class=\"strong\">true</em> </span> if the curve is trimmed; otherwise <span class=\"code\"> <em class=\"strong\">false</em> </span>. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2200\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">flipTrim1</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-45A0\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span> the 1<sup> <span class=\"charspan-emphasis\">st</span> </sup> parent curve is trimmed from the point towards low parameter space. If <span class=\"code\"> <em class=\"strong\">false</em> </span> the curve is trimmed from the point towards high parameter space. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21FF\"></a><pre>&lt;nurbschamfercurve&gt;.<em class=\"codeEmphasisStrong\">flipTrim2</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-459D\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span> the 2<sup> <span class=\"charspan-emphasis\">nd</span> </sup> parent curve is trimmed from the point towards low parameter space. If <span class=\"code\"> <em class=\"strong\">false</em> </span> the curve is trimmed from the point towards high parameter space. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-459A\"></a> <span class=\"char_link\"><a href=\"GUID-8CEABA20-9D21-4ED0-AA95-3749435D2104.htm\">NURBSCurve</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4599\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4598\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";