var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-C30E05F6-0369-4250-9DC3-CB0507E28A06\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Controller\">\n      <meta name=\"indexterm\" content=\"setStartTime() - ik\">\n      <meta name=\"indexterm\" content=\"setIterations() - ik\">\n      <meta name=\"indexterm\" content=\"setEndTime() - ik\">\n      <meta name=\"indexterm\" content=\"Matrix3Controller: MAXWrapper\">\n      <meta name=\"indexterm\" content=\"inverse kinematics controller methods\">\n      <meta name=\"indexterm\" content=\"IK_ControllerMatrix3Controller - Matrix3Controller\">\n      <meta name=\"indexterm\" content=\"IK controller methods\">\n      <meta name=\"indexterm\" content=\"getStartTime() - ik\">\n      <meta name=\"indexterm\" content=\"getRotThreshold() - ik\">\n      <meta name=\"indexterm\" content=\"getPosThreshold() - ik\">\n      <meta name=\"indexterm\" content=\"getIterations() - ik\">\n      <meta name=\"indexterm\" content=\"getEndTime() - ik\">\n      <meta name=\"indexterm\" content=\"setPinNode() - ik\">\n      <meta name=\"indexterm\" content=\"setPosThreshold() - ik\">\n      <meta name=\"indexterm\" content=\"getPinNode() - ik\">\n      <meta name=\"indexterm\" content=\"setPrecedence() - ik\">\n      <meta name=\"indexterm\" content=\"getPrecedence() - ik\">\n      <meta name=\"indexterm\" content=\"setIsTerminator() - ik\">\n      <meta name=\"indexterm\" content=\"getIsTerminator() - ik\">\n      <meta name=\"indexterm\" content=\"setBindPos() - ik\">\n      <meta name=\"indexterm\" content=\"getBindPos() - ik\">\n      <meta name=\"indexterm\" content=\"setBindOrient() - ik\">\n      <meta name=\"indexterm\" content=\"getBindOrient() - ik\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>IK_ControllerMatrix3Controller : Matrix3Controller</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C30E05F6-0369-4250-9DC3-CB0507E28A06\"></a><div class=\"head\">\n            <h1>IK_ControllerMatrix3Controller : Matrix3Controller </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7976\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7975\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controllers</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-D26D932B-0E6C-4A1E-934C-AF2883DD850F.htm\">Matrix3Controller</a></span> &gt; IK_ControllerMatrix3Controller \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7973\"></a>The functions described in this topic provide access to some of the Inverse Kinematics\n            (IK) parameters of the IK controller. The IK controller is typically used by the Bones\n            system in <em class=\"strong\">3ds Max</em>. You cannot create a Bones system using MAXScript in <em class=\"strong\">3ds Max 3</em>, but these methods provide access to the IK controller for existing Bones systems.\n            An IK system actually consists of two types of controllers - the master IK controller\n            and slave IK controllers. The slave IK controllers are used as the transform controller\n            for all nodes in the IK system, and the master IK controller controls the individual\n            slave IK controllers. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7972\"></a>All the IK-related methods are in the <span class=\"code\"> <em class=\"strong\">ik</em> </span> structure and are associated with a parameter in the Motion panel, IK Controller\n            Parameters rollout. These functions return <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if executed on an object whose controller is not an IK controller. The controller\n            actually being accessed in these methods is the master IK controller. Accessing the\n            IK controller for any object in the IK system accesses the same master IK controller.\n            \n         </p>\n         <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F98\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-796F\"></a>The following ik structure methods are still present, but <span class=\"code\"> <em class=\"strong\">not applicable</em> </span> in <em class=\"strong\">3ds Max 4 and higher</em>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-796E\"></a>Getting/setting via these methods return a value of \'undefined\': \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-796D\"></a> <span class=\"code\"> <em class=\"strong\">GetRotThreshold</em> </span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-796C\"></a> <span class=\"code\"> <em class=\"strong\">SetRotThreshold</em> </span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-796B\"></a> <span class=\"code\"> <em class=\"strong\">GetPosThreshold</em> </span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-796A\"></a> <span class=\"code\"> <em class=\"strong\">SetPosThreshold</em> </span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7969\"></a> <span class=\"code\"> <em class=\"strong\">GetIterations</em> </span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7968\"></a> <span class=\"code\"> <em class=\"strong\">SetIterations</em> </span> \n               </p> \n            </div>\n         </div>\n         <p><a name=\"GUID-23451AFD-CB4D-455B-AA89-9340E161F2E7\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DD4\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">GetPosThreshold</em> &lt;node&gt; 		\n<em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">SetPosThreshold</em> &lt;node&gt; &lt;float&gt; 	 </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7962\"></a>Get and set the Position threshold value for the specified object. \n         </p>\n         <p><a name=\"GUID-E61283EE-4DAF-4C42-A641-EAB3329D9493\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DD3\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">GetRotThreshold</em> &lt;node&gt; 	 \n<em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">SetPosThreshold</em> &lt;node&gt; &lt;float&gt;   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-795E\"></a>Get and set the Rotation threshold value for the specified object. \n         </p>\n         <p><a name=\"GUID-39F72F67-B6D6-40A8-B81D-F1FDBD15FC7B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DD2\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">GetIterations</em> &lt;node&gt;   \n<em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">SetIterations</em> &lt;node&gt; &lt;integer&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-795A\"></a>Get and set the Iterations value for the specified object. \n         </p>\n         <p><a name=\"GUID-169E3636-A988-4D7B-9256-A673D79CEA1A\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DD1\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">GetStartTime</em> &lt;node&gt; \n<em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">SetStartTime</em> &lt;node&gt; &lt;time&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7956\"></a>Get and set the Start time for the specified object \n         </p>\n         <p><a name=\"GUID-19373DD7-F7E6-4E2D-AE59-A8C0F5BF7099\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DD0\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">GetEndTime</em> &lt;node&gt; \n<em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">SetEndTime</em> &lt;node&gt; &lt;time&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7952\"></a>Get and set the End time for the specified object \n         </p>\n         <p><a name=\"GUID-41FF0C47-B01C-4B1D-8F7E-0D6E3DF5D494\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DCF\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">getPinNode</em> &lt;node&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-794E\"></a>Gets the node the specified node is bound to in the IK panel as a &lt;node&gt; value, undefined\n            if none. \n         </p>\n         <p><a name=\"GUID-3B235810-1225-4414-87F7-B759CAC04930\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DCE\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">setPinNode</em> &lt;node&gt; (&lt;node&gt; | undefined) </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-794B\"></a>Sets the node the specified node is bound to in the IK panel. If undefined is specified,\n            the node is unbound. Returns true if the bind was successful, false otherwise. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7948\"></a>   \n         </p>\n         <p><a name=\"GUID-1EFE1267-E98B-4C53-9758-531920030056\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DCD\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">getPrecedence</em> &lt;node&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7945\"></a>Gets the precedence of the node as specified in the IK panel as an &lt;integer&gt; value\n            \n         </p>\n         <p><a name=\"GUID-7CCBF80B-72DC-445B-BCFA-0D0361280AC9\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DCC\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">setPrecedence</em> &lt;node&gt; &lt;number&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7942\"></a>Sets the precedence of the node as specified in the IK panel. Returns true if the\n            assignment was successful, false otherwise. \n         </p>\n         <p><a name=\"GUID-22B84817-1FB2-4794-9DFE-3EAE7399470A\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DCB\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">getIsTerminator</em> &lt;node&gt; \n<em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">setIsTerminator</em> &lt;node&gt; &lt;boolean&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-793B\"></a>Get/set whether the node is a terminator. \n         </p>\n         <p><a name=\"GUID-8CD03F6E-37C8-4FAE-8A5F-537EB9560DBC\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DCA\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">getBindPos</em> &lt;node&gt; \n<em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">setBindPos</em> &lt;node&gt; &lt;boolean&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7935\"></a>Get/set whether Bind Position is turned on for the node. \n         </p>\n         <p><a name=\"GUID-121FE992-42AD-44FC-A83B-42963D0AFC8C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DC9\"></a><pre><em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">getBindOrient</em> &lt;node&gt; \n<em class=\"codeEmphasisStrong\">ik</em>.<em class=\"codeEmphasisStrong\">setBindOrient</em> &lt;node&gt; &lt;boolean&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-792F\"></a>Get/set whether Bind Orientation is turned on for the node. \n         </p>\n         <p><a name=\"GUID-D9A97817-6A14-4911-880F-CC263874CBFC\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DC8\"></a><pre><em class=\"codeEmphasisStrong\">ik.getAxisActive</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} \n<em class=\"codeEmphasisStrong\">ik.setAxisActive</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} &lt;bitarray&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-792B\"></a>Get/Set whether each axis is active as a 3 bit bitarray.Available in <em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the free <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-3A8747A7-F7AD-45F4-B898-58341B87A844\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DC7\"></a><pre><em class=\"codeEmphasisStrong\">ik.getAxisLimit</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} \n<em class=\"codeEmphasisStrong\">ik.setAxisLimit</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} &lt;bitarray&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7927\"></a>Get/Set whether each axis is limitted as a 3 bit bitarray.Available in <em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the free <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-2A65D87E-F0CC-408A-9F10-386DEE97801A\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DC6\"></a><pre><em class=\"codeEmphasisStrong\">ik.getAxisEase</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} \n<em class=\"codeEmphasisStrong\">ik.setAxisEase</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} &lt;bitarray&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7923\"></a>Get/Set whether each axis is eased as a 3 bit bitarray.Available in <em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the free <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-00FC69A9-D67E-43AF-9796-0EDB1D264AC7\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DC5\"></a><pre><em class=\"codeEmphasisStrong\">ik.getAxisMin</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} \n<em class=\"codeEmphasisStrong\">ik.setAxisMin</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} &lt;point3&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-791F\"></a>Get/Set min value for each axis as a Point3.Available in <em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the free <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-3D31AA3D-C900-4F5D-9F05-870833BE1F56\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DC4\"></a><pre><em class=\"codeEmphasisStrong\">ik.getAxisMax</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} \n<em class=\"codeEmphasisStrong\">ik.setAxisMax</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} &lt;point3&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-791B\"></a>Get/Set max value for each axis as a Point3.Available in <em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the free <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-44A45B88-20B3-4BEF-B384-D842010D1B8C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DC3\"></a><pre><em class=\"codeEmphasisStrong\">ik.getAxisDamping</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} \n<em class=\"codeEmphasisStrong\">ik.setAxisDamping</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} &lt;point3&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7917\"></a>Get/Set damping value for each axis as a Point3.Available in <em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the free <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-F931638A-C595-4214-B62B-6007E16BA160\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DC2\"></a><pre><em class=\"codeEmphasisStrong\">ik.getAxisPreferredAngle</em> {&lt;node&gt; | &lt;controller&gt;} \n<em class=\"codeEmphasisStrong\">ik.setAxisPreferredAngle</em> {&lt;node&gt; | &lt;controller&gt;} &lt;point3&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7913\"></a>Get/Set preferred angle for each axis as a Point3.Available in 3ds Max 2008 and higher.\n            Previously available in the free <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-F9BBD5B5-D6A0-42DF-89EA-7ADA0BB4FAA8\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DC1\"></a><pre><em class=\"codeEmphasisStrong\">ik.getAxisSpringOn</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} \n<em class=\"codeEmphasisStrong\">ik.setAxisSpringOn</em>{&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} &lt;bitarray&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-790F\"></a>Get/Set whether spring is on for each axis as a 3 bit bitarray.Available in <em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the free <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-D0E513BE-6B4E-4E5D-AB8B-DAEFA591F6CC\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DC0\"></a><pre><em class=\"codeEmphasisStrong\">ik.getAxisSpring</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} \n<em class=\"codeEmphasisStrong\">ik.setAxisSpring</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} &lt;point3&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-790B\"></a>Get/Set spring value for each axis as a Point3.Available in <em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the free <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-17207B3C-476B-4139-8721-0084FEEF55A6\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2DBF\"></a><pre><em class=\"codeEmphasisStrong\">ik.getAxisSpringTension</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} \n<em class=\"codeEmphasisStrong\">ik.setAxisSpringTension</em> {&lt;node&gt; | &lt;controller&gt;} {<em class=\"codeEmphasisStrong\">#rotational</em> | <em class=\"codeEmphasisStrong\">#sliding</em>} &lt;point3&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7907\"></a>Get/Set spring tension for each axis as a Point3.Available in <em class=\"strong\">3ds Max 2008 and higher</em>. Previously available in the free <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F95\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7903\"></a>For those controllers that don\'t support IK parameters via the access method used\n                  for these methods, a value of undefined is returned. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7902\"></a>IK controllers do not support the access method used, but access is provided as properties\n                  of the IK controller. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7901\"></a>If a node is specified, the node\'s transform controller is used. \n               </p> \n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";