var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-C3A090F6-42FB-4DFB-8989-4FEA0F5933B1\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MAXScript Editor - Defining Custom Context Menu Items\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXScript Editor - Defining Custom Context Menu Items</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C3A090F6-42FB-4DFB-8989-4FEA0F5933B1\"></a><div class=\"head\">\n            <h1>MAXScript Editor - Defining Custom Context Menu Items </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4756\"></a>The <span class=\"char_link\"><a href=\"GUID-F561FC1E-CFF8-4FF6-874C-95EC4B9CD2CD.htm\">Tabbed MAXScript Editor</a></span> introduced in <em class=\"strong\">3ds Max 2008</em> lets you define your own custom Context (Right-Click) Menu Items in addition to the\n            hard-coded items like Undo, Redo, Copy and Paste. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4757\"></a>This is the default context menu which appears when you right-click in the Editor\n            window: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4758\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-02CFEF47-D27C-45B6-9987-453DE84CEB9A-low.gif\"></div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4759\"></a> \n            <h2><a name=\"GUID-F5D214E8-B694-44C7-A009-BB13E701DE1F\"></a> <em class=\"strong\">Definition:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC475A\"></a>Custom context menu items can be defined in the file <em class=\"strong\">MXS_Editor.properties </em>which is easily accessible via the <em class=\"strong\">Tools &gt; Open Global Options File </em>menu item.See <span class=\"char_link\"><a href=\"GUID-9014954D-C25C-45B5-BD9C-19260B852185.htm\">MAXScript Editor - Properties File Settings</a></span> for all options. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3512\"></a> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC475C\"></a> <em class=\"strong\">The definition starts with</em> \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63C2\"></a><pre>user.context.menu=\\</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC475E\"></a>and is a \'|\' delimited list of menu item names and the commands they produce. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC475F\"></a>To place each command on a new line, add a backslash \\ at the end of each line. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4761\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4762\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63C1\"></a><pre>user.context.menu=\\\nNext File |IDM_PREVFILE|\\\nPrev File|IDM_NEXTFILE|</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4768\"></a>Note that the above definition is available by default in the Global Options file\n                  but is remarked and thus disabled by default. You can remove the # remark symbold\n                  from all lines to enable it. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-3511\"></a> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC476A\"></a>The commands are either strings or numeric IDs -see <span class=\"char_link\"><a href=\"GUID-2F696A25-6854-4A9F-8E71-5EB81816D51E.htm\">List of Editor Key Commands</a></span> and <span class=\"char_link\"><a href=\"GUID-CA89F654-31EC-4F3C-8269-F11FCA167038.htm\">List of Editor Menu Commands</a></span>. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC476B\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC476D\"></a>Numeric IDs above 2000 are Scintilla commands and are sent to the focussed pane. \n                     </p> \n                  </li>\n               </ul> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC476E\"></a><ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4770\"></a>Named IDs and numeric IDs below 2000 are SciTE menu commands. \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4772\"></a>An Empty entry || defins a separator. \n                     </p> \n                  </li>\n               </ul> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4773\"></a>Other than <span class=\"char_link\"><a href=\"GUID-BC77ED4A-66B5-4958-876D-DBBBBD486A52.htm\">keyboard shortcuts</a></span>, changes to user-defined context menu definitions become active <em class=\"strong\">immediately </em>and do <em class=\"strong\">not </em>require a restart! \n               </p> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4774\"></a> \n            <h2><a name=\"GUID-90BDD6F9-46E3-44AD-93A1-366104842570\"></a> <em class=\"strong\">Adding a new user-defined keyboard shortcut</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4775\"></a>Let’s assume you want to add a menu item for the editor feature \"Copy As RTF\". This\n               feature is already listed in the Edit menu but could be placed closer to the mouse\n               for easier copying of formatted colored text between the Editor and external word\n               processing applications. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4776\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4778\"></a>Let\'s first add a separator by placing two | delimiters and end the line with \\ at\n                     the end of the <em class=\"strong\">user.context.menu </em>definition in the <em class=\"strong\">MXS_Editor.properties </em>file. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC477A\"></a>Then we locate in the <span class=\"char_link\"><a href=\"GUID-CA89F654-31EC-4F3C-8269-F11FCA167038.htm\">List of Named IDs</a></span> the ID called \"<em class=\"strong\">IDM_COPYASRTF</em>\". \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC477C\"></a>Let\'s add this command with label \"Copy As RTF\" to the context menu by adding to the\n                     user.context.menudefinition in the <em class=\"strong\">MXS_Editor.properties </em>file. The final definition looks like this: \n                  </p> \n               </li>\n            </ul> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC477E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-63C0\"></a><pre>\nuser.context.menu=\\\nNext File |IDM_PREVFILE|\\\nPrev File|IDM_NEXTFILE|<em class=\"codeEmphasisStrong\">\\</em> <em class=\"codeEmphasisStrong\">||\\</em> <em class=\"codeEmphasisStrong\">Copy As RTF|IDM_COPYASRTF|</em> </pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4787\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4789\"></a>Press <em class=\"strong\">CTRL+S</em> to save the <em class=\"strong\">MXS_Editor.properties </em>file. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC478B\"></a>Open a MAXScript file and select some lines. \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC478D\"></a>Right-click in the Editor- the new separator and new menu item should appear! \n                  </p> \n               </li>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC478F\"></a>Select the item <em class=\"strong\">\"Copy As RTF\"</em> to copy the selected text to the clipboard including all formatting. \n                  </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4790\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-A41BE71A-B09D-4E7B-8A6B-F28C6FCC7CAA-low.gif\"></div> \n               </li>\n            </ul> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4791\"></a><ul>\n               <li> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4793\"></a>Now you can switch to an application like MS World and paste the text - it should\n                     appear in the same style! \n                  </p> \n               </li>\n            </ul> \n         </div><a name=\"TABLE_B6A1AF5F85D04968AB7AEAE86539E0D3\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col width=\"5.656108597285068%\">\n                  <col width=\"51.696832579185525%\">\n                  <col width=\"42.64705882352941%\">\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                  </td>\n                  <td class=\"table-body\" colspan=\"2\"> <a name=\"P_1E42B9D28C85441DAD9E299584E59B54\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_AEAF86752A7E43218901C679420C99FA\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">MAXScript Editor - Quick Navigation</a></span> </em> \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";