var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-C3F61DC1-D07C-4DCD-939C-CF30E4DCA29F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MacroScripts for New Users\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MacroScripts for New Users</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C3F61DC1-D07C-4DCD-939C-CF30E4DCA29F\"></a><div class=\"head\">\n            <h1>MacroScripts for New Users </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D50\"></a> A MacroScript is generated automatically when scripting code (from the MacroRecorder\n            output, from the MAXScript Listener or from a MAXScript editor) is dragged and dropped\n            onto a toolbar. The new scripts have the extension .mcr and are written by default\n            to the \n            		<em class=\"mild\">#userMacros</em> folder (see \n            		<span class=\"char_link\"><a href=\"GUID-F7577416-051E-478C-BB5D-81243BAAC8EC.htm\">3ds Max System Directories</a></span>). \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D51\"></a>The location of the #userMacros folder is configured via \n            		<em class=\"strong\">Main Menu &gt; Customize &gt; Configure System Paths &gt; Additional Macros</em>. It can be revealed by typing in the MAXScript Listener \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D52\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-6380\"></a><pre>\ngetDir #userMacros\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS3ED54CBA79FF2E3D-7658A5A12B78356069-6E06\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D57\"></a> <em class=\"strong\">To create a MacroScript using Drag And Drop:</em> \n         </p>\n         <ol type=\"1\" start=\"1\">\n            <li>Select some code in the MacroRecorder output, the MAXScript Listener or in a MAXScript\n               editor. \n               		\n            </li>\n            <li> <em class=\"strong\">Click and Drag</em> the selection to a toolbar while holding the left mouse button pressed. \n               		\n            </li>\n            <li> <em class=\"strong\">Drop</em> the selection on the toolbar by releasing the left mouse button. \n               		  \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D5B\"></a><em class=\"strong\">Result:</em> A new button will be created, showing a generic MacroScript icon. The new script\n                  will be named \"MacroN\" where N is a unique number incremented after each drag and\n                  drop operation. The category of the new script will be \"DragAndDrop\". \n                  		  \n               </p> \n            </li>\n         </ol>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D5C\"></a>You can also use MacroScripts as ActionItems in Menus, QuadMenus, Toolbars and Keyboard\n            Shortcuts. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D5D\"></a>Of course, a script developer can write the same form of scripts manually or use automatically\n            generated MacroRecorder code as template for manual enhancements. The developer’s\n            source code might also be contained in an .ms file. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D5E\"></a>A typical MacroScript will usually start like this: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D5F\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-637F\"></a><pre>\nmacroScript scriptName category:\"CategoryName\"\n(\n...\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D67\"></a> <em class=\"strong\">Note \n               		</em>the \n            		<em class=\"strong\">category</em>: name. You will need this name in order to be able to quickly locate the script in\n            the Customize dialog. \n            	 \n         </p><a name=\"WS3ED54CBA79FF2E3D-7658A5A12B78356069-6DFA\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D68\"></a> <em class=\"strong\">To install a MacroScript:</em> \n         </p>\n         <ol type=\"1\" start=\"1\">\n            <li>Click the MAXScript item in the Main Menu, select \n               		  <em class=\"strong\">Open Script</em>... \n               		  \n               <p><a name=\"WS3ED54CBA79FF2E3D-7658A5A12B78356069-6DF7\"></a>Alternatively, go to the Utilities panel, open the MAXScript Utility, press \n                  			 <em class=\"strong\">Open Script...</em> \n               </p> \n            </li>\n            <li>Locate and select the script and press \n               		  <em class=\"strong\">Open</em>. \n               		\n            </li>\n            <li>Note the name of the MacroScript and the Category name. \n               		\n            </li>\n            <li>In the MAXScript Editor, click \n               		  <em class=\"strong\">Tools</em> menu and select \n               		  <em class=\"strong\">Evaluate All \n                  		  </em>or press \n               		  <em class=\"strong\"><span class=\"keyboardEntry\">Ctrl</span>+<span class=\"keyboardEntry\">E</span></em>. This will evaluate the script. \n               		\n            </li>\n            <li>Go to Customize &gt; Customize User Interface and select the desired Tab (Keyboard, Toolbars,\n               Quads or Menus) \n               		\n            </li>\n            <li>Locate the Category you noted in 3. \n               		\n            </li>\n            <li>Search in the Category for the name you noted in 3. \n               		\n            </li>\n            <li>Drag the script to the toolbar, Menu or QuadMenu or assign to a Shortcut. \n               		\n            </li>\n         </ol>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D72\"></a>An evaluated MacroScript appears in the Customize... dialog’s categories list of Action\n            Items. The evaluated version of the script remembers its source’s location. As soon\n            as a MacroScript definition is evaluated, a copy of the source is automatically saved\n            in the \n            		<em class=\"mild\">#userMacros</em> folder with a new name comprised of the Category Name, the MacroScript’s name and\n            the .mcr extension. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D73\"></a>If you change or update the script by evaluating a newer / different version with\n            the same name and category, the copy of the script in the \n            		<em class=\"mild\">#userMacros</em> folder will be overwritten with the actualized version. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D74\"></a>All scripts in \n            		<em class=\"mild\">#macroScripts</em> which contains the factory-defined MacroScripts and \n            		<em class=\"mild\">#userMacros</em> containing the user-defined ones will be automatically evaluated on startup and will\n            be available to the user in future sessions. To remove a MacroScript permanently,\n            you should remove the respective .mcr file from the \n            		<em class=\"mild\">#userMacros</em> folder. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D75\"></a>It is not advisable to have any MacroScript sources in auto start folders like the\n            \n            		<em class=\"mild\">#startupScripts</em> or the plug-in paths as this would mean a double evaluation of the same source code\n            from two different locations. Store sources of MacroScripts (your own creations, free\n            downloads from the web or commercial scripts) at paths that are not listed in your\n            Configure Paths dialog. This way only the automatically managed content of the \n            		<em class=\"mild\">#macroScripts</em> and \n            		<em class=\"mild\">#userMacros</em> folders will be used by \n            		<em class=\"strong\">3ds Max</em>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D78\"></a> <em class=\"strong\">Topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D79\"></a> <span class=\"char_link\"><a href=\"GUID-35CB7918-A86D-465E-AC63-3AAE310A113B.htm\">MAXScript for New and Casual Users</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D7A\"></a> <span class=\"char_link\"><a href=\"GUID-06825F89-B5DD-42D8-AB32-B928C897CA60.htm\">Scripted Utilities for New Users</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D7B\"></a> <span class=\"char_link\"><a href=\"GUID-78D21100-E161-4015-9C8A-15629B153F8D.htm\">Scripted Plug-ins for New Users</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D7C\"></a> <span class=\"char_link\"><a href=\"GUID-F2A15BBB-2542-4983-89C0-BAEDC0E6051E.htm\">Scripted Functions for New Users</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC4D7D\"></a> <span class=\"char_link\"><a href=\"GUID-7A554E0F-6509-4E50-9B52-7FF75774D064.htm\">MAXScript DLX Extensions for New Users</a></span> \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li><span class=\"char_link\"><a href=\"GUID-615D14FB-0F2D-4801-B381-1128C4128C70.htm\">Startup Scripts \n                           		</a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";