var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-C42F8CCE-CE31-49B4-9D5A-65C07D9F33FD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"transform()\">\n      <meta name=\"indexterm\" content=\"squadrev()\">\n      <meta name=\"indexterm\" content=\"squad()\">\n      <meta name=\"indexterm\" content=\"slerp()\">\n      <meta name=\"indexterm\" content=\"random()\">\n      <meta name=\"indexterm\" content=\"qorthog()\">\n      <meta name=\"indexterm\" content=\"qCompA()\">\n      <meta name=\"indexterm\" content=\"normalize()\">\n      <meta name=\"indexterm\" content=\"logN()\">\n      <meta name=\"indexterm\" content=\"LnDif()\">\n      <meta name=\"indexterm\" content=\"isIdentity()\">\n      <meta name=\"indexterm\" content=\"inverse()\">\n      <meta name=\"indexterm\" content=\"exp()\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"indexterm\" content=\"conjugate()\">\n      <meta name=\"indexterm\" content=\"quatToEuler2()\">\n      <meta name=\"indexterm\" content=\"quatToEuler()\">\n      <meta name=\"indexterm\" content=\"getEulerQuatAngleRatio()\">\n      <meta name=\"indexterm\" content=\"eulerToQuat()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Quat Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C42F8CCE-CE31-49B4-9D5A-65C07D9F33FD\"></a><div class=\"head\">\n            <h1>Quat Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DB2\"></a>The \n            		<em class=\"strong\">Quat</em> class provides a compact representation for orientation in three space and provides\n            methods to perform Quaternion algebra. \n            	 \n         </p>\n         <p><a name=\"P_6CA0B0056442498590FDA548118D11E5\"></a>Quaternions are used to store object rotations in \n            		<em class=\"strong\">3ds Max</em>. \n            	 \n         </p>\n         <p><a name=\"P_07C5DBC95BD742DDA45094B6DF00B154\"></a>A quaternion is made up of four terms: a real scalar part that specifies the amount\n            of rotation and an imaginary vector part that defines the axis of rotation. \n            	 \n         </p>\n         <p><a name=\"P_E39D2C9C5E1B4D08A0B1CA4B58592B3C\"></a>If the quaternion is normalized, the scalar term equals the cosine of half the angle\n            of rotation, the vector term is the axis of rotation, and the magnitude of the vector\n            term equals the sine of half the angle of rotation. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DB3\"></a>Interpolation between two key frame orientations is much easier using quaternions\n            and produces smooth and natural motion. Unlike Euler angles, no numerical integration\n            is necessary; quaternions provide an analytic result (no approximations). \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DB4\"></a>Rotations in MAXScript follow the right-hand-rule, namely positive angles rotate counter-clockwise\n            about positive axes, consistent with the convention in the \n            		<em class=\"strong\">3ds Max</em> UI. \n            	 \n         </p>\n         <p><a name=\"P_26C9B3F2D9814CDEBD541BA69969AEFE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DB5\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F6E\"></a><pre><em class=\"codeEmphasisStrong\">quat</em> &lt;x_float&gt; &lt;y_float&gt; &lt;z_float&gt; &lt;w_float&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DB7\"></a>The x, y, z values make up the vector portion. w is the angle of rotation about the\n            vector. \n            	 \n         </p>\n         <p><a name=\"P_F28E798524174E549E5F0A6061F6CD22\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F6D\"></a><pre><em class=\"codeEmphasisStrong\">quat</em> &lt;degrees_float&gt; &lt;axis_point3&gt;\n&lt;angleaxis&gt; <em class=\"codeEmphasisStrong\">as quat</em>\n&lt;eulerangle&gt; <em class=\"codeEmphasisStrong\">as quat</em>\n&lt;matrix3&gt; <em class=\"codeEmphasisStrong\">as quat</em> --extracts the rotation component as a quat</pre></div>\n         <p><a name=\"P_CF9AB6D740FB45D99CDB907C9DE58E59\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DBC\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F6C\"></a><pre>&lt;quat&gt;<em class=\"codeEmphasisStrong\">.w</em>: Float\n&lt;quat&gt;<em class=\"codeEmphasisStrong\">.x</em>: Float\n&lt;quat&gt;<em class=\"codeEmphasisStrong\">.y</em>: Float\n&lt;quat&gt;<em class=\"codeEmphasisStrong\">.z</em>: Float</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DC1\"></a>Access quaternion complex components as Floats. \n            	 \n         </p>\n         <p><a name=\"P_F121017D5E2841FD8B3E405F9287C597\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F6B\"></a><pre>&lt;quat&gt;.<em class=\"codeEmphasisStrong\">angle</em>: Float\n&lt;quat&gt;.<em class=\"codeEmphasisStrong\">axis</em>: Point3</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DC4\"></a>Access derived properties (an angle in degrees and a rotation axis). \n            	 \n         </p>\n         <p><a name=\"P_08B7C4A451764AAA828649C8FBA6A7D6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DC5\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F6A\"></a><pre>&lt;quat&gt; <em class=\"codeEmphasisStrong\">+</em> &lt;quat&gt;\n&lt;quat&gt; <em class=\"codeEmphasisStrong\">-</em> &lt;quat&gt;\n&lt;quat&gt; <em class=\"codeEmphasisStrong\">*</em> &lt;quat_or_number&gt;\n&lt;quat&gt; <em class=\"codeEmphasisStrong\">/</em> &lt;number&gt;\n<em class=\"codeEmphasisStrong\">-</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DCB\"></a>Quaternion algebra. \n            	 \n         </p>\n         <div><a name=\"GUID-348B3E22-83F4-46B9-9695-F6BA4704296A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The \n               		<span class=\"code\">+</span> operator is the same as the \n               		<span class=\"code\">*</span> operator (product) and the \n               		<span class=\"code\">-</span> operator is the same as the \n               		<span class=\"code\">/</span> operator (ratio). \n               	 \n            </div>\n         </div>\n         <p><a name=\"P_8E1FEF9A8BAA4FCBA56456474FE4F931\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F69\"></a><pre>&lt;quat&gt; <em class=\"codeEmphasisStrong\">*</em> &lt;matrix3&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DCD\"></a>Quaternion algebra using rotation portion of the matrix3. \n            	 \n         </p>\n         <div><a name=\"GUID-DA98745E-49F1-4DF9-B429-F22101B4269A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Multiplication with quaternions is not communicative. When multiplying an angle, for\n               example, the quat must be the first term followed by the integer or float.&nbsp;&nbsp; \n               	 \n            </div>\n         </div>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F68\"></a><pre>&lt;quat&gt; <em class=\"codeEmphasisStrong\">==</em> &lt;quat&gt;\n&lt;quat&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;quat&gt;\n&lt;quat&gt; <em class=\"codeEmphasisStrong\">as</em> &lt;class&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DD1\"></a>Quats can convert to Matrix3\'s, Angleaxis\'s, and Eulerangle\'s. \n            	 \n         </p>\n         <p><a name=\"P_C1F9349404A2443D94A2F56F3B739E54\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6A69\"></a>                <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F67\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DE2\"></a>Creates a new copy of the quat value. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8798B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8798C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FFA\"></a><pre>newQuat = copy oldQuat</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DE4\"></a>The new value contains a copy of the input quat value, and is independent of the input\n            quat value. \n            	 \n         </p>\n         <p><a name=\"P_23908D3560634491BDED1FDE80B110B6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F65\"></a><pre><em class=\"codeEmphasisStrong\">isIdentity</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DE7\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if the quaternion is equal to the identity quaternion (x=y=z=0.0; w=1.0). \n            	 \n         </p>\n         <p><a name=\"P_41D00E36E4BF484F825705FFDD3A95F3\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F64\"></a><pre><em class=\"codeEmphasisStrong\">normalize</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DEA\"></a>Returns a normalized quat, dividing each term of the input quat by a scale factor\n            such that the resulting sum of the squares of all parts equals unity. \n            	 \n         </p>\n         <p><a name=\"P_E3F88ED12AD84F1A96DEF95C9F5007E9\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F63\"></a><pre><em class=\"codeEmphasisStrong\">inverse</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DED\"></a>Returns the inverse of the quaternion (1/q). \n            	 \n         </p>\n         <p><a name=\"P_AA3E3B422ACE49D5B56EF530B8CF44C8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F62\"></a><pre><em class=\"codeEmphasisStrong\">conjugate</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DF0\"></a>Returns the conjugate of the quaternion. \n            	 \n         </p>\n         <p><a name=\"P_AD498E3B34C7446B89D9F692618F6677\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F61\"></a><pre><em class=\"codeEmphasisStrong\">logN</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DF3\"></a>Returns the natural logarithm of UNIT quaternion. \n            	 \n         </p>\n         <p><a name=\"P_4E9F9D4592E241B8A9E16E05A95D970D\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F60\"></a><pre><em class=\"codeEmphasisStrong\">exp</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DF6\"></a>Returns the exponentiated quaternion (where q.w=0). \n            	 \n         </p>\n         <p><a name=\"P_9BE1D6761C0148D2B2093FA4230E0A43\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F5F\"></a><pre><em class=\"codeEmphasisStrong\">slerp</em> &lt;start_quat&gt; &lt;end_quat&gt; &lt;number&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DF9\"></a>Returns a spherical linear interpolation of UNIT quaternions. \n            	 \n         </p>\n         <p><a name=\"P_61A7553E8DCF46B79613F1439E951AEF\"></a>As \n            		<span class=\"code\">&lt;number&gt;</span> goes from 0 to 1, the returned value goes from \n            		<span class=\"code\">&lt;start_quat&gt;</span> to \n            		<span class=\"code\">&lt;end_quat&gt;</span>. \n            	 \n         </p>\n         <p><a name=\"P_904B6B28516C4675A52A4A325733A755\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F5E\"></a><pre><em class=\"codeEmphasisStrong\">LnDif</em> &lt;p_quat&gt; &lt;q_quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DFC\"></a>Returns the \"log difference\" of two quaternions as: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-558F\"></a><pre>logN ((inverse p_quat)*q_quat)</pre></div>\n         <p><a name=\"P_2FE93D06BB274D538DDEB7C8C9085197\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-558E\"></a><pre><em class=\"codeEmphasisStrong\">qCompA</em>&lt;prev_quat&gt; &lt;now_quat&gt; &lt;next_quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87DFF\"></a>Computes \n            		<span class=\"code\"> <em class=\"strong\">a</em> </span>, the term used in Boehm-type interpolation: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"CODEBLOCK_A6706748081645129DADD25445FCD616\"></a><pre>a = now_quat * exp(-(1/4)*(logN((inverse <em class=\"codeEmphasisStrong\">now_quat</em>)*<em class=\"codeEmphasisStrong\">next_quat</em>)+logN((inverse <em class=\"codeEmphasisStrong\">now_quat</em>)*<em class=\"codeEmphasisStrong\">prev_quat</em>)))</pre></div>\n         <p><a name=\"P_97604430B16046208B112C1E1FD71C4C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-558D\"></a><pre><em class=\"codeEmphasisStrong\">squad</em>&lt;p_quat&gt; &lt;a_quat&gt; &lt;b_quat&gt; &lt;q_quat&gt; &lt;number&gt;</pre></div>\n         <div class=\"codeBlock\"><a name=\"CODEBLOCK_817827E592854F82BFA7F3344D2A45F2\"></a><pre>slerp (slerp p_quatq_quatnumber) (slerp a_quatb_quatnumber) (2*(1-number)*number)</pre></div>\n         <p><a name=\"P_CD61AA2D71FA4D6E8330291186D19283\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-558C\"></a><pre><em class=\"codeEmphasisStrong\">qorthog</em> &lt;quat&gt; &lt;axis_point3&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E07\"></a>Returns \n            		<span class=\"code\"> <em class=\"strong\">quat</em> </span> rotated by 180 degrees (quaternion space metric) about the specified axis \n            		<span class=\"code\"> <em class=\"strong\">axis_point3</em> </span>. \n            	 \n         </p>\n         <p><a name=\"P_024D1A7D92594AC4843F97FBF4FB8CC1\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF29A9843712B1ADDAC1F-558B\"></a><pre><em class=\"codeEmphasisStrong\">transform</em> &lt;quat&gt; &lt;matrix3&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E0A\"></a>Returns the transformation of the specified quaternion by the specified matrix. \n            	 \n         </p>\n         <p><a name=\"P_B82550498E57439C9B8443033323C42B\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F5B\"></a><pre><em class=\"codeEmphasisStrong\">squadrev</em> &lt;angle_number&gt; &lt;axis_point3&gt; &lt;start_quat&gt; &lt;start_tangent_quat&gt; &lt;end_tangent_quat&gt; &lt;end_quat&gt; &lt;number&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E0D\"></a>Returns quaternion interpolation for angles &gt; 2PI, where \n            		<span class=\"code\"> <em class=\"strong\">angle_number</em> </span> is the angle of rotation, and \n            		<span class=\"code\"> <em class=\"strong\">axis_point3</em> </span> is the axis of rotation. As \n            		<span class=\"code\"> <em class=\"strong\">number</em> </span> goes from 0 to 1, the returned value goes from \n            		<span class=\"code\"> <em class=\"strong\">start_quat</em> </span> to \n            		<span class=\"code\"> <em class=\"strong\">end_quat</em> </span>. \n            	 \n         </p>\n         <p><a name=\"P_5826C6B248404CFBAF222911A3FFA3B2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F5A\"></a><pre><em class=\"codeEmphasisStrong\">random</em> &lt;quat&gt; &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E10\"></a>Returns a random rotation between the two quats, using Slerp. \n            	 \n         </p>\n         <p><a name=\"P_BB0BEFBD91DF4EEC9621D7834A1F70A6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6A36\"></a>     <em class=\"strong\">Related Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F59\"></a><pre><em class=\"codeEmphasisStrong\">quatToEuler</em>&lt;quat&gt; <em class=\"codeEmphasisStrong\">order:</em>&lt;eulertype_integer&gt;\n<em class=\"codeEmphasisStrong\">eulerToQuat</em>&lt;eulerAngle&gt; <em class=\"codeEmphasisStrong\">order:</em>&lt;eulertype_integer&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E17\"></a>Converts between quat and euler angle values. The optional order parameter specifies\n            the order of application of the angles. If not specified, XYZ ordering is used. Its\n            value can be any of the following: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F58\"></a><pre>\n1 - XYZ\n2 - XZY\n3 - YZX\n4 - YXZ\n5 - ZXY\n6 - ZYX\n7 - XYX\n8 - YZY\n9 - ZXZ\n</pre></div>\n         <p><a name=\"P_807A4314D372411CBDC4A4AE28421818\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F57\"></a><pre><em class=\"codeEmphasisStrong\">quatToEuler2</em> &lt;quat&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E22\"></a>Returns the same Euler value for the given Quaternion as shown in the Transform Type-In\n            dialog. Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span> . \n            	 \n         </p>\n         <p><a name=\"P_F063EC36776F4B0D828299308614C2BD\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F56\"></a><pre><em class=\"codeEmphasisStrong\">quatArrayToEulerArray</em> &lt;quat array&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E26\"></a>Returns an array of smooth Euler values from the Quat array. Available in \n            		<em class=\"strong\">3ds Max 2008 and higher</em>. Previously, available in the \n            		<span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n            	 \n         </p>\n         <p><a name=\"P_40F2AD19CAA045549155788166592DD8\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F55\"></a><pre><em class=\"codeEmphasisStrong\">getEulerQuatAngleRatio</em> &lt;quat1&gt; &lt;quat2&gt; &lt;eulerAngles1&gt; &lt;eulerAngles2&gt; [<em class=\"codeEmphasisStrong\">angle</em>:&lt;eulertype_integer&gt;]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E29\"></a>When converting a series of quat values to eulerAngles values, it is possible for\n            sign flips to occur in the eulerAngles values. This is due to the fact that one single\n            quat value can be expressed through many different eulerAngles values. This flip can\n            be detected based on the eulerAngles/quat ratio. The eulerAngles/quat ratio is the\n            relation of the angle difference in eulerAngles space to the angle difference in quat\n            space. If this ratio is bigger than PI, the rotation between the two quat to eulerAngles\n            conversions. This method returns the eulerAngles/quat angle ratio between the two\n            quat to eulerAngles conversions as a float value. The actual detection of the flip\n            is dependent on the amount of rotation in between conversions. The smaller the amount\n            of rotation, the more accurate the detection is. The parameters to this method are:\n            \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E2A\"></a> <span class=\"code\"> <em class=\"strong\">quat1</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">quat2</em> </span> are the previous and current rotation values. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E2B\"></a> <span class=\"code\"> <em class=\"strong\">eulerAngles1</em> </span> and \n            		<span class=\"code\"> <em class=\"strong\">eulerAngles2</em> </span> are the previous and current converted rotation angles. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E2C\"></a>The optional \n            		<span class=\"code\"> <em class=\"strong\">eulertype_integer</em> </span> parameter specifies the order of application of the angles. If not specified, XYZ\n            ordering is used. Its value can be any of the following: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F54\"></a><pre>\n1 - XYZ\n2 - XZY\n3 - YZX\n4 - YXZ\n5 - ZXY\n6 - ZYX\n7 - XYX\n8 - YZY\n9 - ZXZ\n</pre></div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E37\"></a> <span class=\"char_link\"><a href=\"GUID-04D996CE-B03E-41D6-ADD4-E9A043A483B6.htm\">AngleAxis Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87E38\"></a> <span class=\"char_link\"><a href=\"GUID-87BB6468-79E2-4FA2-9BAB-42E427219C4F.htm\">EulerAngles Values</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";