var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-C62167A8-8ED9-422E-BCE1-F01ADDA41D33\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ActiveX by-reference arguments for methods and events\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ActiveX by-reference arguments for methods and events</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C62167A8-8ED9-422E-BCE1-F01ADDA41D33\"></a><div class=\"head\">\n            <h1>ActiveX by-reference arguments for methods and events </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-6F1D\"></a> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75AA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4AC1\"></a> <img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\"> ActiveX Controls have been deprecated by Microsoft in the latest versions of the\n                     Windows operating system in favor of the <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet</a></span> framework and its controls. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4AC0\"></a>While MAXScript still supports ActiveX controls, these have to be installed and registered\n                     on the system to be accessible to MAXScript. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4ABF\"></a>As a replacement of ActiveX controls, MAXScript supports <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet controls</a></span> in <em class=\"strong\">3ds Max 9 and higher</em>. \n                  </p> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4ABD\"></a>The following example will not work unless the used ActiveX control is installed on\n                     your system. \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4ABA\"></a>ActiveX supports by-reference arguments for methods and events since <em class=\"strong\">3ds Max 5.1</em>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4AB8\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4AB7\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7116\"></a><pre>\nrollout winsockTester \"Winsock Tester\" (\nactiveXControl axWinsock \"{248DD896-BB45-11CF-9ABC-0080C7E7B78D}\" align:#left\nedittext txt text:\"mail.iwaynet.net\" offset:[-12, 0] fieldwidth:90\nedittext txt2 \"Port:\" text:\"110\" offset:[8, -2]\nbutton btn \"Connect\" width:90 height:16 offset:[0, 2]\nbutton btn2 \"Disconnect\" width:90 height:16 offset:[0, -2] enabled:false\n-- some data has arrived..\non axWinsock DataArrival bytes do\n(\n  format \"% bytes received.\\n\" bytes\n  local wsckData = \"\" -- initialize to a string\n  p = axWinsock.getdata &amp;wsckdata -- by-reference argument\n  format \"Data: %\\n\" wsckData\n)\n-- connected to remote host\non axWinsock Connect do\n(\n  format \"Connected.\\n\"\n  btn2.enabled = true\n  btn.enabled = false\n)\n-- connect!\non btn pressed do\n(\n  axWinsock.connect txt.text txt2.text\n  format \"Connecting ...\\n\"\n)\n-- disconnect\non btn2 pressed do\n(\n  axWinsock.close()\n  format \"Connection closed.\\n\"\n  btn2.enabled = false\n  btn.enabled = true\n)\n)\ncreatedialog winsockTester 100 115\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4A88\"></a>By-reference arguments are preceded with a \'&amp;\' in showMethods and showEvents. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4A87\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4A86\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7115\"></a><pre>\nshowmethods winsockTester.axWinsock\n.Connect RemoteHost:undefined RemotePort:undefined\n.Listen()\n.Accept requestID:integer\n.SendData data:undefined\n.GetData <em class=\"codeEmphasisStrong\">&amp;data</em>:undefined type:undefined maxLen:undefined\n.PeekData <em class=\"codeEmphasisStrong\">&amp;data</em>:undefined type:undefined maxLen:undefined\n.Close()\n.Bind LocalPort:undefined LocalIP:undefined\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4A7A\"></a>Since the value type for the \'data\' argument for GetData and PeekData is \'unknown\',\n               we have to pass a value type that the ActiveX control knows how to handle. In this\n               case, the methods want a buffer where they can store data, and they know how to deal\n               with a string value. That is why we initialized variable wsckData to a null string.\n               \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4A78\"></a> <span class=\"char_link\"><a href=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA.htm\">ActiveX Controls in MAXScript Rollouts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";