var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-C6A4DAEC-F65F-41DA-B82C-C87F3D1F7C59\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"The Wonderful World of Classes and Class Instances\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>The Wonderful World of Classes and Class Instances</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C6A4DAEC-F65F-41DA-B82C-C87F3D1F7C59\"></a><div class=\"head\">\n            <h1>The Wonderful World of Classes and Class Instances </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA99\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA9A\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; The Wonderful World of Classes and Class Instances \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA9C\"></a> \n            <h2><a name=\"GUID-4A3A4A55-316E-4DCF-B01C-B39DF90E0B7C\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA9D\"></a>I want to be able to turn RenderEffects on and off, but I have not been able to figure\n               out if this is even possible. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCA9E\"></a>I am trying to decipher exactly how the Maxscript Help file syntax works. What does\n               it mean when something is in the &lt; &gt; symbols as in: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-668A\"></a><pre><em class=\"codeEmphasisStrong\">setActive</em> &lt;renderEffect&gt; &lt;boolean&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAA0\"></a>I understand that setActive is the command and boolean is either a true or false flag,\n               but what is required with renderEffect? How does that command actually get written?\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAA1\"></a>I tried \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6689\"></a><pre>\nsetActive blur true\nsetActive blur false\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAA4\"></a>This did not seem to be acceptable as the error states: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6688\"></a><pre>--&nbsp;Runtime error: Invalid object, needed Atmospheric or Effect, got: blur</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAA6\"></a>So, what am I to provide in terms of an OOP object? \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAA7\"></a> \n            <h2><a name=\"GUID-999F7003-7F41-41D1-BE36-1CBA0B8FE8D3\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAA8\"></a>According to <span class=\"char_link\"><a href=\"GUID-D3754952-893E-4ECB-A77B-83DC89684EE5.htm\">Syntax Definitions in This Document</a></span> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6687\"></a><pre>&lt;rule&gt; -- you can insert what is defined by the named rule</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAAA\"></a>So, when you see &lt;boolean&gt;, you need an expression which evaluates to a boolean value.\n               This also means that it does not only expect the symbol True or False, but any expression\n               leading to the value represented by the symbols True and False. So, in place of &lt;boolean&gt;,\n               you can have a variable containing a boolean value, an expression like myValue &gt;=\n               10.5, or a MAXScript method that returns a boolean value (like selection[1].isHidden).\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAAB\"></a>In the case of &lt;renderEffect&gt;, it expects a renderEffect object value. As <em class=\"strong\">3ds Max</em> is an Object-Oriented program, most of its building blocks are objects in the OOP\n               meaning of the word. Similarly, MAXScript lets you construct instances of object classes.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAAC\"></a>For example, b=box() creates an instance of the class Box and returns a value that\n               is then stored in the variable b, which can be used anywhere where a &lt;Node&gt; is expected\n               according to the MAXScript Help. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAAD\"></a>If you create an instance of the lens_effects class, which is of renderEffect superClass,\n               you get back an object that is not a scene node, but an object in the OOP meaning\n               of the word and fits the rule mentioned above because its superClass matches the type\n               of object expected by the setActive method. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAAE\"></a>For example, try to see this from a human perspective: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAAF\"></a>The CLASS of an object can be seen as the Nationality of a human. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAB0\"></a>The SUPERCLASS can be seen as the species, in this case, HumanBeing. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAB1\"></a>So, when you give birth to a human being in Bulgaria, for example, you are creating\n               an instance of the class Bulgarian, of superclass HumanBeing. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAB2\"></a>So, class and superclass are general descriptions of types of objects, but not the\n               objects themselves. If you want to apply the method \"Kiss\" to a human being, you cannot\n               use \"Kiss Bulgarian\" as it is not possible to kiss a nation. You need an <em class=\"strong\">instance</em> of the class, a single human being, to call the method. So, in MAXScript pseudo-code:\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAB3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAB4\"></a><p class=\"table-body\"> <em class=\"strong\">PSEUDO-SCRIPT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-3BC1F56812B783555D7-7E6D\"></a> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6686\"></a><pre>\ntheHuman = Bulgarian()--create an instance of the class Bulgarian\ntheHuman.name =\"Bobo\"--give it a name\nprint (superclassof theHuman)\n--&gt; HumanBeing\nif theHuman.location ==\"Winnipeg\" do\ntheHuman.isFrozen = true--set some properties based on object\'s location\n--&nbsp;Now you have a single instance you can call a method\n--&nbsp;that expects an object of the superclass HumanBeing:\nKiss theHuman\n</pre></div> \n                        </div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAC2\"></a>If you try to use \"Kiss Bulgarian\" in <em class=\"strong\">Pseudo</em> -MAXScript, you will get an error like: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-29F1\"></a>--Runtime error: Invalid object, needed HumanBeing, got: Bulgarian \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAC4\"></a>This is because Bulgarian is not an object. It is a class describing a category of\n               objects. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAC5\"></a>The idea of Object Oriented Programming is to have common classes of objects that\n               inherit from more general classes, and lets you create any number of instances of\n               a class that inherits all typical properties and capabilities of the class hierarchy\n               above. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAC6\"></a>So, you can have a class hierarchy like: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6685\"></a><pre>\nLifeForm &gt; EarthInhabitant &gt; Mammal &gt; HumanBeing &gt; Caucasian &gt; Bulgarian\n</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAC8\"></a>The more general classes in the beginning define common capabilities of a life form\n               like it breathes air or swims in water, drinks milk, is a two-legged creature, the\n               origin and some common skin, hair, and eye color properties, the language it speaks,\n               the region it comes from, and so on. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAC9\"></a>Still, you have to create an instance of the class you are interested in to use methods\n               applicable to objects as shown above. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCACA\"></a>In the special case of the RenderEffects, you need an instance of the Blur effect,\n               not the class Blur itself. Usually, if the object exists in the scene, you can try\n               to get the existing one into a variable, by calling: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCACB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCACC\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6684\"></a><pre>\nmyEffect = getEffect 1--returns the first effect on the RenderEffects list\nsetActive myEffect false--disables it\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAD2\"></a>Or shorter, without the intermediate variable. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAD3\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAD4\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6683\"></a><pre>\nsetActive (getEffect 1) false\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAD9\"></a>To disable all effects in the scene, you can do something like: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCADA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCADB\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6682\"></a><pre>\nfor i = 1 to NumEffects do setActive (getEffect i) false\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCAE1\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";