var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-C8517C4A-A75F-4D4E-A058-BE3EE61A2A11\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Context\">\n      <meta name=\"indexterm\" content=\"undo context\">\n      <meta name=\"indexterm\" content=\"setSaveRequired()\">\n      <meta name=\"indexterm\" content=\"getSaveRequired()\">\n      <meta name=\"indexterm\" content=\"clearUndoBuffer()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>undo</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C8517C4A-A75F-4D4E-A058-BE3EE61A2A11\"></a><div class=\"head\">\n            <h1>undo </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87105\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87106\"></a>  The <span class=\"code\"> <em class=\"strong\">undo &lt;boolean&gt;</em> </span> context provides control over whether scripted scene changes will be undoable. \n            </p> \n            <p><a name=\"P_61EAC1E55C434F9590BABF7DB124CDC7\"></a>By default, the operations performed in MAXScript are undoable. \n            </p> \n            <p><a name=\"P_B7ECE221505A46F285F056C0BE2D7DCE\"></a>This means that scene-modifying commands typed in the Listener are undoable by default.\n               Making this a context-controlled activity allows you to decide when the <span class=\"code\"> <em class=\"strong\">undo</em> </span> overhead is to be taken. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87109\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8710A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60D9\"></a><pre>\nundo on\n(\ndelete $box*\ndelete $sphere*\nclearUndoBuffer()\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87114\"></a>The undoable operations appear as items labeled \"MAXScript\" in the <em class=\"strong\">3ds Max</em> Undo menu. \n            </p> \n            <p><a name=\"P_8AED6D141A83412F82462A8333DF05DD\"></a> It is important to note that the granularity of the undoable operations is at the\n               level of entire undo clauses. \n            </p> \n            <p><a name=\"P_021BDF3D8AFF4A8B9E54895E24F38455\"></a>In the previous example, one entry is added to the Undo stack containing both the\n               deletes as a single operation. \n            </p> \n            <p><a name=\"P_DF8D4A1DE0374FC5AD7D46404065D2D0\"></a> Choosing undo for this entry in the Undo menu causes both the deletes to be undone.\n               \n            </p> \n            <p><a name=\"P_8FB7D4C9453F45AF9DAD86B177A93A03\"></a>Therefore, you can control the granularity of an undo by choosing the appropriate\n               undo block expression groupings. \n            </p> \n            <p><a name=\"P_468BB13DDC89436A8D37A19D357C83A9\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87115\"></a>You can invoke an undo from MAXScript with the <span class=\"code\"> <em class=\"strong\">max</em> </span> command: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60D8\"></a><pre><em class=\"codeEmphasisStrong\">max undo</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87117\"></a>When you script very large scene changes, you must consider turning undo <span class=\"code\"> <em class=\"strong\">off</em> </span> as it easily fills up the Undo stack and consumes substantial amounts of memory.\n               Disabling undo can improve performance in this situation. \n            </p> \n            <p><a name=\"P_73AD2626C3964259BAE8566D2FA4A64F\"></a>If the actions performed by your script can interfere with entries already in the\n               Undo stack, you must explicitly clear the Undo stack before enabling undo. \n            </p> \n            <p><a name=\"P_8D41DA509943414786E7AA417DB7D39F\"></a>An entry in the Undo stack generally expects the scene to be in the state it was when\n               the entry was placed in the Undo stack. \n            </p> \n            <p><a name=\"P_1D3F91B279294EE08D8D029DEC463572\"></a>If you interrupt the storing of Undo stack entries and modify the scene in an incompatible\n               way (such as, deleting an object that an entry assumes is still around), then a <em class=\"strong\">3ds Max</em> crash is likely if you try to perform an undo. \n            </p> \n            <p><a name=\"P_ECED79C2A75B401D96A523C137680950\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87118\"></a>Using the following functions you can control the undo and scene save states in <em class=\"strong\">3ds Max</em>: \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-717F\"></a>    \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60D7\"></a><pre><em class=\"codeEmphasisStrong\">clearUndoBuffer</em>()   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8711C\"></a>Empties the Undo stack, both providing a way to reset the undo state and another way\n               to control the save-changes requester. \n            </p> \n            <p><a name=\"P_FBB2BF84C73F4B10914AC13C1841CD59\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60D6\"></a><pre><em class=\"codeEmphasisStrong\">setSaveRequired</em> &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8711F\"></a>Lets you set the <em class=\"strong\">3ds Max</em> system \"dirty\" flag. If this flag is set or there are entries in the Undo stack,\n               you are prompted to save the scene file on a File &gt; New or File &gt; Reset. \n            </p> \n            <p><a name=\"P_4DA0A8F08FB44190AD0521839C175113\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60D5\"></a><pre><em class=\"codeEmphasisStrong\">getSaveRequired</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87122\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the <em class=\"strong\">3ds Max</em> system \"dirty\" flag is set to <span class=\"code\"> <em class=\"strong\">true</em> </span> or if the Undo buffer is not empty. If the Undo buffer is not empty, this function\n               will still return <span class=\"code\"> <em class=\"strong\">true</em> </span> even if you just called <span class=\"code\"> <em class=\"strong\">setSaveRequired false</em> </span>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87123\"></a>Generally, if there are entries in the Undo stack when the scene is closed, <em class=\"strong\">3ds Max</em> will prompt with a save-changes requester. In some cases, where you are controlling\n               undo in MAXScript, you might want to force the need for a save-changes prompt. \n            </p> \n            <p><a name=\"P_111325EE812641A89C07ED164EDFC02F\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87124\"></a>MAXScript provides some control over the labels displayed in the <em class=\"strong\">3ds Max undo/redo</em> dropdown list for undoable MAXScript operations. \n            </p> \n            <p><a name=\"P_854676739BC04EDDA0D1B4D2108D7E1D\"></a>This is an improvement to just displaying \"MAXScript\" in all cases, as it did in versions\n               prior to <em class=\"strong\">3ds Max 4</em>. \n            </p> \n            <p><a name=\"P_592510399DEE404297702777EA6F4A29\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87125\"></a>Any undoable macroScript execution such as, through a toolbar button, menu item, hotkey,\n               or quad-menu item will be displayed in the <em class=\"strong\">undo/redo</em> list with the name of the macroScript. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87126\"></a>The <em class=\"strong\">\'undo on\'</em> context prefix accepts an optional string literal (text in double quotes) after the\n               <em class=\"strong\">\'undo\'</em> keyword, which will be used as the label for the undo block in the <em class=\"strong\">3ds Max</em> undo/redo lists. \n            </p> \n            <p><a name=\"P_3F544F2E4682455D85A1B929E96BD54E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87127\"></a> \n               <h3><a name=\"GUID-31DA6695-51F3-48AC-99D2-2178C7C28A23\"></a> <em class=\"strong\">Syntax</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60D4\"></a><pre><em class=\"codeEmphasisStrong\">undo</em> [\"undo_item_label\" | <em class=\"codeEmphasisStrong\">label</em>:&lt;string_operand&gt; | variable_name ] &lt;bool_expr&gt; &lt;expr&gt; </pre></div> Where: \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8712A\"></a> <span class=\"code\"> <em class=\"strong\">\"undo_item_label\"</em> </span> must be a string literal, \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8712B\"></a> <span class=\"code\"> <em class=\"strong\">&lt;string_operand&gt;</em> </span> evaluates to a string at runtime, and \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8712C\"></a> <span class=\"code\"> <em class=\"strong\">variable_name</em> </span> is a global or local variable containing a string value. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8712E\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8712F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60D3\"></a><pre>\nrollout test \"test\"\n(\nlocal undoString = \"Button Press\"\nlocal buttonPress = 0\nbutton b \"press me\"\non b pressed do with undo label:(undoString + (buttonPress +=1) as string) on box()\n)\ncreatedialog test\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60D2\"></a><pre>\nundo \"add background\" on\n(\n...\n)\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60D1\"></a><pre>\nmy_context_name = \"An Undo Context\"\nundo my_context_name on\n(\n--...\n)\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87148\"></a>These examples will generate an undo-block for all the operations in the block-expression\n                  following the prefix, which will display in the undo/redo lists with the given string\n                  as its name. \n               </p> \n               <p><a name=\"P_261D006E7E644D0A8B67FC498E8B1858\"></a>The name must be a literal string and is optional, and will default to \"MAXScript\".\n                  \n               </p> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";