var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-CA252E0A-3EB7-4DDD-9E9A-19B95E592902\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"working with\">\n      <meta name=\"indexterm\" content=\"editable meshes\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Working with Editable Meshes</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CA252E0A-3EB7-4DDD-9E9A-19B95E592902\"></a><div class=\"head\">\n            <h1>Working with Editable Meshes </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C184F\"></a>   \n         </p>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-417FC02312B7835BF26-7873\"></a> \n            <h2><a name=\"GUID-C61AF76C-7B76-48A2-8EF3-786392A53939\"></a> <em class=\"strong\">Flipping Face Normals</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1853\"></a>The following function flips the face normal for all faces in the specified mesh object.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1854\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1855\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-54C8\"></a><pre>\nfn FlipObjNormal obj =\n(\nfor f =1 to obj.numFaces do -- for each face in the mesh\n(\nverts=getface obj f -- get its 3 vertices as a point3\nlocal tmp=verts.x -- swap the first and third vertices\nverts.x=verts.z -- which flips the normal\nverts.z=tmp -- (right-hand rule), and\nsetface obj f verts -- store the new vertex order for the face\n)\nupdate obj -- update object so 3ds Max sees the changes\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-417FC02312B7835BF26-786E\"></a> \n            <h2><a name=\"GUID-E67B48C2-A460-4974-92B7-B99872E87EA6\"></a> <em class=\"strong\">Texture Vertices and Faces</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1865\"></a>The following script is an example of working with texture vertices and faces. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1866\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C1867\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-54C7\"></a><pre>\n-- function to apply planar mapping to an object\n-- direction parameter specifies the axis the mapping is\n-- perpendicular to, and can have a value of #x, #y, or #z\n--\nfn ApplyPlanarMap obj direction =\n(local oldcoordsys, normalize_pos\n-- in this case, the number of texture vertices is equal to the\n-- number of mesh vertices\nobj.numtverts=obj.numverts\n-- build the texture vertex faces\nbuildTVFaces obj\n-- operate in objects coordinate space. Save original coord system so we\n-- can restore later.\noldcoordsys=set coordsys local\n-- for each vertex in mesh, get it\'s position and normalize the position\n-- to a range of [0,0,0] to [1,1,1]. This is the planar UVW space.\nfor v = 1 to obj.numverts do\n( normalize_pos=((getvert obj v)-obj.min)/(obj.max-obj.min)\n-- flip around position component values based on which direction the\n-- planar mapping is perpendicular to\ncase direction of\n(#x:( tmp=normalize_pos.x\nnormalize_pos.x=normalize_pos.y\nnormalize_pos.y=normalize_pos.z\nnormalize_pos.z=tmp\n)\n#y:( tmp=normalize_pos.y\nnormalize_pos.y=normalize_pos.z\nnormalize_pos.z=tmp\n)\n)\n-- set the corresponding texture vertex \"position\"\nsettvert obj v normalize_pos\n)\n-- done \"positioning\" the texture vertices. Build the texture faces.\n-- since in this case there is a 1-to-1 correspondence between mesh and\n-- texture vertices, the vertex indices for a mesh face are also the\n-- texture vertex indices for the texture faces.\nfor f = 1 to obj.numfaces do\nsetTVFace obj f (getface obj f)\n-- all done. reset the coordinate system\nset coordsys oldcoordsys\n-- update the mesh so 3ds Max sees the changes\n\nupdate obj\n)\n--\n-- test bed. Create a sphere, apply a material, set the diffuse map\n-- to a 2x3 tiled checker map, turn on viewport display of the\n-- checker texture map, and call the ApplyPlanarMap function\n--\ng=geosphere()\nconvertToMesh g\ng.material=standard()\ng.material.maps[2]=checker()\ng.material.maps[2].coordinates.u_tiling=2\ng.material.maps[2].coordinates.v_tiling=3\nshowTextureMap g.material g.material.maps[2] true\nApplyPlanarMap g #x\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18A4\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-54C6\"></a><pre>\nApplyPlanarMap() -- output of function declaration lines 5 to 45\n$GeoSphere:GeoSphere02 @ [0.0,0.0,0.0] -- output line 51\n$Editable_Mesh:GeoSphere02 @ [0.0,0.0,0.0] -- output line 52\nStandard:Standard -- output line 53\nChecker:Checker -- output line 54\n2 -- output line 55\n3 -- output line 56\nOK -- output line 57\nOK -- output line 58\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1AB6\"></a> <a name=\"TABLE_E9DF4C82E5B940E2B29A208D7A1D1B94\"></a><div class=\"table-not-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n                  <colgroup>\n                     <col width=\"3.536067892503536%\">\n                     <col width=\"53.71287128712871%\">\n                     <col width=\"42.751060820367755%\">\n                  </colgroup>\n                  <tr class=\"not-ruled-odd-row\">\n                     <td class=\"table-body\">&nbsp; <img src=\"../images/GUID-2C3625C6-2574-43A5-9920-B44A46216B32-low.bmp\"> \n                     </td>\n                     <td class=\"table-body\" colspan=\"2\"> <a name=\"P_F0E895D7878F4543BE63347D740B0E09\"></a><p class=\"table-body\">&nbsp;&nbsp;&nbsp; </p> <a name=\"P_17BC4F693D924A2D813B0C4D7ADEC712\"></a><p class=\"table-body\"> <em class=\"strong\"> <span class=\"char_link\"><a href=\"\">Editable Mesh - Quick Navigation</a></span> </em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C18B2\"></a> <span class=\"char_link\"><a href=\"GUID-0532C071-4401-4846-8450-3DA5510A3883.htm\">Editable_Mesh : GeometryClass and TriMesh : Value</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";