var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-CB0EBFC3-9360-445B-BCD4-5F5B2031579F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"picking\">\n      <meta name=\"indexterm\" content=\"pickObject()\">\n      <meta name=\"indexterm\" content=\"pickAnimatable function\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Picking Scene Nodes By Hit</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CB0EBFC3-9360-445B-BCD4-5F5B2031579F\"></a><div class=\"head\">\n            <h1>Picking Scene Nodes By Hit </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-3602\"></a> \n            <h2><a name=\"GUID-9511C739-CC7A-4152-9BF9-EEA53997110F\"></a> Picking Scene Nodes\n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D32\"></a><pre><em class=\"codeEmphasisStrong\">pickObject</em> [	<em class=\"codeEmphasisStrong\">message</em>:&lt;string&gt; ] [	<em class=\"codeEmphasisStrong\">prompt</em>:&lt;string&gt; ] \\ \n[	<em class=\"codeEmphasisStrong\">count</em>:n|#multiple ] [	<em class=\"codeEmphasisStrong\">filter</em>:fn ] \\ \n[	<em class=\"codeEmphasisStrong\">select</em>:&lt;boolean&gt; ] [	<em class=\"codeEmphasisStrong\">pickFrozen</em>:&lt;boolean&gt; ] \\ \n[	<em class=\"codeEmphasisStrong\">rubberBand</em>:&lt;point3&gt;] [	<em class=\"codeEmphasisStrong\">rubberBandColor</em>:&lt;color&gt; ] \\ \n[	<em class=\"codeEmphasisStrong\">forceListenerFocus</em>:&lt;boolean&gt; ] 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35FE\"></a>The <span class=\"code\"> <em class=\"strong\">pickObject()</em> </span> function lets the user pick one or more scene objects in the <em class=\"strong\">3ds Max</em> viewports. It takes several optional keyword arguments. The <span class=\"code\"> <em class=\"strong\">message:</em> </span> argument takes a string value which is displayed in the status bar prompt line. The\n               <span class=\"code\"> <em class=\"strong\">prompt:</em> </span> argument takes a string value which is displayed in the Listener window. The <span class=\"code\"> <em class=\"strong\">count:</em> </span> argument takes either a positive integer or the symbol <span class=\"code\"> <em class=\"strong\">#multiple</em> </span> to specify how many objects are to be picked (default is 1). If the count specified\n               is greater than 1 or the value <span class=\"code\"> <em class=\"strong\">#multiple</em> </span>, an array is returned containing the picked objects. The symbol <span class=\"code\"> <em class=\"strong\">#multiple</em> </span> indicates that any number of objects can be selected and the user terminates the\n               selection with a right mouse click or, if the Listener window has focus, <em class=\"strong\">any</em> character key of the keyboard. If the ESC key is pressed while the Listener windows\n               has focus, an <span class=\"code\"> <em class=\"strong\">#escape</em> </span> value will be returned. If the ESC key is pressed while a viewport has focus, selection\n               is terminated and the selection result is returned. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35FD\"></a>If <span class=\"code\"> <em class=\"strong\">#multiple</em> </span> was specified, and no objects had been selected when the selection was terminated,\n               an empty array is returned. If <span class=\"code\"> <em class=\"strong\">#multiple</em> </span> was not specified, and an object had not been selected when the selection was terminated,\n               a value of <span class=\"code\"> <em class=\"strong\">undefined</em> </span> is returned. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35FC\"></a>The <span class=\"code\"> <em class=\"strong\">filter:</em> </span> function takes a MAXScript function of one argument that is called whenever the cursor\n               is over an object in the scene and is passed that object under the cursor. It returns\n               <span class=\"code\"> <em class=\"strong\">true</em> </span> if the object is eligible for picking, or <span class=\"code\"> <em class=\"strong\">false</em> </span> if not. Typically, the function would contain some object class testing, \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35FB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35FA\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D31\"></a><pre>\nfn shapeFilt o = (superClassOf o == Shape)\n-- which you could use like this:\npickObject prompt:\"enter a shape\" filter:shapeFilt\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35F3\"></a>The optional keyword argument <span class=\"code\"> <em class=\"strong\">select:</em> </span> controls whether the picked objects become the new current selection in the <em class=\"strong\">3ds Max</em> scene. If you supply <span class=\"code\"> <em class=\"strong\">true</em> </span> for that argument, the current selection is replaced with the objects that you pick.\n               The default is <span class=\"code\"> <em class=\"strong\">false</em> </span> in which case the picker doesn\'t affect the selection set. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35F2\"></a>If the <span class=\"code\"> <em class=\"strong\">pickFrozen:</em> </span> keyword argument is set to <span class=\"code\"> <em class=\"strong\">false</em> </span> (the default), frozen nodes cannot be picked. If set to <span class=\"code\"> <em class=\"strong\">true</em> </span>, only frozen nodes can be picked. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35F1\"></a>The two optional keyword arguments <span class=\"code\"> <em class=\"strong\">rubberBand:</em> </span> and <span class=\"code\"> <em class=\"strong\">rubberBandColor:</em> </span> control the display of a rubber-banding line in the viewport during pick operations.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35F0\"></a>If <span class=\"code\"> <em class=\"strong\">rubberBand:</em> </span> is supplied on the <span class=\"code\"> <em class=\"strong\">pickObject()</em> </span> call, it enables rubberbanding, with the given &lt;point3&gt; as world-space coordinates\n               for the start point of the rubber band. You can use the <span class=\"code\"> <em class=\"strong\">rubberBandColor:</em> </span> argument to override the default line color of gray (color 128 128 128). \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35EF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35EE\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D30\"></a><pre>\nobj2 = pickObject rubberBand:obj1.pos rubberBandColor:yellow \n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35E9\"></a>The optional keyword argument <span class=\"code\"> <em class=\"strong\">forceListenerFocus:</em> </span> controls Listener focus forcing. It defaults to <span class=\"code\"> <em class=\"strong\">true</em> </span> to retain existing semantics and backward compatibility. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35E8\"></a>When picking multiple nodes and selecting by name by using the \'H\' key, you need to\n               supply <span class=\"code\"> <em class=\"strong\">forceListenerFocus:false</em> </span> to get the \'H\' key to work consistently. If this is not specified, focus is forced\n               back to the Listener after each pick: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35E7\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35E6\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6D2F\"></a><pre>\npickObject count:#multiple forceListenerFocus:false\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35E2\"></a>Be aware that the array returned can contain the same node multiple times. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35E1\"></a> <span class=\"code\"> <em class=\"strong\">pickObject()</em> </span> will exit if you switch command modes to a non-viewport command mode. For example,\n               if you run <span class=\"code\"> <em class=\"strong\">pickObject()</em> </span> and then click Select and Move, <span class=\"code\"> <em class=\"strong\">pickObject</em> </span> will exit with its current results. If instead you went into pan or zoom, <span class=\"code\"> <em class=\"strong\">pickObject()</em> </span> doesn\'t exit, but waits for its command mode to be re-entered. If you go from a viewport\n               command mode to another command mode, <span class=\"code\"> <em class=\"strong\">pickObject()</em> </span>will exit. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_6EA2EB6B62FC4DEEBE84FB52705D4D5A\"></a> \n            <h2><a name=\"GUID-A9F3CB3B-F9B7-4649-B91E-14AC9553251B\"></a> Picking Animatables\n            </h2> \n            <div class=\"codeBlock\"><a name=\"GUID-634E8A70-BE6E-448A-9693-F5F38A43843E\"></a><pre>&lt;animatable&gt;<em class=\"codeEmphasisStrong\">pickAnimatable</em> [<em class=\"codeEmphasisStrong\">message:</em>&lt;string&gt;] [<em class=\"codeEmphasisStrong\">prompt:</em>&lt;string&gt;] \\\n[<em class=\"codeEmphasisStrong\">count:</em>n|<em class=\"codeEmphasisStrong\">#multiple</em>] [<em class=\"codeEmphasisStrong\">filter:</em>fn] [<em class=\"codeEmphasisStrong\">pickFrozen:</em>&lt;boolean&gt;] \\\n[<em class=\"codeEmphasisStrong\">rubberBand:</em>&lt;point3&gt;] [<em class=\"codeEmphasisStrong\">forceListenerFocus:</em>&lt;boolean&gt;] </pre></div> \n            <p><a name=\"GUID-AD3E70EB-B843-439F-8818-AB62E6E60B7F\"></a> Lets you pick an Animatable from any area of the <em class=\"strong\">3ds Max</em> User Interface.  \n            </p> \n            <p><a name=\"GUID-E3A4C82F-53BD-4624-A54C-DF36B59AF800\"></a>The only difference to the <span class=\"code\"> <em class=\"strong\">pickObject()</em> </span> function documented earlier on this page is that there is no support for the <span class=\"code\"> <em class=\"strong\">select:</em> </span> parameter - selection does not really apply to non-nodes. \n            </p> \n            <p><a name=\"GUID-B0C6CEDA-F33B-4F26-9901-254F2F334B39\"></a>For the description of the other optional keyword arguments, please see the beginning\n               of this page. \n            </p> \n            <p><a name=\"GUID-0A697FE0-CF6E-4E8E-94AE-BB89159CFE9D\"></a>Clicking in a 3D viewport will return scene nodes. \n            </p> \n            <p><a name=\"GUID-8F73B222-0754-4335-905A-FCECDB8419F8\"></a>Clicking in an Explorer will also return scene nodes. \n            </p> \n            <p><a name=\"GUID-DAB6539D-8672-4523-850C-1C4BF4BCB204\"></a>Clicking in Schematic View will return the animatable that was clicked - scene node,\n               base object, modifier, controller and so on. \n            </p> \n            <p><a name=\"GUID-9937EEEB-5270-4D51-B468-7BB0CC4C2218\"></a>Clicking in Track View will return the animatable that was clicked - scene node, modifier,\n               material, map, controller, root node etc. \n            </p> \n            <p><a name=\"GUID-3EEF3212-60A0-4AC6-9368-227D7CC30417\"></a> Available in <em class=\"strong\">3ds Max 2015 and higher</em>. \n            </p> \n            <p><a name=\"GUID-C3CFAEC5-8EAB-4318-8E25-281EB24E0460\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35DE\"></a> <span class=\"char_link\"><a href=\"GUID-42CD0531-6BD1-4489-B5A0-C001F4EE577B.htm\">Picking Points in the Viewports</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"GUID-374BD916-DC1A-4A50-BB16-2F3F4CA5F9F6\"></a> <span class=\"char_link\"><a href=\"GUID-9D407E2A-3691-426F-9B06-4A744C3DEE58.htm\">Picking Scene Nodes By Name</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-35DD\"></a> <span class=\"char_link\"><a href=\"GUID-927A47B2-9749-4E6A-989A-55EFA06FDFD9.htm\">Picking Scene Nodes By Region</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";