var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-CB82B7DD-B4DB-4B26-9655-F42D65C2F671\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"particleVector Sample Script\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>particleVector Sample Script</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CB82B7DD-B4DB-4B26-9655-F42D65C2F671\"></a><div class=\"head\">\n            <h1>particleVector Sample Script </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846EE\"></a> <em class=\"strong\">Description:</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846EF\"></a>The following sample script assigns Vector values to the <em class=\"strong\">particleVector</em> channel. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846F0\"></a> <em class=\"strong\">Can Be Used With:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846F1\"></a>Can be used in a <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator</a></span> to control the Target Point position of a <span class=\"char_link\"><a href=\"GUID-8F43C04E-4C0A-4526-BA6D-9FE326545507.htm\">Find_Target</a></span> Test. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846F2\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-884211A0-99A0-4F8B-BA3C-7617C1E84FEF-low.gif\"></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846F3\"></a> <em class=\"strong\">Effect:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846F4\"></a>Takes a scene geometry object, gets the position of its first vertex, adds a random\n            offset to it, and assigns to the particleVector channel of all particles. In result,\n            all particles stream towards the vertex because the Find_Target is set to read the\n            particleVector channel and send all particles to the position in the channel: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E846F5\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-D8127ED1-8B21-4DF1-87C3-127D5B8A6537-low.gif\"></div><a name=\"WS73099CC142F48755-2231E4B3128F27532E846F6\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E846F7\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E14\"></a><pre>\n--The ChannelsUsed handler defines the channels\n--to be made available to the script.\n--For the list of all channels, see\n--Interface: MaxscriptParticleContainer\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to\non ChannelsUsed pCont do\n(\n--Enable the Vector channel:\npCont.useVector = true \n)\n \n--The Init handler is called on initialization.\n--It is not used in this case.\non Init pCont do\n(\n--Define a global variable with unique name and store the\n--scene object which also has a unique name in it\nglobal obj_19680217 = $Sphere_19680217\n--If the scene object does not exist, create a sphere,\n--give it the unique name and assign to the global variable\nif obj_19680217 == undefined then\nobj_19680217 = Sphere name:\"Sphere_19680217\"\n)\n \n--The Proceed handler contains the main script\n--applied to the Particles.\n--The parameter pCont passed to the handler\n--contains the Particle Container the script is applied to:\non Proceed pCont do\n( \n--Get the current number of particles\ncount = pCont.NumParticles()\n \n--Loop from 1 to the number of particles:\nfor i in 1 to count do\n(\n \n--Set the particle index in the container to the current i value.\n--This makes the i-th particle in the container the current one\npCont.particleIndex = i\n \n--Get the position of the first vertex of the scene object.\nvpos = (getVert obj_19680217.mesh 1)\n \n--Add a random variation between -1 and +1 to all 3 axes\nvpos += random [-1,-1,-1] [1,1,1]\n \n--Set the particleVector channel value to the calculated value\npCont.particleVector = vpos\n )--end i loop\n)--end Proceed\n \n--The Release handler is used to do cleanup work.\n--Not used in this case.\non Release pCont do\n(\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84736\"></a> <span class=\"char_link\"><a href=\"GUID-369FAD27-E733-4E86-9D8F-9C093212A3BC.htm\">Interface: MaxscriptParticleContainer</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84737\"></a> <span class=\"char_link\"><a href=\"GUID-5C075580-4102-4629-ABA3-14C7594B4D7A.htm\">Script_Operator : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84738\"></a> <span class=\"char_link\"><a href=\"GUID-8F43C04E-4C0A-4526-BA6D-9FE326545507.htm\">Find_Target : Helper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84739\"></a> <span class=\"char_link\"><a href=\"GUID-27F1FA0A-F2CF-4FD5-BD76-EA9953F3D794.htm\">Using MAXScript in Script Actions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8473A\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";