var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-CBC09FDC-52DD-4D05-9C7E-E2923DBCC4BA\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"transpose()\">\n      <meta name=\"indexterm\" content=\"setSize()\">\n      <meta name=\"indexterm\" content=\"invert()\">\n      <meta name=\"indexterm\" content=\"identity()\">\n      <meta name=\"indexterm\" content=\"clear()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>BigMatrix Values, BigMatrixRowArray Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CBC09FDC-52DD-4D05-9C7E-E2923DBCC4BA\"></a><div class=\"head\">\n            <h1>BigMatrix Values, BigMatrixRowArray Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87F95\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">BigMatrix</em> </span> class implements an MxN matrix for situations and calculations where the usual 4x3\n            Matrix3 class is not adequate. \n            	 \n         </p>\n         <p><a name=\"P_EEC5D049757E4E978C98DB697FD549EF\"></a>The \n            		<span class=\"code\"> <em class=\"strong\">BigMatrixRowArray</em> </span> class implements an N element vector. \n            	 \n         </p>\n         <p><a name=\"P_18C7755067A6412AAF552100E4C2930B\"></a>Each row in a BigMatrix value is a \n            		<span class=\"code\"> <em class=\"strong\">BigMatrixRowArray</em> </span> value. \n            	 \n         </p>\n         <p><a name=\"P_58E0CF9F508E4C52BE2C16066FC00B8E\"></a>Only Float values can be stored in the elements of a \n            		<span class=\"code\"><em class=\"strong\">BigMatrixRowArray</em>.</span> \n         </p>\n         <div><a name=\"GUID-D8E711C0-2F7D-41B6-A93A-65941F2DFE5A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Both \n               		<span class=\"code\"><em class=\"strong\">BigMatrix</em></span> and \n               		<span class=\"code\"><em class=\"strong\">BigMatrixRowArray</em></span> values can be coerced to strings, but will be truncated to the first 20 items if\n               the \n               		<span class=\"char_link\"><a href=\"GUID-92B98D11-60FF-4742-A1BA-692EE135E085.htm\">PrintAllElements</a></span> context is off. \n               	 \n            </div>\n         </div>\n         <p><a name=\"P_AA9C198F12824EE693E36EF6CDE38EA2\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87F96\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F18\"></a><pre><em class=\"codeEmphasisStrong\">BigMatrix</em> &lt;rows&gt; &lt;columns&gt;</pre></div>\n         <p><a name=\"P_E91D6FA32B564333B696D7EA5DBF21C5\"></a>Constructs a BigMatrix value with the given number of rows and columns. \n            	 \n         </p>\n         <p><a name=\"P_735297124C394E45A642D66E6049958F\"></a>All elements will be initially filled with 0.0 values. \n            	 \n         </p>\n         <p><a name=\"P_EC5323868DB4473FB901956C249D84AB\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87F98\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F17\"></a><pre>&lt;BigMatrix&gt;.<em class=\"codeEmphasisStrong\">rows</em>: Integer, read-only\n&lt;BigMatrix&gt;.<em class=\"codeEmphasisStrong\">columns</em>: Integer, read-only</pre></div>\n         <p><a name=\"P_71BE4BE9E0C743259F5E481D2B3A36AC\"></a>Get the number of rows and number of columns in the BigMatrix value. \n            	 \n         </p>\n         <p><a name=\"P_FFEB1B4D309942D4A1C9F5AC8412DBA5\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87F9B\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F16\"></a><pre>&lt;BigMatrix&gt; <em class=\"codeEmphasisStrong\">+</em> &lt;BigMatrix&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87F9D\"></a>Adds the two BigMatrix values together. \n            	 \n         </p>\n         <p><a name=\"P_FE9EAE1931BE4582AFE2913E1E250113\"></a>Both BigMatrix values must have the same size \n            	 \n         </p>\n         <p><a name=\"P_A9A478A7E4D14D2CA43B718AE708E631\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F15\"></a><pre>&lt;BigMatrix&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;int_row&gt;<em class=\"codeEmphasisStrong\">]</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FA0\"></a>Returns the BigMatrixRowArray value of the indexed row. \n            	 \n         </p>\n         <p><a name=\"P_A4720E5A3E094AA6AF6BFB84057A3BDB\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F14\"></a><pre>&lt;BigMatrixRowArray&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;int_column&gt;<em class=\"codeEmphasisStrong\">]</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FA3\"></a>Returns the float value of the indexed column stored in the BigMatrixRowArray value.\n            \n            	 \n         </p>\n         <p><a name=\"P_589E2EA738F546D6BAC0FAE270D1491F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F13\"></a><pre>&lt;BigMatrixRowArray&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;int_column&gt;<em class=\"codeEmphasisStrong\">]=</em> &lt;float_value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FA6\"></a>Sets the value in the indexed column in the BigMatrixRowArray value. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FA8\"></a>Because accessors are themselves operands, these definitions are recursive, which\n            means that you can string accessors together: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F12\"></a><pre>&lt;BigMatrix&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;int_row&gt;<em class=\"codeEmphasisStrong\">][</em>&lt;int_column&gt;<em class=\"codeEmphasisStrong\">]</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FAA\"></a>Returns the float value of the indexed row and column. \n            	 \n         </p>\n         <p><a name=\"P_713B0CC83468410FBDEC6D7C9C890461\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F11\"></a><pre>&lt;BigMatrix&gt;<em class=\"codeEmphasisStrong\">[</em>&lt;int_row&gt;<em class=\"codeEmphasisStrong\">][</em>&lt;int_column&gt;<em class=\"codeEmphasisStrong\">]</em>= &lt;float_value&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FAD\"></a>Sets the float value of the indexed row and column in the matrix. \n            	 \n         </p>\n         <p><a name=\"P_759EB7EA19B44F7D96213DD0FF910D67\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6935\"></a>      <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F10\"></a><pre><em class=\"codeEmphasisStrong\">invert</em> &lt;BigMatrix&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FB5\"></a>Inverts the matrix in place (the input BigMatrix is modified). \n            	 \n         </p>\n         <p><a name=\"P_53A8780395A64B04909A9DAA329137D8\"></a>The return value is also the inverted matrix. \n            	 \n         </p>\n         <p><a name=\"P_626286D6A84A4DC09F94C4CCAF2BE138\"></a><em class=\"strong\">Note</em> that this method only works if this matrix is \"square\" (if m = n). \n            	 \n         </p>\n         <p><a name=\"P_A088ED5D98A041BB857C23D48D0D27E0\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F0F\"></a><pre><em class=\"codeEmphasisStrong\">transpose</em> &lt;BigMatrix&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FB8\"></a>Returns the transpose of \n            		<span class=\"code\"> &lt;BigMatrix&gt; \n               		</span> (result \n            		<span class=\"code\"> BigMatrix[i][j] \n               		</span>=<span class=\"code\"> BigMatrix[j][i] \n               		</span>). \n            	 \n         </p>\n         <p><a name=\"P_39435FEB98084A0DA6865DE0EFEFF9B7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F0E\"></a><pre><em class=\"codeEmphasisStrong\">clear</em> &lt;BigMatrix&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FBB\"></a>Frees all the elements and sets the matrix size to be 0x0 \n            	 \n         </p>\n         <p><a name=\"P_A7C26CB797B143FCA1A367955A01FCDC\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F0D\"></a><pre><em class=\"codeEmphasisStrong\">setSize</em> &lt;BigMatrix&gt; &lt;rows&gt; &lt;columns&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FBE\"></a>Deletes the current elements and sets the size of the matrix to \n            		<span class=\"code\">&lt;rows&gt;</span> x \n            		<span class=\"code\">&lt;columns&gt;</span>. \n            	 \n         </p>\n         <p><a name=\"P_7B40AB8F250F43B287384DAEF7DEEF97\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F0C\"></a><pre><em class=\"codeEmphasisStrong\">identity</em> &lt;BigMatrix&gt; -- mapped function</pre></div>\n         <p><a name=\"P_F9609ACE04FF45ED814D58B52BA5EE72\"></a>If the number of rows and columns are not equal, this method does nothing. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FC1\"></a>If the number of rows and columns are equal, this method sets the matrix to the identity\n            (diagonal elements = 1, all other elements = 0). \n            	 \n         </p>\n         <p><a name=\"P_A43BFBA9E79142689D98A6C8EAD6F3FC\"></a>If the parameter is an array of matrices, this function returns the value \n            		<span class=\"code\"> <em class=\"strong\">OK</em> </span>. \n            	 \n         </p>\n         <p><a name=\"P_B92E660CE6504532ADCA1198ED0D098B\"></a>In both cases, the input BigMatrix values are set to the identity. \n            	 \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61B4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FC4\"></a>A BigMatrix object is a compound object, similar to an array of arrays. All of the\n                  BigMatrix methods operate directly on the components of the input BigMatrix. As described\n                  in \n                  		  <span class=\"char_link\"><a href=\"GUID-FAF8B2F4-3199-4757-A604-49E1F5BBEBE9.htm\">Reference Assignment</a></span>, this can cause complications if a BigMatrix object is referenced by more than one\n                  variable. If you assign a new value to an element of the matrix, or use any of the\n                  BigMatrix methods, the same object is still referenced by the variables. \n                  		\n               </p> \n               <p><a name=\"P_5E30284E36224EBEB5043D7CDF30A75C\"></a>This can be seen in the following example: \n                  		\n               </p> \n            </div>\n         </div><a name=\"TABLE_B902F8C49B6943D08DD1603E675D354A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"P_AC18768088A54CF8A63801BB38D9958B\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"CODEBLOCK_F754E223959541FF9F6DDD34D22B5560\"></a><pre>\nbm1=bigmatrix 2 2\nfor i=1 to 2 do for j=1 to 2 do bm1[i][j]=random 0 10\nbm2=bm1\ninvert bm1\nbm2\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87FCD\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5F0A\"></a><pre>\n#BigMatrix( --result of line 1, contents of bm1\n[0.00,0.00],\n[0.00,0.00]\n)\nOK -- result of line 2\n#BigMatrix( --result of line 3, contents of bm2\n[4.00,6.00],\n[4.00,9.00]\n)\n#BigMatrix( --result of line 4, contents of bm1\n[0.75,-0.50],\n[-0.33,0.33]\n)\n#BigMatrix( --result of line 5, contents of bm2\n[0.75,-0.50],\n[-0.33,0.33]\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FE2\"></a> <span class=\"char_link\"><a href=\"GUID-04D996CE-B03E-41D6-ADD4-E9A043A483B6.htm\">AngleAxis Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FE3\"></a> <span class=\"char_link\"><a href=\"GUID-87BB6468-79E2-4FA2-9BAB-42E427219C4F.htm\">EulerAngles Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FE4\"></a> <span class=\"char_link\"><a href=\"GUID-C42F8CCE-CE31-49B4-9D5A-65C07D9F33FD.htm\">Quat Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87FE5\"></a> <span class=\"char_link\"><a href=\"GUID-D77C780A-4E8A-4528-949F-CC09AAE048DA.htm\">Matrix3 Values</a></span> \n                     </p> \n                  </li>\n                  <li><span class=\"char_link\"><a href=\"GUID-92B98D11-60FF-4742-A1BA-692EE135E085.htm#GUID-00EA922C-A318-4A2F-888A-67C3DE859EA9\">PrintAllElements Variable and Context </a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";