var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-CC2D2450-AECD-4732-BF93-4AA91ED0BC56\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Context\">\n      <meta name=\"indexterm\" content=\"with animate context\">\n      <meta name=\"indexterm\" content=\"animate context\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>animate</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CC2D2450-AECD-4732-BF93-4AA91ED0BC56\"></a><div class=\"head\">\n            <h1>animate </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87046\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87047\"></a>   The <span class=\"code\"> <em class=\"strong\">[ with ] animate </em>&lt;boolean_expr&gt;</span> context corresponds to setting the Auto Keybutton in the <em class=\"strong\">3ds Max</em> user interface. Placing an expression, operation, or block-expression within an <span class=\"code\"> <em class=\"strong\">animate on</em> </span> context causes keyframes to be generated whenever an animatable property of a <em class=\"strong\">3ds Max</em> object is changed, regardless of the actual state of the <em class=\"strong\">Auto Key</em> button. Likewise, placing an expression within an <span class=\"code\"> <em class=\"strong\">animate off</em> </span> context prevents keyframes from being generated whenever an animatable property of\n               a <em class=\"strong\">3ds Max</em> object is changed. Expressions that change an animatable property of a <em class=\"strong\">3ds Max</em> object, and are not within an <span class=\"code\"> <em class=\"strong\">animate</em> </span> context, will generate keyframes only if the <em class=\"strong\">Auto Key</em> button is on. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8704B\"></a>Setting the <span class=\"code\"> <em class=\"strong\">animate</em> </span> context on or off does not affect the state of the <em class=\"strong\">Auto Key</em> button. The state of the <em class=\"strong\">Auto Key</em> button can be queried and set using the <span class=\"code\"> <em class=\"strong\">animButtonState</em> </span> global variable. The user can be prevented from changing the state of the <em class=\"strong\">Auto Key </em>button using the <span class=\"code\"> <em class=\"strong\">animButtonEnabled</em> </span> global variable. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8704D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8704E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60F3\"></a><pre>\nobj=box()\nliftHeight=50\ntStart=0\ntEnd=60\nloadheight=obj.pos.z\n-- lift object, no key generated\nanimate off\nobj.pos.z=loadheight+liftHeight\n-- Create key at time tStart to keep object lifted until that time.\n-- If tStart != 0, a key will also automatically be created at frame 0.\n-- Then create a key at time tEnd to drop the object\nwith animate on\n(\n  at time tStart obj.pos.z=loadheight+liftHeight\n  at time tEnd obj.pos.z=loadheight\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8705E\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8705F\"></a><p class=\"table-body\"> <em class=\"strong\">HISTORICAL NOTE FOR NEW USERS:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87060\"></a><p class=\"table-body\">In <em class=\"strong\">3ds Max</em> prior to versions 5, the <em class=\"strong\">Auto Key</em> button was called <em class=\"strong\">Animate</em>. Since MAXScript has been first introduced back in <em class=\"strong\">3ds Max 2</em> when there were no Auto Key and Set Key buttons, the MAXScript terminology remains\n                           the same for compatibility reasons, including the name of the <span class=\"code\"> <em class=\"strong\">animate</em> </span> context and the name of the global variable <span class=\"code\"> <em class=\"strong\">animButtonEnabled</em> </span>. Changing their names to reflect the new <em class=\"strong\">3ds Max</em> UI would break old scripts and is thus not a good idea. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";