var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-CCDD9750-28B3-4B35-A12C-AFD20D49742B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface MaterialHolder\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: MaterialHolder</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CCDD9750-28B3-4B35-A12C-AFD20D49742B\"></a><div class=\"head\">\n            <h1>Interface: MaterialHolder </h1>\n         </div>\n         <p><a name=\"GUID-CB2FFEB7-DE71-477E-B878-F0B990287957\"></a> The MaterialHolder Interface is exposed by the <span class=\"char_link\"><a href=\"GUID-3A3D29AB-7A0D-4522-9B9D-A5EA6B1F57BD.htm\">Event Helper class</a></span>. \n         </p>\n         <p><a name=\"GUID-91B36803-97B6-4185-B156-6F89F9B589CF\"></a>It provides access to the particles\' materials. \n         </p>\n         <p><a name=\"GUID-6F2D2B05-E7B0-4FAB-8113-4A9A847C56E4\"></a>Available in <em class=\"strong\">3ds Max 2014 and higher</em>. \n         </p>\n         <p><a name=\"GUID-94413A0F-160A-4C6C-93BD-FEAA6AB50283\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-86FF74A3-7098-4AC2-AC6F-8BBE06D34599\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;&lt;PF_Event&gt;<em class=\"codeEmphasisStrong\">.isMaterialHolder()</em></pre></div>\n         <p><a name=\"GUID-229A8101-B711-431B-8596-7E03E743BC91\"></a>Returns True if a material is assigned to the Event via any of the Particle Flow Material\n            operators. \n         </p>\n         <p><a name=\"GUID-41E6C327-DC05-4428-8432-BC7CDB022049\"></a>Returns False if no material is assigned (even if a Material operator exists, but\n            no valid material is assigned to it). \n         </p>\n         <p><a name=\"GUID-86C8003E-2526-4CC9-A3BC-486712F32AD0\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;&lt;PF_Event&gt;.<em class=\"codeEmphasisStrong\">inheritsMaterial()</em></pre></div>\n         <p><a name=\"GUID-D80E54BF-858A-4C48-AAD9-8B0F95F08D2A\"></a>Returns True if the Event inherits a material from higher up in the flow, for example\n            if the Material operator is assigned to the global PF_Source event, or if the Event\n            has no material (neither in the Event nor in the global PF_Source event). \n         </p>\n         <p><a name=\"GUID-C9A54EB7-751B-4F75-9657-646E971247C8\"></a>Returns False if the Event does not inherit its material because the Material operator\n            is in the Event itself. \n         </p>\n         <p><a name=\"GUID-B4B34BDA-0D52-4F70-87C8-C57B8FA5602D\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;material&gt;&lt;PF_Event&gt;.<em class=\"codeEmphasisStrong\">getMaterial()</em></pre></div>\n         <p><a name=\"GUID-CCD3A776-D665-41B5-BEA5-A4BD62E4052A\"></a>Returns the material associated with the Event, either through a local Material operator,\n            or inherited from a global Material operator. \n         </p>\n         <p><a name=\"GUID-EF27C617-2942-41E4-B41A-A3210380E491\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;&lt;PF_Event&gt;.<em class=\"codeEmphasisStrong\">setMaterial</em> &lt;material&gt;material</pre></div>\n         <p><a name=\"GUID-F95D136A-9571-48DB-838F-E7F509532125\"></a>Assigns a material to the Event. The material will only be used if the Event does\n            not contain a Material operator. \n         </p>\n         <p><a name=\"GUID-79BEC044-0840-44A3-8054-A8C67399E2A9\"></a>After assignment, the Particle Flow must be turned off and on again for the new material\n            to take effect. \n         </p>\n         <p><a name=\"GUID-886461A7-9084-490B-81BD-242201906231\"></a>The <span class=\"code\"> <em class=\"strong\">.getMaterial()</em> </span> method will <em class=\"strong\">NOT</em> return the material if assigned via <span class=\"code\"> <em class=\"strong\">.setMaterial()</em> </span>, it will return undefined instead. \n         </p>\n         <p><a name=\"GUID-C1647F64-5628-445E-85F6-BEEB29AE36DF\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;&lt;PF_Event&gt;.<em class=\"codeEmphasisStrong\">getMaterialPriority()</em></pre></div>\n         <p><a name=\"GUID-2FA61C15-3C31-4C11-89A8-6B04EBD9F10A\"></a>Returns the material priority. \n         </p>\n         <p><a name=\"GUID-B095D990-4B10-4F25-A132-B136B332A07D\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;&lt;PF_Event&gt;.<em class=\"codeEmphasisStrong\">getStreamDepth()</em></pre></div>\n         <p><a name=\"GUID-F895F575-FF4B-4DF8-91C9-F7D4606E02B9\"></a>Returns the stream depth of the Event within the flow. \n         </p>\n         <p><a name=\"GUID-8F94FB68-4C33-48AA-A128-16DB5BABF7ED\"></a>For example, if the Event is directly connected to the PF_Source, the return value\n            will be 1. If the Event is connected to the initial event, the return value will be\n            2 and so on. \n         </p>\n         <p><a name=\"GUID-9619FA83-0D0B-4441-AFEB-2F2E7BA3B2D0\"></a>If an event is not connected, the return value will be 0. \n         </p>\n         <p><a name=\"GUID-2BCAB593-53D9-4696-B9F6-2F295BA0CCB5\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;&lt;PF_Event&gt;.<em class=\"codeEmphasisStrong\">updateMaterial</em> &lt;bool&gt;doReport</pre></div>\n         <p><a name=\"GUID-61EAF281-C930-4933-9F3B-6CD878EDDE8B\"></a>Updates the material and returns True if the material of the current event has been\n            updated, False if it was already updated. \n         </p>\n         <p><a name=\"GUID-D66016C5-E755-4245-A6DC-1C18B89CBF64\"></a>If the argument is passed as True, a pop up message will report the state of the Event\'s\n            material. \n         </p>\n         <p><a name=\"GUID-ED2AA3CA-0D65-4E5A-A781-447CA3B3EE76\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;&lt;PF_Event&gt;.<em class=\"codeEmphasisStrong\">updateMaterials</em> &lt;bool&gt;doReport</pre></div>\n         <p><a name=\"GUID-A7A5DF46-C109-4E14-A84E-465A2A4D1CBA\"></a>Updates all materials in all Events in the flow the PF_Event is part of. \n         </p>\n         <p><a name=\"GUID-4F8A8BD3-76EC-43B6-AE53-D0594BFBF765\"></a>If the argument is passed as True, a pop up message will report the state of the Event\'s\n            material. \n         </p>\n         <p><a name=\"GUID-FAE0AD98-FD45-4A7D-B3E4-BA148A432B64\"></a>Returns the number of Events whose materials have been updated, or 0 if all materials\n            were already updated. \n         </p>\n         <p><a name=\"GUID-9F68C601-832C-4800-B45C-2CFBF0004EAF\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt;&lt;PF_Event&gt;.<em class=\"codeEmphasisStrong\">updateMaterialsDownstream</em> &lt;bool&gt;doReport</pre></div>\n         <p><a name=\"GUID-0FC76EB6-B0B6-4519-8E5E-16F06C11B279\"></a>Updates all materials in all downstream Events of the flow the PF_Event is part of.\n            \n         </p>\n         <p><a name=\"GUID-499A4176-BDD1-48AB-A052-9853BB1338B3\"></a>If the argument is passed as True, a pop up message will report the state of the Event\'s\n            material. \n         </p>\n         <p><a name=\"GUID-58FE9C62-BE3F-489A-A749-E5CDD8225B16\"></a>Returns the number of Events whose materials have been updated, or 0 if all materials\n            were already updated. \n         </p>\n         <p><a name=\"GUID-9854CCA8-3FB0-41BA-8555-2FB05D716A1A\"></a>&nbsp;&nbsp;&nbsp; \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82DDC\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E82DDD\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES AND RESULTS</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>pf = PF_Source() --Create a PF Source\n--&gt; $PF_Source:PF Source 001 @ [0.000000,0.000000,0.000000]\nne = Event() --Create an Event\n--&gt; $Event:Event 001 @ [0.000000,0.000000,0.000000]\nparticleFlow.beginEdit() --Disable automatic encapsulation\n--&gt; OK\nb = Birth() --Create a Birth operator\n--&gt; $Birth:Birth 001 @ [0.000000,0.000000,0.000000]\nrnd = RenderParticles() --Create a Render operator\n--&gt; $Render:Render 001 @ [0.000000,0.000000,0.000000]\nmtl = Material_Static() --Create a Material Static operator\n--&gt; $Material_Static:Material Static 001 @ [0.000000,0.000000,0.000000]\nshp = ShapeLibrary() --Create a Shape operator\n--&gt; $Shape:Shape 001 @ [0.000000,0.000000,0.000000]\npos = Position_Icon() --Create a Position Icon operator\n--&gt; $Position_Icon:Position Icon 001 @ [0.000000,0.000000,0.000000]\ndis = DisplayParticles Type:6 Color:white--Create a white Display operator set to Geometry \n--&gt; $Display:Display 001 @ [0.000000,0.000000,0.000000]\nparticleFlow.endEdit() --Enable automatic encapsulation\n--&gt; OK\npf.appendAction rnd --Add the Render operator to the PF Source\n--&gt; true\nne.appendAction b --Add the Birth operator to the Event\n--&gt; true\nne.appendAction pos --Add the Position Icon operator to the Event\n--&gt; true\npf.appendAction shp --Add the Shape Icon operator to the PF Source\n--&gt; true\npf.appendAction dis --Add the Display operator to the PF Source\n--&gt; true\npf.appendInitialActionList ne --Wire the Event to the PF Source as initial action list\n--&gt; true\n\nne.isMaterialHolder() --Check to see if the Event is a material holder - it is not\n--&gt; false\nne.appendAction mtl --Add the Material Static to the Event\n--&gt; true\nne.isMaterialHolder() --Check again if the Event is a material holder - still not\n--&gt; false\nmtl.setmaterial (standard diffusecolor:red name:\"RedMat\") --Assign a Red material\n--&gt; true\nne.isMaterialHolder() --Check again if the Event is a material holder - now it is!\n--&gt; true\nne.getMaterial() --Get the Event\'s material\n--&gt; RedMat:Standard\nne.activate false --Turn off the Event...\n--&gt; OK\nne.activate true -- ...and turn it on again to force an update\n--&gt; OK\n--RENDERING at this point will produce RED particles\n--based on the color of the Material in the Event.\n\nne.inheritsMaterial() --See if the Event inherits its material - it does not.\n--&gt; false\nparticleFlow.beginEdit() --Disable automatic encapsulation\n--&gt; OK\nmtl2 = Material_Static()\n--&gt; $Material_Static:Material Static 002 @ [0.000000,0.000000,0.000000]\nparticleFlow.endEdit() --Enable automatic encapsulation\n--&gt; OK\npf.appendAction mtl2 --Add the new Material Static to the PF Source\n--&gt; true\nne.inheritsMaterial() --See if the Event inherits its material - it still does not.\n--&gt; false\nmtl2.setmaterial (standard diffusecolor:blue name:\"BlueMat\") --Assign a Blue material\n--&gt; true\nne.inheritsMaterial() --See if the Event inherits its material - it has its own.\n--&gt; false\ndelete mtl --Delete the Material Static operator used by the Event\n--&gt; 1\nne.inheritsMaterial() --Now check to see if the Event inherits a material - it does!\n--&gt; true\n--RENDERING at this point will produce BLUE particles\n--based on the color of the inherited PF Source material.\n\n\ndelete mtl2 --Delete the Material Static operator used by the PF Source\n--&gt; 1\nne.activate false --Turn off the Event...\n--&gt; OK\nne.activate true -- ...and turn it on again \n--&gt; OK\n--RENDERING at this point will produce WHITE particles\n--based on the color of the Display operator.\n\nne.setMaterial (standard diffusecolor:green name:\"GreenMat\") \n--&gt; true\nne.activate false --Turn off the Event...\n--&gt; OK\nne.activate true -- ...and turn it on again \n--&gt; OK\n--RENDERING at this point will produce GREEN particles\n--The Green material is now assigned directly to the Event by MAXScript,\n--without the use of a Material operator!\n\nne.getStreamDepth() --Check the stream depth at the Event - it incorrectly reports 0\n--&gt; 0\nne.updateMaterials false --Force an update of all materials - it claims that they all were ok\n--&gt; 0\nne.getStreamDepth() --Check the stream depth at the Event again - now it is correct\n--&gt; 1\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82E83\"></a> <em class=\"strong\">This Interface is available in:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82E84\"></a> <span class=\"char_link\"><a href=\"GUID-3A3D29AB-7A0D-4522-9B9D-A5EA6B1F57BD.htm\">Event : Helper</a></span> \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E82E86\"></a> <span class=\"char_link\"><a href=\"GUID-B4D7BCE0-D4BC-48C8-8B0E-1513ED9BF43E.htm\">Particle Flow Interfaces</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";