var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-CF408D64-D4E2-4C39-90DB-62E525D7B45A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"files\">\n      <meta name=\"indexterm\" content=\"INI Files Access: Accessing INI File Keys\">\n      <meta name=\"indexterm\" content=\"Accessing INI file keys\">\n      <meta name=\"indexterm\" content=\"getIniSetting()\">\n      <meta name=\"indexterm\" content=\"setIniSetting()\">\n      <meta name=\"indexterm\" content=\"setIniForceUTF16Default()\">\n      <meta name=\"indexterm\" content=\"delIniSetting()\">\n      <meta name=\"indexterm\" content=\"hasIniSetting()\">\n      <meta name=\"indexterm\" content=\"getMaxIniFile()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Accessing INI File Keys</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CF408D64-D4E2-4C39-90DB-62E525D7B45A\"></a><div class=\"head\">\n            <h1>Accessing INI File Keys </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E35\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E34\"></a>   An INI File is a pure ASCII Text file typically used to store settings of User Interface\n               states or any arbitrary information. The data is organized in Categories containing\n               any number of Keys and corresponding Values. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E30\"></a>MAXScript provides a very error-tolerant set of functions to manage INI Files. For\n               example, setting a new category and key in an non-existent INI file will automatically\n               generate a new file without the need for any additional management function calls.\n               Getting a non-existent key value from an existing file or even from a non-existent\n               file will return an empty string without causing an error and so on. \n               		\n            </p> \n            <div><a name=\"GUID-25DECDFC-1F8C-44EC-905C-9EC5F286FE0E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The \n                  		  <span class=\"char_link\"><a href=\"GUID-05A1F59C-7F53-4CB0-A19D-272F310A8C83.htm\">cfgMgr</a></span> struct contains functions to operate specifically on the 3ds Max configuration file,\n                  \n                  		  <span class=\"filePath\">3dsmax.ini</span>.\n                  		\n               </div>\n            </div> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E2F\"></a> \n               <h3><a name=\"GUID-18DEC4A0-B290-4610-8EA9-4551E0F22083\"></a> <em class=\"strong\">The following methods provide read and write access to Categories, Keys and Values\n                     in INI files:</em>  \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69AB\"></a><pre><em class=\"codeEmphasisStrong\">getINISetting</em> &lt;filename_string&gt; &lt;section_string&gt; &lt;key_string&gt; 		</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E2D\"></a>Reads an INI setting from the specified file. Within the file, the section identified\n                  by \n                  			 <span class=\"code\">&lt;section_string&gt;</span> is located, and then the key specified by the \n                  			 <span class=\"code\">&lt;key_string&gt;</span> is located. \n                  		  \n               </p> \n               <p><a name=\"GUID-9D67E91C-E9E3-4B21-95EA-6E0F1492DAB4\"></a>The value assigned to this key is then returned as a string. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E2C\"></a>If the specified file, section, or key is not found, an empty string \"\" is returned.\n                  \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E2B\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E2A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69AA\"></a><pre>\ngetINISetting \"c:/temp/test.ini\" \"Directories\" \"Scenes\"\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E25\"></a>In \n                  			 <em class=\"strong\">3ds Max 6 and higher</em>, if only the .ini file is specified, the method will return an \n                  			 <em class=\"strong\">array of the sections</em> in the .ini file. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E24\"></a>In \n                  			 <em class=\"strong\">3ds Max 6 and higher</em>, if only the .ini file and section are specified, the method will return an \n                  			 <em class=\"strong\">array of the keys</em> in the section. \n                  		  \n               </p> \n               <p>In \n                  			 <em class=\"strong\">3ds Max 2017 Update 1</em> and higher, the return value can be up to 32,767 characters in length. In previous\n                  versions, values would be truncated at about 8000 characters. \n                  		  \n               </p> \n               <p><a name=\"GUID-C76F6ADA-DF13-4F5C-B821-DFBC921456C2\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69A9\"></a><pre><em class=\"codeEmphasisStrong\">setINISetting</em> &lt;filename_string&gt; &lt;section_string&gt; &lt;key_string&gt; &lt;key_value_string&gt; [ <em class=\"codeEmphasisStrong\">forceUTF16:</em>&lt;boolean&gt; ]</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E21\"></a> Sets an INI setting in the specified file. \n                  		  \n               </p> \n               <p><a name=\"GUID-3DAA719E-4729-4234-A044-9AE4D31CFE61\"></a>Returns a value of true if the key value was written to the file, false if the key\n                  was not written. \n                  		  \n               </p> \n               <p><a name=\"GUID-94B446EE-F73C-4E6C-9C8F-80E668A63A74\"></a>Within the file, the section identified by \n                  			 <span class=\"code\">&lt;section_string&gt;</span> is located, and then the key specified by the \n                  			 <span class=\"code\">&lt;key_string&gt;</span> is located. \n                  		  \n               </p> \n               <p><a name=\"GUID-1CB52991-854F-4352-9687-ECC3D5CAA041\"></a>The \n                  			 <span class=\"code\">&lt;key_value_string&gt;</span> is then assigned to this key. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E1A\"></a>If the specified file, section, or key is not found, a \n                  			 <em class=\"strong\">new file, section, or key</em> is created. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E19\"></a>If the specified file is read-only, or the file is open in MAXScript, the key value\n                  is not written to the file. \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E20\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E1F\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69A8\"></a><pre>\nsetINISetting \"c:/temp/test.ini\" \"Directories\" \"Scenes\" \"c:/3dsmax/scenes\"\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-9334A194-D921-4478-8242-7F66C1471BE4\"></a> The optional \n                  			 <span class=\"code\"> <em class=\"strong\">forceUTF16:</em> </span> keyword argument available in \n                  			 <em class=\"strong\">3ds Max 2013 and higher</em> controls whether the value is written using UTF16 encoding or as ASCII text. \n                  		  \n               </p> \n               <p><a name=\"GUID-BE46CE08-BD18-46DB-AC2B-CF85F932402D\"></a>By default, when the optional keyword argument is not supplied, or is supplied as\n                  true, UTF16 encoding will be used. \n                  		  \n               </p> \n               <p><a name=\"GUID-8721AB6F-E3D1-4086-B514-686DC51BE376\"></a>If the optional keyword is provided as false, the value will be written as ASCII text.\n                  \n                  		  \n               </p> \n               <p><a name=\"GUID-55D37A8D-4C7A-43A0-BF27-641940677992\"></a> An additional \n                  			 <em class=\"strong\">method</em> available in \n                  			 <em class=\"strong\">3ds Max 2013 and higher</em> controls the default behavior of the \n                  			 <span class=\"code\"> <em class=\"strong\">forceUTF16:</em> </span> optional keyword argument when it is not supplied: \n                  		  \n               </p> \n               <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">setIniForceUTF16Default</em> &lt;bool&gt;</pre></div> \n               <p><a name=\"GUID-9A9A79F8-343F-4B9A-A2C1-167F71884C05\"></a>After a fresh start, the \n                  			 <span class=\"code\"> <em class=\"strong\">forceUTF16:</em> </span> keyword argument\'s default value is true. \n                  		  \n               </p> \n               <p><a name=\"GUID-AB309675-4DD2-477A-AAAE-02E47FC6CD0B\"></a>Calling \n                  			 <span class=\"code\"> <em class=\"strong\">setIniForceUTF16Default false</em> </span> will set the default encoding of the \n                  			 <span class=\"code\"> <em class=\"strong\">setINISetting()</em> </span> method to ASCII. \n                  		  \n               </p> \n               <p><a name=\"GUID-0A3108AD-5089-4242-9C89-40661D65BEA3\"></a>Calling \n                  			 <span class=\"code\"> <em class=\"strong\">setIniForceUTF16Default true</em> </span> will set the default encoding of the \n                  			 <span class=\"code\"> <em class=\"strong\">setINISetting()</em> </span> method to UTF16. \n                  		  \n               </p> \n               <p><a name=\"GUID-5A86FB71-7A7B-4072-BCFE-138B3C2C2965\"></a>The default behavior is not sticky between sessions, after a restart it will revert\n                  back to \n                  			 <span class=\"code\"> <em class=\"strong\">forceUTF16:</em> </span> default encoding. \n                  		  \n               </p> <a name=\"TABLE_711B7D77303E4C319FBC509F8B603FFF\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"GUID-4D0BF105-4388-42D6-A984-7FAA334143DA\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>\nsetINISetting \"c:/temp/deleteme.ini\" \"Hello\" \"World\" \"10\" --utf16 encoding by default\nsetINISetting \"c:/temp/deleteme.ini\" \"Hello\" \"World\" \"10\" forceUTF16:false --force ASCII\nsetIniForceUTF16Default false --switch default behavior when keyword argument unsupplied\nsetINISetting \"c:/temp/deleteme.ini\" \"Hello\" \"World\" \"10\" --ASCII by default\nsetINISetting \"c:/temp/deleteme.ini\" \"Hello\" \"World\" \"10\" forceUTF16:true --force utf16 encoding\nsetIniForceUTF16Default true --switch back to startup default \n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"GUID-7F140140-9DF8-4E84-A54A-3F07A352896F\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69A7\"></a><pre><em class=\"codeEmphasisStrong\">delIniSetting</em> &lt;filename_string&gt; &lt;section_string&gt; &lt;key_string&gt;   </pre></div> \n               <p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-7949\"></a> Deletes the specified key from the supplied section of the given INI file. \n                  		  \n               </p> \n               <p><a name=\"GUID-CE588C89-FA13-43C5-81CC-89B743EDD20E\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69A6\"></a><pre><em class=\"codeEmphasisStrong\">delIniSetting</em> &lt;filename_string&gt; &lt;section_string&gt; </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E13\"></a>Deletes the section and all keys in the section of the given INI file. \n                  		  \n               </p> \n               <p><a name=\"GUID-8197FD81-299A-4011-9952-FAABB80E4095\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69A5\"></a><pre><em class=\"codeEmphasisStrong\">hasINISetting</em> &lt;filename_string&gt; &lt;section_string&gt; [&lt;key_string&gt;] </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E10\"></a> Returns \n                  			 <span class=\"code\"> <em class=\"strong\">true</em> </span> if the INI setting exists in the specified file. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E0F\"></a>This method is available in \n                  			 <em class=\"strong\">3ds Max 2008 and higher</em>. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E0E\"></a>Within the file, the section identified by \n                  			 <span class=\"code\"> <em class=\"strong\">&lt;section_string&gt;</em> </span> is located, and then the key specified by the \n                  			 <span class=\"code\"> <em class=\"strong\">&lt;key_string&gt;</em> </span> is tested for. \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E0D\"></a>If \n                  			 <span class=\"code\"> <em class=\"strong\">&lt;key_string&gt;</em> </span> is not specified, the section specified by \n                  			 <span class=\"code\"> <em class=\"strong\">&lt;section_string&gt;</em> </span> is tested for. \n                  		  \n               </p> \n               <p><a name=\"GUID-EE1BC781-64FE-44FD-942A-2E559D459294\"></a>&nbsp;&nbsp;&nbsp; \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_07211450F2C34270A5D2ABDC7D1D6159\"></a> \n               <h3><a name=\"GUID-196DEF46-5D10-446F-AF8A-B71261CA917F\"></a>Related Methods:\n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69A4\"></a><pre><em class=\"codeEmphasisStrong\">getMAXIniFile</em>() </pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E09\"></a>In \n                  			 <em class=\"strong\">3ds Max 6 and higher</em>, returns the current 3dsmax.ini file as a string. For some products that store the\n                  ini settings in the registry, this method returns undefined. \n                  		  \n               </p> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1E07\"></a> <span class=\"char_link\"><a href=\"GUID-BA196B48-8ECA-4E0C-AE2E-F7EFAAF39844.htm\">External File Methods</a></span> \n                     </p> \n                  </li>\n                  <li><span class=\"char_link\"><a href=\"GUID-05A1F59C-7F53-4CB0-A19D-272F310A8C83.htm\">3ds Max Configuration File 3dsmax.ini\n                           		</a></span></li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";