var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-CF4BD614-5A08-4DB6-9039-49EE32AA5178\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>dependsOn For Scripted Controllers</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CF4BD614-5A08-4DB6-9039-49EE32AA5178\"></a><div class=\"head\">\n            <h1>dependsOn For Scripted Controllers </h1>\n         </div>\n         <div><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7F88\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C9F\"></a>This is <em class=\"strong\">obsolete</em> in <em class=\"strong\">3ds Max 8 and higher</em>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C9E\"></a>You should assign Nodes to User Variables instead. See <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span> \n               </p> \n               <p><a name=\"GUID-3EC675F9-A3DC-4DC2-864E-AEAF5998308F\"></a>&nbsp;&nbsp;&nbsp; \n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C9C\"></a> <span class=\"code\"> <em class=\"strong\">dependsOn</em> </span> was used with scripted controllers <em class=\"strong\">in versions prior to 3ds Max 8</em> to enable interactive update of scripted controllers when the code in them depends\n            on other objects in the scene. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C9B\"></a>Place a call to <span class=\"code\"> <em class=\"strong\">dependsOn</em> </span> in the controller script somewhere (usually at the top), with a list of objects on\n            which the controller depends. Interactive changes to any of these objects will cause\n            the object containing the script controller to also update. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C9A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C99\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B3B\"></a><pre>\nA $foo.pos controller script:\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B3A\"></a><pre>\ndependsOn $foo2 $foo3\n($foo2.pos + $foo3.pos) / 2\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C93\"></a>will always keep <span class=\"code\"> <em class=\"strong\">$foo</em> </span> centered between <span class=\"code\"> <em class=\"strong\">$foo1</em> </span> and <span class=\"code\"> <em class=\"strong\">$foo2</em> </span>. The objects given to the <span class=\"code\"> <em class=\"strong\">dependsOn()</em> </span> function can be any MAX object, controllers, base object, nodes, materials, etc.\n            They must be individual, explicit objects, not wild-card path names or arrays of objects.\n            The object can be the exact controller you want to depend on or any containing object.\n            The strict dependency for the above script would be, \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C92\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C91\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B39\"></a><pre>\ndependsOn$foo2.pos.controller $foo3.pos.controller\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C8D\"></a>The simpler <span class=\"code\"> <em class=\"strong\">$foo2</em> </span><span class=\"code\"> <em class=\"strong\">$foo3</em> </span> will catch *any* kind of changes to those nodes or components in them like base objects,\n            modifiers, or materials and update the script-controlled object. The dependency is\n            established the first time the controller is evaluated after any script change or\n            recompile. This can be when editing in a controller property box, or after a scene\n            load. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C8C\"></a>You can programmatically force a recompile and reset of the dependents by setting\n            the control script to itself: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C8B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C8A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B38\"></a><pre>\n$foo.pos.controller.script = $foo.pos.controller.script\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C84\"></a> <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C83\"></a> <span class=\"char_link\"><a href=\"GUID-94B704E2-E93F-495B-BB65-A2E99D9E2F12.htm\">\'This\' Local Variable in Scripted Controllers</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";