var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-D0175A53-6007-4F83-8637-1DEFD033E84D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>CRT Debug Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D0175A53-6007-4F83-8637-1DEFD033E84D\"></a><div class=\"head\">\n            <h1>CRT Debug Functions </h1>\n         </div>\n         <p><a name=\"P_1E7CDA9A5FEA43F2B06A8DBDB1C4EBF4\"></a> A few diagnostic tools were added to MAXScript in <em class=\"strong\">3ds Max 2012</em>. \n         </p>\n         <p><a name=\"P_EE5186E70F3649DD89931B5C384ADC31\"></a>They are located in the SDK samples in the maxscript subdirectory <em class=\"mild\">&lt;maxsdk&gt;\\samples\\maxscript\\Diagnostics\\MxsDebugCRT.cpp</em> \n         </p>\n         <p><a name=\"P_CCAD8A63AB2F42B7AF676EFACE4C6EB8\"></a> This file contains some powerful maxscript methods for diagnosing and testing using\n            MAXScript. \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_F25788B6C4354AAB9A272CFFE9480D49\"></a><pre><em class=\"codeEmphasisStrong\">CRTCorruptHeap</em> &lt;int&gt;offset</pre></div>\n         <p><a name=\"P_FB70E31D702C4749A294766B184A590A\"></a> This method will corrupt the Heap! Dangerous! Used for testing only! \n         </p>\n         <p><a name=\"P_A14A50F4D81A4C7EA62497787EB4A222\"></a> The offset parameter defines how far past the end of the pointer you want to do a\n            wild write. Large numbers tend to not crash randomly later. This simply serves to\n            corrupt memory in random places, that may or may not crash the application. \n         </p>\n         <p><a name=\"P_BE71C53809384DF49ED641D28E6ED907\"></a></p>\n         <div class=\"codeBlock\"><a name=\"P_CB2A450D545D4889A2F0C658F09F55FC\"></a><pre><em class=\"codeEmphasisStrong\">CRTCheckMemory</em>()</pre></div>\n         <p><a name=\"P_997A81D2F6774E4C8794EDCFC1A10216\"></a>A MAXScript wrapper around the CRT (C Run-Time) Debug function _CrtCheckMemory \n         </p>\n         <p><a name=\"P_CE27C29BFE5546FB8FA419E1DF090404\"></a> <em class=\"strong\">From MSDN:</em> \n         </p>\n         <p><a name=\"P_02BE47D8A62F48B28103298A8A106900\"></a> Confirms the integrity of the memory blocks allocated in the debug heap (debug version\n            only). \n         </p>\n         <p><a name=\"P_1440D1EDA88441AE9FE40F11BD7FEE79\"></a> The _CrtCheckMemory function validates memory allocated by the debug heap manager\n            by verifying \n         </p>\n         <p><a name=\"P_7B4A346A13F947A48A1AB8637711C426\"></a> the underlying base heap and inspecting every memory block. If an error or memory\n            inconsistency \n         </p>\n         <p><a name=\"P_80A468484BAB4202A02EE8D5D64DC393\"></a> is encountered in the underlying base heap, the debug header information, or the\n            overwrite buffers, \n         </p>\n         <p><a name=\"P_F4805FB3B408471A98AFFC5B2BC9D860\"></a> _CrtCheckMemory generates a debug report with information describing the error condition.\n            \n         </p>\n         <p><a name=\"P_1F249EADAF6C4CDF9363D234D4610D6F\"></a> When _DEBUG is not defined, calls to _CrtCheckMemory are removed during preprocessing.\n            \n         </p>\n         <p><a name=\"P_6EE3A2214E2E4F9E8C8B6D305C20036E\"></a> This function is used to detect heap corruptions created by the previous MAXScript\n            method. In practice this detects only small heap corruptions, of only a few bytes\n            (i.e. 1-6). \n         </p>\n         <p><a name=\"P_8992CF772CBB491090DD006E5246B0DE\"></a> This is because with every debug heap allocation is a small region of guard bytes\n            (about 4 bytes) that wraps each heap allocation. Anything larger than a few bytes\n            will corrupt some other pointers bytes, and thus this method doesn\'t work very well.\n            \n         </p>\n         <div class=\"codeBlock\"><a name=\"P_9B71C62FAFD9490D9791977D8220BC25\"></a><pre><em class=\"codeEmphasisStrong\">CRTCheckAssert</em> &lt;int&gt;choice</pre></div>\n         <p><a name=\"P_21E714C5A69943DDAC8AFA8A113A77D7\"></a> This simply fires one of two asserts. \n         </p>\n         <p><a name=\"P_EA4C16C3A3DD4ACC87DE7C753359E027\"></a> Passing 1 as the argument fires an assert implemented in the max source code, Maxutil.dll.\n            This corresponds to a DbgAsset macro found in the maxsdk: (assert1.h) \n         </p>\n         <p><a name=\"P_0A1FC70D6B434805AD521EADFFA1B215\"></a> Passing 2 as the argument fires an assert implemented in the C runtime (i.e. Microsofts\n            version). \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";