var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-D1AF9C63-53F2-4598-836D-AD882A477401\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface : BooleanObjectManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D1AF9C63-53F2-4598-836D-AD882A477401\"></a><div class=\"head\">\n            <h1>Interface : BooleanObjectManager </h1>\n         </div>\n         <p>This Core Interface exposes methods for managing \n            		<span class=\"char_link\"><a href=\"GUID-BFCB8480-8EAE-43E4-8B37-3374DCD6BDCE.htm\">Boolean3</a></span> objects. Note that the Boolean3 object itself provides a MixinInterface that exposes\n            the same functionality. Available in \n            		<em class=\"strong\">3ds Max 2017 and higher</em>. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-2804\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <p>None. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetNumBooleanObjects</em> &lt;&amp;integer&gt;count\ncount is Out parameter</pre></div>\n         <p> Gets the number of Boolean3 objects in the scene, and writes it into the by-reference\n            argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetNumberOfOperands</em> &lt;index&gt;index &lt;&amp;integer&gt;count\ncount is Out parameter</pre></div>\n         <p> Gets the number of operand in the indexed Boolean3 Object, and writes it into the\n            by-reference second argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetOperandName</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;&amp;TSTR&gt;name\nname is Out parameter</pre></div>\n         <p> Gets the name of the indexed operand in the indexed Boolean3 Object, and writes it\n            into the by-reference third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.SetOperandName</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;&amp;TSTR&gt;name\nname is In parameter</pre></div>\n         <p> Sets the name of the indexed operand in the indexed Boolean3 Object to the string\n            value supplied by the by-reference third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetOperandType</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;&amp;enum&gt;type\ntype enums: {<em class=\"codeEmphasisStrong\">#system|#generated</em>}\ntype is Out parameter</pre></div>\n         <p> Gets the type of the indexed operand in the indexed Boolean3 Object, and writes it\n            into the by-reference third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetNumberOfChildren</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;&amp;integer&gt;children\nchildren is Out parameter</pre></div>\n         <p> Gets the number of children of the indexed operand in the indexed Boolean3 Object,\n            and writes it into the by-reference third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetOperationType</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;&amp;enum&gt;type\ntype enums: {<em class=\"codeEmphasisStrong\">#union|#intersection|#subtraction|#merge|#attach|#insert</em>}\ntype is Out parameter</pre></div>\n         <p> Gets the operation type of the indexed operand in the indexed Boolean3 Object, and\n            writes the enum into the by-reference third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.SetOperationType</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;enum&gt;type\ntype enums: {<em class=\"codeEmphasisStrong\">#union|#intersection|#subtraction|#merge|#attach|#insert</em>}</pre></div>\n         <p> Sets the operation type of the indexed operand in the indexed Boolean3 Object to\n            the enum value supplied by the third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetOperationOptions</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;&amp;enum&gt;options\noptions enums: {<em class=\"codeEmphasisStrong\">#none|#imprint|#cookie</em>}\noptions is Out parameter</pre></div>\n         <p> Gets the operation option of the indexed operand in the indexed Boolean3 Object,\n            and writes it into the by-reference third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.SetOperationOptions</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;enum&gt;options\noptions enums: {<em class=\"codeEmphasisStrong\">#none|#imprint|#cookie</em>}</pre></div>\n         <p> Sets the operation option of the indexed operand in the indexed Boolean3 Object to\n            the enum value supplied by the third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetSeamType</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;&amp;enum&gt;type\ntype enums: {<em class=\"codeEmphasisStrong\">#simple|#fillet</em>}\ntype is Out parameter</pre></div>\n         <p> Gets the seam type of the indexed operand in the indexed Boolean3 Object, and writes\n            it into the by-reference third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.SetSeamType</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;enum&gt;type\ntype enums: {<em class=\"codeEmphasisStrong\">#simple|#fillet</em>}</pre></div>\n         <p> Sets the seam type of the indexed operand in the indexed Boolean3 Object to the enum\n            value supplied by the third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetSeamSize</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;time&gt;time &lt;&amp;float&gt;size &lt;&amp;interval&gt;interval\nsize is Out parameter\ninterval is In and Out parameter</pre></div>\n         <p> Gets the seam size of the indexed operand in the indexed Boolean3 Object in the interval\n            specified by the fourth argument, and writes it into the by-reference third argument.\n            \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.SetSeamSize</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;time&gt;time &lt;float&gt;size</pre></div>\n         <p> Sets the seam size of the indexed operand in the indexed Boolean3 Object at the time\n            specified by the third argument to the value supplied by the fourth argument. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetSolo</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;&amp;bool&gt;solo\nsolo is Out parameter</pre></div>\n         <p> Gets the Solo property of the indexed operand in the indexed Boolean3 Object, and\n            writes it into the by-reference third argument as a boolean - True when solo, False\n            when not. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.SetSolo</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;bool&gt;solo</pre></div>\n         <p> Sets the Solo property of the indexed operand in the indexed Boolean3 Object to the\n            Boolean value supplied by the third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetSoloOperandIndex</em> &lt;index&gt;index &lt;&amp;index&gt;operandIndex\noperandIndex is Out parameter</pre></div>\n         <p> Gets the index of the Solo operand in the indexed Boolean3 Object, and writes it\n            into the by-reference second argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetDisable</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;&amp;bool&gt;disable\ndisable is Out parameter</pre></div>\n         <p> Gets the disabled property of the indexed operand in the indexed Boolean3 Object,\n            and writes it into the by-reference third argument - True when disabled, False when\n            enabled. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.SetDisable</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;bool&gt;disable</pre></div>\n         <p> Sets the disabled property of the indexed operand in the indexed Boolean3 Object\n            to the bool values supplied by the third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.HasSubdivs</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;time&gt;time &lt;&amp;bool&gt;\nsubsub is Out parameter</pre></div>\n         <p> Gets the existence of Subdivs in the indexed operand in the indexed Boolean3 Object,\n            and writes the result into the by-reference third argument - True when the operand\n            has Subdivs, False when it does not. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.GetSubdivs</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;time&gt;time &lt;&amp;integer&gt;subdivs &lt;&amp;interval&gt;interval\nsubdivs is Out parameter\ninterval is In and Out parameter</pre></div>\n         <p> Gets the Subdivs in the indexed operand in the indexed Boolean3 Object in the time\n            interval given by the by-reference fourth argument, and writes the result into the\n            by-reference third argument. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.SetSubdivs</em> &lt;index&gt;index &lt;index&gt;operandIndex &lt;time&gt;time &lt;integer&gt;subdivs</pre></div>\n         <p> Sets the Subdivs of the indexed operand in the indexed Boolean3 Object at the time\n            given by the third argument, and writes the result into the by-reference fourth argument.\n            \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.RemoveOperand</em> &lt;index&gt;index &lt;index&gt;operandIndex</pre></div>\n         <p> Removes the indexed operand from the indexed Boolean3 Object. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.AppendOperand</em> &lt;index&gt;index &lt;node&gt;boolNode &lt;node&gt;operandNode &lt;bool&gt;hold</pre></div>\n         <p> Appends the node specified by the third argument to the operands list of the indexed\n            Boolean3 Object. \n            	 \n         </p>\n         <p> The fourth argument controls the hold. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">BooleanObjectManager.InsertOperand</em> &lt;index&gt;index &lt;node&gt;boolNode &lt;node&gt;operandNode &lt;index&gt;where &lt;bool&gt;hold</pre></div>\n         <p> Inserts the node specified by the third argument into the operands list of the indexed\n            Boolean3 Object. \n            	 \n         </p>\n         <p> The fourth argument controls the position to insert at. \n            	 \n         </p>\n         <p> The fifth argument controls the hold. \n            	 \n         </p>\n         <p> Returns True on success, False on failure. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p> <em class=\"strong\">Actions:</em> \n         </p>\n         <p>None. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";