var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-D2A11E7A-5E6B-4D78-8936-26A0C4080033\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Final Step Update Example\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Final Step Update Example</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D2A11E7A-5E6B-4D78-8936-26A0C4080033\"></a><div class=\"head\">\n            <h1>Final Step Update Example </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E84612\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84615\"></a> <em class=\"strong\">Description:</em>  \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84616\"></a>The following example shows the default Final Step Update script with detailed comments.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84617\"></a> <em class=\"strong\">Can Be Used With:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84618\"></a>Used by <span class=\"char_link\"><a href=\"GUID-FBD4578E-1CDD-4924-B9E2-39650D646881.htm\">PF_Source</a></span> as default Final Step Update script. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E84619\"></a> <em class=\"strong\">Effect:</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8461A\"></a>The default script modifies particle speed and direction, causing particles to follow\n               a bulb-shaped path: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8461B\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-3E335C88-DC07-4A60-93D4-2551A6D3495F-low.gif\"></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8461C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8461D\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-3E17\"></a><pre>\n--Get the current particle system executing the script\npf_node_current = particleFlow.scriptRunner()\n \n--In case the current particle system is a valid node...\nif (pf_node_current != undefined) then(\n \n--Get the total number of particles\ncount = pf_node_current.NumParticles()\n--Loop from 1 to the number of particles\nfor i in 1 to count do(\n--Set the particle index in the container to the current i value.\n--This makes the i-th particle in the container the current one:\npf_node_current.particleIndex = i\n \n--Get the age of the particle, multiply by 5 and use as angle\n--to define the particle speed\n--Decreasing the constant 5 will slow down the rotation\n--Increasing the constant will speed up the rotation\nage = 5*pf_node_current.particleAge\n \n--Calculate a factor variable based on the particle age\n--This variable will define the radius of the bulb and will vary\n--thanks to the sine of the age over time.\n--Change the constant 20 to change the radius.\nfactor = 20*(sin(2*age)+1)\n \n--Finally, calculate and set the particle position\n--using the factor as Radius and the particle index as Angle\n--in the function of the circle. The position of the node has to be\n--added to move the particles to the origin of the Source.\n--Info: In general, a circle can be drawn using an Angle\n--going from 0 to 2*Pi and the following functions for X and Y:\n--X = CenterX+Radius*Cos(Angle)\n--Y = CenterY+Radius*Sin(Angle)\n--In our case, CenterX and CenterY are 0, Radius is set to factor,\n--and Angle is based on the particle index multiplied by 77.\n--The Z position is based on the age.\npf_node_current.particlePosition = [factor*cos(77*i), factor*sin(77*i), -age] + pf_node_current.pos\n \n)--end i loop\n)--end if\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8464B\"></a> <span class=\"char_link\"><a href=\"GUID-570A4B99-5421-4CEE-B6FA-2D9A8230A71F.htm\">Every Step Update Example</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8464C\"></a> <span class=\"char_link\"><a href=\"GUID-FBD4578E-1CDD-4924-B9E2-39650D646881.htm\">PF_Source : GeometryClass</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8464D\"></a> <span class=\"char_link\"><a href=\"GUID-5BD0E849-290D-478D-A689-A44B4F7B4EC9.htm\">Particle Flow Sample Scripts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";