var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-D33B4031-2AB2-4A84-BA96-6BA96DD5A042\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface actionMan\">\n      <meta name=\"indexterm\" content=\"actionMan Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: actionMan</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D33B4031-2AB2-4A84-BA96-6BA96DD5A042\"></a><div class=\"head\">\n            <h1>Interface: actionMan </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6EAA\"></a> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6EA5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6EA4\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; \n                           						<span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; actionMan \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-37C71495-C364-4DEB-ACD4-BCC3F4B47BD2\"></a>The \n               		  <em class=\"strong\">actionMan Interface</em> provides MAXScript access to the \n               		  <em class=\"strong\">ActionTables</em> and \n               		  <em class=\"strong\">ActionItems</em> that represent the actions that can be assigned to Toolbars, Menus, QuadMenus and\n               Keyboard Shortcuts using the Customize User Interface dialog. ActionItems include\n               MacroScripts created using the Macro Recorder or written manually by a MAXScript user.\n               This interface provides methods for executing actions and for managing Keyboard Shortcuts\n               files as well as access to the ActionTables and through them the ActionItems MixinInterfaces,\n               which are documented at the end of this topic. \n               		\n            </p> \n            <p><a name=\"GUID-66943EB6-8DC7-4865-8B0D-4C30256A9050\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"GUID-386A16F5-758A-4E0F-9437-04AFFDD0A6E5\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">actionMan.numActionTables</em> : integer : Read</pre></div> \n            <p><a name=\"GUID-45922745-32D2-4865-9B3A-D63F9FE98BA3\"></a>Contains the number of Action Tables registered with the Action Manager. Read-only.\n               \n               		\n            </p> \n            <p><a name=\"GUID-8D2EA819-E3B1-4983-BE0D-B644F6CFC5C9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"GUID-41C79D18-244C-44F9-B70C-C3505D2430D2\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5CEE\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">actionMan.executeAction</em> &lt;integer&gt;tableId &lt;string&gt;persistentId 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E9E\"></a>Executes the action specified by the table ID and persistent ID. \n               		\n            </p> \n            <p><a name=\"GUID-B6BB9BBD-BEEC-4D60-862F-CC1F88B2A459\"></a>Returns True if successful, False otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-3CB4D213-2C01-4A51-8CD9-8EC1B97CCCF9\"></a>You can get an action\'s IDs by enabling the MacroRecorder and performing actions in\n               the \n               		  <em class=\"strong\">3ds Max</em> User Interface. Actions that can be performed only using the actionMan interface\n               will appear as \n               		  <span class=\"code\"> <em class=\"strong\">actionMan.executeAction()</em> </span> calls with the corresponding IDs. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E9D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E9C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E9B\"></a><ul>\n                           <li> \n                              <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E99\"></a>Enable MacroRecorder. \n                                 						  \n                              </p> \n                           </li>\n                           <li> \n                              <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E97\"></a>Go to Main Menu &gt; Tools &gt; Selection Floater. \n                                 						  \n                              </p> \n                           </li>\n                           <li> \n                              <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E95\"></a>The MacroRecorder will display the code: \n                                 						  \n                              </p> \n                           </li>\n                        </ul> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5CED\"></a><pre>\nactionMan.executeAction 0 \"40266\" -- Selection: Selection Floater\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"GUID-CE584216-255A-4BB6-8778-7EB123F1624B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5CEC\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">actionMan.loadKeyboardFile</em> &lt;filename&gt;file   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E91\"></a>Loads the keyboard shortcuts settings from the specified file. \n               		\n            </p> \n            <p><img src=\"../images/GUID-21C87158-BBA7-4B63-B8F7-CB9BA17CA2CA-low.gif\"> <span class=\"char_link\"><a href=\"GUID-F90290FA-90A2-4720-B9FE-A4CCE0446252.htm\">NEW</a></span><em class=\"strong\"> in 3ds Max 2020.1 Update:</em> If the keyboard shortcut file is in a legacy format (<span class=\"filePath\">.kbdx</span>), the file is converted and saved under User Settings in the new \n               		  <span class=\"filePath\">.hsx</span> format. For example: \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>actionman.loadKeyboardFile \"D:/my_kbdx/my_kbdx_file.kbdx\"\n--&gt; true \nactionman.getKeyboardFile()\n\"C:/Users/UserName/Autodesk/3ds Max 2020/User Settings/my_kbdx_file.hsx\"</pre></div> \n            <p><a name=\"GUID-5B2F8CA4-7AC7-4501-B218-5E3594959DC8\"></a>Returns True if successful and False otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-7A81F79B-3812-4F3C-B68E-DB6B83A864B0\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5CEB\"></a><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">actionMan.saveKeyboardFile</em> &lt;filename&gt;file </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E8E\"></a>Saves the keyboard shortcuts settings to the specified filename. \n               		\n            </p> \n            <p><a name=\"GUID-4A05EA22-E9EA-4E47-9F73-31CB5D6834D6\"></a>Returns True if successful and False otherwise. \n               		\n            </p> \n            <p><a name=\"GUID-D14526E2-3902-44B1-B12F-308DD8AE63F9\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5CEA\"></a><pre>&lt;filename&gt;<em class=\"codeEmphasisStrong\">actionMan.getKeyboardFile</em>() </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E8B\"></a>Returns the filename of the current keyboard shortcuts file. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E8A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E89\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5CE9\"></a><pre>\nactionMan.getKeyboardFile()\n\"C:\\Program Files\\Autodesk\\3ds Max 2008\\UI\\MaxStartUI.kbd\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <div class=\"codeBlock\"><pre>&lt;Interface&gt;<em class=\"codeEmphasisStrong\">actionMan.getActionTable</em> &lt;index&gt;index</pre></div> \n            <p><a name=\"GUID-17230371-CA35-452A-99B8-8AB364528B62\"></a>Returns the &lt;MixinInterface:ActionTable&gt; of the indexed Action Table. \n               		\n            </p> \n            <p><a name=\"GUID-6BECE6F8-8F3B-49B4-B869-F82FBA4215AF\"></a>The index must be in the range of 1 to \n               		  <em class=\"strong\"> <span class=\"code\">actionMan.numActionTables</span> </em>. \n               		\n            </p> \n            <p><a name=\"GUID-A6E52771-4E32-4373-99D1-53959C10291D\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_493ADB6876F74BBCB8662491B2BD9E87\"></a> \n            <h2><a name=\"GUID-4EBC1E07-81D3-44C6-A01F-D084BE736992\"></a>ActionTable MixinInterface\n            </h2> \n            <p><a name=\"GUID-7C6644C4-6295-4159-AEE3-146301C68A57\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;ActionTable&gt;<em class=\"codeEmphasisStrong\">.id</em> : DWORD : Read</pre></div> \n            <p><a name=\"GUID-90737F9D-F50F-4577-A646-952AA236D234\"></a>Contains the ID of the ActionTable. Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-E23285D2-588E-4746-8190-B24A225D7599\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;ActionTable&gt;<em class=\"codeEmphasisStrong\">.name</em> : string : Read</pre></div> \n            <p><a name=\"GUID-AA14D7C0-BF8E-463C-971C-76D870C5FDF9\"></a>Contains the Name of the ActionTable. Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-A36024B9-4339-4119-8A4F-1CC630DFDD8B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;ActionTable&gt;<em class=\"codeEmphasisStrong\">.contextID</em> : DWORD : Read</pre></div> \n            <p><a name=\"GUID-89F85CB2-0C4F-443A-97BC-A753773AB300\"></a>Contains the ContextID of the ActionTable. Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-F71F1C48-E79A-4DCD-8121-CDF8D1FDF247\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;ActionTable&gt;<em class=\"codeEmphasisStrong\">.contextName</em> : string : Read</pre></div> \n            <p><a name=\"GUID-D4BC5568-F073-40C9-97BE-6C885A94905A\"></a>Contains the Context Name of the ActionTable. Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-C1018E7A-A07D-4C29-A50A-1CE48BB56D88\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;ActionTable&gt;<em class=\"codeEmphasisStrong\">.numActionItems</em> : integer : Read</pre></div> \n            <p><a name=\"GUID-50537193-A274-43B3-AFCD-F9CA19DC7169\"></a>Contains the number of ActionItems in the ActionTable. Read-only. \n               		\n            </p> \n            <p><a name=\"GUID-F36F91B7-8E2C-41DC-B2B4-B27F578EF43A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"GUID-72C388EB-FA5A-4BED-8343-132F744DBF77\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;Interface&gt;&lt;ActionTable&gt;<em class=\"codeEmphasisStrong\">.getActionItem</em> &lt;index&gt;index</pre></div> \n            <p><a name=\"GUID-22EC98CC-41C8-4BCE-A569-BC064142D64A\"></a>Returns the &lt;MixinInterface:ActionItem&gt; of the indexed Action Item. \n               		\n            </p> \n            <p><a name=\"GUID-5AEF1CC5-7357-40DF-812C-4F271C8307D3\"></a>The index must be between 1 and \n               		  <span class=\"code\">&lt;ActionTable&gt;.<em class=\"strong\">numActionItems</em></span>. \n               		\n            </p> \n            <p><a name=\"GUID-8C272798-279F-4284-97C3-6A0CF6C743B2\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_3D94C463C0FD4E7FAA5A17024567F12A\"></a> \n            <h2><a name=\"GUID-781740F0-BE79-463C-9C58-5C41414CE156\"></a>ActionItem MixinInterface\n            </h2> \n            <p><a name=\"GUID-8C43CA37-835D-46B4-B7B1-3512B987F60F\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.id</em> : DWORD : Read</pre></div> \n            <p><a name=\"GUID-608A9F03-6413-48D9-A9A1-EC558ABA62B3\"></a>Contains the ID of the ActionItem. \n               		\n            </p> \n            <p><a name=\"GUID-AC1A61ED-E916-418E-A189-05D0238A6E97\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.isVisible</em> : boolean : Read</pre></div> \n            <p><a name=\"GUID-A2CF39D5-C5DC-4BED-8054-8EB3BC66F216\"></a>Contains the Visible state of the ActionItem as determined by its isVisible event\n               handler. \n               		\n            </p> \n            <p><a name=\"GUID-63DB249D-7041-45B0-90E4-21094573827B\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.isEnabled</em> : boolean : Read</pre></div> \n            <p><a name=\"GUID-5976D945-BB36-4550-AAF7-DB90C9353155\"></a>Contains the Enabled state of the ActionItem as determined by its isEnabled event\n               handler. \n               		\n            </p> \n            <p><a name=\"GUID-1D8E8388-66CE-492E-915C-7ED7FB955A60\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.isChecked</em> : boolean : Read</pre></div> \n            <p><a name=\"GUID-353DAF3F-82A5-420A-BF34-8A889C7C2F5E\"></a>Contains the Checked state of the ActionItem as determined by its isChecked event\n               handler. \n               		\n            </p> \n            <p><a name=\"GUID-248847BE-7A6C-44C2-8B5F-6E7DEB627784\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <p><a name=\"GUID-1BD4F4D4-DC57-4FDB-9F72-71B529C77A69\"></a> <em class=\"strong\">Methods:</em> \n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.getDescription</em> &lt;&amp;String&gt;text\n\ntext is Out parameter</pre></div> \n            <p><a name=\"GUID-A8A8D7BE-1523-43DF-BAEE-8EDF239B3FA4\"></a>Sets the by-reference argument to the ActionItem\'s Description. \n               		\n            </p> \n            <p><a name=\"GUID-EECC4114-7815-44C5-9009-6C489DB9CE61\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.getCategory</em> &lt;&amp;String&gt;text\n\ntext is Out parameter</pre></div> \n            <p><a name=\"GUID-DE316260-B84B-48EA-81FA-E279CABD1F60\"></a>Sets the by-reference argument to the ActionItem\'s Category. \n               		\n            </p> \n            <p><a name=\"GUID-F710A5F1-C7ED-4B6F-B536-6DCA220D7C31\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.getButtonText</em> &lt;&amp;String&gt;text\n\ntext is Out parameter</pre></div> \n            <p><a name=\"GUID-A71BB45C-7F5B-421A-ACDA-B2FD26B9EB36\"></a>Sets the by-reference argument to the text that will be displayed on a button when\n               the ActionItem is assigned to a Toolbar. \n               		\n            </p> \n            <p><a name=\"GUID-8039F5FC-DCDB-44DA-B04D-0FE59F5C5C6E\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;void&gt;&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.getMenuText</em> &lt;&amp;String&gt;text\n\ntext is Out parameter</pre></div> \n            <p><a name=\"GUID-6C6B7B77-63E4-4FBF-BEA8-E39FFC52275F\"></a>Sets the by-reference argument to the text that will be displayed when the ActionItem\n               is assigned to a Menu or QuadMenu. \n               		\n            </p> \n            <p><a name=\"GUID-B0D4931B-77F8-4919-BBA2-767199BB8FBB\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;boolean&gt;&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.hasIcon()</em></pre></div> \n            <p><a name=\"GUID-795DAA90-7F5C-4041-9496-DF232D64B391\"></a>Returns True if the ActionItem has an icon associated with it, False if the ActionItem\n               has no icon. \n               		\n            </p> \n            <p><a name=\"GUID-B8FAB689-745D-40A5-844C-EEEAA2EE28AC\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;bool&gt;&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.getIconFileName</em> &lt;&amp;String&gt;fileName\n\nfileName is Out parameter</pre></div> \n            <p><a name=\"GUID-FB8BB680-F4CB-4B34-A2FF-9E332F738368\"></a>Sets the by-reference argument to the Icon file name, or to \"\" if no Icon file is\n               associated with the ActionItem. \n               		\n            </p> \n            <p><a name=\"GUID-1DBE3855-FFBA-418E-A2FB-DD2CD1772263\"></a>Returns True on success, False if no Icon file is associated with the ActionItem.\n               \n               		\n            </p> \n            <p><a name=\"GUID-6B0405F9-2091-4176-BE39-348F48C8B571\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>&lt;index&gt;&lt;ActionItem&gt;<em class=\"codeEmphasisStrong\">.getIconIndex()</em></pre></div> \n            <p><a name=\"GUID-3A7BD227-2328-44A1-BE7C-64F30D4A0C79\"></a>Returns the index of the Action Item\'s Icon within the Icon file, or 0 if there is\n               no icon associated with it (<span class=\"code\">&lt;ActionItem&gt;<em class=\"strong\">.hasIcon()</em></span> returns \n               		  <span class=\"code\"> <em class=\"strong\">false</em> </span>). \n               		\n            </p> \n            <p><a name=\"GUID-A0205A07-0581-4694-BDF2-A7651B2A6266\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D79\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1D78\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-698D\"></a><pre>\nfor i = 1 to actionMan.numActionTables-1 do \n(\n	atbl = actionMan.getActionTable i\n	format \"% ID:% Name:\'%\' ContextID:% ContextName:\'%\' NumActionItems:%\\n\" i atbl.id atbl.name atbl.contextID atbl.contextName atbl.numActionItems\n	for j = 1 to atbl.numActionItems do\n	(\n		aitm = atbl.getActionItem j\n		aitm.getDescription &amp;desc \n		aitm.getCategory &amp;cat\n		aitm.getButtonText &amp;btn\n		aitm.getMenuText &amp;mnu\n		hasicon = aitm.hasIcon()\n		if hasicon then\n		(\n			aitm.getIconFileName &amp;iconfile \n			iconfile = filenamefrompath iconfile \n			iconindex = aitm.getIconIndex()\n			format \"\\t% ID:% Desc:\'%\' Cat:\'%\' BtnTxt:\'%\' MnuTxt:\'%\' Icon:[%,%] \\n\" j aitm.id desc cat btn mnu iconfile iconindex\n		)\n		else\n			format \"\\t% ID:% Desc:\'%\' Cat:\'%\' BtnTxt:\'%\' MnuTxt:\'%\'\\n\" j aitm.id desc cat btn mnu \n	)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"TABLE_9A11B6DBA2194D288217A849FC4A7D1A\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"GUID-20E80644-21E4-4D96-9166-0C3956DBAC62\"></a><p class=\"table-body\"> <em class=\"strong\">PARTIAL OUTPUT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><pre>\n...\n3 ID:-1159893849 Name:\'Render\' ContextID:0 ContextName:\'Main UI\' NumActionItems:1\n	1 ID:36864 Desc:\'Render Message Window Toggle\' Cat:\'Render\' BtnTxt:\'Render Message Window...\' MnuTxt:\'Render Message Window...\'\n4 ID:1724956863 Name:\'Asset Tracking System\' ContextID:0 ContextName:\'Main UI\' NumActionItems:2\n	1 ID:0 Desc:\'Generate Proxies\' Cat:\'Asset Tracking System\' BtnTxt:\'Generate Proxies\' MnuTxt:\'Generate Stale Proxies\'\n	2 ID:1 Desc:\'Set Proxy Resolution...\' Cat:\'Asset Tracking System\' BtnTxt:\'Set Proxy Resolution...\' MnuTxt:\'Set Proxy Resolution...\'\n5 ID:161818329 Name:\'FixAmbientActions\' ContextID:2 ContextName:\'Material Editor\' NumActionItems:2\n	1 ID:1 Desc:\'Fix Ambient All\' Cat:\'Utilities\' BtnTxt:\'Fix Ambient All\' MnuTxt:\'Fix Ambient All\'\n	2 ID:2 Desc:\'Fix Ambient Selected\' Cat:\'Utilities\' BtnTxt:\'Fix Ambient Selected\' MnuTxt:\'Fix Ambient Selected\'\n6 ID:132537306 Name:\'MMCleanActions\' ContextID:2 ContextName:\'Material Editor\' NumActionItems:1\n	1 ID:1 Desc:\'Clean  MultiMaterial\' Cat:\'Utilities\' BtnTxt:\'Clean  MultiMaterial\' MnuTxt:\'Clean MultiMaterial...\'\n7 ID:4745576 Name:\'InstanceDuplMapActions\' ContextID:2 ContextName:\'Material Editor\' NumActionItems:1\n	1 ID:1 Desc:\'Instance Duplicate Map\' Cat:\'Utilities\' BtnTxt:\'Instance Duplicate Map\' MnuTxt:\'Instance Duplicate Map...\'\n8 ID:-1682387772 Name:\'Scene State Manager\' ContextID:0 ContextName:\'Main UI\' NumActionItems:3\n	1 ID:4096 Desc:\'Save Scene State\' Cat:\'Scene State\' BtnTxt:\'Save Scene State...\' MnuTxt:\'Save Scene State...\'\n	2 ID:4112 Desc:\'Scene State Manager Dialog Toggle\' Cat:\'Scene State\' BtnTxt:\'Manage Scene States...\' MnuTxt:\'Manage Scene States...\'\n	3 ID:8192 Desc:\'Restore Scene State\' Cat:\'Scene State\' BtnTxt:\'Restore Scene State\' MnuTxt:\'Restore Scene State\'\n9 ID:-1172021248 Name:\'Containers\' ContextID:0 ContextName:\'Main UI\' NumActionItems:17\n	1 ID:0 Desc:\'Inherit Container\' Cat:\'Containers\' BtnTxt:\'Inherit Container\' MnuTxt:\'Inherit Container\' Icon:[Containers,6] \n	2 ID:1 Desc:\'Create Container from Selection\' Cat:\'Containers\' BtnTxt:\'Create Container from Selection\' MnuTxt:\'Create Container from Selection\' Icon:[Containers,4] \n	3 ID:2 Desc:\'Add Selected to Container\' Cat:\'Containers\' BtnTxt:\'Add Selected to Container\' MnuTxt:\'Add Selected to Container\' Icon:[Containers,2] \n	4 ID:3 Desc:\'Remove Selected from Container\' Cat:\'Containers\' BtnTxt:\'Remove Selected from Container\' MnuTxt:\'Remove Selected from Container\' Icon:[Containers,12] \n	5 ID:4 Desc:\'Unload Container\' Cat:\'Containers\' BtnTxt:\'Unload Container\' MnuTxt:\'Unload Container\' Icon:[Containers,14] \n	6 ID:5 Desc:\'Load Container\' Cat:\'Containers\' BtnTxt:\'Load Container\' MnuTxt:\'Load Container\' Icon:[Containers,7] \n	7 ID:6 Desc:\'Close Container\' Cat:\'Containers\' BtnTxt:\'Close Container\' MnuTxt:\'Close Container\' Icon:[Containers,3] \n	8 ID:7 Desc:\'Open Container\' Cat:\'Containers\' BtnTxt:\'Open Container\' MnuTxt:\'Open Container\' Icon:[Containers,9] \n	9 ID:8 Desc:\'Save Container\' Cat:\'Containers\' BtnTxt:\'Save Container\' MnuTxt:\'Save Container\' Icon:[Containers,13] \n	10 ID:9 Desc:\'Update Container\' Cat:\'Containers\' BtnTxt:\'Update Container\' MnuTxt:\'Update Container\' Icon:[Containers,1] \n	11 ID:10 Desc:\'Reload Container\' Cat:\'Containers\' BtnTxt:\'Reload Container\' MnuTxt:\'Reload Container\' Icon:[Containers,11] \n	12 ID:11 Desc:\'Make All Content Unique\' Cat:\'Containers\' BtnTxt:\'Make All Content Unique\' MnuTxt:\'Make All Content Unique\' Icon:[Containers,15] \n	13 ID:12 Desc:\'Merge Container Source\' Cat:\'Containers\' BtnTxt:\'Merge Container Source\' MnuTxt:\'Merge Container Source\' Icon:[Containers,8] \n	14 ID:13 Desc:\'Edit Container\' Cat:\'Containers\' BtnTxt:\'Edit Container\' MnuTxt:\'Edit Container\' Icon:[Containers,5] \n	15 ID:14 Desc:\'Override Object Properties\' Cat:\'Containers\' BtnTxt:\'Override Object Properties\' MnuTxt:\'Override Object Properties\' Icon:[Containers,10] \n	16 ID:15 Desc:\'Select Content\'s Container\' Cat:\'Containers\' BtnTxt:\'Select Content\'s Container\' MnuTxt:\'Select Content\'s Container\' Icon:[Containers,16] \n	17 ID:16 Desc:\'Override All Locks\' Cat:\'Containers\' BtnTxt:\'Override All Locks\' MnuTxt:\'Override All Locks\' Icon:[Containers,18] \n...\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6EA1\"></a>All Action Items are macro recorded when executed. This includes main menu items,\n            CUI buttons, keyboard shortcuts, and quad menu items. \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E82\"></a> <span class=\"char_link\"><a href=\"GUID-38CB8317-6EB2-49D1-A086-B06BA2A141AE.htm\">Action Manager</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E81\"></a> <span class=\"char_link\"><a href=\"\">The Macro Recorder</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E80\"></a> <span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining Macro Scripts</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E7F\"></a> <span class=\"char_link\"><a href=\"GUID-81403EB7-94F8-4EAA-8026-1A495343AE06.htm\">The MAXScript Listener Window</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E7E\"></a> <span class=\"char_link\"><a href=\"GUID-263B5831-EC57-4ED9-B5DB-DD26FC93A384.htm\">Turning On the Listener Log</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6E7D\"></a> <span class=\"char_link\"><a href=\"GUID-8079981C-344A-47C2-B5CB-4D03B6B68FDC.htm\">Listener Commands</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";