var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-D4B43A33-8342-4BC9-80AB-91460861D37C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"files\">\n      <meta name=\"indexterm\" content=\"standard open and save file dialogs\">\n      <meta name=\"indexterm\" content=\"getSaveFileName()\">\n      <meta name=\"indexterm\" content=\"getOpenFileName()\">\n      <meta name=\"indexterm\" content=\"getSavePath()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Standard Open and Save File Dialogs</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D4B43A33-8342-4BC9-80AB-91460861D37C\"></a><div class=\"head\">\n            <h1>Standard Open and Save File Dialogs </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F4E\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F4D\"></a>    The following methods display the standard <em class=\"strong\">3ds Max</em> file open, file save, or folder selection browser dialog: \n            </p> \n            <p><a name=\"GUID-CA337937-11FE-4AC6-A7E7-8104FA141155\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69D2\"></a><pre><em class=\"codeEmphasisStrong\">getOpenFileName</em> [	<em class=\"codeEmphasisStrong\">caption</em>:&lt;title&gt; ] \\\n[	<em class=\"codeEmphasisStrong\">filename</em>:&lt;seed_filename_string&gt; ] \\\n[	<em class=\"codeEmphasisStrong\">types</em>:&lt;description1&gt;|&lt;pattern1&gt;|&lt;description2&gt;|&lt;pattern2&gt;|...| ] \\\n[	<em class=\"codeEmphasisStrong\">historyCategory</em>:&lt;string&gt; ] 	 </pre></div> \n            <p><a name=\"GUID-22F48CDA-6425-4643-8FBC-A7B2683FF17E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69D1\"></a><pre><em class=\"codeEmphasisStrong\">getSaveFileName</em> [ <em class=\"codeEmphasisStrong\">caption</em>:&lt;title&gt; ] \\\n[ <em class=\"codeEmphasisStrong\">filename</em>:&lt;seed_filename_string&gt; ] \\\n[ <em class=\"codeEmphasisStrong\">types</em>:&lt;description1&gt;|&lt;pattern1&gt;|&lt;description2&gt;|&lt;pattern2&gt;|...| ] \\\n[ <em class=\"codeEmphasisStrong\">historyCategory</em>:&lt;string&gt; ]   </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F3F\"></a>Both functions return a fully-specified file path name or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the user cancels out. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F3E\"></a>When the optional keyword <span class=\"code\"> <em class=\"strong\">filename:</em> </span> is supplied, the string is used to define the path and file name of the file to be\n               loaded or saved. The dialog automatically navigates to the specified path (if available\n               on the disk/network), displays its content in the browsing area and suggests the file\n               name in the \"File name\" field. If the path does not exist, the current path is used\n               and only the file name is displayed as requested. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F3C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F3B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69D0\"></a><pre>\nf = getOpenFileName caption:\"Open A Test File:\" \\\nfilename:\"c:/test/test.txt\"\n--if the path exists, will result in something like:\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F34\"></a> <img src=\"../images/GUID-6090691B-E038-4EC5-810A-BEBAB4FF4ABD-low.gif\"> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F32\"></a>The <span class=\"code\"> <em class=\"strong\">types:</em> </span> parameter lets you specify custom file types and suffixes for the file type drop-down\n               list in the open and save dialogs. You supply a string for this argument that is formatted\n               in a special way, as follows: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69CF\"></a><pre>\"&lt;description1&gt;|&lt;pattern1&gt;|&lt;description2&gt;|&lt;pattern2&gt;|...|\"</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F30\"></a>In other words, a sequence of file type descriptions and file type patterns each separated\n               by a \'|\' vertical bar and terminated by a \'|\' vertical bar. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F2F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F2E\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69CE\"></a><pre>\nf = getOpenFileName \\\ntypes:\"Data(*.dat)|*.dat|Excel(*.csv)|*.csv|All|*.*|\"\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F29\"></a><p class=\"table-body\">Specifies three types in the file type drop-down list, the first reading \"Data(*.dat)\"\n                           and matching *.dat and the second reading \"Excel(*.csv)\" and matching *.csv and the\n                           third reading \"All\" and matching any file. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F27\"></a>The <span class=\"code\"> <em class=\"strong\">getSaveFileName()</em> </span> function tests for the pre-existence of the file with the chosen file type suffix\n               added. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F25\"></a>The <em class=\"strong\">history dropdown list</em> in the file load and save dialogs keeps track of previously selected files according\n               to a specified history name. It is available since <em class=\"strong\">3ds Max 2008</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F24\"></a>If <span class=\"code\"> <em class=\"strong\">historyCategory:</em> </span> is not specified, the caption text is used if specified, and if no caption is specified,\n               the default category \"MAXScriptFileOpenSave\" is used instead. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F23\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F22\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69CD\"></a><pre>\nfilename = getOpenFileName \\\ncaption:\"Render To Texture Object Presets Open\" \\\nfilename:(getDir #renderPresets + @\"\\\") \\\ntypes:\"Object Preset(*.rtp)|*.rtp\" \\\nhistoryCategory:\"RTTObjectPresets\"\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F19\"></a>By using the same <span class=\"code\"> <em class=\"strong\">historyCategory:</em> </span> name for a pair of open and save dialogs, users will see a consistent history dropdown\n               in the dialogs. \n            </p> \n            <p><a name=\"GUID-863BEF17-B91F-4D0D-BF96-4D98A6B1D823\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69CC\"></a><pre><em class=\"codeEmphasisStrong\">getSavePath</em> [ <em class=\"codeEmphasisStrong\">caption</em>:&lt;window_caption_string&gt; ] [ <em class=\"codeEmphasisStrong\">initialDir</em>:&lt;pathname&gt; ] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F15\"></a> This function displays a folder selection browser for the user to select a folder.\n               Returns a string path name for the selected folder or the value <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the user presses <em class=\"strong\">Cancel</em> in the folder browser. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F14\"></a>If the <span class=\"code\"> <em class=\"strong\">initialDir:</em> </span> keyword argument is specified, the Browse For Folder dialog will be opened at the\n               specified directory. Symbolic pathnames are acceptable as the pathname. Available\n               in <em class=\"strong\">3ds Max 8 and higher</em>. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F13\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F12\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-69CB\"></a><pre>\ngetSavePath caption:\"my title\" initialDir:\"$scripts\"\ngetSavePath caption:\"my title\" initialDir:(getDir #maxroot)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F0B\"></a> <span class=\"char_link\"><a href=\"GUID-BB041082-3EEF-4576-9D69-5B258A59065E.htm\">Filestream Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F0A\"></a> <span class=\"char_link\"><a href=\"GUID-BA196B48-8ECA-4E0C-AE2E-F7EFAAF39844.htm\">External File Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F09\"></a> <span class=\"char_link\"><a href=\"GUID-0EE531B2-6FF8-4D0B-ACA1-5400E0B9D604.htm\">File Name Parsing</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";