var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-D62137AE-E500-4B42-983D-E7443E3DFF04\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"StatusPanel Interface\">\n      <meta name=\"indexterm\" content=\"Interface StatusPanel\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: StatusPanel</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D62137AE-E500-4B42-983D-E7443E3DFF04\"></a><div class=\"head\">\n            <h1>Interface: StatusPanel </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76D0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76CF\"></a><p class=\"table-body\">   <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt;StatusPanel \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76CE\"></a>This Interface provides control over the visibility of the Status Panel. The Status\n            Panel is the area at the bottom of the <em class=\"strong\">3ds Max</em> UI containing the Mini Listener, system prompt, selection lock, X,Y,Z values, time\n            controls, keying and viewport navigation controls will be visible. \n         </p>\n         <p><a name=\"GUID-985EC5FD-8139-48FB-9705-B059EF2848D4\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76CD\"></a> \n            <h2><a name=\"GUID-7FBC4700-F377-40ED-A664-9BA3CF04B58D\"></a> <em class=\"strong\">Interface: statusPanel</em> \n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76CC\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5512\"></a><pre><em class=\"codeEmphasisStrong\">StatusPanel</em>.<em class=\"codeEmphasisStrong\">visible</em> : boolean : Read|Write 	 </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76CB\"></a>Get/Set the visible state of the Status Panel. When set to true, the Status Panel\n               will be visible. When set to false, the panel will be hidden. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76CA\"></a>Using the<span class=\"code\"> <em class=\"strong\"> statusPanel </em> </span>interface’s .<span class=\"code\"> <em class=\"strong\">visible </em> </span>property together with the trackbar and time slider visibility controls, you can achieve\n               a Super-Expert mode with just the viewports and the main menu displayed: \n            </p> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76C9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76C8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5511\"></a><pre>\nmacroScript SuperExpertMode category: \"MXS Help Examples\"\n(\n--get the inverse of the curren visibility state of the time slider:\nstate = not(timeslider.isVisible())&nbsp;\n--set the trackbar visiblity to the new value:\ntrackbar.visible = state\n--set the time slider visiblity to the new value:\ntimeSlider.setVisible state\n--if true, exit the expert mode, if false, engage it:\nif state then cui.expertModeOff() else cui.expertModeOn()\n--finally, set the status panel visibility:\nstatusPanel.visible = state\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76C7\"></a> <span class=\"char_link\"><a href=\"GUID-776617CF-FAED-45E7-8BDD-FCAB34421625.htm\">Status Bar</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76C6\"></a> <span class=\"char_link\"><a href=\"GUID-1F607FAC-886A-4B99-9B84-FCF5BAC5C140.htm\">Prompt Line</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76C5\"></a> <span class=\"char_link\"><a href=\"GUID-3EED3E7C-D7BB-4160-99BB-82B7872CA86D.htm\">Coordinate Display</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76C4\"></a> <span class=\"char_link\"><a href=\"GUID-5C069EAA-E2EB-4F7B-B6AC-DECD51121348.htm\">Progress Bar Display</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-76C3\"></a> <span class=\"char_link\"><a href=\"GUID-2C42EF48-5949-4EC9-A067-EBE1267CCBFD.htm\">Status Bar Buttons</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";