var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-D703CF91-2F15-4D69-9C0E-5A102058DC11\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: IAutoCamMax</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D703CF91-2F15-4D69-9C0E-5A102058DC11\"></a><div class=\"head\">\n            <h1>Interface: IAutoCamMax</h1>\n         </div>\n         <p> This Core Interface exposes the new viewport navigation Pivot Ball gizmo which allows\n            the orbiting about a hit point under the mouse cursor, or about a locked point in\n            space. Available in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>.\n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Properties:</em> \n         </p>\n         <p>None \n            	 \n         </p>\n         <p><em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;IAutoCamMax.ShowPivotBall &lt;HWND&gt;hwnd &lt;&amp;point2&gt;center &lt;&amp;point3&gt;mouse &lt;boolean&gt;useMousePoint\n       center is In and Out parameter\n       mouse is In and Out parameter</pre></div>\n         <p>Shows the viewport navigation Pivot Ball in the specified viewport. \n            	 \n         </p>\n         <p>The first ‘hwnd’ argument specifies the viewport by its Windows handle – see \n            		<span class=\"char_link\"><a href=\"GUID-8AA71F9E-F4F0-4437-A44E-9683619E89DE.htm\">viewport.getHWND()</a></span> for details. \n            	 \n         </p>\n         <p>The second ‘center’ by-reference argument supplies the 2D screen position of the Pivot\n            Ball. \n            	 \n         </p>\n         <p>The third ‘mouse’ by-reference argument will contain the 3D mouse position of the\n            Pivot Ball. \n            	 \n         </p>\n         <p>When the fourth ‘useMousePoint’ Boolean argument is set to False, the Pivot Ball will\n            use the 2D center position. When set to True, the 3D mouse point will be used. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;IAutoCamMax.HidePivotBall &lt;HWND&gt;hwnd</pre></div>\n         <p>Hides the viewport navigation Pivot Ball in the specified viewport. \n            	 \n         </p>\n         <p>The ‘hwnd’ argument specifies the viewport by its Windows handle – see \n            		<span class=\"char_link\"><a href=\"GUID-8AA71F9E-F4F0-4437-A44E-9683619E89DE.htm\">viewport.getHWND()</a></span> for details. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;IAutoCamMax.SetHoldPivotBallPosition &lt;boolean&gt;hold</pre></div>\n         <p>Locks the viewport navigation Pivot Ball to its current 3D world position to provide\n            a static point of interest for viewport orbit operations. \n            	 \n         </p>\n         <p>When the argument is True, the Pivot Ball will be locked to its position and will\n            not change the position if viewport navigation operations are performed. \n            	 \n         </p>\n         <p>When the argument is False, the Pivot Ball will be unlocked and will update dynamically\n            (default behavior). \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Actions:</em> \n         </p>\n         <p>None \n            	 \n         </p>\n         <p> </p><a name=\"TABLE_AC1B291046F343CBABEC6ED2F287EA5E\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"><em class=\"strong\">Example</em> \n                  </td>\n               </tr>\n               <tr class=\"not-ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>centerPoint = [0.5,0.5] --use the center of the viewport\nmousePoint = [0,0,0]\n--Show the Pivot Ball at the center of the active viewport:\nIAutoCamMax.ShowPivotBall (viewport.getHWnd()) &amp;centerPoint &amp;mousePoint false\nredrawViews()   --redraw the views to see the Pivot Ball\np = point pos:mousePoint --create a Point helper at the Pivot Ball position\n \nIAutoCamMax.SetHoldPivotBallPosition true --lock the Pivot Ball at its current position\n \nIAutoCamMax.HidePivotBall (viewport.getHWnd()) --	hide the Pivot Ball of the active viewport</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";