var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-D7B7488F-BE23-4A1E-BA83-A48C21F6C73B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"rollout\">\n      <meta name=\"indexterm\" content=\"Accessing locals and other items in a rollout from external code\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Accessing Locals and Other Items in a Rollout from External Code</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D7B7488F-BE23-4A1E-BA83-A48C21F6C73B\"></a><div class=\"head\">\n            <h1>Accessing Locals and Other Items in a Rollout from External Code </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-67CD\"></a>The local components defined in a scripted utility or rollout are accessible to external\n            code as properties of the utility or rollout object. Recall that the rollout object\n            is assigned to a new global variable (or local variable if a nested rollout) named\n            on the utility or rollout definition. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-67CC\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-67CB\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7488\"></a><pre>\nutility foo \"Utility\"\n(\n  local var1, var2\n  checkbox enable \"Enable\"\n  rollout setup \"Setup\" -- local rollout\n  (\n    local var3\n    button doit \"Execute\" enabled:false\n    on doit pressed do\n    (\n      var3 = var1 + var2\n    )\n  ) --end rollout\n  function frab a b = (var1 = b-a; var2 = a*b)\n  on enable changed state do\n  (\n    frab 10 20\n    if state then\n    (\n      addRollout setup\n      setup.doit.enabled = true\n    )\n    else\n      removeRollout setup\n  ) --end on enable handler\n) --end utility\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-67AD\"></a>The example defines the utility and places the utility object in a global variable\n            named <span class=\"code\"> <em class=\"strong\">foo</em> </span>. You can access components in the utility from the Listener or other code as properties\n            of that object, using the name of the variable or item as the property name. Any event-handler\n            functions supplied for user-interface items can also be accessed as sub-properties\n            of the item, using the event name as the property name. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-67AC\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-67AB\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7487\"></a><pre>\n-- Gets and prints foo\'s local variable, var1\nprint foo.var1\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7486\"></a><pre>\n-- test foo\'s enabled checkbox state:\nif foo.enable.state then print \"ON!\" else print \"OFF\"\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7485\"></a><pre>\n-- Sets the foo\'s enabled checkbox state to false.\n-- This will change the checkbox, but not execute the event handler\n-- which deals with the adding/removing the local rollout\nfoo.enable.state = false\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7484\"></a><pre>\n-- Calls the \'changed\' handler function of the enable checkbox\n-- This will call the handler with a value of false, but will NOT\n-- change the checkbox\'s state itself.\nfoo.enable.changed false\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7483\"></a><pre>\n-- This willbothcall the handler with a value of false\n-- AND change the checkbox\'s state, mimicking a checkbox change\n-- via the UI and the mouse:\nfoo.enable.changed (foo.enable.state = false)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7482\"></a><pre>\n-- Calls its \'frab\' function local to the foo utility:\nfoo.frab 100 200\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7481\"></a><pre>\n-- Sets foo’s setup rollout local variable, var3\nfoo.setup.var3 = 42\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7480\"></a><pre>\n-- Calls the change handler function for doit button in the\n-- setup rollout of the foo utility:\nfoo.setup.doit.pressed()\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6782\"></a>The local variables, functions, and structures in scripted utilities and rollouts\n            are initialized as soon as the utility or rollout is first defined, rather than when\n            the utility or rollout is first displayed. This allows other code to use local functions\n            and access local values at any time after definition. \n         </p>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75DF\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"GUID-C2ADF0DF-94D7-4D9A-A128-B79F88CCE7A8\"></a>Whenever a utility or rollout is opened, all local values will be reinitialized and\n                  any values set before opening will be lost! \n               </p> \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-677C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-677B\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-747F\"></a><pre>\n-- define a test rollout with a spinner UI element\n-- initialized to value of 50.0 and two local variables:\nrollout test \"Test\"\n(\n  local testValue1\n  local testValue2 = 10\n  spinner testSpinner \"Spinner\" range:[0.0,100.0,50.0]\n)\n--&gt; Rollout:test\ntest.testSpinner.value --peek into the spinner\'s value\n--&gt; 50.0 --it is 50 as expected\ntest.testValue1 --get the first local variable\'s value\n--&gt; undefined --it is set implicitly to undefined\ntest.testValue2 --get the other local variable\'s value\n--&gt; 10 --it is set to 10 as expected\ntest.testSpinner.value = 60.0 --change the spinner\'s value to 60.0\n--&gt; 60.0\ntest.testSpinner.value --get the value back to see if it worked\n--&gt; 60.0\ntest.testValue1 = 20 --set the first local\'s value to 20\n--&gt; 20\ntest.testValue1 --get the first local\'s value\n--&gt; 20 --now it is initialized to 20\ntest.testValue2 = 40 --set the second local\'s value to 40\n--&gt; 40\ntest.testValue2 --get the second local\'s value\n--&gt; 40 --now it is 40\n--now create a dialog with the rollout -\ncreateDialog test 100 40\n--all variables will be reset!\n--&gt; true\ntest.testSpinner.value --get the spinner value again\n--&gt; 50.0 --it is back to the default value of 50.0\ntest.testValue1 --get the first local\'s value again\n--&gt; undefined --it is back to undefined\ntest.testValue2 --get the second local\'s value again\n--&gt; 10 --it is back to 10\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";