var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-D839F477-A534-4764-BC16-93B702F72807\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Controller\">\n      <meta name=\"indexterm\" content=\"MAXWrapper - Value\">\n      <meta name=\"indexterm\" content=\"animation controllers\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Animation Controllers</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D839F477-A534-4764-BC16-93B702F72807\"></a><div class=\"head\">\n            <h1>Animation Controllers </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D5A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D5B\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; Animation Controllers \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D5D\"></a>All animation in <em class=\"strong\">3ds Max</em> is implemented using one of the many <em class=\"strong\">controller</em> classes accessible in the Track View and Motion Panel, or assigned automatically\n            by <em class=\"strong\">3ds Max</em> when you use the Animate button to do keyframing. Certain controllers (keyframeable\n            controllers) store their animation values as <em class=\"strong\">keys</em>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D5E\"></a>This section includes topics that discuss all aspects of scripting <em class=\"strong\">3ds Max</em> controllers and the Key classes used in keyframing. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D5F\"></a> <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controller Common Properties, Operators, and Methods</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D60\"></a> <span class=\"char_link\"><a href=\"GUID-71299FC9-9EE4-45EB-AF7D-146F31EB6AC6.htm\">Controller Time Functions</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D61\"></a> <span class=\"char_link\"><a href=\"GUID-B1700B1D-B1EA-4A6C-B4A3-A29DB26C8C02.htm\">Controller Key Functions</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D62\"></a> <span class=\"char_link\"><a href=\"GUID-46A7941F-9A1E-49AF-B607-5516DC6ACCEF.htm\">Time and Key Functions on Object Hierarchies</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D63\"></a> <span class=\"char_link\"><a href=\"GUID-FC8E346B-AF24-426F-9A64-73C8AA865F40.htm\">Controller Out-Of-Range Functions</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D64\"></a> <span class=\"char_link\"><a href=\"GUID-2184B9B7-716F-4CFB-A7A6-E121DB24B08A.htm\">Controller Ease and Multiplier Curve Functions</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D65\"></a> <span class=\"char_link\"><a href=\"GUID-E6615B92-8BC4-4A13-BC31-86E006657A5C.htm\">Controller Key Reducer</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D66\"></a> <span class=\"char_link\"><a href=\"GUID-21B5A897-3CF5-4AEA-A4FA-500CA0E3438B.htm\">Controllers - Superclass Level</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D67\"></a>The controllers are arranged in a hierarchy of superclasses and classes. All classes\n            in a superclass output a specific data type (for example, Float or Point3). Each animatable\n            property in <em class=\"strong\">3ds Max</em> has a data type, and any of the classes in the superclass that outputs that data\n            type can be assigned that property. So, for example, the linear_float and noise_float\n            controllers are classes in the Float superclass, and either can be assigned to the\n            <span class=\"code\"> <em class=\"strong\">height</em> </span> property of a box, which has a Float data type. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D68\"></a>The list of controller superclasses can be determined using the <span class=\"code\"> <em class=\"strong\">apropos()</em> </span> function: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F21\"></a><pre>\napropos \"controller:super\"\n</pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D6A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D6B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F20\"></a><pre>\napropos\"controller:super\"\nMasterPointController (const MAXSuperClass): MasterPointController\nMasterBlockController (const MAXSuperClass): MasterBlockController\nMorphController (const MAXSuperClass): MorphController\nMatrix3Controller (const MAXSuperClass): Matrix3Controller\nScaleController (const MAXSuperClass): ScaleController\nRotationController (const MAXSuperClass): RotationController\nQuatController (const MAXSuperClass): QuatController\nPositionController (const MAXSuperClass): PositionController\nPoint4Controller (const MAXSuperClass): Point4Controller\nPoint3Controller (const MAXSuperClass): Point3Controller\nFloatController (const MAXSuperClass): FloatController\nOK\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D7C\"></a>The list of available controllers can be determined using the <span class=\"code\"> <em class=\"strong\">showClass()</em> </span> function: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2F1F\"></a><pre>\nshowClass \"*: *controller*\"\n</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D7E\"></a>which lists all the known classes that have \"controller\" in their superclass name.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7D7F\"></a>The controllers include, at least, <em class=\"strong\">3ds Max</em>’s core controllers and any 3<sup> <span class=\"charspan-emphasis\">rd</span> </sup>-party plug-in controllers. In some cases, embedded controllers for some complex plug-ins\n            may be visible in the <span class=\"code\"> <em class=\"strong\">showClass()</em> </span> listing (such as for Character Studio). You should <em class=\"strong\">not</em> attempt to create and use these controllers individually, this may result in system\n            exceptions. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";