var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-D8DBE1AA-F3D7-4708-93FA-7C28845A1C03\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"random()\">\n      <meta name=\"indexterm\" content=\"copy()\">\n      <meta name=\"indexterm\" content=\"composite()\">\n      <meta name=\"indexterm\" content=\"turbulence()\">\n      <meta name=\"indexterm\" content=\"noise4()\">\n      <meta name=\"indexterm\" content=\"noise3()\">\n      <meta name=\"indexterm\" content=\"fractalNoise()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Color Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D8DBE1AA-F3D7-4708-93FA-7C28845A1C03\"></a><div class=\"head\">\n            <h1>Color Values </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B70\"></a>All the places that colors turn up in MAXScript (such as, wireColor, light color,\n            and others) are represented by instances of the \n            		<em class=\"strong\">Color</em> class. You can also use \n            		<span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 values</a></span> to specify colors. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B71\"></a> <em class=\"strong\">Literals</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FBD\"></a><pre> <em class=\"codeEmphasisStrong\">red</em> <em class=\"codeEmphasisStrong\">green</em> <em class=\"codeEmphasisStrong\">blue</em> <em class=\"codeEmphasisStrong\">white</em> <em class=\"codeEmphasisStrong\">black</em> <em class=\"codeEmphasisStrong\">orange</em> <em class=\"codeEmphasisStrong\">yellow</em> <em class=\"codeEmphasisStrong\">brown</em> <em class=\"codeEmphasisStrong\">gray</em> </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B7B\"></a>Predefined \n            		<span class=\"char_link\"><a href=\"GUID-92E3BC56-2B85-4D54-AB88-EC0B5B23C470.htm\">MAXScript globals</a></span>. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B7C\"></a> <em class=\"strong\">Constructors</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FBC\"></a><pre><em class=\"codeEmphasisStrong\">color </em>&lt;r&gt; &lt;g&gt; &lt;b&gt; [ &lt;a&gt; ]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B7E\"></a>r,g,b and optional alpha are float values, typically in the range of 0 to 255. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FBB\"></a><pre>&lt;point3&gt; <em class=\"codeEmphasisStrong\">as color</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B80\"></a>Interprets x as r, y as g, z as b. Alpha is assumed opaque (255). \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B81\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FBA\"></a><pre>&lt;color&gt;.<em class=\"codeEmphasisStrong\">red</em> or <em class=\"codeEmphasisStrong\">.r</em>: Float\n&lt;color&gt;.<em class=\"codeEmphasisStrong\">green</em> or <em class=\"codeEmphasisStrong\">.g</em>: Float\n&lt;color&gt;.<em class=\"codeEmphasisStrong\">blue</em> or <em class=\"codeEmphasisStrong\">.b</em>: Float\n&lt;color&gt;.<em class=\"codeEmphasisStrong\">alpha</em> or <em class=\"codeEmphasisStrong\">.a</em>: Float</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B86\"></a>Color component properties \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FB9\"></a><pre>&lt;color&gt;.<em class=\"codeEmphasisStrong\">hue</em> or <em class=\"codeEmphasisStrong\">.h</em>: Float\n&lt;color&gt;.<em class=\"codeEmphasisStrong\">saturation</em> or <em class=\"codeEmphasisStrong\">.s</em>: Float\n&lt;color&gt;.<em class=\"codeEmphasisStrong\">value</em> or <em class=\"codeEmphasisStrong\">.v</em>: Float</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B8A\"></a>Derived properties \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B8B\"></a> <em class=\"strong\">Operators</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FB8\"></a><pre>&lt;color&gt; <em class=\"codeEmphasisStrong\">== </em>&lt;color&gt;\n&lt;color&gt; <em class=\"codeEmphasisStrong\">!=</em> &lt;color&gt;&nbsp;\n&lt;color&gt; <em class=\"codeEmphasisStrong\">+</em> &lt;color_or_number&gt;\n&lt;color&gt; <em class=\"codeEmphasisStrong\">-</em> &lt;color_or_number&gt;\n&lt;color&gt; <em class=\"codeEmphasisStrong\">* </em>&lt;color_or_number&gt;\n&lt;color&gt; <em class=\"codeEmphasisStrong\">/ </em>&lt;color_or_number&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B93\"></a>Channel-by-channel mathematical operations. Numbers operate on R,G,B and A channels\n            equally. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FB7\"></a><pre><em class=\"codeEmphasisStrong\">-</em>&lt;color&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B95\"></a>unary minus \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87B97\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87B98\"></a><p class=\"table-body\"> <em class=\"strong\">IMPORTANT NOTES ON COLOR OPERATIONS:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87B99\"></a><p class=\"table-body\">The addition and subtraction operations are performed on the R, G, B and A channels\n                        equally: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FB6\"></a><pre>\naColor = color 1 1 1\n(color111) aColor + aColor\n(color 2 2 2 510)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87B9F\"></a><p class=\"table-body\">The high Alpha value is caused by the fact that MAXScript does not print the Alpha\n                        value if it is 255, but internally the value of the variable aColor is (color 1 1\n                        1 255). Thus, adding the Alpha channels of 255 to 255 produces an Alpha of 512, analogous\n                        to the R,G, and B channels. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BA0\"></a><p class=\"table-body\">While the Color Values allow floating point components, when originally implemented\n                        in<em class=\"strong\">3ds Max 2</em>, it was assumed that they would be used \n                        					 <em class=\"strong\">mainly</em> for 8 bit per channel RGBA values because MAXScript did not support floating point\n                        color bitmaps at that point in time. An internal conversion is performed when printing\n                        color values or converting other values to color. \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BA1\"></a><p class=\"table-body\">Thus, multiplication of two color values leads to seemingly strange results: \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FB5\"></a><pre>\naColor = color 1 1 1\naColor * aColor\n(color 0.00392157 0.00392157 0.00392157)\naColor * [1,1,1]\n(color 0.00392157 0.00392157 0.00392157)\naColor = color 128 128 128\naColor * aColor\n(color 64.251 64.251 64.251)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BAC\"></a><p class=\"table-body\">The reason for these results when multiplying color values is that the actual component\n                        values are float values normally in the range of 0 to 1. \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BAD\"></a><p class=\"table-body\">The scaling from 0-1 to 0-255 is an operation that MAXScript performs to the underlying\n                        color value when the value is printed or converted to some other value type. \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BAE\"></a><p class=\"table-body\">A gray value of 128 multiplied by a gray value of 128 is not really 128*128 = 16384,\n                        which is a blown out white, but \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BAF\"></a><p class=\"table-body\">(128/255.0 * 128/255.0)*255 or (.501961*.501961)*255 \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BB0\"></a><p class=\"table-body\">which is the DARKER shade of gray (color 64.251 64.251 64.251) \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BB1\"></a><p class=\"table-body\">So, when (color 1 1 1 255) is converted to components in the range from 0 to 1, it\n                        also results in RGB components of (1.0/255*1.0/255)*255=0.00392157, while the Alpha\n                        of 255 turns into 1.0 and then back into 255. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BB2\"></a><p class=\"table-body\">Thus, the \n                        					 <em class=\"strong\">Color Value</em> is \n                        					 <em class=\"strong\">not</em> well suited for \n                        					 <em class=\"strong\">High Dynamic Range Image</em> calculations with \n                        					 <em class=\"strong\">floating point color components</em>. \n                        				  \n                     </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BB3\"></a><p class=\"table-body\">For that type of operations, MAXScript provides a \n                        					 <span class=\"char_link\"><a href=\"GUID-31C598AB-B3BE-4965-996E-0CD59C0EC018.htm\">Point4 value</a></span> that can be used to represent floating point colors without implicit conversion from/to\n                        the 0-255 range. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6BB0\"></a>    <em class=\"strong\">Methods</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FB4\"></a><pre><em class=\"codeEmphasisStrong\">copy</em> &lt;color&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87BB9\"></a>Creates a new copy of the color value. \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87BBA\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BBB\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FB3\"></a><pre>\nnewClr = copy oldClr\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BBF\"></a><p class=\"table-body\">The new value contains a copy of the input color value, and is independent of the\n                        input color value. \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FB2\"></a><pre><em class=\"codeEmphasisStrong\">random</em> &lt;from_color&gt; &lt;to_color&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87BC2\"></a>Returns a random color between the given colors. The alpha component of the result\n            will always be 255. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FB1\"></a><pre><em class=\"codeEmphasisStrong\">composite</em> &lt;color1&gt; &lt;color2&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87BC5\"></a>Composites \n            		<span class=\"code\"> <em class=\"strong\">color1</em> </span> over \n            		<span class=\"code\"> <em class=\"strong\">color2</em> </span> through \n            		<span class=\"code\"> <em class=\"strong\">color1</em> </span>\'s alpha. This function is equivalent to: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87BC6\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BC7\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FB0\"></a><pre>\ncolor1 + color2*((255. - color1.alpha)/255.)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D1E593B6612B78359E8F-6B9F\"></a> \n            <h2><a name=\"GUID-CD0FB0D7-7AEB-4398-A32B-3104EB1B6B40\"></a>     <em class=\"strong\">3D Noise Functions</em> \n            </h2> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FAF\"></a><pre><em class=\"codeEmphasisStrong\">noise3</em> &lt;color&gt;\n<em class=\"codeEmphasisStrong\">noise4</em> &lt;color&gt; &lt;phase_float&gt;\n<em class=\"codeEmphasisStrong\">turbulence</em> &lt;color&gt; &lt;frequency_float&gt;\n<em class=\"codeEmphasisStrong\">fractalNoise</em> &lt;color&gt; &lt;H_float&gt; &lt;lacunarity_float&gt; &lt;octaves_float&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87BD4\"></a>See \n               		  <span class=\"char_link\"><a href=\"GUID-1564BD35-50EA-4140-9150-1AECC89F713C.htm\">Point3 Values</a></span> for a description of the noise functions. \n               		\n            </p> \n            <div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A61B2\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n                  <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87BD7\"></a>The component values of a Color value (r, g, b, and a) are normally in the range of\n                     0.0 to 255.0. However, values outside this range are permissible. When color values\n                     outside the normal range are used in \n                     			 <em class=\"strong\">3ds Max</em>,<em class=\"strong\"> 3ds Max</em> clamps the values to the range of 0.0 to 255.0. \n                     		  \n                  </p> \n               </div>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87BD9\"></a>The following script shows the use of various literals, constructors, properties,\n               operators, and methods of the Color class. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BDB\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BDC\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FAE\"></a><pre>\n-- color test bed\nmagenta=color 255 255 0 255-- create colors using constructors\naqua = [0, 255, 255] as color\naqua.v /= 2.-- reduce \"strength\" of aqua color\naqua\naqua.alpha=128-- set aqua to 50% opacity\naqua\nlightGray=white/4-- create light gray color by dividing\n-- each component of white by 4\ncomposite aqua lightGray-- composite light gray over aqua\nrandom black white-- generate a random color\n</pre></div> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87BEA\"></a><p class=\"table-body\"> <em class=\"strong\">OUTPUT:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5FAD\"></a><pre>\n(color 255 255 0)-- result of line 2. Note that if\n-- alpha=255 it is not displayed\n(color 0 255 255)-- result of line 3\n127.5-- result of line 4 - value property of aqua\n(color 0 127.5 127.5)-- result of line 5 - color of aqua\n128-- result of line 6 - alpha property of aqua\n(color 0 127.5 127.5 128)-- result of line 7 - color of aqua\n(color 63.75 63.75 63.75 63.75)-- result of line 8 - each component divided by 4\n(color 31.75 159.25 159.25 159.75)-- result of line 10\n(color 249.607 27.8243 140.23)-- result of line 11\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";