var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-DB36699E-7589-4C38-97C2-A04F093C6789\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"scripted plug-ins\">\n      <meta name=\"indexterm\" content=\"methods\">\n      <meta name=\"indexterm\" content=\"addPluginRollouts()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted Plug-in Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DB36699E-7589-4C38-97C2-A04F093C6789\"></a><div class=\"head\">\n            <h1>Scripted Plug-in Methods </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-72C5\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5327\"></a>   The <span class=\"code\"> <em class=\"strong\">addPluginRollouts()</em> </span> is used within scripted plug-in create tools, specifically for level 1 plug-ins that\n               don\'t create instances of themselves in the scene but might create other objects within\n               their create tool. This method lets you install rollouts for a specified object in\n               the Create panel, typically one of the objects being created in the create tool, so\n               that its parameters can be adjusted directly during creation. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5323\"></a>The form is: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71AB\"></a><pre><em class=\"codeEmphasisStrong\">addPluginRollouts</em> &lt;obj&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5321\"></a>In the following example, a variation of the three light mouse tool example presented\n               in <span class=\"char_link\"><a href=\"GUID-619AF4D3-A347-4155-943B-707D421BC460.htm\">Mouse Tool Clauses</a></span> is set into permanent, editable classes. It defines two new classes. The helper class\n               <span class=\"code\"> <em class=\"strong\">lightMaster</em> </span> is used as a master object for the light system. The light class <span class=\"code\"> <em class=\"strong\">threeLights</em> </span> is what you create to layout the initial system. It also creates a <span class=\"code\"> <em class=\"strong\">lightMaster</em> </span> and sets its parameters to point at the lights. The <span class=\"code\"> <em class=\"strong\">lightMaster</em> </span> rollout allows subsequent editing of the system in the Modifier panel, and storing\n               the lights in a parameter block makes the setup persistent over scene saves and loads.\n               \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-531F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-531E\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71AA\"></a><pre>\nplugin helper lightMaster\nname:\"Light Master\"\nclassID:#(12345,54321)\nextends:Dummy\nreplaceUI:true\ninvisible:true\n(\nparameters main rollout:params\n(\nkey type:#node subAnim:true\nfill type:#node subAnim:true\nback type:#node subAnim:true\nheight type:#worldUnits default:0 ui:height\nspread type:#worldUnits default:0 ui:spread\nangle type:#angle default:90 ui:angle\n-- check value of key since lights don\'t exist at initial creation\non height set val do if key != undefined then coordsys key.target\n(\nkey.pos.z = val\nback.pos.z = val * 1.5\nfill.pos.z = val * 0.5\n)\non spread set val do if key != undefined then coordsys key.target\n(\n-- compute normal vector pointing at key in the target\'s XY plane\n-- (kuv) and reposition everything based on that and the current\n-- spread and angle values\nlocal kuv = normalize ([key.pos.x, key.pos.y, 0])\nkey.pos = [kuv.x * spread, kuv.y * spread, height]\nback.pos = [kuv.x * -spread, kuv.y * -spread, height * 1.5]\n-- position fill by placing it under the key and then rotating in\n-- about the target\nfill.pos = [kuv.x * spread, kuv.y * spread, height * 0.5]\nabout key.target rotate fill angle z_axis\n)\non angle set val do if key != undefined then coordsys key.target\n(\nfill.pos = [key.pos.x, key.pos.y, height * 0.5]\nabout key.target rotate fill angle z_axis\n)\n)\nrollout params \"Light Parameters\"\n(\nspinner height \"Height\" type:#worldUnits range:[-1e32, 1e32, 0]\nspinner spread \"Spread\" type:#worldUnits range:[0, 1e32, 0]\nspinner angle \"Angle\" range:[-180, 180, 30]\non params open do flagForeGround #(key, back, fill) true\non params close do\nif key != undefined and back != undefined and fill != undefined then\nflagForeGround #(key, back, fill) false\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-52E5\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-52E4\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-71A9\"></a><pre>\nplugin light searchlights\nname:\"Three Lights\"\n(\nlocal master\ntool create\n(\non mousePoint click do\n(\nif click == 1 then -- create key, back &amp; fill lights at mousedown\n(\ncoordsys grid\n(\nmaster = lightMaster pos:gridPoint\nmaster.dummy.boxsize = [10,10,10]\nin master\n(\nlocal targObj=targetobject pos:gridPoint\nmaster.key = targetspot pos:gridPoint name:\"key\" \\\ntarget:targObj\nmaster.back = targetspot pos:gridPoint name:\"back\" \\\ntarget:targObj\nmaster.fill = targetspot pos:gridPoint name:\"fill\" \\\ntarget:targObj\n)\n)\naddPluginRollouts master\n)\nif click == 3 then\n(\nselect master\nmaster = undefined\n#stop\n)\n)\non mouseMove click do\n(\nif click == 2 then -- drag out &amp; round on x-y plane\n(\n-- place the key on the grid then set the spread and the\n-- \'on set spread\' handler will\n-- move the lights to the correct heights\nmaster.key.pos = worldPoint\nmaster.spread = distance master.key master.key.target\n)\nelse if click == 3 then -- drag up to elevate lights\nmaster.height = gridDist.z\n)\non mouseAbort click do\n(\nif master != undefined then\n(\nif master.fill != undefined then delete master.fill\nif master.back != undefined then delete master.back\nif master.key != undefined then delete master.key\ndelete master\n)\n)\n)\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-52A4\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";