var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-DB496ACA-1506-4FB1-B8F8-EECC7D9794DD\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Modifier - MAXWrapper\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Modifier Common Properties, Operators, and Methods</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DB496ACA-1506-4FB1-B8F8-EECC7D9794DD\"></a><div class=\"head\">\n            <h1>Modifier Common Properties, Operators, and Methods </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3690\"></a> <em class=\"strong\">Properties</em>  \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3691\"></a>All modifiers have the following properties: \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50C0\"></a><pre>&lt;modifier&gt;.<em class=\"codeEmphasisStrong\">name</em>: string</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3693\"></a>Get and set modifier name \n         </p>\n         <p><a name=\"GUID-A953F675-52F9-4E5D-B89A-65B0C122A051\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50BF\"></a><pre>&lt;modifier&gt;.<em class=\"codeEmphasisStrong\">enabled</em>: boolean\n\n&lt;modifier&gt;.<em class=\"codeEmphasisStrong\">enabledInViews</em>: boolean</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3697\"></a>Lets you control the modifier’s enabled/disabled state. These are read/write properties\n            that let you determine and set the enabled state of the given modifier, \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3698\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C3699\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50BE\"></a><pre>\n$foo.modifiers[2].enabled = false-- turn off 2nd modifier\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C369D\"></a>The <span class=\"code\"> <em class=\"strong\">enabledInViews</em> </span> property controls viewport display,<span class=\"code\"> <em class=\"strong\">enabled</em> </span> controls both viewport and rendered display. \n         </p>\n         <p><a name=\"GUID-996C6467-7A68-4113-9FB2-4A0D825475C5\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50BD\"></a><pre>&lt;modifier&gt;.<em class=\"codeEmphasisStrong\">enabledInRenders</em>: boolean</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36A0\"></a>Get/Set whether the modifier is enabled in renders. \n         </p>\n         <p><a name=\"GUID-6DC13A81-879B-4ED7-AA52-2B0A48B5F493\"></a>When set to <span class=\"code\"> <em class=\"strong\">true</em> </span>, the modifier is enabled in renders, when <span class=\"code\"> <em class=\"strong\">false</em> </span> it is disabled. \n         </p>\n         <p><a name=\"GUID-DEDCA26F-655A-4910-8517-1770191F3E17\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36A1\"></a> <em class=\"strong\">Associated Methods</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36A2\"></a>The modifier stack on a scene node can be manipulated using the following &lt;node&gt; methods:\n            \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50BC\"></a><pre><em class=\"codeEmphasisStrong\">validModifier</em>( &lt;node&gt; | &lt;objectset&gt;) (&lt;modifier | &lt;modifier_class&gt;)</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36A4\"></a>Tests whether a particular modifier or modifier class may be added the given <span class=\"code\"> <em class=\"strong\">&lt;node&gt;</em> </span> or <span class=\"code\"> <em class=\"strong\">&lt;objectset&gt;</em> </span>. Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if so, <span class=\"code\"> <em class=\"strong\">false</em> </span> if not. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36A5\"></a>The <span class=\"code\"> <em class=\"strong\">validModifier()</em> </span> method operates exactly as does the Modify panel in determining modifier applicability.\n            Any modifier that takes a deformable object will return <span class=\"code\"> <em class=\"strong\">true</em> </span> for all scene objects except Helpers. This corresponds to the Modify panel’s behavior\n            of allowing modifiers such as Bend, Taper, etc. to be applied to lights and cameras,\n            space warp objects, etc., as well as geometry types like box, sphere, etc., but not\n            helpers such as dummys or bones. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36A6\"></a>It is recommended that classes be used in RCMenus and macroScripts using <em class=\"strong\">validModifier()</em> to reduce resource usage. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36A7\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36A8\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50BB\"></a><pre>if <em class=\"codeEmphasisStrong\">validModifier</em> $ Edit_Mesh then ...\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36AC\"></a><p class=\"table-body\">instead of </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50BA\"></a><pre>if <em class=\"codeEmphasisStrong\">validModifier</em> $ (Edit_Mesh()) then ...\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36B0\"></a>The MAXScript <span class=\"code\"> <em class=\"strong\">isValidModifier</em> </span> function will check if it has been passed a modifier that doesn\'t exist at runtime.\n            It returns <span class=\"code\"> <em class=\"strong\">false</em> </span> in this case. It uses the ClassEntry to determine the InputType() of the modifier.\n            \n         </p>\n         <p><a name=\"GUID-E370C35E-BB71-468E-950C-044FF433DF44\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50B9\"></a><pre><em class=\"codeEmphasisStrong\">addModifier</em> &lt;node&gt; &lt;modifier&gt; [<em class=\"codeEmphasisStrong\">before</em>:index] -- mapped</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36B4\"></a>Adds the modifier to <em class=\"strong\">all instances</em> of the node to which the function is applied. \n         </p>\n         <p><a name=\"GUID-C3455409-83BA-48CC-B2BE-59B387F95966\"></a>The optional<span class=\"code\"> <em class=\"strong\"> before:</em> </span> keyword argument can be used to insert the modifier into the node’s modifier stack\n            just before the indexed modifier, counting from the top of the stack. \n         </p>\n         <p><a name=\"GUID-EA102220-A48C-401A-B3EE-A221FCF8D5C6\"></a>The added modifier will apply to any appropriate active sub-object selection in the\n            node only if the node is <em class=\"strong\">currently selected and open</em> in the Modify panel at the desired sub-object level. \n         </p>\n         <p><a name=\"GUID-02E91963-CBA6-47F6-AE67-9FE30FF7E55D\"></a>You can use the <em class=\"strong\">3ds Max</em> System global variable, <span class=\"code\"> <em class=\"strong\">subObjectLevel</em> </span> to test and set the level for the object currently open in the Modify panel. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36B5\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36B6\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50B8\"></a><pre>\nmax modify mode-- open mod panel\nselect $box01-- select box01 into mod panel\nsubObjectLevel = 3-- subobject level to Face\naddModifier $box01 (ffd_2x2x2())-- add FFD mod to those faces\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36BE\"></a>If the <span class=\"code\"> <em class=\"strong\">before:</em> </span> keyword argument would place a modifier in an invalid position in the stack, the\n            modifier will be placed at the nearest valid position. \n         </p>\n         <p><a name=\"GUID-A271AB5D-51DF-47CD-AD55-158856F708AF\"></a>For example, if you tried to place a SpacewarpModifier class object below a Modifier\n            class object, the SpacewarpModifier object would be placed below any SpacewarpModifier\n            objects, and above any Modifier objects. \n         </p>\n         <p><a name=\"GUID-87E938EA-0769-4F7C-B636-706DD4E15918\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36BF\"></a>If <span class=\"code\"> <em class=\"strong\">&lt;node&gt;</em> </span> is a collection, an instance of the modifier is placed on each of the nodes in the\n            collection. \n         </p>\n         <p><a name=\"GUID-D4EFE3C0-1033-43EF-8563-6B919F37E8CC\"></a>Unlike interactively applying a modifier to a selection, the position and size of\n            each modifier instance’s gizmo corresponds to position and size of the node the modifier\n            instance is applied to. \n         </p>\n         <p><a name=\"GUID-3404D392-F7D6-4D71-8FCA-9A2EEDB624A6\"></a>To apply a modifier to a collection in the same manner that <em class=\"strong\">3ds Max</em> applies modifiers, use the <span class=\"code\"> <em class=\"strong\">modPanel.addModToSelection()</em> </span> described in <span class=\"char_link\"><a href=\"GUID-BAC3CC23-9D1D-44CE-B4AF-C0CEBDD7099E.htm\">Modify Panel</a></span>. \n         </p>\n         <p><a name=\"GUID-05C9DD29-D54D-4B47-A871-C0463A40B04B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36C0\"></a>A limitation of the<span class=\"code\"> <em class=\"strong\"> addModifier()</em> </span> function is that it cannot generally apply modifiers to sub-object selections, and\n            so it disables any current sub-object levels. \n         </p>\n         <p><a name=\"GUID-4153C145-1498-4E08-B755-667B0BB83143\"></a>To apply a modifier to a sub-object selection in the same manner that<em class=\"strong\"> 3ds Max</em> applies modifiers, use the <span class=\"code\"> <em class=\"strong\">modPanel.addModToSelection()</em> </span>. \n         </p>\n         <p><a name=\"GUID-708F9EA4-2913-476E-BFDE-B301AE159D2A\"></a>This function correctly observes the currently selected sub-object level in the Modify\n            panel. \n         </p>\n         <p><a name=\"GUID-DB3141C2-5E9A-4B15-B9A7-68C42D955B18\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50B7\"></a><pre><em class=\"codeEmphasisStrong\">deleteModifier</em> &lt;node&gt; &lt;modifier_or_index&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36C3\"></a>Lets you delete modifiers from the modifier stack. \n         </p>\n         <p><a name=\"GUID-F153D6E9-FF19-4453-BAF7-A1F940228881\"></a>Takes either a modifier value present on the <span class=\"code\"> <em class=\"strong\">&lt;node&gt;</em> </span> stack, or an index specifying the index of the modifier to delete, counting from\n            the top of the stack. \n         </p>\n         <p><a name=\"GUID-12C714E4-6292-42A0-B050-50F3CC773DBE\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50B6\"></a><pre><em class=\"codeEmphasisStrong\">collapseStack</em> &lt;node&gt; -- mapped</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36C6\"></a>Collapses the modifiers out of a stack, leaving the appropriate resultant editable\n            base class, such as Editable Mesh, Editable Spline, NURBS Surface, etc., as the base\n            object of the node. \n         </p>\n         <p><a name=\"GUID-FE1605BD-EB2B-47E7-A0AB-6E99B075C8E5\"></a>If there are no modifiers in the stack when this is called, no action is taken. \n         </p>\n         <p><a name=\"GUID-1EF863A2-4053-4FC6-AE36-F49090A5AF62\"></a>If you want to force a stack collapse or conversion to editable base class form, use\n            one of the node conversion functions, such as<span class=\"code\"> <em class=\"strong\"> convertToMesh(),convertToSplineShape()</em> </span>, etc. \n         </p>\n         <p><a name=\"GUID-08A1DB80-FEC6-4552-AB2A-E6BB34B3313B\"></a>See the methods section in <span class=\"char_link\"><a href=\"GUID-D1D7EB56-A370-4B07-99B4-BC779FB87CAF.htm\">Node Common Properties, Operators, and Methods</a></span> for more details. \n         </p>\n         <p><a name=\"GUID-2B3A62FB-3C49-479D-963E-10399598517B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50B5\"></a><pre><em class=\"codeEmphasisStrong\">getModContextTM &lt;node&gt; &lt;modifier&gt;</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36C9\"></a>Returns a Matrix3 value giving the modifier’s context transform for the local coordinates\n            used in modifier sub-object gizmos. \n         </p>\n         <p><a name=\"GUID-47E1030C-58A0-4F35-9219-29A36262A17D\"></a>Accessing the transform properties of a modifier sub-object such as a gizmo or a center\n            in MAXScript yields values that are relative to that modifier’s context transform,\n            equivalent to the values shown in track view for those properties. \n         </p>\n         <p><a name=\"GUID-1B0A5D5D-4880-435A-97B8-5B48D3FF8F2E\"></a>If the modifier is not operating on a sub-object selection, such as a face or vertex\n            selection, or if the modifier was interactively applied to an object selection, this\n            context TM is the local coordinate space of the object itself. \n         </p>\n         <p><a name=\"GUID-26BB3970-0B99-4D68-A3CC-BB1E48FF7D7C\"></a>However, if the modifier is operating on either an object selection set or a sub-object\n            selection, the context transform gives the position and orientation of that selection,\n            and so you can use <span class=\"code\"> <em class=\"strong\">getModContextTM()</em> </span> to get the world-space transform properties of any of its sub-objects. \n         </p>\n         <p><a name=\"GUID-D5403DA2-219A-4F14-B8AA-A891B85F281B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-50B4\"></a><pre><em class=\"codeEmphasisStrong\">getModContextBBoxMin&lt;node&gt; &lt;modifier&gt;</em> <em class=\"codeEmphasisStrong\">getModContextBBoxMax&lt;node&gt; &lt;modifier&gt;</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36CD\"></a>These functions complement the <span class=\"code\"> <em class=\"strong\">getModContextTM()</em> </span> function and can be used to derive the world-space coordinates of the bounding box\n            of the modifier context. \n         </p>\n         <p><a name=\"GUID-B5742284-AE16-4355-8317-DC37EAE0B021\"></a>This can be used, for example, to determine the bounds of a modifier operating on\n            a sub-selection or the bounds of an FFD lattice. \n         </p>\n         <p><a name=\"GUID-F0C6D671-EF6F-41AC-B167-26F45E887212\"></a>This is particularly useful for scripting FFD control point placement, since these\n            control points live in a 0-to-1 lattice space&amp;emdash;the mod context bounding box\n            gives the world space bounds of this lattice space allowing you to compute scaled\n            lattice space coordinates from world coordinates. \n         </p>\n         <p><a name=\"GUID-191CD4C9-3C25-4F61-99E9-76AE48EBE783\"></a>The functions return Point3 values for the minimum and maximum extents of the bounding\n            box. \n         </p>\n         <p><a name=\"GUID-F316B1D3-A7EC-4B50-91A6-C9618BFD7469\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36CF\"></a> <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36D0\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C36D1\"></a> <span class=\"char_link\"><a href=\"GUID-1E2277FE-7854-4404-89A9-9D72C07CDBDB.htm\">Modifier Sub-Object Transform Properties</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";