var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-DB82F222-B77F-4F85-865F-A4D54B53107D\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How To Use DotNet\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How To ... Call a MAXScript Function Periodically using DotNet</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DB82F222-B77F-4F85-865F-A4D54B53107D\"></a><div class=\"head\">\n            <h1>How To ... Call a MAXScript Function Periodically using DotNet </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3327\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3328\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-676FB825-84C1-4708-A398-993266E4D2AD.htm\">How To</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">Use DotNet</a></span> &gt; Call a MAXScript Function Periodically \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC332A\"></a>The following tutorials demonstrate the use of the System.Windows.Forms.Timer dotNetObject\n            as alternative to the MAXScript Timer UI Control. Other than the latter, the DotNet\n            object version does not require a MAXScript User Interface to be created and opened\n            to run a MAXScript function at given time intervals. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC332B\"></a> <em class=\"strong\">Related topics:</em> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC332C\"></a> <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet In MAXScript</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC332D\"></a> <span class=\"char_link\"><a href=\"GUID-56961A11-BD8A-40E5-BB68-74AA27F2E056.htm\">dotNetObject</a></span> \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC332E\"></a> <span class=\"char_link\"><a href=\"GUID-AE849061-D19C-404B-8BC4-462D4B1DE7D0.htm\">dotNetObject:System.Windows.Forms.Timer</a></span> \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3331\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3332\"></a><p class=\"table-body\"> <em class=\"strong\">NATURAL LANGUAGE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3333\"></a><p class=\"table-body\">Create a DotNet Timer Object. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3334\"></a><p class=\"table-body\">Define a MAXScript function to be called periodically by the timer. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3335\"></a><p class=\"table-body\">Register an Event Handler to call the function </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3336\"></a><p class=\"table-body\">Start the Timer. </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3339\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC333A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-62FE\"></a><pre>\ntheTimer = dotNetObject \"System.Windows.Forms.Timer\"\nfn printTime = (print localTime)\ndotnet.addEventHandler theTimer \"tick\" printTime\ntheTimer.interval = 1000\ntheTimer.start()\n--theTimer.stop()\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3343\"></a><p class=\"table-body\"> <em class=\"strong\">SAMPLE LISTENER OUTPUT:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-62FD\"></a><pre>\ndotNetObject:System.Windows.Forms.Timer \nprintTime() \nOK \n1000 \nundefined \n\"10/20/2007 1:11:28 PM\" \n\"10/20/2007 1:11:29 PM\" \n\"10/20/2007 1:11:30 PM\" \n\"10/20/2007 1:11:31 PM\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-62FC\"></a><pre><em class=\"codeEmphasisStrong\">theTimer = dotNetObject \"System.Windows.Forms.Timer\"</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3349\"></a>Create a Timer. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-62FB\"></a><pre><em class=\"codeEmphasisStrong\">fn printTime = (print localTime)</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC334B\"></a>Define a MAXScript function to be called by the Timer. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-62FA\"></a><pre><em class=\"codeEmphasisStrong\">dotnet.addEventHandler theTimer \"tick\" printTime</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC334D\"></a>Add ON TICK event handler to call the function. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-62F9\"></a><pre><em class=\"codeEmphasisStrong\">theTimer.interval = 1000</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC334F\"></a>Set the tick interval to 1 second (1000 milliseconds). \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-62F8\"></a><pre><em class=\"codeEmphasisStrong\">theTimer.start()</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3351\"></a>Start the Timer. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-62F7\"></a><pre><em class=\"codeEmphasisStrong\">--theTimer.stop()</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC3353\"></a>Remove the remark and call this method to stop the Timer. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";