var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-DB86A07E-F694-47AD-B21C-BB7F4C9655D4\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSSurface - NURBSObject\">\n      <meta name=\"indexterm\" content=\"NURBS1RailSweepSurface - NURBSSurface\">\n      <meta name=\"indexterm\" content=\"setFlip()\">\n      <meta name=\"indexterm\" content=\"setCurveStartPoint()\">\n      <meta name=\"indexterm\" content=\"setCurveByID()\">\n      <meta name=\"indexterm\" content=\"setCurve()\">\n      <meta name=\"indexterm\" content=\"getFlip()\">\n      <meta name=\"indexterm\" content=\"getCurveStartPoint()\">\n      <meta name=\"indexterm\" content=\"getCurveID()\">\n      <meta name=\"indexterm\" content=\"getCurve()\">\n      <meta name=\"indexterm\" content=\"appendCurveByID()\">\n      <meta name=\"indexterm\" content=\"appendCurve()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBS1RailSweepSurface : NURBSSurface</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DB86A07E-F694-47AD-B21C-BB7F4C9655D4\"></a><div class=\"head\">\n            <h1>NURBS1RailSweepSurface : NURBSSurface </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4340\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-433F\"></a>  This class defines a dependent 1-Rail Sweep surface. A 1-Rail Sweep surface uses at\n               least two curves. One curve, the \"rail,\" defines one edge of the surface. The other\n               curves define the surface\'s cross sections. The cross-section curves should intersect\n               the rail curve. If the cross sections don\'t intersect the rail, the resulting surface\n               is unpredictable. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-433C\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2178\"></a><pre><em class=\"codeEmphasisStrong\">NURBS1RailSweepSurface</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-433A\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2177\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4336\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2176\"></a><pre>&lt;nurbs1railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">rail</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4334\"></a>The parent rail curve by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2175\"></a><pre>&lt;nurbs1railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">railID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4331\"></a>The parent rail curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2174\"></a><pre>&lt;nurbs1railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">numCurves</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-432E\"></a>The number of cross-section curves. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2173\"></a><pre>&lt;nurbs1railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">parallel</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-432B\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, ensures that the sweep surface\'s normal is parallel to the rail. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2172\"></a><pre>&lt;nurbs1railsweepsurface&gt;.<em class=\"codeEmphasisStrong\">axisTM</em> : matrix3 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4328\"></a>The axis of the sweep. \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-524F\"></a>           <em class=\"strong\">Methods</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2171\"></a><pre><em class=\"codeEmphasisStrong\">appendCurve</em> &lt;nurbs1railsweepsurface&gt; &lt;curve&gt; [<em class=\"codeEmphasisStrong\">flip</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">startPoint</em>:&lt;float&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-431B\"></a>Adds a curve to the end of the list of cross-section curves by specifying the index\n               in the NURBSSet. If <span class=\"code\"> <em class=\"strong\">flip:true</em> </span> is specified, the cross-section curve is reversed. <span class=\"code\"> <em class=\"strong\">startPoint</em> </span> specifies the start point on the parent curve. <span class=\"code\"> <em class=\"strong\">startPoint</em> </span> is applicable only if the parent is a closed curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2170\"></a><pre><em class=\"codeEmphasisStrong\">appendCurveByID</em> &lt;nurbs1railsweepsurface&gt; &lt;curveID&gt; [<em class=\"codeEmphasisStrong\">flip</em>:&lt;boolean&gt;] [<em class=\"codeEmphasisStrong\">startPoint</em>:&lt;float&gt;] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4318\"></a>Adds a curve to the end of the list of cross-section curves by specifying the NURBSId.\n               If <span class=\"code\"> <em class=\"strong\">flip:true</em> </span> is specified, the cross-section curve is reversed. <span class=\"code\"> <em class=\"strong\">startPoint</em> </span> specifies the start point on the parent curve. <span class=\"code\"> <em class=\"strong\">startPoint</em> </span> is applicable only if the parent is a closed curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-216F\"></a><pre><em class=\"codeEmphasisStrong\">getCurve</em> &lt;nurbs1railsweepsurface&gt; &lt;index&gt; </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-216E\"></a><pre><em class=\"codeEmphasisStrong\">setCurve</em> &lt;nurbs1railsweepsurface&gt; &lt;index&gt; &lt;curve&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4314\"></a>Get or set the indexed cross-section curve by NURBSSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-216D\"></a><pre><em class=\"codeEmphasisStrong\">getCurveID</em> &lt;nurbs1railsweepsurface&gt; &lt;index&gt; \n<em class=\"codeEmphasisStrong\">setCurveByID</em> &lt;nurbs1railsweepsurface&gt; &lt;index&gt; &lt;curveID&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4310\"></a>Get or set the indexed cross-section curve by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-216C\"></a><pre><em class=\"codeEmphasisStrong\">getFlip</em> &lt;nurbs1railsweepsurface&gt; &lt;index&gt; \n<em class=\"codeEmphasisStrong\">setFlip</em> &lt;nurbs1railsweepsurface&gt; &lt;index&gt; &lt;boolean&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-430C\"></a>Get or set whether the indexed cross-section curve is reversed. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-216B\"></a><pre><em class=\"codeEmphasisStrong\">getCurveStartPoint</em> &lt;nurbs1railsweepsurface&gt; &lt;index&gt; \n<em class=\"codeEmphasisStrong\">setCurveStartPoint</em> &lt;nurbs1railsweepsurface&gt; &lt;index&gt; &lt;float&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4308\"></a>Get or set the start point of the indexed cross-section curve on the parent curve.\n               The start point is applicable only if the parent is a closed curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4306\"></a> <span class=\"char_link\"><a href=\"GUID-19C0A3FC-AECA-437A-A430-51EFC9D70545.htm\">NURBSSurface</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4305\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4304\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";