var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-DBC2E0B8-B7BB-4966-9B4C-BE8A4620F62F\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"viewport grids\">\n      <meta name=\"indexterm\" content=\"setGridSpacing()\">\n      <meta name=\"indexterm\" content=\"setGridMajorLines()\">\n      <meta name=\"indexterm\" content=\"getGridSpacing()\">\n      <meta name=\"indexterm\" content=\"getGridMajorLines()\">\n      <meta name=\"indexterm\" content=\"activeGrid\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Viewport Grids</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DBC2E0B8-B7BB-4966-9B4C-BE8A4620F62F\"></a><div class=\"head\">\n            <h1>Viewport Grids </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AE5\"></a>      The following methods control the <em class=\"strong\">display and spacing of grid lines</em> in the viewports. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B65\"></a><pre><em class=\"codeEmphasisStrong\">getGridSpacing</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2ADD\"></a>Returns the spacing between grid lines in units. \n         </p>\n         <p><a name=\"GUID-CD42D2E6-A058-4E79-A13B-756D9058C03D\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B64\"></a><pre><em class=\"codeEmphasisStrong\">SetGridSpacing</em> &lt;float&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2ADA\"></a>Sets home grid spacing. This corresponds to the Grid and Snap Settings dialog, Home\n            Grid tab. The value is clamped to a minimum value of 0.001. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AD9\"></a>Available in <em class=\"strong\">3ds Max 2008</em> and higher. Previously available in <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-C9B049E5-4ED8-49E2-B363-4C600521AD5E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B63\"></a><pre><em class=\"codeEmphasisStrong\">getGridMajorLines</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AD6\"></a>Returns the number of grid lines between major grid lines. \n         </p>\n         <p><a name=\"GUID-CEB3431D-9303-494E-9CDB-07412D8CBAB3\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B62\"></a><pre><em class=\"codeEmphasisStrong\">SetGridMajorLines</em> &lt;int&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AD3\"></a>Sets home grid major grid lines. This corresponds to the Grid and Snap Settings dialog,\n            Home Grid tab. The value is clamped to a minimum value of 2. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AD2\"></a>Available in <em class=\"strong\">3ds Max 2008</em> and higher. Previously available in <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2AD0\"></a>The following <em class=\"strong\">3ds Max</em> system global variable is associated with the <em class=\"strong\">Viewport grids</em>: \n         </p>\n         <p><a name=\"GUID-19671180-6BEE-4E6D-8520-BF5E4A9F4179\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6B61\"></a><pre><em class=\"codeEmphasisStrong\">activeGrid</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2ACE\"></a>Contains the currently active grid. If the home grid is active, returns the value\n            <span class=\"code\"> <em class=\"strong\">undefined</em> </span>. You can assign a grid node object to this variable to make it the currently active\n            grid. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2ACD\"></a>You can also return to the home grid by setting <span class=\"code\"> <em class=\"strong\">activegrid = undefined</em> </span>. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";