var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-DE634C96-9DEB-42AD-B299-C112F4A739A3\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>New Default Controller Functions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DE634C96-9DEB-42AD-B299-C112F4A739A3\"></a><div class=\"head\">\n            <h1>New Default Controller Functions </h1>\n         </div>\n         <p> The following functions create instances of the default controller class for each\n            animatable value type. If the default controller has been customized by the user,\n            the respective function below will return an instance of the customized class. The\n            default controller for each animatable value type can be customized in the “Assign\n            ... Controller” dialog accessible through Track View. Available in \n            		<em class=\"strong\">3ds Max 2017 and higher</em>.\n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><em class=\"strong\">Functions:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultBoolController()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated Boolean\n            values. \n            	 \n         </p>\n         <p> Default is a Bezier_Float controller. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultColorController()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated Color\n            values. \n            	 \n         </p>\n         <p> Default is a Bezier_Color controller. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultFloatController()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated Float\n            values. \n            	 \n         </p>\n         <p> Default is a Bezier_Float controller. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultFRGBAController()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated floating\n            point Color and Alpha values. \n            	 \n         </p>\n         <p> Default is a Bezier_RGBA_Color controller. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultMasterPointController()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated vertices.\n            \n            	 \n         </p>\n         <p> Default is a MasterPointControlImp controller. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultMatrix3Controller()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated Matrix3\n            values. \n            	 \n         </p>\n         <p> Default is a Position_Rotation_Scale controller with a Position_XYZ sub-controller\n            for Position containing three Bezier_Float sub-controllers for X_Position, Y_Position,\n            and Z_Position; a Eurler_XYZ sub-controller for Rotation with three Bezier_Float sub-controllers\n            for X_Rotation, Y_Rotation, and Z_Rotation; and a Bezier_Scale controller for scaling.\n            \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultPoint2Controller()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated Point2\n            values. \n            	 \n         </p>\n         <p> Default is a Bezier_Point2 controller. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultPoint3Controller()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated Point3\n            values. \n            	 \n         </p>\n         <p> Default is a Bezier_Point3 controller. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultPoint4Controller()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated Point4\n            values. \n            	 \n         </p>\n         <p> Default is a Bezier_Point4 controller. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultPositionController()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated Position\n            values. \n            	 \n         </p>\n         <p> Default is a Position_XYZ controller with three Bezier_Float sub-controllers for\n            X_Position, Y_Position and Z_Position. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultRotationController()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated Rotation\n            values. \n            	 \n         </p>\n         <p> Default is a Euler_XYZ controller with three Bezier_Float sub-controllers for X_Rotation,\n            Y_Rotation and Z_Rotation. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;controller&gt;<em class=\"codeEmphasisStrong\">NewDefaultScaleController()</em></pre></div>\n         <p> Returns an instance of the default controller class used for storing animated Scale\n            values. \n            	 \n         </p>\n         <p> Default is a Bezier_Scale controller. \n            	 \n         </p>\n         <p>&nbsp;&nbsp;&nbsp; \n            	 \n         </p><a name=\"TABLE_4E15F662853243C3B79878EABF749275\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"GUID-F16B3F88-A91F-44BA-B2C3-5E30ABB1904B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>\nndbc = NewDefaultBoolController()\n--&gt; Controller:Bezier_Float\n\nndcc = NewDefaultColorController()\n--&gt; Controller:Bezier_Color\n\nndfc = NewDefaultFloatController()\n--&gt; Controller:Bezier_Float\n\nndfrgbac = NewDefaultFRGBAController()\n--&gt; Controller:Bezier_RGBA_Color\n\nndmpc = NewDefaultMasterPointController()\n--&gt; Controller:MasterPointControlImp\n\nndm3c = NewDefaultMatrix3Controller()\n--&gt; Controller:Position_Rotation_Scale\nndm3c[1]\n--&gt; SubAnim:Position\nndm3c[1].controller\n--&gt; Controller:Position_XYZ\nndm3c[1].controller[1]\n--&gt; SubAnim:X_Position\nndm3c[1].controller[1].controller\n--&gt; Controller:Bezier_Float\nndm3c[2].controller\n--&gt; Controller:Euler_XYZ\nndm3c[3].controller\n--&gt; Controller:Bezier_Scale\n\nndp2c = NewDefaultPoint2Controller()\n--&gt; Controller:Bezier_Point2\n\nndp3c = NewDefaultPoint3Controller()\n--&gt; Controller:Bezier_Point3\n\nndp4c = NewDefaultPoint4Controller()\n--&gt; Controller:Bezier_Point4\n\nndpc = NewDefaultPositionController()\n--&gt; Controller:Position_XYZ\n\nndrc = NewDefaultRotationController()\n--&gt; Controller:Euler_XYZ\n\nndsc = NewDefaultScaleController()\n--&gt; Controller:Bezier_Scale\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";