var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-DF09BF99-2106-408D-9965-60436B853D76\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"memory allocation\">\n      <meta name=\"indexterm\" content=\"heapSize\">\n      <meta name=\"indexterm\" content=\"heapCheck()\">\n      <meta name=\"indexterm\" content=\"garbage collection\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Memory Allocation and Garbage Collection</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DF09BF99-2106-408D-9965-60436B853D76\"></a><div class=\"head\">\n            <h1>Memory Allocation and Garbage Collection </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B6E\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B6F\"></a>    MAXScript allocates its own working memory in addition to any memory <em class=\"strong\">3ds Max</em> allocates as it works. \n            </p> \n            <p><a name=\"P_3CCAE3B909FE449EB4E3E42A1AA1BA66\"></a>The default working memory size setting for MAXScript is 15 MB, and the memory is\n               virtual and pageable like all <em class=\"strong\">3ds Max</em> memory. \n            </p> \n            <p><a name=\"P_7A13C26168A74BD88B211E9083DACD8B\"></a>The default allocation accommodates most tasks, but you can increase it by incrementing\n               the MAXScript system global variable <span class=\"code\"> <em class=\"strong\">heapSize</em> </span>: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E86B74\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-617F\"></a><pre>\nheapSize += 2000000 -- another 2 MB, for a total of 9.5 MB\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B79\"></a>You can add this statement to your startup script if you always need extra memory\n               allocated for MAXScript tasks or you can set the default size in the MAXScript tab\n               in the <em class=\"strong\">3ds Max</em> Customize&gt;Preferences dialog. \n            </p> \n            <p><a name=\"P_2B36903918894BEC8580E89BC96F8C59\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B7A\"></a>Increasing the MAXScript heap reduces memory address space for other <em class=\"strong\">3ds Max</em> tasks. \n            </p> \n            <p><a name=\"P_22E08BBA3AFF4DF5885F82FA5CF177B4\"></a>Adjust the default memory setting only after you receive \"Out of memory\" error messages\n               from MAXScript, or when garbage collection pauses occur frequently. \n            </p> \n            <p><a name=\"P_B166E4B69E424FCE9DD3E998C503AEE1\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B7B\"></a>You can increase the MAXScript heap as many times as you need during a <em class=\"strong\">3ds Max</em> session, but you cannot reduce it. \n            </p> \n            <p><a name=\"P_B9B07CB7F1BA46328B3A9F9B87762461\"></a>Restart <em class=\"strong\">3ds Max</em> to reset the MAXScript memory heap to the default setting. \n            </p> \n            <p><a name=\"P_13DEC07BC27949D082C653A95A8AB828\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B7C\"></a>MAXScript uses a memory management scheme called <em class=\"strong\">automatic garbage collection</em>. \n            </p> \n            <p><a name=\"P_CEEE9D61D9584C3D8B9B57623208F331\"></a>This means you don’t have to explicitly reclaim any memory that a value takes up when\n               you no longer need it. \n            </p> \n            <p><a name=\"P_FEF0EF03970D41F6B5270FE2FF6BD44B\"></a>When you assign a new value to a variable or when a local variable’s block exits,\n               the reference that the variable contained is dropped. \n            </p> \n            <p><a name=\"P_DC8A58D54C1F452E895F33F5B35AE691\"></a>When your program has dropped all references to a value\'s memory, that memory becomes\n               eligible for reclamation. \n            </p> \n            <p><a name=\"P_F847F64D555D412989FDBEAB5A8E0276\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B7D\"></a>Some values, such as arrays, have internal references to other values. \n            </p> \n            <p><a name=\"P_5BADC886D12643A4BC1852C99AA003CF\"></a>In an array, each element contains a reference to another value. \n            </p> \n            <p><a name=\"P_1056648B839E4A1E870C840F0A8BB775\"></a>When you assign a new value to an array element, the element\'s old reference is dropped.\n               \n            </p> \n            <p><a name=\"P_B3A9CE36AB514E6899B4B01EDB5CF570\"></a>If you remove all references to the array itself, all the references in the elements\n               of that array are implicitly dropped. \n            </p> \n            <p><a name=\"P_5BA34AC5138044A5ACE3508B3D8B8492\"></a>The same applies to component values, such as in user structures and most <em class=\"strong\">3ds Max</em> objects. \n            </p> \n            <p><a name=\"P_5F2662AFE35D4321A75F1EA296103800\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B7E\"></a>MAXScript reclaims memory in a garbage collection pass through memory when MAXScript\n               runs out of memory. \n            </p> \n            <p><a name=\"P_23E63AF54BF841939BD7FE49AEE0E6DD\"></a>This simple approach can result in a short pause because the entire MAXScript memory\n               is scanned for garbage. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B7F\"></a>The advantage of garbage collection is you can create as many values as you need,\n               and MAXScript cleans up the ones you no longer use. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B80\"></a>&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B81\"></a>In <em class=\"strong\">3ds Max 9</em>, the <em class=\"strong\"> <span class=\"code\">HeapSize</span> </em> and the <em class=\"strong\"> <span class=\"code\">HeapFree</span> </em> system variables were changed from Integer to <em class=\"strong\">Integer64</em> to accommodate the increased memory address space of 64 bit systems. \n            </p> \n            <p><a name=\"P_747FE705816D41D4A1C8E91E42303DCE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B82\"></a>In <em class=\"strong\">3ds Max 9 and higher</em>, the initial heap size is limited to 512MB. \n            </p> \n            <p><a name=\"P_99A3CEB2FEAB4D3FBDBE4086A0C08DC7\"></a>If the initial heap size is still too high and the specified memory block cannot be\n               allocated, the initial heap size is recursively decreased by 10% until the memory\n               block can be allocated. \n            </p> \n            <p><a name=\"P_FFB6BF0C32C04783A743B9E4A2217946\"></a>If a 1MB memory block cannot be allocated, an assert is triggered and the <em class=\"strong\">3ds Max</em> session is terminated (if the system cannot allocate 1MB at startup, something is\n               very wrong). \n            </p> \n            <p><a name=\"P_5E7D78A98B3A4DB39344E43456612EF4\"></a>Otherwise, a message is displayed in the status panel stating that the requested heap\n               size was automatically decreased, and gives the actual heap size allocated. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B83\"></a>A test was added to ensure that the initial heap size is at least the absolute minimum\n               required by MAXScript - 12 bytes. \n            </p> \n            <p><a name=\"P_177F2426D47E4C5995C9DC454B9F4FC2\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B84\"></a>Code was added so that as new values are allocated, the heap size is automatically\n               increased if necessary (requested memory size not available in the heap after performing\n               a full garbage collection) . \n            </p> \n            <p><a name=\"P_66BBFCF188684266B3F322EDDB2C04C0\"></a>The first attempted increase is the maximum of 50* the requested size or 512KB. \n            </p> \n            <p><a name=\"P_EDC1EA1BAA0C4F02820ED0F2C6E6D5CE\"></a>If this allocation fails, a series of allocation attempts is made with decreasing\n               allocation sizes, with the last one being the maximum of the requested size or 256KB.\n               \n            </p> \n            <p><a name=\"P_391788BD693E4916A626C12C1FC2165B\"></a>If this final allocation attempt fails, a runtime error is thrown. \n            </p> \n            <p><a name=\"P_587E0629E7B44C1694DB79284B73BC80\"></a>Otherwise, a message is displayed in the status panel stating that the requested heap\n               size was automatically increased, and gives the new heap size. \n            </p> \n            <p><a name=\"P_C41F048FA81840A09C8E38E7237C686C\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-617E\"></a><pre><em class=\"codeEmphasisStrong\">heapCheck</em>() 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B87\"></a>The <em class=\"strong\"> <span class=\"code\">heapCheck()</span> </em> method is mostly for internal debugging. \n            </p> \n            <p><a name=\"P_158BB2DFEC3C45E3A9549D3D269BDF65\"></a>It can be called by scripts to perform a minimal consistency check of the Heap. \n            </p> \n            <p><a name=\"P_EE38229279E04138AEF3D8033E401EA1\"></a>Available in <em class=\"strong\">3ds Max 9 and higher.</em> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B88\"></a>Possible return values are: \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B89\"></a> <em class=\"strong\">OK</em> - Heap appears to be consistent (_HEAPOK) \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B8A\"></a> <em class=\"strong\">-1</em> - Heap has not been initialized (_HEAPEMPTY) \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B8B\"></a> <em class=\"strong\">-3</em> -Initial header information is bad or cannot be found.(_HEAPBADBEGIN) \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B8C\"></a> <em class=\"strong\">-4</em> -Bad node has been found or heap is damaged.(_HEAPBADNODE) \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B8D\"></a> <em class=\"strong\">-6</em> - Pointer into Heap is not valid (_HEAPBADPTR) \n            </p> \n            <p><a name=\"P_14D9BE54B0EB47A39A523C3A69272775\"></a>See also the <span class=\"char_link\"><a href=\"GUID-D0175A53-6007-4F83-8637-1DEFD033E84D.htm\">CRT Debug Functions</a></span> topic for related methods. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E86B90\"></a> <span class=\"char_link\"><a href=\"GUID-CA7ABB4B-6CB6-47B7-903D-84D2F45D993D.htm\">Manual Garbage Collection</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"P_8C3014BECA7E4892B9C1C1CFCA69752B\"></a> <span class=\"char_link\"><a href=\"GUID-D0175A53-6007-4F83-8637-1DEFD033E84D.htm\">CRT Debug Functions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-CA7ABB4B-6CB6-47B7-903D-84D2F45D993D.htm\">Manual Garbage Collection </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";