var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-DFC564A3-A5E1-4398-AF50-3B4C91BB3358\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface FileResolutionManager\">\n      <meta name=\"indexterm\" content=\"FileResolutionManager Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: FileResolutionManager</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DFC564A3-A5E1-4398-AF50-3B4C91BB3358\"></a><div class=\"head\">\n            <h1>Interface: FileResolutionManager </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1865\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1864\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span>&gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; FileResolutionManager \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1867\"></a>The<em class=\"strong\"> FileResolutionManager Core Interface</em> exposes the new system introduced in<em class=\"strong\"> 3ds Max 2010</em> which is used internally by plug-ins to resolve the paths of their file assets. \n         </p>\n         <p><a name=\"GUID-D4A2A8DD-CE10-485D-8769-E61F016AA12C\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1862\"></a>In releases prior to<em class=\"strong\"> 3ds Max 2010</em>, the resolution of asset files was performed either locally in the plug-in code,\n            or through one of several methods provided by<em class=\"strong\"> 3ds Max</em>. \n            	 \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1861\"></a>Since<em class=\"strong\"> 3ds Max 2010</em>, all resolutions of asset files must be performed through the \n            		<span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm#WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-52AF\">AssetUser object</a></span> that uses the new \n            		<em class=\"strong\"> Asset File Resolution Manager</em>. The File Resolution Manager can also be used for resolutions of Assets. All other\n            resolution methods have been removed, and plug-ins should not implement their rules\n            for resolving paths to a file asset. File resolution is based on the asset file name,\n            asset type, and the file path to a scene that depends on the asset. \n            	 \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1860\"></a>The File Resolution Manager also implements a path caching mechanism. A set of methods\n            has been exposed to allow plug-ins and scripts to control the cache enabled/disabled\n            state, cache duration and also to provide a way to bypass the cache when getting the\n            resolved path. \n            	 \n         </p>\n         <p><a name=\"P_029E909F297B4A45A42ACF29EA4ABE8F\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <p><em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">FileResolutionManager.searchScenePath</em> : bool : Read|Write</pre></div>\n         <p>Available in <em class=\"strong\">3ds Max 2018.4 and higher</em>: Specifies whether or not the File Resolution Manager should search the scene file\n            path for assets. This is a performance option - when false, this avoids searching\n            the scene file folder; relative paths are still searched relative to the scene file.\n            If this is false, it also implies the scene path subpaths are excluded. The default\n            is true.\n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">FileResolutionManager.searchScenePathSubPaths</em> : bool : Read|Write</pre></div>\n         <p>Available in <em class=\"strong\">3ds Max 2018.4 and higher</em>: Specifies whether or not the File Resolution Manager should search the subpaths\n            of the scene file path for assets. This is a performance option - when false, this\n            avoids searching of all subpaths below the scene file. Relative paths are still searched\n            relative to the scene file, but excluding further subpaths. The default is true.\n            	 \n         </p>\n         <p> </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-185F\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A84\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.getFullFilePath</em> &lt;&amp;TSTR&gt;filePath &lt;enum&gt;assetType <em class=\"codeEmphasisStrong\">byPassCache</em>:&lt;bool&gt; 	 \n\nfilePath is In and Out parameter 	 \nassetType enums: {<em class=\"codeEmphasisStrong\">#Other | #Bitmap | #XRef | #Photometric | #Animation | #VideoPost | #BatchRender | #ExternalLink | #RenderOutput | #PreRenderScript | #PostRenderScript | #Sound | #Container | #MaxCreationGraph</em>} 	 \nbyPassCache default value: false</pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-185E\"></a>Returns the full file path by modifying the first argument passed by-reference. The\n            second argument determines the asset type the file belongs to. \n            	 \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-185D\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">byPassCache: \n                  		  </em> </span>is passed as true, the cache will not be used. If it is passed as false or not specified,\n            the cache will be used. \n            	 \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-185A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1859\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A82\"></a><pre>\ntheFilename = \"Simple_Stone_Mtl_Marble_bump.jpg\"\n--&gt; \"Simple_Stone_Mtl_Marble_bump.jpg\"\n&nbsp;\nFileResolutionManager.getFullFilePath &amp;theFilename #Bitmap\n--&gt; true\n&nbsp;\ntheFilename\n--&gt; \"C:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\adskMtl\\Simple_Stone_Mtl_Marble_bump.jpg\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-759B8A02-D0CF-4B93-9DBD-B3FF5D76E4BE\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A81\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.getFullFilePath_assetID </em>&lt;TSTR&gt;assetID &lt;&amp;TSTR&gt;filePath <em class=\"codeEmphasisStrong\">byPassCache</em>:&lt;bool&gt; \n\nfilePath is In and Out parameter \nbyPassCache default value: false </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1856\"></a>Returns the full file path by modifying the second argument passed by-reference. The\n            first argument defines the assetID to search for. \n            	 \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1855\"></a>If \n            		<span class=\"code\"> <em class=\"strong\">byPassCache: \n                  		  </em> </span>is passed as true, the cache will not be used. If it is passed as false or not specified,\n            the cache will be used. \n            	 \n         </p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1853\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1852\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A7F\"></a><pre>\ntheID = AssetManager.GetAssetID \"Simple_Stone_Mtl_Marble_bump.jpg\" #Bitmap\n--&gt; \"{7477A3A4-0304-47AC-8427-6B490673231A}\"\n&nbsp;\nFileResolutionManager.getFullFilePath_assetID theID &amp;filePath\n--&gt; true\n&nbsp;\nfilePath\n--&gt; \"C:\\Program Files\\Autodesk\\3ds Max 2010\\Maps\\adskMtl\\Simple_Stone_Mtl_Marble_bump.jpg\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-48FC99FF-8AAC-4F3A-92A4-1264B1CF99E7\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A7E\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.doGetUniversalFileName </em>&lt;&amp;TSTR&gt;aFullFilePath \n\naFullFilePath is In and Out parameter </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-184F\"></a>Returns the universal file name by modifying the by-reference argument. \n            	 \n         </p>\n         <p><a name=\"GUID-9D3ADDF5-BFAE-4CA4-A714-5651A23E21F1\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A7C\"></a><pre>&lt;integer&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.GetNumAssetTypes()</em> </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-184D\"></a> Returns the number of asset types. \n            	 \n         </p>\n         <p><a name=\"GUID-052ECA37-B482-41E6-8063-E3BFFE11F4E8\"></a>Available in \n            		<em class=\"strong\">3ds Max 2011 and higher.</em> \n         </p>\n         <p><a name=\"GUID-3DC6D553-061D-4C01-8AE1-C03EC0E388F6\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A7B\"></a><pre>&lt;string&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.GetAssetTypeString</em> &lt;enum&gt;assetType \n\nassetType enums<em class=\"codeEmphasisStrong\">: {#Other | #Bitmap | #XRef | #Photometric | #Animation | #VideoPost | #BatchRender | #ExternalLink | #RenderOutput | #PreRenderScript | #PostRenderScript | #Sound | #Container | #MaxCreationGraph}</em> </pre></div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-184B\"></a> Returns the asset type string corresponding to the provided asset type name. \n            	 \n         </p>\n         <p><a name=\"GUID-8E2DF5E2-F60D-455D-9DCB-4F22BCA356C7\"></a>Available in \n            		<em class=\"strong\">3ds Max 2011 and higher.</em> \n         </p>\n         <p><a name=\"GUID-5E1FB3BA-63BC-43E8-874B-64AE6D712AA9\"></a>&nbsp;&nbsp;&nbsp; \n            	 \n         </p>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1849\"></a> \n            <h2><a name=\"GUID-5C63044A-319D-40C8-9F54-06385D963A70\"></a> <em class=\"strong\">Cache</em> \n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1848\"></a>File Resolution results are being cached, but the cached results expire after a specified\n               maximum cache duration period. \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A78\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.EnableCaching</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1847\"></a>Turns the cache on. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1846\"></a>The cache is on by default. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1845\"></a>File resolutions will be cached and the cached results returns if the same file has\n               to be resolved again sooner than the maximum cache duration (see below). \n               		\n            </p> \n            <p><a name=\"GUID-3E606158-4A2E-4EBB-BA73-B537FD38A978\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A77\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.DisableCaching</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1843\"></a>Turns the cache off. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1842\"></a>Files will always be resolved without using the cache at all. \n               		\n            </p> \n            <p><a name=\"GUID-9B4E8229-6B07-43F3-BC32-91EE6E496C15\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A76\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.IsCachingEnabled</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1840\"></a>Returns true if the cache is on, false if it is off. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-183F\"></a>The cache is on by default. \n               		\n            </p> \n            <p><a name=\"GUID-95E18209-4BE4-43C0-9F74-A24186C8749A\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A75\"></a><pre>&lt;DWORD&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.GetMaximumCacheDuration</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-183D\"></a>Returns the maximum cache duration in milliseconds. Default is 1000. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-183C\"></a>If a resolution has been cached and a new resolution of the same file is requested\n               later than the time of the previous resolution plus the maximum cache duration, the\n               cache result will be ignored and a new resolution will be performed. \n               		\n            </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-183B\"></a>If the time passed since the last resolution is less than the maximum cache duration,\n               the cached result will be returned. \n               		\n            </p> \n            <p><a name=\"GUID-753BB8CF-89CC-441C-A34F-8796DE3438C4\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A74\"></a><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.SetMaximumCacheDuration</em> &lt;DWORD&gt;newMaxDuration </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-183A\"></a>Sets the maximum cache duration. \n               		\n            </p> \n            <p><a name=\"GUID-C477FCB2-AD2E-452C-A675-8E4721BFCA71\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5A73\"></a><pre>&lt;INT64&gt;<em class=\"codeEmphasisStrong\">FileResolutionManager.GetNumCacheHit</em>() </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1838\"></a>Returns the number of cache hits. \n               		\n            </p> \n            <p><a name=\"GUID-A1625E9B-5289-4B05-9B65-FFFFC2D17D59\"></a>&nbsp;&nbsp;&nbsp; \n               		\n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1836\"></a> <span class=\"char_link\"><a href=\"GUID-E5D783F1-9108-4436-921C-D72BF7035866.htm\">Accessing AssetManager, AssetUser and Asset Metadata in MAX Files</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1834\"></a> <span class=\"char_link\"><a href=\"GUID-E3237B13-8069-4177-8544-9000A98B1C15.htm\">Interface: AssetManager</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1833\"></a> <span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm\">IObject:AssetUser</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1832\"></a> <span class=\"char_link\"><a href=\"GUID-2AF2AFE0-1B22-4DA2-B0F9-CA3ADABCB6C6.htm\">MAX File Asset Metadata Stream Access</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";