var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E26199AC-496C-42C4-BCB4-52A3C4DEF411\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I check if a string contains only numbers?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E26199AC-496C-42C4-BCB4-52A3C4DEF411\"></a><div class=\"head\">\n            <h1>How do I check if a string contains only numbers? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBE7\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBE9\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBEA\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8BE\">MAXScript Values</a></span> &gt; How do I check if a string contains only numbers? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBEC\"></a> \n            <h2><a name=\"GUID-353BE24E-1986-4F8F-8728-92E2606602FB\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBED\"></a>I want to check whether the text in an edit text UI element contains numbers or letters.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBEE\"></a>If it contains numbers, I want it to return the numbers. If it contains letters, I\n               want it to display a message \"You may only type numbers, try again\". \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBF0\"></a>How do I do that? \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WSCFD53B2325797C985D627AE6128F25ABCFF-7FE8\"></a> \n            <h2><a name=\"GUID-615964CC-3FF7-4980-A175-69FCEA356223\"></a> <em class=\"strong\">Answer:</em> \n            </h2> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBF1\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCBF2\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6675\"></a><pre>\nrollout MicroListener \"MicroListener\"\n(\nedittext myEditText text:\"\"\nlabel theLabel \"Ready.\"\non myEditText changed txt do\n(\n if txt != \"\" then\n (\n  try\n  (\n   val = execute txt\n   theLabel.text = \"You typed in \"+ (val as string )\n  )\n  catch \n   theLabel.text = \"Invalid Expression!\"\n )\n else\n  theLabel.text = \"Ready.\"\n)\non myEditText entered txt do myEditText.text = \"\"\n)\ncreateDialog MicroListener 300 60\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC0D\"></a>This simple script implements a kind of \"micro-listener\". It uses the <span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm#WS73099CC142F487553098682E12AC2FC2BC7-5FEB\">Execute</a></span> method to turn the string typed in the edit text field into a MAXScript expression.\n               It lets you not only enter numbers, but also constants like Pi, or global variables\n               that you have defined. Not only this, you can define global variables inside the script,\n               and even create objects on the fly. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC0F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC10\"></a><p class=\"table-body\"> <em class=\"strong\">HERE ARE SOME EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC12\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-0D2756A1-2B84-4BA7-A9AC-4126BE75AB29-low.gif\"><p class=\"figure-title\">125.1 is a valid expression - it is a constant and evaluates to itself (125.1).</p>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC15\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-D31DA20A-A205-4AA3-9005-90A898CCEDD1-low.gif\"><p class=\"figure-title\">On the other hand, d returns undefined as it is undefined.</p>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC18\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-1FA5C720-463D-4E94-873B-C7A58E06A292-low.gif\"><p class=\"figure-title\">Surprisingly, e does not return undefined - it is a reserved keyword in MAXScript!</p>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC1B\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-6C20FFE6-926B-43CF-8F9C-C8DFAAE5E136-low.gif\"><p class=\"figure-title\">Same with pi -as expected, it returns 3.14149....</p>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC1E\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-6FB2927D-E795-4273-9437-CBB32A61B4E4-low.gif\"><p class=\"figure-title\">Trying to add two undefined values results in an invalid expression.</p>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC21\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-1F59E8CF-562B-43CB-B43E-0F498823AE8E-low.gif\"><p class=\"figure-title\">This variable is also undefined.</p>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC24\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-A5FF195E-2FCB-4EBE-B358-AD9BCB0F727F-low.gif\"><p class=\"figure-title\">Until we define it. Now it is equal to 10.</p>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC27\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-AB9244A9-1DF5-4729-89C3-64E73BA72725-low.gif\"><p class=\"figure-title\">So, you can write an expression containing constants and variables.</p>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC2A\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-CCCFF6AD-C7C8-4999-9A32-E90E8693112E-low.gif\"><p class=\"figure-title\">Typing in a function name, in this case the constructor of a box, you get the function\n                  back.\n               </p>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC2D\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-207977D7-8C5B-428C-860C-50B941904B8B-low.gif\"><p class=\"figure-title\">By calling the function, you can create objects just like in the \"real\" Listener.</p>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC30\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-CA6EF5B7-6AD9-4A42-B1B3-56F79F1F6AD3-low.gif\"><p class=\"figure-title\">This box is created 100 units to the right because the position is specified.</p>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC32\"></a>And, so on. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC35\"></a> <span class=\"char_link\"><a href=\"GUID-A6A60FC7-6206-4FFC-80E2-0EF8544BE2C4.htm#WS73099CC142F487553098682E12AC2FC2BC7-5FEB\">Execute</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCC36\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";