var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E4E93BC6-C0C2-435B-BE00-DC6C5406A0A7\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Copy To and From Clipboard\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Copy To and From Clipboard</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E4E93BC6-C0C2-435B-BE00-DC6C5406A0A7\"></a><div class=\"head\">\n            <h1>Copy To and From Clipboard </h1>\n         </div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FF5\"></a> The following methods allow the copying of text and bitmap values to and from the\n            Windows Clipboard. \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FF3\"></a>These methods are available in <em class=\"strong\">3ds Max 2008 and higher</em>. \n         </p>\n         <p><a name=\"GUID-3C14371B-B519-4D8C-9783-D9127A533F10\"></a>They were previously available in the <span class=\"char_link\"><a href=\"GUID-6088991F-08CF-4E55-8BE1-6A203A92456B.htm\">Avguard Extensions</a></span>. \n         </p>\n         <p><a name=\"GUID-41F6363D-DA9B-4412-8EEC-9761F5F5FD83\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50EC\"></a><pre><em class=\"codeEmphasisStrong\">getclipboardText</em>()\n<em class=\"codeEmphasisStrong\">setclipboardText</em> &lt;string&gt;</pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FF1\"></a>Get/Set the text string in Window\'s clipboard. <em class=\"strong\"> <span class=\"code\">getclipboardText()</span> </em> returns a string value, or undefined if the clipboard does not contain a string.\n            <em class=\"strong\"> <span class=\"code\">setclipboardText()</span> </em> returns true if the string was successfully placed in the clipboard, an integer error\n            code if failed. Error code meanings are: \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FF0\"></a> <em class=\"strong\">-1:</em>memory could not be allocated \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FEF\"></a> <em class=\"strong\">-2:</em>clipboard could not be opened \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FEE\"></a> <em class=\"strong\">-3:</em>clipboard could not be cleared \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FED\"></a> <em class=\"strong\">-4:</em>clipboard could not be set \n         </p>\n         <p><a name=\"GUID-DE3D10CC-41D7-4A72-8870-C924C9DBEB0E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50EB\"></a><pre><em class=\"codeEmphasisStrong\">setclipboardBitmap</em> &lt;bitmap&gt;\n<em class=\"codeEmphasisStrong\">getclipboardBitmap</em>()</pre></div>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FEB\"></a>Get/Set the bitmap in Window\'s clipboard. <em class=\"strong\"> <span class=\"code\">getclipboardBitmap()</span> </em> returns a bitmap value, or undefined if the clipboard does not contain a bitmap.\n            <em class=\"strong\"> <span class=\"code\">setclipboardBitmap()</span> </em> returns true if the bitmap was successfully placed in the clipboard, an integer error\n            code if failed. Error code meanings are: \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FEA\"></a> <em class=\"strong\">-1:</em>memory could not be allocated \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FE9\"></a> <em class=\"strong\">-2:</em>clipboard could not be opened \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FE8\"></a> <em class=\"strong\">-3:</em>clipboard could not be cleared \n         </p>\n         <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FE7\"></a> <em class=\"strong\">-4:</em>clipboard could not be set \n         </p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FE6\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FE5\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-50EA\"></a><pre>\n(\nlocal str = \"Sorry For The Inconveniences!\"\nretCode = setclipboardText str\nformat \"Return Code: %\\n\" retCode\nlocal result = getclipboardText()\nif (result != str) then\nthrow \"Clipboard functions didn\'t work\"\nelse&nbsp;\nformat \"%\\n\" result\n&nbsp;\nlocal bm1 = bitmap 100 100 color:red\nretCode = setclipboardBitmap bm1\nformat \"Return Code: %\\n\" retCode\nlocal bm2 = getclipboardBitmap()\ndisplay bm2\nOK\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS3ED54CBA79FF2E3D-31C8AD0B12B78355D64-7FE3\"></a> <span class=\"char_link\"><a href=\"GUID-D65AE3C0-0C12-4262-8807-B23CBED54508.htm\">Interaction With The Operating System</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";