var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E5D783F1-9108-4436-921C-D72BF7035866\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Accessing AssetManager AssetUser and Asset Metadata in MAX Files\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Accessing AssetManager, AssetUser and Asset Metadata in MAX Files</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E5D783F1-9108-4436-921C-D72BF7035866\"></a><div class=\"head\">\n            <h1>Accessing AssetManager, AssetUser and Asset Metadata in MAX Files </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F76\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F75\"></a> In releases prior to <em class=\"strong\">3ds Max 2010</em>, a plug-in that referenced an external file (an asset) would hold the asset’s filename\n               as a string or as a Path object, and would store the filename to the <em class=\"strong\">3ds Max</em> scene file as a string or an IParameterBlock2 TYPE_FILENAME parameter. To allow <em class=\"strong\">3ds Max</em> to identify the assets used by a plug-in, the plug-in would implement an IAssetAccessor-derived\n               class. The information provided from this class was primarily used by the Asset Tracker.\n               \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F72\"></a>Since <em class=\"strong\">3ds Max 2010</em>, assets are handled as instances of class <em class=\"strong\">AssetUser</em>. An instance of this class contains information on the asset filename, its type,\n               and the <em class=\"strong\">3ds Max</em> scene file that depends on it (this is used for resolving external references). Access\n               to, and lifetime management of assets is handled by the <em class=\"strong\">Asset Manager</em>. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F71\"></a>Loading and saving the Asset to the <em class=\"strong\">3ds Max</em> scene file is now done through the <span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm\">AssetUser</a></span> and the <em class=\"strong\">AssetManager</em>. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F6F\"></a> \n               <h3><a name=\"GUID-FBEF533B-1973-4A63-A164-834661003DBA\"></a> <em class=\"strong\">The following topics cover the Interfaces, Objects and Methods related to Asset Management\n                     available in MAXScript:</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F70\"></a>When saving a <em class=\"strong\">3ds Max</em> scene, the asset data is saved by the Asset Manager to a <em class=\"strong\">separate stream</em> in the <em class=\"strong\">3ds Max</em> file. This gives the capability to <em class=\"strong\">external programs to access the asset data</em> in order to identify the assets used by the scene and potentially <em class=\"strong\">modify the asset data</em> without loading the scene file into <em class=\"strong\">3ds Max</em>. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F6E\"></a> <span class=\"char_link\"><a href=\"GUID-E3237B13-8069-4177-8544-9000A98B1C15.htm\">Interface: AssetManager</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F6D\"></a> <span class=\"char_link\"><a href=\"GUID-596D54E9-F660-4C1F-8118-628BDCBC115A.htm\">IObject:AssetUser</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F6C\"></a> <span class=\"char_link\"><a href=\"GUID-DFC564A3-A5E1-4398-AF50-3B4C91BB3358.htm\">Interface: FileResolutionManager</a></span> \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1F6B\"></a> <span class=\"char_link\"><a href=\"GUID-2AF2AFE0-1B22-4DA2-B0F9-CA3ADABCB6C6.htm\">MAX File Asset Metadata Stream Access</a></span> \n               </p> \n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";