var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E5EE5B39-C8F2-4AB5-A890-C39C5EFB39E5\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Icon Bitmap Files - Creating\">\n      <meta name=\"indexterm\" content=\"Creating Icon Bitmap Files\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Creating Icon Bitmap Files</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E5EE5B39-C8F2-4AB5-A890-C39C5EFB39E5\"></a><div class=\"head\">\n            <h1>Creating Icon Bitmap Files </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5712\"></a>  An icon bitmap file can have any number of individual icons, which are lined up side-by-side\n            in the file. \n            	 \n         </p>\n         <div><a name=\"GUID-54206712-9EBC-4BAE-A48D-BCCA99AA1A48\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This topic describes a legacy icon format. See \n               		<span class=\"char_link\"><a href=\"GUID-6E21C768-7256-4500-AB1F-B144F492F055.htm\">Defining Macro Scripts</a></span> for a description of the newer method that supports multi-resolution icons.\n               	 \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-570F\"></a>If you are creating icon bitmap files, these files must meet the following requirements:\n            \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-570E\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-570C\"></a>Icon bitmap files must be .bmp files. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-570A\"></a>The icon bitmap files are actually groups of files. For each icon bitmap file group\n                  there needs to be at least two image files: one containing \n                  			 <span class=\"code\"> <em class=\"strong\">16x15</em> </span> pixel images ending in _16i.bmp, and another containing \n                  			 <span class=\"code\"> <em class=\"strong\">24x24</em> </span> pixel images ending in _24i.bmp. For example, these files would be \n                  			 <span class=\"code\"> <em class=\"strong\">myicons_16i.bmp</em> </span> and \n                  			 <span class=\"code\"> <em class=\"strong\">myicons_24i.bmp</em> </span>. \n                  		  \n               </p> \n            </li>\n         </ul>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75C9\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"GUID-E0AC551A-0273-4C81-9EF4-1779B5C4A2E0\"></a>The 16x15 size requirement is not a typo, the small icons are actually displayed as\n                  15 pixels high. Some shipping icon files have been created with a height of 16 pixels\n                  - in such cases, the last pixel row will be clipped. It is suggested that you set\n                  the height of your icon files to 15 pixels to make sure the complete image is visible.\n                  \n                  		\n               </p> \n            </div>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5706\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5702\"></a>All icon images in an icon bitmap file must be the same size, as defined by the file\n                  name suffix. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-5700\"></a>Each icon bitmap file group must contain similar icon images in the same order. This\n                  allows a single index to locate the desired bitmap, independent of which button size\n                  option the user has chosen. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56FE\"></a>If monochrome, Windows-compatible masks are available, they need to be stored in files\n                  ending in _16m.bmp and _24m.bmp. For example, these files would be \n                  			 <span class=\"code\"> <em class=\"strong\">myicons_16m.bmp</em> </span> and \n                  			 <span class=\"code\"> <em class=\"strong\">myicons_24m.bmp</em> </span>. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56FC\"></a>If 8-bit alpha channel data is available, it needs to be stored in _XXa.bmp files\n                  if the alpha is not premultiplied, and in _XXp.bmp files if the alpha is premultiplied,\n                  where XX is either 16 or 24. For example, these files would be \n                  			 <span class=\"code\"> <em class=\"strong\">myicons_16a.bmp</em> </span> and \n                  			 <span class=\"code\"> <em class=\"strong\">myicons_24a.bmp</em> </span>. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56FA\"></a>If the mask channel bitmap files are present, they are used. If the mask channel bitmap\n                  files are not present, then the alpha channel bitmap files are used. If neither the\n                  mask nor alpha channel data bitmap files are present, then the color of the upper-left\n                  pixel is deemed the transparent color, and a mask is generated automatically for the\n                  image bitmaps. \n                  		  \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56F9\"></a>If you wish to generate icons via calls to \n            		<span class=\"code\"> <em class=\"strong\">render()</em> </span> in MAXScript, make sure you use the naming conventions previously described and place\n            the .bmp files in the current \n            		<em class=\"strong\">3ds Max</em> user-interface directory. You can get the current user-interface directory path with\n            the function: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7267\"></a><pre>local ui_dir = cui.getDir ()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56F7\"></a>In \n            		<em class=\"strong\">3ds Max 9</em> and higher, CUI icon files (*_16i.bmp, *_16a.bmp, *_24i.bmp, *_24a.bmp) are loaded\n            first from the user icon directory, then the max system icon directory, and then &lt;3dsmax.exe&gt;\\ui\\icons.\n            If a file set is present in multiple directories, the version in the first directory\n            is used. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56F6\"></a>In \n            		<em class=\"strong\">3ds Max 9</em> and higher, the icon filename specified as an argument to loadPicture, the filename\n            in images arrays for UI items, and the filename for the bitmap UI item no longer needs\n            to specify a path to the icon folder. The icon filename will be searched for in the\n            following directories (in order): \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-6426\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56F4\"></a>The directory associated with the current mzp package, if any. \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-6425\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56F2\"></a>The directory associated with the calling script \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-6424\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56F0\"></a>The user icon directory \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-6423\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56EE\"></a>The max system icon directory \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-6422\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56EC\"></a>&lt; 3dsmax.exe &gt;\\ui\\icons \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-6421\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56EA\"></a>The user startup scripts directory \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-6420\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56E8\"></a>The user scripts directory \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-641F\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56E6\"></a>The max system startup scripts directory \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-641E\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56E4\"></a>The max system scripts directory \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-641D\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56E2\"></a>The map path directories \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-641C\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56E0\"></a>The image directory \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-641B\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56DE\"></a>The 3DS executable main directory \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-641A\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56DC\"></a>The Windows NT 32-bit system directory (system32) \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-6419\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56DA\"></a>The Windows 16-bit system directory (system) \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-6418\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56D8\"></a>The Windows directory \n            	 \n         </p><a name=\"WS73099CC142F48755-49D92FDB129CC323221-6417\"></a><p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56D6\"></a>The directories that are listed in the PATH environment variable \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56D3\"></a>The following methods are useful when working with custom icons files: \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7266\"></a><pre><em class=\"codeEmphasisStrong\">colorman.reInitIcons</em>()</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56D1\"></a>Reloads all CUI icons from the icon files. This can be used to refresh the UI after\n            adding new or editing existing icon bitmap files. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56D0\"></a>Available in \n            		<em class=\"strong\">3ds Max 9 and higher</em>. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7265\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">colorman.resolveIconFolder</em> &lt;filename&gt; &lt;&amp;fullfilename&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56CD\"></a>This method resolves the filename using the user icon path, then the system icon path,\n            and then &lt;3dsmax.exe&gt;\\ui\\icons. If the file is found, fully qualified filename is\n            placed in full filename and the method returns true. If not found, the method returns\n            false. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-56CC\"></a>Available in \n            		<em class=\"strong\">3ds Max 9 and higher</em>. \n            	 \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";