var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E6615B92-8BC4-4A13-BC31-86E006657A5C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Controller\">\n      <meta name=\"indexterm\" content=\"reduceKeys()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Controller Key Reducer</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E6615B92-8BC4-4A13-BC31-86E006657A5C\"></a><div class=\"head\">\n            <h1>Controller Key Reducer </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FCE\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FCD\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controllers</a></span> &gt; Key Reducer Function \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2ECC\"></a><pre><em class=\"codeEmphasisStrong\">reduceKeys</em> &lt;controller&gt; &lt;threshold&gt; &lt;step&gt; [ &lt;range&gt; ]</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FCA\"></a>where <span class=\"code\"> <em class=\"strong\">&lt;threshold&gt;</em> </span> is the closeness that the key-reduced controller will match the original keys, <span class=\"code\"> <em class=\"strong\">&lt;step&gt;</em> </span> is the time step at which the controller will be sampled and <span class=\"code\"> <em class=\"strong\">&lt;range&gt;</em> </span> is an optional time range within which the keys are reduced given as either 2 time\n            values or an Interval value, defaulting to the active animation range. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FC8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FC7\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2ECB\"></a><pre>\nreduceKeys $foo.pos.controller 0.5 1f\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FC3\"></a><p class=\"table-body\">reduce keys on foo’s position, retain 0.5 units accuracy, sample every frame. </p> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FC1\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FC0\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2ECA\"></a><pre>\nreduceKeys $baz.bend.angle.controller 0.1 0.5f (interval 20 75)\n</pre></div> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FBC\"></a><p class=\"table-body\">Reduce keys on baz’s bend angle, retain 0.1 units accuracy, sample every half frame,\n                        reduce within the interval 20f to 75f. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FBA\"></a>As with the reducer in the track view, a progress bar and cancel button is displayed.\n            \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FB7\"></a> <span class=\"char_link\"><a href=\"GUID-B1700B1D-B1EA-4A6C-B4A3-A29DB26C8C02.htm\">Controller Key Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FB6\"></a> <span class=\"char_link\"><a href=\"GUID-71299FC9-9EE4-45EB-AF7D-146F31EB6AC6.htm\">Controller Time Functions</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FB5\"></a> <span class=\"char_link\"><a href=\"GUID-B0AE3E3F-140A-49A2-844B-3C398BA97569.htm\">Controller Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-7FB4\"></a> <span class=\"char_link\"><a href=\"GUID-D839F477-A534-4764-BC16-93B702F72807.htm\">Animation Controllers</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";