var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E66C9960-E058-4EF8-92EA-EB65365B79CF\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"unRegisterViewWindow()\">\n      <meta name=\"indexterm\" content=\"Rollout Floaters as Extended viewports\">\n      <meta name=\"indexterm\" content=\"registerViewWindow()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXScript Dialogs and Rollout Floaters as Extended Viewports</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E66C9960-E058-4EF8-92EA-EB65365B79CF\"></a><div class=\"head\">\n            <h1>MAXScript Dialogs and Rollout Floaters as Extended Viewports </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6698\"></a>The following functions can be used to register and unregister MAXScript dialogs and\n            rollout floaters as extended viewports. \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-746D\"></a><pre><em class=\"codeEmphasisStrong\">registerViewWindow</em> &lt;MAXScript_dialog | rollout_floater&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6696\"></a>Registers any MAXScript dialog or rollout floater as an extended viewport. The title\n            of the dialog or floater appears in the viewport right-click menu under Views &gt; Extended\n            menu. When picked the dialog or floater will be displayed in that viewport. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6695\"></a>If you click anywhere on the outside border, it will pop up the standard views menu.\n            This will let you switch to a different view window. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-746C\"></a><pre><em class=\"codeEmphasisStrong\">unRegisterViewWindow</em> &lt;MAXScript_dialog | rollout_floater&gt;</pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6692\"></a>Unregisters a dialog or floater as an extended view window. It will throw an error\n            if the dialog or floater is currently displayed in a viewport. \n            	 \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-746B\"></a><pre>&lt;rollout_floater&gt;.<em class=\"codeEmphasisStrong\">inViewport</em></pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-668F\"></a>This property returns \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> if the rolloutfloater or rollout is installed in a viewport, \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> otherwise. Read-only. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-668E\"></a>Here is a sample script that creates two instances of a Cult3D viewer found at \n            		<em class=\"strong\">www.cycore.com</em>, and opens two files from the internet. Install the Cult3d Viewer and execute the\n            script example below. After executing the script right click on any of the viewports\n            and pick \"Views &gt; Extended &gt; Cult3D Player\" to display the window in the viewport.\n            \n            		 \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-668D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-668C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-746A\"></a><pre>\nrollout rCult3D \"Cult3D Player\"\n(\nactiveXControl ax1 \"{31B7EB4E-8B4B-11D1-A789-00A0CC6651A8}\" align:#left setupEvents:false pos:[10,10]\nactiveXControl ax2\"{31B7EB4E-8B4B-11D1-A789-00A0CC6651A8}\"align:#left setupEvents:false pos:[10,220]\non rCult3D resized size do\n(\nlocalcsz = (size - [20,30])*[1,.5]\nax2.pos = [10, csz.y+20]\nax1.size = ax2.size = csz\n)\non rCult3D open do\n(\nax1.size = ax2.size = [300,200]\nax1.LoadCult3D\"http://www.cult3d.com/gallery/ecommerce/olympus_on_the_beach.co\"\nax2.LoadCult3D\"http://www.cult3d.com/gallery/museum/madonna.co\"\n)\n)\ncreateDialog rCult3D width:320 height:430\nregisterViewWindow rCult3D\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6675\"></a> <img src=\"../images/GUID-64B634DF-6404-4502-8A06-A9F6C642EDE9-low.gif\"> \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-6673\"></a> <span class=\"char_link\"><a href=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA.htm\">ActiveX Controls in MAXScript Rollouts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";