var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E672728A-EE15-4197-9EDD-487781167B01\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Context\">\n      <meta name=\"indexterm\" content=\"expressions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Context Expressions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E672728A-EE15-4197-9EDD-487781167B01\"></a><div class=\"head\">\n            <h1>Context Expressions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27532E87006\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87007\"></a>  Context expressions are parts of the MAXScript syntax that are specifically designed\n               for use with \n               		  <em class=\"strong\">3ds Max</em>. Context expressions are mirrors of some of the most important abstractions in the\n               \n               		  <em class=\"strong\">3ds Max</em> user interface - the animate button, the time-line slider, the working coordinate\n               system, and so on. Context expressions make it as easy to create animation and perform\n               geometry manipulation in MAXScript as these tools do in the user interface. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8700A\"></a>The basic idea for this is a prefix that is supplied to set up a context for the evaluation\n               of its expression. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8700B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8700C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60F8\"></a><pre>\nb1 = box()\nb2 = box()\nanimate on\n(\n  move $box001 [20, 0, 0]\n  rotate $box002 45 x_axis\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87014\"></a>This effectively \"turns on\" the animate button for the duration of its block-expression.\n               The move and rotate automatically generate keyframes, just as it happens when you\n               turn the animate button on in the \n               		  <em class=\"strong\">3ds Max</em> user interface and move objects around. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87015\"></a>Another kind of context expression has a prefix for setting the current animation\n               time, as though you had moved the time slider. If we mix the two forms together, you\n               can see how to do keyframe animation in MAXScript. \n               		\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87016\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E87017\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE,</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60F7\"></a><pre>\nanimate on\n(\n  at time 0 $box001.position = [-100, 0, 0]\n  at time 100 $box001.position = [100, 0, 0]\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87021\"></a>The full syntax for \n               		  <span class=\"code\">&lt;context_expr&gt;</span> is: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60F6\"></a><pre>&lt;context&gt; { <em class=\"codeEmphasisStrong\">,</em> &lt;context&gt; } &lt;expr&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87023\"></a>where \n               		  <span class=\"code\">&lt;context&gt;</span> is one of: \n               		\n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60F5\"></a><pre>[ <em class=\"codeEmphasisStrong\">with</em> ] <em class=\"codeEmphasisStrong\">animate</em> &lt;boolean&gt; \n<em class=\"codeEmphasisStrong\">at level</em> &lt;node&gt;\n<em class=\"codeEmphasisStrong\">in</em> &lt;node&gt;\n<em class=\"codeEmphasisStrong\">at time</em> &lt;time&gt;\n[ <em class=\"codeEmphasisStrong\">in</em> ] <em class=\"codeEmphasisStrong\">coordsys</em> &lt;coordsys&gt;\n<em class=\"codeEmphasisStrong\">about</em> &lt;center_spec&gt;\n[ <em class=\"codeEmphasisStrong\">with</em> ] <em class=\"codeEmphasisStrong\">undo</em> &lt;boolean&gt;\n[ <em class=\"codeEmphasisStrong\">with</em> ] <em class=\"codeEmphasisStrong\">redraw</em> &lt;boolean&gt;\n[ <em class=\"codeEmphasisStrong\">with</em> ] <em class=\"codeEmphasisStrong\">quiet</em> &lt;bool&gt;\n[ <em class=\"codeEmphasisStrong\">with</em> ] <em class=\"codeEmphasisStrong\">redraw</em> &lt;bool&gt;\n[ <em class=\"codeEmphasisStrong\">with</em> ] <em class=\"codeEmphasisStrong\">printAllElements</em> &lt;bool&gt;\n[ <em class=\"codeEmphasisStrong\">with</em> ] <em class=\"codeEmphasisStrong\">defaultAction</em> &lt;action&gt;\n[ <em class=\"codeEmphasisStrong\">with</em> ] <em class=\"codeEmphasisStrong\">MXSCallstackCaptureEnabled</em> &lt;bool&gt;\n[ <em class=\"codeEmphasisStrong\">with</em> ] <em class=\"codeEmphasisStrong\">dontRepeatMessages</em> &lt;bool&gt;\n[ <em class=\"codeEmphasisStrong\">with</em> ] <em class=\"codeEmphasisStrong\">macroRecorderEmitterEnabled</em> &lt;bool&gt;\n</pre></div> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8702C\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8702D\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES:</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-60F4\"></a><pre>\n-- randomly jiggle each object in the selection around + or - 20 units\nin coordsys local selection.pos = random [-20,20,20] [20,20,20]\n-- rotate all the boxes 30 degrees about the y_axis of $foo\nabout $box001 rotate $box002* 30 y_axis\n-- generate a keyframed animation of $foo randomly chasing $baz\nanimate on\n  for t in 0 to 100 by 5 do\n    at time t\n      $box001.pos = $box002.pos + random [-10,-10,-10] [10,10,10]\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8703A\"></a>The individual context expressions are described in the following topics: \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8703B\"></a> <span class=\"char_link\"><a href=\"GUID-CC2D2450-AECD-4732-BF93-4AA91ED0BC56.htm\">animate</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8703C\"></a> <span class=\"char_link\"><a href=\"GUID-715B1CA8-B27D-495B-964D-1826EAE7030C.htm\">at level, in</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8703D\"></a> <span class=\"char_link\"><a href=\"GUID-4E9CCD61-F575-42E1-8654-315DDF6C6A26.htm\">at time</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8703E\"></a> <span class=\"char_link\"><a href=\"GUID-6C7219CF-B9B7-4B18-A846-5522A9D970F3.htm\">coordsys</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8703F\"></a> <span class=\"char_link\"><a href=\"GUID-E4732A5D-91C4-4EDD-8944-F00E7DC57D10.htm\">about</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87040\"></a> <span class=\"char_link\"><a href=\"GUID-C8517C4A-A75F-4D4E-A058-BE3EE61A2A11.htm\">undo</a></span> \n            </p> \n            <p><span class=\"char_link\"><a href=\"GUID-438AC4EB-2AA9-4EF8-BD1F-4EC8A034A316.htm\">quiet</a></span> \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87041\"></a> <span class=\"char_link\"><a href=\"GUID-9A522918-0517-4B04-80AF-F3FEFEE23448.htm\">redraw</a></span> \n            </p> \n            <p><span class=\"char_link\"><a href=\"GUID-92B98D11-60FF-4742-A1BA-692EE135E085.htm\">PrintAllElements</a></span> \n            </p> \n            <p><span class=\"char_link\"><a href=\"GUID-A6FE1355-631F-47BD-BBAE-4368CF9D31FD.htm\">defaultAction</a></span> \n            </p> \n            <p><span class=\"char_link\"><a href=\"GUID-53483E27-8DFA-47E6-8835-E6FE1C031B12.htm\">macroRecorderEmitterEnabled</a></span> \n            </p> \n            <p><span class=\"char_link\"><a href=\"GUID-F2315A09-440B-4EAE-8873-F27265CDB668.htm\">MXSCallstackCaptureEnabled</a></span> \n            </p> \n            <p><span class=\"char_link\"><a href=\"GUID-BCB0E3E1-31C2-4A6B-B221-2FA798D772CE.htm\">dontRepeatMessages</a></span> \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87043\"></a> <span class=\"char_link\"><a href=\"GUID-BB31B990-EDFE-4E4E-8B28-02A882F33300.htm\">Cascading Contexts</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87044\"></a> <span class=\"char_link\"><a href=\"GUID-95CCAA15-0FA7-4273-AD8E-96B019CE7D28.htm\">Nested Contexts</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87045\"></a> <span class=\"char_link\"><a href=\"GUID-D4660B55-E229-4155-9B4B-EE13178D4E8D.htm\">Sticky Contexts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-CC2D2450-AECD-4732-BF93-4AA91ED0BC56.htm\">animate </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-715B1CA8-B27D-495B-964D-1826EAE7030C.htm\">at level; in </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-4E9CCD61-F575-42E1-8654-315DDF6C6A26.htm\">at time </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-E4732A5D-91C4-4EDD-8944-F00E7DC57D10.htm\">about </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-6C7219CF-B9B7-4B18-A846-5522A9D970F3.htm\">coordsys </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-A6FE1355-631F-47BD-BBAE-4368CF9D31FD.htm\">defaultAction Context </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-F2315A09-440B-4EAE-8873-F27265CDB668.htm\"> MXSCallstackCaptureEnabled </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-438AC4EB-2AA9-4EF8-BD1F-4EC8A034A316.htm\">quiet Context </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-9A522918-0517-4B04-80AF-F3FEFEE23448.htm\">redraw Context </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-C8517C4A-A75F-4D4E-A058-BE3EE61A2A11.htm\">undo </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-BCB0E3E1-31C2-4A6B-B221-2FA798D772CE.htm\">dontRepeatMessages Context</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-BB31B990-EDFE-4E4E-8B28-02A882F33300.htm\">Cascading Contexts </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-95CCAA15-0FA7-4273-AD8E-96B019CE7D28.htm\">Nested Contexts </a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-D4660B55-E229-4155-9B4B-EE13178D4E8D.htm\">Sticky Contexts </a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";