var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E70D3CFB-21A8-4432-BBCD-7F6A19B26F9A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"note track access\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Note Track Access</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E70D3CFB-21A8-4432-BBCD-7F6A19B26F9A\"></a><div class=\"head\">\n            <h1>Note Track Access </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36EB\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36EA\"></a> All MAXWrapper objects can have one or more note tracks assigned to them. \n            </p> \n            <p><a name=\"P_29082ECFD0D64ACB9F3A3B297F9F1129\"></a>These note tracks are visible in Track View as children of the MAXWrapper object.\n               \n            </p> \n            <p><a name=\"P_47115B1269874ABEBAA8EC7118B7C53F\"></a>Note tracks provide a way for plug-ins to attach data to any <em class=\"strong\">3ds Max</em> object in a scene, such as nodes, materials, modifiers, controllers, etc., that is\n               permanently stored with that object in the <em class=\"strong\">3ds Max</em> scene file. \n            </p> \n            <p><a name=\"P_7937CD170FFE4A05AE26C5282A877994\"></a>This data is stored in note keys, and a note track can contain any number of note\n               keys. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36E8\"></a>The structure of note tracks is similar to the structure of key-able animation controllers.\n               \n            </p> \n            <p><a name=\"P_63A477DFF6714F2E9F1A4F8AD4CDC682\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <p><a name=\"P_C8B2E04EF4CB41FF867AE048664F37D7\"></a>A note track is an instance of the class, and has a property called <span class=\"code\"> <em class=\"strong\">keys</em> </span>. \n            </p> \n            <p><a name=\"P_07A57CCC4B844F8F9B430B43B47582A3\"></a>The value returned by accessing the <span class=\"code\"> <em class=\"strong\">keys</em> </span> property is a <span class=\"code\"> <em class=\"strong\">MAXNoteKeyArray</em> </span>. \n            </p> \n            <p><a name=\"P_A42846CCFC6F490A8148B41DCBF9B610\"></a>The <span class=\"code\"> <em class=\"strong\">MAXNoteKeyArray</em> </span> contains the note keys. \n            </p> \n            <p><a name=\"P_254FAD2633E8470994CD223DA4594D1C\"></a>The keys themselves are accessed as if the <span class=\"code\"> <em class=\"strong\">MAXNoteKeyArray</em> </span> was an array. \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36E6\"></a> <span class=\"char_link\"><a href=\"GUID-8038109D-B71B-4685-8E78-E57333F3CA2C.htm\">Notetrack Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36E5\"></a> <span class=\"char_link\"><a href=\"GUID-4A84696B-7541-4E8B-AA7A-7632849B824E.htm\">MAXNoteKeyArray Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36E4\"></a> <span class=\"char_link\"><a href=\"GUID-0901179E-E93C-4E0E-94B5-5BC479B3B056.htm\">MAXNoteKey Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-36E3\"></a> <span class=\"char_link\"><a href=\"GUID-4733B2AC-1F0E-4A78-A79C-93ED8A28DAC9.htm\">Working with Note Tracks</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";