var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E761B52A-E3C5-416D-A1D3-9E7EE973ABBB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface INodeLayerProperties\">\n      <meta name=\"indexterm\" content=\"INodeLayerProperties Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: INodeLayerProperties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E761B52A-E3C5-416D-A1D3-9E7EE973ABBB\"></a><div class=\"head\">\n            <h1>Interface: INodeLayerProperties </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B29\"></a> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B28\"></a>  This represents the interface to the node’s Layer Properties. These properties correspond\n               to UI controls found in different areas of the Object Properties dialog. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B25\"></a> <em class=\"strong\">Properties:</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5330\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.layer</em> : Interface : Read 	 </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B24\"></a>Returns a <span class=\"char_link\"><a href=\"GUID-79537E16-FE25-4567-BEA6-06F39E0A5C1F.htm\">LayerProperties</a></span><span class=\"char_link\"><a href=\"GUID-7BC5A515-913D-45D2-A45F-43792D828055.htm\">Mixin Interface</a></span> giving access to the object’s layer properties. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-532F\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.displayByLayer</em> : boolean : Read|Write   </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B22\"></a>Corresponds to the By Layer / By Object checkbutton in the Object Properties &gt; General\n               tab &gt; Display Properties. When <span class=\"code\"> <em class=\"strong\">true</em> </span>, the layer’s Display Properties settings will be used. When<span class=\"code\"> <em class=\"strong\"> false</em> </span>, the object’s Display Properties settings will be used instead. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-532E\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.renderByLayer</em> : boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B20\"></a>Corresponds to the By Layer / By Object checkbutton in the Object Properties &gt; General\n               tab &gt; Rendering Control. When <span class=\"code\"> <em class=\"strong\">true</em> </span>, the layer’s Rendering Controls settings will be used. When<span class=\"code\"> <em class=\"strong\"> false</em> </span>, the object’s Rendering Controls will be used instead. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-532D\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.motionByLayer</em> : boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B1E\"></a>Corresponds to the By Layer / By Object checkbutton in the Object Properties &gt; General\n               tab &gt; Motion Blur. When <span class=\"code\"> <em class=\"strong\">true</em> </span>, the layer’s Motion Blur settings will be used. When <span class=\"code\"> <em class=\"strong\">false</em> </span>, the object’s Motion Blur settings will be used instead. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-532C\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.colorByLayer</em> : boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B1C\"></a>When<span class=\"code\"> <em class=\"strong\"> true</em> </span>, the object will use the Layer’s color. When <span class=\"code\"> <em class=\"strong\">false</em> </span>, the object’s color will be used instead. This affects the Layer Color switch in\n               the Layer Properties. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-532B\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">.globalIlluminationByLayer</em> : boolean : Read|Write </pre></div> \n            <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B1A\"></a>Corresponds to the By Layer / By Object checkbutton in the Object Properties &gt; Adv.\n               Lighting tab. This is identical to the .<span class=\"code\"> <em class=\"strong\">GIByLayer</em> </span> property exposed by the <span class=\"char_link\"><a href=\"GUID-2EBF67B3-7D0D-4649-80E4-A1D1D7E4C63E.htm\">INodeGIProperties</a></span> Node Interface. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B18\"></a> <span class=\"char_link\"><a href=\"GUID-79537E16-FE25-4567-BEA6-06F39E0A5C1F.htm\">Interface: LayerManager</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-B17\"></a> <span class=\"char_link\"><a href=\"GUID-38A8EFE3-685B-41F8-9E36-5B6B5CEACC18.htm\">Node Interfaces</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";