var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Values</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E79133B4-9C23-40FD-8C2A-9FF43861222A\"></a><div class=\"head\">\n            <h1>Values </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27532E8762E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27532E8762F\"></a><p class=\"table-body\">Value </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87631\"></a>The \n            		<em class=\"strong\">Value</em> class is the root class for all MAXScript classes. It supplies methods and operators\n            that \n            		<em class=\"strong\">any</em> class can use. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87632\"></a>As described in \n            		<span class=\"char_link\"><a href=\"GUID-0CA68F7B-8B14-4D5E-8D9C-BE97E2881B43.htm\">Properties, Methods, Operators, and Literals</a></span>, each class can specify external interfaces for the class. These external interfaces\n            are broken up into the following categories: \n            	 \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87633\"></a><ul>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87635\"></a> <em class=\"strong\">Literals:</em> Any literal form for objects of the class. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87637\"></a> <em class=\"strong\">Constructors:</em> The various ways you can create objects of the class. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87639\"></a> <em class=\"strong\">Properties:</em> Accessible parameters for objects of the class. \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8763B\"></a> <em class=\"strong\">Operators:</em> Defines the math and other symbolic operators that are defined on values in the class.\n                  \n                  		  \n               </p> \n            </li>\n            <li> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8763D\"></a> <em class=\"strong\">Methods:</em> Defines all the functions you can call for objects of the class. \n                  		  \n               </p> \n            </li>\n         </ul>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8763E\"></a>In the description of each class in MAXScript, each of these external interfaces are\n            documented. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8763F\"></a>In the syntax forms given for methods, operators, and properties, the types of argument\n            or property values are specified using the \n            		<span class=\"code\"> &lt;type_name&gt; \n               		</span> convention, in which \n            		<span class=\"code\"> <em class=\"strong\">type_name</em> </span> describes the type of value that is allowable for that argument or property. You\n            can, of course, use an arbitrary expression for these values, as long as it evaluates\n            to a value of the right type. For example, \n            		<span class=\"code\"> <em class=\"strong\">&lt;boolean&gt;</em> </span> means either the \n            		<span class=\"code\"> <em class=\"strong\">true</em> </span> or \n            		<span class=\"code\"> <em class=\"strong\">false</em> </span> Boolean values. \n            	 \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87640\"></a>Also indicated for function calls are those that are automatically \n            		<em class=\"strong\">mapped</em> over collections. This means that the function will be automatically called repeatedly\n            on the elements of a collection if the collection is given as the first argument to\n            the function. See \n            		<span class=\"char_link\"><a href=\"GUID-99A90A15-04D5-4D53-B9F1-CE5C7E1C4D7D.htm\">Collections</a></span> for more information. \n            	 \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87643\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87644\"></a> <span class=\"char_link\"><a href=\"GUID-0AEEF510-1859-48B7-9A19-A6158B0310A7.htm\">Working with Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87646\"></a> <span class=\"char_link\"><a href=\"\">Basic Data Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87647\"></a> <span class=\"char_link\"><a href=\"\">Time Data Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87648\"></a> <span class=\"char_link\"><a href=\"GUID-3468EA14-C6BC-4FA0-BC3F-DA2382BC228E.htm\">Special Data Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E87649\"></a> <span class=\"char_link\"><a href=\"GUID-9F6ABEE1-0728-4B39-8903-D909634C1304.htm\">Bitmap Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8764A\"></a> <span class=\"char_link\"><a href=\"GUID-A2290E77-5392-431D-8B75-F6A1262E9639.htm\">Stream Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8764B\"></a> <span class=\"char_link\"><a href=\"GUID-5ED6F7E0-33CC-4F4E-972E-094EB33BEA85.htm\">MAXKey Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8764C\"></a> <span class=\"char_link\"><a href=\"GUID-49BE2F03-7AC0-41B3-9B82-EF2D2B094BDE.htm\">ArrayParameter Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8764D\"></a> <span class=\"char_link\"><a href=\"GUID-E035EAA8-BDF4-486F-B19E-9E0FFB9990C9.htm\">DataPair Values</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27532E8764E\"></a> <span class=\"char_link\"><a href=\"GUID-DAABD302-FB6A-40BB-882A-888631488FB7.htm\">Collection Types</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";