var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-E9D3BB95-67F8-4E02-AE00-F95CC1711C0C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface assemblyMgr\">\n      <meta name=\"indexterm\" content=\"assemblyMgr Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: assemblyMgr</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E9D3BB95-67F8-4E02-AE00-F95CC1711C0C\"></a><div class=\"head\">\n            <h1>Interface: assemblyMgr </h1>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DC4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DC3\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; assemblyMgr \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DC1\"></a>Represents the interface to the Assembly Manager. Used to put objects together to\n            Assemblies, and test and manipulate the Assemblies. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DC0\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C8B\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">Assemble </em>&lt;node array&gt;nodes [ <em class=\"codeEmphasisStrong\">name</em>:&lt;string&gt; ][ <em class=\"codeEmphasisStrong\">classDesc:</em>&lt;class&gt; ] [ <em class=\"codeEmphasisStrong\">select:</em>&lt;bool&gt; ] 	 \n\nname default value: undefined 	 \nclassDesc default value: undefined 	 \nselect default value: true   </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DBB\"></a>Create a new Assembly using the nodes in the &lt;node array&gt;. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DBA\"></a>A Create Assembly dialog will be displayed if either the name or the classDesc is\n            not specified. The classDesc is passed a MAXClass, an instance of which will be used\n            as the assembly head. This MAXClass must be for a helper object. You can create a\n            scripted plug-in that extends helper to use as assembly head, exposing the properties\n            you desire for the assembly head. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DB8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DB7\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C88\"></a><pre>\nobject1 = Cylinder()--create a cylinder\n--&gt; $Cylinder:Cylinder001 @ [0.000000,0.000000,0.000000]\nobject2 = Box()--create a box\n--&gt; $Box:Box001 @ [0.000000,0.000000,0.000000]\nobject3 = OmniLight()\n--&gt; $Omni_Light:Omni001 @ [0.000000,0.000000,0.000000]\nobj_array = #(object1, object2, object3)\n--&gt; #($Cylinder:Cylinder001 @ [0.000000,0.000000,0.000000], $Box:Box001 @ [0.000000,0.000000,0.000000], $Omni_Light:Omni001 @ [0.000000,0.000000,0.000000])\n&nbsp;\n--Create a new Assembly out of the objects, name it Test001 and use\n--a Dummy as the head. new_ass will contain the assembly head.\nnew_ass = assemblyMgr.assemble obj_array name:\"Test001\" classDesc:Dummy\n--&gt; $Dummy:Test001 @ [0.000000,0.000000,-8.000000]\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-44A2BA44-98CB-4B49-8AC6-8E4BB91F8159\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C87\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">Disassemble</em> &lt;node array&gt;nodes </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DA4\"></a>Disassembles the specified nodes. Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> on success. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DA3\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6DA2\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553DA881E312B1ADD7BD0-5626\"></a><pre>\n--Continuing with the assembly from the above example...\nobj_array\n--&gt; #($Cylinder:Cylinder001 @ [0.000000,0.000000,0.000000], $Box:Box001 @ [0.000000,0.000000,0.000000], $Omni_Light:Omni001 @ [0.000000,0.000000,0.000000])\n--We cannot disassemble the original array because it does not\n--contain the head object!\nassemblyMgr.Disassemble obj_array\n--&gt; false\n--Let’s append the head to the array and try again...\nappend obj_array $Test001\n--&gt; #($Cylinder:Cylinder001 @ [0.000000,0.000000,0.000000], $Box:Box001 @ [0.000000,0.000000,0.000000], $Omni_Light:Omni001 @ [0.000000,0.000000,0.000000], $Dummy:Test01 @ [0.000000,0.000000,-8.000000])\n--Now that we supplied all objects of the assembly,\n--the Disassemble method worked.\nassemblyMgr.Disassemble obj_array\n--&gt; true\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"GUID-62E95641-28B5-4B68-B95F-0002DF680EB0\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C86\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">Open</em> &lt;node array&gt;nodes [<em class=\"codeEmphasisStrong\">clearSelection:</em>&lt;bool&gt;] \n\nclearSelection default value: true </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D8E\"></a>Opens the specified nodes. Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> on success. When <span class=\"code\"> <em class=\"strong\">clearSelection:</em> </span> is supplied as <em class=\"strong\"> <span class=\"code\">false</span> </em>, the selection will not be cleared. \n         </p>\n         <p><a name=\"GUID-1F9A089A-DEED-45B4-B415-7598895CC480\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C83\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">Close</em> &lt;node array&gt;nodes[<em class=\"codeEmphasisStrong\">select:</em>&lt;bool&gt;] \n\nselect default value: true </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D8A\"></a>Closes the specified nodes. Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> on success. \n         </p>\n         <p><a name=\"GUID-BDC18DE5-2EBE-47FF-B37D-FDD040CAB108\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C80\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">Explode</em> &lt;node array&gt;nodes </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D87\"></a>Explodes the specified nodes. Returns<span class=\"code\"> <em class=\"strong\">true</em> </span> on success. \n         </p>\n         <p><a name=\"GUID-D6281EA9-0245-47D4-A91A-BDD5F12F3690\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C7F\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">Attach</em> &lt;node array&gt;nodes[<em class=\"codeEmphasisStrong\">assembly:</em>&lt;node&gt;] \n\nassembly default value: undefined </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D83\"></a>Attaches the specified nodes to the assembly. Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> on success. \n         </p>\n         <p><a name=\"GUID-E3973868-2453-4433-B293-FA8BE5AF07AA\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C7D\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">Detach</em> &lt;node array&gt;nodes </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D80\"></a>Detaches the specified nodes from the assembly. Returns<span class=\"code\"> <em class=\"strong\">true</em> </span> on success. \n         </p>\n         <p><a name=\"GUID-C6BE4DAC-446F-4A63-AC79-7EEA0E810A6E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C7C\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">CanAssemble</em> &lt;node array&gt;nodes </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D7D\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the<span class=\"code\"> <em class=\"strong\">&lt;node array&gt;</em> </span> contains nodes that can be assembled. \n         </p>\n         <p><a name=\"GUID-0F048094-5FC1-4E96-919E-418816A8F475\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C7B\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">CanDisassemble</em> &lt;node array&gt;nodes </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D7A\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the <span class=\"code\"> <em class=\"strong\">&lt;node array&gt;</em> </span> contains nodes that can be disassembled. \n         </p>\n         <p><a name=\"GUID-A1850F5E-1190-4080-9774-0B092842ED35\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C7A\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">CanExplode</em> &lt;node array&gt;nodes </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D77\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the <span class=\"code\"> <em class=\"strong\">&lt;node array&gt;</em> </span> contains nodes that can be exploded. \n         </p>\n         <p><a name=\"GUID-60E66BC8-73B9-4642-AB18-E90733417B4E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C79\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">CanOpen</em> &lt;node array&gt;nodes </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D74\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the <span class=\"code\"> <em class=\"strong\">&lt;node array&gt;</em> </span> contains nodes that can be opened. \n         </p>\n         <p><a name=\"GUID-1A524979-858D-4662-9579-AE0992DE322C\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C78\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">CanClose</em> &lt;node array&gt;nodes </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D71\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the <span class=\"code\"> <em class=\"strong\">&lt;node array&gt;</em> </span> contains nodes that can be closed. \n         </p>\n         <p><a name=\"GUID-D8E4FA52-C6E7-4637-9003-7840114DBC9E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C77\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">CanAttach</em> &lt;node array&gt;nodes <em class=\"codeEmphasisStrong\">assembly:</em>&lt;node&gt; \n\nassembly default value: undefined </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D6D\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the nodes in <span class=\"code\"> <em class=\"strong\">&lt;node array&gt;</em> </span> can be attached to the assembly. \n         </p>\n         <p><a name=\"GUID-77614E71-9F16-42CF-BF2C-8124DC99D3B5\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C74\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">CanDetach</em> &lt;node array&gt;nodes </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D6A\"></a>Returns <span class=\"code\"> <em class=\"strong\">true</em> </span> if the nodes in <span class=\"code\"> <em class=\"strong\">&lt;node array&gt;</em> </span> can be detached. \n         </p>\n         <p><a name=\"GUID-29674B49-34A6-461C-AF03-4EA6C8207178\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C73\"></a><pre>&lt;node&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">IsAssembly</em> &lt;node array&gt;nodes </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D67\"></a>Returns the Head Node of the Assembly comprised by the nodes specified by <span class=\"code\"> <em class=\"strong\">&lt;node array&gt;</em> </span> , or <span class=\"code\"> <em class=\"strong\">undefined</em> </span> if the nodes do not form an Assembly. \n         </p>\n         <p><a name=\"GUID-9C509FEB-16FE-48BF-AA23-75FFBF5AF64E\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C72\"></a><pre>&lt;bool&gt;<em class=\"codeEmphasisStrong\">assemblyMgr</em>.<em class=\"codeEmphasisStrong\">FilterAssembly</em> &lt;node&gt;assemblyHead &lt;value&gt;filterSClassID &lt;&amp;node array&gt;filteredNodes \n\nfilteredNodes is Out parameter </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D63\"></a>Filters all nodes of the specified superclass that are contained in the assembly with\n            the specified head and passes them out to the supplied filterNodes array. Returns\n            <span class=\"code\"> <em class=\"strong\">true</em> </span> on success. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D62\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D61\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-5C6F\"></a><pre>\n--Assembly contains a Cylinder,a Box and a Dummy Helper as head:\ntest_array = #($Box001, $Cylinder001)\n--&gt; #($Box:Box001 @ [0.000000,0.000000,0.000000], $Cylinder:Cylinder001 @ [0.000000,0.000000,0.000000])\n--Check for assembly with the lights only\nassemblyMgr.IsAssembly test_array\n--&gt; undefined\n--Now check with all assembly nodes including the Head\ntest_array = #($Box001, $Cylinder001, $Omni001, $Test001)\n--&gt; #($Box:Box001 @ [0.000000,0.000000,0.000000], $Cylinder:Cylinder001 @ [0.000000,0.000000,0.000000], $Omni_Light:Omni001 @ [0.000000,0.000000,0.000000], $Dummy:Test001 @ [0.000000,0.000000,-8.000000])\na_head = assemblyMgr.IsAssembly test_array\n--&gt; $Dummy:Test001 @ [0.000000,0.000000,-8.000000]\n--a_head now contains the Head of the Assembly containing the above objects!\n&nbsp;\n--Find all light objects in assembly a_head\nAssemblyMgr.FilterAssembly a_head Light &amp;lightnodes\n--&gt; true\n-- lightnodes now contains all nodes corresponding to objects of superclass Light\nlightnodes\n--&gt; #($Omni_Light:Omni001 @ [0.000000,0.000000,0.000000])\n--Find all camera objects in assembly a_head\nAssemblyMgr.FilterAssembly a_head Camera &amp;camnodes\n--&gt; true\n--There are no cameras in the assembly!\ncamnodes\n--&gt; #()\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D42\"></a> <span class=\"char_link\"><a href=\"GUID-E9D3BB95-67F8-4E02-AE00-F95CC1711C0C.htm\">Interface:IAssembly</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C-6D41\"></a> <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";