var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-ECE0A134-6C3A-42BF-8B34-C1D9ED486D07\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"OSL\">\n      <meta name=\"indexterm\" content=\"OSLMap\">\n      <meta name=\"indexterm\" content=\"OSL TextureMap\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>OSLMap: textureMap</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-ECE0A134-6C3A-42BF-8B34-C1D9ED486D07\"></a><div class=\"head\">\n            <h1>OSLMap: textureMap</h1>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4167\"></a><pre><em class=\"codeEmphasisStrong\">OSLMap - superclass: textureMap; super-superclass:material - 11:2 - classID: #(2140830621L, 1875767309L)</em> </pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7CC4\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7CC5\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-23A6A316-7C51-430C-8A44-9236C837DB10.htm\">Material</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-43EC5EED-F275-4325-8D99-819C51C11380.htm\">TextureMap</a></span> &gt; OSLMap \n                        					  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> The OSLMap texturemap provides a container object to hold Open Shader Language shaders.\n            Available in <em class=\"strong\">3ds Max 2019 and higher</em>. All OSL shaders shipped with 3ds Max are instances of this class . \n            	 \n         </p>\n         <p>The OSLMap container has some constant properties that are common to all instances\n            of OSLMaps. Other properties, such as input and output ports, and shader options,\n            are created dynamically by the shader code, and will vary depending on the instance.\n            \n            	 \n         </p>\n         <p> </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7CC7\"></a> <em class=\"strong\">Constructor</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4166\"></a><pre><em class=\"codeEmphasisStrong\">OSLMap</em>...   </pre></div>\n         <p> </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C7CC9\"></a> <em class=\"strong\"> Properties</em> \n         </p>\n         <p>These properties are common to all OSLMap instances. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.OSLAutoUpdate     BooleanClass    default: false   --  boolean; OSL_Auto_Update</pre></div>\n         <p>Specifies whether the OSL shader code is linked to the file on disk (true), or is\n            held independently by the OSL Map in the scene. This parameter corresponds to the\n            link icon next to the file name in the OSLMap UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.OSLCode     String      --  string; OSL_Code </pre></div>\n         <p>A string that contains the OSL shader code. The default is a simple shader that can\n            be used as a starting point for creating a new shader. \n            	 \n         </p>\n         <p> The default shader mixes two input colors (or maps) and produces a single output\n            color: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>// Simple Example Shader with three inputs two outputs, to demo the syntax.\n// For more information read the OSL Language Specifictaion:\n//    https://github.com/imageworks/OpenShadingLanguage/blob/master/src/doc/osl-languagespec.pdf \n\nshader Example\n	[[ string help=\"Example shader with three inputs and two outputs&lt;br&gt;\" ]]\n(\n	// Inputs\n	color Input_A = 0.5 [[ string label = \"A\"]],\n	color Input_B = 0.5 [[ string label = \"B\"]],\n	float Mixer   = 0.5 [[ float min = 0.0, float max = 1.0 ]],\n	// Outputs\n	output color Out = 0.0,\n	output color Mix = 0.0)\n{\n	Out = Input_A + Input_B;            // Sum\n	Mix = mix(Input_A, Input_B, Mixer); // Mix\n}</pre></div>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.OSLPath     String    default: \"\"   --  filename; OSL_Path</pre></div>\n         <p>If the OSL code is loaded from a file, this parameter holds the path to that file.\n            This parameter is maintained even if the file is unlinked (by setting \n            		<span class=\"code\">.OSLAutoUpdate</span> to false). \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.numIMultipleOutputChannels     Integer    default: 2   --  integer; Read-only</pre></div>\n         <p>Specifies the number of output ports for the shader. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.numInputs</pre></div>\n         <p>Specifies the number of input ports. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">OSLMap Example Properties</em> \n         </p>\n         <p>These properties exist on the default example OSLMap, and are defined by the example\n            \n            		<span class=\"code\">.OSLCode</span> string. \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.Input_A     Color    default: (color 127.5 127.5 127.5)   --  animatable; fRGBA color; Controller Scaling: ([1,1,1,1] : (color 255 255 255)); WeirdScaled ([1,1,1,1])</pre></div>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.Input_A_map     UndefinedClass    default: undefined   --  texturemap</pre></div>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.Input_B     Color    default: (color 127.5 127.5 127.5)   --  animatable; fRGBA color; Controller Scaling: ([1,1,1,1] : (color 255 255 255)); WeirdScaled ([1,1,1,1])</pre></div>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.Input_B_map     UndefinedClass    default: undefined   --  texturemap</pre></div>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.Mixer     Float    default: 0.5   --  animatable; float</pre></div>\n         <div class=\"codeBlock\"><pre>&lt;OSLMap&gt;.Mixer_map     UndefinedClass    default: undefined   --  texturemap</pre></div>\n         <p> </p>\n         <div class=\"section\"><a name=\"SECTION_9C0FDBD012F24FB3A56A96E3AD913E01\"></a> \n            <h2><a name=\"GUID-106DACC6-55C1-4701-83E4-D2654FF68261\"></a>OSLMap interfaces\n            </h2> \n            <div class=\"section\"><a name=\"SECTION_449F06926B214DE39B917F048C10BB5E\"></a> \n               <h3><a name=\"GUID-39656EDA-A660-40A6-9516-C20E17126A70\"></a> Interface: IMtlRender_Compability_MtlBase \n               </h3> \n               <p> <em class=\"strong\">Properties: \n                     			 </em> \n               </p> \n               <p><em class=\"strong\"> Methods: \n                     			 </em> \n               </p> \n               <p> <em class=\"strong\">Actions: \n                     			 </em> \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_4CC72F5260254C9D9433990B34E86552\"></a> \n               <h3><a name=\"GUID-38740070-6EC2-48D8-807B-44CD95B4563D\"></a>Interface: iMultipleOutputChannelsWithValues \n               </h3> \n               <p> <em class=\"strong\">Properties:</em> \n               </p> \n               <div class=\"codeBlock\"><pre> .numIMultipleOutputChannels : integer : Read		  </pre></div> \n               <p>Gets the number of output ports for the OSLMap.\n                  		  \n               </p> \n               <p> </p> \n               <p> <em class=\"strong\">Methods: \n                     			 </em> \n               </p> \n               <div class=\"codeBlock\"><pre> &lt;TSTR by value&gt;getIMultipleOutputChannelLocalizedName &lt;index&gt;index \n		   getIMultipleOutputChannelLocalizedName - no automatic redraw after invoked </pre></div> \n               <p>Returns the localized name string for the specified output channel.\n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre> &lt;TSTR by value&gt;getIMultipleOutputChannelName &lt;index&gt;index \n		   getIMultipleOutputChannelName - no automatic redraw after invoked </pre></div> \n               <p>Returns the name string for the specified output channel.\n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre> &lt;enum&gt;getIMultipleOutputChannelType &lt;index&gt;index \n 		  getIMultipleOutputChannelType enums: {#float|#integer|#rgb|#point3|#string|#filename|#material|#texturemap|#bitmap|#node|#maxObject|#matrix3|#paramblock2|#point4|#frgba \n     getIMultipleOutputChannelType - no automatic redraw after invoked </pre></div> \n               <p>Returns the type of the specified output channel.\n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre> &lt;fpvalue by value&gt;getIMultipleOutputChannelValue &lt;index&gt;index time:&lt;time&gt; \n		   getIMultipleOutputChannelValue - no automatic redraw after invoked \n     time default value: 0f </pre></div> \n               <p> Returns the value of the specified output channel at the specified time.\n                  		  \n               </p> \n               <p> </p> \n               <p> <em class=\"strong\">Actions: \n                     			 </em> \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_0B70146A42194CCFACE1BA13AF10F2A4\"></a> \n               <h3><a name=\"GUID-AAB9A97F-7D1B-496B-8182-07CBADDC5F9E\"></a> Interface: iMultiOutputConsumer\n               </h3> \n               <p>This interfaces is exposed to MAXScript, but the properties and methods listed here\n                  are not implemented and cannot be used.\n                  		  \n               </p> \n               <p> <em class=\"strong\">Properties:</em> \n               </p> \n               <div class=\"codeBlock\"><pre> .numInputs : integer : Read \n		  </pre></div> \n               <p> <em class=\"strong\">Methods: \n                     			 </em> \n               </p> \n               <div class=\"codeBlock\"><pre> &lt;bool&gt;SetOutputToInput &lt;index&gt;input_index &lt;maxObject&gt;output_rtarg &lt;index&gt;output_index \n		  </pre></div> \n               <div class=\"codeBlock\"><pre> &lt;maxObject&gt;GetOutputRefTargetFromInput &lt;index&gt;input_index \n		  </pre></div> \n               <div class=\"codeBlock\"><pre> &lt;index&gt;GetOutputIndexFromInput &lt;index&gt;input_index \n		  </pre></div> \n               <div class=\"codeBlock\"><pre> &lt;bool&gt;CanAssignOutputToInput &lt;index&gt;input_index &lt;maxObject&gt;output_rtarg &lt;index&gt;output_index \n		  </pre></div> \n               <div class=\"codeBlock\"><pre> &lt;TSTR by value&gt;GetInputName &lt;index&gt;input_index \n		   GetInputName - no automatic redraw after invoked \n		  </pre></div> \n               <div class=\"codeBlock\"><pre> &lt;TSTR by value&gt;GetInputLocalizedName &lt;index&gt;input_index \n		  GetInputLocalizedName - no automatic redraw after invoked \n		  </pre></div> \n               <p> </p> \n               <p> <em class=\"strong\">Actions:</em> \n               </p> \n            </div> \n         </div>\n         <p> </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";