var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-F105EF1C-C01E-4751-995A-D6DA114008BA\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"NURBSIsoCurve - NURBSCurve\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>NURBSIsoCurve : NURBSCurve</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F105EF1C-C01E-4751-995A-D6DA114008BA\"></a><div class=\"head\">\n            <h1>NURBSIsoCurve : NURBSCurve </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4508\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4507\"></a> This class defines a dependent Iso (isoparametric) curve. U and V Iso curves are dependent\n               curves created along lines of constant parameter value of a NURBS surface. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4505\"></a> <em class=\"strong\">Constructors</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21DD\"></a><pre><em class=\"codeEmphasisStrong\">NURBSIsoCurve</em> [&lt;property&gt;:&lt;val&gt;]... 	 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4503\"></a>Any of the object\'s properties may be set via optional keyword arguments on the constructor.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21DC\"></a><pre><em class=\"codeEmphasisStrong\">getObject</em> &lt;nurbsset&gt; &lt;index&gt;   </pre></div> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44FF\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21DB\"></a><pre>&lt;nurbsisocurve&gt;.<em class=\"codeEmphasisStrong\">parent</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44FD\"></a>The parent surface by NURBSet index. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21DA\"></a><pre>&lt;nurbsisocurve&gt;.<em class=\"codeEmphasisStrong\">parentID</em> : integer </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44FA\"></a>The parent surface by NURBSId. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21D9\"></a><pre>&lt;nurbsisocurve&gt;.<em class=\"codeEmphasisStrong\">dir</em> :<em class=\"codeEmphasisStrong\">#U, #V</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44F7\"></a>The direction of the iso curve, either #U or #V. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21D8\"></a><pre>&lt;nurbsisocurve&gt;.<em class=\"codeEmphasisStrong\">parameter</em> : float </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44F4\"></a>The parametric position in the range of 0.0 to 1.0 in the given direction on the surface\n               at which the iso line will sit. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21D7\"></a><pre>&lt;nurbsisocurve&gt;.<em class=\"codeEmphasisStrong\">trim</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44F1\"></a>If <span class=\"code\"> <em class=\"strong\">true</em> </span>, trims parent surface at the curve. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21D6\"></a><pre>&lt;nurbsisocurve&gt;.<em class=\"codeEmphasisStrong\">flipTrim</em> : boolean </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44EE\"></a>The state of the trim flip toggle. This controls which portion of the surface is trimmed.\n               \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-21D5\"></a><pre>&lt;nurbsisocurve&gt;.<em class=\"codeEmphasisStrong\">seed</em> : point2 </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44EB\"></a>The seed location is a UV position on the parent surface. \n            </p> \n            <p>&nbsp;&nbsp;&nbsp; </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44E8\"></a> <span class=\"char_link\"><a href=\"GUID-8CEABA20-9D21-4ED0-AA95-3749435D2104.htm\">NURBSCurve</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44E7\"></a> <span class=\"char_link\"><a href=\"GUID-3B36B5D6-9647-406D-B607-CFAD8153912B.htm\">NURBSObject</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-44E6\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";