var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-F2315A09-440B-4EAE-8873-F27265CDB668\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MXSCallstackCaptureEnabled</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F2315A09-440B-4EAE-8873-F27265CDB668\"></a><div class=\"head\">\n            <h1> MXSCallstackCaptureEnabled </h1>\n         </div>\n         <p> The \n            		<span class=\"code\">MXSCallstackCaptureEnabled</span> context allows you to better control how the MAXScript call stack is captured, which\n            can aid in debugging. With deep stacks and/or lots of arrays, big structures, etc\n            present in the call stack, doing a stack capture can be an expensive operation. When\n            this context is set, the mxs call stack is not captured if a mxs runtime exception\n            is thrown. Available in \n            		<em class=\"strong\">in 3ds Max 2017 and higher</em>.\n            	 \n         </p>\n         <p>For example: \n            	 \n         </p>\n         <p> Instead of: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>\ntry (setproperty obj #prop val)\n		catch() -- just eat any errors\n</pre></div>\n         <p> You can use: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>\ntry with MXSCallstackCaptureEnabled off (setproperty obj #prop val)\n		catch() -- just eat any errors\n</pre></div>\n         <p>or \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>\nwith MXSCallstackCaptureEnabled off try (setproperty obj #prop val)\n		catch() -- just eat any errors\n</pre></div>\n         <p>or \n            	 \n         </p>\n         <p> \n            <div class=\"codeBlock\"><pre>\nwith MXSCallstackCaptureEnabled off \n		(\n	 		try (setproperty obj #prop val)\n				catch() -- just eat any errors\n		)\n\n</pre></div> \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";