var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-F3FDF49D-C48B-4B2D-BD4B-8DBCDE39081A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I Select Edges Between Material IDs?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F3FDF49D-C48B-4B2D-BD4B-8DBCDE39081A\"></a><div class=\"head\">\n            <h1>How do I Select Edges Between Material IDs? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11A6\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11A8\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11A9\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8E2\"> Working With Editable Polys</a></span> &gt; How do I Select Edges Between Material IDs? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11AB\"></a> \n            <h2><a name=\"GUID-5325FECB-537C-46CA-84FA-B89C812BE4B2\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11AC\"></a>I want to select the edges between different Material IDs in an Editable Poly object.\n               \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11AD\"></a> \n            <h2><a name=\"GUID-AF8B090A-43F9-48A0-BCA3-AFE29A23121F\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11AE\"></a>The following code implements a possible solution: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11AF\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11B0\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6637\"></a><pre>\nmacroScript SelMatIDEdges category: \"MXS Help\"\n(\n--The ActionItem will only be enabled when a single object with\n--Editable_Poly base object is selected:\non isEnabled return\n&nbsp;selection.count == 1 and classof selection[1].baseobject == Editable_Poly\n--When executed,\non execute do\n(\n&nbsp;theEP = selection[1].baseobject --get the base object of the selected object\n&nbsp;edgeSelArray = #() --init. an empty array to collect the edges\n&nbsp;eCount = polyOp.getNumEdges theEP --get the total number of edges\n&nbsp;for edge = 1 to eCount do --loop through all edges\n (\n&nbsp;&nbsp;--get the faces sharing the current edge\n&nbsp;&nbsp;theFaces = (polyOp.getFacesUsingEdge theEP #(edge)) as array\n&nbsp;&nbsp;--if there are two faces sharing the edge,\n&nbsp;&nbsp;if theFaces.count == 2 do\n  (\n&nbsp;&nbsp;&nbsp;--compare their Material IDs. If different, collect the edge\n&nbsp;&nbsp;&nbsp;if polyOp.getFaceMatID theEP theFaces[1] != polyOp.getFaceMatID theEP theFaces[2] do\n&nbsp;&nbsp;&nbsp;&nbsp;append edgeSelArray edge\n&nbsp;&nbsp;)--end if\n&nbsp;)--end loop\n&nbsp;--After checking all edges, select the collected ones\n&nbsp;polyOp.setEdgeSelection theEP edgeSelArray\n&nbsp;max Modify Mode-- switch to modify panel\n&nbsp;modPanel.setCurrentObject theEP-- go to the BaseObject level\n&nbsp;subObjectLevel = 2--and go to Edge SubObject level to show the result\n)--end on execute\n)--end macroScript\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11D7\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-3A1D7003-DF7F-406E-95AA-F5C90E82C864-low.gif\"></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11D8\"></a>A Box primitive has 6 Material IDs assigned to its 6 sides. In this example, a box\n               with 4x4x4 segments was converted to Editable Poly. Then the above script was executed.\n               \n            </p> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11DA\"></a> <span class=\"char_link\"><a href=\"\">Editable PolyMethods-FaceMaterialIDs</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11DB\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";