var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-F4EAAD9B-2961-43BB-BC41-B380CC8E8E32\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"scripted plug-ins\">\n      <meta name=\"indexterm\" content=\"RenderEffect - MAXWrapper\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scripted RenderEffect Plug-ins</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F4EAAD9B-2961-43BB-BC41-B380CC8E8E32\"></a><div class=\"head\">\n            <h1>Scripted RenderEffect Plug-ins </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FBD\"></a>  A scriptable RenderEffect plug-in can be declared by specifying the <span class=\"code\"> &lt;superclass&gt; </span> as <span class=\"code\"> <em class=\"strong\">RenderEffect</em> </span> and by declaring an <span class=\"code\"> <em class=\"strong\">apply</em> </span> event handler. When declared, the render effect can be seen in Render Effects &gt; Add\n            dialog. \n         </p>\n         <p><a name=\"GUID-BDB48B94-5FA2-44BE-B79F-2D1584FCED96\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"P_6AC442AA797D48C4A8248C8DD95936C6\"></a> <em class=\"strong\">Event Handlers:</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-718D\"></a><pre><em class=\"codeEmphasisStrong\">on apply</em> &lt;bitmap&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FB9\"></a>When the scripted effect is added as one of the rendering effects and \"Update Scene\"\n            or \"Update Effect\" buttons are pressed, the <span class=\"code\"> <em class=\"strong\">apply</em> </span> event handler is called and passed a bitmap which can be modified with any changes\n            the render effect wants to make. The bitmap you are given is the current rendered\n            image that has had all of the prior effects in the render effects list applied to\n            it. You modify this bitmap in place, typically by using the <span class=\"code\"> <em class=\"strong\">getPixel()</em> </span> and <span class=\"code\"> <em class=\"strong\">setPixel()</em> </span> functions. This modified bitmap is then passed onto the next render effect in the\n            list or to the render output if it is the last effect. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FB7\"></a>To allow scripted Effects to take advantage of the g-buffer channel access, the following\n            handlers are present: \n         </p>\n         <p><a name=\"GUID-88D63941-E383-42FD-BD83-633A20F44912\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-718C\"></a><pre><em class=\"codeEmphasisStrong\">on channelsRequired do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FB5\"></a>The handler expression must evaluate to an array of the g-buffer channel names that\n            are required. The g-buffer channel names are: \n         </p>\n         <p><a name=\"GUID-61D39507-75D0-4ACC-BD82-CA54257FE849\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-718B\"></a><pre><em class=\"codeEmphasisStrong\">#zDepth</em> <em class=\"codeEmphasisStrong\">#matID</em> <em class=\"codeEmphasisStrong\">#objectID</em> <em class=\"codeEmphasisStrong\">#UVCoords</em> <em class=\"codeEmphasisStrong\">#normal</em> <em class=\"codeEmphasisStrong\">#unClamped</em> <em class=\"codeEmphasisStrong\">#coverage</em> <em class=\"codeEmphasisStrong\">#mask</em> <em class=\"codeEmphasisStrong\">#node</em> <em class=\"codeEmphasisStrong\">#shaderColor</em> <em class=\"codeEmphasisStrong\">#shaderTransparency</em> <em class=\"codeEmphasisStrong\">#velocity</em> <em class=\"codeEmphasisStrong\">#weight</em> </pre></div>\n         <p><a name=\"GUID-C36FD1AC-8FCF-45ED-868F-79F33054E35B\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-718A\"></a><pre>on <em class=\"codeEmphasisStrong\">preApply</em> &lt;bitmap&gt; <em class=\"codeEmphasisStrong\">do</em> &lt;expr&gt; </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FA5\"></a>The <span class=\"code\"> <em class=\"strong\">preApply</em> </span> handler allows the scripted effect to analyze the incoming render bitmap and its\n            channels to precondition the delegate\'s effect processing. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FA4\"></a>So, you might add an <span class=\"code\"> <em class=\"strong\">on channelsRequired do</em> </span> to add <span class=\"code\"> <em class=\"strong\">#node</em> </span> and <span class=\"code\"> <em class=\"strong\">#coverage</em> </span> channels to the renderer’s bitmap, and an <span class=\"code\"> <em class=\"strong\">on preApply bm do</em> </span> to get the <span class=\"code\"> <em class=\"strong\">#node</em> </span> channel out as a mask and then set it into a delegate’s mask parameter to limit an\n            effect to a given object. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FA3\"></a>The <span class=\"code\"> <em class=\"strong\">render()</em> </span> function can be called re-entrantly within scripted renderEffect. In releases prior\n            to <em class=\"strong\">3ds Max 4</em>, attempting to do this caused a runtime error indicating that the renderer cannot\n            be called while a render is already under way. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FA1\"></a>Here is a simple example that extends the Blur effect to add another rollout that\n            has a node picker button. If you pick a node, it generates a channel mask and uses\n            that to limit the blur to that object: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4FA0\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F9F\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7189\"></a><pre>\nplugin RenderEffect myBlurFX\nname:\"Super Blur FX\"\nclassID:#(6545,456581)\nextends:Blur\nversion:1\n(\n  local tx, cm, g_channels\n  local tx = bitmaptexture ()\n  local g_channels = #(#node, #coverage)\n  rollout params \"SupaFX Parameters\"\n  (\n    label nn align:#center\n    pickbutton nodepick \"Pick Node\"\n  )\n  parameters main rollout:params\n  (\n    thenode type:#node ui:nodepick\n    on thenode set nd do\n      params.nn.text = if nd == undefined then \"\" else nd.name\n  )\n  on channelsRequired do g_channels\n  on preApply map do if theNode != undefined then\n  (\n    if cm == undefined then\n    (\n      cm = getChannelAsMask map #node node:theNode \\\n      fileName:(scriptsPath + \"__fxtmp.bmp\")\n      save cm\n      tx.bitmap = cm\n    )\n    else\n      getChannelAsMask map #node node:theNode to:cm\n  )\n  on create do\n  (\n    delegate.selMaskActive = true\n    delegate.selImageActive = false\n    delegate.selMaskMap = tx\n  )\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F72\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F71\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7188\"></a><pre>\nplugin renderEffect myColorBalanceFx\nname:\"Super Color Balance FX\"\nclassID:#(64425,45761)\nextends:Color_Balance version:1\n(\n  parameters main rollout:params\n  (\n    redness type:#integer animatable:true ui:redness default:0.0\n    on redness set val do delegate.red = val\n  )\n  rollout params \"Super Color Balance Parameters\"\n  (\n    spinner redness \"Redness: \" type:#integer range:[-100,100,0]\n  )\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F5E\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F5D\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7187\"></a><pre>\nplugin renderEffect myNegative\nname:\"myNegative\"\nclassID:#(0xb7aa794c, 0xc3bd78ab)\n(\n  parameters main rollout:params\n  (\n    Color type:#color default:blue ui:Color\n  )\n  rollout params \"Negative Parameters\"\n  (\n    colorpicker Color \"Base color: \" align:#center\n  )\n  on apply bmp do\n  (\n    for h=0 to (bmp.height-1) do\n    (\n      local sline = getPixels bmp [0,h] bmp.width\n      for i=1 to sline.count do sline[i] = Color - sline[i]\n      setPixels bmp [0,h] sline\n    )\n  )\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F42\"></a> <span class=\"char_link\"><a href=\"GUID-F7FF013A-F607-4E85-B656-4E1479B8CF26.htm\">RenderEffect Progress Callback Mechanism</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F41\"></a> <span class=\"char_link\"><a href=\"GUID-44D4AC45-65DD-401B-B4A1-07B71B35D544.htm\">Updating Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F40\"></a> <span class=\"char_link\"><a href=\"GUID-DB36699E-7589-4C38-97C2-A04F093C6789.htm\">Scripted Plug-in Methods</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F3F\"></a> <span class=\"char_link\"><a href=\"GUID-461915FA-31A2-49CE-84AF-2544B782ACA3.htm\">Scripted Plug-in Clauses</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F3E\"></a> <span class=\"char_link\"><a href=\"GUID-B0B9C1BF-168C-47D2-A4BE-12D93116FE79.htm\">Scripted Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4F3D\"></a> <span class=\"char_link\"><a href=\"GUID-5E5E1A71-24E2-4605-9720-2178B941DECC.htm\">How To ... Create a MonoChrome RenderEffect</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";