var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-F61593C0-E35A-4347-AB3A-40341EB0700A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I delete randomly a specified percentage of geometry objects?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F61593C0-E35A-4347-AB3A-40341EB0700A\"></a><div class=\"head\">\n            <h1>How do I delete randomly a specified percentage of geometry objects? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCF90\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCF92\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCF93\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8D4\">Working With Scene Nodes</a></span> &gt; How do I delete randomly a specified percentage of geometry objects? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCF95\"></a> \n            <h2><a name=\"GUID-E6F3F696-9002-48A6-B129-F8FD2A6FBC48\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCF96\"></a>I\'m trying to create a script that will delete a certain percentage of the objects\n               in a scene. I want the objects to be chosen randomly. I want the script to affect\n               only the meshes. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCF97\"></a> \n            <h2><a name=\"GUID-F8F1CDFC-5536-4F90-A214-D1410FE3011C\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCF98\"></a>Here is a possible approach: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCF99\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCF9A\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-664A\"></a><pre>\n(\n--&nbsp;Collect the object of a certain type into an array, for example\n--&nbsp;this one collects all geometry objects, excluding the target objects\n--&nbsp;which are of Geometry superClass for pre-MAXScript historical reasons\n&nbsp;\ncandidatesArray = for o in Geometry where classof o != TargetObject collect o\n&nbsp;\n--&nbsp;Because you want to remove random objects, but a specified percentage,\n--&nbsp;it is a good idea to make the decision which objects will be deleted\n--&nbsp;BEFORE actually deleting any objects.\n--&nbsp;You can create a second array and fill it up with the actual\n--&nbsp;objects to be deleted:\n&nbsp;\ndeathRowArray = #() -- init. an empty array\nthePercentage = 50.0 -- define the percentage\n&nbsp;\n--&nbsp;Calculate the number of objects to delete:\nnumberToDelete = (thePercentage / 100.0 * candidatesArray.count) as integer\n&nbsp;\n--&nbsp;Loop until the deathRow array is filled\n--&nbsp;with the desired number of objects:\nwhile deathRowArray.count &lt; numberToDelete do\n(\n  newIndex = random 1 candidatesArray.count --generate new random index\n  --if not already chosen, add it to the deathrow array\n  if findItem deathRowArray candidatesArray[newIndex] == 0 do\n    append deathRowArray candidatesArray[newIndex]\n)\ndelete deathRowArray --finally, delete the collected objects\n)\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FCFBD\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";