var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-F6F42FCD-36CA-4D76-9B17-EA5A661AA348\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Interface MeshInspector\">\n      <meta name=\"indexterm\" content=\"MeshInspector Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: MeshInspector</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F6F42FCD-36CA-4D76-9B17-EA5A661AA348\"></a><div class=\"head\">\n            <h1>Interface: MeshInspector </h1>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1058\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1057\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-BB29A275-58EF-4686-BA58-B9B6265B1B39.htm\">Interfaces</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-240CBB0C-EF58-4A82-9C0F-A59200F58A19.htm\">Core Interfaces</a></span> &gt; MeshInspector \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-105B\"></a>The<em class=\"strong\"> MeshInspector Core Interface </em> available in <em class=\"strong\">3ds Max 2014 and higher </em>exposes properties for the system for checking and repairing inconsistent data in\n            scene geometry objects.  \n         </p>\n         <p><a name=\"GUID-1D5A3FC1-0A51-42B8-9D26-5F0CEA982C3D\"></a>The Mesh Inspector runs in the background and checks geometry objects for errors after\n            the scene is loaded, before the scene is saved, or when the topology of an object\n            is changed at the base object level or on the stack. \n         </p>\n         <p><a name=\"GUID-BE2C3A5F-9EFE-441F-AF87-5E20CBB71251\"></a>The Mesh Inspector checks for the following potential problems: \n         </p><a name=\"UL_B43B5967625F43DB92BBF78BD0EDEAE6\"></a><ul>\n            <li>Bad vertex position values such as NAN and or +/- Infinity </li>\n            <li>Unallocated map channels </li>\n            <li>Unallocated face map channels </li>\n            <li>Unallocated vertex map channels </li>\n            <li>Array out of bounds indices </li>\n            <li>Dead structure references </li>\n            <li>Degenerate faces (MNMesh only) </li>\n            <li>Spur edges (MNMesh only) </li>\n            <li>No degree faces (MNMesh only) </li>\n            <li>Face degree mismatch (MNMesh only) </li>\n         </ul>\n         <p><a name=\"GUID-172D07D5-19B8-4CB5-AB29-378BB571470B\"></a>The system works at two levels: \n         </p><a name=\"UL_91DAF03C921A4AC4AD1F8B30E3276F75\"></a><ul>\n            <li>Level 1 Errors are repaired automatically without user interaction. These errors do\n               not change the appearance or topology of the mesh. \n            </li>\n            <li>Level 2 Errors are reported to the user and only repaired if explicitly requested.\n               These errors may change the look or topology of the mesh. \n            </li>\n         </ul>\n         <p><a name=\"GUID-A0A7807A-51F4-4867-B694-88BD3FE143B5\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-4CD4D186-5FEB-4DDA-9C58-73AD43F03390\"></a> <em class=\"strong\">Properties:</em> \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MeshInspector.Enable</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-719BF17F-47DA-4C34-BC18-ADC44EA9F8D2\"></a>When set to True (default), the Mesh Inspector will be enabled and will check geometry\n            objects for Level 2 errors. \n         </p>\n         <p><a name=\"GUID-E9F38F15-4FAB-4004-AE19-FCB672E58B50\"></a>When set to False, no Level 2 inspection will be performed. <em class=\"strong\">Level 1 errors will still be checked for and repaired automatically</em> as long as <span class=\"code\"> <em class=\"strong\">MeshInspector.RepairMesh</em> </span> is set to True. \n         </p>\n         <p><a name=\"P_FB78CB2CCB184876A725B7A9CADB619A\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MeshInspector.RepairMesh</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-7106FAA9-AB1E-4A34-898D-C076F7FE563B\"></a>When set to True (default), the Mesh Inspector will fix Level 1 errors and report\n            Level 2 errors. \n         </p>\n         <p><a name=\"GUID-7E854581-DFBA-4A30-AE0D-54B4128EB0E2\"></a>When set to False, the Mesh Inspector will not fix any Level 1 or Level 2 errors,\n            only report them according to the settings below. The effectively sets it to Report-Only\n            mode. \n         </p>\n         <p><a name=\"GUID-6B0D3404-7DDD-4576-A6B9-429D928C97B1\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <div class=\"codeBlock\"><pre><em class=\"codeEmphasisStrong\">MeshInspector.ShowDialog</em> : bool : Read|Write</pre></div>\n         <p><a name=\"GUID-69CB32EC-283C-439C-82FB-BD9E63F0E44A\"></a>When set to True, the Mesh Inspector will show a dialog when one or more Level 2 errors\n            are detected. \n         </p>\n         <p><a name=\"GUID-013ECCA1-EA85-4B57-A771-7B95CF958312\"></a>When set to False (default), no dialog will be displayed. \n         </p>\n         <p><a name=\"GUID-C36EEB07-A11D-4976-B3D1-B11A6E55FEC7\"></a>&nbsp;&nbsp;&nbsp; \n         </p>\n         <p><a name=\"GUID-8DBB248C-A24B-4C01-9119-A67AF3AE6BA5\"></a> <em class=\"strong\">Methods:</em> \n         </p>\n         <p><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-1054\"></a>No Methods Exposed. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";