var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-F7FF013A-F607-4E85-B656-4E1479B8CF26\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"RenderEffect - MAXWrapper\">\n      <meta name=\"indexterm\" content=\"progressCB.setTitle\">\n      <meta name=\"indexterm\" content=\"progressCB.progress\">\n      <meta name=\"indexterm\" content=\"progressCB.check()\">\n      <meta name=\"indexterm\" content=\"progressCB\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>RenderEffect Progress Callback Mechanism</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F7FF013A-F607-4E85-B656-4E1479B8CF26\"></a><div class=\"head\">\n            <h1>RenderEffect Progress Callback Mechanism </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EF9\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EF8\"></a>     You can control the main Rendering Effect dialog progress bar resp. the Renderer progress\n               bar using an <span class=\"code\"> <em class=\"strong\">on apply</em> </span> handler with <span class=\"code\"> <em class=\"strong\">progressCB</em> </span>, the progress callback interface object. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EF2\"></a>The following syntax lets you do this: \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-717B\"></a><pre><em class=\"codeEmphasisStrong\">on apply</em> &lt;bitmap&gt; <em class=\"codeEmphasisStrong\">progressCB</em>: <em class=\"codeEmphasisStrong\">do</em> &lt;fn&gt;</pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EEF\"></a>The first argument is the bitmap value to be modified by the effect and <span class=\"code\"> <em class=\"strong\">progressCB</em> </span> is a progress callback interface object. This interface has several methods you can\n               call during the course of processing the bitmap that control the progress bar and\n               check for user cancellation. \n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EEE\"></a> \n               <h3><a name=\"GUID-2CBC348C-A89C-4C57-BF0C-906731BC139B\"></a> <em class=\"strong\">Methods</em> \n               </h3> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-717A\"></a><pre>progressCB.<em class=\"codeEmphasisStrong\">setTitle</em> &lt;string&gt;</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EEC\"></a>Sets the title on the progress bar. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7179\"></a><pre>progressCB.<em class=\"codeEmphasisStrong\">progress</em> &lt;done&gt; &lt;total&gt;</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EEA\"></a>Defines the progress of the rendering. Both arguments are integers; <span class=\"code\"> <em class=\"strong\">done</em> </span> indicates how much of the rendering has been completed and <span class=\"code\"> <em class=\"strong\">total</em> </span> indicates the total amount of work to be done. For instance, in a main loop of a\n                  render effect going through all lines of a bitmap, <span class=\"code\"> <em class=\"strong\">done</em> </span> must be set to the current line number being processed and <span class=\"code\"> <em class=\"strong\">total</em> </span> must be set to the number of lines in the bitmap (its vertical resolution). \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EE9\"></a>When this is called, either the main Rendering Effect progress bar or the Renderer\n                  progress bar is updated to reflect this progress depending on whether the effect is\n                  being updated by the Rendering Effect dialog or called by the renderer. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EE8\"></a>This function also returns a boolean, which if <span class=\"code\"> <em class=\"strong\">true</em> </span> indicates that the user has hit the Escape key to cancel the effect rendering. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7178\"></a><pre>progressCB.<em class=\"codeEmphasisStrong\">check</em>()</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EE6\"></a>Indicates whether the user has hit the escape key to cancel the effect rendering.\n                  This function returns a boolean; <span class=\"code\"> <em class=\"strong\">false</em> </span> if processing must continue and <span class=\"code\"> <em class=\"strong\">true</em> </span> if the user has cancelled the rendering. \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EE5\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EE4\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7177\"></a><pre>\non apply bm progressCB: do\n(\n...\nprogressCB.setTitle \"My Effect Pass1\"\n...\noldEscapeEnable = escapeEnable -- get old state of escape processing\nescapeEnable = false -- turn off MAXScript escape processing\ntotal = bm.height -- define total as the height of the bitmap\nfor i in ...\n(\n&lt;the effect rendering loop&gt;\n...\nif progressCB.progress i total then exit --i lines done out of total\n)--end i loop\n...\nescapeEnable = oldEscapeEnable --restore original state\n...\n)--end on apply\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4ECF\"></a><p class=\"table-body\"></p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4ECE\"></a><p class=\"table-body\">The progress bar update is done inside the main processing loop and the check for\n                              user cancel is done on the same call, which causes the loop to exit prematurely in\n                              this example. \n                           </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4ECD\"></a><p class=\"table-body\"></p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4ECC\"></a><p class=\"table-body\">For a real-world practical example of the RenderEffect Progress Callback usage, see\n                              the <span class=\"char_link\"><a href=\"GUID-5E5E1A71-24E2-4605-9720-2178B941DECC.htm\">How To ... Create a MonoChrome RenderEffect</a></span> tutorial. \n                           </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4ECB\"></a><p class=\"table-body\"></p> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EC8\"></a> <span class=\"char_link\"><a href=\"GUID-262A4361-5EC8-49F2-83A1-9B95694B1363.htm\">RenderEffect : MAXWrapper</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EC7\"></a> <span class=\"char_link\"><a href=\"GUID-F4EAAD9B-2961-43BB-BC41-B380CC8E8E32.htm\">Scripted RenderEffect Plug-ins</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4EC6\"></a> <span class=\"char_link\"><a href=\"GUID-D714D070-AB50-41D4-B3AE-7BCFB4B18C5D.htm\">Render Effects Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";