var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-F9BDCDFD-5C2D-42ED-A840-184795A2E057\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"ActiveX - Disable 3ds Max keyboard accelerators\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>ActiveX - Disable 3ds Max keyboard accelerators</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F9BDCDFD-5C2D-42ED-A840-184795A2E057\"></a><div class=\"head\">\n            <h1>ActiveX - Disable 3ds Max keyboard accelerators </h1>\n         </div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75AD\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B06\"></a> <img src=\"../images/GUID-58798F8D-5DC2-454D-A1A2-9DF57E5A2077-low.gif\"> ActiveX Controls have been deprecated by Microsoft in the latest versions of the\n                  Windows operating system in favor of the <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet</a></span> framework and its controls. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B05\"></a>While MAXScript still supports ActiveX controls, these have to be installed and registered\n                  on the system to be accessible to MAXScript. \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B04\"></a>As a replacement of ActiveX controls, MAXScript supports <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet controls</a></span> in <em class=\"strong\">3ds Max 9 and higher</em>. \n               </p> \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B01\"></a>For most of the ActiveX controls there is no automatic way of determining if it supports\n            keyboard input to disable the 3ds Max keyboard accelerators. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4B00\"></a>AMAXScript system global called \"<em class=\"strong\">enableAccelerators</em>\" can be set to false whenever an ActiveX control gets focus so that the user can\n            type in the controls. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4AFF\"></a>Here is a sample that can be handy to enable/disable keyboard accelerators: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4AFD\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4AFC\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-711A\"></a><pre>\nrollout rAccelState \"State\"\n(\n  checkButton accelState \"Test\"\n  on rAccelState open do\n  (\n    accelState.text = if (enableAccelerators) then \"Enabled\" else \"Disabled\"\n    accelState.checked = enableAccelerators\n  )\n  on accelState changed state do\n  (\n    enableAccelerators = state\n    accelState.text =if (enableAccelerators) then \"Enabled\" else \"Disabled\"\n  )\n)\nnf = newRolloutFloater \"\" 100 100\naddRollout rAccelState nf\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-75AC\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4AE3\"></a>There is no real way of determining when an activeX control got focus and when it\n                  lost it and automatically disable/enable Max\'s accelerators. It\'s up to the script\n                  writer\'s discretion to find a clever way to disable them. There is a \"on StatusTextChange\n                  ...\" event handler to disable the accelerators, but it is not fail-proof. \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-7119\"></a><pre>\non ax StatusTextChange txt do enableAccelerators = false\n</pre></div> \n            </div>\n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-4ADD\"></a> <span class=\"char_link\"><a href=\"GUID-6EBDE243-E457-4B92-AB9E-1E2303B735BA.htm\">ActiveX Controls in MAXScript Rollouts</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";