var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-FA932DB0-738F-4A58-B49E-9A184064676C\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Track View nodes\">\n      <meta name=\"indexterm\" content=\"Values\">\n      <meta name=\"indexterm\" content=\"MAXTVNode - Value\">\n      <meta name=\"indexterm\" content=\"videoPostTracks\">\n      <meta name=\"indexterm\" content=\"trackViewNodes\">\n      <meta name=\"indexterm\" content=\"newTrackViewNode()\">\n      <meta name=\"indexterm\" content=\"globalTracks\">\n      <meta name=\"indexterm\" content=\"deleteTrackViewNode()\">\n      <meta name=\"indexterm\" content=\"deleteTrackViewController()\">\n      <meta name=\"indexterm\" content=\"addTrackViewController()\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Track View Nodes</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FA932DB0-738F-4A58-B49E-9A184064676C\"></a><div class=\"head\">\n            <h1>Track View Nodes </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B6D\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B6C\"></a> You can access and modify controllers in the Global Tracks and Video Post sections\n               in Track View, and create new named global tracks. Among other things, these can be\n               used to provide keyframeable parameters in your scripted utilities. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B6A\"></a>There are also methods associated with the Track View window. These methods are described\n               in <span class=\"char_link\"><a href=\"GUID-B8EBF538-E770-4D37-9CCC-5FA82A1C144B.htm\">Track View</a></span>. \n            </p> \n            <p><a name=\"WS3ED54CBA79FF2E3D-67417BBD12B7835D95C-58A6\"></a>   <em class=\"strong\">MAXTVNode : Value</em> is the class whose instances represent track view global track nodes. Each MAXTVNode\n               can contain any number of MAXTVNodes or animation controllers. The MAXTVNodes and\n               controllers within a MAXTVNode are shown as properties of the MAXTVNode, so you can\n               navigate through the nesting using property access. A MAXTVNode does not store animation\n               data, but rather acts as a container that can store one or more MAXTVNode or animation\n               controller. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B67\"></a>There are three track view nodes that you can access through global variables: the\n               <span class=\"code\"> <em class=\"strong\">root</em> </span> node to which you can add new custom tracks, the existing Global Tracks node which\n               provides access to the global track controllers, and the Video Post tracks node which\n               provides access to any video post controllers. These nodes are also accessible as\n               properties on the <span class=\"code\"> <em class=\"strong\">root</em> </span> node. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B66\"></a> <em class=\"strong\">Constructor</em>     \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-231F\"></a><pre><em class=\"codeEmphasisStrong\">trackViewNodes</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B61\"></a>Global variable containing the top-level World or root node in Track View. This variable\n               is read-only. \n            </p> \n            <p><a name=\"GUID-23C63F7D-0C12-4CB6-BA8B-03517AFDD5B8\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-231E\"></a><pre><em class=\"codeEmphasisStrong\">globalTracks</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B5E\"></a>Global variable containing the top-level Global Tracks node in Track View. This variable\n               is read-only. \n            </p> \n            <p><a name=\"GUID-1165A3CC-6403-4A21-AA66-B5D99ABA480E\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-231D\"></a><pre><em class=\"codeEmphasisStrong\">videoPostTracks</em> </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B5B\"></a>Global variable containing the top-level Video Post Track View node. This variable\n               is read-only. \n            </p> \n            <p><a name=\"GUID-3A38E176-6C0B-4C3D-9804-9B29E46A2EEE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-231C\"></a><pre><em class=\"codeEmphasisStrong\">newTrackViewNode</em> [ &lt;maxtvnode&gt; ] &lt;name_string&gt; [<em class=\"codeEmphasisStrong\">#hidden</em>] </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B58\"></a>If the <span class=\"code\"> <em class=\"strong\">&lt;maxtvnode&gt;</em> </span> argument is supplied, adds a sub-track node to it. If not, creates a new \'top-level\'\n               track in the Track View. If the optional <span class=\"code\"> <em class=\"strong\">#hidden</em> </span> flag is supplied, the node is not visible in the Track View. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B57\"></a> <em class=\"strong\">Properties</em> \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-231B\"></a><pre>&lt;maxtvnode&gt;.<em class=\"codeEmphasisStrong\">name</em> String </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B55\"></a>The track view node name as it appears in Track View. \n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B54\"></a>The sub-tracks and sub-controllers for a track view node are also shown as properties\n               of the track view node. For example, the additional default properties for global\n               <span class=\"code\"> <em class=\"strong\">trackViewNodes</em> </span> are: \n            </p> \n            <p><a name=\"GUID-F651DD68-4E25-4D8B-81EA-EAFFEEDBCDEE\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-231A\"></a><pre><em class=\"codeEmphasisStrong\">TrackViewNodes.Global_Tracks</em> MAXTVNode \n<em class=\"codeEmphasisStrong\">TrackViewNodes.Video_Post</em> MAXTVNode </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B51\"></a>The additional default properties for global <span class=\"code\"> <em class=\"strong\">globalTracks</em> </span> are: \n            </p> \n            <p><a name=\"GUID-B078B0A8-56AF-47E9-9663-9BD7783EAB87\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2319\"></a><pre><em class=\"codeEmphasisStrong\">GlobalTracks.float</em> float_list controller \n<em class=\"codeEmphasisStrong\">GlobalTracks.point3</em> point3_list controller \n<em class=\"codeEmphasisStrong\">GlobalTracks.position</em> position_list controller \n<em class=\"codeEmphasisStrong\">GlobalTracks.rotation</em> rotation_list controller \n<em class=\"codeEmphasisStrong\">GlobalTracks.scale</em> scale_list controller \n<em class=\"codeEmphasisStrong\">GlobalTracks.Block_Control</em> block_control controller </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B4A\"></a> <em class=\"strong\">Methods</em>    \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2318\"></a><pre><em class=\"codeEmphasisStrong\">deleteTrackViewNode</em> [ &lt;parent_maxtvnode&gt; ] &lt;maxtvnode&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B46\"></a>Deletes the given node from the supplied parent or the top-level if the parent is\n               not specified. \n            </p> \n            <p><a name=\"GUID-8854E151-36AF-4274-9961-AF4C24ACED1B\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2317\"></a><pre><em class=\"codeEmphasisStrong\">addTrackViewController</em> &lt;maxtvnode&gt; &lt;controller&gt; &lt;name&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B43\"></a>Adds the sub-controller to the given Track View node. \n            </p> \n            <p><a name=\"GUID-5083C767-6086-4896-AB92-354D1D0EB8C6\"></a>&nbsp;&nbsp;&nbsp; \n            </p> \n            <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2316\"></a><pre><em class=\"codeEmphasisStrong\">deleteTrackViewController</em> &lt;maxtvnode&gt; &lt;controller&gt; </pre></div> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B40\"></a>Deletes the controller from the given Track View node. \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B3F\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B3E\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2315\"></a><pre>\n-- access a video post track\nvideoPostTracks.glow.size = 5\n-- set up some visible tracks for some keyframeable parameters in a rollout panel\nmy_tracks = newTrackViewNode \"Grinner\"\nhappy_ctrl = bezier_position ()\naddTrackViewController my_tracks happy_ctrl \"Happy\"\n...\n-- plant keyframes in rollout spinner handler if the animate button is on\nrollout grinner ...\n(\n...\non happy changed val do\n(\n...\nhappy_ctrl.value = [x, y, z]\n...\n)\n...\n)\n-- add a new float controller to the global tracks float controller list\nglobalTracks.float.controller.available.controller = bezier_float ()\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-4B24\"></a> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value Common Properties, Operators, and Methods</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";