var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-FB52FDC5-CC83-46FB-A430-B90E7107805A\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"MAXScript / DotNet Value Conversions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>MAXScript / DotNet Value Conversions</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FB52FDC5-CC83-46FB-A430-B90E7107805A\"></a><div class=\"head\">\n            <h1>MAXScript / DotNet Value Conversions </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1095\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1094\"></a> MAXScript will automatically convert its native values to DotNet values and DotNet\n               values to MAXScript values. \n               		\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1092\"></a>In addition, value conversion can be performed explicitly using a dedicated function\n               in \n               		  <em class=\"strong\">3ds Max 2010 and higher</em>. \n               		\n            </p> \n            <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1091\"></a> \n               <h3><a name=\"GUID-A2D5DD42-2999-4A4A-90D9-5F131B8CD888\"></a> <em class=\"strong\">Automatic Conversion</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1090\"></a>The following table shows the native MAXScript value types and the converted DotNet\n                  value types in \n                  			 <em class=\"strong\">3ds Max 9 and higher</em>. \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-108F\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"50%\">\n                        <col width=\"50%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-108E\"></a><p class=\"table-body\"> <em class=\"strong\">MAXScript type</em> \n                           </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-108D\"></a><p class=\"table-body\"> <em class=\"strong\">DotNet type</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67B6\"></a><pre>Integer, Integer64, IntegerPtr, \nFloat, Double, MSTime</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67B5\"></a><pre>Byte, SByte, Decimal, \nInt16, UInt16, Int32, UInt32, \nIntPtr, UIntPtr, Int64, UInt64, \nSingle, Double</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67B4\"></a><pre>Boolean</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67B3\"></a><pre>Boolean</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67B2\"></a><pre>String</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67B1\"></a><pre>String, Char array</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1085\"></a>The following table shows the DotNet value types and the converted native MAXScript\n                  value types. \n                  		  \n               </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1084\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"50%\">\n                        <col width=\"50%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1083\"></a><p class=\"table-body\"> <em class=\"strong\">DotNet type</em> \n                           </p> \n                        </td>\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1082\"></a><p class=\"table-body\"> <em class=\"strong\">MAXScript type</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67B0\"></a><pre>Byte, SByte, Decimal, \nInt16, UInt16, Int32, UInt32</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67AF\"></a><pre>Integer</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67AE\"></a><pre>Int64, UInt64</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67AD\"></a><pre>Integer64</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67AC\"></a><pre>IntPtr, UIntPtr</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67AB\"></a><pre>IntegerPtr</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67AA\"></a><pre>Single</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67A9\"></a><pre>Float</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67A8\"></a><pre>Double</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67A7\"></a><pre>Double</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67A6\"></a><pre>Boolean</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67A5\"></a><pre>Boolean</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67A4\"></a><pre>String, Char array</pre></div> \n                        </td>\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67A3\"></a><pre>String</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"WS3ED54CBA79FF2E3D-7A802F912B7835E9A3-488D\"></a> \n               <h3><a name=\"GUID-947D14E1-19CD-402C-967C-795CDDFC39C5\"></a> <em class=\"strong\">Explicit Conversion</em> \n               </h3> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1072\"></a>The following method performs a conversion of a MAXScript value to a DotNet value.\n                  \n                  		  \n               </p> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-1071\"></a>Available in \n                  			 <em class=\"strong\">3ds Max 2010</em> and higher. \n                  		  \n               </p> \n               <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67A2\"></a><pre><em class=\"codeEmphasisStrong\">dotNet.ValueToDotNetObject</em> &lt;value&gt; { &lt;dotNetClass&gt; | &lt;dotNetObject&gt; }</pre></div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-106E\"></a>Returns a dotNetObject value where the MAXScript value passed as first argument is\n                  converted to a DotNet object of the type specified by the second argument. \n                  		  \n               </p> \n               <p>Available in \n                  			 <em class=\"strong\">3ds Max 2018.2 Update and higher</em>: Some native MAXScript types are converted into .NET arrays, as some .NET libraries\n                  do not support these types natively. \n                  			 <em class=\"strong\">Point2</em>, \n                  			 <em class=\"strong\">Point3</em>, \n                  			 <em class=\"strong\">Point4</em>, \n                  			 <em class=\"strong\">Quat</em>, \n                  			 <em class=\"strong\">EulerAngles</em>, and \n                  			 <em class=\"strong\">Matrix3</em> types are all converted into \n                  			 <span class=\"code\">float[]</span> or \n                  			 <span class=\"code\">double[]</span> arrays. \n                  		  \n               </p> \n               <div><a name=\"GUID-82406928-DAC7-4137-BAD7-36669A875E81\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>EulerAngles are displayed in degrees, but are stored internally as radians, so the\n                     converted .NET values are in radians. \n                     		  \n                  </div>\n               </div> \n               <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-106D\"></a>This allows for the easy creation of DotNet arrays from MAXScript arrays: \n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;value&gt; <em class=\"codeEmphasisStrong\">dotnet.DotNetArrayToValue</em> &lt;dotNetObject&gt; &lt;Matrix3 | Point2 | Point3 | Point4 | Quat | EulerAngles&gt;</pre></div> \n               <p> Available in \n                  			 <em class=\"strong\">3ds Max 2018.2 Update and higher</em>:Converts the .net array to a value of the specified mxs value type. The .net arrays\n                  must be of type float or double. For Matrix3, the .net array must be of size [4,4]\n                  , for Point2 it must be of size [2] , for Point3 and EulerAngles it must be of size\n                  [3] , and for Point4 and Quat it must be of size [4] .\n                  		  \n               </p> \n               <p> </p> \n               <div class=\"codeBlock\"><pre>&lt;value&gt; <em class=\"codeEmphasisStrong\">dotnet.DotNetObjectToValue</em> &lt;dotNetObject&gt;</pre></div> \n               <p> Available in \n                  			 <em class=\"strong\">3ds Max 2018.2 Update and higher</em>:Converts the .NET object to a MAXScript value.\n                  		  \n               </p> \n               <p> </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-106C\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"100%\">\n                     </colgroup>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-106B\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLES</em> \n                           </p> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-67A1\"></a><pre>\ntype = dotNetClass \"System.Int32[]\"\n--&gt; dotNetClass:System.Int32[]\nres = dotnet.ValueToDotNetObject #(11,12,23) type\n--&gt; dotNetObject:System.Int32[]\nres.length\n--&gt; 3\nres.getvalue 2 --DotNet arrays are zero-based.\n--&gt; 23\n</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>typef = dotnetclass \"System.Single[]\" --&gt; dotNetClass:System.Single[]\nvf = dotnet.ValueToDotNetObject x_axis typef --&gt; dotNetObject:System.Single[]\nvf.get 0 --&gt; 1.0\ntyped = dotnetclass \"System.Double[]\" --&gt; dotNetClass:System.Double[]\nvd = dotnet.ValueToDotNetObject x_axis typed --&gt; dotNetObject:System.Double[]\nvd.get 0 --&gt; 1.0d0\ntypefa = dotnetclass \"System.Single[][]\" --&gt; dotNetClass:System.Single[][]\nvfa = dotnet.ValueToDotNetObject #([1,2], \n	[1,2,3], \n	[1,2,3,4],\n	(quat 0.854433 0.00437304 0.0050751 0.519518), \n	(eulerAngles -117.399 -0.757267 0.126046) \n	)  typefa  --&gt; dotNetObject:System.Single[]\nvfa0 = vfa.get 0 --&gt; #(1.0, 2.0)\nvfa1 = vfa.get 1 --&gt; #(1.0, 2.0, 3.0)\nvfa2 = vfa.get 2 --&gt; #(1.0, 2.0, 3.0, 4.0)\nvfa3 = vfa.get 3 --&gt; #(0.854433, 0.00437304, 0.0050751, 0.519518)\nvfa4 = vfa.get 4 --&gt; #(-2.049, -0.0132168, 0.00219992)</pre></div> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> \n                           <div class=\"codeBlock\"><pre>typef2 = dotnetclass \"System.Single[]\"\nvfa2 = dotnet.ValueToDotNetObject (matrix3 [0.99991,0.0127462,0.00412892] \n    [0.00219972,-0.460163,0.887832] \n    [0.0132164,-0.887743,-0.46015] \n    [90,0,-45]) typef2  --&gt; dotNetClass:System.Single[,]\nvfa2.get 0 0 --&gt; 0.99991\n</pre></div> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-105E\"></a> <span class=\"char_link\"><a href=\"GUID-779FD7AC-953D-4567-B2A8-60B1D8695B95.htm\">DotNet In MAXScript</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";