var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-FB5AC66F-2D4C-4AA3-BCCD-5EC5113BE664\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Interface: UiCustomization</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FB5AC66F-2D4C-4AA3-BCCD-5EC5113BE664\"></a><div class=\"head\">\n            <h1>Interface: UiCustomization</h1>\n         </div>\n         <p><img src=\"../images/GUID-21C87158-BBA7-4B63-B8F7-CB9BA17CA2CA-low.gif\"> <span class=\"char_link\"><a href=\"GUID-F90290FA-90A2-4720-B9FE-A4CCE0446252.htm\">NEW</a></span><em class=\"strong\"> in 3ds Max 2020.1 Update:</em> This core interface allows you to display the HotKey Editor dialog, and convert keyboard\n            shortcut files to the new \n            		<span class=\"filePath\">.hsx</span> format. \n            	 \n         </p>\n         <p><em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt;<em class=\"codeEmphasisStrong\">ShowHotkeyDialog</em>()</pre></div>\n         <p>Displays the \n            		<em class=\"strong\">Hotkey Editor</em> dialog. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;boolean&gt;<em class=\"codeEmphasisStrong\">ConvertLegacyHotkeys</em> &lt;string&gt;<em class=\"codeEmphasisStrong\">legacyKbdxFilePath</em> &lt;string&gt;<em class=\"codeEmphasisStrong\">convertedHsxFilePath</em></pre></div>\n         <p>Converts the legacy keyboard shortcut \n            		<span class=\"filePath\">.kbdx</span> file at \n            		<span class=\"code\">legacyKbdxFIlePath</span> to a \n            		<span class=\"filePath\">.hsx</span> file at the specified \n            		<span class=\"code\">convertedHsxFilePath</span>. Returns true if successful, false otherwise. \n            	 \n         </p>\n         <div><a name=\"GUID-25563642-374A-4649-86C2-97FA2BAF5945\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>This function will overwrite an existing file with the same name \n               		<em class=\"strong\">without warning</em>. Use with care.\n               	 \n            </div>\n         </div><a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E0B\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-56C0CD8012A8003217A-E0A\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>-- convert a legacy file\nold_file = \"C:/my_kbdx/DefaultUI.kbdx\"\nnew_file = \"C:/my_kbdx/transform2.hsx\"\n\n-- check if file exists, because it will be silently overwritten\nif (getfiles new_file).count == 0 then (\n	format \"upgrading file % \\n\" old_file\n	success = UiCustomization.ConvertLegacyHotkeys old_file new_file\n	format \"success: %\\n\"  success\n)\nelse ( \n  format \"file already exists: % \\n\" new_file\n)</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";