var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-FB7F16DF-1736-456C-BA4B-CA2684AA4ADB\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Script Controller Assignment Behavior Changes in 3ds Max 8\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Script Controller Assignment Behavior Changes in 3ds Max 8</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FB7F16DF-1736-456C-BA4B-CA2684AA4ADB\"></a><div class=\"head\">\n            <h1>Script Controller Assignment Behavior Changes in 3ds Max 8 </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C7F\"></a>In versions <em class=\"strong\">prior to 3ds Max 8</em>, it was possible to provide a script string as a construction parameter, but it did\n            not work as expected. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C7E\"></a>When assigning a script controller to a track, <em class=\"strong\">3ds Max 7 and earlier</em> automatically reads the current value of the track and assigns it to the new controller\n            to make it valid and to preserve the original value. For example, if the track contains\n            the value 12.6, after assigning the script controller, the string inside the controller\n            will be automatically set to \"12.6\" to preserve the last known value. For that reason,\n            trying to assign the script in a single pass did not work in <em class=\"strong\">3ds Max 7 and earlier</em>: \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C7D\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C7C\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B37\"></a><pre>\n$Box01.height.controller = float_script script:\"random 0 100\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C77\"></a>The above would not work because the script controller instance is first created on\n            the right-hand side, the script string \"random 0 100\" is assigned to it, then the\n            controller is assigned to the left-hand side, and its script string is immediately\n            overwritten with a new string containing the current value of the left-hand side track.\n            \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C76\"></a>You always had to assign the controller first, then assign to its <span class=\"code\"> <em class=\"strong\">.script</em> </span> property. \n         </p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C74\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C73\"></a><p class=\"table-body\"> <em class=\"strong\">EXAMPLE:</em> \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-2B36\"></a><pre>\nfs =float_script ()\n$Box01.height.controller =fs\nfs.script=\"random 0 100\"\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C6C\"></a>In <em class=\"strong\">3ds Max 8 and higher</em>, the behavior described above has been corrected. An internal flag has been added\n            to all controllers to denote whether the controller is \"new\" or \"not new\", thus using\n            the current track value only when a new controller is being assigned. \n         </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C6B\"></a>Thanks to this new behavior, the script string in controllers where the script property\n            has already been set will not be replaced. \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C69\"></a> <span class=\"char_link\"><a href=\"GUID-569BE1BC-216E-496F-9EDE-1E8D2DB42194.htm\">Script Controllers</a></span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128F27EE529-6C68\"></a> <span class=\"char_link\"><a href=\"GUID-63624405-E55C-4E7C-825D-747D710DB262.htm\">Using Script Controllers</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";