var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-FCBC7CA5-BFA5-4C5C-8D92-4E40C9EC1388\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Data_Channel\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <meta name=\"keywords\" content=\" Data Channel Modifier &#xA;&#x9;&#x9;  \">\n      <meta name=\"keyword\" content=\" Data Channel Modifier &#xA;&#x9;&#x9;  \">\n      <title>Data_Channel : Modifier</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FCBC7CA5-BFA5-4C5C-8D92-4E40C9EC1388\"></a><div class=\"head\">\n            <h1>Data_Channel : Modifier</h1>\n         </div>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4B7D\"></a><pre><em class=\"codeEmphasisStrong\">Data_Channel - superclass: modifier; super-superclass:MAXWrapper - classID: #(e11,0)</em> </pre></div><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C4E00\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C4E01\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-560852AE-1A09-4464-9E96-14C643EA5C6C.htm\">Value</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-95453E22-A022-4543-B31C-A052CECD3598.htm\">MAXWrapper</a></span> &gt; \n                        					 <span class=\"char_link\"><a href=\"GUID-DB496ACA-1506-4FB1-B8F8-EECC7D9794DD.htm\">Modifier</a></span> &gt; Data_Channel \n                        				  \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> The Data Channel Modifier is a tool for creating effects and automating modelling\n            operations. It pipes object channel data through a series of operators to achieve\n            effects on the mesh. Scene objects contain various subcategories of data that define\n            attributes such as geometry, vertex color settings, world coordinates, selections\n            and texture mapping. This data is stored in separate channels and The Data Channel\n            Modifier can process and modify the data in them. Available in \n            		<em class=\"strong\">3ds Max 2017.1 Update and higher</em> \n         </p>\n         <p>Data Channels are manipulated with components called Operands. Operands are contained\n            in a stack in the Data Channel Modifier, and data is processed as it flows through\n            the operand stack. Operands are held in the operators array, and the order of operand\n            processing (and order in the UI) is determined by the \n            		<em class=\"strong\">operator_order</em> array. \n            	 \n         </p>\n         <p>For operator classes, see \n            		<span class=\"char_link\"><a href=\"GUID-F55E55FE-A78F-431D-9B47-2670DAABEAB6.htm#GUID-8467E284-3CF2-4AC0-A843-795863D5B4BC\">Data Channel Operator Classes</a></span>. \n            	 \n         </p>\n         <p> </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C4E04\"></a> <em class=\"strong\">Constructor</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4B7C\"></a><pre><em class=\"codeEmphasisStrong\">Data_Channel ...</em> </pre></div>\n         <p> </p>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C4E06\"></a> <em class=\"strong\">Properties</em> \n         </p>\n         <div class=\"codeBlock\"><a name=\"WS1A9193826455F5FF-56C0CD8012AE38BF917-4B7B\"></a><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">operators</em> array  </pre></div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128F27E2F8C4E08\"></a>An array of ReferenceTarget objects referring to the operands in the operator stack.\n            Note that the actual order of the operand in the stack is held in the \n            		<em class=\"strong\">operator_order</em> array. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">operator_enabled</em> : boolean array</pre></div>\n         <p>An array of Booleans corresponding to the operands in the \n            		<em class=\"strong\">operators</em> array, indicating whether the corresponding operand is enabled. Note that the actual\n            order of processing (and order in the Data Channel Modifier UI) is not determined\n            by the order of operators in this array, but rather by the \n            		<em class=\"strong\">operator_order</em> array. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">operator_ops</em> : int array</pre></div>\n         <p>An array of integers indicating how the operator at the corresponding index in the\n            \n            		<em class=\"strong\">operators</em> array is applied to the stack data, where: \n            	 \n         </p><a name=\"UL_7840ADEFFCBE49FDABD635874DFB4AF5\"></a><ul>\n            <li>0 = Replaces \n               		\n            </li>\n            <li>1 = Add \n               		\n            </li>\n            <li>2 = Subtract \n               		\n            </li>\n            <li>3 = Multiply \n               		\n            </li>\n            <li>4 = Divide \n               		\n            </li>\n            <li>5 = Dot Product \n               		\n            </li>\n            <li>6 = Cross Product \n               		\n            </li>\n         </ul>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">operator_order</em> : int array</pre></div>\n         <p>An array of integers indicating the order of the operator at the corresponding index\n            in the \n            		<em class=\"strong\">operands</em> array. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">display</em> (Enable_Display) : boolean</pre></div>\n         <p>Indicates whether the results of the modifier are displayed in the viewport. This\n            property corresponds to the state of the \n            		<span class=\"MenuCascade\">Enable Display</span> push button in the Data Channel Modifier UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">operator_frozen</em> (Frozen) : boolean array</pre></div>\n         <p>An array of Booleans indicating whether the corresponding operand in the \n            		<em class=\"strong\">operators</em> array is frozen. This property corresponds to the \n            		<span class=\"MenuCascade\">Freeze</span> right-click command in the Data Channel Modifier UI. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Viewport Display Settings</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">floatDisplay</em> (Float_Display) : integer</pre></div>\n         <p> Gets or sets how the data is displayed when the data in the stack is floating point\n            array. Possible values are: \n            	 \n         </p><a name=\"UL_439A67480A194E099D6A9F4A388E9C03\"></a><ul>\n            <li>0 = Ticks - the float data is displayed as a tick at the vertex associated with the\n               data, colored based on the min/mid/max color setting. \n               		\n            </li>\n            <li>1 = Shaded Colors - the float data is displayed as shaded using the same color scheme\n               as tick. \n               		\n            </li>\n         </ul>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">point3Display</em> (Point3_Display) : integer</pre></div>\n         <p> Gets or sets how the data is displayed when the data in the stack is point3 point\n            array. \n            	 \n         </p><a name=\"UL_94683DE968164BF6A20931508E3779F4\"></a><ul>\n            <li>0 = Position - the point 3 data is considered to positions in space and a point is\n               drawn at each position. \n               		\n            </li>\n            <li> 1 = Color : The data is considered color and point is drawn at each geometric point\n               colored the same as the data value \n               		\n            </li>\n            <li>2 = Vector : the data is considered a vector and a line is drawn from the geo point\n               and extended as a vector \n               		\n            </li>\n            <li>3 = Shaded : the data is considered color data and baked into a viewport shade channel\n               \n               		\n            </li>\n         </ul>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">tickSize</em> (Tick_Size) : integer</pre></div>\n         <p> Gets or sets the size of the tick if a tick display is chosen, where: \n            	 \n         </p><a name=\"UL_CD82523EF1BA4F069628266C56D05B93\"></a><ul>\n            <li>0 = small \n               		\n            </li>\n            <li>1 = medium \n               		\n            </li>\n            <li>2 = large \n               		\n            </li>\n         </ul>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">normalizeDisplay</em> (Normalize_Display) : Boolean</pre></div>\n         <p> Gets or sets whether the data is normalized before converting it to color. This can\n            be useful when the data is not color-based, such as velocity. \n            	 \n         </p>\n         <p>This property corresponds to the \n            		<em class=\"strong\">NormalizeDisplay</em> checkbox in the \n            		<em class=\"strong\">Display</em> section of the Data Channel UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">showNumericData</em> (Numeric_Display) : Boolean</pre></div>\n         <p>Enables or disables the numeric display in the viewport \n            	 \n         </p>\n         <p>This property corresponds to the \n            		<em class=\"strong\">Show Numeric</em> checkbox in the \n            		<em class=\"strong\">Display</em> section of the Data Channel UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">minColor</em> (Min_Color) : RGB color\n&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">midColor</em> (Mid_Color) : RGB color\n&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">maxColor</em> (Max_Color) : RGB color\n</pre></div>\n         <p> Gets or sets the colors used to form the gradient when the data is a float array,\n            similar to the soft selection gradient colors \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">numeric_max</em> : integer default : 1000</pre></div>\n         <p> Gets or sets the maximum number of numerics to draw in the viewport; limiting the\n            number can help performance since they are slow to draw and can clutter the display\n            \n            	 \n         </p>\n         <p>This property is not exposed in the Data Channel UI. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">numeric_drawdist</em> : integer default : 100</pre></div>\n         <p> This is a bounding rect centered on the view and used to cull numerics at the edge\n            of the view. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\">Associated Interface</em> \n         </p>\n         <div class=\"codeBlock\"><pre>Interface: DataChannelModifier</pre></div>\n         <p> <em class=\"strong\">Properties:</em> \n         </p>\n         <p>None \n            	 \n         </p>\n         <p> </p>\n         <p> <em class=\"strong\">Methods:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">NumberOperators()</em></pre></div>\n         <p>Returns the total number of operators available. Note: this is a static number, and\n            can be used to iterate all possible operators. \n            	 \n         </p><a name=\"TABLE_C6634AAFEB5C40AB84FE91B3D6175D5B\"></a><div class=\"table-not-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"not-ruled\">\n               <colgroup>\n                  <col>\n               </colgroup>\n               <tr class=\"not-ruled-heading\">\n                  <th class=\"table-heading\">Example \n                     				\n                  </th>\n               </tr>\n               <tr class=\"not-ruled-odd-row\">\n                  <td class=\"table-body\"> \n                     <div class=\"codeBlock\"><pre>numOps = $.modifiers[#Data_Channel].NumberOperators()\nfor i = 1 to numOps+1 do\n(\n	name = \" \"\n	info = \" \"\n	tt = \" \"\n	idA = 0L\n	idB = 0L\n	$.modifiers[#Data_Channel].OperatorName i &amp;name\n	$.modifiers[#Data_Channel].OperatorTooltip i &amp;tt\n	$.modifiers[#Data_Channel].OperatorInfo i &amp;info\n	$.modifiers[#Data_Channel].OperatorID i &amp;idA &amp;idB\n	print name\n	print tt\n	print info\n	print idA \n	print idB\n)\n</pre></div> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">OperatorName</em> &lt;index&gt;index &lt;&amp;TSTR&gt;name\nname is Out parameter\n	 \n	 </pre></div>\n         <p>Saves the name of the operator at the specified index in the name parameter. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">OperatorInfo</em> &lt;index&gt;index &lt;&amp;TSTR&gt;info\n info is Out parameter\n	 \n	 </pre></div>\n         <p>Saves the information string for the operator at the specified index in the info parameter.\n            \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">OperatorTooltip</em> &lt;index&gt;index &lt;&amp;TSTR&gt;toolTip\n toolTip is Out parameter\n	 </pre></div>\n         <p>Saves the tooltip string for the operator at the specified index in the toolTip parameter.\n            \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">OperatorID</em> &lt;index&gt;index &lt;&amp;INT64&gt;idA &lt;&amp;INT64&gt;idb\nidA is Out parameter\nidb is Out parameter	 \n	 </pre></div>\n         <p>Saves the internal class ID for the operator at the specified index into the idA (PartA)\n            and idB (PartB) parameters. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">AddOperator</em> &lt;INT64&gt;idA &lt;INT64&gt;idb &lt;integer&gt;whereat\n	 </pre></div>\n         <p>Adds the operator specified by a two-part class ID (PartA and PartB) into the DataChannelModfier’s\n            operators array at the specified index. Specify whereat as -1 to insert at the end\n            of the array. The Class ID is passed as a long integer value, not a hexadecimal. You\n            can obtain the class ID in a couple of ways; one way is to use the OperatorID() method\n            to get the class ID in integer format. You can also use the \n            		<span class=\"code\">showClass()</span> method, and convert the result from hex to decimal. For example: \n            		<span class=\"code\">showClass \"Operator_DeltaMush\"</span>. \n            	 \n         </p>\n         <p><em class=\"strong\">Example:</em> \n         </p>\n         <div class=\"codeBlock\"><pre>$.modifiers[#Data_Channel].AddOperator 236108612L 0L -1\n$.modifiers[#Data_Channel].AddOperator 283192250L 0L -1 \n$.modifiers[#Data_Channel].AddOperator 2882382387L 0L -1 \n$.modifiers[#Data_Channel].AddOperator 99L 0L -1\n\nct = $.modifiers[#Data_Channel].StackCount()\n</pre></div>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">StackCount()</em> </pre></div>\n         <p>Returns the number of operators currently in the modifier’s stack. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">StackOperatorName</em> &lt;index&gt;index &lt;&amp;TSTR&gt;name\nname is Out parameter\n	 </pre></div>\n         <p>Saves the name of the operator at the specified index into the name parameter. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">SelectStackOperator</em> &lt;index&gt;index\n	 </pre></div>\n         <p>Selects the operator at the specified index in the modifier’s stack. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">DeleteStackOperator</em> &lt;index&gt;index\n	 </pre></div>\n         <p>Deletes the operator at the specified index in the modifier’s stack. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">ReorderStackOperator</em> &lt;index by value array&gt;indexList\n	 </pre></div>\n         <p>Re-orders the operator stack according to the indexList array. For example, in an\n            operand stack of 4 items, specifying indexList #(3,2,1,0) will reverse the order of\n            the operands. \n            	 \n         </p>\n         <p>Note: you need to be careful with this methods, since it does not bound check and\n            you cannot change the number of operators. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">SavePreset</em> &lt;TSTR&gt;name &lt;TSTR&gt;toolTip\n	 </pre></div>\n         <p>Saves the current operand stack as a preset, with the specified name and toolTip.\n            You do not need to specify a path. Data Channel presets are saved under the 3ds Max\n            install directory in \n            		<span class=\"filePath\">en-US\\plugfcg\\DataChannelPresets</span>. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">LoadPreset</em> &lt;TSTR&gt;name\n	 </pre></div>\n         <p>Loads the specified preset by name. For example: \n            	 \n         </p>\n         <div class=\"codeBlock\"><pre>$.modifiers[#Data_Channel].LoadPreset \"Dirt Map\" \n	 </pre></div>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">DeletePreset</em> &lt;TSTR&gt;name\n	 </pre></div>\n         <p>Deletes the preset specified by name. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;integer&gt; &lt;Data_Channel&gt;.<em class=\"codeEmphasisStrong\">PresetCount()</em> </pre></div>\n         <p>Returns the number of available presets. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; <em class=\"codeEmphasisStrong\">PresetName</em> &lt;index&gt;index &lt;&amp;TSTR&gt;name\nname is Out parameter \n\n	 </pre></div>\n         <p>Saves the name of the preset at the specified index into the name parameter. \n            	 \n         </p>\n         <p> </p>\n         <div class=\"codeBlock\"><pre>&lt;void&gt; <em class=\"codeEmphasisStrong\">PerfTrackingStart()</em>\n&lt;void&gt; <em class=\"codeEmphasisStrong\">PerfTrackingEnd()</em>\n&lt;void&gt; <em class=\"codeEmphasisStrong\">PerfTrackingReport()</em> </pre></div>\n         <p>These functions expose performance tracking functionality. \n            		<span class=\"code\">PerfTrackingStart()</span> starts recording the time data, \n            		<span class=\"code\">PerfTrackingEnd()</span> stops it. All the timestamps are stored internally. \n            		<span class=\"code\">PerfTrackingReport()</span> writes the timing data out to the listener window. \n            	 \n         </p>\n         <p> </p>\n         <p><em class=\"strong\"> Actions:</em> \n         </p>\n         <p>None \n            	 \n         </p><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-F55E55FE-A78F-431D-9B47-2670DAABEAB6.htm\">Data Channel Modifier Operator Classes</a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";