var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-FD481C36-6E1F-43BA-8778-E36ACCA37122\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"Time Tags Access using the FrameTagManager Interface\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Time Tags Access using the FrameTagManager Interface</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FD481C36-6E1F-43BA-8778-E36ACCA37122\"></a><div class=\"head\">\n            <h1>Time Tags Access using the FrameTagManager Interface </h1>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2F72\"></a> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2F71\"></a> The Time Tags are used to define reference points on the time line for quick navigation.\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2F6F\"></a>They are now accessible via the <span class=\"char_link\"><a href=\"GUID-382E69D1-35DB-4474-936C-E53E40F12825.htm\">FrameTagManager Interface</a></span> (corresponding to the IFrameTagManager interface in the SDK).\n            </p> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2F6E\"></a>The example below demonstrates the access to time tags via MAXscript using the FrameTagManager\n               Interface.\n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2F6D\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2F6C\"></a><p class=\"table-body\"> <em class=\"strong\">FOR EXAMPLE</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6C21\"></a><pre>\nntags = FrameTagManager.GetTagCount() --&gt; 0\ntag1 = FrameTagManager.CreateNewTag \"tag1\" 15 --&gt; 1\ntag2 = FrameTagManager.CreateNewTag \"tag2\" 25 lockID:tag1 scale:true --&gt; 2\ntag3 = FrameTagManager.CreateNewTag \"tag3\" 25 scale:false--&gt;3\nloop1 = FrameTagManager.CheckForLoop tag1 tag2 --&gt; false\nloop2 = FrameTagManager.CheckForLoop tag2 tag1 --&gt; true\nloop3 = FrameTagManager.CheckForLoop tag1 tag3 --&gt; false \nloop4 = FrameTagManager.CheckForLoop tag3 tag1 --&gt; false\nntags = FrameTagManager.GetTagCount() --&gt; 3\nfor i = 1 to ntags do\n(\nid = FrameTagManager.GetTagID i\ntagTime = FrameTagManager.GetTimeByID id\ntagLockID = FrameTagManager.GetLockIDByID id\ntagName = FrameTagManager.GetNameByID id\ntagScale = FrameTagManager.GetScaleByID id\nformat \"%: id:%; name:%; time:%; lockID:%; scale:%\\n\" i id tagName tagTime tagLockID tagScale\n)\nFrameTagManager.SetTimeByID tag1 10 --&gt; ok\nFrameTagManager.SetLockIDByID tag3 tag2 --&gt; true\nFrameTagManager.SetNameByID tag1 \"modified tag1\" --&gt; ok\nFrameTagManager.SetScaleByID tag1 false --&gt; ok\nntags = FrameTagManager.GetTagCount() --&gt; 3\nfor i = 1 to ntags do\n(\nid = FrameTagManager.GetTagID i\ntagTime = FrameTagManager.GetTimeByID id\ntagLockID = FrameTagManager.GetLockIDByID id\ntagName = FrameTagManager.GetNameByID id\ntagScale = FrameTagManager.GetScaleByID id\nformat \"%: id:%; name:%; time:%; lockID:%; scale:%\\n\" i id tagName tagTime tagLockID tagScale\n)\nFrameTagManager.SetTimeByID tag2 5 relative:true --&gt; ok\nntags = FrameTagManager.GetTagCount() --&gt; 3\nfor i = 1 to ntags do\n(\nid = FrameTagManager.GetTagID i\ntagTime = FrameTagManager.GetTimeByID id\ntagLockID = FrameTagManager.GetLockIDByID id\ntagName = FrameTagManager.GetNameByID id\ntagScale = FrameTagManager.GetScaleByID id\nformat \"%: id:%; name:%; time:%; lockID:%; scale:%\\n\" i id tagName tagTime tagLockID tagScale\n)\nFrameTagManager.DeleteTag tag2 --&gt; ok\nFrameTagManager.FindItem tag2 --&gt; 0\nFrameTagManager.FindItem tag3 --&gt; 2\nntags = FrameTagManager.GetTagCount() --&gt; 2\nfor i = 1 to ntags do\n(\nid = FrameTagManager.GetTagID i\ntagTime = FrameTagManager.GetTimeByID id\ntagLockID = FrameTagManager.GetLockIDByID id\ntagName = FrameTagManager.GetNameByID id\ntagScale = FrameTagManager.GetScaleByID id\nformat \"%: id:%; name:%; time:%; lockID:%; scale:%\\n\" i id tagName tagTime tagLockID tagScale\n)\nFrameTagManager.SetLockIDByID tag1 tag3 --&gt; true\nFrameTagManager.GetTimeByID tag1 --&gt; 10f\nFrameTagManager.SetLockIDByID tag3 tag1 --&gt; false\nFrameTagManager.GetTimeByID tag3 --&gt; 20f\nFrameTagManager.CheckForLoop tag1 tag3 --&gt; true\nFrameTagManager.CheckForLoop tag3 tag1 --&gt; false\nFrameTagManager.SetLockIDByID tag1 0 --&gt; true\nFrameTagManager.GetTimeByID tag1 --&gt; 10f\nFrameTagManager.FindItemByTime 10 --&gt; 1\nFrameTagManager.FindItemByTime 15 --&gt; 0\nFrameTagManager.FindItemByTime 20 --&gt; 2\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC-2F19\"></a> <span class=\"char_link\"><a href=\"GUID-382E69D1-35DB-4474-936C-E53E40F12825.htm\">Interface: FrameTagManager</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";