var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"3DSMAX\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2019-08-28\">\n      <meta name=\"topicid\" content=\"GUID-FF89F3FF-DB8D-4AB3-BA98-3AD42E3C061B\">\n      <meta name=\"topic-subtype\" content=\"MAXScript\">\n      <meta name=\"indexterm\" content=\"How Do I - Frequently Asked Questions\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>How do I remove mid-edge EPoly Vertices?</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FF89F3FF-DB8D-4AB3-BA98-3AD42E3C061B\"></a><div class=\"head\">\n            <h1>How do I remove mid-edge EPoly Vertices? </h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1168\"></a>  \n         </p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC116A\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"100%\">\n               </colgroup>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC116B\"></a><p class=\"table-body\"> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">MAXScript FAQ</a></span> &gt; <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm#WS73099CC142F48755-2231E4B3128E0E4A0FC8E2\"> Working With Editable Polys</a></span> &gt; How do I remove mid-edge EPoly Vertices? \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC116D\"></a> \n            <h2><a name=\"GUID-8BB80707-4152-430B-8140-3A03181DCD3E\"></a> <em class=\"strong\">A user asked:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC116E\"></a>I want to filter the edge selection and create arrays containing connected edges,\n               something like \"edge selection elements\". Edges from two arrays will never be connected,\n               in other words will not share vertices. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC116F\"></a> \n            <h2><a name=\"GUID-9AE8ED1C-EC48-438B-9BD3-00141C5A5C18\"></a> <em class=\"strong\">Answer:</em> \n            </h2> \n            <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1170\"></a>The following code implements a possible solution: \n            </p> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1171\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"100%\">\n                  </colgroup>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC1172\"></a><p class=\"table-body\"> <em class=\"strong\">SCRIPT</em> \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> \n                        <div class=\"codeBlock\"><a name=\"WS73099CC142F487553098682E12AC2FC2BC7-6638\"></a><pre>\nmacroScript KillMidEdgeVerts category: \"MXS Help\"\n(\n<span class=\"codeComment\">--make sure a single EPoly object is selected</span>\non isEnabled return\n&nbsp;selection.count == 1 and classof selection[1].baseobject == Editable_Poly\non execute do\n(\n&nbsp;thePoly = selection[1]&nbsp;--get the selected object\n&nbsp;select thePoly --select it\n&nbsp;max modify mode --switch to modify panel\n&nbsp;--set the base object as current level:\n&nbsp;modPanel.setCurrentObject selection[1].baseobject\n&nbsp;subObjectLevel = 1 --set sub-*object level to vertex level\n&nbsp;numVerts = (polyop.getNumVerts thePoly) --get the total vertex count\n&nbsp;undo on \"KillMidEdgeVerts\" --enable undo context\n (\n&nbsp;&nbsp;--loop backwards from the last to the first vertex\n&nbsp;&nbsp;for v = numVerts to 1 by -1 do\n  (\n&nbsp;&nbsp;&nbsp;--get the edges using the vertex to check the count\n&nbsp;&nbsp;&nbsp;nVerts = (polyop.getEdgesUsingVert thePoly v) as array\n&nbsp;&nbsp;&nbsp;if nVerts.count == 2 do --if only two edges found, then\n   (\n&nbsp;&nbsp;&nbsp;&nbsp;--get the verts of the first egde\n&nbsp;&nbsp;&nbsp;&nbsp;edge1verts = (polyop.getVertsUsingEdge thePoly nVerts[1]) as array\n&nbsp;&nbsp;&nbsp;&nbsp;--calculate the vector defined by the two vertices in the first edge\n&nbsp;&nbsp;&nbsp;&nbsp;vector1 = (polyop.getVert thePoly edge1verts[1]) - (polyop.getVert thePoly edge1verts[2])\n&nbsp;&nbsp;&nbsp;&nbsp;--get the verts of the second edge\n&nbsp;&nbsp;&nbsp;&nbsp;edge2verts = (polyop.getVertsUsingEdge thePoly nVerts[2] as array)\n&nbsp;&nbsp;&nbsp;&nbsp;--calculate the vector defined by the two vertices in the second edge\n&nbsp;&nbsp;&nbsp;&nbsp;vector2 = (polyop.getVert thePoly edge2verts[1]) - (polyop.getVert thePoly edge2verts[2])\n&nbsp;&nbsp;&nbsp;&nbsp;--calculate the angle between the two normalized vectors\n&nbsp;&nbsp;&nbsp;&nbsp;angle = acos (dot (normalize vector1) (normalize vector2))\n&nbsp;&nbsp;&nbsp;&nbsp;--if the angle is less than the threashold (change 0.01 to whatever threashold you want!)\n&nbsp;&nbsp;&nbsp;&nbsp;if angle &lt; 0.01 do\n    (\n&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;select thePoly.verts[v]--then select the current vertex\n&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;thePoly.EditablePoly.buttonOp #Remove--and hit the remove button\n&nbsp;&nbsp;&nbsp;&nbsp;)\n&nbsp;&nbsp;&nbsp;)--end if\n&nbsp;&nbsp;)--end v loop\n&nbsp;)--end undo\n)--end on\n)--end macro\n</pre></div> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS73099CC142F48755-2231E4B3128E0E4A0FC11A4\"></a> <span class=\"char_link\"><a href=\"GUID-982B0129-4277-4128-83F1-A6584D3F40E0.htm\">Frequently Asked Questions</a></span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";